/* A Bison parser, made by GNU Bison 2.7.1.  */

/* Bison implementation for Yacc-like parsers in C
   
      Copyright (C) 1984, 1989-1990, 2000-2013 Free Software Foundation, Inc.
   
   This program is free software: you can redistribute it and/or modify
   it under the terms of the GNU General Public License as published by
   the Free Software Foundation, either version 3 of the License, or
   (at your option) any later version.
   
   This program is distributed in the hope that it will be useful,
   but WITHOUT ANY WARRANTY; without even the implied warranty of
   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
   GNU General Public License for more details.
   
   You should have received a copy of the GNU General Public License
   along with this program.  If not, see <http://www.gnu.org/licenses/>.  */

/* As a special exception, you may create a larger work that contains
   part or all of the Bison parser skeleton and distribute that work
   under terms of your choice, so long as that work isn't itself a
   parser generator using the skeleton or a modified version thereof
   as a parser skeleton.  Alternatively, if you modify or redistribute
   the parser skeleton itself, you may (at your option) remove this
   special exception, which will cause the skeleton and the resulting
   Bison output files to be licensed under the GNU General Public
   License without this special exception.
   
   This special exception was added by the Free Software Foundation in
   version 2.2 of Bison.  */

/* C LALR(1) parser skeleton written by Richard Stallman, by
   simplifying the original so-called "semantic" parser.  */

/* All symbols defined below should begin with yy or YY, to avoid
   infringing on user name space.  This should be done even for local
   variables, as they might otherwise be expanded by user macros.
   There are some unavoidable exceptions within include files to
   define necessary library symbols; they are noted "INFRINGES ON
   USER NAME SPACE" below.  */

/* Identify Bison output.  */
#define YYBISON 1

/* Bison version.  */
#define YYBISON_VERSION "2.7.1"

/* Skeleton name.  */
#define YYSKELETON_NAME "yacc.c"

/* Pure parsers.  */
#define YYPURE 1

/* Push parsers.  */
#define YYPUSH 0

/* Pull parsers.  */
#define YYPULL 1


/* Substitute the variable and function names.  */
#define yyparse         base_yyparse
#define yylex           base_yylex
#define yyerror         base_yyerror
#define yylval          base_yylval
#define yychar          base_yychar
#define yydebug         base_yydebug
#define yynerrs         base_yynerrs
#define yylloc          base_yylloc

/* Copy the first part of user declarations.  */
/* Line 371 of yacc.c  */
#line 1 "gram.y"


/*#define YYDEBUG 1*/
/*-------------------------------------------------------------------------
 *
 * gram.y
 *	  POSTGRESQL BISON rules/actions
 *
 * Portions Copyright (c) 1996-2014, PostgreSQL Global Development Group
 * Portions Copyright (c) 1994, Regents of the University of California
 *
 *
 * IDENTIFICATION
 *	  src/backend/parser/gram.y
 *
 * HISTORY
 *	  AUTHOR			DATE			MAJOR EVENT
 *	  Andrew Yu			Sept, 1994		POSTQUEL to SQL conversion
 *	  Andrew Yu			Oct, 1994		lispy code conversion
 *
 * NOTES
 *	  CAPITALS are used to represent terminal symbols.
 *	  non-capitals are used to represent non-terminals.
 *
 *	  In general, nothing in this file should initiate database accesses
 *	  nor depend on changeable state (such as SET variables).  If you do
 *	  database accesses, your code will fail when we have aborted the
 *	  current transaction and are just parsing commands to find the next
 *	  ROLLBACK or COMMIT.  If you make use of SET variables, then you
 *	  will do the wrong thing in multi-query strings like this:
 *			SET SQL_inheritance TO off; SELECT * FROM foo;
 *	  because the entire string is parsed by gram.y before the SET gets
 *	  executed.  Anything that depends on the database or changeable state
 *	  should be handled during parse analysis so that it happens at the
 *	  right time not the wrong time.  The handling of SQL_inheritance is
 *	  a good example.
 *
 * WARNINGS
 *	  If you use a list, make sure the datum is a node so that the printing
 *	  routines work.
 *
 *	  Sometimes we assign constants to makeStrings. Make sure we don't free
 *	  those.
 *
 *-------------------------------------------------------------------------
 */
#include "postgres.h"

#include <ctype.h>
#include <limits.h>

#include "catalog/index.h"
#include "catalog/namespace.h"
#include "catalog/pg_trigger.h"
#include "commands/defrem.h"
#include "commands/trigger.h"
#include "nodes/makefuncs.h"
#include "nodes/nodeFuncs.h"
#include "parser/gramparse.h"
#include "parser/parser.h"
#include "storage/lmgr.h"
#include "utils/date.h"
#include "utils/datetime.h"
#include "utils/numeric.h"
#include "utils/xml.h"


/*
 * Location tracking support --- simpler than bison's default, since we only
 * want to track the start position not the end position of each nonterminal.
 */
#define YYLLOC_DEFAULT(Current, Rhs, N) \
	do { \
		if ((N) > 0) \
			(Current) = (Rhs)[1]; \
		else \
			(Current) = (-1); \
	} while (0)

/*
 * The above macro assigns -1 (unknown) as the parse location of any
 * nonterminal that was reduced from an empty rule.  This is problematic
 * for nonterminals defined like
 *		OptFooList: / * EMPTY * / { ... } | OptFooList Foo { ... } ;
 * because we'll set -1 as the location during the first reduction and then
 * copy it during each subsequent reduction, leaving us with -1 for the
 * location even when the list is not empty.  To fix that, do this in the
 * action for the nonempty rule(s):
 *		if (@$ < 0) @$ = @2;
 * (Although we have many nonterminals that follow this pattern, we only
 * bother with fixing @$ like this when the nonterminal's parse location
 * is actually referenced in some rule.)
 */

/*
 * Bison doesn't allocate anything that needs to live across parser calls,
 * so we can easily have it use palloc instead of malloc.  This prevents
 * memory leaks if we error out during parsing.  Note this only works with
 * bison >= 2.0.  However, in bison 1.875 the default is to use alloca()
 * if possible, so there's not really much problem anyhow, at least if
 * you're building with gcc.
 */
#define YYMALLOC palloc
#define YYFREE   pfree

/* Private struct for the result of privilege_target production */
typedef struct PrivTarget
{
	GrantTargetType targtype;
	GrantObjectType objtype;
	List	   *objs;
} PrivTarget;

/* ConstraintAttributeSpec yields an integer bitmask of these flags: */
#define CAS_NOT_DEFERRABLE			0x01
#define CAS_DEFERRABLE				0x02
#define CAS_INITIALLY_IMMEDIATE		0x04
#define CAS_INITIALLY_DEFERRED		0x08
#define CAS_NOT_VALID				0x10
#define CAS_NO_INHERIT				0x20


#define parser_yyerror(msg)  scanner_yyerror(msg, yyscanner)
#define parser_errposition(pos)  scanner_errposition(pos, yyscanner)

static void base_yyerror(YYLTYPE *yylloc, core_yyscan_t yyscanner,
						 const char *msg);
static Node *makeColumnRef(char *colname, List *indirection,
						   int location, core_yyscan_t yyscanner);
static Node *makeTypeCast(Node *arg, TypeName *typename, int location);
static Node *makeStringConst(char *str, int location);
static Node *makeStringConstCast(char *str, int location, TypeName *typename);
static Node *makeIntConst(int val, int location);
static Node *makeFloatConst(char *str, int location);
static Node *makeBitStringConst(char *str, int location);
static Node *makeNullAConst(int location);
static Node *makeAConst(Value *v, int location);
static Node *makeBoolAConst(bool state, int location);
static void check_qualified_name(List *names, core_yyscan_t yyscanner);
static List *check_func_name(List *names, core_yyscan_t yyscanner);
static List *check_indirection(List *indirection, core_yyscan_t yyscanner);
static List *extractArgTypes(List *parameters);
static List *extractAggrArgTypes(List *aggrargs);
static List *makeOrderedSetArgs(List *directargs, List *orderedargs,
								core_yyscan_t yyscanner);
static void insertSelectOptions(SelectStmt *stmt,
								List *sortClause, List *lockingClause,
								Node *limitOffset, Node *limitCount,
								WithClause *withClause,
								core_yyscan_t yyscanner);
static Node *makeSetOp(SetOperation op, bool all, Node *larg, Node *rarg);
static Node *doNegate(Node *n, int location);
static void doNegateFloat(Value *v);
static Node *makeAArrayExpr(List *elements, int location);
static Node *makeXmlExpr(XmlExprOp op, char *name, List *named_args,
						 List *args, int location);
static List *mergeTableFuncParameters(List *func_args, List *columns);
static TypeName *TableFuncTypeName(List *columns);
static RangeVar *makeRangeVarFromAnyName(List *names, int position, core_yyscan_t yyscanner);
static void SplitColQualList(List *qualList,
							 List **constraintList, CollateClause **collClause,
							 core_yyscan_t yyscanner);
static void processCASbits(int cas_bits, int location, const char *constrType,
			   bool *deferrable, bool *initdeferred, bool *not_valid,
			   bool *no_inherit, core_yyscan_t yyscanner);
static Node *makeRecursiveViewSelect(char *relname, List *aliases, Node *query);


/* Line 371 of yacc.c  */
#line 245 "gram.c"

# ifndef YY_NULL
#  if defined __cplusplus && 201103L <= __cplusplus
#   define YY_NULL nullptr
#  else
#   define YY_NULL 0
#  endif
# endif

/* Enabling verbose error messages.  */
#ifdef YYERROR_VERBOSE
# undef YYERROR_VERBOSE
# define YYERROR_VERBOSE 1
#else
# define YYERROR_VERBOSE 0
#endif

/* In a future release of Bison, this section will be replaced
   by #include "gram.h".  */
#ifndef YY_BASE_YY_GRAM_H_INCLUDED
# define YY_BASE_YY_GRAM_H_INCLUDED
/* Enabling traces.  */
#ifndef YYDEBUG
# define YYDEBUG 0
#endif
#if YYDEBUG
extern int base_yydebug;
#endif

/* Tokens.  */
#ifndef YYTOKENTYPE
# define YYTOKENTYPE
   /* Put the tokens into the symbol table, so that GDB and other debuggers
      know about them.  */
   enum yytokentype {
     IDENT = 258,
     FCONST = 259,
     SCONST = 260,
     BCONST = 261,
     XCONST = 262,
     Op = 263,
     ICONST = 264,
     PARAM = 265,
     TYPECAST = 266,
     DOT_DOT = 267,
     COLON_EQUALS = 268,
     ABORT_P = 269,
     ABSOLUTE_P = 270,
     ACCESS = 271,
     ACTION = 272,
     ADD_P = 273,
     ADMIN = 274,
     AFTER = 275,
     AGGREGATE = 276,
     ALL = 277,
     ALSO = 278,
     ALTER = 279,
     ALWAYS = 280,
     ANALYSE = 281,
     ANALYZE = 282,
     AND = 283,
     ANY = 284,
     APPLICATION = 285,
     ARRAY = 286,
     AS = 287,
     ASC = 288,
     ASSERTION = 289,
     ASSIGNMENT = 290,
     ASYMMETRIC = 291,
     AT = 292,
     ATTRIBUTE = 293,
     AUTHORIZATION = 294,
     BACKWARD = 295,
     BEFORE = 296,
     BEGIN_P = 297,
     BETWEEN = 298,
     BIGINT = 299,
     BINARY = 300,
     BIT = 301,
     BOOLEAN_P = 302,
     BOTH = 303,
     BY = 304,
     CACHE = 305,
     CALLED = 306,
     CASCADE = 307,
     CASCADED = 308,
     CASE = 309,
     CAST = 310,
     CATALOG_P = 311,
     CHAIN = 312,
     CHAR_P = 313,
     CHARACTER = 314,
     CHARACTERISTICS = 315,
     CHECK = 316,
     CHECKPOINT = 317,
     CLASS = 318,
     CLOSE = 319,
     CLUSTER = 320,
     COALESCE = 321,
     COLLATE = 322,
     COLLATION = 323,
     COLUMN = 324,
     COMMENT = 325,
     COMMENTS = 326,
     COMMIT = 327,
     COMMITTED = 328,
     CONCURRENTLY = 329,
     CONFIGURATION = 330,
     CONNECTION = 331,
     CONSTRAINT = 332,
     CONSTRAINTS = 333,
     CONTENT_P = 334,
     CONTINUE_P = 335,
     CONVERSION_P = 336,
     COPY = 337,
     COST = 338,
     CREATE = 339,
     CROSS = 340,
     CSV = 341,
     CURRENT_P = 342,
     CURRENT_CATALOG = 343,
     CURRENT_DATE = 344,
     CURRENT_ROLE = 345,
     CURRENT_SCHEMA = 346,
     CURRENT_TIME = 347,
     CURRENT_TIMESTAMP = 348,
     CURRENT_USER = 349,
     CURSOR = 350,
     CYCLE = 351,
     DATA_P = 352,
     DATABASE = 353,
     DAY_P = 354,
     DEALLOCATE = 355,
     DEC = 356,
     DECIMAL_P = 357,
     DECLARE = 358,
     DEFAULT = 359,
     DEFAULTS = 360,
     DEFERRABLE = 361,
     DEFERRED = 362,
     DEFINER = 363,
     DELETE_P = 364,
     DELIMITER = 365,
     DELIMITERS = 366,
     DESC = 367,
     DICTIONARY = 368,
     DISABLE_P = 369,
     DISCARD = 370,
     DISTINCT = 371,
     DO = 372,
     DOCUMENT_P = 373,
     DOMAIN_P = 374,
     DOUBLE_P = 375,
     DROP = 376,
     EACH = 377,
     ELSE = 378,
     ENABLE_P = 379,
     ENCODING = 380,
     ENCRYPTED = 381,
     END_P = 382,
     ENUM_P = 383,
     ESCAPE = 384,
     EVENT = 385,
     EXCEPT = 386,
     EXCLUDE = 387,
     EXCLUDING = 388,
     EXCLUSIVE = 389,
     EXECUTE = 390,
     EXISTS = 391,
     EXPLAIN = 392,
     EXTENSION = 393,
     EXTERNAL = 394,
     EXTRACT = 395,
     FALSE_P = 396,
     FAMILY = 397,
     FETCH = 398,
     FILTER = 399,
     FIRST_P = 400,
     FLOAT_P = 401,
     FOLLOWING = 402,
     FOR = 403,
     FORCE = 404,
     FOREIGN = 405,
     FORWARD = 406,
     FREEZE = 407,
     FROM = 408,
     FULL = 409,
     FUNCTION = 410,
     FUNCTIONS = 411,
     GLOBAL = 412,
     GRANT = 413,
     GRANTED = 414,
     GREATEST = 415,
     GROUP_P = 416,
     HANDLER = 417,
     HAVING = 418,
     HEADER_P = 419,
     HOLD = 420,
     HOUR_P = 421,
     IDENTITY_P = 422,
     IF_P = 423,
     ILIKE = 424,
     IMMEDIATE = 425,
     IMMUTABLE = 426,
     IMPLICIT_P = 427,
     IN_P = 428,
     INCLUDING = 429,
     INCREMENT = 430,
     INDEX = 431,
     INDEXES = 432,
     INHERIT = 433,
     INHERITS = 434,
     INITIALLY = 435,
     INLINE_P = 436,
     INNER_P = 437,
     INOUT = 438,
     INPUT_P = 439,
     INSENSITIVE = 440,
     INSERT = 441,
     INSTEAD = 442,
     INT_P = 443,
     INTEGER = 444,
     INTERSECT = 445,
     INTERVAL = 446,
     INTO = 447,
     INVOKER = 448,
     IS = 449,
     ISNULL = 450,
     ISOLATION = 451,
     JOIN = 452,
     KEY = 453,
     LABEL = 454,
     LANGUAGE = 455,
     LARGE_P = 456,
     LAST_P = 457,
     LATERAL_P = 458,
     LC_COLLATE_P = 459,
     LC_CTYPE_P = 460,
     LEADING = 461,
     LEAKPROOF = 462,
     LEAST = 463,
     LEFT = 464,
     LEVEL = 465,
     LIKE = 466,
     LIMIT = 467,
     LISTEN = 468,
     LOAD = 469,
     LOCAL = 470,
     LOCALTIME = 471,
     LOCALTIMESTAMP = 472,
     LOCATION = 473,
     LOCK_P = 474,
     MAPPING = 475,
     MATCH = 476,
     MATERIALIZED = 477,
     MAXVALUE = 478,
     MINUTE_P = 479,
     MINVALUE = 480,
     MODE = 481,
     MONTH_P = 482,
     MOVE = 483,
     NAME_P = 484,
     NAMES = 485,
     NATIONAL = 486,
     NATURAL = 487,
     NCHAR = 488,
     NEXT = 489,
     NO = 490,
     NONE = 491,
     NOT = 492,
     NOTHING = 493,
     NOTIFY = 494,
     NOTNULL = 495,
     NOWAIT = 496,
     NULL_P = 497,
     NULLIF = 498,
     NULLS_P = 499,
     NUMERIC = 500,
     OBJECT_P = 501,
     OF = 502,
     OFF = 503,
     OFFSET = 504,
     OIDS = 505,
     ON = 506,
     ONLY = 507,
     OPERATOR = 508,
     OPTION = 509,
     OPTIONS = 510,
     OR = 511,
     ORDER = 512,
     ORDINALITY = 513,
     OUT_P = 514,
     OUTER_P = 515,
     OVER = 516,
     OVERLAPS = 517,
     OVERLAY = 518,
     OWNED = 519,
     OWNER = 520,
     PARSER = 521,
     PARTIAL = 522,
     PARTITION = 523,
     PASSING = 524,
     PASSWORD = 525,
     PLACING = 526,
     PLANS = 527,
     POSITION = 528,
     PRECEDING = 529,
     PRECISION = 530,
     PRESERVE = 531,
     PREPARE = 532,
     PREPARED = 533,
     PRIMARY = 534,
     PRIOR = 535,
     PRIVILEGES = 536,
     PROCEDURAL = 537,
     PROCEDURE = 538,
     PROGRAM = 539,
     QUOTE = 540,
     RANGE = 541,
     READ = 542,
     REAL = 543,
     REASSIGN = 544,
     RECHECK = 545,
     RECURSIVE = 546,
     REF = 547,
     REFERENCES = 548,
     REFRESH = 549,
     REINDEX = 550,
     RELATIVE_P = 551,
     RELEASE = 552,
     RENAME = 553,
     REPEATABLE = 554,
     REPLACE = 555,
     REPLICA = 556,
     RESET = 557,
     RESTART = 558,
     RESTRICT = 559,
     RETURNING = 560,
     RETURNS = 561,
     REVOKE = 562,
     RIGHT = 563,
     ROLE = 564,
     ROLLBACK = 565,
     ROW = 566,
     ROWS = 567,
     RULE = 568,
     SAVEPOINT = 569,
     SCHEMA = 570,
     SCROLL = 571,
     SEARCH = 572,
     SECOND_P = 573,
     SECURITY = 574,
     SELECT = 575,
     SEQUENCE = 576,
     SEQUENCES = 577,
     SERIALIZABLE = 578,
     SERVER = 579,
     SESSION = 580,
     SESSION_USER = 581,
     SET = 582,
     SETOF = 583,
     SHARE = 584,
     SHOW = 585,
     SIMILAR = 586,
     SIMPLE = 587,
     SMALLINT = 588,
     SNAPSHOT = 589,
     SOME = 590,
     STABLE = 591,
     STANDALONE_P = 592,
     START = 593,
     STATEMENT = 594,
     STATISTICS = 595,
     STDIN = 596,
     STDOUT = 597,
     STORAGE = 598,
     STRICT_P = 599,
     STRIP_P = 600,
     SUBSTRING = 601,
     SYMMETRIC = 602,
     SYSID = 603,
     SYSTEM_P = 604,
     TABLE = 605,
     TABLES = 606,
     TABLESPACE = 607,
     TEMP = 608,
     TEMPLATE = 609,
     TEMPORARY = 610,
     TEXT_P = 611,
     THEN = 612,
     TIME = 613,
     TIMESTAMP = 614,
     TO = 615,
     TRAILING = 616,
     TRANSACTION = 617,
     TREAT = 618,
     TRIGGER = 619,
     TRIM = 620,
     TRUE_P = 621,
     TRUNCATE = 622,
     TRUSTED = 623,
     TYPE_P = 624,
     TYPES_P = 625,
     UNBOUNDED = 626,
     UNCOMMITTED = 627,
     UNENCRYPTED = 628,
     UNION = 629,
     UNIQUE = 630,
     UNKNOWN = 631,
     UNLISTEN = 632,
     UNLOGGED = 633,
     UNTIL = 634,
     UPDATE = 635,
     USER = 636,
     USING = 637,
     VACUUM = 638,
     VALID = 639,
     VALIDATE = 640,
     VALIDATOR = 641,
     VALUE_P = 642,
     VALUES = 643,
     VARCHAR = 644,
     VARIADIC = 645,
     VARYING = 646,
     VERBOSE = 647,
     VERSION_P = 648,
     VIEW = 649,
     VIEWS = 650,
     VOLATILE = 651,
     WHEN = 652,
     WHERE = 653,
     WHITESPACE_P = 654,
     WINDOW = 655,
     WITH = 656,
     WITHIN = 657,
     WITHOUT = 658,
     WORK = 659,
     WRAPPER = 660,
     WRITE = 661,
     XML_P = 662,
     XMLATTRIBUTES = 663,
     XMLCONCAT = 664,
     XMLELEMENT = 665,
     XMLEXISTS = 666,
     XMLFOREST = 667,
     XMLPARSE = 668,
     XMLPI = 669,
     XMLROOT = 670,
     XMLSERIALIZE = 671,
     YEAR_P = 672,
     YES_P = 673,
     ZONE = 674,
     NULLS_FIRST = 675,
     NULLS_LAST = 676,
     WITH_ORDINALITY = 677,
     WITH_TIME = 678,
     POSTFIXOP = 679,
     UMINUS = 680
   };
#endif


#if ! defined YYSTYPE && ! defined YYSTYPE_IS_DECLARED
typedef union YYSTYPE
{
/* Line 387 of yacc.c  */
#line 179 "gram.y"

	core_YYSTYPE		core_yystype;
	/* these fields must match core_YYSTYPE: */
	int					ival;
	char				*str;
	const char			*keyword;

	char				chr;
	bool				boolean;
	JoinType			jtype;
	DropBehavior		dbehavior;
	OnCommitAction		oncommit;
	List				*list;
	Node				*node;
	Value				*value;
	ObjectType			objtype;
	TypeName			*typnam;
	FunctionParameter   *fun_param;
	FunctionParameterMode fun_param_mode;
	FuncWithArgs		*funwithargs;
	DefElem				*defelt;
	SortBy				*sortby;
	WindowDef			*windef;
	JoinExpr			*jexpr;
	IndexElem			*ielem;
	Alias				*alias;
	RangeVar			*range;
	IntoClause			*into;
	WithClause			*with;
	A_Indices			*aind;
	ResTarget			*target;
	struct PrivTarget	*privtarget;
	AccessPriv			*accesspriv;
	InsertStmt			*istmt;
	VariableSetStmt		*vsetstmt;


/* Line 387 of yacc.c  */
#line 751 "gram.c"
} YYSTYPE;
# define YYSTYPE_IS_TRIVIAL 1
# define yystype YYSTYPE /* obsolescent; will be withdrawn */
# define YYSTYPE_IS_DECLARED 1
#endif

#if ! defined YYLTYPE && ! defined YYLTYPE_IS_DECLARED
typedef struct YYLTYPE
{
  int first_line;
  int first_column;
  int last_line;
  int last_column;
} YYLTYPE;
# define yyltype YYLTYPE /* obsolescent; will be withdrawn */
# define YYLTYPE_IS_DECLARED 1
# define YYLTYPE_IS_TRIVIAL 1
#endif


#ifdef YYPARSE_PARAM
#if defined __STDC__ || defined __cplusplus
int base_yyparse (void *YYPARSE_PARAM);
#else
int base_yyparse ();
#endif
#else /* ! YYPARSE_PARAM */
#if defined __STDC__ || defined __cplusplus
int base_yyparse (core_yyscan_t yyscanner);
#else
int base_yyparse ();
#endif
#endif /* ! YYPARSE_PARAM */

#endif /* !YY_BASE_YY_GRAM_H_INCLUDED  */

/* Copy the second part of user declarations.  */

/* Line 390 of yacc.c  */
#line 791 "gram.c"

#ifdef short
# undef short
#endif

#ifdef YYTYPE_UINT8
typedef YYTYPE_UINT8 yytype_uint8;
#else
typedef unsigned char yytype_uint8;
#endif

#ifdef YYTYPE_INT8
typedef YYTYPE_INT8 yytype_int8;
#elif (defined __STDC__ || defined __C99__FUNC__ \
     || defined __cplusplus || defined _MSC_VER)
typedef signed char yytype_int8;
#else
typedef short int yytype_int8;
#endif

#ifdef YYTYPE_UINT16
typedef YYTYPE_UINT16 yytype_uint16;
#else
typedef unsigned short int yytype_uint16;
#endif

#ifdef YYTYPE_INT16
typedef YYTYPE_INT16 yytype_int16;
#else
typedef short int yytype_int16;
#endif

#ifndef YYSIZE_T
# ifdef __SIZE_TYPE__
#  define YYSIZE_T __SIZE_TYPE__
# elif defined size_t
#  define YYSIZE_T size_t
# elif ! defined YYSIZE_T && (defined __STDC__ || defined __C99__FUNC__ \
     || defined __cplusplus || defined _MSC_VER)
#  include <stddef.h> /* INFRINGES ON USER NAME SPACE */
#  define YYSIZE_T size_t
# else
#  define YYSIZE_T unsigned int
# endif
#endif

#define YYSIZE_MAXIMUM ((YYSIZE_T) -1)

#ifndef YY_
# if defined YYENABLE_NLS && YYENABLE_NLS
#  if ENABLE_NLS
#   include <libintl.h> /* INFRINGES ON USER NAME SPACE */
#   define YY_(Msgid) dgettext ("bison-runtime", Msgid)
#  endif
# endif
# ifndef YY_
#  define YY_(Msgid) Msgid
# endif
#endif

#ifndef __attribute__
/* This feature is available in gcc versions 2.5 and later.  */
# if (! defined __GNUC__ || __GNUC__ < 2 \
      || (__GNUC__ == 2 && __GNUC_MINOR__ < 5))
#  define __attribute__(Spec) /* empty */
# endif
#endif

/* Suppress unused-variable warnings by "using" E.  */
#if ! defined lint || defined __GNUC__
# define YYUSE(E) ((void) (E))
#else
# define YYUSE(E) /* empty */
#endif


/* Identity function, used to suppress warnings about constant conditions.  */
#ifndef lint
# define YYID(N) (N)
#else
#if (defined __STDC__ || defined __C99__FUNC__ \
     || defined __cplusplus || defined _MSC_VER)
static int
YYID (int yyi)
#else
static int
YYID (yyi)
    int yyi;
#endif
{
  return yyi;
}
#endif

#if ! defined yyoverflow || YYERROR_VERBOSE

/* The parser invokes alloca or malloc; define the necessary symbols.  */

# ifdef YYSTACK_USE_ALLOCA
#  if YYSTACK_USE_ALLOCA
#   ifdef __GNUC__
#    define YYSTACK_ALLOC __builtin_alloca
#   elif defined __BUILTIN_VA_ARG_INCR
#    include <alloca.h> /* INFRINGES ON USER NAME SPACE */
#   elif defined _AIX
#    define YYSTACK_ALLOC __alloca
#   elif defined _MSC_VER
#    include <malloc.h> /* INFRINGES ON USER NAME SPACE */
#    define alloca _alloca
#   else
#    define YYSTACK_ALLOC alloca
#    if ! defined _ALLOCA_H && ! defined EXIT_SUCCESS && (defined __STDC__ || defined __C99__FUNC__ \
     || defined __cplusplus || defined _MSC_VER)
#     include <stdlib.h> /* INFRINGES ON USER NAME SPACE */
      /* Use EXIT_SUCCESS as a witness for stdlib.h.  */
#     ifndef EXIT_SUCCESS
#      define EXIT_SUCCESS 0
#     endif
#    endif
#   endif
#  endif
# endif

# ifdef YYSTACK_ALLOC
   /* Pacify GCC's `empty if-body' warning.  */
#  define YYSTACK_FREE(Ptr) do { /* empty */; } while (YYID (0))
#  ifndef YYSTACK_ALLOC_MAXIMUM
    /* The OS might guarantee only one guard page at the bottom of the stack,
       and a page size can be as small as 4096 bytes.  So we cannot safely
       invoke alloca (N) if N exceeds 4096.  Use a slightly smaller number
       to allow for a few compiler-allocated temporary stack slots.  */
#   define YYSTACK_ALLOC_MAXIMUM 4032 /* reasonable circa 2006 */
#  endif
# else
#  define YYSTACK_ALLOC YYMALLOC
#  define YYSTACK_FREE YYFREE
#  ifndef YYSTACK_ALLOC_MAXIMUM
#   define YYSTACK_ALLOC_MAXIMUM YYSIZE_MAXIMUM
#  endif
#  if (defined __cplusplus && ! defined EXIT_SUCCESS \
       && ! ((defined YYMALLOC || defined malloc) \
	     && (defined YYFREE || defined free)))
#   include <stdlib.h> /* INFRINGES ON USER NAME SPACE */
#   ifndef EXIT_SUCCESS
#    define EXIT_SUCCESS 0
#   endif
#  endif
#  ifndef YYMALLOC
#   define YYMALLOC malloc
#   if ! defined malloc && ! defined EXIT_SUCCESS && (defined __STDC__ || defined __C99__FUNC__ \
     || defined __cplusplus || defined _MSC_VER)
void *malloc (YYSIZE_T); /* INFRINGES ON USER NAME SPACE */
#   endif
#  endif
#  ifndef YYFREE
#   define YYFREE free
#   if ! defined free && ! defined EXIT_SUCCESS && (defined __STDC__ || defined __C99__FUNC__ \
     || defined __cplusplus || defined _MSC_VER)
void free (void *); /* INFRINGES ON USER NAME SPACE */
#   endif
#  endif
# endif
#endif /* ! defined yyoverflow || YYERROR_VERBOSE */


#if (! defined yyoverflow \
     && (! defined __cplusplus \
	 || (defined YYLTYPE_IS_TRIVIAL && YYLTYPE_IS_TRIVIAL \
	     && defined YYSTYPE_IS_TRIVIAL && YYSTYPE_IS_TRIVIAL)))

/* A type that is properly aligned for any stack member.  */
union yyalloc
{
  yytype_int16 yyss_alloc;
  YYSTYPE yyvs_alloc;
  YYLTYPE yyls_alloc;
};

/* The size of the maximum gap between one aligned stack and the next.  */
# define YYSTACK_GAP_MAXIMUM (sizeof (union yyalloc) - 1)

/* The size of an array large to enough to hold all stacks, each with
   N elements.  */
# define YYSTACK_BYTES(N) \
     ((N) * (sizeof (yytype_int16) + sizeof (YYSTYPE) + sizeof (YYLTYPE)) \
      + 2 * YYSTACK_GAP_MAXIMUM)

# define YYCOPY_NEEDED 1

/* Relocate STACK from its old location to the new one.  The
   local variables YYSIZE and YYSTACKSIZE give the old and new number of
   elements in the stack, and YYPTR gives the new location of the
   stack.  Advance YYPTR to a properly aligned location for the next
   stack.  */
# define YYSTACK_RELOCATE(Stack_alloc, Stack)				\
    do									\
      {									\
	YYSIZE_T yynewbytes;						\
	YYCOPY (&yyptr->Stack_alloc, Stack, yysize);			\
	Stack = &yyptr->Stack_alloc;					\
	yynewbytes = yystacksize * sizeof (*Stack) + YYSTACK_GAP_MAXIMUM; \
	yyptr += yynewbytes / sizeof (*yyptr);				\
      }									\
    while (YYID (0))

#endif

#if defined YYCOPY_NEEDED && YYCOPY_NEEDED
/* Copy COUNT objects from SRC to DST.  The source and destination do
   not overlap.  */
# ifndef YYCOPY
#  if defined __GNUC__ && 1 < __GNUC__
#   define YYCOPY(Dst, Src, Count) \
      __builtin_memcpy (Dst, Src, (Count) * sizeof (*(Src)))
#  else
#   define YYCOPY(Dst, Src, Count)              \
      do                                        \
        {                                       \
          YYSIZE_T yyi;                         \
          for (yyi = 0; yyi < (Count); yyi++)   \
            (Dst)[yyi] = (Src)[yyi];            \
        }                                       \
      while (YYID (0))
#  endif
# endif
#endif /* !YYCOPY_NEEDED */

/* YYFINAL -- State number of the termination state.  */
#define YYFINAL  728
/* YYLAST -- Last index in YYTABLE.  */
#define YYLAST   79600

/* YYNTOKENS -- Number of terminals.  */
#define YYNTOKENS  443
/* YYNNTS -- Number of nonterminals.  */
#define YYNNTS  576
/* YYNRULES -- Number of rules.  */
#define YYNRULES  2370
/* YYNRULES -- Number of states.  */
#define YYNSTATES  4584

/* YYTRANSLATE(YYLEX) -- Bison symbol number corresponding to YYLEX.  */
#define YYUNDEFTOK  2
#define YYMAXUTOK   680

#define YYTRANSLATE(YYX)						\
  ((unsigned int) (YYX) <= YYMAXUTOK ? yytranslate[YYX] : YYUNDEFTOK)

/* YYTRANSLATE[YYLEX] -- Bison symbol number corresponding to YYLEX.  */
static const yytype_uint16 yytranslate[] =
{
       0,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,   432,     2,     2,
     437,   438,   430,   428,   441,   429,   439,   431,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,   442,   440,
     425,   424,   426,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,   435,     2,   436,   433,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     1,     2,     3,     4,
       5,     6,     7,     8,     9,    10,    11,    12,    13,    14,
      15,    16,    17,    18,    19,    20,    21,    22,    23,    24,
      25,    26,    27,    28,    29,    30,    31,    32,    33,    34,
      35,    36,    37,    38,    39,    40,    41,    42,    43,    44,
      45,    46,    47,    48,    49,    50,    51,    52,    53,    54,
      55,    56,    57,    58,    59,    60,    61,    62,    63,    64,
      65,    66,    67,    68,    69,    70,    71,    72,    73,    74,
      75,    76,    77,    78,    79,    80,    81,    82,    83,    84,
      85,    86,    87,    88,    89,    90,    91,    92,    93,    94,
      95,    96,    97,    98,    99,   100,   101,   102,   103,   104,
     105,   106,   107,   108,   109,   110,   111,   112,   113,   114,
     115,   116,   117,   118,   119,   120,   121,   122,   123,   124,
     125,   126,   127,   128,   129,   130,   131,   132,   133,   134,
     135,   136,   137,   138,   139,   140,   141,   142,   143,   144,
     145,   146,   147,   148,   149,   150,   151,   152,   153,   154,
     155,   156,   157,   158,   159,   160,   161,   162,   163,   164,
     165,   166,   167,   168,   169,   170,   171,   172,   173,   174,
     175,   176,   177,   178,   179,   180,   181,   182,   183,   184,
     185,   186,   187,   188,   189,   190,   191,   192,   193,   194,
     195,   196,   197,   198,   199,   200,   201,   202,   203,   204,
     205,   206,   207,   208,   209,   210,   211,   212,   213,   214,
     215,   216,   217,   218,   219,   220,   221,   222,   223,   224,
     225,   226,   227,   228,   229,   230,   231,   232,   233,   234,
     235,   236,   237,   238,   239,   240,   241,   242,   243,   244,
     245,   246,   247,   248,   249,   250,   251,   252,   253,   254,
     255,   256,   257,   258,   259,   260,   261,   262,   263,   264,
     265,   266,   267,   268,   269,   270,   271,   272,   273,   274,
     275,   276,   277,   278,   279,   280,   281,   282,   283,   284,
     285,   286,   287,   288,   289,   290,   291,   292,   293,   294,
     295,   296,   297,   298,   299,   300,   301,   302,   303,   304,
     305,   306,   307,   308,   309,   310,   311,   312,   313,   314,
     315,   316,   317,   318,   319,   320,   321,   322,   323,   324,
     325,   326,   327,   328,   329,   330,   331,   332,   333,   334,
     335,   336,   337,   338,   339,   340,   341,   342,   343,   344,
     345,   346,   347,   348,   349,   350,   351,   352,   353,   354,
     355,   356,   357,   358,   359,   360,   361,   362,   363,   364,
     365,   366,   367,   368,   369,   370,   371,   372,   373,   374,
     375,   376,   377,   378,   379,   380,   381,   382,   383,   384,
     385,   386,   387,   388,   389,   390,   391,   392,   393,   394,
     395,   396,   397,   398,   399,   400,   401,   402,   403,   404,
     405,   406,   407,   408,   409,   410,   411,   412,   413,   414,
     415,   416,   417,   418,   419,   420,   421,   422,   423,   427,
     434
};

#if YYDEBUG
/* YYPRHS[YYN] -- Index of the first RHS symbol of rule number YYN in
   YYRHS.  */
static const yytype_uint16 yyprhs[] =
{
       0,     0,     3,     5,     9,    11,    13,    15,    17,    19,
      21,    23,    25,    27,    29,    31,    33,    35,    37,    39,
      41,    43,    45,    47,    49,    51,    53,    55,    57,    59,
      61,    63,    65,    67,    69,    71,    73,    75,    77,    79,
      81,    83,    85,    87,    89,    91,    93,    95,    97,    99,
     101,   103,   105,   107,   109,   111,   113,   115,   117,   119,
     121,   123,   125,   127,   129,   131,   133,   135,   137,   139,
     141,   143,   145,   147,   149,   151,   153,   155,   157,   159,
     161,   163,   165,   167,   169,   171,   173,   175,   177,   179,
     181,   183,   185,   187,   189,   191,   193,   195,   197,   199,
     201,   203,   205,   207,   209,   211,   213,   215,   217,   219,
     221,   223,   225,   227,   229,   231,   233,   235,   237,   239,
     241,   243,   244,   250,   252,   253,   256,   257,   260,   261,
     264,   267,   271,   275,   277,   281,   285,   288,   290,   292,
     295,   298,   301,   305,   309,   315,   321,   322,   326,   332,
     338,   344,   350,   356,   360,   366,   370,   376,   382,   389,
     391,   393,   397,   403,   410,   415,   425,   433,   435,   436,
     439,   440,   442,   444,   446,   448,   450,   452,   455,   459,
     463,   466,   472,   474,   478,   482,   486,   490,   492,   496,
     500,   503,   506,   509,   512,   516,   520,   524,   528,   530,
     534,   536,   540,   542,   544,   547,   550,   553,   555,   557,
     559,   561,   563,   565,   567,   571,   578,   580,   582,   584,
     586,   588,   589,   591,   593,   596,   598,   601,   605,   608,
     610,   612,   615,   617,   620,   622,   625,   629,   634,   638,
     641,   646,   648,   650,   652,   654,   656,   659,   662,   665,
     668,   671,   676,   683,   694,   708,   713,   720,   731,   745,
     750,   757,   762,   769,   775,   783,   795,   810,   812,   816,
     819,   823,   828,   835,   842,   849,   855,   861,   868,   875,
     880,   889,   894,   897,   902,   906,   913,   918,   922,   926,
     930,   934,   938,   943,   948,   952,   956,   960,   964,   968,
     972,   977,   982,   986,   989,   993,   996,   999,  1003,  1007,
    1010,  1013,  1017,  1019,  1023,  1026,  1028,  1030,  1031,  1034,
    1035,  1038,  1039,  1041,  1043,  1045,  1049,  1053,  1056,  1057,
    1059,  1063,  1067,  1069,  1075,  1079,  1084,  1086,  1090,  1095,
    1102,  1107,  1116,  1119,  1122,  1134,  1142,  1144,  1146,  1148,
    1149,  1151,  1153,  1155,  1157,  1161,  1164,  1165,  1167,  1169,
    1171,  1175,  1179,  1181,  1183,  1187,  1191,  1195,  1199,  1204,
    1208,  1211,  1213,  1214,  1217,  1218,  1222,  1223,  1225,  1226,
    1228,  1232,  1235,  1237,  1239,  1241,  1245,  1246,  1248,  1252,
    1254,  1266,  1281,  1292,  1306,  1308,  1310,  1313,  1316,  1319,
    1322,  1324,  1325,  1327,  1328,  1332,  1333,  1335,  1339,  1341,
    1345,  1347,  1349,  1351,  1353,  1355,  1360,  1365,  1368,  1369,
    1373,  1375,  1377,  1380,  1383,  1385,  1389,  1394,  1400,  1403,
    1409,  1411,  1414,  1417,  1420,  1424,  1428,  1432,  1433,  1435,
    1437,  1439,  1441,  1443,  1445,  1449,  1451,  1457,  1465,  1469,
    1478,  1483,  1493,  1505,  1508,  1509,  1513,  1514,  1516,  1520,
    1522,  1525,  1528,  1531,  1532,  1534,  1538,  1542,  1549,  1554,
    1555,  1557,  1559,  1562,  1565,  1566,  1570,  1574,  1577,  1579,
    1581,  1584,  1587,  1592,  1593,  1596,  1599,  1602,  1603,  1607,
    1612,  1617,  1618,  1621,  1622,  1627,  1628,  1632,  1640,  1646,
    1649,  1653,  1654,  1663,  1668,  1670,  1671,  1678,  1684,  1689,
    1696,  1698,  1699,  1701,  1704,  1707,  1709,  1712,  1716,  1719,
    1722,  1725,  1728,  1732,  1736,  1738,  1742,  1744,  1745,  1747,
    1750,  1753,  1755,  1757,  1761,  1768,  1779,  1781,  1782,  1784,
    1787,  1790,  1791,  1794,  1797,  1799,  1800,  1806,  1814,  1816,
    1817,  1825,  1828,  1829,  1833,  1839,  1845,  1854,  1857,  1858,
    1861,  1864,  1867,  1873,  1876,  1877,  1880,  1888,  1899,  1906,
    1913,  1920,  1927,  1935,  1943,  1953,  1963,  1970,  1978,  1985,
    1994,  2003,  2012,  2021,  2028,  2035,  2043,  2051,  2060,  2067,
    2074,  2082,  2085,  2088,  2091,  2094,  2096,  2099,  2101,  2102,
    2109,  2118,  2126,  2133,  2138,  2139,  2141,  2145,  2150,  2152,
    2156,  2158,  2161,  2164,  2167,  2170,  2172,  2174,  2185,  2188,
    2189,  2192,  2195,  2197,  2198,  2203,  2210,  2216,  2221,  2226,
    2237,  2251,  2257,  2265,  2274,  2276,  2278,  2280,  2288,  2298,
    2307,  2323,  2344,  2346,  2348,  2351,  2353,  2357,  2359,  2361,
    2363,  2367,  2369,  2373,  2374,  2376,  2377,  2379,  2381,  2386,
    2387,  2389,  2393,  2394,  2396,  2398,  2400,  2402,  2405,  2406,
    2407,  2410,  2413,  2415,  2418,  2421,  2424,  2427,  2434,  2443,
    2455,  2469,  2471,  2475,  2481,  2483,  2487,  2493,  2495,  2498,
    2501,  2503,  2512,  2517,  2523,  2528,  2533,  2538,  2542,  2550,
    2559,  2566,  2573,  2580,  2587,  2594,  2599,  2605,  2609,  2611,
    2615,  2619,  2621,  2623,  2625,  2627,  2629,  2631,  2635,  2637,
    2641,  2645,  2647,  2648,  2650,  2654,  2662,  2672,  2682,  2686,
    2687,  2701,  2703,  2707,  2713,  2720,  2725,  2733,  2736,  2738,
    2739,  2742,  2743,  2746,  2751,  2752,  2754,  2755,  2762,  2771,
    2780,  2782,  2786,  2792,  2798,  2806,  2816,  2824,  2834,  2840,
    2847,  2854,  2859,  2865,  2873,  2875,  2877,  2879,  2882,  2884,
    2887,  2890,  2892,  2894,  2896,  2898,  2900,  2902,  2906,  2910,
    2914,  2918,  2920,  2924,  2926,  2929,  2932,  2936,  2942,  2945,
    2948,  2949,  2956,  2964,  2972,  2980,  2989,  2998,  3005,  3014,
    3024,  3034,  3042,  3053,  3061,  3063,  3065,  3067,  3069,  3071,
    3073,  3075,  3077,  3079,  3082,  3084,  3086,  3088,  3090,  3092,
    3095,  3097,  3101,  3104,  3108,  3112,  3116,  3120,  3122,  3124,
    3133,  3143,  3153,  3163,  3173,  3176,  3177,  3179,  3181,  3184,
    3187,  3189,  3191,  3193,  3195,  3197,  3199,  3201,  3203,  3206,
    3208,  3210,  3213,  3216,  3218,  3221,  3225,  3229,  3233,  3237,
    3242,  3247,  3251,  3255,  3259,  3264,  3269,  3273,  3278,  3283,
    3285,  3287,  3289,  3290,  3298,  3306,  3317,  3319,  3321,  3324,
    3329,  3335,  3337,  3341,  3344,  3347,  3350,  3353,  3355,  3358,
    3361,  3366,  3370,  3373,  3376,  3379,  3382,  3386,  3389,  3392,
    3395,  3401,  3407,  3413,  3415,  3419,  3421,  3424,  3428,  3429,
    3431,  3435,  3438,  3445,  3452,  3462,  3466,  3467,  3471,  3472,
    3478,  3481,  3482,  3486,  3490,  3494,  3502,  3510,  3521,  3523,
    3525,  3527,  3529,  3544,  3546,  3547,  3549,  3550,  3552,  3553,
    3556,  3557,  3559,  3563,  3569,  3575,  3583,  3586,  3587,  3589,
    3592,  3593,  3595,  3597,  3598,  3600,  3602,  3603,  3613,  3626,
    3634,  3637,  3638,  3642,  3645,  3647,  3651,  3655,  3658,  3660,
    3664,  3668,  3672,  3675,  3678,  3680,  3682,  3684,  3686,  3689,
    3691,  3693,  3695,  3697,  3702,  3708,  3710,  3714,  3718,  3720,
    3724,  3728,  3734,  3741,  3743,  3747,  3749,  3752,  3757,  3763,
    3765,  3767,  3769,  3771,  3775,  3779,  3782,  3785,  3787,  3790,
    3793,  3796,  3798,  3801,  3804,  3806,  3808,  3810,  3814,  3817,
    3818,  3821,  3823,  3827,  3833,  3835,  3838,  3840,  3841,  3847,
    3855,  3861,  3869,  3875,  3883,  3887,  3893,  3899,  3905,  3907,
    3911,  3914,  3916,  3919,  3921,  3924,  3936,  3947,  3958,  3961,
    3964,  3965,  3975,  3978,  3979,  3984,  3989,  3994,  3996,  3998,
    4000,  4001,  4007,  4013,  4021,  4028,  4035,  4042,  4049,  4058,
    4067,  4074,  4081,  4089,  4099,  4109,  4116,  4123,  4130,  4139,
    4146,  4155,  4162,  4171,  4179,  4189,  4196,  4205,  4213,  4223,
    4232,  4243,  4253,  4265,  4274,  4284,  4296,  4305,  4314,  4322,
    4329,  4336,  4343,  4352,  4361,  4370,  4379,  4386,  4396,  4398,
    4399,  4402,  4403,  4411,  4418,  4425,  4432,  4439,  4446,  4454,
    4464,  4474,  4481,  4490,  4499,  4508,  4517,  4526,  4533,  4542,
    4549,  4558,  4566,  4576,  4584,  4594,  4601,  4609,  4616,  4623,
    4630,  4637,  4644,  4652,  4660,  4668,  4678,  4688,  4695,  4702,
    4709,  4718,  4727,  4736,  4743,  4751,  4765,  4767,  4769,  4773,
    4777,  4779,  4781,  4783,  4785,  4787,  4789,  4791,  4792,  4794,
    4796,  4798,  4800,  4802,  4804,  4805,  4812,  4821,  4825,  4828,
    4829,  4832,  4835,  4838,  4841,  4845,  4849,  4852,  4855,  4858,
    4861,  4865,  4868,  4874,  4879,  4883,  4887,  4891,  4893,  4895,
    4896,  4900,  4903,  4906,  4908,  4911,  4913,  4917,  4920,  4922,
    4923,  4933,  4945,  4958,  4973,  4977,  4982,  4987,  4988,  4991,
    4997,  5000,  5001,  5005,  5009,  5013,  5017,  5021,  5025,  5029,
    5033,  5037,  5041,  5045,  5049,  5053,  5058,  5062,  5066,  5068,
    5069,  5075,  5082,  5087,  5090,  5091,  5096,  5100,  5106,  5111,
    5116,  5123,  5128,  5135,  5142,  5148,  5156,  5166,  5173,  5175,
    5176,  5183,  5195,  5207,  5219,  5233,  5243,  5255,  5266,  5271,
    5274,  5280,  5283,  5284,  5289,  5295,  5301,  5306,  5313,  5315,
    5319,  5321,  5323,  5325,  5327,  5330,  5335,  5337,  5339,  5341,
    5342,  5344,  5345,  5347,  5348,  5352,  5353,  5356,  5361,  5365,
    5371,  5373,  5375,  5377,  5379,  5381,  5383,  5385,  5387,  5389,
    5391,  5395,  5398,  5400,  5402,  5404,  5406,  5407,  5413,  5417,
    5418,  5420,  5422,  5424,  5426,  5430,  5440,  5444,  5445,  5448,
    5452,  5455,  5459,  5466,  5468,  5473,  5476,  5478,  5482,  5485,
    5488,  5489,  5497,  5500,  5501,  5507,  5511,  5512,  5515,  5518,
    5521,  5524,  5527,  5531,  5533,  5537,  5539,  5542,  5544,  5545,
    5554,  5556,  5560,  5562,  5564,  5568,  5574,  5577,  5579,  5583,
    5591,  5593,  5594,  5598,  5601,  5604,  5607,  5608,  5611,  5614,
    5616,  5618,  5622,  5626,  5628,  5631,  5636,  5641,  5644,  5648,
    5654,  5660,  5662,  5664,  5674,  5676,  5679,  5684,  5689,  5694,
    5697,  5701,  5703,  5707,  5714,  5716,  5717,  5720,  5721,  5725,
    5729,  5734,  5739,  5744,  5749,  5753,  5756,  5758,  5760,  5761,
    5763,  5765,  5766,  5768,  5774,  5776,  5777,  5779,  5780,  5784,
    5786,  5790,  5795,  5799,  5802,  5805,  5807,  5809,  5811,  5812,
    5815,  5820,  5826,  5829,  5833,  5835,  5837,  5839,  5841,  5845,
    5846,  5848,  5850,  5852,  5854,  5856,  5860,  5861,  5864,  5865,
    5867,  5871,  5873,  5874,  5876,  5879,  5883,  5886,  5891,  5894,
    5898,  5901,  5902,  5905,  5909,  5912,  5913,  5915,  5919,  5922,
    5925,  5929,  5932,  5936,  5938,  5943,  5947,  5952,  5958,  5963,
    5969,  5974,  5980,  5983,  5988,  5990,  5992,  5993,  5995,  6000,
    6006,  6011,  6012,  6015,  6018,  6021,  6023,  6025,  6026,  6031,
    6034,  6036,  6039,  6042,  6047,  6049,  6053,  6055,  6058,  6062,
    6065,  6072,  6075,  6077,  6081,  6086,  6087,  6089,  6090,  6093,
    6094,  6097,  6102,  6103,  6105,  6106,  6108,  6112,  6116,  6119,
    6123,  6129,  6136,  6139,  6143,  6147,  6152,  6153,  6155,  6157,
    6159,  6161,  6163,  6166,  6172,  6174,  6176,  6178,  6180,  6183,
    6187,  6191,  6192,  6194,  6196,  6198,  6200,  6202,  6205,  6208,
    6211,  6214,  6217,  6219,  6223,  6224,  6226,  6228,  6230,  6232,
    6238,  6241,  6243,  6245,  6247,  6249,  6255,  6258,  6261,  6264,
    6266,  6270,  6274,  6277,  6279,  6280,  6284,  6285,  6291,  6294,
    6300,  6303,  6305,  6308,  6312,  6313,  6315,  6317,  6319,  6321,
    6323,  6325,  6329,  6333,  6337,  6341,  6345,  6349,  6353,  6354,
    6356,  6361,  6363,  6367,  6371,  6377,  6380,  6383,  6387,  6391,
    6395,  6399,  6403,  6407,  6411,  6415,  6419,  6423,  6426,  6429,
    6433,  6437,  6440,  6444,  6450,  6455,  6462,  6466,  6472,  6477,
    6484,  6489,  6496,  6502,  6510,  6514,  6517,  6522,  6525,  6529,
    6533,  6538,  6542,  6547,  6551,  6556,  6562,  6569,  6576,  6584,
    6591,  6599,  6606,  6614,  6618,  6623,  6628,  6635,  6638,  6642,
    6647,  6649,  6653,  6656,  6659,  6663,  6667,  6671,  6675,  6679,
    6683,  6687,  6691,  6695,  6699,  6702,  6705,  6711,  6718,  6725,
    6733,  6737,  6742,  6744,  6746,  6749,  6754,  6756,  6758,  6760,
    6763,  6766,  6769,  6772,  6774,  6778,  6784,  6791,  6800,  6807,
    6814,  6819,  6824,  6826,  6828,  6830,  6836,  6838,  6840,  6845,
    6847,  6852,  6854,  6859,  6861,  6866,  6868,  6870,  6872,  6874,
    6876,  6878,  6885,  6890,  6895,  6900,  6905,  6912,  6918,  6924,
    6930,  6935,  6942,  6947,  6952,  6957,  6962,  6968,  6976,  6984,
    6994,  7000,  7005,  7012,  7018,  7026,  7034,  7042,  7045,  7049,
    7053,  7057,  7062,  7063,  7068,  7070,  7074,  7078,  7080,  7082,
    7084,  7087,  7090,  7091,  7094,  7099,  7104,  7111,  7117,  7118,
    7124,  7125,  7128,  7129,  7131,  7135,  7139,  7142,  7145,  7146,
    7153,  7155,  7156,  7160,  7161,  7164,  7167,  7168,  7170,  7175,
    7178,  7181,  7184,  7187,  7190,  7195,  7199,  7205,  7207,  7209,
    7211,  7213,  7215,  7217,  7219,  7221,  7223,  7225,  7227,  7229,
    7231,  7233,  7235,  7240,  7242,  7247,  7249,  7254,  7256,  7259,
    7261,  7264,  7266,  7270,  7272,  7276,  7278,  7282,  7284,  7288,
    7292,  7296,  7299,  7301,  7305,  7309,  7310,  7312,  7314,  7316,
    7318,  7320,  7322,  7324,  7326,  7331,  7335,  7338,  7342,  7343,
    7347,  7351,  7354,  7357,  7359,  7360,  7363,  7366,  7370,  7373,
    7375,  7377,  7381,  7387,  7389,  7392,  7397,  7400,  7401,  7403,
    7404,  7406,  7409,  7412,  7415,  7419,  7425,  7427,  7430,  7431,
    7434,  7436,  7437,  7439,  7441,  7443,  7447,  7451,  7453,  7454,
    7456,  7460,  7464,  7467,  7469,  7471,  7473,  7477,  7479,  7482,
    7484,  7488,  7490,  7492,  7494,  7496,  7498,  7500,  7502,  7505,
    7507,  7509,  7511,  7513,  7515,  7518,  7525,  7528,  7532,  7539,
    7541,  7543,  7545,  7547,  7549,  7551,  7553,  7557,  7559,  7562,
    7565,  7567,  7569,  7571,  7573,  7575,  7577,  7579,  7581,  7583,
    7585,  7587,  7589,  7591,  7593,  7595,  7597,  7599,  7601,  7603,
    7605,  7607,  7609,  7611,  7613,  7615,  7617,  7619,  7621,  7623,
    7625,  7627,  7629,  7631,  7633,  7635,  7637,  7639,  7641,  7643,
    7645,  7647,  7649,  7651,  7653,  7655,  7657,  7659,  7661,  7663,
    7665,  7667,  7669,  7671,  7673,  7675,  7677,  7679,  7681,  7683,
    7685,  7687,  7689,  7691,  7693,  7695,  7697,  7699,  7701,  7703,
    7705,  7707,  7709,  7711,  7713,  7715,  7717,  7719,  7721,  7723,
    7725,  7727,  7729,  7731,  7733,  7735,  7737,  7739,  7741,  7743,
    7745,  7747,  7749,  7751,  7753,  7755,  7757,  7759,  7761,  7763,
    7765,  7767,  7769,  7771,  7773,  7775,  7777,  7779,  7781,  7783,
    7785,  7787,  7789,  7791,  7793,  7795,  7797,  7799,  7801,  7803,
    7805,  7807,  7809,  7811,  7813,  7815,  7817,  7819,  7821,  7823,
    7825,  7827,  7829,  7831,  7833,  7835,  7837,  7839,  7841,  7843,
    7845,  7847,  7849,  7851,  7853,  7855,  7857,  7859,  7861,  7863,
    7865,  7867,  7869,  7871,  7873,  7875,  7877,  7879,  7881,  7883,
    7885,  7887,  7889,  7891,  7893,  7895,  7897,  7899,  7901,  7903,
    7905,  7907,  7909,  7911,  7913,  7915,  7917,  7919,  7921,  7923,
    7925,  7927,  7929,  7931,  7933,  7935,  7937,  7939,  7941,  7943,
    7945,  7947,  7949,  7951,  7953,  7955,  7957,  7959,  7961,  7963,
    7965,  7967,  7969,  7971,  7973,  7975,  7977,  7979,  7981,  7983,
    7985,  7987,  7989,  7991,  7993,  7995,  7997,  7999,  8001,  8003,
    8005,  8007,  8009,  8011,  8013,  8015,  8017,  8019,  8021,  8023,
    8025,  8027,  8029,  8031,  8033,  8035,  8037,  8039,  8041,  8043,
    8045,  8047,  8049,  8051,  8053,  8055,  8057,  8059,  8061,  8063,
    8065,  8067,  8069,  8071,  8073,  8075,  8077,  8079,  8081,  8083,
    8085,  8087,  8089,  8091,  8093,  8095,  8097,  8099,  8101,  8103,
    8105,  8107,  8109,  8111,  8113,  8115,  8117,  8119,  8121,  8123,
    8125,  8127,  8129,  8131,  8133,  8135,  8137,  8139,  8141,  8143,
    8145,  8147,  8149,  8151,  8153,  8155,  8157,  8159,  8161,  8163,
    8165,  8167,  8169,  8171,  8173,  8175,  8177,  8179,  8181,  8183,
    8185,  8187,  8189,  8191,  8193,  8195,  8197,  8199,  8201,  8203,
    8205,  8207,  8209,  8211,  8213,  8215,  8217,  8219,  8221,  8223,
    8225,  8227,  8229,  8231,  8233,  8235,  8237,  8239,  8241,  8243,
    8245,  8247,  8249,  8251,  8253,  8255,  8257,  8259,  8261,  8263,
    8265,  8267,  8269,  8271,  8273,  8275,  8277,  8279,  8281,  8283,
    8285,  8287,  8289,  8291,  8293,  8295,  8297,  8299,  8301,  8303,
    8305,  8307,  8309,  8311,  8313,  8315,  8317,  8319,  8321,  8323,
    8325,  8327,  8329,  8331,  8333,  8335,  8337,  8339,  8341,  8343,
    8345,  8347,  8349,  8351,  8353,  8355,  8357,  8359,  8361,  8363,
    8365,  8367,  8369,  8371,  8373,  8375,  8377,  8379,  8381,  8383,
    8385,  8387,  8389,  8391,  8393,  8395,  8397,  8399,  8401,  8403,
    8405
};

/* YYRHS -- A `-1'-separated list of the rules' RHS.  */
static const yytype_int16 yyrhs[] =
{
     444,     0,    -1,   445,    -1,   445,   440,   446,    -1,   446,
      -1,   638,    -1,   788,    -1,   789,    -1,   702,    -1,   795,
      -1,   652,    -1,   590,    -1,   593,    -1,   599,    -1,   613,
      -1,   615,    -1,   740,    -1,   462,    -1,   762,    -1,   763,
      -1,   569,    -1,   793,    -1,   492,    -1,   758,    -1,   504,
      -1,   456,    -1,   454,    -1,   798,    -1,   797,    -1,   619,
      -1,   458,    -1,   457,    -1,   805,    -1,   490,    -1,   507,
      -1,   800,    -1,   676,    -1,   487,    -1,   508,    -1,   561,
      -1,   640,    -1,   751,    -1,   799,    -1,   794,    -1,   587,
      -1,   594,    -1,   608,    -1,   614,    -1,   718,    -1,   461,
      -1,   564,    -1,   654,    -1,   661,    -1,   662,    -1,   576,
      -1,   465,    -1,   568,    -1,   524,    -1,   584,    -1,   620,
      -1,   634,    -1,   447,    -1,   453,    -1,   616,    -1,   784,
      -1,   822,    -1,   841,    -1,   642,    -1,   828,    -1,   491,
      -1,   748,    -1,   641,    -1,   753,    -1,   598,    -1,   612,
      -1,   464,    -1,   665,    -1,   666,    -1,   667,    -1,   582,
      -1,   771,    -1,   669,    -1,   586,    -1,   633,    -1,   459,
      -1,   460,    -1,   618,    -1,   792,    -1,   820,    -1,   811,
      -1,   683,    -1,   687,    -1,   698,    -1,   707,    -1,   823,
      -1,   774,    -1,   567,    -1,   783,    -1,   830,    -1,   772,
      -1,   817,    -1,   668,    -1,   755,    -1,   744,    -1,   743,
      -1,   745,    -1,   759,    -1,   688,    -1,   699,    -1,   764,
      -1,   679,    -1,   845,    -1,   776,    -1,   674,    -1,   775,
      -1,   834,    -1,   802,    -1,   481,    -1,   469,    -1,   486,
      -1,   781,    -1,    -1,    84,   309,  1008,   448,   449,    -1,
     401,    -1,    -1,   449,   452,    -1,    -1,   450,   451,    -1,
      -1,   270,  1007,    -1,   270,   242,    -1,   126,   270,  1007,
      -1,   373,   270,  1007,    -1,   178,    -1,    76,   212,  1010,
      -1,   384,   379,  1007,    -1,   381,  1009,    -1,     3,    -1,
     451,    -1,   348,  1006,    -1,    19,  1009,    -1,   309,  1009,
      -1,   173,   309,  1009,    -1,   173,   161,  1009,    -1,    84,
     381,  1008,   448,   449,    -1,    24,   309,  1008,   448,   450,
      -1,    -1,   173,    98,   999,    -1,    24,   309,  1008,   455,
     484,    -1,    24,   309,    22,   455,   484,    -1,    24,   381,
    1008,   448,   450,    -1,    24,   381,  1008,   455,   484,    -1,
      24,   381,    22,   455,   484,    -1,   121,   309,  1009,    -1,
     121,   309,   168,   136,  1009,    -1,   121,   381,  1009,    -1,
     121,   381,   168,   136,  1009,    -1,    84,   161,  1008,   448,
     449,    -1,    24,   161,  1008,   463,   381,  1009,    -1,    18,
      -1,   121,    -1,   121,   161,  1009,    -1,   121,   161,   168,
     136,  1009,    -1,    84,   315,   466,    39,  1008,   467,    -1,
      84,   315,  1011,   467,    -1,    84,   315,   168,   237,   136,
     466,    39,  1008,   467,    -1,    84,   315,   168,   237,   136,
    1011,   467,    -1,  1011,    -1,    -1,   467,   468,    -1,    -1,
     524,    -1,   707,    -1,   568,    -1,   620,    -1,   687,    -1,
     781,    -1,   327,   470,    -1,   327,   215,   470,    -1,   327,
     325,   470,    -1,   362,   779,    -1,   325,    60,    32,   362,
     779,    -1,   472,    -1,   473,   360,   474,    -1,   473,   424,
     474,    -1,   473,   360,   104,    -1,   473,   424,   104,    -1,
     471,    -1,   473,   153,    87,    -1,   358,   419,   478,    -1,
      56,  1007,    -1,   315,  1007,    -1,   230,   479,    -1,   309,
     480,    -1,   325,    39,   480,    -1,   325,    39,   104,    -1,
     407,   254,   941,    -1,   362,   334,  1007,    -1,  1011,    -1,
     473,   439,  1011,    -1,   475,    -1,   474,   441,   475,    -1,
     477,    -1,   574,    -1,   287,   372,    -1,   287,    73,    -1,
     299,   287,    -1,   323,    -1,   366,    -1,   141,    -1,   251,
      -1,   480,    -1,  1007,    -1,     3,    -1,   925,  1007,   927,
      -1,   925,   437,  1006,   438,  1007,   927,    -1,   574,    -1,
     104,    -1,   215,    -1,  1007,    -1,   104,    -1,    -1,  1013,
      -1,  1007,    -1,   302,   482,    -1,   483,    -1,   358,   419,
      -1,   362,   196,   210,    -1,   325,    39,    -1,   473,    -1,
      22,    -1,   327,   470,    -1,   481,    -1,   327,   472,    -1,
     481,    -1,   330,   473,    -1,   330,   358,   419,    -1,   330,
     362,   196,   210,    -1,   330,   325,    39,    -1,   330,    22,
      -1,   327,    78,   488,   489,    -1,    22,    -1,   995,    -1,
     107,    -1,   170,    -1,    62,    -1,   115,    22,    -1,   115,
     353,    -1,   115,   355,    -1,   115,   272,    -1,   115,   322,
      -1,    24,   350,   892,   493,    -1,    24,   350,   168,   136,
     892,   493,    -1,    24,   350,    22,   173,   352,   998,   327,
     352,   998,   833,    -1,    24,   350,    22,   173,   352,   998,
     264,    49,  1009,   327,   352,   998,   833,    -1,    24,   176,
     996,   493,    -1,    24,   176,   168,   136,   996,   493,    -1,
      24,   176,    22,   173,   352,   998,   327,   352,   998,   833,
      -1,    24,   176,    22,   173,   352,   998,   264,    49,  1009,
     327,   352,   998,   833,    -1,    24,   321,   996,   493,    -1,
      24,   321,   168,   136,   996,   493,    -1,    24,   394,   996,
     493,    -1,    24,   394,   168,   136,   996,   493,    -1,    24,
     222,   394,   996,   493,    -1,    24,   222,   394,   168,   136,
     996,   493,    -1,    24,   222,   394,    22,   173,   352,   998,
     327,   352,   998,   833,    -1,    24,   222,   394,    22,   173,
     352,   998,   264,    49,  1009,   327,   352,   998,   833,    -1,
     494,    -1,   493,   441,   494,    -1,    18,   532,    -1,    18,
      69,   532,    -1,    24,   760,  1011,   495,    -1,    24,   760,
    1011,   121,   237,   242,    -1,    24,   760,  1011,   327,   237,
     242,    -1,    24,   760,  1011,   327,   340,  1010,    -1,    24,
     760,  1011,   327,   500,    -1,    24,   760,  1011,   302,   500,
      -1,    24,   760,  1011,   327,   343,  1011,    -1,   121,   760,
     168,   136,  1011,   496,    -1,   121,   760,  1011,   496,    -1,
      24,   760,  1011,   761,   369,   905,   497,   498,    -1,    24,
     760,  1011,   602,    -1,    18,   541,    -1,    24,    77,   998,
     631,    -1,   385,    77,   998,    -1,   121,    77,   168,   136,
     998,   496,    -1,   121,    77,   998,   496,    -1,   327,   401,
     250,    -1,   327,   403,   250,    -1,    65,   251,   998,    -1,
     327,   403,    65,    -1,   124,   364,   998,    -1,   124,    25,
     364,   998,    -1,   124,   301,   364,   998,    -1,   124,   364,
      22,    -1,   124,   364,   381,    -1,   114,   364,   998,    -1,
     114,   364,    22,    -1,   114,   364,   381,    -1,   124,   313,
     998,    -1,   124,    25,   313,   998,    -1,   124,   301,   313,
     998,    -1,   114,   313,   998,    -1,   178,   996,    -1,   235,
     178,   996,    -1,   247,   672,    -1,   237,   247,    -1,   265,
     360,  1008,    -1,   327,   352,   998,    -1,   327,   500,    -1,
     302,   500,    -1,   301,   167,   499,    -1,   602,    -1,   327,
     104,   929,    -1,   121,   104,    -1,    52,    -1,   304,    -1,
      -1,    67,   672,    -1,    -1,   382,   929,    -1,    -1,   238,
      -1,   154,    -1,   104,    -1,   382,   176,   998,    -1,   437,
     502,   438,    -1,   401,   500,    -1,    -1,   503,    -1,   502,
     441,   503,    -1,  1014,   424,   646,    -1,  1014,    -1,  1014,
     439,  1014,   424,   646,    -1,  1014,   439,  1014,    -1,    24,
     369,   672,   505,    -1,   506,    -1,   505,   441,   506,    -1,
      18,    38,   904,   496,    -1,   121,    38,   168,   136,  1011,
     496,    -1,   121,    38,  1011,   496,    -1,    24,    38,  1011,
     761,   369,   905,   497,   496,    -1,    64,   842,    -1,    64,
      22,    -1,    82,   515,   996,   544,   516,   509,   510,   511,
     517,   448,   512,    -1,    82,   846,   360,   510,   511,   448,
     512,    -1,   153,    -1,   360,    -1,   284,    -1,    -1,  1007,
      -1,   341,    -1,   342,    -1,   513,    -1,   437,   519,   438,
      -1,   513,   514,    -1,    -1,    45,    -1,   250,    -1,   152,
      -1,   110,   796,  1007,    -1,   242,   796,  1007,    -1,    86,
      -1,   164,    -1,   285,   796,  1007,    -1,   129,   796,  1007,
      -1,   149,   285,   545,    -1,   149,   285,   430,    -1,   149,
     237,   242,   545,    -1,   149,   242,   545,    -1,   125,  1007,
      -1,    45,    -1,    -1,   401,   250,    -1,    -1,   518,   111,
    1007,    -1,    -1,   382,    -1,    -1,   520,    -1,   519,   441,
     520,    -1,  1014,   521,    -1,   477,    -1,   574,    -1,   430,
      -1,   437,   522,   438,    -1,    -1,   523,    -1,   522,   441,
     523,    -1,   477,    -1,    84,   525,   350,   996,   437,   526,
     438,   555,   556,   557,   558,    -1,    84,   525,   350,   168,
     237,   136,   996,   437,   526,   438,   555,   556,   557,   558,
      -1,    84,   525,   350,   996,   247,   672,   527,   556,   557,
     558,    -1,    84,   525,   350,   168,   237,   136,   996,   247,
     672,   527,   556,   557,   558,    -1,   355,    -1,   353,    -1,
     215,   355,    -1,   215,   353,    -1,   157,   355,    -1,   157,
     353,    -1,   378,    -1,    -1,   528,    -1,    -1,   437,   529,
     438,    -1,    -1,   530,    -1,   528,   441,   530,    -1,   531,
      -1,   529,   441,   531,    -1,   532,    -1,   538,    -1,   541,
      -1,   533,    -1,   541,    -1,  1011,   905,   600,   534,    -1,
    1011,   401,   255,   534,    -1,   534,   535,    -1,    -1,    77,
     998,   536,    -1,   536,    -1,   537,    -1,    67,   672,    -1,
     237,   242,    -1,   242,    -1,   375,   737,   559,    -1,   279,
     198,   737,   559,    -1,    61,   437,   929,   438,   543,    -1,
     104,   930,    -1,   293,   996,   544,   547,   551,    -1,   106,
      -1,   237,   106,    -1,   180,   107,    -1,   180,   170,    -1,
     211,   996,   539,    -1,   539,   174,   540,    -1,   539,   133,
     540,    -1,    -1,   105,    -1,    78,    -1,   177,    -1,   343,
      -1,    71,    -1,    22,    -1,    77,   998,   542,    -1,   542,
      -1,    61,   437,   929,   438,   631,    -1,   375,   437,   545,
     438,   737,   559,   631,    -1,   375,   560,   631,    -1,   279,
     198,   437,   545,   438,   737,   559,   631,    -1,   279,   198,
     560,   631,    -1,   132,   711,   437,   548,   438,   737,   559,
     550,   631,    -1,   150,   198,   437,   545,   438,   293,   996,
     544,   547,   551,   631,    -1,   235,   178,    -1,    -1,   437,
     545,   438,    -1,    -1,   546,    -1,   545,   441,   546,    -1,
    1011,    -1,   221,   154,    -1,   221,   267,    -1,   221,   332,
      -1,    -1,   549,    -1,   548,   441,   549,    -1,   713,   401,
     747,    -1,   713,   401,   253,   437,   747,   438,    -1,   398,
     437,   929,   438,    -1,    -1,   552,    -1,   553,    -1,   552,
     553,    -1,   553,   552,    -1,    -1,   251,   380,   554,    -1,
     251,   109,   554,    -1,   235,    17,    -1,   304,    -1,    52,
      -1,   327,   242,    -1,   327,   104,    -1,   179,   437,   995,
     438,    -1,    -1,   401,   500,    -1,   401,   250,    -1,   403,
     250,    -1,    -1,   251,    72,   121,    -1,   251,    72,   109,
     312,    -1,   251,    72,   276,   312,    -1,    -1,   352,   998,
      -1,    -1,   382,   176,   352,   998,    -1,    -1,   382,   176,
    1002,    -1,    84,   525,   350,   562,    32,   845,   563,    -1,
     996,   544,   556,   557,   558,    -1,   401,    97,    -1,   401,
     235,    97,    -1,    -1,    84,   566,   222,   394,   565,    32,
     845,   563,    -1,   996,   544,   501,   558,    -1,   378,    -1,
      -1,   294,   222,   394,   709,   996,   563,    -1,    84,   525,
     321,   996,   570,    -1,    24,   321,   996,   571,    -1,    24,
     321,   168,   136,   996,   571,    -1,   571,    -1,    -1,   572,
      -1,   571,   572,    -1,    50,   574,    -1,    96,    -1,   235,
      96,    -1,   175,   573,   574,    -1,   223,   574,    -1,   225,
     574,    -1,   235,   223,    -1,   235,   225,    -1,   264,    49,
     672,    -1,   338,   448,   574,    -1,   303,    -1,   303,   448,
     574,    -1,    49,    -1,    -1,     4,    -1,   428,     4,    -1,
     429,     4,    -1,  1010,    -1,   574,    -1,   575,   441,   574,
      -1,    84,   719,   577,   583,   200,   480,    -1,    84,   719,
     577,   583,   200,   480,   162,   578,   579,   581,    -1,   368,
      -1,    -1,   998,    -1,   998,   673,    -1,   181,   578,    -1,
      -1,   386,   578,    -1,   235,   386,    -1,   580,    -1,    -1,
     121,   583,   200,   480,   496,    -1,   121,   583,   200,   168,
     136,   480,   496,    -1,   282,    -1,    -1,    84,   352,   998,
     585,   218,  1007,   501,    -1,   265,   998,    -1,    -1,   121,
     352,   998,    -1,   121,   352,   168,   136,   998,    -1,    84,
     138,   998,   448,   588,    -1,    84,   138,   168,   237,   136,
     998,   448,   588,    -1,   588,   589,    -1,    -1,   315,   998,
      -1,   393,   480,    -1,   153,   480,    -1,    24,   138,   998,
     380,   591,    -1,   591,   592,    -1,    -1,   360,   480,    -1,
      24,   138,   998,   463,    21,  1004,   731,    -1,    24,   138,
     998,   463,    55,   437,   905,    32,   905,   438,    -1,    24,
     138,   998,   463,    68,   672,    -1,    24,   138,   998,   463,
      81,   672,    -1,    24,   138,   998,   463,   119,   672,    -1,
      24,   138,   998,   463,   155,   697,    -1,    24,   138,   998,
     463,   583,   200,   998,    -1,    24,   138,   998,   463,   253,
     747,   746,    -1,    24,   138,   998,   463,   253,    63,   672,
     382,  1000,    -1,    24,   138,   998,   463,   253,   142,   672,
     382,  1000,    -1,    24,   138,   998,   463,   315,   998,    -1,
      24,   138,   998,   463,   130,   364,   998,    -1,    24,   138,
     998,   463,   350,   672,    -1,    24,   138,   998,   463,   356,
     317,   266,   672,    -1,    24,   138,   998,   463,   356,   317,
     113,   672,    -1,    24,   138,   998,   463,   356,   317,   354,
     672,    -1,    24,   138,   998,   463,   356,   317,    75,   672,
      -1,    24,   138,   998,   463,   321,   672,    -1,    24,   138,
     998,   463,   394,   672,    -1,    24,   138,   998,   463,   222,
     394,   672,    -1,    24,   138,   998,   463,   150,   350,   672,
      -1,    24,   138,   998,   463,   150,    97,   405,   998,    -1,
      24,   138,   998,   463,   324,   998,    -1,    24,   138,   998,
     463,   369,   672,    -1,    84,   150,    97,   405,   998,   597,
     600,    -1,   162,   578,    -1,   235,   162,    -1,   386,   578,
      -1,   235,   386,    -1,   595,    -1,   596,   595,    -1,   596,
      -1,    -1,   121,   150,    97,   405,   998,   496,    -1,   121,
     150,    97,   405,   168,   136,   998,   496,    -1,    24,   150,
      97,   405,   998,   597,   602,    -1,    24,   150,    97,   405,
     998,   596,    -1,   255,   437,   601,   438,    -1,    -1,   605,
      -1,   601,   441,   605,    -1,   255,   437,   603,   438,    -1,
     604,    -1,   603,   441,   604,    -1,   605,    -1,   327,   605,
      -1,    18,   605,    -1,   121,   606,    -1,   606,   607,    -1,
    1014,    -1,  1007,    -1,    84,   324,   998,   609,   611,   150,
      97,   405,   998,   600,    -1,   369,  1007,    -1,    -1,   393,
    1007,    -1,   393,   242,    -1,   610,    -1,    -1,   121,   324,
     998,   496,    -1,   121,   324,   168,   136,   998,   496,    -1,
      24,   324,   998,   610,   602,    -1,    24,   324,   998,   610,
      -1,    24,   324,   998,   602,    -1,    84,   150,   350,   996,
     437,   526,   438,   324,   998,   600,    -1,    84,   150,   350,
     168,   237,   136,   996,   437,   526,   438,   324,   998,   600,
      -1,    24,   150,   350,   892,   493,    -1,    24,   150,   350,
     168,   136,   892,   493,    -1,    84,   381,   220,   148,   617,
     324,   998,   600,    -1,    94,    -1,   381,    -1,  1008,    -1,
     121,   381,   220,   148,   617,   324,   998,    -1,   121,   381,
     220,   168,   136,   148,   617,   324,   998,    -1,    24,   381,
     220,   148,   617,   324,   998,   602,    -1,    84,   364,   998,
     621,   622,   251,   996,   624,   627,   135,   283,  1004,   437,
     628,   438,    -1,    84,    77,   364,   998,    20,   622,   251,
     996,   630,   631,   148,   122,   311,   627,   135,   283,  1004,
     437,   628,   438,    -1,    41,    -1,    20,    -1,   187,   247,
      -1,   623,    -1,   622,   256,   623,    -1,   186,    -1,   109,
      -1,   380,    -1,   380,   247,   545,    -1,   367,    -1,   148,
     625,   626,    -1,    -1,   122,    -1,    -1,   311,    -1,   339,
      -1,   397,   437,   929,   438,    -1,    -1,   629,    -1,   628,
     441,   629,    -1,    -1,  1006,    -1,     4,    -1,  1007,    -1,
    1014,    -1,   153,   996,    -1,    -1,    -1,   631,   632,    -1,
     237,   106,    -1,   106,    -1,   180,   170,    -1,   180,   107,
      -1,   237,   384,    -1,   235,   178,    -1,   121,   364,   998,
     251,   672,   496,    -1,   121,   364,   168,   136,   998,   251,
     672,   496,    -1,    84,   130,   364,   998,   251,  1014,   135,
     283,  1004,   437,   438,    -1,    84,   130,   364,   998,   251,
    1014,   397,   635,   135,   283,  1004,   437,   438,    -1,   636,
      -1,   635,    28,   636,    -1,  1011,   173,   437,   637,   438,
      -1,     5,    -1,   637,   441,     5,    -1,    24,   130,   364,
     998,   639,    -1,   124,    -1,   124,   301,    -1,   124,    25,
      -1,   114,    -1,    84,    34,   998,    61,   437,   929,   438,
     631,    -1,   121,    34,   998,   496,    -1,    84,    21,  1004,
     731,   643,    -1,    84,    21,  1004,   647,    -1,    84,   253,
     747,   643,    -1,    84,   369,   672,   643,    -1,    84,   369,
     672,    -1,    84,   369,   672,    32,   437,   902,   438,    -1,
      84,   369,   672,    32,   128,   437,   650,   438,    -1,    84,
     369,   672,    32,   286,   643,    -1,    84,   356,   317,   266,
     672,   643,    -1,    84,   356,   317,   113,   672,   643,    -1,
      84,   356,   317,   354,   672,   643,    -1,    84,   356,   317,
      75,   672,   643,    -1,    84,    68,   672,   643,    -1,    84,
      68,   672,   153,   672,    -1,   437,   644,   438,    -1,   645,
      -1,   644,   441,   645,    -1,  1014,   424,   646,    -1,  1014,
      -1,   728,    -1,  1018,    -1,   961,    -1,   574,    -1,  1007,
      -1,   437,   648,   438,    -1,   649,    -1,   648,   441,   649,
      -1,     3,   424,   646,    -1,   651,    -1,    -1,  1007,    -1,
     651,   441,  1007,    -1,    24,   369,   672,    18,   387,   653,
    1007,    -1,    24,   369,   672,    18,   387,   653,  1007,    41,
    1007,    -1,    24,   369,   672,    18,   387,   653,  1007,    20,
    1007,    -1,   168,   237,   136,    -1,    -1,    84,   253,    63,
     672,   657,   148,   369,   905,   382,  1000,   658,    32,   655,
      -1,   656,    -1,   655,   441,   656,    -1,   253,  1006,   747,
     659,   660,    -1,   253,  1006,   747,   746,   659,   660,    -1,
     155,  1006,  1004,   720,    -1,   155,  1006,   437,   966,   438,
    1004,   720,    -1,   343,   905,    -1,   104,    -1,    -1,   142,
     672,    -1,    -1,   148,   317,    -1,   148,   257,    49,   672,
      -1,    -1,   290,    -1,    -1,    84,   253,   142,   672,   382,
    1000,    -1,    24,   253,   142,   672,   382,  1000,    18,   655,
      -1,    24,   253,   142,   672,   382,  1000,   121,   663,    -1,
     664,    -1,   663,   441,   664,    -1,   253,  1006,   437,   966,
     438,    -1,   155,  1006,   437,   966,   438,    -1,   121,   253,
      63,   672,   382,  1000,   496,    -1,   121,   253,    63,   168,
     136,   672,   382,  1000,   496,    -1,   121,   253,   142,   672,
     382,  1000,   496,    -1,   121,   253,   142,   168,   136,   672,
     382,  1000,   496,    -1,   121,   264,    49,  1009,   496,    -1,
     289,   264,    49,  1009,   360,   998,    -1,   121,   670,   168,
     136,   671,   496,    -1,   121,   670,   671,   496,    -1,   121,
     176,    74,   671,   496,    -1,   121,   176,    74,   168,   136,
     671,   496,    -1,   350,    -1,   321,    -1,   394,    -1,   222,
     394,    -1,   176,    -1,   150,   350,    -1,   130,   364,    -1,
     369,    -1,   119,    -1,    68,    -1,    81,    -1,   315,    -1,
     138,    -1,   356,   317,   266,    -1,   356,   317,   113,    -1,
     356,   317,   354,    -1,   356,   317,    75,    -1,   672,    -1,
     671,   441,   672,    -1,  1011,    -1,  1011,   673,    -1,   439,
    1001,    -1,   673,   439,  1001,    -1,   367,   856,   893,   675,
     496,    -1,    80,   167,    -1,   303,   167,    -1,    -1,    70,
     251,   677,   672,   194,   678,    -1,    70,   251,    21,  1004,
     731,   194,   678,    -1,    70,   251,   155,  1004,   720,   194,
     678,    -1,    70,   251,   253,   747,   746,   194,   678,    -1,
      70,   251,    77,   998,   251,   672,   194,   678,    -1,    70,
     251,   313,   998,   251,   672,   194,   678,    -1,    70,   251,
     313,   998,   194,   678,    -1,    70,   251,   364,   998,   251,
     672,   194,   678,    -1,    70,   251,   253,    63,   672,   382,
    1000,   194,   678,    -1,    70,   251,   253,   142,   672,   382,
    1000,   194,   678,    -1,    70,   251,   201,   246,   574,   194,
     678,    -1,    70,   251,    55,   437,   905,    32,   905,   438,
     194,   678,    -1,    70,   251,   583,   200,   672,   194,   678,
      -1,    69,    -1,    98,    -1,   315,    -1,   176,    -1,   321,
      -1,   350,    -1,   119,    -1,   369,    -1,   394,    -1,   222,
     394,    -1,    68,    -1,    81,    -1,   352,    -1,   138,    -1,
     309,    -1,   150,   350,    -1,   324,    -1,   150,    97,   405,
      -1,   130,   364,    -1,   356,   317,    75,    -1,   356,   317,
     113,    -1,   356,   317,   266,    -1,   356,   317,   354,    -1,
    1007,    -1,   242,    -1,   319,   199,   680,   251,   681,   672,
     194,   682,    -1,   319,   199,   680,   251,    21,  1004,   731,
     194,   682,    -1,   319,   199,   680,   251,   155,  1004,   720,
     194,   682,    -1,   319,   199,   680,   251,   201,   246,   574,
     194,   682,    -1,   319,   199,   680,   251,   583,   200,   672,
     194,   682,    -1,   148,   480,    -1,    -1,    69,    -1,    98,
      -1,   130,   364,    -1,   150,   350,    -1,   315,    -1,   321,
      -1,   350,    -1,   119,    -1,   309,    -1,   352,    -1,   369,
      -1,   394,    -1,   222,   394,    -1,  1007,    -1,   242,    -1,
     143,   684,    -1,   228,   684,    -1,   842,    -1,   685,   842,
      -1,   234,   686,   842,    -1,   280,   686,   842,    -1,   145,
     686,   842,    -1,   202,   686,   842,    -1,    15,  1010,   686,
     842,    -1,   296,  1010,   686,   842,    -1,  1010,   686,   842,
      -1,    22,   686,   842,    -1,   151,   686,   842,    -1,   151,
    1010,   686,   842,    -1,   151,    22,   686,   842,    -1,    40,
     686,   842,    -1,    40,  1010,   686,   842,    -1,    40,    22,
     686,   842,    -1,   153,    -1,   173,    -1,   685,    -1,    -1,
     158,   689,   251,   692,   360,   693,   695,    -1,   307,   689,
     251,   692,   153,   693,   496,    -1,   307,   158,   254,   148,
     689,   251,   692,   153,   693,   496,    -1,   690,    -1,    22,
      -1,    22,   281,    -1,    22,   437,   545,   438,    -1,    22,
     281,   437,   545,   438,    -1,   691,    -1,   690,   441,   691,
      -1,   320,   544,    -1,   293,   544,    -1,    84,   544,    -1,
    1011,   544,    -1,   995,    -1,   350,   995,    -1,   321,   995,
      -1,   150,    97,   405,   997,    -1,   150,   324,   997,    -1,
     155,   696,    -1,    98,   997,    -1,   119,   671,    -1,   200,
     997,    -1,   201,   246,   575,    -1,   315,   997,    -1,   352,
     997,    -1,   369,   671,    -1,    22,   351,   173,   315,   997,
      -1,    22,   322,   173,   315,   997,    -1,    22,   156,   173,
     315,   997,    -1,   694,    -1,   693,   441,   694,    -1,  1008,
      -1,   161,  1008,    -1,   401,   158,   254,    -1,    -1,   697,
      -1,   696,   441,   697,    -1,  1004,   720,    -1,   158,   690,
     360,  1009,   700,   701,    -1,   307,   690,   153,  1009,   701,
     496,    -1,   307,    19,   254,   148,   690,   153,  1009,   701,
     496,    -1,   401,    19,   254,    -1,    -1,   159,    49,  1008,
      -1,    -1,    24,   104,   281,   703,   705,    -1,   703,   704,
      -1,    -1,   173,   315,   997,    -1,   148,   309,  1009,    -1,
     148,   381,  1009,    -1,   158,   689,   251,   706,   360,   693,
     695,    -1,   307,   689,   251,   706,   153,   693,   496,    -1,
     307,   158,   254,   148,   689,   251,   706,   153,   693,   496,
      -1,   351,    -1,   156,    -1,   322,    -1,   370,    -1,    84,
     708,   176,   709,   710,   251,   996,   711,   437,   712,   438,
     501,   558,   900,    -1,   375,    -1,    -1,    74,    -1,    -1,
    1002,    -1,    -1,   382,  1000,    -1,    -1,   713,    -1,   712,
     441,   713,    -1,  1011,   714,   715,   716,   717,    -1,   934,
     714,   715,   716,   717,    -1,   437,   929,   438,   714,   715,
     716,   717,    -1,    67,   672,    -1,    -1,   672,    -1,   382,
     672,    -1,    -1,    33,    -1,   112,    -1,    -1,   420,    -1,
     421,    -1,    -1,    84,   719,   155,  1004,   722,   306,   727,
     733,   737,    -1,    84,   719,   155,  1004,   722,   306,   350,
     437,   739,   438,   733,   737,    -1,    84,   719,   155,  1004,
     722,   733,   737,    -1,   256,   300,    -1,    -1,   437,   721,
     438,    -1,   437,   438,    -1,   724,    -1,   721,   441,   724,
      -1,   437,   723,   438,    -1,   437,   438,    -1,   729,    -1,
     723,   441,   729,    -1,   725,   726,   728,    -1,   726,   725,
     728,    -1,   726,   728,    -1,   725,   728,    -1,   728,    -1,
     173,    -1,   259,    -1,   183,    -1,   173,   259,    -1,   390,
      -1,  1012,    -1,   728,    -1,   905,    -1,  1012,   673,   432,
     369,    -1,   328,  1012,   673,   432,   369,    -1,   724,    -1,
     724,   104,   929,    -1,   724,   424,   929,    -1,   724,    -1,
     437,   430,   438,    -1,   437,   732,   438,    -1,   437,   257,
      49,   732,   438,    -1,   437,   732,   257,    49,   732,   438,
      -1,   730,    -1,   732,   441,   730,    -1,   735,    -1,   733,
     735,    -1,    51,   251,   242,   184,    -1,   306,   242,   251,
     242,   184,    -1,   344,    -1,   171,    -1,   336,    -1,   396,
      -1,   139,   319,   108,    -1,   139,   319,   193,    -1,   319,
     108,    -1,   319,   193,    -1,   207,    -1,   237,   207,    -1,
      83,   574,    -1,   312,   574,    -1,   485,    -1,    32,   736,
      -1,   200,   480,    -1,   400,    -1,   734,    -1,  1007,    -1,
    1007,   441,  1007,    -1,   401,   643,    -1,    -1,   726,   728,
      -1,   738,    -1,   739,   441,   738,    -1,    24,   155,   697,
     741,   742,    -1,   734,    -1,   741,   734,    -1,   304,    -1,
      -1,   121,   155,  1004,   720,   496,    -1,   121,   155,   168,
     136,  1004,   720,   496,    -1,   121,    21,  1004,   731,   496,
      -1,   121,    21,   168,   136,  1004,   731,   496,    -1,   121,
     253,   747,   746,   496,    -1,   121,   253,   168,   136,   747,
     746,   496,    -1,   437,   905,   438,    -1,   437,   905,   441,
     905,   438,    -1,   437,   236,   441,   905,   438,    -1,   437,
     905,   441,   236,   438,    -1,   958,    -1,  1011,   439,   747,
      -1,   117,   749,    -1,   750,    -1,   749,   750,    -1,  1007,
      -1,   200,   480,    -1,    84,    55,   437,   905,    32,   905,
     438,   401,   155,   697,   752,    -1,    84,    55,   437,   905,
      32,   905,   438,   403,   155,   752,    -1,    84,    55,   437,
     905,    32,   905,   438,   401,   183,   752,    -1,    32,   172,
      -1,    32,    35,    -1,    -1,   121,    55,   754,   437,   905,
      32,   905,   438,   496,    -1,   168,   136,    -1,    -1,   295,
     756,   996,   757,    -1,   295,   349,   998,   757,    -1,   295,
      98,   998,   757,    -1,   176,    -1,   350,    -1,   149,    -1,
      -1,    24,   352,   998,   327,   500,    -1,    24,   352,   998,
     302,   500,    -1,    24,    21,  1004,   731,   298,   360,   998,
      -1,    24,    68,   672,   298,   360,   998,    -1,    24,    81,
     672,   298,   360,   998,    -1,    24,    98,   999,   298,   360,
     999,    -1,    24,   119,   672,   298,   360,   998,    -1,    24,
     119,   672,   298,    77,   998,   360,   998,    -1,    24,   150,
      97,   405,   998,   298,   360,   998,    -1,    24,   155,   697,
     298,   360,   998,    -1,    24,   161,  1008,   298,   360,  1008,
      -1,    24,   583,   200,   998,   298,   360,   998,    -1,    24,
     253,    63,   672,   382,  1000,   298,   360,   998,    -1,    24,
     253,   142,   672,   382,  1000,   298,   360,   998,    -1,    24,
     315,   998,   298,   360,   998,    -1,    24,   324,   998,   298,
     360,   998,    -1,    24,   350,   892,   298,   360,   998,    -1,
      24,   350,   168,   136,   892,   298,   360,   998,    -1,    24,
     321,   996,   298,   360,   998,    -1,    24,   321,   168,   136,
     996,   298,   360,   998,    -1,    24,   394,   996,   298,   360,
     998,    -1,    24,   394,   168,   136,   996,   298,   360,   998,
      -1,    24,   222,   394,   996,   298,   360,   998,    -1,    24,
     222,   394,   168,   136,   996,   298,   360,   998,    -1,    24,
     176,   996,   298,   360,   998,    -1,    24,   176,   168,   136,
     996,   298,   360,   998,    -1,    24,   150,   350,   892,   298,
     360,   998,    -1,    24,   150,   350,   168,   136,   892,   298,
     360,   998,    -1,    24,   350,   892,   298,   760,   998,   360,
     998,    -1,    24,   350,   168,   136,   892,   298,   760,   998,
     360,   998,    -1,    24,   222,   394,   996,   298,   760,   998,
     360,   998,    -1,    24,   222,   394,   168,   136,   996,   298,
     760,   998,   360,   998,    -1,    24,   350,   892,   298,    77,
     998,   360,   998,    -1,    24,   150,   350,   892,   298,   760,
     998,   360,   998,    -1,    24,   150,   350,   168,   136,   892,
     298,   760,   998,   360,   998,    -1,    24,   313,   998,   251,
     996,   298,   360,   998,    -1,    24,   364,   998,   251,   996,
     298,   360,   998,    -1,    24,   130,   364,   998,   298,   360,
     998,    -1,    24,   309,  1008,   298,   360,  1008,    -1,    24,
     381,  1008,   298,   360,  1008,    -1,    24,   352,   998,   298,
     360,   998,    -1,    24,   356,   317,   266,   672,   298,   360,
     998,    -1,    24,   356,   317,   113,   672,   298,   360,   998,
      -1,    24,   356,   317,   354,   672,   298,   360,   998,    -1,
      24,   356,   317,    75,   672,   298,   360,   998,    -1,    24,
     369,   672,   298,   360,   998,    -1,    24,   369,   672,   298,
      38,   998,   360,   998,   496,    -1,    69,    -1,    -1,   327,
      97,    -1,    -1,    24,    21,  1004,   731,   327,   315,   998,
      -1,    24,    68,   672,   327,   315,   998,    -1,    24,    81,
     672,   327,   315,   998,    -1,    24,   119,   672,   327,   315,
     998,    -1,    24,   138,   672,   327,   315,   998,    -1,    24,
     155,   697,   327,   315,   998,    -1,    24,   253,   747,   746,
     327,   315,   998,    -1,    24,   253,    63,   672,   382,  1000,
     327,   315,   998,    -1,    24,   253,   142,   672,   382,  1000,
     327,   315,   998,    -1,    24,   350,   892,   327,   315,   998,
      -1,    24,   350,   168,   136,   892,   327,   315,   998,    -1,
      24,   356,   317,   266,   672,   327,   315,   998,    -1,    24,
     356,   317,   113,   672,   327,   315,   998,    -1,    24,   356,
     317,   354,   672,   327,   315,   998,    -1,    24,   356,   317,
      75,   672,   327,   315,   998,    -1,    24,   321,   996,   327,
     315,   998,    -1,    24,   321,   168,   136,   996,   327,   315,
     998,    -1,    24,   394,   996,   327,   315,   998,    -1,    24,
     394,   168,   136,   996,   327,   315,   998,    -1,    24,   222,
     394,   996,   327,   315,   998,    -1,    24,   222,   394,   168,
     136,   996,   327,   315,   998,    -1,    24,   150,   350,   892,
     327,   315,   998,    -1,    24,   150,   350,   168,   136,   892,
     327,   315,   998,    -1,    24,   369,   672,   327,   315,   998,
      -1,    24,    21,  1004,   731,   265,   360,  1008,    -1,    24,
      68,   672,   265,   360,  1008,    -1,    24,    81,   672,   265,
     360,  1008,    -1,    24,    98,   999,   265,   360,  1008,    -1,
      24,   119,   672,   265,   360,  1008,    -1,    24,   155,   697,
     265,   360,  1008,    -1,    24,   583,   200,   998,   265,   360,
    1008,    -1,    24,   201,   246,   574,   265,   360,  1008,    -1,
      24,   253,   747,   746,   265,   360,  1008,    -1,    24,   253,
      63,   672,   382,  1000,   265,   360,  1008,    -1,    24,   253,
     142,   672,   382,  1000,   265,   360,  1008,    -1,    24,   315,
     998,   265,   360,  1008,    -1,    24,   369,   672,   265,   360,
    1008,    -1,    24,   352,   998,   265,   360,  1008,    -1,    24,
     356,   317,   113,   672,   265,   360,  1008,    -1,    24,   356,
     317,    75,   672,   265,   360,  1008,    -1,    24,   150,    97,
     405,   998,   265,   360,  1008,    -1,    24,   324,   998,   265,
     360,  1008,    -1,    24,   130,   364,   998,   265,   360,  1008,
      -1,    84,   719,   313,   998,    32,   251,   769,   360,   996,
     900,   117,   770,   765,    -1,   238,    -1,   767,    -1,   437,
     766,   438,    -1,   766,   440,   768,    -1,   768,    -1,   845,
      -1,   823,    -1,   834,    -1,   828,    -1,   772,    -1,   767,
      -1,    -1,   320,    -1,   380,    -1,   109,    -1,   186,    -1,
     187,    -1,    23,    -1,    -1,   121,   313,   998,   251,   672,
     496,    -1,   121,   313,   168,   136,   998,   251,   672,   496,
      -1,   239,  1011,   773,    -1,   441,  1007,    -1,    -1,   213,
    1011,    -1,   377,  1011,    -1,   377,   430,    -1,    14,   777,
      -1,    42,   777,   780,    -1,   338,   362,   780,    -1,    72,
     777,    -1,   127,   777,    -1,   310,   777,    -1,   314,  1011,
      -1,   297,   314,  1011,    -1,   297,  1011,    -1,   310,   777,
     360,   314,  1011,    -1,   310,   777,   360,  1011,    -1,   277,
     362,  1007,    -1,    72,   278,  1007,    -1,   310,   278,  1007,
      -1,   404,    -1,   362,    -1,    -1,   196,   210,   476,    -1,
     287,   252,    -1,   287,   406,    -1,   106,    -1,   237,   106,
      -1,   778,    -1,   779,   441,   778,    -1,   779,   778,    -1,
     779,    -1,    -1,    84,   525,   394,   996,   544,   501,    32,
     845,   782,    -1,    84,   256,   300,   525,   394,   996,   544,
     501,    32,   845,   782,    -1,    84,   525,   291,   394,   996,
     437,   545,   438,   501,    32,   845,   782,    -1,    84,   256,
     300,   525,   291,   394,   996,   437,   545,   438,   501,    32,
     845,   782,    -1,   401,    61,   254,    -1,   401,    53,    61,
     254,    -1,   401,   215,    61,   254,    -1,    -1,   214,  1003,
      -1,    84,    98,   999,   448,   785,    -1,   785,   786,    -1,
      -1,   352,   787,   998,    -1,   352,   787,   104,    -1,   218,
     787,  1007,    -1,   218,   787,   104,    -1,   354,   787,   998,
      -1,   354,   787,   104,    -1,   125,   787,  1007,    -1,   125,
     787,  1006,    -1,   125,   787,   104,    -1,   204,   787,  1007,
      -1,   204,   787,   104,    -1,   205,   787,  1007,    -1,   205,
     787,   104,    -1,    76,   212,   787,  1010,    -1,   265,   787,
     998,    -1,   265,   787,   104,    -1,   424,    -1,    -1,    24,
      98,   999,   448,   790,    -1,    24,    98,   999,   327,   352,
     998,    -1,    24,    98,   999,   484,    -1,   790,   791,    -1,
      -1,    76,   212,   787,  1010,    -1,   121,    98,   999,    -1,
     121,    98,   168,   136,   999,    -1,    24,   349,   327,   471,
      -1,    24,   349,   302,   483,    -1,    84,   119,   672,   796,
     905,   534,    -1,    24,   119,   672,   495,    -1,    24,   119,
     672,   121,   237,   242,    -1,    24,   119,   672,   327,   237,
     242,    -1,    24,   119,   672,    18,   541,    -1,    24,   119,
     672,   121,    77,   998,   496,    -1,    24,   119,   672,   121,
      77,   168,   136,   998,   496,    -1,    24,   119,   672,   385,
      77,   998,    -1,    32,    -1,    -1,    24,   356,   317,   113,
     672,   643,    -1,    24,   356,   317,    75,   672,    18,   220,
     148,   997,   401,   671,    -1,    24,   356,   317,    75,   672,
      24,   220,   148,   997,   401,   671,    -1,    24,   356,   317,
      75,   672,    24,   220,   300,   672,   401,   672,    -1,    24,
     356,   317,    75,   672,    24,   220,   148,   997,   300,   672,
     401,   672,    -1,    24,   356,   317,    75,   672,   121,   220,
     148,   997,    -1,    24,   356,   317,    75,   672,   121,   220,
     168,   136,   148,   997,    -1,    84,   657,    81,   672,   148,
    1007,   360,  1007,   153,   672,    -1,    65,   807,   996,   801,
      -1,    65,   807,    -1,    65,   807,  1002,   251,   996,    -1,
     382,  1002,    -1,    -1,   383,   808,   809,   807,    -1,   383,
     808,   809,   807,   996,    -1,   383,   808,   809,   807,   805,
      -1,   383,   437,   803,   438,    -1,   383,   437,   803,   438,
     996,   810,    -1,   804,    -1,   803,   441,   804,    -1,   806,
      -1,   392,    -1,   152,    -1,   154,    -1,   806,   807,    -1,
     806,   807,   996,   810,    -1,    27,    -1,    26,    -1,   392,
      -1,    -1,   154,    -1,    -1,   152,    -1,    -1,   437,   997,
     438,    -1,    -1,   137,   812,    -1,   137,   806,   807,   812,
      -1,   137,   392,   812,    -1,   137,   437,   813,   438,   812,
      -1,   845,    -1,   823,    -1,   834,    -1,   828,    -1,   841,
      -1,   561,    -1,   564,    -1,   567,    -1,   820,    -1,   814,
      -1,   813,   441,   814,    -1,   815,   816,    -1,  1013,    -1,
     806,    -1,   477,    -1,   574,    -1,    -1,   277,   998,   818,
      32,   819,    -1,   437,   966,   438,    -1,    -1,   845,    -1,
     823,    -1,   834,    -1,   828,    -1,   135,   998,   821,    -1,
      84,   525,   350,   562,    32,   135,   998,   821,   563,    -1,
     437,   963,   438,    -1,    -1,   100,   998,    -1,   100,   277,
     998,    -1,   100,    22,    -1,   100,   277,    22,    -1,   853,
     186,   192,   996,   824,   827,    -1,   845,    -1,   437,   825,
     438,   845,    -1,   104,   388,    -1,   826,    -1,   825,   441,
     826,    -1,  1011,   987,    -1,   305,   993,    -1,    -1,   853,
     109,   153,   894,   829,   901,   827,    -1,   382,   883,    -1,
      -1,   219,   856,   893,   831,   833,    -1,   173,   832,   226,
      -1,    -1,    16,   329,    -1,   311,   329,    -1,   311,   134,
      -1,    30,   329,    -1,    30,   134,    -1,   329,   380,   134,
      -1,   329,    -1,   329,   311,   134,    -1,   134,    -1,    16,
     134,    -1,   241,    -1,    -1,   853,   380,   894,   327,   835,
     882,   901,   827,    -1,   836,    -1,   835,   441,   836,    -1,
     837,    -1,   838,    -1,   839,   424,   989,    -1,   437,   840,
     438,   424,   991,    -1,  1011,   987,    -1,   839,    -1,   840,
     441,   839,    -1,   103,   842,   843,    95,   844,   148,   845,
      -1,   998,    -1,    -1,   843,   235,   316,    -1,   843,   316,
      -1,   843,    45,    -1,   843,   185,    -1,    -1,   401,   165,
      -1,   403,   165,    -1,   847,    -1,   846,    -1,   437,   847,
     438,    -1,   437,   846,   438,    -1,   849,    -1,   848,   860,
      -1,   848,   859,   875,   864,    -1,   848,   859,   863,   876,
      -1,   850,   848,    -1,   850,   848,   860,    -1,   850,   848,
     859,   875,   864,    -1,   850,   848,   859,   863,   876,    -1,
     849,    -1,   846,    -1,   320,   858,   992,   854,   882,   900,
     873,   874,   946,    -1,   881,    -1,   350,   892,    -1,   848,
     374,   857,   848,    -1,   848,   190,   857,   848,    -1,   848,
     131,   857,   848,    -1,   401,   851,    -1,   401,   291,   851,
      -1,   852,    -1,   851,   441,   852,    -1,   998,   810,    32,
     437,   819,   438,    -1,   850,    -1,    -1,   192,   855,    -1,
      -1,   355,   856,   996,    -1,   353,   856,   996,    -1,   215,
     355,   856,   996,    -1,   215,   353,   856,   996,    -1,   157,
     355,   856,   996,    -1,   157,   353,   856,   996,    -1,   378,
     856,   996,    -1,   350,   996,    -1,   996,    -1,   350,    -1,
      -1,    22,    -1,   116,    -1,    -1,   116,    -1,   116,   251,
     437,   963,   438,    -1,    22,    -1,    -1,   860,    -1,    -1,
     257,    49,   861,    -1,   862,    -1,   861,   441,   862,    -1,
     929,   382,   961,   717,    -1,   929,   716,   717,    -1,   865,
     866,    -1,   866,   865,    -1,   865,    -1,   866,    -1,   863,
      -1,    -1,   212,   867,    -1,   212,   867,   441,   868,    -1,
     143,   872,   869,   871,   252,    -1,   249,   868,    -1,   249,
     870,   871,    -1,   929,    -1,    22,    -1,   929,    -1,  1010,
      -1,   437,   929,   438,    -1,    -1,   931,    -1,   311,    -1,
     312,    -1,   145,    -1,   234,    -1,   161,    49,   963,    -1,
      -1,   163,   929,    -1,    -1,   877,    -1,   148,   287,   252,
      -1,   875,    -1,    -1,   878,    -1,   877,   878,    -1,   879,
     880,   833,    -1,   148,   380,    -1,   148,   235,   198,   380,
      -1,   148,   329,    -1,   148,   198,   329,    -1,   247,   995,
      -1,    -1,   388,   991,    -1,   881,   441,   991,    -1,   153,
     883,    -1,    -1,   884,    -1,   883,   441,   884,    -1,   892,
     887,    -1,   895,   888,    -1,   203,   895,   888,    -1,   846,
     887,    -1,   203,   846,   887,    -1,   885,    -1,   437,   885,
     438,   886,    -1,   437,   885,   438,    -1,   884,    85,   197,
     884,    -1,   884,   889,   197,   884,   891,    -1,   884,   197,
     884,   891,    -1,   884,   232,   889,   197,   884,    -1,   884,
     232,   197,   884,    -1,    32,  1011,   437,   997,   438,    -1,
      32,  1011,    -1,  1011,   437,   997,   438,    -1,  1011,    -1,
     886,    -1,    -1,   886,    -1,    32,   437,   903,   438,    -1,
      32,  1011,   437,   903,   438,    -1,  1011,   437,   903,   438,
      -1,    -1,   154,   890,    -1,   209,   890,    -1,   308,   890,
      -1,   182,    -1,   260,    -1,    -1,   382,   437,   997,   438,
      -1,   251,   929,    -1,   996,    -1,   996,   430,    -1,   252,
     996,    -1,   252,   437,   996,   438,    -1,   892,    -1,   893,
     441,   892,    -1,   892,    -1,   892,  1011,    -1,   892,    32,
    1011,    -1,   934,   899,    -1,   312,   153,   437,   897,   438,
     899,    -1,   934,   898,    -1,   896,    -1,   897,   441,   896,
      -1,    32,   437,   903,   438,    -1,    -1,   422,    -1,    -1,
     398,   929,    -1,    -1,   398,   929,    -1,   398,    87,   247,
     842,    -1,    -1,   903,    -1,    -1,   904,    -1,   903,   441,
     904,    -1,  1011,   905,   497,    -1,   907,   906,    -1,   328,
     907,   906,    -1,   907,    31,   435,  1006,   436,    -1,   328,
     907,    31,   435,  1006,   436,    -1,   907,    31,    -1,   328,
     907,    31,    -1,   906,   435,   436,    -1,   906,   435,  1006,
     436,    -1,    -1,   909,    -1,   911,    -1,   913,    -1,   917,
      -1,   924,    -1,   925,   927,    -1,   925,   437,  1006,   438,
     927,    -1,   911,    -1,   914,    -1,   918,    -1,   924,    -1,
    1012,   910,    -1,  1012,   673,   910,    -1,   437,   963,   438,
      -1,    -1,   188,    -1,   189,    -1,   333,    -1,    44,    -1,
     288,    -1,   146,   912,    -1,   120,   275,    -1,   102,   910,
      -1,   101,   910,    -1,   245,   910,    -1,    47,    -1,   437,
    1006,   438,    -1,    -1,   915,    -1,   916,    -1,   915,    -1,
     916,    -1,    46,   922,   437,   963,   438,    -1,    46,   922,
      -1,   919,    -1,   920,    -1,   919,    -1,   920,    -1,   921,
     437,  1006,   438,   923,    -1,   921,   923,    -1,    59,   922,
      -1,    58,   922,    -1,   389,    -1,   231,    59,   922,    -1,
     231,    58,   922,    -1,   233,   922,    -1,   391,    -1,    -1,
      59,   327,  1011,    -1,    -1,   359,   437,  1006,   438,   926,
      -1,   359,   926,    -1,   358,   437,  1006,   438,   926,    -1,
     358,   926,    -1,   191,    -1,   423,   419,    -1,   403,   358,
     419,    -1,    -1,   417,    -1,   227,    -1,    99,    -1,   166,
      -1,   224,    -1,   928,    -1,   417,   360,   227,    -1,    99,
     360,   166,    -1,    99,   360,   224,    -1,    99,   360,   928,
      -1,   166,   360,   224,    -1,   166,   360,   928,    -1,   224,
     360,   928,    -1,    -1,   318,    -1,   318,   437,  1006,   438,
      -1,   931,    -1,   929,    11,   905,    -1,   929,    67,   672,
      -1,   929,    37,   358,   419,   929,    -1,   428,   929,    -1,
     429,   929,    -1,   929,   428,   929,    -1,   929,   429,   929,
      -1,   929,   430,   929,    -1,   929,   431,   929,    -1,   929,
     432,   929,    -1,   929,   433,   929,    -1,   929,   425,   929,
      -1,   929,   426,   929,    -1,   929,   424,   929,    -1,   929,
     960,   929,    -1,   960,   929,    -1,   929,   960,    -1,   929,
      28,   929,    -1,   929,   256,   929,    -1,   237,   929,    -1,
     929,   211,   929,    -1,   929,   211,   929,   129,   929,    -1,
     929,   237,   211,   929,    -1,   929,   237,   211,   929,   129,
     929,    -1,   929,   169,   929,    -1,   929,   169,   929,   129,
     929,    -1,   929,   237,   169,   929,    -1,   929,   237,   169,
     929,   129,   929,    -1,   929,   331,   360,   929,    -1,   929,
     331,   360,   929,   129,   929,    -1,   929,   237,   331,   360,
     929,    -1,   929,   237,   331,   360,   929,   129,   929,    -1,
     929,   194,   242,    -1,   929,   195,    -1,   929,   194,   237,
     242,    -1,   929,   240,    -1,   956,   262,   956,    -1,   929,
     194,   366,    -1,   929,   194,   237,   366,    -1,   929,   194,
     141,    -1,   929,   194,   237,   141,    -1,   929,   194,   376,
      -1,   929,   194,   237,   376,    -1,   929,   194,   116,   153,
     929,    -1,   929,   194,   237,   116,   153,   929,    -1,   929,
     194,   247,   437,   966,   438,    -1,   929,   194,   237,   247,
     437,   966,   438,    -1,   929,    43,   988,   930,    28,   930,
      -1,   929,   237,    43,   988,   930,    28,   930,    -1,   929,
      43,   347,   930,    28,   930,    -1,   929,   237,    43,   347,
     930,    28,   930,    -1,   929,   173,   978,    -1,   929,   237,
     173,   978,    -1,   929,   962,   957,   846,    -1,   929,   962,
     957,   437,   929,   438,    -1,   375,   846,    -1,   929,   194,
     118,    -1,   929,   194,   237,   118,    -1,   931,    -1,   930,
      11,   905,    -1,   428,   930,    -1,   429,   930,    -1,   930,
     428,   930,    -1,   930,   429,   930,    -1,   930,   430,   930,
      -1,   930,   431,   930,    -1,   930,   432,   930,    -1,   930,
     433,   930,    -1,   930,   425,   930,    -1,   930,   426,   930,
      -1,   930,   424,   930,    -1,   930,   960,   930,    -1,   960,
     930,    -1,   930,   960,    -1,   930,   194,   116,   153,   930,
      -1,   930,   194,   237,   116,   153,   930,    -1,   930,   194,
     247,   437,   966,   438,    -1,   930,   194,   237,   247,   437,
     966,   438,    -1,   930,   194,   118,    -1,   930,   194,   237,
     118,    -1,   984,    -1,  1005,    -1,    10,   987,    -1,   437,
     929,   438,   987,    -1,   979,    -1,   933,    -1,   846,    -1,
     846,   986,    -1,   136,   846,    -1,    31,   846,    -1,    31,
     967,    -1,   956,    -1,  1004,   437,   438,    -1,  1004,   437,
     964,   859,   438,    -1,  1004,   437,   390,   965,   859,   438,
      -1,  1004,   437,   964,   441,   390,   965,   859,   438,    -1,
    1004,   437,    22,   964,   859,   438,    -1,  1004,   437,   116,
     964,   859,   438,    -1,  1004,   437,   430,   438,    -1,   932,
     944,   945,   949,    -1,   935,    -1,   932,    -1,   935,    -1,
      68,   148,   437,   929,   438,    -1,    89,    -1,    92,    -1,
      92,   437,  1006,   438,    -1,    93,    -1,    93,   437,  1006,
     438,    -1,   216,    -1,   216,   437,  1006,   438,    -1,   217,
      -1,   217,   437,  1006,   438,    -1,    90,    -1,    94,    -1,
     326,    -1,   381,    -1,    88,    -1,    91,    -1,    55,   437,
     929,    32,   905,   438,    -1,   140,   437,   969,   438,    -1,
     263,   437,   971,   438,    -1,   273,   437,   973,   438,    -1,
     346,   437,   974,   438,    -1,   363,   437,   929,    32,   905,
     438,    -1,   365,   437,    48,   977,   438,    -1,   365,   437,
     206,   977,   438,    -1,   365,   437,   361,   977,   438,    -1,
     365,   437,   977,   438,    -1,   243,   437,   929,   441,   929,
     438,    -1,    66,   437,   963,   438,    -1,   160,   437,   963,
     438,    -1,   208,   437,   963,   438,    -1,   409,   437,   963,
     438,    -1,   410,   437,   229,  1014,   438,    -1,   410,   437,
     229,  1014,   441,   938,   438,    -1,   410,   437,   229,  1014,
     441,   963,   438,    -1,   410,   437,   229,  1014,   441,   938,
     441,   963,   438,    -1,   411,   437,   931,   943,   438,    -1,
     412,   437,   939,   438,    -1,   413,   437,   941,   929,   942,
     438,    -1,   414,   437,   229,  1014,   438,    -1,   414,   437,
     229,  1014,   441,   929,   438,    -1,   415,   437,   929,   441,
     936,   937,   438,    -1,   416,   437,   941,   929,    32,   907,
     438,    -1,   393,   929,    -1,   393,   235,   387,    -1,   441,
     337,   418,    -1,   441,   337,   235,    -1,   441,   337,   235,
     387,    -1,    -1,   408,   437,   939,   438,    -1,   940,    -1,
     939,   441,   940,    -1,   929,    32,  1014,    -1,   929,    -1,
     118,    -1,    79,    -1,   276,   399,    -1,   345,   399,    -1,
      -1,   269,   931,    -1,   269,   931,    49,   292,    -1,   269,
      49,   292,   931,    -1,   269,    49,   292,   931,    49,   292,
      -1,   402,   161,   437,   860,   438,    -1,    -1,   144,   437,
     398,   929,   438,    -1,    -1,   400,   947,    -1,    -1,   948,
      -1,   947,   441,   948,    -1,  1011,    32,   950,    -1,   261,
     950,    -1,   261,  1011,    -1,    -1,   437,   951,   952,   859,
     953,   438,    -1,  1011,    -1,    -1,   268,    49,   963,    -1,
      -1,   286,   954,    -1,   312,   954,    -1,    -1,   955,    -1,
      43,   955,    28,   955,    -1,   371,   274,    -1,   371,   147,
      -1,    87,   311,    -1,   929,   274,    -1,   929,   147,    -1,
     311,   437,   963,   438,    -1,   311,   437,   438,    -1,   437,
     963,   441,   929,   438,    -1,    29,    -1,   335,    -1,    22,
      -1,     8,    -1,   959,    -1,   428,    -1,   429,    -1,   430,
      -1,   431,    -1,   432,    -1,   433,    -1,   425,    -1,   426,
      -1,   424,    -1,     8,    -1,   253,   437,   747,   438,    -1,
     958,    -1,   253,   437,   747,   438,    -1,   958,    -1,   253,
     437,   747,   438,    -1,   211,    -1,   237,   211,    -1,   169,
      -1,   237,   169,    -1,   929,    -1,   963,   441,   929,    -1,
     965,    -1,   964,   441,   965,    -1,   929,    -1,   726,    13,
     929,    -1,   905,    -1,   966,   441,   905,    -1,   435,   963,
     436,    -1,   435,   968,   436,    -1,   435,   436,    -1,   967,
      -1,   968,   441,   967,    -1,   970,   153,   929,    -1,    -1,
       3,    -1,   417,    -1,   227,    -1,    99,    -1,   166,    -1,
     224,    -1,   318,    -1,  1007,    -1,   929,   972,   975,   976,
      -1,   929,   972,   975,    -1,   271,   929,    -1,   930,   173,
     930,    -1,    -1,   929,   975,   976,    -1,   929,   976,   975,
      -1,   929,   975,    -1,   929,   976,    -1,   963,    -1,    -1,
     153,   929,    -1,   148,   929,    -1,   929,   153,   963,    -1,
     153,   963,    -1,   963,    -1,   846,    -1,   437,   963,   438,
      -1,    54,   983,   980,   982,   127,    -1,   981,    -1,   980,
     981,    -1,   397,   929,   357,   929,    -1,   123,   929,    -1,
      -1,   929,    -1,    -1,  1011,    -1,  1011,   986,    -1,   439,
    1001,    -1,   439,   430,    -1,   435,   929,   436,    -1,   435,
     929,   442,   929,   436,    -1,   985,    -1,   986,   985,    -1,
      -1,   987,   985,    -1,    36,    -1,    -1,   929,    -1,   104,
      -1,   989,    -1,   990,   441,   989,    -1,   437,   990,   438,
      -1,   993,    -1,    -1,   994,    -1,   993,   441,   994,    -1,
     929,    32,  1014,    -1,   929,     3,    -1,   929,    -1,   430,
      -1,   996,    -1,   995,   441,   996,    -1,  1011,    -1,  1011,
     986,    -1,   998,    -1,   997,   441,   998,    -1,  1011,    -1,
    1011,    -1,  1011,    -1,  1014,    -1,  1011,    -1,  1007,    -1,
    1012,    -1,  1011,   986,    -1,  1006,    -1,     4,    -1,  1007,
      -1,     6,    -1,     7,    -1,  1004,  1007,    -1,  1004,   437,
     964,   859,   438,  1007,    -1,   908,  1007,    -1,   925,  1007,
     927,    -1,   925,   437,  1006,   438,  1007,   927,    -1,   366,
      -1,   141,    -1,   242,    -1,     9,    -1,     5,    -1,  1013,
      -1,  1008,    -1,  1009,   441,  1008,    -1,  1006,    -1,   428,
    1006,    -1,   429,  1006,    -1,     3,    -1,  1015,    -1,  1016,
      -1,     3,    -1,  1015,    -1,  1017,    -1,     3,    -1,  1015,
      -1,  1016,    -1,  1017,    -1,     3,    -1,  1015,    -1,  1016,
      -1,  1017,    -1,  1018,    -1,    14,    -1,    15,    -1,    16,
      -1,    17,    -1,    18,    -1,    19,    -1,    20,    -1,    21,
      -1,    23,    -1,    24,    -1,    25,    -1,    30,    -1,    34,
      -1,    35,    -1,    37,    -1,    38,    -1,    40,    -1,    41,
      -1,    42,    -1,    49,    -1,    50,    -1,    51,    -1,    52,
      -1,    53,    -1,    56,    -1,    57,    -1,    60,    -1,    62,
      -1,    63,    -1,    64,    -1,    65,    -1,    70,    -1,    71,
      -1,    72,    -1,    73,    -1,    75,    -1,    76,    -1,    78,
      -1,    79,    -1,    80,    -1,    81,    -1,    82,    -1,    83,
      -1,    86,    -1,    87,    -1,    95,    -1,    96,    -1,    97,
      -1,    98,    -1,    99,    -1,   100,    -1,   103,    -1,   105,
      -1,   107,    -1,   108,    -1,   109,    -1,   110,    -1,   111,
      -1,   113,    -1,   114,    -1,   115,    -1,   118,    -1,   119,
      -1,   120,    -1,   121,    -1,   122,    -1,   124,    -1,   125,
      -1,   126,    -1,   128,    -1,   129,    -1,   130,    -1,   132,
      -1,   133,    -1,   134,    -1,   135,    -1,   137,    -1,   138,
      -1,   139,    -1,   142,    -1,   144,    -1,   145,    -1,   147,
      -1,   149,    -1,   151,    -1,   155,    -1,   156,    -1,   157,
      -1,   159,    -1,   162,    -1,   164,    -1,   165,    -1,   166,
      -1,   167,    -1,   168,    -1,   170,    -1,   171,    -1,   172,
      -1,   174,    -1,   175,    -1,   176,    -1,   177,    -1,   178,
      -1,   179,    -1,   181,    -1,   184,    -1,   185,    -1,   186,
      -1,   187,    -1,   193,    -1,   196,    -1,   198,    -1,   199,
      -1,   200,    -1,   201,    -1,   202,    -1,   204,    -1,   205,
      -1,   207,    -1,   210,    -1,   213,    -1,   214,    -1,   215,
      -1,   218,    -1,   219,    -1,   220,    -1,   221,    -1,   222,
      -1,   223,    -1,   224,    -1,   225,    -1,   226,    -1,   227,
      -1,   228,    -1,   229,    -1,   230,    -1,   234,    -1,   235,
      -1,   238,    -1,   239,    -1,   241,    -1,   244,    -1,   246,
      -1,   247,    -1,   248,    -1,   250,    -1,   253,    -1,   254,
      -1,   255,    -1,   258,    -1,   261,    -1,   264,    -1,   265,
      -1,   266,    -1,   267,    -1,   268,    -1,   269,    -1,   270,
      -1,   272,    -1,   274,    -1,   277,    -1,   278,    -1,   276,
      -1,   280,    -1,   281,    -1,   282,    -1,   283,    -1,   284,
      -1,   285,    -1,   286,    -1,   287,    -1,   289,    -1,   290,
      -1,   291,    -1,   292,    -1,   294,    -1,   295,    -1,   296,
      -1,   297,    -1,   298,    -1,   299,    -1,   300,    -1,   301,
      -1,   302,    -1,   303,    -1,   304,    -1,   306,    -1,   307,
      -1,   309,    -1,   310,    -1,   312,    -1,   313,    -1,   314,
      -1,   315,    -1,   316,    -1,   317,    -1,   318,    -1,   319,
      -1,   321,    -1,   322,    -1,   323,    -1,   324,    -1,   325,
      -1,   327,    -1,   329,    -1,   330,    -1,   332,    -1,   334,
      -1,   336,    -1,   337,    -1,   338,    -1,   339,    -1,   340,
      -1,   341,    -1,   342,    -1,   343,    -1,   344,    -1,   345,
      -1,   348,    -1,   349,    -1,   351,    -1,   352,    -1,   353,
      -1,   354,    -1,   355,    -1,   356,    -1,   362,    -1,   364,
      -1,   367,    -1,   368,    -1,   369,    -1,   370,    -1,   371,
      -1,   372,    -1,   373,    -1,   376,    -1,   377,    -1,   378,
      -1,   379,    -1,   380,    -1,   383,    -1,   384,    -1,   385,
      -1,   386,    -1,   387,    -1,   391,    -1,   393,    -1,   394,
      -1,   395,    -1,   396,    -1,   399,    -1,   402,    -1,   403,
      -1,   404,    -1,   405,    -1,   406,    -1,   407,    -1,   417,
      -1,   418,    -1,   419,    -1,    43,    -1,    44,    -1,    46,
      -1,    47,    -1,    58,    -1,    59,    -1,    66,    -1,   101,
      -1,   102,    -1,   136,    -1,   140,    -1,   146,    -1,   160,
      -1,   183,    -1,   188,    -1,   189,    -1,   191,    -1,   208,
      -1,   231,    -1,   233,    -1,   236,    -1,   243,    -1,   245,
      -1,   259,    -1,   263,    -1,   273,    -1,   275,    -1,   288,
      -1,   311,    -1,   328,    -1,   333,    -1,   346,    -1,   358,
      -1,   359,    -1,   363,    -1,   365,    -1,   388,    -1,   389,
      -1,   408,    -1,   409,    -1,   410,    -1,   411,    -1,   412,
      -1,   413,    -1,   414,    -1,   415,    -1,   416,    -1,    39,
      -1,    45,    -1,    68,    -1,    74,    -1,    85,    -1,    91,
      -1,   152,    -1,   154,    -1,   169,    -1,   182,    -1,   194,
      -1,   195,    -1,   197,    -1,   209,    -1,   211,    -1,   232,
      -1,   240,    -1,   260,    -1,   262,    -1,   308,    -1,   331,
      -1,   392,    -1,    22,    -1,    26,    -1,    27,    -1,    28,
      -1,    29,    -1,    31,    -1,    32,    -1,    33,    -1,    36,
      -1,    48,    -1,    54,    -1,    55,    -1,    61,    -1,    67,
      -1,    69,    -1,    77,    -1,    84,    -1,    88,    -1,    89,
      -1,    90,    -1,    92,    -1,    93,    -1,    94,    -1,   104,
      -1,   106,    -1,   112,    -1,   116,    -1,   117,    -1,   123,
      -1,   127,    -1,   131,    -1,   141,    -1,   143,    -1,   148,
      -1,   150,    -1,   153,    -1,   158,    -1,   161,    -1,   163,
      -1,   173,    -1,   180,    -1,   190,    -1,   192,    -1,   203,
      -1,   206,    -1,   212,    -1,   216,    -1,   217,    -1,   237,
      -1,   242,    -1,   249,    -1,   251,    -1,   252,    -1,   256,
      -1,   257,    -1,   271,    -1,   279,    -1,   293,    -1,   305,
      -1,   320,    -1,   326,    -1,   335,    -1,   347,    -1,   350,
      -1,   357,    -1,   360,    -1,   361,    -1,   366,    -1,   374,
      -1,   375,    -1,   381,    -1,   382,    -1,   390,    -1,   397,
      -1,   398,    -1,   400,    -1,   401,    -1
};

/* YYRLINE[YYN] -- source line where rule number YYN was defined.  */
static const yytype_uint16 yyrline[] =
{
       0,   690,   690,   697,   704,   714,   715,   716,   717,   718,
     719,   720,   721,   722,   723,   724,   725,   726,   727,   728,
     729,   730,   731,   732,   733,   734,   735,   736,   737,   738,
     739,   740,   741,   742,   743,   744,   745,   746,   747,   748,
     749,   750,   751,   752,   753,   754,   755,   756,   757,   758,
     759,   760,   761,   762,   763,   764,   765,   766,   767,   768,
     769,   770,   771,   772,   773,   774,   775,   776,   777,   778,
     779,   780,   781,   782,   783,   784,   785,   786,   787,   788,
     789,   790,   791,   792,   793,   794,   795,   796,   797,   798,
     799,   800,   801,   802,   803,   804,   805,   806,   807,   808,
     809,   810,   811,   812,   813,   814,   815,   816,   817,   818,
     819,   820,   821,   822,   823,   824,   825,   826,   827,   828,
     829,   831,   841,   852,   853,   862,   863,   867,   868,   872,
     877,   881,   886,   891,   895,   899,   904,   908,   962,   964,
     968,   972,   976,   980,   994,  1012,  1023,  1024,  1028,  1036,
    1054,  1066,  1074,  1095,  1102,  1121,  1128,  1145,  1163,  1174,
    1175,  1187,  1194,  1211,  1224,  1234,  1252,  1270,  1271,  1275,
    1282,  1290,  1291,  1292,  1293,  1294,  1295,  1309,  1315,  1321,
    1330,  1338,  1346,  1350,  1358,  1366,  1373,  1382,  1383,  1391,
    1402,  1410,  1418,  1429,  1437,  1445,  1452,  1461,  1471,  1472,
    1476,  1477,  1480,  1482,  1486,  1487,  1488,  1489,  1493,  1494,
    1495,  1501,  1513,  1517,  1521,  1536,  1559,  1560,  1561,  1565,
    1566,  1567,  1571,  1572,  1576,  1580,  1581,  1588,  1595,  1605,
    1612,  1622,  1623,  1628,  1629,  1634,  1640,  1646,  1652,  1658,
    1668,  1678,  1679,  1683,  1684,  1692,  1707,  1713,  1719,  1725,
    1731,  1750,  1759,  1768,  1779,  1790,  1799,  1808,  1819,  1830,
    1839,  1848,  1857,  1866,  1875,  1884,  1895,  1909,  1910,  1915,
    1923,  1931,  1940,  1948,  1956,  1965,  1974,  1983,  1992,  2002,
    2015,  2030,  2039,  2047,  2062,  2070,  2080,  2090,  2097,  2104,
    2112,  2120,  2128,  2136,  2144,  2151,  2158,  2166,  2173,  2180,
    2188,  2196,  2204,  2212,  2220,  2228,  2238,  2245,  2253,  2261,
    2269,  2277,  2284,  2294,  2295,  2299,  2300,  2301,  2305,  2313,
    2317,  2318,  2322,  2329,  2336,  2343,  2353,  2356,  2357,  2361,
    2362,  2367,  2371,  2375,  2380,  2395,  2408,  2409,  2414,  2423,
    2433,  2443,  2469,  2475,  2505,  2534,  2556,  2557,  2561,  2562,
    2571,  2572,  2573,  2576,  2577,  2582,  2583,  2587,  2591,  2595,
    2599,  2603,  2607,  2611,  2615,  2619,  2623,  2627,  2631,  2635,
    2639,  2648,  2652,  2656,  2660,  2664,  2668,  2672,  2673,  2678,
    2682,  2689,  2696,  2697,  2698,  2699,  2700,  2704,  2708,  2716,
    2727,  2742,  2758,  2774,  2803,  2804,  2805,  2806,  2807,  2814,
    2821,  2822,  2826,  2827,  2831,  2832,  2836,  2840,  2847,  2851,
    2858,  2859,  2860,  2864,  2865,  2868,  2889,  2910,  2911,  2915,
    2923,  2924,  2925,  2956,  2963,  2970,  2981,  2992,  3002,  3011,
    3044,  3051,  3058,  3065,  3076,  3086,  3087,  3088,  3092,  3093,
    3094,  3095,  3096,  3097,  3106,  3114,  3118,  3131,  3146,  3160,
    3175,  3189,  3207,  3228,  3229,  3233,  3234,  3238,  3239,  3242,
    3248,  3252,  3260,  3265,  3271,  3272,  3276,  3281,  3288,  3289,
    3299,  3301,  3303,  3305,  3308,  3311,  3314,  3318,  3319,  3320,
    3321,  3322,  3325,  3326,  3331,  3332,  3333,  3334,  3337,  3338,
    3339,  3340,  3343,  3344,  3347,  3348,  3351,  3366,  3381,  3395,
    3396,  3397,  3409,  3424,  3437,  3438,  3450,  3470,  3482,  3490,
    3501,  3502,  3505,  3506,  3509,  3513,  3517,  3521,  3525,  3529,
    3533,  3537,  3541,  3545,  3549,  3553,  3559,  3560,  3564,  3565,
    3566,  3571,  3574,  3575,  3587,  3599,  3614,  3615,  3623,  3624,
    3628,  3629,  3633,  3634,  3638,  3639,  3643,  3654,  3667,  3668,
    3678,  3689,  3690,  3703,  3710,  3727,  3735,  3746,  3749,  3753,
    3757,  3761,  3773,  3783,  3786,  3790,  3803,  3813,  3823,  3832,
    3841,  3850,  3860,  3869,  3879,  3889,  3899,  3908,  3917,  3926,
    3935,  3944,  3953,  3962,  3971,  3980,  3989,  3998,  4007,  4016,
    4034,  4045,  4046,  4047,  4048,  4052,  4053,  4057,  4058,  4068,
    4079,  4099,  4107,  4119,  4120,  4124,  4128,  4136,  4140,  4144,
    4151,  4155,  4160,  4165,  4172,  4179,  4184,  4194,  4208,  4209,
    4214,  4215,  4219,  4220,  4230,  4241,  4261,  4270,  4278,  4295,
    4310,  4335,  4344,  4362,  4374,  4375,  4376,  4386,  4394,  4411,
    4430,  4450,  4475,  4476,  4477,  4481,  4483,  4505,  4507,  4509,
    4511,  4513,  4518,  4523,  4533,  4534,  4538,  4539,  4543,  4544,
    4548,  4549,  4550,  4554,  4560,  4561,  4562,  4566,  4567,  4572,
    4573,  4600,  4601,  4602,  4603,  4604,  4605,  4610,  4621,  4644,
    4654,  4668,  4670,  4675,  4680,  4682,  4687,  4697,  4698,  4699,
    4700,  4712,  4732,  4755,  4765,  4776,  4786,  4796,  4807,  4816,
    4823,  4830,  4839,  4848,  4857,  4866,  4875,  4886,  4889,  4890,
    4893,  4897,  4904,  4905,  4906,  4907,  4908,  4911,  4914,  4915,
    4923,  4930,  4931,  4934,  4936,  4947,  4957,  4967,  4979,  4980,
    4996,  5011,  5012,  5016,  5026,  5037,  5046,  5056,  5065,  5066,
    5069,  5070,  5073,  5074,  5075,  5078,  5092,  5097,  5107,  5116,
    5128,  5129,  5133,  5141,  5153,  5164,  5178,  5189,  5212,  5222,
    5240,  5251,  5262,  5273,  5287,  5288,  5289,  5290,  5291,  5292,
    5293,  5294,  5295,  5296,  5297,  5298,  5299,  5300,  5301,  5302,
    5303,  5307,  5308,  5311,  5312,  5315,  5317,  5330,  5341,  5342,
    5343,  5375,  5384,  5393,  5402,  5411,  5420,  5429,  5439,  5448,
    5457,  5466,  5475,  5484,  5496,  5497,  5498,  5499,  5500,  5501,
    5502,  5503,  5504,  5505,  5506,  5507,  5508,  5509,  5510,  5511,
    5512,  5513,  5514,  5515,  5516,  5517,  5518,  5522,  5523,  5537,
    5548,  5559,  5570,  5581,  5594,  5595,  5599,  5600,  5601,  5602,
    5603,  5604,  5605,  5606,  5607,  5608,  5609,  5610,  5611,  5614,
    5615,  5625,  5631,  5639,  5647,  5655,  5663,  5671,  5679,  5687,
    5695,  5703,  5711,  5719,  5727,  5735,  5743,  5751,  5759,  5769,
    5770,  5773,  5774,  5784,  5800,  5814,  5840,  5842,  5844,  5846,
    5853,  5862,  5863,  5866,  5873,  5880,  5887,  5901,  5909,  5917,
    5925,  5933,  5941,  5949,  5957,  5965,  5973,  5981,  5989,  5997,
    6005,  6013,  6021,  6033,  6034,  6037,  6047,  6061,  6062,  6066,
    6067,  6072,  6088,  6101,  6111,  6123,  6124,  6127,  6128,  6138,
    6148,  6149,  6153,  6157,  6161,  6172,  6185,  6199,  6216,  6217,
    6218,  6219,  6231,  6258,  6259,  6263,  6264,  6268,  6269,  6273,
    6274,  6277,  6278,  6286,  6297,  6308,  6321,  6322,  6325,  6326,
    6327,  6330,  6331,  6332,  6335,  6336,  6337,  6353,  6365,  6378,
    6393,  6394,  6397,  6398,  6402,  6403,  6411,  6412,  6416,  6417,
    6432,  6441,  6450,  6459,  6468,  6480,  6481,  6482,  6483,  6484,
    6490,  6494,  6509,  6510,  6516,  6526,  6530,  6535,  6543,  6584,
    6588,  6592,  6596,  6604,  6605,  6610,  6611,  6618,  6622,  6626,
    6630,  6634,  6638,  6642,  6646,  6650,  6654,  6658,  6662,  6666,
    6670,  6674,  6682,  6686,  6690,  6694,  6700,  6701,  6708,  6709,
    6712,  6724,  6728,  6743,  6754,  6755,  6760,  6761,  6776,  6787,
    6801,  6812,  6826,  6837,  6851,  6859,  6861,  6863,  6868,  6870,
    6883,  6892,  6893,  6897,  6901,  6913,  6924,  6935,  6948,  6949,
    6950,  6954,  6967,  6968,  6982,  6990,  7000,  7013,  7014,  7017,
    7018,  7029,  7038,  7055,  7065,  7074,  7083,  7092,  7101,  7111,
    7120,  7130,  7139,  7148,  7158,  7168,  7177,  7186,  7196,  7206,
    7216,  7226,  7236,  7246,  7256,  7266,  7276,  7286,  7296,  7306,
    7317,  7328,  7339,  7350,  7360,  7371,  7382,  7392,  7402,  7410,
    7419,  7428,  7437,  7446,  7455,  7464,  7473,  7482,  7496,  7497,
    7500,  7501,  7511,  7521,  7530,  7539,  7548,  7557,  7567,  7577,
    7587,  7597,  7606,  7615,  7624,  7633,  7642,  7651,  7660,  7669,
    7678,  7687,  7696,  7705,  7714,  7723,  7740,  7749,  7757,  7765,
    7773,  7781,  7790,  7798,  7806,  7815,  7824,  7833,  7841,  7849,
    7857,  7865,  7873,  7881,  7889,  7906,  7923,  7924,  7925,  7930,
    7936,  7945,  7946,  7947,  7948,  7949,  7953,  7954,  7957,  7958,
    7959,  7960,  7964,  7965,  7966,  7971,  7982,  8004,  8014,  8015,
    8018,  8027,  8033,  8052,  8059,  8066,  8073,  8080,  8087,  8094,
    8102,  8110,  8118,  8126,  8134,  8141,  8148,  8157,  8158,  8159,
    8163,  8166,  8169,  8172,  8175,  8182,  8184,  8186,  8191,  8193,
    8205,  8218,  8231,  8249,  8270,  8271,  8272,  8273,  8283,  8299,
    8309,  8310,  8314,  8318,  8322,  8326,  8330,  8334,  8338,  8342,
    8346,  8350,  8354,  8358,  8362,  8366,  8370,  8374,  8384,  8385,
    8396,  8403,  8414,  8425,  8426,  8430,  8444,  8451,  8469,  8475,
    8491,  8504,  8513,  8521,  8529,  8538,  8549,  8560,  8570,  8571,
    8582,  8592,  8602,  8612,  8622,  8632,  8640,  8661,  8684,  8692,
    8701,  8712,  8713,  8725,  8741,  8757,  8771,  8791,  8816,  8817,
    8821,  8822,  8823,  8824,  8828,  8842,  8859,  8860,  8864,  8865,
    8868,  8869,  8872,  8873,  8877,  8878,  8891,  8898,  8908,  8915,
    8925,  8926,  8927,  8928,  8929,  8930,  8931,  8932,  8933,  8937,
    8941,  8948,  8955,  8956,  8960,  8961,  8962,  8972,  8982,  8983,
    8987,  8988,  8989,  8990,  9000,  9007,  9025,  9026,  9036,  9042,
    9048,  9054,  9070,  9080,  9086,  9092,  9101,  9103,  9108,  9119,
    9120,  9131,  9145,  9146,  9157,  9168,  9169,  9172,  9173,  9174,
    9175,  9176,  9177,  9178,  9179,  9180,  9181,  9184,  9185,  9196,
    9214,  9215,  9219,  9220,  9224,  9232,  9260,  9271,  9272,  9282,
    9293,  9296,  9297,  9298,  9299,  9300,  9303,  9304,  9305,  9353,
    9354,  9358,  9359,  9374,  9375,  9382,  9390,  9398,  9406,  9414,
    9422,  9433,  9434,  9461,  9476,  9477,  9496,  9500,  9504,  9519,
    9526,  9536,  9537,  9540,  9552,  9553,  9557,  9569,  9577,  9582,
    9587,  9592,  9597,  9605,  9613,  9618,  9623,  9630,  9631,  9634,
    9635,  9636,  9643,  9644,  9645,  9646,  9650,  9651,  9655,  9659,
    9660,  9663,  9672,  9685,  9686,  9687,  9688,  9692,  9693,  9697,
    9699,  9709,  9714,  9717,  9722,  9723,  9731,  9741,  9742,  9743,
    9751,  9755,  9756,  9759,  9760,  9765,  9766,  9770,  9771,  9775,
    9776,  9780,  9781,  9785,  9786,  9790,  9801,  9802,  9803,  9804,
    9808,  9809,  9814,  9820,  9838,  9839,  9843,  9844,  9850,  9855,
    9862,  9870,  9905,  9930,  9934,  9960,  9964,  9976,  9989, 10003,
   10014, 10029, 10035, 10040, 10046, 10053, 10054, 10062, 10066, 10070,
   10076, 10083, 10088, 10089, 10090, 10091, 10095, 10096, 10108, 10109,
   10114, 10121, 10128, 10135, 10146, 10147, 10160, 10164, 10171, 10192,
   10202, 10214, 10219, 10220, 10223, 10224, 10227, 10228, 10233, 10234,
   10239, 10240, 10248, 10253, 10254, 10258, 10262, 10268, 10298, 10303,
   10310, 10315, 10321, 10326, 10335, 10337, 10340, 10344, 10345, 10346,
   10347, 10348, 10349, 10354, 10384, 10385, 10386, 10387, 10398, 10404,
   10412, 10413, 10419, 10424, 10429, 10434, 10439, 10444, 10449, 10454,
   10460, 10466, 10472, 10479, 10501, 10510, 10514, 10522, 10526, 10534,
   10546, 10567, 10571, 10577, 10581, 10594, 10605, 10620, 10622, 10624,
   10626, 10628, 10630, 10635, 10636, 10640, 10641, 10648, 10657, 10665,
   10674, 10685, 10693, 10694, 10695, 10699, 10701, 10703, 10705, 10707,
   10709, 10711, 10716, 10721, 10727, 10735, 10740, 10747, 10754, 10758,
   10762, 10792, 10793, 10795, 10803, 10818, 10820, 10822, 10824, 10826,
   10828, 10830, 10832, 10834, 10836, 10838, 10841, 10843, 10845, 10848,
   10850, 10852, 10855, 10857, 10864, 10866, 10873, 10875, 10882, 10884,
   10892, 10899, 10906, 10913, 10930, 10937, 10944, 10951, 10958, 10974,
   10981, 10988, 10995, 11002, 11009, 11016, 11020, 11028, 11032, 11042,
   11049, 11056, 11069, 11082, 11101, 11122, 11132, 11139, 11155, 11160,
   11178, 11180, 11182, 11184, 11186, 11188, 11190, 11192, 11194, 11196,
   11198, 11200, 11202, 11204, 11206, 11208, 11210, 11214, 11219, 11223,
   11227, 11232, 11249, 11250, 11251, 11266, 11278, 11280, 11282, 11292,
   11315, 11325, 11335, 11343, 11354, 11358, 11364, 11371, 11378, 11388,
   11395, 11423, 11458, 11469, 11470, 11477, 11483, 11509, 11519, 11532,
   11540, 11553, 11563, 11576, 11586, 11599, 11603, 11607, 11611, 11615,
   11619, 11623, 11625, 11629, 11638, 11643, 11650, 11665, 11672, 11676,
   11680, 11684, 11688, 11695, 11703, 11711, 11715, 11719, 11723, 11727,
   11731, 11737, 11741, 11750, 11754, 11758, 11763, 11777, 11779, 11783,
   11785, 11787, 11790, 11793, 11796, 11797, 11800, 11808, 11818, 11819,
   11822, 11823, 11824, 11829, 11833, 11837, 11841, 11852, 11853, 11857,
   11858, 11866, 11867, 11871, 11872, 11877, 11885, 11887, 11901, 11904,
   11931, 11932, 11935, 11936, 11947, 11965, 11972, 11981, 11998, 12043,
   12051, 12059, 12067, 12075, 12096, 12097, 12098, 12101, 12102, 12103,
   12106, 12107, 12110, 12111, 12112, 12113, 12114, 12115, 12116, 12117,
   12118, 12121, 12123, 12128, 12130, 12135, 12137, 12139, 12141, 12143,
   12145, 12157, 12161, 12168, 12172, 12178, 12182, 12193, 12194, 12197,
   12201, 12205, 12211, 12212, 12217, 12221, 12228, 12229, 12230, 12231,
   12232, 12233, 12234, 12235, 12245, 12249, 12256, 12263, 12264, 12280,
   12284, 12289, 12293, 12308, 12313, 12317, 12320, 12323, 12324, 12325,
   12328, 12335, 12345, 12359, 12360, 12364, 12375, 12376, 12379, 12380,
   12383, 12387, 12394, 12398, 12402, 12409, 12419, 12420, 12424, 12425,
   12428, 12429, 12440, 12441, 12450, 12451, 12459, 12469, 12470, 12474,
   12475, 12478, 12494, 12502, 12510, 12532, 12533, 12544, 12548, 12575,
   12577, 12582, 12585, 12588, 12590, 12592, 12594, 12604, 12606, 12617,
   12621, 12625, 12629, 12633, 12642, 12649, 12681, 12685, 12691, 12708,
   12712, 12716, 12722, 12723, 12724, 12726, 12728, 12732, 12733, 12734,
   12750, 12751, 12752, 12757, 12758, 12759, 12764, 12765, 12766, 12767,
   12773, 12774, 12775, 12776, 12777, 12797, 12798, 12799, 12800, 12801,
   12802, 12803, 12804, 12805, 12806, 12807, 12808, 12809, 12810, 12811,
   12812, 12813, 12814, 12815, 12816, 12817, 12818, 12819, 12820, 12821,
   12822, 12823, 12824, 12825, 12826, 12827, 12828, 12829, 12830, 12831,
   12832, 12833, 12834, 12835, 12836, 12837, 12838, 12839, 12840, 12841,
   12842, 12843, 12844, 12845, 12846, 12847, 12848, 12849, 12850, 12851,
   12852, 12853, 12854, 12855, 12856, 12857, 12858, 12859, 12860, 12861,
   12862, 12863, 12864, 12865, 12866, 12867, 12868, 12869, 12870, 12871,
   12872, 12873, 12874, 12875, 12876, 12877, 12878, 12879, 12880, 12881,
   12882, 12883, 12884, 12885, 12886, 12887, 12888, 12889, 12890, 12891,
   12892, 12893, 12894, 12895, 12896, 12897, 12898, 12899, 12900, 12901,
   12902, 12903, 12904, 12905, 12906, 12907, 12908, 12909, 12910, 12911,
   12912, 12913, 12914, 12915, 12916, 12917, 12918, 12919, 12920, 12921,
   12922, 12923, 12924, 12925, 12926, 12927, 12928, 12929, 12930, 12931,
   12932, 12933, 12934, 12935, 12936, 12937, 12938, 12939, 12940, 12941,
   12942, 12943, 12944, 12945, 12946, 12947, 12948, 12949, 12950, 12951,
   12952, 12953, 12954, 12955, 12956, 12957, 12958, 12959, 12960, 12961,
   12962, 12963, 12964, 12965, 12966, 12967, 12968, 12969, 12970, 12971,
   12972, 12973, 12974, 12975, 12976, 12977, 12978, 12979, 12980, 12981,
   12982, 12983, 12984, 12985, 12986, 12987, 12988, 12989, 12990, 12991,
   12992, 12993, 12994, 12995, 12996, 12997, 12998, 12999, 13000, 13001,
   13002, 13003, 13004, 13005, 13006, 13007, 13008, 13009, 13010, 13011,
   13012, 13013, 13014, 13015, 13016, 13017, 13018, 13019, 13020, 13021,
   13022, 13023, 13024, 13025, 13026, 13027, 13028, 13029, 13030, 13031,
   13032, 13033, 13034, 13035, 13036, 13037, 13038, 13039, 13040, 13041,
   13042, 13043, 13044, 13045, 13046, 13047, 13048, 13049, 13050, 13051,
   13052, 13053, 13054, 13055, 13056, 13070, 13071, 13072, 13073, 13074,
   13075, 13076, 13077, 13078, 13079, 13080, 13081, 13082, 13083, 13084,
   13085, 13086, 13087, 13088, 13089, 13090, 13091, 13092, 13093, 13094,
   13095, 13096, 13097, 13098, 13099, 13100, 13101, 13102, 13103, 13104,
   13105, 13106, 13107, 13108, 13109, 13110, 13111, 13112, 13113, 13114,
   13115, 13116, 13130, 13131, 13132, 13133, 13134, 13135, 13136, 13137,
   13138, 13139, 13140, 13141, 13142, 13143, 13144, 13145, 13146, 13147,
   13148, 13149, 13150, 13151, 13161, 13162, 13163, 13164, 13165, 13166,
   13167, 13168, 13169, 13170, 13171, 13172, 13173, 13174, 13175, 13176,
   13177, 13178, 13179, 13180, 13181, 13182, 13183, 13184, 13185, 13186,
   13187, 13188, 13189, 13190, 13191, 13192, 13193, 13194, 13195, 13196,
   13197, 13198, 13199, 13200, 13201, 13202, 13203, 13204, 13205, 13206,
   13207, 13208, 13209, 13210, 13211, 13212, 13213, 13214, 13215, 13216,
   13217, 13218, 13219, 13220, 13221, 13222, 13223, 13224, 13225, 13226,
   13227, 13228, 13229, 13230, 13231, 13232, 13233, 13234, 13235, 13236,
   13237
};
#endif

#if YYDEBUG || YYERROR_VERBOSE || 0
/* YYTNAME[SYMBOL-NUM] -- String name of the symbol SYMBOL-NUM.
   First, the terminals, then, starting at YYNTOKENS, nonterminals.  */
static const char *const yytname[] =
{
  "$end", "error", "$undefined", "IDENT", "FCONST", "SCONST", "BCONST",
  "XCONST", "Op", "ICONST", "PARAM", "TYPECAST", "DOT_DOT", "COLON_EQUALS",
  "ABORT_P", "ABSOLUTE_P", "ACCESS", "ACTION", "ADD_P", "ADMIN", "AFTER",
  "AGGREGATE", "ALL", "ALSO", "ALTER", "ALWAYS", "ANALYSE", "ANALYZE",
  "AND", "ANY", "APPLICATION", "ARRAY", "AS", "ASC", "ASSERTION",
  "ASSIGNMENT", "ASYMMETRIC", "AT", "ATTRIBUTE", "AUTHORIZATION",
  "BACKWARD", "BEFORE", "BEGIN_P", "BETWEEN", "BIGINT", "BINARY", "BIT",
  "BOOLEAN_P", "BOTH", "BY", "CACHE", "CALLED", "CASCADE", "CASCADED",
  "CASE", "CAST", "CATALOG_P", "CHAIN", "CHAR_P", "CHARACTER",
  "CHARACTERISTICS", "CHECK", "CHECKPOINT", "CLASS", "CLOSE", "CLUSTER",
  "COALESCE", "COLLATE", "COLLATION", "COLUMN", "COMMENT", "COMMENTS",
  "COMMIT", "COMMITTED", "CONCURRENTLY", "CONFIGURATION", "CONNECTION",
  "CONSTRAINT", "CONSTRAINTS", "CONTENT_P", "CONTINUE_P", "CONVERSION_P",
  "COPY", "COST", "CREATE", "CROSS", "CSV", "CURRENT_P", "CURRENT_CATALOG",
  "CURRENT_DATE", "CURRENT_ROLE", "CURRENT_SCHEMA", "CURRENT_TIME",
  "CURRENT_TIMESTAMP", "CURRENT_USER", "CURSOR", "CYCLE", "DATA_P",
  "DATABASE", "DAY_P", "DEALLOCATE", "DEC", "DECIMAL_P", "DECLARE",
  "DEFAULT", "DEFAULTS", "DEFERRABLE", "DEFERRED", "DEFINER", "DELETE_P",
  "DELIMITER", "DELIMITERS", "DESC", "DICTIONARY", "DISABLE_P", "DISCARD",
  "DISTINCT", "DO", "DOCUMENT_P", "DOMAIN_P", "DOUBLE_P", "DROP", "EACH",
  "ELSE", "ENABLE_P", "ENCODING", "ENCRYPTED", "END_P", "ENUM_P", "ESCAPE",
  "EVENT", "EXCEPT", "EXCLUDE", "EXCLUDING", "EXCLUSIVE", "EXECUTE",
  "EXISTS", "EXPLAIN", "EXTENSION", "EXTERNAL", "EXTRACT", "FALSE_P",
  "FAMILY", "FETCH", "FILTER", "FIRST_P", "FLOAT_P", "FOLLOWING", "FOR",
  "FORCE", "FOREIGN", "FORWARD", "FREEZE", "FROM", "FULL", "FUNCTION",
  "FUNCTIONS", "GLOBAL", "GRANT", "GRANTED", "GREATEST", "GROUP_P",
  "HANDLER", "HAVING", "HEADER_P", "HOLD", "HOUR_P", "IDENTITY_P", "IF_P",
  "ILIKE", "IMMEDIATE", "IMMUTABLE", "IMPLICIT_P", "IN_P", "INCLUDING",
  "INCREMENT", "INDEX", "INDEXES", "INHERIT", "INHERITS", "INITIALLY",
  "INLINE_P", "INNER_P", "INOUT", "INPUT_P", "INSENSITIVE", "INSERT",
  "INSTEAD", "INT_P", "INTEGER", "INTERSECT", "INTERVAL", "INTO",
  "INVOKER", "IS", "ISNULL", "ISOLATION", "JOIN", "KEY", "LABEL",
  "LANGUAGE", "LARGE_P", "LAST_P", "LATERAL_P", "LC_COLLATE_P",
  "LC_CTYPE_P", "LEADING", "LEAKPROOF", "LEAST", "LEFT", "LEVEL", "LIKE",
  "LIMIT", "LISTEN", "LOAD", "LOCAL", "LOCALTIME", "LOCALTIMESTAMP",
  "LOCATION", "LOCK_P", "MAPPING", "MATCH", "MATERIALIZED", "MAXVALUE",
  "MINUTE_P", "MINVALUE", "MODE", "MONTH_P", "MOVE", "NAME_P", "NAMES",
  "NATIONAL", "NATURAL", "NCHAR", "NEXT", "NO", "NONE", "NOT", "NOTHING",
  "NOTIFY", "NOTNULL", "NOWAIT", "NULL_P", "NULLIF", "NULLS_P", "NUMERIC",
  "OBJECT_P", "OF", "OFF", "OFFSET", "OIDS", "ON", "ONLY", "OPERATOR",
  "OPTION", "OPTIONS", "OR", "ORDER", "ORDINALITY", "OUT_P", "OUTER_P",
  "OVER", "OVERLAPS", "OVERLAY", "OWNED", "OWNER", "PARSER", "PARTIAL",
  "PARTITION", "PASSING", "PASSWORD", "PLACING", "PLANS", "POSITION",
  "PRECEDING", "PRECISION", "PRESERVE", "PREPARE", "PREPARED", "PRIMARY",
  "PRIOR", "PRIVILEGES", "PROCEDURAL", "PROCEDURE", "PROGRAM", "QUOTE",
  "RANGE", "READ", "REAL", "REASSIGN", "RECHECK", "RECURSIVE", "REF",
  "REFERENCES", "REFRESH", "REINDEX", "RELATIVE_P", "RELEASE", "RENAME",
  "REPEATABLE", "REPLACE", "REPLICA", "RESET", "RESTART", "RESTRICT",
  "RETURNING", "RETURNS", "REVOKE", "RIGHT", "ROLE", "ROLLBACK", "ROW",
  "ROWS", "RULE", "SAVEPOINT", "SCHEMA", "SCROLL", "SEARCH", "SECOND_P",
  "SECURITY", "SELECT", "SEQUENCE", "SEQUENCES", "SERIALIZABLE", "SERVER",
  "SESSION", "SESSION_USER", "SET", "SETOF", "SHARE", "SHOW", "SIMILAR",
  "SIMPLE", "SMALLINT", "SNAPSHOT", "SOME", "STABLE", "STANDALONE_P",
  "START", "STATEMENT", "STATISTICS", "STDIN", "STDOUT", "STORAGE",
  "STRICT_P", "STRIP_P", "SUBSTRING", "SYMMETRIC", "SYSID", "SYSTEM_P",
  "TABLE", "TABLES", "TABLESPACE", "TEMP", "TEMPLATE", "TEMPORARY",
  "TEXT_P", "THEN", "TIME", "TIMESTAMP", "TO", "TRAILING", "TRANSACTION",
  "TREAT", "TRIGGER", "TRIM", "TRUE_P", "TRUNCATE", "TRUSTED", "TYPE_P",
  "TYPES_P", "UNBOUNDED", "UNCOMMITTED", "UNENCRYPTED", "UNION", "UNIQUE",
  "UNKNOWN", "UNLISTEN", "UNLOGGED", "UNTIL", "UPDATE", "USER", "USING",
  "VACUUM", "VALID", "VALIDATE", "VALIDATOR", "VALUE_P", "VALUES",
  "VARCHAR", "VARIADIC", "VARYING", "VERBOSE", "VERSION_P", "VIEW",
  "VIEWS", "VOLATILE", "WHEN", "WHERE", "WHITESPACE_P", "WINDOW", "WITH",
  "WITHIN", "WITHOUT", "WORK", "WRAPPER", "WRITE", "XML_P",
  "XMLATTRIBUTES", "XMLCONCAT", "XMLELEMENT", "XMLEXISTS", "XMLFOREST",
  "XMLPARSE", "XMLPI", "XMLROOT", "XMLSERIALIZE", "YEAR_P", "YES_P",
  "ZONE", "NULLS_FIRST", "NULLS_LAST", "WITH_ORDINALITY", "WITH_TIME",
  "'='", "'<'", "'>'", "POSTFIXOP", "'+'", "'-'", "'*'", "'/'", "'%'",
  "'^'", "UMINUS", "'['", "']'", "'('", "')'", "'.'", "';'", "','", "':'",
  "$accept", "stmtblock", "stmtmulti", "stmt", "CreateRoleStmt",
  "opt_with", "OptRoleList", "AlterOptRoleList", "AlterOptRoleElem",
  "CreateOptRoleElem", "CreateUserStmt", "AlterRoleStmt",
  "opt_in_database", "AlterRoleSetStmt", "AlterUserStmt",
  "AlterUserSetStmt", "DropRoleStmt", "DropUserStmt", "CreateGroupStmt",
  "AlterGroupStmt", "add_drop", "DropGroupStmt", "CreateSchemaStmt",
  "OptSchemaName", "OptSchemaEltList", "schema_stmt", "VariableSetStmt",
  "set_rest", "generic_set", "set_rest_more", "var_name", "var_list",
  "var_value", "iso_level", "opt_boolean_or_string", "zone_value",
  "opt_encoding", "NonReservedWord_or_Sconst", "VariableResetStmt",
  "reset_rest", "generic_reset", "SetResetClause",
  "FunctionSetResetClause", "VariableShowStmt", "ConstraintsSetStmt",
  "constraints_set_list", "constraints_set_mode", "CheckPointStmt",
  "DiscardStmt", "AlterTableStmt", "alter_table_cmds", "alter_table_cmd",
  "alter_column_default", "opt_drop_behavior", "opt_collate_clause",
  "alter_using", "replica_identity", "reloptions", "opt_reloptions",
  "reloption_list", "reloption_elem", "AlterCompositeTypeStmt",
  "alter_type_cmds", "alter_type_cmd", "ClosePortalStmt", "CopyStmt",
  "copy_from", "opt_program", "copy_file_name", "copy_options",
  "copy_opt_list", "copy_opt_item", "opt_binary", "opt_oids",
  "copy_delimiter", "opt_using", "copy_generic_opt_list",
  "copy_generic_opt_elem", "copy_generic_opt_arg",
  "copy_generic_opt_arg_list", "copy_generic_opt_arg_list_item",
  "CreateStmt", "OptTemp", "OptTableElementList",
  "OptTypedTableElementList", "TableElementList", "TypedTableElementList",
  "TableElement", "TypedTableElement", "columnDef", "columnOptions",
  "ColQualList", "ColConstraint", "ColConstraintElem", "ConstraintAttr",
  "TableLikeClause", "TableLikeOptionList", "TableLikeOption",
  "TableConstraint", "ConstraintElem", "opt_no_inherit", "opt_column_list",
  "columnList", "columnElem", "key_match", "ExclusionConstraintList",
  "ExclusionConstraintElem", "ExclusionWhereClause", "key_actions",
  "key_update", "key_delete", "key_action", "OptInherit", "OptWith",
  "OnCommitOption", "OptTableSpace", "OptConsTableSpace", "ExistingIndex",
  "CreateAsStmt", "create_as_target", "opt_with_data", "CreateMatViewStmt",
  "create_mv_target", "OptNoLog", "RefreshMatViewStmt", "CreateSeqStmt",
  "AlterSeqStmt", "OptSeqOptList", "SeqOptList", "SeqOptElem", "opt_by",
  "NumericOnly", "NumericOnly_list", "CreatePLangStmt", "opt_trusted",
  "handler_name", "opt_inline_handler", "validator_clause",
  "opt_validator", "DropPLangStmt", "opt_procedural",
  "CreateTableSpaceStmt", "OptTableSpaceOwner", "DropTableSpaceStmt",
  "CreateExtensionStmt", "create_extension_opt_list",
  "create_extension_opt_item", "AlterExtensionStmt",
  "alter_extension_opt_list", "alter_extension_opt_item",
  "AlterExtensionContentsStmt", "CreateFdwStmt", "fdw_option",
  "fdw_options", "opt_fdw_options", "DropFdwStmt", "AlterFdwStmt",
  "create_generic_options", "generic_option_list", "alter_generic_options",
  "alter_generic_option_list", "alter_generic_option_elem",
  "generic_option_elem", "generic_option_name", "generic_option_arg",
  "CreateForeignServerStmt", "opt_type", "foreign_server_version",
  "opt_foreign_server_version", "DropForeignServerStmt",
  "AlterForeignServerStmt", "CreateForeignTableStmt",
  "AlterForeignTableStmt", "CreateUserMappingStmt", "auth_ident",
  "DropUserMappingStmt", "AlterUserMappingStmt", "CreateTrigStmt",
  "TriggerActionTime", "TriggerEvents", "TriggerOneEvent",
  "TriggerForSpec", "TriggerForOptEach", "TriggerForType", "TriggerWhen",
  "TriggerFuncArgs", "TriggerFuncArg", "OptConstrFromTable",
  "ConstraintAttributeSpec", "ConstraintAttributeElem", "DropTrigStmt",
  "CreateEventTrigStmt", "event_trigger_when_list",
  "event_trigger_when_item", "event_trigger_value_list",
  "AlterEventTrigStmt", "enable_trigger", "CreateAssertStmt",
  "DropAssertStmt", "DefineStmt", "definition", "def_list", "def_elem",
  "def_arg", "old_aggr_definition", "old_aggr_list", "old_aggr_elem",
  "opt_enum_val_list", "enum_val_list", "AlterEnumStmt",
  "opt_if_not_exists", "CreateOpClassStmt", "opclass_item_list",
  "opclass_item", "opt_default", "opt_opfamily", "opclass_purpose",
  "opt_recheck", "CreateOpFamilyStmt", "AlterOpFamilyStmt",
  "opclass_drop_list", "opclass_drop", "DropOpClassStmt",
  "DropOpFamilyStmt", "DropOwnedStmt", "ReassignOwnedStmt", "DropStmt",
  "drop_type", "any_name_list", "any_name", "attrs", "TruncateStmt",
  "opt_restart_seqs", "CommentStmt", "comment_type", "comment_text",
  "SecLabelStmt", "opt_provider", "security_label_type", "security_label",
  "FetchStmt", "fetch_args", "from_in", "opt_from_in", "GrantStmt",
  "RevokeStmt", "privileges", "privilege_list", "privilege",
  "privilege_target", "grantee_list", "grantee", "opt_grant_grant_option",
  "function_with_argtypes_list", "function_with_argtypes", "GrantRoleStmt",
  "RevokeRoleStmt", "opt_grant_admin_option", "opt_granted_by",
  "AlterDefaultPrivilegesStmt", "DefACLOptionList", "DefACLOption",
  "DefACLAction", "defacl_privilege_target", "IndexStmt", "opt_unique",
  "opt_concurrently", "opt_index_name", "access_method_clause",
  "index_params", "index_elem", "opt_collate", "opt_class", "opt_asc_desc",
  "opt_nulls_order", "CreateFunctionStmt", "opt_or_replace", "func_args",
  "func_args_list", "func_args_with_defaults",
  "func_args_with_defaults_list", "func_arg", "arg_class", "param_name",
  "func_return", "func_type", "func_arg_with_default", "aggr_arg",
  "aggr_args", "aggr_args_list", "createfunc_opt_list",
  "common_func_opt_item", "createfunc_opt_item", "func_as",
  "opt_definition", "table_func_column", "table_func_column_list",
  "AlterFunctionStmt", "alterfunc_opt_list", "opt_restrict",
  "RemoveFuncStmt", "RemoveAggrStmt", "RemoveOperStmt", "oper_argtypes",
  "any_operator", "DoStmt", "dostmt_opt_list", "dostmt_opt_item",
  "CreateCastStmt", "cast_context", "DropCastStmt", "opt_if_exists",
  "ReindexStmt", "reindex_type", "opt_force", "AlterTblSpcStmt",
  "RenameStmt", "opt_column", "opt_set_data", "AlterObjectSchemaStmt",
  "AlterOwnerStmt", "RuleStmt", "RuleActionList", "RuleActionMulti",
  "RuleActionStmt", "RuleActionStmtOrEmpty", "event", "opt_instead",
  "DropRuleStmt", "NotifyStmt", "notify_payload", "ListenStmt",
  "UnlistenStmt", "TransactionStmt", "opt_transaction",
  "transaction_mode_item", "transaction_mode_list",
  "transaction_mode_list_or_empty", "ViewStmt", "opt_check_option",
  "LoadStmt", "CreatedbStmt", "createdb_opt_list", "createdb_opt_item",
  "opt_equal", "AlterDatabaseStmt", "AlterDatabaseSetStmt",
  "alterdb_opt_list", "alterdb_opt_item", "DropdbStmt", "AlterSystemStmt",
  "CreateDomainStmt", "AlterDomainStmt", "opt_as", "AlterTSDictionaryStmt",
  "AlterTSConfigurationStmt", "CreateConversionStmt", "ClusterStmt",
  "cluster_index_specification", "VacuumStmt", "vacuum_option_list",
  "vacuum_option_elem", "AnalyzeStmt", "analyze_keyword", "opt_verbose",
  "opt_full", "opt_freeze", "opt_name_list", "ExplainStmt",
  "ExplainableStmt", "explain_option_list", "explain_option_elem",
  "explain_option_name", "explain_option_arg", "PrepareStmt",
  "prep_type_clause", "PreparableStmt", "ExecuteStmt",
  "execute_param_clause", "DeallocateStmt", "InsertStmt", "insert_rest",
  "insert_column_list", "insert_column_item", "returning_clause",
  "DeleteStmt", "using_clause", "LockStmt", "opt_lock", "lock_type",
  "opt_nowait", "UpdateStmt", "set_clause_list", "set_clause",
  "single_set_clause", "multiple_set_clause", "set_target",
  "set_target_list", "DeclareCursorStmt", "cursor_name", "cursor_options",
  "opt_hold", "SelectStmt", "select_with_parens", "select_no_parens",
  "select_clause", "simple_select", "with_clause", "cte_list",
  "common_table_expr", "opt_with_clause", "into_clause",
  "OptTempTableName", "opt_table", "opt_all", "opt_distinct",
  "opt_sort_clause", "sort_clause", "sortby_list", "sortby",
  "select_limit", "opt_select_limit", "limit_clause", "offset_clause",
  "select_limit_value", "select_offset_value",
  "opt_select_fetch_first_value", "select_offset_value2", "row_or_rows",
  "first_or_next", "group_clause", "having_clause", "for_locking_clause",
  "opt_for_locking_clause", "for_locking_items", "for_locking_item",
  "for_locking_strength", "locked_rels_list", "values_clause",
  "from_clause", "from_list", "table_ref", "joined_table", "alias_clause",
  "opt_alias_clause", "func_alias_clause", "join_type", "join_outer",
  "join_qual", "relation_expr", "relation_expr_list",
  "relation_expr_opt_alias", "func_table", "rowsfrom_item",
  "rowsfrom_list", "opt_col_def_list", "opt_ordinality", "where_clause",
  "where_or_current_clause", "OptTableFuncElementList",
  "TableFuncElementList", "TableFuncElement", "Typename",
  "opt_array_bounds", "SimpleTypename", "ConstTypename", "GenericType",
  "opt_type_modifiers", "Numeric", "opt_float", "Bit", "ConstBit",
  "BitWithLength", "BitWithoutLength", "Character", "ConstCharacter",
  "CharacterWithLength", "CharacterWithoutLength", "character",
  "opt_varying", "opt_charset", "ConstDatetime", "ConstInterval",
  "opt_timezone", "opt_interval", "interval_second", "a_expr", "b_expr",
  "c_expr", "func_application", "func_expr", "func_expr_windowless",
  "func_expr_common_subexpr", "xml_root_version",
  "opt_xml_root_standalone", "xml_attributes", "xml_attribute_list",
  "xml_attribute_el", "document_or_content", "xml_whitespace_option",
  "xmlexists_argument", "within_group_clause", "filter_clause",
  "window_clause", "window_definition_list", "window_definition",
  "over_clause", "window_specification", "opt_existing_window_name",
  "opt_partition_clause", "opt_frame_clause", "frame_extent",
  "frame_bound", "row", "sub_type", "all_Op", "MathOp", "qual_Op",
  "qual_all_Op", "subquery_Op", "expr_list", "func_arg_list",
  "func_arg_expr", "type_list", "array_expr", "array_expr_list",
  "extract_list", "extract_arg", "overlay_list", "overlay_placing",
  "position_list", "substr_list", "substr_from", "substr_for", "trim_list",
  "in_expr", "case_expr", "when_clause_list", "when_clause",
  "case_default", "case_arg", "columnref", "indirection_el", "indirection",
  "opt_indirection", "opt_asymmetric", "ctext_expr", "ctext_expr_list",
  "ctext_row", "opt_target_list", "target_list", "target_el",
  "qualified_name_list", "qualified_name", "name_list", "name",
  "database_name", "access_method", "attr_name", "index_name", "file_name",
  "func_name", "AexprConst", "Iconst", "Sconst", "RoleId", "role_list",
  "SignedIconst", "ColId", "type_function_name", "NonReservedWord",
  "ColLabel", "unreserved_keyword", "col_name_keyword",
  "type_func_name_keyword", "reserved_keyword", YY_NULL
};
#endif

# ifdef YYPRINT
/* YYTOKNUM[YYLEX-NUM] -- Internal token number corresponding to
   token YYLEX-NUM.  */
static const yytype_uint16 yytoknum[] =
{
       0,   256,   257,   258,   259,   260,   261,   262,   263,   264,
     265,   266,   267,   268,   269,   270,   271,   272,   273,   274,
     275,   276,   277,   278,   279,   280,   281,   282,   283,   284,
     285,   286,   287,   288,   289,   290,   291,   292,   293,   294,
     295,   296,   297,   298,   299,   300,   301,   302,   303,   304,
     305,   306,   307,   308,   309,   310,   311,   312,   313,   314,
     315,   316,   317,   318,   319,   320,   321,   322,   323,   324,
     325,   326,   327,   328,   329,   330,   331,   332,   333,   334,
     335,   336,   337,   338,   339,   340,   341,   342,   343,   344,
     345,   346,   347,   348,   349,   350,   351,   352,   353,   354,
     355,   356,   357,   358,   359,   360,   361,   362,   363,   364,
     365,   366,   367,   368,   369,   370,   371,   372,   373,   374,
     375,   376,   377,   378,   379,   380,   381,   382,   383,   384,
     385,   386,   387,   388,   389,   390,   391,   392,   393,   394,
     395,   396,   397,   398,   399,   400,   401,   402,   403,   404,
     405,   406,   407,   408,   409,   410,   411,   412,   413,   414,
     415,   416,   417,   418,   419,   420,   421,   422,   423,   424,
     425,   426,   427,   428,   429,   430,   431,   432,   433,   434,
     435,   436,   437,   438,   439,   440,   441,   442,   443,   444,
     445,   446,   447,   448,   449,   450,   451,   452,   453,   454,
     455,   456,   457,   458,   459,   460,   461,   462,   463,   464,
     465,   466,   467,   468,   469,   470,   471,   472,   473,   474,
     475,   476,   477,   478,   479,   480,   481,   482,   483,   484,
     485,   486,   487,   488,   489,   490,   491,   492,   493,   494,
     495,   496,   497,   498,   499,   500,   501,   502,   503,   504,
     505,   506,   507,   508,   509,   510,   511,   512,   513,   514,
     515,   516,   517,   518,   519,   520,   521,   522,   523,   524,
     525,   526,   527,   528,   529,   530,   531,   532,   533,   534,
     535,   536,   537,   538,   539,   540,   541,   542,   543,   544,
     545,   546,   547,   548,   549,   550,   551,   552,   553,   554,
     555,   556,   557,   558,   559,   560,   561,   562,   563,   564,
     565,   566,   567,   568,   569,   570,   571,   572,   573,   574,
     575,   576,   577,   578,   579,   580,   581,   582,   583,   584,
     585,   586,   587,   588,   589,   590,   591,   592,   593,   594,
     595,   596,   597,   598,   599,   600,   601,   602,   603,   604,
     605,   606,   607,   608,   609,   610,   611,   612,   613,   614,
     615,   616,   617,   618,   619,   620,   621,   622,   623,   624,
     625,   626,   627,   628,   629,   630,   631,   632,   633,   634,
     635,   636,   637,   638,   639,   640,   641,   642,   643,   644,
     645,   646,   647,   648,   649,   650,   651,   652,   653,   654,
     655,   656,   657,   658,   659,   660,   661,   662,   663,   664,
     665,   666,   667,   668,   669,   670,   671,   672,   673,   674,
     675,   676,   677,   678,    61,    60,    62,   679,    43,    45,
      42,    47,    37,    94,   680,    91,    93,    40,    41,    46,
      59,    44,    58
};
# endif

/* YYR1[YYN] -- Symbol number of symbol that rule YYN derives.  */
static const yytype_uint16 yyr1[] =
{
       0,   443,   444,   445,   445,   446,   446,   446,   446,   446,
     446,   446,   446,   446,   446,   446,   446,   446,   446,   446,
     446,   446,   446,   446,   446,   446,   446,   446,   446,   446,
     446,   446,   446,   446,   446,   446,   446,   446,   446,   446,
     446,   446,   446,   446,   446,   446,   446,   446,   446,   446,
     446,   446,   446,   446,   446,   446,   446,   446,   446,   446,
     446,   446,   446,   446,   446,   446,   446,   446,   446,   446,
     446,   446,   446,   446,   446,   446,   446,   446,   446,   446,
     446,   446,   446,   446,   446,   446,   446,   446,   446,   446,
     446,   446,   446,   446,   446,   446,   446,   446,   446,   446,
     446,   446,   446,   446,   446,   446,   446,   446,   446,   446,
     446,   446,   446,   446,   446,   446,   446,   446,   446,   446,
     446,   446,   447,   448,   448,   449,   449,   450,   450,   451,
     451,   451,   451,   451,   451,   451,   451,   451,   452,   452,
     452,   452,   452,   452,   453,   454,   455,   455,   456,   456,
     457,   458,   458,   459,   459,   460,   460,   461,   462,   463,
     463,   464,   464,   465,   465,   465,   465,   466,   466,   467,
     467,   468,   468,   468,   468,   468,   468,   469,   469,   469,
     470,   470,   470,   471,   471,   471,   471,   472,   472,   472,
     472,   472,   472,   472,   472,   472,   472,   472,   473,   473,
     474,   474,   475,   475,   476,   476,   476,   476,   477,   477,
     477,   477,   478,   478,   478,   478,   478,   478,   478,   479,
     479,   479,   480,   480,   481,   482,   482,   482,   482,   483,
     483,   484,   484,   485,   485,   486,   486,   486,   486,   486,
     487,   488,   488,   489,   489,   490,   491,   491,   491,   491,
     491,   492,   492,   492,   492,   492,   492,   492,   492,   492,
     492,   492,   492,   492,   492,   492,   492,   493,   493,   494,
     494,   494,   494,   494,   494,   494,   494,   494,   494,   494,
     494,   494,   494,   494,   494,   494,   494,   494,   494,   494,
     494,   494,   494,   494,   494,   494,   494,   494,   494,   494,
     494,   494,   494,   494,   494,   494,   494,   494,   494,   494,
     494,   494,   494,   495,   495,   496,   496,   496,   497,   497,
     498,   498,   499,   499,   499,   499,   500,   501,   501,   502,
     502,   503,   503,   503,   503,   504,   505,   505,   506,   506,
     506,   506,   507,   507,   508,   508,   509,   509,   510,   510,
     511,   511,   511,   512,   512,   513,   513,   514,   514,   514,
     514,   514,   514,   514,   514,   514,   514,   514,   514,   514,
     514,   515,   515,   516,   516,   517,   517,   518,   518,   519,
     519,   520,   521,   521,   521,   521,   521,   522,   522,   523,
     524,   524,   524,   524,   525,   525,   525,   525,   525,   525,
     525,   525,   526,   526,   527,   527,   528,   528,   529,   529,
     530,   530,   530,   531,   531,   532,   533,   534,   534,   535,
     535,   535,   535,   536,   536,   536,   536,   536,   536,   536,
     537,   537,   537,   537,   538,   539,   539,   539,   540,   540,
     540,   540,   540,   540,   541,   541,   542,   542,   542,   542,
     542,   542,   542,   543,   543,   544,   544,   545,   545,   546,
     547,   547,   547,   547,   548,   548,   549,   549,   550,   550,
     551,   551,   551,   551,   551,   552,   553,   554,   554,   554,
     554,   554,   555,   555,   556,   556,   556,   556,   557,   557,
     557,   557,   558,   558,   559,   559,   560,   561,   562,   563,
     563,   563,   564,   565,   566,   566,   567,   568,   569,   569,
     570,   570,   571,   571,   572,   572,   572,   572,   572,   572,
     572,   572,   572,   572,   572,   572,   573,   573,   574,   574,
     574,   574,   575,   575,   576,   576,   577,   577,   578,   578,
     579,   579,   580,   580,   581,   581,   582,   582,   583,   583,
     584,   585,   585,   586,   586,   587,   587,   588,   588,   589,
     589,   589,   590,   591,   591,   592,   593,   593,   593,   593,
     593,   593,   593,   593,   593,   593,   593,   593,   593,   593,
     593,   593,   593,   593,   593,   593,   593,   593,   593,   593,
     594,   595,   595,   595,   595,   596,   596,   597,   597,   598,
     598,   599,   599,   600,   600,   601,   601,   602,   603,   603,
     604,   604,   604,   604,   605,   606,   607,   608,   609,   609,
     610,   610,   611,   611,   612,   612,   613,   613,   613,   614,
     614,   615,   615,   616,   617,   617,   617,   618,   618,   619,
     620,   620,   621,   621,   621,   622,   622,   623,   623,   623,
     623,   623,   624,   624,   625,   625,   626,   626,   627,   627,
     628,   628,   628,   629,   629,   629,   629,   630,   630,   631,
     631,   632,   632,   632,   632,   632,   632,   633,   633,   634,
     634,   635,   635,   636,   637,   637,   638,   639,   639,   639,
     639,   640,   641,   642,   642,   642,   642,   642,   642,   642,
     642,   642,   642,   642,   642,   642,   642,   643,   644,   644,
     645,   645,   646,   646,   646,   646,   646,   647,   648,   648,
     649,   650,   650,   651,   651,   652,   652,   652,   653,   653,
     654,   655,   655,   656,   656,   656,   656,   656,   657,   657,
     658,   658,   659,   659,   659,   660,   660,   661,   662,   662,
     663,   663,   664,   664,   665,   665,   666,   666,   667,   668,
     669,   669,   669,   669,   670,   670,   670,   670,   670,   670,
     670,   670,   670,   670,   670,   670,   670,   670,   670,   670,
     670,   671,   671,   672,   672,   673,   673,   674,   675,   675,
     675,   676,   676,   676,   676,   676,   676,   676,   676,   676,
     676,   676,   676,   676,   677,   677,   677,   677,   677,   677,
     677,   677,   677,   677,   677,   677,   677,   677,   677,   677,
     677,   677,   677,   677,   677,   677,   677,   678,   678,   679,
     679,   679,   679,   679,   680,   680,   681,   681,   681,   681,
     681,   681,   681,   681,   681,   681,   681,   681,   681,   682,
     682,   683,   683,   684,   684,   684,   684,   684,   684,   684,
     684,   684,   684,   684,   684,   684,   684,   684,   684,   685,
     685,   686,   686,   687,   688,   688,   689,   689,   689,   689,
     689,   690,   690,   691,   691,   691,   691,   692,   692,   692,
     692,   692,   692,   692,   692,   692,   692,   692,   692,   692,
     692,   692,   692,   693,   693,   694,   694,   695,   695,   696,
     696,   697,   698,   699,   699,   700,   700,   701,   701,   702,
     703,   703,   704,   704,   704,   705,   705,   705,   706,   706,
     706,   706,   707,   708,   708,   709,   709,   710,   710,   711,
     711,   712,   712,   713,   713,   713,   714,   714,   715,   715,
     715,   716,   716,   716,   717,   717,   717,   718,   718,   718,
     719,   719,   720,   720,   721,   721,   722,   722,   723,   723,
     724,   724,   724,   724,   724,   725,   725,   725,   725,   725,
     726,   727,   728,   728,   728,   729,   729,   729,   730,   731,
     731,   731,   731,   732,   732,   733,   733,   734,   734,   734,
     734,   734,   734,   734,   734,   734,   734,   734,   734,   734,
     734,   734,   735,   735,   735,   735,   736,   736,   737,   737,
     738,   739,   739,   740,   741,   741,   742,   742,   743,   743,
     744,   744,   745,   745,   746,   746,   746,   746,   747,   747,
     748,   749,   749,   750,   750,   751,   751,   751,   752,   752,
     752,   753,   754,   754,   755,   755,   755,   756,   756,   757,
     757,   758,   758,   759,   759,   759,   759,   759,   759,   759,
     759,   759,   759,   759,   759,   759,   759,   759,   759,   759,
     759,   759,   759,   759,   759,   759,   759,   759,   759,   759,
     759,   759,   759,   759,   759,   759,   759,   759,   759,   759,
     759,   759,   759,   759,   759,   759,   759,   759,   760,   760,
     761,   761,   762,   762,   762,   762,   762,   762,   762,   762,
     762,   762,   762,   762,   762,   762,   762,   762,   762,   762,
     762,   762,   762,   762,   762,   762,   763,   763,   763,   763,
     763,   763,   763,   763,   763,   763,   763,   763,   763,   763,
     763,   763,   763,   763,   763,   764,   765,   765,   765,   766,
     766,   767,   767,   767,   767,   767,   768,   768,   769,   769,
     769,   769,   770,   770,   770,   771,   771,   772,   773,   773,
     774,   775,   775,   776,   776,   776,   776,   776,   776,   776,
     776,   776,   776,   776,   776,   776,   776,   777,   777,   777,
     778,   778,   778,   778,   778,   779,   779,   779,   780,   780,
     781,   781,   781,   781,   782,   782,   782,   782,   783,   784,
     785,   785,   786,   786,   786,   786,   786,   786,   786,   786,
     786,   786,   786,   786,   786,   786,   786,   786,   787,   787,
     788,   788,   789,   790,   790,   791,   792,   792,   793,   793,
     794,   795,   795,   795,   795,   795,   795,   795,   796,   796,
     797,   798,   798,   798,   798,   798,   798,   799,   800,   800,
     800,   801,   801,   802,   802,   802,   802,   802,   803,   803,
     804,   804,   804,   804,   805,   805,   806,   806,   807,   807,
     808,   808,   809,   809,   810,   810,   811,   811,   811,   811,
     812,   812,   812,   812,   812,   812,   812,   812,   812,   813,
     813,   814,   815,   815,   816,   816,   816,   817,   818,   818,
     819,   819,   819,   819,   820,   820,   821,   821,   822,   822,
     822,   822,   823,   824,   824,   824,   825,   825,   826,   827,
     827,   828,   829,   829,   830,   831,   831,   832,   832,   832,
     832,   832,   832,   832,   832,   832,   832,   833,   833,   834,
     835,   835,   836,   836,   837,   838,   839,   840,   840,   841,
     842,   843,   843,   843,   843,   843,   844,   844,   844,   845,
     845,   846,   846,   847,   847,   847,   847,   847,   847,   847,
     847,   848,   848,   849,   849,   849,   849,   849,   849,   850,
     850,   851,   851,   852,   853,   853,   854,   854,   855,   855,
     855,   855,   855,   855,   855,   855,   855,   856,   856,   857,
     857,   857,   858,   858,   858,   858,   859,   859,   860,   861,
     861,   862,   862,   863,   863,   863,   863,   864,   864,   865,
     865,   865,   866,   866,   867,   867,   868,   869,   869,   869,
     870,   871,   871,   872,   872,   873,   873,   874,   874,   875,
     875,   876,   876,   877,   877,   878,   879,   879,   879,   879,
     880,   880,   881,   881,   882,   882,   883,   883,   884,   884,
     884,   884,   884,   884,   884,   885,   885,   885,   885,   885,
     885,   886,   886,   886,   886,   887,   887,   888,   888,   888,
     888,   888,   889,   889,   889,   889,   890,   890,   891,   891,
     892,   892,   892,   892,   893,   893,   894,   894,   894,   895,
     895,   896,   897,   897,   898,   898,   899,   899,   900,   900,
     901,   901,   901,   902,   902,   903,   903,   904,   905,   905,
     905,   905,   905,   905,   906,   906,   906,   907,   907,   907,
     907,   907,   907,   907,   908,   908,   908,   908,   909,   909,
     910,   910,   911,   911,   911,   911,   911,   911,   911,   911,
     911,   911,   911,   912,   912,   913,   913,   914,   914,   915,
     916,   917,   917,   918,   918,   919,   920,   921,   921,   921,
     921,   921,   921,   922,   922,   923,   923,   924,   924,   924,
     924,   925,   926,   926,   926,   927,   927,   927,   927,   927,
     927,   927,   927,   927,   927,   927,   927,   927,   927,   928,
     928,   929,   929,   929,   929,   929,   929,   929,   929,   929,
     929,   929,   929,   929,   929,   929,   929,   929,   929,   929,
     929,   929,   929,   929,   929,   929,   929,   929,   929,   929,
     929,   929,   929,   929,   929,   929,   929,   929,   929,   929,
     929,   929,   929,   929,   929,   929,   929,   929,   929,   929,
     929,   929,   929,   929,   929,   929,   929,   929,   929,   929,
     930,   930,   930,   930,   930,   930,   930,   930,   930,   930,
     930,   930,   930,   930,   930,   930,   930,   930,   930,   930,
     930,   930,   931,   931,   931,   931,   931,   931,   931,   931,
     931,   931,   931,   931,   932,   932,   932,   932,   932,   932,
     932,   933,   933,   934,   934,   935,   935,   935,   935,   935,
     935,   935,   935,   935,   935,   935,   935,   935,   935,   935,
     935,   935,   935,   935,   935,   935,   935,   935,   935,   935,
     935,   935,   935,   935,   935,   935,   935,   935,   935,   935,
     935,   935,   935,   935,   935,   935,   935,   936,   936,   937,
     937,   937,   937,   938,   939,   939,   940,   940,   941,   941,
     942,   942,   942,   943,   943,   943,   943,   944,   944,   945,
     945,   946,   946,   947,   947,   948,   949,   949,   949,   950,
     951,   951,   952,   952,   953,   953,   953,   954,   954,   955,
     955,   955,   955,   955,   956,   956,   956,   957,   957,   957,
     958,   958,   959,   959,   959,   959,   959,   959,   959,   959,
     959,   960,   960,   961,   961,   962,   962,   962,   962,   962,
     962,   963,   963,   964,   964,   965,   965,   966,   966,   967,
     967,   967,   968,   968,   969,   969,   970,   970,   970,   970,
     970,   970,   970,   970,   971,   971,   972,   973,   973,   974,
     974,   974,   974,   974,   974,   975,   976,   977,   977,   977,
     978,   978,   979,   980,   980,   981,   982,   982,   983,   983,
     984,   984,   985,   985,   985,   985,   986,   986,   987,   987,
     988,   988,   989,   989,   990,   990,   991,   992,   992,   993,
     993,   994,   994,   994,   994,   995,   995,   996,   996,   997,
     997,   998,   999,  1000,  1001,  1002,  1003,  1004,  1004,  1005,
    1005,  1005,  1005,  1005,  1005,  1005,  1005,  1005,  1005,  1005,
    1005,  1005,  1006,  1007,  1008,  1009,  1009,  1010,  1010,  1010,
    1011,  1011,  1011,  1012,  1012,  1012,  1013,  1013,  1013,  1013,
    1014,  1014,  1014,  1014,  1014,  1015,  1015,  1015,  1015,  1015,
    1015,  1015,  1015,  1015,  1015,  1015,  1015,  1015,  1015,  1015,
    1015,  1015,  1015,  1015,  1015,  1015,  1015,  1015,  1015,  1015,
    1015,  1015,  1015,  1015,  1015,  1015,  1015,  1015,  1015,  1015,
    1015,  1015,  1015,  1015,  1015,  1015,  1015,  1015,  1015,  1015,
    1015,  1015,  1015,  1015,  1015,  1015,  1015,  1015,  1015,  1015,
    1015,  1015,  1015,  1015,  1015,  1015,  1015,  1015,  1015,  1015,
    1015,  1015,  1015,  1015,  1015,  1015,  1015,  1015,  1015,  1015,
    1015,  1015,  1015,  1015,  1015,  1015,  1015,  1015,  1015,  1015,
    1015,  1015,  1015,  1015,  1015,  1015,  1015,  1015,  1015,  1015,
    1015,  1015,  1015,  1015,  1015,  1015,  1015,  1015,  1015,  1015,
    1015,  1015,  1015,  1015,  1015,  1015,  1015,  1015,  1015,  1015,
    1015,  1015,  1015,  1015,  1015,  1015,  1015,  1015,  1015,  1015,
    1015,  1015,  1015,  1015,  1015,  1015,  1015,  1015,  1015,  1015,
    1015,  1015,  1015,  1015,  1015,  1015,  1015,  1015,  1015,  1015,
    1015,  1015,  1015,  1015,  1015,  1015,  1015,  1015,  1015,  1015,
    1015,  1015,  1015,  1015,  1015,  1015,  1015,  1015,  1015,  1015,
    1015,  1015,  1015,  1015,  1015,  1015,  1015,  1015,  1015,  1015,
    1015,  1015,  1015,  1015,  1015,  1015,  1015,  1015,  1015,  1015,
    1015,  1015,  1015,  1015,  1015,  1015,  1015,  1015,  1015,  1015,
    1015,  1015,  1015,  1015,  1015,  1015,  1015,  1015,  1015,  1015,
    1015,  1015,  1015,  1015,  1015,  1015,  1015,  1015,  1015,  1015,
    1015,  1015,  1015,  1015,  1015,  1015,  1015,  1015,  1015,  1015,
    1015,  1015,  1015,  1015,  1015,  1015,  1015,  1015,  1015,  1015,
    1015,  1015,  1015,  1015,  1015,  1015,  1015,  1015,  1015,  1015,
    1015,  1015,  1015,  1015,  1015,  1015,  1015,  1015,  1015,  1015,
    1015,  1015,  1015,  1015,  1015,  1016,  1016,  1016,  1016,  1016,
    1016,  1016,  1016,  1016,  1016,  1016,  1016,  1016,  1016,  1016,
    1016,  1016,  1016,  1016,  1016,  1016,  1016,  1016,  1016,  1016,
    1016,  1016,  1016,  1016,  1016,  1016,  1016,  1016,  1016,  1016,
    1016,  1016,  1016,  1016,  1016,  1016,  1016,  1016,  1016,  1016,
    1016,  1016,  1017,  1017,  1017,  1017,  1017,  1017,  1017,  1017,
    1017,  1017,  1017,  1017,  1017,  1017,  1017,  1017,  1017,  1017,
    1017,  1017,  1017,  1017,  1018,  1018,  1018,  1018,  1018,  1018,
    1018,  1018,  1018,  1018,  1018,  1018,  1018,  1018,  1018,  1018,
    1018,  1018,  1018,  1018,  1018,  1018,  1018,  1018,  1018,  1018,
    1018,  1018,  1018,  1018,  1018,  1018,  1018,  1018,  1018,  1018,
    1018,  1018,  1018,  1018,  1018,  1018,  1018,  1018,  1018,  1018,
    1018,  1018,  1018,  1018,  1018,  1018,  1018,  1018,  1018,  1018,
    1018,  1018,  1018,  1018,  1018,  1018,  1018,  1018,  1018,  1018,
    1018,  1018,  1018,  1018,  1018,  1018,  1018,  1018,  1018,  1018,
    1018
};

/* YYR2[YYN] -- Number of symbols composing right hand side of rule YYN.  */
static const yytype_uint8 yyr2[] =
{
       0,     2,     1,     3,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     0,     5,     1,     0,     2,     0,     2,     0,     2,
       2,     3,     3,     1,     3,     3,     2,     1,     1,     2,
       2,     2,     3,     3,     5,     5,     0,     3,     5,     5,
       5,     5,     5,     3,     5,     3,     5,     5,     6,     1,
       1,     3,     5,     6,     4,     9,     7,     1,     0,     2,
       0,     1,     1,     1,     1,     1,     1,     2,     3,     3,
       2,     5,     1,     3,     3,     3,     3,     1,     3,     3,
       2,     2,     2,     2,     3,     3,     3,     3,     1,     3,
       1,     3,     1,     1,     2,     2,     2,     1,     1,     1,
       1,     1,     1,     1,     3,     6,     1,     1,     1,     1,
       1,     0,     1,     1,     2,     1,     2,     3,     2,     1,
       1,     2,     1,     2,     1,     2,     3,     4,     3,     2,
       4,     1,     1,     1,     1,     1,     2,     2,     2,     2,
       2,     4,     6,    10,    13,     4,     6,    10,    13,     4,
       6,     4,     6,     5,     7,    11,    14,     1,     3,     2,
       3,     4,     6,     6,     6,     5,     5,     6,     6,     4,
       8,     4,     2,     4,     3,     6,     4,     3,     3,     3,
       3,     3,     4,     4,     3,     3,     3,     3,     3,     3,
       4,     4,     3,     2,     3,     2,     2,     3,     3,     2,
       2,     3,     1,     3,     2,     1,     1,     0,     2,     0,
       2,     0,     1,     1,     1,     3,     3,     2,     0,     1,
       3,     3,     1,     5,     3,     4,     1,     3,     4,     6,
       4,     8,     2,     2,    11,     7,     1,     1,     1,     0,
       1,     1,     1,     1,     3,     2,     0,     1,     1,     1,
       3,     3,     1,     1,     3,     3,     3,     3,     4,     3,
       2,     1,     0,     2,     0,     3,     0,     1,     0,     1,
       3,     2,     1,     1,     1,     3,     0,     1,     3,     1,
      11,    14,    10,    13,     1,     1,     2,     2,     2,     2,
       1,     0,     1,     0,     3,     0,     1,     3,     1,     3,
       1,     1,     1,     1,     1,     4,     4,     2,     0,     3,
       1,     1,     2,     2,     1,     3,     4,     5,     2,     5,
       1,     2,     2,     2,     3,     3,     3,     0,     1,     1,
       1,     1,     1,     1,     3,     1,     5,     7,     3,     8,
       4,     9,    11,     2,     0,     3,     0,     1,     3,     1,
       2,     2,     2,     0,     1,     3,     3,     6,     4,     0,
       1,     1,     2,     2,     0,     3,     3,     2,     1,     1,
       2,     2,     4,     0,     2,     2,     2,     0,     3,     4,
       4,     0,     2,     0,     4,     0,     3,     7,     5,     2,
       3,     0,     8,     4,     1,     0,     6,     5,     4,     6,
       1,     0,     1,     2,     2,     1,     2,     3,     2,     2,
       2,     2,     3,     3,     1,     3,     1,     0,     1,     2,
       2,     1,     1,     3,     6,    10,     1,     0,     1,     2,
       2,     0,     2,     2,     1,     0,     5,     7,     1,     0,
       7,     2,     0,     3,     5,     5,     8,     2,     0,     2,
       2,     2,     5,     2,     0,     2,     7,    10,     6,     6,
       6,     6,     7,     7,     9,     9,     6,     7,     6,     8,
       8,     8,     8,     6,     6,     7,     7,     8,     6,     6,
       7,     2,     2,     2,     2,     1,     2,     1,     0,     6,
       8,     7,     6,     4,     0,     1,     3,     4,     1,     3,
       1,     2,     2,     2,     2,     1,     1,    10,     2,     0,
       2,     2,     1,     0,     4,     6,     5,     4,     4,    10,
      13,     5,     7,     8,     1,     1,     1,     7,     9,     8,
      15,    20,     1,     1,     2,     1,     3,     1,     1,     1,
       3,     1,     3,     0,     1,     0,     1,     1,     4,     0,
       1,     3,     0,     1,     1,     1,     1,     2,     0,     0,
       2,     2,     1,     2,     2,     2,     2,     6,     8,    11,
      13,     1,     3,     5,     1,     3,     5,     1,     2,     2,
       1,     8,     4,     5,     4,     4,     4,     3,     7,     8,
       6,     6,     6,     6,     6,     4,     5,     3,     1,     3,
       3,     1,     1,     1,     1,     1,     1,     3,     1,     3,
       3,     1,     0,     1,     3,     7,     9,     9,     3,     0,
      13,     1,     3,     5,     6,     4,     7,     2,     1,     0,
       2,     0,     2,     4,     0,     1,     0,     6,     8,     8,
       1,     3,     5,     5,     7,     9,     7,     9,     5,     6,
       6,     4,     5,     7,     1,     1,     1,     2,     1,     2,
       2,     1,     1,     1,     1,     1,     1,     3,     3,     3,
       3,     1,     3,     1,     2,     2,     3,     5,     2,     2,
       0,     6,     7,     7,     7,     8,     8,     6,     8,     9,
       9,     7,    10,     7,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     2,     1,     1,     1,     1,     1,     2,
       1,     3,     2,     3,     3,     3,     3,     1,     1,     8,
       9,     9,     9,     9,     2,     0,     1,     1,     2,     2,
       1,     1,     1,     1,     1,     1,     1,     1,     2,     1,
       1,     2,     2,     1,     2,     3,     3,     3,     3,     4,
       4,     3,     3,     3,     4,     4,     3,     4,     4,     1,
       1,     1,     0,     7,     7,    10,     1,     1,     2,     4,
       5,     1,     3,     2,     2,     2,     2,     1,     2,     2,
       4,     3,     2,     2,     2,     2,     3,     2,     2,     2,
       5,     5,     5,     1,     3,     1,     2,     3,     0,     1,
       3,     2,     6,     6,     9,     3,     0,     3,     0,     5,
       2,     0,     3,     3,     3,     7,     7,    10,     1,     1,
       1,     1,    14,     1,     0,     1,     0,     1,     0,     2,
       0,     1,     3,     5,     5,     7,     2,     0,     1,     2,
       0,     1,     1,     0,     1,     1,     0,     9,    12,     7,
       2,     0,     3,     2,     1,     3,     3,     2,     1,     3,
       3,     3,     2,     2,     1,     1,     1,     1,     2,     1,
       1,     1,     1,     4,     5,     1,     3,     3,     1,     3,
       3,     5,     6,     1,     3,     1,     2,     4,     5,     1,
       1,     1,     1,     3,     3,     2,     2,     1,     2,     2,
       2,     1,     2,     2,     1,     1,     1,     3,     2,     0,
       2,     1,     3,     5,     1,     2,     1,     0,     5,     7,
       5,     7,     5,     7,     3,     5,     5,     5,     1,     3,
       2,     1,     2,     1,     2,    11,    10,    10,     2,     2,
       0,     9,     2,     0,     4,     4,     4,     1,     1,     1,
       0,     5,     5,     7,     6,     6,     6,     6,     8,     8,
       6,     6,     7,     9,     9,     6,     6,     6,     8,     6,
       8,     6,     8,     7,     9,     6,     8,     7,     9,     8,
      10,     9,    11,     8,     9,    11,     8,     8,     7,     6,
       6,     6,     8,     8,     8,     8,     6,     9,     1,     0,
       2,     0,     7,     6,     6,     6,     6,     6,     7,     9,
       9,     6,     8,     8,     8,     8,     8,     6,     8,     6,
       8,     7,     9,     7,     9,     6,     7,     6,     6,     6,
       6,     6,     7,     7,     7,     9,     9,     6,     6,     6,
       8,     8,     8,     6,     7,    13,     1,     1,     3,     3,
       1,     1,     1,     1,     1,     1,     1,     0,     1,     1,
       1,     1,     1,     1,     0,     6,     8,     3,     2,     0,
       2,     2,     2,     2,     3,     3,     2,     2,     2,     2,
       3,     2,     5,     4,     3,     3,     3,     1,     1,     0,
       3,     2,     2,     1,     2,     1,     3,     2,     1,     0,
       9,    11,    12,    14,     3,     4,     4,     0,     2,     5,
       2,     0,     3,     3,     3,     3,     3,     3,     3,     3,
       3,     3,     3,     3,     3,     4,     3,     3,     1,     0,
       5,     6,     4,     2,     0,     4,     3,     5,     4,     4,
       6,     4,     6,     6,     5,     7,     9,     6,     1,     0,
       6,    11,    11,    11,    13,     9,    11,    10,     4,     2,
       5,     2,     0,     4,     5,     5,     4,     6,     1,     3,
       1,     1,     1,     1,     2,     4,     1,     1,     1,     0,
       1,     0,     1,     0,     3,     0,     2,     4,     3,     5,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       3,     2,     1,     1,     1,     1,     0,     5,     3,     0,
       1,     1,     1,     1,     3,     9,     3,     0,     2,     3,
       2,     3,     6,     1,     4,     2,     1,     3,     2,     2,
       0,     7,     2,     0,     5,     3,     0,     2,     2,     2,
       2,     2,     3,     1,     3,     1,     2,     1,     0,     8,
       1,     3,     1,     1,     3,     5,     2,     1,     3,     7,
       1,     0,     3,     2,     2,     2,     0,     2,     2,     1,
       1,     3,     3,     1,     2,     4,     4,     2,     3,     5,
       5,     1,     1,     9,     1,     2,     4,     4,     4,     2,
       3,     1,     3,     6,     1,     0,     2,     0,     3,     3,
       4,     4,     4,     4,     3,     2,     1,     1,     0,     1,
       1,     0,     1,     5,     1,     0,     1,     0,     3,     1,
       3,     4,     3,     2,     2,     1,     1,     1,     0,     2,
       4,     5,     2,     3,     1,     1,     1,     1,     3,     0,
       1,     1,     1,     1,     1,     3,     0,     2,     0,     1,
       3,     1,     0,     1,     2,     3,     2,     4,     2,     3,
       2,     0,     2,     3,     2,     0,     1,     3,     2,     2,
       3,     2,     3,     1,     4,     3,     4,     5,     4,     5,
       4,     5,     2,     4,     1,     1,     0,     1,     4,     5,
       4,     0,     2,     2,     2,     1,     1,     0,     4,     2,
       1,     2,     2,     4,     1,     3,     1,     2,     3,     2,
       6,     2,     1,     3,     4,     0,     1,     0,     2,     0,
       2,     4,     0,     1,     0,     1,     3,     3,     2,     3,
       5,     6,     2,     3,     3,     4,     0,     1,     1,     1,
       1,     1,     2,     5,     1,     1,     1,     1,     2,     3,
       3,     0,     1,     1,     1,     1,     1,     2,     2,     2,
       2,     2,     1,     3,     0,     1,     1,     1,     1,     5,
       2,     1,     1,     1,     1,     5,     2,     2,     2,     1,
       3,     3,     2,     1,     0,     3,     0,     5,     2,     5,
       2,     1,     2,     3,     0,     1,     1,     1,     1,     1,
       1,     3,     3,     3,     3,     3,     3,     3,     0,     1,
       4,     1,     3,     3,     5,     2,     2,     3,     3,     3,
       3,     3,     3,     3,     3,     3,     3,     2,     2,     3,
       3,     2,     3,     5,     4,     6,     3,     5,     4,     6,
       4,     6,     5,     7,     3,     2,     4,     2,     3,     3,
       4,     3,     4,     3,     4,     5,     6,     6,     7,     6,
       7,     6,     7,     3,     4,     4,     6,     2,     3,     4,
       1,     3,     2,     2,     3,     3,     3,     3,     3,     3,
       3,     3,     3,     3,     2,     2,     5,     6,     6,     7,
       3,     4,     1,     1,     2,     4,     1,     1,     1,     2,
       2,     2,     2,     1,     3,     5,     6,     8,     6,     6,
       4,     4,     1,     1,     1,     5,     1,     1,     4,     1,
       4,     1,     4,     1,     4,     1,     1,     1,     1,     1,
       1,     6,     4,     4,     4,     4,     6,     5,     5,     5,
       4,     6,     4,     4,     4,     4,     5,     7,     7,     9,
       5,     4,     6,     5,     7,     7,     7,     2,     3,     3,
       3,     4,     0,     4,     1,     3,     3,     1,     1,     1,
       2,     2,     0,     2,     4,     4,     6,     5,     0,     5,
       0,     2,     0,     1,     3,     3,     2,     2,     0,     6,
       1,     0,     3,     0,     2,     2,     0,     1,     4,     2,
       2,     2,     2,     2,     4,     3,     5,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     4,     1,     4,     1,     4,     1,     2,     1,
       2,     1,     3,     1,     3,     1,     3,     1,     3,     3,
       3,     2,     1,     3,     3,     0,     1,     1,     1,     1,
       1,     1,     1,     1,     4,     3,     2,     3,     0,     3,
       3,     2,     2,     1,     0,     2,     2,     3,     2,     1,
       1,     3,     5,     1,     2,     4,     2,     0,     1,     0,
       1,     2,     2,     2,     3,     5,     1,     2,     0,     2,
       1,     0,     1,     1,     1,     3,     3,     1,     0,     1,
       3,     3,     2,     1,     1,     1,     3,     1,     2,     1,
       3,     1,     1,     1,     1,     1,     1,     1,     2,     1,
       1,     1,     1,     1,     2,     6,     2,     3,     6,     1,
       1,     1,     1,     1,     1,     1,     3,     1,     2,     2,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1
};

/* YYDEFACT[STATE-NAME] -- Default reduction number in state STATE-NUM.
   Performed when YYTABLE doesn't specify something else to do.  Zero
   means the default is an error.  */
static const yytype_uint16 yydefact[] =
{
    1405,  1199,   549,  1287,  1286,  1199,   245,     0,  1289,     0,
    1199,   372,   961,     0,     0,     0,     0,   549,  1199,     0,
    1405,     0,     0,     0,     0,  1418,     0,     0,     0,     0,
       0,     0,     0,     0,     0,  1199,     0,     0,  1425,     0,
       0,     0,     0,  1418,     0,  1291,     0,     0,     0,     0,
       2,     4,    61,    62,    26,    25,    31,    30,    84,    85,
      49,    17,    75,    55,   118,   117,   119,    37,    33,    69,
      22,    24,    34,    38,    57,    39,    50,    96,    56,    20,
      54,    79,    58,    82,    44,    11,    12,    45,    73,    13,
      46,    74,    14,    47,    15,    63,    86,    29,    59,    83,
      60,     5,    40,    71,    67,    10,    51,    52,    53,    76,
      77,    78,   101,    81,   113,    36,   110,    90,    91,   107,
      92,   108,     8,    93,    48,    16,   104,   103,   105,    70,
      41,    72,   102,    23,   106,    18,    19,   109,    80,    99,
      95,   114,   112,   120,    97,    64,     6,     7,    87,    21,
      43,     9,    28,    27,    42,    35,   116,    32,  1289,    89,
     100,    88,    65,    94,    68,    98,   115,    66,   111,  1392,
    1379,  1427,  1391,  1404,     0,  1394,  1198,  1197,  1183,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,   548,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,  1209,
    1950,  1965,  1966,  1967,  1968,  1969,  1970,  1971,  1972,   343,
    1973,  1974,  1975,  1976,  1977,  1978,  1979,  1980,  1981,  1982,
    1983,  2225,  2226,  2227,  2228,  1984,  1985,  1986,  1987,  1988,
    1989,  1990,  2229,  2230,  1991,  1992,  1993,  1994,  1995,  2231,
    1996,  1997,  1998,  1999,  2000,  2001,  2002,  2003,  2004,  2005,
    2006,  2007,  2008,  2009,  2010,  2011,  2012,  2013,  2014,  2015,
    2232,  2233,  2016,  2017,  2018,  2019,  2020,  2021,  2022,  2023,
    2024,  2025,  2026,  2027,  2028,  2029,  2030,  2031,  2032,  2033,
    2034,  2035,  2036,  2037,  2038,  2039,  2040,  2234,  2041,  2042,
    2043,  2235,  2044,  2045,  2046,  2236,  2047,  2048,  2049,  2050,
    2051,  2052,  2053,  2237,  2054,  2055,  2056,  2057,  2058,  2059,
    2060,  2061,  2062,  2063,  2064,  2065,  2066,  2067,  2068,  2069,
    2238,  2070,  2071,  2072,  2073,  2239,  2240,  2241,  2074,  2075,
    2076,  2077,  2078,  2079,  2080,  2081,  2082,  2083,  2242,  2084,
    2085,  2086,  2087,  2088,  2089,  2090,  2091,  2092,  2093,  2094,
    2095,  2096,  2097,  2098,  2099,  2100,  2243,  2244,  2101,  2102,
    2245,  2103,  2104,  2105,  2246,  2106,  2247,  2107,  2108,  2109,
    2110,  2111,  2112,  2113,  2114,  2248,  2115,  2249,  2116,  2117,
    2118,  2119,  2120,  2121,  2122,  2123,  2250,  2124,  2251,  2127,
    2125,  2126,  2128,  2129,  2130,  2131,  2132,  2133,  2134,  2135,
    2252,  2136,  2137,  2138,  2139,  2140,  2141,  2142,  2143,  2144,
    2145,  2146,  2147,  2148,  2149,  2150,  2151,  2152,  2153,  2154,
    2253,  2155,  2156,  2157,  2158,  2159,  2160,  2161,  2162,  2163,
    2164,  2165,  2166,  2167,  2168,  2254,  2169,  2170,  2171,  2255,
    2172,  2173,  2174,  2175,  2176,  2177,  2178,  2179,  2180,  2181,
    2182,  2256,  2183,  2184,  2185,  2186,  2187,  2188,  2189,  2190,
    2257,  2258,  2191,  2259,  2192,  2260,  2193,  2194,  2195,  2196,
    2197,  2198,  2199,  2200,  2201,  2202,  2203,  2204,  2205,  2206,
    2207,  2208,  2209,  2261,  2262,  2210,  2211,  2212,  2213,  2214,
    2215,  2216,  2217,  2218,  2219,  2220,  2221,  2263,  2264,  2265,
    2266,  2267,  2268,  2269,  2270,  2271,  2222,  2223,  2224,   342,
    1370,  1921,  1951,  1952,  1288,  1269,   549,     0,  1186,   371,
       0,     0,     0,     0,     0,     0,     0,     0,   738,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,   168,
       0,     0,   395,   394,     0,     0,     0,   933,   400,     0,
       0,     0,     0,     0,   537,  1330,  2125,  1328,  1371,   246,
     249,   250,   247,   248,  1943,     0,  1040,  1041,  1043,     0,
       0,  1053,   773,   774,     0,   772,     0,   776,     0,     0,
       0,   768,     0,     0,     0,     0,     0,   775,   765,     0,
     764,     0,     0,     0,   771,     0,   766,     0,     0,  1187,
    1327,   401,  1405,     0,  1305,  1306,  1307,  1289,  1296,  1308,
    1301,  1303,  1302,  1304,  1300,  1942,  1966,   872,   872,   872,
     872,   869,   870,   872,   872,   872,  2142,     0,     0,   851,
       0,   853,  1947,   872,   877,   456,   456,   456,     0,   876,
     881,   456,  1180,  1218,  1926,  1417,     0,   852,  1179,  2191,
    1319,     0,     0,     0,  1057,     0,  1058,     0,  2157,  1191,
     230,  2167,  2257,  2191,   229,   224,   225,   198,  1970,     0,
       0,   876,     0,  1188,  1189,   835,  1424,  1422,  1908,  1989,
    2002,  2087,   221,  2153,  2158,  2167,  2257,  2191,  2221,   177,
     187,   182,     0,   239,  2167,  2257,  2191,   235,  1209,     0,
    1395,  1510,  1917,     0,  1182,  1181,  1290,     0,  1293,     0,
    1472,  2138,  1399,  1401,  1295,  1392,     0,     0,     1,  1405,
    1284,  1421,  1421,     0,  1421,     0,  1384,  1392,  1387,  1391,
       0,     0,     0,     0,  1950,  2272,  2273,  2274,  2275,  2276,
    2277,  2278,  2279,  2280,  2281,  2282,  2283,  2284,  2285,  2286,
    2287,  2288,  2289,  2290,  2291,  2292,  2293,     0,     0,  1927,
    1951,  1955,     0,   783,     0,   124,  1922,   921,     0,     0,
       0,     0,  1921,     0,     0,     0,     0,  1956,     0,  1944,
    1957,  1958,  1959,     0,  2059,     0,     0,     0,  1820,  1993,
    2044,  1830,  1828,  1829,  1822,  1823,  1824,  1825,  1826,  1827,
       0,  1038,  1821,     0,   146,   124,     0,     0,  2059,     0,
       0,     0,     0,     0,  2059,     0,     0,     0,     0,     0,
     146,  2090,   124,  2059,     0,     0,  1203,     0,     0,     0,
    1205,  1208,  1184,  1272,     0,  1917,     0,     0,   814,   804,
       0,   815,   805,   810,     0,   817,     0,     0,   807,     0,
       0,     0,   818,     0,   806,   808,   820,   809,   816,     0,
       0,   811,   812,     0,     0,  1195,   456,   349,     0,     0,
       0,     0,     0,   124,  1259,     0,  2059,   124,     0,     0,
     399,   398,   124,   397,   396,  1993,  2044,     0,   960,   124,
    2059,     0,   170,   619,   552,     0,     0,   697,  2090,   124,
       0,     0,     0,     0,     0,     0,   936,     0,     0,   536,
     549,  1331,  1329,     0,  1044,   223,   222,  1042,  2059,     0,
     317,     0,     0,  2059,  1246,   770,     0,   769,  2059,     0,
    2059,  1945,   161,     0,   767,  1993,  2044,  2059,     0,     0,
    2059,   153,  2059,     0,  2059,   317,  2059,   553,     0,  2059,
       0,  2059,  2090,   155,     0,  2059,   317,   781,     0,  1324,
       0,  1298,  2261,  1313,     0,  1309,  1316,  1312,  1405,   872,
     871,     0,   872,     0,   872,     0,   872,     0,   872,     0,
       0,     0,   872,  1948,  1949,   854,     0,   878,     0,     0,
     885,   884,   883,     0,     0,     0,   886,  1514,  1346,     0,
    1177,  1194,     0,     0,     0,   936,  1060,  1060,  1060,  1190,
     228,   226,     0,     0,     0,     0,     0,     0,  1196,     0,
       0,     0,     0,  1930,  1932,  1933,  1831,  1898,     0,  2226,
    2227,  2228,  1889,     0,  2229,  2230,  2231,  2274,  1739,  1726,
    1735,  1740,  1727,  1729,  1736,  2232,  2233,  2028,  2234,  2235,
    1940,  2236,  2237,  2239,  2240,  2241,  2242,  1731,  1733,  2243,
    2244,     0,  1941,  2246,  2247,  2111,  2249,  2250,  2252,  2253,
    1737,  2255,  2256,  2257,  2258,  2259,  2260,  1939,     0,  1738,
    2262,  2264,  2265,  2266,  2267,  2268,  2269,  2270,  2271,     0,
       0,  1914,     0,  1708,     0,  1554,  1555,  1577,  1578,  1556,
    1583,  1584,  1596,  1557,     0,  1913,  1621,  1788,  1707,  1722,
    1713,     0,  1706,  1702,  1407,  1907,  1909,     0,  1703,  1929,
    1931,  1890,   190,   241,     0,   242,  1915,  2167,   178,   220,
     192,   219,   193,   191,     0,  1991,   179,     0,     0,   180,
       0,     0,     0,     0,   238,   236,     0,  1185,     0,  1512,
    1511,     0,     0,  1896,  1918,   790,  1282,  1283,  1281,     0,
    1278,  1280,  1292,  1289,  1903,  1902,  1904,     0,  1400,     0,
       0,     0,  1382,  1381,     3,  1295,  1419,  1420,     0,     0,
       0,     0,     0,     0,     0,     0,  1462,  1435,  1436,  1438,
    1459,  1463,  1471,     0,  1388,     0,     0,  1516,     0,  1473,
       0,     0,  1928,     0,     0,     0,     0,   784,     0,     0,
       0,     0,     0,     0,   123,  1244,   232,  1242,     0,     0,
       0,     0,     0,     0,     0,  1251,     0,     0,   159,   160,
     564,   549,     0,  2059,     0,     0,     0,     0,  1000,  1007,
       0,     0,     0,     0,     0,     0,     0,  1001,   999,  1002,
     234,  1011,  1024,  1027,     0,   911,     0,     0,     0,     0,
       0,  1109,     0,     0,  1109,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,   255,   267,   312,
     528,     0,     0,     0,   531,     0,  2059,     0,     0,     0,
       0,     0,     0,     0,     0,     0,   128,     0,     0,     0,
       0,     0,     0,   515,   527,     0,     0,     0,     0,     0,
     524,     0,   124,   259,   508,   512,     0,     0,     0,   628,
     627,  1249,  1248,     0,     0,     0,  1109,     0,   251,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,   335,   336,     0,     0,     0,   128,
       0,     0,     0,     0,   261,     0,     0,  1204,  1201,  1202,
       0,  1207,     0,  1268,     0,     0,     0,     0,   822,     0,
     819,     0,     0,   813,  1993,  2044,     0,     0,     0,     0,
       0,     0,   374,   348,     0,     0,   694,     0,     0,  1953,
    1565,  1594,  1572,  1594,  1594,  1561,  1561,  1574,  1562,  1563,
    1601,     0,  1594,  1561,  1566,     0,  1564,  1604,  1604,  1589,
       0,  1546,  1547,  1548,  1549,  1575,  1576,  1550,  1581,  1582,
    1551,  1618,  1561,  1954,     0,     0,   705,     0,  1221,  1258,
       0,     0,     0,   558,     0,  2059,     0,   126,   739,     0,
     695,   400,     0,   126,     0,     0,   164,     0,   623,     0,
       0,     0,     0,     0,     0,   643,   642,     0,     0,     0,
     696,     0,   126,     0,   511,  2059,     0,   456,   456,     0,
       0,   935,   938,     0,     0,     0,  1374,  1376,  1375,     0,
    1373,     0,   317,   315,   316,   692,  1052,     0,     0,     0,
       0,   317,     0,     0,  2059,   317,  2059,     0,  2059,     0,
       0,   317,   317,     0,     0,     0,     0,   624,     0,   780,
     778,   777,   779,     0,     0,     0,     0,     0,  2059,   317,
       0,     0,   761,  1841,     0,     0,  1405,     0,   209,   210,
     208,  1314,   211,  1315,  1311,  1297,     0,   862,     0,   866,
       0,   857,     0,   863,     0,   858,   855,   856,     0,   861,
       0,     0,   457,   459,     0,     0,  2013,  2027,     0,  2050,
    2078,  2079,  2158,  2163,     0,  2186,  2195,     0,   887,   916,
     882,     0,     0,  1358,  1178,  1847,     0,  1405,     0,     0,
    1059,  1056,  1055,  1054,   227,   199,     0,     0,     0,   918,
    2157,  1193,   834,   549,     0,  1704,     0,  1711,  1712,  1593,
    1580,  1888,     0,     0,  1588,  1587,     0,     0,     0,     0,
       0,  1570,  1569,  1568,  1710,  1855,     0,  1567,     0,     0,
       0,     0,  1594,  1594,  1592,  1641,     0,  1571,     0,     0,
    1868,     0,  1874,     0,     0,     0,  1600,     0,  1598,     0,
       0,  1677,     0,     0,     0,     0,     0,     0,     0,     0,
    1625,  1626,  1708,  1841,     0,  1709,  1936,     0,     0,  1586,
       0,  1618,  1912,  1831,     0,     0,     0,     0,  1901,     0,
    1839,     0,     0,  1655,  1837,     0,  1657,     0,     0,     0,
    1830,  1828,  1829,  1822,  1823,  1824,  1825,  1826,  1827,  1835,
    1638,     0,     0,  1790,     0,  1637,     0,  1475,     0,     0,
    1934,  1891,   243,   244,   240,     0,     0,   195,   194,     0,
     213,   217,   218,   189,   216,     0,   212,   197,  1779,  1778,
     196,   188,   185,   183,   200,   202,   203,   186,   184,   237,
       0,     0,  1960,  2294,  2295,  2296,  2297,  2298,  2299,  2300,
    2301,  2302,  2303,  2304,  2305,  2306,  2307,  2308,  2309,  2310,
    2311,  2312,  2313,  2314,  2315,  2316,  2317,  2318,  2319,  2320,
    2321,  2322,  2323,  2324,  2325,  2326,  2327,  2328,  2329,  2330,
    2331,  2332,  2333,  2334,  2335,  2336,  2337,  2338,  2339,  2340,
    2341,  2342,  2343,  2344,  2345,  2346,  2347,  2348,  2349,  2350,
    2351,  2352,  2353,  2354,  2355,  2356,  2357,  2358,  2359,  2360,
    2361,  2362,  2363,  2364,  2365,  2366,  2367,  2368,  2369,  2370,
    1893,  1892,  1924,  1961,  1962,  1963,  1964,  1897,     0,     0,
     317,  1276,     0,  1273,  1906,     0,  1402,     0,  1919,     0,
    1285,  1398,  1397,  1428,  1429,   953,  1396,  1453,  1454,  1449,
       0,     0,     0,  1468,  1466,  1445,  1439,  1444,  1442,     0,
    1446,  1621,  1461,  1386,  1433,  1434,  1437,  1385,     0,  1464,
       0,  1358,  1462,  1438,  1343,     0,     0,  1517,     0,   975,
     977,     0,   976,     0,   979,     0,   988,     0,     0,   974,
     993,     0,   982,   980,     0,     0,     0,     0,     0,     0,
     785,     0,     0,     0,     0,     0,     0,  2186,   231,  1240,
       0,     0,     0,     0,   920,   919,     0,     0,   940,     0,
       0,     0,  1254,   445,     0,   314,     0,     0,     0,     0,
       0,     0,     0,     0,   690,   687,     0,     0,   686,     0,
     562,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,   598,
       0,  1109,     0,   631,     0,  1009,     0,  1008,     0,     0,
       0,  1010,  1005,  1006,  2158,  2167,  2191,   233,  1026,     0,
    1025,  1023,   963,     0,   964,     0,     0,     0,     0,     0,
    2037,   269,   282,     0,  1108,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,   303,     0,   306,   305,
       0,     0,     0,     0,     0,   310,     0,     0,     0,   309,
       0,     0,   529,   530,     0,     0,     0,  1109,     0,   263,
       0,     0,     0,     0,     0,     0,  1039,     0,     0,   149,
       0,   145,   148,     0,     0,     0,     0,   514,   526,     0,
     518,   519,   516,   520,   521,     0,     0,     0,     0,     0,
       0,   513,     0,     0,   621,   620,   626,     0,     0,     0,
       0,     0,     0,     0,     0,  1062,  1061,     0,     0,     0,
       0,     0,     0,   729,     0,     0,     0,     0,     0,     0,
       0,   152,   634,   635,     0,   636,     0,   150,   151,     0,
       0,     0,     0,     0,     0,     0,   207,  1200,  1206,  1271,
    1925,  1270,     0,     0,     0,   821,     0,     0,     0,     0,
       0,     0,     0,   823,   824,   825,   826,     0,     0,     0,
       0,     0,   351,   352,   124,   350,  1953,     0,   718,   693,
       0,  1546,     0,  1542,  1538,  1607,  1608,  1609,  1606,  1619,
    1605,     0,  1552,  1610,  1561,  1558,   706,     0,   708,   711,
       0,  1219,   418,     0,     0,   555,   598,     0,   403,   157,
       0,     0,     0,     0,   122,   168,   170,   401,     0,   169,
     171,   173,   174,   175,   172,   176,   618,   622,     0,   551,
       0,     0,     0,     0,     0,   644,   648,   647,   651,   649,
       0,   645,     0,     0,  1534,     0,   144,     0,   507,   510,
       0,     0,     0,   403,   487,   328,     0,   456,     0,     0,
     937,     0,     0,     0,     0,     0,     0,     0,  1372,     0,
    1030,     0,  1247,  2059,   317,     0,  1028,   162,  1946,     0,
     762,     0,     0,     0,     0,     0,  1032,   758,   154,     0,
     317,   317,   554,     0,   317,   156,     0,     0,     0,   546,
     317,   782,  1326,     0,   456,  1299,  1310,   859,   868,   867,
     865,   864,   860,     0,   879,     0,   455,     0,     0,     0,
     893,   894,     0,     0,   892,   909,   895,     0,   897,   889,
     888,   898,   899,     0,     0,   918,     0,     0,  1355,     0,
    1353,     0,  1515,  1357,  1344,  1318,     0,  1317,  1321,  1323,
    1322,  1320,     0,   501,     0,     0,   876,     0,     0,   317,
    1192,     0,   836,   837,   843,     0,     0,     0,     0,     0,
     844,   840,   841,   842,   845,   846,   847,     0,     0,     0,
    1899,  1851,     0,  1852,     0,     0,     0,  1887,  1883,     0,
       0,     0,     0,     0,     0,  1856,  1859,  1860,  1861,  1858,
    1862,  1857,     0,     0,  1863,     0,     0,     0,     0,     0,
    1591,  1590,     0,     0,     0,     0,     0,     0,     0,  1680,
    1713,     0,     0,  1815,     0,  1841,  1873,     0,     0,  1602,
       0,     0,     0,     0,     0,     0,     0,  1841,  1879,     0,
       0,     0,     0,  1777,     0,  1774,     0,     0,     0,     0,
    1898,     0,     0,     0,     0,  1937,  1622,  1639,  1911,     0,
    1900,     0,     0,  1623,  1646,     0,  1880,  1673,     0,  1678,
    1661,     0,  1654,     0,  1659,  1663,  1642,  1901,  1840,     0,
    1838,     0,     0,  1640,     0,  1635,  1633,  1634,  1627,  1628,
    1629,  1630,  1631,  1632,  1636,  1819,  1817,  1818,     0,     0,
       0,  1798,     0,     0,  1658,  2052,  2087,     0,  1418,  1418,
    1418,  1406,  1416,     0,  1529,  1910,     0,     0,     0,     0,
    1714,     0,  1845,  1427,  1843,  1927,  1916,     0,     0,  1618,
       0,  1513,  1894,     0,   788,   789,   787,  1295,  1279,  1275,
    1274,  1905,  1294,     0,  1405,     0,   951,   952,     0,   956,
       0,     0,  1447,  1469,     0,  1460,     0,  1451,  1452,  1443,
    1470,  1465,  1390,  1389,     0,  1532,     0,     0,  1340,  1333,
    1518,     0,  1475,  1360,  1362,  1363,     0,  1898,   978,     0,
    1561,   989,     0,   973,     0,   972,  1561,     0,   990,     0,
    1561,     0,     0,     0,  1137,  1064,  1113,   786,  1138,  1065,
    1114,  1139,  1066,  1241,     0,  1243,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
     669,  2059,   317,  1252,  1140,     0,  1067,   313,  1253,  1115,
    1257,   689,   688,     0,     0,  1116,     0,   563,     0,     0,
     568,   569,   570,     0,     0,     0,   571,     0,  1993,  2044,
       0,   576,   583,   588,   578,     0,   589,   584,     0,     0,
       0,     0,     0,     0,   595,   602,     0,     0,     0,     0,
       0,     0,  1003,  1004,  1141,  1070,     0,  1117,   962,     0,
    1071,   158,     0,     0,   256,   270,   604,   669,  1111,   289,
     302,   297,   298,   296,  2059,   317,  2059,   317,     0,     0,
       0,     0,   299,   294,   295,   291,   304,  1969,  2029,  2168,
       0,   608,   610,     0,   615,   307,  1085,   324,   323,   322,
       0,   311,     0,   329,   332,   308,   287,   290,   288,   284,
     268,     0,     0,     0,     0,     0,     0,     0,  1923,     0,
       0,  1034,     0,     0,     0,   147,  1099,   137,     0,     0,
     133,     0,     0,     0,     0,   127,     0,  1147,  1075,     0,
       0,   260,   509,   517,   522,  1079,   525,  1127,   523,  1153,
    1076,     0,  1109,     0,   252,     0,  1077,     0,  1121,  1149,
    1101,     0,     0,     0,     0,     0,     0,     0,     0,     0,
    1260,     0,     0,     0,     0,     0,   317,     0,     0,     0,
    1111,  2059,   317,  1148,     0,  1106,  1135,     0,   337,     0,
    1100,     0,     0,   262,  1081,  1129,     0,     0,   205,   204,
     206,     0,     0,     0,     0,     0,     0,     0,     0,   828,
     797,   827,     0,     0,     0,   791,   373,   346,   347,   349,
     356,     0,   717,     0,     0,  1543,  1539,     0,     0,     0,
       0,     0,     0,     0,     0,     0,  1559,   707,     0,     0,
       0,     0,  1239,  1239,  1239,  1239,  1239,  1239,  1239,  1220,
    1250,     0,   124,     0,     0,     0,   557,   597,   604,     0,
       0,     0,   402,   406,   410,   411,   412,     0,     0,     0,
       0,   138,   125,     0,   747,     0,   456,     0,   170,   163,
       0,     0,     0,   328,   704,   702,   701,   703,     0,     0,
       0,   722,   700,     0,  1533,  1535,     0,     0,     0,     0,
     501,   405,     0,   459,     0,     0,   491,     0,     0,     0,
     328,     0,     0,   967,     0,   985,   968,     0,     0,     0,
    1014,  1019,  1015,   995,     0,   534,  1377,  1378,     0,   317,
       0,     0,   599,   317,   317,     0,   317,     0,   317,   317,
       0,  1175,   625,     0,   677,     0,     0,   317,   760,  1842,
     880,   458,     0,     0,     0,     0,   891,     0,   532,   896,
       0,   908,   903,   905,     0,   912,  1356,  1347,  1351,  1350,
    1349,  1348,     0,     0,  1345,  1848,   759,     0,   506,     0,
       0,   317,     0,   913,     0,   838,   839,     0,     0,   848,
       0,     0,  1423,  1849,  1850,     0,     0,     0,     0,  1884,
       0,     0,  1752,     0,  1728,  1730,  1560,  1742,     0,  1573,
    1753,  1754,  1732,  1734,     0,  1832,     0,     0,  1743,  1682,
    1683,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,  1695,  1694,  1744,  1814,     0,     0,
    1871,  1872,  1745,  1603,  1604,  1604,     0,     0,  1878,     0,
       0,     0,  1750,  1755,     0,     0,     0,     0,  1761,     0,
    1782,     0,     0,     0,  1705,  1842,  1595,  1596,     0,     0,
       0,     0,     0,     0,     0,     0,  1679,  1662,  1656,     0,
    1660,  1664,     0,     0,     0,     0,  1648,  1674,  1644,     0,
       0,  1650,     0,  1675,     0,     0,     0,  1721,  1418,  1418,
    1418,  1418,  1415,     0,     0,     0,     0,  2155,     0,  1496,
    1474,  1476,  1483,  1496,  1501,  1723,  1527,  1724,     0,  1917,
       0,  1456,  1427,  1427,  1427,  1720,     0,     0,     0,  1426,
     181,     0,   214,   201,     0,  1277,  1920,     0,  1430,     0,
    1833,   956,   954,   955,  1432,     0,     0,  1467,  1440,  1342,
       0,  1340,  1335,     0,  1336,  1898,     0,  1332,  1367,     0,
       0,  1532,     0,  1366,     0,  1561,   970,   971,     0,   994,
       0,  1136,  1063,  1112,  1239,   923,   924,     0,   922,     0,
       0,     0,   444,   939,     0,     0,     0,   669,     0,     0,
     448,     0,  1255,     0,  1154,  1098,   565,   566,     0,   577,
       0,   586,   585,     0,     0,   573,     0,     0,     0,     0,
     572,   591,   538,   592,   594,     0,     0,   593,   596,   601,
    1109,     0,   632,  1087,     0,  1133,   997,     0,   965,     0,
       0,     0,     0,   418,   283,     0,     0,     0,   271,   281,
       0,     0,   286,     0,   279,   300,   292,   301,   293,   612,
     613,   611,   607,     0,   614,   616,     0,   326,     0,     0,
       0,  1143,     0,  1109,     0,   264,  1083,     0,  1131,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
    1144,  1118,     0,     0,   130,   129,     0,   136,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,   338,   319,     0,   725,     0,     0,     0,
     340,     0,     0,     0,     0,  1142,  1072,   792,     0,     0,
     793,   801,     0,     0,   794,     0,     0,   803,     0,     0,
     345,   353,  2111,  1822,  1823,   715,   720,   712,   714,   716,
     713,     0,   719,   669,     0,     0,     0,  1544,     0,  1612,
    1613,  1614,  1615,  1616,  1617,     0,  1611,  1618,   709,   710,
       0,  1239,  1238,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,   430,     0,     0,   424,     0,     0,
    1019,   417,   420,   421,     0,     0,   558,   561,   559,   560,
     590,     0,   437,     0,     0,   140,     0,     0,   141,   139,
       0,     0,   328,     0,   166,   401,     0,     0,   550,   650,
     653,   646,     0,   721,   723,   698,     0,   604,     0,     0,
    1327,   497,     0,   487,   483,   485,   484,   486,     0,   493,
     327,     0,   501,   493,     0,   940,   966,     0,     0,     0,
    1012,  1016,  1013,     0,     0,   981,     0,   996,   959,  1170,
    1171,  1168,  1169,     0,     0,  1369,  1031,     0,   317,  1029,
     763,     0,   754,     0,   756,  1033,   317,   317,   637,     0,
     547,     0,     0,     0,   890,   910,     0,   906,     0,     0,
     873,   915,  1354,  1352,   499,     0,   918,     0,   874,   917,
       0,     0,     0,     0,     0,  1853,  1579,     0,  1886,  1882,
       0,  1725,  1854,     0,  1866,  1865,  1681,  1867,     0,  1700,
       0,     0,  1692,  1690,  1691,  1684,  1685,  1686,  1687,  1688,
    1689,  1693,  1876,  1875,  1869,  1870,  1599,  1597,     0,  1747,
    1748,  1749,  1877,  1756,     0,  1984,  1783,  1760,  1776,  1775,
       0,     0,     0,  1763,     0,     0,  1772,     0,  1816,  1585,
    1618,  1624,     0,     0,  1647,  1881,  1665,     0,     0,     0,
    1643,     0,     0,     0,     0,  1652,  1832,     0,     0,     0,
       0,  1801,  1796,  1797,     0,     0,     0,     0,  1409,  1408,
    1414,  1496,  1501,     0,  1392,     0,  1483,     0,  1495,  1481,
    1494,     0,     0,  1507,  1505,     0,  1507,     0,  1507,     0,
    1478,     0,  1497,  1479,  1494,  1526,  1519,     0,  1918,  1528,
       0,  1458,     0,     0,     0,     0,  1846,     0,  1844,  1715,
       0,  1895,  1403,     0,  1431,  1448,  1441,  2009,  1530,  1341,
       0,     0,  1338,  1339,     0,     0,  1361,  1340,  1364,   991,
       0,     0,   983,     0,   929,   930,   928,   931,     0,     0,
       0,   669,     0,     0,   464,     0,   947,   947,     0,     0,
     450,   496,  1019,   672,     0,     0,     0,   670,   317,  1068,
       0,   587,     0,     0,   582,   580,   579,   581,   539,  1152,
    1069,     0,     0,     0,     0,   998,     0,     0,  1086,     0,
     415,     0,   276,  1110,     0,     0,     0,   275,     0,   317,
     317,   609,   325,   330,   331,   334,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,   748,   731,
       0,     0,   749,   750,     0,     0,     0,  1036,  1037,  1035,
     134,   131,   132,   135,  1096,  1080,  1128,     0,     0,  1078,
       0,  1122,  1093,  1089,     0,     0,     0,     0,     0,  1151,
    1105,  1126,  1150,  1103,  1124,  1102,  1123,  1104,  1125,  1097,
       0,  1537,   728,     0,     0,     0,   317,   317,   639,  1082,
    1130,     0,   795,     0,     0,   796,   798,   376,     0,   379,
     386,   357,   362,  1259,     0,  1259,     0,   359,   363,  1259,
     358,  1259,   355,   691,     0,     0,     0,  1540,  1545,  1620,
    1553,   668,     0,  1230,  1229,  1228,  1232,  1231,  1234,  1233,
    1225,  1224,  1237,  1236,  1223,  1222,  1227,  1226,     0,   422,
       0,   428,   432,   433,   431,   423,  1019,   456,   495,     0,
       0,   681,     0,   556,   403,   434,     0,   407,   143,   142,
       0,     0,     0,   170,     0,     0,   655,   659,   699,     0,
    1536,   633,   328,     0,   403,   501,     0,   408,   413,   414,
       0,   491,     0,   487,     0,     0,   498,  1217,   502,   503,
       0,     0,   969,   986,   987,     0,     0,  1019,  1018,     0,
     541,   317,   600,   317,   317,  1176,   678,     0,   902,   901,
     900,   533,     0,   904,   500,   317,     0,     0,     0,     0,
       0,   850,   829,   849,  1885,  1741,  1751,  1864,     0,     0,
    1701,     0,     0,  1746,  2263,     0,     0,     0,     0,  1780,
    1781,  1762,     0,  2102,  1767,     0,     0,     0,  1938,  1671,
    1669,  1666,     0,  1667,     0,     0,  1649,  1645,     0,  1651,
    1676,  1787,     0,  1803,  1800,  1413,  1412,  1411,  1410,  1482,
    1480,     0,  1485,  1492,     0,  1477,     0,  1506,  1502,     0,
    1503,     0,     0,  1504,     0,     0,  1492,     0,  1427,     0,
       0,  1792,  1718,  1719,  1716,  1427,  1935,  1618,     0,     0,
    1334,  1337,     0,  1368,  1359,   984,   992,  1245,     0,     0,
       0,   446,     0,  1019,     0,     0,     0,   950,   950,     0,
    1019,   495,   674,   673,   676,   671,   675,  1256,     0,   574,
     575,  1088,     0,  1134,  1094,     0,  1358,     0,   605,   272,
     273,   274,   277,   319,   285,   278,     0,     0,     0,  1084,
       0,  1132,  1091,  1145,  1073,  1119,     0,     0,   737,     0,
       0,     0,     0,  1146,  1074,  1120,     0,  1358,     0,     0,
       0,     0,  1265,     0,   318,   727,   726,   319,   339,  1107,
       0,   799,   800,   377,   124,     0,   354,     0,   384,     0,
     382,   381,   383,     0,   370,     0,     0,     0,     0,     0,
       0,  1541,     0,  1050,  1050,     0,   669,  1235,     0,     0,
     419,   495,   463,     0,   425,     0,     0,     0,     0,     0,
       0,     0,   604,     0,     0,     0,   165,   403,   604,   654,
       0,     0,     0,   724,     0,   405,     0,  1325,   404,     0,
       0,   493,     0,   491,     0,   488,     0,   492,     0,  1210,
       0,     0,  1017,     0,  1021,     0,   980,   957,  1529,     0,
     545,  1051,   755,   757,   638,   907,   914,   317,   830,   831,
     832,   833,  1696,     0,     0,     0,     0,  1757,     0,  1758,
    1785,  1784,  1764,  1768,     0,  1765,  1766,  1668,  1672,  1670,
    1653,  1789,     0,  1427,  1522,     0,  1525,  1484,     0,     0,
    1486,     0,     0,  1488,  1490,     0,     0,     0,     0,     0,
    1921,     0,  1455,  1457,     0,  1393,     0,   215,  1834,  1531,
    1365,   908,     0,   317,   947,   495,   465,  2111,   466,   946,
       0,   948,   953,   953,     0,   495,   669,   567,     0,     0,
     257,   603,     0,   321,   333,     0,  1358,     0,     0,     0,
     744,   732,     0,     0,   751,     0,   253,  1090,     0,     0,
       0,     0,     0,   317,   802,   356,     0,   380,   389,     0,
     387,   360,   365,     0,   369,   367,   366,   361,   364,  1050,
       0,  1047,  1046,   667,     0,   454,   426,     0,   474,     0,
       0,   682,     0,     0,     0,   443,   442,   439,   438,   440,
     441,   436,   435,   629,   741,   328,  1217,   617,   656,   657,
     652,     0,     0,     0,   487,   483,   409,   418,   392,     0,
     493,   489,   490,     0,     0,     0,  1267,     0,   941,  1020,
       0,     0,     0,   540,     0,     0,   544,   535,   875,  1697,
       0,  1698,     0,     0,     0,  1770,  1769,     0,  1806,  1527,
       0,     0,  1521,     0,  1493,  1509,     0,  1489,  1487,  1498,
       0,  1500,  1715,  1791,  1793,     0,  1717,   925,     0,   926,
     950,   469,     0,   949,   956,   956,   456,   669,   447,  1095,
       0,   606,     0,   280,     0,   265,  1092,     0,   735,     0,
     746,   744,     0,     0,     0,  1261,     0,  1262,  1263,  1266,
     341,   344,   375,   385,     0,   368,  1045,  1049,  1048,     0,
       0,   427,   460,   461,   462,     0,   429,   470,   471,     0,
     679,     0,   684,     0,     0,     0,     0,     0,  1211,     0,
       0,  1217,   491,   487,   416,   482,   390,     0,  1214,     0,
     328,     0,  1019,  1022,  1174,   543,   542,  1699,  1773,  1759,
    1786,  1771,  1802,     0,     0,     0,  1520,  1523,     0,  1491,
       0,  1499,     0,     0,     0,   953,     0,   669,     0,   944,
     943,   463,   449,  1358,   320,     0,     0,     0,   742,   745,
     733,   746,   753,   752,  1358,     0,   388,     0,   453,     0,
       0,     0,   472,     0,   473,   494,     0,   683,     0,   604,
     740,     0,     0,   658,     0,  1212,   493,   491,  1215,  1216,
     493,   942,   958,  1173,  1172,  1405,  2225,  2009,  2197,     0,
    1804,  1807,  1805,  1799,     0,  1508,  1794,  1795,   317,   956,
       0,   451,   467,   474,   258,  1358,     0,     0,   734,   254,
    1264,   659,   479,     0,   478,     0,   476,   475,   680,   685,
     630,   730,  1217,   662,   393,   493,  1529,  1156,  1405,  1155,
    1157,  1165,  1162,  1164,  1163,  1161,     0,  1811,  1810,  1809,
    1813,  1812,  1524,   927,   945,     0,   669,   266,   736,   743,
       0,   477,   481,   480,  1213,   664,     0,   660,   663,   665,
     666,   391,   932,     0,  1166,  1160,  1392,  1379,     0,   468,
     452,     0,   640,     0,  1158,  1405,  1808,     0,   661,  1159,
       0,   662,     0,   641
};

/* YYDEFGOTO[NTERM-NUM].  */
static const yytype_int16 yydefgoto[] =
{
      -1,    49,    50,    51,    52,  1225,  2169,  2041,  2851,  2852,
      53,    54,  1304,    55,    56,    57,    58,    59,    60,    61,
    1241,    62,    63,   901,  1456,  2179,    64,  1908,   700,   701,
     702,  1733,  1734,  2107,  1735,  1723,  1140,  1542,  1260,   675,
     676,  1227,  1261,    66,    67,  1134,  1714,    68,    69,    70,
    1287,  1288,  1235,  1495,  3751,  4353,  2681,  2019,  2888,  2682,
    2683,    71,  1354,  1355,    72,    73,  2799,  1394,  2134,  3320,
    3321,  3782,   530,  2131,  4054,  4055,  3768,  3769,  4061,  4239,
    4240,  2180,  1452,  2882,  3413,  2842,  3846,  2843,  3847,  2844,
    3848,  2830,  3371,  3372,  3373,  2845,  3825,  4271,  2846,  1923,
    4381,  2214,  1564,  1562,  4258,  3643,  3644,  4437,  4386,  4387,
    4388,  4516,  3853,  2886,  3419,  3856,  4084,  2580,   614,  1476,
    2958,   615,  2216,   561,   616,  2181,    79,  2208,  1324,  1325,
    2049,  3325,  2939,    80,   920,  3191,  4130,  4306,  4307,    81,
     208,    82,  1460,    83,    84,  2165,  2836,    85,  1940,  2597,
      86,    87,  2624,  2625,  2626,    88,    89,  3213,  4007,  1289,
    2670,  2671,  2672,  2673,  3234,    90,  1458,  1330,  2188,    91,
      92,    93,    94,    95,  2094,    96,    97,  2182,  1468,  2200,
    2201,  3837,  4100,  4280,  4102,  4556,  4557,  4076,  3170,  3657,
      99,   100,  3820,  3821,  4393,   101,  1938,   102,   103,   104,
    1436,  2157,  2158,  3326,  1396,  2137,  2138,  3402,  3403,   105,
    2759,   106,  3708,  3709,   562,  4396,  4360,  4450,   107,   108,
    3712,  3713,   109,   110,   111,   112,   113,   608,   966,   967,
    1217,   114,  1830,   115,   874,  2790,   116,  1031,  2338,  3892,
     117,   639,   980,   981,  2183,   119,   648,  2316,   650,  1577,
    2941,  2942,  3470,  2284,   785,   120,   121,  2295,  2319,   122,
    1228,  1914,  1915,  3638,  2184,   563,  1482,  2219,  2575,  4297,
    3645,  3987,  4202,  2509,  3124,   124,   564,  1265,  1983,  2222,
    2894,  1886,  1887,  1888,  3434,  1889,  2896,  1890,  1211,  1891,
    2901,  2902,  2903,  3430,  3438,  4124,  4125,   125,  1263,  1981,
     126,   127,   128,  1301,   810,   129,   576,   577,   130,  4251,
     131,   932,   132,   667,  1591,   133,   134,  1996,  3220,   135,
     136,   137,  4529,  4563,  4564,  4565,  3443,  4485,   138,  4531,
    1010,   140,   141,   142,   178,   840,   841,   842,  2185,  4119,
     144,   145,  2161,  2829,  3353,   146,   147,  1909,  2565,   148,
     149,   150,   151,  1440,   152,   153,   154,   155,  1373,   156,
    1169,  1170,   157,   158,   525,   718,  1173,  1181,   159,   618,
     974,   975,   976,  1544,   160,  1013,  2307,   619,   969,   162,
     620,  2528,  3133,  3134,  3137,   621,  2525,   165,  1583,  2301,
    2304,   622,  2532,  2533,  2534,  2535,  2536,  3139,   623,   641,
     923,  2227,   624,  1103,   170,   171,   172,   727,   722,   723,
     174,  1707,  2471,   656,  1188,   688,   735,  3109,  1843,  1844,
    1866,  1867,  1197,  1198,  1856,  1858,  2511,  1859,  2519,  1849,
    3601,  3961,  1862,  1863,  1200,  1201,  1202,  1871,   175,  2474,
    3090,  3091,  3092,  3578,  3579,  3593,  3589,  3948,  4173,  3093,
    1008,  1208,  3094,  4164,  4165,  4322,  3596,  3101,  3131,  2873,
    2874,  2875,  1892,  2144,  1421,  1104,  1422,  2155,  1105,  1627,
    1424,  1106,  1107,  1108,  1427,  1109,  1110,  1111,  1112,  1610,
    1669,  1113,  1114,  1646,  2152,  2153,  1533,  2378,  1116,  1117,
    1118,  3096,  1119,  3536,  3916,  3905,  2404,  2405,  1730,  3532,
    3036,  1703,  2461,  4185,  4333,  4334,  3077,  3562,  3933,  4163,
    4425,  4490,  4491,  1120,  2458,  1699,   812,  1121,  3328,  1701,
    2398,  2483,  2484,  1586,  1608,  2344,  2362,  2363,  2375,  2997,
    2382,  2387,  3020,  3021,  2399,  2427,  1122,  2347,  2348,  2980,
    1612,  1123,  1163,  1164,  1605,  2422,  1176,  1177,   720,  1124,
    1125,  1126,  1578,   711,  4169,   520,   775,  2697,  1821,   844,
     653,  1127,  1128,  1129,  1130,   941,   942,  1294,   521,   769,
     789,  2674,   522,   523,   771,  1826
};

/* YYPACT[STATE-NUM] -- Index in YYTABLE of the portion describing
   STATE-NUM.  */
#define YYPACT_NINF -3935
static const int yypact[] =
{
    5181,   -27, 10381, -3935, -3935,   -27, -3935, 54655,    -8,   601,
    1254,   138, 10254, 55072, 62995,   675,   281, 10655,   -27, 62995,
    1836, 40477, 51736, 62995,   906,   578, 40477, 62995, 63412,   792,
     900,  1022, 63829, 55489, 50485,  1295, 62995,   968,  1143, 64246,
   55906,   847, 56323,   578, 37576,    77,   778, 64663,  1291,  1239,
     846, -3935, -3935, -3935, -3935, -3935, -3935, -3935, -3935, -3935,
   -3935, -3935, -3935, -3935, -3935, -3935, -3935, -3935, -3935, -3935,
   -3935, -3935, -3935, -3935, -3935, -3935, -3935, -3935, -3935, -3935,
   -3935, -3935, -3935, -3935, -3935, -3935, -3935, -3935, -3935, -3935,
   -3935, -3935, -3935, -3935, -3935, -3935, -3935, -3935, -3935, -3935,
   -3935, -3935, -3935, -3935, -3935, -3935, -3935, -3935, -3935, -3935,
   -3935, -3935, -3935, -3935, -3935, -3935, -3935, -3935, -3935, -3935,
   -3935, -3935, -3935, -3935, -3935, -3935, -3935, -3935, -3935, -3935,
   -3935, -3935, -3935, -3935, -3935, -3935, -3935, -3935, -3935, -3935,
   -3935, -3935, -3935, -3935, -3935, -3935, -3935, -3935, -3935, -3935,
   -3935, -3935, -3935, -3935, -3935, -3935, -3935, -3935,    -8, -3935,
   -3935, -3935, -3935, -3935, -3935, -3935, -3935, -3935, -3935,   207,
   -3935,   111,   265,  1459,   364,   938, -3935, -3935, -3935, 46315,
   62995, 62995, 62995,  1128, 62995,  1028, 62995,   140, 46315, 46732,
   56740,  1177,  1062, 34153, -3935, 44230, 62995, 62995, 65080, 62995,
     772, 52987, 62995,  1181, 62995, 62995, 44647, 65497,  1324,  1335,
   -3935, -3935, -3935, -3935, -3935, -3935, -3935, -3935, -3935, -3935,
   -3935, -3935, -3935, -3935, -3935, -3935, -3935, -3935, -3935, -3935,
   -3935, -3935, -3935, -3935, -3935, -3935, -3935, -3935, -3935, -3935,
   -3935, -3935, -3935, -3935, -3935, -3935, -3935, -3935, -3935, -3935,
   -3935, -3935, -3935, -3935, -3935, -3935, -3935, -3935, -3935, -3935,
   -3935, -3935, -3935, -3935, -3935, -3935, -3935, -3935, -3935, -3935,
   -3935, -3935, -3935, -3935, -3935, -3935, -3935, -3935, -3935, -3935,
   -3935, -3935, -3935, -3935, -3935, -3935, -3935, -3935, -3935, -3935,
   -3935, -3935, -3935, -3935, -3935, -3935, -3935, -3935, -3935, -3935,
   -3935, -3935, -3935, -3935, -3935, -3935, -3935, -3935, -3935, -3935,
   -3935, -3935, -3935, -3935, -3935, -3935, -3935, -3935, -3935, -3935,
   -3935, -3935, -3935, -3935, -3935, -3935, -3935, -3935, -3935, -3935,
   -3935, -3935, -3935, -3935, -3935, -3935, -3935, -3935, -3935, -3935,
   -3935, -3935, -3935, -3935, -3935, -3935, -3935, -3935, -3935, -3935,
   -3935, -3935, -3935, -3935, -3935, -3935, -3935, -3935, -3935, -3935,
   -3935, -3935, -3935, -3935, -3935, -3935, -3935, -3935, -3935, -3935,
   -3935, -3935, -3935, -3935, -3935, -3935, -3935, -3935, -3935, -3935,
   -3935, -3935, -3935, -3935, -3935, -3935, -3935, -3935, -3935, -3935,
   -3935, -3935, -3935, -3935, -3935, -3935, -3935, -3935, -3935, -3935,
   -3935, -3935, -3935, -3935, -3935, -3935, -3935, -3935, -3935, -3935,
   -3935, -3935, -3935, -3935, -3935, -3935, -3935, -3935, -3935, -3935,
   -3935, -3935, -3935, -3935, -3935, -3935, -3935, -3935, -3935, -3935,
   -3935, -3935, -3935, -3935, -3935, -3935, -3935, -3935, -3935, -3935,
   -3935, -3935, -3935, -3935, -3935, -3935, -3935, -3935, -3935, -3935,
   -3935, -3935, -3935, -3935, -3935, -3935, -3935, -3935, -3935, -3935,
   -3935, -3935, -3935, -3935, -3935, -3935, -3935, -3935, -3935, -3935,
   -3935, -3935, -3935, -3935, -3935, -3935, -3935, -3935, -3935, -3935,
   -3935, -3935, -3935, -3935, -3935, -3935, -3935, -3935, -3935, -3935,
   -3935, -3935, -3935, -3935, -3935, -3935, -3935, -3935, -3935, -3935,
   -3935, -3935, -3935, -3935, -3935, -3935, -3935, -3935, -3935, -3935,
   -3935, -3935, -3935, -3935, -3935, -3935, -3935, -3935, -3935, -3935,
   -3935, -3935, -3935, -3935, -3935, 62995,  9986,   906, -3935, -3935,
   62995,  1191, 46315, 62995,  1104, 62995,  1234, 62995, -3935, 62995,
    1265, 65914,   198,  1597, 46732,  1698, 34584,  1432, 46732, 66331,
   62995, 62995, -3935, -3935,  1441, 62995, 62995, -3935,  1576, 47149,
    1532,  1600,  1785,  1746,   728, -3935, 57157, -3935, -3935, -3935,
   -3935, -3935, -3935, -3935, -3935, 45064,   281, -3935, -3935, 47566,
   62995,  1767, -3935, -3935, 66748, -3935,  1523, -3935,   343, 47983,
   48400,  1888,  1579, 35015,  1948, 48817, 67165, -3935, -3935, 67582,
   -3935, 67999,  1684, 68416, -3935, 49234, -3935,  1861, 68833, -3935,
    1582,  1732,   676, 30754, -3935, -3935, -3935,    -8, -3935, -3935,
   -3935, -3935, -3935, -3935, -3935, -3935,   285,  1604,   266,   188,
     271, -3935, -3935,   191,   203,   216,   285,  2056,  2056, -3935,
   62995, -3935, -3935,  1604,    38,  1652,  1652,  1652,  1839,   -44,
   -3935,  1652, -3935, -3935, -3935, -3935, 56323, -3935,  1658,   906,
    1692,  2088,  1751, 62995, -3935, 62995, -3935, 62995, 62995, -3935,
   -3935,  2125,  1754,  1982,  1731, -3935, -3935, -3935,  1929,  1956,
    1944,   302,   906,  1890, -3935,  2079, -3935,  2011, 21278,   906,
   57574, 69250,   247, 45064,   906, 57991,  1871,  1283,  2001, -3935,
   -3935, -3935,   669, -3935,  2255,  1876,  2130,  1731,  1335, 32026,
   -3935,  1891,  1550, 56323, -3935, -3935, -3935,   299,  2182, 21713,
   -3935, 62995,  1904, -3935,  1920,  1934,  1943,  1459, -3935,  5181,
   62995,  1300,  1300,  2346,  1300,  1504,  1711, -3935,  1109, -3935,
    2257,  2210, 56323,   778,   193, -3935, -3935, -3935, -3935, -3935,
   -3935, -3935, -3935, -3935, -3935, -3935, -3935, -3935, -3935, -3935,
   -3935, -3935, -3935, -3935, -3935, -3935, -3935,  1980,  1550, -3935,
     230, -3935,  1534,  1972,  1702,  1159, -3935, -3935,   201, 62995,
    2095,   192,   664,  2030, 58408,  3845,  2063, -3935,   328, -3935,
   -3935, -3935, -3935,  2279,  2348,  4546,   295, 58825, -3935, 62995,
   62995, -3935, -3935, -3935, -3935, -3935, -3935, -3935, -3935, -3935,
    2064, -3935, -3935,  2050,  2321,  1225,  2251,  1365,  2374,  9659,
    1220, 59242, 62995,  2341,  2384,  6458,  1614,   978,  2270,   814,
    2321,  2381,  1322,  2395,  7017, 62995, -3935,  2323,  2431,   587,
   -3935,   297, -3935,  2178,  2310,   648, 46315,  2126, -3935, -3935,
   62995, -3935, -3935, -3935,  2205, -3935,   424, 46315, -3935,  2325,
    2203, 35446, -3935, 62995, -3935, -3935, -3935, -3935, -3935,  2281,
   62995, -3935, -3935,  2406, 62995, -3935,  1652,  2326,  2172,  2551,
   77963,    76, 62995,  2212,  2582, 62995,  2378,  2212,  2211, 69667,
   -3935, -3935,  2212, -3935, -3935, 62995, 62995,  2181,  1202,  2212,
    2383,  2583,  2584,  2252,  2361,  1135,   878,   148,  2481,  2212,
    2237, 62995, 70084, 62995,  2239, 62995,  2560, 46315, 62995, -3935,
    2354, -3935, -3935,  1078, -3935, -3935, -3935, -3935,  2501,  1980,
     729,  2502,  2202,  2504, -3935, -3935,  2241, -3935,  2508,  2063,
    2511, -3935,  2207, 70501, -3935, 70918, 71335,  2515,  2064, 46732,
    2517,  2207,  2520,  2407,  2523,   729,  2525, -3935,  1183,  2526,
    2413,  2529,  1616,  2207, 45481,  2530,   150, -3935, 23453, -3935,
    2317, -3935,   778, -3935,   428, -3935, 40060, -3935,   676,  1604,
   -3935, 62995,  1604, 62995,  1604, 62995,  1604, 62995,  1604, 62995,
   62995, 62995,  1604, -3935, -3935, -3935, 62995,  2231, 62995, 62995,
   -3935, -3935, -3935, 52153, 46732, 52570, -3935, -3935,   100,   906,
   -3935, -3935, 77963,  2637, 46732,  2560,  2521,  2521,  2521, -3935,
   -3935, -3935,  2461, 62995,  2527,  2531, 52153, 46732, -3935, 71752,
   45064,  2422,  2243, -3935, -3935, -3935, -3935, -3935,  1681,  2669,
     284,  2680, 23453,  2250,   173,   173,  2253,  2541, -3935, -3935,
   -3935,   243,  2256,  2258, -3935,   244,   244,  2417,  2259,  2260,
   -3935,   250,  2261,  2695,  2701,   252,  2271,  2276,  2283,  1790,
     173, 23453, -3935,  2284,   244,  2285,  2288,  2289,  2713,  2290,
   -3935,  2723,  2306,   180,   196,  2307,  2308, -3935,  2259, -3935,
     239,  2311,  2313,  2314,  2315,  2316,  2318,  2319,  2322, 23453,
   23453, -3935, 20408,  1550,   906, -3935, -3935, -3935, -3935, -3935,
   -3935, -3935,   164, -3935,   253,  4916, -3935,  2344, -3935, -3935,
    2492, 23453, -3935, -3935,  2566,  2327, -3935,   255, -3935, -3935,
   -3935,  1550, -3935, -3935,   222,  2329, -3935,  1720, -3935, -3935,
   -3935, -3935, -3935, -3935, 42979,  2731, -3935,   832,   906,   297,
    1096,  2677, 39226, 39643, -3935, -3935,  2556, -3935, 62995, -3935,
   -3935, 23453, 37159, -3935,  1550,   133, -3935, -3935, -3935,  1383,
   -3935, -3935, -3935,    -8, -3935,  9382, -3935,  1397,  1904, 62995,
   62995,  2735, -3935, -3935, -3935,  1920, -3935, -3935,  1459,  1459,
   23453,  1459,  1031,  1598, 22148, 23453,  2624,  2524,  1256,   973,
    2628, -3935,  2532,  1504,  1711, 56323, 62995, 72169,  2450, -3935,
   37993,  1707,  1550,  2420,  2421,  2467, 41311,  2347,  2423,  2425,
    2472,  2428,  2429, 72586, -3935, -3935, -3935, -3935,  1204,   892,
    1158,  2430,   366,   774,  2716, -3935,  1167,  2479, -3935, -3935,
   -3935,  5335, 62995,  2662,  8207,  2554,   295,  2487, -3935, -3935,
    2601,  2453,  2454,  2568,   295,   913, 73003, -3935, -3935, -3935,
   -3935, -3935, -3935,  3310, 19161, -3935,  2455,  2436,  2466, 62995,
   49651,  1608,  2569,  1297,  1609,   733, 62995,  2641,  2574, 62995,
    2385,  2464,  2468,  2660,  2392,  1230,  2753,  2391, -3935, -3935,
   -3935,  1718,  1816,  2570, -3935,  2663,  2703,  8252,  2459,  2463,
   77151,    72, 35877,  2739,  1416,  2486, -3935,  1416, 62995,  2488,
    2489, 62995,   295, -3935,  2802,   295,   295,  1425,  2803,  2494,
     402,  1672,  2212,  2391,  2046, -3935,  2495,  2496,   273, -3935,
    2602, -3935, -3935,  1285,  2506, 56323,   399,  1881,  2391,  2499,
    2500,  2392,  2392, 62995, 62995, 62995, 62995, 62995,   186,  2824,
    2825,  2505,   232,  2549,  2426, -3935,  1416, 43396,  2513, -3935,
    1416, 62995,  2514,  2004,  2391,  1389,    60, -3935, -3935, -3935,
    1335, -3935, 62995, -3935, 62995,  1980, 77963,  2615, -3935,  2471,
   -3935,  2063,   295, -3935, 62995, 62995,  2064,  1171,  1210,  2620,
   62995,  2674,  2482, -3935,   220, 38401, -3935,  2181,  2447, -3935,
   -3935,  2503, -3935,  2503,  2503,  2448,  2448,  2449, -3935, -3935,
   -3935,  1790,  2503,  2448, -3935, 78775, -3935,  1481,  1521, -3935,
    2860,  2862, -3935, -3935, -3935, -3935, -3935, -3935, -3935, -3935,
   -3935,   115,  1740, -3935, 62995, 41311, -3935,  2875, -3935, -3935,
   77963,  2645,  2761, -3935, 62995,  2661,  2462, -3935,  2797,  2522,
   -3935, -3935,   549, -3935,  2767, 46732,   279,   906,  2512, 62995,
    2688, 62995, 62995, 62995, 62995, -3935, -3935,  2666,   865,   304,
   -3935, 43396, -3935, 62995,  2046,  2673,  2883,    40,  1652, 62995,
    2776, -3935, 62995,  2497,  2893,  2726, -3935,  1867, -3935,  2619,
   -3935, 46315,   729, -3935, -3935, -3935, -3935, 77963, 62995, 73420,
   46315,   729, 46732, 46732,  2801,   150,  2804,  2559,  2806,  2562,
   35877,   729,   168, 46732, 62995, 62995, 62995, -3935, 62995, -3935,
   -3935, -3935, -3935, 62995, 62995, 46732, 43396,  2809,  2810,   729,
   62995, 62995, -3935,  9382,  1653, 62995,   676, 43813, -3935, -3935,
   -3935, -3935, -3935, -3935, -3935, -3935, 62995, -3935, 62995, -3935,
   62995, -3935, 62995, -3935, 62995, -3935, -3935, -3935, 62995, -3935,
   62995,  1657, -3935, -3935,  1695,   176, 62995, 62995,   701, 46315,
   62995,  2692, 62995, 62995, 62995, 62995, 62995,  2589,  2329,   -61,
   -3935,   817, 56323,  2710, -3935, -3935,  1700,  1291,   -15, 62995,
   -3935, -3935, -3935, -3935, -3935, -3935, 52570, 51736,  2799,   306,
   62995, -3935, -3935,  2367, 23453,  1550, 20843, -3935, -3935, -3935,
    2516,  9382,  2557, 23453, -3935, -3935, 23453,  2518,  2056,  2056,
   23453, -3935, -3935, -3935, -3935,   763,  2056, -3935, 23453, 23453,
    2056,  2056,  2503,  2503, -3935,  4086, 23453, -3935, 35877, 23453,
   26063, 18309, 23453,  2598,  2538,  2056, -3935,  2056, -3935, 23453,
   19973, -3935, 23453,  2729, 26927, 23453,  1096,  2732, 23453,  1096,
    2949,  2949,  1139,  4580,  2533,  1550, -3935,  2635,  2056, -3935,
    2056,   204, -3935,   245, 77963, 23453, 41311,  2605,   190, 62995,
   23453,  2534,  1589, -3935, 23453,   898, -3935,  2535, 23453,  2607,
   23453, 23453, 23453, 23453, 23453, 23453, 23453, 23453, 23453, -3935,
   27775,   373,  2807,  2826,     9,  1673, 59659,  2820, 21278, 17873,
   -3935,   200, -3935, -3935, -3935, 62995,  2731, -3935, -3935,  2613,
   -3935, -3935, -3935, -3935, -3935,   259, -3935, -3935, -3935, -3935,
   -3935, -3935, -3935,  2536, -3935, -3935, -3935, -3935,  2536, -3935,
    2540,  3877, -3935, -3935, -3935, -3935, -3935, -3935, -3935, -3935,
   -3935, -3935, -3935, -3935, -3935, -3935, -3935, -3935, -3935, -3935,
   -3935, -3935, -3935, -3935, -3935, -3935, -3935, -3935, -3935, -3935,
   -3935, -3935, -3935, -3935, -3935, -3935, -3935, -3935, -3935, -3935,
   -3935, -3935, -3935, -3935, -3935, -3935, -3935, -3935, -3935, -3935,
   -3935, -3935, -3935, -3935, -3935, -3935, -3935, -3935, -3935, -3935,
   -3935, -3935, -3935, -3935, -3935, -3935, -3935, -3935, -3935, -3935,
   -3935, -3935, -3935, -3935, -3935, -3935, -3935, -3935, -3935, -3935,
   -3935, -3935, -3935, -3935, -3935, -3935, -3935, -3935,  2812,  2813,
     729, 62995,   299, 53404, -3935, 21713, -3935,  1728, -3935,  2546,
   -3935,  2794, -3935,  2544, -3935,  7979,  2794, -3935, -3935,   325,
    2658,  2790,  2737, -3935, -3935, -3935,  2550,  9382, -3935,  1569,
    9382,  1586, -3935, -3935, -3935, -3935, -3935, -3935,  1252, -3935,
   62995,  2710,  2624,   973,  2608,   132, 62995, -3935, 32450,  2736,
   -3935,  2945, -3935, 78775, -3935,  2558, -3935, 78369, 75922, -3935,
   -3935,   912, -3935,   996,  2638,  2639,  2685, 46732, 62995, 62995,
   -3935, 41311, 46732, 62995, 62995, 46732, 62995, 62995, -3935,  2925,
      24, 51736,  2687, 50902, -3935, -3935,  2567, 62995,  2621,  2811,
    2814,   469, -3935, -3935, 73837, -3935,  2763, 46732, 62995, 62995,
   23453,  2765, 62995, 62995, -3935,   215,  2648,  2650, -3935, 62995,
    2653, 46315,  2578, 62995, 62995, 62995,  2652,   615, 46315,  2623,
   36308, 62995, 62995, 62995, 62995,  2702, 62995, 62995,  2821,   939,
   56323,   178,  2017,  2391,  2778, -3935,  1253, -3935, 46732, 62995,
    2771, -3935, -3935, -3935, 60076,  2984,  2691, -3935, -3935, 74254,
   -3935, -3935, -3935,  1734, -3935, 46732, 46732, 62995,  8702, 62995,
    1045, -3935, -3935, 77963, -3935, 62995, 62995, 62995, 62995, 53821,
   74671, 75088,  1361,  1369, 62995, 54238, -3935, 62995, -3935, -3935,
   41728, 46732, 62995,   750, 41311, -3935, 62995,  2777,   735, -3935,
   62995,  5360, -3935, -3935,  2668,  2681, 62995,   184,  2075,  2391,
   62995, 62995,  2588,  1759,  2675,  2719, -3935, 62995, 69250, -3935,
   46732,   767, -3935,  2741, 46732, 62995, 10604, -3935, -3935,   295,
   -3935, -3935, -3935, -3935, -3935, 62995, 62995,   295, 62995,   295,
    1151, -3935, 46732, 62995, -3935, -3935, -3935, 62995,  8741, 62995,
   62995, 62995, 62995, 46732, 62995, -3935, -3935,   914,  1037,  1348,
    1385,  2742, 62995,  2869, 62995, 75505, 46732, 62995, 62995, 62995,
    1445, -3935, -3935, -3935,  2720, -3935, 46732,   767, -3935,  9351,
   62995, 62995,  2693,  2694,   131,  2764, -3935, -3935, -3935, -3935,
   -3935, -3935,  2863,  3024, 62995, -3935,  2865,  2867,  2682,  2684,
    2868,   465, 62995, -3935, -3935, -3935, -3935, 62995,  2874,   465,
    2829,   129, -3935, -3935,  2212, -3935,  2646,  1765, -3935, -3935,
   23453,  3040, 77963,  2640,  2649,  2721,  2727,  2738, -3935,  2664,
    2740,  2056, -3935, -3935,  1780, -3935, -3935,  1793, -3935,  2665,
     865,  1625, -3935, 41311, 62995,   656,   698,  2940, 50068,   766,
    2951, 62995,  2708, 62995,   766, 62995, -3935,  1865, 51736, -3935,
   -3935, -3935, -3935, -3935, -3935, -3935, -3935, -3935,  2947, -3935,
     906,  2181,  2181,  2181,  2181, -3935, -3935, -3935, -3935,  2856,
    1621, -3935,  2667,  2181, 62995,  2781,   766,  2670, -3935,  2046,
    2970,   805, 62995, 50068,  1903,  2709,  3077,  1652,   906,  2864,
   -3935, 19567,  4627,  2866, 45064,  2946,  2948,  2966, -3935,  1980,
   -3935,  3084, -3935,  2982,   729,  2063, -3935,  2207, -3935, 62995,
   -3935, 62995, 62995, 62995, 62995,  2064, -3935, -3935,  2207,  2870,
     729,   729, -3935,  2871,   729,  2207,  2796,  2975, 45064, -3935,
     150, -3935, -3935, 23453,  1652, -3935, -3935, -3935, -3935, -3935,
   -3935, -3935, -3935,  1797, -3935, 62995, -3935,  2953,  2956,  2957,
    2683,  2690,  2734, 62995,  2700, -3935,  2683,   295,  2683,  2329,
    2329,  2683,  2690, 45898,  3113,  2983,   680,   714, -3935,   815,
      10,  2918, -3935, -3935, -3935, -3935, 77963, -3935, -3935, -3935,
   -3935, -3935, 62995,  2744,   309,  2900,  2712, 45898,  3105,   729,
   -3935, 46315, -3935, -3935, -3935,  2791,  2808, 46315,  2910,  2768,
   -3935, -3935, -3935, -3935, -3935, -3935, -3935,  2959, 62995,  1803,
   -3935, -3935,  1552, -3935,  1642, 23453, 23453,   139, -3935,  8349,
    1804, 23453,  2725,  2728,  1811, -3935, -3935, -3935, -3935, -3935,
   -3935, -3935,  2733,  3004, -3935,  2743,  1813,  1818,  2745,  2746,
   -3935, -3935,  2371,  2747,  8412,  2748, 26063, 26063,   531, -3935,
   -3935, 26063,  2749, -3935,  1819,  8142,  2724,  2750,  2754, -3935,
    2751,  2752,  8623, 22583, 23453, 22583, 22583,  8733,  2724,  2755,
    1825, 41311,  2892,  8864,  1826, -3935, 23453, 41311,  4225, 23453,
   -3935, 23453, 62995,  2756,  2757, -3935, -3935,  4086, -3935,  2758,
   -3935, 26063, 26063, -3935,  4547, 20408, -3935, -3935,  3011, -3935,
   -3935,  1555, -3935,  2759, -3935, -3935,  6459,   264, 23453,  2534,
   23453,  2815, 35877,  6740, 23453,  2939,  3930,  3930,   493,   493,
     240,   240,   240,  1862,  1673, -3935, -3935, -3935,  2760,  2762,
    2766,  2913,  2290, 23453, -3935,  1991,  2032, 62995,  2442,  2769,
    3396, -3935, -3935, 29058,  2780, -3935, 23453, 23453, 23453,  2772,
   -3935,  3169,  9382,    61, -3935,  3178, -3935,  1335,  2056,   204,
   40060, -3935, -3935, 23453, -3935, -3935, -3935,  1920, -3935, -3935,
   -3935, -3935, -3935, 62995,  1291, 23453, -3935, -3935,   484,   -49,
   23453,  1569, -3935, -3935,  2818, -3935, 23453, -3935, -3935, -3935,
    2329, -3935, -3935, -3935, 29058,  2817,  2828, 31602,  2896, -3935,
   -3935, 62995,   314, -3935, -3935, -3935,  2782, -3935, -3935, 75922,
    1740, -3935, 78369, -3935, 78369, -3935,  1740,  3153, -3935, 75922,
    1649, 46732, 62995, 62995, -3935, -3935, -3935, -3935, -3935, -3935,
   -3935, -3935, -3935, -3935,  2993, -3935, 46732, 46732,  2961, 62995,
    2963,  2962, 23453,   928, 62995,  2783,  2784,  1069,  3042, 62995,
   -3935,  3086,   729, -3935, -3935,  2872, -3935,  9382, -3935, -3935,
   -3935, -3935, -3935, 46732, 62995, -3935, 45064, -3935,  1980, 77963,
   -3935, -3935, -3935, 62995,  2819, 62995, -3935, 62995, 62995, 62995,
    2064, -3935, -3935, -3935, -3935,  1273, -3935, -3935, 62995, 62995,
     114,  2873,  2876, 62995, -3935,   687,  2602,  9857, 62995, 62995,
   62995,  3039, -3935, -3935, -3935, -3935,  2985, -3935, -3935, 75922,
   -3935,  2207,    64,  2878,  2391, -3935,  2971, -3935,   897, -3935,
   -3935, -3935, -3935, -3935,  3089,   729,  3092,   729, 62995, 62995,
   62995, 62995, -3935, -3935, -3935, -3935, -3935, 41311, 41311, 41311,
    1834, -3935, -3935,   906, -3935, -3935, -3935, -3935, -3935, -3935,
    3055, -3935,  1845, -3935,   -58, -3935, -3935, -3935, -3935, -3935,
   -3935, 46732, 62995,  9902, 62995, 62995, 62995,  1725, -3935,   797,
   77963, -3935, 77557, 46732, 62995, -3935, -3935, -3935,  3022,  2965,
   -3935,   777,  2969, 46732,  2861, -3935,  2882, -3935, -3935,  2884,
    2122,  2391,  2046, -3935, -3935, -3935, -3935, -3935, -3935, -3935,
   -3935,   607,   194,  2135,  2391,  2885, -3935,  2886, -3935, -3935,
   -3935,  3027,  3028,  3029,  2891,  2894,  2937,  2895,  2897,  2944,
   -3935,  2901,  2950,  2902,  2952,  2909,   729, 77963,  3023,   906,
    2954,  3135,   729, -3935,  2914, -3935, -3935,  3235, -3935, 62995,
   -3935,  2915,  2140,  2391, -3935, -3935, 46732, 62995, -3935, -3935,
   -3935,   465, 77963,  3082,   465,   465, 62995, 62995,   465, -3935,
   -3935, -3935,  3085,  3088,   465, -3935, -3935, -3935, -3935,  2326,
    2841, 33722, -3935,  3277,  5542,  2848,  2649,  2847,  2056,   224,
    1088,   112,  2968,  2056,  3062,  2854, -3935, -3935, 41311, 33722,
    1719,  3081,  2887,  2887,  2887,  2887,  2887,  2887,  2887, -3935,
    1558,   313,  2212, 45064, 62995, 45064, -3935,   698,  2971, 62995,
   62995,  2857,  2853, -3935, -3935, -3935, -3935, 46732,   776, 46732,
    2056, -3935, -3935,  2927, -3935, 62995,  1652,  3258,  2584,   279,
    3000,  1670,  3205,  2709, -3935, -3935, -3935, -3935, 62995, 62995,
     865,   906, -3935,  2877,  2888, -3935, 62995, 62995, 62995, 62995,
    2744,  2879,  2880, 77963,    34,  3057,  3058,  2392,  3280,  1291,
    2709,  2964, 62995, -3935,  1851,    86, -3935,   906, 45064, 76328,
   -3935,  3497, -3935, -3935,   875,  3151, -3935, -3935,  1291,   729,
   77963, 62995, -3935,   729,   150,  2932,   729,  2935,   729,   729,
   62995, -3935, -3935, 62995, -3935, 62995, 43396,   729, -3935,  9382,
   -3935, -3935,  3010,  3012,  3013, 62995,  2683, 46315, -3935,  2889,
   46732,   456, -3935, -3935,  3065, -3935, -3935, -3935, -3935, -3935,
   -3935, -3935,  3192,  3197, -3935, -3935, -3935,   212, -3935, 46732,
   52153,   175, 46732, -3935,  1980, -3935, -3935,  2063,   295, -3935,
   62995,  3138, -3935, -3935, -3935,  2898,  1858,  9007, 23453, -3935,
    3207, 77963, -3935,  5615, -3935, -3935, -3935, -3935, 23453, -3935,
   -3935, -3935, -3935, -3935, 23453, -3935, 23453,  3182, -3935,  3325,
    3325, 77963, 26063,  1193,  2285, 26063, 26063, 26063, 26063, 26063,
   26063, 26063, 26063, 26063, 28210,  1116, -3935, -3935, 23453, 23453,
    3189,  3182, -3935, -3935,  1405,  1405, 77963,  2903,  2724,  2912,
    2916, 23453, -3935, -3935,  1864, 27351,  2917, 41311, -3935, 23453,
    8263,  1875,  2960,  9171,  1550,  5684, -3935,  3279,   906, 23453,
    2038,  2617, 23453,  1887, 23453,  3186, -3935, -3935, -3935,  2919,
   -3935, -3935, 77963, 23453, 26063, 26063,  6663, -3935,  7204, 23453,
    2920,  9418, 20408, -3935,  3083,  2977, 32874, -3935,   578,   578,
     578,   578, -3935, 62995, 62995, 62995, 29482,  3194, 28634, 60493,
    2911,  1771, -3935, 60493, 60910, -3935,  2929, -3935,  2936,  1550,
   23453,  3196,    66,    66,  3083, -3935, 23453, 23018,  2924, -3935,
     297,  2928, -3935, -3935,  7815, -3935, -3935,  2938, -3935,  2942,
   -3935,   -49, -3935, -3935, -3935,  5750,  3125, -3935, -3935,  2911,
   23888,  2896, -3935,  1889, -3935, -3935, 21278, -3935, -3935,  1895,
   32450,  2817, 21713,  1550,  1897,  1675, -3935, -3935, 75922, -3935,
    3016, -3935, -3935, -3935,  2887,  2207,  2207,  1145,  2683,  3232,
    1145,  5883, -3935, -3935, 29906, 62995, 62995, -3935, 62995,  1902,
    1262, 62995, -3935, 62995, -3935, -3935, -3935, -3935,  3349, -3935,
   62995, -3935, -3935,  3015,  3017, -3935, 62995, 62995, 62995, 62995,
   -3935, -3935,  1972, -3935, -3935, 46732, 62995, -3935, -3935, -3935,
     227,  2240,  2391, -3935,  3032, -3935, -3935,  3210, -3935,  3346,
    3046, 62995,  2967, -3935,  1262,   955,  2392,   118, -3935, -3935,
    3031, 62995, -3935, 62995, -3935, -3935, -3935, -3935, -3935, -3935,
   -3935, -3935, -3935, 41728, -3935, -3935, 62995, -3935, 41311, 33722,
   41311, -3935,  1111,   341,  2249,  2391, -3935,  3041, -3935,  3043,
    3047,  3087,  1013,   981,  3048,  3050,  3091,  2978,  2979,  2980,
   -3935, -3935,   285,   906, -3935, -3935,   906,  2207,   906, 62995,
   62995, 62995,  3366,  3067, 62995, 62995, 62995, 62995, 62995,  3272,
     686,  1723, 46732, 62995, 62995, 46732, 62995, 62995, 62995, 62995,
   62995, 62995, 62995, -3935,  3356,  3289,  1742,  3329,  3059, 62995,
   -3935, 62995,  2602, 62995, 62995, -3935, -3935, -3935,  2989,   465,
   -3935, -3935,  3236,  3237, -3935,   465,   465, -3935,   220, 41311,
   -3935,  2136,  2942,  1718,  1816, -3935, -3935, -3935, -3935, -3935,
   -3935,  2646, -3935, -3935,  2056,  1967,  2996, -3935,  2997, -3935,
   -3935, -3935, -3935, -3935, -3935,  2998, -3935,   204, -3935, -3935,
   62995,  2887, -3935,  1373,   292,   310,  1011, 61327, 61744, 62161,
    3001, 62995, 62995, 26063, -3935,  1338,   844, -3935,  3239, 62995,
    3033, -3935, -3935, -3935,  3158, 62995, -3935, -3935, -3935, -3935,
   -3935,  3005, -3935,  3119, 50068,  2207, 46732, 46732,  2207, -3935,
   77963,  3007,  2709, 46732,   279,  1287, 70084,  3051, -3935,  3019,
    3297, -3935,  3008,  3021, -3935, -3935, 62995,  2971,  1912,    43,
    1582, -3935, 51319,  1903,  3287, -3935, -3935, -3935,  3398,  3120,
   -3935,  1291,  2744,  3120,   906,  2621, -3935, 75922, 23453, 23453,
   -3935,  3030, -3935,  3036,  5926, -3935,  2181, -3935, -3935, -3935,
   -3935, -3935, -3935,  3115, 62995, -3935, -3935,  3038,   729, -3935,
   -3935, 62995, -3935, 62995, -3935, -3935,   729,   729, -3935,  3154,
   -3935, 62995, 62995, 62995,  2683, -3935,   295, -3935,  3319, 45898,
   -3935, -3935, -3935, -3935, -3935,  3382,   306,  3330, -3935, -3935,
    3288,  3290,  3291,  3292,   821, -3935, -3935, 23453,  9382, -3935,
    3052, -3935,  9382,  6231,  9382,  3189, -3935,  2309,  3335, -3935,
    1337,  3056,  2309,  1176,  1176,   375,   375,   171,   171,   171,
    3325,  1116,  9382,  9382, -3935, -3935, -3935, -3935,  3054, -3935,
   -3935, -3935,  2724, -3935, 24323,  3202,  3440, -3935, -3935, -3935,
    3096,  3098,  3060, -3935, 23453, 24758,  3061, 78775, -3935, -3935,
     204,  1391, 26063, 26063,  2120, -3935,   788, 23453, 77963,  1917,
    2120,  2958,  3293, 23453, 23453,  9436,   400, 23453,  6630,  3063,
   23453, 76734, -3935, -3935, 62995, 62995, 62995, 62995, -3935, -3935,
   -3935, 60493, 60910,  3068, 18736,  1771,  3066, 62995, -3935, -3935,
    3069, 29058,  3302,  3240, -3935, 29058,  3240,   170,  3240,  3313,
   -3935, 33298, -3935, -3935,  3070, -3935, -3935, 17873,  1709,  9382,
    3462,  3350, 23453,  3074,  3078,  3080,  9382, 23453, -3935,   906,
     906, -3935, -3935, 35877, -3935, -3935, -3935,  3268,  9382, -3935,
    1291, 62995,  1550,  2327,  3095, 62995, -3935,  2896, -3935, -3935,
    3152,  1923, -3935,   285, -3935, -3935, -3935, -3935,  3160, 51736,
    3370, -3935, 23453,  1924, -3935,  3123,  3458,   154,  1925,  1939,
    1262, -3935,  3033, -3935,  1490,  3348,   221, -3935,   729, -3935,
   77963, -3935, 62995, 62995, -3935, -3935, -3935, -3935,  2347, -3935,
   -3935, 62995, 62995, 62995, 62995, -3935, 46732, 62995, -3935, 41311,
    1558,  3286, -3935, -3935,  3294,   285, 62995, -3935, 77963,   729,
     729, -3935, -3935, -3935, -3935,  3106,  3482,  3180, 62995, 62995,
   62995, 62995, 46732, 62995, 62995,  2056,  2056, 77963,  3093, -3935,
    2056,  2056,  3094, -3935, 46732, 62995, 62995, -3935, -3935, -3935,
   -3935, -3935, -3935, -3935, -3935, -3935, -3935, 46732, 62995, -3935,
    3173, -3935, -3935, -3935, 62995, 62995, 62995, 62995,  3401, -3935,
   -3935, -3935, -3935, -3935, -3935, -3935, -3935, -3935, -3935, -3935,
   62995, -3935, -3935,   906,   906, 77963,   729,   729, -3935, -3935,
   -3935,  3344, -3935,   465,   465, -3935, -3935,   413,  1962, -3935,
   30330, -3935, -3935,  2582,   906,  2582,  1519, -3935, -3935,  2582,
   -3935,  2582, -3935,  1262,  3104,   202,  3386, -3935, -3935, -3935,
   -3935,  3390,   285, -3935, -3935, -3935, -3935, -3935, -3935, -3935,
   -3935, -3935, -3935, -3935, -3935, -3935, -3935, -3935, 23453, -3935,
    1263,  2309, -3935, -3935, -3935, -3935,  3033,  1652,  3163, 46315,
     303, -3935,  3378,   656, 50068,  1384, 62995, -3935,  2207,  2207,
    3170, 62995,  3521, -3935,   566, 62995,  3433,  3159, -3935,   906,
   -3935, -3935,  2709, 62995, 50068,  2744,  1963, -3935, -3935, -3935,
    3157,  3058,  3124,  1903,  1012, 62995, -3935,  3161, -3935, -3935,
    3407,  3126, -3935,  9382,  9382,   906, 79181,  3497, -3935, 62995,
    3383,   729, -3935,   729,   729, -3935, -3935, 62995,  2683,  2683,
    2683, -3935,  3311, -3935, -3935,   729, 45898,   821,   821,   821,
     821, -3935, -3935, -3935,  9382, -3935, -3935, -3935, 26063,  3413,
   -3935,  3131, 77963, -3935,  3132,  1968,  1974, 26927,  3278, -3935,
   -3935, -3935,  6690,  3184,  9382,  3241,  3134,  3136, -3935,   845,
     845,   788,  1978, -3935, 26063, 26063,  2120,  2120, 23453,  2120,
   -3935, -3935,  7037,  3305, -3935, -3935, -3935, -3935, -3935, -3935,
   -3935, 42145, 60493,  3139, 62995,  1771, 29058, -3935, -3935,  1386,
   -3935, 29058,  3380, -3935, 29058, 62995,  3142, 62995,    61, 23453,
   23453,  3183, -3935, -3935, -3935,  3083, -3935,   204,  3144, 62995,
   -3935, -3935,   778, -3935, -3935, -3935, -3935, -3935, 45898,  3333,
   45898,  1262,  7151,  3033, 29906, 36739, 62995, 62578, 62578,  3296,
    3033,  3163, -3935, -3935, -3935, -3935, -3935, -3935,  3149, -3935,
   -3935, -3935,  3230, -3935, -3935,   -16,  2710,  1985, -3935, -3935,
   -3935, -3935, -3935,  3356, -3935, -3935, 33722, 46732, 62995, -3935,
    3231, -3935, -3935, -3935, -3935, -3935, 31178, 35877, -3935,  1013,
    3164,  3165,   981, -3935, -3935, -3935,   843,  2710, 62995,  1121,
     810,  3193,  2683,  3447, -3935, -3935, -3935,  3356, -3935, -3935,
     465, -3935, -3935, -3935,  2212,  3485, -3935, 41311, -3935, 42562,
   -3935, -3935, -3935,   906, -3935,   906,  3355, 62995, 38809,   906,
     906, -3935, 46315,  3566,  3566, 62995, -3935, -3935,  7488,  3368,
   -3935,  3163,  3403,  3441, -3935,  3188, 62995,  3336,  3190,  3195,
    1048,  1048,  2971, 62995,  1992,  1291,   279, 50068,  2971, -3935,
    1467,  3198,  3496, -3935,  3602,  2879,  3200, -3935, -3935, 51319,
    3385,  3120, 62995,  3058,  3331, -3935,  3332, -3935,   249, -3935,
   62995, 29906, -3935, 78369, -3935,  1993, -3935, -3935,  2780, 62995,
      71, -3935, -3935, -3935, -3935, -3935, -3935,   175, -3935, -3935,
   -3935, -3935,  1316, 26063, 77963,  2002, 23453, -3935, 23453, -3935,
    3592, -3935, -3935, -3935,    79, -3935, -3935, -3935,   845,   845,
    2120, -3935,  3593,  3083, -3935,  2006,  3616, -3935, 62995,  2007,
   -3935, 23453,  3212, -3935, -3935, 29058,  1386,  2008, 62995,  2015,
   77963,  3213,  2724,  9382, 62995, -3935,  3214, -3935, -3935, -3935,
   -3935,   456,  1145,   175,  3458,  3163, -3935,  3218, -3935, -3935,
   62995, -3935,   791,   791, 62995,  3163, -3935, -3935, 62995,  3298,
   -3935, -3935, 41311,  3274, -3935,   919,  2710, 62995, 77963,  2063,
      98, -3935, 77963, 77963, -3935,  3307, -3935, -3935, 62995, 62995,
   62995, 62995, 62995,   729, -3935,  2841,   906, -3935, -3935,  2019,
   -3935, -3935, -3935, 62995,  3019, -3935,  3019, -3935, -3935,  3566,
    1041, -3935, -3935, -3935,  1880,  3422, -3935,   748,  3409,  3309,
    3224, -3935, 46315,  3660,  3342, -3935, -3935, -3935, -3935, -3935,
   -3935, -3935, -3935, -3935,  3525,  2709,  3161, -3935, -3935, -3935,
   -3935, 23453,  3387,  1291,  1903,  3287, -3935, -3935, -3935,  2034,
    3120, -3935, -3935,  3608,  3417,  3611, -3935,  2047, -3935, -3935,
    5926, 79181,  3556, -3935,  3295, 62995, -3935, -3935, -3935,  1316,
    2052, -3935,  2057,  2058,  3384,  3299, -3935, 23453,    62,  2929,
   42145,  3238, -3935,  2078, -3935,  9382, 62995, -3935, -3935, -3935,
    2104, -3935, -3935,  3233, -3935,  3645, -3935, -3935,  3527, -3935,
   62578,  3284, 35877, -3935,   -49,   -49,  1652, -3935,  1262, -3935,
   62995, -3935, 23453, -3935,  3326, -3935, -3935,  2129, -3935,    96,
    3394,  3539,  2137,  2138, 62995,  2690,  3304,  2690, -3935,  2683,
   -3935, -3935, -3935, -3935, 42562,  3019, -3935, -3935, -3935,  3568,
    3510, -3935, -3935, -3935, -3935,   377, -3935,  3443,  3445, 62995,
   -3935,  3255, -3935,  2146, 62995, 62995,  3666,  3668, -3935,  7696,
   46315,  3161,  3058,  1903,  1558, -3935, -3935,  3449, -3935,  3453,
    2709, 29906,  3497, -3935,   282, -3935, -3935, -3935, -3935, -3935,
   -3935, -3935,  2724, 25193, 25193,  3270, -3935, -3935, 62995, -3935,
    2153, -3935, 62995,  3275, 45898,   791,  3276, -3935,  3271, -3935,
   -3935,  3403,  1262,  2710,  9382, 62995, 46315,  3662, -3935, -3935,
   -3935,  3394, -3935, -3935,  2710, 62995, -3935,  3404, -3935,  1003,
    1003,  3605, -3935,  3340, -3935, -3935,  3300, -3935,  3722,  2971,
   -3935,  1013,  1291, -3935,  3303, -3935,  3120,  3058, -3935, -3935,
    3120, -3935, -3935, -3935, -3935,  1451, 26498,  3421,   998,  7856,
   -3935, -3935, -3935, -3935,  2155, -3935, -3935, -3935,   175,   -49,
   23453,  1262, -3935,  3409, -3935,  2710,  2063, 62995, -3935, -3935,
   -3935,  3159, -3935,  3711, -3935,   869, -3935, -3935, -3935, -3935,
   -3935,  3093,  3161, 40894, -3935,  3120,  2780, -3935,  1595, -3935,
   -3935, -3935, -3935, -3935, -3935, -3935,  3705, -3935, -3935, -3935,
   -3935, -3935, -3935, -3935, -3935,  7768, -3935, -3935, -3935, -3935,
    3604, -3935, -3935, -3935, -3935, -3935,  2161, -3935, -3935, -3935,
   -3935, -3935, -3935,  1838, -3935, -3935,  1953,  1943, 25628, -3935,
    1262,  3454, -3935, 40894, -3935,  1595, -3935, 46315, -3935, -3935,
    3308, 40894,  2166, -3935
};

/* YYPGOTO[NTERM-NUM].  */
static const yytype_int16 yypgoto[] =
{
   -3935, -3935, -3935,  3018, -3935,  -777,   442,  2382,  -538, -3935,
   -3935, -3935,  -457, -3935, -3935, -3935, -3935, -3935, -3935, -3935,
    2973, -3935, -3935,  1567, -2107, -3935, -3935,   125,  2926, -1106,
     109,  2596,  1260, -3935,  -963, -3935, -3935,  -504,    83, -3935,
    2930,   407, -3935, -3935, -3935, -3935, -3935, -3935, -3935, -3935,
    -580,  1735,  1107,  -725, -2497, -3935, -3935, -1218, -2774, -3935,
     514, -3935, -3935,  1667, -3935, -3935, -3935,   959,   441,  -473,
   -3935, -3935, -3935, -3935, -3935, -3935, -3935,  -294, -3935, -3935,
    -609,   134,    27, -2103,  -339, -3935, -3935,   383,  -341, -1099,
   -3935, -3082, -3935,   -39, -3935, -3935, -3935,  -319, -1189,  1203,
   -3935,  -617,  -940,  1500,  -664, -3935,  -206, -3935,  -720,  -607,
    -602,  -674,  -498, -3272, -3686, -3322, -3123,  1211,   136, -3935,
   -2753,   146, -3935, -3935,   151,   152, -3935, -3935, -1307, -1232,
   -3935,  -759, -3935, -3935, -3935, -2553, -3935, -3935, -3935, -3935,
      56, -3935, -3935, -3935, -3935,   414, -3935, -3935, -3935, -3935,
   -3935, -3935, -2346,  1623,  1627, -3935, -3935, -2778, -3935,  -784,
   -3935,   558, -2589,  1132, -3935, -3935, -3935,  2349, -3935, -3935,
   -3935, -3935, -3935, -3935, -1383, -3935, -3935,   153, -3935,  1644,
     932, -3935, -3935, -3935,  -706,  -775,  -765, -3935, -2572, -3935,
   -3935, -3935, -3935,  -276, -3935, -3935, -3935, -3935, -3935, -3935,
    -848, -3935,   995, -2708, -3935, -3935,  1016, -3935, -3935, -3935,
   -3935, -3935,  -657,  -214,  2372, -3935,  -540,  -628, -3935, -3935,
   -3935,  -210, -3935, -3935, -3935, -3935, -3935, -3935,  -908,   -51,
   -1346, -3935, -3935, -3935, -3935, -2066, -3935, -3935, -3935, -1764,
   -3935,  3799,  2036,  2081,   155, -3935,   -11,    57,  2822,  -965,
   -2272,   357,  -363, -3935, -1544, -3935, -3935, -3935, -2196, -3935,
   -3935, -3935, -3935, -3043,   156, -3935,  2823, -3935,   405, -3935,
   -3903, -3485, -3777, -3934, -3039, -3935, -3935,  -931, -3935, -3935,
   -3935, -1211,  1949, -1659, -3935, -1769,   412,  1293,  -824, -2376,
   -3308,  -613, -2827, -3935, -3189,  -461, -3935, -3935, -3935, -3935,
   -3935, -3935, -3935,  -930,  -531, -3935, -3935,  3269, -3935, -3766,
   -3935, -3935, -3935, -3935,  1009, -3935, -3935, -1198,  1084, -3935,
   -3935, -3935, -3935, -3935,  -639,  -727, -3935, -3935, -3935,   157,
   -3935, -3935, -3935, -3935,  1941,  -799,  -629,  3141,   158, -3474,
   -3935, -3935, -3935, -3935, -2631, -3935, -3935, -3935, -3935, -3935,
   -3935, -3935, -3935, -1731, -3935, -3935, -3935, -3935, -3935, -3935,
   -3935,  2018,  2014,    75,   -38, -3935, -3935, -1083, -3935,  -484,
   -3935,  2320, -3935, -3935, -3935, -3935,  1347,   159,   443, -3935,
       3, -3935, -3935,   231, -2962,     4, -3935, -3935, -3935, -3935,
   -1824,     5, -3935,   716, -3935, -3935, -2417, -3935,   160,    17,
   -3935, -3935,     1,     0,   -36,   -29,   -25,     2,  3137,  2686,
   -3935, -3935, -3935,    13,  1727, -3935,  -728,  -138, -3935,  1354,
    -551,  1987,  2671,  2676, -3935,  1345, -3935, -3935,  1351, -3935,
   -3935, -3935,  -549,  1994, -3935,  2672, -3935, -3935, -3935,  1331,
    1340, -2979,   780, -2947, -2925,   298,   287, -1109,  -305,   137,
    3162,  2678,   790,  -439, -3935, -3935,  -437, -3928,   743, -3935,
   -3780, -1988,  -630,  1745, -1372, -3935, -3935,  -971,  5802, -3935,
   -3935, -3935, 12412, 12914, -3935, -3935, 12955, 13493, -3935,  -836,
     840, 13683,   541, -1017, -1630,  -652, 11547, -1220,  -996, -2212,
   -3935, -3064, -2181, -3935, -3935, -3935,  -257,   851,   491, -3935,
   -3935, -3935, -3935, -3935, -3935,  -541, -3935,  -539, -3935, -3935,
   -3935,  -532, -3696, -1195, -3935,  -184, -3935, 11699,  1387, -3935,
    -864, -2364, -2371, -2954, -1516, -3935, -3935, -3935, -3935, -3935,
   -3935, -3935, -2643, -2854,  -242,  1460, -3935, -3935,  1554, -3935,
   -3935, -3935, -1087,  -716, -2265,  1465, -1739, -3935,  -722, -3935,
     768,  2195,  -673,   824, -1154,  6044,  -444, -1959, -1055, -1308,
   -3935,  -172, -3935,    25,   -10,   -19,  -508,     6,  3425, 10629,
    -556, -1118,  8540,  9900, 10898, -2680
};

/* YYTABLE[YYPACT[STATE-NUM]].  What to do in state STATE-NUM.  If
   positive, shift that token.  If negative, reduce the rule which
   number is the opposite.  If YYTABLE_NINF, syntax error.  */
#define YYTABLE_NINF -2278
static const yytype_int16 yytable[] =
{
     169,   168,   173,   163,   164,   166,   578,   767,  1501,   811,
    1203,   531,   726,  1541,   654,   897,   786,  1135,  1511,   926,
     169,  1209,   173,   680,   519,  2285,  1837,   643,  1000,  1001,
    1002,   568,   643,   736,  1006,  1505,  1329,  1293,  1306,   560,
    1922,  2415,  1371,  2141,  1822,  2961,   642,  2521,   725,  1450,
    2481,   642,  1212,  1984,  1397,  1359,   713,   977,  1561,  1470,
    3380,  1598,   948,  2795,  2109,  2841,  2015,  1648,  1149,  2859,
    3197,   924,  2699,   607,  3437,  3214,  2001,  1827,  3229,   649,
    3231,  1992,  3614,    65,  1621,  1622,  2154,   951,  2205,  3398,
    2343,   681,  2061,   883,  2756,   617,  2501,   963,  1822,  2945,
    3646,  3859,  1840,  1637,  1534,  1492,  1438,  3104,  3549,  3575,
    1443,  3349,  3102,  3103,  3138,  1447,  3423,  3640,  2543,  2545,
     730,  3330,  1453,  2075,  2076,  1827,  3867,  3411,   971,   772,
     774,  3680,  1472,   778,    74,   780,    75,   926,  2071,  3330,
     934,  3851,   674,  2256,   738,  3044,    76,  3592,   739,   707,
    1977,    77,    78,    98,   829,   118,   123,   139,   143,   161,
     167,  1900,  3988,  3144,   699,  4111,  3514,  2209,  3590,  3619,
     788,  1991,  1262,   737,  2220,  4177,   815,  4179, -1594,   710,
    1469,  3818,  3001,   529,  1196, -1604,  1199,   832, -2046,  1142,
    3428, -2080,  3354,  3355,  3356,  3357,  3358,  3359, -1953,  1861,
    4302, -1604,  1493, -2101,  2778, -1928, -1953, -1380,  1614,  1615,
    1238,  4203,  2854,  1828,  2145,  3683, -2128,  1543,  4298,  1229,
    1493,  3986,  1930,  1667,  2082,   574,  2420,  1493,  2542,  1434,
    1517,   716, -1594,   625,  1634, -1954,  2526,   783,  1664,  1323,
    2591,  1532,   731, -1954, -1589,  1338,  4359,  1994, -2277, -1561,
    1420,  1674,   574,  1994,  1364, -1574, -2277, -1601,   574,  1392,
     574,  3095,  2978,  1994,   574, -1383, -1981, -1820,  4344,  4345,
    2087, -2049,  3143,  1581, -1820,   625,  3193,  1677,   574,  3198,
     625,  2146,  2797,  2916,  3415,  2918,   574,  2212,   982, -1594,
    3843, -1380,  3097,   986,   625,   888,  1994,   574, -1589,  1290,
    2420,   732,  4293,  2145,   625,  4483,  4304,  1679,  4252,  3474,
    4294,  4209,  3095,  1239,  4315,   574,  1004,  2159,   733,   997,
    2462,  2952,  1230,   733,  3583,     3,     4,  3995,  3209,  1712,
    1386,  4086,  2277,  2566,   625,   176,  3342,  2034,   825,  2147,
    2294,   631,  2148,  3097,   631,  2312,  1238,  2104,  4423, -1383,
    1371,  1139,  3584,  4447,  3495,  3684,   631,  4072,  1307,  2105,
     878,   632,   811,  2177,   632, -1380,  3239,  3951,   733,   631,
    2146,  3122,  3123,  1356,  4424,  1360,   632,   177,  3515,  3586,
    1503,  3240,  1585,  2106,   524,  4073,  3001,  1665,  1724,   632,
    2953,  3210,  1713,  1736,  1736,  2455,  3796,  1005,  4330,  2035,
   -2100,  1648,  2456,   836,  2606,  2567,  -124,   929,   926,   811,
    1994,  -124,  2280,  4448,  3798,  1711,  2286,   939,  2288,   631,
     926,  2291, -1836, -1383,   631,  1503,  1503,  4290,  2147, -1836,
    2149,  2148,  2202,  2149,  1621,  1622,  1829,  2178,  4087,   632,
     936,  1512,  1637,  1928,   632,  2380,  2463,  3475,  3374,  1239,
    2116,  1166,    38,  1167,  1494,  1027,  2120,  4305,  3685,  2380,
    1529,  3686,  2959,  3991,  4295,  2318,  1231,  2473,  1994,  4484,
     574,  2014,  1494,   740,   926,   998,  2069,  2213,  3588,  1494,
    3844,   575,    42,  4376,   881,   734,  4459,  1965,   884,  2798,
     784,  3198,   798,   837,  1545,  1971,  1579,  4316,  2278,  1232,
    3194,  4499,  3107,  2779,  1674,   907,  1588,  3602,  4481,  2464,
    3429,  2141, -1380,  1435,   717,  2064,  2592,   875,  2340,  1599,
      46,  1379,  2149,  3633,  -378,   892,  1602,  2279,  1233,   899,
    1677,  3694,  2150,    47,   838,  1300,  2346,  2421,  2628,  1036,
     909,  1582,  3001,  2057,  2694,  2059,  2066,  2550,   889,  2139,
     741,  2112,  2151,  2047,  3274,  2014,  2050,  2051,  2418,  3330,
    1679,  2132,  2133,  4435,  1609,   925,   578,  1614,  1615,  2527,
   -1383,  2108,  1240,  2083,  1582,    48,  1634,   726,  1827,   978,
   -1820,  4113,   873,  1643,   839,  1435,  1234,  3671,   926,  1161,
    2203,  1531,  2088,  1162,  3922,  3650,   926,   926,  4562,  1643,
    1204,  1668,  3945,  1644,  3013,  3996,  3949, -2100, -1380,  1503,
   -1594,  3064,   169,   725,   173,  3163,  3469,  1645,  3832,  1644,
    2273,  2150,  2260,  2117,  1827,  3592,  1266,  4081, -2046,  3841,
   -1953, -2080,   979,  1647,   984,  1161,   988, -1928,   970,  1162,
    1718,  3897,   992, -2101,  2379, -1380,  3939, -1380,  4494,  1011,
    1980,   642,  1872,   642,  1873,   642, -2128,   995,  2402,  2281,
    3337,   642,   993,   994,  1963,  3974, -1383, -1954,  2292,  3858,
    2033, -2100,  1028,  1698,  1375,  1609, -1589,   811,  4127,  1132,
   -2277,  1620,  1141,   925,  1143,  1381, -2100,  1626,   973, -1601,
    1670,  1168,  1709,   937,   637,   638,  2488,   569,   738,   637,
     638,  3698,   739, -1383,  3002, -1383, -1981,  2789,  2457,  4340,
    3375, -2049,  2604,   637,   638,  3307,  4476,  2029,  3310,  3311,
    3792, -1594,  3314,  1291,  1292,  3003,  1929,   737,  3317,   169,
     168,   173,   163,   164,   166, -1836,  3608,  3119,  1370,  2722,
    2339,  2204,  2342,  1005,   742,  1483,  2113,  1503,  1298,  1299,
    1005,  3394,  2350,   637,   638,  3140,  2354,  4460,  2002,  2070,
     611,  3783,  2510,  2629,  2366,  2367,  2355,  2230,   574,  2707,
    2707,  2036,  3631,  3146,  1380,  3147,  2236,  2384,  2386,    14,
    2240,  1493,   574,  1822,  3004,  2847,  2246,  2247,  2400,  4288,
    4536,  4525,  1171,  1007,  4195,  4053,  2370,  2371,  2282,  1674,
    2687,  4205,  4398,  1224,  2259,  3010,  3011,  3012,  3013,  2833,
    2162,    19,    65,  2212,  2946,  3252,  1138,  2481,  2481,  2481,
    1146,   642,  1151,  1391,  2506,  1677,   574,  3312,  3313,  2695,
    -124,  -124,  1348,  2296,  3735,  1720,  1290,   574,  1349,  1368,
    2172,   625,  2708,  2708,  1448,  1449,  2557,  2297,  2948,  2619,
    1007,  2578,   526,  1036,  2677,  1679,  3001,  3468,  1226,  3112,
    2619,  2215,  2356,    74,  1480,    75,  1536,  2231,  4206,  1537,
    3622,  3272,  4576,  1977,  3095,    76,  3095,  4166,  1930,  1207,
      77,    78,    98,   917,   118,   123,   139,   143,   161,   167,
    2645,  3870,  2709,  2709,  1507,  1509,  2684,  3469,  1465, -1925,
    2289,  2290,  4382,  2507,  2678,  3097,  2579,  3097,   801,   802,
     803,   574,   804,   805,   806,   807,   808,   809,  3253,  1466,
    3646,  1244,  2620,  1695,  1696,  1697,  1698,  4475,   655,  2357,
     674,  1333,  2741,  2620,  3273,  1350,  1721,  3386,  2742,  2848,
    2879,  2437,  -597,  2173,  2710,  2710,  1665,   570,  4145,  2950,
    3814,  2298,  3095,  1916,   925,  3005,  3006,  3007,  4256,  3008,
    3009,  3010,  3011,  3012,  3013,  2605,   925,  4170,  4406,  1917,
      30,  2834,  4174,  4552,  2196,  4176,  1485,  2061,   169,  2245,
     173,   977, -2278,  3097,  3439,  2688,  3736,  2358,  2679,  1916,
    2359,  -783,  4412,  1369,  2237,  4167,    38,   571,  1547,  1584,
    1549,   642,  1551,  4097,  1553,  2248,  1555,  1556,  1557,  2947,
    2895,  1931,  4402,  1559,   795,  4383,   574,  2255,  3215,  3264,
     925,  1972,   819,  1410,  1918,  2283,    42, -1561,   572,  1152,
     573,   834,  3327,  1494,  2003,  2743,  2711,  2711,  1607,  3003,
    3437,   918,  1919,  2949,  2416,  2831,  2004,  1722,  4554,  2835,
    3327,  2197,  2265,  1343,  2232,  4512,   661,  3646,  1624,  1925,
    1918,  3440,  3254,  3891,    46,  1467,   726,  2438,  4104,  3981,
    4265,  2439,  4341,  2623,   821,  2849,  4377,    47,  1919,  1351,
    4384,  2360,  4347,  1161,  2623,  3387,  3815,  1162,  1651,  1932,
    4008,  1344,  4107,  1153,  1666,  3255,   919,  2005,  3004,   822,
   -1561,  2619,  1662,  1216,  1671,  2496,  1973,  2373,  1023,  2440,
    4229,  4553,  1352,    48,  2850,  3800,  1192,  1710,   811,  4266,
     663,  4114,   662,  1486,  3256,    38,  4267,  3001,  2299,  2936,
    3435,  4477,  2680,  4115,   925,  1833,  3710,  1726,  1727,  2712,
    2712,  1353,   925,   925,  2951,  4538,  2300,  2713,  2713,  4338,
    2714,  2714,  1280,  4268,  4524,    42,  2999,  3000,  4526,  1841,
    1842,  3015,  1846,   739,   739,   686,   739,   685,  3705,  2547,
    4225,  1920,   642,  1487,  2620,  1728,  1847,   642,   642,  2744,
    2361,  2380,  2380,  2816,  1036,  1194,  2380,  3001,   737,   737,
    4310,   737,  3681,    46,  3145,  3441,  4327,  2520,   664,  3216,
    2550,  3050,  3051,  4561,  2621,  4404,    47,  1920,  3973,   708,
    1461,  4230,  2745,  4378,  1729,   719,  1693,  1694,  1695,  1696,
    1697,  1698,  1195,  4482,  3217,  4269,  2380,  2380,  2009,  2441,
    2750,  3608,  2198,  3958,  3711,  1924,  3965,  2622,  4513,   728,
     731,  2746,    48,  3762,  1345,  2199,  4354,  2052,  1462,  3765,
    3766,  2503, -1427, -1561,  3339,  3442,  4166, -1427,  1519,   687,
    1291,  1292,  1925,  1488,  4357,  1848,  3706,  1921,  4362,  4363,
   -1392,   642,  4539,  3008,  3009,  3010,  3011,  3012,  3013,   642,
    3885,  1934, -1392,  3034,  1503,  2123,   729, -1392,  4116,  3041,
    2723,  1935,  2077,  2078,  2079,  2080,  1520,  1958,  2726,   732,
    2728,  3634,  2747,  1921,  2913,  4439,  4440,  4514,  4214,  3498,
    3003,  3499,  3340,  1489,  4273,  2919,   993,   994,  2065,  2229,
    4277, -1427,  1186,  2124,  3360,  2623,   811,  3001,  2235, -1392,
    4515,  2914,  1346,  2118,  2119,  2748,  3330,   642,  2095,  2128,
     642,   642,  1207,  2864,  2865,  2866,  2867,  3646,  3186,   843,
    2548, -1392,  1910,  2549,   876,  2872,  3707,  2800, -1427,   543,
    1503,  2632,  1911,  2646,  2749,  2121,   733,  3363,  3653,  3095,
    3003,   665,   666,  3095,  2053,  3696,  2054,  1912,   574,   743,
    2379,  2379,   625,  2156,  2135,  2379,  3187,  1226, -1392,   836,
    1226,  4270,   779,  3465,  1490,  1926, -1392,   786,  1303,  1192,
    3097,  1463,  1674,  3628,  3097,  2909,  2149,   642,  2644,   777,
    2191,  2192,  2193,  2194,  3115,  3158,  1187,   545,  3840,  2610,
   -1561,  1431,  2122,   796,  1221,  2379,  2379,  2574,  3208,  3004,
    3500, -1561,  1936,  1620, -1561,  1216,  2176, -1561,  3697,  1226,
    3501,   836,  3654,  1226,   543,  3812,  2633,  2186,  2481,  1521,
    1850,  2578,  2095,  3899,   811,  3900,   797,  1222,  1679,  3485,
    4544,    33,  2562,  2767,  2250,  1937,  2721,  3635,  1194,  1349,
    3327,  3582,  2068,  2254,  1435,  1280,  2125,  3793,  2641,   837,
    2261,  2976,  -940,   734,  2238,  1326,  1223,  1851,  2734,  1464,
    2061,  1018,  3873,  -401,  3874,  1303,  3636,  3655,   827,  3656,
    4079,  4397,   545,  2715,  4254,  3367,  3166,  2095,  3813,  2912,
   -2278,  1913,  2807, -1392,  1136,  3637,  4213,  4090,  1327,  2773,
     838,  2052,  4228,  1305,   835,  2921,  2922,  -146,  2938,  2924,
    3028,   837,   527,  1159,  3275,  2928,   169,  1522,   173,  3188,
    3583,   880,  3368,  3459,  3008,  3009,  3010,  3011,  3012,  3013,
    4233,   877,  -146,  1431,  1185,   552,  3369,   553,  4091,  2715,
    1224,  3053,  2503,  2267,  2126,  2268,  1350,  2269,  3584,  2270,
     839,  2271,   838,   682,  1161,  2272,  4303,  1182,  1162,  2816,
    1451,  1853,  2016,  3585,  3901,  3437,  2315,   169,  2311,   173,
    2308,  2309,  2310,  2705,  2963,  3586,  -401,  3992,   882,  1664,
    2890, -2278, -2278,  2007,  3008,  3009,  3010,  3011,  3012,  3013,
    1998,    38,   973,  1328,  4137,  2364,   176,  1148,  3587,  3360,
    1358,  1297,   839,  4351,  -146,  3361,  1224,  3189,  2423,   885,
    1309,  2017,  1854,  2018,  4348,  3362,  4480,  4171,  3370,  3169,
     552,    42,   553,  2352,  2353,  1152,  2751,  1192,  2053,  -146,
    2054,  2365,  1193,  2314,  2102,  2368,  2369,   176,   177,  2337,
    3993,  1999,  3363,  1310,  3364,  1451,  3416,  2014,   926,  3420,
    2390,  3055,  2391,  3056,  2658,  2752,  2955,  1994,  1994,    46,
    3185,  2426,  2660,  2753,  1674,  1995,  2000,  2103,  1725,  4527,
      27,  4520,    47,  2413,  3588,  2414,  3057,  4051,  4052,   177,
    2159,  2821,   926,  3999,  4000,  2428,  4191,  2429,  4193,  1153,
    1677,  2039,  2754,  1446,  2042,  2489,  1194,  3790,    33,  2302,
    2905,  4089,  2022,  1224,  1023,  2659,  4096,   625,    48,  3095,
    2430,  1736,   898,  2661,  3095,  1474,  1477,  1478,  3365,  3095,
    1679,  4106,  3095,  2038,  3008,  3009,  3010,  3011,  3012,  3013,
    2822,  1431,  4416,  1195,  2927,  3108,  4066,   631,   905,  1144,
    3097,  4067,  3753,  2091,  1526,  3097,   811,  2098,  4172,  2598,
    3097,    38,  3095,  3097,  3177,  4442,   786,   632,  4278,    38,
    1716,  3464,  3497,  3754,  1527,  3502,  3503,  3504,  3505,  3506,
    3507,  3508,  3509,  3510,  3511,  3366,  1850,  3058,  -504,  1213,
    3367,    42,  3059,  3097,  4068,  1431,  4279,  2380,  1643,    42,
    2380,  2380,  2380,  2380,  2380,  2380,  2380,  2380,  2380,  2380,
    2023,  1831,   914,   910,  1832,   625,  2431,  1136,  1644,  2823,
    2824,  2432,  1214,  1851,    27,  1834,  2433,  3368,  1835,    46,
    2380,  1431,  3199,  2825,  3551,  3552,  3668,    46,  1632,  1633,
    1136,  3369,    47,   911, -1426,  2512,  3582,  3172,  3110, -1426,
    3651,  1215,     3,     4,  3219,  4501,   915,  1682,  1683,  2380,
    2380,  3737,  2869,  1674,   642,   169,  2529,  2870,  2554,  1339,
    2517,  2518,   912,  2558,  1643,  1852,  2561,   935,  4528,   543,
    2826,  3738,  2600,  2601,  2602,  2174,    48, -1450, -1450,  1677,
    2568,  2612,  2571,  2614,  1644,  2616,  2617,  1171,  2584,  3095,
    3918,  3070,  1340,  1686,  2206,    38,  1341,  1431,  1645,  3528,
     611,  3060,   916, -1426,  1643,  3583,   913,  1853,  3399,  1679,
    3222,  3061,  3224,  3370,   926,   931,  1431,  3408,  2481,    14,
    3097,  1342,   536,  2481,  1644,    42,   209,   545,  2481,  2634,
     890,   528,   891,  3584,  -505,  2434,  1431,  2340,  1647,   609,
   -1426,   910,   943,  3095,  1143,  2435,  2640,  1218,  3585,  3178,
    3350,    19,  1894,   944,  4570,  2870,   683,  2827,  1854,  2828,
    3586,  1431,  1740,    46,  4234,  1161,  3653,  2058,  2973,  1162,
    3249,   911,  2675,  2263,  3097,  3477,    47,   949,  3682,  3687,
    1219,   958,  3672,  3587,  2724,  1895,  2379,  3516,  3517,  2379,
    2379,  2379,  2379,  2379,  2379,  2379,  2379,  2379,  2379,   968,
    3396,  2706,   543,  3250,  2016,  2717,  1592,  1593,  4379,  1220,
    1875,  3293,    48, -1167,  1896, -1167,  3481,  3300,  1431,  3526,
     926,  -934,  4063,  2729,  4065,  3699,  1036,  3202,  4069,  3001,
    4070,   893,  3251,   894,  2739,  3376,  2340,   640,  3155,  3156,
    3654,   964,   640,  2783,   913,   625,  3542,  2763,  2379,  2379,
    3257,  2792,  3259,  2017,   642,  2018,  2793,  2770,  2974,  3588,
     545,  3150,   642,  2975,   642,   552,  1620,   553,  1901,   999,
    1003,  2262,  3176,  1988,  2263,  2274,  1312,  2627,  2275,  1009,
    2006,  1693,  1694,  1695,  1696,  1697,  1698,  3630,  3095,  2014,
     558,  2791,  1620,  3245,  1901,  3655,  1606,  3656,    48,  2791,
    2684,  2860,  3695,  4138,  4139,  4140,  4141,  3294,  1673,  1012,
      30,  1674,  2043,  2276,  4274,  2046,  2275,  1014,  2305,  3097,
    3480,  2306,  1313,  3811,  1161,  1015, -1928,  2406,  1162,  2964,
    2409,  3027,  3308,  3029,  3030,  2967,    38,  1677,  3341,  3343,
    3344,  2881,  4498,  1678,  1020,  3917,  2502,  3522,  2380,  2503,
    1023,  2081,  2638,  1021,  2816,  2639,  2815,  1620,  1022,  1216,
    2863,  3771,  4210,  1024,  3446,  2099,    42,  1679,  3449,  3450,
    2915,  3452,  2917,  3454,  3455,  1026,  2072,  2701,  2111,  3095,
    2702,  3770,  3460,  2802,  2861,  3267,  2803,  4123,  2891,  3482,
    1025,   169,  2880,  4226,   925,  1431,  2895,  1620,   552,  1901,
     553,  1314,  3772,  3849,    46,  3648,  3649,  1030,   612,   555,
    3097,  2817,  3003,  2016,  2818,  2930,  3478,    47,  2275,  3392,
     557,  2972,  2982,  1451,  2263,  2263,  3773,  3327,   925,  2986,
    1029,  2990,  2263,  2646,  2263,  1150,  2991,  3017,   811,  2263,
    2263,  3774,  1032,  3033,  3038,  3775,  2263,  3039,  2225,  1315,
    2226,  1316,  3232,   613,  2943,  3233,  4574,   926,  4575,   926,
    3447,  2060,  2017,  3237,  2018,  3776,  3238,  2971,  3777,  3426,
    1147,  3004,  3427,  1681,  1154,  1155,  3486,  2207,  2943,  2263,
    3778,  3098,  3523,  2217,  2884,  3524,  2885,  3878,  3879,  3880,
    1318,  1371,   642,  3533,  1682,  1683,  3534,  1036,  2014,  2101,
    3001,  1160,  3919,  3920,  3120,  3545,  1156,  3620,  2263,  3377,
    3621,  3379,  2630,  3624,  1172,  3629,  3625,  4187,  2549,  3385,
    3652,  3388,   926,  2275,  3078,  1179,  3079,  2380,  2380,  1320,
    3842,  3490,  3098,  2275,  4299,  3923,  2016,  1180,  2306,  2264,
    1686,  3976,  3983,  3989,  2549,  3984,  2275,  2379,  3785,  2016,
    3786,  3496,  1182,  1687,  3603,  3604,  3605,  3990,  3779,  1673,
    2275,  1183,  1674,  3598,  1322,  3080,  3780,  3081,  2321,   726,
    2696,  1182,  4355, -1380,  3432,  1190,  3518,  1136,  1136,  1675,
    4056,  4108,  1206,  4057,  4109,  2017,  4147,  2018,  1677,  4148,
    1205,  1216,  4149,  2313,  1678,  2263,  4157,  1210,  2017,  2306,
    2018,  3781,  1237,  4211,  1431,  1662,  4212,  2016,  1431,  1431,
    4275,  4300,  1585,  2275,  4301,  1242,  2322,  3271,  1679,  2426,
    4311,  2014, -2187,  2306,  4319,  4324,  4329,  4320,  2503,  3406,
    3276,  3476,  1268,  4331,  2014,  3304,  3406,  4373,  3073,  1189,
    4374,  1191,  3005,  3006,  3007,  2323,  3008,  3009,  3010,  3011,
    3012,  3013,  4405,  3089,  2016,  1715,  2017,  3950,  2018,  3953,
     925,  3083,  3084,  3085,  1269,  4410,  2324,  2016,  4411,  1302,
    4417,   726,  2016,  2306,  1303,  4418,  4419,  2325,  3039,  2263,
    1264,  1300,  1308,  3003,   169,  2311,   173,  2308,  2309,  2310,
    1311,  1827,  2014,  3111,  1334,   642,  4429,  2326,  3758,  2503,
    1335,  1347,  2327,  2017,  3089,  2018, -2187,   725,  4249,  1357,
    2472,  1361,  3151,  1366,  1431,  2340,  2017,  1367,  2018,  2486,
    1680,  2017,  4431,  2018,  1681,  3406,  2379,  2379,  1693,  1694,
    1695,  1696,  1697,  1698,  3181,  3673,  3182,  3183,  3184,  2014,
    1372,  1374,  3004,  1376,  3700,  1682,  1683,  4446,  2328,  1378,
    2306,  1382,  2014, -2187,  3174,  4452,  4453,  2014,  2306,  2306,
    4039,  4040,  1684,  4042,  4467, -2187,   925,  4468,  3868,  2329,
   -2187,  4495,  2016,  4542,  2503, -2187,  3406,  1383,  1388,  4572,
   -2187,  2016,  4573, -2187,  4583, -2187,  1390,  4573,  1685,  1395,
    1393,  1686,  1398,  1224,  1439,  1442,  1444,  3120,  1435,  4504,
    1454,  1457,  1455,  -167,  1687,  1036,  1459,  1688,  3001,  1471,
    4509,  1473, -2187,  1479,  1481,  3120,   194,  1491,  1496,  1497,
    1498,  2017,  4123,  2018,  1500,  3543,  1499,  1502,  1503,   194,
    2017,  1510,  2018,  1513, -2187,  2497,  1514,  2500,  1515,  1516,
    3906,  1518,  1523,  3235,  1524,  1525,  1530,  1535,  1560,  1587,
    1590,  1594,  3241,  1603, -1565,  1596,  2330,  2014,  4142,  1597,
    1604,  4547,  2331,  1431,  3260, -1572,  2014,  1613,  2332,  1617,
    1616, -2187,  1623,  1618,  1136,  1619,    48,  1625,  1628, -2187,
   -1562,  3265,  1689,  2380,  4158,  4159, -1563,  3881,  1629,   983,
     985,   987,  2380,  1630,   989,   990,   991,  2333, -1566,  2334,
    1631,  1636,  1638,  3872,   996,  1639,  1640,  1641, -1564,  2380,
    2380,  3875,  3876,  3005,  3006,  3007,  2335,  3008,  3009,  3010,
    3011,  3012,  3013,  1642,  1649,  1650,  1702, -2187,  1652,  3296,
    1653,  1654,  1655,  1656,  1704,  1657,  1658,  3305,  1706,  1659,
    3830,  2336,  1431,  1719,  1731,   786,  1739,  1839,  1708, -2189,
    1715,  2791,  1193,  1195,  2791,  2791,  1868,  1878,  2791,  1870,
    1897,  1898,  1899,  1902,  2791,  1903,  1901,  1904,  1905,  1906,
    1927,  3329,   655,  1933,  1939,  1690,  1691,  1692,  1960,  1693,
    1694,  1695,  1696,  1697,  1698,  1964,  1966,  4060,  1967,  3329,
    1970,  3003,  2994,  1968,  1969,  1985, -2187,  1986,  1987,  2007,
    1997,  2008,  2010,   925,  2011,   925,   642,  2013,  2012,  2014,
    2020,  2666,  2021,  3336,  3338,  2024,  2025,  2037,  3345,  2026,
   -2187,  2030, -2187, -2187,   642,  2031,  2040,  1431,  2044,  2045,
    2693,  2048,  2055, -2189,  2056,  2062,  2063,  1280,  2067,  2073,
    2074,  3404,  2084,  2085,  2089,  2086,  2114,  2090,  2129,  3456,
    3004,  2127,  3457,  2096,  2100,  3389,  2115, -2187,  3828,  3829,
   -2187, -2187, -2187,  2130,  2140,  1620,  1626,  3431,   925,   169,
    3422,  4094,  2142,  2143,  1609,  2160,  2163,  2164,  2167,  2168,
   -2189,   538,  2379,  2175,  2171,  1328,  2190,  2095,   169,  3445,
    2210,  4150, -2189,  2195,  3098,  2211,  3098, -2189,  1585,  3483,
    3849,  3467, -2189,  4309,  2218,  2223,  2224, -2189,  2379,  2379,
   -2189,  1212, -2189,  3997,  2221,  2228,  3559,  2239,  2287,  3770,
    2241,  2242,  2243,  3479,  2244,  2257,  2258,  1673,  2380,  2293,
    1674,  2303,  2317,  2345,  2346,  2351,  2388,  2389,  2401, -2189,
    1674,  2407,  2412,  2419,  4014,  4015,  1036,  2444,  2459,  3001,
    2460,  2425,  2442,  2473,  2411,  2487,  1677,  2490,  2491,  2494,
    2495, -2189,  1678,  2504,   732,  2505,  3924,  2513,  2514,  2515,
    2524,  2516,  3098,   642,  2539,  2538,  2541,  2856,  2551,  2552,
    2553,  2564,  2569,  2574,  2572,  2583,  1679,  2588,  2593,  2576,
    2594,  4062,  2577,  2596,  4323,  2599,  2603,  2607, -2189,  2615,
    2631,  2618,  2636,  1144,  4323,  1148, -2189,  2686,  2691,  2700,
    3998,  4048,  4049,  2692,  2704,  2703,   726,  2758,  3540,  2716,
    2755,  3005,  3006,  3007,  2769,  3008,  3009,  3010,  3011,  3012,
    3013,  2780,   726,  2776,  2777,  3120,  2782,  2781,  4013,  2784,
    1546,  2785,  2788,  1548,  2786,  1550,  2787,  1552,  2794,  1554,
    2801,  2805,  1662,  1558, -2189,  2808,  2839,  4028,  4369,  2796,
    1431,  2810,  3968,  1431,  2809,  1431,  3571,  2811,  3574,  2819,
    1431,  3564,  3565,  3566,  3567,  4182,  4238,  2862,  2812,  2853,
    2814,  2813,  2855,  2868,  2871,  2876,  2878,  2877,  1680,  2889,
    2887,  2906,  1681,  2907,  2908,  2892,  2910,  2904,  2911,   655,
    2925,  2920,  2923,  2926,  2503,  4047,  2932,  4244,  4246,  2933,
    2934,  1531,  2944,  1682,  1683,  3664,  3665,  3666,  3667,  2935,
    1431,  2937,  2318, -2189,  2954,  2957,  4131,  2379,  4132,  4133,
    1684,  2960,  3003,  1005,  2962,  2965,  2968,  2988,  2966,  2970,
    4136,  3035,  2969,  2984,  3054,  2263,  2985, -2189,  4005, -2189,
   -2189,  2987,  4430,  3023,  3076,  3069,  3669,  3049,  3100,  1686,
    1431,  2989,  3106,  2992,  2993,  2995,  2998,  3016,  3022,  3024,
    3025,  -980,  1687,  3032,  3047,  3048,  3062,  3072,  3127,  3074,
    4082,  3136,  3148,  3075, -2189,  3154,  3142, -2189, -2189, -2189,
    3105,  3004,  3157,  3160,   926,  3130,  3132,  3159,  3168,  4036,
    3164,  3165,  3171,  3206,  3180,  3221,  3212,  3207,  3223,  3329,
    4181,  3236,  3173,  3195,  3262,  3263,  3196,  4186,  3211,  3266,
    3268,  1431,  3269,  1431,  3270,  3277,  3278,  3279,  3280,  3281,
    4190,  3282,  3284,  3721,  3283,  3285,  3722,  3286,  3723,  3287,
    3295,  3288,  3290,  3739,   642,  3289,  3742,  3291,  3720,  3292,
    1689,  3299,  1585,  2082,  3301,  3303,  3309,  4235,  3319,  3315,
    3331,  3297,  3316,  3334,  4313,  3335,  2149,   642,  4358,  3346,
    4361,  3082,  3347,  3351,  3384,  3383,  3390,  3393,  1431,  2791,
    3395,  1036,  3397,  4375,  3001,  2791,  2791,  3417,  2135,  3418,
    3809,  3352,  3421,  3444,  3451,  3405,  3412,  3453,  3414,  3471,
    4365,  3925,  4367,  1431,  3424,  3461,  3472,  3462,  3463,  3406,
    3466,  3473,  3484,  1606,  3489,  3019,  3001,  3018,  1667,  3547,
     733,  3519,  1431,  3795,  3797,  3799,  3801,  3573,   993,   994,
    3520,  3595,  3581,  3535,  3521,  3527,  3548,  3600,  3556,  3784,
    1431,  1245,  3609,  1690,  1691,  1692,  3610,  1693,  1694,  1695,
    1696,  1697,  1698,  3597,  3833,  3560,  3612,  3616,  3794,  3613,
    3639,  3660,  3005,  3006,  3007,  3632,  3008,  3009,  3010,  3011,
    3012,  3013,  3674,  1246,  3675,  3676, -2202,  3662,  3677,  3663,
    3688,  3701,  3704,  3702,  3679,  4560,  3716,  3703,  3714,  3098,
    3715,  4238,  4308,  3098,  3860,  3727,  3717,  3718,  3719,  3728,
    3734,   169,  3857,  3750,  1431,  3752,  3683,  3761,  3755,   811,
    3763,  3764,  3787,  3788,  3436,  4318,  3789,  3816,  3808,  4289,
    1431,  3819,  3824,  3826,  3831,  3836,  3838,   651,   652,  1247,
    2943,  1431,   658,  4422,  4198,  4560,  3835,   669,   677,   651,
    2275,   684,  3839,  4560,   677,   677,  3852,   712,  4339,   715,
    3854,  3865,  3855,  3866,  3893,  3869,  3871,  3882,  3877,  3884,
   -2202,  1248,  3887,  3886,  3888,  3889,  3890,  3003,  3898,  3908,
    3895,   642,  3903,  3902,  3907,  3909,  4220,  3910,  3911,  3946,
    3947,  3931,  3915,   926,  3942,  3941,  3944,  3957,  4370,  4215,
    3954,  3959,  3962,  3960,  1585,  3969,  3963,  1249,  3964,  3972,
    3978,  3975,  1431,  3980,  3985,  3986,  3994, -2202,  4009,  2897,
    4016,  4017,  4018,  4038,  4029,  4032,  4010,  4043,  4050, -2202,
    4071,  4074,  1431,  4075, -2202,  4083,  3004,  1250,  1245, -2202,
    3294,  4088,  4093,  4095, -2202,  4099,  4101, -2202,  4110, -2202,
    4120,  4112,  4118,  4121,  4129,  4135,  4143,  1431,  4144,  4146,
    4151,  4153,  4155,  4162,  4156,  4548,  4168,  4175,  4154,  4178,
    1246,  3089,  4188,  4184,  4192,  3089, -2202,  4207,  1585,  4204,
    4208,  4217,  1585,  1585,  4231,  4232,  4236,  4243,  4250,  3966,
    3967,  4222,  4223,  1431,   768,   773,   773,   776, -2202,   773,
    3815,   782,    33,   768,  1978,   712,  1253,  4259,   813,  4262,
     169,  3970,  1254,   712,  4257,  4260,   712,  4263,  3979,  1255,
     773,  4282,   712,  4264,  4283,  4281,  1247,  1979,  4285,  3977,
    4287,  4314,  4317,  4291,  4292, -2202,  1257,  4085,  4321,  4326,
    4350,  4332,  4336, -2202,  1258,  4342,  4352,  4380,   642,  4364,
    4385,  4389,  4390,  3381,  3382,  4392,  4394,  4395,  1248,  4407,
    4400,  4408,  4409,  4414,  4432,  4428,  4420,  4433,  4445,  3391,
    4434,  4415,  4436,  4023,  4449,  4041,  4421,  4359,  4458,  1431,
    4457,  4011,  4466,  3400,  4461,  4033,  4463,  2898,  4471,  4044,
    4472, -2202,  3409,  4478,  1249,  4455,  1259,  4479,  4493,  4502,
     642,  4507,  3561,  4500,  4459,  4511,  3425,  3005,  3006,  3007,
    4460,  3008,  3009,  3010,  3011,  3012,  3013,  4519,  4551,  4441,
    4026,  4027,  4537,  4568,  1250,  4030,  4031,  4577,  4518,  4571,
    4523,  2097,  2857,  4045,  4046,  4581,   655,  1184,  1332,  1738,
    3113,  1331,  3693,  2791,  2791,  3218,  2690,  2768,  3318,  3767,
     925,  1267,  4371,  4237,  4064,  4456,  4284,  3827,  4286,  3098,
   -2202,  4080,  4272,  4543,  3098,  2931,  3162,  4503,  4196,  3098,
    1431,  4464,  3098,  4546,  1136,  4462,  4517,  4403,  3167,  2837,
    3823,  3691,  4105,  2838, -2202,   642, -2202, -2202,  4077,    33,
    3230,   811,  3401,  1253,  2820,  4550,  4582,  2187,  4578,  1254,
    4261,  4438,  3098,  3348,  4521,  4221,  1255,   642,   926,  3332,
    2170,  4451,  4224,  4508,  1979,   657,  3883,  1580,  4337,  4103,
    3861, -2202,  3120,  1257, -2202, -2202, -2202,  2544,  1589,  3862,
    4413,  1258,  3149,   811,  3298,   927,  4530,  2499,  4579,  1157,
    2498,  3117,  3971,  3845,  4219,  4122,  3626,  2266,  1178,  3118,
    2523,  3128,  3126,  3141,  3129,  1836,  2522,  2943,  3576,  1865,
    3940,  4328,  1869,  1864,  3952,  1165,  3572,  3893,  3893,  3893,
    3893,  4427,  4426,  1874,  3627,  1673,  2806,  3539,  1674,  4312,
    3529,  4496,  4492,  1259,  4497,  3121,  1245,  2900,  3436,  3067,
     786,  2979,  3065,  2475,  3623,  1675,     0,  3568,  3569,  3570,
       0,     0,     0,     0,  1677,     0,     0,     0,     0,     0,
    1678,     0,     0,     0,     0,     0,     0,     0,  1246,     0,
       0,  1431,     0,     0,     0,  4199,  4201,  4201,  1673,     0,
       0,  1674,     0,     0,  1679,     0,  3089,     0,     0,  3098,
     845,  3089,     0,     0,  3089,   712,     0,   768,     0,  2943,
     773,  2943,   776,     0,   773,     0,     0,  1677,  1431,     0,
       0,   813,     0,  1678,   902,     0,     0,     0,     0,     0,
       0,   773,     0,     0,  1247,     0,  4189,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,  1679,     0,     0,
       0,     0,     0,  3098,   768,     0,  3329,     0,     0,   776,
       0,     0,     0,     0,   768,     0,  1248,     0,   813,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,   773,     0,     0,     0,     0,     0,     0,
    2791,   642,     0,     0,     0,     0,  1680,     0,     0,   925,
    1681,     0,  1249,  4241,     0,  4242,     0,     0,     0,  4247,
    4248,     0,     0,     0,     0,     0,     0,     0,     0,  4296,
       0,  1682,  1683,     0,     0,     0,     0,     0,  1431,     0,
       0,   712,  1250,     0,     0,     0,     0,     0,  1684,  1431,
    4391,     0,   712,  1019,  1673,   169,  4276,  1674,     0,  1680,
       0,     0,     0,  1681,     0,     0,     0,     0,     0,     0,
    1251,     0,     0,  1131,  1685,   712,   677,  1686,     0,     0,
     677,     0,     0,  1677,  1682,  1683,     0,     0,     0,  1678,
    1687,     0,     0,  1688,   712,     0,     0,     0,   712,     0,
       0,  1684,     0,  1252,  1131,     0,     0,    33,  3098,  4343,
       0,  1253,     0,  1679,     0,   712,     0,  1254,   811,     0,
       0,     0,     0,     0,  1255,     0,     0,   712,     0,     0,
    1686,     0,  1256,     0,  3791,  3089,     0,     0,  4366,     0,
    4368,  1257,     0,  1687,     0,     0,     0,     0,     0,  1258,
       0,     0,     0,  3817,     0,     0,     0,     0,     0,     0,
       0,  1431,     0,     0,     0,     0,     0,     0,  1689,   712,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
    3834,     0,   712,     0,   773,   773,  4372,     0,  4474,  1431,
       0,     0,     0,  1673,     0,     0,  1674,     0,     0,  3098,
       0,  1259,     0,     0,     0,     0,   677,   677,  1431,     0,
       0,     0,     0,  1675,     0,  1680,     0,     0,     0,  1681,
       0,  1689,  1677,     0,     0,     0,     0,     0,  1678,     0,
       0,   768,     0,     0,  4506,     0,     0,     0,     0,     0,
    1682,  1683,   768,   169,  4401,     0,   813,     0,     0,  4201,
       0,     0,  1679,     0,     0,     0,  1431,  1684,     0,   773,
       0,  1690,  1691,  1692,     0,  1693,  1694,  1695,  1696,  1697,
    1698,     0,     0,  2492,   712,     0,     0,     0,     0,  2493,
     773,   773,     0,  1685,     0,     0,  1686,     0,     0,     0,
       0,     0,     0,     0,     0,     0,   712,   712,   712,  1687,
     773,     0,   768,     0,  4470,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0, -2278, -2278,     0,  1693,  1694,
    1695,  1696,  1697,  1698,   925,     0,     0,     0,   773,     0,
     773,   773,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,  3935,  3936,
    3937,  3938,     0,  1131,  1680,     0,     0,     0,  1681,     0,
       0,     0,     0,     0,  4510,  4580,     0,     0,     0,     0,
       0,     0,     0,     0,     0,  2943,     0,  1689,     0,  1682,
    1683,     0,     0,  1563,  1563,     0,     0,     0,   712,     0,
     651,     0,     0,     0,     0,     0,  1684,     0,     0,     0,
       0,     0,     0,  1431,     0,     0,     0,     0,  1595,     0,
       0,   712,     0,     0,  1601,     0,  4549,     0,     0,     0,
       0,     0,  1685,     0,     0,  1686,     0,  1131,     0,     0,
       0,     0,   169,  4522,     0,     0,     0,     0,  1687,     0,
       0,  1688,     0,     0,     0,   169,  4535,   173,  4532,  4533,
    4534,     0,  4567,     0,     0,     0,  1131,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
    1690,  1691,  1692,  4559,  1693,  1694,  1695,  1696,  1697,  1698,
       0,     0,     0,     0,  1131,  1131,     0,  1131,  4566,  4535,
     173,  4532,  4533,  4534,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,  1131,     0,  4558,     0,
       0,     0,     0,     0,     0,  1673,  1689,  1431,  1674,     0,
       0,     0,     0,  4559,  1270,     0,     0,     0,     0,     0,
    1271,  4559,     0,     0,     0,   169,  4535,   173,  4532,  4533,
    4534,     0,     0,   712,  1677,     0,  1131,     0,  1673,     0,
    1678,  1674,     0,     0,     0,     0,     0,     0,  4558,     0,
       0,     0,     0,     0,     0,     0,  4558,     0,  1675,     0,
       0,  1272,     0,     0,  1679,  1131,     0,  1677,     0,  1131,
    1131,     0,     0,  1678,     0,     0,     0,     0,     0,     0,
     712,   712,  1877,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,  1679,   677,  1690,
    1691,  1692,     0,  1693,  1694,  1695,  1696,  1697,  1698,  2897,
    1273,     0,     0,     0,  1431,     0,  3042,  1274,     0,     0,
    1275,     0,     0,     0,     0,     0,  3052,     0,  1245,     0,
       0,   677,     0,     0,     0,  1431,     0,     0,     0,     0,
       0,     0,     0,  4128,   712,  1993,     0,     0,     0,     0,
       0,   712,     0,     0,   773,     0,     0,     0,     0,     0,
    1246,     0,     0,     0,     0,     0, -2278,     0,     0,     0,
    1681,  1431,     0,     0,  1276,     0,     0,   813,     0,     0,
       0,     0,     0,   712,     0,     0,   712,     0,     0,     0,
       0,  1682,  1683,     0,     0,     0,     0,     0,     0,  1680,
       0,     0,     0,  1681,     0,     0,     0,     0, -2278,  1431,
     712,     0,     0,  1431,  1431,     0,  1247,     0,   773,   773,
     773,   773,   712,     0,  1682,  1683,     0,     0,     0,     0,
       0,  1277,     0,  1278,     0,     0,   712,  1686,     0,     0,
       0,  1684,     0,  1279,     0,     0,     0,  2110,  1248,   712,
    1687,  1280,     0,     0,     0,     0,     0,     0,     0,   773,
     773,  1281,     0,     0,     0,   773,     0,  1685,     0,     0,
    1686,     0,     0,     0,     0,     0,     0,  2898,     0,     0,
       0,     0,     0,  1687,  1249,     0,  1688,     0,     0,     0,
       0,     0,     0,     0,  1282,     0,     0,  1283,  1284,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,   773,
       0,     0,     0,     0,  1250,     0,     0,     0,     0,     0,
       0,     0,     0,  1285,     0,     0,     0,     0, -2278,     0,
       0,     0,     0,     0,     0,     0,   773,   773,   773,   773,
       0,     0,     0,     0,     0,     0,     0,     0,   712,  4253,
       0,     0,     0,     0,   712,     0,     0,  2110,     0,     0,
       0,  1689,     0,     0,     0,     0,   768,     0,     0,  1672,
       0,     0,     0,   776,  1673,   768,     0,  1674,     0,    33,
       0,  1286,     0,  2899,     0,   813,  1136,     0,     0,  1254,
     773,     0,     0,     0,  1675,     0,  1255,     0,  1676,   773,
       0,     0,     0,  1677,  1979,   773,   773,     0,     0,  1678,
     712,     0,     0,  1257,     0,     0,     0,     0,     0,     0,
       0,  1258,     0,     0,     0,  1693,  1694,  1695,  1696,  1697,
    1698,     0,     0,  1679,     0,  1563,     0,     0,     0,     0,
       0,     0,   773,     0,   768,     0,     0,     0,   712,   712,
       0,   773,     0,     0,  1690,  1691,  1692,   712,  1693,  1694,
    1695,  1696,  1697,  1698,   712,     0,     0,     0,  2410,     0,
       0,   651,   651,  1259,     0,  2320,     0,  2900,  4346,  1131,
       0,  1131,     0,     0,     0,     0,     0,     0,  1131,     0,
       0,  1131,     0,     0,     0,  1131,     0,     0,     0,     0,
       0,     0,     0,  1131,  1131,     0,     0,     0,     0,     0,
       0,  1131,     0,   813,  1131,  1131,  1131,  1131,     0,     0,
       0,     0,     0,     0,  1131,  1131,     0,  1131,     0,  1131,
    1131,     0,     0,  1131,     0,  1680,     0,     0,     0,  1681,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
    1131,     0,     0,     0,   773,  1131,     0,     0,     0,  1131,
    1682,  1683,     0,  1131,     0,  1131,  1131,  1131,  1131,  1131,
    1131,  1131,  1131,  1131,     0,  1131,     0,  1684,     0,     0,
       0,   712,     0,  1131,  1131,     0,     0,     0,     0,     0,
     712,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,  1685,     0,     0,  1686,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,  1687,
       0,     0,  1688,     0,     0,     0,     0,     0,     0,     0,
       0,  -121,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     1,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     2,     0,     3,     4,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     5,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     6,     0,     7,     8,  1689,     0,     0,
       0,     9,     0,    10,     0,     0,   712,     0,   712,     0,
    1131,     0,     0,    11,     0,    12,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,    13,     0,     0,    14,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,   712,    15,     0,    16,     0,
       0,  2530,    17,  2537,     0,     0,     0,     0,    18,     0,
       0,     0,     0,     0,     0,     0,    19,     0,    20,     0,
       0,     0,     0,     0,    21,     0,     0,     0,     0,     0,
       0,   776,     0,     0,     0,     0,   651,     0,   651,    22,
    1690,  1691,  1692,     0,  1693,  1694,  1695,  1696,  1697,  1698,
       0,     0,     0,     0,     0,  1131,  1941,     0,     0,     0,
       0,     0,     0,     0,     0,     0,   768,     0,   773,   773,
     773,     0,     0,   768,     0,   813,     0,   773,  1270,   773,
       0,   773,   773,     0,  1271,   712,     0,     0,     0,     0,
    1942,     0,     0,     0,    23,    24,     0,     0,     0,     0,
      25,     0,     0,  1943,   677,     0,     0,     0,     0,    26,
       0,     0,     0,     0,  1993,     0,  1944,     0,     0,     0,
      27,  2648,     0,     0,     0,  1272,  2657,     0,     0,     0,
       0,     0,   712,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,   712,     0,     0,  1945,  2698,  2698,     0,    28,     0,
       0,     0,   776,   677,     0,  1946,     0,     0,     0,     0,
      29,     0,     0,     0,  1273,    30,    31,     0,    32,     0,
     773,  1274,     0,    33,  1275,  1947,     0,     0,    34,     0,
    1948,    35,     0,     0,     0,    36,     0,     0,     0,     0,
      37,    38,     0,     0,     0,     0,     0,  2757,    39,  2760,
    2762,    40,     0,     0,     0,     0,     0,     0,     0,    41,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,    42,     0,     0,     0,     0,     0,     0,  1276,   773,
       0,     0,     0,     0,     0,     0,     0,   773,    43,     0,
    1673,     0,   773,  1674,     0,     0,     0,  1949,    44,     0,
       0,     0,     0,     0,    45,  1131,     0,     0,     0,    46,
    1675,     0,     0,     0,     0,     0,     0,     0,     0,  1677,
       0,     0,    47,     0,     0,  1678,     0,     0,  1950,     0,
       0,     0,     0,  1993,     0,  1277,  2698,  1278,   712,     0,
    2858,     0,     0,   651,     0,     0,     0,  1279,     0,  1679,
       0,     0,     0,     0,     0,  1280,     0,   194,    48,     0,
       0,  -121,     0,  1673,     0,  1281,  1674,     0,     0,  2757,
       0,     0,     0,     0,     0,     0,     0,   773,  2883,     0,
       0,     0,     0,  1675,     0,     0,     0,     0,     0,     0,
    1951,     0,  1677,     0,     0,     0,  1952,     0,  1678,  1953,
       0,  1283,  1284,     0,   773,     0,   773,  2698,   773,  2698,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,  1679,     0,     0,  1954,     0,  1285,  1131,     0,
       0,  1955,  1673,     0,     0,  1674,     0,     0,     0,     0,
    1563,     0,     0,     0,  1956,     0,     0,     0,     0,     0,
       0,  1680,  1675,     0,     0,  1681,     0,     0,     0,     0,
       0,  1677,     0,     0,     0,     0,     0,  1678,     0,  1957,
       0,     0,     0,     0,     0,     0,  1682,  1683,     0,     0,
       0,     0,     0,     0,     0,  1286,   768,     0,     0,     0,
       0,  1679,   768,  1684,     0,     0,     0,     0,  1673,     0,
       0,  1674,     0,   773,     0,     0,     0,     0,     0,     0,
    1131,  1131,     0,     0,     0,     0,  1131,     0,  1675,  1685,
       0,     0,  1686,     0,  1680,     0,     0,  1677,  1681,     0,
       0,     0,     0,  1678,     0,  1687,     0,     0,  1688,     0,
       0,  1131,  1131,     0,     0,     0,  1131,     0,     0,  1682,
    1683,     0,     0,     0,     0,     0,     0,  1679,  1131,  1131,
    1131,  1131,     0,     0,     0,     0,  1684,     0,     0,     0,
       0,  1131,     0,     0,  1131,     0,  1131,  3046,     0,     0,
       0,     0,     0,     0,     0,     0,  1131,  1131,     0,     0,
    1131,     0,  1685,  1680,     0,  1686,     0,  1681,     0,     0,
       0,     0,     0,  1131,     0,  1131,     0,   813,  1687,  1131,
       0,  1688,     0,  1689,     0,     0,     0,     0,  1682,  1683,
       0,     0,     0,     0,     0,     0,     0,     0,  1131,     0,
       0,  1673,   712,     0,  1674,  1684,     0,     0,  3099,     0,
       0,  1131,  1131,  1131,     0,     0,     0,     0,     0,     0,
       0,  1675,     0,     0,     0,     0,     0,     0,  1131,  1680,
    1677,  1685,     0,  1681,  1686,     0,  1678,     0,     0,     0,
    1131,     0,     0,     0,     0,  1131,     0,  1687,     0,     0,
    1688,  1131,     0,     0,  1682,  1683,  1689,     0,     0,  3099,
    1679,     0,  3135,     0,     0,     0,  2537,     0,  2897,     0,
       0,  1684,     0,     0,     0,     0,  1690,  1691,  1692,     0,
    1693,  1694,  1695,  1696,  1697,  1698,     0,  1245,     0,     0,
    3333,     0,     0,     0,     0,     0,     0,  1685,     0,     0,
    1686,     0,     0,     0,     0,     0,     0,  1131,     0,  2698,
       0,     0,     0,  1687,  1563,     0,  1688,     0,     0,  1246,
       0,     0,     0,     0,     0,  1689,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
     773,     0,   773,   773,   773,     0,     0,     0,     0,  1690,
    1691,  1692,     0,  1693,  1694,  1695,  1696,  1697,  1698,     0,
       0,     0,  1680,  3491,     0,     0,  1681,   567,     0,     0,
       0,     0,     0,   610,     0,  1247,     0,     0,     0,     0,
       0,     0,   660,     0,     0,     0,     0,  1682,  1683,     0,
       0,  1689,     0,     0,     0,     0,     0,     0,     0,     0,
       0,   724,     0,     0,  1684,     0,     0,  1248,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,  1690,  1691,
    1692,     0,  1693,  1694,  1695,  1696,  1697,  1698,     0,     0,
    1685,     0,  3538,  1686,     0,     0,  2898,     0,     0,     0,
       0,     0,     0,  1249,     0,     0,  1687,     0,     0,  1688,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,  1250,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,  1690,  1691,  1692,     0,  1693,  1694,
    1695,  1696,  1697,  1698,     0,     0,     0,     0,  3615,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,  2698,  2698,     0,  1689,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,    33,     0,
     781,     0,  1253,     0,     0,     0,     0,     0,  1254,  1673,
     816,   817,  1674,   820,     0,  1255,   826,     0,   828,     0,
       0,     0,     0,  1979,     0,     0,     0,     0,     0,  1675,
       0,     0,  1257,     0,   712,   712,     0,     0,  1677,     0,
    1258,     0,     0,     0,  1678,     0,     0,     0,     0,     0,
     712,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,  1563,   712,     0,     0,     0,  1679,     0,
       0,     0,  1563,   712,     0,     0,     0,  1690,  1691,  1692,
       0,  1693,  1694,  1695,  1696,  1697,  1698,   712,     0,     0,
       0,  3641,  1259,     0,     0,     0,  2900,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,   773,     0,     0,   773,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,   768,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,   712,     0,     0,     0,     0,
       0,     0,     0,     0,     0,   773,     0,     0,     0,     0,
    1680,     0,     0,  1131,  1681,     0,     0,     0,     0,     0,
       0,     0,     0,  1131,     0,     0,     0,     0,     0,  1131,
       0,  1131,     0,     0,     0,  1682,  1683,  1131,     0,     0,
    1131,  1131,  1131,  1131,  1131,  1131,  1131,  1131,  1131,  1131,
       0,     0,  1684,  1131,  1131,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,  1131,     0,     0,     0,
    1131,     0,     0,     0,  1131,     0,     0,  1673,  1685,     0,
    1674,  1686,     0,     0,  1131,     0,  1270,  1131,     0,  1131,
       0,     0,  1271,     0,  1687,     0,     0,  1688,  1131,  1131,
    1131,     0,     0,     0,  1131,     0,  1677,  1131,     0,     0,
       0,  3563,  1678,     0,     0,     0,     0,     0,   712,   712,
     712,   768,     0,  3099,  3580,     0,     0,     0,  3580,  3594,
       0,     0,     0,  1272,     0,  1131,  1679,     0,     0,     0,
       0,  1131,  1131,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,  1131,     0,     0,     0,     0,
       0,  1131,  1689,     0,     0,  2537,     0,  1131,     0,     0,
       0,     0,  1273,     0,     0,     0,     0,   879,     0,  1274,
       0,     0,  1275,     0,     0,   887,     0,     0,  3063,  3647,
    1563,  1563,     0,  2110,   903,   904,     0,     0,     0,   906,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
     922,   773,   773,   773,   773,     0,     0,     0,     0,     0,
       0,     0,     0,     0,   930,     0,     0,     0, -2278,     0,
       0,     0,  1681,     0,     0,     0,  1276,     0,  1673,     0,
     953,  1674,     0,   955,     0,   957,     0,   960,  3690,     0,
       0,     0,     0,  1682,  1683,  1690,  1691,  1692,  1675,  1693,
    1694,  1695,  1696,  1697,  1698,     0,     0,  1677,     0,  3896,
   -2278,  1673,     0,  1678,  1674,     0,     0,     0,     0,     0,
       0,     0,  1423,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,  1277,     0,  1278,     0,  1679,  1673,  1686,
    1677,  1674,     0,     0,     0,  1279,  1678,  1016,     0,  1017,
       0,     0,  1687,  1280,     0,     0,     0,     0,  1675,     0,
       0,     0,     0,  1281,  3756,     0,     0,  1677,     0,     0,
    1679,     0,     0,  1678,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,  1673,     0,
       0,  1674,     0,     0,     0,     0,  1336,  1679,     0,  1283,
    1284,     0,     0,     0,     0,   724,     0,     0,  1675,     0,
       0,     0,     0,     0,     0,   712,     0,  1677,     0,     0,
       0,     0,     0,  1678,     0,  1337,   773,     0,  1131,     0,
   -2278,     0,  3553,     0,   712,     0,     0,     0,     0,  1680,
    3822,     0,     0,  1681,     0,     0,     0,  1679,     0,  1993,
       0,     0,     0,     0,  1423,     0,     0,     0,     0,     0,
       0,   712,     0,  1236,  1682,  1683,     0,     0,     0,     0,
       0,  2757, -2278,     0,     0,     0,  1681,  3850,     0,     0,
       0,  1684,     0,  1286,     0,     0,     0,     0,     0,     0,
       0,     0,     0,  1131,  1131,     0,     0,  1682,  1683,  1680,
       0,     0,     0,  1681,     0,     0,     0,  1685,     0,     0,
    1686,     0,     0,     0, -2278,     0,  2698,     0,  2698,  1365,
       0,     0,     0,  1687,  1682,  1683,  1688,  1693,  1694,  1695,
    1696,  1697,  1698,     0,  1377,     0,     0,     0,     0,     0,
       0,  1684,     0,  1686,     0,     0,     0,  1387,     0,  1680,
       0,     0,  1131,  1681,  1389,     0,  1687,     0,     0,     0,
       0,     0,     0,     0,     0,     0,  1437,  1685,     0,  1441,
    1686,     0,     0,     0,  1682,  1683,     0,     0,     0,     0,
       0,     0,     0,  1687,     0,     0,  1688,     0,     0,  1131,
       0,  1684,     0,     0,     0,     0,     0,     0,     0,  1131,
    1131,  1689,  1484,     0,     0,     0,     0,  1131,  1131,     0,
       0,     0,  1131,     0,     0,     0,     0,  1685,  1131,  1131,
    1686,     0,  1131,     0,     0,  1131,  3934,     0,     0,   712,
     712,   712,   712,  1687, -2278,     0,  3580,  3594,     0,  3580,
       0,     0,  3943,     0,     0,     0,  3099,     0,     0,     0,
    3099,     0,  1423,     0,     0,     0,  3956,     0,     0,     0,
       0,  1689,  1131,     0,     0,     0,     0,  1131,     0,     0,
       0,     0,  1131,     0,     0,  1270,     0,     0,   813,     0,
       0,  1271,     0,     0,     0,  1673,  3135,     0,  1674,     0,
    2537,     0,     0,     0,  1690,  1691,  1692,     0,  1693,  1694,
    1695,  1696,  1697,  1698,   651,  1675,  1423,  1131,  3930,     0,
       0,  1689,     0,     0,  1677,     0,     0,     0,     0,     0,
    1678,     0,  1272,     0,     0,     0,     0,  2698,  2698,     0,
       0,  1693,  1694,  1695,  1696,  1697,  1698,     0,     0,     0,
       0,     0,  1423,     0,  1679,     0,     0,     0,     0,     0,
       0,  4012,     0,     0,  1690,  1691,  1692,     0,  1693,  1694,
    1695,  1696,  1697,  1698,     0,     0,     0,     0,  4152,     0,
       0,  1273,     0,     0,     0,     0,     0,     0,  1274,     0,
       0,  1275,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,  1673,
       0,   773,  1674,     0,  1690,  1691,  1692,     0,  1693,  1694,
    1695,  1696,  1697,  1698,     0,   773,     0,     0,  1423,  1675,
       0,     0,     0,     0,     0,     0,     0,     0,  1677,     0,
       0,     0,     0,     0,  1678,  1276,     0,  1423,     0,     0,
       0,     0,     0,     0,     0,     0,  1680,     0,     0,     0,
    1681,     0,  1673,     0,     0,  1674,     0,  1423,  1679,     0,
       0,     0,     0,   724,  1838,     0,     0,     0,     0,     0,
       0,  1682,  1683,  1131,     0,     0,     0,     0,     0,     0,
       0,  1677,  1423,     0,   768,     0,     0,  1678,  1684,  1993,
       0,     0,  1277,     0,  1278,     0,  1563,     0,     0,     0,
       0,     0,     0,     0,  1279,     0,     0,     0,   773,  1993,
       0,  1679,  1280,     0,  1685,     0,     0,  1686,     0,     0,
       0,     0,  1281,     0,     0,     0,  1959,     0,     0,     0,
    1687,     0,     0,  1688,   712,     0,     0,     0,     0,  1423,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,  1362,     0,     0,  1283,  1284,
    1680,     0,     0,  1131,  1681,     0,     0,     0,     0,     0,
       0,     0,  1131,  3554,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,  1363,  1682,  1683,     0,     0,  1131,
    1131,     0,     0,  1131,     0,     0,     0,     0,     0,     0,
       0,     0,  1684,     0,     0,     0,   768,  3580,  1689,     0,
       0,  3099,     0, -2278,     0,     0,  3099,  1681,     0,  3099,
    2757,     0,  4180,     0,  1131,  1131,     0,     0,  1685,     0,
       0,  1686,     0,     0,     0,     0,     0,     0,  1682,  1683,
       0,     0,  1286,     0,  1687,     0,     0,  1688,     0,  3647,
     813,   773,   773,   773,     0, -2278,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,  1686,     0,     0,     0,     0,     0,
       0,   768,   813,     0,     0,     0,     0,  1687,     0,     0,
       0,  1690,  1691,  1692,     0,  1693,  1694,  1695,  1696,  1697,
    1698,     0,     0,     0,     0,  4161,  1423,     0,     0,     0,
       0,     0,  1689,     0,     0,     0,     0,     0,  2166,     0,
       0,     0,  1563,  1563,     0,     0,  1673,   768,     0,  1674,
     712,     0,     0,  2189,     0,     0,     0,     0,     0,     0,
       0,  3822,     0,     0,     0,     0,  1675,     0,  2698,     0,
       0,     0,  1993,     0,     0,  1677,     0,     0,     0,     0,
       0,  1678,     0,     0,  3850, -2278,     0,   712,     0,     0,
       0,     0,     0,  2234,     0,   773,  3647,     0,     0,     0,
       0,     0,     0,     0,     0,  1679,     0,     0,  2249,     0,
    2251,     0,  2252,     0,     0,     0,     0,  2253,  1131,     0,
       0,  1131,     0,  1131,     0,  1690,  1691,  1692,     0,  1693,
    1694,  1695,  1696,  1697,  1698,     0,     0,     0,     0,  4194,
       0,     0,     0,     0,     0,     0,  1131,     0,     0,     0,
    3099,     0,     0,  4180,     0,     0,     0,     0,     0,  4335,
    1838,     0,     0,     0,  1838,     0,  1838,     0,     0,  1838,
       0,     0,     0,     0,     0,   773,     0,     0,     0,   712,
       0,     0,  1693,  1694,  1695,  1696,  1697,  1698,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,   773,   773,   773,   773,  1680,     0,     0,
       0,  1681,     0,     0,     0,     0,     0,     0,  1563,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,  1682,  1683,     0,  1423,     0,   768,     0,  1423,
    1423,     0,     0,     0,     0,     0,     0,     0,     0,  1684,
       0,     0,     0,     0,  1673,     0,  1131,  1674,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,  1675,  1685,     0,     0,  1686,     0,
       0,     0,     0,  1677,     0,     0,     0,     0,     0,  1678,
       0,  1687,  1131,     0,  1688,   768,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,  1679,     0,   773,     0,   813,     0,     0,
       0,     0,     0,     0,     0,     0,  1673,  1131,     0,  1674,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,  1423,  1675,     0,     0,     0,
       0,     0,     0,     0,     0,  1677,     0,     0,     0,     0,
       0,  1678,     0,     0,     0,     0,     0,     0,     0,  1689,
     773,     0,     0,  1673,     0,   768,  1674,     0,     0,     0,
       0,     0,     0,     0,     0,  1679,  3647,     0,     0,     0,
       0,     0,     0,  1675,     0,     0,     0,     0,  1131,  1131,
       0,     0,  1677,  2757,     0,     0,     0,  4335,  1678,     0,
       0,     0,     0,     0,  1673,  1680,     0,  1674,     0,  1681,
       0,   768,     0,     0,     0,     0,     0,     0,     0,     0,
     773,     0,  1679,     0,  1675,     0,     0,     0,     0,     0,
    1682,  1683,     0,  1677,     0,     0,     0,     0,     0,  1678,
       0,     0,     0,     0,     0,     0,     0,  1684,     0,     0,
       0,  1131,  1690,  1691,  1692,     0,  1693,  1694,  1695,  1696,
    1697,  1698,     0,  1679,     0,  1131,  4255,     0,     0,     0,
       0,     0,   773,  1685,     0,     0,  1686,  1680,     0,     0,
       0,  1681,  2555,  2556,  1423,     0,     0,  2559,  2560,  1687,
       0,  2563,  1688,     0,     0,     0,     0,     0,     0,     0,
       0,  2573,  1682,  1683,     0,     0,     0,     0,  2582,     0,
       0,     0,  2585,  2586,     0,     0,  2589,  2590,     0,  1684,
       0,     0,     0,  2595,  1680,     0,     0,  1673,  1681,     0,
    1674,     0,     0,  1131,     0,  2611,     0,  2613,     0,     0,
       0,     0,   768,  4540,     0,  1685,     0,  1675,  1686,  1682,
    1683,     0,  2506,  2635,     0,     0,  1677,     0,  2637,     0,
       0,  1687,  1678,  1423,  1688,  1680,  1684,  1689,     0,  1681,
       0,  2642,     0,     0,     0,     0,     0,     0,     0,  2647,
       0,  2649,  2650,  2653,  2655,     0,  1679,     0,  2662,  2665,
    1682,  1683,  1685,     0,     0,  1686,  2676,     0,     0,     0,
    2685,     0,     0,     0,  2689,     0,     0,  1684,  1687,     0,
       0,  1688,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,  2718,
       0,  2507,     0,  1685,     0,     0,  1686,     0,     0,  1689,
    2725,     0,  2727,     0,     0,     0,     0,  2730,  1423,  1687,
       0,  2731,  1688,  2735,  2736,  2737,  2738,     0,  2740,     0,
    1690,  1691,  1692,     0,  1693,  1694,  1695,  1696,  1697,  1698,
    4541,  2764,  2765,  2766,  4473,     0,     0,     0,     0,     0,
       0,     0,     0,     0,  2774,  2775,  1689,     0,  1680,     0,
    1673,     0,  1681,  1674,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
    1675,     0,     0,  1682,  1683,     0,     0,     0,     0,  1677,
       0,     0,     0,     0,     0,  1678,     0,  1689,     0,     0,
    1684,     0,  1690,  1691,  1692,     0,  1693,  1694,  1695,  1696,
    1697,  1698,     0,     0,     0,     0,  4569,     0,  2832,  1679,
       0,     0,     0,     0,     0,     0,  1685,     0,     0,  1686,
       0,     0,     0,     0,     0,  1270,     0,     0,     0,     0,
       0,  1271,  1687,     0,     0,  1688,     0,     0,     0,  1690,
    1691,  1692,     0,  1693,  1694,  1695,  1696,  1697,  1698,     0,
       0,  3611,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
    1270,  1673,  1272,     0,  1674,     0,  1271,     0,     0,     0,
    1690,  1691,  1692,     0,  1693,  1694,  1695,  1696,  1697,  1698,
    3018,  1675,     0,     0,     0,  3019,     0,     0,     0,     0,
    1677,     0,     0,     0,     0,     0,  1678,     0,     0,     0,
    1689,  1680,     0,     0,     0,  1681,     0,  1272,     0,     0,
       0,  1273,     0,     0,     0,     0,     0,  1838,  1274,     0,
    1679,  1275,     0,     0,     0,     0,  1682,  1683,     0,     0,
       0,  1423,     0,     0,  1423,     0,  1423,     0,     0,     0,
       0,  1423,     0,  1684,     0,     0,  2956,  1673,     0,     0,
    1674,  2508,     0,     0,     0,     0,  1273,     0,     0,     0,
       0,     0,     0,  1274,     0,     0,  1275,  1675,     0,  1685,
       0,  2981,  1686,     0,     0,  1276,  1677,     0,     0,     0,
       0,     0,  1678,     0,     0,  1687,     0,     0,  1688,     0,
       0,  1423,     0,  1690,  1691,  1692,     0,  1693,  1694,  1695,
    1696,  1697,  1698,     0,     0,     0,  1679,     0,     0,     0,
    1673,     0,     0,  1674,     0,     0,     0,     0,     0,     0,
    1276,     0,  1680,     0,     0,     0,  1681,     0,     0,     0,
    1675,  1423,  1277,     0,  1278,     0,     0,     0,     0,  1677,
       0,     0,     0,     0,  1279,  1678,     0,  1682,  1683,     0,
       0,     0,  1280,     0,     0,     0,     0,     0,     0,     0,
       0,     0,  1281,  1689,  1684,     0,     0,     0,     0,  1679,
       0,     0,     0,     0,     0,     0,     0,  1277,     0,  1278,
       0,     0,     0,     0,     0,     0,     0,     0,     0,  1279,
    1685,     0,  1423,  1686,  1423,  1961,     0,  1280,  1283,  1284,
       0,     0,     0,     0,     0,     0,  1687,  1281,  1680,  1688,
       0,     0,  1681,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,  1962,     0,     0,     0,     0,  3530,
       0,     0,     0,  1682,  1683,     0,     0,  3116,     0,     0,
    2027,     0,     0,  1283,  1284,     0,     0,     0,     0,  1423,
    1684,     0,     0,     0,     0,     0,  1690,  1691,  1692,     0,
    1693,  1694,  1695,  1696,  1697,  1698,     0,     0,     0,  2028,
       0,  1680,     0,     0,  1423,  1681,  1685,     0,     0,  1686,
       0,     0,  1286,     0,  1689,     0,  3152,  3153,     0,     0,
       0,     0,  1687,  1423,     0,  1688,  1682,  1683,  3531,     0,
       0,     0,     0,  1838,     0,     0,     0,     0,     0,     0,
       0,  1423,     0,  1684,     0,     0,     0,     0,     0,     0,
       0,  1673,     0,     0,  1674,     0,     0,  1286,  3175,     0,
       0,     0,     0,     0,     0,     0,     0,  3179,     0,  1685,
       0,  1675,  1686,     0,     0,  3026,     0,     0,     0,     0,
    1677,     0,  3190,  3192,     0,  1687,  1678,  3192,  1688,     0,
       0,     0,  3203,  3204,  3205,     0,     0,     0,     0,     0,
    1689,     0,     0,  2996,     0,  1423,     0,  1690,  1691,  1692,
    1679,  1693,  1694,  1695,  1696,  1697,  1698,     0,     0,     0,
       0,  1423,  3225,  3226,  3227,  3228,     0,     0,     0,     0,
       0,     0,  1423,     0,     0,     0,     0,     0,     0,   770,
    1270,     0,     0,     0,     0,     0,  1271,     0,   770,   790,
       0,     0,     0,     0,     0,   790,  3242,     0,  3246,  3247,
    3248,  1673,     0,  1689,  1674,     0,   790,     0,  3261,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,  1270,
       0,  1675,     0,     0,     0,  1271,     0,  1272,     0,     0,
    1677,     0,     0,  1690,  1691,  1692,  1678,  1693,  1694,  1695,
    1696,  1697,  1698,  1423,     0,     0,     0,     0,     0,     0,
       0,     0,  1680,     0,     0,     0,  1681,     0,     0,     0,
    1679,     0,     0,  1423,     0,     0,  1272,     0,     0,     0,
       0,     0,     0,  3302,     0,     0,  1273,  1682,  1683,     0,
       0,  3306,     0,  1274,     0,     0,  1275,     0,  1423,     0,
       0,     0,     0,     0,  1684,     0,  1690,  1691,  1692,     0,
    1693,  1694,  1695,  1696,  1697,  1698,     0,     0,     0,     0,
       0,     0,     0,     0,     0,  1273,     0,     0,     0,     0,
    1685,     0,  1274,  1686,  1423,  1275,     0,     0,     0,     0,
       0,     0,  1673,     0,     0,  1674,  1687,     0,  3378,  1688,
    1276,     0,     0,     0,     0,     0,  3031,     0,     0,     0,
       0,     0,  1675,     0,     0,     0,  3037,     0,     0,     0,
       0,  1677,  1680,     0,     0,     0,  1681,  1678,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,  1276,
    3407,     0,     0,  3410,     0,     0,     0,  1682,  1683,     0,
       0,  1679,     0,     0,     0,     0,     0,  1277,     0,  1278,
       0,     0,     0,     0,  1684,     0,     0,     0,     0,  1279,
    1423,     0,     0,     0,  1689,  3448,     0,  1280,     0,     0,
       0,     0,     0,     0,     0,     0,     0,  1281,     0,  3458,
    1685,     0,     0,  1686,     0,     0,  1277,     0,  1278,  1838,
       0,     0,     0,     0,     0,     0,  1687,     0,  1279,  1688,
       0,     0,     0,     0,     0,     0,  1280,     0,     0,     0,
    2643,     0,     0,  1283,  1284,     0,  1281,     0,     0,     0,
       0,     0,     0,     0,     0,  1673,     0,     0,  1674,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,  1285,
       0,     0,     0,  1680,     0,  1675,     0,  1681,     0,  2732,
       0,  1423,  1283,  1284,  1677,     0,     0,  1690,  1691,  1692,
    1678,  1693,  1694,  1695,  1696,  1697,  1698,     0,  1682,  1683,
       0,     0,     0,     0,  1689,     0,     0,     0,  2733,     0,
       0,     0,   770,     0,  1679,  1684,     0,     0,     0,     0,
       0,     0,     0,     0,   790,     0,     0,  1286,   790,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,   790,
       0,  1685,     0,     0,  1686,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,   790,     0,  1687,     0,   770,
    1688,     0,     0,     0,     0,     0,  1286,     0,     0,   770,
     790,     0,     0,     0,     0,   790,     0,     0,     0,     0,
       0,     0,     0,     0,     0,   790,     0,     0,     0,     0,
       0,     0,     0,   790,     0,     0,     0,  1690,  1691,  1692,
       0,  1693,  1694,  1695,  1696,  1697,  1698,     0,     0,     0,
       0,     0,     0,     0,     0,     0,  1680,     0,     0,  1673,
    1681,     0,  1674,     0,     0,     0,     0,     0,     0,     0,
       0,     0,  1423,     0,     0,  1689,     0,     0,     0,  1675,
       0,  1682,  1683,  3537,     0,     0,     0,     0,  1677,     0,
       0,     0,     0,     0,  1678,  3658,     0,  3659,  1684,     0,
       0,     0,     0,     0,  3661,     0,     0,     0,   770,  1423,
       0,     0,     0,   790,     0,     0,     0,     0,  1679,     0,
    3670,     0,     0,     0,  1685,     0,     0,  1686,     0,     0,
       0,     0,     0,     0,     0,  3678,     0,     0,     0,   770,
    1687,     0,     0,  1688,     0,  3689,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
    3692,     0,     0,     0,     0,     0,     0,     0,  1690,  1691,
    1692,     0,  1693,  1694,  1695,  1696,  1697,  1698,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,  3724,  3725,  3726,     0,     0,  3729,  3730,
    3731,  3732,  3733,     0,     0,     0,     0,  3740,  3741,     0,
    3743,  3744,  3745,  3746,  3747,  3748,  3749,     0,  1689,  1423,
    1680,     0,     0,     0,  1681,  3757,     0,  3759,  3760,     0,
    1423,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,  3487,  1682,  1683,     0,     0,  1270,
       0,     0,     0,     0,     0,  1271,     0,     0,     0,     0,
       0,     0,  1684,     0,     0,     0,   770,     0,     0,     0,
    1673,     0,     0,  1674,     0,     0,     0,   770,     0,     0,
       0,  3803,  3805,  3807,     0,     0,  3810,     0,  1685,     0,
    1675,  1686,     0,     0,     0,     0,  1272,     0,     0,  1677,
    1433,     0,     0,     0,  1687,  1678,  1673,  1688,     0,  1674,
       0,  1690,  1691,  1692,     0,  1693,  1694,  1695,  1696,  1697,
    1698,     0,     0,     0,  1673,     0,     0,  1674,     0,  1679,
       0,     0,     0,     0,     0,  1677,     0,   770,     0,     0,
       0,  1678,  1423,     0,     0,  1273,     0,     0,     0,     0,
       0,     0,  1274,  1677,     0,  1275,     0,     0,     0,  1678,
       0,     0,     0,     0,     0,  1679,     0,     0,  3192,   790,
    1423,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,  1689,  1679,   790,  1838,  1838,  1838,   770,  1423,
       0,     0,     0,     0,     0,     0,   790,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,  1276,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,   790,     0,     0,  3557,     0,     0,
       0,  1680,  1433,     0,   790,  1681,     0,  1423,     0,     0,
       0,     0,     0,     0,     0,  3928,     0,   790,     0,     0,
     790,     0,     0,     0,     0,     0,  1682,  1683,     0,     0,
       0,     0,   770,     0,     0,     0,  1277, -2278,  1278,     0,
       0,  1681,     0,  1684,     0,  1690,  1691,  1692,  1279,  1693,
    1694,  1695,  1696,  1697,  1698, -2278,  1280,     0,     0,  1681,
       0,   770,  1682,  1683,     0,     0,  1281,     0,     0,  1685,
       0,     0,  1686,     0,     0,     0,     0,     0,     0, -2278,
    1682,  1683,     0,     0,     0,  1687,     0,     0,  1688,   770,
     770,     0,   770,     0,     0,     0,     0, -2278,     0,  2771,
       0,     0,  1283,  1284,     0,     0,     0,     0,  1686,     0,
       0,   770,     0,     0,     0,     0,     0,     0,     0,     0,
       0,  1687,     0,     0,     0,     0,  1686,  1270,  2772,     0,
       0,     0,     0,  1271,   790,     0,     0,     0,     0,  1687,
       0,     0,   790,   790,     0,     0,     0,     0,     0,     0,
       0,   770,  1823,     0,  1423,     0,     0,     0,     0,  1312,
       0,     0,     0,  1689,     0,  4001,  4002,  4003,  4004,     0,
       0,  4006,     0,     0,  1272,     0,     0,     0,     0,     0,
     770,     0,     0,     0,   770,   770,  1286,     0,     0,     0,
       0,     0,  4019,  4020,  4021,  4022,     0,  4024,  4025, -2278,
    1433,     0,     0,     0,     0,  1313,  1823,     0,     0,  4034,
    4035,     0,     0,     0,     0,     0,     0, -2278,     0,     0,
       0,     0,  4037,  1273,     0,     0,     0,     0,  1838,  1838,
    1274,  1838,     0,  1275,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,  1433,     0,  1690,  1691,  1692,     0,
    1693,  1694,  1695,  1696,  1697,  1698,     0,     0,  1423,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,  1314,     0,     0,  1276,     0,     0,
    1433,     0,     0,     0,     0,     0,  1693,  1694,  1695,  1696,
    1697,  1698,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,  1693,  1694,  1695,  1696,  1697,  1698,
    4092,     0,     0,     0,     0,  1270,     0,     0,     0,  4098,
       0,  1271,  1315,     0,  1316,     0,     0,     0,     0,     0,
       0,     0,     0,     0,  1317,     0,  1278,   790,     0,  4117,
       0,     0,     0,     0,     0,     0,  1279,     0,     0,     0,
       0,     0,     0,     0,  1280,     0,  1433,     0,     0,     0,
    1270,  4134,  1272,  1318,  1281,  1423,  1271,     0,     0,     0,
       0,     0,     0,     0,     0,  1433,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,  1423,     0,     0,     0,
       0,     0,     0,     0,     0,  1433,     0,  1319,     0,     0,
    1283,  1284,  1320,     0,     0,     0,     0,  1272,     0,     0,
       0,  1273,     0,     0,     0,  1823,     0,     0,  1274,     0,
    1433,  1275,  1423,     0,     0,     0,  1321,     0,  1838,     0,
       0,     0,     0,     0,     0,   790,     0,  1322,     0,     0,
       0,  1838,     0,     0,     0,     0,     0,   846,     0,     0,
       0,   790,     0,     0,     0,     0,  1273,     0,     0,     0,
    1423,     0,     0,  1274,  1423,  1423,  1275,     0,     0,     0,
       0,   770,     0,     0,     0,  1276,     0,  1433,     0,     0,
     770,   847,   790,   790,  1286,     0,     0,     0,     0,     0,
       0,     0,     0,   790,   848,   849,     0,     0,     0,     0,
       0,     0,  4216,   850,     0,   790,   790,   851,     0,     0,
       0,     0,     0,     0,     0,     0,     0,   790,     0,     0,
    1276,     0,  4227,     0,   852,     0,     0,     0,     0,   791,
       0,     0,  1277,     0,  1278,   791,     0,     0,     0,     0,
       0,     0,     0,     0,  1279,   853,   791,     0,     0,   770,
       0,     0,  1280,     0,     0,     0,   854,     0,     0,     0,
       0,     0,  1281,     0,   855,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,   856,  1277,     0,  1278,
       0,   857,     0,     0,   770,     0,   770,     0,     0,  1279,
       0,     0,     0,   770,     0,  3200,   770,  1280,  1283,  1284,
     770,     0,   858,     0,     0,     0,     0,  1281,   770,   770,
       0,     0,     0,  3192,     0,     0,   770,     0,     0,   770,
     770,   770,   770,     0,  3201,     0,     0,   859,     0,   770,
     770,     0,   770,     0,   770,   770,     0,     0,   770,     0,
    3243,     0,     0,  1283,  1284,     0,     0,     0,   860,     0,
       0,     0,  1838,     0,  1433,   770,  1823,     0,     0,     0,
     770,     0,  1838,     0,   770,     0,     0,     0,   770,  3244,
     770,   770,   770,   770,   770,   770,   770,   770,   770,   861,
     770,     0,  1286,     0,     0,     0,     0,     0,   770,   770,
       0,     0,  4349,     0,     0,     0,     0,     0,     0,     0,
       0,  4356,     0,     0,     0,     0,     0,     0,   194,     0,
       0,     0,     0,     0,     0,   532,  1838,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,  1286,   533,     0,
       0,     0,     0,     0,     0,   862,     0,     0,     0,   863,
       0,   864,     0,     0,     0,     0,     0,   865,     0,   534,
     866,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,   535,     0,     0,     0,     0,     0,     0,     0,
       0,   536,     0,     0,     0,  -739,   867,     0,   868,     0,
       0,     0,   869,     0,     0,     0,     0,     0,     0,  3192,
     870,     0,   537,     0,     0,   871,     0,     0,   538,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
    1838,     0,     0,   539,     0,   770,     0,     0,     0,     0,
     872,     0,     0,     0,   540,     0,     0,     0,     0,     0,
       0,     0,   541,     0,  4443,     0,     0,     0,     0,     0,
       0,     0,   179,     0,   542,     0,     0,     0,  4454,     0,
       0,   543,     0,     0,     0,   544,     0,     0,     0,     0,
       0,     0,     0,  1433,     0,     0,     0,  1433,  1433,     0,
    -934,     0,     0,  4465,     0,     0,     0,   790,  4469,     0,
       0,  1823,   790,     0,   791,   790,     0,     0,   791,   180,
       0,     0,     0,     0,     0,     0,     0,     0,     0,   791,
       0,     0,   181,     0,     0,     0,     0,   790,     0,   545,
     770,     0,     0,     0,     0,   791,  -505,     0,     0,   182,
       0,   770,     0,     0,     0,   183,     0,     0,   770,  4505,
     791,     0,     0,     0,     0,   791,     0,     0,     0,     0,
     184,     0,     0,     0,     0,   791,     0,   546,   790,     0,
     547,   185,     0,   791,     0,     0,     0,     0,     0,   186,
       0,     0,     0,     0,     0,   790,   790,     0,     0,     0,
       0,   187,     0,  1433,     0,     0,   188,     0,     0,     0,
       0,     0,   189,     0,     0,  -401,     0,     0,     0,     0,
    1823,   790,     0,     0,  1823,     0,     0,   190,     0,     0,
       0,     0,     0,   548,     0,     0,     0,     0,     0,   549,
       0,     0,     0,     0,     0,  -401,     0,     0,   550,     0,
     790,     0,   191,     0,   790,     0,     0,     0,     0,     0,
       0,     0,     0,   791,     0,     0,     0,     0,     0,     0,
       0,     0,   790,   192,  -401,     0,   551,   552,     0,   553,
     554,     0,     0,   790,     0,     0,     0,     0,   555,     0,
       0,     0,  1270,   556,     0,     0,   790,     0,  1271,   557,
       0,     0,   558,     0,   193,   559,   790,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,  -401,     0,
       0,     0,     0,     0,  1312,     0,     0,     0,     0,     0,
       0,     0,     0,   194,     0,     0,     0,     0,     0,  1272,
       0,     0,     0,     0,     0,     0,   579,     0,     0,     0,
     770,     0,  1433,     0,     0,     0,     0,     0,     0,   580,
     195,     0,     0,     0,   196,     0,   197,     0,     0,     0,
    1313,     0,   198,  1823,     0,   199,     0,     0,     0,     0,
     581,     0,     0,     0,     0,     0,     0,     0,  1273,     0,
       0,     0,     0,   582,     0,  1274,     0,     0,  1275,     0,
     200,   201,     0,   202,     0,     0,   583,   203,     0,     0,
       0,     0,     0,     0,     0,   204,     0,     0,     0,     0,
     205,     0,     0,   584,     0,     0,     0,     0,     0,     0,
       0,  1433,   206,     0,   790,     0,     0,     0,     0,     0,
       0,     0,     0,     0,   585,   207,     0,     0,     0,  1314,
       0,     0,  1276,     0,     0,   586,     0,     0,     0,     0,
       0,     0,     0,   587,     0,     0,     0,     0,   790,     0,
       0,     0,     0,   770,     0,   588,     0,     0,     0,     0,
     589,     0,     0,     0,     0,     0,   590,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,  1315,     0,  1316,
       0,   591,     0,   790,     0,     0,     0,     0,     0,  1317,
       0,  1278,     0,     0,     0,     0,  1433,     0,     0,   791,
       0,  1279,     0,     0,     0,     0,     0,   790,     0,  1280,
       0,   770,     0,     0,   791,     0,     0,   770,  1318,  1281,
       0,     0,     0,     0,     0,     0,   791,   592,     0,     0,
       0,     0,     0,     0,     0,   770,   770,     0,     0,     0,
       0,   770,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,  2719,     0,   791,  1283,  1284,  1320,   593,     0,
       0,     0,     0,     0,   791,     0,   770,   770,     0,   594,
       0,   770,     0,     0,     0,     0,     0,   791,     0,     0,
     791,  2720,     0,   770,   770,   770,   770,   194,     0,     0,
       0,  1823,  1322,     0,     0,     0,   770,  1823,     0,   770,
       0,   770,     0,     0,     0,     0,     0,     0,     0,     0,
       0,   770,   770,     0,   595,   770,     0,     0,   596,     0,
     597,     0,     0,     0,     0,     0,   598,     0,   770,   599,
     770,     0,     0,     0,   770,     0,     0,     0,     0,  1286,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,   770,     0,   600,     0,   601,     0,     0,
       0,   602,     0,   770,     0,     0,   770,   770,   770,   603,
       0,     0,     0,     0,   604,     0,     0,     0,     0,     0,
     790,     0,     0,   770,     0,     0,   605,     0,     0,     0,
       0,     0,     0,     0,   791,   770,     0,     0,     0,   606,
     770,     0,   791,   791,     0,     0,   770,     0,     0,     0,
       0,     0,  1824,     0,   770,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,  1433,
       0,     0,  1433,     0,  1433,     0,     0,   792,     0,  1433,
       0,   790,     0,   792,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,   792,     0,   790,   790,     0,     0,
       0,     0,   770,     0,     0,     0,  1824,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,   790,     0,     0,   790,     0,     0,  1433,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,  1433,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,  1823,  1823,  1823,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,   790,     0,     0,     0,     0,     0,     0,     0,     0,
    1433,     0,  1433,   790,     0,     0,     0,     0,     0,     0,
       0,     0,     0,   790,     0,     0,     0,   791,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,  1433,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,   790,     0,     0,     0,
       0,     0,  1433,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,  1824,     0,     0,     0,     0,
       0,  1433,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,   791,     0,     0,  1823,  1433,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,   791,     0,   790,     0,   790,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,   790,     0,   790,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,   791,   791,     0,     0,     0,     0,     0,     0,
       0,     0,     0,   791,     0,     0,     0,     0,     0,     0,
       0,     0,     0,  1433,     0,   791,   791,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,   791,   790,  1433,
       0,     0,   792,     0,     0,     0,   792,     0,     0,     0,
    1433,     0,     0,     0,     0,     0,     0,   792,     0,     0,
       0,     0,     0,     0,     0,     0,   790,     0,     0,     0,
       0,     0,     0,   792,     0,     0,     0,   770,     0,     0,
     790,     0,     0,     0,     0,     0,     0,     0,   792,     0,
       0,     0,     0,   792,     0,     0,     0,     0,     0,   790,
       0,     0,   790,   792,     0,     0,     0,     0,     0,  1432,
       0,   792,     0,     0,     0,     0,     0,     0,   770,     0,
       0,  1433,     0,     0,     0,     0,     0,     0,   770,     0,
       0,     0,     0,     0,   770,     0,   770,     0,     0,     0,
       0,  1433,   770,     0,     0,   770,   770,   770,   770,   770,
     770,   770,   770,   770,   770,     0,     0,     0,   770,   770,
       0,     0,     0,     0,     0,     0,  1433,     0,     0,     0,
       0,   770,     0,     0,     0,   770,  1824,  1823,     0,   770,
       0,     0,     0,     0,     0,     0,     0,     0,     0,   770,
       0,   792,   770,     0,   770,     0,     0,     0,     0,     0,
       0,     0,  1433,   770,   770,   770,     0,     0,     0,   770,
       0,     0,   770,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,   770,     0,   770,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
     770,  1432,     0,     0,     0,     0,   770,   770,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
     770,     0,     0,     0,     0,     0,   770,     0,     0,     0,
       0,     0,   770,     0,     0,     0,     0,     0,  1433,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,   770,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,   790,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,  1823,     0,     0,     0,     0,  1823,  1433,
    1823,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,   791,     0,     0,
       0,  1824,   791,     0,     0,   791,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,   790,     0,     0,   790,     0,   791,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,  1893,
       0,     0,     0,     0,     0,     0,     0,   792,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,  1823,
       0,     0,   792,     0,     0,     0,     0,     0,   791,     0,
       0,     0,     0,     0,   792,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,   791,   791,     0,     0,     0,
       0,     0,     0,  1893,     0,     0,     0,     0,     0,     0,
       0,     0,   792,   770,     0,     0,     0,     0,     0,     0,
    1824,   791,   792,     0,  1824,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,   792,   790,   790,   792,  1432,
    1433,     0,     0,   790,     0,     0,     0,     0,     0,     0,
     791,     0,     0,     0,   791,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,   791,     0,     0,     0,     0,  1433,   770,   770,
       0,     0,     0,   791,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,   791,     0,     0,     0,
       0,     0,     0,     0,     0,     0,   791,     0,     0,     0,
       0,     0,     0,     0,     0,  1432,     0,     0,     0,   790,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,  1893,     0,     0,   770,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,   792,     0,  1432,     0,     0,     0,     0,     0,
     792,   792,     0,     0,     0,     0,     0,     0,     0,     0,
    1825,     0,     0,  1824,   770,     0,     0,     0,     0,  1432,
       0,     0,     0,     0,   770,   770,     0,  1433,     0,     0,
       0,     0,   770,   770,     0,     0,     0,   770,  1433,     0,
       0,     0,     0,   770,   770,     0,     0,   770,     0,     0,
     770,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,  1825,     0,     0,     0,     0,     0,
       0,   770,     0,     0,   791,   770,  1432,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,   770,     0,     0,
       0,     0,   770,     0,     0,     0,     0,   770,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,   791,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,   770,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,   791,     0,     0,     0,     0,     0,     0,
    1433,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,   790,   791,     0,  1823,
       0,     0,     0,     0,     0,     0,     0,     0,  1433,     0,
       0,     0,     0,     0,     0,  1115,     0,     0,     0,     0,
       0,     0,   790,     0,     0,     0,     0,  1433,     0,     0,
       0,     0,     0,     0,   790,   792,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,  1175,   790,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,  1433,     0,     0,     0,     0,
       0,  1824,     0,  1432,     0,     0,     0,  1824,     0,     0,
     790,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,  1825,     0,     0,     0,     0,  2485,     0,
       0,     0,     0,     0,     0,     0,     0,     0,   770,     0,
       0,     0,     0,   792,     0,     0,     0,     0,     0,   770,
       0,     0,     0,     0,     0,     0,     0,     0,     0,   792,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
     791,     0,     0,     0,     0,     0,     0,     0,     0,     0,
     792,   792,     0,     0,     0,     0,  1433,     0,     0,     0,
       0,   792,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,   792,   792,     0,   790,     0,     0,     0,
       0,     0,     0,     0,     0,   792,     0,     0,   770,     0,
       0,     0,  1433,     0,     0,     0,     0,   770,     0,     0,
       0,   791,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,   770,   770,   791,   791,   770,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,   770,     0,     0,     0,     0,   770,     0,     0,     0,
       0,   770,     0,   791,   770,     0,   791,     0,     0,   770,
     770,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,  2540,     0,     0,     0,  1893,  2546,   790,     0,
     790,     0,     0,     0,   770,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,  1433,   790,     0,     0,
       0,     0,     0,     0,     0,     0,   770,  1824,  1824,  1824,
       0,     0,     0,     0,  1825,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,  1611,
       0,   791,     0,     0,     0,     0,     0,  1823,     0,   790,
       0,     0,     0,   791,     0,     0,     0,     0,     0,     0,
       0,     0,   770,   791,     0,     0,     0,     0,  1635,     0,
       0,     0,  1432,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,  1660,  1661,     0,  1663,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,   770,     0,  1433,     0,     0,     0,     0,  1705,     0,
       0,     0,     0,     0,     0,     0,   791,     0,     0,     0,
       0,     0,     0,   770,  1433,     0,   770,     0,   770,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,  1741,     0,
       0,   770,     0,     0,     0,   770,     0,     0,  1824,     0,
    1433,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,   791,     0,   791,     0,  1845,     0,     0,
       0,  1857,  1860,     0,     0,     0,     0,   791,     0,   791,
       0,     0,  1823,     0,     0,     0,     0,     0,  1433,     0,
       0,     0,  1433,  1433,     0,     0,     0,     0,     0,     0,
       0,  1432,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,   792,     0,     0,   791,  1825,
     792,     0,   770,   792,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,  1700,     0,     0,     0,     0,     0,
       0,   770,     0,     0,     0,   792,   791,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
     791,  1433,     0,     0,     0,     0,     0,     0,     0,     0,
    1893,     0,     0,     0,     0,     0,     0,   770,     0,   791,
     770,     0,   791,     0,     0,     0,   792,     0,     0,     0,
       0,     0,     0,     0,  1700,     0,     0,     0,     0,     0,
       0,     0,     0,   792,   792,     0,     0,     0,     0,     0,
       0,     0,   770,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,  1825,   792,
       0,     0,  1825,     0,   790,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,  1432,     0,  1824,   792,     0,
     770,     0,   792,     0,     0,     0,     0,     0,     0,     0,
       0,   770,     0,     0,     0,     0,     0,     0,     0,     0,
     792,     0,     0,   770,   770,     0,     0,     0,     0,     0,
       0,   792,     0,     0,   790,     0,     0,     0,     0,     0,
       0,     0,     0,     0,   792,     0,   770,     0,     0,     0,
       0,     0,     0,     0,   792,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,   770,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
     770,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,  1825,     0,  1823,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,   791,     0,     0,     0,     0,
       0,     0,     0,     0,     0,  2485,  2485,  2485,   770,     0,
       0,     0,     0,  1823,     0,     0,     0,   770,     0,     0,
       0,  1823,   792,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,  1824,     0,     0,     0,     0,  1824,     0,
    1824,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,   792,     0,     0,     0,
    2349,     0,     0,     0,     0,     0,     0,     0,  1893,     0,
       0,  2546,     0,  2546,     0,     0,     0,     0,  1893,     0,
       0,     0,   791,  2372,     0,   791,  2374,     0,     0,  2385,
       0,   792,     0,     0,     0,     0,  2392,  2397,     0,     0,
       0,     0,  2403,     0,     0,  2408,     0,     0,     0,     0,
       0,     0,     0,     0,     0,   792,     0,     0,     0,  1824,
       0,     0,  2417,     0,     0,     0,     0,  2424,  1432,     0,
       0,  2436,  1700,     0,     0,  2443,     0,  2445,  2446,  2447,
    2448,  2449,  2450,  2451,  2452,  2453,     0,  2454,     0,     0,
       0,     0,     0,     0,     0,  1115,  2482,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,  1893,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,   791,   791,     0,     0,
       0,     0,  1425,   791,     0,     0,     0,     0,     0,  1825,
       0,     0,     0,     0,     0,  1825,     0,     0,     0,     0,
    1700,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,  1432,
       0,  1432,     0,     0,  1700,     0,     0,     0,     0,  2381,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,  1700,
    1700,     0,  1700,     0,     0,     0,     0,     0,     0,   791,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,  1175,     0,     0,     0,  1432,     0,   792,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,  1700,     0,     0,     0,     0,     0,
       0,  1432,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,  1425,     0,     0,     0,     0,     0,
    2546,     0,     0,     0,     0,     0,     0,     0,     0,     0,
    1700,     0,     0,     0,     0,     0,     0,     0,  2546,   792,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,   792,   792,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,  2587,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,   792,     0,     0,   792,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,  1432,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,  2546,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,  1432,
       0,     0,     0,     0,  1700,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,  1700,     0,     0,  1700,
       0,     0,     0,     0,     0,  1825,  1825,  1825,     0,     0,
       0,     0,     0,     0,     0,     0,   791,     0,     0,  1824,
       0,     0,     0,     0,     0,     0,     0,     0,     0,   792,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,   792,   791,     0,     0,     0,     0,     0,     0,     0,
    1432,   792,     0,     0,   791,     0,     0,     0,     0,     0,
       0,     0,  1425,     0,     0,     0,     0,   791,     0,     0,
    1432,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,  1432,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
     791,     0,     0,     0,   792,     0,  1425,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,  2804,     0,     0,
       0,  1432,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,  1425,     0,     0,     0,  1825,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,   792,     0,   792,     0,     0,  2485,     0,     0,     0,
       0,     0,     0,     0,     0,   792,     0,   792,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,  1893,     0,     0,
       0,     0,     0,     0,     0,     0,   791,     0,  1425,     0,
       0,     0,     0,     0,  1426,     0,   792,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,  1425,     0,     0,
    2929,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,   792,     0,     0,  1425,     0,     0,
       0,     0,     0,     0,     0,  1428,     0,     0,   792,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,  1425,     0,     0,     0,     0,   792,     0,     0,
     792,     0,     0,     0,     0,     0,     0,     0,  2546,     0,
       0,     0,     0,     0,     0,     0,     0,     0,   791,     0,
     791,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,  2977,     0,     0,     0,     0,  2983,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,  1425,
       0,     0,     0,     0,     0,     0,     0,   791,     0,     0,
       0,     0,     0,     0,     0,     0,  1426,     0,     0,     0,
       0,     0,     0,     0,     0,  1825,     0,     0,     0,     0,
    2397,     0,  2397,  2397,     0,     0,     0,     0,     0,     0,
       0,     0,     0,  3040,     0,     0,  3043,  1824,  3045,   791,
       0,     0,     0,     0,     0,     0,     0,  1428,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,  3066,     0,  3068,     0,     0,
       0,  3071,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,  1432,
       0,     0,     0,  2482,  2482,  2482,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
    3114,     0,     0,     0,     0,     0,     0,     0,  1700,     0,
       0,     0,  1845,     0,     0,     0,  1893,  3125,     0,     0,
       0,     0,     0,  1860,     0,     0,     0,     0,     0,     0,
       0,  1700,     0,  1700,     0,  2381,  2381,  3014,     0,     0,
    2381,     0,     0,     0,  1700,     0,  1425,     0,     0,     0,
       0,  1700,     0,   792,     0,     0,  1700,     0,     0,     0,
       0,     0,  1700,     0,     0,     0,     0,  1700,     0,     0,
       0,     0,  1824,     0,     0,     0,  1700,     0,     0,  3161,
    2381,  2381,     0,  1700,  1426,     0,     0,     0,     0,     0,
       0,  1825,     0,     0,     0,  1700,  1825,     0,  1825,     0,
       0,     0,  1700,     0,  1700,  1700,  1700,  1700,  1700,  1700,
    1700,  1700,  1700,  1700,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,  1428,  1432,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,  1432,  1426,     0,
     792,  1700,     0,   792,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,  1426,     0,     0,  1825,     0,  1428,
       0,     0,     0,     0,     0,     0,  2485,     0,     0,     0,
       0,  2485,     0,     0,     0,     0,  2485,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,  1428,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,   791,     0,     0,     0,     0,     0,
       0,     0,     0,     0,   792,   792,  1700,     0,     0,  1432,
    1426,   792,     0,     0,     0,  1425,     0,     0,     0,  1425,
    1425,     0,     0,     0,     0,     0,     0,     0,     0,  1426,
       0,     0,     0,     0,     0,     0,     0,  1432,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,  1426,
       0,  1428,     0,     0,   791,     0,  1432,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
    1428,     0,     0,     0,  1426,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,   792,     0,     0,
    1428,     0,     0,  1429,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,  1432,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,  1428,     0,     0,     0,     0,
       0,     0,     0,     0,     0,  1425,     0,     0,     0,     0,
       0,  1426,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,  1824,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,  1428,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,  1824,     0,     0,     0,     0,     0,     0,
       0,  1824,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,  4126,     0,     0,     0,     0,
       0,     0,     0,  1700,     0,  1429,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,  3488,     0,     0,     0,     0,
       0,  1432,     0,     0,     0,  3492,     0,     0,     0,     0,
       0,  3493,     0,  3494,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,  1425,     0,     0,     0,     0,     0,
       0,     0,     0,  1430,     0,  3512,  3513,     0,     0,     0,
       0,     0,     0,     0,   792,     0,     0,  1825,     0,     0,
       0,     0,     0,     0,     0,     0,  2403,     0,  1426,     0,
       0,     0,     0,     0,     0,     0,  3541,     0,     0,  3544,
     792,  3546,     0,     0,     0,     0,     0,     0,     0,     0,
    3550,     0,   792,     0,     0,     0,  3555,     0,     0,  3558,
       0,     0,     0,     0,     0,   792,     0,     0,  1700,  1428,
       0,     0,     0,  1425,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,  2546,     0,  3599,     0,     0,
       0,     0,     0,  3606,  2482,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,   792,     0,
       0,     0,     0,     0,     0,     0,  1700,  3618,     0,     0,
       0,     0,  1700,  1115,     0,     0,     0,     0,     0,  1175,
       0,     0,     0,     0,     0,  1430,     0,     0,  3014,  3014,
       0,  2381,     0,  1429,  2381,  2381,  2381,  2381,  2381,  2381,
    2381,  2381,  2381,  2381,  3014,     0,     0,     0,  1425,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,  1700,
       0,     0,  1700,     0,  1700,     0,     0,     0,     0,  3014,
    3014,     0,  2546,     0,     0,     0,     0,  1429,     0,     0,
       0,     0,     0,  2381,  2381,  1700,     0,  1700,     0,     0,
    1700,     0,     0,  1432,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,   792,     0,     0,     0,     0,     0,
       0,     0,     0,  1429,     0,     0,     0,  1426,     0,     0,
       0,  1426,  1426,     0,     0,     0,     0,     0,     0,  1432,
       0,     0,     0,  1700,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,  1700,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,  1428,     0,
       0,     0,  1428,  1428,     0,     0,     0,  1432,     0,     0,
       0,  1432,  1432,     0,     0,     0,     0,     0,     0,     0,
    1700,     0,     0,     0,     0,     0,     0,     0,     0,  1429,
       0,     0,     0,     0,     0,     0,   792,     0,   792,     0,
       0,     0,     0,     0,     0,     0,     0,     0,  1429,     0,
       0,     0,     0,  1430,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,  1426,  1429,     0,
       0,     0,     0,     0,     0,   792,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
    4126,     0,     0,  1429,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,  1430,  1428,     0,
       0,  1425,     0,     0,  1425,  1825,  1425,   792,     0,     0,
       0,  1425,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,  3863,  3864,     0,     0,     0,
       0,     0,     0,  1430,     0,     0,     0,     0,     0,     0,
    1429,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,  1425,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,  3894,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,  1425,     0,     0,     0,     0,  1426,     0,     0,  1430,
       0,     0,  2381,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,  1430,     0,
       0,  3912,  3914,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,  3921,     0,     0,  1428,  1430,     0,
    3926,  3927,     0,     0,  3929,     0,     0,  3932,     0,     0,
    1825,     0,  1425,     0,  1425,     0,     0,     0,     0,     0,
       0,     0,     0,  1430,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,  1426,     0,     0,     0,     0,
       0,     0,     0,     0,  2482,     0,     0,     0,     0,  2482,
       0,     0,     0,     0,  2482,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,  1429,     0,  1425,
       0,     0,     0,     0,     0,     0,  1428,     0,     0,     0,
    1430,     0,     0,     0,     0,     0,     0,  1700,     0,  3982,
       0,  1700,  1700,  1700,  1425,     0,  3014,     0,     0,     0,
       0,  3014,  3014,  3014,  3014,  3014,  3014,  3014,  3014,  3014,
    3014,  1700,  1700,  1425,     0,     0,     0,     0,     0,     0,
    1426,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,  1425,     0,     0,     0,     0,     0,     0,     0,     0,
    1700,  2381,  2381,  1700,     0,  1700,     0,     0,     0,  1700,
    3014,  3014,     0,     0,  1700,     0,     0,  1700,     0,     0,
       0,  1428,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,   792,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,  1425,     0,     0,  1700,     0,
       0,     0,     0,     0,     0,  1700,     0,     0,     0,     0,
       0,  1425,     0,     0,     0,     0,     0,  1700,     0,     0,
       0,     0,  1425,     0,     0,     0,     0,     0,     0,     0,
       0,     0,   792,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,  4078,     0,  1430,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,  1429,     0,     0,     0,
    1429,  1429,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,  1425,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,  1425,     0,     0,     0,     0,     0,     0,
       0,  1825,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,  1425,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,  1426,     0,     0,  1426,     0,  1426,     0,
       0,     0,     0,  1426,     0,     0,     0,     0,     0,     0,
       0,  1825,     0,     0,  1425,  4160,     0,     0,     0,  1825,
       0,     0,     0,     0,     0,     0,  1429,     0,     0,     0,
       0,     0,     0,     0,  1428,     0,     0,  1428,     0,  1428,
       0,     0,     0,     0,  1428,     0,     0,  4183,     0,     0,
    3014,     0,     0,  1426,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,  1426,  1428,     0,     0,     0,     0,     0,
    1425,     0,  1700,  1700,     0,     0,  1430,     0,     0,     0,
    1430,  1430,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,  1700,  1428,     0,     0,  2381,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,  1700,     0,  1700,  1426,     0,  1426,     0,  3014,  3014,
    1700,     0,     0,  2381,  2381,  1700,  1700,     0,  1700,     0,
       0,  1700,     0,     0,     0,  1429,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,  1425,     0,     0,     0,  1428,     0,  1428,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,  1426,     0,     0,     0,     0,  1430,     0,     0,     0,
       0,  1700,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,  2403,     0,     0,  1426,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,  1428,     0,  1429,  1426,     0,     0,  4325,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,  1426,     0,     0,     0,  1428,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,  1428,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,  1428,     0,     0,  1700,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,  1426,     0,  1429,
       0,     0,  1425,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,  1426,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,  1426,  1430,     0,     0,  4399,     0,
       0,     0,     0,     0,     0,     0,     0,     0,  1428,  1425,
       0,  3014,  2381,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,  1428,     0,     0,  3014,  3014,  1700,
       0,     0,     0,     0,     0,  1428,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,  1700,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,  1426,     0,     0,     0,  4444,
       0,     0,     0,     0,  1430,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,  1426,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,  1428,     0,     0,     0,
    1426,     0,     0,     0,     0,     0,     0,     0,     0,  1425,
       0,     0,     0,     0,     0,     0,  1428,     0,     0,     0,
    1425,     0,     0,     0,     0,     0,     0,     0,     0,     0,
    4489,  4489,     0,     0,     0,     0,  1426,     0,     0,     0,
       0,  1428,     0,     0,     0,     0,     0,     0,     0,  1430,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,  3014,     0,
       0,     0,     0,     0,     0,     0,     0,  1428,     0,     0,
       0,     0,     0,     0,  1700,     0,     0,     0,     0,     0,
       0,     0,  1429,  4489,     0,  1429,     0,  1429,     0,     0,
       0,     0,  1429,     0,     0,     0,     0,  4545,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,  1426,     0,     0,     0,     0,     0,     0,     0,
       0,     0,  1425,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,  1429,     0,     0,     0,     0,     0,  1700,     0,
    1425,     0,     0,  1428,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,  4489,     0,     0,     0,  1425,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,  1429,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,  1700,     0,     0,     0,     0,     0,     0,
       0,     0,     0,  1426,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,  1425,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,  1700,     0,
       0,     0,     0,  1429,  1428,  1429,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,  1430,     0,     0,  1430,     0,  1430,     0,     0,
       0,     0,  1430,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,  1700,     0,     0,     0,     0,     0,
    1429,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,  1429,     0,     0,     0,     0,
       0,     0,  1430,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,  1429,     0,     0,     0,     0,     0,
       0,     0,     0,     0,  1426,     0,     0,     0,     0,     0,
       0,     0,  1429,     0,  1425,     0,     0,     0,     0,     0,
       0,     0,  1430,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,  1426,     0,     0,     0,  1428,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,  1429,     0,     0,     0,
       0,     0,  1428,  1430,     0,  1430,     0,     0,     0,     0,
       0,     0,  1429,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,  1429,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,  1425,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
    1430,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,  1426,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,  1426,     0,     0,  1430,     0,     0,     0,     0,
       0,     0,     0,     0,  1429,     0,     0,     0,     0,     0,
       0,     0,     0,     0,  1430,     0,     0,     0,     0,     0,
       0,     0,  1428,     0,  1429,     0,     0,     0,     0,     0,
       0,     0,  1430,  1428,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,  1429,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,  1425,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,  1429,  1425,     0,     0,     0,
       0,     0,     0,     0,     0,     0,  1430,     0,     0,     0,
       0,     0,     0,     0,  1426,     0,     0,     0,     0,     0,
       0,     0,  1430,     0,     0,     0,     0,     0,     0,     0,
       0,     0,  1425,  1430,     0,     0,     0,     0,     0,     0,
       0,     0,  1426,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,  1428,     0,     0,     0,     0,
       0,  1426,     0,     0,     0,     0,     0,     0,     0,     0,
    1425,     0,     0,     0,  1425,  1425,     0,     0,     0,     0,
       0,  1429,     0,  1428,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,  1428,     0,  1430,     0,     0,     0,     0,  1426,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,  1430,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,  1430,
    1428,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,  1429,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,  1430,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,  1426,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,  1430,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,  1428,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,  1429,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
    1429,     0,  1430,     0,     0,     0,     0,     0,     0,     0,
    1426,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,  1428,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
    1429,     0,     0,     0,     0,     0,     0,  1426,     0,     0,
       0,  1429,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,  1426,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,  1430,     0,     0,     0,     0,  1428,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,  1426,     0,     0,     0,     0,  1428,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
    1430,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,  1426,     0,     0,  1428,  1426,  1426,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,  1429,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,  1428,     0,     0,     0,  1428,  1428,     0,
       0,  1429,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
    1429,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
    1430,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,  1430,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,  1429,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,  1430,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,  1430,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
    1430,     0,     0,     0,     0,  1429,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,  1430,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,  1429,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,  1430,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,  1429,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,  1429,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,  1429,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,  1430,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,  1429,     0,     0,     0,  1429,  1429,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,  1430,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,  1430,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,  1430,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,   744,  1033,   574,  1034,
    1035,  1036,   625,  1037,     0,     0,     0,   211,   212,   213,
     214,   215,   216,   217,   218,  2476,   220,   221,   222,     0,
       0,  1430,     0,   223,  1038,  1430,  1430,   224,   225,     0,
     226,   227,   745,   228,   229,   230,   231,  1039,   746,  1040,
    1041,     0,   235,   236,   237,   238,   239,  1042,  1043,   240,
     241,  1044,  1045,   244,     0,   245,   246,   247,   248,  1046,
       0,  1047,     0,   250,   251,   252,   253,   748,   254,   255,
       0,   256,   257,   258,   259,   260,   261,     0,   749,   262,
     263,  1048,  1049,  1050,  1051,  1052,  1053,  1054,   264,   265,
     266,   267,   268,   269,  1055,  1056,   272,     0,   273,     0,
     274,   275,   276,   277,   278,     0,   279,   280,   281,  2477,
       0,   282,   283,  1057,   285,   286,     0,   287,   288,   289,
       0,   290,   291,   292,     0,   293,   294,   295,   296,  1058,
     298,   299,   300,  1059,  1060,   302,     0,   303,   304,  1061,
     306,     0,   307,     0,   308,   751,     0,   752,   309,   310,
     311,     0,   312,  1062,     0,   314,     0,   315,   316,   317,
     318,   319,   753,   320,   321,   322,     0,   323,   324,   325,
     326,   327,   328,     0,   329,   754,   330,   331,   332,   333,
     334,  1063,  1064,     0,  1065,     0,   338,   755,   756,   339,
     757,   340,   341,   342,   343,   344,     0,   345,   346,     0,
     347,  1066,   758,   349,   759,     0,   350,   351,   352,  1067,
    1068,   353,   354,   355,   356,   357,   358,   359,   360,   361,
     362,   363,   364,   365,  1069,   760,  1070,   368,   369,   370,
    1071,   371,   372,   761,   373,  1072,  1073,   375,  1074,   377,
     378,   379,     0,   380,     0,     0,  1075,   382,   383,     0,
       0,   384,   385,   762,   386,   763,  1076,   388,   389,   390,
     391,   392,   393,   394,     0,   395,  1077,   397,   398,   399,
     400,   401,     0,   402,   403,   404,   405,   406,   407,   408,
     409,  1078,   411,   412,   413,   414,     0,   415,   416,   417,
     418,   419,   420,   421,   422,   423,   424,   425,     0,   426,
     427,   764,   428,   429,  1079,   431,   432,   433,   434,   435,
     436,   437,   438,     0,   439,   440,   441,   442,   443,  1080,
     444,   445,   446,   447,   765,   448,  1081,   450,     0,   451,
     452,   453,   454,   455,   456,   457,   458,   459,   460,  1082,
       0,   462,   463,     0,   464,   465,   466,   467,   468,   469,
       0,  1083,  1084,     0,     0,   472,  1085,   474,  1086,  1087,
     476,   477,   478,   479,   480,   481,   482,     0,  1088,   483,
     484,   485,   486,   487,  1089,     0,   488,   489,   490,   491,
     492,   493,  1090,  2478,   495,   766,   496,   497,   498,   499,
       0,     0,   500,     0,     0,   501,   502,   503,   504,   505,
     506,   507,  1091,  1092,  1093,  1094,  1095,  1096,  1097,  1098,
     516,   517,   518,     0,     0,     0,     0,     0,     0,     0,
       0,  1099,  1100,  2479,     0,     0,     0,     0,     0,     0,
    1102,  2480,   744,  1033,   574,  1034,  1035,  1036,   625,  1037,
       0,     0,     0,   211,   212,   213,   214,   215,   216,   217,
     218,     0,   220,   221,   222,     0,     0,     0,     0,   223,
    1038,     0,     0,   224,   225,     0,   226,   227,   745,   228,
     229,   230,   231,  1039,   746,  1040,  1041,     0,   235,   236,
     237,   238,   239,  1042,  1043,   240,   241,  1044,  1045,   244,
       0,   245,   246,   247,   248,  1046,     0,  1047,     0,   250,
     251,   252,   253,   748,   254,   255,     0,   256,   257,   258,
     259,   260,   261,     0,   749,   262,   263,  1048,  1049,  1050,
    1051,  1052,  1053,  1054,   264,   265,   266,   267,   268,   269,
    1055,  1056,   272,     0,   273,     0,   274,   275,   276,   277,
     278,     0,   279,   280,   281,     0,     0,   282,   283,  1057,
     285,   286,     0,   287,   288,   289,     0,   290,   291,   292,
       0,   293,   294,   295,   296,  1058,   298,   299,   300,  1059,
    1060,   302,     0,   303,   304,  1061,   306,     0,   307,     0,
     308,   751,     0,   752,   309,   310,   311,     0,   312,  1062,
       0,   314,     0,   315,   316,   317,   318,   319,   753,   320,
     321,   322,     0,   323,   324,   325,   326,   327,   328,     0,
     329,   754,   330,   331,   332,   333,   334,  1063,  1064,     0,
    1065,     0,   338,   755,   756,   339,   757,   340,   341,   342,
     343,   344,     0,   345,   346,     0,   347,  1066,   758,   349,
     759,     0,   350,   351,   352,  1067,  1068,   353,   354,   355,
     356,   357,   358,   359,   360,   361,   362,   363,   364,   365,
    1069,   760,  1070,   368,   369,   370,  1071,   371,   372,   761,
     373,  1072,  1073,   375,  1074,   377,   378,   379,     0,   380,
       0,     0,  1075,   382,   383,     0,     0,   384,   385,   762,
     386,   763,  1076,   388,   389,   390,   391,   392,   393,   394,
       0,   395,  1077,   397,   398,   399,   400,   401,     0,   402,
     403,   404,   405,   406,   407,   408,   409,  1078,   411,   412,
     413,   414,     0,   415,   416,   417,   418,   419,   420,   421,
     422,   423,   424,   425,     0,   426,   427,   764,   428,   429,
    1079,   431,   432,   433,   434,   435,   436,   437,   438,     0,
     439,   440,   441,   442,   443,  1080,   444,   445,   446,   447,
     765,   448,  1081,   450,     0,   451,   452,   453,   454,   455,
     456,   457,   458,   459,   460,  1082,     0,   462,   463,     0,
     464,   465,   466,   467,   468,   469,     0,  1083,  1084,     0,
       0,   472,  1085,   474,  1086,  1087,   476,   477,   478,   479,
     480,   481,   482,     0,  1088,   483,   484,   485,   486,   487,
    1089,     0,   488,   489,   490,   491,   492,   493,  1090,     0,
     495,   766,   496,   497,   498,   499,     0,     0,   500,     0,
       0,   501,   502,   503,   504,   505,   506,   507,  1091,  1092,
    1093,  1094,  1095,  1096,  1097,  1098,   516,   517,   518,     0,
       0,     0,     0,     0,     0,     0,     0,  1099,  1100,   210,
       0,     0,     0,     0,     0,     0,  1102,  2383,     0,     0,
     211,   212,   213,   214,   215,   216,   217,   218,     0,   220,
     221,   222,     0,     0,     0,     0,   223,     0,  3577,     0,
     224,   225,     0,   226,   227,     0,   228,   229,   230,   231,
     232,     0,   233,   234,     0,   235,   236,   237,   238,   239,
       0,     0,   240,   241,   242,   243,   244,     0,   245,   246,
     247,   248,   249,     0,     0,     0,   250,   251,   252,   253,
       0,   254,   255,     0,   256,   257,   258,   259,   260,   261,
       0, -1496,   262,   263,     0,     0,     0,     0,     0,     0,
       0,   264,   265,   266,   267,   268,   269,   270,   271,   272,
       0,   273,     0,   274,   275,   276,   277,   278,     0,   279,
     280,   281,     0,     0,   282,   283,   284,   285,   286,     0,
     287,   288,   289,     0,   290,   291,   292,     0,   293,   294,
     295,   296,   297,   298,   299,   300,   301,     0,   302,     0,
     303,   304,   305,   306,     0,   307,     0,   308,     0,     0,
   -1496,   309,   310,   311,     0,   312,   313,     0,   314,     0,
     315,   316,   317,   318,   319,     0,   320,   321,   322,     0,
     323,   324,   325,   326,   327,   328,     0,   329, -1496,   330,
     331,   332,   333,   334,   335,   336,     0,   337,     0,   338,
       0,     0,   339, -1496,   340,   341,   342,   343,   344,     0,
     345,   346,     0,   347,   348, -1496,   349,     0,     0,   350,
     351,   352,     0,     0,   353,   354,   355,   356,   357,   358,
     359,   360,   361,   362,   363,   364,   365,   366, -1496,   367,
     368,   369,   370,     0,   371,   372,     0,   373,     0,   374,
     375,   376,   377,   378,   379,     0,   380,     0,     0,   381,
     382,   383,     0,     0,   384,   385,     0,   386,     0,   387,
     388,   389,   390,   391,   392,   393,   394,     0,   395,   396,
     397,   398,   399,   400,   401,     0,   402,   403,   404,   405,
     406,   407,   408,   409,   410,   411,   412,   413,   414,     0,
     415,   416,   417,   418,   419,   420,   421,   422,   423,   424,
     425,     0,   426,   427, -1496,   428,   429,   430,   431,   432,
     433,   434,   435,   436,   437,   438,     0,   439,   440,   441,
     442,   443,     0,   444,   445,   446,   447,     0,   448,   449,
     450,     0,   451,   452,   453,   454,   455,   456,   457,   458,
     459,   460,   461,     0,   462,   463,     0,   464,   465,   466,
     467,   468,   469,     0,   470,   471,     0,     0,   472,   473,
     474,   475,     0,   476,   477,   478,   479,   480,   481,   482,
       0,     0,   483,   484,   485,   486,   487,     0,     0,   488,
     489,   490,   491,   492,   493,   494,     0,   495,     0,   496,
     497,   498,   499,     0,     0,   500,     0,     0,   501,   502,
     503,   504,   505,   506,   507,   508,   509,   510,   511,   512,
     513,   514,   515,   516,   517,   518,     0,     0,     0,     0,
       0,     0,     0,     0,  1399,     0,     0,     0,     0,     0,
       0,     0,     0,     0,  1182,   211,   212,   213,   214,   215,
     216,   217,   218,     0,   220,   221,   222,     0,     0,     0,
       0,   223,     0,     0,     0,   224,   225,     0,   226,   227,
     745,   228,   229,   230,     0,  1400,   746,  1401,  1402,     0,
     235,   236,   237,   238,   239,     0,     0,   240,   241,  1403,
    1404,   244,     0,   245,   246,   247,   248,     0,     0,   747,
       0,   250,   251,   252,   253,   748,   254,   255,     0,   256,
     257,   258,   259,   260,   261,     0,   749,   262,   263,     0,
       0,     0,   750,     0,     0,     0,   264,   265,   266,   267,
     268,   269,  1405,  1406,   272,     0,   273,     0,   274,   275,
     276,   277,   278,     0,   279,   280,   281,     0,     0,   282,
     283,  1057,   285,   286,     0,   287,   288,   289,     0,   290,
     291,   292,     0,   293,   294,   295,   296,     0,   298,   299,
     300,     0,     0,   302,     0,   303,   304,  1407,   306,     0,
     307,     0,   308,   751,     0,   752,   309,   310,   311,     0,
     312,     0,     0,   314,     0,   315,   316,   317,   318,   319,
     753,   320,   321,   322,  1879,   323,   324,   325,   326,   327,
     328,     0,   329,   754,  1880,   331,   332,   333,   334,  1408,
    1409,     0,  1410,     0,   338,   755,   756,   339,   757,   340,
     341,   342,   343,   344,     0,   345,   346,     0,   347,     0,
     758,   349,   759,     0,   350,   351,   352,     0,     0,   353,
     354,   355,   356,   357,   358,   359,   360,   361,   362,   363,
     364,   365,  1411,   760,  1412,   368,   369,     0,     0,   371,
     372,   761,   373,     0,     0,   375,  1413,   377,   378,   379,
       0,   380,     0,     0,   381,   382,   383,     0,     0,   384,
    1882,   762,   386,   763,     0,   388,   389,   390,   391,   392,
     393,   394,     0,   395,     0,   397,     0,   399,   400,   401,
       0,   402,   403,   404,   405,   406,   407,   408,   409,  1414,
     411,   412,   413,   414,     0,   415,   416,   417,   418,   419,
     420,   421,   422,   423,   424,   425,     0,   426,   427,   764,
     428,   429,     0,   431,   432,   433,   434,   435,   436,   437,
     438,     0,   439,   440,   441,   442,   443,     0,   444,  1883,
     446,   447,   765,   448,  1416,   450,     0,   451,   452,   453,
     454,   455,   456,   457,   458,   459,   460,     0,     0,   462,
     463,     0,   464,   465,   466,   467,   468,   469,     0,  1417,
    1418,     0,     0,   472,     0,   474,     0,     0,   476,   477,
     478,   479,   480,   481,   482,     0,     0,   483,   484,   485,
     486,   487,     0,     0,   488,   489,   490,   491,   492,     0,
    1419,  1884,   495,   766,   496,   497,   498,   499,     0,     0,
     500,     0,     0,   501,   502,   503,   504,   505,   506,     0,
    1399,     0,     0,     0,     0,     0,     0,     0,   516,   517,
     518,   211,   212,   213,   214,   215,   216,   217,   218,     0,
     220,   221,   222,     0,     0,     0,     0,   223,     0,  1982,
       0,   224,   225,     0,   226,   227,   745,   228,   229,   230,
       0,  1400,   746,  1401,  1402,     0,   235,   236,   237,   238,
     239,     0,     0,   240,   241,  1403,  1404,   244,     0,   245,
     246,   247,   248,     0,     0,   747,     0,   250,   251,   252,
     253,   748,   254,   255,     0,   256,   257,   258,   259,   260,
     261,     0,   749,   262,   263,     0,     0,     0,   750,     0,
       0,     0,   264,   265,   266,   267,   268,   269,  1405,  1406,
     272,     0,   273,     0,   274,   275,   276,   277,   278,     0,
     279,   280,   281,     0,     0,   282,   283,  1057,   285,   286,
       0,   287,   288,   289,     0,   290,   291,   292,     0,   293,
     294,   295,   296,     0,   298,   299,   300,     0,     0,   302,
       0,   303,   304,  1407,   306,     0,   307,     0,   308,   751,
       0,   752,   309,   310,   311,     0,   312,     0,     0,   314,
       0,   315,   316,   317,   318,   319,   753,   320,   321,   322,
    1879,   323,   324,   325,   326,   327,   328,     0,   329,   754,
    1880,   331,   332,   333,   334,  1408,  1409,     0,  1410,     0,
     338,   755,   756,   339,   757,   340,   341,   342,   343,   344,
       0,   345,   346,     0,   347,     0,   758,   349,   759,     0,
     350,   351,   352,     0,     0,   353,   354,   355,   356,   357,
     358,   359,   360,   361,   362,   363,   364,   365,  1411,   760,
    1412,   368,   369,     0,     0,   371,   372,   761,   373,     0,
       0,   375,  1413,   377,   378,   379,     0,   380,     0,     0,
     381,   382,   383,     0,     0,   384,  1882,   762,   386,   763,
       0,   388,   389,   390,   391,   392,   393,   394,     0,   395,
       0,   397,     0,   399,   400,   401,     0,   402,   403,   404,
     405,   406,   407,   408,   409,  1414,   411,   412,   413,   414,
       0,   415,   416,   417,   418,   419,   420,   421,   422,   423,
     424,   425,     0,   426,   427,   764,   428,   429,     0,   431,
     432,   433,   434,   435,   436,   437,   438,     0,   439,   440,
     441,   442,   443,     0,   444,  1883,   446,   447,   765,   448,
    1416,   450,     0,   451,   452,   453,   454,   455,   456,   457,
     458,   459,   460,     0,     0,   462,   463,     0,   464,   465,
     466,   467,   468,   469,     0,  1417,  1418,     0,     0,   472,
       0,   474,     0,     0,   476,   477,   478,   479,   480,   481,
     482,     0,     0,   483,   484,   485,   486,   487,     0,     0,
     488,   489,   490,   491,   492,     0,  1419,  1884,   495,   766,
     496,   497,   498,   499,     0,     0,   500,     0,     0,   501,
     502,   503,   504,   505,   506,     0,   744,  1033,   574,  1034,
    1035,  1036,   625,  1037,   516,   517,   518,   211,   212,   213,
     214,   215,   216,   217,   218,     0,   220,   221,   222,     0,
       0,     0,     0,   223,  1038,  2893,     0,   224,   225,     0,
     226,   227,   745,   228,   229,   230,   231,  1039,   746,  1040,
    1041,  2393,   235,   236,   237,   238,   239,  1042,  1043,   240,
     241,  1044,  1045,   244,     0,   245,   246,   247,   248,  1046,
       0,  1047,     0,   250,   251,   252,   253,   748,   254,   255,
       0,   256,   257,   258,   259,   260,   261,     0,   749,   262,
     263,  1048,  1049,  1050,  1051,  1052,  1053,  1054,   264,   265,
     266,   267,   268,   269,  1055,  1056,   272,     0,   273,     0,
     274,   275,   276,   277,   278,     0,   279,   280,   281,     0,
       0,   282,   283,  1057,   285,   286,     0,   287,   288,   289,
       0,   290,   291,   292,     0,   293,   294,   295,   296,  1058,
     298,   299,   300,  1059,  1060,   302,     0,   303,   304,  1061,
     306,     0,   307,     0,   308,   751,  2394,   752,   309,   310,
     311,     0,   312,  1062,     0,   314,     0,   315,   316,   317,
     318,   319,   753,   320,   321,   322,     0,   323,   324,   325,
     326,   327,   328,     0,   329,   754,   330,   331,   332,   333,
     334,  1063,  1064,     0,  1065,     0,   338,   755,   756,   339,
     757,   340,   341,   342,   343,   344,     0,   345,   346,  2395,
     347,  1066,   758,   349,   759,     0,   350,   351,   352,  1067,
    1068,   353,   354,   355,   356,   357,   358,   359,   360,   361,
     362,   363,   364,   365,  1069,   760,  1070,   368,   369,   370,
    1071,   371,   372,   761,   373,  1072,  1073,   375,  1074,   377,
     378,   379,     0,   380,     0,     0,  1075,   382,   383,     0,
       0,   384,   385,   762,   386,   763,  1076,   388,   389,   390,
     391,   392,   393,   394,     0,   395,  1077,   397,   398,   399,
     400,   401,     0,   402,   403,   404,   405,   406,   407,   408,
     409,  1078,   411,   412,   413,   414,     0,   415,   416,   417,
     418,   419,   420,   421,   422,   423,   424,   425,     0,   426,
     427,   764,   428,   429,  1079,   431,   432,   433,   434,   435,
     436,   437,   438,     0,   439,   440,   441,   442,   443,  1080,
     444,   445,   446,   447,   765,   448,  1081,   450,     0,   451,
     452,   453,   454,   455,   456,   457,   458,   459,   460,  1082,
       0,   462,   463,     0,   464,   465,   466,   467,   468,   469,
       0,  1083,  1084,     0,  2396,   472,  1085,   474,  1086,  1087,
     476,   477,   478,   479,   480,   481,   482,     0,  1088,   483,
     484,   485,   486,   487,  1089,     0,   488,   489,   490,   491,
     492,   493,  1090,     0,   495,   766,   496,   497,   498,   499,
       0,     0,   500,     0,     0,   501,   502,   503,   504,   505,
     506,   507,  1091,  1092,  1093,  1094,  1095,  1096,  1097,  1098,
     516,   517,   518,     0,     0,     0,     0,     0,     0,     0,
       0,  1099,  1100,     0,     0,     0,     0,     0,     0,     0,
    1102,   744,  1033,   574,  1034,  1035,  1036,   625,  1037,     0,
       0,     0,   211,   212,   213,   214,   215,   216,   217,   218,
       0,   220,   221,   222,     0,     0,     0,     0,   223,  1038,
       0,     0,   224,   225,     0,   226,   227,   745,   228,   229,
     230,   231,  1039,   746,  1040,  1041,     0,   235,   236,   237,
     238,   239,  1042,  1043,   240,   241,  1044,  1045,   244,     0,
     245,   246,   247,   248,  1046,     0,  1047,     0,   250,   251,
     252,   253,   748,   254,   255,     0,   256,   257,   258,   259,
     260,   261,     0,   749,   262,   263,  1048,  1049,  1050,  1051,
    1052,  1053,  1054,   264,   265,   266,   267,   268,   269,  1055,
    1056,   272,     0,   273,     0,   274,   275,   276,   277,   278,
       0,   279,   280,   281,     0,     0,   282,   283,  1057,   285,
     286,     0,   287,   288,   289,     0,   290,   291,   292,     0,
     293,   294,   295,   296,  1058,   298,   299,   300,  1059,  1060,
     302,     0,   303,   304,  1061,   306,     0,   307,     0,   308,
     751,     0,   752,   309,   310,   311,     0,   312,  1062,     0,
     314,     0,   315,   316,   317,   318,   319,   753,   320,   321,
     322,     0,   323,   324,   325,   326,   327,   328,     0,   329,
     754,   330,   331,   332,   333,   334,  1063,  1064,     0,  1065,
       0,   338,   755,   756,   339,   757,   340,   341,   342,   343,
     344,     0,   345,   346,     0,   347,  1066,   758,   349,   759,
       0,   350,   351,   352,  1067,  1068,   353,   354,   355,   356,
     357,   358,   359,   360,   361,   362,   363,   364,   365,  1069,
     760,  1070,   368,   369,   370,  1071,   371,   372,   761,   373,
    1072,  1073,   375,  1074,   377,   378,   379,     0,   380,     0,
       0,  1075,   382,   383,     0,     0,   384,   385,   762,   386,
     763,  1076,   388,   389,   390,   391,   392,   393,   394,     0,
     395,  1077,   397,   398,   399,   400,   401,     0,   402,   403,
     404,   405,   406,   407,   408,   409,  1078,   411,   412,   413,
     414,     0,   415,   416,   417,   418,   419,   420,   421,   422,
     423,   424,   425,     0,   426,   427,   764,   428,   429,  1079,
     431,   432,   433,   434,   435,   436,   437,   438,    38,   439,
     440,   441,   442,   443,  1080,   444,   445,   446,   447,   765,
     448,  1081,   450,     0,   451,   452,   453,   454,   455,   456,
     457,   458,   459,   460,  1082,     0,   462,   463,    42,   464,
     465,   466,   467,   468,   469,     0,  1083,  1084,     0,     0,
     472,  1085,   474,  1086,  1087,   476,   477,   478,   479,   480,
     481,   482,     0,  1088,   483,   484,   485,   486,   487,  1089,
       0,   488,   489,   490,   491,   492,   972,  1090,     0,   495,
     766,   496,   497,   498,   499,     0,     0,   500,     0,    47,
     501,   502,   503,   504,   505,   506,   507,  1091,  1092,  1093,
    1094,  1095,  1096,  1097,  1098,   516,   517,   518,     0,     0,
       0,     0,     0,     0,     0,     0,  1099,  1100,     0,     0,
       0,     0,     0,     0,     0,  1102,   744,  1033,   574,  1034,
    1035,  1036,   625,  1037,     0,     0,     0,   211,   212,   213,
     214,   215,   216,   217,   218,     0,   220,   221,   222,     0,
       0,     0,     0,   223,  1038,     0,     0,   224,   225,     0,
     226,   227,   745,   228,   229,   230,   231,  1039,   746,  1040,
    1041,     0,   235,   236,   237,   238,   239,  1042,  1043,   240,
     241,  1044,  1045,   244,     0,   245,   246,   247,   248,  1046,
       0,  1047,     0,   250,   251,   252,   253,   748,   254,   255,
       0,   256,   257,   258,   259,   260,   261,     0,   749,   262,
     263,  1048,  1049,  1050,  1051,  1052,  1053,  1054,   264,   265,
     266,   267,   268,   269,  1055,  1056,   272,     0,   273,     0,
     274,   275,   276,   277,   278,     0,   279,   280,   281,     0,
       0,   282,   283,  1057,   285,   286,     0,   287,   288,   289,
       0,   290,   291,   292,     0,   293,   294,   295,   296,  1058,
     298,   299,   300,  1059,  1060,   302,     0,   303,   304,  1061,
     306,     0,   307,     0,   308,   751,     0,   752,   309,   310,
     311,     0,   312,  1062,     0,   314,     0,   315,   316,   317,
     318,   319,   753,   320,   321,   322,     0,   323,   324,   325,
     326,   327,   328,     0,   329,   754,   330,   331,   332,   333,
     334,  1063,  1064,     0,  1065,     0,   338,   755,   756,   339,
     757,   340,   341,   342,   343,   344,     0,   345,   346,     0,
     347,  1066,   758,   349,   759,     0,   350,   351,   352,  1067,
    1068,   353,   354,   355,   356,   357,   358,   359,   360,   361,
     362,   363,   364,   365,  1069,   760,  1070,   368,   369,   370,
    1071,   371,   372,   761,   373,  1072,  1073,   375,  1074,   377,
     378,   379,     0,   380,     0,     0,  1075,   382,   383,     0,
       0,   384,   385,   762,   386,   763,  1076,   388,   389,   390,
     391,   392,   393,   394,     0,   395,  1077,   397,   398,   399,
     400,   401,     0,   402,   403,   404,   405,   406,   407,   408,
     409,  1078,   411,   412,   413,   414,     0,   415,   416,   417,
     418,   419,   420,   421,   422,   423,   424,   425,     0,   426,
     427,   764,   428,   429,  1079,   431,   432,   433,   434,   435,
     436,   437,   438,     0,   439,   440,   441,   442,   443,  1080,
     444,   445,   446,   447,   765,   448,  1081,   450,     0,   451,
     452,   453,   454,   455,   456,   457,   458,   459,   460,  1082,
       0,   462,   463,     0,   464,   465,   466,   467,   468,   469,
       0,  1083,  1084,     0,     0,   472,  1085,   474,  1086,  1087,
     476,   477,   478,   479,   480,   481,   482,     0,  1088,   483,
     484,   485,   486,   487,  1089,     0,   488,   489,   490,   491,
     492,   493,  1090,     0,   495,   766,   496,   497,   498,   499,
       0,     0,   500,     0,     0,   501,   502,   503,   504,   505,
     506,   507,  1091,  1092,  1093,  1094,  1095,  1096,  1097,  1098,
     516,   517,   518,     0,     0,     0,     0,     0,     0,     0,
       0,  1099,  1100,     0,     0,     0,     0,     0,  1606,  2341,
    1102,   744,  1033,   574,  1034,  1035,  1036,   625,  1037,     0,
       0,     0,   211,   212,   213,   214,   215,   216,   217,   218,
       0,   220,   221,   222,     0,     0,     0,     0,   223,  1038,
       0,     0,   224,   225,     0,   226,   227,   745,   228,   229,
     230,   231,  1039,   746,  1040,  1041,     0,   235,   236,   237,
     238,   239,  1042,  1043,   240,   241,  1044,  1045,   244,     0,
     245,   246,   247,   248,  1046,     0,  1047,     0,   250,   251,
     252,   253,   748,   254,   255,     0,   256,   257,   258,   259,
     260,   261,     0,   749,   262,   263,  1048,  1049,  1050,  1051,
    1052,  1053,  1054,   264,   265,   266,   267,   268,   269,  1055,
    1056,   272,     0,   273,     0,   274,   275,   276,   277,   278,
       0,   279,   280,   281,     0,     0,   282,   283,  1057,   285,
     286,     0,   287,   288,   289,     0,   290,   291,   292,     0,
     293,   294,   295,   296,  1058,   298,   299,   300,  1059,  1060,
     302,     0,   303,   304,  1061,   306,     0,   307,     0,   308,
     751,     0,   752,   309,   310,   311,     0,   312,  1062,     0,
     314,     0,   315,   316,   317,   318,   319,   753,   320,   321,
     322,     0,   323,   324,   325,   326,   327,   328,     0,   329,
     754,   330,   331,   332,   333,   334,  1063,  1064,     0,  1065,
       0,   338,   755,   756,   339,   757,   340,   341,   342,   343,
     344,     0,   345,   346,     0,   347,  1066,   758,   349,   759,
       0,   350,   351,   352,  1067,  1068,   353,   354,   355,   356,
     357,   358,   359,   360,   361,   362,   363,   364,   365,  1069,
     760,  1070,   368,   369,   370,  1071,   371,   372,   761,   373,
    1072,  1073,   375,  1074,   377,   378,   379,     0,   380,     0,
       0,  1075,   382,   383,     0,     0,   384,   385,   762,   386,
     763,  1076,   388,   389,   390,   391,   392,   393,   394,     0,
     395,  1077,   397,   398,   399,   400,   401,     0,   402,   403,
     404,   405,   406,   407,   408,   409,  1078,   411,   412,   413,
     414,     0,   415,   416,   417,   418,   419,   420,   421,   422,
     423,   424,   425,     0,   426,   427,   764,   428,   429,  1079,
     431,   432,   433,   434,   435,   436,   437,   438,     0,   439,
     440,   441,   442,   443,  1080,   444,   445,   446,   447,   765,
     448,  1081,   450,     0,   451,   452,   453,   454,   455,   456,
     457,   458,   459,   460,  1082,     0,   462,   463,     0,   464,
     465,   466,   467,   468,   469,     0,  1083,  1084,     0,     0,
     472,  1085,   474,  1086,  1087,   476,   477,   478,   479,   480,
     481,   482,     0,  1088,   483,   484,   485,   486,   487,  1089,
       0,   488,   489,   490,   491,   492,   493,  1090,     0,   495,
     766,   496,   497,   498,   499,     0,     0,   500,     0,     0,
     501,   502,   503,   504,   505,   506,   507,  1091,  1092,  1093,
    1094,  1095,  1096,  1097,  1098,   516,   517,   518,     0,     0,
       0,     0,     0,     0,     0,     0,  1099,  1100,  1101,     0,
       0,     0,     0,     0,     0,  1102,   744,  1033,   574,  1034,
    1035,  1036,   625,  1037,     0,     0,     0,   211,   212,   213,
     214,   215,   216,   217,   218,     0,   220,   221,   222,     0,
       0,     0,     0,   223,  1038,     0,     0,   224,   225,     0,
     226,   227,   745,   228,   229,   230,   231,  1039,   746,  1040,
    1041,     0,   235,   236,   237,   238,   239,  1042,  1043,   240,
     241,  1044,  1045,   244,     0,   245,   246,   247,   248,  1046,
       0,  1047,     0,   250,   251,   252,   253,   748,   254,   255,
       0,   256,   257,   258,   259,   260,   261,     0,   749,   262,
     263,  1048,  1049,  1050,  1051,  1052,  1053,  1054,   264,   265,
     266,   267,   268,   269,  1055,  1056,   272,  1174,   273,     0,
     274,   275,   276,   277,   278,     0,   279,   280,   281,     0,
       0,   282,   283,  1057,   285,   286,     0,   287,   288,   289,
       0,   290,   291,   292,     0,   293,   294,   295,   296,  1058,
     298,   299,   300,  1059,  1060,   302,     0,   303,   304,  1061,
     306,     0,   307,     0,   308,   751,     0,   752,   309,   310,
     311,     0,   312,  1062,     0,   314,     0,   315,   316,   317,
     318,   319,   753,   320,   321,   322,     0,   323,   324,   325,
     326,   327,   328,     0,   329,   754,   330,   331,   332,   333,
     334,  1063,  1064,     0,  1065,     0,   338,   755,   756,   339,
     757,   340,   341,   342,   343,   344,     0,   345,   346,     0,
     347,  1066,   758,   349,   759,     0,   350,   351,   352,  1067,
    1068,   353,   354,   355,   356,   357,   358,   359,   360,   361,
     362,   363,   364,   365,  1069,   760,  1070,   368,   369,   370,
    1071,   371,   372,   761,   373,  1072,  1073,   375,  1074,   377,
     378,   379,     0,   380,     0,     0,  1075,   382,   383,     0,
       0,   384,   385,   762,   386,   763,  1076,   388,   389,   390,
     391,   392,   393,   394,     0,   395,  1077,   397,   398,   399,
     400,   401,     0,   402,   403,   404,   405,   406,   407,   408,
     409,  1078,   411,   412,   413,   414,     0,   415,   416,   417,
     418,   419,   420,   421,   422,   423,   424,   425,     0,   426,
     427,   764,   428,   429,  1079,   431,   432,   433,   434,   435,
     436,   437,   438,     0,   439,   440,   441,   442,   443,  1080,
     444,   445,   446,   447,   765,   448,  1081,   450,     0,   451,
     452,   453,   454,   455,   456,   457,   458,   459,   460,  1082,
       0,   462,   463,     0,   464,   465,   466,   467,   468,   469,
       0,  1083,  1084,     0,     0,   472,  1085,   474,  1086,  1087,
     476,   477,   478,   479,   480,   481,   482,     0,  1088,   483,
     484,   485,   486,   487,  1089,     0,   488,   489,   490,   491,
     492,   493,  1090,     0,   495,   766,   496,   497,   498,   499,
       0,     0,   500,     0,     0,   501,   502,   503,   504,   505,
     506,   507,  1091,  1092,  1093,  1094,  1095,  1096,  1097,  1098,
     516,   517,   518,     0,     0,     0,     0,     0,     0,     0,
       0,  1099,  1100,     0,     0,     0,     0,     0,     0,     0,
    1102,   744,  1033,   574,  1034,  1035,  1036,   625,  1037,     0,
       0,     0,   211,   212,   213,   214,   215,   216,   217,   218,
    1855,   220,   221,   222,     0,     0,     0,     0,   223,  1038,
       0,     0,   224,   225,     0,   226,   227,   745,   228,   229,
     230,   231,  1039,   746,  1040,  1041,     0,   235,   236,   237,
     238,   239,  1042,  1043,   240,   241,  1044,  1045,   244,     0,
     245,   246,   247,   248,  1046,     0,  1047,     0,   250,   251,
     252,   253,   748,   254,   255,     0,   256,   257,   258,   259,
     260,   261,     0,   749,   262,   263,  1048,  1049,  1050,  1051,
    1052,  1053,  1054,   264,   265,   266,   267,   268,   269,  1055,
    1056,   272,     0,   273,     0,   274,   275,   276,   277,   278,
       0,   279,   280,   281,     0,     0,   282,   283,  1057,   285,
     286,     0,   287,   288,   289,     0,   290,   291,   292,     0,
     293,   294,   295,   296,  1058,   298,   299,   300,  1059,  1060,
     302,     0,   303,   304,  1061,   306,     0,   307,     0,   308,
     751,     0,   752,   309,   310,   311,     0,   312,  1062,     0,
     314,     0,   315,   316,   317,   318,   319,   753,   320,   321,
     322,     0,   323,   324,   325,   326,   327,   328,     0,   329,
     754,   330,   331,   332,   333,   334,  1063,  1064,     0,  1065,
       0,   338,   755,   756,   339,   757,   340,   341,   342,   343,
     344,     0,   345,   346,     0,   347,  1066,   758,   349,   759,
       0,   350,   351,   352,  1067,  1068,   353,   354,   355,   356,
     357,   358,   359,   360,   361,   362,   363,   364,   365,  1069,
     760,  1070,   368,   369,   370,  1071,   371,   372,   761,   373,
    1072,  1073,   375,  1074,   377,   378,   379,     0,   380,     0,
       0,  1075,   382,   383,     0,     0,   384,   385,   762,   386,
     763,  1076,   388,   389,   390,   391,   392,   393,   394,     0,
     395,  1077,   397,   398,   399,   400,   401,     0,   402,   403,
     404,   405,   406,   407,   408,   409,  1078,   411,   412,   413,
     414,     0,   415,   416,   417,   418,   419,   420,   421,   422,
     423,   424,   425,     0,   426,   427,   764,   428,   429,  1079,
     431,   432,   433,   434,   435,   436,   437,   438,     0,   439,
     440,   441,   442,   443,  1080,   444,   445,   446,   447,   765,
     448,  1081,   450,     0,   451,   452,   453,   454,   455,   456,
     457,   458,   459,   460,  1082,     0,   462,   463,     0,   464,
     465,   466,   467,   468,   469,     0,  1083,  1084,     0,     0,
     472,  1085,   474,  1086,  1087,   476,   477,   478,   479,   480,
     481,   482,     0,  1088,   483,   484,   485,   486,   487,  1089,
       0,   488,   489,   490,   491,   492,   493,  1090,     0,   495,
     766,   496,   497,   498,   499,     0,     0,   500,     0,     0,
     501,   502,   503,   504,   505,   506,   507,  1091,  1092,  1093,
    1094,  1095,  1096,  1097,  1098,   516,   517,   518,     0,     0,
       0,     0,     0,     0,     0,     0,  1099,  1100,     0,     0,
       0,     0,     0,     0,     0,  1102,   744,  1033,   574,  1034,
    1035,  1036,   625,  1037,     0,     0,     0,   211,   212,   213,
     214,   215,   216,   217,   218,     0,   220,   221,   222,     0,
       0,     0,     0,   223,  1038,     0,     0,   224,   225,     0,
     226,   227,   745,   228,   229,   230,   231,  1039,   746,  1040,
    1041,     0,   235,   236,   237,   238,   239,  1042,  1043,   240,
     241,  1044,  1045,   244,     0,   245,   246,   247,   248,  1046,
       0,  1047,     0,   250,   251,   252,   253,   748,   254,   255,
       0,   256,   257,   258,   259,   260,   261,     0,   749,   262,
     263,  1048,  1049,  1050,  1051,  1052,  1053,  1054,   264,   265,
     266,   267,   268,   269,  1055,  1056,   272,     0,   273,     0,
     274,   275,   276,   277,   278,     0,   279,   280,   281,     0,
       0,   282,   283,  1057,   285,   286,     0,   287,   288,   289,
       0,   290,   291,   292,     0,   293,   294,   295,   296,  1058,
     298,   299,   300,  1059,  1060,   302,     0,   303,   304,  1061,
     306,     0,   307,     0,   308,   751,  2394,   752,   309,   310,
     311,     0,   312,  1062,     0,   314,     0,   315,   316,   317,
     318,   319,   753,   320,   321,   322,     0,   323,   324,   325,
     326,   327,   328,     0,   329,   754,   330,   331,   332,   333,
     334,  1063,  1064,     0,  1065,     0,   338,   755,   756,   339,
     757,   340,   341,   342,   343,   344,     0,   345,   346,     0,
     347,  1066,   758,   349,   759,     0,   350,   351,   352,  1067,
    1068,   353,   354,   355,   356,   357,   358,   359,   360,   361,
     362,   363,   364,   365,  1069,   760,  1070,   368,   369,   370,
    1071,   371,   372,   761,   373,  1072,  1073,   375,  1074,   377,
     378,   379,     0,   380,     0,     0,  1075,   382,   383,     0,
       0,   384,   385,   762,   386,   763,  1076,   388,   389,   390,
     391,   392,   393,   394,     0,   395,  1077,   397,   398,   399,
     400,   401,     0,   402,   403,   404,   405,   406,   407,   408,
     409,  1078,   411,   412,   413,   414,     0,   415,   416,   417,
     418,   419,   420,   421,   422,   423,   424,   425,     0,   426,
     427,   764,   428,   429,  1079,   431,   432,   433,   434,   435,
     436,   437,   438,     0,   439,   440,   441,   442,   443,  1080,
     444,   445,   446,   447,   765,   448,  1081,   450,     0,   451,
     452,   453,   454,   455,   456,   457,   458,   459,   460,  1082,
       0,   462,   463,     0,   464,   465,   466,   467,   468,   469,
       0,  1083,  1084,     0,     0,   472,  1085,   474,  1086,  1087,
     476,   477,   478,   479,   480,   481,   482,     0,  1088,   483,
     484,   485,   486,   487,  1089,     0,   488,   489,   490,   491,
     492,   493,  1090,     0,   495,   766,   496,   497,   498,   499,
       0,     0,   500,     0,     0,   501,   502,   503,   504,   505,
     506,   507,  1091,  1092,  1093,  1094,  1095,  1096,  1097,  1098,
     516,   517,   518,     0,     0,     0,     0,     0,     0,     0,
       0,  1099,  1100,     0,     0,     0,     0,     0,     0,     0,
    1102,   744,  1033,   574,  1034,  1035,  1036,   625,  1037,     0,
       0,     0,   211,   212,   213,   214,   215,   216,   217,   218,
       0,   220,   221,   222,     0,     0,     0,     0,   223,  1038,
       0,     0,   224,   225,     0,   226,   227,   745,   228,   229,
     230,   231,  1039,   746,  1040,  1041,     0,   235,   236,   237,
     238,   239,  1042,  1043,   240,   241,  1044,  1045,   244,     0,
     245,   246,   247,   248,  1046,     0,  1047,     0,   250,   251,
     252,   253,   748,   254,   255,     0,   256,   257,   258,   259,
     260,   261,     0,   749,   262,   263,  1048,  1049,  1050,  1051,
    1052,  1053,  1054,   264,   265,   266,   267,   268,   269,  1055,
    1056,   272,     0,   273,     0,   274,   275,   276,   277,   278,
       0,   279,   280,   281,     0,     0,   282,   283,  1057,   285,
     286,     0,   287,   288,   289,     0,   290,   291,   292,     0,
     293,   294,   295,   296,  1058,   298,   299,   300,  1059,  1060,
     302,     0,   303,   304,  1061,   306,     0,   307,     0,   308,
     751,     0,   752,   309,   310,   311,     0,   312,  1062,     0,
     314,     0,   315,   316,   317,   318,   319,   753,   320,   321,
     322,     0,   323,   324,   325,   326,   327,   328,     0,   329,
     754,   330,   331,   332,   333,   334,  1063,  1064,     0,  1065,
       0,   338,   755,   756,   339,   757,   340,   341,   342,   343,
     344,     0,   345,   346,     0,   347,  1066,   758,   349,   759,
       0,   350,   351,   352,  1067,  1068,   353,   354,   355,   356,
     357,   358,   359,   360,   361,   362,   363,   364,   365,  1069,
     760,  1070,   368,   369,   370,  1071,   371,   372,   761,   373,
    1072,  1073,   375,  1074,   377,   378,   379,     0,   380,     0,
       0,  1075,   382,   383,     0,     0,   384,   385,   762,   386,
     763,  1076,   388,   389,   390,   391,   392,   393,   394,     0,
     395,  1077,   397,   398,   399,   400,   401,     0,   402,   403,
     404,   405,   406,   407,   408,   409,  1078,   411,   412,   413,
     414,     0,   415,   416,   417,   418,   419,   420,   421,   422,
     423,   424,   425,     0,   426,   427,   764,   428,   429,  1079,
     431,   432,   433,   434,   435,   436,   437,   438,     0,   439,
     440,   441,   442,   443,  1080,   444,   445,   446,   447,   765,
     448,  1081,   450,     0,   451,   452,   453,   454,   455,   456,
     457,   458,   459,   460,  1082,     0,   462,   463,     0,   464,
     465,   466,   467,   468,   469,     0,  1083,  1084,     0,     0,
     472,  1085,   474,  1086,  1087,   476,   477,   478,   479,   480,
     481,   482,     0,  1088,   483,   484,   485,   486,   487,  1089,
       0,   488,   489,   490,   491,   492,   493,  1090,  3607,   495,
     766,   496,   497,   498,   499,     0,     0,   500,     0,     0,
     501,   502,   503,   504,   505,   506,   507,  1091,  1092,  1093,
    1094,  1095,  1096,  1097,  1098,   516,   517,   518,     0,     0,
       0,     0,     0,     0,     0,     0,  1099,  1100,     0,     0,
       0,     0,     0,     0,     0,  1102,   744,  1033,   574,  1034,
    1035,  1036,   625,  1037,     0,     0,     0,   211,   212,   213,
     214,   215,   216,   217,   218,     0,   220,   221,   222,     0,
       0,     0,     0,   223,  1038,     0,     0,   224,   225,     0,
     226,   227,   745,   228,   229,   230,   231,  1039,   746,  1040,
    1041,     0,   235,   236,   237,   238,   239,  1042,  1043,   240,
     241,  1044,  1045,   244,     0,   245,   246,   247,   248,  1046,
       0,  1047,     0,   250,   251,   252,   253,   748,   254,   255,
       0,   256,   257,   258,   259,   260,   261,     0,   749,   262,
     263,  1048,  1049,  1050,  1051,  1052,  1053,  1054,   264,   265,
     266,   267,   268,   269,  1055,  1056,   272,     0,   273,     0,
     274,   275,   276,   277,   278,     0,   279,   280,   281,     0,
       0,   282,   283,  1057,   285,   286,     0,   287,   288,   289,
       0,   290,   291,   292,     0,   293,   294,   295,   296,  1058,
     298,   299,   300,  1059,  1060,   302,     0,   303,   304,  1061,
     306,     0,   307,     0,   308,   751,     0,   752,   309,   310,
     311,     0,   312,  1062,     0,   314,     0,   315,   316,   317,
     318,   319,   753,   320,   321,   322,     0,   323,   324,   325,
     326,   327,   328,     0,   329,   754,   330,   331,   332,   333,
     334,  1063,  1064,     0,  1065,     0,   338,   755,   756,   339,
     757,   340,   341,   342,   343,   344,     0,   345,   346,     0,
     347,  1066,   758,   349,   759,     0,   350,   351,   352,  1067,
    1068,   353,   354,   355,   356,   357,   358,   359,   360,   361,
     362,   363,   364,   365,  1069,   760,  1070,   368,   369,   370,
    1071,   371,   372,   761,   373,  1072,  1073,   375,  1074,   377,
     378,   379,     0,   380,     0,     0,  1075,   382,   383,     0,
       0,   384,   385,   762,   386,   763,  1076,   388,   389,   390,
     391,   392,   393,   394,     0,   395,  1077,   397,   398,   399,
     400,   401,     0,   402,   403,   404,   405,   406,   407,   408,
     409,  1078,   411,   412,   413,   414,     0,   415,   416,   417,
     418,   419,   420,   421,   422,   423,   424,   425,     0,   426,
     427,   764,   428,   429,  1079,   431,   432,   433,   434,   435,
     436,   437,   438,     0,   439,   440,   441,   442,   443,  1080,
     444,   445,   446,   447,   765,   448,  1081,   450,     0,   451,
     452,   453,   454,   455,   456,   457,   458,   459,   460,  1082,
       0,   462,   463,     0,   464,   465,   466,   467,   468,   469,
       0,  1083,  1084,     0,     0,   472,  1085,   474,  1086,  1087,
     476,   477,   478,   479,   480,   481,   482,     0,  1088,   483,
     484,   485,   486,   487,  1089,     0,   488,   489,   490,   491,
     492,   493,  1090,     0,   495,   766,   496,   497,   498,   499,
       0,     0,   500,     0,     0,   501,   502,   503,   504,   505,
     506,   507,  1091,  1092,  1093,  1094,  1095,  1096,  1097,  1098,
     516,   517,   518,     0,     0,     0,     0,     0,     0,     0,
       0,  1099,  1100,     0,     0,     0,     0,     0,     0,     0,
    1102,   744,  1033,   574,  1034,  1035,  1036,   625,  1037,     0,
       0,     0,   211,   212,   213,   214,   215,   216,   217,   218,
       0,   220,   221,   222,     0,     0,     0,     0,   223,  1038,
       0,     0,   224,   225,     0,   226,   227,   745,   228,   229,
     230,   231,  1039,   746,  1040,  1041,     0,   235,   236,   237,
     238,   239,  1042,  1043,   240,   241,  1044,  1045,   244,     0,
     245,   246,   247,   248,  1046,     0,  1047,     0,   250,   251,
     252,   253,   748,   254,   255,     0,   256,   257,   258,   259,
     260,   261,     0,   749,   262,  3617,  1048,  1049,  1050,  1051,
    1052,  1053,  1054,   264,   265,   266,   267,   268,   269,  1055,
    1056,   272,     0,   273,     0,   274,   275,   276,   277,   278,
       0,   279,   280,   281,     0,     0,   282,   283,  1057,   285,
     286,     0,   287,   288,   289,     0,   290,   291,   292,     0,
     293,   294,   295,   296,  1058,   298,   299,   300,  1059,  1060,
     302,     0,   303,   304,  1061,   306,     0,   307,     0,   308,
     751,     0,   752,   309,   310,   311,     0,   312,  1062,     0,
     314,     0,   315,   316,   317,   318,   319,   753,   320,   321,
     322,     0,   323,   324,   325,   326,   327,   328,     0,   329,
     754,   330,   331,   332,   333,   334,  1063,  1064,     0,  1065,
       0,   338,   755,   756,   339,   757,   340,   341,   342,   343,
     344,     0,   345,   346,     0,   347,  1066,   758,   349,   759,
       0,   350,   351,   352,  1067,  1068,   353,   354,   355,   356,
     357,   358,   359,   360,   361,   362,   363,   364,   365,  1069,
     760,  1070,   368,   369,   370,  1071,   371,   372,   761,   373,
    1072,  1073,   375,  1074,   377,   378,   379,     0,   380,     0,
       0,  1075,   382,   383,     0,     0,   384,   385,   762,   386,
     763,  1076,   388,   389,   390,   391,   392,   393,   394,     0,
     395,  1077,   397,   398,   399,   400,   401,     0,   402,   403,
     404,   405,   406,   407,   408,   409,  1078,   411,   412,   413,
     414,     0,   415,   416,   417,   418,   419,   420,   421,   422,
     423,   424,   425,     0,   426,   427,   764,   428,   429,  1079,
     431,   432,   433,   434,   435,   436,   437,   438,     0,   439,
     440,   441,   442,   443,  1080,   444,   445,   446,   447,   765,
     448,  1081,   450,     0,   451,   452,   453,   454,   455,   456,
     457,   458,   459,   460,  1082,     0,   462,   463,     0,   464,
     465,   466,   467,   468,   469,     0,  1083,  1084,     0,     0,
     472,  1085,   474,  1086,  1087,   476,   477,   478,   479,   480,
     481,   482,     0,  1088,   483,   484,   485,   486,   487,  1089,
       0,   488,   489,   490,   491,   492,   493,  1090,     0,   495,
     766,   496,   497,   498,   499,     0,     0,   500,     0,     0,
     501,   502,   503,   504,   505,   506,   507,  1091,  1092,  1093,
    1094,  1095,  1096,  1097,  1098,   516,   517,   518,     0,     0,
       0,     0,     0,     0,     0,     0,  1099,  1100,     0,     0,
       0,     0,     0,     0,     0,  1102,   744,  1033,   574,  1034,
    1035,  1036,   625,  1037,     0,     0,     0,   211,   212,   213,
     214,   215,   216,   217,   218,     0,   220,   221,   222,     0,
       0,     0,     0,   223,  1038,     0,     0,   224,   225,     0,
     226,   227,   745,   228,   229,   230,   231,  1039,   746,  1040,
    1041,     0,   235,   236,   237,   238,   239,  1042,  1043,   240,
     241,  1044,  1045,   244,     0,   245,   246,   247,   248,  1046,
       0,  1047,     0,   250,   251,   252,   253,   748,   254,   255,
       0,   256,   257,   258,   259,   260,   261,     0,   749,   262,
     263,  1048,  1049,  1050,  1051,  1052,  1053,  1054,   264,   265,
     266,   267,   268,   269,  1055,  1056,   272,     0,   273,     0,
     274,   275,   276,   277,   278,     0,   279,   280,   281,     0,
       0,   282,   283,  1057,   285,   286,     0,   287,   288,   289,
       0,   290,   291,   292,     0,   293,   294,   295,   296,  1058,
     298,   299,   300,  1059,  1060,   302,     0,   303,   304,  1061,
     306,     0,   307,     0,   308,   751,     0,   752,   309,   310,
     311,     0,   312,  1062,     0,   314,     0,   315,   316,   317,
     318,   319,   753,   320,   321,   322,     0,   323,   324,   325,
     326,   327,   328,     0,   329,   754,   330,   331,   332,   333,
     334,  1063,  1064,     0,  1065,     0,   338,   755,   756,   339,
     757,   340,   341,   342,   343,   344,     0,   345,   346,     0,
     347,  1066,   758,   349,   759,     0,   350,   351,   352,  1067,
    1068,   353,   354,   355,   356,   357,   358,   359,   360,   361,
     362,   363,   364,   365,  1069,   760,  1070,   368,   369,   370,
    1071,   371,   372,   761,   373,  1072,  1073,   375,  1074,   377,
     378,   379,     0,   380,     0,     0,  1075,   382,   383,     0,
       0,   384,   385,   762,   386,   763,  1076,   388,   389,   390,
     391,   392,   393,   394,     0,   395,  1077,   397,   398,   399,
     400,   401,     0,   402,   403,   404,   405,   406,   407,   408,
     409,  1078,   411,   412,   413,   414,     0,   415,   416,   417,
     418,   419,   420,   421,   422,   423,   424,   425,     0,   426,
     427,   764,   428,   429,  1079,   431,   432,   433,   434,   435,
     436,   437,   438,     0,   439,   440,   441,   442,   443,  1080,
     444,   445,   446,   447,   765,   448,  1081,   450,     0,   451,
     452,   453,   454,   455,   456,   457,   458,   459,   460,  1082,
       0,   462,   463,     0,   464,   465,   466,   467,   468,   469,
       0,  1083,  1084,     0,     0,   472,  1085,   474,  1086,  1087,
     476,   477,   478,   479,   480,   481,   482,     0,  1088,   483,
     484,   485,   486,   487,  1089,     0,   488,   489,   490,   491,
     492,   493,  1090,     0,   495,   766,   496,   497,   498,   499,
       0,     0,   500,     0,     0,   501,   502,   503,   504,   505,
     506,  3904,  1091,  1092,  1093,  1094,  1095,  1096,  1097,  1098,
     516,   517,   518,     0,     0,     0,     0,     0,     0,     0,
       0,  1099,  1100,     0,     0,     0,     0,     0,     0,     0,
    1102,   744,  1033,   574,  1034,  1035,  1036,   625,  1037,     0,
       0,     0,   211,   212,   213,   214,   215,   216,   217,   218,
       0,   220,   221,   222,     0,     0,     0,     0,   223,  1038,
       0,     0,   224,   225,     0,   226,   227,   745,   228,   229,
     230,   231,  1039,   746,  1040,  1041,     0,   235,   236,   237,
     238,   239,  1042,  1043,   240,   241,  1044,  1045,   244,     0,
     245,   246,   247,   248,  1046,     0,  1047,     0,   250,   251,
     252,   253,   748,   254,   255,     0,   256,   257,   258,   259,
     260,   261,     0,   749,   262,   263,  1048,  1049,  1050,  1051,
    1052,  1053,  1054,   264,   265,   266,   267,   268,   269,  1055,
    1056,   272,     0,   273,     0,   274,   275,   276,   277,   278,
       0,   279,   280,   281,     0,     0,   282,   283,  1057,   285,
     286,     0,   287,   288,   289,     0,   290,   291,   292,     0,
     293,   294,   295,   296,  1058,   298,   299,   300,  1059,  1060,
     302,     0,   303,   304,  1061,   306,     0,   307,     0,   308,
     751,     0,   752,   309,   310,   311,     0,   312,  1062,     0,
     314,     0,   315,   316,   317,   318,   319,   753,   320,   321,
     322,     0,   323,   324,   325,   326,   327,   328,     0,   329,
     754,   330,   331,   332,   333,   334,  1063,  1064,     0,  1065,
       0,   338,   755,   756,   339,   757,   340,   341,   342,   343,
     344,     0,   345,   346,     0,   347,  1066,   758,   349,   759,
       0,   350,   351,   352,  1067,  1068,   353,   354,   355,   356,
     357,   358,   359,   360,   361,   362,   363,   364,   365,  1069,
     760,  1070,   368,  3913,   370,  1071,   371,   372,   761,   373,
    1072,  1073,   375,  1074,   377,   378,   379,     0,   380,     0,
       0,  1075,   382,   383,     0,     0,   384,   385,   762,   386,
     763,  1076,   388,   389,   390,   391,   392,   393,   394,     0,
     395,  1077,   397,   398,   399,   400,   401,     0,   402,   403,
     404,   405,   406,   407,   408,   409,  1078,   411,   412,   413,
     414,     0,   415,   416,   417,   418,   419,   420,   421,   422,
     423,   424,   425,     0,   426,   427,   764,   428,   429,  1079,
     431,   432,   433,   434,   435,   436,   437,   438,     0,   439,
     440,   441,   442,   443,  1080,   444,   445,   446,   447,   765,
     448,  1081,   450,     0,   451,   452,   453,   454,   455,   456,
     457,   458,   459,   460,  1082,     0,   462,   463,     0,   464,
     465,   466,   467,   468,   469,     0,  1083,  1084,     0,     0,
     472,  1085,   474,  1086,  1087,   476,   477,   478,   479,   480,
     481,   482,     0,  1088,   483,   484,   485,   486,   487,  1089,
       0,   488,   489,   490,   491,   492,   493,  1090,     0,   495,
     766,   496,   497,   498,   499,     0,     0,   500,     0,     0,
     501,   502,   503,   504,   505,   506,   507,  1091,  1092,  1093,
    1094,  1095,  1096,  1097,  1098,   516,   517,   518,     0,     0,
       0,     0,     0,     0,     0,     0,  1099,  1100,     0,     0,
       0,     0,     0,     0,     0,  1102,   744,  1033,   574,  1034,
    1035,  1036,   625,  1037,     0,     0,     0,   211,   212,   213,
     214,   215,   216,   217,   218,     0,   220,   221,   222,     0,
       0,     0,     0,   223,  1038,     0,     0,   224,   225,     0,
     226,   227,   745,   228,   229,   230,  4486,  1039,   746,  1040,
    1041,     0,   235,   236,   237,   238,   239,  1042,  1043,   240,
     241,  1044,  1045,   244,     0,   245,   246,   247,   248,  1046,
       0,  1047,     0,   250,   251,   252,   253,   748,   254,   255,
       0,   256,   257,   258,   259,   260,   261,     0,   749,   262,
    4487,  1048,  1049,  1050,  1051,  1052,  1053,  1054,   264,   265,
     266,   267,   268,   269,  1055,  1056,   272,     0,   273,     0,
     274,   275,   276,   277,   278,     0,   279,   280,   281,     0,
       0,   282,   283,  1057,   285,   286,     0,   287,   288,   289,
       0,   290,   291,   292,     0,   293,   294,   295,   296,  1058,
     298,   299,   300,  1059,  1060,   302,     0,   303,   304,  1061,
     306,     0,   307,     0,   308,   751,     0,   752,   309,   310,
     311,     0,   312,  1062,     0,   314,     0,   315,   316,   317,
     318,   319,   753,   320,   321,   322,     0,   323,   324,   325,
     326,   327,   328,     0,   329,   754,   330,   331,   332,   333,
     334,  1063,  1064,     0,  1065,     0,   338,   755,   756,   339,
     757,   340,   341,   342,   343,   344,     0,   345,   346,     0,
     347,  1066,   758,   349,   759,     0,   350,   351,   352,  1067,
    1068,   353,   354,   355,   356,   357,   358,   359,   360,   361,
     362,   363,   364,   365,  1069,   760,  1070,   368,   369,   370,
    1071,   371,   372,   761,   373,  1072,  1073,   375,  1074,   377,
     378,   379,     0,   380,     0,     0,  1075,   382,   383,     0,
       0,   384,   385,   762,   386,   763,  1076,   388,   389,   390,
     391,   392,   393,   394,     0,   395,  1077,   397,   398,   399,
     400,   401,     0,   402,   403,   404,   405,   406,   407,   408,
     409,  1078,   411,   412,   413,   414,     0,   415,   416,   417,
     418,   419,   420,   421,   422,   423,   424,   425,     0,   426,
     427,   764,   428,   429,  1079,   431,   432,   433,   434,   435,
     436,   437,   438,     0,   439,   440,   441,   442,   443,  1080,
     444,   445,   446,   447,   765,   448,  1081,   450,     0,   451,
     452,   453,   454,   455,   456,   457,   458,   459,   460,  1082,
       0,   462,   463,     0,   464,   465,   466,   467,   468,   469,
       0,  1083,  1084,     0,     0,   472,  1085,   474,  1086,  1087,
     476,   477,   478,   479,  4488,   481,   482,     0,  1088,   483,
     484,   485,   486,   487,  1089,     0,   488,   489,   490,   491,
     492,   493,  1090,     0,   495,   766,   496,   497,   498,   499,
       0,     0,   500,     0,     0,   501,   502,   503,   504,   505,
     506,   507,  1091,  1092,  1093,  1094,  1095,  1096,  1097,  1098,
     516,   517,   518,     0,     0,     0,     0,     0,     0,     0,
       0,  1099,  1100,     0,     0,     0,     0,     0,     0,     0,
    1102,   744,  1033,   574,  1034,  1035,  1036,   625,  1037,     0,
       0,     0,   211,   212,   213,   214,   215,   216,   217,   218,
       0,   220,   221,   222,     0,     0,     0,     0,   223,  1038,
       0,     0,   224,   225,     0,   226,   227,   745,   228,   229,
     230,   231,  1039,   746,  1040,  1041,     0,   235,   236,   237,
     238,   239,  1042,  1043,   240,   241,  1044,  1045,   244,     0,
     245,   246,   247,   248,  1046,     0,  1047,     0,   250,   251,
     252,   253,   748,   254,   255,     0,   256,   257,   258,   259,
     260,   261,     0,   749,   262,  4487,  1048,  1049,  1050,  1051,
    1052,  1053,  1054,   264,   265,   266,   267,   268,   269,  1055,
    1056,   272,     0,   273,     0,   274,   275,   276,   277,   278,
       0,   279,   280,   281,     0,     0,   282,   283,  1057,   285,
     286,     0,   287,   288,   289,     0,   290,   291,   292,     0,
     293,   294,   295,   296,  1058,   298,   299,   300,  1059,  1060,
     302,     0,   303,   304,  1061,   306,     0,   307,     0,   308,
     751,     0,   752,   309,   310,   311,     0,   312,  1062,     0,
     314,     0,   315,   316,   317,   318,   319,   753,   320,   321,
     322,     0,   323,   324,   325,   326,   327,   328,     0,   329,
     754,   330,   331,   332,   333,   334,  1063,  1064,     0,  1065,
       0,   338,   755,   756,   339,   757,   340,   341,   342,   343,
     344,     0,   345,   346,     0,   347,  1066,   758,   349,   759,
       0,   350,   351,   352,  1067,  1068,   353,   354,   355,   356,
     357,   358,   359,   360,   361,   362,   363,   364,   365,  1069,
     760,  1070,   368,   369,   370,  1071,   371,   372,   761,   373,
    1072,  1073,   375,  1074,   377,   378,   379,     0,   380,     0,
       0,  1075,   382,   383,     0,     0,   384,   385,   762,   386,
     763,  1076,   388,   389,   390,   391,   392,   393,   394,     0,
     395,  1077,   397,   398,   399,   400,   401,     0,   402,   403,
     404,   405,   406,   407,   408,   409,  1078,   411,   412,   413,
     414,     0,   415,   416,   417,   418,   419,   420,   421,   422,
     423,   424,   425,     0,   426,   427,   764,   428,   429,  1079,
     431,   432,   433,   434,   435,   436,   437,   438,     0,   439,
     440,   441,   442,   443,  1080,   444,   445,   446,   447,   765,
     448,  1081,   450,     0,   451,   452,   453,   454,   455,   456,
     457,   458,   459,   460,  1082,     0,   462,   463,     0,   464,
     465,   466,   467,   468,   469,     0,  1083,  1084,     0,     0,
     472,  1085,   474,  1086,  1087,   476,   477,   478,   479,  4488,
     481,   482,     0,  1088,   483,   484,   485,   486,   487,  1089,
       0,   488,   489,   490,   491,   492,   493,  1090,     0,   495,
     766,   496,   497,   498,   499,     0,     0,   500,     0,     0,
     501,   502,   503,   504,   505,   506,   507,  1091,  1092,  1093,
    1094,  1095,  1096,  1097,  1098,   516,   517,   518,     0,     0,
       0,     0,     0,     0,     0,     0,  1099,  1100,     0,     0,
       0,     0,     0,     0,     0,  1102,   744,  1033,   574,  1034,
    1035,  1036,   625,  1037,     0,     0,     0,   211,   212,   213,
     214,   215,   216,   217,   218,     0,   220,   221,   222,     0,
       0,     0,     0,   223,  1038,     0,     0,   224,   225,     0,
     226,   227,   745,   228,   229,   230,   231,  1039,   746,  1040,
    1041,     0,   235,   236,   237,   238,   239,  1042,  1043,   240,
     241,  1044,  1045,   244,     0,   245,   246,   247,   248,  1046,
       0,  1047,     0,   250,   251,   252,   253,   748,   254,   255,
       0,   256,   257,   258,   259,   260,   261,     0,   749,   262,
     263,  1048,  1049,  1050,  1051,  1052,  1053,  1054,   264,   265,
     266,   267,   268,   269,  1055,  1056,   272,     0,   273,     0,
     274,   275,   276,   277,   278,     0,   279,   280,   281,     0,
       0,   282,   283,  1057,   285,   286,     0,   287,   288,   289,
       0,   290,   291,   292,     0,   293,   294,   295,   296,  1058,
     298,   299,   300,  1059,  1060,   302,     0,   303,   304,  1061,
     306,     0,   307,     0,   308,   751,     0,   752,   309,   310,
     311,     0,   312,  1062,     0,   314,     0,   315,   316,   317,
     318,   319,   753,   320,   321,   322,     0,   323,   324,   325,
     326,   327,   328,     0,   329,   754,   330,   331,   332,   333,
     334,  1063,  1064,     0,  1065,     0,   338,   755,   756,   339,
     757,   340,   341,   342,   343,   344,     0,   345,   346,     0,
     347,  1066,   758,   349,   759,     0,   350,   351,   352,  1067,
    1068,   353,   354,   355,   356,   357,   358,   359,   360,   361,
     362,   363,   364,   365,  1069,   760,  1070,   368,   369,   370,
       0,   371,   372,   761,   373,  1072,  1073,   375,  1074,   377,
     378,   379,     0,   380,     0,     0,  1075,   382,   383,     0,
       0,   384,   385,   762,   386,   763,  1076,   388,   389,   390,
     391,   392,   393,   394,     0,   395,  1077,   397,   398,   399,
     400,   401,     0,   402,   403,   404,   405,   406,   407,   408,
     409,  1078,   411,   412,   413,   414,     0,   415,   416,   417,
     418,   419,   420,   421,   422,   423,   424,   425,     0,   426,
     427,   764,   428,   429,  1079,   431,   432,   433,   434,   435,
     436,   437,   438,     0,   439,   440,   441,   442,   443,  1080,
     444,   445,   446,   447,   765,   448,  1081,   450,     0,   451,
     452,   453,   454,   455,   456,   457,   458,   459,   460,  1082,
       0,   462,   463,     0,   464,   465,   466,   467,   468,   469,
       0,  1083,  1084,     0,     0,   472,  1085,   474,  1086,  1087,
     476,   477,   478,   479,   480,   481,   482,     0,     0,   483,
     484,   485,   486,   487,  1089,     0,   488,   489,   490,   491,
     492,   493,  1090,     0,   495,   766,   496,   497,   498,   499,
       0,     0,   500,     0,     0,   501,   502,   503,   504,   505,
     506,   507,  1091,  1092,  1093,  1094,  1095,  1096,  1097,  1098,
     516,   517,   518,     0,     0,     0,     0,     0,     0,     0,
       0,  2376,  2377,     0,     0,     0,     0,     0,     0,     0,
    1102,   744,  1033,   574,  1034,  1035,  1036,   625,  1037,     0,
       0,     0,   211,   212,   213,   214,   215,   216,   217,   218,
       0,   220,   221,   222,     0,     0,     0,     0,   223,  1038,
       0,     0,   224,   225,     0,   226,   227,   745,   228,   229,
     230, -2278,  1039,   746,  1040,  1041,     0,   235,   236,   237,
     238,   239,  1042,  1043,   240,   241,  1044,  1045,   244,     0,
     245,   246,   247,   248,  1046,     0,  1047,     0,   250,   251,
     252,   253,   748,   254,   255,     0,   256,   257,   258,   259,
     260,   261,     0,   749,   262,  4487,  1048,  1049,  1050,  1051,
    1052,  1053,  1054,   264,   265,   266,   267,   268,   269,  1055,
    1056,   272,     0,   273,     0,   274,   275,   276,   277,   278,
       0,   279,   280,   281,     0,     0,   282,   283,  1057,   285,
     286,     0,   287,   288,   289,     0,   290,   291,   292,     0,
     293,   294,   295,   296,  1058,   298,   299,   300,  1059,  1060,
     302,     0,   303,   304,  1061,   306,     0,   307,     0,   308,
     751,     0,   752,   309,   310,   311,     0,   312,  1062,     0,
     314,     0,   315,   316,   317,   318,   319,     0,   320,   321,
     322,     0,   323,   324,   325,   326,   327,   328,     0,   329,
     754,   330,   331,   332,   333,   334,  1063,  1064,     0,  1065,
       0,   338,   755,   756,   339,   757,   340,   341,   342,   343,
     344,     0,   345,   346,     0,   347,  1066,   758,   349,     0,
       0,   350,   351,   352,  1067,  1068,   353,   354,   355,   356,
     357,   358,   359,   360,   361,   362,   363,   364,   365,  1069,
     760,  1070,   368,   369,   370,     0,   371,   372,   761,   373,
    1072,  1073,   375,  1074,   377,   378,   379,     0,   380,     0,
       0,  1075,   382,   383,     0,     0,   384,   385,   762,   386,
     763,  1076,   388,   389,   390,   391,   392,   393,   394,     0,
     395,  1077,   397,   398,   399,   400,   401,     0,   402,   403,
     404,   405,   406,   407,   408,   409,  1078,   411,   412,   413,
     414,     0,   415,   416,   417,   418,   419,   420,   421,   422,
     423,   424,   425,     0,   426,   427,   764,   428,   429,  1079,
     431,   432,   433,   434,   435,   436,   437,   438,     0,   439,
     440,   441,   442,   443,  1080,   444,   445,   446,   447,     0,
     448,  1081,   450,     0,   451,   452,   453,   454,   455,   456,
     457,   458,   459,   460,  1082,     0,   462,   463,     0,   464,
     465,   466,   467,   468,   469,     0,  1083,  1084,     0,     0,
     472,  1085,   474,  1086,  1087,   476,   477,   478,   479,  4488,
     481,   482,     0,  1088,   483,   484,   485,   486,   487,  1089,
       0,   488,   489,   490,   491,   492,   493,  1090,     0,   495,
     766,   496,   497,   498,   499,     0,     0,   500,     0,     0,
     501,   502,   503,   504,   505,   506,   507,  1091,  1092,  1093,
    1094,  1095,  1096,  1097,  1098,   516,   517,   518,     0,     0,
       0,     0,     0,     0,     0,     0,  1099,  1100,     0,     0,
     744,  1033,   574,  1034,  1035,  1102,   625,  1037,     0,     0,
       0,   211,   212,   213,   214,   215,   216,   217,   218,     0,
     220,   221,   222,     0,     0,     0,     0,   223,  1038,     0,
       0,   224,   225,     0,   226,   227,   745,   228,   229,   230,
     231,  1039,   746,  1040,  1041,     0,   235,   236,   237,   238,
     239,  1042,  1043,   240,   241,  1044,  1045,   244,     0,   245,
     246,   247,   248,  1046,     0,  1047,     0,   250,   251,   252,
     253,   748,   254,   255,     0,   256,   257,   258,   259,   260,
     261,     0,   749,   262,   263,  1048,  1049,  1050,  1051,  1052,
    1053,  1054,   264,   265,   266,   267,   268,   269,  1055,  1056,
     272,     0,   273,     0,   274,   275,   276,   277,   278,     0,
     279,   280,   281,     0,     0,   282,   283,  1057,   285,   286,
       0,   287,   288,   289,     0,   290,   291,   292,     0,   293,
     294,   295,   296,  1058,   298,   299,   300,  1059,  1060,   302,
       0,   303,   304,  1061,   306,     0,   307,     0,   308,   751,
       0,   752,   309,   310,   311,     0,   312,  1062,     0,   314,
       0,   315,   316,   317,   318,   319,   753,   320,   321,   322,
       0,   323,   324,   325,   326,   327,   328,     0,   329,   754,
     330,   331,   332,   333,   334,  1063,  1064,     0,  1065,     0,
     338,   755,   756,   339,   757,   340,   341,   342,   343,   344,
       0,   345,   346,     0,   347,  1066,   758,   349,   759,     0,
     350,   351,   352,  1067,  1068,   353,   354,   355,   356,   357,
     358,   359,   360,   361,   362,   363,   364,   365,  1069,   760,
    1070,   368,   369,   370,     0,   371,   372,   761,   373,  1072,
    1073,   375,  1074,   377,   378,   379,     0,   380,     0,     0,
     381,   382,   383,     0,     0,   384,   385,   762,   386,   763,
    1076,   388,   389,   390,   391,   392,   393,   394,     0,   395,
    1077,   397,   398,   399,   400,   401,     0,   402,   403,   404,
     405,   406,   407,   408,   409,  1078,   411,   412,   413,   414,
       0,   415,   416,   417,   418,   419,   420,   421,   422,   423,
     424,   425,     0,   426,   427,   764,   428,   429,  1079,   431,
     432,   433,   434,   435,   436,   437,   438,     0,   439,   440,
     441,   442,   443,  1080,   444,   445,   446,   447,   765,   448,
    1081,   450,     0,   451,   452,   453,   454,   455,   456,   457,
     458,   459,   460,  1082,     0,   462,   463,     0,   464,   465,
     466,   467,   468,   469,     0,  1083,  1084,     0,     0,   472,
    1085,   474,  1086,  1087,   476,   477,   478,   479,   480,   481,
     482,     0,     0,   483,   484,   485,   486,   487,  1089,     0,
     488,   489,   490,   491,   492,   493,  1090,     0,   495,   766,
     496,   497,   498,   499,     0,     0,   500,     0,     0,   501,
     502,   503,   504,   505,   506,   507,  1091,  1092,  1093,  1094,
    1095,  1096,  1097,  1098,   516,   517,   518,     0,     0,     0,
       0,     0,     0,     0,   744,  1033,   574,  1034,  1035,     0,
     625,  1037,     0,     0,  1102,   211,   212,   213,   214,   215,
     216,   217,   218,     0,   220,   221,   222,     0,     0,     0,
       0,   223,  1038,     0,     0,   224,   225,     0,   226,   227,
     745,   228,   229,   230,   231,  1039,   746,  1040,  1041,     0,
    3525,   236,   237,   238,   239,  1042,  1043,   240,   241,  1044,
    1045,   244,     0,   245,   246,   247,   248,  1046,     0,  1047,
       0,   250,   251,   252,   253,   748,   254,   255,     0,   256,
     257,   258,   259,   260,   261,     0,   749,   262,   263,  1048,
    1049,  1050,  1051,  1052,  1053,  1054,   264,   265,   266,   267,
     268,   269,  1055,  1056,   272,     0,   273,     0,   274,   275,
     276,   277,   278,     0,   279,   280,   281,     0,     0,   282,
     283,  1057,   285,   286,     0,   287,   288,   289,     0,   290,
     291,   292,     0,   293,   294,   295,   296,  1058,   298,   299,
     300,  1059,  1060,   302,     0,   303,   304,  1061,   306,     0,
     307,     0,   308,   751,     0,   752,   309,   310,   311,     0,
     312,  1062,     0,   314,     0,   315,   316,   317,   318,   319,
     753,   320,   321,   322,     0,   323,   324,   325,   326,   327,
     328,     0,   329,   754,   330,   331,   332,   333,   334,  1063,
    1064,     0,  1065,     0,   338,   755,   756,   339,   757,   340,
     341,   342,   343,   344,     0,   345,   346,     0,   347,  1066,
     758,   349,   759,     0,   350,   351,   352,  1067,  1068,   353,
     354,   355,   356,   357,   358,   359,   360,   361,   362,   363,
     364,   365,  1069,   760,  1070,   368,   369,   370,     0,   371,
     372,   761,   373,  1072,  1073,   375,  1074,   377,   378,   379,
       0,   380,     0,     0,   381,   382,   383,     0,     0,   384,
     385,   762,   386,   763,  1076,   388,   389,   390,   391,   392,
     393,   394,     0,   395,  1077,   397,   398,   399,   400,   401,
       0,   402,   403,   404,   405,   406,   407,   408,   409,  1078,
     411,   412,   413,   414,     0,   415,   416,   417,   418,   419,
     420,   421,   422,   423,   424,   425,     0,   426,   427,   764,
     428,   429,  1079,   431,   432,   433,   434,   435,   436,   437,
     438,     0,   439,   440,   441,   442,   443,  1080,   444,   445,
     446,   447,   765,   448,  1081,   450,     0,   451,   452,   453,
     454,   455,   456,   457,   458,   459,   460,  1082,     0,   462,
     463,     0,   464,   465,   466,   467,   468,   469,     0,  1083,
    1084,     0,     0,   472,  1085,   474,  1086,  1087,   476,   477,
     478,   479,   480,   481,   482,     0,     0,   483,   484,   485,
     486,   487,  1089,     0,   488,   489,   490,   491,   492,   493,
    1090,     0,   495,   766,   496,   497,   498,   499,     0,     0,
     500,     0,     0,   501,   502,   503,   504,   505,   506,   507,
    1091,  1092,  1093,  1094,  1095,  1096,  1097,  1098,   516,   517,
     518,     0,     0,     0,     0,     0,     0,     0,   744,  1033,
     574,  1034,  1035,  1036,   625,  1037,     0,     0,  1102,   211,
     212,   213,   214,   215,   216,   217,   218,     0,   220,   221,
     222,     0,     0,     0,     0,   223,  1038,     0,     0,   224,
     225,     0,   226,   227,   745,   228,   229,   230,     0,  1039,
     746,  1040,  1041,     0,   235,   236,   237,   238,   239,  1042,
    1043,   240,   241,  1044,  1045,   244,     0,   245,   246,   247,
     248,  1046,     0,  1047,     0,   250,   251,   252,   253,   748,
     254,   255,     0,   256,   257,   258,   259,   260,   261,     0,
     749,   262,   263,  1048,  1049,  1050,  1051,  1052,  1053,  1054,
     264,   265,   266,   267,   268,   269,  1055,  1056,   272,     0,
     273,     0,   274,   275,   276,   277,   278,     0,   279,   280,
     281,     0,     0,   282,   283,  1057,   285,   286,     0,   287,
     288,   289,     0,   290,     0,   292,     0,   293,   294,   295,
     296,  1058,   298,   299,   300,  1059,  1060,   302,     0,   303,
     304,  1061,   306,     0,   307,     0,   308,   751,     0,   752,
     309,   310,   311,     0,   312,  1062,     0,   314,     0,   315,
     316,   317,   318,   319,     0,   320,   321,   322,     0,   323,
     324,   325,   326,   327,   328,     0,   329,   754,   330,   331,
     332,   333,   334,  1063,  1064,     0,  1065,     0,   338,   755,
     756,   339,   757,   340,   341,   342,   343,   344,     0,   345,
     346,     0,   347,  1066,   758,   349,     0,     0,   350,   351,
     352,  1067,  1068,   353,   354,   355,   356,   357,   358,   359,
     360,   361,   362,   363,   364,   365,  1069,   760,  1070,   368,
     369,   370,     0,   371,   372,   761,   373,  1072,  1073,   375,
    1074,   377,   378,   379,     0,   380,     0,     0,  1075,   382,
     383,     0,     0,   384,   385,   762,   386,   763,  1076,   388,
     389,   390,   391,   392,   393,   394,     0,   395,  1077,   397,
     398,   399,   400,   401,     0,   402,   403,   404,   405,   406,
     407,   408,   409,  1078,   411,   412,   413,   414,     0,   415,
     416,   417,   418,   419,   420,   421,   422,   423,   424,   425,
       0,   426,   427,   764,   428,   429,  1079,   431,   432,   433,
     434,   435,   436,   437,   438,     0,   439,   440,   441,   442,
     443,  1080,   444,   445,   446,   447,     0,   448,  1081,   450,
       0,   451,   452,   453,   454,   455,   456,   457,   458,   459,
     460,  1082,     0,   462,   463,     0,   464,   465,   466,   467,
     468,   469,     0,  1083,  1084,     0,     0,   472,  1085,   474,
    1086,  1087,   476,   477,   478,   479,   480,   481,   482,     0,
    1088,   483,   484,   485,   486,   487,  1089,     0,   488,   489,
     490,   491,   492,   493,  1090,     0,   495,   766,   496,   497,
     498,   499,     0,     0,   500,     0,     0,   501,   502,   503,
     504,   505,   506,   507,  1091,  1092,  1093,  1094,  1095,  1096,
    1097,  1098,   516,   517,   518,     0,     0,     0,     0,     0,
       0,     0,     0,  1099,  1100,     0,     0,     0,     0,     0,
       0,     0,  1102,   744,  1033,   574,  1034,  1035,  1036,   625,
    1037,     0,     0,     0,   211,   212,   213,   214,   215,   216,
     217,   218,     0,   220,   221,   222,     0,     0,     0,     0,
     223,  1038,     0,     0,   224,   225,     0,   226,   227,   745,
     228,   229,   230,     0,  1039,   746,  1040,  1041,     0,   235,
     236,   237,   238,   239,  1042,  1043,   240,   241,  1044,  1045,
     244,     0,   245,   246,   247,   248,  1046,     0,  1047,     0,
     250,   251,   252,   253,   748,   254,   255,     0,   256,   257,
     258,   259,   260,   261,     0,   749,   262,   263,  1048,  1049,
    1050,  1051,  1052,  1053,  1054,   264,   265,   266,   267,   268,
     269,  1055,  1056,   272,     0,   273,     0,   274,   275,   276,
     277,   278,     0,   279,   280,   281,     0,     0,   282,   283,
    1057,   285,   286,     0,   287,   288,   289,     0,   290,     0,
     292,     0,   293,   294,   295,   296,  1058,   298,   299,   300,
    1059,  1060,   302,     0,   303,   304,  1061,   306,     0,   307,
       0,   308,   751,     0,   752,   309,   310,   311,     0,   312,
    1062,     0,   314,     0,   315,   316,   317,   318,   319,     0,
     320,   321,   322,     0,   323,   324,   325,   326,   327,   328,
       0,   329,   754,   330,   331,   332,   333,   334,  1063,  1064,
       0,  1065,     0,   338,   755,   756,   339,   757,   340,   341,
     342,   343,   344,     0,   345,   346,     0,   347,  1066,   758,
     349,     0,     0,   350,   351,   352,  1067,  1068,   353,   354,
     355,   356,   357,   358,   359,   360,   361,   362,   363,   364,
     365,  1069,   760,  1070,   368,   369,   370,     0,   371,   372,
     761,   373,  1072,  1073,   375,  1074,   377,   378,   379,     0,
     380,     0,     0,  1075,   382,   383,     0,     0,   384,   385,
     762,   386,   763,  1076,   388,   389,   390,   391,   392,   393,
     394,     0,   395,  1077,   397,   398,   399,   400,   401,     0,
     402,   403,   404,   405,   406,   407,   408,   409,  1078,   411,
     412,   413,   414,     0,   415,   416,   417,   418,   419,   420,
     421,   422,   423,   424,   425,     0,   426,   427,   764,   428,
     429,  1079,   431,   432,   433,   434,   435,   436,   437,   438,
       0,   439,   440,   441,   442,   443,  1080,   444,   445,   446,
     447,     0,   448,  1081,   450,     0,   451,   452,   453,   454,
     455,   456,   457,   458,   459,   460,  1082,     0,   462,   463,
       0,   464,   465,   466,   467,   468,   469,     0,  1083,  1084,
       0,     0,   472,  1085,   474,  1086,  1087,   476,   477,   478,
     479,   480,   481,   482,     0,     0,   483,   484,   485,   486,
     487,  1089,     0,   488,   489,   490,   491,   492,   493,  1090,
       0,   495,   766,   496,   497,   498,   499,     0,     0,   500,
       0,     0,   501,   502,   503,   504,   505,   506,   507,  1091,
    1092,  1093,  1094,  1095,  1096,  1097,  1098,   516,   517,   518,
       0,     0,     0,     0,     0,     0,     0,   744,  2376,  2377,
       0,     0,     0,     0,     0,     0,     0,  1102,   211,   212,
     213,   214,   215,   216,   217,   218,     0,   220,   221,   222,
       0,     0,     0,     0,   223,     0,     0,     0,   224,   225,
       0,   226,   227,   745,   228,   229,   230,   231,   232,   746,
     233,   234,     0,   235,   236,   237,   238,   239,     0,  1043,
     240,   241,   242,   243,   244,     0,   245,   246,   247,   248,
    1046,     0,  1047,     0,   250,   251,   252,   253,   748,   254,
     255,     0,   256,   257,   258,   259,   260,   261,     0,   749,
     262,   263,  1048,  1049,  1050,  1051,  1052,  1053,  1054,   264,
     265,   266,   267,   268,   269,   270,   271,   272,     0,   273,
       0,   274,   275,   276,   277,   278,     0,   279,   280,   281,
       0,     0,   282,   283,   284,   285,   286,     0,   287,   288,
     289,     0,   290,   291,   292,     0,   293,   294,   295,   296,
     297,   298,   299,   300,  1059,     0,   302,     0,   303,   304,
     305,   306,     0,   307,     0,   308,   751,     0,   752,   309,
     310,   311,     0,   312,  1062,     0,   314,     0,   315,   316,
     317,   318,   319,   753,   320,   321,   322,     0,   323,   324,
     325,   326,   327,   328,     0,   329,   754,   330,   331,   332,
     333,   334,   335,   336,     0,   337,     0,   338,   755,   756,
     339,   757,   340,   341,   342,   343,   344,  3086,   345,   346,
       0,   347,  1066,   758,   349,   759,     0,   350,   351,   352,
    1067,  1068,   353,   354,   355,   356,   357,   358,   359,   360,
     361,   362,   363,   364,   365,   366,   760,   367,   368,   369,
     370,     0,   371,   372,   761,   373,     0,  1073,   375,   376,
     377,   378,   379,     0,   380,     0,   709,   381,   382,   383,
       0,     0,   384,   385,   762,   386,   763,  1076,   388,   389,
     390,   391,   392,   393,   394,     0,   395,  1077,   397,   398,
     399,   400,   401,     0,   402,   403,   404,   405,   406,   407,
     408,   409,   410,   411,   412,   413,   414,     0,   415,   416,
     417,   418,   419,   420,   421,   422,   423,   424,   425,     0,
     426,   427,   764,   428,   429,   430,  3087,   432,   433,   434,
     435,   436,   437,   438,    38,   439,   440,   441,   442,   443,
    1080,   444,   445,   446,   447,   765,   448,   449,   450,     0,
     451,   452,   453,   454,   455,   456,   457,   458,   459,   460,
    1082,     0,   462,   463,    42,   464,   465,   466,   467,   468,
     469,     0,   470,   471,     0,     0,   472,  1085,   474,  1086,
       0,   476,   477,   478,   479,   480,   481,   482,     0,     0,
     483,   484,   485,   486,   487,  1089,     0,   488,   489,   490,
     491,   492,   972,   494,     0,   495,   766,   496,   497,   498,
     499,     0,     0,   500,     0,    47,   501,   502,   503,   504,
     505,   506,   507,  1091,  1092,  1093,  1094,  1095,  1096,  1097,
    1098,   516,   517,   518,     0,     0,     0,     0,     0,     0,
       0,   744,     0,     0,     0,     0,     0,     0,     0,     0,
       0,  3088,   211,   212,   213,   214,   215,   216,   217,   218,
       0,   220,   221,   222,     0,     0,     0,     0,   223,     0,
       0,     0,   224,   225,     0,   226,   227,   745,   228,   229,
     230,   231,   232,   746,   233,   234,     0,   235,   236,   237,
     238,   239,     0,  1043,   240,   241,   242,   243,   244,     0,
     245,   246,   247,   248,  1046,     0,  1047,     0,   250,   251,
     252,   253,   748,   254,   255,     0,   256,   257,   258,   259,
     260,   261,     0,   749,   262,   263,  1048,  1049,  1050,  1051,
    1052,  1053,  1054,   264,   265,   266,   267,   268,   269,   270,
     271,   272,     0,   273,     0,   274,   275,   276,   277,   278,
       0,   279,   280,   281,     0,     0,   282,   283,   284,   285,
     286,     0,   287,   288,   289,     0,   290,   291,   292,     0,
     293,   294,   295,   296,   297,   298,   299,   300,  1059,     0,
     302,     0,   303,   304,   305,   306,     0,   307,     0,   308,
     751,     0,   752,   309,   310,   311,     0,   312,  1062,     0,
     314,     0,   315,   316,   317,   318,   319,   753,   320,   321,
     322,     0,   323,   324,   325,   326,   327,   328,     0,   329,
     754,   330,   331,   332,   333,   334,   335,   336,     0,   337,
       0,   338,   755,   756,   339,   757,   340,   341,   342,   343,
     344,  3086,   345,   346,     0,   347,  1066,   758,   349,   759,
       0,   350,   351,   352,  1067,  1068,   353,   354,   355,   356,
     357,   358,   359,   360,   361,   362,   363,   364,   365,   366,
     760,   367,   368,   369,   370,     0,   371,   372,   761,   373,
       0,  1073,   375,   376,   377,   378,   379,     0,   380,     0,
     709,   381,   382,   383,     0,     0,   384,   385,   762,   386,
     763,  1076,   388,   389,   390,   391,   392,   393,   394,     0,
     395,  1077,   397,   398,   399,   400,   401,     0,   402,   403,
     404,   405,   406,   407,   408,   409,   410,   411,   412,   413,
     414,     0,   415,   416,   417,   418,   419,   420,   421,   422,
     423,   424,   425,     0,   426,   427,   764,   428,   429,   430,
    3087,   432,   433,   434,   435,   436,   437,   438,     0,   439,
     440,   441,   442,   443,  1080,   444,   445,   446,   447,   765,
     448,   449,   450,     0,   451,   452,   453,   454,   455,   456,
     457,   458,   459,   460,  1082,     0,   462,   463,     0,   464,
     465,   466,   467,   468,   469,     0,   470,   471,     0,     0,
     472,  1085,   474,  1086,     0,   476,   477,   478,   479,   480,
     481,   482,     0,     0,   483,   484,   485,   486,   487,  1089,
       0,   488,   489,   490,   491,   492,   493,   494,     0,   495,
     766,   496,   497,   498,   499,     0,     0,   500,     0,     0,
     501,   502,   503,   504,   505,   506,   507,  1091,  1092,  1093,
    1094,  1095,  1096,  1097,  1098,   516,   517,   518,     0,     0,
       0,     0,     0,     0,     0,   744,     0,     0,     0,     0,
       0,     0,     0,     0,     0,  3088,   211,   212,   213,   214,
     215,   216,   217,   218,     0,   220,   221,   222,     0,     0,
       0,     0,   223,     0,     0,     0,   224,   225,     0,   226,
     227,   745,   228,   229,   230,   231,   232,   746,   233,   234,
       0,   235,   236,   237,   238,   239,     0,  1043,   240,   241,
     242,   243,   244,     0,   245,   246,   247,   248,  1046,     0,
    1047,     0,   250,   251,   252,   253,   748,   254,   255,     0,
     256,   257,   258,   259,   260,   261,     0,   749,   262,   263,
    1048,  1049,  1050,  1051,  1052,  1053,  1054,   264,   265,   266,
     267,   268,   269,   270,   271,   272,     0,   273,     0,   274,
     275,   276,   277,   278,     0,   279,   280,   281,     0,     0,
     282,   283,   284,   285,   286,     0,   287,   288,   289,     0,
     290,   291,   292,     0,   293,   294,   295,   296,   297,   298,
     299,   300,  1059,     0,   302,     0,   303,   304,   305,   306,
       0,   307,     0,   308,   751,     0,   752,   309,   310,   311,
       0,   312,  1062,     0,   314,     0,   315,   316,   317,   318,
     319,   753,   320,   321,   322,     0,   323,   324,   325,   326,
     327,   328,     0,   329,   754,   330,   331,   332,   333,   334,
     335,   336,     0,   337,     0,   338,   755,   756,   339,   757,
     340,   341,   342,   343,   344,     0,   345,   346,     0,   347,
    1066,   758,   349,   759,     0,   350,   351,   352,  1067,  1068,
     353,   354,   355,   356,   357,   358,   359,   360,   361,   362,
     363,   364,   365,   366,   760,   367,   368,   369,   370,     0,
     371,   372,   761,   373,     0,  1073,   375,   376,   377,   378,
     379,     0,   380,     0,     0,   381,   382,   383,     0,     0,
     384,   385,   762,   386,   763,  1076,   388,   389,   390,   391,
     392,   393,   394,     0,   395,  1077,   397,   398,   399,   400,
     401,     0,   402,   403,   404,   405,   406,   407,   408,   409,
     410,   411,   412,   413,   414,     0,   415,   416,   417,   418,
     419,   420,   421,   422,   423,   424,   425,     0,   426,   427,
     764,   428,   429,   430,  3087,   432,   433,   434,   435,   436,
     437,   438,     0,   439,   440,   441,   442,   443,  1080,   444,
     445,   446,   447,   765,   448,   449,   450,     0,   451,   452,
     453,   454,   455,   456,   457,   458,   459,   460,  1082,     0,
     462,   463,     0,   464,   465,   466,   467,   468,   469,     0,
     470,   471,     0,     0,   472,  1085,   474,  1086,     0,   476,
     477,   478,   479,   480,   481,   482,     0,     0,   483,   484,
     485,   486,   487,  1089,     0,   488,   489,   490,   491,   492,
     493,   494,     0,   495,   766,   496,   497,   498,   499,     0,
       0,   500,     0,     0,   501,   502,   503,   504,   505,   506,
     507,  1091,  1092,  1093,  1094,  1095,  1096,  1097,  1098,   516,
     517,   518,     0,     0,     0,     0,     0,     0,     0,   744,
       0,     0,     0,     0,     0,     0,     0,     0,     0,    48,
     211,   212,   213,   214,   215,   216,   217,   218,     0,   220,
     221,   222,     0,     0,     0,     0,   223,     0,     0,     0,
     224,   225,     0,   226,   227,   745,   228,   229,   230,   231,
     232,   746,   233,   234,     0,   235,   236,   237,   238,   239,
       0,  1043,   240,   241,   242,   243,   244,     0,   245,   246,
     247,   248,  1046,     0,  1047,     0,   250,   251,   252,   253,
     748,   254,   255,     0,   256,   257,   258,   259,   260,   261,
       0,   749,   262,   263,  1048,  1049,  1050,  1051,  1052,  1053,
    1054,   264,   265,   266,   267,   268,   269,   270,   271,   272,
       0,   273,     0,   274,   275,   276,   277,   278,     0,   279,
     280,   281,     0,     0,   282,   283,   284,   285,   286,     0,
     287,   288,   289,     0,   290,   291,   292,     0,   293,   294,
     295,   296,   297,   298,   299,   300,  1059,     0,   302,     0,
     303,   304,   305,   306,     0,   307,     0,   308,   751,     0,
     752,   309,   310,   311,     0,   312,  1062,     0,   314,     0,
     315,   316,   317,   318,   319,   753,   320,   321,   322,     0,
     323,   324,   325,   326,   327,   328,     0,   329,   754,   330,
     331,   332,   333,   334,   335,   336,     0,   337,     0,   338,
     755,   756,   339,   757,   340,   341,   342,   343,   344,     0,
     345,   346,     0,   347,  1066,   758,   349,   759,     0,   350,
     351,   352,  1067,  1068,   353,   354,   355,   356,   357,   358,
     359,   360,   361,   362,   363,   364,   365,   366,   760,   367,
     368,   369,   370,     0,   371,   372,   761,   373,     0,  1073,
     375,   376,   377,   378,   379,     0,   380,     0,     0,   381,
     382,   383,     0,     0,   384,   385,   762,   386,   763,  1076,
     388,   389,   390,   391,   392,   393,   394,     0,   395,  1077,
     397,   398,   399,   400,   401,     0,   402,   403,   404,   405,
     406,   407,   408,   409,   410,   411,   412,   413,   414,     0,
     415,   416,   417,   418,   419,   420,   421,   422,   423,   424,
     425,     0,   426,   427,   764,   428,   429,   430,   431,   432,
     433,   434,   435,   436,   437,   438,     0,   439,   440,   441,
     442,   443,  1080,   444,   445,   446,   447,   765,   448,   449,
     450,     0,   451,   452,   453,   454,   455,   456,   457,   458,
     459,   460,  1082,     0,   462,   463,     0,   464,   465,   466,
     467,   468,   469,     0,   470,   471,     0,     0,   472,  1085,
     474,  1086,     0,   476,   477,   478,   479,   480,   481,   482,
       0,     0,   483,   484,   485,   486,   487,  1089,     0,   488,
     489,   490,   491,   492,   493,   494,     0,   495,   766,   496,
     497,   498,   499,     0,     0,   500,     0,     0,   501,   502,
     503,   504,   505,   506,   507,  1091,  1092,  1093,  1094,  1095,
    1096,  1097,  1098,   516,   517,   518,     0,     0,     0,     0,
       0,     0,     0,   787,  1290,   574,     0,     0,     0,   625,
       0,     0,     0,  3642,   211,   212,   213,   214,   215,   216,
     217,   218,     0,   220,   221,   222,     0,     0,     0,     0,
     223,     0,     0,     0,   224,   225,     0,   226,   227,   745,
     228,   229,   230,   231,   232,   746,   233,   234,     0,   235,
     236,   237,   238,   239,     0,     0,   240,   241,   242,   243,
     244,     0,   245,   246,   247,   248,   249,     0,   747,     0,
     250,   251,   252,   253,   748,   254,   255,     0,   256,   257,
     258,   259,   260,   261,     0,   749,   262,   263,     0,     0,
       0,   750,     0,     0,     0,   264,   265,   266,   267,   268,
     269,   270,   271,   272,     0,   273,     0,   274,   275,   276,
     277,   278,     0,   279,   280,   281,     0,     0,   282,   283,
     284,   285,   286,     0,   287,   288,   289,     0,   290,   291,
     292,     0,   293,   294,   295,   296,   297,   298,   299,   300,
     301,  1538,   302,     0,   303,   304,   305,   306,     0,   307,
       0,   308,   751,     0,   752,   309,   310,   311,     0,   312,
     313,     0,   314,     0,   315,   316,   317,   318,   319,   753,
     320,   321,   322,     0,   323,   324,   325,   326,   327,   328,
       0,   329,   754,   330,   331,   332,   333,   334,   335,   336,
       0,   337,     0,   338,   755,   756,   339,   757,   340,   341,
     342,   343,   344,     0,   345,   346,     0,   347,   348,   758,
     349,   759,     0,   350,   351,   352,     0,     0,   353,   354,
     355,   356,   357,   358,   359,   360,   361,   362,   363,   364,
     365,   366,   760,   367,   368,   369,   370,     0,   371,   372,
     761,   373,     0,   374,   375,   376,   377,   378,   379,     0,
     380,  1539,     0,   381,   382,   383,     0,     0,   384,   385,
     762,   386,   763,   387,   388,   389,   390,   391,   392,   393,
     394,     0,   395,   396,   397,   398,   399,   400,   401,     0,
     402,   403,   404,   405,   406,   407,   408,   409,   410,   411,
     412,   413,   414,     0,   415,   416,   417,   418,   419,   420,
     421,   422,   423,   424,   425,     0,   426,   427,   764,   428,
     429,   430,   431,   432,   433,   434,   435,   436,   437,   438,
       0,   439,   440,   441,   442,   443,     0,   444,   445,   446,
     447,   765,   448,   449,   450,     0,   451,   452,   453,   454,
     455,   456,   457,   458,   459,   460,   461,     0,   462,   463,
       0,   464,   465,   466,   467,   468,   469,     0,   470,   471,
       0,     0,   472,   473,   474,   475,  1540,   476,   477,   478,
     479,   480,   481,   482,     0,     0,   483,   484,   485,   486,
     487,     0,     0,   488,   489,   490,   491,   492,   493,   494,
       0,   495,   766,   496,   497,   498,   499,     0,     0,   500,
       0,     0,   501,   502,   503,   504,   505,   506,   507,   508,
     509,   510,   511,   512,   513,   514,   515,   516,   517,   518,
       0,     0,     0,     0,     0,     0,     0,   787,  1291,  1292,
    4058,     0,     0,     0,     0,     0,     0,  4059,   211,   212,
     213,   214,   215,   216,   217,   218,     0,   220,   221,   222,
       3,     4,     0,     0,   223,     0,     0,     0,   224,   225,
       0,   226,   227,   745,   228,   229,   230,   231,   232,   746,
     233,   234,     0,   235,   236,   237,   238,   239,     0,     0,
     240,   241,   242,   243,   244,     0,   245,   246,   247,   248,
     249,     0,   747,     0,   250,   251,   252,   253,   748,   254,
     255,     0,   256,   257,   258,   259,   260,   261,     0,   749,
     262,   263,     0,     0,     0,   750,     0,     0,     0,   264,
     265,   266,   267,   268,   269,   270,   271,   272,     0,   273,
       0,   274,   275,   276,   277,   278,     0,   279,   280,   281,
       0,     0,   282,   283,   284,   285,   286,     0,   287,   288,
     289,     0,   290,   291,   292,     0,   293,   294,   295,   296,
     297,   298,   299,   300,   301,     0,   302,     0,   303,   304,
     305,   306,     0,   307,     0,   308,   751,     0,   752,   309,
     310,   311,     0,   312,   313,     0,   314,     0,   315,   316,
     317,   318,   319,   753,   320,   321,   322,     0,   323,   324,
     325,   326,   327,   328,     0,   329,   754,   330,   331,   332,
     333,   334,   335,   336,     0,   337,     0,   338,   755,   756,
     339,   757,   340,   341,   342,   343,   344,     0,   345,   346,
       0,   347,   348,   758,   349,   759,     0,   350,   351,   352,
       0,     0,   353,   354,   355,   356,   357,   358,   359,   360,
     361,   362,   363,   364,   365,   366,   760,   367,   368,   369,
     370,     0,   371,   372,   761,   373,     0,   374,   375,   376,
     377,   378,   379,     0,   380,     0,     0,   381,   382,   383,
       0,     0,   384,   385,   762,   386,   763,   387,   388,   389,
     390,   391,   392,   393,   394,     0,   395,   396,   397,   398,
     399,   400,   401,     0,   402,   403,   404,   405,   406,   407,
     408,   409,   410,   411,   412,   413,   414,     0,   415,   416,
     417,   418,   419,   420,   421,   422,   423,   424,   425,     0,
     426,   427,   764,   428,   429,   430,   431,   432,   433,   434,
     435,   436,   437,   438,    38,   439,   440,   441,   442,   443,
       0,   444,   445,   446,   447,   765,   448,   449,   450,     0,
     451,   452,   453,   454,   455,   456,   457,   458,   459,   460,
     461,     0,   462,   463,    42,   464,   465,   466,   467,   468,
     469,     0,   470,   471,     0,     0,   472,   473,   474,   475,
       0,   476,   477,   478,   479,   480,   481,   482,     0,     0,
     483,   484,   485,   486,   487,     0,     0,   488,   489,   490,
     491,   492,   972,   494,     0,   495,   766,   496,   497,   498,
     499,     0,     0,   500,     0,    47,   501,   502,   503,   504,
     505,   506,   507,   508,   509,   510,   511,   512,   513,   514,
     515,   516,   517,   518,     0,     0,     0,     0,     0,     0,
       0,   744,     0,     0,     0,     0,     0,     0,     0,     0,
       0,    48,   211,   212,   213,   214,   215,   216,   217,   218,
       0,   220,   221,   222,     0,     0,     0,     0,   223,     0,
       0,     0,   224,   225,     0,   226,   227,   745,   228,   229,
     230,   231,   232,   746,   233,   234,     0,   235,   236,   237,
     238,   239,     0,     0,   240,   241,   242,   243,   244,     0,
     245,   246,   247,   248,   249,     0,   747,     0,   250,   251,
     252,   253,   748,   254,   255,     0,   256,   257,   258,   259,
     260,   261,     0,   749,   262,   263,     0,     0,     0,   750,
       0,     0,     0,   264,   265,   266,   267,   268,   269,   270,
     271,   272,     0,   273,     0,   274,   275,   276,   277,   278,
       0,   279,   280,   281,     0,     0,   282,   283,   284,   285,
     286,     0,   287,   288,   289,     0,   290,   291,   292,     0,
     293,   294,   295,   296,   297,   298,   299,   300,   301,     0,
     302,     0,   303,   304,   305,   306,     0,   307,     0,   308,
     751,     0,   752,   309,   310,   311,     0,   312,   313,     0,
     314,     0,   315,   316,   317,   318,   319,   753,   320,   321,
     322,     0,   323,   324,   325,   326,   327,   328,     0,   329,
     754,   330,   331,   332,   333,   334,   335,   336,     0,   337,
       0,   338,   755,   756,   339,   757,   340,   341,   342,   343,
     344,     0,   345,   346,     0,   347,   348,   758,   349,   759,
       0,   350,   351,   352,     0,     0,   353,   354,   355,   356,
     357,   358,   359,   360,   361,   362,   363,   364,   365,   366,
     760,   367,   368,   369,   370,     0,   371,   372,   761,   373,
       0,   374,   375,   376,   377,   378,   379,     0,   380,     0,
       0,   381,   382,   383,     0,     0,   384,   385,   762,   386,
     763,   387,   388,   389,   390,   391,   392,   393,   394,     0,
     395,   396,   397,   398,   399,   400,   401,     0,   402,   403,
     404,   405,   406,   407,   408,   409,   410,   411,   412,   413,
     414,     0,   415,   416,   417,   418,   419,   420,   421,   422,
     423,   424,   425,     0,   426,   427,   764,   428,   429,   430,
     431,   432,   433,   434,   435,   436,   437,   438,     0,   439,
     440,   441,   442,   443,     0,   444,   445,   446,   447,   765,
     448,   449,   450,     0,   451,   452,   453,   454,   455,   456,
     457,   458,   459,   460,   461,     0,   462,   463,     0,   464,
     465,   466,   467,   468,   469,     0,   470,   471,     0,     0,
     472,   473,   474,   475,     0,   476,   477,   478,   479,   480,
     481,   482,     0,     0,   483,   484,   485,   486,   487,     0,
       0,   488,   489,   490,   491,   492,   493,   494,     0,   495,
     766,   496,   497,   498,   499,     0,     0,   500,     0,     0,
     501,   502,   503,   504,   505,   506,   507,   508,   509,   510,
     511,   512,   513,   514,   515,   516,   517,   518,     0,     0,
       0,     0,     0,     0,     0,   210,     0,     0,     0,     0,
       0,     0,     0,     0,     0,  4218,   211,   212,   213,   214,
     215,   216,   217,   218,     0,   220,   221,   222,     0,     0,
       0,     0,   223,     0,     0,     0,   224,   225,     0,   226,
     227,     0,   228,   229,   230,   231,   232,     0,   233,   234,
       0,   235,   236,   237,   238,   239,     0,     0,   240,   241,
     242,   243,   244,     0,   245,   246,   247,   248,   249,     0,
       0,     0,   250,   251,   252,   253,     0,   254,   255,     0,
     256,   257,   258,   259,   260,   261,     0,     0,   262,   263,
       0,     0,     0,     0,     0,     0,     0,   264,   265,   266,
     267,   268,   269,   270,   271,   272,     0,   273,     0,   274,
     275,   276,   277,   278,     0,   279,   280,   281,     0,     0,
     282,   283,   284,   285,   286,     0,   287,   288,   289,     0,
     290,   291,   292,     0,   293,   294,   295,   296,   297,   298,
     299,   300,   301,     0,   302,     0,   303,   304,   305,   306,
       0,   307,     0,   308,     0,     0,     0,   309,   310,   311,
       0,   312,   313,     0,   314,     0,   315,   316,   317,   318,
     319,     0,   320,   321,   322,     0,   323,   324,   325,   326,
     327,   328,     0,   329,     0,   330,   331,   332,   333,   334,
     335,   336,     0,   337,     0,   338,     0,     0,   339,     0,
     340,   341,   342,   343,   344,     0,   345,   346,     0,   347,
     348,     0,   349,     0,     0,   350,   351,   352,     0,     0,
     353,   354,   355,   356,   357,   358,   359,   360,   361,   362,
     363,   364,   365,   366,     0,   367,   368,   369,   370,     0,
     371,   372,     0,   373,     0,   374,   375,   376,   377,   378,
     379,     0,   380,     0,     0,   381,   382,   383,     0,     0,
     384,   385,     0,   386,     0,   387,   388,   389,   390,   391,
     392,   393,   394,     0,   395,   396,   397,   398,   399,   400,
     401,     0,   402,   403,   404,   405,   406,   407,   408,   409,
     410,   411,   412,   413,   414,     0,   415,   416,   417,   418,
     419,   420,   421,   422,   423,   424,   425,     0,   426,   427,
       0,   428,   429,   430,   431,   432,   433,   434,   435,   436,
     437,   438,    38,   439,   440,   441,   442,   443,     0,   444,
     445,   446,   447,     0,   448,   449,   450,     0,   451,   452,
     453,   454,   455,   456,   457,   458,   459,   460,   461,     0,
     462,   463,    42,   464,   465,   466,   467,   468,   469,     0,
     470,   471,     0,     0,   472,   473,   474,   475,     0,   476,
     477,   478,   479,   480,   481,   482,     0,     0,   483,   484,
     485,   486,   487,     0,     0,   488,   489,   490,   491,   492,
     972,   494,     0,   495,     0,   496,   497,   498,   499,     0,
       0,   500,     0,    47,   501,   502,   503,   504,   505,   506,
     507,   508,   509,   510,   511,   512,   513,   514,   515,   516,
     517,   518,     0,     0,     0,     0,     0,     0,     0,   210,
       0,     0,     0,     0,     0,     0,     0,     0,     0,    48,
     211,   212,   213,   214,   215,   216,   217,   218,     0,   220,
     221,   222,     0,     0,     0,     0,   223,     0,     0,     0,
     224,   225,     0,   226,   227,     0,   228,   229,   230,   231,
     232,     0,   233,   234,     0,   235,   236,   237,   238,   239,
       0,     0,   240,   241,   242,   243,   244,     0,   245,   246,
     247,   248,   249,     0,     0,     0,   250,   251,   252,   253,
       0,   254,   255,     0,   256,   257,   258,   259,   260,   261,
       0,     0,   262,   263,     0,     0,     0,     0,     0,     0,
       0,   264,   265,   266,   267,   268,   269,   270,   271,   272,
       0,   273,     0,   274,   275,   276,   277,   278,     0,   279,
     280,   281,     0,     0,   282,   283,   284,   285,   286,     0,
     287,   288,   289,     0,   290,   291,   292,     0,   293,   294,
     295,   296,   297,   298,   299,   300,   301,     0,   302,     0,
     303,   304,   305,   306,     0,   307,     0,   308,     0,     0,
       0,   309,   310,   311,     0,   312,   313,     0,   314,     0,
     315,   316,   317,   318,   319,     0,   320,   321,   322,     0,
     323,   324,   325,   326,   327,   328,     0,   329,     0,   330,
     331,   332,   333,   334,   335,   336,     0,   337,     0,   338,
       0,     0,   339,     0,   340,   341,   342,   343,   344,     0,
     345,   346,     0,   347,   348,     0,   349,     0,     0,   350,
     351,   352,     0,     0,   353,   354,   355,   356,   357,   358,
     359,   360,   361,   362,   363,   364,   365,   366,     0,   367,
     368,   369,   370,     0,   371,   372,     0,   373,     0,   374,
     375,   376,   377,   378,   379,     0,   380,     0,     0,   381,
     382,   383,     0,     0,   384,   385,     0,   386,     0,   387,
     388,   389,   390,   391,   392,   393,   394,     0,   395,   396,
     397,   398,   399,   400,   401,     0,   402,   403,   404,   405,
     406,   407,   408,   409,   410,   411,   412,   413,   414,     0,
     415,   416,   417,   418,   419,   420,   421,   422,   423,   424,
     425,     0,   426,   427,     0,   428,   429,   430,   431,   432,
     433,   434,   435,   436,   437,   438,     0,   439,   440,   441,
     442,   443,     0,   444,   445,   446,   447,     0,   448,   449,
     450,     0,   451,   452,   453,   454,   455,   456,   457,   458,
     459,   460,   461,     0,   462,   463,     0,   464,   465,   466,
     467,   468,   469,     0,   470,   471,     0,     0,   472,   473,
     474,   475,     0,   476,   477,   478,   479,   480,   481,   482,
       0,     0,   483,   484,   485,   486,   487,     0,     0,   488,
     489,   490,   491,   492,   493,   494,     0,   495,     0,   496,
     497,   498,   499,     0,     0,   500,     0,     0,   501,   502,
     503,   504,   505,   506,   507,   508,   509,   510,   511,   512,
     513,   514,   515,   516,   517,   518,     0,     0,     0,     0,
       0,     0,     0,   210,     0,     0,     0,     0,     0,     0,
       0,     0,     0,  1158,   211,   212,   213,   214,   215,   216,
     217,   218,     0,   220,   221,   222,     0,     0,     0,     0,
     223,     0,     0,     0,   224,   225,     0,   226,   227,     0,
     228,   229,   230,   231,   232,     0,   233,   234,     0,   235,
     236,   237,   238,   239,     0,     0,   240,   241,   242,   243,
     244,     0,   245,   246,   247,   248,   249,     0,     0,     0,
     250,   251,   252,   253,     0,   254,   255,     0,   256,   257,
     258,   259,   260,   261,     0,     0,   262,   263,     0,     0,
       0,     0,     0,     0,     0,   264,   265,   266,   267,   268,
     269,   270,   271,   272,     0,   273,     0,   274,   275,   276,
     277,   278,     0,   279,   280,   281,     0,     0,   282,   283,
     284,   285,   286,     0,   287,   288,   289,     0,   290,   291,
     292,     0,   293,   294,   295,   296,   297,   298,   299,   300,
     301,     0,   302,     0,   303,   304,   305,   306,     0,   307,
       0,   308,     0,     0,     0,   309,   310,   311,     0,   312,
     313,     0,   314,     0,   315,   316,   317,   318,   319,     0,
     320,   321,   322,     0,   323,   324,   325,   326,   327,   328,
       0,   329,     0,   330,   331,   332,   333,   334,   335,   336,
       0,   337,     0,   338,     0,     0,   339,     0,   340,   341,
     342,   343,   344,     0,   345,   346,     0,   347,   348,     0,
     349,     0,     0,   350,   351,   352,     0,     0,   353,   354,
     355,   356,   357,   358,   359,   360,   361,   362,   363,   364,
     365,   366,     0,   367,   368,   369,   370,     0,   371,   372,
       0,   373,     0,   374,   375,   376,   377,   378,   379,     0,
     380,     0,     0,   381,   382,   383,     0,     0,   384,   385,
       0,   386,     0,   387,   388,   389,   390,   391,   392,   393,
     394,     0,   395,   396,   397,   398,   399,   400,   401,     0,
     402,   403,   404,   405,   406,   407,   408,   409,   410,   411,
     412,   413,   414,     0,   415,   416,   417,   418,   419,   420,
     421,   422,   423,   424,   425,     0,   426,   427,     0,   428,
     429,   430,   431,   432,   433,   434,   435,   436,   437,   438,
       0,   439,   440,   441,   442,   443,     0,   444,   445,   446,
     447,     0,   448,   449,   450,     0,   451,   452,   453,   454,
     455,   456,   457,   458,   459,   460,   461,     0,   462,   463,
       0,   464,   465,   466,   467,   468,   469,     0,   470,   471,
       0,     0,   472,   473,   474,   475,     0,   476,   477,   478,
     479,   480,   481,   482,     0,     0,   483,   484,   485,   486,
     487,     0,     0,   488,   489,   490,   491,   492,   493,   494,
       0,   495,     0,   496,   497,   498,   499,     0,     0,   500,
       0,     0,   501,   502,   503,   504,   505,   506,   507,   508,
     509,   510,   511,   512,   513,   514,   515,   516,   517,   518,
       0,     0,     0,     0,     0,     0,     0,   210,     0,     0,
       0,     0,     0,     0,     0,     0,     0,  2531,   211,   212,
     213,   214,   215,   216,   217,   218,     0,   220,   221,   222,
       0,     0,     0,     0,   223,     0,     0,     0,   224,   225,
       0,   226,   227,     0,   228,   229,   230,   231,   232,     0,
     233,   234,     0,   235,   236,   237,   238,   239,     0,     0,
     240,   241,   242,   243,   244,     0,   245,   246,   247,   248,
     249,     0,     0,     0,   250,   251,   252,   253,     0,   254,
     255,     0,   256,   257,   258,   259,   260,   261,     0,     0,
     262,   263,     0,     0,     0,     0,     0,     0,     0,   264,
     265,   266,   267,   268,   269,   270,   271,   272,     0,   273,
       0,   274,   275,   276,   277,   278,     0,   279,   280,   281,
       0,     0,   282,   283,   284,   285,   286,     0,   287,   288,
     289,     0,   290,   291,   292,     0,   293,   294,   295,   296,
     297,   298,   299,   300,   301,     0,   302,     0,   303,   304,
     305,   306,     0,   307,     0,   308,     0,     0,     0,   309,
     310,   311,     0,   312,   313,     0,   314,     0,   315,   316,
     317,   318,   319,     0,   320,   321,   322,     0,   323,   324,
     325,   326,   327,   328,     0,   329,     0,   330,   331,   332,
     333,   334,   335,   336,     0,   337,     0,   338,     0,     0,
     339,     0,   340,   341,   342,   343,   344,     0,   345,   346,
       0,   347,   348,     0,   349,     0,     0,   350,   351,   352,
       0,     0,   353,   354,   355,   356,   357,   358,   359,   360,
     361,   362,   363,   364,   365,   366,     0,   367,   368,   369,
     370,     0,   371,   372,     0,   373,     0,   374,   375,   376,
     377,   378,   379,     0,   380,     0,     0,   381,   382,   383,
       0,     0,   384,   385,     0,   386,     0,   387,   388,   389,
     390,   391,   392,   393,   394,     0,   395,   396,   397,   398,
     399,   400,   401,     0,   402,   403,   404,   405,   406,   407,
     408,   409,   410,   411,   412,   413,   414,     0,   415,   416,
     417,   418,   419,   420,   421,   422,   423,   424,   425,     0,
     426,   427,     0,   428,   429,   430,   431,   432,   433,   434,
     435,   436,   437,   438,     0,   439,   440,   441,   442,   443,
       0,   444,   445,   446,   447,     0,   448,   449,   450,     0,
     451,   452,   453,   454,   455,   456,   457,   458,   459,   460,
     461,     0,   462,   463,     0,   464,   465,   466,   467,   468,
     469,     0,   470,   471,     0,     0,   472,   473,   474,   475,
       0,   476,   477,   478,   479,   480,   481,   482,     0,     0,
     483,   484,   485,   486,   487,     0,     0,   488,   489,   490,
     491,   492,   493,   494,     0,   495,     0,   496,   497,   498,
     499,     0,     0,   500,     0,     0,   501,   502,   503,   504,
     505,   506,   507,   508,   509,   510,   511,   512,   513,   514,
     515,   516,   517,   518,     0,     0,     0,     0,     0,     0,
       0,   210,     0,     0,     0,     0,     0,     0,     0,     0,
       0,  3561,   211,   212,   213,   214,   215,   216,   217,   218,
       0,   220,   221,   222,     0,     0,     0,     0,   223,     0,
       0,     0,   224,   225,     0,   226,   227,     0,   228,   229,
     230,   231,   232,     0,   233,   234,     0,   235,   236,   237,
     238,   239,     0,     0,   240,   241,   242,   243,   244,     0,
     245,   246,   247,   248,   249,     0,     0,     0,   250,   251,
     252,   253,     0,   254,   255,     0,   256,   257,   258,   259,
     260,   261,     0,     0,   262,   263,     0,     0,     0,     0,
       0,     0,     0,   264,   265,   266,   267,   268,   269,   270,
     271,   272,     0,   273,     0,   274,   275,   276,   277,   278,
       0,   279,   280,   281,     0,     0,   282,   283,   284,   285,
     286,     0,   287,   288,   289,     0,   290,   291,   292,     0,
     293,   294,   295,   296,   297,   298,   299,   300,   301,     0,
     302,     0,   303,   304,   305,   306,     0,   307,     0,   308,
       0,     0,     0,   309,   310,   311,     0,   312,   313,     0,
     314,     0,   315,   316,   317,   318,   319,     0,   320,   321,
     322,     0,   323,   324,   325,   326,   327,   328,     0,   329,
       0,   330,   331,   332,   333,   334,   335,   336,     0,   337,
       0,   338,     0,     0,   339,     0,   340,   341,   342,   343,
     344,     0,   345,   346,     0,   347,   348,     0,   349,     0,
       0,   350,   351,   352,     0,     0,   353,   354,   355,   356,
     357,   358,   359,   360,   361,   362,   363,   364,   365,   366,
       0,   367,   368,   369,   370,     0,   371,   372,     0,   373,
       0,   374,   375,   376,   377,   378,   379,     0,   380,     0,
       0,   381,   382,   383,     0,     0,   384,   385,     0,   386,
       0,   387,   388,   389,   390,   391,   392,   393,   394,     0,
     395,   396,   397,   398,   399,   400,   401,     0,   402,   403,
     404,   405,   406,   407,   408,   409,   410,   411,   412,   413,
     414,     0,   415,   416,   417,   418,   419,   420,   421,   422,
     423,   424,   425,     0,   426,   427,     0,   428,   429,   430,
     431,   432,   433,   434,   435,   436,   437,   438,     0,   439,
     440,   441,   442,   443,     0,   444,   445,   446,   447,     0,
     448,   449,   450,     0,   451,   452,   453,   454,   455,   456,
     457,   458,   459,   460,   461,     0,   462,   463,     0,   464,
     465,   466,   467,   468,   469,     0,   470,   471,     0,     0,
     472,   473,   474,   475,     0,   476,   477,   478,   479,   480,
     481,   482,     0,     0,   483,   484,   485,   486,   487,     0,
       0,   488,   489,   490,   491,   492,   493,   494,     0,   495,
       0,   496,   497,   498,   499,     0,     0,   500,     0,     0,
     501,   502,   503,   504,   505,   506,   507,   508,   509,   510,
     511,   512,   513,   514,   515,   516,   517,   518,     0,     0,
       0,     0,     0,     0,     0,  1399,  1290,   574,     0,     0,
     798,   625,     0,     0,     0,  3955,   211,   212,   213,   214,
     215,   216,   217,   218,  1743,   220,   221,   222,  1744,  1745,
    1746,  1747,   223,  1748,  1749,  1750,   224,   225,  1751,   226,
     227,   745,   228,   229,   230,     0,  1400,   746,  1401,  1402,
    1752,   235,   236,   237,   238,   239,  1753,  1754,   240,   241,
    1403,  1404,   244,  1755,   245,   246,   247,   248,     0,  1756,
     747,  1757,   250,   251,   252,   253,   748,   254,   255,  1758,
     256,   257,   258,   259,   260,   261,  1759,   749,   262,   263,
    1760,  1761,  1762,   750,  1763,  1764,  1765,   264,   265,   266,
     267,   268,   269,  1405,  1406,   272,  1766,   273,  1767,   274,
     275,   276,   277,   278,  1768,   279,   280,   281,  1769,  1770,
     282,   283,  1057,   285,   286,  1771,   287,   288,   289,  1772,
     290,   291,   292,  1773,   293,   294,   295,   296,     0,   298,
     299,   300,     0,  1774,   302,  1775,   303,   304,  1407,   306,
    1776,   307,  1777,   308,   751,  1778,   752,   309,   310,   311,
    1779,   312,     0,  1780,   314,  1781,   315,   316,   317,   318,
     319,   753,   320,   321,   322,  1782,   323,   324,   325,   326,
     327,   328,  1783,   329,   754,     0,   331,   332,   333,   334,
    1408,  1409,  1784,  1410,  1785,   338,   755,   756,   339,   757,
     340,   341,   342,   343,   344,  1786,   345,   346,  1787,   347,
       0,   758,   349,   759,  1788,   350,   351,   352,  1789,  1790,
     353,   354,   355,   356,   357,   358,   359,   360,   361,   362,
     363,   364,   365,  1411,   760,  1412,   368,   369,     0,  1791,
     371,   372,   761,   373,  1792,     0,   375,  1413,   377,   378,
     379,  1793,   380,  1794,  1795,  3322,   382,   383,  1796,  1797,
     384,     0,   762,   386,   763,     0,   388,   389,   390,   391,
     392,   393,   394,  1798,   395,     0,   397,     0,   399,   400,
     401,  1799,   402,   403,   404,   405,   406,   407,   408,   409,
    1414,   411,   412,   413,   414,  1800,   415,   416,   417,   418,
     419,   420,   421,   422,   423,   424,   425,  1801,   426,   427,
     764,   428,   429,     0,   431,   432,   433,   434,   435,   436,
     437,   438,  1802,   439,   440,   441,   442,   443,  1803,   444,
    1883,   446,   447,   765,   448,  1416,   450,  1804,   451,   452,
     453,   454,   455,   456,   457,   458,   459,   460,     0,  1805,
     462,   463,  1806,   464,   465,   466,   467,   468,   469,  1807,
    1417,  1418,  1808,  1809,   472,     0,   474,     0,  1810,   476,
     477,   478,   479,   480,   481,   482,  1811,  1812,   483,   484,
     485,   486,   487,  1813,  1814,   488,   489,   490,   491,   492,
       0,  1419,  1815,   495,   766,   496,   497,   498,   499,  1816,
    1817,   500,  1818,  1819,   501,   502,   503,   504,   505,   506,
       0,     0,     0,     0,     0,     0,     0,     0,     0,   516,
     517,   518,     0,     0,     0,     0,   801,   802,   803,     0,
    3323,  3324,   806,   807,   808,   809,   210,     0,     0,     0,
       0,   798,     0,     0,     0,     0,     0,   211,   212,   213,
     214,   215,   216,   217,   218,     0,   220,   221,   222,     0,
       0,     0,     0,   223,     0,     0,     0,   224,   225,     0,
     226,   227,     0,   228,   229,   230,   231,   232,     0,   233,
     234,     0,   235,   236,   237,   238,   239,     0,     0,   240,
     241,   242,   243,   244,     0,   245,   799,   247,   248,   249,
       0,     0,     0,   250,   251,   252,   253,     0,   254,   255,
       0,   256,   257,   258,   259,   260,   261,     0,     0,   262,
     263,     0,     0,     0,     0,     0,     0,     0,   264,   265,
     266,   267,   268,   269,   270,   271,   272,     0,   273,     0,
     274,   275,   276,   277,   278,     0,   279,   280,   281,     0,
       0,   282,   283,   284,   285,   286,     0,   287,   288,   289,
       0,   290,   291,   292,     0,   293,   294,   295,   296,   297,
     298,   299,   300,   301,     0,   800,     0,   303,   304,   305,
     306,     0,   307,     0,   308,     0,     0,     0,   309,   310,
     311,     0,   312,   313,     0,   314,     0,   315,   316,   317,
     318,   319,     0,   320,   321,   322,     0,   323,   324,   325,
     326,   327,   328,     0,   329,     0,   330,   331,   332,   333,
     334,   335,   336,     0,   337,     0,   338,     0,     0,   339,
       0,   340,   341,   342,   343,   344,     0,   345,   346,     0,
     347,   348,     0,   349,     0,     0,   350,   351,   352,     0,
       0,   353,   354,   355,   356,   357,   358,   359,   360,   361,
     362,   363,   364,   365,   366,     0,   367,   368,   369,   370,
       0,   371,   372,     0,   373,     0,   374,   375,   376,   377,
     378,   379,     0,   380,     0,     0,   381,   382,   383,     0,
       0,   384,   385,     0,   386,     0,   387,   388,   389,   390,
     391,   392,   393,   394,     0,   395,   396,   397,   398,   399,
     400,   401,     0,   402,   403,   404,   405,   406,   407,   408,
     409,   410,   411,   412,   413,   414,     0,   415,   416,   417,
     418,   419,   420,   421,   422,   423,   424,   425,     0,   426,
     427,     0,   428,   429,   430,   431,   432,   433,   434,   435,
     436,   437,   438,     0,   439,   440,   441,   442,   443,     0,
     444,   445,   446,   447,     0,   448,   449,   450,     0,   451,
     452,   453,   454,   455,   456,   457,   458,   459,   460,   461,
       0,   462,   463,     0,   464,   465,   466,   467,   468,   469,
       0,   470,   471,     0,     0,   472,   473,   474,   475,     0,
     476,   477,   478,   479,   480,   481,   482,     0,     0,   483,
     484,   485,   486,   487,     0,     0,   488,   489,   490,   491,
     492,   493,   494,     0,   495,     0,   496,   497,   498,   499,
       0,     0,   500,     0,     0,   501,   502,   503,   504,   505,
     506,   507,   508,   509,   510,   511,   512,   513,   514,   515,
     516,   517,   518,     0,     0,     0,     0,   801,   802,   803,
       0,   804,   805,   806,   807,   808,   809,   210,     0,     0,
       0,     0,   798,     0,     0,     0,     0,     0,   211,   212,
     213,   214,   215,   216,   217,   218,     0,   220,   221,   222,
       0,     0,     0,     0,   223,     0,     0,     0,   224,   225,
       0,   226,   227,     0,   228,   229,   230,   231,   232,     0,
     233,   234,     0,   235,   236,   237,   238,   239,     0,     0,
     240,   241,   242,   243,   244,     0,   245,   895,   247,   248,
     249,     0,     0,     0,   250,   251,   252,   253,     0,   254,
     255,     0,   256,   257,   258,   259,   260,   261,     0,     0,
     262,   263,     0,     0,     0,     0,     0,     0,     0,   264,
     265,   266,   267,   268,   269,   270,   271,   272,     0,   273,
       0,   274,   275,   276,   277,   278,     0,   279,   280,   281,
       0,     0,   282,   283,   284,   285,   286,     0,   287,   288,
     289,     0,   290,   291,   292,     0,   293,   294,   295,   296,
     297,   298,   299,   300,   301,     0,   896,     0,   303,   304,
     305,   306,     0,   307,     0,   308,     0,     0,     0,   309,
     310,   311,     0,   312,   313,     0,   314,     0,   315,   316,
     317,   318,   319,     0,   320,   321,   322,     0,   323,   324,
     325,   326,   327,   328,     0,   329,     0,   330,   331,   332,
     333,   334,   335,   336,     0,   337,     0,   338,     0,     0,
     339,     0,   340,   341,   342,   343,   344,     0,   345,   346,
       0,   347,   348,     0,   349,     0,     0,   350,   351,   352,
       0,     0,   353,   354,   355,   356,   357,   358,   359,   360,
     361,   362,   363,   364,   365,   366,     0,   367,   368,   369,
     370,     0,   371,   372,     0,   373,     0,   374,   375,   376,
     377,   378,   379,     0,   380,     0,     0,   381,   382,   383,
       0,     0,   384,   385,     0,   386,     0,   387,   388,   389,
     390,   391,   392,   393,   394,     0,   395,   396,   397,   398,
     399,   400,   401,     0,   402,   403,   404,   405,   406,   407,
     408,   409,   410,   411,   412,   413,   414,     0,   415,   416,
     417,   418,   419,   420,   421,   422,   423,   424,   425,     0,
     426,   427,     0,   428,   429,   430,   431,   432,   433,   434,
     435,   436,   437,   438,     0,   439,   440,   441,   442,   443,
       0,   444,   445,   446,   447,     0,   448,   449,   450,     0,
     451,   452,   453,   454,   455,   456,   457,   458,   459,   460,
     461,     0,   462,   463,     0,   464,   465,   466,   467,   468,
     469,     0,   470,   471,     0,     0,   472,   473,   474,   475,
       0,   476,   477,   478,   479,   480,   481,   482,     0,     0,
     483,   484,   485,   486,   487,     0,     0,   488,   489,   490,
     491,   492,   493,   494,     0,   495,     0,   496,   497,   498,
     499,     0,     0,   500,     0,     0,   501,   502,   503,   504,
     505,   506,   507,   508,   509,   510,   511,   512,   513,   514,
     515,   516,   517,   518,     0,     0,     0,     0,   801,   802,
     803,     0,   804,   805,   806,   807,   808,   809,   210,     0,
       0,     0,     0,   798,     0,     0,     0,     0,     0,   211,
     212,   213,   214,   215,   216,   217,   218,     0,   220,   221,
     222,     0,     0,     0,     0,   223,     0,     0,     0,   224,
     225,     0,   226,   227,     0,   228,   229,   230,   231,   232,
       0,   233,   234,     0,   235,   236,   237,   238,   239,     0,
       0,   240,   241,   242,   243,   244,     0,   245,   945,   247,
     248,   249,     0,     0,     0,   250,   251,   252,   253,     0,
     254,   255,     0,   256,   257,   258,   259,   260,   261,     0,
       0,   262,   263,     0,     0,     0,     0,     0,     0,     0,
     264,   265,   266,   267,   268,   269,   270,   271,   272,     0,
     273,     0,   274,   275,   276,   277,   278,     0,   279,   280,
     281,     0,     0,   282,   283,   284,   285,   286,     0,   287,
     288,   289,     0,   290,   291,   292,     0,   293,   294,   295,
     296,   297,   298,   299,   300,   301,     0,   946,     0,   303,
     304,   305,   306,     0,   307,     0,   308,     0,     0,     0,
     309,   310,   311,     0,   312,   313,     0,   314,     0,   315,
     316,   317,   318,   947,     0,   320,   321,   322,     0,   323,
     324,   325,   326,   327,   328,     0,   329,     0,   330,   331,
     332,   333,   334,   335,   336,     0,   337,     0,   338,     0,
       0,   339,     0,   340,   341,   342,   343,   344,     0,   345,
     346,     0,   347,   348,     0,   349,     0,     0,   350,   351,
     352,     0,     0,   353,   354,   355,   356,   357,   358,   359,
     360,   361,   362,   363,   364,   365,   366,     0,   367,   368,
     369,   370,     0,   371,   372,     0,   373,     0,   374,   375,
     376,   377,   378,   379,     0,   380,     0,     0,   381,   382,
     383,     0,     0,   384,   385,     0,   386,     0,   387,   388,
     389,   390,   391,   392,   393,   394,     0,   395,   396,   397,
     398,   399,   400,   401,     0,   402,   403,   404,   405,   406,
     407,   408,   409,   410,   411,   412,   413,   414,     0,   415,
     416,   417,   418,   419,   420,   421,   422,   423,   424,   425,
       0,   426,   427,     0,   428,   429,   430,   431,   432,   433,
     434,   435,   436,   437,   438,     0,   439,   440,   441,   442,
     443,     0,   444,   445,   446,   447,     0,   448,   449,   450,
       0,   451,   452,   453,   454,   455,   456,   457,   458,   459,
     460,   461,     0,   462,   463,     0,   464,   465,   466,   467,
     468,   469,     0,   470,   471,     0,     0,   472,   473,   474,
     475,     0,   476,   477,   478,   479,   480,   481,   482,     0,
       0,   483,   484,   485,   486,   487,     0,     0,   488,   489,
     490,   491,   492,   493,   494,     0,   495,     0,   496,   497,
     498,   499,     0,     0,   500,     0,     0,   501,   502,   503,
     504,   505,   506,   507,   508,   509,   510,   511,   512,   513,
     514,   515,   516,   517,   518,     0,     0,     0,     0,   801,
     802,   803,     0,   804,   805,   806,   807,   808,   809,   210,
       0,     0,     0,     0,   798,     0,     0,     0,     0,     0,
     211,   212,   213,   214,   215,   216,   217,   218,     0,   220,
     221,   222,     0,     0,     0,     0,   223,     0,     0,     0,
     224,   225,     0,   226,   227,     0,   228,   229,   230,   231,
     232,     0,   233,   234,     0,   235,   236,   237,   238,   239,
       0,     0,   240,   241,   242,   243,   244,     0,   245,  1384,
     247,   248,   249,     0,     0,     0,   250,   251,   252,   253,
       0,   254,   255,     0,   256,   257,   258,   259,   260,   261,
       0,     0,   262,   263,     0,     0,     0,     0,     0,     0,
       0,   264,   265,   266,   267,   268,   269,   270,   271,   272,
       0,   273,     0,   274,   275,   276,   277,   278,     0,   279,
     280,   281,     0,     0,   282,   283,   284,   285,   286,     0,
     287,   288,   289,     0,   290,   291,   292,     0,   293,   294,
     295,   296,   297,   298,   299,   300,   301,     0,  1385,     0,
     303,   304,   305,   306,     0,   307,     0,   308,     0,     0,
       0,   309,   310,   311,     0,   312,   313,     0,   314,     0,
     315,   316,   317,   318,   319,     0,   320,   321,   322,     0,
     323,   324,   325,   326,   327,   328,     0,   329,     0,   330,
     331,   332,   333,   334,   335,   336,     0,   337,     0,   338,
       0,     0,   339,     0,   340,   341,   342,   343,   344,     0,
     345,   346,     0,   347,   348,     0,   349,     0,     0,   350,
     351,   352,     0,     0,   353,   354,   355,   356,   357,   358,
     359,   360,   361,   362,   363,   364,   365,   366,     0,   367,
     368,   369,   370,     0,   371,   372,     0,   373,     0,   374,
     375,   376,   377,   378,   379,     0,   380,     0,     0,   381,
     382,   383,     0,     0,   384,   385,     0,   386,     0,   387,
     388,   389,   390,   391,   392,   393,   394,     0,   395,   396,
     397,   398,   399,   400,   401,     0,   402,   403,   404,   405,
     406,   407,   408,   409,   410,   411,   412,   413,   414,     0,
     415,   416,   417,   418,   419,   420,   421,   422,   423,   424,
     425,     0,   426,   427,     0,   428,   429,   430,   431,   432,
     433,   434,   435,   436,   437,   438,     0,   439,   440,   441,
     442,   443,     0,   444,   445,   446,   447,     0,   448,   449,
     450,     0,   451,   452,   453,   454,   455,   456,   457,   458,
     459,   460,   461,     0,   462,   463,     0,   464,   465,   466,
     467,   468,   469,     0,   470,   471,     0,     0,   472,   473,
     474,   475,     0,   476,   477,   478,   479,   480,   481,   482,
       0,     0,   483,   484,   485,   486,   487,     0,     0,   488,
     489,   490,   491,   492,   493,   494,     0,   495,     0,   496,
     497,   498,   499,     0,     0,   500,     0,     0,   501,   502,
     503,   504,   505,   506,   507,   508,   509,   510,   511,   512,
     513,   514,   515,   516,   517,   518,     0,     0,     0,     0,
     801,   802,   803,     0,   804,   805,   806,   807,   808,   809,
     210,     0,     0,     0,     0,   798,     0,     0,     0,     0,
       0,   211,   212,   213,   214,   215,   216,   217,   218,     0,
     220,   221,   222,     0,     0,     0,     0,   223,     0,     0,
       0,   224,   225,     0,   226,   227,     0,   228,   229,   230,
     231,   232,     0,   233,   234,     0,   235,   236,   237,   238,
     239,     0,     0,   240,   241,   242,   243,   244,     0,   245,
     246,   247,   248,   249,     0,     0,     0,   250,   251,   252,
     253,     0,   254,   255,     0,   256,   257,   258,   259,   260,
     261,     0,     0,   262,   263,     0,     0,     0,     0,     0,
       0,     0,   264,   265,   266,   267,   268,   269,   270,   271,
     272,     0,   273,     0,   274,   275,   276,   277,   278,     0,
     279,   280,   281,     0,     0,   282,   283,   284,   285,   286,
       0,   287,   288,   289,     0,   290,   291,   292,     0,   293,
     294,   295,   296,   297,   298,   299,   300,   301,     0,   302,
       0,   303,   304,   305,   306,     0,   307,     0,   308,     0,
       0,     0,   309,   310,   311,     0,   312,   313,     0,   314,
       0,   315,   316,   317,   318,   319,     0,   320,   321,   322,
       0,   323,   324,   325,   326,   327,   328,     0,   329,     0,
     330,   331,   332,   333,   334,   335,   336,     0,   337,     0,
     338,     0,     0,   339,     0,   340,   341,   342,   343,   344,
       0,   345,   346,     0,   347,   348,     0,   349,     0,     0,
     350,   351,   352,     0,     0,   353,   354,   355,   356,   357,
     358,   359,   360,   361,   362,   363,   364,   365,   366,     0,
     367,   368,   369,   370,     0,   371,   372,     0,   373,     0,
     374,   375,   376,   377,   378,   379,     0,   380,     0,     0,
     381,   382,   383,     0,     0,   384,   385,     0,   386,     0,
     387,   388,   389,   390,   391,   392,   393,   394,     0,   395,
     396,   397,   398,   399,   400,   401,     0,   402,   403,   404,
     405,   406,   407,   408,   409,   410,   411,   412,   413,   414,
       0,   415,   416,   417,   418,   419,   420,   421,   422,   423,
     424,   425,     0,   426,   427,     0,   428,   429,   430,   431,
     432,   433,   434,   435,   436,   437,   438,     0,   439,   440,
     441,   442,   443,     0,   444,   445,   446,   447,     0,   448,
     449,   450,     0,   451,   452,   453,   454,   455,   456,   457,
     458,   459,   460,   461,     0,   462,   463,     0,   464,   465,
     466,   467,   468,   469,     0,   470,   471,     0,     0,   472,
     473,   474,   475,     0,   476,   477,   478,   479,   480,   481,
     482,     0,     0,   483,   484,   485,   486,   487,     0,     0,
     488,   489,   490,   491,   492,   493,   494,     0,   495,     0,
     496,   497,   498,   499,     0,     0,   500,     0,     0,   501,
     502,   503,   504,   505,   506,   507,   508,   509,   510,   511,
     512,   513,   514,   515,   516,   517,   518,     0,     0,     0,
       0,   801,   802,   803,     0,   804,   805,   806,   807,   808,
     809,   210,     0,     0,     0,     0,   798,     0,     0,     0,
       0,     0,   211,   212,   213,   214,   215,   216,   217,   218,
       0,   220,   221,   222,     0,     0,     0,     0,   223,     0,
       0,     0,   224,   225,     0,   226,   227,     0,   228,   229,
     230,   231,   232,     0,   233,   234,     0,   235,   236,   237,
     238,   239,     0,     0,   240,   241,   242,   243,   244,     0,
     245,  2608,   247,   248,   249,     0,     0,     0,   250,   251,
     252,   253,     0,   254,   255,     0,   256,   257,   258,   259,
     260,   261,     0,     0,   262,   263,     0,     0,     0,     0,
       0,     0,     0,   264,   265,   266,   267,   268,   269,   270,
     271,   272,     0,   273,     0,   274,   275,   276,   277,   278,
       0,   279,   280,   281,     0,     0,   282,   283,   284,   285,
     286,     0,   287,   288,   289,     0,   290,   291,   292,     0,
     293,   294,   295,   296,   297,   298,   299,   300,   301,     0,
    2609,     0,   303,   304,   305,   306,     0,   307,     0,   308,
       0,     0,     0,   309,   310,   311,     0,   312,   313,     0,
     314,     0,   315,   316,   317,   318,   319,     0,   320,   321,
     322,     0,   323,   324,   325,   326,   327,   328,     0,   329,
       0,   330,   331,   332,   333,   334,   335,   336,     0,   337,
       0,   338,     0,     0,   339,     0,   340,   341,   342,   343,
     344,     0,   345,   346,     0,   347,   348,     0,   349,     0,
       0,   350,   351,   352,     0,     0,   353,   354,   355,   356,
     357,   358,   359,   360,   361,   362,   363,   364,   365,   366,
       0,   367,   368,   369,   370,     0,   371,   372,     0,   373,
       0,   374,   375,   376,   377,   378,   379,     0,   380,     0,
       0,   381,   382,   383,     0,     0,   384,   385,     0,   386,
       0,   387,   388,   389,   390,   391,   392,   393,   394,     0,
     395,   396,   397,   398,   399,   400,   401,     0,   402,   403,
     404,   405,   406,   407,   408,   409,   410,   411,   412,   413,
     414,     0,   415,   416,   417,   418,   419,   420,   421,   422,
     423,   424,   425,     0,   426,   427,     0,   428,   429,   430,
     431,   432,   433,   434,   435,   436,   437,   438,     0,   439,
     440,   441,   442,   443,     0,   444,   445,   446,   447,     0,
     448,   449,   450,     0,   451,   452,   453,   454,   455,   456,
     457,   458,   459,   460,   461,     0,   462,   463,     0,   464,
     465,   466,   467,   468,   469,     0,   470,   471,     0,     0,
     472,   473,   474,   475,     0,   476,   477,   478,   479,   480,
     481,   482,     0,     0,   483,   484,   485,   486,   487,     0,
       0,   488,   489,   490,   491,   492,   493,   494,     0,   495,
       0,   496,   497,   498,   499,     0,     0,   500,     0,     0,
     501,   502,   503,   504,   505,   506,   507,   508,   509,   510,
     511,   512,   513,   514,   515,   516,   517,   518,     0,     0,
       0,     0,   801,   802,   803,     0,   804,   805,   806,   807,
     808,   809,   210,     0,     0,     0,     0,   798,     0,     0,
       0,     0,     0,   211,   212,   213,   214,   215,   216,   217,
     218,     0,   220,   221,   222,     0,     0,     0,     0,   223,
       0,     0,     0,   224,   225,     0,   226,   227,     0,   228,
     229,   230,   231,   232,     0,   233,   234,     0,   235,   236,
     237,   238,   239,     0,     0,   240,   241,   242,   243,   244,
       0,   245,   246,   247,   248,   249,     0,     0,     0,   250,
     251,   252,   253,     0,   254,   255,     0,   256,   257,   258,
     259,   260,   261,     0,     0,   262,   263,     0,     0,     0,
       0,     0,     0,     0,   264,   265,   266,   267,   268,   269,
     270,   271,   272,     0,   273,     0,   274,   275,   276,   277,
     278,     0,   279,   280,   281,     0,     0,   282,   283,   284,
     285,   286,     0,   287,   288,   289,     0,   290,   291,   292,
       0,   293,   294,   295,   296,   297,   298,   299,   300,   301,
       0,   302,     0,   303,   304,   305,   306,     0,   307,     0,
     308,     0,     0,     0,   309,   310,   311,     0,   312,   313,
       0,   314,     0,   315,   316,   317,   318,   319,     0,   320,
     321,   322,     0,   323,   324,   325,   326,   327,   328,     0,
     329,     0,   330,   331,   332,   333,   334,   335,   336,     0,
     337,     0,   338,     0,     0,   339,     0,   340,   341,   342,
     343,   344,     0,   345,   346,     0,   347,   348,     0,   349,
       0,     0,   350,   351,   352,     0,     0,   353,   354,   355,
     356,   357,   358,   359,   360,   361,   362,   363,   364,   365,
     366,     0,   367,   368,   369,   370,     0,   371,   372,     0,
     373,     0,   374,   375,   376,   377,   378,   379,     0,   380,
       0,     0,  4197,   382,   383,     0,     0,   384,   385,     0,
     386,     0,   387,   388,   389,   390,   391,   392,   393,   394,
       0,   395,   396,   397,   398,   399,   400,   401,     0,   402,
     403,   404,   405,   406,   407,   408,   409,   410,   411,   412,
     413,   414,     0,   415,   416,   417,   418,   419,   420,   421,
     422,   423,   424,   425,     0,   426,   427,     0,   428,   429,
     430,   431,   432,   433,   434,   435,   436,   437,   438,     0,
     439,   440,   441,   442,   443,     0,   444,   445,   446,   447,
       0,   448,   449,   450,     0,   451,   452,   453,   454,   455,
     456,   457,   458,   459,   460,   461,     0,   462,   463,     0,
     464,   465,   466,   467,   468,   469,     0,   470,   471,     0,
       0,   472,   473,   474,   475,     0,   476,   477,   478,   479,
     480,   481,   482,     0,     0,   483,   484,   485,   486,   487,
       0,     0,   488,   489,   490,   491,   492,   493,   494,     0,
     495,     0,   496,   497,   498,   499,     0,     0,   500,     0,
       0,   501,   502,   503,   504,   505,   506,   507,   508,   509,
     510,   511,   512,   513,   514,   515,   516,   517,   518,     0,
       0,     0,  1742,   801,   802,   803,     0,   804,   805,   806,
     807,   808,   809,   211,   212,   213,   214,   215,   216,   217,
     218,  1743,   220,   221,   222,  1744,  1745,  1746,  1747,   223,
    1748,  1749,  1750,   224,   225,  1751,   226,   227,   745,   228,
     229,   230,   231,   232,   746,   233,   234,  1752,   235,   236,
     237,   238,   239,  1753,  1754,   240,   241,   242,   243,   244,
    1755,   245,   246,   247,   248,   249,  1756,   747,  1757,   250,
     251,   252,   253,   748,   254,   255,  1758,   256,   257,   258,
     259,   260,   261,  1759,   749,   262,   263,  1760,  1761,  1762,
     750,  1763,  1764,  1765,   264,   265,   266,   267,   268,   269,
     270,   271,   272,  1766,   273,  1767,   274,   275,   276,   277,
     278,  1768,   279,   280,   281,  1769,  1770,   282,   283,   284,
     285,   286,  1771,   287,   288,   289,  1772,   290,   291,   292,
    1773,   293,   294,   295,   296,   297,   298,   299,   300,   301,
    1774,   302,  1775,   303,   304,   305,   306,  1776,   307,  1777,
     308,   751,  1778,   752,   309,   310,   311,  1779,   312,   313,
    1780,   314,  1781,   315,   316,   317,   318,   319,   753,   320,
     321,   322,  1782,   323,   324,   325,   326,   327,   328,  1783,
     329,   754,   330,   331,   332,   333,   334,   335,   336,  1784,
     337,  1785,   338,   755,   756,   339,   757,   340,   341,   342,
     343,   344,  1786,   345,   346,  1787,   347,   348,   758,   349,
     759,  1788,   350,   351,   352,  1789,  1790,   353,   354,   355,
     356,   357,   358,   359,   360,   361,   362,   363,   364,   365,
     366,   760,   367,   368,   369,   370,  1791,   371,   372,   761,
     373,  1792,   374,   375,   376,   377,   378,   379,  1793,   380,
    1794,  1795,   381,   382,   383,  1796,  1797,   384,   385,   762,
     386,   763,   387,   388,   389,   390,   391,   392,   393,   394,
    1798,   395,   396,   397,   398,   399,   400,   401,  1799,   402,
     403,   404,   405,   406,   407,   408,   409,   410,   411,   412,
     413,   414,  1800,   415,   416,   417,   418,   419,   420,   421,
     422,   423,   424,   425,  1801,   426,   427,   764,   428,   429,
     430,   431,   432,   433,   434,   435,   436,   437,   438,  1802,
     439,   440,   441,   442,   443,  1803,   444,   445,   446,   447,
     765,   448,   449,   450,  1804,   451,   452,   453,   454,   455,
     456,   457,   458,   459,   460,   461,  1805,   462,   463,  1806,
     464,   465,   466,   467,   468,   469,  1807,   470,   471,  1808,
    1809,   472,   473,   474,   475,  1810,   476,   477,   478,   479,
     480,   481,   482,  1811,  1812,   483,   484,   485,   486,   487,
    1813,  1814,   488,   489,   490,   491,   492,   493,   494,  1815,
     495,   766,   496,   497,   498,   499,  1816,  1817,   500,  1818,
    1819,   501,   502,   503,   504,   505,   506,   507,   508,   509,
     510,   511,   512,   513,   514,   515,   516,   517,   518,   210,
       0,     0,     0,     0,     0,     0,     0,     0,     0,  1820,
     211,   212,   213,   214,   215,   216,   217,   218,     0,   220,
     221,   222,     0,     0,     0,     0,   223,     0,     0,     0,
     224,   225,     0,   226,   227,     0,   228,   229,   230,   231,
     232,     0,   233,   234,     0,   235,   236,   237,   238,   239,
       0,     0,   240,   241,   242,   243,   244,     0,   245,   246,
     247,   248,   249,     0,     0,     0,   250,   251,   252,   253,
       0,   254,   255,     0,   256,   257,   258,   259,   260,   261,
       0,     0,   262,   263,     0,     0,     0,     0,     0,     0,
       0,   264,   265,   266,   267,   268,   269,   270,   271,   272,
       0,   273,     0,   274,   275,   276,   277,   278,     0,   279,
     280,   281,     0,     0,   282,   283,   284,   285,   286,     0,
     287,   288,   289,     0,   290,   291,   292,     0,   293,   294,
     295,   296,   297,   298,   299,   300,   301,     0,   302,     0,
     303,   304,   305,   306,     0,   307,     0,   308,     0,     0,
       0,   309,   310,   311,     0,   312,   313,     0,   314,     0,
     315,   316,   317,   318,   319,     0,   320,   321,   322,     0,
     323,   324,   325,   326,   327,   328,     0,   329,     0,   330,
     331,   332,   333,   334,   335,   336,     0,   337,     0,   338,
       0,     0,   339,     0,   340,   341,   342,   343,   344,     0,
     345,   346,     0,   347,   348,     0,   349,     0,     0,   350,
     351,   352,     0,     0,   353,   354,   355,   356,   357,   358,
     359,   360,   361,   362,   363,   364,   365,   366,     0,   367,
     368,   369,   370,     0,   371,   372,     0,   373,     0,   374,
     375,   376,   377,   378,   379,     0,   380,     0,     0,   381,
     382,   383,     0,     0,   384,   385,     0,   386,     0,   387,
     388,   389,   390,   391,   392,   393,   394,     0,   395,   396,
     397,   398,   399,   400,   401,     0,   402,   403,   404,   405,
     406,   407,   408,   409,   410,   411,   412,   413,   414,     0,
     415,   416,   417,   418,   419,   420,   421,   422,   423,   424,
     425,     0,   426,   427,     0,   428,   429,   430,   431,   432,
     433,   434,   435,   436,   437,   438,     0,   439,   440,   441,
     442,   443,     0,   444,   445,   446,   447,     0,   448,   449,
     450,     0,   451,   452,   453,   454,   455,   456,   457,   458,
     459,   460,   461,     0,   462,   463,     0,   464,   465,   466,
     467,   468,   469,     0,   470,   471,     0,     0,   472,   473,
     474,   475,     0,   476,   477,   478,   479,   480,   481,   482,
       0,     0,   483,   484,   485,   486,   487,     0,     0,   488,
     489,   490,   491,   492,   493,   494,     0,   495,     0,   496,
     497,   498,   499,     0,     0,   500,     0,     0,   501,   502,
     503,   504,   505,   506,   507,   508,   509,   510,   511,   512,
     513,   514,   515,   516,   517,   518,  1399,     0,     0,     0,
       0,     0,     0,     0,     0,     0,   714,   211,   212,   213,
     214,   215,   216,   217,   218,     0,   220,   221,   222,     0,
       0,     0,     0,   223,     0,     0,     0,   224,   225,     0,
     226,   227,   745,   228,   229,   230,     0,  1400,   746,  1401,
    1402,     0,   235,   236,   237,   238,   239,     0,     0,   240,
     241,  1403,  1404,   244,     0,   245,   246,   247,   248,     0,
       0,   747,     0,   250,   251,   252,   253,   748,   254,   255,
       0,   256,   257,   258,   259,   260,   261,     0,   749,   262,
     263,     0,     0,     0,   750,     0,     0,     0,   264,   265,
     266,   267,   268,   269,  1405,  1406,   272,     0,   273,     0,
     274,   275,   276,   277,   278,     0,   279,   280,   281,     0,
       0,   282,   283,  1057,   285,   286,     0,   287,   288,   289,
       0,   290,   291,   292,     0,   293,   294,   295,   296,     0,
     298,   299,   300,     0,     0,   302,     0,   303,   304,  1407,
     306,     0,   307,     0,   308,   751,     0,   752,   309,   310,
     311,     0,   312,     0,     0,   314,     0,   315,   316,   317,
     318,   319,   753,   320,   321,   322,  1879,   323,   324,   325,
     326,   327,   328,     0,   329,   754,  1880,   331,   332,   333,
     334,  1408,  1409,     0,  1410,     0,   338,   755,   756,   339,
     757,   340,   341,   342,   343,   344,     0,   345,   346,     0,
     347,     0,   758,   349,   759,     0,   350,   351,   352,     0,
       0,   353,   354,   355,   356,   357,   358,   359,   360,   361,
     362,   363,   364,   365,  1411,   760,  1412,   368,   369,     0,
       0,   371,   372,   761,   373,     0,     0,   375,  1413,   377,
     378,   379,     0,   380,     0,     0,   381,   382,   383,     0,
    1881,   384,  1882,   762,   386,   763,     0,   388,   389,   390,
     391,   392,   393,   394,     0,   395,     0,   397,     0,   399,
     400,   401,     0,   402,   403,   404,   405,   406,   407,   408,
     409,  1414,   411,   412,   413,   414,     0,   415,   416,   417,
     418,   419,   420,   421,   422,   423,   424,   425,     0,   426,
     427,   764,   428,   429,     0,   431,   432,   433,   434,   435,
     436,   437,   438,     0,   439,   440,   441,   442,   443,     0,
     444,  1883,   446,   447,   765,   448,  1416,   450,     0,   451,
     452,   453,   454,   455,   456,   457,   458,   459,   460,     0,
       0,   462,   463,     0,   464,   465,   466,   467,   468,   469,
       0,  1417,  1418,     0,     0,   472,     0,   474,     0,     0,
     476,   477,   478,   479,   480,   481,   482,     0,     0,   483,
     484,   485,   486,   487,     0,     0,   488,   489,   490,   491,
     492,     0,  1419,  1884,   495,   766,   496,   497,   498,   499,
       0,     0,   500,     0,     0,   501,   502,   503,   504,   505,
     506,     0,     0,     0,  2136,     0,     0,     0,     0,     0,
     516,   517,   518,     0,     0,   211,   212,   213,   214,   215,
     216,   217,   218,  1885,   220,   221,   222,     0,     0,     0,
       0,   223,     0,     0,     0,   224,   225,     0,   226,   227,
     745,   228,   229,   230,     0,  1400,   746,  1401,  1402,     0,
     235,   236,   237,   238,   239,     0,     0,   240,   241,  1403,
    1404,   244,     0,   245,   246,   247,   248,     0,     0,   747,
       0,   250,   251,   252,   253,   748,   254,   255,     0,   256,
     257,   258,   259,   260,   261,     0,   749,   262,   263,     0,
       0,     0,   750,     0,     0,     0,   264,   265,   266,   267,
     268,   269,  1405,  1406,   272,     0,   273,     0,   274,   275,
     276,   277,   278,     0,   279,   280,   281,     0,     0,   282,
     283,  1057,   285,   286,     0,   287,   288,   289,     0,   290,
     291,   292,     0,   293,   294,   295,   296,     0,   298,   299,
     300,     0,     0,   302,     0,   303,   304,  1407,   306,     0,
     307,     0,   308,   751,     0,   752,   309,   310,   311,     0,
     312,     0,     0,   314,     0,   315,   316,   317,   318,   319,
     753,   320,   321,   322,  1879,   323,   324,   325,   326,   327,
     328,     0,   329,   754,  1880,   331,   332,   333,   334,  1408,
    1409,     0,  1410,     0,   338,   755,   756,   339,   757,   340,
     341,   342,   343,   344,     0,   345,   346,     0,   347,     0,
     758,   349,   759,     0,   350,   351,   352,     0,     0,   353,
     354,   355,   356,   357,   358,   359,   360,   361,   362,   363,
     364,   365,  1411,   760,  1412,   368,   369,     0,     0,   371,
     372,   761,   373,     0,     0,   375,  1413,   377,   378,   379,
       0,   380,     0,     0,   381,   382,   383,     0,  1881,   384,
    1882,   762,   386,   763,     0,   388,   389,   390,   391,   392,
     393,   394,     0,   395,     0,   397,     0,   399,   400,   401,
       0,   402,   403,   404,   405,   406,   407,   408,   409,  1414,
     411,   412,   413,   414,     0,   415,   416,   417,   418,   419,
     420,   421,   422,   423,   424,   425,     0,   426,   427,   764,
     428,   429,     0,   431,   432,   433,   434,   435,   436,   437,
     438,     0,   439,   440,   441,   442,   443,     0,   444,  1883,
     446,   447,   765,   448,  1416,   450,     0,   451,   452,   453,
     454,   455,   456,   457,   458,   459,   460,     0,     0,   462,
     463,     0,   464,   465,   466,   467,   468,   469,     0,  1417,
    1418,     0,     0,   472,     0,   474,     0,     0,   476,   477,
     478,   479,   480,   481,   482,     0,     0,   483,   484,   485,
     486,   487,     0,     0,   488,   489,   490,   491,   492,     0,
    1419,  1884,   495,   766,   496,   497,   498,   499,     0,     0,
     500,     0,     0,   501,   502,   503,   504,   505,   506,     0,
       0,     0,   210,     0,     0,     0,     0,     0,   516,   517,
     518,     0,     0,   211,   212,   213,   214,   215,   216,   217,
     218,  1885,   220,   221,   222,     0,     0,     0,     0,   223,
       0,     0,     0,   224,   225,     0,   226,   227,     0,   228,
     229,   230,   231,   232,     0,   233,   234,     0,   235,   236,
     237,   238,   239,     0,     0,   240,   241,   242,   243,   244,
       0,   245,   246,   247,   248,   249,     0,     0,     0,   250,
     251,   252,   253,     0,   254,   255,     0,   256,   257,   258,
     259,   260,   261,     0,     0,   262,   263,     0,     0,     0,
       0,     0,     0,     0,   264,   265,   266,   267,   268,   269,
     270,   271,   272,     0,   273,     0,   274,   275,   276,   277,
     278,     0,   279,   280,   281,     0,     0,   282,   283,   284,
     285,   286,     0,   287,   288,   289,     0,   290,   291,   292,
       0,   293,   294,   295,   296,   297,   298,   299,   300,   301,
       0,   302,     0,   303,   304,   305,   306,     0,   307,     0,
     308,     0,     0,     0,   309,   310,   311,     0,   312,   313,
       0,   314,     0,   315,   316,   317,   318,   319,     0,   320,
     321,   322,     0,   323,   324,   325,   326,   327,   328,     0,
     329,     0,   330,   331,   332,   333,   334,   335,   336,     0,
     337,     0,   338,     0,     0,   339,     0,   340,   341,   342,
     343,   344,     0,   345,   346,     0,   347,   348,     0,   349,
       0,     0,   350,   351,   352,     0,     0,   353,   354,   355,
     356,   357,   358,   359,   360,   361,   362,   363,   364,   365,
     366,     0,   367,   368,   369,   370,     0,   371,   372,     0,
     373,     0,   374,   375,   376,   377,   378,   379,     0,   380,
       0,     0,   381,   382,   383,     0,     0,   384,   385,     0,
     386,     0,   387,   388,   389,   390,   391,   392,   393,   394,
       0,   395,   396,   397,   398,   399,   400,   401,     0,   402,
     403,   404,   405,   406,   407,   408,   409,   410,   411,   412,
     413,   414,     0,   415,   416,   417,   418,   419,   420,   421,
     422,   423,   424,   425,     0,   426,   427,     0,   428,   429,
     430,   431,   432,   433,   434,   435,   436,   437,   438,     0,
     439,   440,   441,   442,   443,     0,   444,   445,   446,   447,
       0,   448,   449,   450,     0,   451,   452,   453,   454,   455,
     456,   457,   458,   459,   460,   461,     0,   462,   463,     0,
     464,   465,   466,   467,   468,   469,     0,   470,   471,     0,
       0,   472,   473,   474,   475,     0,   476,   477,   478,   479,
     480,   481,   482,     0,     0,   483,   484,   485,   486,   487,
       0,     0,   488,   489,   490,   491,   492,   493,   494,     0,
     495,     0,   496,   497,   498,   499,     0,     0,   500,     0,
       0,   501,   502,   503,   504,   505,   506,   507,   508,   509,
     510,   511,   512,   513,   514,   515,   516,   517,   518,   787,
    1290,   574,     0,     0,     0,   625,     0,     0,     0,  4245,
     211,   212,   213,   214,   215,   216,   217,   218,     0,   220,
     221,   222,     0,     0,     0,     0,   223,     0,     0,     0,
     224,   225,     0,   226,   227,   745,   228,   229,   230,   231,
     232,   746,   233,   234,     0,   235,   236,   237,   238,   239,
       0,     0,   240,   241,   242,   243,   244,     0,   245,   246,
     247,   248,   249,     0,   747,     0,   250,   251,   252,   253,
     748,   254,   255,     0,   256,   257,   258,   259,   260,   261,
       0,   749,   262,   263,     0,     0,     0,   750,     0,     0,
       0,   264,   265,   266,   267,   268,   269,   270,   271,   272,
    1732,   273,     0,   274,   275,   276,   277,   278,     0,   279,
     280,   281,     0,     0,   282,   283,   284,   285,   286,     0,
     287,   288,   289,     0,   290,   291,   292,     0,   293,   294,
     295,   296,   297,   298,   299,   300,   301,  1538,   302,     0,
     303,   304,   305,   306,     0,   307,     0,   308,   751,     0,
     752,   309,   310,   311,     0,   312,   313,     0,   314,     0,
     315,   316,   317,   318,   319,   753,   320,   321,   322,     0,
     323,   324,   325,   326,   327,   328,     0,   329,   754,   330,
     331,   332,   333,   334,   335,   336,     0,   337,     0,   338,
     755,   756,   339,   757,   340,   341,   342,   343,   344,     0,
     345,   346,     0,   347,   348,   758,   349,   759,     0,   350,
     351,   352,     0,     0,   353,   354,   355,   356,   357,   358,
     359,   360,   361,   362,   363,   364,   365,   366,   760,   367,
     368,   369,   370,     0,   371,   372,   761,   373,     0,   374,
     375,   376,   377,   378,   379,     0,   380,  1539,     0,   381,
     382,   383,     0,     0,   384,   385,   762,   386,   763,   387,
     388,   389,   390,   391,   392,   393,   394,     0,   395,   396,
     397,   398,   399,   400,   401,     0,   402,   403,   404,   405,
     406,   407,   408,   409,   410,   411,   412,   413,   414,     0,
     415,   416,   417,   418,   419,   420,   421,   422,   423,   424,
     425,     0,   426,   427,   764,   428,   429,   430,   431,   432,
     433,   434,   435,   436,   437,   438,     0,   439,   440,   441,
     442,   443,     0,   444,   445,   446,   447,   765,   448,   449,
     450,     0,   451,   452,   453,   454,   455,   456,   457,   458,
     459,   460,   461,     0,   462,   463,     0,   464,   465,   466,
     467,   468,   469,     0,   470,   471,     0,     0,   472,   473,
     474,   475,  1540,   476,   477,   478,   479,   480,   481,   482,
       0,     0,   483,   484,   485,   486,   487,     0,     0,   488,
     489,   490,   491,   492,   493,   494,     0,   495,   766,   496,
     497,   498,   499,     0,     0,   500,     0,     0,   501,   502,
     503,   504,   505,   506,   507,   508,   509,   510,   511,   512,
     513,   514,   515,   516,   517,   518,   787,  1290,   574,     0,
       0,     0,   625,     0,  1291,  1292,     0,   211,   212,   213,
     214,   215,   216,   217,   218,     0,   220,   221,   222,     0,
       0,     0,     0,   223,     0,     0,     0,   224,   225,     0,
     226,   227,   745,   228,   229,   230,   231,   232,   746,   233,
     234,     0,   235,   236,   237,   238,   239,     0,     0,   240,
     241,   242,   243,   244,     0,   245,   246,   247,   248,   249,
       0,   747,     0,   250,   251,   252,   253,   748,   254,   255,
       0,   256,   257,   258,   259,   260,   261,     0,   749,   262,
     263,     0,     0,     0,   750,     0,     0,     0,   264,   265,
     266,   267,   268,   269,   270,   271,   272,  1737,   273,     0,
     274,   275,   276,   277,   278,     0,   279,   280,   281,     0,
       0,   282,   283,   284,   285,   286,     0,   287,   288,   289,
       0,   290,   291,   292,     0,   293,   294,   295,   296,   297,
     298,   299,   300,   301,  1538,   302,     0,   303,   304,   305,
     306,     0,   307,     0,   308,   751,     0,   752,   309,   310,
     311,     0,   312,   313,     0,   314,     0,   315,   316,   317,
     318,   319,   753,   320,   321,   322,     0,   323,   324,   325,
     326,   327,   328,     0,   329,   754,   330,   331,   332,   333,
     334,   335,   336,     0,   337,     0,   338,   755,   756,   339,
     757,   340,   341,   342,   343,   344,     0,   345,   346,     0,
     347,   348,   758,   349,   759,     0,   350,   351,   352,     0,
       0,   353,   354,   355,   356,   357,   358,   359,   360,   361,
     362,   363,   364,   365,   366,   760,   367,   368,   369,   370,
       0,   371,   372,   761,   373,     0,   374,   375,   376,   377,
     378,   379,     0,   380,  1539,     0,   381,   382,   383,     0,
       0,   384,   385,   762,   386,   763,   387,   388,   389,   390,
     391,   392,   393,   394,     0,   395,   396,   397,   398,   399,
     400,   401,     0,   402,   403,   404,   405,   406,   407,   408,
     409,   410,   411,   412,   413,   414,     0,   415,   416,   417,
     418,   419,   420,   421,   422,   423,   424,   425,     0,   426,
     427,   764,   428,   429,   430,   431,   432,   433,   434,   435,
     436,   437,   438,     0,   439,   440,   441,   442,   443,     0,
     444,   445,   446,   447,   765,   448,   449,   450,     0,   451,
     452,   453,   454,   455,   456,   457,   458,   459,   460,   461,
       0,   462,   463,     0,   464,   465,   466,   467,   468,   469,
       0,   470,   471,     0,     0,   472,   473,   474,   475,  1540,
     476,   477,   478,   479,   480,   481,   482,     0,     0,   483,
     484,   485,   486,   487,     0,     0,   488,   489,   490,   491,
     492,   493,   494,     0,   495,   766,   496,   497,   498,   499,
       0,     0,   500,     0,     0,   501,   502,   503,   504,   505,
     506,   507,   508,   509,   510,   511,   512,   513,   514,   515,
     516,   517,   518,   787,  1290,   574,     0,     0,     0,   625,
       0,  1291,  1292,     0,   211,   212,   213,   214,   215,   216,
     217,   218,     0,   220,   221,   222,     0,     0,     0,     0,
     223,     0,     0,     0,   224,   225,     0,   226,   227,   745,
     228,   229,   230,   231,   232,   746,   233,   234,     0,   235,
     236,   237,   238,   239,     0,     0,   240,   241,   242,   243,
     244,     0,   245,   246,   247,   248,   249,     0,   747,     0,
     250,   251,   252,   253,   748,   254,   255,     0,   256,   257,
     258,   259,   260,   261,     0,   749,   262,   263,     0,     0,
       0,   750,     0,     0,     0,   264,   265,   266,   267,   268,
     269,   270,   271,   272,     0,   273,     0,   274,   275,   276,
     277,   278,     0,   279,   280,   281,     0,     0,   282,   283,
     284,   285,   286,     0,   287,   288,   289,     0,   290,   291,
     292,     0,   293,   294,   295,   296,   297,   298,   299,   300,
     301,  1538,   302,     0,   303,   304,   305,   306,     0,   307,
       0,   308,   751,     0,   752,   309,   310,   311,     0,   312,
     313,     0,   314,     0,   315,   316,   317,   318,   319,   753,
     320,   321,   322,     0,   323,   324,   325,   326,   327,   328,
       0,   329,   754,   330,   331,   332,   333,   334,   335,   336,
       0,   337,     0,   338,   755,   756,   339,   757,   340,   341,
     342,   343,   344,     0,   345,   346,     0,   347,   348,   758,
     349,   759,     0,   350,   351,   352,     0,     0,   353,   354,
     355,   356,   357,   358,   359,   360,   361,   362,   363,   364,
     365,   366,   760,   367,   368,   369,   370,     0,   371,   372,
     761,   373,     0,   374,   375,   376,   377,   378,   379,     0,
     380,  1539,     0,   381,   382,   383,     0,     0,   384,   385,
     762,   386,   763,   387,   388,   389,   390,   391,   392,   393,
     394,     0,   395,   396,   397,   398,   399,   400,   401,     0,
     402,   403,   404,   405,   406,   407,   408,   409,   410,   411,
     412,   413,   414,     0,   415,   416,   417,   418,   419,   420,
     421,   422,   423,   424,   425,     0,   426,   427,   764,   428,
     429,   430,   431,   432,   433,   434,   435,   436,   437,   438,
       0,   439,   440,   441,   442,   443,     0,   444,   445,   446,
     447,   765,   448,   449,   450,     0,   451,   452,   453,   454,
     455,   456,   457,   458,   459,   460,   461,     0,   462,   463,
       0,   464,   465,   466,   467,   468,   469,     0,   470,   471,
       0,     0,   472,   473,   474,   475,  1540,   476,   477,   478,
     479,   480,   481,   482,     0,     0,   483,   484,   485,   486,
     487,     0,     0,   488,   489,   490,   491,   492,   493,   494,
       0,   495,   766,   496,   497,   498,   499,     0,     0,   500,
       0,     0,   501,   502,   503,   504,   505,   506,   507,   508,
     509,   510,   511,   512,   513,   514,   515,   516,   517,   518,
     210,     0,     0,     0,     0,     0,   625,     0,  1291,  1292,
       0,   211,   626,   213,   214,   215,   216,   217,   218,   627,
     220,   221,   222,     0,     0,     0,     0,   223,     0,     0,
       0,   224,   225,     0,   226,   227,     0,   628,   229,   230,
     231,   232,     0,   233,   234,     0,   235,   236,   237,   238,
     239,     0,     0,   240,   241,   242,   243,   244,     0,   245,
     246,   247,   248,   249,     0,     0,     0,   250,   251,   252,
     253,     0,   254,   255,     0,   256,   257,   258,   259,   260,
     261,     0,     0,   262,   263,     0,     0,     0,     0,     0,
       0,     0,   264,   265,   266,   267,   268,   269,   270,   271,
     272,     0,   273,     0,   274,   275,   276,   277,   278,     0,
     279,   280,   281,     0,     0,   282,   283,   284,   285,   286,
       0,   287,   288,   289,     0,   290,   291,   292,     0,   293,
     294,   295,   296,   297,   298,   299,   300,   301,     0,   302,
       0,   303,   629,   305,   306,     0,   307,     0,   630,     0,
     631,     0,   309,   310,   311,     0,   312,   313,     0,   314,
       0,   315,   316,   317,   318,   319,     0,   320,   321,   322,
     632,   323,   324,   325,   326,   327,   328,     0,   329,     0,
     330,   331,   332,   333,   334,   335,   336,     0,   337,     0,
     338,     0,     0,   339,     0,   340,   341,   342,   343,   633,
       0,   345,   346,     0,   347,   348,     0,   349,     0,     0,
     350,   351,   352,     0,     0,   353,   354,   355,   356,   357,
     358,   359,   360,   361,   362,   363,   364,   365,   366,     0,
     367,   634,   369,   370,     0,   371,   372,     0,   373,     0,
     374,   375,   376,   377,   378,   379,     0,   380,     0,     0,
     381,   382,   383,     0,     0,   384,   385,     0,   386,     0,
     387,   388,   389,   390,   391,   392,   393,   394,     0,   395,
     396,   397,   398,   399,   400,   401,     0,   635,   403,   404,
     405,   406,   407,   408,   409,   410,   411,   412,   413,   414,
       0,   415,   416,   636,   418,   419,   420,   421,   422,   423,
     424,   425,     0,   426,   427,     0,   428,   429,   430,   431,
     432,   433,   434,   435,   436,   437,   438,     0,   439,   440,
     441,   442,   443,     0,   444,   445,   446,   447,     0,   448,
     449,   450,     0,   451,   452,   453,   454,   455,   456,   457,
     458,   459,   460,   461,     0,   462,   463,     0,   464,   465,
     466,   467,   468,   469,     0,   470,   471,     0,     0,   472,
     473,   474,   475,     0,   476,   477,   478,   479,   480,   481,
     482,     0,     0,   483,   484,   485,   486,   487,     0,     0,
     488,   489,   490,   491,   492,   493,   494,     0,   495,     0,
     496,   497,   498,   499,     0,     0,   500,     0,     0,   501,
     502,   503,   504,   505,   506,   507,   508,   509,   510,   511,
     512,   513,   514,   515,   516,   517,   518,  1742,  4555,   574,
       0,     0,     0,   625,     0,   637,   638,     0,   211,   212,
     213,   214,   215,   216,   217,   218,  1743,   220,   221,   222,
    1744,  1745,  1746,  1747,   223,  1748,  1749,  1750,   224,   225,
    1751,   226,   227,   745,   228,   229,   230,   231,   232,   746,
     233,   234,  1752,   235,   236,   237,   238,   239,  1753,  1754,
     240,   241,   242,   243,   244,  1755,   245,   246,   247,   248,
     249,  1756,   747,  1757,   250,   251,   252,   253,   748,   254,
     255,  1758,   256,   257,   258,   259,   260,   261,  1759,   749,
     262,   263,  1760,  1761,  1762,   750,  1763,  1764,  1765,   264,
     265,   266,   267,   268,   269,   270,   271,   272,  1766,   273,
    1767,   274,   275,   276,   277,   278,  1768,   279,   280,   281,
    1769,  1770,   282,   283,   284,   285,   286,  1771,   287,   288,
     289,  1772,   290,   291,   292,  1773,   293,   294,   295,   296,
     297,   298,   299,   300,   301,  1774,   302,  1775,   303,   304,
     305,   306,  1776,   307,  1777,   308,   751,  1778,   752,   309,
     310,   311,  1779,   312,   313,  1780,   314,  1781,   315,   316,
     317,   318,   319,   753,   320,   321,   322,  1782,   323,   324,
     325,   326,   327,   328,  1783,   329,   754,   330,   331,   332,
     333,   334,   335,   336,  1784,   337,  1785,   338,   755,   756,
     339,   757,   340,   341,   342,   343,   344,  1786,   345,   346,
    1787,   347,   348,   758,   349,   759,  1788,   350,   351,   352,
    1789,  1790,   353,   354,   355,   356,   357,   358,   359,   360,
     361,   362,   363,   364,   365,   366,   760,   367,   368,   369,
     370,  1791,   371,   372,   761,   373,  1792,   374,   375,   376,
     377,   378,   379,  1793,   380,  1794,  1795,   381,   382,   383,
    1796,  1797,   384,   385,   762,   386,   763,   387,   388,   389,
     390,   391,   392,   393,   394,  1798,   395,   396,   397,   398,
     399,   400,   401,  1799,   402,   403,   404,   405,   406,   407,
     408,   409,   410,   411,   412,   413,   414,  1800,   415,   416,
     417,   418,   419,   420,   421,   422,   423,   424,   425,  1801,
     426,   427,   764,   428,   429,   430,   431,   432,   433,   434,
     435,   436,   437,   438,  1802,   439,   440,   441,   442,   443,
    1803,   444,   445,   446,   447,   765,   448,   449,   450,  1804,
     451,   452,   453,   454,   455,   456,   457,   458,   459,   460,
     461,  1805,   462,   463,  1806,   464,   465,   466,   467,   468,
     469,  1807,   470,   471,  1808,  1809,   472,   473,   474,   475,
    1810,   476,   477,   478,   479,   480,   481,   482,  1811,  1812,
     483,   484,   485,   486,   487,  1813,  1814,   488,   489,   490,
     491,   492,   493,   494,  1815,   495,   766,   496,   497,   498,
     499,  1816,  1817,   500,  1818,  1819,   501,   502,   503,   504,
     505,   506,   507,   508,   509,   510,   511,   512,   513,   514,
     515,   516,   517,   518,  1742,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,   211,   212,   213,   214,   215,
     216,   217,   218,  1743,   220,   221,   222,  1744,  1745,  1746,
    1747,   223,  1748,  1749,  1750,   224,   225,  1751,   226,   227,
     745,   228,   229,   230,   231,   232,   746,   233,   234,  1752,
     235,   236,   237,   238,   239,  1753,  1754,   240,   241,   242,
     243,   244,  1755,   245,   246,   247,   248,   249,  1756,   747,
    1757,   250,   251,   252,   253,   748,   254,   255,  1758,   256,
     257,   258,   259,   260,   261,  1759,   749,   262,   263,  1760,
    1761,  1762,   750,  1763,  1764,  1765,   264,   265,   266,   267,
     268,   269,   270,   271,   272,  1766,   273,  1767,   274,   275,
     276,   277,   278,  1768,   279,   280,   281,  1769,  1770,   282,
     283,   284,   285,   286,  1771,   287,   288,   289,  1772,   290,
     291,   292,  1773,   293,   294,   295,   296,   297,   298,   299,
     300,   301,  1774,   302,  1775,   303,   304,   305,   306,  1776,
     307,  1777,   308,   751,  1778,   752,   309,   310,   311,  1779,
     312,   313,  1780,   314,  1781,   315,   316,   317,   318,   319,
     753,   320,   321,   322,  1782,   323,   324,   325,   326,   327,
     328,  1783,   329,   754,   330,   331,   332,   333,   334,   335,
     336,  1784,   337,  1785,   338,   755,   756,   339,   757,   340,
     341,   342,   343,   344,  1786,   345,   346,  1787,   347,   348,
     758,   349,   759,  1788,   350,   351,   352,  1789,  1790,   353,
     354,   355,   356,   357,   358,   359,   360,   361,   362,   363,
     364,   365,   366,   760,   367,   368,   369,   370,  1791,   371,
     372,   761,   373,  1792,   374,   375,   376,   377,   378,   379,
    1793,   380,  1794,  1795,   381,   382,   383,  1796,  1797,   384,
     385,   762,   386,   763,   387,   388,   389,   390,   391,   392,
     393,   394,  1798,   395,   396,   397,   398,   399,   400,   401,
    1799,   402,   403,   404,   405,   406,   407,   408,   409,   410,
     411,   412,   413,   414,  1800,   415,   416,   417,   418,   419,
     420,   421,   422,   423,   424,   425,  1801,   426,   427,   764,
     428,   429,   430,   431,   432,   433,   434,   435,   436,   437,
     438,  1802,   439,   440,   441,   442,   443,  1803,   444,   445,
     446,   447,   765,   448,   449,   450,  1804,   451,   452,   453,
     454,   455,   456,   457,   458,   459,   460,   461,  1805,   462,
     463,  1806,   464,   465,   466,   467,   468,   469,  1807,   470,
     471,  1808,  1809,   472,   473,   474,   475,  1810,   476,   477,
     478,   479,   480,   481,   482,  1811,  1812,   483,   484,   485,
     486,   487,  1813,  1814,   488,   489,   490,   491,   492,   493,
     494,  1815,   495,   766,   496,   497,   498,   499,  1816,  1817,
     500,  1818,  1819,   501,   502,   503,   504,   505,   506,   507,
     508,   509,   510,   511,   512,   513,   514,   515,   516,   517,
     518,  1742,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,   211,   212,   213,   214,  2667,   216,   217,   218,
    1743,   220,   221,   222,  1744,  1745,  1746,  1747,   223,  1748,
    1749,  1750,   224,   225,  1751,   226,   227,   745,   228,   229,
     230,   231,   232,   746,   233,   234,  1752,   235,   236,   237,
     238,   239,  1753,  1754,   240,   241,   242,   243,   244,  1755,
     245,   246,   247,   248,   249,  1756,   747,  1757,   250,   251,
     252,   253,   748,   254,   255,  1758,   256,   257,   258,   259,
     260,   261,  1759,   749,   262,   263,  1760,  1761,  1762,   750,
    1763,  1764,  1765,   264,   265,   266,   267,   268,   269,   270,
     271,   272,  1766,   273,  1767,   274,   275,   276,   277,   278,
    1768,   279,   280,   281,  1769,  1770,   282,   283,   284,  2668,
     286,  1771,   287,   288,   289,  1772,   290,   291,   292,  1773,
     293,   294,   295,   296,   297,   298,   299,   300,   301,  1774,
     302,  1775,   303,   304,   305,   306,  1776,   307,  1777,   308,
     751,  1778,   752,   309,   310,   311,  1779,   312,   313,  1780,
     314,  1781,   315,   316,   317,   318,   319,   753,   320,   321,
     322,  1782,   323,   324,   325,   326,   327,   328,  1783,   329,
     754,   330,   331,   332,   333,   334,   335,   336,  1784,   337,
    1785,   338,   755,   756,   339,   757,   340,   341,   342,   343,
     344,  1786,   345,   346,  1787,   347,   348,   758,   349,   759,
    1788,   350,   351,   352,  1789,  1790,   353,   354,   355,   356,
     357,   358,   359,   360,   361,   362,   363,   364,   365,   366,
     760,   367,   368,   369,   370,  1791,   371,   372,   761,   373,
    1792,   374,   375,   376,   377,   378,   379,  1793,   380,  1794,
    1795,   381,   382,   383,  1796,  1797,   384,   385,   762,   386,
     763,   387,   388,   389,   390,   391,   392,   393,   394,  1798,
     395,   396,   397,   398,   399,   400,   401,  1799,   402,   403,
     404,   405,   406,   407,   408,   409,   410,   411,   412,   413,
     414,  1800,   415,   416,   417,   418,   419,   420,   421,   422,
     423,   424,   425,  1801,   426,   427,   764,   428,   429,   430,
     431,   432,   433,   434,   435,   436,   437,   438,  1802,   439,
     440,   441,   442,   443,  1803,  2669,   445,   446,   447,   765,
     448,   449,   450,  1804,   451,   452,   453,   454,   455,   456,
     457,   458,   459,   460,   461,  1805,   462,   463,  1806,   464,
     465,   466,   467,   468,   469,  1807,   470,   471,  1808,  1809,
     472,   473,   474,   475,  1810,   476,   477,   478,   479,   480,
     481,   482,  1811,  1812,   483,   484,   485,   486,   487,  1813,
    1814,   488,   489,   490,   491,   492,   493,   494,  1815,   495,
     766,   496,   497,   498,   499,  1816,  1817,   500,  1818,  1819,
     501,   502,   503,   504,   505,   506,   507,   508,   509,   510,
     511,   512,   513,   514,   515,   516,   517,   518,   744,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,   211,
     212,   213,   214,   215,   216,   217,   218,     0,   220,   221,
     222,     0,     0,     0,     0,   223,     0,     0,     0,   224,
     225,     0,   226,   227,   745,   228,   229,   230,   231,   232,
     746,   233,   234,     0,   235,   236,   237,   238,   239,     0,
    1043,   240,   241,   242,   243,   244,     0,   245,   246,   247,
     248,  1046,     0,  1047,     0,   250,   251,   252,   253,   748,
     254,   255,     0,   256,   257,   258,   259,   260,   261,     0,
     749,   262,   263,  1048,  1049,  1050,  1051,  1052,  1053,  1054,
     264,   265,   266,   267,   268,   269,   270,   271,   272,     0,
     273,     0,   274,   275,   276,   277,   278,     0,   279,   280,
     281,     0,     0,   282,   283,   284,   285,   286,     0,   287,
     288,   289,     0,   290,   291,   292,     0,   293,   294,   295,
     296,   297,   298,   299,   300,  1059,     0,   302,     0,   303,
     304,   305,   306,     0,   307,     0,   308,   751,     0,   752,
     309,   310,   311,     0,   312,  1062,     0,   314,     0,   315,
     316,   317,   318,   319,   753,   320,   321,   322,     0,   323,
     324,   325,   326,   327,   328,     0,   329,   754,   330,   331,
     332,   333,   334,   335,   336,     0,   337,     0,   338,   755,
     756,   339,   757,   340,   341,   342,   343,   344,     0,   345,
     346,     0,   347,  1066,   758,   349,   759,     0,   350,   351,
     352,  1067,  1068,   353,   354,   355,   356,   357,   358,   359,
     360,   361,   362,   363,   364,   365,   366,   760,   367,   368,
     369,   370,     0,   371,   372,   761,   373,     0,  1073,   375,
     376,   377,   378,   379,     0,   380,     0,     0,   381,   382,
     383,     0,     0,   384,   385,   762,   386,   763,  1076,   388,
     389,   390,   391,   392,   393,   394,     0,   395,  1077,   397,
     398,   399,   400,   401,     0,   402,   403,   404,   405,   406,
     407,   408,   409,   410,   411,   412,   413,   414,     0,   415,
     416,   417,   418,   419,   420,   421,   422,   423,   424,   425,
       0,   426,   427,   764,   428,   429,   430,   431,   432,   433,
     434,   435,   436,   437,   438,     0,   439,   440,   441,   442,
     443,  1080,   444,   445,   446,   447,   765,   448,   449,   450,
       0,   451,   452,   453,   454,   455,   456,   457,   458,   459,
     460,  1082,     0,   462,   463,     0,   464,   465,   466,   467,
     468,   469,     0,   470,   471,     0,     0,   472,  1085,   474,
    1086,     0,   476,   477,   478,   479,   480,   481,   482,     0,
       0,   483,   484,   485,   486,   487,  1089,     0,   488,   489,
     490,   491,   492,   493,   494,     0,   495,   766,   496,   497,
     498,   499,     0,     0,   500,     0,     0,   501,   502,   503,
     504,   505,   506,   507,  1091,  1092,  1093,  1094,  1095,  1096,
    1097,  1098,   516,   517,   518,   787,     0,   574,     0,     0,
       0,     0,     0,     0,     0,     0,   211,   212,   213,   214,
     215,   216,   217,   218,     0,   220,   221,   222,     0,     0,
       0,     0,   223,     0,     0,     0,   224,   225,     0,   226,
     227,   745,   228,   229,   230,   231,   232,   746,   233,   234,
       0,   235,   236,   237,   238,   239,     0,     0,   240,   241,
     242,   243,   244,     0,   245,   246,   247,   248,   249,     0,
     747,     0,   250,   251,   252,   253,   748,   254,   255,     0,
     256,   257,   258,   259,   260,   261,     0,   749,   262,   263,
       0,     0,     0,   750,     0,     0,     0,   264,   265,   266,
     267,   268,   269,   270,   271,   272,     0,   273,     0,   274,
     275,   276,   277,   278,     0,   279,   280,   281,     0,     0,
     282,   283,   284,   285,   286,     0,   287,   288,   289,     0,
     290,   291,   292,     0,   293,   294,   295,   296,   297,   298,
     299,   300,   301,  1538,   302,     0,   303,   304,   305,   306,
       0,   307,     0,   308,   751,     0,   752,   309,   310,   311,
       0,   312,   313,     0,   314,     0,   315,   316,   317,   318,
     319,   753,   320,   321,   322,     0,   323,   324,   325,   326,
     327,   328,     0,   329,   754,   330,   331,   332,   333,   334,
     335,   336,     0,   337,     0,   338,   755,   756,   339,   757,
     340,   341,   342,   343,   344,     0,   345,   346,     0,   347,
     348,   758,   349,   759,     0,   350,   351,   352,     0,     0,
     353,   354,   355,   356,   357,   358,   359,   360,   361,   362,
     363,   364,   365,   366,   760,   367,   368,   369,   370,     0,
     371,   372,   761,   373,     0,   374,   375,   376,   377,   378,
     379,     0,   380,  1539,     0,   381,   382,   383,     0,     0,
     384,   385,   762,   386,   763,   387,   388,   389,   390,   391,
     392,   393,   394,     0,   395,   396,   397,   398,   399,   400,
     401,     0,   402,   403,   404,   405,   406,   407,   408,   409,
     410,   411,   412,   413,   414,     0,   415,   416,   417,   418,
     419,   420,   421,   422,   423,   424,   425,     0,   426,   427,
     764,   428,   429,   430,   431,   432,   433,   434,   435,   436,
     437,   438,     0,   439,   440,   441,   442,   443,     0,   444,
     445,   446,   447,   765,   448,   449,   450,     0,   451,   452,
     453,   454,   455,   456,   457,   458,   459,   460,   461,     0,
     462,   463,     0,   464,   465,   466,   467,   468,   469,     0,
     470,   471,     0,     0,   472,   473,   474,   475,  1540,   476,
     477,   478,   479,   480,   481,   482,     0,     0,   483,   484,
     485,   486,   487,     0,     0,   488,   489,   490,   491,   492,
     493,   494,     0,   495,   766,   496,   497,   498,   499,     0,
       0,   500,     0,     0,   501,   502,   503,   504,   505,   506,
     507,   508,   509,   510,   511,   512,   513,   514,   515,   516,
     517,   518,   787,     0,   574,     0,     0,     0,     0,     0,
       0,     0,     0,   211,   212,   213,   214,   215,   216,   217,
     218,     0,   220,   221,   222,     0,     0,     0,     0,   223,
       0,     0,     0,   224,   225,     0,   226,   227,   745,   228,
     229,   230,   231,   232,   746,   233,   234,     0,   235,   236,
     237,   238,   239,     0,     0,   240,   241,   242,   243,   244,
       0,   245,   246,   247,   248,   249,     0,   747,     0,   250,
     251,   252,   253,   748,   254,   255,     0,   256,   257,   258,
     259,   260,   261,     0,   749,   262,   263,     0,     0,     0,
     750,     0,     0,     0,   264,   265,   266,   267,   268,   269,
     270,   271,   272,  1717,   273,     0,   274,   275,   276,   277,
     278,     0,   279,   280,   281,     0,     0,   282,   283,   284,
     285,   286,     0,   287,   288,   289,     0,   290,   291,   292,
       0,   293,   294,   295,   296,   297,   298,   299,   300,   301,
       0,   302,     0,   303,   304,   305,   306,     0,   307,     0,
     308,   751,     0,   752,   309,   310,   311,     0,   312,   313,
       0,   314,     0,   315,   316,   317,   318,   319,   753,   320,
     321,   322,     0,   323,   324,   325,   326,   327,   328,     0,
     329,   754,   330,   331,   332,   333,   334,   335,   336,     0,
     337,     0,   338,   755,   756,   339,   757,   340,   341,   342,
     343,   344,     0,   345,   346,     0,   347,   348,   758,   349,
     759,     0,   350,   351,   352,     0,     0,   353,   354,   355,
     356,   357,   358,   359,   360,   361,   362,   363,   364,   365,
     366,   760,   367,   368,   369,   370,     0,   371,   372,   761,
     373,     0,   374,   375,   376,   377,   378,   379,     0,   380,
       0,     0,   381,   382,   383,     0,     0,   384,   385,   762,
     386,   763,   387,   388,   389,   390,   391,   392,   393,   394,
       0,   395,   396,   397,   398,   399,   400,   401,     0,   402,
     403,   404,   405,   406,   407,   408,   409,   410,   411,   412,
     413,   414,     0,   415,   416,   417,   418,   419,   420,   421,
     422,   423,   424,   425,     0,   426,   427,   764,   428,   429,
     430,   431,   432,   433,   434,   435,   436,   437,   438,     0,
     439,   440,   441,   442,   443,     0,   444,   445,   446,   447,
     765,   448,   449,   450,     0,   451,   452,   453,   454,   455,
     456,   457,   458,   459,   460,   461,     0,   462,   463,     0,
     464,   465,   466,   467,   468,   469,     0,   470,   471,     0,
       0,   472,   473,   474,   475,     0,   476,   477,   478,   479,
     480,   481,   482,     0,     0,   483,   484,   485,   486,   487,
       0,     0,   488,   489,   490,   491,   492,   493,   494,     0,
     495,   766,   496,   497,   498,   499,     0,     0,   500,     0,
       0,   501,   502,   503,   504,   505,   506,   507,   508,   509,
     510,   511,   512,   513,   514,   515,   516,   517,   518,   787,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
     211,   212,   213,   214,   215,   216,   217,   218,     0,   220,
     221,   222,     0,     0,     0,     0,   223,     0,     0,     0,
     224,   225,     0,   226,   227,   745,   228,   229,   230,   231,
     232,   746,   233,   234,     0,   235,   236,   237,   238,   239,
       0,     0,   240,   241,   242,   243,   244,     0,   245,   246,
     247,   248,   249,     0,   747,     0,   250,   251,   252,   253,
     748,   254,   255,     0,   256,   257,   258,   259,   260,   261,
       0,   749,   262,   263,     0,     0,     0,   750,     0,     0,
    2092,   264,   265,   266,   267,   268,   269,   270,   271,   272,
       0,   273,     0,   274,   275,   276,   277,   278,     0,   279,
     280,   281,     0,     0,   282,   283,   284,   285,   286,     0,
     287,   288,   289,     0,   290,   291,   292,     0,   293,   294,
     295,   296,   297,   298,   299,   300,   301,     0,   302,     0,
     303,   304,   305,   306,     0,   307,     0,   308,   751,     0,
     752,   309,   310,   311,     0,   312,   313,     0,   314,     0,
     315,   316,   317,   318,   319,   753,   320,   321,   322,     0,
     323,   324,   325,   326,   327,   328,     0,   329,   754,   330,
     331,   332,   333,   334,   335,   336,     0,   337,     0,   338,
     755,   756,   339,   757,   340,   341,   342,   343,   344,     0,
     345,   346,     0,   347,   348,   758,   349,   759,     0,   350,
     351,   352,     0,     0,   353,   354,   355,   356,   357,   358,
     359,   360,   361,   362,   363,   364,   365,   366,   760,   367,
     368,   369,   370,     0,   371,   372,   761,   373,     0,   374,
     375,   376,   377,   378,   379,     0,   380,     0,     0,   381,
     382,   383,     0,     0,   384,   385,   762,   386,   763,   387,
     388,   389,   390,   391,   392,   393,   394,     0,   395,   396,
     397,   398,   399,   400,   401,     0,   402,   403,   404,   405,
     406,   407,   408,   409,   410,   411,   412,   413,   414,     0,
     415,   416,   417,   418,   419,   420,   421,   422,   423,   424,
     425,     0,   426,   427,   764,   428,   429,   430,   431,   432,
     433,   434,   435,   436,   437,   438,     0,   439,   440,   441,
     442,   443,     0,   444,   445,   446,   447,   765,   448,   449,
     450,     0,   451,   452,   453,   454,   455,   456,   457,   458,
     459,   460,   461,     0,   462,   463,     0,   464,   465,   466,
     467,   468,   469,     0,   470,   471,     0,     0,   472,   473,
     474,   475,     0,   476,   477,   478,   479,   480,   481,   482,
       0,     0,   483,   484,   485,   486,   487,  2093,     0,   488,
     489,   490,   491,   492,   493,   494,     0,   495,   766,   496,
     497,   498,   499,     0,     0,   500,     0,     0,   501,   502,
     503,   504,   505,   506,   507,   508,   509,   510,   511,   512,
     513,   514,   515,   516,   517,   518,   787,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,   211,   212,   213,
     214,   215,   216,   217,   218,     0,   220,   221,   222,     3,
       4,     0,     0,   223,     0,     0,     0,   224,   225,     0,
     226,   227,   745,   228,   229,   230,   231,   232,   746,   233,
     234,     0,   235,   236,   237,   238,   239,     0,     0,   240,
     241,   242,   243,   244,     0,   245,   246,   247,   248,   249,
       0,   747,     0,   250,   251,   252,   253,   748,   254,   255,
       0,   256,   257,   258,   259,   260,   261,     0,   749,   262,
     263,     0,     0,     0,   750,     0,     0,     0,   264,   265,
     266,   267,   268,   269,   270,   271,   272,     0,   273,     0,
     274,   275,   276,   277,   278,     0,   279,   280,   281,     0,
       0,   282,   283,   284,   285,   286,     0,   287,   288,   289,
       0,   290,   291,   292,     0,   293,   294,   295,   296,   297,
     298,   299,   300,   301,     0,   302,     0,   303,   304,   305,
     306,     0,   307,     0,   308,   751,     0,   752,   309,   310,
     311,     0,   312,   313,     0,   314,     0,   315,   316,   317,
     318,   319,   753,   320,   321,   322,     0,   323,   324,   325,
     326,   327,   328,     0,   329,   754,   330,   331,   332,   333,
     334,   335,   336,     0,   337,     0,   338,   755,   756,   339,
     757,   340,   341,   342,   343,   344,     0,   345,   346,     0,
     347,   348,   758,   349,   759,     0,   350,   351,   352,     0,
       0,   353,   354,   355,   356,   357,   358,   359,   360,   361,
     362,   363,   364,   365,   366,   760,   367,   368,   369,   370,
       0,   371,   372,   761,   373,     0,   374,   375,   376,   377,
     378,   379,     0,   380,     0,     0,   381,   382,   383,     0,
       0,   384,   385,   762,   386,   763,   387,   388,   389,   390,
     391,   392,   393,   394,     0,   395,   396,   397,   398,   399,
     400,   401,     0,   402,   403,   404,   405,   406,   407,   408,
     409,   410,   411,   412,   413,   414,     0,   415,   416,   417,
     418,   419,   420,   421,   422,   423,   424,   425,     0,   426,
     427,   764,   428,   429,   430,   431,   432,   433,   434,   435,
     436,   437,   438,     0,   439,   440,   441,   442,   443,     0,
     444,   445,   446,   447,   765,   448,   449,   450,     0,   451,
     452,   453,   454,   455,   456,   457,   458,   459,   460,   461,
       0,   462,   463,     0,   464,   465,   466,   467,   468,   469,
       0,   470,   471,     0,     0,   472,   473,   474,   475,     0,
     476,   477,   478,   479,   480,   481,   482,     0,     0,   483,
     484,   485,   486,   487,     0,     0,   488,   489,   490,   491,
     492,   493,   494,     0,   495,   766,   496,   497,   498,   499,
       0,     0,   500,     0,     0,   501,   502,   503,   504,   505,
     506,   507,   508,   509,   510,   511,   512,   513,   514,   515,
     516,   517,   518,   787,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,   211,   212,   213,   214,   215,   216,
     217,   218,   814,   220,   221,   222,     0,     0,     0,     0,
     223,     0,     0,     0,   224,   225,     0,   226,   227,   745,
     228,   229,   230,   231,   232,   746,   233,   234,     0,   235,
     236,   237,   238,   239,     0,     0,   240,   241,   242,   243,
     244,     0,   245,   246,   247,   248,   249,     0,   747,     0,
     250,   251,   252,   253,   748,   254,   255,     0,   256,   257,
     258,   259,   260,   261,     0,   749,   262,   263,     0,     0,
       0,   750,     0,     0,     0,   264,   265,   266,   267,   268,
     269,   270,   271,   272,     0,   273,     0,   274,   275,   276,
     277,   278,     0,   279,   280,   281,     0,     0,   282,   283,
     284,   285,   286,     0,   287,   288,   289,     0,   290,   291,
     292,     0,   293,   294,   295,   296,   297,   298,   299,   300,
     301,     0,   302,     0,   303,   304,   305,   306,     0,   307,
       0,   308,   751,     0,   752,   309,   310,   311,     0,   312,
     313,     0,   314,     0,   315,   316,   317,   318,   319,   753,
     320,   321,   322,     0,   323,   324,   325,   326,   327,   328,
       0,   329,   754,   330,   331,   332,   333,   334,   335,   336,
       0,   337,     0,   338,   755,   756,   339,   757,   340,   341,
     342,   343,   344,     0,   345,   346,     0,   347,   348,   758,
     349,   759,     0,   350,   351,   352,     0,     0,   353,   354,
     355,   356,   357,   358,   359,   360,   361,   362,   363,   364,
     365,   366,   760,   367,   368,   369,   370,     0,   371,   372,
     761,   373,     0,   374,   375,   376,   377,   378,   379,     0,
     380,     0,     0,   381,   382,   383,     0,     0,   384,   385,
     762,   386,   763,   387,   388,   389,   390,   391,   392,   393,
     394,     0,   395,   396,   397,   398,   399,   400,   401,     0,
     402,   403,   404,   405,   406,   407,   408,   409,   410,   411,
     412,   413,   414,     0,   415,   416,   417,   418,   419,   420,
     421,   422,   423,   424,   425,     0,   426,   427,   764,   428,
     429,   430,   431,   432,   433,   434,   435,   436,   437,   438,
       0,   439,   440,   441,   442,   443,     0,   444,   445,   446,
     447,   765,   448,   449,   450,     0,   451,   452,   453,   454,
     455,   456,   457,   458,   459,   460,   461,     0,   462,   463,
       0,   464,   465,   466,   467,   468,   469,     0,   470,   471,
       0,     0,   472,   473,   474,   475,     0,   476,   477,   478,
     479,   480,   481,   482,     0,     0,   483,   484,   485,   486,
     487,     0,     0,   488,   489,   490,   491,   492,   493,   494,
       0,   495,   766,   496,   497,   498,   499,     0,     0,   500,
       0,     0,   501,   502,   503,   504,   505,   506,   507,   508,
     509,   510,   511,   512,   513,   514,   515,   516,   517,   518,
     787,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,   211,   212,   213,   214,   215,   216,   217,   218,   830,
     220,   221,   222,     0,     0,     0,     0,   223,     0,     0,
       0,   224,   225,     0,   226,   227,   745,   228,   229,   230,
     231,   232,   746,   233,   234,     0,   235,   236,   237,   238,
     239,     0,     0,   240,   241,   242,   243,   244,     0,   245,
     246,   247,   248,   249,     0,   747,     0,   250,   251,   252,
     253,   748,   254,   255,     0,   256,   257,   258,   259,   260,
     261,     0,   749,   262,   263,     0,     0,     0,   750,     0,
       0,     0,   264,   265,   266,   267,   268,   269,   270,   271,
     272,     0,   273,     0,   274,   275,   276,   277,   278,     0,
     279,   280,   281,     0,     0,   282,   283,   284,   285,   286,
       0,   287,   288,   289,     0,   290,   291,   292,     0,   293,
     294,   295,   296,   297,   298,   299,   300,   301,     0,   302,
       0,   303,   304,   305,   306,     0,   307,     0,   308,   751,
       0,   752,   309,   310,   311,     0,   312,   313,     0,   314,
       0,   315,   316,   317,   318,   319,   753,   320,   321,   322,
       0,   323,   324,   325,   326,   327,   328,     0,   329,   754,
     330,   331,   332,   333,   334,   335,   336,     0,   337,     0,
     338,   755,   756,   339,   757,   340,   341,   342,   343,   344,
       0,   345,   346,     0,   347,   348,   758,   349,   759,     0,
     350,   351,   352,     0,     0,   353,   354,   831,   356,   357,
     358,   359,   360,   361,   362,   363,   364,   365,   366,   760,
     367,   368,   369,   370,     0,   371,   372,   761,   373,     0,
     374,   375,   376,   377,   378,   379,     0,   380,     0,     0,
     381,   382,   383,     0,     0,   384,   385,   762,   386,   763,
     387,   388,   389,   390,   391,   392,   393,   394,     0,   395,
     396,   397,   398,   399,   400,   401,     0,   402,   403,   404,
     405,   406,   407,   408,   409,   410,   411,   412,   413,   414,
       0,   415,   416,   417,   418,   419,   420,   421,   422,   423,
     424,   425,     0,   426,   427,   764,   428,   429,   430,   431,
     432,   433,   434,   435,   436,   437,   438,     0,   439,   440,
     441,   442,   443,     0,   444,   445,   446,   447,   765,   448,
     449,   450,     0,   451,   452,   453,   454,   455,   456,   457,
     458,   459,   460,   461,     0,   462,   463,     0,   464,   465,
     466,   467,   468,   469,     0,   470,   471,     0,     0,   472,
     473,   474,   475,     0,   476,   477,   478,   479,   480,   481,
     482,     0,     0,   483,   484,   485,   486,   487,     0,     0,
     488,   489,   490,   491,   492,   493,   494,     0,   495,   766,
     496,   497,   498,   499,     0,     0,   500,     0,     0,   501,
     502,   503,   504,   505,   506,   507,   508,   509,   510,   511,
     512,   513,   514,   515,   516,   517,   518,   787,     0,   574,
       0,     0,     0,     0,     0,     0,     0,     0,   211,   212,
     213,   214,   215,   216,   217,   218,     0,   220,   221,   222,
       0,     0,     0,     0,   223,     0,     0,     0,   224,   225,
       0,   226,   227,   745,   228,   229,   230,   231,   232,   746,
     233,   234,     0,   235,   236,   237,   238,   239,     0,     0,
     240,   241,   242,   243,   244,     0,   245,   246,   247,   248,
     249,     0,   747,     0,   250,   251,   252,   253,   748,   254,
     255,     0,   256,   257,   258,   259,   260,   261,     0,   749,
     262,   263,     0,     0,     0,   750,     0,     0,     0,   264,
     265,   266,   267,   268,   269,   270,   271,   272,     0,   273,
       0,   274,   275,   276,   277,   278,     0,   279,   280,   281,
       0,     0,   282,   283,   284,   285,   286,     0,   287,   288,
     289,     0,   290,   291,   292,     0,   293,   294,   295,   296,
     297,   298,   299,   300,   301,     0,   302,     0,   303,   304,
     305,   306,     0,   307,     0,   308,   751,     0,   752,   309,
     310,   311,     0,   312,   313,     0,   314,     0,   315,   316,
     317,   318,   319,   753,   320,   321,   322,     0,   323,   324,
     325,   326,   327,   328,     0,   329,   754,   330,   331,   332,
     333,   334,   335,   336,     0,   337,     0,   338,   755,   756,
     339,   757,   340,   341,   342,   343,   344,     0,   345,   346,
       0,   347,   348,   758,   349,   759,     0,   350,   351,   352,
       0,     0,   353,   354,   355,   356,   357,   358,   359,   360,
     361,   362,   363,   364,   365,   366,   760,   367,   368,   369,
     370,     0,   371,   372,   761,   373,     0,   374,   375,   376,
     377,   378,   379,     0,   380,     0,     0,   381,   382,   383,
       0,     0,   384,   385,   762,   386,   763,   387,   388,   389,
     390,   391,   392,   393,   394,     0,   395,   396,   397,   398,
     399,   400,   401,     0,   402,   403,   404,   405,   406,   407,
     408,   409,   410,   411,   412,   413,   414,     0,   415,   416,
     417,   418,   419,   420,   421,   422,   423,   424,   425,     0,
     426,   427,   764,   428,   429,   430,   431,   432,   433,   434,
     435,   436,   437,   438,     0,   439,   440,   441,   442,   443,
       0,   444,   445,   446,   447,   765,   448,   449,   450,     0,
     451,   452,   453,   454,   455,   456,   457,   458,   459,   460,
     461,     0,   462,   463,     0,   464,   465,   466,   467,   468,
     469,     0,   470,   471,     0,     0,   472,   473,   474,   475,
       0,   476,   477,   478,   479,   480,   481,   482,     0,     0,
     483,   484,   485,   486,   487,     0,     0,   488,   489,   490,
     491,   492,   493,   494,     0,   495,   766,   496,   497,   498,
     499,     0,     0,   500,     0,     0,   501,   502,   503,   504,
     505,   506,   507,   508,   509,   510,   511,   512,   513,   514,
     515,   516,   517,   518,   787,     0,   574,     0,     0,     0,
       0,     0,     0,     0,     0,   211,   212,   213,   214,   215,
     216,   217,   218,     0,   220,   221,   222,     0,     0,     0,
       0,   223,     0,     0,     0,   224,   225,     0,   226,   227,
     745,   228,   229,   230,   231,   232,   746,   233,   234,     0,
     235,   236,   237,   238,   239,     0,     0,   240,   241,   242,
     243,   244,     0,   245,   246,   247,   248,   249,     0,   747,
       0,   250,   251,   252,   253,   748,   254,   255,     0,   256,
     257,   258,   259,   260,   261,     0,   749,   262,   263,     0,
       0,     0,   750,     0,     0,     0,   264,   265,   266,   267,
     268,   269,   270,   271,   272,     0,   273,     0,   274,   275,
     276,   277,   278,     0,   279,   280,   281,     0,     0,   282,
     283,   284,   285,   286,     0,   287,   288,   289,     0,   290,
     291,   292,     0,   293,   294,   295,   296,   297,   298,   299,
     300,   301,     0,   302,     0,   303,   304,   305,   306,     0,
     307,     0,   308,   751,     0,   752,   309,   310,   311,     0,
     312,   313,     0,   314,     0,   315,   316,   317,   318,  1528,
     753,   320,   321,   322,     0,   323,   324,   325,   326,   327,
     328,     0,   329,   754,   330,   331,   332,   333,   334,   335,
     336,     0,   337,     0,   338,   755,   756,   339,   757,   340,
     341,   342,   343,   344,     0,   345,   346,     0,   347,   348,
     758,   349,   759,     0,   350,   351,   352,     0,     0,   353,
     354,   355,   356,   357,   358,   359,   360,   361,   362,   363,
     364,   365,   366,   760,   367,   368,   369,   370,     0,   371,
     372,   761,   373,     0,   374,   375,   376,   377,   378,   379,
       0,   380,     0,     0,   381,   382,   383,     0,     0,   384,
     385,   762,   386,   763,   387,   388,   389,   390,   391,   392,
     393,   394,     0,   395,   396,   397,   398,   399,   400,   401,
       0,   402,   403,   404,   405,   406,   407,   408,   409,   410,
     411,   412,   413,   414,     0,   415,   416,   417,   418,   419,
     420,   421,   422,   423,   424,   425,     0,   426,   427,   764,
     428,   429,   430,   431,   432,   433,   434,   435,   436,   437,
     438,     0,   439,   440,   441,   442,   443,     0,   444,   445,
     446,   447,   765,   448,   449,   450,     0,   451,   452,   453,
     454,   455,   456,   457,   458,   459,   460,   461,     0,   462,
     463,     0,   464,   465,   466,   467,   468,   469,     0,   470,
     471,     0,     0,   472,   473,   474,   475,     0,   476,   477,
     478,   479,   480,   481,   482,     0,     0,   483,   484,   485,
     486,   487,     0,     0,   488,   489,   490,   491,   492,   493,
     494,     0,   495,   766,   496,   497,   498,   499,     0,     0,
     500,     0,     0,   501,   502,   503,   504,   505,   506,   507,
     508,   509,   510,   511,   512,   513,   514,   515,   516,   517,
     518,   787,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,   211,   212,   213,   214,   215,   216,   217,   218,
       0,   220,   221,   222,     0,     0,     0,     0,   223,     0,
       0,     0,   224,   225,     0,   226,   227,   745,   228,   229,
     230,   231,   232,   746,   233,   234,     0,   235,   236,   237,
     238,   239,     0,     0,   240,   241,   242,   243,   244,     0,
     245,   246,   247,   248,   249,     0,   747,     0,   250,   251,
     252,   253,   748,   254,   255,     0,   256,   257,   258,   259,
     260,   261,     0,   749,   262,   263,     0,     0,     0,   750,
       0,     0,     0,   264,   265,   266,   267,   268,   269,   270,
     271,   272,     0,   273,     0,   274,   275,   276,   277,   278,
       0,   279,   280,   281,     0,     0,   282,   283,   284,   285,
     286,     0,   287,   288,   289,     0,   290,   291,   292,     0,
     293,   294,   295,   296,   297,   298,   299,   300,   301,     0,
     302,     0,   303,   304,   305,   306,     0,   307,     0,   308,
     751,     0,   752,   309,   310,   311,     0,   312,   313,  2940,
     314,     0,   315,   316,   317,   318,   319,   753,   320,   321,
     322,     0,   323,   324,   325,   326,   327,   328,     0,   329,
     754,   330,   331,   332,   333,   334,   335,   336,     0,   337,
       0,   338,   755,   756,   339,   757,   340,   341,   342,   343,
     344,     0,   345,   346,     0,   347,   348,   758,   349,   759,
       0,   350,   351,   352,     0,     0,   353,   354,   355,   356,
     357,   358,   359,   360,   361,   362,   363,   364,   365,   366,
     760,   367,   368,   369,   370,     0,   371,   372,   761,   373,
       0,   374,   375,   376,   377,   378,   379,     0,   380,     0,
       0,   381,   382,   383,     0,     0,   384,   385,   762,   386,
     763,   387,   388,   389,   390,   391,   392,   393,   394,     0,
     395,   396,   397,   398,   399,   400,   401,     0,   402,   403,
     404,   405,   406,   407,   408,   409,   410,   411,   412,   413,
     414,     0,   415,   416,   417,   418,   419,   420,   421,   422,
     423,   424,   425,     0,   426,   427,   764,   428,   429,   430,
     431,   432,   433,   434,   435,   436,   437,   438,     0,   439,
     440,   441,   442,   443,     0,   444,   445,   446,   447,   765,
     448,   449,   450,     0,   451,   452,   453,   454,   455,   456,
     457,   458,   459,   460,   461,     0,   462,   463,     0,   464,
     465,   466,   467,   468,   469,     0,   470,   471,     0,     0,
     472,   473,   474,   475,     0,   476,   477,   478,   479,   480,
     481,   482,     0,     0,   483,   484,   485,   486,   487,     0,
       0,   488,   489,   490,   491,   492,   493,   494,     0,   495,
     766,   496,   497,   498,   499,     0,     0,   500,     0,     0,
     501,   502,   503,   504,   505,   506,   507,   508,   509,   510,
     511,   512,   513,   514,   515,   516,   517,   518,   744,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,   211,
     212,   213,   214,   215,   216,   217,   218,     0,   220,   221,
     222,     0,     0,     0,     0,   223,     0,     0,     0,   224,
     225,     0,   226,   227,   745,   228,   229,   230,   231,   232,
     746,   233,   234,     0,   235,   236,   237,   238,   239,     0,
       0,   240,   241,   242,   243,   244,     0,   245,   246,   247,
     248,   249,     0,   747,     0,   250,   251,   252,   253,   748,
     254,   255,     0,   256,   257,   258,   259,   260,   261,     0,
     749,   262,   263,     0,     0,     0,   750,     0,     0,     0,
     264,   265,   266,   267,   268,   269,   270,   271,   272,     0,
     273,     0,   274,   275,   276,   277,   278,     0,   279,   280,
     281,     0,     0,   282,   283,   284,   285,   286,     0,   287,
     288,   289,     0,   290,   291,   292,     0,   293,   294,   295,
     296,   297,   298,   299,   300,   301,     0,   302,     0,   303,
     304,   305,   306,     0,   307,     0,   308,   751,     0,   752,
     309,   310,   311,     0,   312,   313,     0,   314,     0,   315,
     316,   317,   318,   319,   753,   320,   321,   322,     0,   323,
     324,   325,   326,   327,   328,     0,   329,   754,   330,   331,
     332,   333,   334,   335,   336,     0,   337,     0,   338,   755,
     756,   339,   757,   340,   341,   342,   343,   344,     0,   345,
     346,     0,   347,   348,   758,   349,   759,     0,   350,   351,
     352,     0,     0,   353,   354,   355,   356,   357,   358,   359,
     360,   361,   362,   363,   364,   365,   366,   760,   367,   368,
     369,   370,     0,   371,   372,   761,   373,     0,   374,   375,
     376,   377,   378,   379,     0,   380,     0,     0,   381,   382,
     383,     0,     0,   384,   385,   762,   386,   763,   387,   388,
     389,   390,   391,   392,   393,   394,     0,   395,   396,   397,
     398,   399,   400,   401,     0,   402,   403,   404,   405,   406,
     407,   408,   409,   410,   411,   412,   413,   414,     0,   415,
     416,   417,   418,   419,   420,   421,   422,   423,   424,   425,
       0,   426,   427,   764,   428,   429,   430,   431,   432,   433,
     434,   435,   436,   437,   438,     0,   439,   440,   441,   442,
     443,     0,   444,   445,   446,   447,   765,   448,   449,   450,
       0,   451,   452,   453,   454,   455,   456,   457,   458,   459,
     460,   461,     0,   462,   463,     0,   464,   465,   466,   467,
     468,   469,     0,   470,   471,     0,     0,   472,   473,   474,
     475,     0,   476,   477,   478,   479,   480,   481,   482,     0,
       0,   483,   484,   485,   486,   487,     0,     0,   488,   489,
     490,   491,   492,   493,   494,     0,   495,   766,   496,   497,
     498,   499,     0,     0,   500,     0,     0,   501,   502,   503,
     504,   505,   506,   507,   508,   509,   510,   511,   512,   513,
     514,   515,   516,   517,   518,   787,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,   211,   212,   213,   214,
     215,   216,   217,   218,     0,   220,   221,   222,     0,     0,
       0,     0,   223,     0,     0,     0,   224,   225,     0,   226,
     227,   745,   228,   229,   230,   231,   232,   746,   233,   234,
       0,   235,   236,   237,   238,   239,     0,     0,   240,   241,
     242,   243,   244,     0,   245,   246,   247,   248,   249,     0,
     747,     0,   250,   251,   252,   253,   748,   254,   255,     0,
     256,   257,   258,   259,   260,   261,     0,   749,   262,   263,
       0,     0,     0,   750,     0,     0,     0,   264,   265,   266,
     267,   268,   269,   270,   271,   272,     0,   273,     0,   274,
     275,   276,   277,   278,     0,   279,   280,   281,     0,     0,
     282,   283,   284,   285,   286,     0,   287,   288,   289,     0,
     290,   291,   292,     0,   293,   294,   295,   296,   297,   298,
     299,   300,   301,     0,   302,     0,   303,   304,   305,   306,
       0,   307,     0,   308,   751,     0,   752,   309,   310,   311,
       0,   312,   313,     0,   314,     0,   315,   316,   317,   318,
     319,   753,   320,   321,   322,     0,   323,   324,   325,   326,
     327,   328,     0,   329,   754,   330,   331,   332,   333,   334,
     335,   336,     0,   337,     0,   338,   755,   756,   339,   757,
     340,   341,   342,   343,   344,     0,   345,   346,     0,   347,
     348,   758,   349,   759,     0,   350,   351,   352,     0,     0,
     353,   354,   355,   356,   357,   358,   359,   360,   361,   362,
     363,   364,   365,   366,   760,   367,   368,   369,   370,     0,
     371,   372,   761,   373,     0,   374,   375,   376,   377,   378,
     379,     0,   380,     0,     0,   381,   382,   383,     0,     0,
     384,   385,   762,   386,   763,   387,   388,   389,   390,   391,
     392,   393,   394,     0,   395,   396,   397,   398,   399,   400,
     401,     0,   402,   403,   404,   405,   406,   407,   408,   409,
     410,   411,   412,   413,   414,     0,   415,   416,   417,   418,
     419,   420,   421,   422,   423,   424,   425,     0,   426,   427,
     764,   428,   429,   430,   431,   432,   433,   434,   435,   436,
     437,   438,     0,   439,   440,   441,   442,   443,     0,   444,
     445,   446,   447,   765,   448,   449,   450,     0,   451,   452,
     453,   454,   455,   456,   457,   458,   459,   460,   461,     0,
     462,   463,     0,   464,   465,   466,   467,   468,   469,     0,
     470,   471,     0,     0,   472,   473,   474,   475,     0,   476,
     477,   478,   479,   480,   481,   482,     0,     0,   483,   484,
     485,   486,   487,     0,     0,   488,   489,   490,   491,   492,
     493,   494,     0,   495,   766,   496,   497,   498,   499,     0,
       0,   500,     0,     0,   501,   502,   503,   504,   505,   506,
     507,   508,   509,   510,   511,   512,   513,   514,   515,   516,
     517,   518,   787,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,   211,   212,   213,   214,   215,   216,   217,
     218,     0,   220,   221,   222,     0,     0,     0,     0,   223,
       0,     0,     0,   224,   225,     0,   226,   227,   745,   228,
     229,   230,   231,   232,   746,   233,   234,     0,   235,   236,
     237,   238,   239,     0,     0,   240,   241,   242,   243,   244,
       0,   245,   246,   247,   248,   249,     0,   747,     0,   250,
     251,   252,   253,   748,   254,   255,     0,   256,   257,   258,
     259,   260,   261,     0,   749,   262,   263,     0,     0,     0,
     750,     0,     0,     0,   264,   265,   266,   267,   268,   269,
     270,   271,   272,     0,   273,     0,   274,   275,   276,   277,
     278,     0,   279,   280,   281,     0,     0,   282,   283,   284,
     285,   286,     0,   287,   288,   289,     0,   290,   291,   292,
       0,   293,   294,   295,   296,   297,   298,   299,   300,   301,
       0,   302,     0,   303,   304,   305,   306,     0,   307,     0,
     308,   751,     0,   752,   309,   310,   311,     0,   312,   313,
       0,   314,     0,   315,   316,   317,   318,   319,   753,   320,
     321,   322,     0,   323,   324,   325,   326,   327,   328,     0,
     329,   754,   330,   331,   332,   333,   334,   335,   336,     0,
     337,     0,   338,   755,   756,   339,   757,   340,   341,   342,
     343,   344,     0,   345,   346,     0,   347,   348,   758,   349,
     759,     0,   350,   351,   352,     0,     0,   353,   354,   908,
     356,   357,   358,   359,   360,   361,   362,   363,   364,   365,
     366,   760,   367,   368,   369,   370,     0,   371,   372,   761,
     373,     0,   374,   375,   376,   377,   378,   379,     0,   380,
       0,     0,   381,   382,   383,     0,     0,   384,   385,   762,
     386,   763,   387,   388,   389,   390,   391,   392,   393,   394,
       0,   395,   396,   397,   398,   399,   400,   401,     0,   402,
     403,   404,   405,   406,   407,   408,   409,   410,   411,   412,
     413,   414,     0,   415,   416,   417,   418,   419,   420,   421,
     422,   423,   424,   425,     0,   426,   427,   764,   428,   429,
     430,   431,   432,   433,   434,   435,   436,   437,   438,     0,
     439,   440,   441,   442,   443,     0,   444,   445,   446,   447,
     765,   448,   449,   450,     0,   451,   452,   453,   454,   455,
     456,   457,   458,   459,   460,   461,     0,   462,   463,     0,
     464,   465,   466,   467,   468,   469,     0,   470,   471,     0,
       0,   472,   473,   474,   475,     0,   476,   477,   478,   479,
     480,   481,   482,     0,     0,   483,   484,   485,   486,   487,
       0,     0,   488,   489,   490,   491,   492,   493,   494,     0,
     495,   766,   496,   497,   498,   499,     0,     0,   500,     0,
       0,   501,   502,   503,   504,   505,   506,   507,   508,   509,
     510,   511,   512,   513,   514,   515,   516,   517,   518,   744,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
     211,   212,   213,   214,   215,   216,   217,   218,     0,   220,
     221,   222,     0,     0,     0,     0,   223,     0,     0,     0,
     224,   225,     0,   226,   227,   745,   228,   229,   230,   231,
     232,   746,   233,   234,     0,   235,   236,   237,   238,   239,
       0,     0,   240,   241,   242,   243,   244,     0,   245,   246,
     247,   248,   249,     0,   747,     0,   250,   251,   252,   253,
     748,   254,   255,     0,   256,   257,   258,   259,   260,   261,
       0,   749,   262,   263,     0,     0,     0,   750,     0,     0,
       0,   264,   265,   266,   267,   268,   269,   270,   271,   272,
       0,   273,     0,   274,   275,   276,   277,   278,     0,   279,
     280,   281,     0,     0,   282,   283,   284,   285,   286,     0,
     287,   288,   289,     0,   290,   291,   292,     0,   293,   294,
     295,   296,   297,   298,   299,   300,   301,     0,   302,     0,
     303,   304,   305,   306,     0,   307,     0,   308,   751,     0,
     752,   309,   310,   311,     0,   312,   313,     0,   314,     0,
     315,   316,   317,   318,   928,   753,   320,   321,   322,     0,
     323,   324,   325,   326,   327,   328,     0,   329,   754,   330,
     331,   332,   333,   334,   335,   336,     0,   337,     0,   338,
     755,   756,   339,   757,   340,   341,   342,   343,   344,     0,
     345,   346,     0,   347,   348,   758,   349,   759,     0,   350,
     351,   352,     0,     0,   353,   354,   355,   356,   357,   358,
     359,   360,   361,   362,   363,   364,   365,   366,   760,   367,
     368,   369,   370,     0,   371,   372,   761,   373,     0,   374,
     375,   376,   377,   378,   379,     0,   380,     0,     0,   381,
     382,   383,     0,     0,   384,   385,   762,   386,   763,   387,
     388,   389,   390,   391,   392,   393,   394,     0,   395,   396,
     397,   398,   399,   400,   401,     0,   402,   403,   404,   405,
     406,   407,   408,   409,   410,   411,   412,   413,   414,     0,
     415,   416,   417,   418,   419,   420,   421,   422,   423,   424,
     425,     0,   426,   427,   764,   428,   429,   430,   431,   432,
     433,   434,   435,   436,   437,   438,     0,   439,   440,   441,
     442,   443,     0,   444,   445,   446,   447,   765,   448,   449,
     450,     0,   451,   452,   453,   454,   455,   456,   457,   458,
     459,   460,   461,     0,   462,   463,     0,   464,   465,   466,
     467,   468,   469,     0,   470,   471,     0,     0,   472,   473,
     474,   475,     0,   476,   477,   478,   479,   480,   481,   482,
       0,     0,   483,   484,   485,   486,   487,     0,     0,   488,
     489,   490,   491,   492,   493,   494,     0,   495,   766,   496,
     497,   498,   499,     0,     0,   500,     0,     0,   501,   502,
     503,   504,   505,   506,   507,   508,   509,   510,   511,   512,
     513,   514,   515,   516,   517,   518,   744,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,   211,   212,   213,
     214,   215,   216,   217,   218,     0,   220,   221,   222,     0,
       0,     0,     0,   223,     0,     0,     0,   224,   225,     0,
     226,   227,   745,   228,   229,   230,   231,   232,   746,   233,
     234,     0,   235,   236,   237,   238,   239,     0,     0,   240,
     241,   242,   243,   244,     0,   245,   246,   247,   248,   249,
       0,   747,     0,   250,   251,   252,   253,   748,   254,   255,
       0,   256,   257,   258,   259,   260,   261,     0,   749,   262,
     263,     0,     0,     0,   750,     0,     0,     0,   264,   265,
     266,   267,   268,   269,   270,   271,   272,     0,   273,     0,
     274,   275,   276,   277,   278,     0,   279,   280,   281,     0,
       0,   282,   283,   284,   285,   286,     0,   287,   288,   289,
       0,   290,   291,   292,     0,   293,   294,   295,   296,   297,
     298,   299,   300,   301,     0,   302,     0,   303,   304,   305,
     306,     0,   307,     0,   308,   751,     0,   752,   309,   310,
     311,     0,   312,   313,     0,   314,     0,   315,   316,   317,
     318,   938,   753,   320,   321,   322,     0,   323,   324,   325,
     326,   327,   328,     0,   329,   754,   330,   331,   332,   333,
     334,   335,   336,     0,   337,     0,   338,   755,   756,   339,
     757,   340,   341,   342,   343,   344,     0,   345,   346,     0,
     347,   348,   758,   349,   759,     0,   350,   351,   352,     0,
       0,   353,   354,   355,   356,   357,   358,   359,   360,   361,
     362,   363,   364,   365,   366,   760,   367,   368,   369,   370,
       0,   371,   372,   761,   373,     0,   374,   375,   376,   377,
     378,   379,     0,   380,     0,     0,   381,   382,   383,     0,
       0,   384,   385,   762,   386,   763,   387,   388,   389,   390,
     391,   392,   393,   394,     0,   395,   396,   397,   398,   399,
     400,   401,     0,   402,   403,   404,   405,   406,   407,   408,
     409,   410,   411,   412,   413,   414,     0,   415,   416,   417,
     418,   419,   420,   421,   422,   423,   424,   425,     0,   426,
     427,   764,   428,   429,   430,   431,   432,   433,   434,   435,
     436,   437,   438,     0,   439,   440,   441,   442,   443,     0,
     444,   445,   446,   447,   765,   448,   449,   450,     0,   451,
     452,   453,   454,   455,   456,   457,   458,   459,   460,   461,
       0,   462,   463,     0,   464,   465,   466,   467,   468,   469,
       0,   470,   471,     0,     0,   472,   473,   474,   475,     0,
     476,   477,   478,   479,   480,   481,   482,     0,     0,   483,
     484,   485,   486,   487,     0,     0,   488,   489,   490,   491,
     492,   493,   494,     0,   495,   766,   496,   497,   498,   499,
       0,     0,   500,     0,     0,   501,   502,   503,   504,   505,
     506,   507,   508,   509,   510,   511,   512,   513,   514,   515,
     516,   517,   518,   787,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,   211,   212,   213,   214,   215,   216,
     217,   218,     0,   220,   221,   222,     0,     0,     0,     0,
     223,     0,     0,     0,   224,   225,     0,   226,   227,   745,
     228,   229,   230,   231,   232,   746,   233,   234,     0,   235,
     236,   237,   238,   239,     0,     0,   240,   241,   242,   243,
     244,     0,   245,   246,   247,   248,   249,     0,   747,     0,
     250,   251,   252,   253,   748,   254,   255,     0,   256,   257,
     258,   259,   260,   261,     0,   749,   262,   263,     0,     0,
       0,   750,     0,     0,     0,   264,   265,   266,   267,   268,
     269,   270,   271,   272,     0,   273,     0,   274,   275,   276,
     277,   278,     0,   279,   280,   281,     0,     0,   282,   283,
     284,   285,   286,     0,   287,   288,   289,     0,   290,   291,
     292,     0,   293,   294,   295,   296,   297,   298,   299,   300,
     301,     0,   302,     0,   303,   304,   305,   306,     0,   307,
       0,   308,   751,     0,   752,   309,   310,   311,     0,   312,
     313,     0,   314,     0,   315,   316,   317,   318,   940,   753,
     320,   321,   322,     0,   323,   324,   325,   326,   327,   328,
       0,   329,   754,   330,   331,   332,   333,   334,   335,   336,
       0,   337,     0,   338,   755,   756,   339,   757,   340,   341,
     342,   343,   344,     0,   345,   346,     0,   347,   348,   758,
     349,   759,     0,   350,   351,   352,     0,     0,   353,   354,
     355,   356,   357,   358,   359,   360,   361,   362,   363,   364,
     365,   366,   760,   367,   368,   369,   370,     0,   371,   372,
     761,   373,     0,   374,   375,   376,   377,   378,   379,     0,
     380,     0,     0,   381,   382,   383,     0,     0,   384,   385,
     762,   386,   763,   387,   388,   389,   390,   391,   392,   393,
     394,     0,   395,   396,   397,   398,   399,   400,   401,     0,
     402,   403,   404,   405,   406,   407,   408,   409,   410,   411,
     412,   413,   414,     0,   415,   416,   417,   418,   419,   420,
     421,   422,   423,   424,   425,     0,   426,   427,   764,   428,
     429,   430,   431,   432,   433,   434,   435,   436,   437,   438,
       0,   439,   440,   441,   442,   443,     0,   444,   445,   446,
     447,   765,   448,   449,   450,     0,   451,   452,   453,   454,
     455,   456,   457,   458,   459,   460,   461,     0,   462,   463,
       0,   464,   465,   466,   467,   468,   469,     0,   470,   471,
       0,     0,   472,   473,   474,   475,     0,   476,   477,   478,
     479,   480,   481,   482,     0,     0,   483,   484,   485,   486,
     487,     0,     0,   488,   489,   490,   491,   492,   493,   494,
       0,   495,   766,   496,   497,   498,   499,     0,     0,   500,
       0,     0,   501,   502,   503,   504,   505,   506,   507,   508,
     509,   510,   511,   512,   513,   514,   515,   516,   517,   518,
     787,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,   211,   212,   213,   214,   215,   216,   217,   218,     0,
     220,   221,   222,     0,     0,     0,     0,   223,     0,     0,
       0,   224,   225,     0,   226,   227,   745,   228,   229,   230,
     231,   232,   746,   233,   234,     0,   235,   236,   237,   238,
     239,     0,     0,   240,   241,   242,   243,   244,     0,   245,
     246,   247,   248,   249,     0,   747,     0,   250,   251,   252,
     253,   748,   254,   255,     0,   256,   257,   258,   259,   260,
     261,     0,   749,   262,   263,     0,     0,     0,   750,     0,
       0,     0,   264,   265,   266,   267,   268,   269,   270,   271,
     272,     0,   273,     0,   274,   275,   276,   277,   278,     0,
     279,   280,   281,     0,     0,   282,   283,   284,   285,   286,
       0,   287,   288,   289,     0,   290,   291,   292,     0,   293,
     294,   295,   296,   297,   298,   299,   300,   301,     0,   302,
       0,   303,   304,   305,   306,     0,   307,     0,   308,   751,
       0,   752,   309,   310,   311,     0,   312,   313,     0,   314,
       0,   315,   316,   317,   318,   950,   753,   320,   321,   322,
       0,   323,   324,   325,   326,   327,   328,     0,   329,   754,
     330,   331,   332,   333,   334,   335,   336,     0,   337,     0,
     338,   755,   756,   339,   757,   340,   341,   342,   343,   344,
       0,   345,   346,     0,   347,   348,   758,   349,   759,     0,
     350,   351,   352,     0,     0,   353,   354,   355,   356,   357,
     358,   359,   360,   361,   362,   363,   364,   365,   366,   760,
     367,   368,   369,   370,     0,   371,   372,   761,   373,     0,
     374,   375,   376,   377,   378,   379,     0,   380,     0,     0,
     381,   382,   383,     0,     0,   384,   385,   762,   386,   763,
     387,   388,   389,   390,   391,   392,   393,   394,     0,   395,
     396,   397,   398,   399,   400,   401,     0,   402,   403,   404,
     405,   406,   407,   408,   409,   410,   411,   412,   413,   414,
       0,   415,   416,   417,   418,   419,   420,   421,   422,   423,
     424,   425,     0,   426,   427,   764,   428,   429,   430,   431,
     432,   433,   434,   435,   436,   437,   438,     0,   439,   440,
     441,   442,   443,     0,   444,   445,   446,   447,   765,   448,
     449,   450,     0,   451,   452,   453,   454,   455,   456,   457,
     458,   459,   460,   461,     0,   462,   463,     0,   464,   465,
     466,   467,   468,   469,     0,   470,   471,     0,     0,   472,
     473,   474,   475,     0,   476,   477,   478,   479,   480,   481,
     482,     0,     0,   483,   484,   485,   486,   487,     0,     0,
     488,   489,   490,   491,   492,   493,   494,     0,   495,   766,
     496,   497,   498,   499,     0,     0,   500,     0,     0,   501,
     502,   503,   504,   505,   506,   507,   508,   509,   510,   511,
     512,   513,   514,   515,   516,   517,   518,   787,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,   211,   212,
     213,   214,   215,   216,   217,   218,     0,   220,   221,   222,
       0,     0,     0,     0,   223,     0,     0,     0,   224,   225,
       0,   226,   227,   745,   228,   229,   230,   231,   232,   746,
     233,   234,     0,   235,   236,   237,   238,   239,     0,     0,
     240,   241,   242,   243,   244,     0,   245,   246,   247,   248,
     249,     0,   747,     0,   250,   251,   252,   253,   748,   254,
     255,     0,   256,   257,   258,   259,   260,   261,     0,   749,
     262,   263,     0,     0,     0,   750,     0,     0,     0,   264,
     265,   266,   267,   268,   269,   270,   271,   272,     0,   273,
       0,   274,   275,   276,   277,   278,     0,   279,   280,   281,
       0,     0,   282,   283,   284,   285,   286,     0,   287,   288,
     289,     0,   290,   291,   292,     0,   293,   294,   295,   296,
     297,   298,   299,   300,   301,     0,   302,     0,   303,   304,
     305,   306,     0,   307,     0,   308,   751,     0,   752,   309,
     310,   311,     0,   312,   313,     0,   314,     0,   315,   316,
     317,   318,   961,   753,   320,   321,   322,     0,   323,   324,
     325,   326,   327,   328,     0,   329,   754,   330,   331,   332,
     333,   334,   335,   336,     0,   337,     0,   338,   755,   756,
     339,   757,   340,   341,   342,   343,   344,     0,   345,   346,
       0,   347,   348,   758,   349,   759,     0,   350,   351,   352,
       0,     0,   353,   354,   962,   356,   357,   358,   359,   360,
     361,   362,   363,   364,   365,   366,   760,   367,   368,   369,
     370,     0,   371,   372,   761,   373,     0,   374,   375,   376,
     377,   378,   379,     0,   380,     0,     0,   381,   382,   383,
       0,     0,   384,   385,   762,   386,   763,   387,   388,   389,
     390,   391,   392,   393,   394,     0,   395,   396,   397,   398,
     399,   400,   401,     0,   402,   403,   404,   405,   406,   407,
     408,   409,   410,   411,   412,   413,   414,     0,   415,   416,
     417,   418,   419,   420,   421,   422,   423,   424,   425,     0,
     426,   427,   764,   428,   429,   430,   431,   432,   433,   434,
     435,   436,   437,   438,     0,   439,   440,   441,   442,   443,
       0,   444,   445,   446,   447,   765,   448,   449,   450,     0,
     451,   452,   453,   454,   455,   456,   457,   458,   459,   460,
     461,     0,   462,   463,     0,   464,   465,   466,   467,   468,
     469,     0,   470,   471,     0,     0,   472,   473,   474,   475,
       0,   476,   477,   478,   479,   480,   481,   482,     0,     0,
     483,   484,   485,   486,   487,     0,     0,   488,   489,   490,
     491,   492,   493,   494,     0,   495,   766,   496,   497,   498,
     499,     0,     0,   500,     0,     0,   501,   502,   503,   504,
     505,   506,   507,   508,   509,   510,   511,   512,   513,   514,
     515,   516,   517,   518,   210,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,   211,   212,   213,   214,   215,
     216,   217,   218,     0,   220,   221,   222,     0,     0,     0,
       0,   223,     0,     0,     0,   224,   225,     0,   226,   227,
       0,   228,   229,   230,   231,   232,     0,   233,   234,     0,
     235,   236,   237,   238,   239,     0,     0,   240,   241,   242,
     243,   244,  1916,   245,   246,   247,   248,   249,     0,     0,
    1989,   250,   251,   252,   253,     0,   254,   255,  1917,   256,
     257,   258,   259,   260,   261,     0,     0,   262,   263,     0,
       0,     0,     0,     0,     0,     0,   264,   265,   266,   267,
     268,   269,   270,   271,   272,     0,   273,     0,   274,   275,
     276,   277,   278,     0,   279,   280,   281,     0,     0,   282,
     283,   284,   285,   286,     0,   287,   288,   289,     0,   290,
     291,   292,     0,  1990,   294,   295,   296,   297,   298,   299,
     300,   301,     0,   302,     0,   303,   304,   305,   306,     0,
     307,  1919,   308,     0,     0,     0,   309,   310,   311,     0,
     312,   313,     0,   314,     0,   315,   316,   317,   318,   319,
       0,   320,   321,   322,     0,   323,   324,   325,   326,   327,
     328,     0,   329,     0,   330,   331,   332,   333,   334,   335,
     336,     0,   337,     0,   338,     0,     0,   339,     0,   340,
     341,   342,   343,   344,     0,   345,   346,     0,   347,   348,
       0,   349,     0,     0,   350,   351,   352,     0,     0,   353,
     354,   355,   356,   357,   358,   359,   360,   361,   362,   363,
     364,   365,   366,     0,   367,   368,   369,   370,     0,   371,
     372,     0,   373,     0,   374,   375,   376,   377,   378,   379,
       0,   380,     0,     0,   381,   382,   383,     0,     0,   384,
     385,     0,   386,     0,   387,   388,   389,   390,   391,   392,
     393,   394,     0,   395,   396,   397,   398,   399,   400,   401,
    1920,   402,   403,   404,   405,   406,   407,   408,   409,   410,
     411,   412,   413,   414,     0,   415,   416,   417,   418,   419,
     420,   421,   422,   423,   424,   425,     0,   426,   427,     0,
     428,   429,   430,   431,   432,   433,   434,   435,   436,   437,
     438,     0,   439,   440,   441,   442,   443,     0,   444,   445,
     446,   447,     0,   448,   449,   450,     0,   451,   452,   453,
     454,   455,   456,   457,   458,   459,   460,   461,     0,   462,
     463,     0,   464,   465,   466,   467,   468,   469,     0,   470,
     471,     0,     0,   472,   473,   474,   475,     0,   476,   477,
     478,   479,   480,   481,   482,     0,  1921,   483,   484,   485,
     486,   487,     0,     0,   488,   489,   490,   491,   492,   493,
     494,     0,   495,     0,   496,   497,   498,   499,     0,     0,
     500,     0,     0,   501,   502,   503,   504,   505,   506,   507,
     508,   509,   510,   511,   512,   513,   514,   515,   516,   517,
     518,   210,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,   211,   212,   213,   214,   215,   216,   217,   218,
       0,   220,   221,   222,     0,     0,     0,     0,   223,     0,
       0,     0,   224,   225,     0,   226,   227,     0,   228,   229,
     230,   231,   232,     0,   233,   234,     0,   235,   236,   237,
     238,   239,     0,     0,   240,   241,   242,   243,   244,  1916,
     245,   246,   247,   248,   249,     0,     0,     0,   250,   251,
     252,   253,     0,   254,   255,  1917,   256,   257,   258,   259,
     260,   261,     0,     0,   262,   263,     0,     0,     0,     0,
       0,     0,     0,   264,   265,   266,   267,   268,   269,   270,
     271,   272,     0,   273,     0,   274,   275,   276,   277,   278,
       0,   279,   280,   281,     0,     0,   282,   283,   284,   285,
     286,     0,   287,   288,   289,     0,   290,   291,   292,     0,
    1990,   294,   295,   296,   297,   298,   299,   300,   301,     0,
     302,     0,   303,   304,   305,   306,     0,   307,  1919,   308,
       0,     0,     0,   309,   310,   311,     0,   312,   313,     0,
     314,     0,   315,   316,   317,   318,   319,     0,   320,   321,
     322,     0,   323,   324,   325,   326,   327,   328,     0,   329,
       0,   330,   331,   332,   333,   334,   335,   336,     0,   337,
       0,   338,     0,     0,   339,     0,   340,   341,   342,   343,
     344,     0,   345,   346,     0,   347,   348,     0,   349,  2840,
       0,   350,   351,   352,     0,     0,   353,   354,   355,   356,
     357,   358,   359,   360,   361,   362,   363,   364,   365,   366,
       0,   367,   368,   369,   370,     0,   371,   372,     0,   373,
       0,   374,   375,   376,   377,   378,   379,     0,   380,     0,
       0,   381,   382,   383,     0,     0,   384,   385,     0,   386,
       0,   387,   388,   389,   390,   391,   392,   393,   394,     0,
     395,   396,   397,   398,   399,   400,   401,  1920,   402,   403,
     404,   405,   406,   407,   408,   409,   410,   411,   412,   413,
     414,     0,   415,   416,   417,   418,   419,   420,   421,   422,
     423,   424,   425,     0,   426,   427,     0,   428,   429,   430,
     431,   432,   433,   434,   435,   436,   437,   438,     0,   439,
     440,   441,   442,   443,     0,   444,   445,   446,   447,     0,
     448,   449,   450,     0,   451,   452,   453,   454,   455,   456,
     457,   458,   459,   460,   461,     0,   462,   463,     0,   464,
     465,   466,   467,   468,   469,     0,   470,   471,     0,     0,
     472,   473,   474,   475,     0,   476,   477,   478,   479,   480,
     481,   482,     0,  1921,   483,   484,   485,   486,   487,     0,
       0,   488,   489,   490,   491,   492,   493,   494,     0,   495,
       0,   496,   497,   498,   499,     0,     0,   500,     0,     0,
     501,   502,   503,   504,   505,   506,   507,   508,   509,   510,
     511,   512,   513,   514,   515,   516,   517,   518,   210,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,   211,
     212,   213,   214,   215,   678,   217,   218,   644,   220,   221,
     222,     0,     0,     0,     0,   223,     0,     0,     0,   224,
     225,     0,   226,   227,     0,   228,   229,   230,   231,   232,
       0,   233,   234,     0,   235,   236,   237,   238,   239,     0,
       0,   240,   241,   242,   243,   244,     0,   245,   246,   247,
     248,   249,     0,     0,     0,   250,   251,   252,   253,     0,
     254,   255,     0,   256,   257,   258,   259,   260,   261,   645,
       0,   262,   263,     0,     0,     0,     0,     0,     0,     0,
     264,   265,   266,   267,   268,   269,   270,   271,   272,     0,
     273,     0,   274,   275,   276,   277,   278,     0,   279,   280,
     281,     0,     0,   282,   283,   284,   285,   286,     0,   287,
     288,   289,     0,   290,   291,   292,     0,   293,   294,   295,
     296,   297,   298,   299,   300,   301,     0,   302,     0,   303,
     304,   305,   306,     0,   307,     0,   308,     0,     0,     0,
     309,   310,   311,   679,   312,   313,     0,   314,     0,   315,
     316,   317,   318,   319,     0,   320,   321,   322,     0,   323,
     324,   325,   326,   327,   328,     0,   329,     0,   330,   331,
     332,   333,   334,   335,   336,     0,   337,     0,   338,     0,
       0,   339,     0,   340,   341,   342,   343,   344,     0,   345,
     346,     0,   347,   348,     0,   349,     0,     0,   350,   351,
     352,     0,     0,   353,   354,   355,   356,   357,   358,   359,
     360,   361,   362,   363,   364,   365,   366,     0,   367,   368,
     369,   370,     0,   371,   372,     0,   373,     0,   374,   375,
     376,   377,   378,   379,     0,   380,     0,     0,   381,   382,
     383,     0,     0,   384,   385,     0,   386,     0,   387,   388,
     389,   390,   391,   392,   393,   394,     0,   395,   396,   397,
     398,   399,   400,   401,     0,   402,   403,   404,   405,   406,
     407,   408,   409,   410,   411,   412,   413,   414,   646,   415,
     416,   417,   418,   419,   420,   421,   422,   423,   424,   425,
       0,   426,   427,     0,   428,   429,   430,   431,   432,   433,
     434,   435,   436,   437,   438,   647,   439,   440,   441,   442,
     443,     0,   444,   445,   446,   447,     0,   448,   449,   450,
       0,   451,   452,   453,   454,   455,   456,   457,   458,   459,
     460,   461,     0,   462,   463,     0,   464,   465,   466,   467,
     468,   469,     0,   470,   471,     0,     0,   472,   473,   474,
     475,     0,   476,   477,   478,   479,   480,   481,   482,     0,
       0,   483,   484,   485,   486,   487,     0,     0,   488,   489,
     490,   491,   492,   493,   494,     0,   495,     0,   496,   497,
     498,   499,     0,     0,   500,     0,     0,   501,   502,   503,
     504,   505,   506,   507,   508,   509,   510,   511,   512,   513,
     514,   515,   516,   517,   518,   210,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,   211,   212,   213,   214,
     215,   216,   217,   218,   644,   220,   221,   222,     0,     0,
       0,     0,   223,     0,     0,     0,   224,   225,     0,   226,
     227,     0,   228,   229,   230,   231,   232,     0,   233,   234,
       0,   235,   236,   237,   238,   239,     0,     0,   240,   241,
     242,   243,   244,     0,   245,   246,   247,   248,   249,     0,
       0,     0,   250,   251,   252,   253,     0,   254,   255,     0,
     256,   257,   258,   259,   260,   261,   645,     0,   262,   263,
       0,     0,     0,     0,     0,     0,     0,   264,   265,   266,
     267,   268,   269,   270,   271,   272,     0,   273,     0,   274,
     275,   276,   277,   278,     0,   279,   280,   281,     0,     0,
     282,   283,   284,   285,   286,     0,   287,   288,   289,     0,
     290,   291,   292,     0,   293,   294,   295,   296,   297,   298,
     299,   300,   301,     0,   302,     0,   303,   304,   305,   306,
       0,   307,     0,   308,     0,     0,     0,   309,   310,   311,
    2570,   312,   313,     0,   314,     0,   315,   316,   317,   318,
     319,     0,   320,   321,   322,     0,   323,   324,   325,   326,
     327,   328,     0,   329,     0,   330,   331,   332,   333,   334,
     335,   336,     0,   337,     0,   338,     0,     0,   339,     0,
     340,   341,   342,   343,   344,     0,   345,   346,     0,   347,
     348,     0,   349,     0,     0,   350,   351,   352,     0,     0,
     353,   354,   355,   356,   357,   358,   359,   360,   361,   362,
     363,   364,   365,   366,     0,   367,   368,   369,   370,     0,
     371,   372,     0,   373,     0,   374,   375,   376,   377,   378,
     379,     0,   380,     0,     0,   381,   382,   383,     0,     0,
     384,   385,     0,   386,     0,   387,   388,   389,   390,   391,
     392,   393,   394,     0,   395,   396,   397,   398,   399,   400,
     401,     0,   402,   403,   404,   405,   406,   407,   408,   409,
     410,   411,   412,   413,   414,   646,   415,   416,   417,   418,
     419,   420,   421,   422,   423,   424,   425,     0,   426,   427,
       0,   428,   429,   430,   431,   432,   433,   434,   435,   436,
     437,   438,   647,   439,   440,   441,   442,   443,     0,   444,
     445,   446,   447,     0,   448,   449,   450,     0,   451,   452,
     453,   454,   455,   456,   457,   458,   459,   460,   461,     0,
     462,   463,     0,   464,   465,   466,   467,   468,   469,     0,
     470,   471,     0,     0,   472,   473,   474,   475,     0,   476,
     477,   478,   479,   480,   481,   482,     0,     0,   483,   484,
     485,   486,   487,     0,     0,   488,   489,   490,   491,   492,
     493,   494,     0,   495,     0,   496,   497,   498,   499,     0,
       0,   500,     0,     0,   501,   502,   503,   504,   505,   506,
     507,   508,   509,   510,   511,   512,   513,   514,   515,   516,
     517,   518,   210,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,   211,   212,   213,   214,   215,   216,   217,
     218,     0,   220,   221,   222,     0,     0,     0,     0,   223,
       0,     0,     0,   224,   225,     0,   226,   227,     0,   228,
     229,   230,   231,   232,     0,   233,   234,     0,   235,   236,
     237,   238,   239,     0,     0,   240,   241,   242,   243,   244,
    1916,   245,   246,   247,   248,   249,     0,     0,     0,   250,
     251,   252,   253,     0,   254,   255,  1917,   256,   257,   258,
     259,   260,   261,     0,     0,   262,   263,     0,     0,     0,
       0,     0,     0,     0,   264,   265,   266,   267,   268,   269,
     270,   271,   272,     0,   273,     0,   274,   275,   276,   277,
     278,     0,   279,   280,   281,     0,     0,   282,   283,   284,
     285,   286,     0,   287,   288,   289,     0,   290,   291,   292,
       0,  1990,   294,   295,   296,   297,   298,   299,   300,   301,
       0,   302,     0,   303,   304,   305,   306,     0,   307,  1919,
     308,     0,     0,     0,   309,   310,   311,     0,   312,   313,
       0,   314,     0,   315,   316,   317,   318,   319,     0,   320,
     321,   322,     0,   323,   324,   325,   326,   327,   328,     0,
     329,     0,   330,   331,   332,   333,   334,   335,   336,     0,
     337,     0,   338,     0,     0,   339,     0,   340,   341,   342,
     343,   344,     0,   345,   346,     0,   347,   348,     0,   349,
       0,     0,   350,   351,   352,     0,     0,   353,   354,   355,
     356,   357,   358,   359,   360,   361,   362,   363,   364,   365,
     366,     0,   367,   368,   369,   370,     0,   371,   372,     0,
     373,     0,   374,   375,   376,   377,   378,   379,     0,   380,
       0,     0,   381,   382,   383,     0,     0,   384,   385,     0,
     386,     0,   387,   388,   389,   390,   391,   392,   393,   394,
       0,   395,   396,   397,   398,   399,   400,   401,  1920,   402,
     403,   404,   405,   406,   407,   408,   409,   410,   411,   412,
     413,   414,     0,   415,   416,   417,   418,   419,   420,   421,
     422,   423,   424,   425,     0,   426,   427,     0,   428,   429,
     430,   431,   432,   433,   434,   435,   436,   437,   438,     0,
     439,   440,   441,   442,   443,     0,   444,   445,   446,   447,
       0,   448,   449,   450,     0,   451,   452,   453,   454,   455,
     456,   457,   458,   459,   460,   461,     0,   462,   463,     0,
     464,   465,   466,   467,   468,   469,     0,   470,   471,     0,
       0,   472,   473,   474,   475,     0,   476,   477,   478,   479,
     480,   481,   482,     0,  1921,   483,   484,   485,   486,   487,
       0,     0,   488,   489,   490,   491,   492,   493,   494,     0,
     495,     0,   496,   497,   498,   499,     0,     0,   500,     0,
       0,   501,   502,   503,   504,   505,   506,   507,   508,   509,
     510,   511,   512,   513,   514,   515,   516,   517,   518,   210,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
     211,   212,   213,   214,   215,   216,   217,   218,   644,   220,
     221,   222,     0,     0,     0,     0,   223,     0,     0,     0,
     224,   225,     0,   226,   227,     0,   228,   229,   230,   231,
     232,     0,   233,   234,     0,   235,   236,   237,   238,   239,
       0,     0,   240,   241,   242,   243,   244,     0,   245,   246,
     247,   248,   249,     0,     0,     0,   250,   251,   252,   253,
       0,   254,   255,     0,   256,   257,   258,   259,   260,   261,
     645,     0,   262,   263,     0,     0,     0,     0,     0,     0,
       0,   264,   265,   266,   267,   268,   269,   270,   271,   272,
       0,   273,     0,   274,   275,   276,   277,   278,     0,   279,
     280,   281,     0,     0,   282,   283,   284,   285,   286,     0,
     287,   288,   289,     0,   290,   291,   292,     0,   293,   294,
     295,   296,   297,   298,   299,   300,   301,     0,   302,     0,
     303,   304,   305,   306,     0,   307,     0,   308,     0,     0,
       0,   309,   310,   311,     0,   312,   313,     0,   314,     0,
     315,   316,   317,   318,   319,     0,   320,   321,   322,     0,
     323,   324,   325,   326,   327,   328,     0,   329,     0,   330,
     331,   332,   333,   334,   335,   336,     0,   337,     0,   338,
       0,     0,   339,     0,   340,   341,   342,   343,   344,     0,
     345,   346,     0,   347,   348,     0,   349,     0,     0,   350,
     351,   352,     0,     0,   353,   354,   355,   356,   357,   358,
     359,   360,   361,   362,   363,   364,   365,   366,     0,   367,
     368,   369,   370,     0,   371,   372,     0,   373,     0,   374,
     375,   376,   377,   378,   379,     0,   380,     0,     0,   381,
     382,   383,     0,     0,   384,   385,     0,   386,     0,   387,
     388,   389,   390,   391,   392,   393,   394,     0,   395,   396,
     397,   398,   399,   400,   401,     0,   402,   403,   404,   405,
     406,   407,   408,   409,   410,   411,   412,   413,   414,   646,
     415,   416,   417,   418,   419,   420,   421,   422,   423,   424,
     425,     0,   426,   427,     0,   428,   429,   430,   431,   432,
     433,   434,   435,   436,   437,   438,   647,   439,   440,   441,
     442,   443,     0,   444,   445,   446,   447,     0,   448,   449,
     450,     0,   451,   452,   453,   454,   455,   456,   457,   458,
     459,   460,   461,     0,   462,   463,     0,   464,   465,   466,
     467,   468,   469,     0,   470,   471,     0,     0,   472,   473,
     474,   475,     0,   476,   477,   478,   479,   480,   481,   482,
       0,     0,   483,   484,   485,   486,   487,     0,     0,   488,
     489,   490,   491,   492,   493,   494,     0,   495,     0,   496,
     497,   498,   499,     0,     0,   500,     0,     0,   501,   502,
     503,   504,   505,   506,   507,   508,   509,   510,   511,   512,
     513,   514,   515,   516,   517,   518,   210,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,   211,   212,   213,
     214,   215,   216,   217,   218,  1565,   220,   221,   222,     0,
       0,     0,     0,   223,     0,     0,     0,   224,   225,     0,
     226,   227,     0,   228,   229,   230,   231,   232,     0,   233,
     234,     0,   235,   236,   237,   238,   239,     0,     0,   240,
     241,   242,   243,   244,     0,   245,   246,   247,   248,   249,
       0,     0,     0,   250,   251,   252,   253,     0,   254,   255,
       0,   256,   257,   258,   259,   260,   261,     0,     0,   262,
     263,     0,     0,     0,     0,     0,     0,     0,   264,   265,
     266,  1566,   268,   269,   270,   271,   272,     0,   273,     0,
     274,   275,   276,   277,   278,     0,   279,   280,   281,     0,
       0,   282,  1567,   284,   285,   286,     0,   287,   288,   289,
       0,   290,   291,   292,     0,   293,   294,   295,   296,   297,
     298,   299,   300,   301,     0,   302,     0,   303,   304,   305,
     306,     0,   307,  1568,   308,     0,     0,     0,  1569,   310,
     311,     0,   312,   313,     0,   314,     0,   315,   316,   317,
     318,   319,     0,   320,   321,   322,     0,   323,   324,   325,
     326,   327,   328,     0,   329,     0,   330,   331,   332,   333,
     334,   335,   336,     0,   337,     0,   338,     0,     0,   339,
       0,   340,   341,  1570,  1571,   344,     0,   345,   346,     0,
     347,   348,     0,   349,     0,     0,   350,   351,   352,     0,
       0,   353,   354,   355,   356,   357,   358,   359,   360,   361,
     362,   363,   364,   365,   366,     0,   367,   368,   369,   370,
       0,   371,   372,     0,   373,     0,   374,   375,   376,   377,
     378,   379,     0,   380,     0,     0,   381,   382,   383,     0,
       0,   384,   385,     0,   386,     0,   387,   388,   389,   390,
     391,   392,   393,   394,     0,   395,   396,   397,   398,   399,
     400,   401,     0,   402,   403,   404,   405,   406,   407,   408,
     409,   410,   411,   412,   413,   414,     0,   415,   416,   417,
     418,   419,   420,   421,   422,   423,   424,   425,     0,   426,
     427,     0,   428,   429,   430,   431,   432,   433,  1572,   435,
     436,   437,   438,     0,  1573,   440,   441,   442,   443,     0,
     444,   445,   446,   447,     0,   448,   449,   450,     0,   451,
     452,   453,   454,   455,   456,   457,   458,   459,   460,   461,
       0,   462,   463,  1574,   464,  1575,   466,   467,   468,   469,
       0,   470,   471,     0,     0,   472,   473,   474,   475,     0,
     476,   477,  1576,   479,   480,   481,   482,     0,     0,   483,
     484,   485,   486,   487,     0,     0,   488,   489,   490,   491,
     492,   493,   494,     0,   495,     0,   496,   497,   498,   499,
       0,     0,   500,     0,     0,   501,   502,   503,   504,   505,
     506,   507,   508,   509,   510,   511,   512,   513,   514,   515,
     516,   517,   518,   210,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,   211,   212,   213,   214,   215,   216,
     217,   218,     0,   220,   221,   222,     0,     0,     0,     0,
     223,     0,     0,     0,   224,   225,     0,   226,   227,     0,
     228,   229,   230,   231,   232,     0,   233,   234,     0,   235,
     236,   237,   238,   239,     0,     0,   240,   241,   242,   243,
     244,     0,   245,   246,   247,   248,   249,     0,     0,     0,
     250,   251,   252,   253,     0,   254,   255,     0,   256,   257,
     258,   259,   260,   261,   645,     0,   262,   263,     0,     0,
       0,     0,     0,     0,     0,   264,   265,   266,   267,   268,
     269,   270,   271,   272,     0,   273,     0,   274,   275,   276,
     277,   278,     0,   279,   280,   281,     0,     0,   282,   283,
     284,   285,   286,     0,   287,   288,   289,     0,   290,   291,
     292,     0,   293,   294,   295,   296,   297,   298,   299,   300,
     301,     0,   302,     0,   303,   304,   305,   306,     0,   307,
       0,   308,     0,     0,     0,   309,   310,   311,     0,   312,
     313,     0,   314,     0,   315,   316,   317,   318,   319,     0,
     320,   321,   322,     0,   323,   324,   325,   326,   327,   328,
       0,   329,     0,   330,   331,   332,   333,   334,   335,   336,
       0,   337,     0,   338,     0,     0,   339,     0,   340,   341,
     342,   343,   344,     0,   345,   346,     0,   347,   348,     0,
     349,     0,     0,   350,   351,   352,     0,     0,   353,   354,
     355,   356,   357,   358,   359,   360,   361,   362,   363,   364,
     365,   366,     0,   367,   368,   369,   370,     0,   371,   372,
       0,   373,     0,   374,   375,   376,   377,   378,   379,     0,
     380,     0,     0,   381,   382,   383,     0,     0,   384,   385,
       0,   386,     0,   387,   388,   389,   390,   391,   392,   393,
     394,     0,   395,   396,   397,   398,   399,   400,   401,     0,
     402,   403,   404,   405,   406,   407,   408,   409,   410,   411,
     412,   413,   414,   646,   415,   416,   417,   418,   419,   420,
     421,   422,   423,   424,   425,     0,   426,   427,     0,   428,
     429,   430,   431,   432,   433,   434,   435,   436,   437,   438,
     647,   439,   440,   441,   442,   443,     0,   444,   445,   446,
     447,     0,   448,   449,   450,     0,   451,   452,   453,   454,
     455,   456,   457,   458,   459,   460,   461,     0,   462,   463,
       0,   464,   465,   466,   467,   468,   469,     0,   470,   471,
       0,     0,   472,   473,   474,   475,     0,   476,   477,   478,
     479,   480,   481,   482,     0,     0,   483,   484,   485,   486,
     487,     0,     0,   488,   489,   490,   491,   492,   493,   494,
       0,   495,     0,   496,   497,   498,   499,     0,     0,   500,
       0,     0,   501,   502,   503,   504,   505,   506,   507,   508,
     509,   510,   511,   512,   513,   514,   515,   516,   517,   518,
     210,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,   211,   212,   213,   214,   215,   216,   217,   218,   823,
     220,   221,   222,     0,     0,     0,     0,   223,     0,     0,
       0,   224,   225,     0,   226,   227,     0,   228,   229,   230,
     231,   232,     0,   233,   234,     0,   235,   236,   237,   238,
     239,     0,     0,   240,   241,   242,   243,   244,     0,   245,
     246,   247,   248,   249,     0,     0,     0,   250,   251,   252,
     253,     0,   254,   255,     0,   256,   257,   258,   259,   260,
     261,     0,     0,   262,   263,     0,     0,     0,     0,     0,
       0,     0,   264,   265,   266,   267,   268,   269,   270,   271,
     272,     0,   273,     0,   274,   275,   276,   277,   278,     0,
     279,   280,   281,     0,     0,   282,   283,   284,   285,   286,
       0,   287,   288,   289,     0,   290,   291,   292,     0,   293,
     294,   295,   296,   297,   298,   299,   300,   301,     0,   302,
       0,   303,   304,   305,   306,     0,   307,     0,   308,     0,
       0,     0,   309,   310,   311,     0,   312,   313,     0,   314,
       0,   315,   316,   317,   318,   824,     0,   320,   321,   322,
       0,   323,   324,   325,   326,   327,   328,     0,   329,     0,
     330,   331,   332,   333,   334,   335,   336,     0,   337,     0,
     338,     0,     0,   339,     0,   340,   341,   342,   343,   344,
       0,   345,   346,     0,   347,   348,     0,   349,     0,     0,
     350,   351,   352,     0,     0,   353,   354,   355,   356,   357,
     358,   359,   360,   361,   362,   363,   364,   365,   366,     0,
     367,   368,   369,   370,     0,   371,   372,     0,   373,     0,
     374,   375,   376,   377,   378,   379,     0,   380,     0,   709,
     381,   382,   383,     0,     0,   384,   385,     0,   386,     0,
     387,   388,   389,   390,   391,   392,   393,   394,     0,   395,
     396,   397,   398,   399,   400,   401,     0,   402,   403,   404,
     405,   406,   407,   408,   409,   410,   411,   412,   413,   414,
       0,   415,   416,   417,   418,   419,   420,   421,   422,   423,
     424,   425,     0,   426,   427,     0,   428,   429,   430,   431,
     432,   433,   434,   435,   436,   437,   438,     0,   439,   440,
     441,   442,   443,     0,   444,   445,   446,   447,     0,   448,
     449,   450,     0,   451,   452,   453,   454,   455,   456,   457,
     458,   459,   460,   461,     0,   462,   463,     0,   464,   465,
     466,   467,   468,   469,     0,   470,   471,     0,     0,   472,
     473,   474,   475,     0,   476,   477,   478,   479,   480,   481,
     482,     0,     0,   483,   484,   485,   486,   487,     0,     0,
     488,   489,   490,   491,   492,   493,   494,     0,   495,     0,
     496,   497,   498,   499,     0,     0,   500,     0,     0,   501,
     502,   503,   504,   505,   506,   507,   508,   509,   510,   511,
     512,   513,   514,   515,   516,   517,   518,   210,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,   211,   212,
     213,   214,   215,   216,   217,   218,     0,   220,   221,   222,
       3,     4,     0,     0,   223,     0,     0,     0,   224,   225,
       0,   226,   227,     0,   228,   229,   230,   231,   232,     0,
     233,   234,     0,   235,   236,   237,   238,   239,     0,     0,
     240,   241,   242,   243,   244,     0,   245,   246,   247,   248,
     249,     0,     0,     0,   250,   251,   252,   253,     0,   254,
     255,     0,   256,   257,   258,   259,   260,   261,     0,     0,
     262,   263,     0,     0,     0,     0,     0,     0,     0,   264,
     265,   266,   267,   268,   269,   270,   271,   272,     0,   273,
       0,   274,   275,   276,   277,   278,     0,   279,   280,   281,
       0,     0,   282,   283,   284,   285,   286,     0,   287,   288,
     289,     0,   290,   291,   292,     0,   293,   294,   295,   296,
     297,   298,   299,   300,   301,     0,   302,     0,   303,   304,
     305,   306,     0,   307,     0,   308,     0,     0,     0,   309,
     310,   311,     0,   312,   313,     0,   314,     0,   315,   316,
     317,   318,   319,     0,   320,   321,   322,     0,   323,   324,
     325,   326,   327,   328,     0,   329,     0,   330,   331,   332,
     333,   334,   335,   336,     0,   337,     0,   338,     0,     0,
     339,     0,   340,   341,   342,   343,   344,     0,   345,   346,
       0,   347,   348,     0,   349,     0,     0,   350,   351,   352,
       0,     0,   353,   354,   355,   356,   357,   358,   359,   360,
     361,   362,   363,   364,   365,   366,     0,   367,   368,   369,
     370,     0,   371,   372,     0,   373,     0,   374,   375,   376,
     377,   378,   379,     0,   380,     0,     0,   381,   382,   383,
       0,     0,   384,   385,     0,   386,     0,   387,   388,   389,
     390,   391,   392,   393,   394,     0,   395,   396,   397,   398,
     399,   400,   401,     0,   402,   403,   404,   405,   406,   407,
     408,   409,   410,   411,   412,   413,   414,     0,   415,   416,
     417,   418,   419,   420,   421,   422,   423,   424,   425,     0,
     426,   427,     0,   428,   429,   430,   431,   432,   433,   434,
     435,   436,   437,   438,     0,   439,   440,   441,   442,   443,
       0,   444,   445,   446,   447,     0,   448,   449,   450,     0,
     451,   452,   453,   454,   455,   456,   457,   458,   459,   460,
     461,     0,   462,   463,     0,   464,   465,   466,   467,   468,
     469,     0,   470,   471,     0,     0,   472,   473,   474,   475,
       0,   476,   477,   478,   479,   480,   481,   482,     0,     0,
     483,   484,   485,   486,   487,     0,     0,   488,   489,   490,
     491,   492,   493,   494,     0,   495,     0,   496,   497,   498,
     499,     0,     0,   500,     0,     0,   501,   502,   503,   504,
     505,   506,   507,   508,   509,   510,   511,   512,   513,   514,
     515,   516,   517,   518,   210,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,   211,   212,   213,   214,   215,
     216,   217,   218,  2651,   220,   221,   222,     0,     0,     0,
       0,   223,     0,     0,     0,   224,   225,     0,   226,   227,
       0,   228,   229,   230,   231,   232,     0,   233,   234,     0,
     235,   236,   237,   238,   239,     0,     0,   240,   241,   242,
     243,   244,     0,   245,   246,   247,   248,   249,     0,     0,
       0,   250,   251,   252,   253,     0,   254,   255,     0,   256,
     257,   258,   259,   260,   261,     0,     0,   262,   263,     0,
       0,     0,     0,     0,     0,     0,   264,   265,   266,   267,
     268,   269,   270,   271,   272,     0,   273,     0,   274,   275,
     276,   277,   278,     0,   279,   280,   281,     0,     0,   282,
     283,   284,   285,   286,     0,   287,   288,   289,     0,   290,
     291,   292,     0,   293,   294,   295,   296,   297,   298,   299,
     300,   301,     0,   302,     0,   303,   304,   305,   306,     0,
     307,     0,   308,     0,     0,     0,   309,   310,   311,     0,
     312,   313,     0,   314,     0,   315,   316,   317,   318,   319,
       0,   320,   321,   322,     0,   323,   324,   325,   326,   327,
     328,     0,   329,     0,   330,   331,   332,   333,   334,   335,
     336,     0,   337,     0,   338,     0,     0,   339,     0,   340,
     341,   342,   343,   344,     0,   345,   346,     0,   347,   348,
       0,   349,     0,     0,   350,   351,   352,     0,     0,   353,
     354,   355,   356,   357,   358,   359,   360,   361,   362,   363,
     364,   365,   366,     0,   367,   368,   369,   370,     0,   371,
     372,     0,   373,     0,   374,   375,   376,   377,   378,   379,
       0,   380,     0,     0,   381,   382,   383,     0,     0,   384,
     385,     0,   386,     0,   387,   388,   389,   390,   391,   392,
     393,   394,     0,   395,   396,   397,   398,   399,   400,   401,
       0,   402,   403,   404,   405,   406,   407,   408,   409,   410,
     411,   412,   413,   414,     0,   415,   416,   417,   418,   419,
     420,   421,   422,   423,   424,   425,     0,   426,   427,     0,
     428,   429,   430,   431,   432,   433,   434,   435,   436,   437,
     438,     0,   439,   440,   441,   442,   443,     0,   444,   445,
     446,   447,     0,   448,   449,   450,     0,   451,   452,   453,
     454,   455,   456,   457,   458,   459,   460,   461,     0,   462,
     463,     0,   464,   465,   466,   467,   468,   469,     0,   470,
     471,     0,     0,   472,   473,   474,   475,     0,   476,   477,
     478,   479,   480,   481,   482,     0,     0,   483,   484,   485,
     486,   487,  2652,     0,   488,   489,   490,   491,   492,   493,
     494,     0,   495,     0,   496,   497,   498,   499,     0,     0,
     500,     0,     0,   501,   502,   503,   504,   505,   506,   507,
     508,   509,   510,   511,   512,   513,   514,   515,   516,   517,
     518,   210,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,   211,   212,   213,   214,   215,   216,   217,   218,
    2663,   220,   221,   222,     0,     0,     0,     0,   223,     0,
       0,     0,   224,   225,     0,   226,   227,     0,   228,   229,
     230,   231,   232,     0,   233,   234,     0,   235,   236,   237,
     238,   239,     0,     0,   240,   241,   242,   243,   244,     0,
     245,   246,   247,   248,   249,     0,     0,     0,   250,   251,
     252,   253,     0,   254,   255,     0,   256,   257,   258,   259,
     260,   261,     0,     0,   262,   263,     0,     0,     0,     0,
       0,     0,     0,   264,   265,   266,   267,   268,   269,   270,
     271,   272,     0,   273,     0,   274,   275,   276,   277,   278,
       0,   279,   280,   281,     0,     0,   282,   283,   284,   285,
     286,     0,   287,   288,   289,     0,   290,   291,   292,     0,
     293,   294,   295,   296,   297,   298,   299,   300,   301,     0,
     302,     0,   303,   304,   305,   306,     0,   307,     0,   308,
       0,     0,     0,   309,   310,   311,     0,   312,   313,     0,
     314,     0,   315,   316,   317,   318,   319,     0,   320,   321,
     322,     0,   323,   324,   325,   326,   327,   328,     0,   329,
       0,   330,   331,   332,   333,   334,   335,   336,     0,   337,
       0,   338,     0,     0,   339,     0,   340,   341,   342,   343,
     344,     0,   345,   346,     0,   347,   348,     0,   349,     0,
       0,   350,   351,   352,     0,     0,   353,   354,   355,   356,
     357,   358,   359,   360,   361,   362,   363,   364,   365,   366,
       0,   367,   368,   369,   370,     0,   371,   372,     0,   373,
       0,   374,   375,   376,   377,   378,   379,     0,   380,     0,
       0,   381,   382,   383,     0,     0,   384,   385,     0,   386,
       0,   387,   388,   389,   390,   391,   392,   393,   394,     0,
     395,   396,   397,   398,   399,   400,   401,     0,   402,   403,
     404,   405,   406,   407,   408,   409,   410,   411,   412,   413,
     414,     0,   415,   416,   417,   418,   419,   420,   421,   422,
     423,   424,   425,     0,   426,   427,     0,   428,   429,   430,
     431,   432,   433,   434,   435,   436,   437,   438,     0,   439,
     440,   441,   442,   443,     0,   444,   445,   446,   447,     0,
     448,   449,   450,     0,   451,   452,   453,   454,   455,   456,
     457,   458,   459,   460,   461,     0,   462,   463,     0,   464,
     465,   466,   467,   468,   469,     0,   470,   471,     0,     0,
     472,   473,   474,   475,     0,   476,   477,   478,   479,   480,
     481,   482,     0,     0,   483,   484,   485,   486,   487,  2664,
       0,   488,   489,   490,   491,   492,   493,   494,     0,   495,
       0,   496,   497,   498,   499,     0,     0,   500,     0,     0,
     501,   502,   503,   504,   505,   506,   507,   508,   509,   510,
     511,   512,   513,   514,   515,   516,   517,   518,   210,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,   211,
     212,   213,   214,   215,   216,   217,   218,   219,   220,   221,
     222,     0,     0,     0,     0,   223,     0,     0,     0,   224,
     225,     0,   226,   227,     0,   228,   229,   230,   231,   232,
       0,   233,   234,     0,   235,   236,   237,   238,   239,     0,
       0,   240,   241,   242,   243,   244,     0,   245,   246,   247,
     248,   249,     0,     0,     0,   250,   251,   252,   253,     0,
     254,   255,     0,   256,   257,   258,   259,   260,   261,     0,
       0,   262,   263,     0,     0,     0,     0,     0,     0,     0,
     264,   265,   266,   267,   268,   269,   270,   271,   272,     0,
     273,     0,   274,   275,   276,   277,   278,     0,   279,   280,
     281,     0,     0,   282,   283,   284,   285,   286,     0,   287,
     288,   289,     0,   290,   291,   292,     0,   293,   294,   295,
     296,   297,   298,   299,   300,   301,     0,   302,     0,   303,
     304,   305,   306,     0,   307,     0,   308,     0,     0,     0,
     309,   310,   311,     0,   312,   313,     0,   314,     0,   315,
     316,   317,   318,   319,     0,   320,   321,   322,     0,   323,
     324,   325,   326,   327,   328,     0,   329,     0,   330,   331,
     332,   333,   334,   335,   336,     0,   337,     0,   338,     0,
       0,   339,     0,   340,   341,   342,   343,   344,     0,   345,
     346,     0,   347,   348,     0,   349,     0,     0,   350,   351,
     352,     0,     0,   353,   354,   355,   356,   357,   358,   359,
     360,   361,   362,   363,   364,   365,   366,     0,   367,   368,
     369,   370,     0,   371,   372,     0,   373,     0,   374,   375,
     376,   377,   378,   379,     0,   380,     0,     0,   381,   382,
     383,     0,     0,   384,   385,     0,   386,     0,   387,   388,
     389,   390,   391,   392,   393,   394,     0,   395,   396,   397,
     398,   399,   400,   401,     0,   402,   403,   404,   405,   406,
     407,   408,   409,   410,   411,   412,   413,   414,     0,   415,
     416,   417,   418,   419,   420,   421,   422,   423,   424,   425,
       0,   426,   427,     0,   428,   429,   430,   431,   432,   433,
     434,   435,   436,   437,   438,     0,   439,   440,   441,   442,
     443,     0,   444,   445,   446,   447,     0,   448,   449,   450,
       0,   451,   452,   453,   454,   455,   456,   457,   458,   459,
     460,   461,     0,   462,   463,     0,   464,   465,   466,   467,
     468,   469,     0,   470,   471,     0,     0,   472,   473,   474,
     475,     0,   476,   477,   478,   479,   480,   481,   482,     0,
       0,   483,   484,   485,   486,   487,     0,     0,   488,   489,
     490,   491,   492,   493,   494,     0,   495,     0,   496,   497,
     498,   499,     0,     0,   500,     0,     0,   501,   502,   503,
     504,   505,   506,   507,   508,   509,   510,   511,   512,   513,
     514,   515,   516,   517,   518,   210,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,   211,   212,   213,   214,
     215,   216,   217,   218,   565,   220,   221,   222,     0,     0,
       0,     0,   223,     0,     0,     0,   224,   225,     0,   226,
     227,     0,   228,   229,   230,   231,   232,     0,   233,   234,
       0,   235,   236,   237,   238,   239,     0,     0,   240,   241,
     242,   243,   244,     0,   245,   246,   247,   248,   249,     0,
       0,     0,   250,   251,   252,   253,     0,   254,   255,     0,
     256,   257,   258,   259,   260,   261,     0,     0,   262,   263,
       0,     0,     0,     0,     0,     0,     0,   264,   265,   266,
     267,   268,   269,   270,   271,   272,     0,   273,     0,   274,
     275,   276,   277,   278,     0,   279,   280,   281,     0,     0,
     282,   283,   284,   285,   286,     0,   287,   288,   289,     0,
     290,   291,   292,     0,   293,   294,   295,   296,   297,   298,
     299,   300,   301,     0,   302,     0,   303,   304,   305,   306,
       0,   307,     0,   308,     0,     0,     0,   309,   310,   311,
       0,   312,   313,     0,   314,     0,   315,   316,   317,   318,
     319,     0,   320,   321,   322,     0,   323,   324,   325,   326,
     327,   328,     0,   329,     0,   330,   331,   332,   333,   334,
     335,   336,     0,   337,     0,   338,     0,     0,   339,     0,
     340,   341,   342,   343,   344,     0,   345,   346,     0,   347,
     348,     0,   349,     0,     0,   350,   351,   352,     0,     0,
     353,   354,   355,   356,   357,   358,   359,   360,   361,   362,
     363,   364,   365,   366,     0,   367,   368,   369,   370,     0,
     371,   372,     0,   373,     0,   374,   375,   376,   377,   378,
     379,     0,   380,     0,     0,   381,   382,   383,     0,     0,
     384,   385,     0,   386,     0,   387,   388,   389,   390,   391,
     392,   393,   394,     0,   395,   396,   397,   398,   399,   566,
     401,     0,   402,   403,   404,   405,   406,   407,   408,   409,
     410,   411,   412,   413,   414,     0,   415,   416,   417,   418,
     419,   420,   421,   422,   423,   424,   425,     0,   426,   427,
       0,   428,   429,   430,   431,   432,   433,   434,   435,   436,
     437,   438,     0,   439,   440,   441,   442,   443,     0,   444,
     445,   446,   447,     0,   448,   449,   450,     0,   451,   452,
     453,   454,   455,   456,   457,   458,   459,   460,   461,     0,
     462,   463,     0,   464,   465,   466,   467,   468,   469,     0,
     470,   471,     0,     0,   472,   473,   474,   475,     0,   476,
     477,   478,   479,   480,   481,   482,     0,     0,   483,   484,
     485,   486,   487,     0,     0,   488,   489,   490,   491,   492,
     493,   494,     0,   495,     0,   496,   497,   498,   499,     0,
       0,   500,     0,     0,   501,   502,   503,   504,   505,   506,
     507,   508,   509,   510,   511,   512,   513,   514,   515,   516,
     517,   518,   210,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,   211,   212,   213,   214,   215,   216,   217,
     218,   670,   220,   221,   222,     0,     0,     0,     0,   223,
       0,     0,     0,   224,   225,     0,   226,   227,     0,   228,
     229,   230,   231,   232,     0,   233,   234,     0,   235,   236,
     237,   238,   239,     0,     0,   240,   241,   242,   243,   244,
       0,   245,   246,   247,   248,   249,     0,     0,     0,   250,
     251,   252,   253,     0,   254,   255,     0,   256,   257,   258,
     259,   260,   261,     0,     0,   262,   263,     0,     0,     0,
       0,     0,     0,     0,   264,   265,   266,   267,   268,   269,
     270,   271,   272,     0,   273,     0,   274,   275,   276,   277,
     278,     0,   279,   280,   281,     0,     0,   282,   283,   284,
     285,   286,     0,   287,   288,   289,     0,   290,   291,   292,
       0,   293,   294,   295,   296,   297,   298,   299,   300,   301,
       0,   302,     0,   303,   304,   305,   306,     0,   307,     0,
     308,     0,     0,     0,   309,   310,   311,     0,   312,   313,
       0,   314,     0,   315,   316,   317,   318,   319,     0,   320,
     321,   322,     0,   323,   324,   325,   326,   327,   328,     0,
     329,     0,   330,   331,   332,   333,   334,   335,   336,     0,
     337,     0,   338,     0,     0,   339,     0,   340,   341,   342,
     343,   344,     0,   345,   346,     0,   347,   348,     0,   349,
       0,     0,   350,   351,   352,     0,     0,   353,   354,   355,
     356,   357,   358,   359,   360,   361,   362,   363,   364,   365,
     366,     0,   367,   368,   369,   370,     0,   371,   372,     0,
     373,     0,   374,   375,   376,   377,   378,   379,     0,   380,
       0,     0,   381,   382,   383,     0,     0,   384,   385,     0,
     386,     0,   387,   388,   389,   390,   391,   392,   393,   394,
       0,   395,   396,   397,   398,   399,   400,   401,     0,   402,
     403,   404,   405,   406,   407,   408,   409,   410,   411,   412,
     413,   414,     0,   415,   416,   417,   418,   419,   420,   421,
     422,   423,   424,   425,     0,   426,   427,     0,   428,   429,
     430,   431,   432,   433,   434,   435,   436,   437,   438,     0,
     439,   440,   441,   442,   671,     0,   444,   445,   446,   447,
       0,   448,   449,   450,     0,   451,   452,   453,   454,   455,
     456,   457,   458,   459,   460,   461,     0,   462,   463,     0,
     464,   465,   466,   467,   468,   469,     0,   672,   471,     0,
       0,   673,   473,   474,   475,     0,   476,   477,   478,   479,
     480,   481,   482,     0,     0,   483,   484,   485,   486,   487,
       0,     0,   488,   489,   490,   491,   492,   493,   494,     0,
     495,     0,   496,   497,   498,   499,     0,     0,   500,     0,
       0,   501,   502,   503,   504,   505,   506,   507,   508,   509,
     510,   511,   512,   513,   514,   515,   516,   517,   518,   210,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
     211,   212,   213,   214,   215,   216,   217,   218,   703,   220,
     221,   222,     0,     0,     0,     0,   223,     0,     0,     0,
     224,   225,     0,   226,   227,     0,   228,   229,   230,   231,
     232,     0,   233,   234,     0,   235,   236,   237,   238,   239,
       0,     0,   240,   241,   242,   243,   244,     0,   245,   246,
     247,   248,   249,     0,     0,     0,   250,   251,   252,   253,
       0,   254,   255,     0,   256,   257,   258,   259,   260,   261,
       0,     0,   262,   263,     0,     0,     0,     0,     0,     0,
       0,   264,   265,   266,   267,   268,   269,   270,   271,   272,
       0,   273,     0,   274,   275,   276,   277,   278,     0,   279,
     280,   281,     0,     0,   282,   283,   284,   285,   286,     0,
     287,   288,   289,     0,   290,   291,   292,     0,   293,   294,
     295,   296,   297,   298,   299,   300,   301,     0,   302,     0,
     303,   304,   305,   306,     0,   307,     0,   308,     0,     0,
       0,   309,   310,   311,     0,   312,   313,     0,   314,     0,
     315,   316,   317,   318,   319,     0,   320,   321,   322,     0,
     323,   324,   325,   326,   327,   328,     0,   329,     0,   330,
     331,   332,   333,   334,   335,   336,     0,   337,     0,   338,
       0,     0,   339,     0,   340,   341,   342,   343,   344,     0,
     345,   346,     0,   347,   348,     0,   349,     0,     0,   350,
     351,   352,     0,     0,   353,   354,   355,   356,   357,   358,
     359,   360,   361,   362,   363,   364,   365,   366,     0,   367,
     368,   369,   370,     0,   371,   372,     0,   373,     0,   374,
     375,   376,   377,   378,   379,     0,   380,     0,     0,   381,
     382,   383,     0,     0,   384,   385,     0,   386,     0,   387,
     388,   389,   390,   391,   392,   393,   394,     0,   395,   396,
     397,   398,   399,   400,   401,     0,   402,   403,   404,   405,
     406,   407,   408,   409,   410,   411,   412,   413,   414,     0,
     415,   416,   417,   418,   419,   420,   421,   422,   423,   424,
     425,     0,   426,   427,     0,   428,   429,   430,   431,   432,
     433,   434,   435,   436,   437,   438,     0,   439,   440,   441,
     442,   704,     0,   444,   445,   446,   447,     0,   448,   449,
     450,     0,   451,   452,   453,   454,   455,   456,   457,   458,
     459,   460,   461,     0,   462,   463,     0,   464,   465,   466,
     467,   468,   469,     0,   705,   471,     0,     0,   706,   473,
     474,   475,     0,   476,   477,   478,   479,   480,   481,   482,
       0,     0,   483,   484,   485,   486,   487,     0,     0,   488,
     489,   490,   491,   492,   493,   494,     0,   495,     0,   496,
     497,   498,   499,     0,     0,   500,     0,     0,   501,   502,
     503,   504,   505,   506,   507,   508,   509,   510,   511,   512,
     513,   514,   515,   516,   517,   518,   210,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,   211,   212,   213,
     214,   215,   216,   217,   218,     0,   220,   221,   222,     0,
       0,     0,     0,   223,     0,     0,     0,   224,   225,     0,
     226,   227,     0,   228,   229,   230,   231,   232,     0,   233,
     234,     0,   235,   236,   237,   238,   239,     0,     0,   240,
     241,   242,   243,   244,     0,   245,   246,   247,   248,   249,
       0,     0,     0,   250,   251,   252,   253,     0,   254,   255,
       0,   256,   257,   258,   259,   260,   261,     0,     0,   262,
     263,     0,     0,     0,     0,     0,     0,     0,   264,   265,
     266,   267,   268,   269,   270,   271,   272,     0,   273,     0,
     274,   275,   276,   277,   278,     0,   279,   280,   281,     0,
       0,   282,   283,   284,   285,   286,     0,   287,   288,   289,
       0,   290,   291,   292,     0,   293,   294,   295,   296,   297,
     298,   299,   300,   301,     0,   302,     0,   303,   304,   305,
     306,     0,   307,     0,   308,     0,     0,     0,   309,   310,
     311,     0,   312,   313,     0,   314,     0,   315,   316,   317,
     318,   319,     0,   320,   321,   322,     0,   323,   324,   325,
     326,   327,   328,     0,   329,     0,   330,   331,   332,   333,
     334,   335,   336,     0,   337,     0,   338,     0,     0,   339,
       0,   340,   341,   342,   343,   344,     0,   345,   346,     0,
     347,   348,     0,   349,     0,     0,   350,   351,   352,     0,
       0,   353,   354,   355,   356,   357,   358,   359,   360,   361,
     362,   363,   364,   365,   366,     0,   367,   368,   369,   370,
       0,   371,   372,     0,   373,     0,   374,   375,   376,   377,
     378,   379,     0,   380,     0,   709,   381,   382,   383,     0,
       0,   384,   385,     0,   386,     0,   387,   388,   389,   390,
     391,   392,   393,   394,     0,   395,   396,   397,   398,   399,
     400,   401,     0,   402,   403,   404,   405,   406,   407,   408,
     409,   410,   411,   412,   413,   414,     0,   415,   416,   417,
     418,   419,   420,   421,   422,   423,   424,   425,     0,   426,
     427,     0,   428,   429,   430,   431,   432,   433,   434,   435,
     436,   437,   438,     0,   439,   440,   441,   442,   443,     0,
     444,   445,   446,   447,     0,   448,   449,   450,     0,   451,
     452,   453,   454,   455,   456,   457,   458,   459,   460,   461,
       0,   462,   463,     0,   464,   465,   466,   467,   468,   469,
       0,   470,   471,     0,     0,   472,   473,   474,   475,     0,
     476,   477,   478,   479,   480,   481,   482,     0,     0,   483,
     484,   485,   486,   487,     0,     0,   488,   489,   490,   491,
     492,   493,   494,     0,   495,     0,   496,   497,   498,   499,
       0,     0,   500,     0,     0,   501,   502,   503,   504,   505,
     506,   507,   508,   509,   510,   511,   512,   513,   514,   515,
     516,   517,   518,   210,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,   211,   212,   213,   214,   215,   216,
     217,   218,   793,   220,   221,   222,     0,     0,     0,     0,
     223,     0,     0,     0,   224,   225,     0,   226,   227,     0,
     228,   229,   230,   231,   232,     0,   233,   234,     0,   235,
     236,   237,   238,   239,     0,     0,   240,   241,   242,   243,
     244,     0,   245,   246,   247,   248,   249,     0,     0,     0,
     250,   251,   252,   253,     0,   254,   255,     0,   256,   257,
     258,   259,   260,   261,     0,     0,   262,   263,     0,     0,
       0,     0,     0,     0,     0,   264,   265,   266,   267,   268,
     269,   270,   271,   272,     0,   273,     0,   274,   275,   276,
     277,   278,     0,   279,   280,   281,     0,     0,   282,   283,
     284,   285,   286,     0,   287,   288,   289,     0,   290,   291,
     292,     0,   293,   294,   295,   296,   297,   298,   299,   300,
     301,     0,   302,     0,   303,   304,   305,   306,     0,   307,
       0,   308,     0,     0,     0,   309,   310,   311,     0,   312,
     313,     0,   314,     0,   315,   316,   317,   318,   794,     0,
     320,   321,   322,     0,   323,   324,   325,   326,   327,   328,
       0,   329,     0,   330,   331,   332,   333,   334,   335,   336,
       0,   337,     0,   338,     0,     0,   339,     0,   340,   341,
     342,   343,   344,     0,   345,   346,     0,   347,   348,     0,
     349,     0,     0,   350,   351,   352,     0,     0,   353,   354,
     355,   356,   357,   358,   359,   360,   361,   362,   363,   364,
     365,   366,     0,   367,   368,   369,   370,     0,   371,   372,
       0,   373,     0,   374,   375,   376,   377,   378,   379,     0,
     380,     0,     0,   381,   382,   383,     0,     0,   384,   385,
       0,   386,     0,   387,   388,   389,   390,   391,   392,   393,
     394,     0,   395,   396,   397,   398,   399,   400,   401,     0,
     402,   403,   404,   405,   406,   407,   408,   409,   410,   411,
     412,   413,   414,     0,   415,   416,   417,   418,   419,   420,
     421,   422,   423,   424,   425,     0,   426,   427,     0,   428,
     429,   430,   431,   432,   433,   434,   435,   436,   437,   438,
       0,   439,   440,   441,   442,   443,     0,   444,   445,   446,
     447,     0,   448,   449,   450,     0,   451,   452,   453,   454,
     455,   456,   457,   458,   459,   460,   461,     0,   462,   463,
       0,   464,   465,   466,   467,   468,   469,     0,   470,   471,
       0,     0,   472,   473,   474,   475,     0,   476,   477,   478,
     479,   480,   481,   482,     0,     0,   483,   484,   485,   486,
     487,     0,     0,   488,   489,   490,   491,   492,   493,   494,
       0,   495,     0,   496,   497,   498,   499,     0,     0,   500,
       0,     0,   501,   502,   503,   504,   505,   506,   507,   508,
     509,   510,   511,   512,   513,   514,   515,   516,   517,   518,
     210,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,   211,   212,   213,   214,   215,   216,   217,   218,   921,
     220,   221,   222,     0,     0,     0,     0,   223,     0,     0,
       0,   224,   225,     0,   226,   227,     0,   228,   229,   230,
     231,   232,     0,   233,   234,     0,   235,   236,   237,   238,
     239,     0,     0,   240,   241,   242,   243,   244,     0,   245,
     246,   247,   248,   249,     0,     0,     0,   250,   251,   252,
     253,     0,   254,   255,     0,   256,   257,   258,   259,   260,
     261,     0,     0,   262,   263,     0,     0,     0,     0,     0,
       0,     0,   264,   265,   266,   267,   268,   269,   270,   271,
     272,     0,   273,     0,   274,   275,   276,   277,   278,     0,
     279,   280,   281,     0,     0,   282,   283,   284,   285,   286,
       0,   287,   288,   289,     0,   290,   291,   292,     0,   293,
     294,   295,   296,   297,   298,   299,   300,   301,     0,   302,
       0,   303,   304,   305,   306,     0,   307,     0,   308,     0,
       0,     0,   309,   310,   311,     0,   312,   313,     0,   314,
       0,   315,   316,   317,   318,   319,     0,   320,   321,   322,
       0,   323,   324,   325,   326,   327,   328,     0,   329,     0,
     330,   331,   332,   333,   334,   335,   336,     0,   337,     0,
     338,     0,     0,   339,     0,   340,   341,   342,   343,   344,
       0,   345,   346,     0,   347,   348,     0,   349,     0,     0,
     350,   351,   352,     0,     0,   353,   354,   355,   356,   357,
     358,   359,   360,   361,   362,   363,   364,   365,   366,     0,
     367,   368,   369,   370,     0,   371,   372,     0,   373,     0,
     374,   375,   376,   377,   378,   379,     0,   380,     0,     0,
     381,   382,   383,     0,     0,   384,   385,     0,   386,     0,
     387,   388,   389,   390,   391,   392,   393,   394,     0,   395,
     396,   397,   398,   399,   400,   401,     0,   402,   403,   404,
     405,   406,   407,   408,   409,   410,   411,   412,   413,   414,
       0,   415,   416,   417,   418,   419,   420,   421,   422,   423,
     424,   425,     0,   426,   427,     0,   428,   429,   430,   431,
     432,   433,   434,   435,   436,   437,   438,     0,   439,   440,
     441,   442,   443,     0,   444,   445,   446,   447,     0,   448,
     449,   450,     0,   451,   452,   453,   454,   455,   456,   457,
     458,   459,   460,   461,     0,   462,   463,     0,   464,   465,
     466,   467,   468,   469,     0,   470,   471,     0,     0,   472,
     473,   474,   475,     0,   476,   477,   478,   479,   480,   481,
     482,     0,     0,   483,   484,   485,   486,   487,     0,     0,
     488,   489,   490,   491,   492,   493,   494,     0,   495,     0,
     496,   497,   498,   499,     0,     0,   500,     0,     0,   501,
     502,   503,   504,   505,   506,   507,   508,   509,   510,   511,
     512,   513,   514,   515,   516,   517,   518,   210,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,   211,   212,
     213,   214,   215,   216,   217,   218,  1133,   220,   221,   222,
       0,     0,     0,     0,   223,     0,     0,     0,   224,   225,
       0,   226,   227,     0,   228,   229,   230,   231,   232,     0,
     233,   234,     0,   235,   236,   237,   238,   239,     0,     0,
     240,   241,   242,   243,   244,     0,   245,   246,   247,   248,
     249,     0,     0,     0,   250,   251,   252,   253,     0,   254,
     255,     0,   256,   257,   258,   259,   260,   261,     0,     0,
     262,   263,     0,     0,     0,     0,     0,     0,     0,   264,
     265,   266,   267,   268,   269,   270,   271,   272,     0,   273,
       0,   274,   275,   276,   277,   278,     0,   279,   280,   281,
       0,     0,   282,   283,   284,   285,   286,     0,   287,   288,
     289,     0,   290,   291,   292,     0,   293,   294,   295,   296,
     297,   298,   299,   300,   301,     0,   302,     0,   303,   304,
     305,   306,     0,   307,     0,   308,     0,     0,     0,   309,
     310,   311,     0,   312,   313,     0,   314,     0,   315,   316,
     317,   318,   319,     0,   320,   321,   322,     0,   323,   324,
     325,   326,   327,   328,     0,   329,     0,   330,   331,   332,
     333,   334,   335,   336,     0,   337,     0,   338,     0,     0,
     339,     0,   340,   341,   342,   343,   344,     0,   345,   346,
       0,   347,   348,     0,   349,     0,     0,   350,   351,   352,
       0,     0,   353,   354,   355,   356,   357,   358,   359,   360,
     361,   362,   363,   364,   365,   366,     0,   367,   368,   369,
     370,     0,   371,   372,     0,   373,     0,   374,   375,   376,
     377,   378,   379,     0,   380,     0,     0,   381,   382,   383,
       0,     0,   384,   385,     0,   386,     0,   387,   388,   389,
     390,   391,   392,   393,   394,     0,   395,   396,   397,   398,
     399,   400,   401,     0,   402,   403,   404,   405,   406,   407,
     408,   409,   410,   411,   412,   413,   414,     0,   415,   416,
     417,   418,   419,   420,   421,   422,   423,   424,   425,     0,
     426,   427,     0,   428,   429,   430,   431,   432,   433,   434,
     435,   436,   437,   438,     0,   439,   440,   441,   442,   443,
       0,   444,   445,   446,   447,     0,   448,   449,   450,     0,
     451,   452,   453,   454,   455,   456,   457,   458,   459,   460,
     461,     0,   462,   463,     0,   464,   465,   466,   467,   468,
     469,     0,   470,   471,     0,     0,   472,   473,   474,   475,
       0,   476,   477,   478,   479,   480,   481,   482,     0,     0,
     483,   484,   485,   486,   487,     0,     0,   488,   489,   490,
     491,   492,   493,   494,     0,   495,     0,   496,   497,   498,
     499,     0,     0,   500,     0,     0,   501,   502,   503,   504,
     505,   506,   507,   508,   509,   510,   511,   512,   513,   514,
     515,   516,   517,   518,   210,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,   211,   212,   213,   214,   215,
     216,   217,   218,     0,   220,   221,   222,     0,     0,     0,
       0,   223,     0,     0,     0,   224,   225,     0,   226,   227,
    1144,   228,   229,   230,   231,   232,     0,   233,   234,     0,
     235,   236,   237,   238,   239,     0,     0,   689,   241,   242,
     243,  1145,     0,   245,   246,   247,   248,   249,     0,     0,
       0,   250,   251,   252,   253,     0,   254,   255,     0,   256,
     257,   258,   259,   260,   261,     0,     0,   262,   263,     0,
       0,     0,     0,     0,     0,     0,   264,   265,   266,   267,
     268,   269,   270,   271,   272,     0,   273,     0,   274,   275,
     276,   277,   278,     0,   279,   280,   281,     0,     0,   282,
     283,   284,   285,   286,     0,   287,   288,   289,     0,   290,
     291,   292,     0,   293,   294,   295,   296,   297,   298,   299,
     300,   301,     0,   302,     0,   303,   304,   305,   306,     0,
     307,     0,   308,     0,     0,     0,   309,   310,   311,     0,
     312,   313,     0,   314,     0,   315,   316,   317,   318,   319,
       0,   320,   321,   322,     0,   323,   324,   325,   326,   327,
     328,     0,   329,     0,   330,   331,   332,   333,   334,   335,
     336,     0,   337,     0,   338,     0,     0,   339,     0,   340,
     341,   342,   343,   344,     0,   345,   346,     0,   347,   348,
       0,   349,     0,     0,   350,   351,   352,     0,     0,   353,
     354,   355,   356,   357,   358,   359,   360,   361,   362,   363,
     364,   692,   366,     0,   367,   368,   369,   370,     0,   371,
     372,     0,   373,     0,   374,   375,   376,   377,   378,   379,
       0,   380,     0,     0,   381,   382,   383,     0,     0,   384,
     385,     0,   386,     0,   387,   388,   389,   390,   391,   392,
     393,   394,     0,   395,   396,   397,   398,   399,   400,   401,
       0,   402,   403,   404,   405,   406,   407,   408,   409,   410,
     411,   412,   413,   414,     0,   415,   416,   417,   418,   419,
     420,   421,   422,   423,   424,   425,     0,   426,   427,     0,
     693,   429,   430,   431,   432,   433,   694,   435,   436,   437,
     438,     0,   439,   440,   441,   442,  1137,     0,   444,   445,
     446,   447,     0,   448,   449,   450,     0,   451,   452,   453,
     454,   455,   456,   457,   458,   459,   460,   461,     0,   462,
     463,     0,   464,   465,   466,   467,   468,   469,     0,   696,
     471,     0,     0,   697,   473,   474,   475,     0,   476,   477,
     478,   479,   480,   481,   482,     0,     0,   483,   484,   485,
     486,   487,     0,     0,   488,   489,   490,   491,   492,   493,
     494,     0,   495,     0,   496,   497,   498,   499,     0,     0,
     500,     0,     0,   501,   502,   503,   504,   505,   698,   507,
     508,   509,   510,   511,   512,   513,   514,   515,   516,   517,
     518,   210,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,   211,   212,   213,   214,   215,   216,   217,   218,
       0,   220,   221,   222,     0,     0,     0,     0,   223,     0,
       0,     0,   224,   225,     0,   226,   227,     0,   228,   229,
     230,   231,   232,     0,   233,   234,     0,   235,   236,   237,
     238,   239,     0,     0,   240,   241,   242,   243,   244,     0,
     245,   246,   247,   248,   249,     0,     0,     0,   250,   251,
     252,   253,     0,   254,   255,     0,   256,   257,   258,   259,
     260,   261,     0,     0,   262,   263,     0,     0,     0,     0,
       0,     0,     0,   264,   265,   266,   267,   268,   269,   270,
     271,   272,     0,   273,     0,   274,   275,   276,   277,   278,
       0,   279,   280,   281,     0,     0,   282,   283,   284,   285,
     286,     0,   287,   288,   289,     0,   290,   291,   292,     0,
     293,   294,   295,   296,   297,   298,   299,   300,   301,     0,
     302,     0,   303,   304,   305,   306,     0,   307,     0,   308,
       0,     0,     0,   309,   310,   311,     0,   312,   313,     0,
     314,     0,   315,   316,   317,   318,  1243,     0,   320,   321,
     322,     0,   323,   324,   325,   326,   327,   328,     0,   329,
       0,   330,   331,   332,   333,   334,   335,   336,     0,   337,
       0,   338,     0,     0,   339,     0,   340,   341,   342,   343,
     344,     0,   345,   346,     0,   347,   348,     0,   349,     0,
       0,   350,   351,   352,     0,     0,   353,   354,   355,   356,
     357,   358,   359,   360,   361,   362,   363,   364,   365,   366,
       0,   367,   368,   369,   370,     0,   371,   372,     0,   373,
       0,   374,   375,   376,   377,   378,   379,     0,   380,     0,
     709,   381,   382,   383,     0,     0,   384,   385,     0,   386,
       0,   387,   388,   389,   390,   391,   392,   393,   394,     0,
     395,   396,   397,   398,   399,   400,   401,     0,   402,   403,
     404,   405,   406,   407,   408,   409,   410,   411,   412,   413,
     414,     0,   415,   416,   417,   418,   419,   420,   421,   422,
     423,   424,   425,     0,   426,   427,     0,   428,   429,   430,
     431,   432,   433,   434,   435,   436,   437,   438,     0,   439,
     440,   441,   442,   443,     0,   444,   445,   446,   447,     0,
     448,   449,   450,     0,   451,   452,   453,   454,   455,   456,
     457,   458,   459,   460,   461,     0,   462,   463,     0,   464,
     465,   466,   467,   468,   469,     0,   470,   471,     0,     0,
     472,   473,   474,   475,     0,   476,   477,   478,   479,   480,
     481,   482,     0,     0,   483,   484,   485,   486,   487,     0,
       0,   488,   489,   490,   491,   492,   493,   494,     0,   495,
       0,   496,   497,   498,   499,     0,     0,   500,     0,     0,
     501,   502,   503,   504,   505,   506,   507,   508,   509,   510,
     511,   512,   513,   514,   515,   516,   517,   518,   210,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,   211,
     212,   213,   214,   215,   216,   217,   218,  1295,   220,   221,
     222,     0,     0,     0,     0,   223,     0,     0,     0,   224,
     225,     0,   226,   227,     0,   228,   229,   230,   231,   232,
       0,   233,   234,     0,   235,   236,   237,   238,   239,     0,
       0,   240,   241,   242,   243,   244,     0,   245,   246,   247,
     248,   249,     0,     0,     0,   250,   251,   252,   253,     0,
     254,   255,     0,   256,   257,   258,   259,   260,   261,     0,
       0,   262,   263,     0,     0,     0,     0,     0,     0,     0,
     264,   265,   266,   267,   268,   269,   270,   271,   272,     0,
     273,     0,   274,   275,   276,   277,   278,     0,   279,   280,
     281,     0,     0,   282,   283,   284,   285,   286,     0,   287,
     288,   289,     0,   290,   291,   292,     0,   293,   294,   295,
     296,   297,   298,   299,   300,   301,     0,   302,     0,   303,
     304,   305,   306,     0,   307,     0,   308,     0,     0,     0,
     309,   310,   311,     0,   312,   313,     0,   314,     0,   315,
     316,   317,   318,  1296,     0,   320,   321,   322,     0,   323,
     324,   325,   326,   327,   328,     0,   329,     0,   330,   331,
     332,   333,   334,   335,   336,     0,   337,     0,   338,     0,
       0,   339,     0,   340,   341,   342,   343,   344,     0,   345,
     346,     0,   347,   348,     0,   349,     0,     0,   350,   351,
     352,     0,     0,   353,   354,   355,   356,   357,   358,   359,
     360,   361,   362,   363,   364,   365,   366,     0,   367,   368,
     369,   370,     0,   371,   372,     0,   373,     0,   374,   375,
     376,   377,   378,   379,     0,   380,     0,     0,   381,   382,
     383,     0,     0,   384,   385,     0,   386,     0,   387,   388,
     389,   390,   391,   392,   393,   394,     0,   395,   396,   397,
     398,   399,   400,   401,     0,   402,   403,   404,   405,   406,
     407,   408,   409,   410,   411,   412,   413,   414,     0,   415,
     416,   417,   418,   419,   420,   421,   422,   423,   424,   425,
       0,   426,   427,     0,   428,   429,   430,   431,   432,   433,
     434,   435,   436,   437,   438,     0,   439,   440,   441,   442,
     443,     0,   444,   445,   446,   447,     0,   448,   449,   450,
       0,   451,   452,   453,   454,   455,   456,   457,   458,   459,
     460,   461,     0,   462,   463,     0,   464,   465,   466,   467,
     468,   469,     0,   470,   471,     0,     0,   472,   473,   474,
     475,     0,   476,   477,   478,   479,   480,   481,   482,     0,
       0,   483,   484,   485,   486,   487,     0,     0,   488,   489,
     490,   491,   492,   493,   494,     0,   495,     0,   496,   497,
     498,   499,     0,     0,   500,     0,     0,   501,   502,   503,
     504,   505,   506,   507,   508,   509,   510,   511,   512,   513,
     514,   515,   516,   517,   518,   210,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,   211,   212,   213,   214,
     215,   216,   217,   218,   670,   220,   221,   222,     0,     0,
       0,     0,   223,     0,     0,     0,   224,   225,     0,   226,
     227,     0,   228,   229,   230,   231,   232,     0,   233,   234,
       0,   235,   236,   237,   238,   239,     0,     0,   240,   241,
     242,   243,   244,     0,   245,   246,   247,   248,   249,     0,
       0,     0,   250,   251,   252,   253,     0,   254,   255,     0,
     256,   257,   258,   259,   260,   261,     0,     0,   262,   263,
       0,     0,     0,     0,     0,     0,     0,   264,   265,   266,
     267,   268,   269,   270,   271,   272,     0,   273,     0,   274,
     275,   276,   277,   278,     0,   279,   280,   281,     0,     0,
     282,   283,   284,   285,   286,     0,   287,   288,   289,     0,
     290,   291,   292,     0,   293,   294,   295,   296,   297,   298,
     299,   300,   301,     0,   302,     0,   303,   304,   305,   306,
       0,   307,     0,   308,     0,     0,     0,   309,   310,   311,
       0,   312,   313,     0,   314,     0,   315,   316,   317,   318,
     319,     0,   320,   321,   322,     0,   323,   324,   325,   326,
     327,   328,     0,   329,     0,   330,   331,   332,   333,   334,
     335,   336,     0,   337,     0,   338,     0,     0,   339,     0,
     340,   341,   342,   343,   344,     0,   345,   346,     0,   347,
     348,     0,   349,     0,     0,   350,   351,   352,     0,     0,
     353,   354,   355,   356,   357,   358,   359,   360,   361,   362,
     363,   364,   365,   366,     0,   367,   368,   369,   370,     0,
     371,   372,     0,   373,     0,   374,   375,   376,   377,   378,
     379,     0,   380,     0,     0,   381,   382,   383,     0,     0,
     384,   385,     0,   386,     0,   387,   388,   389,   390,   391,
     392,   393,   394,     0,   395,   396,   397,   398,   399,   400,
     401,     0,   402,   403,   404,   405,   406,   407,   408,   409,
     410,   411,   412,   413,   414,     0,   415,   416,   417,   418,
     419,   420,   421,   422,   423,   424,   425,     0,   426,   427,
       0,   428,   429,   430,   431,   432,   433,   434,   435,   436,
     437,   438,     0,   439,   440,   441,   442,   443,     0,   444,
     445,   446,   447,     0,   448,   449,   450,     0,   451,   452,
     453,   454,   455,   456,   457,   458,   459,   460,   461,     0,
     462,   463,     0,   464,   465,   466,   467,   468,   469,     0,
     470,   471,     0,     0,   472,   473,   474,   475,     0,   476,
     477,   478,   479,   480,   481,   482,     0,     0,   483,   484,
     485,   486,   487,     0,     0,   488,   489,   490,   491,   492,
     493,   494,     0,   495,     0,   496,   497,   498,   499,     0,
       0,   500,     0,     0,   501,   502,   503,   504,   505,   506,
     507,   508,   509,   510,   511,   512,   513,   514,   515,   516,
     517,   518,   210,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,   211,   212,   213,   214,   215,   216,   217,
     218,     0,   220,   221,   222,     0,     0,     0,     0,   223,
       0,     0,     0,   224,   225,     0,   226,   227,     0,   228,
     229,   230,   231,   232,     0,   233,   234,     0,   235,   236,
     237,   238,   239,     0,     0,   240,   241,   242,   243,   244,
       0,   245,   246,   247,   248,   249,     0,     0,     0,   250,
     251,   252,   253,     0,   254,   255,     0,   256,   257,   258,
     259,   260,   261,     0,     0,   262,   263,     0,     0,     0,
       0,     0,     0,     0,   264,   265,   266,   267,   268,   269,
     270,   271,   272,     0,   273,     0,   274,   275,   276,   277,
     278,     0,   279,   280,   281,     0,     0,   282,   283,   284,
     285,   286,     0,   287,   288,   289,     0,   290,   291,   292,
       0,   293,   294,   295,   296,   297,   298,   299,   300,   301,
       0,   302,     0,   303,   304,   305,   306,     0,   307,     0,
     308,     0,     0,     0,   309,   310,  2465,     0,   312,   313,
       0,   314,     0,   315,   316,   317,   318,   319,     0,   320,
     321,   322,     0,   323,   324,   325,   326,   327,   328,     0,
     329,     0,   330,   331,   332,   333,   334,   335,   336,     0,
     337,     0,   338,     0,     0,   339,     0,   340,   341,   342,
     343,   344,     0,   345,   346,     0,   347,   348,     0,   349,
       0,     0,   350,   351,  2466,     0,     0,   353,   354,   355,
     356,   357,   358,   359,   360,   361,   362,   363,   364,   365,
     366,     0,   367,   368,   369,   370,     0,   371,   372,     0,
     373,     0,   374,   375,   376,   377,   378,   379,     0,   380,
       0,     0,   381,   382,   383,     0,     0,   384,   385,     0,
     386,     0,   387,   388,   389,   390,   391,   392,   393,   394,
       0,   395,   396,   397,   398,   399,   400,   401,     0,   402,
     403,   404,   405,   406,   407,   408,   409,   410,   411,   412,
     413,   414,     0,   415,   416,   417,   418,   419,   420,   421,
     422,   423,   424,   425,     0,   426,   427,     0,   428,   429,
     430,   431,   432,   433,   434,   435,   436,   437,   438,     0,
     439,   440,   441,   442,   443,     0,   444,   445,   446,   447,
       0,   448,   449,   450,     0,   451,   452,   453,   454,   455,
     456,   457,   458,   459,   460,   461,     0,   462,   463,  2467,
     464,   465,  2468,   467,  2469,   469,     0,   470,   471,     0,
       0,   472,   473,   474,   475,     0,   476,   477,   478,   479,
     480,   481,   482,     0,     0,   483,   484,  2470,   486,   487,
       0,     0,   488,   489,   490,   491,   492,   493,   494,     0,
     495,     0,   496,   497,   498,   499,     0,     0,   500,     0,
       0,   501,   502,   503,   504,   505,   506,   507,   508,   509,
     510,   511,   512,   513,   514,   515,   516,   517,   518,   210,
       0,   574,     0,     0,     0,     0,     0,     0,     0,     0,
     211,   212,   213,   214,   215,   216,   217,   218,     0,   220,
     221,   222,     0,     0,     0,     0,   223,     0,     0,     0,
     224,   225,     0,   226,   227,     0,   228,   229,   230,   231,
     232,     0,   233,   234,     0,   235,   236,   237,   238,   239,
       0,     0,   240,   241,   242,   243,   244,     0,   245,   246,
     247,   248,   249,     0,     0,     0,   250,   251,   252,   253,
       0,   254,   255,     0,   256,   257,   258,   259,   260,   261,
       0,     0,   262,   263,     0,     0,     0,     0,     0,     0,
       0,   264,   265,   266,   267,   268,   269,   270,   271,   272,
       0,   273,     0,   274,   275,   276,   277,   278,     0,   279,
     280,   281,     0,     0,   282,   283,   284,   285,   286,     0,
     287,   288,   289,     0,   290,   291,   292,     0,   293,   294,
     295,   296,   297,   298,   299,   300,   301,     0,   302,     0,
     303,   304,   305,   306,     0,   307,     0,   308,     0,     0,
       0,   309,   310,   311,     0,   312,   313,     0,   314,     0,
     315,   316,   317,   318,   319,     0,   320,   321,   322,     0,
     323,   324,   325,   326,   327,   328,     0,   329,     0,   330,
     331,   332,   333,   334,   335,   336,     0,   337,     0,   338,
       0,     0,   339,     0,   340,   341,   342,   343,   344,     0,
     345,   346,     0,   347,   348,     0,   349,     0,     0,   350,
     351,   352,     0,     0,   353,   354,   355,   356,   357,   358,
     359,   360,   361,   362,   363,   364,   365,   366,     0,   367,
     368,   369,   370,     0,   371,   372,     0,   373,     0,   374,
     375,   376,   377,   378,   379,     0,   380,     0,     0,   381,
     382,   383,     0,     0,   384,   385,     0,   386,     0,   387,
     388,   389,   390,   391,   392,   393,   394,     0,   395,   396,
     397,   398,   399,   400,   401,     0,   402,   403,   404,   405,
     406,   407,   408,   409,   410,   411,   412,   413,   414,     0,
     415,   416,   417,   418,   419,   420,   421,   422,   423,   424,
     425,     0,   426,   427,     0,   428,   429,   430,   431,   432,
     433,   434,   435,   436,   437,   438,     0,   439,   440,   441,
     442,   443,     0,   444,   445,   446,   447,     0,   448,   449,
     450,     0,   451,   452,   453,   454,   455,   456,   457,   458,
     459,   460,   461,     0,   462,   463,     0,   464,   465,   466,
     467,   468,   469,     0,   470,   471,     0,     0,   472,   473,
     474,   475,     0,   476,   477,   478,   479,   480,   481,   482,
       0,     0,   483,   484,   485,   486,   487,     0,     0,   488,
     489,   490,   491,   492,   493,   494,     0,   495,     0,   496,
     497,   498,   499,     0,     0,   500,     0,     0,   501,   502,
     503,   504,   505,   506,   507,   508,   509,   510,   511,   512,
     513,   514,   515,   516,   517,   518,   210,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,   211,   212,   213,
     214,   215,   216,   217,   218,     0,   220,   221,   222,     0,
       0,     0,     0,   223,     0,  3577,     0,   224,   225,     0,
     226,   227,     0,   228,   229,   230,   231,   232,     0,   233,
     234,     0,   235,   236,   237,   238,   239,     0,     0,   240,
     241,   242,   243,   244,     0,   245,   246,   247,   248,   249,
       0,     0,     0,   250,   251,   252,   253,     0,   254,   255,
       0,   256,   257,   258,   259,   260,   261,     0,     0,   262,
     263,     0,     0,     0,     0,     0,     0,     0,   264,   265,
     266,   267,   268,   269,   270,   271,   272,     0,   273,     0,
     274,   275,   276,   277,   278,     0,   279,   280,   281,     0,
       0,   282,   283,   284,   285,   286,     0,   287,   288,   289,
       0,   290,   291,   292,     0,   293,   294,   295,   296,   297,
     298,   299,   300,   301,     0,   302,     0,   303,   304,   305,
     306,     0,   307,     0,   308,     0,     0,     0,   309,   310,
     311,     0,   312,   313,     0,   314,     0,   315,   316,   317,
     318,   319,     0,   320,   321,   322,     0,   323,   324,   325,
     326,   327,   328,     0,   329,     0,   330,   331,   332,   333,
     334,   335,   336,     0,   337,     0,   338,     0,     0,   339,
       0,   340,   341,   342,   343,   344,     0,   345,   346,     0,
     347,   348,     0,   349,     0,     0,   350,   351,   352,     0,
       0,   353,   354,   355,   356,   357,   358,   359,   360,   361,
     362,   363,   364,   365,   366,     0,   367,   368,   369,   370,
       0,   371,   372,     0,   373,     0,   374,   375,   376,   377,
     378,   379,     0,   380,     0,     0,   381,   382,   383,     0,
       0,   384,   385,     0,   386,     0,   387,   388,   389,   390,
     391,   392,   393,   394,     0,   395,   396,   397,   398,   399,
     400,   401,     0,   402,   403,   404,   405,   406,   407,   408,
     409,   410,   411,   412,   413,   414,     0,   415,   416,   417,
     418,   419,   420,   421,   422,   423,   424,   425,     0,   426,
     427,     0,   428,   429,   430,   431,   432,   433,   434,   435,
     436,   437,   438,     0,   439,   440,   441,   442,   443,     0,
     444,   445,   446,   447,     0,   448,   449,   450,     0,   451,
     452,   453,   454,   455,   456,   457,   458,   459,   460,   461,
       0,   462,   463,     0,   464,   465,   466,   467,   468,   469,
       0,   470,   471,     0,     0,   472,   473,   474,   475,     0,
     476,   477,   478,   479,   480,   481,   482,     0,     0,   483,
     484,   485,   486,   487,     0,     0,   488,   489,   490,   491,
     492,   493,   494,     0,   495,     0,   496,   497,   498,   499,
       0,     0,   500,     0,     0,   501,   502,   503,   504,   505,
     506,   507,   508,   509,   510,   511,   512,   513,   514,   515,
     516,   517,   518,   210,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,   211,   212,   213,   214,   215,   216,
     217,   218,     0,   220,   221,   222,     0,     0,     0,     0,
     223,     0,  3591,     0,   224,   225,     0,   226,   227,     0,
     228,   229,   230,   231,   232,     0,   233,   234,     0,   235,
     236,   237,   238,   239,     0,     0,   240,   241,   242,   243,
     244,     0,   245,   246,   247,   248,   249,     0,     0,     0,
     250,   251,   252,   253,     0,   254,   255,     0,   256,   257,
     258,   259,   260,   261,     0,     0,   262,   263,     0,     0,
       0,     0,     0,     0,     0,   264,   265,   266,   267,   268,
     269,   270,   271,   272,     0,   273,     0,   274,   275,   276,
     277,   278,     0,   279,   280,   281,     0,     0,   282,   283,
     284,   285,   286,     0,   287,   288,   289,     0,   290,   291,
     292,     0,   293,   294,   295,   296,   297,   298,   299,   300,
     301,     0,   302,     0,   303,   304,   305,   306,     0,   307,
       0,   308,     0,     0,     0,   309,   310,   311,     0,   312,
     313,     0,   314,     0,   315,   316,   317,   318,   319,     0,
     320,   321,   322,     0,   323,   324,   325,   326,   327,   328,
       0,   329,     0,   330,   331,   332,   333,   334,   335,   336,
       0,   337,     0,   338,     0,     0,   339,     0,   340,   341,
     342,   343,   344,     0,   345,   346,     0,   347,   348,     0,
     349,     0,     0,   350,   351,   352,     0,     0,   353,   354,
     355,   356,   357,   358,   359,   360,   361,   362,   363,   364,
     365,   366,     0,   367,   368,   369,   370,     0,   371,   372,
       0,   373,     0,   374,   375,   376,   377,   378,   379,     0,
     380,     0,     0,   381,   382,   383,     0,     0,   384,   385,
       0,   386,     0,   387,   388,   389,   390,   391,   392,   393,
     394,     0,   395,   396,   397,   398,   399,   400,   401,     0,
     402,   403,   404,   405,   406,   407,   408,   409,   410,   411,
     412,   413,   414,     0,   415,   416,   417,   418,   419,   420,
     421,   422,   423,   424,   425,     0,   426,   427,     0,   428,
     429,   430,   431,   432,   433,   434,   435,   436,   437,   438,
       0,   439,   440,   441,   442,   443,     0,   444,   445,   446,
     447,     0,   448,   449,   450,     0,   451,   452,   453,   454,
     455,   456,   457,   458,   459,   460,   461,     0,   462,   463,
       0,   464,   465,   466,   467,   468,   469,     0,   470,   471,
       0,     0,   472,   473,   474,   475,     0,   476,   477,   478,
     479,   480,   481,   482,     0,     0,   483,   484,   485,   486,
     487,     0,     0,   488,   489,   490,   491,   492,   493,   494,
       0,   495,     0,   496,   497,   498,   499,     0,     0,   500,
       0,     0,   501,   502,   503,   504,   505,   506,   507,   508,
     509,   510,   511,   512,   513,   514,   515,   516,   517,   518,
     210,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,   211,   212,   213,   214,   215,   216,   217,   218,     0,
     220,   221,   222,     0,     0,     0,     0,   223,     0,     0,
       0,   224,   225,     0,   226,   227,     0,   228,   229,   230,
     231,   232,     0,   233,   234,     0,   235,   236,   237,   238,
     239,     0,     0,   240,   241,   242,   243,   244,     0,   245,
     246,   247,   248,   249,     0,     0,     0,   250,   251,   252,
     253,     0,   254,   255,     0,   256,   257,   258,   259,   260,
     261,     0,     0,   262,   263,     0,     0,     0,     0,     0,
       0,     0,   264,   265,   266,   267,   268,   269,   270,   271,
     272,  3802,   273,     0,   274,   275,   276,   277,   278,     0,
     279,   280,   281,     0,     0,   282,   283,   284,   285,   286,
       0,   287,   288,   289,     0,   290,   291,   292,     0,   293,
     294,   295,   296,   297,   298,   299,   300,   301,     0,   302,
       0,   303,   304,   305,   306,     0,   307,     0,   308,     0,
       0,     0,   309,   310,   311,     0,   312,   313,     0,   314,
       0,   315,   316,   317,   318,   319,     0,   320,   321,   322,
       0,   323,   324,   325,   326,   327,   328,     0,   329,     0,
     330,   331,   332,   333,   334,   335,   336,     0,   337,     0,
     338,     0,     0,   339,     0,   340,   341,   342,   343,   344,
       0,   345,   346,     0,   347,   348,     0,   349,     0,     0,
     350,   351,   352,     0,     0,   353,   354,   355,   356,   357,
     358,   359,   360,   361,   362,   363,   364,   365,   366,     0,
     367,   368,   369,   370,     0,   371,   372,     0,   373,     0,
     374,   375,   376,   377,   378,   379,     0,   380,     0,     0,
     381,   382,   383,     0,     0,   384,   385,     0,   386,     0,
     387,   388,   389,   390,   391,   392,   393,   394,     0,   395,
     396,   397,   398,   399,   400,   401,     0,   402,   403,   404,
     405,   406,   407,   408,   409,   410,   411,   412,   413,   414,
       0,   415,   416,   417,   418,   419,   420,   421,   422,   423,
     424,   425,     0,   426,   427,     0,   428,   429,   430,   431,
     432,   433,   434,   435,   436,   437,   438,     0,   439,   440,
     441,   442,   443,     0,   444,   445,   446,   447,     0,   448,
     449,   450,     0,   451,   452,   453,   454,   455,   456,   457,
     458,   459,   460,   461,     0,   462,   463,     0,   464,   465,
     466,   467,   468,   469,     0,   470,   471,     0,     0,   472,
     473,   474,   475,     0,   476,   477,   478,   479,   480,   481,
     482,     0,     0,   483,   484,   485,   486,   487,     0,     0,
     488,   489,   490,   491,   492,   493,   494,     0,   495,     0,
     496,   497,   498,   499,     0,     0,   500,     0,     0,   501,
     502,   503,   504,   505,   506,   507,   508,   509,   510,   511,
     512,   513,   514,   515,   516,   517,   518,   210,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,   211,   212,
     213,   214,   215,   216,   217,   218,     0,   220,   221,   222,
       0,     0,     0,     0,   223,     0,     0,     0,   224,   225,
       0,   226,   227,     0,   228,   229,   230,   231,   232,     0,
     233,   234,     0,   235,   236,   237,   238,   239,     0,     0,
     240,   241,   242,   243,   244,     0,   245,   246,   247,   248,
     249,     0,     0,     0,   250,   251,   252,   253,     0,   254,
     255,     0,   256,   257,   258,   259,   260,   261,     0,     0,
     262,   263,     0,     0,     0,     0,     0,     0,     0,   264,
     265,   266,   267,   268,   269,   270,   271,   272,  3804,   273,
       0,   274,   275,   276,   277,   278,     0,   279,   280,   281,
       0,     0,   282,   283,   284,   285,   286,     0,   287,   288,
     289,     0,   290,   291,   292,     0,   293,   294,   295,   296,
     297,   298,   299,   300,   301,     0,   302,     0,   303,   304,
     305,   306,     0,   307,     0,   308,     0,     0,     0,   309,
     310,   311,     0,   312,   313,     0,   314,     0,   315,   316,
     317,   318,   319,     0,   320,   321,   322,     0,   323,   324,
     325,   326,   327,   328,     0,   329,     0,   330,   331,   332,
     333,   334,   335,   336,     0,   337,     0,   338,     0,     0,
     339,     0,   340,   341,   342,   343,   344,     0,   345,   346,
       0,   347,   348,     0,   349,     0,     0,   350,   351,   352,
       0,     0,   353,   354,   355,   356,   357,   358,   359,   360,
     361,   362,   363,   364,   365,   366,     0,   367,   368,   369,
     370,     0,   371,   372,     0,   373,     0,   374,   375,   376,
     377,   378,   379,     0,   380,     0,     0,   381,   382,   383,
       0,     0,   384,   385,     0,   386,     0,   387,   388,   389,
     390,   391,   392,   393,   394,     0,   395,   396,   397,   398,
     399,   400,   401,     0,   402,   403,   404,   405,   406,   407,
     408,   409,   410,   411,   412,   413,   414,     0,   415,   416,
     417,   418,   419,   420,   421,   422,   423,   424,   425,     0,
     426,   427,     0,   428,   429,   430,   431,   432,   433,   434,
     435,   436,   437,   438,     0,   439,   440,   441,   442,   443,
       0,   444,   445,   446,   447,     0,   448,   449,   450,     0,
     451,   452,   453,   454,   455,   456,   457,   458,   459,   460,
     461,     0,   462,   463,     0,   464,   465,   466,   467,   468,
     469,     0,   470,   471,     0,     0,   472,   473,   474,   475,
       0,   476,   477,   478,   479,   480,   481,   482,     0,     0,
     483,   484,   485,   486,   487,     0,     0,   488,   489,   490,
     491,   492,   493,   494,     0,   495,     0,   496,   497,   498,
     499,     0,     0,   500,     0,     0,   501,   502,   503,   504,
     505,   506,   507,   508,   509,   510,   511,   512,   513,   514,
     515,   516,   517,   518,   210,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,   211,   212,   213,   214,   215,
     216,   217,   218,     0,   220,   221,   222,     0,     0,     0,
       0,   223,     0,     0,     0,   224,   225,     0,   226,   227,
       0,   228,   229,   230,   231,   232,     0,   233,   234,     0,
     235,   236,   237,   238,   239,     0,     0,   240,   241,   242,
     243,   244,     0,   245,   246,   247,   248,   249,     0,     0,
       0,   250,   251,   252,   253,     0,   254,   255,     0,   256,
     257,   258,   259,   260,   261,     0,     0,   262,   263,     0,
       0,     0,     0,     0,     0,     0,   264,   265,   266,   267,
     268,   269,   270,   271,   272,  3806,   273,     0,   274,   275,
     276,   277,   278,     0,   279,   280,   281,     0,     0,   282,
     283,   284,   285,   286,     0,   287,   288,   289,     0,   290,
     291,   292,     0,   293,   294,   295,   296,   297,   298,   299,
     300,   301,     0,   302,     0,   303,   304,   305,   306,     0,
     307,     0,   308,     0,     0,     0,   309,   310,   311,     0,
     312,   313,     0,   314,     0,   315,   316,   317,   318,   319,
       0,   320,   321,   322,     0,   323,   324,   325,   326,   327,
     328,     0,   329,     0,   330,   331,   332,   333,   334,   335,
     336,     0,   337,     0,   338,     0,     0,   339,     0,   340,
     341,   342,   343,   344,     0,   345,   346,     0,   347,   348,
       0,   349,     0,     0,   350,   351,   352,     0,     0,   353,
     354,   355,   356,   357,   358,   359,   360,   361,   362,   363,
     364,   365,   366,     0,   367,   368,   369,   370,     0,   371,
     372,     0,   373,     0,   374,   375,   376,   377,   378,   379,
       0,   380,     0,     0,   381,   382,   383,     0,     0,   384,
     385,     0,   386,     0,   387,   388,   389,   390,   391,   392,
     393,   394,     0,   395,   396,   397,   398,   399,   400,   401,
       0,   402,   403,   404,   405,   406,   407,   408,   409,   410,
     411,   412,   413,   414,     0,   415,   416,   417,   418,   419,
     420,   421,   422,   423,   424,   425,     0,   426,   427,     0,
     428,   429,   430,   431,   432,   433,   434,   435,   436,   437,
     438,     0,   439,   440,   441,   442,   443,     0,   444,   445,
     446,   447,     0,   448,   449,   450,     0,   451,   452,   453,
     454,   455,   456,   457,   458,   459,   460,   461,     0,   462,
     463,     0,   464,   465,   466,   467,   468,   469,     0,   470,
     471,     0,     0,   472,   473,   474,   475,     0,   476,   477,
     478,   479,   480,   481,   482,     0,     0,   483,   484,   485,
     486,   487,     0,     0,   488,   489,   490,   491,   492,   493,
     494,     0,   495,     0,   496,   497,   498,   499,     0,     0,
     500,     0,     0,   501,   502,   503,   504,   505,   506,   507,
     508,   509,   510,   511,   512,   513,   514,   515,   516,   517,
     518,   210,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,   211,   212,   213,   214,   215,   216,   217,   218,
       0,   220,   221,   222,     0,     0,     0,     0,   223,     0,
       0,     0,   224,   225,     0,   226,   227,     0,   228,   229,
     230,   231,   232,     0,   233,   234,     0,   235,   236,   237,
     238,   239,     0,     0,   240,   241,   242,   243,   244,     0,
     245,   246,   247,   248,   249,     0,     0,     0,   250,   251,
     252,   253,     0,   254,   255,     0,   256,   257,   258,   259,
     260,   261,     0,     0,   262,   263,     0,     0,     0,     0,
       0,     0,     0,   264,   265,   266,   267,   268,   269,   270,
     271,   272,     0,   273,     0,   274,   275,   276,   277,   278,
       0,   279,   280,   281,     0,     0,   282,   283,   284,   285,
     286,     0,   287,   288,   289,     0,   290,   291,   292,     0,
     293,   294,   295,   296,   297,   298,   299,   300,   301,     0,
     302,     0,   303,   304,   305,   306,     0,   307,     0,   308,
       0,     0,     0,   309,   310,   311,     0,   312,   313,     0,
     314,     0,   315,   316,   317,   318,   319,     0,   320,   321,
     322,     0,   323,   324,   325,   326,   327,   328,     0,   329,
       0,   330,   331,   332,   333,   334,   335,   336,     0,   337,
       0,   338,     0,     0,   339,     0,   340,   341,   342,   343,
     344,     0,   345,   346,     0,   347,   348,     0,   349,     0,
       0,   350,   351,   352,     0,     0,   353,   354,   355,   356,
     357,   358,   359,   360,   361,   362,   363,   364,   365,   366,
       0,   367,   368,   369,   370,     0,   371,   372,     0,   373,
       0,   374,   375,   376,   377,   378,   379,     0,   380,     0,
       0,   381,   382,   383,     0,     0,   384,   385,     0,   386,
       0,   387,   388,   389,   390,   391,   392,   393,   394,     0,
     395,   396,   397,   398,   399,   400,   401,     0,   402,   403,
     404,   405,   406,   407,   408,   409,   410,   411,   412,   413,
     414,     0,   415,   416,   417,   418,   419,   420,   421,   422,
     423,   424,   425,     0,   426,   427,     0,   428,   429,   430,
     431,   432,   433,   434,   435,   436,   437,   438,     0,   439,
     440,   441,   442,   443,     0,   444,   445,   446,   447,     0,
     448,   449,   450,     0,   451,   452,   453,   454,   455,   456,
     457,   458,   459,   460,   461,     0,   462,   463,     0,   464,
     465,   466,   467,   468,   469,     0,   470,   471,     0,     0,
     472,   473,   474,   475,     0,   476,   477,   478,   479,   480,
     481,   482,     0,     0,   483,   484,   485,   486,   487,     0,
    4200,   488,   489,   490,   491,   492,   493,   494,     0,   495,
       0,   496,   497,   498,   499,     0,     0,   500,     0,     0,
     501,   502,   503,   504,   505,   506,   507,   508,   509,   510,
     511,   512,   513,   514,   515,   516,   517,   518,   210,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,   211,
     212,   213,   214,   215,   216,   217,   218,     0,   220,   221,
     222,     0,     0,     0,     0,   223,     0,     0,     0,   224,
     225,     0,   226,   227,     0,   228,   229,   230,   231,   232,
       0,   233,   234,     0,   235,   236,   237,   238,   239,     0,
       0,   240,   241,   242,   243,   244,     0,   245,   246,   247,
     248,   249,     0,     0,     0,   250,   251,   252,   253,     0,
     254,   255,     0,   256,   257,   258,   259,   260,   261,     0,
       0,   262,   263,     0,     0,     0,     0,     0,     0,     0,
     264,   265,   266,   267,   268,   269,   270,   271,   272,     0,
     273,     0,   274,   275,   276,   277,   278,     0,   279,   280,
     281,     0,     0,   282,   283,   284,   285,   286,     0,   287,
     288,   289,     0,   290,   291,   292,     0,   293,   294,   295,
     296,   297,   298,   299,   300,   301,     0,   302,     0,   303,
     304,   305,   306,     0,   307,     0,   308,     0,     0,     0,
     309,   310,   311,     0,   312,   313,     0,   314,     0,   315,
     316,   317,   318,   319,     0,   320,   321,   322,     0,   323,
     324,   325,   326,   327,   328,     0,   329,     0,   330,   331,
     332,   333,   334,   335,   336,     0,   337,     0,   338,     0,
       0,   339,     0,   340,   341,   342,   343,   344,     0,   345,
     346,     0,   347,   348,     0,   349,     0,     0,   350,   351,
     352,     0,     0,   353,   354,   355,   356,   357,   358,   359,
     360,   361,   362,   363,   364,   365,   366,     0,   367,   368,
     369,   370,     0,   371,   372,     0,   373,     0,   374,   375,
     376,   377,   378,   379,     0,   380,     0,     0,   381,   382,
     383,     0,     0,   384,   385,     0,   386,     0,   387,   388,
     389,   390,   391,   392,   393,   394,     0,   395,   396,   397,
     398,   399,   400,   401,     0,   402,   403,   404,   405,   406,
     407,   408,   409,   410,   411,   412,   413,   414,     0,   415,
     416,   417,   418,   419,   420,   421,   422,   423,   424,   425,
       0,   426,   427,     0,   428,   429,   430,   431,   432,   433,
     434,   435,   436,   437,   438,     0,   439,   440,   441,   442,
     443,     0,   444,   445,   446,   447,     0,   448,   449,   450,
       0,   451,   452,   453,   454,   455,   456,   457,   458,   459,
     460,   461,     0,   462,   463,     0,   464,   465,   466,   467,
     468,   469,     0,   470,   471,     0,     0,   472,   473,   474,
     475,     0,   476,   477,   478,   479,   480,   481,   482,     0,
       0,   483,   484,   485,   486,   487,     0,     0,   488,   489,
     490,   491,   492,   493,   494,     0,   495,     0,   496,   497,
     498,   499,     0,     0,   500,     0,     0,   501,   502,   503,
     504,   505,   506,   507,   508,   509,   510,   511,   512,   513,
     514,   515,   516,   517,   518,   210,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,   211,   212,   213,   214,
     215,   216,   217,   218,     0,   220,   221,   222,     0,     0,
       0,     0,   223,     0,     0,     0,   224,   225,     0,   226,
     227,     0,   228,   229,   230,   231,   232,     0,   233,   234,
       0,   235,   236,   237,   238,   239,     0,     0,   240,   241,
     242,   243,   244,     0,   245,   246,   247,   248,   249,     0,
       0,     0,   250,   251,   252,   253,     0,   254,   255,     0,
     256,   257,   258,   259,   260,   261,     0,     0,   262,   263,
       0,     0,     0,     0,     0,     0,     0,   264,   265,   266,
     267,   268,   269,   270,   271,   272,     0,   273,     0,   274,
     275,   276,   277,   278,     0,   279,   280,   281,     0,     0,
     282,   283,   284,   285,   286,     0,   287,   288,   289,     0,
     290,   291,   292,     0,   293,   294,   295,   296,   297,   298,
     299,   300,   301,     0,   302,     0,   303,   304,   305,   306,
       0,   307,     0,   308,     0,     0,     0,   309,   310,   311,
       0,   312,   313,     0,   314,     0,   315,   316,   317,   318,
     319,     0,   320,   321,   322,     0,   323,   324,   325,   326,
     327,   328,     0,   329,     0,   330,   331,   332,   333,   334,
     335,   336,     0,   337,     0,   338,     0,     0,   339,     0,
     340,   341,   342,   343,   344,     0,   345,   346,     0,   347,
     348,     0,   349,     0,     0,   350,   351,   352,     0,     0,
     353,   354,   355,   356,   357,   358,   359,   360,   361,   362,
     363,   364,   365,   366,     0,   367,   368,   369,   370,     0,
     371,   372,     0,   373,     0,   374,   375,   376,   377,   378,
     379,     0,   380,     0,     0,   381,   382,   383,     0,     0,
     384,   385,     0,   386,     0,   387,   388,   389,   390,   391,
     392,   393,   394,     0,   395,   396,   397,   398,   399,   400,
     401,     0,   402,   403,   404,   405,   406,   407,   408,   409,
     410,   411,   412,   413,   414,     0,   415,   416,   417,   418,
     419,   420,   421,   422,   423,   424,   425,     0,   426,   427,
       0,   428,   429,   430,   431,   432,   433,   434,   435,   436,
     437,   438,     0,   439,   440,   441,   442,   443,     0,   444,
     445,   446,   447,     0,   448,   449,   450,     0,   451,   452,
     453,   454,   455,   456,   457,   458,   459,   460,   461,     0,
     462,   463,     0,   464,   465,   466,   467,   468,   469,     0,
     470,   471,     0,     0,   659,   473,   474,   475,     0,   476,
     477,   478,   479,   480,   481,   482,     0,     0,   483,   484,
     485,   486,   487,     0,     0,   488,   489,   490,   491,   492,
     493,   494,     0,   495,     0,   496,   497,   498,   499,     0,
       0,   500,     0,     0,   501,   502,   503,   504,   505,   506,
     507,   508,   509,   510,   511,   512,   513,   514,   515,   516,
     517,   518,   210,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,   211,   212,   213,   214,   215,   216,   217,
     218,     0,   220,   221,   222,     0,     0,     0,     0,   223,
       0,     0,     0,   224,   225,     0,   226,   227,     0,   228,
     229,   230,   231,   232,     0,   233,   234,     0,   235,   236,
     237,   238,   239,     0,     0,   240,   241,   242,   243,   244,
       0,   245,   246,   247,   248,   249,     0,     0,     0,   250,
     251,   252,   253,     0,   254,   255,     0,   256,   257,   258,
     259,   260,   261,     0,     0,   262,   263,     0,     0,     0,
       0,     0,     0,     0,   264,   265,   266,   267,   268,   269,
     270,   271,   272,     0,   273,     0,   274,   275,   276,   277,
     278,     0,   279,   280,   281,     0,     0,   282,   283,   284,
     285,   286,     0,   287,   288,   289,     0,   290,   291,   292,
       0,   293,   294,   295,   296,   297,   298,   299,   300,   301,
       0,   302,     0,   303,   304,   305,   306,     0,   307,     0,
     308,     0,     0,     0,   309,   310,   311,     0,   312,   313,
       0,   314,     0,   315,   316,   317,   318,   319,     0,   320,
     321,   322,     0,   323,   324,   325,   326,   327,   328,     0,
     329,     0,   330,   331,   332,   333,   334,   335,   336,     0,
     337,     0,   338,     0,     0,   339,     0,   340,   341,   342,
     343,   344,     0,   345,   346,     0,   347,   348,     0,   349,
       0,     0,   350,   351,   352,     0,     0,   353,   354,   355,
     356,   357,   358,   359,   360,   361,   362,   363,   364,   365,
     366,     0,   367,   368,   369,   370,     0,   371,   372,     0,
     373,     0,   374,   375,   376,   377,   378,   379,     0,   380,
       0,     0,   381,   382,   383,     0,     0,   384,   385,     0,
     386,     0,   387,   388,   389,   390,   391,   392,   393,   394,
       0,   395,   396,   397,   398,   399,   400,   401,     0,   402,
     403,   404,   405,   406,   407,   408,   409,   410,   411,   412,
     413,   414,     0,   415,   416,   417,   418,   419,   420,   421,
     422,   423,   424,   425,     0,   426,   427,     0,   428,   429,
     430,   431,   432,   668,   434,   435,   436,   437,   438,     0,
     439,   440,   441,   442,   443,     0,   444,   445,   446,   447,
       0,   448,   449,   450,     0,   451,   452,   453,   454,   455,
     456,   457,   458,   459,   460,   461,     0,   462,   463,     0,
     464,   465,   466,   467,   468,   469,     0,   470,   471,     0,
       0,   472,   473,   474,   475,     0,   476,   477,   478,   479,
     480,   481,   482,     0,     0,   483,   484,   485,   486,   487,
       0,     0,   488,   489,   490,   491,   492,   493,   494,     0,
     495,     0,   496,   497,   498,   499,     0,     0,   500,     0,
       0,   501,   502,   503,   504,   505,   506,   507,   508,   509,
     510,   511,   512,   513,   514,   515,   516,   517,   518,   210,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
     211,   212,   213,   214,   215,   216,   217,   218,     0,   220,
     221,   222,     0,     0,     0,     0,   223,     0,     0,     0,
     224,   225,     0,   226,   227,     0,   228,   229,   230,   231,
     232,     0,   233,   234,     0,   235,   236,   237,   238,   239,
       0,     0,   689,   241,   242,   243,   244,     0,   245,   246,
     247,   248,   249,     0,     0,     0,   250,   251,   252,   253,
       0,   254,   255,     0,   690,   257,   258,   259,   260,   261,
       0,     0,   262,   263,     0,     0,     0,     0,     0,     0,
       0,   264,   265,   266,   267,   268,   269,   270,   271,   272,
       0,   273,     0,   274,   275,   276,   277,   278,     0,   279,
     280,   281,     0,     0,   282,   283,   284,   285,   286,     0,
     287,   288,   289,     0,   290,   291,   292,     0,   293,   294,
     295,   296,   297,   298,   299,   300,   301,     0,   302,     0,
     303,   304,   305,   306,     0,   307,     0,   308,     0,     0,
       0,   309,   310,   311,     0,   312,   313,     0,   314,     0,
     315,   316,   317,   318,   319,     0,   320,   321,   322,     0,
     323,   324,   325,   326,   327,   328,     0,   329,     0,   330,
     331,   332,   333,   334,   335,   336,     0,   337,     0,   338,
       0,     0,   339,     0,   340,   341,   342,   343,   344,     0,
     345,   346,     0,   347,   348,     0,   349,     0,     0,   350,
     351,   691,     0,     0,   353,   354,   355,   356,   357,   358,
     359,   360,   361,   362,   363,   364,   692,   366,     0,   367,
     368,   369,   370,     0,   371,   372,     0,   373,     0,   374,
     375,   376,   377,   378,   379,     0,   380,     0,     0,   381,
     382,   383,     0,     0,   384,   385,     0,   386,     0,   387,
     388,   389,   390,   391,   392,   393,   394,     0,   395,   396,
     397,   398,   399,   400,   401,     0,   402,   403,   404,   405,
     406,   407,   408,   409,   410,   411,   412,   413,   414,     0,
     415,   416,   417,   418,   419,   420,   421,   422,   423,   424,
     425,     0,   426,   427,     0,   693,   429,   430,   431,   432,
     433,   694,   435,   436,   437,   438,     0,   439,   440,   441,
     442,   695,     0,   444,   445,   446,   447,     0,   448,   449,
     450,     0,   451,   452,   453,   454,   455,   456,   457,   458,
     459,   460,   461,     0,   462,   463,     0,   464,   465,   466,
     467,   468,   469,     0,   696,   471,     0,     0,   697,   473,
     474,   475,     0,   476,   477,   478,   479,   480,   481,   482,
       0,     0,   483,   484,   485,   486,   487,     0,     0,   488,
     489,   490,   491,   492,   493,   494,     0,   495,     0,   496,
     497,   498,   499,     0,     0,   500,     0,     0,   501,   502,
     503,   504,   505,   698,   507,   508,   509,   510,   511,   512,
     513,   514,   515,   516,   517,   518,   210,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,   211,   212,   213,
     214,   215,   216,   217,   218,     0,   220,   221,   222,     0,
       0,     0,     0,   223,     0,     0,     0,   224,   225,     0,
     226,   227,     0,   228,   229,   230,   231,   232,     0,   233,
     234,     0,   235,   236,   237,   238,   239,     0,     0,   240,
     241,   242,   243,   244,     0,   245,   246,   247,   248,   249,
       0,     0,     0,   250,   251,   252,   253,     0,   254,   255,
       0,   256,   257,   258,   259,   260,   261,     0,     0,   262,
     263,     0,     0,     0,     0,     0,     0,     0,   264,   265,
     266,   267,   268,   269,   270,   271,   272,     0,   273,     0,
     274,   275,   276,   277,   278,     0,   279,   280,   281,     0,
       0,   282,   283,   284,   285,   286,     0,   287,   288,   289,
       0,   290,   291,   292,     0,   293,   294,   295,   296,   297,
     298,   299,   300,   301,     0,   302,     0,   303,   304,   305,
     306,     0,   307,     0,   308,     0,     0,     0,   309,   310,
     311,     0,   312,   313,     0,   314,     0,   315,   316,   317,
     318,   319,     0,   320,   321,   322,     0,   323,   324,   325,
     326,   327,   328,     0,   329,     0,   330,   331,   332,   333,
     334,   335,   336,     0,   337,     0,   338,     0,     0,   339,
       0,   340,   341,   342,   343,   344,     0,   345,   346,     0,
     347,   348,     0,   349,     0,     0,   350,   351,   352,     0,
       0,   353,   354,   355,   356,   357,   358,   359,   360,   361,
     362,   363,   364,   365,   366,     0,   367,   368,   369,   370,
       0,   371,   372,     0,   373,     0,   374,   375,   376,   377,
     378,   379,     0,   380,     0,     0,   381,   382,   383,     0,
       0,   384,   385,     0,   386,     0,   387,   388,   389,   390,
     391,   392,   393,   394,     0,   395,   396,   397,   398,   399,
     400,   401,     0,   402,   403,   404,   405,   406,   407,   408,
     409,   410,   411,   412,   721,   414,     0,   415,   416,   417,
     418,   419,   420,   421,   422,   423,   424,   425,     0,   426,
     427,     0,   428,   429,   430,   431,   432,   433,   434,   435,
     436,   437,   438,     0,   439,   440,   441,   442,   443,     0,
     444,   445,   446,   447,     0,   448,   449,   450,     0,   451,
     452,   453,   454,   455,   456,   457,   458,   459,   460,   461,
       0,   462,   463,     0,   464,   465,   466,   467,   468,   469,
       0,   470,   471,     0,     0,   472,   473,   474,   475,     0,
     476,   477,   478,   479,   480,   481,   482,     0,     0,   483,
     484,   485,   486,   487,     0,     0,   488,   489,   490,   491,
     492,   493,   494,     0,   495,     0,   496,   497,   498,   499,
       0,     0,   500,     0,     0,   501,   502,   503,   504,   505,
     506,   507,   508,   509,   510,   511,   512,   513,   514,   515,
     516,   517,   518,   210,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,   211,   212,   213,   214,   215,   216,
     217,   218,     0,   220,   221,   222,     0,     0,     0,     0,
     223,     0,     0,     0,   224,   225,     0,   226,   227,     0,
     228,   229,   230,   231,   232,     0,   233,   234,     0,   235,
     236,   237,   238,   239,     0,     0,   240,   241,   242,   243,
     244,     0,   245,   246,   247,   248,   249,     0,     0,     0,
     250,   251,   252,   253,     0,   254,   255,     0,   256,   257,
     258,   259,   260,   261,     0,     0,   262,   263,     0,     0,
       0,     0,     0,     0,     0,   264,   265,   266,   267,   268,
     269,   270,   271,   272,     0,   273,     0,   274,   275,   276,
     277,   278,     0,   279,   280,   281,     0,     0,   282,   283,
     284,   285,   286,     0,   287,   288,   289,     0,   290,   291,
     292,     0,   293,   294,   295,   296,   297,   298,   299,   300,
     301,     0,   302,     0,   303,   304,   305,   306,     0,   307,
       0,   308,     0,     0,     0,   309,   310,   311,     0,   312,
     313,     0,   314,     0,   315,   316,   317,   318,   818,     0,
     320,   321,   322,     0,   323,   324,   325,   326,   327,   328,
       0,   329,     0,   330,   331,   332,   333,   334,   335,   336,
       0,   337,     0,   338,     0,     0,   339,     0,   340,   341,
     342,   343,   344,     0,   345,   346,     0,   347,   348,     0,
     349,     0,     0,   350,   351,   352,     0,     0,   353,   354,
     355,   356,   357,   358,   359,   360,   361,   362,   363,   364,
     365,   366,     0,   367,   368,   369,   370,     0,   371,   372,
       0,   373,     0,   374,   375,   376,   377,   378,   379,     0,
     380,     0,     0,   381,   382,   383,     0,     0,   384,   385,
       0,   386,     0,   387,   388,   389,   390,   391,   392,   393,
     394,     0,   395,   396,   397,   398,   399,   400,   401,     0,
     402,   403,   404,   405,   406,   407,   408,   409,   410,   411,
     412,   413,   414,     0,   415,   416,   417,   418,   419,   420,
     421,   422,   423,   424,   425,     0,   426,   427,     0,   428,
     429,   430,   431,   432,   433,   434,   435,   436,   437,   438,
       0,   439,   440,   441,   442,   443,     0,   444,   445,   446,
     447,     0,   448,   449,   450,     0,   451,   452,   453,   454,
     455,   456,   457,   458,   459,   460,   461,     0,   462,   463,
       0,   464,   465,   466,   467,   468,   469,     0,   470,   471,
       0,     0,   472,   473,   474,   475,     0,   476,   477,   478,
     479,   480,   481,   482,     0,     0,   483,   484,   485,   486,
     487,     0,     0,   488,   489,   490,   491,   492,   493,   494,
       0,   495,     0,   496,   497,   498,   499,     0,     0,   500,
       0,     0,   501,   502,   503,   504,   505,   506,   507,   508,
     509,   510,   511,   512,   513,   514,   515,   516,   517,   518,
     210,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,   211,   212,   213,   214,   215,   216,   217,   218,     0,
     220,   221,   222,     0,     0,     0,     0,   223,     0,     0,
       0,   224,   225,     0,   226,   227,     0,   228,   229,   230,
     231,   232,     0,   233,   234,     0,   235,   236,   237,   238,
     239,     0,     0,   240,   241,   242,   243,   244,     0,   245,
     246,   247,   248,   249,     0,     0,     0,   250,   251,   252,
     253,     0,   254,   255,     0,   256,   257,   258,   259,   260,
     261,     0,     0,   262,   263,     0,     0,     0,     0,     0,
       0,     0,   264,   265,   266,   267,   268,   269,   270,   271,
     272,     0,   273,     0,   274,   275,   276,   277,   278,     0,
     279,   280,   281,     0,     0,   282,   283,   284,   285,   286,
       0,   287,   288,   289,     0,   290,   291,   292,     0,   293,
     294,   295,   296,   297,   298,   299,   300,   301,     0,   302,
       0,   303,   304,   305,   306,     0,   307,     0,   308,     0,
       0,     0,   309,   310,   311,     0,   312,   313,     0,   314,
       0,   315,   316,   317,   318,   833,     0,   320,   321,   322,
       0,   323,   324,   325,   326,   327,   328,     0,   329,     0,
     330,   331,   332,   333,   334,   335,   336,     0,   337,     0,
     338,     0,     0,   339,     0,   340,   341,   342,   343,   344,
       0,   345,   346,     0,   347,   348,     0,   349,     0,     0,
     350,   351,   352,     0,     0,   353,   354,   355,   356,   357,
     358,   359,   360,   361,   362,   363,   364,   365,   366,     0,
     367,   368,   369,   370,     0,   371,   372,     0,   373,     0,
     374,   375,   376,   377,   378,   379,     0,   380,     0,     0,
     381,   382,   383,     0,     0,   384,   385,     0,   386,     0,
     387,   388,   389,   390,   391,   392,   393,   394,     0,   395,
     396,   397,   398,   399,   400,   401,     0,   402,   403,   404,
     405,   406,   407,   408,   409,   410,   411,   412,   413,   414,
       0,   415,   416,   417,   418,   419,   420,   421,   422,   423,
     424,   425,     0,   426,   427,     0,   428,   429,   430,   431,
     432,   433,   434,   435,   436,   437,   438,     0,   439,   440,
     441,   442,   443,     0,   444,   445,   446,   447,     0,   448,
     449,   450,     0,   451,   452,   453,   454,   455,   456,   457,
     458,   459,   460,   461,     0,   462,   463,     0,   464,   465,
     466,   467,   468,   469,     0,   470,   471,     0,     0,   472,
     473,   474,   475,     0,   476,   477,   478,   479,   480,   481,
     482,     0,     0,   483,   484,   485,   486,   487,     0,     0,
     488,   489,   490,   491,   492,   493,   494,     0,   495,     0,
     496,   497,   498,   499,     0,     0,   500,     0,     0,   501,
     502,   503,   504,   505,   506,   507,   508,   509,   510,   511,
     512,   513,   514,   515,   516,   517,   518,   210,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,   211,   212,
     213,   214,   215,   216,   217,   218,     0,   220,   221,   222,
       0,     0,     0,     0,   223,     0,     0,     0,   224,   225,
       0,   226,   227,     0,   228,   229,   230,   231,   232,     0,
     233,   234,     0,   235,   236,   237,   238,   239,     0,     0,
     240,   241,   242,   243,   244,     0,   245,   246,   247,   248,
     249,     0,     0,     0,   250,   251,   252,   253,     0,   254,
     255,     0,   256,   257,   258,   259,   260,   261,     0,     0,
     262,   263,     0,     0,     0,     0,     0,     0,     0,   264,
     265,   266,   267,   268,   269,   270,   271,   272,     0,   273,
       0,   274,   275,   276,   277,   278,     0,   279,   280,   281,
       0,     0,   282,   283,   284,   285,   286,     0,   287,   288,
     289,     0,   290,   291,   292,     0,   293,   294,   295,   296,
     297,   298,   299,   300,   301,     0,   302,     0,   303,   304,
     305,   306,     0,   307,     0,   308,     0,     0,     0,   309,
     310,   311,     0,   312,   313,     0,   314,     0,   315,   316,
     317,   318,   886,     0,   320,   321,   322,     0,   323,   324,
     325,   326,   327,   328,     0,   329,     0,   330,   331,   332,
     333,   334,   335,   336,     0,   337,     0,   338,     0,     0,
     339,     0,   340,   341,   342,   343,   344,     0,   345,   346,
       0,   347,   348,     0,   349,     0,     0,   350,   351,   352,
       0,     0,   353,   354,   355,   356,   357,   358,   359,   360,
     361,   362,   363,   364,   365,   366,     0,   367,   368,   369,
     370,     0,   371,   372,     0,   373,     0,   374,   375,   376,
     377,   378,   379,     0,   380,     0,     0,   381,   382,   383,
       0,     0,   384,   385,     0,   386,     0,   387,   388,   389,
     390,   391,   392,   393,   394,     0,   395,   396,   397,   398,
     399,   400,   401,     0,   402,   403,   404,   405,   406,   407,
     408,   409,   410,   411,   412,   413,   414,     0,   415,   416,
     417,   418,   419,   420,   421,   422,   423,   424,   425,     0,
     426,   427,     0,   428,   429,   430,   431,   432,   433,   434,
     435,   436,   437,   438,     0,   439,   440,   441,   442,   443,
       0,   444,   445,   446,   447,     0,   448,   449,   450,     0,
     451,   452,   453,   454,   455,   456,   457,   458,   459,   460,
     461,     0,   462,   463,     0,   464,   465,   466,   467,   468,
     469,     0,   470,   471,     0,     0,   472,   473,   474,   475,
       0,   476,   477,   478,   479,   480,   481,   482,     0,     0,
     483,   484,   485,   486,   487,     0,     0,   488,   489,   490,
     491,   492,   493,   494,     0,   495,     0,   496,   497,   498,
     499,     0,     0,   500,     0,     0,   501,   502,   503,   504,
     505,   506,   507,   508,   509,   510,   511,   512,   513,   514,
     515,   516,   517,   518,   210,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,   211,   212,   213,   214,   215,
     216,   217,   218,     0,   220,   221,   222,     0,     0,     0,
       0,   223,     0,     0,     0,   224,   225,     0,   226,   227,
       0,   228,   229,   230,   231,   232,     0,   233,   234,     0,
     235,   236,   237,   238,   239,     0,     0,   240,   241,   242,
     243,   244,     0,   245,   246,   247,   248,   249,     0,     0,
       0,   250,   251,   252,   253,     0,   254,   255,     0,   256,
     257,   258,   259,   260,   261,     0,     0,   262,   263,     0,
       0,     0,     0,     0,     0,     0,   264,   265,   266,   267,
     268,   269,   270,   271,   272,     0,   273,     0,   274,   275,
     276,   277,   278,     0,   279,   280,   281,     0,     0,   282,
     283,   284,   285,   286,     0,   287,   288,   289,     0,   290,
     291,   292,     0,   293,   294,   295,   296,   297,   298,   299,
     300,   301,     0,   302,     0,   303,   304,   305,   306,     0,
     307,     0,   308,     0,     0,     0,   309,   310,   311,     0,
     312,   313,     0,   314,     0,   315,   316,   317,   318,   900,
       0,   320,   321,   322,     0,   323,   324,   325,   326,   327,
     328,     0,   329,     0,   330,   331,   332,   333,   334,   335,
     336,     0,   337,     0,   338,     0,     0,   339,     0,   340,
     341,   342,   343,   344,     0,   345,   346,     0,   347,   348,
       0,   349,     0,     0,   350,   351,   352,     0,     0,   353,
     354,   355,   356,   357,   358,   359,   360,   361,   362,   363,
     364,   365,   366,     0,   367,   368,   369,   370,     0,   371,
     372,     0,   373,     0,   374,   375,   376,   377,   378,   379,
       0,   380,     0,     0,   381,   382,   383,     0,     0,   384,
     385,     0,   386,     0,   387,   388,   389,   390,   391,   392,
     393,   394,     0,   395,   396,   397,   398,   399,   400,   401,
       0,   402,   403,   404,   405,   406,   407,   408,   409,   410,
     411,   412,   413,   414,     0,   415,   416,   417,   418,   419,
     420,   421,   422,   423,   424,   425,     0,   426,   427,     0,
     428,   429,   430,   431,   432,   433,   434,   435,   436,   437,
     438,     0,   439,   440,   441,   442,   443,     0,   444,   445,
     446,   447,     0,   448,   449,   450,     0,   451,   452,   453,
     454,   455,   456,   457,   458,   459,   460,   461,     0,   462,
     463,     0,   464,   465,   466,   467,   468,   469,     0,   470,
     471,     0,     0,   472,   473,   474,   475,     0,   476,   477,
     478,   479,   480,   481,   482,     0,     0,   483,   484,   485,
     486,   487,     0,     0,   488,   489,   490,   491,   492,   493,
     494,     0,   495,     0,   496,   497,   498,   499,     0,     0,
     500,     0,     0,   501,   502,   503,   504,   505,   506,   507,
     508,   509,   510,   511,   512,   513,   514,   515,   516,   517,
     518,   210,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,   211,   212,   213,   214,   215,   216,   217,   218,
       0,   220,   221,   222,     0,     0,     0,     0,   223,     0,
       0,     0,   224,   225,     0,   226,   227,     0,   228,   229,
     230,   231,   232,     0,   233,   234,     0,   235,   236,   237,
     238,   239,     0,     0,   240,   241,   242,   243,   244,     0,
     245,   246,   247,   248,   249,     0,     0,     0,   250,   251,
     252,   253,     0,   254,   255,     0,   256,   257,   258,   259,
     260,   261,     0,     0,   262,   263,     0,     0,     0,     0,
       0,     0,     0,   264,   265,   266,   267,   268,   269,   270,
     271,   272,     0,   273,     0,   274,   275,   276,   277,   278,
       0,   279,   280,   281,     0,     0,   282,   283,   284,   285,
     286,     0,   287,   288,   289,     0,   290,   291,   292,     0,
     293,   294,   295,   296,   297,   298,   299,   300,   301,     0,
     302,     0,   303,   304,   305,   306,     0,   307,     0,   308,
       0,     0,     0,   309,   310,   311,     0,   312,   313,     0,
     314,     0,   315,   316,   317,   318,   933,     0,   320,   321,
     322,     0,   323,   324,   325,   326,   327,   328,     0,   329,
       0,   330,   331,   332,   333,   334,   335,   336,     0,   337,
       0,   338,     0,     0,   339,     0,   340,   341,   342,   343,
     344,     0,   345,   346,     0,   347,   348,     0,   349,     0,
       0,   350,   351,   352,     0,     0,   353,   354,   355,   356,
     357,   358,   359,   360,   361,   362,   363,   364,   365,   366,
       0,   367,   368,   369,   370,     0,   371,   372,     0,   373,
       0,   374,   375,   376,   377,   378,   379,     0,   380,     0,
       0,   381,   382,   383,     0,     0,   384,   385,     0,   386,
       0,   387,   388,   389,   390,   391,   392,   393,   394,     0,
     395,   396,   397,   398,   399,   400,   401,     0,   402,   403,
     404,   405,   406,   407,   408,   409,   410,   411,   412,   413,
     414,     0,   415,   416,   417,   418,   419,   420,   421,   422,
     423,   424,   425,     0,   426,   427,     0,   428,   429,   430,
     431,   432,   433,   434,   435,   436,   437,   438,     0,   439,
     440,   441,   442,   443,     0,   444,   445,   446,   447,     0,
     448,   449,   450,     0,   451,   452,   453,   454,   455,   456,
     457,   458,   459,   460,   461,     0,   462,   463,     0,   464,
     465,   466,   467,   468,   469,     0,   470,   471,     0,     0,
     472,   473,   474,   475,     0,   476,   477,   478,   479,   480,
     481,   482,     0,     0,   483,   484,   485,   486,   487,     0,
       0,   488,   489,   490,   491,   492,   493,   494,     0,   495,
       0,   496,   497,   498,   499,     0,     0,   500,     0,     0,
     501,   502,   503,   504,   505,   506,   507,   508,   509,   510,
     511,   512,   513,   514,   515,   516,   517,   518,   210,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,   211,
     212,   213,   214,   215,   216,   217,   218,     0,   220,   221,
     222,     0,     0,     0,     0,   223,     0,     0,     0,   224,
     225,     0,   226,   227,     0,   228,   229,   230,   231,   232,
       0,   233,   234,     0,   235,   236,   237,   238,   239,     0,
       0,   240,   241,   242,   243,   244,     0,   245,   246,   247,
     248,   249,     0,     0,     0,   250,   251,   252,   253,     0,
     254,   255,     0,   256,   257,   258,   259,   260,   261,     0,
       0,   262,   263,     0,     0,     0,     0,     0,     0,     0,
     264,   265,   266,   267,   268,   269,   270,   271,   272,     0,
     273,     0,   274,   275,   276,   277,   278,     0,   279,   280,
     281,     0,     0,   282,   283,   284,   285,   286,     0,   287,
     288,   289,     0,   290,   291,   292,     0,   293,   294,   295,
     296,   297,   298,   299,   300,   301,     0,   302,     0,   303,
     304,   305,   306,     0,   307,     0,   308,     0,     0,     0,
     309,   310,   311,     0,   312,   313,     0,   314,     0,   315,
     316,   317,   318,   952,     0,   320,   321,   322,     0,   323,
     324,   325,   326,   327,   328,     0,   329,     0,   330,   331,
     332,   333,   334,   335,   336,     0,   337,     0,   338,     0,
       0,   339,     0,   340,   341,   342,   343,   344,     0,   345,
     346,     0,   347,   348,     0,   349,     0,     0,   350,   351,
     352,     0,     0,   353,   354,   355,   356,   357,   358,   359,
     360,   361,   362,   363,   364,   365,   366,     0,   367,   368,
     369,   370,     0,   371,   372,     0,   373,     0,   374,   375,
     376,   377,   378,   379,     0,   380,     0,     0,   381,   382,
     383,     0,     0,   384,   385,     0,   386,     0,   387,   388,
     389,   390,   391,   392,   393,   394,     0,   395,   396,   397,
     398,   399,   400,   401,     0,   402,   403,   404,   405,   406,
     407,   408,   409,   410,   411,   412,   413,   414,     0,   415,
     416,   417,   418,   419,   420,   421,   422,   423,   424,   425,
       0,   426,   427,     0,   428,   429,   430,   431,   432,   433,
     434,   435,   436,   437,   438,     0,   439,   440,   441,   442,
     443,     0,   444,   445,   446,   447,     0,   448,   449,   450,
       0,   451,   452,   453,   454,   455,   456,   457,   458,   459,
     460,   461,     0,   462,   463,     0,   464,   465,   466,   467,
     468,   469,     0,   470,   471,     0,     0,   472,   473,   474,
     475,     0,   476,   477,   478,   479,   480,   481,   482,     0,
       0,   483,   484,   485,   486,   487,     0,     0,   488,   489,
     490,   491,   492,   493,   494,     0,   495,     0,   496,   497,
     498,   499,     0,     0,   500,     0,     0,   501,   502,   503,
     504,   505,   506,   507,   508,   509,   510,   511,   512,   513,
     514,   515,   516,   517,   518,   210,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,   211,   212,   213,   214,
     215,   216,   217,   218,     0,   220,   221,   222,     0,     0,
       0,     0,   223,     0,     0,     0,   224,   225,     0,   226,
     227,     0,   228,   229,   230,   231,   232,     0,   233,   234,
       0,   235,   236,   237,   238,   239,     0,     0,   240,   241,
     242,   243,   244,     0,   245,   246,   247,   248,   249,     0,
       0,     0,   250,   251,   252,   253,     0,   254,   255,     0,
     256,   257,   258,   259,   260,   261,     0,     0,   262,   263,
       0,     0,     0,     0,     0,     0,     0,   264,   265,   266,
     267,   268,   269,   270,   271,   272,     0,   273,     0,   274,
     275,   276,   277,   278,     0,   279,   280,   281,     0,     0,
     282,   283,   284,   285,   286,     0,   287,   288,   289,     0,
     290,   291,   292,     0,   293,   294,   295,   296,   297,   298,
     299,   300,   301,     0,   302,     0,   303,   304,   305,   306,
       0,   307,     0,   308,     0,     0,     0,   309,   310,   311,
       0,   312,   313,     0,   314,     0,   315,   316,   317,   318,
     954,     0,   320,   321,   322,     0,   323,   324,   325,   326,
     327,   328,     0,   329,     0,   330,   331,   332,   333,   334,
     335,   336,     0,   337,     0,   338,     0,     0,   339,     0,
     340,   341,   342,   343,   344,     0,   345,   346,     0,   347,
     348,     0,   349,     0,     0,   350,   351,   352,     0,     0,
     353,   354,   355,   356,   357,   358,   359,   360,   361,   362,
     363,   364,   365,   366,     0,   367,   368,   369,   370,     0,
     371,   372,     0,   373,     0,   374,   375,   376,   377,   378,
     379,     0,   380,     0,     0,   381,   382,   383,     0,     0,
     384,   385,     0,   386,     0,   387,   388,   389,   390,   391,
     392,   393,   394,     0,   395,   396,   397,   398,   399,   400,
     401,     0,   402,   403,   404,   405,   406,   407,   408,   409,
     410,   411,   412,   413,   414,     0,   415,   416,   417,   418,
     419,   420,   421,   422,   423,   424,   425,     0,   426,   427,
       0,   428,   429,   430,   431,   432,   433,   434,   435,   436,
     437,   438,     0,   439,   440,   441,   442,   443,     0,   444,
     445,   446,   447,     0,   448,   449,   450,     0,   451,   452,
     453,   454,   455,   456,   457,   458,   459,   460,   461,     0,
     462,   463,     0,   464,   465,   466,   467,   468,   469,     0,
     470,   471,     0,     0,   472,   473,   474,   475,     0,   476,
     477,   478,   479,   480,   481,   482,     0,     0,   483,   484,
     485,   486,   487,     0,     0,   488,   489,   490,   491,   492,
     493,   494,     0,   495,     0,   496,   497,   498,   499,     0,
       0,   500,     0,     0,   501,   502,   503,   504,   505,   506,
     507,   508,   509,   510,   511,   512,   513,   514,   515,   516,
     517,   518,   210,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,   211,   212,   213,   214,   215,   216,   217,
     218,     0,   220,   221,   222,     0,     0,     0,     0,   223,
       0,     0,     0,   224,   225,     0,   226,   227,     0,   228,
     229,   230,   231,   232,     0,   233,   234,     0,   235,   236,
     237,   238,   239,     0,     0,   240,   241,   242,   243,   244,
       0,   245,   246,   247,   248,   249,     0,     0,     0,   250,
     251,   252,   253,     0,   254,   255,     0,   256,   257,   258,
     259,   260,   261,     0,     0,   262,   263,     0,     0,     0,
       0,     0,     0,     0,   264,   265,   266,   267,   268,   269,
     270,   271,   272,     0,   273,     0,   274,   275,   276,   277,
     278,     0,   279,   280,   281,     0,     0,   282,   283,   284,
     285,   286,     0,   287,   288,   289,     0,   290,   291,   292,
       0,   293,   294,   295,   296,   297,   298,   299,   300,   301,
       0,   302,     0,   303,   304,   305,   306,     0,   307,     0,
     308,     0,     0,     0,   309,   310,   311,     0,   312,   313,
       0,   314,     0,   315,   316,   317,   318,   956,     0,   320,
     321,   322,     0,   323,   324,   325,   326,   327,   328,     0,
     329,     0,   330,   331,   332,   333,   334,   335,   336,     0,
     337,     0,   338,     0,     0,   339,     0,   340,   341,   342,
     343,   344,     0,   345,   346,     0,   347,   348,     0,   349,
       0,     0,   350,   351,   352,     0,     0,   353,   354,   355,
     356,   357,   358,   359,   360,   361,   362,   363,   364,   365,
     366,     0,   367,   368,   369,   370,     0,   371,   372,     0,
     373,     0,   374,   375,   376,   377,   378,   379,     0,   380,
       0,     0,   381,   382,   383,     0,     0,   384,   385,     0,
     386,     0,   387,   388,   389,   390,   391,   392,   393,   394,
       0,   395,   396,   397,   398,   399,   400,   401,     0,   402,
     403,   404,   405,   406,   407,   408,   409,   410,   411,   412,
     413,   414,     0,   415,   416,   417,   418,   419,   420,   421,
     422,   423,   424,   425,     0,   426,   427,     0,   428,   429,
     430,   431,   432,   433,   434,   435,   436,   437,   438,     0,
     439,   440,   441,   442,   443,     0,   444,   445,   446,   447,
       0,   448,   449,   450,     0,   451,   452,   453,   454,   455,
     456,   457,   458,   459,   460,   461,     0,   462,   463,     0,
     464,   465,   466,   467,   468,   469,     0,   470,   471,     0,
       0,   472,   473,   474,   475,     0,   476,   477,   478,   479,
     480,   481,   482,     0,     0,   483,   484,   485,   486,   487,
       0,     0,   488,   489,   490,   491,   492,   493,   494,     0,
     495,     0,   496,   497,   498,   499,     0,     0,   500,     0,
       0,   501,   502,   503,   504,   505,   506,   507,   508,   509,
     510,   511,   512,   513,   514,   515,   516,   517,   518,   210,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
     211,   212,   213,   214,   215,   216,   217,   218,     0,   220,
     221,   222,     0,     0,     0,     0,   223,     0,     0,     0,
     224,   225,     0,   226,   227,     0,   228,   229,   230,   231,
     232,     0,   233,   234,     0,   235,   236,   237,   238,   239,
       0,     0,   240,   241,   242,   243,   244,     0,   245,   246,
     247,   248,   249,     0,     0,     0,   250,   251,   252,   253,
       0,   254,   255,     0,   256,   257,   258,   259,   260,   261,
       0,     0,   262,   263,     0,     0,     0,     0,     0,     0,
       0,   264,   265,   266,   267,   268,   269,   270,   271,   272,
       0,   273,     0,   274,   275,   276,   277,   278,     0,   279,
     280,   281,     0,     0,   282,   283,   284,   285,   286,     0,
     287,   288,   289,     0,   290,   291,   292,     0,   293,   294,
     295,   296,   297,   298,   299,   300,   301,     0,   302,     0,
     303,   304,   305,   306,     0,   307,     0,   308,     0,     0,
       0,   309,   310,   311,     0,   312,   313,     0,   314,     0,
     315,   316,   317,   318,   959,     0,   320,   321,   322,     0,
     323,   324,   325,   326,   327,   328,     0,   329,     0,   330,
     331,   332,   333,   334,   335,   336,     0,   337,     0,   338,
       0,     0,   339,     0,   340,   341,   342,   343,   344,     0,
     345,   346,     0,   347,   348,     0,   349,     0,     0,   350,
     351,   352,     0,     0,   353,   354,   355,   356,   357,   358,
     359,   360,   361,   362,   363,   364,   365,   366,     0,   367,
     368,   369,   370,     0,   371,   372,     0,   373,     0,   374,
     375,   376,   377,   378,   379,     0,   380,     0,     0,   381,
     382,   383,     0,     0,   384,   385,     0,   386,     0,   387,
     388,   389,   390,   391,   392,   393,   394,     0,   395,   396,
     397,   398,   399,   400,   401,     0,   402,   403,   404,   405,
     406,   407,   408,   409,   410,   411,   412,   413,   414,     0,
     415,   416,   417,   418,   419,   420,   421,   422,   423,   424,
     425,     0,   426,   427,     0,   428,   429,   430,   431,   432,
     433,   434,   435,   436,   437,   438,     0,   439,   440,   441,
     442,   443,     0,   444,   445,   446,   447,     0,   448,   449,
     450,     0,   451,   452,   453,   454,   455,   456,   457,   458,
     459,   460,   461,     0,   462,   463,     0,   464,   465,   466,
     467,   468,   469,     0,   470,   471,     0,     0,   472,   473,
     474,   475,     0,   476,   477,   478,   479,   480,   481,   482,
       0,     0,   483,   484,   485,   486,   487,     0,     0,   488,
     489,   490,   491,   492,   493,   494,     0,   495,     0,   496,
     497,   498,   499,     0,     0,   500,     0,     0,   501,   502,
     503,   504,   505,   506,   507,   508,   509,   510,   511,   512,
     513,   514,   515,   516,   517,   518,   210,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,   211,   212,   213,
     214,   215,   216,   217,   218,     0,   220,   221,   222,     0,
       0,     0,     0,   223,     0,     0,     0,   224,   225,     0,
     226,   227,     0,   228,   229,   230,   231,   232,     0,   233,
     234,     0,   235,   236,   237,   238,   239,     0,     0,   240,
     241,   242,   243,   244,     0,   245,   246,   247,   248,   249,
       0,     0,     0,   250,   251,   252,   253,     0,   254,   255,
       0,   256,   257,   258,   259,   260,   261,     0,     0,   262,
     263,     0,     0,     0,     0,     0,     0,     0,   264,   265,
     266,   267,   268,   269,   270,   271,   272,     0,   273,     0,
     274,   275,   276,   277,   278,     0,   279,   280,   281,     0,
       0,   282,   283,   284,   285,   286,     0,   287,   288,   289,
       0,   290,   291,   292,     0,   293,   294,   295,   296,   297,
     298,   299,   300,   301,     0,   302,     0,   303,   304,   305,
     306,     0,   307,     0,   308,     0,     0,     0,   309,   310,
     311,     0,   312,   313,     0,   314,     0,   315,   316,   317,
     318,   965,     0,   320,   321,   322,     0,   323,   324,   325,
     326,   327,   328,     0,   329,     0,   330,   331,   332,   333,
     334,   335,   336,     0,   337,     0,   338,     0,     0,   339,
       0,   340,   341,   342,   343,   344,     0,   345,   346,     0,
     347,   348,     0,   349,     0,     0,   350,   351,   352,     0,
       0,   353,   354,   355,   356,   357,   358,   359,   360,   361,
     362,   363,   364,   365,   366,     0,   367,   368,   369,   370,
       0,   371,   372,     0,   373,     0,   374,   375,   376,   377,
     378,   379,     0,   380,     0,     0,   381,   382,   383,     0,
       0,   384,   385,     0,   386,     0,   387,   388,   389,   390,
     391,   392,   393,   394,     0,   395,   396,   397,   398,   399,
     400,   401,     0,   402,   403,   404,   405,   406,   407,   408,
     409,   410,   411,   412,   413,   414,     0,   415,   416,   417,
     418,   419,   420,   421,   422,   423,   424,   425,     0,   426,
     427,     0,   428,   429,   430,   431,   432,   433,   434,   435,
     436,   437,   438,     0,   439,   440,   441,   442,   443,     0,
     444,   445,   446,   447,     0,   448,   449,   450,     0,   451,
     452,   453,   454,   455,   456,   457,   458,   459,   460,   461,
       0,   462,   463,     0,   464,   465,   466,   467,   468,   469,
       0,   470,   471,     0,     0,   472,   473,   474,   475,     0,
     476,   477,   478,   479,   480,   481,   482,     0,     0,   483,
     484,   485,   486,   487,     0,     0,   488,   489,   490,   491,
     492,   493,   494,     0,   495,     0,   496,   497,   498,   499,
       0,     0,   500,     0,     0,   501,   502,   503,   504,   505,
     506,   507,   508,   509,   510,   511,   512,   513,   514,   515,
     516,   517,   518,   210,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,   211,   212,   213,   214,   215,   216,
     217,   218,     0,   220,   221,   222,     0,     0,     0,     0,
     223,     0,     0,     0,   224,   225,     0,   226,   227,     0,
     228,   229,   230,   231,   232,     0,   233,   234,     0,   235,
     236,   237,   238,   239,     0,     0,   689,   241,   242,   243,
     244,     0,   245,   246,   247,   248,   249,     0,     0,     0,
     250,   251,   252,   253,     0,   254,   255,     0,   256,   257,
     258,   259,   260,   261,     0,     0,   262,   263,     0,     0,
       0,     0,     0,     0,     0,   264,   265,   266,   267,   268,
     269,   270,   271,   272,     0,   273,     0,   274,   275,   276,
     277,   278,     0,   279,   280,   281,     0,     0,   282,   283,
     284,   285,   286,     0,   287,   288,   289,     0,   290,   291,
     292,     0,   293,   294,   295,   296,   297,   298,   299,   300,
     301,     0,   302,     0,   303,   304,   305,   306,     0,   307,
       0,   308,     0,     0,     0,   309,   310,   311,     0,   312,
     313,     0,   314,     0,   315,   316,   317,   318,   319,     0,
     320,   321,   322,     0,   323,   324,   325,   326,   327,   328,
       0,   329,     0,   330,   331,   332,   333,   334,   335,   336,
       0,   337,     0,   338,     0,     0,   339,     0,   340,   341,
     342,   343,   344,     0,   345,   346,     0,   347,   348,     0,
     349,     0,     0,   350,   351,   352,     0,     0,   353,   354,
     355,   356,   357,   358,   359,   360,   361,   362,   363,   364,
     692,   366,     0,   367,   368,   369,   370,     0,   371,   372,
       0,   373,     0,   374,   375,   376,   377,   378,   379,     0,
     380,     0,     0,   381,   382,   383,     0,     0,   384,   385,
       0,   386,     0,   387,   388,   389,   390,   391,   392,   393,
     394,     0,   395,   396,   397,   398,   399,   400,   401,     0,
     402,   403,   404,   405,   406,   407,   408,   409,   410,   411,
     412,   413,   414,     0,   415,   416,   417,   418,   419,   420,
     421,   422,   423,   424,   425,     0,   426,   427,     0,   693,
     429,   430,   431,   432,   433,   694,   435,   436,   437,   438,
       0,   439,   440,   441,   442,  1137,     0,   444,   445,   446,
     447,     0,   448,   449,   450,     0,   451,   452,   453,   454,
     455,   456,   457,   458,   459,   460,   461,     0,   462,   463,
       0,   464,   465,   466,   467,   468,   469,     0,   696,   471,
       0,     0,   697,   473,   474,   475,     0,   476,   477,   478,
     479,   480,   481,   482,     0,     0,   483,   484,   485,   486,
     487,     0,     0,   488,   489,   490,   491,   492,   493,   494,
       0,   495,     0,   496,   497,   498,   499,     0,     0,   500,
       0,     0,   501,   502,   503,   504,   505,   698,   507,   508,
     509,   510,   511,   512,   513,   514,   515,   516,   517,   518,
     210,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,   211,   212,   213,   214,   215,   216,   217,   218,     0,
     220,   221,   222,     0,     0,     0,     0,   223,     0,     0,
       0,   224,   225,     0,   226,   227,     0,   228,   229,   230,
     231,   232,     0,   233,   234,     0,   235,   236,   237,   238,
     239,     0,     0,   240,   241,   242,   243,   244,     0,   245,
     246,   247,   248,   249,     0,     0,     0,   250,   251,   252,
     253,     0,   254,   255,     0,   256,   257,   258,   259,   260,
     261,     0,     0,   262,   263,     0,     0,     0,     0,     0,
       0,     0,   264,   265,   266,   267,   268,   269,   270,   271,
     272,     0,   273,     0,   274,   275,   276,   277,   278,     0,
     279,   280,   281,     0,     0,   282,   283,   284,   285,   286,
       0,   287,   288,   289,     0,   290,   291,   292,     0,   293,
     294,   295,   296,   297,   298,   299,   300,   301,     0,   302,
       0,   303,   304,   305,   306,     0,   307,     0,   308,     0,
       0,     0,   309,   310,   311,     0,   312,   313,     0,   314,
       0,   315,   316,   317,   318,  1445,     0,   320,   321,   322,
       0,   323,   324,   325,   326,   327,   328,     0,   329,     0,
     330,   331,   332,   333,   334,   335,   336,     0,   337,     0,
     338,     0,     0,   339,     0,   340,   341,   342,   343,   344,
       0,   345,   346,     0,   347,   348,     0,   349,     0,     0,
     350,   351,   352,     0,     0,   353,   354,   355,   356,   357,
     358,   359,   360,   361,   362,   363,   364,   365,   366,     0,
     367,   368,   369,   370,     0,   371,   372,     0,   373,     0,
     374,   375,   376,   377,   378,   379,     0,   380,     0,     0,
     381,   382,   383,     0,     0,   384,   385,     0,   386,     0,
     387,   388,   389,   390,   391,   392,   393,   394,     0,   395,
     396,   397,   398,   399,   400,   401,     0,   402,   403,   404,
     405,   406,   407,   408,   409,   410,   411,   412,   413,   414,
       0,   415,   416,   417,   418,   419,   420,   421,   422,   423,
     424,   425,     0,   426,   427,     0,   428,   429,   430,   431,
     432,   433,   434,   435,   436,   437,   438,     0,   439,   440,
     441,   442,   443,     0,   444,   445,   446,   447,     0,   448,
     449,   450,     0,   451,   452,   453,   454,   455,   456,   457,
     458,   459,   460,   461,     0,   462,   463,     0,   464,   465,
     466,   467,   468,   469,     0,   470,   471,     0,     0,   472,
     473,   474,   475,     0,   476,   477,   478,   479,   480,   481,
     482,     0,     0,   483,   484,   485,   486,   487,     0,     0,
     488,   489,   490,   491,   492,   493,   494,     0,   495,     0,
     496,   497,   498,   499,     0,     0,   500,     0,     0,   501,
     502,   503,   504,   505,   506,   507,   508,   509,   510,   511,
     512,   513,   514,   515,   516,   517,   518,   210,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,   211,   212,
     213,   214,   215,   216,   217,   218,     0,   220,   221,   222,
       0,     0,     0,     0,   223,     0,     0,     0,   224,   225,
       0,   226,   227,     0,   228,   229,   230,   231,   232,     0,
     233,   234,     0,   235,   236,   237,   238,   239,     0,     0,
     240,   241,   242,   243,   244,     0,   245,   246,   247,   248,
     249,     0,     0,     0,   250,   251,   252,   253,     0,   254,
     255,     0,   256,   257,   258,   259,   260,   261,     0,     0,
     262,   263,     0,     0,     0,     0,     0,     0,     0,   264,
     265,   266,   267,   268,   269,   270,   271,   272,     0,   273,
       0,   274,   275,   276,   277,   278,     0,   279,   280,   281,
       0,     0,   282,   283,   284,   285,   286,     0,   287,   288,
     289,     0,   290,   291,   292,     0,   293,   294,   295,   296,
     297,   298,   299,   300,   301,     0,   302,     0,   303,   304,
     305,   306,     0,   307,     0,   308,     0,     0,     0,   309,
     310,   311,     0,   312,   313,     0,   314,     0,   315,   316,
     317,   318,  1475,     0,   320,   321,   322,     0,   323,   324,
     325,   326,   327,   328,     0,   329,     0,   330,   331,   332,
     333,   334,   335,   336,     0,   337,     0,   338,     0,     0,
     339,     0,   340,   341,   342,   343,   344,     0,   345,   346,
       0,   347,   348,     0,   349,     0,     0,   350,   351,   352,
       0,     0,   353,   354,   355,   356,   357,   358,   359,   360,
     361,   362,   363,   364,   365,   366,     0,   367,   368,   369,
     370,     0,   371,   372,     0,   373,     0,   374,   375,   376,
     377,   378,   379,     0,   380,     0,     0,   381,   382,   383,
       0,     0,   384,   385,     0,   386,     0,   387,   388,   389,
     390,   391,   392,   393,   394,     0,   395,   396,   397,   398,
     399,   400,   401,     0,   402,   403,   404,   405,   406,   407,
     408,   409,   410,   411,   412,   413,   414,     0,   415,   416,
     417,   418,   419,   420,   421,   422,   423,   424,   425,     0,
     426,   427,     0,   428,   429,   430,   431,   432,   433,   434,
     435,   436,   437,   438,     0,   439,   440,   441,   442,   443,
       0,   444,   445,   446,   447,     0,   448,   449,   450,     0,
     451,   452,   453,   454,   455,   456,   457,   458,   459,   460,
     461,     0,   462,   463,     0,   464,   465,   466,   467,   468,
     469,     0,   470,   471,     0,     0,   472,   473,   474,   475,
       0,   476,   477,   478,   479,   480,   481,   482,     0,     0,
     483,   484,   485,   486,   487,     0,     0,   488,   489,   490,
     491,   492,   493,   494,     0,   495,     0,   496,   497,   498,
     499,     0,     0,   500,     0,     0,   501,   502,   503,   504,
     505,   506,   507,   508,   509,   510,   511,   512,   513,   514,
     515,   516,   517,   518,   210,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,   211,   212,   213,   214,   215,
     216,   217,   218,     0,   220,   221,   222,     0,     0,     0,
       0,   223,     0,     0,     0,   224,   225,     0,   226,   227,
       0,   228,   229,   230,   231,   232,     0,   233,   234,     0,
     235,   236,   237,   238,   239,     0,     0,   240,   241,   242,
     243,   244,     0,   245,   246,   247,   248,   249,     0,     0,
       0,   250,   251,   252,   253,     0,   254,   255,     0,   256,
     257,   258,   259,   260,   261,     0,     0,   262,   263,     0,
       0,     0,     0,     0,     0,     0,   264,   265,   266,   267,
     268,   269,   270,   271,   272,     0,   273,     0,   274,   275,
     276,   277,   278,     0,   279,   280,   281,     0,     0,   282,
     283,   284,   285,   286,     0,   287,   288,   289,     0,   290,
     291,   292,     0,   293,   294,   295,   296,   297,   298,   299,
     300,   301,     0,   302,     0,   303,   304,   305,   306,     0,
     307,     0,   308,     0,     0,     0,   309,   310,   311,     0,
     312,   313,     0,   314,     0,   315,   316,   317,   318,  1504,
       0,   320,   321,   322,     0,   323,   324,   325,   326,   327,
     328,     0,   329,     0,   330,   331,   332,   333,   334,   335,
     336,     0,   337,     0,   338,     0,     0,   339,     0,   340,
     341,   342,   343,   344,     0,   345,   346,     0,   347,   348,
       0,   349,     0,     0,   350,   351,   352,     0,     0,   353,
     354,   355,   356,   357,   358,   359,   360,   361,   362,   363,
     364,   365,   366,     0,   367,   368,   369,   370,     0,   371,
     372,     0,   373,     0,   374,   375,   376,   377,   378,   379,
       0,   380,     0,     0,   381,   382,   383,     0,     0,   384,
     385,     0,   386,     0,   387,   388,   389,   390,   391,   392,
     393,   394,     0,   395,   396,   397,   398,   399,   400,   401,
       0,   402,   403,   404,   405,   406,   407,   408,   409,   410,
     411,   412,   413,   414,     0,   415,   416,   417,   418,   419,
     420,   421,   422,   423,   424,   425,     0,   426,   427,     0,
     428,   429,   430,   431,   432,   433,   434,   435,   436,   437,
     438,     0,   439,   440,   441,   442,   443,     0,   444,   445,
     446,   447,     0,   448,   449,   450,     0,   451,   452,   453,
     454,   455,   456,   457,   458,   459,   460,   461,     0,   462,
     463,     0,   464,   465,   466,   467,   468,   469,     0,   470,
     471,     0,     0,   472,   473,   474,   475,     0,   476,   477,
     478,   479,   480,   481,   482,     0,     0,   483,   484,   485,
     486,   487,     0,     0,   488,   489,   490,   491,   492,   493,
     494,     0,   495,     0,   496,   497,   498,   499,     0,     0,
     500,     0,     0,   501,   502,   503,   504,   505,   506,   507,
     508,   509,   510,   511,   512,   513,   514,   515,   516,   517,
     518,   210,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,   211,   212,   213,   214,   215,   216,   217,   218,
       0,   220,   221,   222,     0,     0,     0,     0,   223,     0,
       0,     0,   224,   225,     0,   226,   227,     0,   228,   229,
     230,   231,   232,     0,   233,   234,     0,   235,   236,   237,
     238,   239,     0,     0,   240,   241,   242,   243,   244,     0,
     245,   246,   247,   248,   249,     0,     0,     0,   250,   251,
     252,   253,     0,   254,   255,     0,   256,   257,   258,   259,
     260,   261,     0,     0,   262,   263,     0,     0,     0,     0,
       0,     0,     0,   264,   265,   266,   267,   268,   269,   270,
     271,   272,     0,   273,     0,   274,   275,   276,   277,   278,
       0,   279,   280,   281,     0,     0,   282,   283,   284,   285,
     286,     0,   287,   288,   289,     0,   290,   291,   292,     0,
     293,   294,   295,   296,   297,   298,   299,   300,   301,     0,
     302,     0,   303,   304,   305,   306,     0,   307,     0,   308,
       0,     0,     0,   309,   310,   311,     0,   312,   313,     0,
     314,     0,   315,   316,   317,   318,  1506,     0,   320,   321,
     322,     0,   323,   324,   325,   326,   327,   328,     0,   329,
       0,   330,   331,   332,   333,   334,   335,   336,     0,   337,
       0,   338,     0,     0,   339,     0,   340,   341,   342,   343,
     344,     0,   345,   346,     0,   347,   348,     0,   349,     0,
       0,   350,   351,   352,     0,     0,   353,   354,   355,   356,
     357,   358,   359,   360,   361,   362,   363,   364,   365,   366,
       0,   367,   368,   369,   370,     0,   371,   372,     0,   373,
       0,   374,   375,   376,   377,   378,   379,     0,   380,     0,
       0,   381,   382,   383,     0,     0,   384,   385,     0,   386,
       0,   387,   388,   389,   390,   391,   392,   393,   394,     0,
     395,   396,   397,   398,   399,   400,   401,     0,   402,   403,
     404,   405,   406,   407,   408,   409,   410,   411,   412,   413,
     414,     0,   415,   416,   417,   418,   419,   420,   421,   422,
     423,   424,   425,     0,   426,   427,     0,   428,   429,   430,
     431,   432,   433,   434,   435,   436,   437,   438,     0,   439,
     440,   441,   442,   443,     0,   444,   445,   446,   447,     0,
     448,   449,   450,     0,   451,   452,   453,   454,   455,   456,
     457,   458,   459,   460,   461,     0,   462,   463,     0,   464,
     465,   466,   467,   468,   469,     0,   470,   471,     0,     0,
     472,   473,   474,   475,     0,   476,   477,   478,   479,   480,
     481,   482,     0,     0,   483,   484,   485,   486,   487,     0,
       0,   488,   489,   490,   491,   492,   493,   494,     0,   495,
       0,   496,   497,   498,   499,     0,     0,   500,     0,     0,
     501,   502,   503,   504,   505,   506,   507,   508,   509,   510,
     511,   512,   513,   514,   515,   516,   517,   518,   210,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,   211,
     212,   213,   214,   215,   216,   217,   218,     0,   220,   221,
     222,     0,     0,     0,     0,   223,     0,     0,     0,   224,
     225,     0,   226,   227,     0,   228,   229,   230,   231,   232,
       0,   233,   234,     0,   235,   236,   237,   238,   239,     0,
       0,   240,   241,   242,   243,   244,     0,   245,   246,   247,
     248,   249,     0,     0,     0,   250,   251,   252,   253,     0,
     254,   255,     0,   256,   257,   258,   259,   260,   261,     0,
       0,   262,   263,     0,     0,     0,     0,     0,     0,     0,
     264,   265,   266,   267,   268,   269,   270,   271,   272,     0,
     273,     0,   274,   275,   276,   277,   278,     0,   279,   280,
     281,     0,     0,   282,   283,   284,   285,   286,     0,   287,
     288,   289,     0,   290,   291,   292,     0,   293,   294,   295,
     296,   297,   298,   299,   300,   301,     0,   302,     0,   303,
     304,   305,   306,     0,   307,     0,   308,     0,     0,     0,
     309,   310,   311,     0,   312,   313,     0,   314,     0,   315,
     316,   317,   318,  1508,     0,   320,   321,   322,     0,   323,
     324,   325,   326,   327,   328,     0,   329,     0,   330,   331,
     332,   333,   334,   335,   336,     0,   337,     0,   338,     0,
       0,   339,     0,   340,   341,   342,   343,   344,     0,   345,
     346,     0,   347,   348,     0,   349,     0,     0,   350,   351,
     352,     0,     0,   353,   354,   355,   356,   357,   358,   359,
     360,   361,   362,   363,   364,   365,   366,     0,   367,   368,
     369,   370,     0,   371,   372,     0,   373,     0,   374,   375,
     376,   377,   378,   379,     0,   380,     0,     0,   381,   382,
     383,     0,     0,   384,   385,     0,   386,     0,   387,   388,
     389,   390,   391,   392,   393,   394,     0,   395,   396,   397,
     398,   399,   400,   401,     0,   402,   403,   404,   405,   406,
     407,   408,   409,   410,   411,   412,   413,   414,     0,   415,
     416,   417,   418,   419,   420,   421,   422,   423,   424,   425,
       0,   426,   427,     0,   428,   429,   430,   431,   432,   433,
     434,   435,   436,   437,   438,     0,   439,   440,   441,   442,
     443,     0,   444,   445,   446,   447,     0,   448,   449,   450,
       0,   451,   452,   453,   454,   455,   456,   457,   458,   459,
     460,   461,     0,   462,   463,     0,   464,   465,   466,   467,
     468,   469,     0,   470,   471,     0,     0,   472,   473,   474,
     475,     0,   476,   477,   478,   479,   480,   481,   482,     0,
       0,   483,   484,   485,   486,   487,     0,     0,   488,   489,
     490,   491,   492,   493,   494,     0,   495,     0,   496,   497,
     498,   499,     0,     0,   500,     0,     0,   501,   502,   503,
     504,   505,   506,   507,   508,   509,   510,   511,   512,   513,
     514,   515,   516,   517,   518,   210,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,   211,   212,   213,   214,
     215,   216,   217,   218,     0,   220,   221,   222,     0,     0,
       0,     0,   223,     0,     0,     0,   224,   225,     0,   226,
     227,     0,   228,   229,   230,   231,   232,     0,   233,   234,
       0,   235,   236,   237,   238,   239,     0,     0,   240,   241,
     242,   243,   244,     0,   245,   246,   247,   248,   249,     0,
       0,     0,   250,   251,   252,   253,     0,   254,   255,     0,
     256,   257,   258,   259,   260,   261,     0,     0,   262,   263,
       0,     0,     0,     0,     0,     0,     0,   264,   265,   266,
     267,   268,   269,   270,   271,   272,     0,   273,     0,   274,
     275,   276,   277,   278,     0,   279,   280,   281,     0,     0,
     282,   283,   284,   285,   286,     0,   287,   288,   289,     0,
     290,   291,   292,     0,   293,   294,   295,   296,   297,   298,
     299,   300,   301,     0,   302,     0,   303,   304,   305,   306,
       0,   307,     0,   308,     0,     0,     0,   309,   310,   311,
       0,   312,   313,     0,   314,     0,   315,   316,   317,   318,
     319,     0,   320,   321,   322,     0,   323,   324,   325,   326,
     327,   328,     0,   329,     0,   330,   331,   332,   333,   334,
     335,   336,     0,   337,     0,   338,     0,     0,   339,     0,
     340,   341,   342,   343,   344,     0,   345,   346,     0,   347,
     348,     0,   349,     0,     0,   350,   351,   352,     0,     0,
     353,   354,   355,   356,   357,   358,   359,   360,   361,   362,
     363,   364,   365,   366,     0,   367,   368,   369,   370,     0,
     371,   372,     0,   373,     0,   374,   375,   376,   377,   378,
     379,     0,   380,     0,     0,   381,   382,   383,     0,     0,
     384,   385,     0,   386,     0,   387,   388,   389,   390,   391,
     392,   393,   394,     0,   395,   396,   397,   398,   399,   400,
     401,     0,   402,   403,   404,   405,   406,   407,   408,   409,
     410,   411,   412,   413,   414,     0,   415,   416,   417,   418,
     419,   420,   421,   422,   423,   424,   425,     0,   426,   427,
       0,   428,   429,   430,   431,   432,  1600,   434,   435,   436,
     437,   438,     0,   439,   440,   441,   442,   443,     0,   444,
     445,   446,   447,     0,   448,   449,   450,     0,   451,   452,
     453,   454,   455,   456,   457,   458,   459,   460,   461,     0,
     462,   463,     0,   464,   465,   466,   467,   468,   469,     0,
     470,   471,     0,     0,   472,   473,   474,   475,     0,   476,
     477,   478,   479,   480,   481,   482,     0,     0,   483,   484,
     485,   486,   487,     0,     0,   488,   489,   490,   491,   492,
     493,   494,     0,   495,     0,   496,   497,   498,   499,     0,
       0,   500,     0,     0,   501,   502,   503,   504,   505,   506,
     507,   508,   509,   510,   511,   512,   513,   514,   515,   516,
     517,   518,   210,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,   211,   212,   213,   214,   215,   216,   217,
     218,     0,   220,   221,   222,     0,     0,     0,     0,   223,
       0,  1876,     0,   224,   225,     0,   226,   227,     0,   228,
     229,   230,   231,   232,     0,   233,   234,     0,   235,   236,
     237,   238,   239,     0,     0,   240,   241,   242,   243,   244,
       0,   245,   246,   247,   248,   249,     0,     0,     0,   250,
     251,   252,   253,     0,   254,   255,     0,   256,   257,   258,
     259,   260,   261,     0,     0,   262,   263,     0,     0,     0,
       0,     0,     0,     0,   264,   265,   266,   267,   268,   269,
     270,   271,   272,     0,   273,     0,   274,   275,   276,   277,
     278,     0,   279,   280,   281,     0,     0,   282,   283,   284,
     285,   286,     0,   287,   288,   289,     0,   290,   291,   292,
       0,   293,   294,   295,   296,   297,   298,   299,   300,   301,
       0,   302,     0,   303,   304,   305,   306,     0,   307,     0,
     308,     0,     0,     0,   309,   310,   311,     0,   312,   313,
       0,   314,     0,   315,   316,   317,   318,   319,     0,   320,
     321,   322,     0,   323,   324,   325,   326,   327,   328,     0,
     329,     0,   330,   331,   332,   333,   334,   335,   336,     0,
     337,     0,   338,     0,     0,   339,     0,   340,   341,   342,
     343,   344,     0,   345,   346,     0,   347,   348,     0,   349,
       0,     0,   350,   351,   352,     0,     0,   353,   354,   355,
     356,   357,   358,   359,   360,   361,   362,   363,   364,   365,
     366,     0,   367,   368,   369,   370,     0,   371,   372,     0,
     373,     0,   374,   375,   376,   377,   378,   379,     0,   380,
       0,     0,   381,   382,   383,     0,     0,   384,   385,     0,
     386,     0,   387,   388,   389,   390,   391,   392,   393,   394,
       0,   395,   396,   397,   398,   399,   400,   401,     0,   402,
     403,   404,   405,   406,   407,   408,   409,   410,   411,   412,
     413,   414,     0,   415,   416,   417,   418,   419,   420,   421,
     422,   423,   424,   425,     0,   426,   427,     0,   428,   429,
     430,   431,   432,   433,   434,   435,   436,   437,   438,     0,
     439,   440,   441,   442,   443,     0,     0,   445,   446,   447,
       0,   448,   449,   450,     0,   451,   452,   453,   454,   455,
     456,   457,   458,   459,   460,   461,     0,   462,   463,     0,
     464,   465,   466,   467,   468,   469,     0,   470,   471,     0,
       0,   472,   473,   474,   475,     0,   476,   477,   478,   479,
     480,   481,   482,     0,     0,   483,   484,   485,   486,   487,
       0,     0,   488,   489,   490,   491,   492,   493,   494,     0,
     495,     0,   496,   497,   498,   499,     0,     0,   500,     0,
       0,   501,   502,   503,   504,   505,   506,   507,   508,   509,
     510,   511,   512,   513,   514,   515,   516,   517,   518,   210,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
     211,   212,   213,   214,   215,   216,   217,   218,     0,   220,
     221,   222,     0,     0,     0,     0,   223,     0,     0,     0,
     224,   225,     0,   226,   227,     0,   228,   229,   230,   231,
     232,     0,   233,   234,     0,   235,   236,   237,   238,   239,
       0,     0,   689,   241,   242,   243,   244,     0,   245,   246,
     247,   248,   249,     0,     0,     0,   250,   251,   252,   253,
       0,   254,   255,     0,   256,   257,   258,   259,   260,   261,
       0,     0,   262,   263,     0,     0,     0,     0,     0,     0,
       0,   264,   265,   266,   267,   268,   269,   270,   271,   272,
       0,   273,     0,   274,   275,   276,   277,   278,     0,   279,
     280,   281,     0,     0,   282,   283,   284,   285,   286,     0,
     287,   288,   289,     0,   290,   291,   292,     0,   293,   294,
     295,   296,   297,   298,   299,   300,   301,     0,   302,     0,
     303,   304,   305,   306,     0,   307,     0,   308,     0,     0,
       0,   309,   310,   311,     0,   312,   313,     0,   314,     0,
     315,   316,   317,   318,   319,     0,   320,   321,   322,     0,
     323,   324,   325,   326,   327,   328,     0,   329,     0,   330,
     331,   332,   333,   334,   335,   336,     0,   337,     0,   338,
       0,     0,   339,     0,   340,   341,   342,   343,   344,     0,
     345,   346,     0,   347,   348,     0,   349,     0,     0,   350,
     351,   352,     0,     0,   353,   354,   355,   356,   357,   358,
     359,   360,   361,   362,   363,   364,   692,   366,     0,   367,
     368,   369,   370,     0,   371,   372,     0,   373,     0,   374,
     375,   376,   377,   378,   379,     0,   380,     0,     0,   381,
     382,   383,     0,     0,   384,   385,     0,   386,     0,   387,
     388,   389,   390,   391,   392,   393,   394,     0,   395,   396,
     397,   398,   399,   400,   401,     0,   402,   403,   404,   405,
     406,   407,   408,   409,   410,   411,   412,   413,   414,     0,
     415,   416,   417,   418,   419,   420,   421,   422,   423,   424,
     425,     0,   426,   427,     0,   693,   429,   430,   431,   432,
     433,   694,   435,   436,   437,   438,     0,   439,   440,   441,
     442,  1137,     0,   444,   445,   446,   447,     0,   448,   449,
     450,     0,   451,   452,   453,   454,   455,   456,   457,   458,
     459,   460,   461,     0,   462,   463,     0,   464,  1907,   466,
     467,   468,   469,     0,   696,   471,     0,     0,   697,   473,
     474,   475,     0,   476,   477,   478,   479,   480,   481,   482,
       0,     0,   483,   484,   485,   486,   487,     0,     0,   488,
     489,   490,   491,   492,   493,   494,     0,   495,     0,   496,
     497,   498,   499,     0,     0,   500,     0,     0,   501,   502,
     503,   504,   505,   698,   507,   508,   509,   510,   511,   512,
     513,   514,   515,   516,   517,   518,   210,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,   211,   212,   213,
     214,   215,   216,   217,   218,     0,   220,   221,   222,     0,
       0,     0,     0,   223,     0,     0,     0,   224,   225,     0,
     226,   227,     0,   228,   229,   230,   231,   232,     0,   233,
     234,     0,   235,   236,   237,   238,   239,     0,     0,   689,
     241,   242,   243,   244,     0,   245,   246,   247,   248,   249,
       0,     0,     0,   250,   251,   252,   253,     0,   254,   255,
       0,   256,   257,   258,   259,   260,   261,     0,     0,   262,
     263,     0,     0,     0,     0,     0,     0,     0,   264,   265,
     266,   267,   268,   269,   270,   271,   272,     0,   273,     0,
     274,   275,   276,   277,   278,     0,   279,   280,   281,     0,
       0,   282,   283,   284,   285,   286,     0,   287,   288,   289,
       0,   290,   291,   292,     0,   293,   294,   295,   296,   297,
     298,   299,   300,   301,     0,   302,     0,   303,   304,   305,
     306,     0,   307,     0,   308,     0,     0,     0,   309,   310,
     311,     0,   312,   313,     0,   314,     0,   315,   316,   317,
     318,   319,     0,   320,   321,   322,     0,   323,   324,   325,
     326,   327,   328,     0,   329,     0,   330,   331,   332,   333,
     334,   335,   336,     0,   337,     0,   338,     0,     0,   339,
       0,   340,   341,   342,   343,   344,     0,   345,   346,     0,
     347,   348,     0,   349,     0,     0,   350,   351,   352,     0,
       0,   353,   354,   355,   356,   357,   358,   359,   360,   361,
     362,   363,   364,   692,   366,     0,   367,   368,   369,   370,
       0,   371,   372,     0,   373,     0,   374,   375,   376,   377,
     378,   379,     0,   380,     0,     0,   381,   382,   383,     0,
       0,   384,   385,     0,   386,     0,   387,   388,   389,   390,
     391,   392,   393,   394,     0,   395,   396,   397,   398,   399,
     400,   401,     0,   402,   403,   404,   405,   406,   407,   408,
     409,   410,   411,   412,   413,   414,     0,   415,   416,   417,
     418,   419,   420,   421,   422,   423,   424,   425,     0,   426,
     427,     0,   693,   429,   430,   431,   432,   433,  1974,   435,
     436,   437,   438,     0,   439,   440,   441,   442,  1975,     0,
     444,   445,   446,   447,     0,   448,   449,   450,     0,   451,
     452,   453,   454,   455,   456,   457,   458,   459,   460,   461,
       0,   462,   463,     0,   464,   465,   466,   467,   468,   469,
       0,   696,   471,     0,     0,  1976,   473,   474,   475,     0,
     476,   477,   478,   479,   480,   481,   482,     0,     0,   483,
     484,   485,   486,   487,     0,     0,   488,   489,   490,   491,
     492,   493,   494,     0,   495,     0,   496,   497,   498,   499,
       0,     0,   500,     0,     0,   501,   502,   503,   504,   505,
     698,   507,   508,   509,   510,   511,   512,   513,   514,   515,
     516,   517,   518,   210,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,   211,   212,   213,   214,   215,   216,
     217,   218,     0,   220,   221,   222,     0,     0,     0,     0,
     223,     0,     0,     0,   224,   225,     0,   226,   227,     0,
     228,   229,   230,   231,   232,     0,   233,   234,     0,   235,
     236,   237,   238,   239,     0,     0,   240,   241,   242,   243,
     244,     0,   245,   246,   247,   248,   249,     0,     0,     0,
     250,   251,   252,   253,     0,   254,   255,     0,   256,   257,
     258,   259,   260,   261,     0,     0,   262,   263,     0,     0,
       0,     0,     0,     0,     0,   264,   265,   266,   267,   268,
     269,   270,   271,   272,     0,   273,     0,   274,   275,   276,
     277,   278,     0,   279,   280,   281,     0,     0,   282,   283,
     284,   285,   286,     0,   287,   288,   289,     0,   290,   291,
     292,     0,   293,   294,   295,   296,   297,   298,   299,   300,
     301,     0,   302,     0,   303,   304,   305,   306,     0,   307,
       0,   308,     0,     0,     0,   309,   310,   311,     0,   312,
     313,     0,   314,     0,   315,   316,   317,   318,  2233,     0,
     320,   321,   322,     0,   323,   324,   325,   326,   327,   328,
       0,   329,     0,   330,   331,   332,   333,   334,   335,   336,
       0,   337,     0,   338,     0,     0,   339,     0,   340,   341,
     342,   343,   344,     0,   345,   346,     0,   347,   348,     0,
     349,     0,     0,   350,   351,   352,     0,     0,   353,   354,
     355,   356,   357,   358,   359,   360,   361,   362,   363,   364,
     365,   366,     0,   367,   368,   369,   370,     0,   371,   372,
       0,   373,     0,   374,   375,   376,   377,   378,   379,     0,
     380,     0,     0,   381,   382,   383,     0,     0,   384,   385,
       0,   386,     0,   387,   388,   389,   390,   391,   392,   393,
     394,     0,   395,   396,   397,   398,   399,   400,   401,     0,
     402,   403,   404,   405,   406,   407,   408,   409,   410,   411,
     412,   413,   414,     0,   415,   416,   417,   418,   419,   420,
     421,   422,   423,   424,   425,     0,   426,   427,     0,   428,
     429,   430,   431,   432,   433,   434,   435,   436,   437,   438,
       0,   439,   440,   441,   442,   443,     0,   444,   445,   446,
     447,     0,   448,   449,   450,     0,   451,   452,   453,   454,
     455,   456,   457,   458,   459,   460,   461,     0,   462,   463,
       0,   464,   465,   466,   467,   468,   469,     0,   470,   471,
       0,     0,   472,   473,   474,   475,     0,   476,   477,   478,
     479,   480,   481,   482,     0,     0,   483,   484,   485,   486,
     487,     0,     0,   488,   489,   490,   491,   492,   493,   494,
       0,   495,     0,   496,   497,   498,   499,     0,     0,   500,
       0,     0,   501,   502,   503,   504,   505,   506,   507,   508,
     509,   510,   511,   512,   513,   514,   515,   516,   517,   518,
     210,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,   211,   212,   213,   214,   215,   216,   217,   218,     0,
     220,   221,   222,     0,     0,     0,     0,   223,     0,     0,
       0,   224,   225,     0,   226,   227,     0,   228,   229,   230,
     231,   232,     0,   233,   234,     0,   235,   236,   237,   238,
     239,     0,     0,   240,   241,   242,   243,   244,     0,   245,
     246,   247,   248,   249,     0,     0,     0,   250,   251,   252,
     253,     0,   254,   255,     0,   256,   257,   258,   259,   260,
     261,     0,     0,   262,   263,     0,     0,     0,     0,     0,
       0,     0,   264,   265,   266,   267,   268,   269,   270,   271,
     272,     0,   273,     0,   274,   275,   276,   277,   278,     0,
     279,   280,   281,     0,     0,   282,   283,   284,   285,   286,
       0,   287,   288,   289,     0,   290,   291,   292,     0,   293,
     294,   295,   296,   297,   298,   299,   300,   301,     0,   302,
       0,   303,   304,   305,   306,     0,   307,     0,   308,     0,
       0,     0,   309,   310,   311,     0,   312,   313,     0,   314,
       0,   315,   316,   317,   318,  2581,     0,   320,   321,   322,
       0,   323,   324,   325,   326,   327,   328,     0,   329,     0,
     330,   331,   332,   333,   334,   335,   336,     0,   337,     0,
     338,     0,     0,   339,     0,   340,   341,   342,   343,   344,
       0,   345,   346,     0,   347,   348,     0,   349,     0,     0,
     350,   351,   352,     0,     0,   353,   354,   355,   356,   357,
     358,   359,   360,   361,   362,   363,   364,   365,   366,     0,
     367,   368,   369,   370,     0,   371,   372,     0,   373,     0,
     374,   375,   376,   377,   378,   379,     0,   380,     0,     0,
     381,   382,   383,     0,     0,   384,   385,     0,   386,     0,
     387,   388,   389,   390,   391,   392,   393,   394,     0,   395,
     396,   397,   398,   399,   400,   401,     0,   402,   403,   404,
     405,   406,   407,   408,   409,   410,   411,   412,   413,   414,
       0,   415,   416,   417,   418,   419,   420,   421,   422,   423,
     424,   425,     0,   426,   427,     0,   428,   429,   430,   431,
     432,   433,   434,   435,   436,   437,   438,     0,   439,   440,
     441,   442,   443,     0,   444,   445,   446,   447,     0,   448,
     449,   450,     0,   451,   452,   453,   454,   455,   456,   457,
     458,   459,   460,   461,     0,   462,   463,     0,   464,   465,
     466,   467,   468,   469,     0,   470,   471,     0,     0,   472,
     473,   474,   475,     0,   476,   477,   478,   479,   480,   481,
     482,     0,     0,   483,   484,   485,   486,   487,     0,     0,
     488,   489,   490,   491,   492,   493,   494,     0,   495,     0,
     496,   497,   498,   499,     0,     0,   500,     0,     0,   501,
     502,   503,   504,   505,   506,   507,   508,   509,   510,   511,
     512,   513,   514,   515,   516,   517,   518,   210,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,   211,   212,
     213,   214,   215,   216,   217,   218,     0,   220,   221,   222,
       0,     0,     0,     0,   223,     0,     0,     0,   224,   225,
       0,   226,   227,     0,   228,   229,   230,   231,   232,     0,
     233,   234,     0,   235,   236,   237,   238,   239,     0,     0,
     689,   241,   242,   243,   244,     0,   245,   246,   247,   248,
     249,     0,     0,     0,   250,   251,   252,   253,     0,   254,
     255,     0,   256,   257,   258,   259,   260,   261,     0,     0,
     262,   263,     0,     0,     0,     0,     0,     0,     0,   264,
     265,   266,   267,   268,   269,   270,   271,   272,     0,   273,
       0,   274,   275,   276,   277,   278,     0,   279,   280,   281,
       0,     0,   282,   283,   284,   285,   286,     0,   287,   288,
     289,     0,   290,   291,   292,     0,   293,   294,   295,   296,
     297,   298,   299,   300,   301,     0,   302,     0,   303,   304,
     305,   306,     0,   307,     0,   308,     0,     0,     0,   309,
     310,   311,     0,   312,   313,     0,   314,     0,   315,   316,
     317,   318,   319,     0,   320,   321,   322,     0,   323,   324,
     325,   326,   327,   328,     0,   329,     0,   330,   331,   332,
     333,   334,   335,   336,     0,   337,     0,   338,     0,     0,
     339,     0,   340,   341,   342,   343,   344,     0,   345,   346,
       0,   347,   348,     0,   349,     0,     0,   350,   351,   352,
       0,     0,   353,   354,   355,   356,   357,   358,   359,   360,
     361,   362,   363,   364,   692,   366,     0,   367,   368,   369,
     370,     0,   371,   372,     0,   373,     0,   374,   375,   376,
     377,   378,   379,     0,   380,     0,     0,   381,   382,   383,
       0,     0,   384,   385,     0,   386,     0,   387,   388,   389,
     390,   391,   392,   393,   394,     0,   395,   396,   397,   398,
     399,   400,   401,     0,   402,   403,   404,   405,   406,   407,
     408,   409,   410,   411,   412,   413,   414,     0,   415,   416,
     417,   418,   419,   420,   421,   422,   423,   424,   425,     0,
     426,   427,     0,   693,   429,   430,   431,   432,   433,   694,
     435,   436,   437,   438,     0,   439,   440,   441,   442,  1975,
       0,   444,   445,   446,   447,     0,   448,   449,   450,     0,
     451,   452,   453,   454,   455,   456,   457,   458,   459,   460,
     461,     0,   462,   463,     0,   464,   465,   466,   467,   468,
     469,     0,   696,   471,     0,     0,  1976,   473,   474,   475,
       0,   476,   477,   478,   479,   480,   481,   482,     0,     0,
     483,   484,   485,   486,   487,     0,     0,   488,   489,   490,
     491,   492,   493,   494,     0,   495,     0,   496,   497,   498,
     499,     0,     0,   500,     0,     0,   501,   502,   503,   504,
     505,   698,   507,   508,   509,   510,   511,   512,   513,   514,
     515,   516,   517,   518,   210,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,   211,   212,   213,   214,   215,
     216,   217,   218,     0,   220,   221,   222,     0,     0,     0,
       0,   223,     0,     0,     0,   224,   225,     0,   226,   227,
       0,   228,   229,   230,   231,   232,     0,   233,   234,     0,
     235,   236,   237,   238,   239,     0,     0,   240,   241,   242,
     243,   244,     0,   245,   246,   247,   248,   249,     0,     0,
       0,   250,   251,   252,   253,     0,   254,   255,     0,   256,
     257,   258,   259,   260,   261,     0,     0,   262,   263,     0,
       0,     0,     0,     0,     0,     0,   264,   265,   266,   267,
     268,   269,   270,   271,   272,     0,   273,     0,   274,   275,
     276,   277,   278,     0,   279,   280,   281,     0,     0,   282,
     283,   284,   285,   286,     0,   287,   288,   289,     0,   290,
     291,   292,     0,   293,   294,   295,   296,   297,   298,   299,
     300,   301,     0,   302,     0,   303,   304,   305,   306,     0,
     307,     0,   308,     0,     0,     0,   309,   310,   311,     0,
     312,   313,     0,   314,     0,   315,   316,   317,   318,  2654,
       0,   320,   321,   322,     0,   323,   324,   325,   326,   327,
     328,     0,   329,     0,   330,   331,   332,   333,   334,   335,
     336,     0,   337,     0,   338,     0,     0,   339,     0,   340,
     341,   342,   343,   344,     0,   345,   346,     0,   347,   348,
       0,   349,     0,     0,   350,   351,   352,     0,     0,   353,
     354,   355,   356,   357,   358,   359,   360,   361,   362,   363,
     364,   365,   366,     0,   367,   368,   369,   370,     0,   371,
     372,     0,   373,     0,   374,   375,   376,   377,   378,   379,
       0,   380,     0,     0,   381,   382,   383,     0,     0,   384,
     385,     0,   386,     0,   387,   388,   389,   390,   391,   392,
     393,   394,     0,   395,   396,   397,   398,   399,   400,   401,
       0,   402,   403,   404,   405,   406,   407,   408,   409,   410,
     411,   412,   413,   414,     0,   415,   416,   417,   418,   419,
     420,   421,   422,   423,   424,   425,     0,   426,   427,     0,
     428,   429,   430,   431,   432,   433,   434,   435,   436,   437,
     438,     0,   439,   440,   441,   442,   443,     0,   444,   445,
     446,   447,     0,   448,   449,   450,     0,   451,   452,   453,
     454,   455,   456,   457,   458,   459,   460,   461,     0,   462,
     463,     0,   464,   465,   466,   467,   468,   469,     0,   470,
     471,     0,     0,   472,   473,   474,   475,     0,   476,   477,
     478,   479,   480,   481,   482,     0,     0,   483,   484,   485,
     486,   487,     0,     0,   488,   489,   490,   491,   492,   493,
     494,     0,   495,     0,   496,   497,   498,   499,     0,     0,
     500,     0,     0,   501,   502,   503,   504,   505,   506,   507,
     508,   509,   510,   511,   512,   513,   514,   515,   516,   517,
     518,   210,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,   211,   212,   213,   214,   215,   216,   217,   218,
       0,   220,   221,   222,     0,     0,     0,     0,   223,     0,
       0,     0,   224,   225,     0,   226,   227,     0,   228,   229,
     230,   231,   232,     0,   233,   234,     0,   235,   236,   237,
     238,   239,     0,     0,   240,   241,   242,   243,   244,     0,
     245,   246,   247,   248,   249,     0,     0,     0,   250,   251,
     252,   253,     0,   254,   255,     0,   256,   257,   258,   259,
     260,   261,     0,     0,   262,   263,     0,     0,     0,     0,
       0,     0,     0,   264,   265,   266,   267,   268,   269,   270,
     271,   272,     0,   273,     0,   274,   275,   276,   277,   278,
       0,   279,   280,   281,     0,     0,   282,   283,   284,   285,
     286,     0,   287,   288,   289,     0,   290,   291,   292,     0,
     293,   294,   295,   296,   297,   298,   299,   300,   301,     0,
     302,     0,   303,   304,   305,   306,     0,   307,     0,   308,
       0,     0,     0,   309,   310,   311,     0,   312,   313,     0,
     314,     0,   315,   316,   317,   318,  2656,     0,   320,   321,
     322,     0,   323,   324,   325,   326,   327,   328,     0,   329,
       0,   330,   331,   332,   333,   334,   335,   336,     0,   337,
       0,   338,     0,     0,   339,     0,   340,   341,   342,   343,
     344,     0,   345,   346,     0,   347,   348,     0,   349,     0,
       0,   350,   351,   352,     0,     0,   353,   354,   355,   356,
     357,   358,   359,   360,   361,   362,   363,   364,   365,   366,
       0,   367,   368,   369,   370,     0,   371,   372,     0,   373,
       0,   374,   375,   376,   377,   378,   379,     0,   380,     0,
       0,   381,   382,   383,     0,     0,   384,   385,     0,   386,
       0,   387,   388,   389,   390,   391,   392,   393,   394,     0,
     395,   396,   397,   398,   399,   400,   401,     0,   402,   403,
     404,   405,   406,   407,   408,   409,   410,   411,   412,   413,
     414,     0,   415,   416,   417,   418,   419,   420,   421,   422,
     423,   424,   425,     0,   426,   427,     0,   428,   429,   430,
     431,   432,   433,   434,   435,   436,   437,   438,     0,   439,
     440,   441,   442,   443,     0,   444,   445,   446,   447,     0,
     448,   449,   450,     0,   451,   452,   453,   454,   455,   456,
     457,   458,   459,   460,   461,     0,   462,   463,     0,   464,
     465,   466,   467,   468,   469,     0,   470,   471,     0,     0,
     472,   473,   474,   475,     0,   476,   477,   478,   479,   480,
     481,   482,     0,     0,   483,   484,   485,   486,   487,     0,
       0,   488,   489,   490,   491,   492,   493,   494,     0,   495,
       0,   496,   497,   498,   499,     0,     0,   500,     0,     0,
     501,   502,   503,   504,   505,   506,   507,   508,   509,   510,
     511,   512,   513,   514,   515,   516,   517,   518,   210,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,   211,
     212,   213,   214,   215,   216,   217,   218,     0,   220,   221,
     222,     0,     0,     0,     0,   223,     0,     0,     0,   224,
     225,     0,   226,   227,     0,   228,   229,   230,   231,   232,
       0,   233,   234,     0,   235,   236,   237,   238,   239,     0,
       0,   240,   241,   242,   243,   244,     0,   245,   246,   247,
     248,   249,     0,     0,     0,   250,   251,   252,   253,     0,
     254,   255,     0,   256,   257,   258,   259,   260,   261,     0,
       0,   262,   263,     0,     0,     0,     0,     0,     0,     0,
     264,   265,   266,   267,   268,   269,   270,   271,   272,     0,
     273,     0,   274,   275,   276,   277,   278,     0,   279,   280,
     281,     0,     0,   282,   283,   284,   285,   286,     0,   287,
     288,   289,     0,   290,   291,   292,     0,   293,   294,   295,
     296,   297,   298,   299,   300,   301,     0,   302,     0,   303,
     304,   305,   306,     0,   307,     0,   308,     0,     0,     0,
     309,   310,   311,     0,   312,   313,     0,   314,     0,   315,
     316,   317,   318,  2761,     0,   320,   321,   322,     0,   323,
     324,   325,   326,   327,   328,     0,   329,     0,   330,   331,
     332,   333,   334,   335,   336,     0,   337,     0,   338,     0,
       0,   339,     0,   340,   341,   342,   343,   344,     0,   345,
     346,     0,   347,   348,     0,   349,     0,     0,   350,   351,
     352,     0,     0,   353,   354,   355,   356,   357,   358,   359,
     360,   361,   362,   363,   364,   365,   366,     0,   367,   368,
     369,   370,     0,   371,   372,     0,   373,     0,   374,   375,
     376,   377,   378,   379,     0,   380,     0,     0,   381,   382,
     383,     0,     0,   384,   385,     0,   386,     0,   387,   388,
     389,   390,   391,   392,   393,   394,     0,   395,   396,   397,
     398,   399,   400,   401,     0,   402,   403,   404,   405,   406,
     407,   408,   409,   410,   411,   412,   413,   414,     0,   415,
     416,   417,   418,   419,   420,   421,   422,   423,   424,   425,
       0,   426,   427,     0,   428,   429,   430,   431,   432,   433,
     434,   435,   436,   437,   438,     0,   439,   440,   441,   442,
     443,     0,   444,   445,   446,   447,     0,   448,   449,   450,
       0,   451,   452,   453,   454,   455,   456,   457,   458,   459,
     460,   461,     0,   462,   463,     0,   464,   465,   466,   467,
     468,   469,     0,   470,   471,     0,     0,   472,   473,   474,
     475,     0,   476,   477,   478,   479,   480,   481,   482,     0,
       0,   483,   484,   485,   486,   487,     0,     0,   488,   489,
     490,   491,   492,   493,   494,     0,   495,     0,   496,   497,
     498,   499,     0,     0,   500,     0,     0,   501,   502,   503,
     504,   505,   506,   507,   508,   509,   510,   511,   512,   513,
     514,   515,   516,   517,   518,  1399,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,   211,   212,   213,   214,
     215,   216,   217,   218,     0,   220,   221,   222,     0,     0,
       0,     0,   223,     0,     0,     0,   224,   225,     0,   226,
     227,   745,   228,   229,   230,     0,  1400,   746,  1401,  1402,
       0,   235,   236,   237,   238,   239,     0,     0,   240,   241,
    1403,  1404,   244,     0,   245,   246,   247,   248,     0,     0,
     747,     0,   250,   251,   252,   253,   748,   254,   255,     0,
     256,   257,   258,   259,   260,   261,     0,   749,   262,   263,
       0,     0,     0,   750,     0,     0,     0,   264,   265,   266,
     267,   268,   269,  1405,  1406,   272,     0,   273,     0,   274,
     275,   276,   277,   278,     0,   279,   280,   281,     0,     0,
     282,   283,  1057,   285,   286,     0,   287,   288,   289,     0,
     290,   291,   292,     0,   293,   294,   295,   296,     0,   298,
     299,   300,     0,     0,   302,     0,   303,   304,  1407,   306,
       0,   307,     0,   308,   751,     0,   752,   309,   310,   311,
       0,   312,     0,     0,   314,     0,   315,   316,   317,   318,
     319,   753,   320,   321,   322,  1879,   323,   324,   325,   326,
     327,   328,     0,   329,   754,  1880,   331,   332,   333,   334,
    1408,  1409,     0,  1410,     0,   338,   755,   756,   339,   757,
     340,   341,   342,   343,   344,     0,   345,   346,     0,   347,
       0,   758,   349,   759,     0,   350,   351,   352,     0,     0,
     353,   354,   355,   356,   357,   358,   359,   360,   361,   362,
     363,   364,   365,  1411,   760,  1412,   368,   369,     0,     0,
     371,   372,   761,   373,     0,     0,   375,  1413,   377,   378,
     379,     0,   380,     0,     0,   381,   382,   383,     0,     0,
     384,  1882,   762,   386,   763,     0,   388,   389,   390,   391,
     392,   393,   394,     0,   395,     0,   397,     0,   399,   400,
     401,     0,   402,   403,   404,   405,   406,   407,   408,   409,
    1414,   411,   412,   413,   414,     0,   415,   416,   417,   418,
     419,   420,   421,   422,   423,   424,   425,     0,   426,   427,
     764,   428,   429,     0,   431,   432,   433,   434,   435,   436,
     437,   438,     0,   439,   440,   441,   442,   443,     0,   444,
    1883,   446,   447,   765,   448,  1416,   450,     0,   451,   452,
     453,   454,   455,   456,   457,   458,   459,   460,     0,     0,
     462,   463,     0,   464,   465,   466,   467,   468,   469,     0,
    1417,  1418,     0,     0,   472,     0,   474,     0,     0,   476,
     477,   478,   479,   480,   481,   482,     0,     0,   483,   484,
     485,   486,   487,     0,     0,   488,   489,   490,   491,   492,
       0,  1419,  1884,   495,   766,   496,   497,   498,   499,     0,
       0,   500,     0,     0,   501,   502,   503,   504,   505,   506,
       0,  1399,     0,     0,     0,     0,     0,     0,     0,   516,
     517,   518,   211,   212,   213,   214,   215,   216,   217,   218,
       0,   220,   221,   222,     0,     0,     0,     0,   223,     0,
       0,     0,   224,   225,     0,   226,   227,   745,   228,   229,
     230,     0,  1400,   746,  1401,  1402,     0,   235,   236,   237,
     238,   239,     0,     0,   240,   241,  1403,  1404,   244,     0,
     245,   246,   247,   248,     0,     0,   747,     0,   250,   251,
     252,   253,   748,   254,   255,     0,   256,   257,   258,   259,
     260,   261,     0,   749,   262,   263,     0,     0,     0,   750,
       0,     0,     0,   264,   265,   266,   267,   268,   269,  1405,
    1406,   272,     0,   273,     0,   274,   275,   276,   277,   278,
       0,   279,   280,   281,     0,     0,   282,   283,  1057,   285,
     286,     0,   287,   288,   289,     0,   290,   291,   292,     0,
     293,   294,   295,   296,     0,   298,   299,   300,     0,     0,
     302,     0,   303,   304,  1407,   306,     0,   307,     0,   308,
     751,     0,   752,   309,   310,   311,     0,   312,     0,     0,
     314,     0,   315,   316,   317,   318,   319,   753,   320,   321,
     322,     0,   323,   324,   325,   326,   327,   328,     0,   329,
     754,     0,   331,   332,   333,   334,  1408,  1409,     0,  1410,
       0,   338,   755,   756,   339,   757,   340,   341,   342,   343,
     344,     0,   345,   346,     0,   347,     0,   758,   349,   759,
       0,   350,   351,   352,     0,     0,   353,   354,   355,   356,
     357,   358,   359,   360,   361,   362,   363,   364,   365,  1411,
     760,  1412,   368,   369,     0,     0,   371,   372,   761,   373,
    1970,     0,   375,  1413,   377,   378,   379,     0,   380,     0,
       0,   381,   382,   383,     0,     0,   384,     0,   762,   386,
     763,     0,   388,   389,   390,   391,   392,   393,   394,     0,
     395,     0,   397,     0,   399,   400,   401,     0,   402,   403,
     404,   405,   406,   407,   408,   409,  1414,   411,   412,   413,
     414,     0,   415,   416,   417,   418,   419,   420,   421,   422,
     423,   424,   425,     0,   426,   427,   764,   428,   429,     0,
     431,   432,   433,   434,   435,   436,   437,   438,     0,   439,
     440,   441,   442,   443,     0,   444,  1883,   446,   447,   765,
     448,  1416,   450,     0,   451,   452,   453,   454,   455,   456,
     457,   458,   459,   460,     0,     0,   462,   463,  3433,   464,
     465,   466,   467,   468,   469,     0,  1417,  1418,     0,     0,
     472,     0,   474,     0,     0,   476,   477,   478,   479,   480,
     481,   482,     0,     0,   483,   484,   485,   486,   487,     0,
       0,   488,   489,   490,   491,   492,     0,  1419,     0,   495,
     766,   496,   497,   498,   499,     0,     0,   500,     0,     0,
     501,   502,   503,   504,   505,   506,     0,   210,     0,     0,
       0,     0,     0,     0,     0,   516,   517,   518,   211,   212,
     213,   214,   215,   216,   217,   218,     0,   220,   221,   222,
       0,     0,     0,     0,   223,     0,     0,     0,   224,   225,
       0,   226,   227,     0,   228,   229,   230,   231,   232,     0,
     233,   234,     0,   235,   236,   237,   238,   239,     0,     0,
     240,   241,   242,   243,   244,     0,   245,   246,   247,   248,
     249,     0,     0,     0,   250,   251,   252,   253,     0,   254,
     255,     0,   256,   257,   258,   259,   260,   261,     0,     0,
     262,   263,     0,     0,     0,     0,     0,     0,     0,   264,
     265,   266,   267,   268,   269,   270,   271,   272,     0,   273,
       0,   274,   275,   276,   277,   278,     0,   279,   280,   281,
       0,     0,   282,   283,   284,   285,   286,     0,   287,   288,
     289,     0,   290,   291,   292,     0,   293,   294,   295,   296,
     297,   298,   299,   300,   301,     0,   302,     0,   303,   304,
     305,   306,     0,   307,     0,   308,     0,     0,     0,   309,
     310,   311,     0,   312,   313,     0,   314,     0,   315,   316,
     317,   318,   319,     0,   320,   321,   322,     0,   323,   324,
     325,   326,   327,   328,     0,   329,     0,   330,   331,   332,
     333,   334,   335,   336,     0,   337,     0,   338,     0,     0,
     339,     0,   340,   341,   342,   343,   344,     0,   345,   346,
       0,   347,   348,     0,   349,     0,     0,   350,   351,   352,
       0,     0,   353,   354,   355,   356,   357,   358,   359,   360,
     361,   362,   363,   364,   365,   366,     0,   367,   368,   369,
     370,     0,   371,   372,     0,   373,     0,   374,   375,   376,
     377,   378,   379,     0,   380,     0,     0,   381,   382,   383,
       0,     0,   384,   385,     0,   386,     0,   387,   388,   389,
     390,   391,     0,   393,   394,     0,   395,   396,   397,   398,
     399,   400,   401,     0,   402,   403,   404,   405,   406,   407,
       0,   409,   410,   411,   412,   413,   414,     0,   415,   416,
     417,   418,   419,   420,   421,   422,   423,   424,   425,     0,
     426,   427,     0,   428,   429,   430,     0,   432,   433,   434,
     435,   436,   437,   438,     0,   439,   440,   441,   442,   443,
       0,   444,   445,   446,   447,     0,   448,   449,   450,     0,
     451,   452,   453,   454,   455,   456,   457,   458,   459,   460,
     461,     0,   462,   463,     0,   464,   465,   466,   467,   468,
     469,     0,   470,   471,     0,     0,   472,   473,   474,   475,
       0,   476,   477,   478,   479,   480,   481,   482,     0,     0,
     483,   484,   485,   486,   487,     0,     0,   488,   489,   490,
     491,   492,   493,   494,     0,   495,     0,   496,   497,   498,
     499,     0,     0,   500,     0,     0,   501,   502,   503,   504,
     505,   506,   507,   508,   509,   510,   511,   512,   513,   514,
     515,   516,   517,   518,  1399,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,   211,   212,   213,   214,   215,
     216,   217,   218,     0,   220,   221,   222,     0,     0,     0,
       0,   223,     0,     0,     0,   224,   225,     0,   226,   227,
     745,   228,   229,   230,     0,  1400,   746,  1401,  1402,     0,
     235,   236,   237,   238,   239,     0,     0,   240,   241,  1403,
    1404,   244,     0,   245,   246,   247,   248,     0,     0,   747,
       0,   250,   251,   252,   253,   748,   254,   255,     0,   256,
     257,   258,   259,   260,   261,     0,   749,   262,   263,     0,
       0,     0,   750,     0,     0,     0,   264,   265,   266,   267,
     268,   269,  1405,  1406,   272,     0,   273,     0,   274,   275,
     276,   277,   278,     0,   279,   280,   281,     0,     0,   282,
     283,  1057,   285,   286,     0,   287,   288,   289,     0,   290,
     291,   292,     0,   293,   294,   295,   296,     0,   298,   299,
     300,     0,     0,   302,     0,   303,   304,  1407,   306,     0,
     307,     0,   308,   751,     0,   752,   309,   310,   311,     0,
     312,     0,     0,   314,     0,   315,   316,   317,   318,   319,
     753,   320,   321,   322,     0,   323,   324,   325,   326,   327,
     328,     0,   329,   754,     0,   331,   332,   333,   334,  1408,
    1409,     0,  1410,     0,   338,   755,   756,   339,   757,   340,
     341,   342,   343,   344,     0,   345,   346,     0,   347,     0,
     758,   349,   759,     0,   350,   351,   352,     0,     0,   353,
     354,   355,   356,   357,   358,   359,   360,   361,   362,   363,
     364,   365,  1411,   760,  1412,   368,   369,  2032,     0,   371,
     372,   761,   373,     0,     0,   375,  1413,   377,   378,   379,
       0,   380,     0,     0,   381,   382,   383,     0,     0,   384,
       0,   762,   386,   763,     0,   388,   389,   390,   391,   392,
     393,   394,     0,   395,     0,   397,     0,   399,   400,   401,
       0,   402,   403,   404,   405,   406,   407,   408,   409,  1414,
     411,   412,   413,   414,     0,   415,   416,   417,   418,   419,
     420,   421,   422,   423,   424,   425,     0,   426,   427,   764,
     428,   429,     0,   431,   432,   433,   434,   435,   436,   437,
     438,     0,   439,   440,   441,   442,   443,     0,   444,  1415,
     446,   447,   765,   448,  1416,   450,     0,   451,   452,   453,
     454,   455,   456,   457,   458,   459,   460,     0,     0,   462,
     463,     0,   464,   465,   466,   467,   468,   469,     0,  1417,
    1418,     0,     0,   472,     0,   474,     0,     0,   476,   477,
     478,   479,   480,   481,   482,     0,     0,   483,   484,   485,
     486,   487,     0,     0,   488,   489,   490,   491,   492,     0,
    1419,     0,   495,   766,   496,   497,   498,   499,     0,     0,
     500,     0,     0,   501,   502,   503,   504,   505,   506,     0,
    1399,     0,     0,     0,     0,     0,     0,     0,   516,   517,
     518,   211,   212,   213,   214,   215,   216,   217,   218,     0,
     220,   221,   222,     0,     0,     0,     0,   223,     0,     0,
       0,   224,   225,     0,   226,   227,   745,   228,   229,   230,
       0,  1400,   746,  1401,  1402,     0,   235,   236,   237,   238,
     239,     0,     0,   240,   241,  1403,  1404,   244,     0,   245,
     246,   247,   248,     0,     0,   747,     0,   250,   251,   252,
     253,   748,   254,   255,     0,   256,   257,   258,   259,   260,
     261,     0,   749,   262,   263,     0,     0,     0,   750,     0,
       0,     0,   264,   265,   266,   267,   268,   269,  1405,  1406,
     272,     0,   273,     0,   274,   275,   276,   277,   278,     0,
     279,   280,   281,     0,     0,   282,   283,  1057,   285,   286,
       0,   287,   288,   289,     0,   290,   291,   292,     0,   293,
     294,   295,   296,     0,   298,   299,   300,     0,     0,   302,
       0,   303,   304,  1407,   306,     0,   307,     0,   308,   751,
       0,   752,   309,   310,   311,     0,   312,     0,     0,   314,
       0,   315,   316,   317,   318,   319,   753,   320,   321,   322,
       0,   323,   324,   325,   326,   327,   328,     0,   329,   754,
       0,   331,   332,   333,   334,  1408,  1409,     0,  1410,     0,
     338,   755,   756,   339,   757,   340,   341,   342,   343,   344,
       0,   345,   346,     0,   347,     0,   758,   349,   759,     0,
     350,   351,   352,     0,     0,   353,   354,   355,   356,   357,
     358,   359,   360,   361,   362,   363,   364,   365,  1411,   760,
    1412,   368,   369,  3258,     0,   371,   372,   761,   373,     0,
       0,   375,  1413,   377,   378,   379,     0,   380,     0,     0,
     381,   382,   383,     0,     0,   384,     0,   762,   386,   763,
       0,   388,   389,   390,   391,   392,   393,   394,     0,   395,
       0,   397,     0,   399,   400,   401,     0,   402,   403,   404,
     405,   406,   407,   408,   409,  1414,   411,   412,   413,   414,
       0,   415,   416,   417,   418,   419,   420,   421,   422,   423,
     424,   425,     0,   426,   427,   764,   428,   429,     0,   431,
     432,   433,   434,   435,   436,   437,   438,     0,   439,   440,
     441,   442,   443,     0,   444,  1415,   446,   447,   765,   448,
    1416,   450,     0,   451,   452,   453,   454,   455,   456,   457,
     458,   459,   460,     0,     0,   462,   463,     0,   464,   465,
     466,   467,   468,   469,     0,  1417,  1418,     0,     0,   472,
       0,   474,     0,     0,   476,   477,   478,   479,   480,   481,
     482,     0,     0,   483,   484,   485,   486,   487,     0,     0,
     488,   489,   490,   491,   492,     0,  1419,     0,   495,   766,
     496,   497,   498,   499,     0,     0,   500,     0,     0,   501,
     502,   503,   504,   505,   506,     0,  1399,     0,     0,     0,
       0,     0,     0,     0,   516,   517,   518,   211,   212,   213,
     214,   215,   216,   217,   218,     0,   220,   221,   222,     0,
       0,     0,     0,   223,     0,     0,     0,   224,   225,     0,
     226,   227,   745,   228,   229,   230,     0,  1400,   746,  1401,
    1402,     0,   235,   236,   237,   238,   239,     0,     0,   240,
     241,  1403,  1404,   244,     0,   245,   246,   247,   248,     0,
       0,   747,     0,   250,   251,   252,   253,   748,   254,   255,
       0,   256,   257,   258,   259,   260,   261,     0,   749,   262,
     263,     0,     0,     0,   750,     0,     0,     0,   264,   265,
     266,   267,   268,   269,  1405,  1406,   272,     0,   273,     0,
     274,   275,   276,   277,   278,     0,   279,   280,   281,     0,
       0,   282,   283,  1057,   285,   286,     0,   287,   288,   289,
       0,   290,   291,   292,     0,   293,   294,   295,   296,     0,
     298,   299,   300,     0,     0,   302,     0,   303,   304,  1407,
     306,     0,   307,     0,   308,   751,     0,   752,   309,   310,
     311,     0,   312,     0,     0,   314,     0,   315,   316,   317,
     318,   319,   753,   320,   321,   322,     0,   323,   324,   325,
     326,   327,   328,     0,   329,   754,     0,   331,   332,   333,
     334,  1408,  1409,     0,  1410,     0,   338,   755,   756,   339,
     757,   340,   341,   342,   343,   344,     0,   345,   346,     0,
     347,     0,   758,   349,   759,     0,   350,   351,   352,     0,
       0,   353,   354,   355,   356,   357,   358,   359,   360,   361,
     362,   363,   364,   365,  1411,   760,  1412,   368,   369,     0,
       0,   371,   372,   761,   373,     0,     0,   375,  1413,   377,
     378,   379,     0,   380,     0,     0,   381,   382,   383,     0,
       0,   384,     0,   762,   386,   763,     0,   388,   389,   390,
     391,   392,   393,   394,     0,   395,     0,   397,     0,   399,
     400,   401,     0,   402,   403,   404,   405,   406,   407,   408,
     409,  1414,   411,   412,   413,   414,     0,   415,   416,   417,
     418,   419,   420,   421,   422,   423,   424,   425,     0,   426,
     427,   764,   428,   429,     0,   431,   432,   433,   434,   435,
     436,   437,   438,     0,   439,   440,   441,   442,   443,     0,
     444,  1415,   446,   447,   765,   448,  1416,   450,     0,   451,
     452,   453,   454,   455,   456,   457,   458,   459,   460,     0,
       0,   462,   463,     0,   464,   465,   466,   467,   468,   469,
       0,  1417,  1418,     0,     0,   472,     0,   474,     0,     0,
     476,   477,   478,   479,   480,   481,   482,     0,     0,   483,
     484,   485,   486,   487,     0,     0,   488,   489,   490,   491,
     492,     0,  1419,     0,   495,   766,   496,   497,   498,   499,
       0,     0,   500,     0,     0,   501,   502,   503,   504,   505,
     506,     0,  1399,     0,     0,     0,     0,     0,     0,     0,
     516,   517,   518,   211,   212,   213,   214,   215,   216,   217,
     218,     0,   220,   221,   222,     0,     0,     0,     0,   223,
       0,     0,     0,   224,   225,     0,   226,   227,   745,   228,
     229,   230,     0,  1400,   746,  1401,  1402,     0,   235,   236,
     237,   238,   239,     0,     0,   240,   241,  1403,  1404,   244,
       0,   245,   246,   247,   248,     0,     0,   747,     0,   250,
     251,   252,   253,   748,   254,   255,     0,   256,   257,   258,
     259,   260,   261,     0,   749,   262,   263,     0,     0,     0,
     750,     0,     0,     0,   264,   265,   266,   267,   268,   269,
    1405,  1406,   272,     0,   273,     0,   274,   275,   276,   277,
     278,     0,   279,   280,   281,     0,     0,   282,   283,  1057,
     285,   286,     0,   287,   288,   289,     0,   290,   291,   292,
       0,   293,   294,   295,   296,     0,   298,   299,   300,     0,
       0,   302,     0,   303,   304,  1407,   306,     0,   307,     0,
     308,   751,     0,   752,   309,   310,   311,     0,   312,     0,
       0,   314,     0,   315,   316,   317,   318,   319,   753,   320,
     321,   322,     0,   323,   324,   325,   326,   327,   328,     0,
     329,   754,     0,   331,   332,   333,   334,  1408,  1409,     0,
    1410,     0,   338,   755,   756,   339,   757,   340,   341,   342,
     343,   344,     0,   345,   346,     0,   347,     0,   758,   349,
     759,     0,   350,   351,   352,     0,     0,   353,   354,   355,
     356,   357,   358,   359,   360,   361,   362,   363,   364,   365,
    1411,   760,  1412,   368,   369,     0,     0,   371,   372,   761,
     373,     0,     0,   375,  1413,   377,   378,   379,     0,   380,
       0,     0,   381,   382,   383,     0,     0,   384,     0,   762,
     386,   763,     0,   388,   389,   390,   391,   392,   393,   394,
       0,   395,     0,   397,     0,   399,   400,   401,     0,   402,
     403,   404,   405,   406,   407,   408,   409,  1414,   411,   412,
     413,   414,     0,   415,   416,   417,   418,   419,   420,   421,
     422,   423,   424,   425,     0,   426,   427,   764,   428,   429,
       0,   431,   432,   433,   434,   435,   436,   437,   438,     0,
     439,   440,   441,   442,   443,     0,   444,  1883,   446,   447,
     765,   448,  1416,   450,     0,   451,   452,   453,   454,   455,
     456,   457,   458,   459,   460,     0,     0,   462,   463,     0,
     464,   465,   466,   467,   468,   469,     0,  1417,  1418,     0,
       0,   472,     0,   474,     0,     0,   476,   477,   478,   479,
     480,   481,   482,     0,     0,   483,   484,   485,   486,   487,
       0,     0,   488,   489,   490,   491,   492,     0,  1419,     0,
     495,   766,   496,   497,   498,   499,     0,     0,   500,     0,
       0,   501,   502,   503,   504,   505,   506,     0,  1399,     0,
       0,     0,     0,     0,     0,     0,   516,   517,   518,   211,
     212,   213,   214,   215,   216,   217,   218,     0,   220,   221,
     222,     0,     0,     0,     0,   223,     0,     0,     0,   224,
     225,     0,   226,   227,   745,   228,   229,   230,     0,  1400,
     746,  1401,  1402,     0,   235,   236,   237,   238,   239,     0,
       0,   240,   241,  1403,  1404,   244,     0,   245,   246,   247,
     248,     0,     0,   747,     0,   250,   251,   252,   253,   748,
     254,   255,     0,   256,   257,   258,   259,   260,   261,     0,
     749,   262,   263,     0,     0,     0,   750,     0,     0,     0,
     264,   265,   266,   267,   268,   269,  1405,  1406,   272,     0,
     273,     0,   274,   275,   276,   277,   278,     0,   279,   280,
     281,     0,     0,   282,   283,  1057,   285,   286,     0,   287,
     288,   289,     0,   290,   291,   292,     0,   293,   294,   295,
     296,     0,   298,   299,   300,     0,     0,   302,     0,   303,
     304,  1407,   306,     0,   307,     0,   308,   751,     0,   752,
     309,   310,   311,     0,   312,     0,     0,   314,     0,   315,
     316,   317,   318,   319,   753,   320,   321,   322,     0,   323,
     324,   325,   326,   327,   328,     0,   329,   754,     0,   331,
     332,   333,   334,  1408,  1409,     0,  1410,     0,   338,   755,
     756,   339,   757,   340,   341,   342,   343,   344,     0,   345,
     346,     0,   347,     0,   758,   349,   759,     0,   350,   351,
     352,     0,     0,   353,   354,   355,   356,   357,   358,   359,
     360,   361,   362,   363,   364,   365,  1411,   760,  1412,   368,
     369,     0,     0,   371,   372,   761,   373,     0,     0,   375,
    1413,   377,   378,   379,     0,   380,     0,     0,   381,   382,
     383,     0,     0,   384,     0,   762,   386,   763,     0,   388,
     389,   390,   391,   392,   393,   394,     0,   395,     0,   397,
       0,   399,   400,   401,     0,   402,   403,   404,   405,   406,
     407,   408,   409,  1414,   411,   412,   413,   414,     0,   415,
     416,   417,   418,   419,   420,   421,   422,   423,   424,   425,
       0,   426,   427,   764,   428,   429,     0,   431,   432,   433,
     434,   435,   436,   437,   438,     0,   439,   440,   441,   442,
     443,     0,   444,     0,   446,   447,   765,   448,  1416,   450,
       0,   451,   452,   453,   454,   455,   456,   457,   458,   459,
     460,     0,     0,   462,   463,     0,   464,   465,   466,   467,
     468,   469,     0,  1417,  1418,     0,     0,   472,     0,   474,
       0,     0,   476,   477,   478,   479,   480,   481,   482,     0,
       0,   483,   484,   485,   486,   487,     0,     0,   488,   489,
     490,   491,   492,     0,  1419,     0,   495,   766,   496,   497,
     498,   499,     0,     0,   500,     0,     0,   501,   502,   503,
     504,   505,   506,     0,  1399,     0,     0,     0,     0,     0,
       0,     0,   516,   517,   518,   211,   212,   213,   214,   215,
     216,   217,   218,     0,   220,   221,   222,     0,     0,     0,
       0,   223,     0,     0,     0,   224,   225,     0,   226,   227,
     745,   228,   229,   230,     0,     0,   746,     0,     0,     0,
     235,   236,   237,   238,   239,     0,     0,   240,   241,     0,
       0,   244,     0,   245,   246,   247,   248,     0,     0,   747,
       0,   250,   251,   252,   253,   748,   254,   255,     0,   256,
     257,   258,   259,   260,   261,     0,   749,   262,   263,     0,
       0,     0,   750,     0,     0,     0,   264,   265,   266,   267,
     268,   269,     0,     0,   272,     0,   273,     0,   274,   275,
     276,   277,   278,     0,   279,   280,   281,     0,     0,   282,
     283,   284,   285,   286,     0,   287,   288,   289,     0,   290,
     291,   292,     0,   293,   294,   295,   296,     0,   298,   299,
     300,     0,     0,   302,     0,   303,   304,     0,   306,     0,
     307,     0,   308,   751,     0,   752,   309,   310,   311,     0,
     312,     0,     0,   314,     0,   315,   316,   317,   318,   319,
     753,   320,   321,   322,     0,   323,   324,   325,   326,   327,
     328,     0,   329,   754,     0,   331,   332,   333,   334,     0,
       0,     0,     0,     0,   338,   755,   756,   339,   757,   340,
     341,   342,   343,   344,     0,   345,   346,     0,   347,     0,
     758,   349,   759,     0,   350,   351,   352,     0,     0,   353,
     354,   355,   356,   357,   358,   359,   360,   361,   362,   363,
     364,   365,     0,   760,     0,   368,   369,     0,     0,   371,
     372,   761,   373,     0,     0,   375,     0,   377,   378,   379,
       0,   380,     0,     0,   381,   382,   383,     0,     0,   384,
       0,   762,   386,   763,     0,   388,   389,   390,   391,   392,
     393,   394,     0,   395,     0,   397,     0,   399,   400,   401,
       0,   402,   403,   404,   405,   406,   407,   408,   409,     0,
     411,   412,   413,   414,     0,   415,   416,   417,   418,   419,
     420,   421,   422,   423,   424,   425,     0,   426,   427,   764,
     428,   429,     0,   431,   432,   433,   434,   435,   436,   437,
     438,     0,   439,   440,   441,   442,   443,     0,   444,     0,
     446,   447,   765,   448,     0,   450,     0,   451,   452,   453,
     454,   455,   456,   457,   458,   459,   460,     0,     0,   462,
     463,     0,   464,   465,   466,   467,   468,   469,     0,     0,
       0,     0,     0,   472,     0,   474,     0,     0,   476,   477,
     478,   479,   480,   481,   482,     0,     0,   483,   484,   485,
     486,   487,     0,     0,   488,   489,   490,   491,   492,     0,
       0,     0,   495,   766,   496,   497,   498,   499,     0,     0,
     500,     0,     0,   501,   502,   503,   504,   505,   506,     0,
       0,     0,     0,     0,     0,     0,     0,     0,   516,   517,
     518
};

#define yypact_value_is_default(Yystate) \
  (!!((Yystate) == (-3935)))

#define yytable_value_is_error(Yytable_value) \
  (!!((Yytable_value) == (-2278)))

static const yytype_int16 yycheck[] =
{
       0,     0,     0,     0,     0,     0,    16,   179,   939,   193,
     738,    11,    48,   976,    24,   546,   188,   690,   948,   575,
      20,   743,    20,    34,     7,  1569,  1180,    21,   645,   646,
     647,    14,    26,   171,   651,   943,   820,   796,   815,    12,
    1229,  1671,   841,  1415,  1162,  2317,    21,  1871,    48,   897,
    1709,    26,   768,  1264,   878,   832,    43,   613,   998,   907,
    2838,  1026,   593,  2129,  1372,  2168,  1284,  1084,   697,  2176,
    2623,   575,  2031,    17,  2901,  2647,  1274,  1164,  2667,    22,
    2669,  1270,  3121,     0,  1055,  1056,  1432,   595,  1471,  2863,
    1606,    34,  1324,   537,  2082,    20,  1835,   605,  1216,  2295,
    3164,  3423,  1185,  1074,   968,   929,   883,  2478,  3062,  3088,
     887,  2819,  2476,  2477,  2531,   892,  2890,  3160,  1887,  1888,
     158,  2801,   899,  1341,  1342,  1212,  3434,  2880,   612,   180,
     181,  3213,   909,   184,     0,   186,     0,   693,  1336,  2819,
     584,  3413,    33,  1526,   173,  2410,     0,  3094,   173,    40,
    1256,     0,     0,     0,   205,     0,     0,     0,     0,     0,
       0,  1216,  3647,  2539,    39,  3851,  3020,  1474,  3093,  3131,
     189,  1270,   785,   173,  1482,  3955,   195,  3957,     5,    42,
      32,  3370,    11,    45,   735,     5,   735,   206,     0,   693,
     104,     0,  2823,  2824,  2825,  2826,  2827,  2828,     5,  1195,
    4128,     5,    52,     0,    73,     5,    13,     0,  1044,  1045,
      18,  3988,  2171,    80,    99,    97,     0,   976,  4121,    18,
      52,    67,   104,    59,    38,     5,    36,    52,  1887,   153,
     955,   154,    59,     9,  1070,     5,   104,    97,  1102,   819,
      25,   966,   131,    13,     5,   825,   148,    69,     5,     5,
     880,    11,     5,    69,   834,     5,    13,     5,     5,   876,
       5,  2473,   123,    69,     5,     0,     0,    22,  4202,  4203,
      38,     0,  2537,   173,    29,     9,   162,    37,     5,  2625,
       9,   166,   153,  2242,   250,  2244,     5,   247,    22,     5,
     247,    84,  2473,    22,     9,    97,    69,     5,    59,     4,
      36,   190,    53,    99,     9,    23,   235,    67,  4074,    97,
      61,   327,  2524,   121,   235,     5,   360,  1435,   257,   281,
     311,   311,   121,   257,   154,    26,    27,   106,   264,   107,
     861,    28,   156,   309,     9,   362,   224,   265,   201,   224,
     401,   153,   227,  2524,   153,   360,    18,   287,   286,    84,
    1149,   104,   182,   257,  2997,   237,   153,   155,   815,   299,
     532,   173,   546,    84,   173,   158,   424,   197,   257,   153,
     166,   420,   421,   830,   312,   832,   173,   404,  3021,   209,
     441,   439,  1012,   323,   392,   183,    11,  1103,  1147,   173,
     380,   327,   170,  1152,  1153,    22,   104,   441,  4178,   327,
     153,  1418,    29,   106,  1948,   381,     4,   579,   964,   593,
      69,     9,  1566,   317,   104,  1131,  1570,   589,  1572,   153,
     976,  1575,    22,   158,   153,   441,   441,  4113,   224,    29,
     318,   227,   128,   318,  1405,  1406,   303,   158,   135,   173,
      97,   949,  1413,    77,   173,  1640,   437,   235,   135,   121,
    1381,   152,   320,   154,   304,   153,  1386,   386,   340,  1654,
     964,   343,   153,  3652,   215,   159,   265,   153,    69,   187,
       5,   437,   304,   109,  1030,   437,    77,   437,   308,   304,
     437,   200,   350,  4249,   535,   374,   109,  1246,   539,   360,
     350,  2837,     8,   196,   978,  1254,  1004,   418,   322,   298,
     386,  4435,   441,   372,    11,   556,  1014,   441,  4411,  1704,
     424,  1883,   305,   437,   437,   242,   301,   527,  1605,  1027,
     388,    97,   318,  3154,   111,   544,  1030,   351,   327,   548,
      37,  3239,   417,   401,   237,   437,   397,   347,   360,     8,
     559,   441,    11,  1320,   360,  1322,  1330,  1893,   350,  1397,
     186,  1375,   437,  1312,   360,   437,  1315,  1316,  1676,  3239,
      67,   341,   342,  4340,   391,   575,   576,  1403,  1404,   437,
     305,  1370,   380,   387,   441,   437,  1412,   613,  1665,   617,
     335,  3853,   526,   403,   287,   437,   385,   360,  1144,   435,
     286,   441,   360,   439,  3548,  3167,  1152,  1153,  4526,   403,
     738,   437,  3581,   423,   433,   384,  3585,   360,   401,   441,
     437,   347,   612,   613,   612,  2574,   441,   437,  3392,   423,
    1560,   417,  1530,  1382,  1711,  3572,   298,  3816,   440,  3407,
     437,   440,   626,   437,   628,   435,   630,   437,   611,   439,
    1144,  3495,   636,   440,  1640,   438,  3571,   440,  4428,   659,
    1263,   626,  1203,   628,  1203,   630,   440,   640,  1654,  1567,
     436,   636,   637,   638,  1244,  3627,   401,   437,  1576,  3422,
    1300,   424,   682,   433,   846,   391,   437,   861,  3867,   689,
     437,   437,   692,   693,   694,   857,   439,   437,   613,   437,
     437,   392,   437,   350,   428,   429,   437,    22,   727,   428,
     429,   360,   727,   438,   173,   440,   440,   242,   335,  4194,
     397,   440,    97,   428,   429,  2781,  4402,  1297,  2784,  2785,
    3351,   437,  2788,   428,   429,   194,   360,   727,  2794,   729,
     729,   729,   729,   729,   729,   335,  3107,   253,   441,  2046,
    1604,   437,  1606,   441,   380,   917,  1376,   441,   799,   800,
     441,  2858,  1616,   428,   429,   441,  1620,   380,    25,   360,
      84,  3333,   437,  1961,  1628,  1629,     3,  1492,     5,     3,
       3,  1302,  3148,  2542,   350,  2544,  1501,  1641,  1642,   103,
    1505,    52,     5,  1901,   253,    19,  1511,  1512,  1652,  4111,
    4486,  4477,   717,   656,  3983,   382,  1632,  1633,    97,    11,
      65,  3990,  4276,   401,  1529,   430,   431,   432,   433,   153,
    1440,   135,   729,   247,   134,    18,   691,  2476,  2477,  2478,
     695,   796,   153,   874,    33,    37,     5,  2786,  2787,  2027,
     428,   429,    18,    16,   148,     3,     4,     5,    24,   252,
     291,     9,    76,    76,   895,   896,  1901,    30,   134,   162,
     713,   382,   251,     8,   104,    67,    11,   401,   775,  2489,
     162,  1478,    99,   729,   915,   729,   438,  1497,  3991,   441,
    3135,   264,  4568,  1979,  3086,   729,  3088,  3941,   104,   742,
     729,   729,   729,   155,   729,   729,   729,   729,   729,   729,
    1989,  3444,   126,   126,   945,   946,  2014,   441,    20,   251,
    1573,  1574,   154,   112,   154,  3086,   437,  3088,   424,   425,
     426,     5,   428,   429,   430,   431,   432,   433,   121,    41,
    3984,   784,   235,   430,   431,   432,   433,  4401,   350,   166,
     821,   822,    18,   235,   327,   121,   104,   161,    24,   173,
     135,    43,   255,   394,   178,   178,  1662,   272,  3902,   134,
     106,   134,  3164,    61,   964,   424,   425,   426,  4081,   428,
     429,   430,   431,   432,   433,   350,   976,  3946,  4290,    77,
     294,   315,  3951,   104,   109,  3954,   920,  2209,   978,  1510,
     978,  1537,   194,  3164,   109,   250,   300,   224,   238,    61,
     227,   327,  4300,   406,  1502,  3942,   320,   322,   981,  1009,
     983,   976,   985,   437,   987,  1513,   989,   990,   991,   329,
    2221,   237,  4284,   996,   190,   267,     5,  1525,   121,   242,
    1030,   108,   198,   191,   132,   324,   350,    31,   353,   360,
     355,   207,  2801,   304,   301,   121,   270,   270,  1038,   194,
    3867,   313,   150,   329,  1674,  2163,   313,   215,  4522,   393,
    2819,   186,  1536,    75,  1498,    52,   264,  4121,  1058,   104,
     132,   186,   265,   242,   388,   187,  1102,   169,  3842,  3641,
      22,   173,  4195,   386,   302,   309,    35,   401,   150,   265,
     332,   318,  4205,   435,   386,   309,   242,   439,  1088,   315,
    3679,   113,  3845,   424,  1104,   298,   368,   364,   253,   327,
     104,   162,  1102,   439,  1114,  1830,   193,  1638,   439,   211,
     300,   242,   298,   437,   348,   104,   143,  1127,  1302,    71,
      98,   109,   222,    45,   327,   320,    78,    11,   311,  2283,
    2899,  4403,   382,   121,  1144,  1173,   155,  1147,  1148,   373,
     373,   327,  1152,  1153,   329,   147,   329,   381,   381,  4192,
     384,   384,   255,   105,  4476,   350,  2376,  2377,  4480,  1188,
    1189,  2381,  1191,  1188,  1189,    22,  1191,   199,   155,   257,
     327,   279,  1147,    95,   235,    79,   145,  1152,  1153,   265,
     417,  2376,  2377,  2154,     8,   212,  2381,    11,  1188,  1189,
    4144,  1191,   237,   388,  2540,   320,  4175,  1870,   176,   302,
    2546,  2421,  2422,  4525,   265,  4287,   401,   279,  3625,   362,
      75,   401,   298,   172,   118,   437,   428,   429,   430,   431,
     432,   433,   249,  4412,   327,   177,  2421,  2422,  1279,   331,
    2078,  3602,   367,  3597,   253,    77,  3607,   298,   235,     0,
     131,   327,   437,  3309,   266,   380,   327,    96,   113,  3315,
    3316,   441,   143,   257,   166,   380,  4320,   148,    75,   116,
     428,   429,   104,   185,  4218,   234,   253,   375,  4222,  4223,
     131,  1246,   274,   428,   429,   430,   431,   432,   433,  1254,
    3476,   114,   143,  2401,   441,    75,   440,   148,   276,  2407,
    2049,   124,  1343,  1344,  1345,  1346,   113,  1241,  2057,   190,
    2059,   156,   265,   375,  2235,  4344,  4345,   304,  4016,   116,
     194,   118,   224,   235,  4092,  2245,  1291,  1292,  1328,  1491,
    4098,   212,    22,   113,    61,   386,  1510,    11,  1500,   190,
     327,  2239,   354,  1384,  1385,   298,  4016,  1312,  1357,  1390,
    1315,  1316,  1205,  2191,  2192,  2193,  2194,  4411,    75,   525,
     438,   212,   148,   441,   530,  2203,   343,  2134,   249,   157,
     441,   108,   158,  1993,   327,   194,   257,   104,   106,  3581,
     194,   349,   350,  3585,   223,   264,   225,   173,     5,   441,
    2376,  2377,     9,  1434,  1394,  2381,   113,  1304,   249,   106,
    1307,   343,   364,  2937,   316,   237,   257,  1569,   173,   143,
    3581,   266,    11,  3142,  3585,  2229,   318,  1382,  1988,   281,
    1461,  1462,  1463,  1464,  2497,  2569,   116,   215,  3406,  1950,
     424,   880,   251,   246,   265,  2421,  2422,   382,  2639,   253,
     237,   435,   265,   437,   438,   439,  1455,   441,   327,  1356,
     247,   106,   180,  1360,   157,   107,   193,  1457,  3107,   266,
     198,   382,  1471,   116,  1638,   118,   394,   298,    67,  2975,
    4499,   302,  1906,    18,  1515,   298,  2046,   322,   212,    24,
    3239,    85,  1335,  1524,   437,   255,   266,   104,  1986,   196,
    1531,  2345,   437,   374,  1503,   265,   327,   235,  2068,   354,
    2722,   667,  3451,   291,  3453,   173,   351,   235,   317,   237,
     237,  4275,   215,  2041,  4076,   242,   437,  1526,   170,  2234,
     194,   307,  2142,   374,   690,   370,  4013,   133,   298,  2099,
     237,    96,   401,   298,   200,  2250,  2251,   302,  2287,  2254,
    2394,   196,   278,   709,  2732,  2260,  1536,   354,  1536,   266,
     154,   437,   279,  2926,   428,   429,   430,   431,   432,   433,
    4047,   360,   327,  1012,   730,   353,   293,   355,   174,  2097,
     401,  2425,   441,  1546,   354,  1548,   121,  1550,   182,  1552,
     287,  1554,   237,   278,   435,  1558,  4129,   438,   439,  2550,
     378,   329,   352,   197,   247,  4412,  1597,  1587,  1587,  1587,
    1587,  1587,  1587,  2037,  2319,   209,   394,   107,   364,  2463,
    2217,   425,   426,   178,   428,   429,   430,   431,   432,   433,
     313,   320,  1537,   393,  3886,  1625,   362,   334,   232,    61,
     298,   797,   287,  4212,   302,    67,   401,   354,  1679,   364,
     265,   401,   380,   403,  4206,    77,  4410,   251,   375,  2579,
     353,   350,   355,  1618,  1619,   360,   298,   143,   223,   327,
     225,  1626,   148,  1596,   265,  1630,  1631,   362,   404,  1603,
     170,   364,   104,   298,   106,   378,  2884,   437,  2224,  2887,
    1645,   116,  1647,   118,   313,   327,  2306,    69,    69,   388,
    2610,  1681,   313,   298,    11,    77,    77,   298,  1147,   238,
     239,  4469,   401,  1668,   308,  1670,   141,  3763,  3764,   404,
    2818,    76,  2258,  3662,  3663,   116,  3978,   118,  3980,   424,
      37,  1304,   327,   889,  1307,  1725,   212,  3347,   302,  1582,
    2224,  3824,     4,   401,   439,   364,  3833,     9,   437,  3941,
     141,  2490,   300,   364,  3946,   911,   912,   913,   180,  3951,
      67,  3844,  3954,   327,   428,   429,   430,   431,   432,   433,
     125,  1210,  4305,   249,  2258,  2483,   237,   153,   317,    39,
    3941,   242,    20,  1356,   148,  3946,  1950,  1360,   382,  1941,
    3951,   320,  3984,  3954,  2598,  4347,  1948,   173,   311,   320,
      60,  2935,  3002,    41,   168,  3005,  3006,  3007,  3008,  3009,
    3010,  3011,  3012,  3013,  3014,   237,   198,   242,   222,   265,
     242,   350,   247,  3984,   285,  1264,   339,  3002,   403,   350,
    3005,  3006,  3007,  3008,  3009,  3010,  3011,  3012,  3013,  3014,
       4,   438,   222,   291,   441,     9,   237,  1003,   423,   204,
     205,   242,   298,   235,   239,   438,   247,   279,   441,   388,
    3035,  1300,  2626,   218,  3064,  3065,  3192,   388,    58,    59,
    1026,   293,   401,   321,   143,  1849,    85,  2582,  2487,   148,
    3168,   327,    26,    27,  2648,  4437,    81,   194,   195,  3064,
    3065,   148,   251,    11,  1849,  1875,  1875,   256,  1897,   265,
     311,   312,   350,  1902,   403,   287,  1905,   364,   437,   157,
     265,   168,  1943,  1944,  1945,  1453,   437,   311,   312,    37,
    1911,  1952,  1913,  1954,   423,  1956,  1957,  1832,  1927,  4121,
    3540,  2442,   298,   240,  1472,   320,   302,  1376,   437,  3037,
      84,   366,   176,   212,   403,   154,   394,   329,  2868,    67,
    2655,   376,  2657,   375,  2490,   168,  1395,  2877,  3597,   103,
    4121,   327,    77,  3602,   423,   350,     5,   215,  3607,  1968,
     353,    10,   355,   182,   222,   366,  1415,  3044,   437,    18,
     249,   291,    74,  4175,  1974,   376,  1985,   265,   197,  2599,
     251,   135,   265,   394,  4546,   256,    35,   352,   380,   354,
     209,  1440,  1158,   388,  4050,   435,   106,   315,   436,   439,
     265,   321,  2011,   441,  4175,  2960,   401,    49,  3216,  3217,
     298,   317,  3200,   232,  2055,   298,  3002,  3024,  3025,  3005,
    3006,  3007,  3008,  3009,  3010,  3011,  3012,  3013,  3014,   437,
     350,  2040,   157,   298,   352,  2044,  1017,  1018,   148,   327,
    1206,  2756,   437,   438,   327,   440,  2967,  2762,  1497,  3035,
    2596,   176,  3773,  2062,  3775,  3243,     8,  2627,  3779,    11,
    3781,   353,   327,   355,  2073,  2832,  3143,    21,  2566,  2567,
     180,   200,    26,  2114,   394,     9,    28,  2086,  3064,  3065,
    2700,  2122,  2702,   401,  2049,   403,  2127,  2096,   436,   308,
     215,   432,  2057,   441,  2059,   353,   437,   355,   439,   437,
     251,   438,  2596,  1269,   441,   438,    50,  1960,   441,   441,
    1276,   428,   429,   430,   431,   432,   433,   432,  4320,   437,
     378,  2121,   437,  2693,   439,   235,   435,   237,   437,  2129,
    3238,   256,  3240,  3887,  3888,  3889,  3890,  2757,     8,   437,
     294,    11,  1308,   438,  4093,  1311,   441,    49,   438,  4320,
    2964,   441,    96,  3363,   435,   394,   437,  1656,   439,  2321,
    1659,  2393,  2782,  2395,  2396,  2327,   320,    37,  2810,  2811,
    2812,  2212,  4434,    43,    39,  3537,   438,  3031,  3363,   441,
     439,  1347,   438,   419,  3145,   441,  2151,   437,   196,   439,
    2190,    45,  4006,   254,  2909,  1361,   350,    67,  2913,  2914,
    2241,  2916,  2243,  2918,  2919,   251,   315,   438,  1374,  4411,
     441,  3319,  2927,   438,  2177,  2713,   441,  3866,  2218,  2968,
     254,  2211,  2211,  4037,  2224,  1674,  3427,   437,   353,   439,
     355,   175,    86,  3412,   388,  3165,  3166,   148,   392,   364,
    4411,   438,   194,   352,   441,   438,  2961,   401,   441,  2856,
     375,   438,   438,   378,   441,   441,   110,  4016,  2258,   438,
     360,   438,   441,  2883,   441,   254,   438,   438,  2442,   441,
     441,   125,   251,   438,   438,   129,   441,   441,   401,   223,
     403,   225,   438,   437,  2293,   441,   438,  2833,   440,  2835,
    2910,   235,   401,   438,   403,   149,   441,  2338,   152,   438,
     419,   253,   441,   173,    39,   419,   438,  1473,  2317,   441,
     164,  2473,   438,  1479,   401,   441,   403,  3461,  3462,  3463,
     264,  3110,  2287,   438,   194,   195,   441,     8,   437,   315,
      11,   430,  3542,  3543,  2508,   438,   196,   438,   441,  2833,
     441,  2835,   315,   438,   152,   438,   441,  3967,   441,  2847,
     438,  2849,  2898,   441,   353,   441,   355,  3542,  3543,   303,
     438,  2981,  2524,   441,  4123,   438,   352,   437,   441,  1535,
     240,   438,   438,   438,   441,   441,   441,  3363,   401,   352,
     403,  3001,   438,   253,  3102,  3103,  3104,   438,   242,     8,
     441,   438,    11,  3099,   338,   353,   250,   355,    21,  2425,
     315,   438,  4216,   440,  2898,    49,  3026,  1573,  1574,    28,
     438,   438,   192,   441,   441,   401,   438,   403,    37,   441,
     153,   439,   438,  1589,    43,   441,   438,   437,   401,   441,
     403,   285,   327,   438,  1883,  2425,   441,   352,  1887,  1888,
     438,   438,  3062,   441,   441,   405,    69,   315,    67,  2439,
     438,   437,     0,   441,   438,   438,   438,   441,   441,   441,
     315,  2959,   173,   438,   437,   315,   441,   438,  2458,   732,
     441,   734,   424,   425,   426,    98,   428,   429,   430,   431,
     432,   433,   438,  2473,   352,   441,   401,  3586,   403,  3588,
    2490,  2468,  2469,  2470,   136,   438,   119,   352,   441,   439,
     438,  2527,   352,   441,   173,   438,   438,   130,   441,   441,
     437,   437,   251,   194,  2504,  2504,  2504,  2504,  2504,  2504,
     136,  3598,   437,  2488,   173,  2490,   438,   150,  3302,   441,
     136,   251,   155,   401,  2524,   403,    84,  2527,  4072,   148,
    1706,   136,  2551,   210,  1993,  3622,   401,   106,   403,  1715,
     169,   401,   438,   403,   173,   441,  3542,  3543,   428,   429,
     430,   431,   432,   433,  2605,   315,  2607,  2608,  2609,   437,
     382,   251,   253,   437,   315,   194,   195,   438,   201,   364,
     441,   246,   437,   131,  2593,   438,   438,   437,   441,   441,
    3734,  3735,   211,  3737,   438,   143,  2596,   441,  3436,   222,
     148,   438,   352,   438,   441,   153,   441,   394,   317,   438,
     158,   352,   441,   161,   438,   163,   200,   441,   237,   437,
     284,   240,    61,   401,    32,   237,   405,  2801,   437,  4443,
     237,   369,    39,    39,   253,     8,   265,   256,    11,   148,
    4454,   394,   190,   394,    74,  2819,   282,   136,   136,   437,
     136,   401,  4301,   403,   136,    28,   405,   136,   441,   282,
     401,   136,   403,   136,   212,  1831,   136,  1833,   251,   136,
    3524,   136,   136,  2673,   251,   136,   136,   350,   437,    32,
     149,   210,  2691,   251,     5,   148,   309,   437,  3898,   148,
     437,  4505,   315,  2142,  2703,     5,   437,   437,   321,   148,
     437,   249,   275,   437,  1870,   437,   437,   437,   437,   257,
       5,  2711,   331,  3898,  3924,  3925,     5,  3466,   437,   628,
     629,   630,  3907,   437,   633,   634,   635,   350,     5,   352,
     437,   437,   437,  3448,   643,   437,   437,   437,     5,  3924,
    3925,  3456,  3457,   424,   425,   426,   369,   428,   429,   430,
     431,   432,   433,   437,   437,   437,   402,   305,   437,  2759,
     437,   437,   437,   437,   262,   437,   437,  2776,   192,   437,
    3390,   394,  2221,    32,    87,  2937,   210,    32,   441,     0,
     441,  2781,   148,   249,  2784,  2785,   148,   327,  2788,   247,
     360,   360,   315,   360,  2794,   360,   439,   315,   360,   360,
     360,  2801,   350,    77,   315,   424,   425,   426,   136,   428,
     429,   430,   431,   432,   433,   251,   319,  3770,   207,  2819,
     242,   194,   441,   360,   360,   360,   374,   381,   352,   178,
     251,   247,   437,  2833,   360,  2835,  2801,   167,   360,   437,
      77,  2007,   441,  2808,  2809,   265,   173,    98,  2813,   136,
     398,   382,   400,   401,  2819,   382,   360,  2306,   360,   360,
    2026,    49,    49,    84,   360,   360,   360,   255,   352,   360,
     360,  2871,    38,    38,   315,   360,   251,   441,   194,  2920,
     253,   251,  2923,   360,   360,  2850,   405,   435,  3386,  3387,
     438,   439,   440,   401,   437,   437,   437,  2897,  2898,  2889,
    2889,  3831,    32,    31,   391,    20,   251,   136,   237,   437,
     131,   104,  3898,   136,   382,   393,   218,  2926,  2908,  2908,
     237,  3907,   143,   247,  3086,    32,  3088,   148,  3548,  2970,
    4109,  2940,   153,  4143,   148,    32,   200,   158,  3924,  3925,
     161,  3647,   163,  3658,   437,   316,  3074,   136,   246,  4057,
     136,   382,   136,  2962,   382,   136,   136,     8,  4143,   360,
      11,   241,   153,   437,   397,   437,   358,   419,   229,   190,
      11,   229,   327,   358,  3689,  3690,     8,   360,   161,    11,
     144,   437,   437,   153,   441,   362,    37,   441,   438,   167,
     167,   212,    43,   437,   190,   441,    28,   329,   198,   252,
     382,   441,  3164,  2968,    49,   259,   438,  2173,   360,   360,
     315,    76,   315,   382,   437,   242,    67,   242,   360,   198,
     360,  3770,   198,   360,  4168,   437,   364,   394,   249,   317,
     242,   200,   251,    39,  4178,   334,   257,   250,   360,   441,
    3660,  3756,  3757,   352,   315,   360,  3072,   168,  3048,   298,
     298,   424,   425,   426,   324,   428,   429,   430,   431,   432,
     433,   287,  3088,   360,   360,  3239,    32,   194,  3688,   194,
     979,   194,   194,   982,   382,   984,   382,   986,   194,   988,
     424,    31,  3072,   992,   305,   435,   136,  3707,  4232,   250,
    2539,   360,  3613,  2542,   435,  2544,  3086,   360,  3088,   424,
    2549,  3078,  3079,  3080,  3081,  3959,  4059,   150,   360,   148,
     360,   437,   394,   247,   437,   324,   136,   437,   169,    32,
     401,   165,   173,   165,   148,   251,    32,   251,   136,   350,
     324,   251,   251,   148,   441,  3755,   173,  4067,  4068,   173,
     173,   441,    19,   194,   195,  3186,  3187,  3188,  3189,   405,
    2599,   441,   159,   374,   226,   401,  3871,  4143,  3873,  3874,
     211,   251,   194,   441,    49,   364,   246,   153,   350,   200,
    3885,   269,   394,   438,   153,   441,   438,   398,  3676,   400,
     401,   438,  4326,   419,   261,   360,  3195,   419,   398,   240,
    2639,   438,    13,   438,   438,   438,   438,   438,   438,   438,
     438,    13,   253,   438,   438,   438,   437,   437,   380,   437,
    3817,   305,    49,   437,   435,   212,   424,   438,   439,   440,
     438,   253,   251,   251,  3770,   398,   388,   254,   176,  3727,
     437,   437,   136,   184,   405,   136,   255,   242,   136,  3239,
    3958,   176,   360,   360,   212,   270,   360,  3965,   360,   270,
     379,  2700,   360,  2702,   360,   360,   360,   220,   220,   220,
    3972,   360,   315,  3263,   360,   360,  3266,   360,  3268,   315,
     237,   360,   360,  3282,  3239,   315,  3285,   315,  3262,   360,
     331,   136,  3902,    38,   360,   360,   194,  4054,   437,   194,
       3,   327,   194,   435,  4148,   438,   318,  3262,  4219,   227,
    4220,  2467,   438,   212,   441,   438,   369,    39,  2757,  3309,
     300,     8,    97,  4243,    11,  3315,  3316,   250,  3318,   251,
    3361,   424,    32,   162,   382,   438,   437,   382,   438,   254,
    4228,    28,  4230,  2782,   360,   315,   134,   315,   315,   441,
     441,   134,   194,   435,   127,   153,    11,   148,    59,   153,
     257,   438,  2801,  3353,  3354,  3355,  3356,   153,  3323,  3324,
     438,   422,   441,   393,   438,   438,   437,   161,   438,  3334,
    2819,    51,   438,   424,   425,   426,   438,   428,   429,   430,
     431,   432,   433,   437,  3393,   398,   438,   252,  3353,   437,
     148,    32,   424,   425,   426,   369,   428,   429,   430,   431,
     432,   433,   360,    83,   184,    49,     0,   382,   352,   382,
     369,   360,   315,   360,   437,  4523,   315,   360,   360,  3581,
     360,  4374,  4137,  3585,  3424,    49,   438,   438,   438,   352,
     148,  3421,  3421,    67,  2883,   136,    97,   438,   369,  3613,
     194,   194,   436,   436,   401,  4163,   438,   198,   437,  4112,
    2899,   283,   437,   324,   437,   148,   438,    22,    23,   139,
    3469,  2910,    27,  4317,  3985,  4573,   405,    32,    33,    34,
     441,    36,   441,  4581,    39,    40,   179,    42,  4193,    44,
      72,   441,   352,   437,  3484,   360,   438,   158,   324,    97,
      84,   171,   194,   153,   194,   194,   194,   194,   153,    49,
     438,  3466,   438,   437,   292,   399,  4027,   399,   438,   197,
     260,   438,   441,  4059,   438,   437,   437,   437,  4233,  4017,
     197,    49,   438,   163,  4144,   247,   438,   207,   438,   424,
     360,   369,  2981,   153,   401,    67,   178,   131,   242,    32,
     424,    49,   352,   360,   441,   441,   242,   136,   194,   143,
     436,   155,  3001,   153,   148,   382,   253,   237,    51,   153,
    4180,   173,   382,    32,   158,   122,   397,   161,   401,   163,
     153,   437,   401,   437,   181,   254,   153,  3026,   437,   437,
     292,   387,   438,   268,   438,  4506,   437,   197,   337,   437,
      83,  3581,   438,   400,   251,  3585,   190,   438,  4218,   293,
     360,   360,  4222,  4223,   401,   148,   111,   242,    32,  3609,
    3610,   437,   437,  3062,   179,   180,   181,   182,   212,   184,
     242,   186,   302,   188,   304,   190,   306,   176,   193,   283,
    3620,  3620,   312,   198,   221,   437,   201,   437,  3639,   319,
     205,   135,   207,   438,    32,   437,   139,   327,   438,  3633,
     255,    49,    49,   312,   312,   249,   336,  3819,    32,   437,
     352,   438,   438,   257,   344,   437,   382,   235,  3633,   352,
     251,   352,   438,  2839,  2840,     5,   324,   142,   171,    61,
     283,   254,    61,   117,   441,   437,   292,    32,   352,  2855,
     153,   386,   398,  3702,   290,  3736,   387,   148,   178,  3148,
     122,  3685,   437,  2869,   251,  3714,   251,   200,    32,  3750,
      32,   305,  2878,   254,   207,   401,   396,   254,   438,   438,
    3685,    49,   437,   437,   109,   311,  2892,   424,   425,   426,
     380,   428,   429,   430,   431,   432,   433,     5,    17,  4346,
    3705,  3706,   311,    28,   237,  3710,  3711,   283,   438,   135,
     437,  1359,  2175,  3753,  3754,   437,   350,   729,   822,  1153,
    2490,   821,  3238,  3763,  3764,  2648,  2021,  2090,  2799,  3318,
    3770,   788,  4235,  4057,  3774,  4374,  4105,  3384,  4109,  3941,
     374,  3810,  4091,  4498,  3946,  2275,  2573,  4441,  3984,  3951,
    3239,  4388,  3954,  4503,  2960,  4387,  4460,  4285,  2577,  2166,
    3376,  3233,  3843,  2166,   398,  3770,   400,   401,  3792,   302,
    2668,  3985,  2870,   306,  2160,  4511,  4581,  1458,  4573,   312,
    4086,  4342,  3984,  2818,  4471,  4029,   319,  3792,  4374,  2803,
    1448,  4361,  4032,  4451,   327,    26,  3469,  1005,  4191,  3839,
    3425,   435,  4016,   336,   438,   439,   440,  1888,  1015,  3427,
    4301,   344,  2549,  4027,  2760,   576,  4485,  1833,  4575,   708,
    1832,  2504,  3621,  3410,  4026,  3865,  3140,  1537,   721,  2505,
    1873,  2516,  2511,  2532,  2524,  1179,  1872,  3886,  3088,  1198,
    3572,  4176,  1200,  1197,  3587,   713,  3086,  3887,  3888,  3889,
    3890,  4320,  4319,  1205,  3141,     8,  2141,  3047,    11,  4146,
    3039,  4432,  4424,   396,  4433,  2508,    51,   400,   401,  2439,
    4072,  2347,  2437,  1708,  3136,    28,    -1,  3083,  3084,  3085,
      -1,    -1,    -1,    -1,    37,    -1,    -1,    -1,    -1,    -1,
      43,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    83,    -1,
      -1,  3390,    -1,    -1,    -1,  3986,  3987,  3988,     8,    -1,
      -1,    11,    -1,    -1,    67,    -1,  3946,    -1,    -1,  4121,
     525,  3951,    -1,    -1,  3954,   530,    -1,   532,    -1,  3978,
     535,  3980,   537,    -1,   539,    -1,    -1,    37,  3427,    -1,
      -1,   546,    -1,    43,   549,    -1,    -1,    -1,    -1,    -1,
      -1,   556,    -1,    -1,   139,    -1,  3969,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    67,    -1,    -1,
      -1,    -1,    -1,  4175,   579,    -1,  4016,    -1,    -1,   584,
      -1,    -1,    -1,    -1,   589,    -1,   171,    -1,   593,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,   608,    -1,    -1,    -1,    -1,    -1,    -1,
    4050,  4016,    -1,    -1,    -1,    -1,   169,    -1,    -1,  4059,
     173,    -1,   207,  4063,    -1,  4065,    -1,    -1,    -1,  4069,
    4070,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,  4120,
      -1,   194,   195,    -1,    -1,    -1,    -1,    -1,  3537,    -1,
      -1,   656,   237,    -1,    -1,    -1,    -1,    -1,   211,  3548,
    4262,    -1,   667,   668,     8,  4095,  4095,    11,    -1,   169,
      -1,    -1,    -1,   173,    -1,    -1,    -1,    -1,    -1,    -1,
     265,    -1,    -1,   688,   237,   690,   691,   240,    -1,    -1,
     695,    -1,    -1,    37,   194,   195,    -1,    -1,    -1,    43,
     253,    -1,    -1,   256,   709,    -1,    -1,    -1,   713,    -1,
      -1,   211,    -1,   298,   719,    -1,    -1,   302,  4320,  4200,
      -1,   306,    -1,    67,    -1,   730,    -1,   312,  4342,    -1,
      -1,    -1,    -1,    -1,   319,    -1,    -1,   742,    -1,    -1,
     240,    -1,   327,    -1,  3350,  4175,    -1,    -1,  4229,    -1,
    4231,   336,    -1,   253,    -1,    -1,    -1,    -1,    -1,   344,
      -1,    -1,    -1,  3369,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,  3660,    -1,    -1,    -1,    -1,    -1,    -1,   331,   784,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
    3396,    -1,   797,    -1,   799,   800,  4236,    -1,  4400,  3688,
      -1,    -1,    -1,     8,    -1,    -1,    11,    -1,    -1,  4411,
      -1,   396,    -1,    -1,    -1,    -1,   821,   822,  3707,    -1,
      -1,    -1,    -1,    28,    -1,   169,    -1,    -1,    -1,   173,
      -1,   331,    37,    -1,    -1,    -1,    -1,    -1,    43,    -1,
      -1,   846,    -1,    -1,  4446,    -1,    -1,    -1,    -1,    -1,
     194,   195,   857,  4283,  4283,    -1,   861,    -1,    -1,  4340,
      -1,    -1,    67,    -1,    -1,    -1,  3755,   211,    -1,   874,
      -1,   424,   425,   426,    -1,   428,   429,   430,   431,   432,
     433,    -1,    -1,   436,   889,    -1,    -1,    -1,    -1,   442,
     895,   896,    -1,   237,    -1,    -1,   240,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,   911,   912,   913,   253,
     915,    -1,   917,    -1,  4395,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,   425,   426,    -1,   428,   429,
     430,   431,   432,   433,  4374,    -1,    -1,    -1,   943,    -1,
     945,   946,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,  3564,  3565,
    3566,  3567,    -1,   968,   169,    -1,    -1,    -1,   173,    -1,
      -1,    -1,    -1,    -1,  4455,  4577,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,  4434,    -1,   331,    -1,   194,
     195,    -1,    -1,   998,   999,    -1,    -1,    -1,  1003,    -1,
    1005,    -1,    -1,    -1,    -1,    -1,   211,    -1,    -1,    -1,
      -1,    -1,    -1,  3902,    -1,    -1,    -1,    -1,  1023,    -1,
      -1,  1026,    -1,    -1,  1029,    -1,  4507,    -1,    -1,    -1,
      -1,    -1,   237,    -1,    -1,   240,    -1,  1042,    -1,    -1,
      -1,    -1,  4472,  4472,    -1,    -1,    -1,    -1,   253,    -1,
      -1,   256,    -1,    -1,    -1,  4485,  4485,  4485,  4485,  4485,
    4485,    -1,  4528,    -1,    -1,    -1,  1071,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
     424,   425,   426,  4523,   428,   429,   430,   431,   432,   433,
      -1,    -1,    -1,    -1,  1099,  1100,    -1,  1102,  4528,  4528,
    4528,  4528,  4528,  4528,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,  1121,    -1,  4523,    -1,
      -1,    -1,    -1,    -1,    -1,     8,   331,  4016,    11,    -1,
      -1,    -1,    -1,  4573,    18,    -1,    -1,    -1,    -1,    -1,
      24,  4581,    -1,    -1,    -1,  4575,  4575,  4575,  4575,  4575,
    4575,    -1,    -1,  1158,    37,    -1,  1161,    -1,     8,    -1,
      43,    11,    -1,    -1,    -1,    -1,    -1,    -1,  4573,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,  4581,    -1,    28,    -1,
      -1,    65,    -1,    -1,    67,  1190,    -1,    37,    -1,  1194,
    1195,    -1,    -1,    43,    -1,    -1,    -1,    -1,    -1,    -1,
    1205,  1206,  1207,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    67,  1223,   424,
     425,   426,    -1,   428,   429,   430,   431,   432,   433,    32,
     114,    -1,    -1,    -1,  4123,    -1,   441,   121,    -1,    -1,
     124,    -1,    -1,    -1,    -1,    -1,   129,    -1,    51,    -1,
      -1,  1256,    -1,    -1,    -1,  4144,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,  3869,  1269,  1270,    -1,    -1,    -1,    -1,
      -1,  1276,    -1,    -1,  1279,    -1,    -1,    -1,    -1,    -1,
      83,    -1,    -1,    -1,    -1,    -1,   169,    -1,    -1,    -1,
     173,  4180,    -1,    -1,   178,    -1,    -1,  1302,    -1,    -1,
      -1,    -1,    -1,  1308,    -1,    -1,  1311,    -1,    -1,    -1,
      -1,   194,   195,    -1,    -1,    -1,    -1,    -1,    -1,   169,
      -1,    -1,    -1,   173,    -1,    -1,    -1,    -1,   211,  4218,
    1335,    -1,    -1,  4222,  4223,    -1,   139,    -1,  1343,  1344,
    1345,  1346,  1347,    -1,   194,   195,    -1,    -1,    -1,    -1,
      -1,   235,    -1,   237,    -1,    -1,  1361,   240,    -1,    -1,
      -1,   211,    -1,   247,    -1,    -1,    -1,  1372,   171,  1374,
     253,   255,    -1,    -1,    -1,    -1,    -1,    -1,    -1,  1384,
    1385,   265,    -1,    -1,    -1,  1390,    -1,   237,    -1,    -1,
     240,    -1,    -1,    -1,    -1,    -1,    -1,   200,    -1,    -1,
      -1,    -1,    -1,   253,   207,    -1,   256,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,   298,    -1,    -1,   301,   302,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,  1434,
      -1,    -1,    -1,    -1,   237,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,   327,    -1,    -1,    -1,    -1,   331,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,  1461,  1462,  1463,  1464,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,  1473,  4075,
      -1,    -1,    -1,    -1,  1479,    -1,    -1,  1482,    -1,    -1,
      -1,   331,    -1,    -1,    -1,    -1,  1491,    -1,    -1,     3,
      -1,    -1,    -1,  1498,     8,  1500,    -1,    11,    -1,   302,
      -1,   385,    -1,   306,    -1,  1510,  4112,    -1,    -1,   312,
    1515,    -1,    -1,    -1,    28,    -1,   319,    -1,    32,  1524,
      -1,    -1,    -1,    37,   327,  1530,  1531,    -1,    -1,    43,
    1535,    -1,    -1,   336,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,   344,    -1,    -1,    -1,   428,   429,   430,   431,   432,
     433,    -1,    -1,    67,    -1,  1560,    -1,    -1,    -1,    -1,
      -1,    -1,  1567,    -1,  1569,    -1,    -1,    -1,  1573,  1574,
      -1,  1576,    -1,    -1,   424,   425,   426,  1582,   428,   429,
     430,   431,   432,   433,  1589,    -1,    -1,    -1,   438,    -1,
      -1,  1596,  1597,   396,    -1,  1600,    -1,   400,  4204,  1604,
      -1,  1606,    -1,    -1,    -1,    -1,    -1,    -1,  1613,    -1,
      -1,  1616,    -1,    -1,    -1,  1620,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,  1628,  1629,    -1,    -1,    -1,    -1,    -1,
      -1,  1636,    -1,  1638,  1639,  1640,  1641,  1642,    -1,    -1,
      -1,    -1,    -1,    -1,  1649,  1650,    -1,  1652,    -1,  1654,
    1655,    -1,    -1,  1658,    -1,   169,    -1,    -1,    -1,   173,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
    1675,    -1,    -1,    -1,  1679,  1680,    -1,    -1,    -1,  1684,
     194,   195,    -1,  1688,    -1,  1690,  1691,  1692,  1693,  1694,
    1695,  1696,  1697,  1698,    -1,  1700,    -1,   211,    -1,    -1,
      -1,  1706,    -1,  1708,  1709,    -1,    -1,    -1,    -1,    -1,
    1715,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,   237,    -1,    -1,   240,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   253,
      -1,    -1,   256,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,     0,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    14,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    24,    -1,    26,    27,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    42,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    62,    -1,    64,    65,   331,    -1,    -1,
      -1,    70,    -1,    72,    -1,    -1,  1831,    -1,  1833,    -1,
    1835,    -1,    -1,    82,    -1,    84,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,   100,    -1,    -1,   103,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,  1870,   115,    -1,   117,    -1,
      -1,  1876,   121,  1878,    -1,    -1,    -1,    -1,   127,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,   135,    -1,   137,    -1,
      -1,    -1,    -1,    -1,   143,    -1,    -1,    -1,    -1,    -1,
      -1,  1906,    -1,    -1,    -1,    -1,  1911,    -1,  1913,   158,
     424,   425,   426,    -1,   428,   429,   430,   431,   432,   433,
      -1,    -1,    -1,    -1,    -1,  1930,    21,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,  1941,    -1,  1943,  1944,
    1945,    -1,    -1,  1948,    -1,  1950,    -1,  1952,    18,  1954,
      -1,  1956,  1957,    -1,    24,  1960,    -1,    -1,    -1,    -1,
      55,    -1,    -1,    -1,   213,   214,    -1,    -1,    -1,    -1,
     219,    -1,    -1,    68,  1979,    -1,    -1,    -1,    -1,   228,
      -1,    -1,    -1,    -1,  1989,    -1,    81,    -1,    -1,    -1,
     239,  1996,    -1,    -1,    -1,    65,  2001,    -1,    -1,    -1,
      -1,    -1,  2007,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,  2026,    -1,    -1,   119,  2030,  2031,    -1,   277,    -1,
      -1,    -1,  2037,  2038,    -1,   130,    -1,    -1,    -1,    -1,
     289,    -1,    -1,    -1,   114,   294,   295,    -1,   297,    -1,
    2055,   121,    -1,   302,   124,   150,    -1,    -1,   307,    -1,
     155,   310,    -1,    -1,    -1,   314,    -1,    -1,    -1,    -1,
     319,   320,    -1,    -1,    -1,    -1,    -1,  2082,   327,  2084,
    2085,   330,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   338,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,   350,    -1,    -1,    -1,    -1,    -1,    -1,   178,  2114,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,  2122,   367,    -1,
       8,    -1,  2127,    11,    -1,    -1,    -1,   222,   377,    -1,
      -1,    -1,    -1,    -1,   383,  2140,    -1,    -1,    -1,   388,
      28,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    37,
      -1,    -1,   401,    -1,    -1,    43,    -1,    -1,   253,    -1,
      -1,    -1,    -1,  2168,    -1,   235,  2171,   237,  2173,    -1,
    2175,    -1,    -1,  2178,    -1,    -1,    -1,   247,    -1,    67,
      -1,    -1,    -1,    -1,    -1,   255,    -1,   282,   437,    -1,
      -1,   440,    -1,     8,    -1,   265,    11,    -1,    -1,  2204,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,  2212,  2213,    -1,
      -1,    -1,    -1,    28,    -1,    -1,    -1,    -1,    -1,    -1,
     315,    -1,    37,    -1,    -1,    -1,   321,    -1,    43,   324,
      -1,   301,   302,    -1,  2239,    -1,  2241,  2242,  2243,  2244,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    67,    -1,    -1,   350,    -1,   327,  2263,    -1,
      -1,   356,     8,    -1,    -1,    11,    -1,    -1,    -1,    -1,
    2275,    -1,    -1,    -1,   369,    -1,    -1,    -1,    -1,    -1,
      -1,   169,    28,    -1,    -1,   173,    -1,    -1,    -1,    -1,
      -1,    37,    -1,    -1,    -1,    -1,    -1,    43,    -1,   394,
      -1,    -1,    -1,    -1,    -1,    -1,   194,   195,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,   385,  2321,    -1,    -1,    -1,
      -1,    67,  2327,   211,    -1,    -1,    -1,    -1,     8,    -1,
      -1,    11,    -1,  2338,    -1,    -1,    -1,    -1,    -1,    -1,
    2345,  2346,    -1,    -1,    -1,    -1,  2351,    -1,    28,   237,
      -1,    -1,   240,    -1,   169,    -1,    -1,    37,   173,    -1,
      -1,    -1,    -1,    43,    -1,   253,    -1,    -1,   256,    -1,
      -1,  2376,  2377,    -1,    -1,    -1,  2381,    -1,    -1,   194,
     195,    -1,    -1,    -1,    -1,    -1,    -1,    67,  2393,  2394,
    2395,  2396,    -1,    -1,    -1,    -1,   211,    -1,    -1,    -1,
      -1,  2406,    -1,    -1,  2409,    -1,  2411,  2412,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,  2421,  2422,    -1,    -1,
    2425,    -1,   237,   169,    -1,   240,    -1,   173,    -1,    -1,
      -1,    -1,    -1,  2438,    -1,  2440,    -1,  2442,   253,  2444,
      -1,   256,    -1,   331,    -1,    -1,    -1,    -1,   194,   195,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,  2463,    -1,
      -1,     8,  2467,    -1,    11,   211,    -1,    -1,  2473,    -1,
      -1,  2476,  2477,  2478,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    28,    -1,    -1,    -1,    -1,    -1,    -1,  2493,   169,
      37,   237,    -1,   173,   240,    -1,    43,    -1,    -1,    -1,
    2505,    -1,    -1,    -1,    -1,  2510,    -1,   253,    -1,    -1,
     256,  2516,    -1,    -1,   194,   195,   331,    -1,    -1,  2524,
      67,    -1,  2527,    -1,    -1,    -1,  2531,    -1,    32,    -1,
      -1,   211,    -1,    -1,    -1,    -1,   424,   425,   426,    -1,
     428,   429,   430,   431,   432,   433,    -1,    51,    -1,    -1,
     438,    -1,    -1,    -1,    -1,    -1,    -1,   237,    -1,    -1,
     240,    -1,    -1,    -1,    -1,    -1,    -1,  2572,    -1,  2574,
      -1,    -1,    -1,   253,  2579,    -1,   256,    -1,    -1,    83,
      -1,    -1,    -1,    -1,    -1,   331,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
    2605,    -1,  2607,  2608,  2609,    -1,    -1,    -1,    -1,   424,
     425,   426,    -1,   428,   429,   430,   431,   432,   433,    -1,
      -1,    -1,   169,   438,    -1,    -1,   173,    13,    -1,    -1,
      -1,    -1,    -1,    19,    -1,   139,    -1,    -1,    -1,    -1,
      -1,    -1,    28,    -1,    -1,    -1,    -1,   194,   195,    -1,
      -1,   331,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    47,    -1,    -1,   211,    -1,    -1,   171,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   424,   425,
     426,    -1,   428,   429,   430,   431,   432,   433,    -1,    -1,
     237,    -1,   438,   240,    -1,    -1,   200,    -1,    -1,    -1,
      -1,    -1,    -1,   207,    -1,    -1,   253,    -1,    -1,   256,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,   237,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,   424,   425,   426,    -1,   428,   429,
     430,   431,   432,   433,    -1,    -1,    -1,    -1,   438,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,  2786,  2787,    -1,   331,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   302,    -1,
     186,    -1,   306,    -1,    -1,    -1,    -1,    -1,   312,     8,
     196,   197,    11,   199,    -1,   319,   202,    -1,   204,    -1,
      -1,    -1,    -1,   327,    -1,    -1,    -1,    -1,    -1,    28,
      -1,    -1,   336,    -1,  2839,  2840,    -1,    -1,    37,    -1,
     344,    -1,    -1,    -1,    43,    -1,    -1,    -1,    -1,    -1,
    2855,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,  2868,  2869,    -1,    -1,    -1,    67,    -1,
      -1,    -1,  2877,  2878,    -1,    -1,    -1,   424,   425,   426,
      -1,   428,   429,   430,   431,   432,   433,  2892,    -1,    -1,
      -1,   438,   396,    -1,    -1,    -1,   400,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,  2920,    -1,    -1,  2923,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,  2937,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,  2960,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,  2970,    -1,    -1,    -1,    -1,
     169,    -1,    -1,  2978,   173,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,  2988,    -1,    -1,    -1,    -1,    -1,  2994,
      -1,  2996,    -1,    -1,    -1,   194,   195,  3002,    -1,    -1,
    3005,  3006,  3007,  3008,  3009,  3010,  3011,  3012,  3013,  3014,
      -1,    -1,   211,  3018,  3019,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,  3031,    -1,    -1,    -1,
    3035,    -1,    -1,    -1,  3039,    -1,    -1,     8,   237,    -1,
      11,   240,    -1,    -1,  3049,    -1,    18,  3052,    -1,  3054,
      -1,    -1,    24,    -1,   253,    -1,    -1,   256,  3063,  3064,
    3065,    -1,    -1,    -1,  3069,    -1,    37,  3072,    -1,    -1,
      -1,  3076,    43,    -1,    -1,    -1,    -1,    -1,  3083,  3084,
    3085,  3086,    -1,  3088,  3089,    -1,    -1,    -1,  3093,  3094,
      -1,    -1,    -1,    65,    -1,  3100,    67,    -1,    -1,    -1,
      -1,  3106,  3107,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,  3130,    -1,    -1,    -1,    -1,
      -1,  3136,   331,    -1,    -1,  3140,    -1,  3142,    -1,    -1,
      -1,    -1,   114,    -1,    -1,    -1,    -1,   533,    -1,   121,
      -1,    -1,   124,    -1,    -1,   541,    -1,    -1,   129,  3164,
    3165,  3166,    -1,  3168,   550,   551,    -1,    -1,    -1,   555,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
     566,  3186,  3187,  3188,  3189,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,   580,    -1,    -1,    -1,   169,    -1,
      -1,    -1,   173,    -1,    -1,    -1,   178,    -1,     8,    -1,
     596,    11,    -1,   599,    -1,   601,    -1,   603,  3223,    -1,
      -1,    -1,    -1,   194,   195,   424,   425,   426,    28,   428,
     429,   430,   431,   432,   433,    -1,    -1,    37,    -1,   438,
     211,     8,    -1,    43,    11,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,   880,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,   235,    -1,   237,    -1,    67,     8,   240,
      37,    11,    -1,    -1,    -1,   247,    43,   663,    -1,   665,
      -1,    -1,   253,   255,    -1,    -1,    -1,    -1,    28,    -1,
      -1,    -1,    -1,   265,  3299,    -1,    -1,    37,    -1,    -1,
      67,    -1,    -1,    43,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,     8,    -1,
      -1,    11,    -1,    -1,    -1,    -1,   298,    67,    -1,   301,
     302,    -1,    -1,    -1,    -1,   721,    -1,    -1,    28,    -1,
      -1,    -1,    -1,    -1,    -1,  3350,    -1,    37,    -1,    -1,
      -1,    -1,    -1,    43,    -1,   327,  3361,    -1,  3363,    -1,
     331,    -1,   129,    -1,  3369,    -1,    -1,    -1,    -1,   169,
    3375,    -1,    -1,   173,    -1,    -1,    -1,    67,    -1,  3384,
      -1,    -1,    -1,    -1,  1012,    -1,    -1,    -1,    -1,    -1,
      -1,  3396,    -1,   779,   194,   195,    -1,    -1,    -1,    -1,
      -1,  3406,   169,    -1,    -1,    -1,   173,  3412,    -1,    -1,
      -1,   211,    -1,   385,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,  3428,  3429,    -1,    -1,   194,   195,   169,
      -1,    -1,    -1,   173,    -1,    -1,    -1,   237,    -1,    -1,
     240,    -1,    -1,    -1,   211,    -1,  3451,    -1,  3453,   835,
      -1,    -1,    -1,   253,   194,   195,   256,   428,   429,   430,
     431,   432,   433,    -1,   850,    -1,    -1,    -1,    -1,    -1,
      -1,   211,    -1,   240,    -1,    -1,    -1,   863,    -1,   169,
      -1,    -1,  3487,   173,   870,    -1,   253,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,   882,   237,    -1,   885,
     240,    -1,    -1,    -1,   194,   195,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,   253,    -1,    -1,   256,    -1,    -1,  3524,
      -1,   211,    -1,    -1,    -1,    -1,    -1,    -1,    -1,  3534,
    3535,   331,   918,    -1,    -1,    -1,    -1,  3542,  3543,    -1,
      -1,    -1,  3547,    -1,    -1,    -1,    -1,   237,  3553,  3554,
     240,    -1,  3557,    -1,    -1,  3560,  3561,    -1,    -1,  3564,
    3565,  3566,  3567,   253,   331,    -1,  3571,  3572,    -1,  3574,
      -1,    -1,  3577,    -1,    -1,    -1,  3581,    -1,    -1,    -1,
    3585,    -1,  1210,    -1,    -1,    -1,  3591,    -1,    -1,    -1,
      -1,   331,  3597,    -1,    -1,    -1,    -1,  3602,    -1,    -1,
      -1,    -1,  3607,    -1,    -1,    18,    -1,    -1,  3613,    -1,
      -1,    24,    -1,    -1,    -1,     8,  3621,    -1,    11,    -1,
    3625,    -1,    -1,    -1,   424,   425,   426,    -1,   428,   429,
     430,   431,   432,   433,  3639,    28,  1264,  3642,   438,    -1,
      -1,   331,    -1,    -1,    37,    -1,    -1,    -1,    -1,    -1,
      43,    -1,    65,    -1,    -1,    -1,    -1,  3662,  3663,    -1,
      -1,   428,   429,   430,   431,   432,   433,    -1,    -1,    -1,
      -1,    -1,  1300,    -1,    67,    -1,    -1,    -1,    -1,    -1,
      -1,  3686,    -1,    -1,   424,   425,   426,    -1,   428,   429,
     430,   431,   432,   433,    -1,    -1,    -1,    -1,   438,    -1,
      -1,   114,    -1,    -1,    -1,    -1,    -1,    -1,   121,    -1,
      -1,   124,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,     8,
      -1,  3736,    11,    -1,   424,   425,   426,    -1,   428,   429,
     430,   431,   432,   433,    -1,  3750,    -1,    -1,  1376,    28,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    37,    -1,
      -1,    -1,    -1,    -1,    43,   178,    -1,  1395,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,   169,    -1,    -1,    -1,
     173,    -1,     8,    -1,    -1,    11,    -1,  1415,    67,    -1,
      -1,    -1,    -1,  1179,  1180,    -1,    -1,    -1,    -1,    -1,
      -1,   194,   195,  3808,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    37,  1440,    -1,  3819,    -1,    -1,    43,   211,  3824,
      -1,    -1,   235,    -1,   237,    -1,  3831,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,   247,    -1,    -1,    -1,  3843,  3844,
      -1,    67,   255,    -1,   237,    -1,    -1,   240,    -1,    -1,
      -1,    -1,   265,    -1,    -1,    -1,  1242,    -1,    -1,    -1,
     253,    -1,    -1,   256,  3869,    -1,    -1,    -1,    -1,  1497,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,   298,    -1,    -1,   301,   302,
     169,    -1,    -1,  3898,   173,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,  3907,   129,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,   327,   194,   195,    -1,    -1,  3924,
    3925,    -1,    -1,  3928,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,   211,    -1,    -1,    -1,  3941,  3942,   331,    -1,
      -1,  3946,    -1,   169,    -1,    -1,  3951,   173,    -1,  3954,
    3955,    -1,  3957,    -1,  3959,  3960,    -1,    -1,   237,    -1,
      -1,   240,    -1,    -1,    -1,    -1,    -1,    -1,   194,   195,
      -1,    -1,   385,    -1,   253,    -1,    -1,   256,    -1,  3984,
    3985,  3986,  3987,  3988,    -1,   211,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,   240,    -1,    -1,    -1,    -1,    -1,
      -1,  4026,  4027,    -1,    -1,    -1,    -1,   253,    -1,    -1,
      -1,   424,   425,   426,    -1,   428,   429,   430,   431,   432,
     433,    -1,    -1,    -1,    -1,   438,  1674,    -1,    -1,    -1,
      -1,    -1,   331,    -1,    -1,    -1,    -1,    -1,  1444,    -1,
      -1,    -1,  4067,  4068,    -1,    -1,     8,  4072,    -1,    11,
    4075,    -1,    -1,  1459,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,  4086,    -1,    -1,    -1,    -1,    28,    -1,  4093,    -1,
      -1,    -1,  4097,    -1,    -1,    37,    -1,    -1,    -1,    -1,
      -1,    43,    -1,    -1,  4109,   331,    -1,  4112,    -1,    -1,
      -1,    -1,    -1,  1499,    -1,  4120,  4121,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    67,    -1,    -1,  1514,    -1,
    1516,    -1,  1518,    -1,    -1,    -1,    -1,  1523,  4143,    -1,
      -1,  4146,    -1,  4148,    -1,   424,   425,   426,    -1,   428,
     429,   430,   431,   432,   433,    -1,    -1,    -1,    -1,   438,
      -1,    -1,    -1,    -1,    -1,    -1,  4171,    -1,    -1,    -1,
    4175,    -1,    -1,  4178,    -1,    -1,    -1,    -1,    -1,  4184,
    1566,    -1,    -1,    -1,  1570,    -1,  1572,    -1,    -1,  1575,
      -1,    -1,    -1,    -1,    -1,  4200,    -1,    -1,    -1,  4204,
      -1,    -1,   428,   429,   430,   431,   432,   433,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,  4228,  4229,  4230,  4231,   169,    -1,    -1,
      -1,   173,    -1,    -1,    -1,    -1,    -1,    -1,  4243,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,   194,   195,    -1,  1883,    -1,  4262,    -1,  1887,
    1888,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   211,
      -1,    -1,    -1,    -1,     8,    -1,  4281,    11,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    28,   237,    -1,    -1,   240,    -1,
      -1,    -1,    -1,    37,    -1,    -1,    -1,    -1,    -1,    43,
      -1,   253,  4317,    -1,   256,  4320,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    67,    -1,  4340,    -1,  4342,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,     8,  4352,    -1,    11,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,  1993,    28,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    37,    -1,    -1,    -1,    -1,
      -1,    43,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   331,
    4395,    -1,    -1,     8,    -1,  4400,    11,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    67,  4411,    -1,    -1,    -1,
      -1,    -1,    -1,    28,    -1,    -1,    -1,    -1,  4423,  4424,
      -1,    -1,    37,  4428,    -1,    -1,    -1,  4432,    43,    -1,
      -1,    -1,    -1,    -1,     8,   169,    -1,    11,    -1,   173,
      -1,  4446,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
    4455,    -1,    67,    -1,    28,    -1,    -1,    -1,    -1,    -1,
     194,   195,    -1,    37,    -1,    -1,    -1,    -1,    -1,    43,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,   211,    -1,    -1,
      -1,  4486,   424,   425,   426,    -1,   428,   429,   430,   431,
     432,   433,    -1,    67,    -1,  4500,   438,    -1,    -1,    -1,
      -1,    -1,  4507,   237,    -1,    -1,   240,   169,    -1,    -1,
      -1,   173,  1898,  1899,  2142,    -1,    -1,  1903,  1904,   253,
      -1,  1907,   256,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,  1917,   194,   195,    -1,    -1,    -1,    -1,  1924,    -1,
      -1,    -1,  1928,  1929,    -1,    -1,  1932,  1933,    -1,   211,
      -1,    -1,    -1,  1939,   169,    -1,    -1,     8,   173,    -1,
      11,    -1,    -1,  4568,    -1,  1951,    -1,  1953,    -1,    -1,
      -1,    -1,  4577,   147,    -1,   237,    -1,    28,   240,   194,
     195,    -1,    33,  1969,    -1,    -1,    37,    -1,  1974,    -1,
      -1,   253,    43,  2221,   256,   169,   211,   331,    -1,   173,
      -1,  1987,    -1,    -1,    -1,    -1,    -1,    -1,    -1,  1995,
      -1,  1997,  1998,  1999,  2000,    -1,    67,    -1,  2004,  2005,
     194,   195,   237,    -1,    -1,   240,  2012,    -1,    -1,    -1,
    2016,    -1,    -1,    -1,  2020,    -1,    -1,   211,   253,    -1,
      -1,   256,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,  2045,
      -1,   112,    -1,   237,    -1,    -1,   240,    -1,    -1,   331,
    2056,    -1,  2058,    -1,    -1,    -1,    -1,  2063,  2306,   253,
      -1,  2067,   256,  2069,  2070,  2071,  2072,    -1,  2074,    -1,
     424,   425,   426,    -1,   428,   429,   430,   431,   432,   433,
     274,  2087,  2088,  2089,   438,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,  2100,  2101,   331,    -1,   169,    -1,
       8,    -1,   173,    11,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      28,    -1,    -1,   194,   195,    -1,    -1,    -1,    -1,    37,
      -1,    -1,    -1,    -1,    -1,    43,    -1,   331,    -1,    -1,
     211,    -1,   424,   425,   426,    -1,   428,   429,   430,   431,
     432,   433,    -1,    -1,    -1,    -1,   438,    -1,  2164,    67,
      -1,    -1,    -1,    -1,    -1,    -1,   237,    -1,    -1,   240,
      -1,    -1,    -1,    -1,    -1,    18,    -1,    -1,    -1,    -1,
      -1,    24,   253,    -1,    -1,   256,    -1,    -1,    -1,   424,
     425,   426,    -1,   428,   429,   430,   431,   432,   433,    -1,
      -1,   436,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      18,     8,    65,    -1,    11,    -1,    24,    -1,    -1,    -1,
     424,   425,   426,    -1,   428,   429,   430,   431,   432,   433,
     148,    28,    -1,    -1,    -1,   153,    -1,    -1,    -1,    -1,
      37,    -1,    -1,    -1,    -1,    -1,    43,    -1,    -1,    -1,
     331,   169,    -1,    -1,    -1,   173,    -1,    65,    -1,    -1,
      -1,   114,    -1,    -1,    -1,    -1,    -1,  2283,   121,    -1,
      67,   124,    -1,    -1,    -1,    -1,   194,   195,    -1,    -1,
      -1,  2539,    -1,    -1,  2542,    -1,  2544,    -1,    -1,    -1,
      -1,  2549,    -1,   211,    -1,    -1,  2312,     8,    -1,    -1,
      11,   382,    -1,    -1,    -1,    -1,   114,    -1,    -1,    -1,
      -1,    -1,    -1,   121,    -1,    -1,   124,    28,    -1,   237,
      -1,    32,   240,    -1,    -1,   178,    37,    -1,    -1,    -1,
      -1,    -1,    43,    -1,    -1,   253,    -1,    -1,   256,    -1,
      -1,  2599,    -1,   424,   425,   426,    -1,   428,   429,   430,
     431,   432,   433,    -1,    -1,    -1,    67,    -1,    -1,    -1,
       8,    -1,    -1,    11,    -1,    -1,    -1,    -1,    -1,    -1,
     178,    -1,   169,    -1,    -1,    -1,   173,    -1,    -1,    -1,
      28,  2639,   235,    -1,   237,    -1,    -1,    -1,    -1,    37,
      -1,    -1,    -1,    -1,   247,    43,    -1,   194,   195,    -1,
      -1,    -1,   255,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,   265,   331,   211,    -1,    -1,    -1,    -1,    67,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,   235,    -1,   237,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   247,
     237,    -1,  2700,   240,  2702,   298,    -1,   255,   301,   302,
      -1,    -1,    -1,    -1,    -1,    -1,   253,   265,   169,   256,
      -1,    -1,   173,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,   327,    -1,    -1,    -1,    -1,   276,
      -1,    -1,    -1,   194,   195,    -1,    -1,  2503,    -1,    -1,
     298,    -1,    -1,   301,   302,    -1,    -1,    -1,    -1,  2757,
     211,    -1,    -1,    -1,    -1,    -1,   424,   425,   426,    -1,
     428,   429,   430,   431,   432,   433,    -1,    -1,    -1,   327,
      -1,   169,    -1,    -1,  2782,   173,   237,    -1,    -1,   240,
      -1,    -1,   385,    -1,   331,    -1,  2552,  2553,    -1,    -1,
      -1,    -1,   253,  2801,    -1,   256,   194,   195,   345,    -1,
      -1,    -1,    -1,  2569,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,  2819,    -1,   211,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,     8,    -1,    -1,    11,    -1,    -1,   385,  2594,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,  2603,    -1,   237,
      -1,    28,   240,    -1,    -1,    32,    -1,    -1,    -1,    -1,
      37,    -1,  2618,  2619,    -1,   253,    43,  2623,   256,    -1,
      -1,    -1,  2628,  2629,  2630,    -1,    -1,    -1,    -1,    -1,
     331,    -1,    -1,   271,    -1,  2883,    -1,   424,   425,   426,
      67,   428,   429,   430,   431,   432,   433,    -1,    -1,    -1,
      -1,  2899,  2658,  2659,  2660,  2661,    -1,    -1,    -1,    -1,
      -1,    -1,  2910,    -1,    -1,    -1,    -1,    -1,    -1,   179,
      18,    -1,    -1,    -1,    -1,    -1,    24,    -1,   188,   189,
      -1,    -1,    -1,    -1,    -1,   195,  2692,    -1,  2694,  2695,
    2696,     8,    -1,   331,    11,    -1,   206,    -1,  2704,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    18,
      -1,    28,    -1,    -1,    -1,    24,    -1,    65,    -1,    -1,
      37,    -1,    -1,   424,   425,   426,    43,   428,   429,   430,
     431,   432,   433,  2981,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,   169,    -1,    -1,    -1,   173,    -1,    -1,    -1,
      67,    -1,    -1,  3001,    -1,    -1,    65,    -1,    -1,    -1,
      -1,    -1,    -1,  2769,    -1,    -1,   114,   194,   195,    -1,
      -1,  2777,    -1,   121,    -1,    -1,   124,    -1,  3026,    -1,
      -1,    -1,    -1,    -1,   211,    -1,   424,   425,   426,    -1,
     428,   429,   430,   431,   432,   433,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,   114,    -1,    -1,    -1,    -1,
     237,    -1,   121,   240,  3062,   124,    -1,    -1,    -1,    -1,
      -1,    -1,     8,    -1,    -1,    11,   253,    -1,  2834,   256,
     178,    -1,    -1,    -1,    -1,    -1,   153,    -1,    -1,    -1,
      -1,    -1,    28,    -1,    -1,    -1,    32,    -1,    -1,    -1,
      -1,    37,   169,    -1,    -1,    -1,   173,    43,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   178,
    2876,    -1,    -1,  2879,    -1,    -1,    -1,   194,   195,    -1,
      -1,    67,    -1,    -1,    -1,    -1,    -1,   235,    -1,   237,
      -1,    -1,    -1,    -1,   211,    -1,    -1,    -1,    -1,   247,
    3148,    -1,    -1,    -1,   331,  2911,    -1,   255,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,   265,    -1,  2925,
     237,    -1,    -1,   240,    -1,    -1,   235,    -1,   237,  2935,
      -1,    -1,    -1,    -1,    -1,    -1,   253,    -1,   247,   256,
      -1,    -1,    -1,    -1,    -1,    -1,   255,    -1,    -1,    -1,
     298,    -1,    -1,   301,   302,    -1,   265,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,     8,    -1,    -1,    11,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   327,
      -1,    -1,    -1,   169,    -1,    28,    -1,   173,    -1,   298,
      -1,  3239,   301,   302,    37,    -1,    -1,   424,   425,   426,
      43,   428,   429,   430,   431,   432,   433,    -1,   194,   195,
      -1,    -1,    -1,    -1,   331,    -1,    -1,    -1,   327,    -1,
      -1,    -1,   532,    -1,    67,   211,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,   544,    -1,    -1,   385,   548,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   559,
      -1,   237,    -1,    -1,   240,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,   575,    -1,   253,    -1,   579,
     256,    -1,    -1,    -1,    -1,    -1,   385,    -1,    -1,   589,
     590,    -1,    -1,    -1,    -1,   595,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,   605,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,   613,    -1,    -1,    -1,   424,   425,   426,
      -1,   428,   429,   430,   431,   432,   433,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,   169,    -1,    -1,     8,
     173,    -1,    11,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,  3390,    -1,    -1,   331,    -1,    -1,    -1,    28,
      -1,   194,   195,    32,    -1,    -1,    -1,    -1,    37,    -1,
      -1,    -1,    -1,    -1,    43,  3171,    -1,  3173,   211,    -1,
      -1,    -1,    -1,    -1,  3180,    -1,    -1,    -1,   688,  3427,
      -1,    -1,    -1,   693,    -1,    -1,    -1,    -1,    67,    -1,
    3196,    -1,    -1,    -1,   237,    -1,    -1,   240,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,  3211,    -1,    -1,    -1,   719,
     253,    -1,    -1,   256,    -1,  3221,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
    3236,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   424,   425,
     426,    -1,   428,   429,   430,   431,   432,   433,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,  3269,  3270,  3271,    -1,    -1,  3274,  3275,
    3276,  3277,  3278,    -1,    -1,    -1,    -1,  3283,  3284,    -1,
    3286,  3287,  3288,  3289,  3290,  3291,  3292,    -1,   331,  3537,
     169,    -1,    -1,    -1,   173,  3301,    -1,  3303,  3304,    -1,
    3548,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,   357,   194,   195,    -1,    -1,    18,
      -1,    -1,    -1,    -1,    -1,    24,    -1,    -1,    -1,    -1,
      -1,    -1,   211,    -1,    -1,    -1,   846,    -1,    -1,    -1,
       8,    -1,    -1,    11,    -1,    -1,    -1,   857,    -1,    -1,
      -1,  3357,  3358,  3359,    -1,    -1,  3362,    -1,   237,    -1,
      28,   240,    -1,    -1,    -1,    -1,    65,    -1,    -1,    37,
     880,    -1,    -1,    -1,   253,    43,     8,   256,    -1,    11,
      -1,   424,   425,   426,    -1,   428,   429,   430,   431,   432,
     433,    -1,    -1,    -1,     8,    -1,    -1,    11,    -1,    67,
      -1,    -1,    -1,    -1,    -1,    37,    -1,   917,    -1,    -1,
      -1,    43,  3660,    -1,    -1,   114,    -1,    -1,    -1,    -1,
      -1,    -1,   121,    37,    -1,   124,    -1,    -1,    -1,    43,
      -1,    -1,    -1,    -1,    -1,    67,    -1,    -1,  3444,   949,
    3688,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,   331,    67,   964,  3461,  3462,  3463,   968,  3707,
      -1,    -1,    -1,    -1,    -1,    -1,   976,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   178,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,  1004,    -1,    -1,   129,    -1,    -1,
      -1,   169,  1012,    -1,  1014,   173,    -1,  3755,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,   129,    -1,  1027,    -1,    -1,
    1030,    -1,    -1,    -1,    -1,    -1,   194,   195,    -1,    -1,
      -1,    -1,  1042,    -1,    -1,    -1,   235,   169,   237,    -1,
      -1,   173,    -1,   211,    -1,   424,   425,   426,   247,   428,
     429,   430,   431,   432,   433,   169,   255,    -1,    -1,   173,
      -1,  1071,   194,   195,    -1,    -1,   265,    -1,    -1,   237,
      -1,    -1,   240,    -1,    -1,    -1,    -1,    -1,    -1,   211,
     194,   195,    -1,    -1,    -1,   253,    -1,    -1,   256,  1099,
    1100,    -1,  1102,    -1,    -1,    -1,    -1,   211,    -1,   298,
      -1,    -1,   301,   302,    -1,    -1,    -1,    -1,   240,    -1,
      -1,  1121,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,   253,    -1,    -1,    -1,    -1,   240,    18,   327,    -1,
      -1,    -1,    -1,    24,  1144,    -1,    -1,    -1,    -1,   253,
      -1,    -1,  1152,  1153,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,  1161,  1162,    -1,  3902,    -1,    -1,    -1,    -1,    50,
      -1,    -1,    -1,   331,    -1,  3671,  3672,  3673,  3674,    -1,
      -1,  3677,    -1,    -1,    65,    -1,    -1,    -1,    -1,    -1,
    1190,    -1,    -1,    -1,  1194,  1195,   385,    -1,    -1,    -1,
      -1,    -1,  3698,  3699,  3700,  3701,    -1,  3703,  3704,   331,
    1210,    -1,    -1,    -1,    -1,    96,  1216,    -1,    -1,  3715,
    3716,    -1,    -1,    -1,    -1,    -1,    -1,   331,    -1,    -1,
      -1,    -1,  3728,   114,    -1,    -1,    -1,    -1,  3734,  3735,
     121,  3737,    -1,   124,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,  1264,    -1,   424,   425,   426,    -1,
     428,   429,   430,   431,   432,   433,    -1,    -1,  4016,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,   175,    -1,    -1,   178,    -1,    -1,
    1300,    -1,    -1,    -1,    -1,    -1,   428,   429,   430,   431,
     432,   433,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,   428,   429,   430,   431,   432,   433,
    3826,    -1,    -1,    -1,    -1,    18,    -1,    -1,    -1,  3835,
      -1,    24,   223,    -1,   225,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,   235,    -1,   237,  1357,    -1,  3855,
      -1,    -1,    -1,    -1,    -1,    -1,   247,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,   255,    -1,  1376,    -1,    -1,    -1,
      18,  3877,    65,   264,   265,  4123,    24,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,  1395,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,  4144,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,  1415,    -1,   298,    -1,    -1,
     301,   302,   303,    -1,    -1,    -1,    -1,    65,    -1,    -1,
      -1,   114,    -1,    -1,    -1,  1435,    -1,    -1,   121,    -1,
    1440,   124,  4180,    -1,    -1,    -1,   327,    -1,  3944,    -1,
      -1,    -1,    -1,    -1,    -1,  1455,    -1,   338,    -1,    -1,
      -1,  3957,    -1,    -1,    -1,    -1,    -1,    21,    -1,    -1,
      -1,  1471,    -1,    -1,    -1,    -1,   114,    -1,    -1,    -1,
    4218,    -1,    -1,   121,  4222,  4223,   124,    -1,    -1,    -1,
      -1,  1491,    -1,    -1,    -1,   178,    -1,  1497,    -1,    -1,
    1500,    55,  1502,  1503,   385,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,  1513,    68,    69,    -1,    -1,    -1,    -1,
      -1,    -1,  4018,    77,    -1,  1525,  1526,    81,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,  1537,    -1,    -1,
     178,    -1,  4038,    -1,    98,    -1,    -1,    -1,    -1,   189,
      -1,    -1,   235,    -1,   237,   195,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,   247,   119,   206,    -1,    -1,  1569,
      -1,    -1,   255,    -1,    -1,    -1,   130,    -1,    -1,    -1,
      -1,    -1,   265,    -1,   138,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,   150,   235,    -1,   237,
      -1,   155,    -1,    -1,  1604,    -1,  1606,    -1,    -1,   247,
      -1,    -1,    -1,  1613,    -1,   298,  1616,   255,   301,   302,
    1620,    -1,   176,    -1,    -1,    -1,    -1,   265,  1628,  1629,
      -1,    -1,    -1,  4129,    -1,    -1,  1636,    -1,    -1,  1639,
    1640,  1641,  1642,    -1,   327,    -1,    -1,   201,    -1,  1649,
    1650,    -1,  1652,    -1,  1654,  1655,    -1,    -1,  1658,    -1,
     298,    -1,    -1,   301,   302,    -1,    -1,    -1,   222,    -1,
      -1,    -1,  4168,    -1,  1674,  1675,  1676,    -1,    -1,    -1,
    1680,    -1,  4178,    -1,  1684,    -1,    -1,    -1,  1688,   327,
    1690,  1691,  1692,  1693,  1694,  1695,  1696,  1697,  1698,   253,
    1700,    -1,   385,    -1,    -1,    -1,    -1,    -1,  1708,  1709,
      -1,    -1,  4208,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,  4217,    -1,    -1,    -1,    -1,    -1,    -1,   282,    -1,
      -1,    -1,    -1,    -1,    -1,    21,  4232,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,   385,    34,    -1,
      -1,    -1,    -1,    -1,    -1,   309,    -1,    -1,    -1,   313,
      -1,   315,    -1,    -1,    -1,    -1,    -1,   321,    -1,    55,
     324,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    68,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    77,    -1,    -1,    -1,    81,   350,    -1,   352,    -1,
      -1,    -1,   356,    -1,    -1,    -1,    -1,    -1,    -1,  4305,
     364,    -1,    98,    -1,    -1,   369,    -1,    -1,   104,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
    4326,    -1,    -1,   119,    -1,  1835,    -1,    -1,    -1,    -1,
     394,    -1,    -1,    -1,   130,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,   138,    -1,  4350,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    21,    -1,   150,    -1,    -1,    -1,  4364,    -1,
      -1,   157,    -1,    -1,    -1,   161,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,  1883,    -1,    -1,    -1,  1887,  1888,    -1,
     176,    -1,    -1,  4389,    -1,    -1,    -1,  1897,  4394,    -1,
      -1,  1901,  1902,    -1,   544,  1905,    -1,    -1,   548,    68,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   559,
      -1,    -1,    81,    -1,    -1,    -1,    -1,  1927,    -1,   215,
    1930,    -1,    -1,    -1,    -1,   575,   222,    -1,    -1,    98,
      -1,  1941,    -1,    -1,    -1,   104,    -1,    -1,  1948,  4445,
     590,    -1,    -1,    -1,    -1,   595,    -1,    -1,    -1,    -1,
     119,    -1,    -1,    -1,    -1,   605,    -1,   253,  1968,    -1,
     256,   130,    -1,   613,    -1,    -1,    -1,    -1,    -1,   138,
      -1,    -1,    -1,    -1,    -1,  1985,  1986,    -1,    -1,    -1,
      -1,   150,    -1,  1993,    -1,    -1,   155,    -1,    -1,    -1,
      -1,    -1,   161,    -1,    -1,   291,    -1,    -1,    -1,    -1,
    2010,  2011,    -1,    -1,  2014,    -1,    -1,   176,    -1,    -1,
      -1,    -1,    -1,   309,    -1,    -1,    -1,    -1,    -1,   315,
      -1,    -1,    -1,    -1,    -1,   321,    -1,    -1,   324,    -1,
    2040,    -1,   201,    -1,  2044,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,   693,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,  2062,   222,   350,    -1,   352,   353,    -1,   355,
     356,    -1,    -1,  2073,    -1,    -1,    -1,    -1,   364,    -1,
      -1,    -1,    18,   369,    -1,    -1,  2086,    -1,    24,   375,
      -1,    -1,   378,    -1,   253,   381,  2096,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   394,    -1,
      -1,    -1,    -1,    -1,    50,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,   282,    -1,    -1,    -1,    -1,    -1,    65,
      -1,    -1,    -1,    -1,    -1,    -1,    21,    -1,    -1,    -1,
    2140,    -1,  2142,    -1,    -1,    -1,    -1,    -1,    -1,    34,
     309,    -1,    -1,    -1,   313,    -1,   315,    -1,    -1,    -1,
      96,    -1,   321,  2163,    -1,   324,    -1,    -1,    -1,    -1,
      55,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   114,    -1,
      -1,    -1,    -1,    68,    -1,   121,    -1,    -1,   124,    -1,
     349,   350,    -1,   352,    -1,    -1,    81,   356,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,   364,    -1,    -1,    -1,    -1,
     369,    -1,    -1,    98,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,  2221,   381,    -1,  2224,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,   119,   394,    -1,    -1,    -1,   175,
      -1,    -1,   178,    -1,    -1,   130,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,   138,    -1,    -1,    -1,    -1,  2258,    -1,
      -1,    -1,    -1,  2263,    -1,   150,    -1,    -1,    -1,    -1,
     155,    -1,    -1,    -1,    -1,    -1,   161,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,   223,    -1,   225,
      -1,   176,    -1,  2293,    -1,    -1,    -1,    -1,    -1,   235,
      -1,   237,    -1,    -1,    -1,    -1,  2306,    -1,    -1,   949,
      -1,   247,    -1,    -1,    -1,    -1,    -1,  2317,    -1,   255,
      -1,  2321,    -1,    -1,   964,    -1,    -1,  2327,   264,   265,
      -1,    -1,    -1,    -1,    -1,    -1,   976,   222,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,  2345,  2346,    -1,    -1,    -1,
      -1,  2351,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,   298,    -1,  1004,   301,   302,   303,   253,    -1,
      -1,    -1,    -1,    -1,  1014,    -1,  2376,  2377,    -1,   264,
      -1,  2381,    -1,    -1,    -1,    -1,    -1,  1027,    -1,    -1,
    1030,   327,    -1,  2393,  2394,  2395,  2396,   282,    -1,    -1,
      -1,  2401,   338,    -1,    -1,    -1,  2406,  2407,    -1,  2409,
      -1,  2411,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,  2421,  2422,    -1,   309,  2425,    -1,    -1,   313,    -1,
     315,    -1,    -1,    -1,    -1,    -1,   321,    -1,  2438,   324,
    2440,    -1,    -1,    -1,  2444,    -1,    -1,    -1,    -1,   385,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,  2463,    -1,   350,    -1,   352,    -1,    -1,
      -1,   356,    -1,  2473,    -1,    -1,  2476,  2477,  2478,   364,
      -1,    -1,    -1,    -1,   369,    -1,    -1,    -1,    -1,    -1,
    2490,    -1,    -1,  2493,    -1,    -1,   381,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,  1144,  2505,    -1,    -1,    -1,   394,
    2510,    -1,  1152,  1153,    -1,    -1,  2516,    -1,    -1,    -1,
      -1,    -1,  1162,    -1,  2524,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,  2539,
      -1,    -1,  2542,    -1,  2544,    -1,    -1,   189,    -1,  2549,
      -1,  2551,    -1,   195,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,   206,    -1,  2566,  2567,    -1,    -1,
      -1,    -1,  2572,    -1,    -1,    -1,  1216,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,  2593,    -1,    -1,  2596,    -1,    -1,  2599,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,  2639,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,  2667,  2668,  2669,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,  2691,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
    2700,    -1,  2702,  2703,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,  2713,    -1,    -1,    -1,  1357,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,  2757,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,  2776,    -1,    -1,    -1,
      -1,    -1,  2782,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,  1435,    -1,    -1,    -1,    -1,
      -1,  2801,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,  1455,    -1,    -1,  2818,  2819,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,  1471,    -1,  2833,    -1,  2835,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,  2847,    -1,  2849,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,  1502,  1503,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,  1513,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,  2883,    -1,  1525,  1526,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,  1537,  2898,  2899,
      -1,    -1,   544,    -1,    -1,    -1,   548,    -1,    -1,    -1,
    2910,    -1,    -1,    -1,    -1,    -1,    -1,   559,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,  2926,    -1,    -1,    -1,
      -1,    -1,    -1,   575,    -1,    -1,    -1,  2937,    -1,    -1,
    2940,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   590,    -1,
      -1,    -1,    -1,   595,    -1,    -1,    -1,    -1,    -1,  2959,
      -1,    -1,  2962,   605,    -1,    -1,    -1,    -1,    -1,   880,
      -1,   613,    -1,    -1,    -1,    -1,    -1,    -1,  2978,    -1,
      -1,  2981,    -1,    -1,    -1,    -1,    -1,    -1,  2988,    -1,
      -1,    -1,    -1,    -1,  2994,    -1,  2996,    -1,    -1,    -1,
      -1,  3001,  3002,    -1,    -1,  3005,  3006,  3007,  3008,  3009,
    3010,  3011,  3012,  3013,  3014,    -1,    -1,    -1,  3018,  3019,
      -1,    -1,    -1,    -1,    -1,    -1,  3026,    -1,    -1,    -1,
      -1,  3031,    -1,    -1,    -1,  3035,  1676,  3037,    -1,  3039,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,  3049,
      -1,   693,  3052,    -1,  3054,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,  3062,  3063,  3064,  3065,    -1,    -1,    -1,  3069,
      -1,    -1,  3072,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,  3086,    -1,  3088,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
    3100,  1012,    -1,    -1,    -1,    -1,  3106,  3107,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
    3130,    -1,    -1,    -1,    -1,    -1,  3136,    -1,    -1,    -1,
      -1,    -1,  3142,    -1,    -1,    -1,    -1,    -1,  3148,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,  3164,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,  3195,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,  3233,    -1,    -1,    -1,    -1,  3238,  3239,
    3240,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,  1897,    -1,    -1,
      -1,  1901,  1902,    -1,    -1,  1905,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,  3282,    -1,    -1,  3285,    -1,  1927,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,  1210,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,   949,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,  3319,
      -1,    -1,   964,    -1,    -1,    -1,    -1,    -1,  1968,    -1,
      -1,    -1,    -1,    -1,   976,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,  1985,  1986,    -1,    -1,    -1,
      -1,    -1,    -1,  1264,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,  1004,  3363,    -1,    -1,    -1,    -1,    -1,    -1,
    2010,  2011,  1014,    -1,  2014,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,  1027,  3386,  3387,  1030,  1300,
    3390,    -1,    -1,  3393,    -1,    -1,    -1,    -1,    -1,    -1,
    2040,    -1,    -1,    -1,  2044,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,  2062,    -1,    -1,    -1,    -1,  3427,  3428,  3429,
      -1,    -1,    -1,  2073,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,  2086,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,  2096,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,  1376,    -1,    -1,    -1,  3469,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,  1395,    -1,    -1,  3487,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,  1144,    -1,  1415,    -1,    -1,    -1,    -1,    -1,
    1152,  1153,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
    1162,    -1,    -1,  2163,  3524,    -1,    -1,    -1,    -1,  1440,
      -1,    -1,    -1,    -1,  3534,  3535,    -1,  3537,    -1,    -1,
      -1,    -1,  3542,  3543,    -1,    -1,    -1,  3547,  3548,    -1,
      -1,    -1,    -1,  3553,  3554,    -1,    -1,  3557,    -1,    -1,
    3560,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,  1216,    -1,    -1,    -1,    -1,    -1,
      -1,  3581,    -1,    -1,  2224,  3585,  1497,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,  3597,    -1,    -1,
      -1,    -1,  3602,    -1,    -1,    -1,    -1,  3607,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,  2258,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,  3642,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,  2293,    -1,    -1,    -1,    -1,    -1,    -1,
    3660,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,  3676,  2317,    -1,  3679,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,  3688,    -1,
      -1,    -1,    -1,    -1,    -1,   688,    -1,    -1,    -1,    -1,
      -1,    -1,  3702,    -1,    -1,    -1,    -1,  3707,    -1,    -1,
      -1,    -1,    -1,    -1,  3714,  1357,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,   719,  3727,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,  3755,    -1,    -1,    -1,    -1,
      -1,  2401,    -1,  1674,    -1,    -1,    -1,  2407,    -1,    -1,
    3770,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,  1435,    -1,    -1,    -1,    -1,  1709,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,  3808,    -1,
      -1,    -1,    -1,  1455,    -1,    -1,    -1,    -1,    -1,  3819,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,  1471,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
    2490,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
    1502,  1503,    -1,    -1,    -1,    -1,  3866,    -1,    -1,    -1,
      -1,  1513,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,  1525,  1526,    -1,  3886,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,  1537,    -1,    -1,  3898,    -1,
      -1,    -1,  3902,    -1,    -1,    -1,    -1,  3907,    -1,    -1,
      -1,  2551,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,  3924,  3925,  2566,  2567,  3928,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,  3941,    -1,    -1,    -1,    -1,  3946,    -1,    -1,    -1,
      -1,  3951,    -1,  2593,  3954,    -1,  2596,    -1,    -1,  3959,
    3960,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,  1883,    -1,    -1,    -1,  1887,  1888,  3978,    -1,
    3980,    -1,    -1,    -1,  3984,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,  4016,  4017,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,  4026,  2667,  2668,  2669,
      -1,    -1,    -1,    -1,  1676,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,  1042,
      -1,  2691,    -1,    -1,    -1,    -1,    -1,  4057,    -1,  4059,
      -1,    -1,    -1,  2703,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,  4072,  2713,    -1,    -1,    -1,    -1,  1071,    -1,
      -1,    -1,  1993,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,  1099,  1100,    -1,  1102,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,  4121,    -1,  4123,    -1,    -1,    -1,    -1,  1121,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,  2776,    -1,    -1,    -1,
      -1,    -1,    -1,  4143,  4144,    -1,  4146,    -1,  4148,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,  1161,    -1,
      -1,  4171,    -1,    -1,    -1,  4175,    -1,    -1,  2818,    -1,
    4180,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,  2833,    -1,  2835,    -1,  1190,    -1,    -1,
      -1,  1194,  1195,    -1,    -1,    -1,    -1,  2847,    -1,  2849,
      -1,    -1,  4212,    -1,    -1,    -1,    -1,    -1,  4218,    -1,
      -1,    -1,  4222,  4223,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,  2142,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,  1897,    -1,    -1,  2898,  1901,
    1902,    -1,  4262,  1905,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,  1115,    -1,    -1,    -1,    -1,    -1,
      -1,  4281,    -1,    -1,    -1,  1927,  2926,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
    2940,  4301,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
    2221,    -1,    -1,    -1,    -1,    -1,    -1,  4317,    -1,  2959,
    4320,    -1,  2962,    -1,    -1,    -1,  1968,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,  1175,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,  1985,  1986,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,  4352,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,  2010,  2011,
      -1,    -1,  2014,    -1,  4374,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,  2306,    -1,  3037,  2040,    -1,
    4400,    -1,  2044,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,  4411,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
    2062,    -1,    -1,  4423,  4424,    -1,    -1,    -1,    -1,    -1,
      -1,  2073,    -1,    -1,  4434,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,  2086,    -1,  4446,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,  2096,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,  4486,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
    4500,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,  2163,    -1,  4523,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,  3195,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,  2476,  2477,  2478,  4568,    -1,
      -1,    -1,    -1,  4573,    -1,    -1,    -1,  4577,    -1,    -1,
      -1,  4581,  2224,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,  3233,    -1,    -1,    -1,    -1,  3238,    -1,
    3240,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,  2258,    -1,    -1,    -1,
    1613,    -1,    -1,    -1,    -1,    -1,    -1,    -1,  2539,    -1,
      -1,  2542,    -1,  2544,    -1,    -1,    -1,    -1,  2549,    -1,
      -1,    -1,  3282,  1636,    -1,  3285,  1639,    -1,    -1,  1642,
      -1,  2293,    -1,    -1,    -1,    -1,  1649,  1650,    -1,    -1,
      -1,    -1,  1655,    -1,    -1,  1658,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,  2317,    -1,    -1,    -1,  3319,
      -1,    -1,  1675,    -1,    -1,    -1,    -1,  1680,  2599,    -1,
      -1,  1684,  1533,    -1,    -1,  1688,    -1,  1690,  1691,  1692,
    1693,  1694,  1695,  1696,  1697,  1698,    -1,  1700,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,  1708,  1709,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,  2639,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,  3386,  3387,    -1,    -1,
      -1,    -1,   880,  3393,    -1,    -1,    -1,    -1,    -1,  2401,
      -1,    -1,    -1,    -1,    -1,  2407,    -1,    -1,    -1,    -1,
    1611,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,  2700,
      -1,  2702,    -1,    -1,  1635,    -1,    -1,    -1,    -1,  1640,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,  1660,
    1661,    -1,  1663,    -1,    -1,    -1,    -1,    -1,    -1,  3469,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,  1835,    -1,    -1,    -1,  2757,    -1,  2490,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,  1705,    -1,    -1,    -1,    -1,    -1,
      -1,  2782,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,  1012,    -1,    -1,    -1,    -1,    -1,
    2801,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
    1741,    -1,    -1,    -1,    -1,    -1,    -1,    -1,  2819,  2551,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,  2566,  2567,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,  1930,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,  2593,    -1,    -1,  2596,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,  2883,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,  2899,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,  2910,
      -1,    -1,    -1,    -1,  1845,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,  1857,    -1,    -1,  1860,
      -1,    -1,    -1,    -1,    -1,  2667,  2668,  2669,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,  3676,    -1,    -1,  3679,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,  2691,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,  2703,  3702,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
    2981,  2713,    -1,    -1,  3714,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,  1210,    -1,    -1,    -1,    -1,  3727,    -1,    -1,
    3001,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,  3026,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
    3770,    -1,    -1,    -1,  2776,    -1,  1264,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,  2140,    -1,    -1,
      -1,  3062,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,  1300,    -1,    -1,    -1,  2818,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,  2833,    -1,  2835,    -1,    -1,  3107,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,  2847,    -1,  2849,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,  3148,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,  3886,    -1,  1376,    -1,
      -1,    -1,    -1,    -1,   880,    -1,  2898,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,  1395,    -1,    -1,
    2263,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,  2926,    -1,    -1,  1415,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,   880,    -1,    -1,  2940,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,  1440,    -1,    -1,    -1,    -1,  2959,    -1,    -1,
    2962,    -1,    -1,    -1,    -1,    -1,    -1,    -1,  3239,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,  3978,    -1,
    3980,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,  2346,    -1,    -1,    -1,    -1,  2351,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,  1497,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,  4017,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,  1012,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,  3037,    -1,    -1,    -1,    -1,
    2393,    -1,  2395,  2396,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,  2406,    -1,    -1,  2409,  4057,  2411,  4059,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,  1012,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,  2438,    -1,  2440,    -1,    -1,
      -1,  2444,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,  3390,
      -1,    -1,    -1,  2476,  2477,  2478,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
    2493,    -1,    -1,    -1,    -1,    -1,    -1,    -1,  2349,    -1,
      -1,    -1,  2505,    -1,    -1,    -1,  3427,  2510,    -1,    -1,
      -1,    -1,    -1,  2516,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,  2372,    -1,  2374,    -1,  2376,  2377,  2378,    -1,    -1,
    2381,    -1,    -1,    -1,  2385,    -1,  1674,    -1,    -1,    -1,
      -1,  2392,    -1,  3195,    -1,    -1,  2397,    -1,    -1,    -1,
      -1,    -1,  2403,    -1,    -1,    -1,    -1,  2408,    -1,    -1,
      -1,    -1,  4212,    -1,    -1,    -1,  2417,    -1,    -1,  2572,
    2421,  2422,    -1,  2424,  1210,    -1,    -1,    -1,    -1,    -1,
      -1,  3233,    -1,    -1,    -1,  2436,  3238,    -1,  3240,    -1,
      -1,    -1,  2443,    -1,  2445,  2446,  2447,  2448,  2449,  2450,
    2451,  2452,  2453,  2454,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,  1210,  3537,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,  3548,  1264,    -1,
    3282,  2482,    -1,  3285,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,  1300,    -1,    -1,  3319,    -1,  1264,
      -1,    -1,    -1,    -1,    -1,    -1,  3597,    -1,    -1,    -1,
      -1,  3602,    -1,    -1,    -1,    -1,  3607,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,  1300,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,  4374,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,  3386,  3387,  2587,    -1,    -1,  3660,
    1376,  3393,    -1,    -1,    -1,  1883,    -1,    -1,    -1,  1887,
    1888,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,  1395,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,  3688,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,  1415,
      -1,  1376,    -1,    -1,  4434,    -1,  3707,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
    1395,    -1,    -1,    -1,  1440,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,  3469,    -1,    -1,
    1415,    -1,    -1,   880,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,  3755,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,  1440,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,  1993,    -1,    -1,    -1,    -1,
      -1,  1497,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,  4523,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,  1497,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,  4573,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,  4581,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,  3866,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,  2804,    -1,  1012,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,  2978,    -1,    -1,    -1,    -1,
      -1,  3902,    -1,    -1,    -1,  2988,    -1,    -1,    -1,    -1,
      -1,  2994,    -1,  2996,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,  2142,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,   880,    -1,  3018,  3019,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,  3676,    -1,    -1,  3679,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,  3039,    -1,  1674,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,  3049,    -1,    -1,  3052,
    3702,  3054,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
    3063,    -1,  3714,    -1,    -1,    -1,  3069,    -1,    -1,  3072,
      -1,    -1,    -1,    -1,    -1,  3727,    -1,    -1,  2929,  1674,
      -1,    -1,    -1,  2221,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,  4016,    -1,  3100,    -1,    -1,
      -1,    -1,    -1,  3106,  3107,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,  3770,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,  2977,  3130,    -1,    -1,
      -1,    -1,  2983,  3136,    -1,    -1,    -1,    -1,    -1,  3142,
      -1,    -1,    -1,    -1,    -1,  1012,    -1,    -1,  2999,  3000,
      -1,  3002,    -1,  1210,  3005,  3006,  3007,  3008,  3009,  3010,
    3011,  3012,  3013,  3014,  3015,    -1,    -1,    -1,  2306,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,  3040,
      -1,    -1,  3043,    -1,  3045,    -1,    -1,    -1,    -1,  3050,
    3051,    -1,  4123,    -1,    -1,    -1,    -1,  1264,    -1,    -1,
      -1,    -1,    -1,  3064,  3065,  3066,    -1,  3068,    -1,    -1,
    3071,    -1,    -1,  4144,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,  3886,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,  1300,    -1,    -1,    -1,  1883,    -1,    -1,
      -1,  1887,  1888,    -1,    -1,    -1,    -1,    -1,    -1,  4180,
      -1,    -1,    -1,  3114,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,  3125,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,  1883,    -1,
      -1,    -1,  1887,  1888,    -1,    -1,    -1,  4218,    -1,    -1,
      -1,  4222,  4223,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
    3161,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,  1376,
      -1,    -1,    -1,    -1,    -1,    -1,  3978,    -1,  3980,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,  1395,    -1,
      -1,    -1,    -1,  1210,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,  1993,  1415,    -1,
      -1,    -1,    -1,    -1,    -1,  4017,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
    4301,    -1,    -1,  1440,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,  1264,  1993,    -1,
      -1,  2539,    -1,    -1,  2542,  4057,  2544,  4059,    -1,    -1,
      -1,  2549,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,  3428,  3429,    -1,    -1,    -1,
      -1,    -1,    -1,  1300,    -1,    -1,    -1,    -1,    -1,    -1,
    1497,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,  2599,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,  3487,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,  2639,    -1,    -1,    -1,    -1,  2142,    -1,    -1,  1376,
      -1,    -1,  3363,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,  1395,    -1,
      -1,  3534,  3535,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,  3547,    -1,    -1,  2142,  1415,    -1,
    3553,  3554,    -1,    -1,  3557,    -1,    -1,  3560,    -1,    -1,
    4212,    -1,  2700,    -1,  2702,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,  1440,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,  2221,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,  3597,    -1,    -1,    -1,    -1,  3602,
      -1,    -1,    -1,    -1,  3607,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,  1674,    -1,  2757,
      -1,    -1,    -1,    -1,    -1,    -1,  2221,    -1,    -1,    -1,
    1497,    -1,    -1,    -1,    -1,    -1,    -1,  3488,    -1,  3642,
      -1,  3492,  3493,  3494,  2782,    -1,  3497,    -1,    -1,    -1,
      -1,  3502,  3503,  3504,  3505,  3506,  3507,  3508,  3509,  3510,
    3511,  3512,  3513,  2801,    -1,    -1,    -1,    -1,    -1,    -1,
    2306,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,  2819,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
    3541,  3542,  3543,  3544,    -1,  3546,    -1,    -1,    -1,  3550,
    3551,  3552,    -1,    -1,  3555,    -1,    -1,  3558,    -1,    -1,
      -1,  2306,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,  4374,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,  2883,    -1,    -1,  3599,    -1,
      -1,    -1,    -1,    -1,    -1,  3606,    -1,    -1,    -1,    -1,
      -1,  2899,    -1,    -1,    -1,    -1,    -1,  3618,    -1,    -1,
      -1,    -1,  2910,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,  4434,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,  3808,    -1,  1674,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,  1883,    -1,    -1,    -1,
    1887,  1888,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,  2981,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,  3001,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,  4523,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,  3026,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,  2539,    -1,    -1,  2542,    -1,  2544,    -1,
      -1,    -1,    -1,  2549,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,  4573,    -1,    -1,  3062,  3928,    -1,    -1,    -1,  4581,
      -1,    -1,    -1,    -1,    -1,    -1,  1993,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,  2539,    -1,    -1,  2542,    -1,  2544,
      -1,    -1,    -1,    -1,  2549,    -1,    -1,  3960,    -1,    -1,
    3811,    -1,    -1,  2599,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,  2639,  2599,    -1,    -1,    -1,    -1,    -1,
    3148,    -1,  3863,  3864,    -1,    -1,  1883,    -1,    -1,    -1,
    1887,  1888,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,  3894,  2639,    -1,    -1,  3898,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,  3912,    -1,  3914,  2700,    -1,  2702,    -1,  3919,  3920,
    3921,    -1,    -1,  3924,  3925,  3926,  3927,    -1,  3929,    -1,
      -1,  3932,    -1,    -1,    -1,  2142,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,  3239,    -1,    -1,    -1,  2700,    -1,  2702,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,  2757,    -1,    -1,    -1,    -1,  1993,    -1,    -1,    -1,
      -1,  3982,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,  4146,    -1,    -1,  2782,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,  2757,    -1,  2221,  2801,    -1,    -1,  4171,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,  2819,    -1,    -1,    -1,  2782,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,  2801,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,  2819,    -1,    -1,  4078,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,  2883,    -1,  2306,
      -1,    -1,  3390,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,  2899,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,  2910,  2142,    -1,    -1,  4281,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,  2883,  3427,
      -1,  4142,  4143,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,  2899,    -1,    -1,  4158,  4159,  4160,
      -1,    -1,    -1,    -1,    -1,  2910,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,  4183,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,  2981,    -1,    -1,    -1,  4352,
      -1,    -1,    -1,    -1,  2221,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,  3001,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,  2981,    -1,    -1,    -1,
    3026,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,  3537,
      -1,    -1,    -1,    -1,    -1,    -1,  3001,    -1,    -1,    -1,
    3548,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
    4423,  4424,    -1,    -1,    -1,    -1,  3062,    -1,    -1,    -1,
      -1,  3026,    -1,    -1,    -1,    -1,    -1,    -1,    -1,  2306,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,  4309,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,  3062,    -1,    -1,
      -1,    -1,    -1,    -1,  4325,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,  2539,  4486,    -1,  2542,    -1,  2544,    -1,    -1,
      -1,    -1,  2549,    -1,    -1,    -1,    -1,  4500,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,  3148,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,  3660,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,  2599,    -1,    -1,    -1,    -1,    -1,  4399,    -1,
    3688,    -1,    -1,  3148,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,  4568,    -1,    -1,    -1,  3707,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,  2639,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,  4444,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,  3239,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,  3755,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,  4489,    -1,
      -1,    -1,    -1,  2700,  3239,  2702,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,  2539,    -1,    -1,  2542,    -1,  2544,    -1,    -1,
      -1,    -1,  2549,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,  4545,    -1,    -1,    -1,    -1,    -1,
    2757,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,  2782,    -1,    -1,    -1,    -1,
      -1,    -1,  2599,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,  2801,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,  3390,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,  2819,    -1,  3902,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,  2639,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,  3427,    -1,    -1,    -1,  3390,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,  2883,    -1,    -1,    -1,
      -1,    -1,  3427,  2700,    -1,  2702,    -1,    -1,    -1,    -1,
      -1,    -1,  2899,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,  2910,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,  4016,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
    2757,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,  3537,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,  3548,    -1,    -1,  2782,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,  2981,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,  2801,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,  3537,    -1,  3001,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,  2819,  3548,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,  3026,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,  4123,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,  3062,  4144,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,  2883,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,  3660,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,  2899,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,  4180,  2910,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,  3688,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,  3660,    -1,    -1,    -1,    -1,
      -1,  3707,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
    4218,    -1,    -1,    -1,  4222,  4223,    -1,    -1,    -1,    -1,
      -1,  3148,    -1,  3688,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,  3707,    -1,  2981,    -1,    -1,    -1,    -1,  3755,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,  3001,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,  3026,
    3755,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,  3239,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,  3062,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,  3902,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,  3148,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,  3902,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,  3390,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
    3427,    -1,  3239,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
    4016,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,  4016,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
    3537,    -1,    -1,    -1,    -1,    -1,    -1,  4123,    -1,    -1,
      -1,  3548,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,  4144,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,  3390,    -1,    -1,    -1,    -1,  4123,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,  4180,    -1,    -1,    -1,    -1,  4144,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
    3427,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,  4218,    -1,    -1,  4180,  4222,  4223,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,  3660,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,  4218,    -1,    -1,    -1,  4222,  4223,    -1,
      -1,  3688,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
    3707,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
    3537,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,  3548,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,  3755,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,  3660,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,  3688,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
    3707,    -1,    -1,    -1,    -1,  3902,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,  3755,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,  4016,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,  3902,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,  4123,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,  4144,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,  4180,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,  4016,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,  4218,    -1,    -1,    -1,  4222,  4223,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,  4123,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,  4144,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,  4180,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,     3,     4,     5,     6,
       7,     8,     9,    10,    -1,    -1,    -1,    14,    15,    16,
      17,    18,    19,    20,    21,    22,    23,    24,    25,    -1,
      -1,  4218,    -1,    30,    31,  4222,  4223,    34,    35,    -1,
      37,    38,    39,    40,    41,    42,    43,    44,    45,    46,
      47,    -1,    49,    50,    51,    52,    53,    54,    55,    56,
      57,    58,    59,    60,    -1,    62,    63,    64,    65,    66,
      -1,    68,    -1,    70,    71,    72,    73,    74,    75,    76,
      -1,    78,    79,    80,    81,    82,    83,    -1,    85,    86,
      87,    88,    89,    90,    91,    92,    93,    94,    95,    96,
      97,    98,    99,   100,   101,   102,   103,    -1,   105,    -1,
     107,   108,   109,   110,   111,    -1,   113,   114,   115,   116,
      -1,   118,   119,   120,   121,   122,    -1,   124,   125,   126,
      -1,   128,   129,   130,    -1,   132,   133,   134,   135,   136,
     137,   138,   139,   140,   141,   142,    -1,   144,   145,   146,
     147,    -1,   149,    -1,   151,   152,    -1,   154,   155,   156,
     157,    -1,   159,   160,    -1,   162,    -1,   164,   165,   166,
     167,   168,   169,   170,   171,   172,    -1,   174,   175,   176,
     177,   178,   179,    -1,   181,   182,   183,   184,   185,   186,
     187,   188,   189,    -1,   191,    -1,   193,   194,   195,   196,
     197,   198,   199,   200,   201,   202,    -1,   204,   205,    -1,
     207,   208,   209,   210,   211,    -1,   213,   214,   215,   216,
     217,   218,   219,   220,   221,   222,   223,   224,   225,   226,
     227,   228,   229,   230,   231,   232,   233,   234,   235,   236,
     237,   238,   239,   240,   241,   242,   243,   244,   245,   246,
     247,   248,    -1,   250,    -1,    -1,   253,   254,   255,    -1,
      -1,   258,   259,   260,   261,   262,   263,   264,   265,   266,
     267,   268,   269,   270,    -1,   272,   273,   274,   275,   276,
     277,   278,    -1,   280,   281,   282,   283,   284,   285,   286,
     287,   288,   289,   290,   291,   292,    -1,   294,   295,   296,
     297,   298,   299,   300,   301,   302,   303,   304,    -1,   306,
     307,   308,   309,   310,   311,   312,   313,   314,   315,   316,
     317,   318,   319,    -1,   321,   322,   323,   324,   325,   326,
     327,   328,   329,   330,   331,   332,   333,   334,    -1,   336,
     337,   338,   339,   340,   341,   342,   343,   344,   345,   346,
      -1,   348,   349,    -1,   351,   352,   353,   354,   355,   356,
      -1,   358,   359,    -1,    -1,   362,   363,   364,   365,   366,
     367,   368,   369,   370,   371,   372,   373,    -1,   375,   376,
     377,   378,   379,   380,   381,    -1,   383,   384,   385,   386,
     387,   388,   389,   390,   391,   392,   393,   394,   395,   396,
      -1,    -1,   399,    -1,    -1,   402,   403,   404,   405,   406,
     407,   408,   409,   410,   411,   412,   413,   414,   415,   416,
     417,   418,   419,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,   428,   429,   430,    -1,    -1,    -1,    -1,    -1,    -1,
     437,   438,     3,     4,     5,     6,     7,     8,     9,    10,
      -1,    -1,    -1,    14,    15,    16,    17,    18,    19,    20,
      21,    -1,    23,    24,    25,    -1,    -1,    -1,    -1,    30,
      31,    -1,    -1,    34,    35,    -1,    37,    38,    39,    40,
      41,    42,    43,    44,    45,    46,    47,    -1,    49,    50,
      51,    52,    53,    54,    55,    56,    57,    58,    59,    60,
      -1,    62,    63,    64,    65,    66,    -1,    68,    -1,    70,
      71,    72,    73,    74,    75,    76,    -1,    78,    79,    80,
      81,    82,    83,    -1,    85,    86,    87,    88,    89,    90,
      91,    92,    93,    94,    95,    96,    97,    98,    99,   100,
     101,   102,   103,    -1,   105,    -1,   107,   108,   109,   110,
     111,    -1,   113,   114,   115,    -1,    -1,   118,   119,   120,
     121,   122,    -1,   124,   125,   126,    -1,   128,   129,   130,
      -1,   132,   133,   134,   135,   136,   137,   138,   139,   140,
     141,   142,    -1,   144,   145,   146,   147,    -1,   149,    -1,
     151,   152,    -1,   154,   155,   156,   157,    -1,   159,   160,
      -1,   162,    -1,   164,   165,   166,   167,   168,   169,   170,
     171,   172,    -1,   174,   175,   176,   177,   178,   179,    -1,
     181,   182,   183,   184,   185,   186,   187,   188,   189,    -1,
     191,    -1,   193,   194,   195,   196,   197,   198,   199,   200,
     201,   202,    -1,   204,   205,    -1,   207,   208,   209,   210,
     211,    -1,   213,   214,   215,   216,   217,   218,   219,   220,
     221,   222,   223,   224,   225,   226,   227,   228,   229,   230,
     231,   232,   233,   234,   235,   236,   237,   238,   239,   240,
     241,   242,   243,   244,   245,   246,   247,   248,    -1,   250,
      -1,    -1,   253,   254,   255,    -1,    -1,   258,   259,   260,
     261,   262,   263,   264,   265,   266,   267,   268,   269,   270,
      -1,   272,   273,   274,   275,   276,   277,   278,    -1,   280,
     281,   282,   283,   284,   285,   286,   287,   288,   289,   290,
     291,   292,    -1,   294,   295,   296,   297,   298,   299,   300,
     301,   302,   303,   304,    -1,   306,   307,   308,   309,   310,
     311,   312,   313,   314,   315,   316,   317,   318,   319,    -1,
     321,   322,   323,   324,   325,   326,   327,   328,   329,   330,
     331,   332,   333,   334,    -1,   336,   337,   338,   339,   340,
     341,   342,   343,   344,   345,   346,    -1,   348,   349,    -1,
     351,   352,   353,   354,   355,   356,    -1,   358,   359,    -1,
      -1,   362,   363,   364,   365,   366,   367,   368,   369,   370,
     371,   372,   373,    -1,   375,   376,   377,   378,   379,   380,
     381,    -1,   383,   384,   385,   386,   387,   388,   389,    -1,
     391,   392,   393,   394,   395,   396,    -1,    -1,   399,    -1,
      -1,   402,   403,   404,   405,   406,   407,   408,   409,   410,
     411,   412,   413,   414,   415,   416,   417,   418,   419,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,   428,   429,     3,
      -1,    -1,    -1,    -1,    -1,    -1,   437,   438,    -1,    -1,
      14,    15,    16,    17,    18,    19,    20,    21,    -1,    23,
      24,    25,    -1,    -1,    -1,    -1,    30,    -1,    32,    -1,
      34,    35,    -1,    37,    38,    -1,    40,    41,    42,    43,
      44,    -1,    46,    47,    -1,    49,    50,    51,    52,    53,
      -1,    -1,    56,    57,    58,    59,    60,    -1,    62,    63,
      64,    65,    66,    -1,    -1,    -1,    70,    71,    72,    73,
      -1,    75,    76,    -1,    78,    79,    80,    81,    82,    83,
      -1,    85,    86,    87,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    95,    96,    97,    98,    99,   100,   101,   102,   103,
      -1,   105,    -1,   107,   108,   109,   110,   111,    -1,   113,
     114,   115,    -1,    -1,   118,   119,   120,   121,   122,    -1,
     124,   125,   126,    -1,   128,   129,   130,    -1,   132,   133,
     134,   135,   136,   137,   138,   139,   140,    -1,   142,    -1,
     144,   145,   146,   147,    -1,   149,    -1,   151,    -1,    -1,
     154,   155,   156,   157,    -1,   159,   160,    -1,   162,    -1,
     164,   165,   166,   167,   168,    -1,   170,   171,   172,    -1,
     174,   175,   176,   177,   178,   179,    -1,   181,   182,   183,
     184,   185,   186,   187,   188,   189,    -1,   191,    -1,   193,
      -1,    -1,   196,   197,   198,   199,   200,   201,   202,    -1,
     204,   205,    -1,   207,   208,   209,   210,    -1,    -1,   213,
     214,   215,    -1,    -1,   218,   219,   220,   221,   222,   223,
     224,   225,   226,   227,   228,   229,   230,   231,   232,   233,
     234,   235,   236,    -1,   238,   239,    -1,   241,    -1,   243,
     244,   245,   246,   247,   248,    -1,   250,    -1,    -1,   253,
     254,   255,    -1,    -1,   258,   259,    -1,   261,    -1,   263,
     264,   265,   266,   267,   268,   269,   270,    -1,   272,   273,
     274,   275,   276,   277,   278,    -1,   280,   281,   282,   283,
     284,   285,   286,   287,   288,   289,   290,   291,   292,    -1,
     294,   295,   296,   297,   298,   299,   300,   301,   302,   303,
     304,    -1,   306,   307,   308,   309,   310,   311,   312,   313,
     314,   315,   316,   317,   318,   319,    -1,   321,   322,   323,
     324,   325,    -1,   327,   328,   329,   330,    -1,   332,   333,
     334,    -1,   336,   337,   338,   339,   340,   341,   342,   343,
     344,   345,   346,    -1,   348,   349,    -1,   351,   352,   353,
     354,   355,   356,    -1,   358,   359,    -1,    -1,   362,   363,
     364,   365,    -1,   367,   368,   369,   370,   371,   372,   373,
      -1,    -1,   376,   377,   378,   379,   380,    -1,    -1,   383,
     384,   385,   386,   387,   388,   389,    -1,   391,    -1,   393,
     394,   395,   396,    -1,    -1,   399,    -1,    -1,   402,   403,
     404,   405,   406,   407,   408,   409,   410,   411,   412,   413,
     414,   415,   416,   417,   418,   419,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,     3,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,   438,    14,    15,    16,    17,    18,
      19,    20,    21,    -1,    23,    24,    25,    -1,    -1,    -1,
      -1,    30,    -1,    -1,    -1,    34,    35,    -1,    37,    38,
      39,    40,    41,    42,    -1,    44,    45,    46,    47,    -1,
      49,    50,    51,    52,    53,    -1,    -1,    56,    57,    58,
      59,    60,    -1,    62,    63,    64,    65,    -1,    -1,    68,
      -1,    70,    71,    72,    73,    74,    75,    76,    -1,    78,
      79,    80,    81,    82,    83,    -1,    85,    86,    87,    -1,
      -1,    -1,    91,    -1,    -1,    -1,    95,    96,    97,    98,
      99,   100,   101,   102,   103,    -1,   105,    -1,   107,   108,
     109,   110,   111,    -1,   113,   114,   115,    -1,    -1,   118,
     119,   120,   121,   122,    -1,   124,   125,   126,    -1,   128,
     129,   130,    -1,   132,   133,   134,   135,    -1,   137,   138,
     139,    -1,    -1,   142,    -1,   144,   145,   146,   147,    -1,
     149,    -1,   151,   152,    -1,   154,   155,   156,   157,    -1,
     159,    -1,    -1,   162,    -1,   164,   165,   166,   167,   168,
     169,   170,   171,   172,   173,   174,   175,   176,   177,   178,
     179,    -1,   181,   182,   183,   184,   185,   186,   187,   188,
     189,    -1,   191,    -1,   193,   194,   195,   196,   197,   198,
     199,   200,   201,   202,    -1,   204,   205,    -1,   207,    -1,
     209,   210,   211,    -1,   213,   214,   215,    -1,    -1,   218,
     219,   220,   221,   222,   223,   224,   225,   226,   227,   228,
     229,   230,   231,   232,   233,   234,   235,    -1,    -1,   238,
     239,   240,   241,    -1,    -1,   244,   245,   246,   247,   248,
      -1,   250,    -1,    -1,   253,   254,   255,    -1,    -1,   258,
     259,   260,   261,   262,    -1,   264,   265,   266,   267,   268,
     269,   270,    -1,   272,    -1,   274,    -1,   276,   277,   278,
      -1,   280,   281,   282,   283,   284,   285,   286,   287,   288,
     289,   290,   291,   292,    -1,   294,   295,   296,   297,   298,
     299,   300,   301,   302,   303,   304,    -1,   306,   307,   308,
     309,   310,    -1,   312,   313,   314,   315,   316,   317,   318,
     319,    -1,   321,   322,   323,   324,   325,    -1,   327,   328,
     329,   330,   331,   332,   333,   334,    -1,   336,   337,   338,
     339,   340,   341,   342,   343,   344,   345,    -1,    -1,   348,
     349,    -1,   351,   352,   353,   354,   355,   356,    -1,   358,
     359,    -1,    -1,   362,    -1,   364,    -1,    -1,   367,   368,
     369,   370,   371,   372,   373,    -1,    -1,   376,   377,   378,
     379,   380,    -1,    -1,   383,   384,   385,   386,   387,    -1,
     389,   390,   391,   392,   393,   394,   395,   396,    -1,    -1,
     399,    -1,    -1,   402,   403,   404,   405,   406,   407,    -1,
       3,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   417,   418,
     419,    14,    15,    16,    17,    18,    19,    20,    21,    -1,
      23,    24,    25,    -1,    -1,    -1,    -1,    30,    -1,   438,
      -1,    34,    35,    -1,    37,    38,    39,    40,    41,    42,
      -1,    44,    45,    46,    47,    -1,    49,    50,    51,    52,
      53,    -1,    -1,    56,    57,    58,    59,    60,    -1,    62,
      63,    64,    65,    -1,    -1,    68,    -1,    70,    71,    72,
      73,    74,    75,    76,    -1,    78,    79,    80,    81,    82,
      83,    -1,    85,    86,    87,    -1,    -1,    -1,    91,    -1,
      -1,    -1,    95,    96,    97,    98,    99,   100,   101,   102,
     103,    -1,   105,    -1,   107,   108,   109,   110,   111,    -1,
     113,   114,   115,    -1,    -1,   118,   119,   120,   121,   122,
      -1,   124,   125,   126,    -1,   128,   129,   130,    -1,   132,
     133,   134,   135,    -1,   137,   138,   139,    -1,    -1,   142,
      -1,   144,   145,   146,   147,    -1,   149,    -1,   151,   152,
      -1,   154,   155,   156,   157,    -1,   159,    -1,    -1,   162,
      -1,   164,   165,   166,   167,   168,   169,   170,   171,   172,
     173,   174,   175,   176,   177,   178,   179,    -1,   181,   182,
     183,   184,   185,   186,   187,   188,   189,    -1,   191,    -1,
     193,   194,   195,   196,   197,   198,   199,   200,   201,   202,
      -1,   204,   205,    -1,   207,    -1,   209,   210,   211,    -1,
     213,   214,   215,    -1,    -1,   218,   219,   220,   221,   222,
     223,   224,   225,   226,   227,   228,   229,   230,   231,   232,
     233,   234,   235,    -1,    -1,   238,   239,   240,   241,    -1,
      -1,   244,   245,   246,   247,   248,    -1,   250,    -1,    -1,
     253,   254,   255,    -1,    -1,   258,   259,   260,   261,   262,
      -1,   264,   265,   266,   267,   268,   269,   270,    -1,   272,
      -1,   274,    -1,   276,   277,   278,    -1,   280,   281,   282,
     283,   284,   285,   286,   287,   288,   289,   290,   291,   292,
      -1,   294,   295,   296,   297,   298,   299,   300,   301,   302,
     303,   304,    -1,   306,   307,   308,   309,   310,    -1,   312,
     313,   314,   315,   316,   317,   318,   319,    -1,   321,   322,
     323,   324,   325,    -1,   327,   328,   329,   330,   331,   332,
     333,   334,    -1,   336,   337,   338,   339,   340,   341,   342,
     343,   344,   345,    -1,    -1,   348,   349,    -1,   351,   352,
     353,   354,   355,   356,    -1,   358,   359,    -1,    -1,   362,
      -1,   364,    -1,    -1,   367,   368,   369,   370,   371,   372,
     373,    -1,    -1,   376,   377,   378,   379,   380,    -1,    -1,
     383,   384,   385,   386,   387,    -1,   389,   390,   391,   392,
     393,   394,   395,   396,    -1,    -1,   399,    -1,    -1,   402,
     403,   404,   405,   406,   407,    -1,     3,     4,     5,     6,
       7,     8,     9,    10,   417,   418,   419,    14,    15,    16,
      17,    18,    19,    20,    21,    -1,    23,    24,    25,    -1,
      -1,    -1,    -1,    30,    31,   438,    -1,    34,    35,    -1,
      37,    38,    39,    40,    41,    42,    43,    44,    45,    46,
      47,    48,    49,    50,    51,    52,    53,    54,    55,    56,
      57,    58,    59,    60,    -1,    62,    63,    64,    65,    66,
      -1,    68,    -1,    70,    71,    72,    73,    74,    75,    76,
      -1,    78,    79,    80,    81,    82,    83,    -1,    85,    86,
      87,    88,    89,    90,    91,    92,    93,    94,    95,    96,
      97,    98,    99,   100,   101,   102,   103,    -1,   105,    -1,
     107,   108,   109,   110,   111,    -1,   113,   114,   115,    -1,
      -1,   118,   119,   120,   121,   122,    -1,   124,   125,   126,
      -1,   128,   129,   130,    -1,   132,   133,   134,   135,   136,
     137,   138,   139,   140,   141,   142,    -1,   144,   145,   146,
     147,    -1,   149,    -1,   151,   152,   153,   154,   155,   156,
     157,    -1,   159,   160,    -1,   162,    -1,   164,   165,   166,
     167,   168,   169,   170,   171,   172,    -1,   174,   175,   176,
     177,   178,   179,    -1,   181,   182,   183,   184,   185,   186,
     187,   188,   189,    -1,   191,    -1,   193,   194,   195,   196,
     197,   198,   199,   200,   201,   202,    -1,   204,   205,   206,
     207,   208,   209,   210,   211,    -1,   213,   214,   215,   216,
     217,   218,   219,   220,   221,   222,   223,   224,   225,   226,
     227,   228,   229,   230,   231,   232,   233,   234,   235,   236,
     237,   238,   239,   240,   241,   242,   243,   244,   245,   246,
     247,   248,    -1,   250,    -1,    -1,   253,   254,   255,    -1,
      -1,   258,   259,   260,   261,   262,   263,   264,   265,   266,
     267,   268,   269,   270,    -1,   272,   273,   274,   275,   276,
     277,   278,    -1,   280,   281,   282,   283,   284,   285,   286,
     287,   288,   289,   290,   291,   292,    -1,   294,   295,   296,
     297,   298,   299,   300,   301,   302,   303,   304,    -1,   306,
     307,   308,   309,   310,   311,   312,   313,   314,   315,   316,
     317,   318,   319,    -1,   321,   322,   323,   324,   325,   326,
     327,   328,   329,   330,   331,   332,   333,   334,    -1,   336,
     337,   338,   339,   340,   341,   342,   343,   344,   345,   346,
      -1,   348,   349,    -1,   351,   352,   353,   354,   355,   356,
      -1,   358,   359,    -1,   361,   362,   363,   364,   365,   366,
     367,   368,   369,   370,   371,   372,   373,    -1,   375,   376,
     377,   378,   379,   380,   381,    -1,   383,   384,   385,   386,
     387,   388,   389,    -1,   391,   392,   393,   394,   395,   396,
      -1,    -1,   399,    -1,    -1,   402,   403,   404,   405,   406,
     407,   408,   409,   410,   411,   412,   413,   414,   415,   416,
     417,   418,   419,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,   428,   429,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
     437,     3,     4,     5,     6,     7,     8,     9,    10,    -1,
      -1,    -1,    14,    15,    16,    17,    18,    19,    20,    21,
      -1,    23,    24,    25,    -1,    -1,    -1,    -1,    30,    31,
      -1,    -1,    34,    35,    -1,    37,    38,    39,    40,    41,
      42,    43,    44,    45,    46,    47,    -1,    49,    50,    51,
      52,    53,    54,    55,    56,    57,    58,    59,    60,    -1,
      62,    63,    64,    65,    66,    -1,    68,    -1,    70,    71,
      72,    73,    74,    75,    76,    -1,    78,    79,    80,    81,
      82,    83,    -1,    85,    86,    87,    88,    89,    90,    91,
      92,    93,    94,    95,    96,    97,    98,    99,   100,   101,
     102,   103,    -1,   105,    -1,   107,   108,   109,   110,   111,
      -1,   113,   114,   115,    -1,    -1,   118,   119,   120,   121,
     122,    -1,   124,   125,   126,    -1,   128,   129,   130,    -1,
     132,   133,   134,   135,   136,   137,   138,   139,   140,   141,
     142,    -1,   144,   145,   146,   147,    -1,   149,    -1,   151,
     152,    -1,   154,   155,   156,   157,    -1,   159,   160,    -1,
     162,    -1,   164,   165,   166,   167,   168,   169,   170,   171,
     172,    -1,   174,   175,   176,   177,   178,   179,    -1,   181,
     182,   183,   184,   185,   186,   187,   188,   189,    -1,   191,
      -1,   193,   194,   195,   196,   197,   198,   199,   200,   201,
     202,    -1,   204,   205,    -1,   207,   208,   209,   210,   211,
      -1,   213,   214,   215,   216,   217,   218,   219,   220,   221,
     222,   223,   224,   225,   226,   227,   228,   229,   230,   231,
     232,   233,   234,   235,   236,   237,   238,   239,   240,   241,
     242,   243,   244,   245,   246,   247,   248,    -1,   250,    -1,
      -1,   253,   254,   255,    -1,    -1,   258,   259,   260,   261,
     262,   263,   264,   265,   266,   267,   268,   269,   270,    -1,
     272,   273,   274,   275,   276,   277,   278,    -1,   280,   281,
     282,   283,   284,   285,   286,   287,   288,   289,   290,   291,
     292,    -1,   294,   295,   296,   297,   298,   299,   300,   301,
     302,   303,   304,    -1,   306,   307,   308,   309,   310,   311,
     312,   313,   314,   315,   316,   317,   318,   319,   320,   321,
     322,   323,   324,   325,   326,   327,   328,   329,   330,   331,
     332,   333,   334,    -1,   336,   337,   338,   339,   340,   341,
     342,   343,   344,   345,   346,    -1,   348,   349,   350,   351,
     352,   353,   354,   355,   356,    -1,   358,   359,    -1,    -1,
     362,   363,   364,   365,   366,   367,   368,   369,   370,   371,
     372,   373,    -1,   375,   376,   377,   378,   379,   380,   381,
      -1,   383,   384,   385,   386,   387,   388,   389,    -1,   391,
     392,   393,   394,   395,   396,    -1,    -1,   399,    -1,   401,
     402,   403,   404,   405,   406,   407,   408,   409,   410,   411,
     412,   413,   414,   415,   416,   417,   418,   419,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,   428,   429,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,   437,     3,     4,     5,     6,
       7,     8,     9,    10,    -1,    -1,    -1,    14,    15,    16,
      17,    18,    19,    20,    21,    -1,    23,    24,    25,    -1,
      -1,    -1,    -1,    30,    31,    -1,    -1,    34,    35,    -1,
      37,    38,    39,    40,    41,    42,    43,    44,    45,    46,
      47,    -1,    49,    50,    51,    52,    53,    54,    55,    56,
      57,    58,    59,    60,    -1,    62,    63,    64,    65,    66,
      -1,    68,    -1,    70,    71,    72,    73,    74,    75,    76,
      -1,    78,    79,    80,    81,    82,    83,    -1,    85,    86,
      87,    88,    89,    90,    91,    92,    93,    94,    95,    96,
      97,    98,    99,   100,   101,   102,   103,    -1,   105,    -1,
     107,   108,   109,   110,   111,    -1,   113,   114,   115,    -1,
      -1,   118,   119,   120,   121,   122,    -1,   124,   125,   126,
      -1,   128,   129,   130,    -1,   132,   133,   134,   135,   136,
     137,   138,   139,   140,   141,   142,    -1,   144,   145,   146,
     147,    -1,   149,    -1,   151,   152,    -1,   154,   155,   156,
     157,    -1,   159,   160,    -1,   162,    -1,   164,   165,   166,
     167,   168,   169,   170,   171,   172,    -1,   174,   175,   176,
     177,   178,   179,    -1,   181,   182,   183,   184,   185,   186,
     187,   188,   189,    -1,   191,    -1,   193,   194,   195,   196,
     197,   198,   199,   200,   201,   202,    -1,   204,   205,    -1,
     207,   208,   209,   210,   211,    -1,   213,   214,   215,   216,
     217,   218,   219,   220,   221,   222,   223,   224,   225,   226,
     227,   228,   229,   230,   231,   232,   233,   234,   235,   236,
     237,   238,   239,   240,   241,   242,   243,   244,   245,   246,
     247,   248,    -1,   250,    -1,    -1,   253,   254,   255,    -1,
      -1,   258,   259,   260,   261,   262,   263,   264,   265,   266,
     267,   268,   269,   270,    -1,   272,   273,   274,   275,   276,
     277,   278,    -1,   280,   281,   282,   283,   284,   285,   286,
     287,   288,   289,   290,   291,   292,    -1,   294,   295,   296,
     297,   298,   299,   300,   301,   302,   303,   304,    -1,   306,
     307,   308,   309,   310,   311,   312,   313,   314,   315,   316,
     317,   318,   319,    -1,   321,   322,   323,   324,   325,   326,
     327,   328,   329,   330,   331,   332,   333,   334,    -1,   336,
     337,   338,   339,   340,   341,   342,   343,   344,   345,   346,
      -1,   348,   349,    -1,   351,   352,   353,   354,   355,   356,
      -1,   358,   359,    -1,    -1,   362,   363,   364,   365,   366,
     367,   368,   369,   370,   371,   372,   373,    -1,   375,   376,
     377,   378,   379,   380,   381,    -1,   383,   384,   385,   386,
     387,   388,   389,    -1,   391,   392,   393,   394,   395,   396,
      -1,    -1,   399,    -1,    -1,   402,   403,   404,   405,   406,
     407,   408,   409,   410,   411,   412,   413,   414,   415,   416,
     417,   418,   419,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,   428,   429,    -1,    -1,    -1,    -1,    -1,   435,   436,
     437,     3,     4,     5,     6,     7,     8,     9,    10,    -1,
      -1,    -1,    14,    15,    16,    17,    18,    19,    20,    21,
      -1,    23,    24,    25,    -1,    -1,    -1,    -1,    30,    31,
      -1,    -1,    34,    35,    -1,    37,    38,    39,    40,    41,
      42,    43,    44,    45,    46,    47,    -1,    49,    50,    51,
      52,    53,    54,    55,    56,    57,    58,    59,    60,    -1,
      62,    63,    64,    65,    66,    -1,    68,    -1,    70,    71,
      72,    73,    74,    75,    76,    -1,    78,    79,    80,    81,
      82,    83,    -1,    85,    86,    87,    88,    89,    90,    91,
      92,    93,    94,    95,    96,    97,    98,    99,   100,   101,
     102,   103,    -1,   105,    -1,   107,   108,   109,   110,   111,
      -1,   113,   114,   115,    -1,    -1,   118,   119,   120,   121,
     122,    -1,   124,   125,   126,    -1,   128,   129,   130,    -1,
     132,   133,   134,   135,   136,   137,   138,   139,   140,   141,
     142,    -1,   144,   145,   146,   147,    -1,   149,    -1,   151,
     152,    -1,   154,   155,   156,   157,    -1,   159,   160,    -1,
     162,    -1,   164,   165,   166,   167,   168,   169,   170,   171,
     172,    -1,   174,   175,   176,   177,   178,   179,    -1,   181,
     182,   183,   184,   185,   186,   187,   188,   189,    -1,   191,
      -1,   193,   194,   195,   196,   197,   198,   199,   200,   201,
     202,    -1,   204,   205,    -1,   207,   208,   209,   210,   211,
      -1,   213,   214,   215,   216,   217,   218,   219,   220,   221,
     222,   223,   224,   225,   226,   227,   228,   229,   230,   231,
     232,   233,   234,   235,   236,   237,   238,   239,   240,   241,
     242,   243,   244,   245,   246,   247,   248,    -1,   250,    -1,
      -1,   253,   254,   255,    -1,    -1,   258,   259,   260,   261,
     262,   263,   264,   265,   266,   267,   268,   269,   270,    -1,
     272,   273,   274,   275,   276,   277,   278,    -1,   280,   281,
     282,   283,   284,   285,   286,   287,   288,   289,   290,   291,
     292,    -1,   294,   295,   296,   297,   298,   299,   300,   301,
     302,   303,   304,    -1,   306,   307,   308,   309,   310,   311,
     312,   313,   314,   315,   316,   317,   318,   319,    -1,   321,
     322,   323,   324,   325,   326,   327,   328,   329,   330,   331,
     332,   333,   334,    -1,   336,   337,   338,   339,   340,   341,
     342,   343,   344,   345,   346,    -1,   348,   349,    -1,   351,
     352,   353,   354,   355,   356,    -1,   358,   359,    -1,    -1,
     362,   363,   364,   365,   366,   367,   368,   369,   370,   371,
     372,   373,    -1,   375,   376,   377,   378,   379,   380,   381,
      -1,   383,   384,   385,   386,   387,   388,   389,    -1,   391,
     392,   393,   394,   395,   396,    -1,    -1,   399,    -1,    -1,
     402,   403,   404,   405,   406,   407,   408,   409,   410,   411,
     412,   413,   414,   415,   416,   417,   418,   419,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,   428,   429,   430,    -1,
      -1,    -1,    -1,    -1,    -1,   437,     3,     4,     5,     6,
       7,     8,     9,    10,    -1,    -1,    -1,    14,    15,    16,
      17,    18,    19,    20,    21,    -1,    23,    24,    25,    -1,
      -1,    -1,    -1,    30,    31,    -1,    -1,    34,    35,    -1,
      37,    38,    39,    40,    41,    42,    43,    44,    45,    46,
      47,    -1,    49,    50,    51,    52,    53,    54,    55,    56,
      57,    58,    59,    60,    -1,    62,    63,    64,    65,    66,
      -1,    68,    -1,    70,    71,    72,    73,    74,    75,    76,
      -1,    78,    79,    80,    81,    82,    83,    -1,    85,    86,
      87,    88,    89,    90,    91,    92,    93,    94,    95,    96,
      97,    98,    99,   100,   101,   102,   103,   104,   105,    -1,
     107,   108,   109,   110,   111,    -1,   113,   114,   115,    -1,
      -1,   118,   119,   120,   121,   122,    -1,   124,   125,   126,
      -1,   128,   129,   130,    -1,   132,   133,   134,   135,   136,
     137,   138,   139,   140,   141,   142,    -1,   144,   145,   146,
     147,    -1,   149,    -1,   151,   152,    -1,   154,   155,   156,
     157,    -1,   159,   160,    -1,   162,    -1,   164,   165,   166,
     167,   168,   169,   170,   171,   172,    -1,   174,   175,   176,
     177,   178,   179,    -1,   181,   182,   183,   184,   185,   186,
     187,   188,   189,    -1,   191,    -1,   193,   194,   195,   196,
     197,   198,   199,   200,   201,   202,    -1,   204,   205,    -1,
     207,   208,   209,   210,   211,    -1,   213,   214,   215,   216,
     217,   218,   219,   220,   221,   222,   223,   224,   225,   226,
     227,   228,   229,   230,   231,   232,   233,   234,   235,   236,
     237,   238,   239,   240,   241,   242,   243,   244,   245,   246,
     247,   248,    -1,   250,    -1,    -1,   253,   254,   255,    -1,
      -1,   258,   259,   260,   261,   262,   263,   264,   265,   266,
     267,   268,   269,   270,    -1,   272,   273,   274,   275,   276,
     277,   278,    -1,   280,   281,   282,   283,   284,   285,   286,
     287,   288,   289,   290,   291,   292,    -1,   294,   295,   296,
     297,   298,   299,   300,   301,   302,   303,   304,    -1,   306,
     307,   308,   309,   310,   311,   312,   313,   314,   315,   316,
     317,   318,   319,    -1,   321,   322,   323,   324,   325,   326,
     327,   328,   329,   330,   331,   332,   333,   334,    -1,   336,
     337,   338,   339,   340,   341,   342,   343,   344,   345,   346,
      -1,   348,   349,    -1,   351,   352,   353,   354,   355,   356,
      -1,   358,   359,    -1,    -1,   362,   363,   364,   365,   366,
     367,   368,   369,   370,   371,   372,   373,    -1,   375,   376,
     377,   378,   379,   380,   381,    -1,   383,   384,   385,   386,
     387,   388,   389,    -1,   391,   392,   393,   394,   395,   396,
      -1,    -1,   399,    -1,    -1,   402,   403,   404,   405,   406,
     407,   408,   409,   410,   411,   412,   413,   414,   415,   416,
     417,   418,   419,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,   428,   429,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
     437,     3,     4,     5,     6,     7,     8,     9,    10,    -1,
      -1,    -1,    14,    15,    16,    17,    18,    19,    20,    21,
      22,    23,    24,    25,    -1,    -1,    -1,    -1,    30,    31,
      -1,    -1,    34,    35,    -1,    37,    38,    39,    40,    41,
      42,    43,    44,    45,    46,    47,    -1,    49,    50,    51,
      52,    53,    54,    55,    56,    57,    58,    59,    60,    -1,
      62,    63,    64,    65,    66,    -1,    68,    -1,    70,    71,
      72,    73,    74,    75,    76,    -1,    78,    79,    80,    81,
      82,    83,    -1,    85,    86,    87,    88,    89,    90,    91,
      92,    93,    94,    95,    96,    97,    98,    99,   100,   101,
     102,   103,    -1,   105,    -1,   107,   108,   109,   110,   111,
      -1,   113,   114,   115,    -1,    -1,   118,   119,   120,   121,
     122,    -1,   124,   125,   126,    -1,   128,   129,   130,    -1,
     132,   133,   134,   135,   136,   137,   138,   139,   140,   141,
     142,    -1,   144,   145,   146,   147,    -1,   149,    -1,   151,
     152,    -1,   154,   155,   156,   157,    -1,   159,   160,    -1,
     162,    -1,   164,   165,   166,   167,   168,   169,   170,   171,
     172,    -1,   174,   175,   176,   177,   178,   179,    -1,   181,
     182,   183,   184,   185,   186,   187,   188,   189,    -1,   191,
      -1,   193,   194,   195,   196,   197,   198,   199,   200,   201,
     202,    -1,   204,   205,    -1,   207,   208,   209,   210,   211,
      -1,   213,   214,   215,   216,   217,   218,   219,   220,   221,
     222,   223,   224,   225,   226,   227,   228,   229,   230,   231,
     232,   233,   234,   235,   236,   237,   238,   239,   240,   241,
     242,   243,   244,   245,   246,   247,   248,    -1,   250,    -1,
      -1,   253,   254,   255,    -1,    -1,   258,   259,   260,   261,
     262,   263,   264,   265,   266,   267,   268,   269,   270,    -1,
     272,   273,   274,   275,   276,   277,   278,    -1,   280,   281,
     282,   283,   284,   285,   286,   287,   288,   289,   290,   291,
     292,    -1,   294,   295,   296,   297,   298,   299,   300,   301,
     302,   303,   304,    -1,   306,   307,   308,   309,   310,   311,
     312,   313,   314,   315,   316,   317,   318,   319,    -1,   321,
     322,   323,   324,   325,   326,   327,   328,   329,   330,   331,
     332,   333,   334,    -1,   336,   337,   338,   339,   340,   341,
     342,   343,   344,   345,   346,    -1,   348,   349,    -1,   351,
     352,   353,   354,   355,   356,    -1,   358,   359,    -1,    -1,
     362,   363,   364,   365,   366,   367,   368,   369,   370,   371,
     372,   373,    -1,   375,   376,   377,   378,   379,   380,   381,
      -1,   383,   384,   385,   386,   387,   388,   389,    -1,   391,
     392,   393,   394,   395,   396,    -1,    -1,   399,    -1,    -1,
     402,   403,   404,   405,   406,   407,   408,   409,   410,   411,
     412,   413,   414,   415,   416,   417,   418,   419,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,   428,   429,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,   437,     3,     4,     5,     6,
       7,     8,     9,    10,    -1,    -1,    -1,    14,    15,    16,
      17,    18,    19,    20,    21,    -1,    23,    24,    25,    -1,
      -1,    -1,    -1,    30,    31,    -1,    -1,    34,    35,    -1,
      37,    38,    39,    40,    41,    42,    43,    44,    45,    46,
      47,    -1,    49,    50,    51,    52,    53,    54,    55,    56,
      57,    58,    59,    60,    -1,    62,    63,    64,    65,    66,
      -1,    68,    -1,    70,    71,    72,    73,    74,    75,    76,
      -1,    78,    79,    80,    81,    82,    83,    -1,    85,    86,
      87,    88,    89,    90,    91,    92,    93,    94,    95,    96,
      97,    98,    99,   100,   101,   102,   103,    -1,   105,    -1,
     107,   108,   109,   110,   111,    -1,   113,   114,   115,    -1,
      -1,   118,   119,   120,   121,   122,    -1,   124,   125,   126,
      -1,   128,   129,   130,    -1,   132,   133,   134,   135,   136,
     137,   138,   139,   140,   141,   142,    -1,   144,   145,   146,
     147,    -1,   149,    -1,   151,   152,   153,   154,   155,   156,
     157,    -1,   159,   160,    -1,   162,    -1,   164,   165,   166,
     167,   168,   169,   170,   171,   172,    -1,   174,   175,   176,
     177,   178,   179,    -1,   181,   182,   183,   184,   185,   186,
     187,   188,   189,    -1,   191,    -1,   193,   194,   195,   196,
     197,   198,   199,   200,   201,   202,    -1,   204,   205,    -1,
     207,   208,   209,   210,   211,    -1,   213,   214,   215,   216,
     217,   218,   219,   220,   221,   222,   223,   224,   225,   226,
     227,   228,   229,   230,   231,   232,   233,   234,   235,   236,
     237,   238,   239,   240,   241,   242,   243,   244,   245,   246,
     247,   248,    -1,   250,    -1,    -1,   253,   254,   255,    -1,
      -1,   258,   259,   260,   261,   262,   263,   264,   265,   266,
     267,   268,   269,   270,    -1,   272,   273,   274,   275,   276,
     277,   278,    -1,   280,   281,   282,   283,   284,   285,   286,
     287,   288,   289,   290,   291,   292,    -1,   294,   295,   296,
     297,   298,   299,   300,   301,   302,   303,   304,    -1,   306,
     307,   308,   309,   310,   311,   312,   313,   314,   315,   316,
     317,   318,   319,    -1,   321,   322,   323,   324,   325,   326,
     327,   328,   329,   330,   331,   332,   333,   334,    -1,   336,
     337,   338,   339,   340,   341,   342,   343,   344,   345,   346,
      -1,   348,   349,    -1,   351,   352,   353,   354,   355,   356,
      -1,   358,   359,    -1,    -1,   362,   363,   364,   365,   366,
     367,   368,   369,   370,   371,   372,   373,    -1,   375,   376,
     377,   378,   379,   380,   381,    -1,   383,   384,   385,   386,
     387,   388,   389,    -1,   391,   392,   393,   394,   395,   396,
      -1,    -1,   399,    -1,    -1,   402,   403,   404,   405,   406,
     407,   408,   409,   410,   411,   412,   413,   414,   415,   416,
     417,   418,   419,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,   428,   429,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
     437,     3,     4,     5,     6,     7,     8,     9,    10,    -1,
      -1,    -1,    14,    15,    16,    17,    18,    19,    20,    21,
      -1,    23,    24,    25,    -1,    -1,    -1,    -1,    30,    31,
      -1,    -1,    34,    35,    -1,    37,    38,    39,    40,    41,
      42,    43,    44,    45,    46,    47,    -1,    49,    50,    51,
      52,    53,    54,    55,    56,    57,    58,    59,    60,    -1,
      62,    63,    64,    65,    66,    -1,    68,    -1,    70,    71,
      72,    73,    74,    75,    76,    -1,    78,    79,    80,    81,
      82,    83,    -1,    85,    86,    87,    88,    89,    90,    91,
      92,    93,    94,    95,    96,    97,    98,    99,   100,   101,
     102,   103,    -1,   105,    -1,   107,   108,   109,   110,   111,
      -1,   113,   114,   115,    -1,    -1,   118,   119,   120,   121,
     122,    -1,   124,   125,   126,    -1,   128,   129,   130,    -1,
     132,   133,   134,   135,   136,   137,   138,   139,   140,   141,
     142,    -1,   144,   145,   146,   147,    -1,   149,    -1,   151,
     152,    -1,   154,   155,   156,   157,    -1,   159,   160,    -1,
     162,    -1,   164,   165,   166,   167,   168,   169,   170,   171,
     172,    -1,   174,   175,   176,   177,   178,   179,    -1,   181,
     182,   183,   184,   185,   186,   187,   188,   189,    -1,   191,
      -1,   193,   194,   195,   196,   197,   198,   199,   200,   201,
     202,    -1,   204,   205,    -1,   207,   208,   209,   210,   211,
      -1,   213,   214,   215,   216,   217,   218,   219,   220,   221,
     222,   223,   224,   225,   226,   227,   228,   229,   230,   231,
     232,   233,   234,   235,   236,   237,   238,   239,   240,   241,
     242,   243,   244,   245,   246,   247,   248,    -1,   250,    -1,
      -1,   253,   254,   255,    -1,    -1,   258,   259,   260,   261,
     262,   263,   264,   265,   266,   267,   268,   269,   270,    -1,
     272,   273,   274,   275,   276,   277,   278,    -1,   280,   281,
     282,   283,   284,   285,   286,   287,   288,   289,   290,   291,
     292,    -1,   294,   295,   296,   297,   298,   299,   300,   301,
     302,   303,   304,    -1,   306,   307,   308,   309,   310,   311,
     312,   313,   314,   315,   316,   317,   318,   319,    -1,   321,
     322,   323,   324,   325,   326,   327,   328,   329,   330,   331,
     332,   333,   334,    -1,   336,   337,   338,   339,   340,   341,
     342,   343,   344,   345,   346,    -1,   348,   349,    -1,   351,
     352,   353,   354,   355,   356,    -1,   358,   359,    -1,    -1,
     362,   363,   364,   365,   366,   367,   368,   369,   370,   371,
     372,   373,    -1,   375,   376,   377,   378,   379,   380,   381,
      -1,   383,   384,   385,   386,   387,   388,   389,   390,   391,
     392,   393,   394,   395,   396,    -1,    -1,   399,    -1,    -1,
     402,   403,   404,   405,   406,   407,   408,   409,   410,   411,
     412,   413,   414,   415,   416,   417,   418,   419,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,   428,   429,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,   437,     3,     4,     5,     6,
       7,     8,     9,    10,    -1,    -1,    -1,    14,    15,    16,
      17,    18,    19,    20,    21,    -1,    23,    24,    25,    -1,
      -1,    -1,    -1,    30,    31,    -1,    -1,    34,    35,    -1,
      37,    38,    39,    40,    41,    42,    43,    44,    45,    46,
      47,    -1,    49,    50,    51,    52,    53,    54,    55,    56,
      57,    58,    59,    60,    -1,    62,    63,    64,    65,    66,
      -1,    68,    -1,    70,    71,    72,    73,    74,    75,    76,
      -1,    78,    79,    80,    81,    82,    83,    -1,    85,    86,
      87,    88,    89,    90,    91,    92,    93,    94,    95,    96,
      97,    98,    99,   100,   101,   102,   103,    -1,   105,    -1,
     107,   108,   109,   110,   111,    -1,   113,   114,   115,    -1,
      -1,   118,   119,   120,   121,   122,    -1,   124,   125,   126,
      -1,   128,   129,   130,    -1,   132,   133,   134,   135,   136,
     137,   138,   139,   140,   141,   142,    -1,   144,   145,   146,
     147,    -1,   149,    -1,   151,   152,    -1,   154,   155,   156,
     157,    -1,   159,   160,    -1,   162,    -1,   164,   165,   166,
     167,   168,   169,   170,   171,   172,    -1,   174,   175,   176,
     177,   178,   179,    -1,   181,   182,   183,   184,   185,   186,
     187,   188,   189,    -1,   191,    -1,   193,   194,   195,   196,
     197,   198,   199,   200,   201,   202,    -1,   204,   205,    -1,
     207,   208,   209,   210,   211,    -1,   213,   214,   215,   216,
     217,   218,   219,   220,   221,   222,   223,   224,   225,   226,
     227,   228,   229,   230,   231,   232,   233,   234,   235,   236,
     237,   238,   239,   240,   241,   242,   243,   244,   245,   246,
     247,   248,    -1,   250,    -1,    -1,   253,   254,   255,    -1,
      -1,   258,   259,   260,   261,   262,   263,   264,   265,   266,
     267,   268,   269,   270,    -1,   272,   273,   274,   275,   276,
     277,   278,    -1,   280,   281,   282,   283,   284,   285,   286,
     287,   288,   289,   290,   291,   292,    -1,   294,   295,   296,
     297,   298,   299,   300,   301,   302,   303,   304,    -1,   306,
     307,   308,   309,   310,   311,   312,   313,   314,   315,   316,
     317,   318,   319,    -1,   321,   322,   323,   324,   325,   326,
     327,   328,   329,   330,   331,   332,   333,   334,    -1,   336,
     337,   338,   339,   340,   341,   342,   343,   344,   345,   346,
      -1,   348,   349,    -1,   351,   352,   353,   354,   355,   356,
      -1,   358,   359,    -1,    -1,   362,   363,   364,   365,   366,
     367,   368,   369,   370,   371,   372,   373,    -1,   375,   376,
     377,   378,   379,   380,   381,    -1,   383,   384,   385,   386,
     387,   388,   389,    -1,   391,   392,   393,   394,   395,   396,
      -1,    -1,   399,    -1,    -1,   402,   403,   404,   405,   406,
     407,   408,   409,   410,   411,   412,   413,   414,   415,   416,
     417,   418,   419,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,   428,   429,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
     437,     3,     4,     5,     6,     7,     8,     9,    10,    -1,
      -1,    -1,    14,    15,    16,    17,    18,    19,    20,    21,
      -1,    23,    24,    25,    -1,    -1,    -1,    -1,    30,    31,
      -1,    -1,    34,    35,    -1,    37,    38,    39,    40,    41,
      42,    43,    44,    45,    46,    47,    -1,    49,    50,    51,
      52,    53,    54,    55,    56,    57,    58,    59,    60,    -1,
      62,    63,    64,    65,    66,    -1,    68,    -1,    70,    71,
      72,    73,    74,    75,    76,    -1,    78,    79,    80,    81,
      82,    83,    -1,    85,    86,    87,    88,    89,    90,    91,
      92,    93,    94,    95,    96,    97,    98,    99,   100,   101,
     102,   103,    -1,   105,    -1,   107,   108,   109,   110,   111,
      -1,   113,   114,   115,    -1,    -1,   118,   119,   120,   121,
     122,    -1,   124,   125,   126,    -1,   128,   129,   130,    -1,
     132,   133,   134,   135,   136,   137,   138,   139,   140,   141,
     142,    -1,   144,   145,   146,   147,    -1,   149,    -1,   151,
     152,    -1,   154,   155,   156,   157,    -1,   159,   160,    -1,
     162,    -1,   164,   165,   166,   167,   168,   169,   170,   171,
     172,    -1,   174,   175,   176,   177,   178,   179,    -1,   181,
     182,   183,   184,   185,   186,   187,   188,   189,    -1,   191,
      -1,   193,   194,   195,   196,   197,   198,   199,   200,   201,
     202,    -1,   204,   205,    -1,   207,   208,   209,   210,   211,
      -1,   213,   214,   215,   216,   217,   218,   219,   220,   221,
     222,   223,   224,   225,   226,   227,   228,   229,   230,   231,
     232,   233,   234,   235,   236,   237,   238,   239,   240,   241,
     242,   243,   244,   245,   246,   247,   248,    -1,   250,    -1,
      -1,   253,   254,   255,    -1,    -1,   258,   259,   260,   261,
     262,   263,   264,   265,   266,   267,   268,   269,   270,    -1,
     272,   273,   274,   275,   276,   277,   278,    -1,   280,   281,
     282,   283,   284,   285,   286,   287,   288,   289,   290,   291,
     292,    -1,   294,   295,   296,   297,   298,   299,   300,   301,
     302,   303,   304,    -1,   306,   307,   308,   309,   310,   311,
     312,   313,   314,   315,   316,   317,   318,   319,    -1,   321,
     322,   323,   324,   325,   326,   327,   328,   329,   330,   331,
     332,   333,   334,    -1,   336,   337,   338,   339,   340,   341,
     342,   343,   344,   345,   346,    -1,   348,   349,    -1,   351,
     352,   353,   354,   355,   356,    -1,   358,   359,    -1,    -1,
     362,   363,   364,   365,   366,   367,   368,   369,   370,   371,
     372,   373,    -1,   375,   376,   377,   378,   379,   380,   381,
      -1,   383,   384,   385,   386,   387,   388,   389,    -1,   391,
     392,   393,   394,   395,   396,    -1,    -1,   399,    -1,    -1,
     402,   403,   404,   405,   406,   407,   408,   409,   410,   411,
     412,   413,   414,   415,   416,   417,   418,   419,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,   428,   429,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,   437,     3,     4,     5,     6,
       7,     8,     9,    10,    -1,    -1,    -1,    14,    15,    16,
      17,    18,    19,    20,    21,    -1,    23,    24,    25,    -1,
      -1,    -1,    -1,    30,    31,    -1,    -1,    34,    35,    -1,
      37,    38,    39,    40,    41,    42,    43,    44,    45,    46,
      47,    -1,    49,    50,    51,    52,    53,    54,    55,    56,
      57,    58,    59,    60,    -1,    62,    63,    64,    65,    66,
      -1,    68,    -1,    70,    71,    72,    73,    74,    75,    76,
      -1,    78,    79,    80,    81,    82,    83,    -1,    85,    86,
      87,    88,    89,    90,    91,    92,    93,    94,    95,    96,
      97,    98,    99,   100,   101,   102,   103,    -1,   105,    -1,
     107,   108,   109,   110,   111,    -1,   113,   114,   115,    -1,
      -1,   118,   119,   120,   121,   122,    -1,   124,   125,   126,
      -1,   128,   129,   130,    -1,   132,   133,   134,   135,   136,
     137,   138,   139,   140,   141,   142,    -1,   144,   145,   146,
     147,    -1,   149,    -1,   151,   152,    -1,   154,   155,   156,
     157,    -1,   159,   160,    -1,   162,    -1,   164,   165,   166,
     167,   168,   169,   170,   171,   172,    -1,   174,   175,   176,
     177,   178,   179,    -1,   181,   182,   183,   184,   185,   186,
     187,   188,   189,    -1,   191,    -1,   193,   194,   195,   196,
     197,   198,   199,   200,   201,   202,    -1,   204,   205,    -1,
     207,   208,   209,   210,   211,    -1,   213,   214,   215,   216,
     217,   218,   219,   220,   221,   222,   223,   224,   225,   226,
     227,   228,   229,   230,   231,   232,   233,   234,   235,   236,
     237,   238,   239,   240,   241,   242,   243,   244,   245,   246,
     247,   248,    -1,   250,    -1,    -1,   253,   254,   255,    -1,
      -1,   258,   259,   260,   261,   262,   263,   264,   265,   266,
     267,   268,   269,   270,    -1,   272,   273,   274,   275,   276,
     277,   278,    -1,   280,   281,   282,   283,   284,   285,   286,
     287,   288,   289,   290,   291,   292,    -1,   294,   295,   296,
     297,   298,   299,   300,   301,   302,   303,   304,    -1,   306,
     307,   308,   309,   310,   311,   312,   313,   314,   315,   316,
     317,   318,   319,    -1,   321,   322,   323,   324,   325,   326,
     327,   328,   329,   330,   331,   332,   333,   334,    -1,   336,
     337,   338,   339,   340,   341,   342,   343,   344,   345,   346,
      -1,   348,   349,    -1,   351,   352,   353,   354,   355,   356,
      -1,   358,   359,    -1,    -1,   362,   363,   364,   365,   366,
     367,   368,   369,   370,   371,   372,   373,    -1,   375,   376,
     377,   378,   379,   380,   381,    -1,   383,   384,   385,   386,
     387,   388,   389,    -1,   391,   392,   393,   394,   395,   396,
      -1,    -1,   399,    -1,    -1,   402,   403,   404,   405,   406,
     407,   408,   409,   410,   411,   412,   413,   414,   415,   416,
     417,   418,   419,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,   428,   429,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
     437,     3,     4,     5,     6,     7,     8,     9,    10,    -1,
      -1,    -1,    14,    15,    16,    17,    18,    19,    20,    21,
      -1,    23,    24,    25,    -1,    -1,    -1,    -1,    30,    31,
      -1,    -1,    34,    35,    -1,    37,    38,    39,    40,    41,
      42,    43,    44,    45,    46,    47,    -1,    49,    50,    51,
      52,    53,    54,    55,    56,    57,    58,    59,    60,    -1,
      62,    63,    64,    65,    66,    -1,    68,    -1,    70,    71,
      72,    73,    74,    75,    76,    -1,    78,    79,    80,    81,
      82,    83,    -1,    85,    86,    87,    88,    89,    90,    91,
      92,    93,    94,    95,    96,    97,    98,    99,   100,   101,
     102,   103,    -1,   105,    -1,   107,   108,   109,   110,   111,
      -1,   113,   114,   115,    -1,    -1,   118,   119,   120,   121,
     122,    -1,   124,   125,   126,    -1,   128,   129,   130,    -1,
     132,   133,   134,   135,   136,   137,   138,   139,   140,   141,
     142,    -1,   144,   145,   146,   147,    -1,   149,    -1,   151,
     152,    -1,   154,   155,   156,   157,    -1,   159,   160,    -1,
     162,    -1,   164,   165,   166,   167,   168,   169,   170,   171,
     172,    -1,   174,   175,   176,   177,   178,   179,    -1,   181,
     182,   183,   184,   185,   186,   187,   188,   189,    -1,   191,
      -1,   193,   194,   195,   196,   197,   198,   199,   200,   201,
     202,    -1,   204,   205,    -1,   207,   208,   209,   210,   211,
      -1,   213,   214,   215,   216,   217,   218,   219,   220,   221,
     222,   223,   224,   225,   226,   227,   228,   229,   230,   231,
     232,   233,   234,   235,   236,   237,   238,   239,   240,   241,
     242,   243,   244,   245,   246,   247,   248,    -1,   250,    -1,
      -1,   253,   254,   255,    -1,    -1,   258,   259,   260,   261,
     262,   263,   264,   265,   266,   267,   268,   269,   270,    -1,
     272,   273,   274,   275,   276,   277,   278,    -1,   280,   281,
     282,   283,   284,   285,   286,   287,   288,   289,   290,   291,
     292,    -1,   294,   295,   296,   297,   298,   299,   300,   301,
     302,   303,   304,    -1,   306,   307,   308,   309,   310,   311,
     312,   313,   314,   315,   316,   317,   318,   319,    -1,   321,
     322,   323,   324,   325,   326,   327,   328,   329,   330,   331,
     332,   333,   334,    -1,   336,   337,   338,   339,   340,   341,
     342,   343,   344,   345,   346,    -1,   348,   349,    -1,   351,
     352,   353,   354,   355,   356,    -1,   358,   359,    -1,    -1,
     362,   363,   364,   365,   366,   367,   368,   369,   370,   371,
     372,   373,    -1,   375,   376,   377,   378,   379,   380,   381,
      -1,   383,   384,   385,   386,   387,   388,   389,    -1,   391,
     392,   393,   394,   395,   396,    -1,    -1,   399,    -1,    -1,
     402,   403,   404,   405,   406,   407,   408,   409,   410,   411,
     412,   413,   414,   415,   416,   417,   418,   419,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,   428,   429,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,   437,     3,     4,     5,     6,
       7,     8,     9,    10,    -1,    -1,    -1,    14,    15,    16,
      17,    18,    19,    20,    21,    -1,    23,    24,    25,    -1,
      -1,    -1,    -1,    30,    31,    -1,    -1,    34,    35,    -1,
      37,    38,    39,    40,    41,    42,    43,    44,    45,    46,
      47,    -1,    49,    50,    51,    52,    53,    54,    55,    56,
      57,    58,    59,    60,    -1,    62,    63,    64,    65,    66,
      -1,    68,    -1,    70,    71,    72,    73,    74,    75,    76,
      -1,    78,    79,    80,    81,    82,    83,    -1,    85,    86,
      87,    88,    89,    90,    91,    92,    93,    94,    95,    96,
      97,    98,    99,   100,   101,   102,   103,    -1,   105,    -1,
     107,   108,   109,   110,   111,    -1,   113,   114,   115,    -1,
      -1,   118,   119,   120,   121,   122,    -1,   124,   125,   126,
      -1,   128,   129,   130,    -1,   132,   133,   134,   135,   136,
     137,   138,   139,   140,   141,   142,    -1,   144,   145,   146,
     147,    -1,   149,    -1,   151,   152,    -1,   154,   155,   156,
     157,    -1,   159,   160,    -1,   162,    -1,   164,   165,   166,
     167,   168,   169,   170,   171,   172,    -1,   174,   175,   176,
     177,   178,   179,    -1,   181,   182,   183,   184,   185,   186,
     187,   188,   189,    -1,   191,    -1,   193,   194,   195,   196,
     197,   198,   199,   200,   201,   202,    -1,   204,   205,    -1,
     207,   208,   209,   210,   211,    -1,   213,   214,   215,   216,
     217,   218,   219,   220,   221,   222,   223,   224,   225,   226,
     227,   228,   229,   230,   231,   232,   233,   234,   235,   236,
     237,   238,   239,   240,   241,   242,   243,   244,   245,   246,
     247,   248,    -1,   250,    -1,    -1,   253,   254,   255,    -1,
      -1,   258,   259,   260,   261,   262,   263,   264,   265,   266,
     267,   268,   269,   270,    -1,   272,   273,   274,   275,   276,
     277,   278,    -1,   280,   281,   282,   283,   284,   285,   286,
     287,   288,   289,   290,   291,   292,    -1,   294,   295,   296,
     297,   298,   299,   300,   301,   302,   303,   304,    -1,   306,
     307,   308,   309,   310,   311,   312,   313,   314,   315,   316,
     317,   318,   319,    -1,   321,   322,   323,   324,   325,   326,
     327,   328,   329,   330,   331,   332,   333,   334,    -1,   336,
     337,   338,   339,   340,   341,   342,   343,   344,   345,   346,
      -1,   348,   349,    -1,   351,   352,   353,   354,   355,   356,
      -1,   358,   359,    -1,    -1,   362,   363,   364,   365,   366,
     367,   368,   369,   370,   371,   372,   373,    -1,   375,   376,
     377,   378,   379,   380,   381,    -1,   383,   384,   385,   386,
     387,   388,   389,    -1,   391,   392,   393,   394,   395,   396,
      -1,    -1,   399,    -1,    -1,   402,   403,   404,   405,   406,
     407,   408,   409,   410,   411,   412,   413,   414,   415,   416,
     417,   418,   419,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,   428,   429,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
     437,     3,     4,     5,     6,     7,     8,     9,    10,    -1,
      -1,    -1,    14,    15,    16,    17,    18,    19,    20,    21,
      -1,    23,    24,    25,    -1,    -1,    -1,    -1,    30,    31,
      -1,    -1,    34,    35,    -1,    37,    38,    39,    40,    41,
      42,    43,    44,    45,    46,    47,    -1,    49,    50,    51,
      52,    53,    54,    55,    56,    57,    58,    59,    60,    -1,
      62,    63,    64,    65,    66,    -1,    68,    -1,    70,    71,
      72,    73,    74,    75,    76,    -1,    78,    79,    80,    81,
      82,    83,    -1,    85,    86,    87,    88,    89,    90,    91,
      92,    93,    94,    95,    96,    97,    98,    99,   100,   101,
     102,   103,    -1,   105,    -1,   107,   108,   109,   110,   111,
      -1,   113,   114,   115,    -1,    -1,   118,   119,   120,   121,
     122,    -1,   124,   125,   126,    -1,   128,   129,   130,    -1,
     132,   133,   134,   135,   136,   137,   138,   139,   140,   141,
     142,    -1,   144,   145,   146,   147,    -1,   149,    -1,   151,
     152,    -1,   154,   155,   156,   157,    -1,   159,   160,    -1,
     162,    -1,   164,   165,   166,   167,   168,   169,   170,   171,
     172,    -1,   174,   175,   176,   177,   178,   179,    -1,   181,
     182,   183,   184,   185,   186,   187,   188,   189,    -1,   191,
      -1,   193,   194,   195,   196,   197,   198,   199,   200,   201,
     202,    -1,   204,   205,    -1,   207,   208,   209,   210,   211,
      -1,   213,   214,   215,   216,   217,   218,   219,   220,   221,
     222,   223,   224,   225,   226,   227,   228,   229,   230,   231,
     232,   233,   234,   235,   236,   237,   238,   239,   240,   241,
     242,   243,   244,   245,   246,   247,   248,    -1,   250,    -1,
      -1,   253,   254,   255,    -1,    -1,   258,   259,   260,   261,
     262,   263,   264,   265,   266,   267,   268,   269,   270,    -1,
     272,   273,   274,   275,   276,   277,   278,    -1,   280,   281,
     282,   283,   284,   285,   286,   287,   288,   289,   290,   291,
     292,    -1,   294,   295,   296,   297,   298,   299,   300,   301,
     302,   303,   304,    -1,   306,   307,   308,   309,   310,   311,
     312,   313,   314,   315,   316,   317,   318,   319,    -1,   321,
     322,   323,   324,   325,   326,   327,   328,   329,   330,   331,
     332,   333,   334,    -1,   336,   337,   338,   339,   340,   341,
     342,   343,   344,   345,   346,    -1,   348,   349,    -1,   351,
     352,   353,   354,   355,   356,    -1,   358,   359,    -1,    -1,
     362,   363,   364,   365,   366,   367,   368,   369,   370,   371,
     372,   373,    -1,   375,   376,   377,   378,   379,   380,   381,
      -1,   383,   384,   385,   386,   387,   388,   389,    -1,   391,
     392,   393,   394,   395,   396,    -1,    -1,   399,    -1,    -1,
     402,   403,   404,   405,   406,   407,   408,   409,   410,   411,
     412,   413,   414,   415,   416,   417,   418,   419,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,   428,   429,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,   437,     3,     4,     5,     6,
       7,     8,     9,    10,    -1,    -1,    -1,    14,    15,    16,
      17,    18,    19,    20,    21,    -1,    23,    24,    25,    -1,
      -1,    -1,    -1,    30,    31,    -1,    -1,    34,    35,    -1,
      37,    38,    39,    40,    41,    42,    43,    44,    45,    46,
      47,    -1,    49,    50,    51,    52,    53,    54,    55,    56,
      57,    58,    59,    60,    -1,    62,    63,    64,    65,    66,
      -1,    68,    -1,    70,    71,    72,    73,    74,    75,    76,
      -1,    78,    79,    80,    81,    82,    83,    -1,    85,    86,
      87,    88,    89,    90,    91,    92,    93,    94,    95,    96,
      97,    98,    99,   100,   101,   102,   103,    -1,   105,    -1,
     107,   108,   109,   110,   111,    -1,   113,   114,   115,    -1,
      -1,   118,   119,   120,   121,   122,    -1,   124,   125,   126,
      -1,   128,   129,   130,    -1,   132,   133,   134,   135,   136,
     137,   138,   139,   140,   141,   142,    -1,   144,   145,   146,
     147,    -1,   149,    -1,   151,   152,    -1,   154,   155,   156,
     157,    -1,   159,   160,    -1,   162,    -1,   164,   165,   166,
     167,   168,   169,   170,   171,   172,    -1,   174,   175,   176,
     177,   178,   179,    -1,   181,   182,   183,   184,   185,   186,
     187,   188,   189,    -1,   191,    -1,   193,   194,   195,   196,
     197,   198,   199,   200,   201,   202,    -1,   204,   205,    -1,
     207,   208,   209,   210,   211,    -1,   213,   214,   215,   216,
     217,   218,   219,   220,   221,   222,   223,   224,   225,   226,
     227,   228,   229,   230,   231,   232,   233,   234,   235,   236,
      -1,   238,   239,   240,   241,   242,   243,   244,   245,   246,
     247,   248,    -1,   250,    -1,    -1,   253,   254,   255,    -1,
      -1,   258,   259,   260,   261,   262,   263,   264,   265,   266,
     267,   268,   269,   270,    -1,   272,   273,   274,   275,   276,
     277,   278,    -1,   280,   281,   282,   283,   284,   285,   286,
     287,   288,   289,   290,   291,   292,    -1,   294,   295,   296,
     297,   298,   299,   300,   301,   302,   303,   304,    -1,   306,
     307,   308,   309,   310,   311,   312,   313,   314,   315,   316,
     317,   318,   319,    -1,   321,   322,   323,   324,   325,   326,
     327,   328,   329,   330,   331,   332,   333,   334,    -1,   336,
     337,   338,   339,   340,   341,   342,   343,   344,   345,   346,
      -1,   348,   349,    -1,   351,   352,   353,   354,   355,   356,
      -1,   358,   359,    -1,    -1,   362,   363,   364,   365,   366,
     367,   368,   369,   370,   371,   372,   373,    -1,    -1,   376,
     377,   378,   379,   380,   381,    -1,   383,   384,   385,   386,
     387,   388,   389,    -1,   391,   392,   393,   394,   395,   396,
      -1,    -1,   399,    -1,    -1,   402,   403,   404,   405,   406,
     407,   408,   409,   410,   411,   412,   413,   414,   415,   416,
     417,   418,   419,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,   428,   429,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
     437,     3,     4,     5,     6,     7,     8,     9,    10,    -1,
      -1,    -1,    14,    15,    16,    17,    18,    19,    20,    21,
      -1,    23,    24,    25,    -1,    -1,    -1,    -1,    30,    31,
      -1,    -1,    34,    35,    -1,    37,    38,    39,    40,    41,
      42,    43,    44,    45,    46,    47,    -1,    49,    50,    51,
      52,    53,    54,    55,    56,    57,    58,    59,    60,    -1,
      62,    63,    64,    65,    66,    -1,    68,    -1,    70,    71,
      72,    73,    74,    75,    76,    -1,    78,    79,    80,    81,
      82,    83,    -1,    85,    86,    87,    88,    89,    90,    91,
      92,    93,    94,    95,    96,    97,    98,    99,   100,   101,
     102,   103,    -1,   105,    -1,   107,   108,   109,   110,   111,
      -1,   113,   114,   115,    -1,    -1,   118,   119,   120,   121,
     122,    -1,   124,   125,   126,    -1,   128,   129,   130,    -1,
     132,   133,   134,   135,   136,   137,   138,   139,   140,   141,
     142,    -1,   144,   145,   146,   147,    -1,   149,    -1,   151,
     152,    -1,   154,   155,   156,   157,    -1,   159,   160,    -1,
     162,    -1,   164,   165,   166,   167,   168,    -1,   170,   171,
     172,    -1,   174,   175,   176,   177,   178,   179,    -1,   181,
     182,   183,   184,   185,   186,   187,   188,   189,    -1,   191,
      -1,   193,   194,   195,   196,   197,   198,   199,   200,   201,
     202,    -1,   204,   205,    -1,   207,   208,   209,   210,    -1,
      -1,   213,   214,   215,   216,   217,   218,   219,   220,   221,
     222,   223,   224,   225,   226,   227,   228,   229,   230,   231,
     232,   233,   234,   235,   236,    -1,   238,   239,   240,   241,
     242,   243,   244,   245,   246,   247,   248,    -1,   250,    -1,
      -1,   253,   254,   255,    -1,    -1,   258,   259,   260,   261,
     262,   263,   264,   265,   266,   267,   268,   269,   270,    -1,
     272,   273,   274,   275,   276,   277,   278,    -1,   280,   281,
     282,   283,   284,   285,   286,   287,   288,   289,   290,   291,
     292,    -1,   294,   295,   296,   297,   298,   299,   300,   301,
     302,   303,   304,    -1,   306,   307,   308,   309,   310,   311,
     312,   313,   314,   315,   316,   317,   318,   319,    -1,   321,
     322,   323,   324,   325,   326,   327,   328,   329,   330,    -1,
     332,   333,   334,    -1,   336,   337,   338,   339,   340,   341,
     342,   343,   344,   345,   346,    -1,   348,   349,    -1,   351,
     352,   353,   354,   355,   356,    -1,   358,   359,    -1,    -1,
     362,   363,   364,   365,   366,   367,   368,   369,   370,   371,
     372,   373,    -1,   375,   376,   377,   378,   379,   380,   381,
      -1,   383,   384,   385,   386,   387,   388,   389,    -1,   391,
     392,   393,   394,   395,   396,    -1,    -1,   399,    -1,    -1,
     402,   403,   404,   405,   406,   407,   408,   409,   410,   411,
     412,   413,   414,   415,   416,   417,   418,   419,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,   428,   429,    -1,    -1,
       3,     4,     5,     6,     7,   437,     9,    10,    -1,    -1,
      -1,    14,    15,    16,    17,    18,    19,    20,    21,    -1,
      23,    24,    25,    -1,    -1,    -1,    -1,    30,    31,    -1,
      -1,    34,    35,    -1,    37,    38,    39,    40,    41,    42,
      43,    44,    45,    46,    47,    -1,    49,    50,    51,    52,
      53,    54,    55,    56,    57,    58,    59,    60,    -1,    62,
      63,    64,    65,    66,    -1,    68,    -1,    70,    71,    72,
      73,    74,    75,    76,    -1,    78,    79,    80,    81,    82,
      83,    -1,    85,    86,    87,    88,    89,    90,    91,    92,
      93,    94,    95,    96,    97,    98,    99,   100,   101,   102,
     103,    -1,   105,    -1,   107,   108,   109,   110,   111,    -1,
     113,   114,   115,    -1,    -1,   118,   119,   120,   121,   122,
      -1,   124,   125,   126,    -1,   128,   129,   130,    -1,   132,
     133,   134,   135,   136,   137,   138,   139,   140,   141,   142,
      -1,   144,   145,   146,   147,    -1,   149,    -1,   151,   152,
      -1,   154,   155,   156,   157,    -1,   159,   160,    -1,   162,
      -1,   164,   165,   166,   167,   168,   169,   170,   171,   172,
      -1,   174,   175,   176,   177,   178,   179,    -1,   181,   182,
     183,   184,   185,   186,   187,   188,   189,    -1,   191,    -1,
     193,   194,   195,   196,   197,   198,   199,   200,   201,   202,
      -1,   204,   205,    -1,   207,   208,   209,   210,   211,    -1,
     213,   214,   215,   216,   217,   218,   219,   220,   221,   222,
     223,   224,   225,   226,   227,   228,   229,   230,   231,   232,
     233,   234,   235,   236,    -1,   238,   239,   240,   241,   242,
     243,   244,   245,   246,   247,   248,    -1,   250,    -1,    -1,
     253,   254,   255,    -1,    -1,   258,   259,   260,   261,   262,
     263,   264,   265,   266,   267,   268,   269,   270,    -1,   272,
     273,   274,   275,   276,   277,   278,    -1,   280,   281,   282,
     283,   284,   285,   286,   287,   288,   289,   290,   291,   292,
      -1,   294,   295,   296,   297,   298,   299,   300,   301,   302,
     303,   304,    -1,   306,   307,   308,   309,   310,   311,   312,
     313,   314,   315,   316,   317,   318,   319,    -1,   321,   322,
     323,   324,   325,   326,   327,   328,   329,   330,   331,   332,
     333,   334,    -1,   336,   337,   338,   339,   340,   341,   342,
     343,   344,   345,   346,    -1,   348,   349,    -1,   351,   352,
     353,   354,   355,   356,    -1,   358,   359,    -1,    -1,   362,
     363,   364,   365,   366,   367,   368,   369,   370,   371,   372,
     373,    -1,    -1,   376,   377,   378,   379,   380,   381,    -1,
     383,   384,   385,   386,   387,   388,   389,    -1,   391,   392,
     393,   394,   395,   396,    -1,    -1,   399,    -1,    -1,   402,
     403,   404,   405,   406,   407,   408,   409,   410,   411,   412,
     413,   414,   415,   416,   417,   418,   419,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,     3,     4,     5,     6,     7,    -1,
       9,    10,    -1,    -1,   437,    14,    15,    16,    17,    18,
      19,    20,    21,    -1,    23,    24,    25,    -1,    -1,    -1,
      -1,    30,    31,    -1,    -1,    34,    35,    -1,    37,    38,
      39,    40,    41,    42,    43,    44,    45,    46,    47,    -1,
      49,    50,    51,    52,    53,    54,    55,    56,    57,    58,
      59,    60,    -1,    62,    63,    64,    65,    66,    -1,    68,
      -1,    70,    71,    72,    73,    74,    75,    76,    -1,    78,
      79,    80,    81,    82,    83,    -1,    85,    86,    87,    88,
      89,    90,    91,    92,    93,    94,    95,    96,    97,    98,
      99,   100,   101,   102,   103,    -1,   105,    -1,   107,   108,
     109,   110,   111,    -1,   113,   114,   115,    -1,    -1,   118,
     119,   120,   121,   122,    -1,   124,   125,   126,    -1,   128,
     129,   130,    -1,   132,   133,   134,   135,   136,   137,   138,
     139,   140,   141,   142,    -1,   144,   145,   146,   147,    -1,
     149,    -1,   151,   152,    -1,   154,   155,   156,   157,    -1,
     159,   160,    -1,   162,    -1,   164,   165,   166,   167,   168,
     169,   170,   171,   172,    -1,   174,   175,   176,   177,   178,
     179,    -1,   181,   182,   183,   184,   185,   186,   187,   188,
     189,    -1,   191,    -1,   193,   194,   195,   196,   197,   198,
     199,   200,   201,   202,    -1,   204,   205,    -1,   207,   208,
     209,   210,   211,    -1,   213,   214,   215,   216,   217,   218,
     219,   220,   221,   222,   223,   224,   225,   226,   227,   228,
     229,   230,   231,   232,   233,   234,   235,   236,    -1,   238,
     239,   240,   241,   242,   243,   244,   245,   246,   247,   248,
      -1,   250,    -1,    -1,   253,   254,   255,    -1,    -1,   258,
     259,   260,   261,   262,   263,   264,   265,   266,   267,   268,
     269,   270,    -1,   272,   273,   274,   275,   276,   277,   278,
      -1,   280,   281,   282,   283,   284,   285,   286,   287,   288,
     289,   290,   291,   292,    -1,   294,   295,   296,   297,   298,
     299,   300,   301,   302,   303,   304,    -1,   306,   307,   308,
     309,   310,   311,   312,   313,   314,   315,   316,   317,   318,
     319,    -1,   321,   322,   323,   324,   325,   326,   327,   328,
     329,   330,   331,   332,   333,   334,    -1,   336,   337,   338,
     339,   340,   341,   342,   343,   344,   345,   346,    -1,   348,
     349,    -1,   351,   352,   353,   354,   355,   356,    -1,   358,
     359,    -1,    -1,   362,   363,   364,   365,   366,   367,   368,
     369,   370,   371,   372,   373,    -1,    -1,   376,   377,   378,
     379,   380,   381,    -1,   383,   384,   385,   386,   387,   388,
     389,    -1,   391,   392,   393,   394,   395,   396,    -1,    -1,
     399,    -1,    -1,   402,   403,   404,   405,   406,   407,   408,
     409,   410,   411,   412,   413,   414,   415,   416,   417,   418,
     419,    -1,    -1,    -1,    -1,    -1,    -1,    -1,     3,     4,
       5,     6,     7,     8,     9,    10,    -1,    -1,   437,    14,
      15,    16,    17,    18,    19,    20,    21,    -1,    23,    24,
      25,    -1,    -1,    -1,    -1,    30,    31,    -1,    -1,    34,
      35,    -1,    37,    38,    39,    40,    41,    42,    -1,    44,
      45,    46,    47,    -1,    49,    50,    51,    52,    53,    54,
      55,    56,    57,    58,    59,    60,    -1,    62,    63,    64,
      65,    66,    -1,    68,    -1,    70,    71,    72,    73,    74,
      75,    76,    -1,    78,    79,    80,    81,    82,    83,    -1,
      85,    86,    87,    88,    89,    90,    91,    92,    93,    94,
      95,    96,    97,    98,    99,   100,   101,   102,   103,    -1,
     105,    -1,   107,   108,   109,   110,   111,    -1,   113,   114,
     115,    -1,    -1,   118,   119,   120,   121,   122,    -1,   124,
     125,   126,    -1,   128,    -1,   130,    -1,   132,   133,   134,
     135,   136,   137,   138,   139,   140,   141,   142,    -1,   144,
     145,   146,   147,    -1,   149,    -1,   151,   152,    -1,   154,
     155,   156,   157,    -1,   159,   160,    -1,   162,    -1,   164,
     165,   166,   167,   168,    -1,   170,   171,   172,    -1,   174,
     175,   176,   177,   178,   179,    -1,   181,   182,   183,   184,
     185,   186,   187,   188,   189,    -1,   191,    -1,   193,   194,
     195,   196,   197,   198,   199,   200,   201,   202,    -1,   204,
     205,    -1,   207,   208,   209,   210,    -1,    -1,   213,   214,
     215,   216,   217,   218,   219,   220,   221,   222,   223,   224,
     225,   226,   227,   228,   229,   230,   231,   232,   233,   234,
     235,   236,    -1,   238,   239,   240,   241,   242,   243,   244,
     245,   246,   247,   248,    -1,   250,    -1,    -1,   253,   254,
     255,    -1,    -1,   258,   259,   260,   261,   262,   263,   264,
     265,   266,   267,   268,   269,   270,    -1,   272,   273,   274,
     275,   276,   277,   278,    -1,   280,   281,   282,   283,   284,
     285,   286,   287,   288,   289,   290,   291,   292,    -1,   294,
     295,   296,   297,   298,   299,   300,   301,   302,   303,   304,
      -1,   306,   307,   308,   309,   310,   311,   312,   313,   314,
     315,   316,   317,   318,   319,    -1,   321,   322,   323,   324,
     325,   326,   327,   328,   329,   330,    -1,   332,   333,   334,
      -1,   336,   337,   338,   339,   340,   341,   342,   343,   344,
     345,   346,    -1,   348,   349,    -1,   351,   352,   353,   354,
     355,   356,    -1,   358,   359,    -1,    -1,   362,   363,   364,
     365,   366,   367,   368,   369,   370,   371,   372,   373,    -1,
     375,   376,   377,   378,   379,   380,   381,    -1,   383,   384,
     385,   386,   387,   388,   389,    -1,   391,   392,   393,   394,
     395,   396,    -1,    -1,   399,    -1,    -1,   402,   403,   404,
     405,   406,   407,   408,   409,   410,   411,   412,   413,   414,
     415,   416,   417,   418,   419,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,   428,   429,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,   437,     3,     4,     5,     6,     7,     8,     9,
      10,    -1,    -1,    -1,    14,    15,    16,    17,    18,    19,
      20,    21,    -1,    23,    24,    25,    -1,    -1,    -1,    -1,
      30,    31,    -1,    -1,    34,    35,    -1,    37,    38,    39,
      40,    41,    42,    -1,    44,    45,    46,    47,    -1,    49,
      50,    51,    52,    53,    54,    55,    56,    57,    58,    59,
      60,    -1,    62,    63,    64,    65,    66,    -1,    68,    -1,
      70,    71,    72,    73,    74,    75,    76,    -1,    78,    79,
      80,    81,    82,    83,    -1,    85,    86,    87,    88,    89,
      90,    91,    92,    93,    94,    95,    96,    97,    98,    99,
     100,   101,   102,   103,    -1,   105,    -1,   107,   108,   109,
     110,   111,    -1,   113,   114,   115,    -1,    -1,   118,   119,
     120,   121,   122,    -1,   124,   125,   126,    -1,   128,    -1,
     130,    -1,   132,   133,   134,   135,   136,   137,   138,   139,
     140,   141,   142,    -1,   144,   145,   146,   147,    -1,   149,
      -1,   151,   152,    -1,   154,   155,   156,   157,    -1,   159,
     160,    -1,   162,    -1,   164,   165,   166,   167,   168,    -1,
     170,   171,   172,    -1,   174,   175,   176,   177,   178,   179,
      -1,   181,   182,   183,   184,   185,   186,   187,   188,   189,
      -1,   191,    -1,   193,   194,   195,   196,   197,   198,   199,
     200,   201,   202,    -1,   204,   205,    -1,   207,   208,   209,
     210,    -1,    -1,   213,   214,   215,   216,   217,   218,   219,
     220,   221,   222,   223,   224,   225,   226,   227,   228,   229,
     230,   231,   232,   233,   234,   235,   236,    -1,   238,   239,
     240,   241,   242,   243,   244,   245,   246,   247,   248,    -1,
     250,    -1,    -1,   253,   254,   255,    -1,    -1,   258,   259,
     260,   261,   262,   263,   264,   265,   266,   267,   268,   269,
     270,    -1,   272,   273,   274,   275,   276,   277,   278,    -1,
     280,   281,   282,   283,   284,   285,   286,   287,   288,   289,
     290,   291,   292,    -1,   294,   295,   296,   297,   298,   299,
     300,   301,   302,   303,   304,    -1,   306,   307,   308,   309,
     310,   311,   312,   313,   314,   315,   316,   317,   318,   319,
      -1,   321,   322,   323,   324,   325,   326,   327,   328,   329,
     330,    -1,   332,   333,   334,    -1,   336,   337,   338,   339,
     340,   341,   342,   343,   344,   345,   346,    -1,   348,   349,
      -1,   351,   352,   353,   354,   355,   356,    -1,   358,   359,
      -1,    -1,   362,   363,   364,   365,   366,   367,   368,   369,
     370,   371,   372,   373,    -1,    -1,   376,   377,   378,   379,
     380,   381,    -1,   383,   384,   385,   386,   387,   388,   389,
      -1,   391,   392,   393,   394,   395,   396,    -1,    -1,   399,
      -1,    -1,   402,   403,   404,   405,   406,   407,   408,   409,
     410,   411,   412,   413,   414,   415,   416,   417,   418,   419,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,     3,   428,   429,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,   437,    14,    15,
      16,    17,    18,    19,    20,    21,    -1,    23,    24,    25,
      -1,    -1,    -1,    -1,    30,    -1,    -1,    -1,    34,    35,
      -1,    37,    38,    39,    40,    41,    42,    43,    44,    45,
      46,    47,    -1,    49,    50,    51,    52,    53,    -1,    55,
      56,    57,    58,    59,    60,    -1,    62,    63,    64,    65,
      66,    -1,    68,    -1,    70,    71,    72,    73,    74,    75,
      76,    -1,    78,    79,    80,    81,    82,    83,    -1,    85,
      86,    87,    88,    89,    90,    91,    92,    93,    94,    95,
      96,    97,    98,    99,   100,   101,   102,   103,    -1,   105,
      -1,   107,   108,   109,   110,   111,    -1,   113,   114,   115,
      -1,    -1,   118,   119,   120,   121,   122,    -1,   124,   125,
     126,    -1,   128,   129,   130,    -1,   132,   133,   134,   135,
     136,   137,   138,   139,   140,    -1,   142,    -1,   144,   145,
     146,   147,    -1,   149,    -1,   151,   152,    -1,   154,   155,
     156,   157,    -1,   159,   160,    -1,   162,    -1,   164,   165,
     166,   167,   168,   169,   170,   171,   172,    -1,   174,   175,
     176,   177,   178,   179,    -1,   181,   182,   183,   184,   185,
     186,   187,   188,   189,    -1,   191,    -1,   193,   194,   195,
     196,   197,   198,   199,   200,   201,   202,   203,   204,   205,
      -1,   207,   208,   209,   210,   211,    -1,   213,   214,   215,
     216,   217,   218,   219,   220,   221,   222,   223,   224,   225,
     226,   227,   228,   229,   230,   231,   232,   233,   234,   235,
     236,    -1,   238,   239,   240,   241,    -1,   243,   244,   245,
     246,   247,   248,    -1,   250,    -1,   252,   253,   254,   255,
      -1,    -1,   258,   259,   260,   261,   262,   263,   264,   265,
     266,   267,   268,   269,   270,    -1,   272,   273,   274,   275,
     276,   277,   278,    -1,   280,   281,   282,   283,   284,   285,
     286,   287,   288,   289,   290,   291,   292,    -1,   294,   295,
     296,   297,   298,   299,   300,   301,   302,   303,   304,    -1,
     306,   307,   308,   309,   310,   311,   312,   313,   314,   315,
     316,   317,   318,   319,   320,   321,   322,   323,   324,   325,
     326,   327,   328,   329,   330,   331,   332,   333,   334,    -1,
     336,   337,   338,   339,   340,   341,   342,   343,   344,   345,
     346,    -1,   348,   349,   350,   351,   352,   353,   354,   355,
     356,    -1,   358,   359,    -1,    -1,   362,   363,   364,   365,
      -1,   367,   368,   369,   370,   371,   372,   373,    -1,    -1,
     376,   377,   378,   379,   380,   381,    -1,   383,   384,   385,
     386,   387,   388,   389,    -1,   391,   392,   393,   394,   395,
     396,    -1,    -1,   399,    -1,   401,   402,   403,   404,   405,
     406,   407,   408,   409,   410,   411,   412,   413,   414,   415,
     416,   417,   418,   419,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,     3,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,   437,    14,    15,    16,    17,    18,    19,    20,    21,
      -1,    23,    24,    25,    -1,    -1,    -1,    -1,    30,    -1,
      -1,    -1,    34,    35,    -1,    37,    38,    39,    40,    41,
      42,    43,    44,    45,    46,    47,    -1,    49,    50,    51,
      52,    53,    -1,    55,    56,    57,    58,    59,    60,    -1,
      62,    63,    64,    65,    66,    -1,    68,    -1,    70,    71,
      72,    73,    74,    75,    76,    -1,    78,    79,    80,    81,
      82,    83,    -1,    85,    86,    87,    88,    89,    90,    91,
      92,    93,    94,    95,    96,    97,    98,    99,   100,   101,
     102,   103,    -1,   105,    -1,   107,   108,   109,   110,   111,
      -1,   113,   114,   115,    -1,    -1,   118,   119,   120,   121,
     122,    -1,   124,   125,   126,    -1,   128,   129,   130,    -1,
     132,   133,   134,   135,   136,   137,   138,   139,   140,    -1,
     142,    -1,   144,   145,   146,   147,    -1,   149,    -1,   151,
     152,    -1,   154,   155,   156,   157,    -1,   159,   160,    -1,
     162,    -1,   164,   165,   166,   167,   168,   169,   170,   171,
     172,    -1,   174,   175,   176,   177,   178,   179,    -1,   181,
     182,   183,   184,   185,   186,   187,   188,   189,    -1,   191,
      -1,   193,   194,   195,   196,   197,   198,   199,   200,   201,
     202,   203,   204,   205,    -1,   207,   208,   209,   210,   211,
      -1,   213,   214,   215,   216,   217,   218,   219,   220,   221,
     222,   223,   224,   225,   226,   227,   228,   229,   230,   231,
     232,   233,   234,   235,   236,    -1,   238,   239,   240,   241,
      -1,   243,   244,   245,   246,   247,   248,    -1,   250,    -1,
     252,   253,   254,   255,    -1,    -1,   258,   259,   260,   261,
     262,   263,   264,   265,   266,   267,   268,   269,   270,    -1,
     272,   273,   274,   275,   276,   277,   278,    -1,   280,   281,
     282,   283,   284,   285,   286,   287,   288,   289,   290,   291,
     292,    -1,   294,   295,   296,   297,   298,   299,   300,   301,
     302,   303,   304,    -1,   306,   307,   308,   309,   310,   311,
     312,   313,   314,   315,   316,   317,   318,   319,    -1,   321,
     322,   323,   324,   325,   326,   327,   328,   329,   330,   331,
     332,   333,   334,    -1,   336,   337,   338,   339,   340,   341,
     342,   343,   344,   345,   346,    -1,   348,   349,    -1,   351,
     352,   353,   354,   355,   356,    -1,   358,   359,    -1,    -1,
     362,   363,   364,   365,    -1,   367,   368,   369,   370,   371,
     372,   373,    -1,    -1,   376,   377,   378,   379,   380,   381,
      -1,   383,   384,   385,   386,   387,   388,   389,    -1,   391,
     392,   393,   394,   395,   396,    -1,    -1,   399,    -1,    -1,
     402,   403,   404,   405,   406,   407,   408,   409,   410,   411,
     412,   413,   414,   415,   416,   417,   418,   419,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,     3,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,   437,    14,    15,    16,    17,
      18,    19,    20,    21,    -1,    23,    24,    25,    -1,    -1,
      -1,    -1,    30,    -1,    -1,    -1,    34,    35,    -1,    37,
      38,    39,    40,    41,    42,    43,    44,    45,    46,    47,
      -1,    49,    50,    51,    52,    53,    -1,    55,    56,    57,
      58,    59,    60,    -1,    62,    63,    64,    65,    66,    -1,
      68,    -1,    70,    71,    72,    73,    74,    75,    76,    -1,
      78,    79,    80,    81,    82,    83,    -1,    85,    86,    87,
      88,    89,    90,    91,    92,    93,    94,    95,    96,    97,
      98,    99,   100,   101,   102,   103,    -1,   105,    -1,   107,
     108,   109,   110,   111,    -1,   113,   114,   115,    -1,    -1,
     118,   119,   120,   121,   122,    -1,   124,   125,   126,    -1,
     128,   129,   130,    -1,   132,   133,   134,   135,   136,   137,
     138,   139,   140,    -1,   142,    -1,   144,   145,   146,   147,
      -1,   149,    -1,   151,   152,    -1,   154,   155,   156,   157,
      -1,   159,   160,    -1,   162,    -1,   164,   165,   166,   167,
     168,   169,   170,   171,   172,    -1,   174,   175,   176,   177,
     178,   179,    -1,   181,   182,   183,   184,   185,   186,   187,
     188,   189,    -1,   191,    -1,   193,   194,   195,   196,   197,
     198,   199,   200,   201,   202,    -1,   204,   205,    -1,   207,
     208,   209,   210,   211,    -1,   213,   214,   215,   216,   217,
     218,   219,   220,   221,   222,   223,   224,   225,   226,   227,
     228,   229,   230,   231,   232,   233,   234,   235,   236,    -1,
     238,   239,   240,   241,    -1,   243,   244,   245,   246,   247,
     248,    -1,   250,    -1,    -1,   253,   254,   255,    -1,    -1,
     258,   259,   260,   261,   262,   263,   264,   265,   266,   267,
     268,   269,   270,    -1,   272,   273,   274,   275,   276,   277,
     278,    -1,   280,   281,   282,   283,   284,   285,   286,   287,
     288,   289,   290,   291,   292,    -1,   294,   295,   296,   297,
     298,   299,   300,   301,   302,   303,   304,    -1,   306,   307,
     308,   309,   310,   311,   312,   313,   314,   315,   316,   317,
     318,   319,    -1,   321,   322,   323,   324,   325,   326,   327,
     328,   329,   330,   331,   332,   333,   334,    -1,   336,   337,
     338,   339,   340,   341,   342,   343,   344,   345,   346,    -1,
     348,   349,    -1,   351,   352,   353,   354,   355,   356,    -1,
     358,   359,    -1,    -1,   362,   363,   364,   365,    -1,   367,
     368,   369,   370,   371,   372,   373,    -1,    -1,   376,   377,
     378,   379,   380,   381,    -1,   383,   384,   385,   386,   387,
     388,   389,    -1,   391,   392,   393,   394,   395,   396,    -1,
      -1,   399,    -1,    -1,   402,   403,   404,   405,   406,   407,
     408,   409,   410,   411,   412,   413,   414,   415,   416,   417,
     418,   419,    -1,    -1,    -1,    -1,    -1,    -1,    -1,     3,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   437,
      14,    15,    16,    17,    18,    19,    20,    21,    -1,    23,
      24,    25,    -1,    -1,    -1,    -1,    30,    -1,    -1,    -1,
      34,    35,    -1,    37,    38,    39,    40,    41,    42,    43,
      44,    45,    46,    47,    -1,    49,    50,    51,    52,    53,
      -1,    55,    56,    57,    58,    59,    60,    -1,    62,    63,
      64,    65,    66,    -1,    68,    -1,    70,    71,    72,    73,
      74,    75,    76,    -1,    78,    79,    80,    81,    82,    83,
      -1,    85,    86,    87,    88,    89,    90,    91,    92,    93,
      94,    95,    96,    97,    98,    99,   100,   101,   102,   103,
      -1,   105,    -1,   107,   108,   109,   110,   111,    -1,   113,
     114,   115,    -1,    -1,   118,   119,   120,   121,   122,    -1,
     124,   125,   126,    -1,   128,   129,   130,    -1,   132,   133,
     134,   135,   136,   137,   138,   139,   140,    -1,   142,    -1,
     144,   145,   146,   147,    -1,   149,    -1,   151,   152,    -1,
     154,   155,   156,   157,    -1,   159,   160,    -1,   162,    -1,
     164,   165,   166,   167,   168,   169,   170,   171,   172,    -1,
     174,   175,   176,   177,   178,   179,    -1,   181,   182,   183,
     184,   185,   186,   187,   188,   189,    -1,   191,    -1,   193,
     194,   195,   196,   197,   198,   199,   200,   201,   202,    -1,
     204,   205,    -1,   207,   208,   209,   210,   211,    -1,   213,
     214,   215,   216,   217,   218,   219,   220,   221,   222,   223,
     224,   225,   226,   227,   228,   229,   230,   231,   232,   233,
     234,   235,   236,    -1,   238,   239,   240,   241,    -1,   243,
     244,   245,   246,   247,   248,    -1,   250,    -1,    -1,   253,
     254,   255,    -1,    -1,   258,   259,   260,   261,   262,   263,
     264,   265,   266,   267,   268,   269,   270,    -1,   272,   273,
     274,   275,   276,   277,   278,    -1,   280,   281,   282,   283,
     284,   285,   286,   287,   288,   289,   290,   291,   292,    -1,
     294,   295,   296,   297,   298,   299,   300,   301,   302,   303,
     304,    -1,   306,   307,   308,   309,   310,   311,   312,   313,
     314,   315,   316,   317,   318,   319,    -1,   321,   322,   323,
     324,   325,   326,   327,   328,   329,   330,   331,   332,   333,
     334,    -1,   336,   337,   338,   339,   340,   341,   342,   343,
     344,   345,   346,    -1,   348,   349,    -1,   351,   352,   353,
     354,   355,   356,    -1,   358,   359,    -1,    -1,   362,   363,
     364,   365,    -1,   367,   368,   369,   370,   371,   372,   373,
      -1,    -1,   376,   377,   378,   379,   380,   381,    -1,   383,
     384,   385,   386,   387,   388,   389,    -1,   391,   392,   393,
     394,   395,   396,    -1,    -1,   399,    -1,    -1,   402,   403,
     404,   405,   406,   407,   408,   409,   410,   411,   412,   413,
     414,   415,   416,   417,   418,   419,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,     3,     4,     5,    -1,    -1,    -1,     9,
      -1,    -1,    -1,   437,    14,    15,    16,    17,    18,    19,
      20,    21,    -1,    23,    24,    25,    -1,    -1,    -1,    -1,
      30,    -1,    -1,    -1,    34,    35,    -1,    37,    38,    39,
      40,    41,    42,    43,    44,    45,    46,    47,    -1,    49,
      50,    51,    52,    53,    -1,    -1,    56,    57,    58,    59,
      60,    -1,    62,    63,    64,    65,    66,    -1,    68,    -1,
      70,    71,    72,    73,    74,    75,    76,    -1,    78,    79,
      80,    81,    82,    83,    -1,    85,    86,    87,    -1,    -1,
      -1,    91,    -1,    -1,    -1,    95,    96,    97,    98,    99,
     100,   101,   102,   103,    -1,   105,    -1,   107,   108,   109,
     110,   111,    -1,   113,   114,   115,    -1,    -1,   118,   119,
     120,   121,   122,    -1,   124,   125,   126,    -1,   128,   129,
     130,    -1,   132,   133,   134,   135,   136,   137,   138,   139,
     140,   141,   142,    -1,   144,   145,   146,   147,    -1,   149,
      -1,   151,   152,    -1,   154,   155,   156,   157,    -1,   159,
     160,    -1,   162,    -1,   164,   165,   166,   167,   168,   169,
     170,   171,   172,    -1,   174,   175,   176,   177,   178,   179,
      -1,   181,   182,   183,   184,   185,   186,   187,   188,   189,
      -1,   191,    -1,   193,   194,   195,   196,   197,   198,   199,
     200,   201,   202,    -1,   204,   205,    -1,   207,   208,   209,
     210,   211,    -1,   213,   214,   215,    -1,    -1,   218,   219,
     220,   221,   222,   223,   224,   225,   226,   227,   228,   229,
     230,   231,   232,   233,   234,   235,   236,    -1,   238,   239,
     240,   241,    -1,   243,   244,   245,   246,   247,   248,    -1,
     250,   251,    -1,   253,   254,   255,    -1,    -1,   258,   259,
     260,   261,   262,   263,   264,   265,   266,   267,   268,   269,
     270,    -1,   272,   273,   274,   275,   276,   277,   278,    -1,
     280,   281,   282,   283,   284,   285,   286,   287,   288,   289,
     290,   291,   292,    -1,   294,   295,   296,   297,   298,   299,
     300,   301,   302,   303,   304,    -1,   306,   307,   308,   309,
     310,   311,   312,   313,   314,   315,   316,   317,   318,   319,
      -1,   321,   322,   323,   324,   325,    -1,   327,   328,   329,
     330,   331,   332,   333,   334,    -1,   336,   337,   338,   339,
     340,   341,   342,   343,   344,   345,   346,    -1,   348,   349,
      -1,   351,   352,   353,   354,   355,   356,    -1,   358,   359,
      -1,    -1,   362,   363,   364,   365,   366,   367,   368,   369,
     370,   371,   372,   373,    -1,    -1,   376,   377,   378,   379,
     380,    -1,    -1,   383,   384,   385,   386,   387,   388,   389,
      -1,   391,   392,   393,   394,   395,   396,    -1,    -1,   399,
      -1,    -1,   402,   403,   404,   405,   406,   407,   408,   409,
     410,   411,   412,   413,   414,   415,   416,   417,   418,   419,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,     3,   428,   429,
     430,    -1,    -1,    -1,    -1,    -1,    -1,   437,    14,    15,
      16,    17,    18,    19,    20,    21,    -1,    23,    24,    25,
      26,    27,    -1,    -1,    30,    -1,    -1,    -1,    34,    35,
      -1,    37,    38,    39,    40,    41,    42,    43,    44,    45,
      46,    47,    -1,    49,    50,    51,    52,    53,    -1,    -1,
      56,    57,    58,    59,    60,    -1,    62,    63,    64,    65,
      66,    -1,    68,    -1,    70,    71,    72,    73,    74,    75,
      76,    -1,    78,    79,    80,    81,    82,    83,    -1,    85,
      86,    87,    -1,    -1,    -1,    91,    -1,    -1,    -1,    95,
      96,    97,    98,    99,   100,   101,   102,   103,    -1,   105,
      -1,   107,   108,   109,   110,   111,    -1,   113,   114,   115,
      -1,    -1,   118,   119,   120,   121,   122,    -1,   124,   125,
     126,    -1,   128,   129,   130,    -1,   132,   133,   134,   135,
     136,   137,   138,   139,   140,    -1,   142,    -1,   144,   145,
     146,   147,    -1,   149,    -1,   151,   152,    -1,   154,   155,
     156,   157,    -1,   159,   160,    -1,   162,    -1,   164,   165,
     166,   167,   168,   169,   170,   171,   172,    -1,   174,   175,
     176,   177,   178,   179,    -1,   181,   182,   183,   184,   185,
     186,   187,   188,   189,    -1,   191,    -1,   193,   194,   195,
     196,   197,   198,   199,   200,   201,   202,    -1,   204,   205,
      -1,   207,   208,   209,   210,   211,    -1,   213,   214,   215,
      -1,    -1,   218,   219,   220,   221,   222,   223,   224,   225,
     226,   227,   228,   229,   230,   231,   232,   233,   234,   235,
     236,    -1,   238,   239,   240,   241,    -1,   243,   244,   245,
     246,   247,   248,    -1,   250,    -1,    -1,   253,   254,   255,
      -1,    -1,   258,   259,   260,   261,   262,   263,   264,   265,
     266,   267,   268,   269,   270,    -1,   272,   273,   274,   275,
     276,   277,   278,    -1,   280,   281,   282,   283,   284,   285,
     286,   287,   288,   289,   290,   291,   292,    -1,   294,   295,
     296,   297,   298,   299,   300,   301,   302,   303,   304,    -1,
     306,   307,   308,   309,   310,   311,   312,   313,   314,   315,
     316,   317,   318,   319,   320,   321,   322,   323,   324,   325,
      -1,   327,   328,   329,   330,   331,   332,   333,   334,    -1,
     336,   337,   338,   339,   340,   341,   342,   343,   344,   345,
     346,    -1,   348,   349,   350,   351,   352,   353,   354,   355,
     356,    -1,   358,   359,    -1,    -1,   362,   363,   364,   365,
      -1,   367,   368,   369,   370,   371,   372,   373,    -1,    -1,
     376,   377,   378,   379,   380,    -1,    -1,   383,   384,   385,
     386,   387,   388,   389,    -1,   391,   392,   393,   394,   395,
     396,    -1,    -1,   399,    -1,   401,   402,   403,   404,   405,
     406,   407,   408,   409,   410,   411,   412,   413,   414,   415,
     416,   417,   418,   419,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,     3,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,   437,    14,    15,    16,    17,    18,    19,    20,    21,
      -1,    23,    24,    25,    -1,    -1,    -1,    -1,    30,    -1,
      -1,    -1,    34,    35,    -1,    37,    38,    39,    40,    41,
      42,    43,    44,    45,    46,    47,    -1,    49,    50,    51,
      52,    53,    -1,    -1,    56,    57,    58,    59,    60,    -1,
      62,    63,    64,    65,    66,    -1,    68,    -1,    70,    71,
      72,    73,    74,    75,    76,    -1,    78,    79,    80,    81,
      82,    83,    -1,    85,    86,    87,    -1,    -1,    -1,    91,
      -1,    -1,    -1,    95,    96,    97,    98,    99,   100,   101,
     102,   103,    -1,   105,    -1,   107,   108,   109,   110,   111,
      -1,   113,   114,   115,    -1,    -1,   118,   119,   120,   121,
     122,    -1,   124,   125,   126,    -1,   128,   129,   130,    -1,
     132,   133,   134,   135,   136,   137,   138,   139,   140,    -1,
     142,    -1,   144,   145,   146,   147,    -1,   149,    -1,   151,
     152,    -1,   154,   155,   156,   157,    -1,   159,   160,    -1,
     162,    -1,   164,   165,   166,   167,   168,   169,   170,   171,
     172,    -1,   174,   175,   176,   177,   178,   179,    -1,   181,
     182,   183,   184,   185,   186,   187,   188,   189,    -1,   191,
      -1,   193,   194,   195,   196,   197,   198,   199,   200,   201,
     202,    -1,   204,   205,    -1,   207,   208,   209,   210,   211,
      -1,   213,   214,   215,    -1,    -1,   218,   219,   220,   221,
     222,   223,   224,   225,   226,   227,   228,   229,   230,   231,
     232,   233,   234,   235,   236,    -1,   238,   239,   240,   241,
      -1,   243,   244,   245,   246,   247,   248,    -1,   250,    -1,
      -1,   253,   254,   255,    -1,    -1,   258,   259,   260,   261,
     262,   263,   264,   265,   266,   267,   268,   269,   270,    -1,
     272,   273,   274,   275,   276,   277,   278,    -1,   280,   281,
     282,   283,   284,   285,   286,   287,   288,   289,   290,   291,
     292,    -1,   294,   295,   296,   297,   298,   299,   300,   301,
     302,   303,   304,    -1,   306,   307,   308,   309,   310,   311,
     312,   313,   314,   315,   316,   317,   318,   319,    -1,   321,
     322,   323,   324,   325,    -1,   327,   328,   329,   330,   331,
     332,   333,   334,    -1,   336,   337,   338,   339,   340,   341,
     342,   343,   344,   345,   346,    -1,   348,   349,    -1,   351,
     352,   353,   354,   355,   356,    -1,   358,   359,    -1,    -1,
     362,   363,   364,   365,    -1,   367,   368,   369,   370,   371,
     372,   373,    -1,    -1,   376,   377,   378,   379,   380,    -1,
      -1,   383,   384,   385,   386,   387,   388,   389,    -1,   391,
     392,   393,   394,   395,   396,    -1,    -1,   399,    -1,    -1,
     402,   403,   404,   405,   406,   407,   408,   409,   410,   411,
     412,   413,   414,   415,   416,   417,   418,   419,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,     3,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,   437,    14,    15,    16,    17,
      18,    19,    20,    21,    -1,    23,    24,    25,    -1,    -1,
      -1,    -1,    30,    -1,    -1,    -1,    34,    35,    -1,    37,
      38,    -1,    40,    41,    42,    43,    44,    -1,    46,    47,
      -1,    49,    50,    51,    52,    53,    -1,    -1,    56,    57,
      58,    59,    60,    -1,    62,    63,    64,    65,    66,    -1,
      -1,    -1,    70,    71,    72,    73,    -1,    75,    76,    -1,
      78,    79,    80,    81,    82,    83,    -1,    -1,    86,    87,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    95,    96,    97,
      98,    99,   100,   101,   102,   103,    -1,   105,    -1,   107,
     108,   109,   110,   111,    -1,   113,   114,   115,    -1,    -1,
     118,   119,   120,   121,   122,    -1,   124,   125,   126,    -1,
     128,   129,   130,    -1,   132,   133,   134,   135,   136,   137,
     138,   139,   140,    -1,   142,    -1,   144,   145,   146,   147,
      -1,   149,    -1,   151,    -1,    -1,    -1,   155,   156,   157,
      -1,   159,   160,    -1,   162,    -1,   164,   165,   166,   167,
     168,    -1,   170,   171,   172,    -1,   174,   175,   176,   177,
     178,   179,    -1,   181,    -1,   183,   184,   185,   186,   187,
     188,   189,    -1,   191,    -1,   193,    -1,    -1,   196,    -1,
     198,   199,   200,   201,   202,    -1,   204,   205,    -1,   207,
     208,    -1,   210,    -1,    -1,   213,   214,   215,    -1,    -1,
     218,   219,   220,   221,   222,   223,   224,   225,   226,   227,
     228,   229,   230,   231,    -1,   233,   234,   235,   236,    -1,
     238,   239,    -1,   241,    -1,   243,   244,   245,   246,   247,
     248,    -1,   250,    -1,    -1,   253,   254,   255,    -1,    -1,
     258,   259,    -1,   261,    -1,   263,   264,   265,   266,   267,
     268,   269,   270,    -1,   272,   273,   274,   275,   276,   277,
     278,    -1,   280,   281,   282,   283,   284,   285,   286,   287,
     288,   289,   290,   291,   292,    -1,   294,   295,   296,   297,
     298,   299,   300,   301,   302,   303,   304,    -1,   306,   307,
      -1,   309,   310,   311,   312,   313,   314,   315,   316,   317,
     318,   319,   320,   321,   322,   323,   324,   325,    -1,   327,
     328,   329,   330,    -1,   332,   333,   334,    -1,   336,   337,
     338,   339,   340,   341,   342,   343,   344,   345,   346,    -1,
     348,   349,   350,   351,   352,   353,   354,   355,   356,    -1,
     358,   359,    -1,    -1,   362,   363,   364,   365,    -1,   367,
     368,   369,   370,   371,   372,   373,    -1,    -1,   376,   377,
     378,   379,   380,    -1,    -1,   383,   384,   385,   386,   387,
     388,   389,    -1,   391,    -1,   393,   394,   395,   396,    -1,
      -1,   399,    -1,   401,   402,   403,   404,   405,   406,   407,
     408,   409,   410,   411,   412,   413,   414,   415,   416,   417,
     418,   419,    -1,    -1,    -1,    -1,    -1,    -1,    -1,     3,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   437,
      14,    15,    16,    17,    18,    19,    20,    21,    -1,    23,
      24,    25,    -1,    -1,    -1,    -1,    30,    -1,    -1,    -1,
      34,    35,    -1,    37,    38,    -1,    40,    41,    42,    43,
      44,    -1,    46,    47,    -1,    49,    50,    51,    52,    53,
      -1,    -1,    56,    57,    58,    59,    60,    -1,    62,    63,
      64,    65,    66,    -1,    -1,    -1,    70,    71,    72,    73,
      -1,    75,    76,    -1,    78,    79,    80,    81,    82,    83,
      -1,    -1,    86,    87,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    95,    96,    97,    98,    99,   100,   101,   102,   103,
      -1,   105,    -1,   107,   108,   109,   110,   111,    -1,   113,
     114,   115,    -1,    -1,   118,   119,   120,   121,   122,    -1,
     124,   125,   126,    -1,   128,   129,   130,    -1,   132,   133,
     134,   135,   136,   137,   138,   139,   140,    -1,   142,    -1,
     144,   145,   146,   147,    -1,   149,    -1,   151,    -1,    -1,
      -1,   155,   156,   157,    -1,   159,   160,    -1,   162,    -1,
     164,   165,   166,   167,   168,    -1,   170,   171,   172,    -1,
     174,   175,   176,   177,   178,   179,    -1,   181,    -1,   183,
     184,   185,   186,   187,   188,   189,    -1,   191,    -1,   193,
      -1,    -1,   196,    -1,   198,   199,   200,   201,   202,    -1,
     204,   205,    -1,   207,   208,    -1,   210,    -1,    -1,   213,
     214,   215,    -1,    -1,   218,   219,   220,   221,   222,   223,
     224,   225,   226,   227,   228,   229,   230,   231,    -1,   233,
     234,   235,   236,    -1,   238,   239,    -1,   241,    -1,   243,
     244,   245,   246,   247,   248,    -1,   250,    -1,    -1,   253,
     254,   255,    -1,    -1,   258,   259,    -1,   261,    -1,   263,
     264,   265,   266,   267,   268,   269,   270,    -1,   272,   273,
     274,   275,   276,   277,   278,    -1,   280,   281,   282,   283,
     284,   285,   286,   287,   288,   289,   290,   291,   292,    -1,
     294,   295,   296,   297,   298,   299,   300,   301,   302,   303,
     304,    -1,   306,   307,    -1,   309,   310,   311,   312,   313,
     314,   315,   316,   317,   318,   319,    -1,   321,   322,   323,
     324,   325,    -1,   327,   328,   329,   330,    -1,   332,   333,
     334,    -1,   336,   337,   338,   339,   340,   341,   342,   343,
     344,   345,   346,    -1,   348,   349,    -1,   351,   352,   353,
     354,   355,   356,    -1,   358,   359,    -1,    -1,   362,   363,
     364,   365,    -1,   367,   368,   369,   370,   371,   372,   373,
      -1,    -1,   376,   377,   378,   379,   380,    -1,    -1,   383,
     384,   385,   386,   387,   388,   389,    -1,   391,    -1,   393,
     394,   395,   396,    -1,    -1,   399,    -1,    -1,   402,   403,
     404,   405,   406,   407,   408,   409,   410,   411,   412,   413,
     414,   415,   416,   417,   418,   419,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,     3,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,   437,    14,    15,    16,    17,    18,    19,
      20,    21,    -1,    23,    24,    25,    -1,    -1,    -1,    -1,
      30,    -1,    -1,    -1,    34,    35,    -1,    37,    38,    -1,
      40,    41,    42,    43,    44,    -1,    46,    47,    -1,    49,
      50,    51,    52,    53,    -1,    -1,    56,    57,    58,    59,
      60,    -1,    62,    63,    64,    65,    66,    -1,    -1,    -1,
      70,    71,    72,    73,    -1,    75,    76,    -1,    78,    79,
      80,    81,    82,    83,    -1,    -1,    86,    87,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    95,    96,    97,    98,    99,
     100,   101,   102,   103,    -1,   105,    -1,   107,   108,   109,
     110,   111,    -1,   113,   114,   115,    -1,    -1,   118,   119,
     120,   121,   122,    -1,   124,   125,   126,    -1,   128,   129,
     130,    -1,   132,   133,   134,   135,   136,   137,   138,   139,
     140,    -1,   142,    -1,   144,   145,   146,   147,    -1,   149,
      -1,   151,    -1,    -1,    -1,   155,   156,   157,    -1,   159,
     160,    -1,   162,    -1,   164,   165,   166,   167,   168,    -1,
     170,   171,   172,    -1,   174,   175,   176,   177,   178,   179,
      -1,   181,    -1,   183,   184,   185,   186,   187,   188,   189,
      -1,   191,    -1,   193,    -1,    -1,   196,    -1,   198,   199,
     200,   201,   202,    -1,   204,   205,    -1,   207,   208,    -1,
     210,    -1,    -1,   213,   214,   215,    -1,    -1,   218,   219,
     220,   221,   222,   223,   224,   225,   226,   227,   228,   229,
     230,   231,    -1,   233,   234,   235,   236,    -1,   238,   239,
      -1,   241,    -1,   243,   244,   245,   246,   247,   248,    -1,
     250,    -1,    -1,   253,   254,   255,    -1,    -1,   258,   259,
      -1,   261,    -1,   263,   264,   265,   266,   267,   268,   269,
     270,    -1,   272,   273,   274,   275,   276,   277,   278,    -1,
     280,   281,   282,   283,   284,   285,   286,   287,   288,   289,
     290,   291,   292,    -1,   294,   295,   296,   297,   298,   299,
     300,   301,   302,   303,   304,    -1,   306,   307,    -1,   309,
     310,   311,   312,   313,   314,   315,   316,   317,   318,   319,
      -1,   321,   322,   323,   324,   325,    -1,   327,   328,   329,
     330,    -1,   332,   333,   334,    -1,   336,   337,   338,   339,
     340,   341,   342,   343,   344,   345,   346,    -1,   348,   349,
      -1,   351,   352,   353,   354,   355,   356,    -1,   358,   359,
      -1,    -1,   362,   363,   364,   365,    -1,   367,   368,   369,
     370,   371,   372,   373,    -1,    -1,   376,   377,   378,   379,
     380,    -1,    -1,   383,   384,   385,   386,   387,   388,   389,
      -1,   391,    -1,   393,   394,   395,   396,    -1,    -1,   399,
      -1,    -1,   402,   403,   404,   405,   406,   407,   408,   409,
     410,   411,   412,   413,   414,   415,   416,   417,   418,   419,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,     3,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,   437,    14,    15,
      16,    17,    18,    19,    20,    21,    -1,    23,    24,    25,
      -1,    -1,    -1,    -1,    30,    -1,    -1,    -1,    34,    35,
      -1,    37,    38,    -1,    40,    41,    42,    43,    44,    -1,
      46,    47,    -1,    49,    50,    51,    52,    53,    -1,    -1,
      56,    57,    58,    59,    60,    -1,    62,    63,    64,    65,
      66,    -1,    -1,    -1,    70,    71,    72,    73,    -1,    75,
      76,    -1,    78,    79,    80,    81,    82,    83,    -1,    -1,
      86,    87,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    95,
      96,    97,    98,    99,   100,   101,   102,   103,    -1,   105,
      -1,   107,   108,   109,   110,   111,    -1,   113,   114,   115,
      -1,    -1,   118,   119,   120,   121,   122,    -1,   124,   125,
     126,    -1,   128,   129,   130,    -1,   132,   133,   134,   135,
     136,   137,   138,   139,   140,    -1,   142,    -1,   144,   145,
     146,   147,    -1,   149,    -1,   151,    -1,    -1,    -1,   155,
     156,   157,    -1,   159,   160,    -1,   162,    -1,   164,   165,
     166,   167,   168,    -1,   170,   171,   172,    -1,   174,   175,
     176,   177,   178,   179,    -1,   181,    -1,   183,   184,   185,
     186,   187,   188,   189,    -1,   191,    -1,   193,    -1,    -1,
     196,    -1,   198,   199,   200,   201,   202,    -1,   204,   205,
      -1,   207,   208,    -1,   210,    -1,    -1,   213,   214,   215,
      -1,    -1,   218,   219,   220,   221,   222,   223,   224,   225,
     226,   227,   228,   229,   230,   231,    -1,   233,   234,   235,
     236,    -1,   238,   239,    -1,   241,    -1,   243,   244,   245,
     246,   247,   248,    -1,   250,    -1,    -1,   253,   254,   255,
      -1,    -1,   258,   259,    -1,   261,    -1,   263,   264,   265,
     266,   267,   268,   269,   270,    -1,   272,   273,   274,   275,
     276,   277,   278,    -1,   280,   281,   282,   283,   284,   285,
     286,   287,   288,   289,   290,   291,   292,    -1,   294,   295,
     296,   297,   298,   299,   300,   301,   302,   303,   304,    -1,
     306,   307,    -1,   309,   310,   311,   312,   313,   314,   315,
     316,   317,   318,   319,    -1,   321,   322,   323,   324,   325,
      -1,   327,   328,   329,   330,    -1,   332,   333,   334,    -1,
     336,   337,   338,   339,   340,   341,   342,   343,   344,   345,
     346,    -1,   348,   349,    -1,   351,   352,   353,   354,   355,
     356,    -1,   358,   359,    -1,    -1,   362,   363,   364,   365,
      -1,   367,   368,   369,   370,   371,   372,   373,    -1,    -1,
     376,   377,   378,   379,   380,    -1,    -1,   383,   384,   385,
     386,   387,   388,   389,    -1,   391,    -1,   393,   394,   395,
     396,    -1,    -1,   399,    -1,    -1,   402,   403,   404,   405,
     406,   407,   408,   409,   410,   411,   412,   413,   414,   415,
     416,   417,   418,   419,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,     3,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,   437,    14,    15,    16,    17,    18,    19,    20,    21,
      -1,    23,    24,    25,    -1,    -1,    -1,    -1,    30,    -1,
      -1,    -1,    34,    35,    -1,    37,    38,    -1,    40,    41,
      42,    43,    44,    -1,    46,    47,    -1,    49,    50,    51,
      52,    53,    -1,    -1,    56,    57,    58,    59,    60,    -1,
      62,    63,    64,    65,    66,    -1,    -1,    -1,    70,    71,
      72,    73,    -1,    75,    76,    -1,    78,    79,    80,    81,
      82,    83,    -1,    -1,    86,    87,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    95,    96,    97,    98,    99,   100,   101,
     102,   103,    -1,   105,    -1,   107,   108,   109,   110,   111,
      -1,   113,   114,   115,    -1,    -1,   118,   119,   120,   121,
     122,    -1,   124,   125,   126,    -1,   128,   129,   130,    -1,
     132,   133,   134,   135,   136,   137,   138,   139,   140,    -1,
     142,    -1,   144,   145,   146,   147,    -1,   149,    -1,   151,
      -1,    -1,    -1,   155,   156,   157,    -1,   159,   160,    -1,
     162,    -1,   164,   165,   166,   167,   168,    -1,   170,   171,
     172,    -1,   174,   175,   176,   177,   178,   179,    -1,   181,
      -1,   183,   184,   185,   186,   187,   188,   189,    -1,   191,
      -1,   193,    -1,    -1,   196,    -1,   198,   199,   200,   201,
     202,    -1,   204,   205,    -1,   207,   208,    -1,   210,    -1,
      -1,   213,   214,   215,    -1,    -1,   218,   219,   220,   221,
     222,   223,   224,   225,   226,   227,   228,   229,   230,   231,
      -1,   233,   234,   235,   236,    -1,   238,   239,    -1,   241,
      -1,   243,   244,   245,   246,   247,   248,    -1,   250,    -1,
      -1,   253,   254,   255,    -1,    -1,   258,   259,    -1,   261,
      -1,   263,   264,   265,   266,   267,   268,   269,   270,    -1,
     272,   273,   274,   275,   276,   277,   278,    -1,   280,   281,
     282,   283,   284,   285,   286,   287,   288,   289,   290,   291,
     292,    -1,   294,   295,   296,   297,   298,   299,   300,   301,
     302,   303,   304,    -1,   306,   307,    -1,   309,   310,   311,
     312,   313,   314,   315,   316,   317,   318,   319,    -1,   321,
     322,   323,   324,   325,    -1,   327,   328,   329,   330,    -1,
     332,   333,   334,    -1,   336,   337,   338,   339,   340,   341,
     342,   343,   344,   345,   346,    -1,   348,   349,    -1,   351,
     352,   353,   354,   355,   356,    -1,   358,   359,    -1,    -1,
     362,   363,   364,   365,    -1,   367,   368,   369,   370,   371,
     372,   373,    -1,    -1,   376,   377,   378,   379,   380,    -1,
      -1,   383,   384,   385,   386,   387,   388,   389,    -1,   391,
      -1,   393,   394,   395,   396,    -1,    -1,   399,    -1,    -1,
     402,   403,   404,   405,   406,   407,   408,   409,   410,   411,
     412,   413,   414,   415,   416,   417,   418,   419,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,     3,     4,     5,    -1,    -1,
       8,     9,    -1,    -1,    -1,   437,    14,    15,    16,    17,
      18,    19,    20,    21,    22,    23,    24,    25,    26,    27,
      28,    29,    30,    31,    32,    33,    34,    35,    36,    37,
      38,    39,    40,    41,    42,    -1,    44,    45,    46,    47,
      48,    49,    50,    51,    52,    53,    54,    55,    56,    57,
      58,    59,    60,    61,    62,    63,    64,    65,    -1,    67,
      68,    69,    70,    71,    72,    73,    74,    75,    76,    77,
      78,    79,    80,    81,    82,    83,    84,    85,    86,    87,
      88,    89,    90,    91,    92,    93,    94,    95,    96,    97,
      98,    99,   100,   101,   102,   103,   104,   105,   106,   107,
     108,   109,   110,   111,   112,   113,   114,   115,   116,   117,
     118,   119,   120,   121,   122,   123,   124,   125,   126,   127,
     128,   129,   130,   131,   132,   133,   134,   135,    -1,   137,
     138,   139,    -1,   141,   142,   143,   144,   145,   146,   147,
     148,   149,   150,   151,   152,   153,   154,   155,   156,   157,
     158,   159,    -1,   161,   162,   163,   164,   165,   166,   167,
     168,   169,   170,   171,   172,   173,   174,   175,   176,   177,
     178,   179,   180,   181,   182,    -1,   184,   185,   186,   187,
     188,   189,   190,   191,   192,   193,   194,   195,   196,   197,
     198,   199,   200,   201,   202,   203,   204,   205,   206,   207,
      -1,   209,   210,   211,   212,   213,   214,   215,   216,   217,
     218,   219,   220,   221,   222,   223,   224,   225,   226,   227,
     228,   229,   230,   231,   232,   233,   234,   235,    -1,   237,
     238,   239,   240,   241,   242,    -1,   244,   245,   246,   247,
     248,   249,   250,   251,   252,   253,   254,   255,   256,   257,
     258,    -1,   260,   261,   262,    -1,   264,   265,   266,   267,
     268,   269,   270,   271,   272,    -1,   274,    -1,   276,   277,
     278,   279,   280,   281,   282,   283,   284,   285,   286,   287,
     288,   289,   290,   291,   292,   293,   294,   295,   296,   297,
     298,   299,   300,   301,   302,   303,   304,   305,   306,   307,
     308,   309,   310,    -1,   312,   313,   314,   315,   316,   317,
     318,   319,   320,   321,   322,   323,   324,   325,   326,   327,
     328,   329,   330,   331,   332,   333,   334,   335,   336,   337,
     338,   339,   340,   341,   342,   343,   344,   345,    -1,   347,
     348,   349,   350,   351,   352,   353,   354,   355,   356,   357,
     358,   359,   360,   361,   362,    -1,   364,    -1,   366,   367,
     368,   369,   370,   371,   372,   373,   374,   375,   376,   377,
     378,   379,   380,   381,   382,   383,   384,   385,   386,   387,
      -1,   389,   390,   391,   392,   393,   394,   395,   396,   397,
     398,   399,   400,   401,   402,   403,   404,   405,   406,   407,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   417,
     418,   419,    -1,    -1,    -1,    -1,   424,   425,   426,    -1,
     428,   429,   430,   431,   432,   433,     3,    -1,    -1,    -1,
      -1,     8,    -1,    -1,    -1,    -1,    -1,    14,    15,    16,
      17,    18,    19,    20,    21,    -1,    23,    24,    25,    -1,
      -1,    -1,    -1,    30,    -1,    -1,    -1,    34,    35,    -1,
      37,    38,    -1,    40,    41,    42,    43,    44,    -1,    46,
      47,    -1,    49,    50,    51,    52,    53,    -1,    -1,    56,
      57,    58,    59,    60,    -1,    62,    63,    64,    65,    66,
      -1,    -1,    -1,    70,    71,    72,    73,    -1,    75,    76,
      -1,    78,    79,    80,    81,    82,    83,    -1,    -1,    86,
      87,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    95,    96,
      97,    98,    99,   100,   101,   102,   103,    -1,   105,    -1,
     107,   108,   109,   110,   111,    -1,   113,   114,   115,    -1,
      -1,   118,   119,   120,   121,   122,    -1,   124,   125,   126,
      -1,   128,   129,   130,    -1,   132,   133,   134,   135,   136,
     137,   138,   139,   140,    -1,   142,    -1,   144,   145,   146,
     147,    -1,   149,    -1,   151,    -1,    -1,    -1,   155,   156,
     157,    -1,   159,   160,    -1,   162,    -1,   164,   165,   166,
     167,   168,    -1,   170,   171,   172,    -1,   174,   175,   176,
     177,   178,   179,    -1,   181,    -1,   183,   184,   185,   186,
     187,   188,   189,    -1,   191,    -1,   193,    -1,    -1,   196,
      -1,   198,   199,   200,   201,   202,    -1,   204,   205,    -1,
     207,   208,    -1,   210,    -1,    -1,   213,   214,   215,    -1,
      -1,   218,   219,   220,   221,   222,   223,   224,   225,   226,
     227,   228,   229,   230,   231,    -1,   233,   234,   235,   236,
      -1,   238,   239,    -1,   241,    -1,   243,   244,   245,   246,
     247,   248,    -1,   250,    -1,    -1,   253,   254,   255,    -1,
      -1,   258,   259,    -1,   261,    -1,   263,   264,   265,   266,
     267,   268,   269,   270,    -1,   272,   273,   274,   275,   276,
     277,   278,    -1,   280,   281,   282,   283,   284,   285,   286,
     287,   288,   289,   290,   291,   292,    -1,   294,   295,   296,
     297,   298,   299,   300,   301,   302,   303,   304,    -1,   306,
     307,    -1,   309,   310,   311,   312,   313,   314,   315,   316,
     317,   318,   319,    -1,   321,   322,   323,   324,   325,    -1,
     327,   328,   329,   330,    -1,   332,   333,   334,    -1,   336,
     337,   338,   339,   340,   341,   342,   343,   344,   345,   346,
      -1,   348,   349,    -1,   351,   352,   353,   354,   355,   356,
      -1,   358,   359,    -1,    -1,   362,   363,   364,   365,    -1,
     367,   368,   369,   370,   371,   372,   373,    -1,    -1,   376,
     377,   378,   379,   380,    -1,    -1,   383,   384,   385,   386,
     387,   388,   389,    -1,   391,    -1,   393,   394,   395,   396,
      -1,    -1,   399,    -1,    -1,   402,   403,   404,   405,   406,
     407,   408,   409,   410,   411,   412,   413,   414,   415,   416,
     417,   418,   419,    -1,    -1,    -1,    -1,   424,   425,   426,
      -1,   428,   429,   430,   431,   432,   433,     3,    -1,    -1,
      -1,    -1,     8,    -1,    -1,    -1,    -1,    -1,    14,    15,
      16,    17,    18,    19,    20,    21,    -1,    23,    24,    25,
      -1,    -1,    -1,    -1,    30,    -1,    -1,    -1,    34,    35,
      -1,    37,    38,    -1,    40,    41,    42,    43,    44,    -1,
      46,    47,    -1,    49,    50,    51,    52,    53,    -1,    -1,
      56,    57,    58,    59,    60,    -1,    62,    63,    64,    65,
      66,    -1,    -1,    -1,    70,    71,    72,    73,    -1,    75,
      76,    -1,    78,    79,    80,    81,    82,    83,    -1,    -1,
      86,    87,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    95,
      96,    97,    98,    99,   100,   101,   102,   103,    -1,   105,
      -1,   107,   108,   109,   110,   111,    -1,   113,   114,   115,
      -1,    -1,   118,   119,   120,   121,   122,    -1,   124,   125,
     126,    -1,   128,   129,   130,    -1,   132,   133,   134,   135,
     136,   137,   138,   139,   140,    -1,   142,    -1,   144,   145,
     146,   147,    -1,   149,    -1,   151,    -1,    -1,    -1,   155,
     156,   157,    -1,   159,   160,    -1,   162,    -1,   164,   165,
     166,   167,   168,    -1,   170,   171,   172,    -1,   174,   175,
     176,   177,   178,   179,    -1,   181,    -1,   183,   184,   185,
     186,   187,   188,   189,    -1,   191,    -1,   193,    -1,    -1,
     196,    -1,   198,   199,   200,   201,   202,    -1,   204,   205,
      -1,   207,   208,    -1,   210,    -1,    -1,   213,   214,   215,
      -1,    -1,   218,   219,   220,   221,   222,   223,   224,   225,
     226,   227,   228,   229,   230,   231,    -1,   233,   234,   235,
     236,    -1,   238,   239,    -1,   241,    -1,   243,   244,   245,
     246,   247,   248,    -1,   250,    -1,    -1,   253,   254,   255,
      -1,    -1,   258,   259,    -1,   261,    -1,   263,   264,   265,
     266,   267,   268,   269,   270,    -1,   272,   273,   274,   275,
     276,   277,   278,    -1,   280,   281,   282,   283,   284,   285,
     286,   287,   288,   289,   290,   291,   292,    -1,   294,   295,
     296,   297,   298,   299,   300,   301,   302,   303,   304,    -1,
     306,   307,    -1,   309,   310,   311,   312,   313,   314,   315,
     316,   317,   318,   319,    -1,   321,   322,   323,   324,   325,
      -1,   327,   328,   329,   330,    -1,   332,   333,   334,    -1,
     336,   337,   338,   339,   340,   341,   342,   343,   344,   345,
     346,    -1,   348,   349,    -1,   351,   352,   353,   354,   355,
     356,    -1,   358,   359,    -1,    -1,   362,   363,   364,   365,
      -1,   367,   368,   369,   370,   371,   372,   373,    -1,    -1,
     376,   377,   378,   379,   380,    -1,    -1,   383,   384,   385,
     386,   387,   388,   389,    -1,   391,    -1,   393,   394,   395,
     396,    -1,    -1,   399,    -1,    -1,   402,   403,   404,   405,
     406,   407,   408,   409,   410,   411,   412,   413,   414,   415,
     416,   417,   418,   419,    -1,    -1,    -1,    -1,   424,   425,
     426,    -1,   428,   429,   430,   431,   432,   433,     3,    -1,
      -1,    -1,    -1,     8,    -1,    -1,    -1,    -1,    -1,    14,
      15,    16,    17,    18,    19,    20,    21,    -1,    23,    24,
      25,    -1,    -1,    -1,    -1,    30,    -1,    -1,    -1,    34,
      35,    -1,    37,    38,    -1,    40,    41,    42,    43,    44,
      -1,    46,    47,    -1,    49,    50,    51,    52,    53,    -1,
      -1,    56,    57,    58,    59,    60,    -1,    62,    63,    64,
      65,    66,    -1,    -1,    -1,    70,    71,    72,    73,    -1,
      75,    76,    -1,    78,    79,    80,    81,    82,    83,    -1,
      -1,    86,    87,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      95,    96,    97,    98,    99,   100,   101,   102,   103,    -1,
     105,    -1,   107,   108,   109,   110,   111,    -1,   113,   114,
     115,    -1,    -1,   118,   119,   120,   121,   122,    -1,   124,
     125,   126,    -1,   128,   129,   130,    -1,   132,   133,   134,
     135,   136,   137,   138,   139,   140,    -1,   142,    -1,   144,
     145,   146,   147,    -1,   149,    -1,   151,    -1,    -1,    -1,
     155,   156,   157,    -1,   159,   160,    -1,   162,    -1,   164,
     165,   166,   167,   168,    -1,   170,   171,   172,    -1,   174,
     175,   176,   177,   178,   179,    -1,   181,    -1,   183,   184,
     185,   186,   187,   188,   189,    -1,   191,    -1,   193,    -1,
      -1,   196,    -1,   198,   199,   200,   201,   202,    -1,   204,
     205,    -1,   207,   208,    -1,   210,    -1,    -1,   213,   214,
     215,    -1,    -1,   218,   219,   220,   221,   222,   223,   224,
     225,   226,   227,   228,   229,   230,   231,    -1,   233,   234,
     235,   236,    -1,   238,   239,    -1,   241,    -1,   243,   244,
     245,   246,   247,   248,    -1,   250,    -1,    -1,   253,   254,
     255,    -1,    -1,   258,   259,    -1,   261,    -1,   263,   264,
     265,   266,   267,   268,   269,   270,    -1,   272,   273,   274,
     275,   276,   277,   278,    -1,   280,   281,   282,   283,   284,
     285,   286,   287,   288,   289,   290,   291,   292,    -1,   294,
     295,   296,   297,   298,   299,   300,   301,   302,   303,   304,
      -1,   306,   307,    -1,   309,   310,   311,   312,   313,   314,
     315,   316,   317,   318,   319,    -1,   321,   322,   323,   324,
     325,    -1,   327,   328,   329,   330,    -1,   332,   333,   334,
      -1,   336,   337,   338,   339,   340,   341,   342,   343,   344,
     345,   346,    -1,   348,   349,    -1,   351,   352,   353,   354,
     355,   356,    -1,   358,   359,    -1,    -1,   362,   363,   364,
     365,    -1,   367,   368,   369,   370,   371,   372,   373,    -1,
      -1,   376,   377,   378,   379,   380,    -1,    -1,   383,   384,
     385,   386,   387,   388,   389,    -1,   391,    -1,   393,   394,
     395,   396,    -1,    -1,   399,    -1,    -1,   402,   403,   404,
     405,   406,   407,   408,   409,   410,   411,   412,   413,   414,
     415,   416,   417,   418,   419,    -1,    -1,    -1,    -1,   424,
     425,   426,    -1,   428,   429,   430,   431,   432,   433,     3,
      -1,    -1,    -1,    -1,     8,    -1,    -1,    -1,    -1,    -1,
      14,    15,    16,    17,    18,    19,    20,    21,    -1,    23,
      24,    25,    -1,    -1,    -1,    -1,    30,    -1,    -1,    -1,
      34,    35,    -1,    37,    38,    -1,    40,    41,    42,    43,
      44,    -1,    46,    47,    -1,    49,    50,    51,    52,    53,
      -1,    -1,    56,    57,    58,    59,    60,    -1,    62,    63,
      64,    65,    66,    -1,    -1,    -1,    70,    71,    72,    73,
      -1,    75,    76,    -1,    78,    79,    80,    81,    82,    83,
      -1,    -1,    86,    87,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    95,    96,    97,    98,    99,   100,   101,   102,   103,
      -1,   105,    -1,   107,   108,   109,   110,   111,    -1,   113,
     114,   115,    -1,    -1,   118,   119,   120,   121,   122,    -1,
     124,   125,   126,    -1,   128,   129,   130,    -1,   132,   133,
     134,   135,   136,   137,   138,   139,   140,    -1,   142,    -1,
     144,   145,   146,   147,    -1,   149,    -1,   151,    -1,    -1,
      -1,   155,   156,   157,    -1,   159,   160,    -1,   162,    -1,
     164,   165,   166,   167,   168,    -1,   170,   171,   172,    -1,
     174,   175,   176,   177,   178,   179,    -1,   181,    -1,   183,
     184,   185,   186,   187,   188,   189,    -1,   191,    -1,   193,
      -1,    -1,   196,    -1,   198,   199,   200,   201,   202,    -1,
     204,   205,    -1,   207,   208,    -1,   210,    -1,    -1,   213,
     214,   215,    -1,    -1,   218,   219,   220,   221,   222,   223,
     224,   225,   226,   227,   228,   229,   230,   231,    -1,   233,
     234,   235,   236,    -1,   238,   239,    -1,   241,    -1,   243,
     244,   245,   246,   247,   248,    -1,   250,    -1,    -1,   253,
     254,   255,    -1,    -1,   258,   259,    -1,   261,    -1,   263,
     264,   265,   266,   267,   268,   269,   270,    -1,   272,   273,
     274,   275,   276,   277,   278,    -1,   280,   281,   282,   283,
     284,   285,   286,   287,   288,   289,   290,   291,   292,    -1,
     294,   295,   296,   297,   298,   299,   300,   301,   302,   303,
     304,    -1,   306,   307,    -1,   309,   310,   311,   312,   313,
     314,   315,   316,   317,   318,   319,    -1,   321,   322,   323,
     324,   325,    -1,   327,   328,   329,   330,    -1,   332,   333,
     334,    -1,   336,   337,   338,   339,   340,   341,   342,   343,
     344,   345,   346,    -1,   348,   349,    -1,   351,   352,   353,
     354,   355,   356,    -1,   358,   359,    -1,    -1,   362,   363,
     364,   365,    -1,   367,   368,   369,   370,   371,   372,   373,
      -1,    -1,   376,   377,   378,   379,   380,    -1,    -1,   383,
     384,   385,   386,   387,   388,   389,    -1,   391,    -1,   393,
     394,   395,   396,    -1,    -1,   399,    -1,    -1,   402,   403,
     404,   405,   406,   407,   408,   409,   410,   411,   412,   413,
     414,   415,   416,   417,   418,   419,    -1,    -1,    -1,    -1,
     424,   425,   426,    -1,   428,   429,   430,   431,   432,   433,
       3,    -1,    -1,    -1,    -1,     8,    -1,    -1,    -1,    -1,
      -1,    14,    15,    16,    17,    18,    19,    20,    21,    -1,
      23,    24,    25,    -1,    -1,    -1,    -1,    30,    -1,    -1,
      -1,    34,    35,    -1,    37,    38,    -1,    40,    41,    42,
      43,    44,    -1,    46,    47,    -1,    49,    50,    51,    52,
      53,    -1,    -1,    56,    57,    58,    59,    60,    -1,    62,
      63,    64,    65,    66,    -1,    -1,    -1,    70,    71,    72,
      73,    -1,    75,    76,    -1,    78,    79,    80,    81,    82,
      83,    -1,    -1,    86,    87,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    95,    96,    97,    98,    99,   100,   101,   102,
     103,    -1,   105,    -1,   107,   108,   109,   110,   111,    -1,
     113,   114,   115,    -1,    -1,   118,   119,   120,   121,   122,
      -1,   124,   125,   126,    -1,   128,   129,   130,    -1,   132,
     133,   134,   135,   136,   137,   138,   139,   140,    -1,   142,
      -1,   144,   145,   146,   147,    -1,   149,    -1,   151,    -1,
      -1,    -1,   155,   156,   157,    -1,   159,   160,    -1,   162,
      -1,   164,   165,   166,   167,   168,    -1,   170,   171,   172,
      -1,   174,   175,   176,   177,   178,   179,    -1,   181,    -1,
     183,   184,   185,   186,   187,   188,   189,    -1,   191,    -1,
     193,    -1,    -1,   196,    -1,   198,   199,   200,   201,   202,
      -1,   204,   205,    -1,   207,   208,    -1,   210,    -1,    -1,
     213,   214,   215,    -1,    -1,   218,   219,   220,   221,   222,
     223,   224,   225,   226,   227,   228,   229,   230,   231,    -1,
     233,   234,   235,   236,    -1,   238,   239,    -1,   241,    -1,
     243,   244,   245,   246,   247,   248,    -1,   250,    -1,    -1,
     253,   254,   255,    -1,    -1,   258,   259,    -1,   261,    -1,
     263,   264,   265,   266,   267,   268,   269,   270,    -1,   272,
     273,   274,   275,   276,   277,   278,    -1,   280,   281,   282,
     283,   284,   285,   286,   287,   288,   289,   290,   291,   292,
      -1,   294,   295,   296,   297,   298,   299,   300,   301,   302,
     303,   304,    -1,   306,   307,    -1,   309,   310,   311,   312,
     313,   314,   315,   316,   317,   318,   319,    -1,   321,   322,
     323,   324,   325,    -1,   327,   328,   329,   330,    -1,   332,
     333,   334,    -1,   336,   337,   338,   339,   340,   341,   342,
     343,   344,   345,   346,    -1,   348,   349,    -1,   351,   352,
     353,   354,   355,   356,    -1,   358,   359,    -1,    -1,   362,
     363,   364,   365,    -1,   367,   368,   369,   370,   371,   372,
     373,    -1,    -1,   376,   377,   378,   379,   380,    -1,    -1,
     383,   384,   385,   386,   387,   388,   389,    -1,   391,    -1,
     393,   394,   395,   396,    -1,    -1,   399,    -1,    -1,   402,
     403,   404,   405,   406,   407,   408,   409,   410,   411,   412,
     413,   414,   415,   416,   417,   418,   419,    -1,    -1,    -1,
      -1,   424,   425,   426,    -1,   428,   429,   430,   431,   432,
     433,     3,    -1,    -1,    -1,    -1,     8,    -1,    -1,    -1,
      -1,    -1,    14,    15,    16,    17,    18,    19,    20,    21,
      -1,    23,    24,    25,    -1,    -1,    -1,    -1,    30,    -1,
      -1,    -1,    34,    35,    -1,    37,    38,    -1,    40,    41,
      42,    43,    44,    -1,    46,    47,    -1,    49,    50,    51,
      52,    53,    -1,    -1,    56,    57,    58,    59,    60,    -1,
      62,    63,    64,    65,    66,    -1,    -1,    -1,    70,    71,
      72,    73,    -1,    75,    76,    -1,    78,    79,    80,    81,
      82,    83,    -1,    -1,    86,    87,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    95,    96,    97,    98,    99,   100,   101,
     102,   103,    -1,   105,    -1,   107,   108,   109,   110,   111,
      -1,   113,   114,   115,    -1,    -1,   118,   119,   120,   121,
     122,    -1,   124,   125,   126,    -1,   128,   129,   130,    -1,
     132,   133,   134,   135,   136,   137,   138,   139,   140,    -1,
     142,    -1,   144,   145,   146,   147,    -1,   149,    -1,   151,
      -1,    -1,    -1,   155,   156,   157,    -1,   159,   160,    -1,
     162,    -1,   164,   165,   166,   167,   168,    -1,   170,   171,
     172,    -1,   174,   175,   176,   177,   178,   179,    -1,   181,
      -1,   183,   184,   185,   186,   187,   188,   189,    -1,   191,
      -1,   193,    -1,    -1,   196,    -1,   198,   199,   200,   201,
     202,    -1,   204,   205,    -1,   207,   208,    -1,   210,    -1,
      -1,   213,   214,   215,    -1,    -1,   218,   219,   220,   221,
     222,   223,   224,   225,   226,   227,   228,   229,   230,   231,
      -1,   233,   234,   235,   236,    -1,   238,   239,    -1,   241,
      -1,   243,   244,   245,   246,   247,   248,    -1,   250,    -1,
      -1,   253,   254,   255,    -1,    -1,   258,   259,    -1,   261,
      -1,   263,   264,   265,   266,   267,   268,   269,   270,    -1,
     272,   273,   274,   275,   276,   277,   278,    -1,   280,   281,
     282,   283,   284,   285,   286,   287,   288,   289,   290,   291,
     292,    -1,   294,   295,   296,   297,   298,   299,   300,   301,
     302,   303,   304,    -1,   306,   307,    -1,   309,   310,   311,
     312,   313,   314,   315,   316,   317,   318,   319,    -1,   321,
     322,   323,   324,   325,    -1,   327,   328,   329,   330,    -1,
     332,   333,   334,    -1,   336,   337,   338,   339,   340,   341,
     342,   343,   344,   345,   346,    -1,   348,   349,    -1,   351,
     352,   353,   354,   355,   356,    -1,   358,   359,    -1,    -1,
     362,   363,   364,   365,    -1,   367,   368,   369,   370,   371,
     372,   373,    -1,    -1,   376,   377,   378,   379,   380,    -1,
      -1,   383,   384,   385,   386,   387,   388,   389,    -1,   391,
      -1,   393,   394,   395,   396,    -1,    -1,   399,    -1,    -1,
     402,   403,   404,   405,   406,   407,   408,   409,   410,   411,
     412,   413,   414,   415,   416,   417,   418,   419,    -1,    -1,
      -1,    -1,   424,   425,   426,    -1,   428,   429,   430,   431,
     432,   433,     3,    -1,    -1,    -1,    -1,     8,    -1,    -1,
      -1,    -1,    -1,    14,    15,    16,    17,    18,    19,    20,
      21,    -1,    23,    24,    25,    -1,    -1,    -1,    -1,    30,
      -1,    -1,    -1,    34,    35,    -1,    37,    38,    -1,    40,
      41,    42,    43,    44,    -1,    46,    47,    -1,    49,    50,
      51,    52,    53,    -1,    -1,    56,    57,    58,    59,    60,
      -1,    62,    63,    64,    65,    66,    -1,    -1,    -1,    70,
      71,    72,    73,    -1,    75,    76,    -1,    78,    79,    80,
      81,    82,    83,    -1,    -1,    86,    87,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    95,    96,    97,    98,    99,   100,
     101,   102,   103,    -1,   105,    -1,   107,   108,   109,   110,
     111,    -1,   113,   114,   115,    -1,    -1,   118,   119,   120,
     121,   122,    -1,   124,   125,   126,    -1,   128,   129,   130,
      -1,   132,   133,   134,   135,   136,   137,   138,   139,   140,
      -1,   142,    -1,   144,   145,   146,   147,    -1,   149,    -1,
     151,    -1,    -1,    -1,   155,   156,   157,    -1,   159,   160,
      -1,   162,    -1,   164,   165,   166,   167,   168,    -1,   170,
     171,   172,    -1,   174,   175,   176,   177,   178,   179,    -1,
     181,    -1,   183,   184,   185,   186,   187,   188,   189,    -1,
     191,    -1,   193,    -1,    -1,   196,    -1,   198,   199,   200,
     201,   202,    -1,   204,   205,    -1,   207,   208,    -1,   210,
      -1,    -1,   213,   214,   215,    -1,    -1,   218,   219,   220,
     221,   222,   223,   224,   225,   226,   227,   228,   229,   230,
     231,    -1,   233,   234,   235,   236,    -1,   238,   239,    -1,
     241,    -1,   243,   244,   245,   246,   247,   248,    -1,   250,
      -1,    -1,   253,   254,   255,    -1,    -1,   258,   259,    -1,
     261,    -1,   263,   264,   265,   266,   267,   268,   269,   270,
      -1,   272,   273,   274,   275,   276,   277,   278,    -1,   280,
     281,   282,   283,   284,   285,   286,   287,   288,   289,   290,
     291,   292,    -1,   294,   295,   296,   297,   298,   299,   300,
     301,   302,   303,   304,    -1,   306,   307,    -1,   309,   310,
     311,   312,   313,   314,   315,   316,   317,   318,   319,    -1,
     321,   322,   323,   324,   325,    -1,   327,   328,   329,   330,
      -1,   332,   333,   334,    -1,   336,   337,   338,   339,   340,
     341,   342,   343,   344,   345,   346,    -1,   348,   349,    -1,
     351,   352,   353,   354,   355,   356,    -1,   358,   359,    -1,
      -1,   362,   363,   364,   365,    -1,   367,   368,   369,   370,
     371,   372,   373,    -1,    -1,   376,   377,   378,   379,   380,
      -1,    -1,   383,   384,   385,   386,   387,   388,   389,    -1,
     391,    -1,   393,   394,   395,   396,    -1,    -1,   399,    -1,
      -1,   402,   403,   404,   405,   406,   407,   408,   409,   410,
     411,   412,   413,   414,   415,   416,   417,   418,   419,    -1,
      -1,    -1,     3,   424,   425,   426,    -1,   428,   429,   430,
     431,   432,   433,    14,    15,    16,    17,    18,    19,    20,
      21,    22,    23,    24,    25,    26,    27,    28,    29,    30,
      31,    32,    33,    34,    35,    36,    37,    38,    39,    40,
      41,    42,    43,    44,    45,    46,    47,    48,    49,    50,
      51,    52,    53,    54,    55,    56,    57,    58,    59,    60,
      61,    62,    63,    64,    65,    66,    67,    68,    69,    70,
      71,    72,    73,    74,    75,    76,    77,    78,    79,    80,
      81,    82,    83,    84,    85,    86,    87,    88,    89,    90,
      91,    92,    93,    94,    95,    96,    97,    98,    99,   100,
     101,   102,   103,   104,   105,   106,   107,   108,   109,   110,
     111,   112,   113,   114,   115,   116,   117,   118,   119,   120,
     121,   122,   123,   124,   125,   126,   127,   128,   129,   130,
     131,   132,   133,   134,   135,   136,   137,   138,   139,   140,
     141,   142,   143,   144,   145,   146,   147,   148,   149,   150,
     151,   152,   153,   154,   155,   156,   157,   158,   159,   160,
     161,   162,   163,   164,   165,   166,   167,   168,   169,   170,
     171,   172,   173,   174,   175,   176,   177,   178,   179,   180,
     181,   182,   183,   184,   185,   186,   187,   188,   189,   190,
     191,   192,   193,   194,   195,   196,   197,   198,   199,   200,
     201,   202,   203,   204,   205,   206,   207,   208,   209,   210,
     211,   212,   213,   214,   215,   216,   217,   218,   219,   220,
     221,   222,   223,   224,   225,   226,   227,   228,   229,   230,
     231,   232,   233,   234,   235,   236,   237,   238,   239,   240,
     241,   242,   243,   244,   245,   246,   247,   248,   249,   250,
     251,   252,   253,   254,   255,   256,   257,   258,   259,   260,
     261,   262,   263,   264,   265,   266,   267,   268,   269,   270,
     271,   272,   273,   274,   275,   276,   277,   278,   279,   280,
     281,   282,   283,   284,   285,   286,   287,   288,   289,   290,
     291,   292,   293,   294,   295,   296,   297,   298,   299,   300,
     301,   302,   303,   304,   305,   306,   307,   308,   309,   310,
     311,   312,   313,   314,   315,   316,   317,   318,   319,   320,
     321,   322,   323,   324,   325,   326,   327,   328,   329,   330,
     331,   332,   333,   334,   335,   336,   337,   338,   339,   340,
     341,   342,   343,   344,   345,   346,   347,   348,   349,   350,
     351,   352,   353,   354,   355,   356,   357,   358,   359,   360,
     361,   362,   363,   364,   365,   366,   367,   368,   369,   370,
     371,   372,   373,   374,   375,   376,   377,   378,   379,   380,
     381,   382,   383,   384,   385,   386,   387,   388,   389,   390,
     391,   392,   393,   394,   395,   396,   397,   398,   399,   400,
     401,   402,   403,   404,   405,   406,   407,   408,   409,   410,
     411,   412,   413,   414,   415,   416,   417,   418,   419,     3,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   430,
      14,    15,    16,    17,    18,    19,    20,    21,    -1,    23,
      24,    25,    -1,    -1,    -1,    -1,    30,    -1,    -1,    -1,
      34,    35,    -1,    37,    38,    -1,    40,    41,    42,    43,
      44,    -1,    46,    47,    -1,    49,    50,    51,    52,    53,
      -1,    -1,    56,    57,    58,    59,    60,    -1,    62,    63,
      64,    65,    66,    -1,    -1,    -1,    70,    71,    72,    73,
      -1,    75,    76,    -1,    78,    79,    80,    81,    82,    83,
      -1,    -1,    86,    87,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    95,    96,    97,    98,    99,   100,   101,   102,   103,
      -1,   105,    -1,   107,   108,   109,   110,   111,    -1,   113,
     114,   115,    -1,    -1,   118,   119,   120,   121,   122,    -1,
     124,   125,   126,    -1,   128,   129,   130,    -1,   132,   133,
     134,   135,   136,   137,   138,   139,   140,    -1,   142,    -1,
     144,   145,   146,   147,    -1,   149,    -1,   151,    -1,    -1,
      -1,   155,   156,   157,    -1,   159,   160,    -1,   162,    -1,
     164,   165,   166,   167,   168,    -1,   170,   171,   172,    -1,
     174,   175,   176,   177,   178,   179,    -1,   181,    -1,   183,
     184,   185,   186,   187,   188,   189,    -1,   191,    -1,   193,
      -1,    -1,   196,    -1,   198,   199,   200,   201,   202,    -1,
     204,   205,    -1,   207,   208,    -1,   210,    -1,    -1,   213,
     214,   215,    -1,    -1,   218,   219,   220,   221,   222,   223,
     224,   225,   226,   227,   228,   229,   230,   231,    -1,   233,
     234,   235,   236,    -1,   238,   239,    -1,   241,    -1,   243,
     244,   245,   246,   247,   248,    -1,   250,    -1,    -1,   253,
     254,   255,    -1,    -1,   258,   259,    -1,   261,    -1,   263,
     264,   265,   266,   267,   268,   269,   270,    -1,   272,   273,
     274,   275,   276,   277,   278,    -1,   280,   281,   282,   283,
     284,   285,   286,   287,   288,   289,   290,   291,   292,    -1,
     294,   295,   296,   297,   298,   299,   300,   301,   302,   303,
     304,    -1,   306,   307,    -1,   309,   310,   311,   312,   313,
     314,   315,   316,   317,   318,   319,    -1,   321,   322,   323,
     324,   325,    -1,   327,   328,   329,   330,    -1,   332,   333,
     334,    -1,   336,   337,   338,   339,   340,   341,   342,   343,
     344,   345,   346,    -1,   348,   349,    -1,   351,   352,   353,
     354,   355,   356,    -1,   358,   359,    -1,    -1,   362,   363,
     364,   365,    -1,   367,   368,   369,   370,   371,   372,   373,
      -1,    -1,   376,   377,   378,   379,   380,    -1,    -1,   383,
     384,   385,   386,   387,   388,   389,    -1,   391,    -1,   393,
     394,   395,   396,    -1,    -1,   399,    -1,    -1,   402,   403,
     404,   405,   406,   407,   408,   409,   410,   411,   412,   413,
     414,   415,   416,   417,   418,   419,     3,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,   430,    14,    15,    16,
      17,    18,    19,    20,    21,    -1,    23,    24,    25,    -1,
      -1,    -1,    -1,    30,    -1,    -1,    -1,    34,    35,    -1,
      37,    38,    39,    40,    41,    42,    -1,    44,    45,    46,
      47,    -1,    49,    50,    51,    52,    53,    -1,    -1,    56,
      57,    58,    59,    60,    -1,    62,    63,    64,    65,    -1,
      -1,    68,    -1,    70,    71,    72,    73,    74,    75,    76,
      -1,    78,    79,    80,    81,    82,    83,    -1,    85,    86,
      87,    -1,    -1,    -1,    91,    -1,    -1,    -1,    95,    96,
      97,    98,    99,   100,   101,   102,   103,    -1,   105,    -1,
     107,   108,   109,   110,   111,    -1,   113,   114,   115,    -1,
      -1,   118,   119,   120,   121,   122,    -1,   124,   125,   126,
      -1,   128,   129,   130,    -1,   132,   133,   134,   135,    -1,
     137,   138,   139,    -1,    -1,   142,    -1,   144,   145,   146,
     147,    -1,   149,    -1,   151,   152,    -1,   154,   155,   156,
     157,    -1,   159,    -1,    -1,   162,    -1,   164,   165,   166,
     167,   168,   169,   170,   171,   172,   173,   174,   175,   176,
     177,   178,   179,    -1,   181,   182,   183,   184,   185,   186,
     187,   188,   189,    -1,   191,    -1,   193,   194,   195,   196,
     197,   198,   199,   200,   201,   202,    -1,   204,   205,    -1,
     207,    -1,   209,   210,   211,    -1,   213,   214,   215,    -1,
      -1,   218,   219,   220,   221,   222,   223,   224,   225,   226,
     227,   228,   229,   230,   231,   232,   233,   234,   235,    -1,
      -1,   238,   239,   240,   241,    -1,    -1,   244,   245,   246,
     247,   248,    -1,   250,    -1,    -1,   253,   254,   255,    -1,
     257,   258,   259,   260,   261,   262,    -1,   264,   265,   266,
     267,   268,   269,   270,    -1,   272,    -1,   274,    -1,   276,
     277,   278,    -1,   280,   281,   282,   283,   284,   285,   286,
     287,   288,   289,   290,   291,   292,    -1,   294,   295,   296,
     297,   298,   299,   300,   301,   302,   303,   304,    -1,   306,
     307,   308,   309,   310,    -1,   312,   313,   314,   315,   316,
     317,   318,   319,    -1,   321,   322,   323,   324,   325,    -1,
     327,   328,   329,   330,   331,   332,   333,   334,    -1,   336,
     337,   338,   339,   340,   341,   342,   343,   344,   345,    -1,
      -1,   348,   349,    -1,   351,   352,   353,   354,   355,   356,
      -1,   358,   359,    -1,    -1,   362,    -1,   364,    -1,    -1,
     367,   368,   369,   370,   371,   372,   373,    -1,    -1,   376,
     377,   378,   379,   380,    -1,    -1,   383,   384,   385,   386,
     387,    -1,   389,   390,   391,   392,   393,   394,   395,   396,
      -1,    -1,   399,    -1,    -1,   402,   403,   404,   405,   406,
     407,    -1,    -1,    -1,     3,    -1,    -1,    -1,    -1,    -1,
     417,   418,   419,    -1,    -1,    14,    15,    16,    17,    18,
      19,    20,    21,   430,    23,    24,    25,    -1,    -1,    -1,
      -1,    30,    -1,    -1,    -1,    34,    35,    -1,    37,    38,
      39,    40,    41,    42,    -1,    44,    45,    46,    47,    -1,
      49,    50,    51,    52,    53,    -1,    -1,    56,    57,    58,
      59,    60,    -1,    62,    63,    64,    65,    -1,    -1,    68,
      -1,    70,    71,    72,    73,    74,    75,    76,    -1,    78,
      79,    80,    81,    82,    83,    -1,    85,    86,    87,    -1,
      -1,    -1,    91,    -1,    -1,    -1,    95,    96,    97,    98,
      99,   100,   101,   102,   103,    -1,   105,    -1,   107,   108,
     109,   110,   111,    -1,   113,   114,   115,    -1,    -1,   118,
     119,   120,   121,   122,    -1,   124,   125,   126,    -1,   128,
     129,   130,    -1,   132,   133,   134,   135,    -1,   137,   138,
     139,    -1,    -1,   142,    -1,   144,   145,   146,   147,    -1,
     149,    -1,   151,   152,    -1,   154,   155,   156,   157,    -1,
     159,    -1,    -1,   162,    -1,   164,   165,   166,   167,   168,
     169,   170,   171,   172,   173,   174,   175,   176,   177,   178,
     179,    -1,   181,   182,   183,   184,   185,   186,   187,   188,
     189,    -1,   191,    -1,   193,   194,   195,   196,   197,   198,
     199,   200,   201,   202,    -1,   204,   205,    -1,   207,    -1,
     209,   210,   211,    -1,   213,   214,   215,    -1,    -1,   218,
     219,   220,   221,   222,   223,   224,   225,   226,   227,   228,
     229,   230,   231,   232,   233,   234,   235,    -1,    -1,   238,
     239,   240,   241,    -1,    -1,   244,   245,   246,   247,   248,
      -1,   250,    -1,    -1,   253,   254,   255,    -1,   257,   258,
     259,   260,   261,   262,    -1,   264,   265,   266,   267,   268,
     269,   270,    -1,   272,    -1,   274,    -1,   276,   277,   278,
      -1,   280,   281,   282,   283,   284,   285,   286,   287,   288,
     289,   290,   291,   292,    -1,   294,   295,   296,   297,   298,
     299,   300,   301,   302,   303,   304,    -1,   306,   307,   308,
     309,   310,    -1,   312,   313,   314,   315,   316,   317,   318,
     319,    -1,   321,   322,   323,   324,   325,    -1,   327,   328,
     329,   330,   331,   332,   333,   334,    -1,   336,   337,   338,
     339,   340,   341,   342,   343,   344,   345,    -1,    -1,   348,
     349,    -1,   351,   352,   353,   354,   355,   356,    -1,   358,
     359,    -1,    -1,   362,    -1,   364,    -1,    -1,   367,   368,
     369,   370,   371,   372,   373,    -1,    -1,   376,   377,   378,
     379,   380,    -1,    -1,   383,   384,   385,   386,   387,    -1,
     389,   390,   391,   392,   393,   394,   395,   396,    -1,    -1,
     399,    -1,    -1,   402,   403,   404,   405,   406,   407,    -1,
      -1,    -1,     3,    -1,    -1,    -1,    -1,    -1,   417,   418,
     419,    -1,    -1,    14,    15,    16,    17,    18,    19,    20,
      21,   430,    23,    24,    25,    -1,    -1,    -1,    -1,    30,
      -1,    -1,    -1,    34,    35,    -1,    37,    38,    -1,    40,
      41,    42,    43,    44,    -1,    46,    47,    -1,    49,    50,
      51,    52,    53,    -1,    -1,    56,    57,    58,    59,    60,
      -1,    62,    63,    64,    65,    66,    -1,    -1,    -1,    70,
      71,    72,    73,    -1,    75,    76,    -1,    78,    79,    80,
      81,    82,    83,    -1,    -1,    86,    87,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    95,    96,    97,    98,    99,   100,
     101,   102,   103,    -1,   105,    -1,   107,   108,   109,   110,
     111,    -1,   113,   114,   115,    -1,    -1,   118,   119,   120,
     121,   122,    -1,   124,   125,   126,    -1,   128,   129,   130,
      -1,   132,   133,   134,   135,   136,   137,   138,   139,   140,
      -1,   142,    -1,   144,   145,   146,   147,    -1,   149,    -1,
     151,    -1,    -1,    -1,   155,   156,   157,    -1,   159,   160,
      -1,   162,    -1,   164,   165,   166,   167,   168,    -1,   170,
     171,   172,    -1,   174,   175,   176,   177,   178,   179,    -1,
     181,    -1,   183,   184,   185,   186,   187,   188,   189,    -1,
     191,    -1,   193,    -1,    -1,   196,    -1,   198,   199,   200,
     201,   202,    -1,   204,   205,    -1,   207,   208,    -1,   210,
      -1,    -1,   213,   214,   215,    -1,    -1,   218,   219,   220,
     221,   222,   223,   224,   225,   226,   227,   228,   229,   230,
     231,    -1,   233,   234,   235,   236,    -1,   238,   239,    -1,
     241,    -1,   243,   244,   245,   246,   247,   248,    -1,   250,
      -1,    -1,   253,   254,   255,    -1,    -1,   258,   259,    -1,
     261,    -1,   263,   264,   265,   266,   267,   268,   269,   270,
      -1,   272,   273,   274,   275,   276,   277,   278,    -1,   280,
     281,   282,   283,   284,   285,   286,   287,   288,   289,   290,
     291,   292,    -1,   294,   295,   296,   297,   298,   299,   300,
     301,   302,   303,   304,    -1,   306,   307,    -1,   309,   310,
     311,   312,   313,   314,   315,   316,   317,   318,   319,    -1,
     321,   322,   323,   324,   325,    -1,   327,   328,   329,   330,
      -1,   332,   333,   334,    -1,   336,   337,   338,   339,   340,
     341,   342,   343,   344,   345,   346,    -1,   348,   349,    -1,
     351,   352,   353,   354,   355,   356,    -1,   358,   359,    -1,
      -1,   362,   363,   364,   365,    -1,   367,   368,   369,   370,
     371,   372,   373,    -1,    -1,   376,   377,   378,   379,   380,
      -1,    -1,   383,   384,   385,   386,   387,   388,   389,    -1,
     391,    -1,   393,   394,   395,   396,    -1,    -1,   399,    -1,
      -1,   402,   403,   404,   405,   406,   407,   408,   409,   410,
     411,   412,   413,   414,   415,   416,   417,   418,   419,     3,
       4,     5,    -1,    -1,    -1,     9,    -1,    -1,    -1,   430,
      14,    15,    16,    17,    18,    19,    20,    21,    -1,    23,
      24,    25,    -1,    -1,    -1,    -1,    30,    -1,    -1,    -1,
      34,    35,    -1,    37,    38,    39,    40,    41,    42,    43,
      44,    45,    46,    47,    -1,    49,    50,    51,    52,    53,
      -1,    -1,    56,    57,    58,    59,    60,    -1,    62,    63,
      64,    65,    66,    -1,    68,    -1,    70,    71,    72,    73,
      74,    75,    76,    -1,    78,    79,    80,    81,    82,    83,
      -1,    85,    86,    87,    -1,    -1,    -1,    91,    -1,    -1,
      -1,    95,    96,    97,    98,    99,   100,   101,   102,   103,
     104,   105,    -1,   107,   108,   109,   110,   111,    -1,   113,
     114,   115,    -1,    -1,   118,   119,   120,   121,   122,    -1,
     124,   125,   126,    -1,   128,   129,   130,    -1,   132,   133,
     134,   135,   136,   137,   138,   139,   140,   141,   142,    -1,
     144,   145,   146,   147,    -1,   149,    -1,   151,   152,    -1,
     154,   155,   156,   157,    -1,   159,   160,    -1,   162,    -1,
     164,   165,   166,   167,   168,   169,   170,   171,   172,    -1,
     174,   175,   176,   177,   178,   179,    -1,   181,   182,   183,
     184,   185,   186,   187,   188,   189,    -1,   191,    -1,   193,
     194,   195,   196,   197,   198,   199,   200,   201,   202,    -1,
     204,   205,    -1,   207,   208,   209,   210,   211,    -1,   213,
     214,   215,    -1,    -1,   218,   219,   220,   221,   222,   223,
     224,   225,   226,   227,   228,   229,   230,   231,   232,   233,
     234,   235,   236,    -1,   238,   239,   240,   241,    -1,   243,
     244,   245,   246,   247,   248,    -1,   250,   251,    -1,   253,
     254,   255,    -1,    -1,   258,   259,   260,   261,   262,   263,
     264,   265,   266,   267,   268,   269,   270,    -1,   272,   273,
     274,   275,   276,   277,   278,    -1,   280,   281,   282,   283,
     284,   285,   286,   287,   288,   289,   290,   291,   292,    -1,
     294,   295,   296,   297,   298,   299,   300,   301,   302,   303,
     304,    -1,   306,   307,   308,   309,   310,   311,   312,   313,
     314,   315,   316,   317,   318,   319,    -1,   321,   322,   323,
     324,   325,    -1,   327,   328,   329,   330,   331,   332,   333,
     334,    -1,   336,   337,   338,   339,   340,   341,   342,   343,
     344,   345,   346,    -1,   348,   349,    -1,   351,   352,   353,
     354,   355,   356,    -1,   358,   359,    -1,    -1,   362,   363,
     364,   365,   366,   367,   368,   369,   370,   371,   372,   373,
      -1,    -1,   376,   377,   378,   379,   380,    -1,    -1,   383,
     384,   385,   386,   387,   388,   389,    -1,   391,   392,   393,
     394,   395,   396,    -1,    -1,   399,    -1,    -1,   402,   403,
     404,   405,   406,   407,   408,   409,   410,   411,   412,   413,
     414,   415,   416,   417,   418,   419,     3,     4,     5,    -1,
      -1,    -1,     9,    -1,   428,   429,    -1,    14,    15,    16,
      17,    18,    19,    20,    21,    -1,    23,    24,    25,    -1,
      -1,    -1,    -1,    30,    -1,    -1,    -1,    34,    35,    -1,
      37,    38,    39,    40,    41,    42,    43,    44,    45,    46,
      47,    -1,    49,    50,    51,    52,    53,    -1,    -1,    56,
      57,    58,    59,    60,    -1,    62,    63,    64,    65,    66,
      -1,    68,    -1,    70,    71,    72,    73,    74,    75,    76,
      -1,    78,    79,    80,    81,    82,    83,    -1,    85,    86,
      87,    -1,    -1,    -1,    91,    -1,    -1,    -1,    95,    96,
      97,    98,    99,   100,   101,   102,   103,   104,   105,    -1,
     107,   108,   109,   110,   111,    -1,   113,   114,   115,    -1,
      -1,   118,   119,   120,   121,   122,    -1,   124,   125,   126,
      -1,   128,   129,   130,    -1,   132,   133,   134,   135,   136,
     137,   138,   139,   140,   141,   142,    -1,   144,   145,   146,
     147,    -1,   149,    -1,   151,   152,    -1,   154,   155,   156,
     157,    -1,   159,   160,    -1,   162,    -1,   164,   165,   166,
     167,   168,   169,   170,   171,   172,    -1,   174,   175,   176,
     177,   178,   179,    -1,   181,   182,   183,   184,   185,   186,
     187,   188,   189,    -1,   191,    -1,   193,   194,   195,   196,
     197,   198,   199,   200,   201,   202,    -1,   204,   205,    -1,
     207,   208,   209,   210,   211,    -1,   213,   214,   215,    -1,
      -1,   218,   219,   220,   221,   222,   223,   224,   225,   226,
     227,   228,   229,   230,   231,   232,   233,   234,   235,   236,
      -1,   238,   239,   240,   241,    -1,   243,   244,   245,   246,
     247,   248,    -1,   250,   251,    -1,   253,   254,   255,    -1,
      -1,   258,   259,   260,   261,   262,   263,   264,   265,   266,
     267,   268,   269,   270,    -1,   272,   273,   274,   275,   276,
     277,   278,    -1,   280,   281,   282,   283,   284,   285,   286,
     287,   288,   289,   290,   291,   292,    -1,   294,   295,   296,
     297,   298,   299,   300,   301,   302,   303,   304,    -1,   306,
     307,   308,   309,   310,   311,   312,   313,   314,   315,   316,
     317,   318,   319,    -1,   321,   322,   323,   324,   325,    -1,
     327,   328,   329,   330,   331,   332,   333,   334,    -1,   336,
     337,   338,   339,   340,   341,   342,   343,   344,   345,   346,
      -1,   348,   349,    -1,   351,   352,   353,   354,   355,   356,
      -1,   358,   359,    -1,    -1,   362,   363,   364,   365,   366,
     367,   368,   369,   370,   371,   372,   373,    -1,    -1,   376,
     377,   378,   379,   380,    -1,    -1,   383,   384,   385,   386,
     387,   388,   389,    -1,   391,   392,   393,   394,   395,   396,
      -1,    -1,   399,    -1,    -1,   402,   403,   404,   405,   406,
     407,   408,   409,   410,   411,   412,   413,   414,   415,   416,
     417,   418,   419,     3,     4,     5,    -1,    -1,    -1,     9,
      -1,   428,   429,    -1,    14,    15,    16,    17,    18,    19,
      20,    21,    -1,    23,    24,    25,    -1,    -1,    -1,    -1,
      30,    -1,    -1,    -1,    34,    35,    -1,    37,    38,    39,
      40,    41,    42,    43,    44,    45,    46,    47,    -1,    49,
      50,    51,    52,    53,    -1,    -1,    56,    57,    58,    59,
      60,    -1,    62,    63,    64,    65,    66,    -1,    68,    -1,
      70,    71,    72,    73,    74,    75,    76,    -1,    78,    79,
      80,    81,    82,    83,    -1,    85,    86,    87,    -1,    -1,
      -1,    91,    -1,    -1,    -1,    95,    96,    97,    98,    99,
     100,   101,   102,   103,    -1,   105,    -1,   107,   108,   109,
     110,   111,    -1,   113,   114,   115,    -1,    -1,   118,   119,
     120,   121,   122,    -1,   124,   125,   126,    -1,   128,   129,
     130,    -1,   132,   133,   134,   135,   136,   137,   138,   139,
     140,   141,   142,    -1,   144,   145,   146,   147,    -1,   149,
      -1,   151,   152,    -1,   154,   155,   156,   157,    -1,   159,
     160,    -1,   162,    -1,   164,   165,   166,   167,   168,   169,
     170,   171,   172,    -1,   174,   175,   176,   177,   178,   179,
      -1,   181,   182,   183,   184,   185,   186,   187,   188,   189,
      -1,   191,    -1,   193,   194,   195,   196,   197,   198,   199,
     200,   201,   202,    -1,   204,   205,    -1,   207,   208,   209,
     210,   211,    -1,   213,   214,   215,    -1,    -1,   218,   219,
     220,   221,   222,   223,   224,   225,   226,   227,   228,   229,
     230,   231,   232,   233,   234,   235,   236,    -1,   238,   239,
     240,   241,    -1,   243,   244,   245,   246,   247,   248,    -1,
     250,   251,    -1,   253,   254,   255,    -1,    -1,   258,   259,
     260,   261,   262,   263,   264,   265,   266,   267,   268,   269,
     270,    -1,   272,   273,   274,   275,   276,   277,   278,    -1,
     280,   281,   282,   283,   284,   285,   286,   287,   288,   289,
     290,   291,   292,    -1,   294,   295,   296,   297,   298,   299,
     300,   301,   302,   303,   304,    -1,   306,   307,   308,   309,
     310,   311,   312,   313,   314,   315,   316,   317,   318,   319,
      -1,   321,   322,   323,   324,   325,    -1,   327,   328,   329,
     330,   331,   332,   333,   334,    -1,   336,   337,   338,   339,
     340,   341,   342,   343,   344,   345,   346,    -1,   348,   349,
      -1,   351,   352,   353,   354,   355,   356,    -1,   358,   359,
      -1,    -1,   362,   363,   364,   365,   366,   367,   368,   369,
     370,   371,   372,   373,    -1,    -1,   376,   377,   378,   379,
     380,    -1,    -1,   383,   384,   385,   386,   387,   388,   389,
      -1,   391,   392,   393,   394,   395,   396,    -1,    -1,   399,
      -1,    -1,   402,   403,   404,   405,   406,   407,   408,   409,
     410,   411,   412,   413,   414,   415,   416,   417,   418,   419,
       3,    -1,    -1,    -1,    -1,    -1,     9,    -1,   428,   429,
      -1,    14,    15,    16,    17,    18,    19,    20,    21,    22,
      23,    24,    25,    -1,    -1,    -1,    -1,    30,    -1,    -1,
      -1,    34,    35,    -1,    37,    38,    -1,    40,    41,    42,
      43,    44,    -1,    46,    47,    -1,    49,    50,    51,    52,
      53,    -1,    -1,    56,    57,    58,    59,    60,    -1,    62,
      63,    64,    65,    66,    -1,    -1,    -1,    70,    71,    72,
      73,    -1,    75,    76,    -1,    78,    79,    80,    81,    82,
      83,    -1,    -1,    86,    87,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    95,    96,    97,    98,    99,   100,   101,   102,
     103,    -1,   105,    -1,   107,   108,   109,   110,   111,    -1,
     113,   114,   115,    -1,    -1,   118,   119,   120,   121,   122,
      -1,   124,   125,   126,    -1,   128,   129,   130,    -1,   132,
     133,   134,   135,   136,   137,   138,   139,   140,    -1,   142,
      -1,   144,   145,   146,   147,    -1,   149,    -1,   151,    -1,
     153,    -1,   155,   156,   157,    -1,   159,   160,    -1,   162,
      -1,   164,   165,   166,   167,   168,    -1,   170,   171,   172,
     173,   174,   175,   176,   177,   178,   179,    -1,   181,    -1,
     183,   184,   185,   186,   187,   188,   189,    -1,   191,    -1,
     193,    -1,    -1,   196,    -1,   198,   199,   200,   201,   202,
      -1,   204,   205,    -1,   207,   208,    -1,   210,    -1,    -1,
     213,   214,   215,    -1,    -1,   218,   219,   220,   221,   222,
     223,   224,   225,   226,   227,   228,   229,   230,   231,    -1,
     233,   234,   235,   236,    -1,   238,   239,    -1,   241,    -1,
     243,   244,   245,   246,   247,   248,    -1,   250,    -1,    -1,
     253,   254,   255,    -1,    -1,   258,   259,    -1,   261,    -1,
     263,   264,   265,   266,   267,   268,   269,   270,    -1,   272,
     273,   274,   275,   276,   277,   278,    -1,   280,   281,   282,
     283,   284,   285,   286,   287,   288,   289,   290,   291,   292,
      -1,   294,   295,   296,   297,   298,   299,   300,   301,   302,
     303,   304,    -1,   306,   307,    -1,   309,   310,   311,   312,
     313,   314,   315,   316,   317,   318,   319,    -1,   321,   322,
     323,   324,   325,    -1,   327,   328,   329,   330,    -1,   332,
     333,   334,    -1,   336,   337,   338,   339,   340,   341,   342,
     343,   344,   345,   346,    -1,   348,   349,    -1,   351,   352,
     353,   354,   355,   356,    -1,   358,   359,    -1,    -1,   362,
     363,   364,   365,    -1,   367,   368,   369,   370,   371,   372,
     373,    -1,    -1,   376,   377,   378,   379,   380,    -1,    -1,
     383,   384,   385,   386,   387,   388,   389,    -1,   391,    -1,
     393,   394,   395,   396,    -1,    -1,   399,    -1,    -1,   402,
     403,   404,   405,   406,   407,   408,   409,   410,   411,   412,
     413,   414,   415,   416,   417,   418,   419,     3,     4,     5,
      -1,    -1,    -1,     9,    -1,   428,   429,    -1,    14,    15,
      16,    17,    18,    19,    20,    21,    22,    23,    24,    25,
      26,    27,    28,    29,    30,    31,    32,    33,    34,    35,
      36,    37,    38,    39,    40,    41,    42,    43,    44,    45,
      46,    47,    48,    49,    50,    51,    52,    53,    54,    55,
      56,    57,    58,    59,    60,    61,    62,    63,    64,    65,
      66,    67,    68,    69,    70,    71,    72,    73,    74,    75,
      76,    77,    78,    79,    80,    81,    82,    83,    84,    85,
      86,    87,    88,    89,    90,    91,    92,    93,    94,    95,
      96,    97,    98,    99,   100,   101,   102,   103,   104,   105,
     106,   107,   108,   109,   110,   111,   112,   113,   114,   115,
     116,   117,   118,   119,   120,   121,   122,   123,   124,   125,
     126,   127,   128,   129,   130,   131,   132,   133,   134,   135,
     136,   137,   138,   139,   140,   141,   142,   143,   144,   145,
     146,   147,   148,   149,   150,   151,   152,   153,   154,   155,
     156,   157,   158,   159,   160,   161,   162,   163,   164,   165,
     166,   167,   168,   169,   170,   171,   172,   173,   174,   175,
     176,   177,   178,   179,   180,   181,   182,   183,   184,   185,
     186,   187,   188,   189,   190,   191,   192,   193,   194,   195,
     196,   197,   198,   199,   200,   201,   202,   203,   204,   205,
     206,   207,   208,   209,   210,   211,   212,   213,   214,   215,
     216,   217,   218,   219,   220,   221,   222,   223,   224,   225,
     226,   227,   228,   229,   230,   231,   232,   233,   234,   235,
     236,   237,   238,   239,   240,   241,   242,   243,   244,   245,
     246,   247,   248,   249,   250,   251,   252,   253,   254,   255,
     256,   257,   258,   259,   260,   261,   262,   263,   264,   265,
     266,   267,   268,   269,   270,   271,   272,   273,   274,   275,
     276,   277,   278,   279,   280,   281,   282,   283,   284,   285,
     286,   287,   288,   289,   290,   291,   292,   293,   294,   295,
     296,   297,   298,   299,   300,   301,   302,   303,   304,   305,
     306,   307,   308,   309,   310,   311,   312,   313,   314,   315,
     316,   317,   318,   319,   320,   321,   322,   323,   324,   325,
     326,   327,   328,   329,   330,   331,   332,   333,   334,   335,
     336,   337,   338,   339,   340,   341,   342,   343,   344,   345,
     346,   347,   348,   349,   350,   351,   352,   353,   354,   355,
     356,   357,   358,   359,   360,   361,   362,   363,   364,   365,
     366,   367,   368,   369,   370,   371,   372,   373,   374,   375,
     376,   377,   378,   379,   380,   381,   382,   383,   384,   385,
     386,   387,   388,   389,   390,   391,   392,   393,   394,   395,
     396,   397,   398,   399,   400,   401,   402,   403,   404,   405,
     406,   407,   408,   409,   410,   411,   412,   413,   414,   415,
     416,   417,   418,   419,     3,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    14,    15,    16,    17,    18,
      19,    20,    21,    22,    23,    24,    25,    26,    27,    28,
      29,    30,    31,    32,    33,    34,    35,    36,    37,    38,
      39,    40,    41,    42,    43,    44,    45,    46,    47,    48,
      49,    50,    51,    52,    53,    54,    55,    56,    57,    58,
      59,    60,    61,    62,    63,    64,    65,    66,    67,    68,
      69,    70,    71,    72,    73,    74,    75,    76,    77,    78,
      79,    80,    81,    82,    83,    84,    85,    86,    87,    88,
      89,    90,    91,    92,    93,    94,    95,    96,    97,    98,
      99,   100,   101,   102,   103,   104,   105,   106,   107,   108,
     109,   110,   111,   112,   113,   114,   115,   116,   117,   118,
     119,   120,   121,   122,   123,   124,   125,   126,   127,   128,
     129,   130,   131,   132,   133,   134,   135,   136,   137,   138,
     139,   140,   141,   142,   143,   144,   145,   146,   147,   148,
     149,   150,   151,   152,   153,   154,   155,   156,   157,   158,
     159,   160,   161,   162,   163,   164,   165,   166,   167,   168,
     169,   170,   171,   172,   173,   174,   175,   176,   177,   178,
     179,   180,   181,   182,   183,   184,   185,   186,   187,   188,
     189,   190,   191,   192,   193,   194,   195,   196,   197,   198,
     199,   200,   201,   202,   203,   204,   205,   206,   207,   208,
     209,   210,   211,   212,   213,   214,   215,   216,   217,   218,
     219,   220,   221,   222,   223,   224,   225,   226,   227,   228,
     229,   230,   231,   232,   233,   234,   235,   236,   237,   238,
     239,   240,   241,   242,   243,   244,   245,   246,   247,   248,
     249,   250,   251,   252,   253,   254,   255,   256,   257,   258,
     259,   260,   261,   262,   263,   264,   265,   266,   267,   268,
     269,   270,   271,   272,   273,   274,   275,   276,   277,   278,
     279,   280,   281,   282,   283,   284,   285,   286,   287,   288,
     289,   290,   291,   292,   293,   294,   295,   296,   297,   298,
     299,   300,   301,   302,   303,   304,   305,   306,   307,   308,
     309,   310,   311,   312,   313,   314,   315,   316,   317,   318,
     319,   320,   321,   322,   323,   324,   325,   326,   327,   328,
     329,   330,   331,   332,   333,   334,   335,   336,   337,   338,
     339,   340,   341,   342,   343,   344,   345,   346,   347,   348,
     349,   350,   351,   352,   353,   354,   355,   356,   357,   358,
     359,   360,   361,   362,   363,   364,   365,   366,   367,   368,
     369,   370,   371,   372,   373,   374,   375,   376,   377,   378,
     379,   380,   381,   382,   383,   384,   385,   386,   387,   388,
     389,   390,   391,   392,   393,   394,   395,   396,   397,   398,
     399,   400,   401,   402,   403,   404,   405,   406,   407,   408,
     409,   410,   411,   412,   413,   414,   415,   416,   417,   418,
     419,     3,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    14,    15,    16,    17,    18,    19,    20,    21,
      22,    23,    24,    25,    26,    27,    28,    29,    30,    31,
      32,    33,    34,    35,    36,    37,    38,    39,    40,    41,
      42,    43,    44,    45,    46,    47,    48,    49,    50,    51,
      52,    53,    54,    55,    56,    57,    58,    59,    60,    61,
      62,    63,    64,    65,    66,    67,    68,    69,    70,    71,
      72,    73,    74,    75,    76,    77,    78,    79,    80,    81,
      82,    83,    84,    85,    86,    87,    88,    89,    90,    91,
      92,    93,    94,    95,    96,    97,    98,    99,   100,   101,
     102,   103,   104,   105,   106,   107,   108,   109,   110,   111,
     112,   113,   114,   115,   116,   117,   118,   119,   120,   121,
     122,   123,   124,   125,   126,   127,   128,   129,   130,   131,
     132,   133,   134,   135,   136,   137,   138,   139,   140,   141,
     142,   143,   144,   145,   146,   147,   148,   149,   150,   151,
     152,   153,   154,   155,   156,   157,   158,   159,   160,   161,
     162,   163,   164,   165,   166,   167,   168,   169,   170,   171,
     172,   173,   174,   175,   176,   177,   178,   179,   180,   181,
     182,   183,   184,   185,   186,   187,   188,   189,   190,   191,
     192,   193,   194,   195,   196,   197,   198,   199,   200,   201,
     202,   203,   204,   205,   206,   207,   208,   209,   210,   211,
     212,   213,   214,   215,   216,   217,   218,   219,   220,   221,
     222,   223,   224,   225,   226,   227,   228,   229,   230,   231,
     232,   233,   234,   235,   236,   237,   238,   239,   240,   241,
     242,   243,   244,   245,   246,   247,   248,   249,   250,   251,
     252,   253,   254,   255,   256,   257,   258,   259,   260,   261,
     262,   263,   264,   265,   266,   267,   268,   269,   270,   271,
     272,   273,   274,   275,   276,   277,   278,   279,   280,   281,
     282,   283,   284,   285,   286,   287,   288,   289,   290,   291,
     292,   293,   294,   295,   296,   297,   298,   299,   300,   301,
     302,   303,   304,   305,   306,   307,   308,   309,   310,   311,
     312,   313,   314,   315,   316,   317,   318,   319,   320,   321,
     322,   323,   324,   325,   326,   327,   328,   329,   330,   331,
     332,   333,   334,   335,   336,   337,   338,   339,   340,   341,
     342,   343,   344,   345,   346,   347,   348,   349,   350,   351,
     352,   353,   354,   355,   356,   357,   358,   359,   360,   361,
     362,   363,   364,   365,   366,   367,   368,   369,   370,   371,
     372,   373,   374,   375,   376,   377,   378,   379,   380,   381,
     382,   383,   384,   385,   386,   387,   388,   389,   390,   391,
     392,   393,   394,   395,   396,   397,   398,   399,   400,   401,
     402,   403,   404,   405,   406,   407,   408,   409,   410,   411,
     412,   413,   414,   415,   416,   417,   418,   419,     3,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    14,
      15,    16,    17,    18,    19,    20,    21,    -1,    23,    24,
      25,    -1,    -1,    -1,    -1,    30,    -1,    -1,    -1,    34,
      35,    -1,    37,    38,    39,    40,    41,    42,    43,    44,
      45,    46,    47,    -1,    49,    50,    51,    52,    53,    -1,
      55,    56,    57,    58,    59,    60,    -1,    62,    63,    64,
      65,    66,    -1,    68,    -1,    70,    71,    72,    73,    74,
      75,    76,    -1,    78,    79,    80,    81,    82,    83,    -1,
      85,    86,    87,    88,    89,    90,    91,    92,    93,    94,
      95,    96,    97,    98,    99,   100,   101,   102,   103,    -1,
     105,    -1,   107,   108,   109,   110,   111,    -1,   113,   114,
     115,    -1,    -1,   118,   119,   120,   121,   122,    -1,   124,
     125,   126,    -1,   128,   129,   130,    -1,   132,   133,   134,
     135,   136,   137,   138,   139,   140,    -1,   142,    -1,   144,
     145,   146,   147,    -1,   149,    -1,   151,   152,    -1,   154,
     155,   156,   157,    -1,   159,   160,    -1,   162,    -1,   164,
     165,   166,   167,   168,   169,   170,   171,   172,    -1,   174,
     175,   176,   177,   178,   179,    -1,   181,   182,   183,   184,
     185,   186,   187,   188,   189,    -1,   191,    -1,   193,   194,
     195,   196,   197,   198,   199,   200,   201,   202,    -1,   204,
     205,    -1,   207,   208,   209,   210,   211,    -1,   213,   214,
     215,   216,   217,   218,   219,   220,   221,   222,   223,   224,
     225,   226,   227,   228,   229,   230,   231,   232,   233,   234,
     235,   236,    -1,   238,   239,   240,   241,    -1,   243,   244,
     245,   246,   247,   248,    -1,   250,    -1,    -1,   253,   254,
     255,    -1,    -1,   258,   259,   260,   261,   262,   263,   264,
     265,   266,   267,   268,   269,   270,    -1,   272,   273,   274,
     275,   276,   277,   278,    -1,   280,   281,   282,   283,   284,
     285,   286,   287,   288,   289,   290,   291,   292,    -1,   294,
     295,   296,   297,   298,   299,   300,   301,   302,   303,   304,
      -1,   306,   307,   308,   309,   310,   311,   312,   313,   314,
     315,   316,   317,   318,   319,    -1,   321,   322,   323,   324,
     325,   326,   327,   328,   329,   330,   331,   332,   333,   334,
      -1,   336,   337,   338,   339,   340,   341,   342,   343,   344,
     345,   346,    -1,   348,   349,    -1,   351,   352,   353,   354,
     355,   356,    -1,   358,   359,    -1,    -1,   362,   363,   364,
     365,    -1,   367,   368,   369,   370,   371,   372,   373,    -1,
      -1,   376,   377,   378,   379,   380,   381,    -1,   383,   384,
     385,   386,   387,   388,   389,    -1,   391,   392,   393,   394,
     395,   396,    -1,    -1,   399,    -1,    -1,   402,   403,   404,
     405,   406,   407,   408,   409,   410,   411,   412,   413,   414,
     415,   416,   417,   418,   419,     3,    -1,     5,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    14,    15,    16,    17,
      18,    19,    20,    21,    -1,    23,    24,    25,    -1,    -1,
      -1,    -1,    30,    -1,    -1,    -1,    34,    35,    -1,    37,
      38,    39,    40,    41,    42,    43,    44,    45,    46,    47,
      -1,    49,    50,    51,    52,    53,    -1,    -1,    56,    57,
      58,    59,    60,    -1,    62,    63,    64,    65,    66,    -1,
      68,    -1,    70,    71,    72,    73,    74,    75,    76,    -1,
      78,    79,    80,    81,    82,    83,    -1,    85,    86,    87,
      -1,    -1,    -1,    91,    -1,    -1,    -1,    95,    96,    97,
      98,    99,   100,   101,   102,   103,    -1,   105,    -1,   107,
     108,   109,   110,   111,    -1,   113,   114,   115,    -1,    -1,
     118,   119,   120,   121,   122,    -1,   124,   125,   126,    -1,
     128,   129,   130,    -1,   132,   133,   134,   135,   136,   137,
     138,   139,   140,   141,   142,    -1,   144,   145,   146,   147,
      -1,   149,    -1,   151,   152,    -1,   154,   155,   156,   157,
      -1,   159,   160,    -1,   162,    -1,   164,   165,   166,   167,
     168,   169,   170,   171,   172,    -1,   174,   175,   176,   177,
     178,   179,    -1,   181,   182,   183,   184,   185,   186,   187,
     188,   189,    -1,   191,    -1,   193,   194,   195,   196,   197,
     198,   199,   200,   201,   202,    -1,   204,   205,    -1,   207,
     208,   209,   210,   211,    -1,   213,   214,   215,    -1,    -1,
     218,   219,   220,   221,   222,   223,   224,   225,   226,   227,
     228,   229,   230,   231,   232,   233,   234,   235,   236,    -1,
     238,   239,   240,   241,    -1,   243,   244,   245,   246,   247,
     248,    -1,   250,   251,    -1,   253,   254,   255,    -1,    -1,
     258,   259,   260,   261,   262,   263,   264,   265,   266,   267,
     268,   269,   270,    -1,   272,   273,   274,   275,   276,   277,
     278,    -1,   280,   281,   282,   283,   284,   285,   286,   287,
     288,   289,   290,   291,   292,    -1,   294,   295,   296,   297,
     298,   299,   300,   301,   302,   303,   304,    -1,   306,   307,
     308,   309,   310,   311,   312,   313,   314,   315,   316,   317,
     318,   319,    -1,   321,   322,   323,   324,   325,    -1,   327,
     328,   329,   330,   331,   332,   333,   334,    -1,   336,   337,
     338,   339,   340,   341,   342,   343,   344,   345,   346,    -1,
     348,   349,    -1,   351,   352,   353,   354,   355,   356,    -1,
     358,   359,    -1,    -1,   362,   363,   364,   365,   366,   367,
     368,   369,   370,   371,   372,   373,    -1,    -1,   376,   377,
     378,   379,   380,    -1,    -1,   383,   384,   385,   386,   387,
     388,   389,    -1,   391,   392,   393,   394,   395,   396,    -1,
      -1,   399,    -1,    -1,   402,   403,   404,   405,   406,   407,
     408,   409,   410,   411,   412,   413,   414,   415,   416,   417,
     418,   419,     3,    -1,     5,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    14,    15,    16,    17,    18,    19,    20,
      21,    -1,    23,    24,    25,    -1,    -1,    -1,    -1,    30,
      -1,    -1,    -1,    34,    35,    -1,    37,    38,    39,    40,
      41,    42,    43,    44,    45,    46,    47,    -1,    49,    50,
      51,    52,    53,    -1,    -1,    56,    57,    58,    59,    60,
      -1,    62,    63,    64,    65,    66,    -1,    68,    -1,    70,
      71,    72,    73,    74,    75,    76,    -1,    78,    79,    80,
      81,    82,    83,    -1,    85,    86,    87,    -1,    -1,    -1,
      91,    -1,    -1,    -1,    95,    96,    97,    98,    99,   100,
     101,   102,   103,   104,   105,    -1,   107,   108,   109,   110,
     111,    -1,   113,   114,   115,    -1,    -1,   118,   119,   120,
     121,   122,    -1,   124,   125,   126,    -1,   128,   129,   130,
      -1,   132,   133,   134,   135,   136,   137,   138,   139,   140,
      -1,   142,    -1,   144,   145,   146,   147,    -1,   149,    -1,
     151,   152,    -1,   154,   155,   156,   157,    -1,   159,   160,
      -1,   162,    -1,   164,   165,   166,   167,   168,   169,   170,
     171,   172,    -1,   174,   175,   176,   177,   178,   179,    -1,
     181,   182,   183,   184,   185,   186,   187,   188,   189,    -1,
     191,    -1,   193,   194,   195,   196,   197,   198,   199,   200,
     201,   202,    -1,   204,   205,    -1,   207,   208,   209,   210,
     211,    -1,   213,   214,   215,    -1,    -1,   218,   219,   220,
     221,   222,   223,   224,   225,   226,   227,   228,   229,   230,
     231,   232,   233,   234,   235,   236,    -1,   238,   239,   240,
     241,    -1,   243,   244,   245,   246,   247,   248,    -1,   250,
      -1,    -1,   253,   254,   255,    -1,    -1,   258,   259,   260,
     261,   262,   263,   264,   265,   266,   267,   268,   269,   270,
      -1,   272,   273,   274,   275,   276,   277,   278,    -1,   280,
     281,   282,   283,   284,   285,   286,   287,   288,   289,   290,
     291,   292,    -1,   294,   295,   296,   297,   298,   299,   300,
     301,   302,   303,   304,    -1,   306,   307,   308,   309,   310,
     311,   312,   313,   314,   315,   316,   317,   318,   319,    -1,
     321,   322,   323,   324,   325,    -1,   327,   328,   329,   330,
     331,   332,   333,   334,    -1,   336,   337,   338,   339,   340,
     341,   342,   343,   344,   345,   346,    -1,   348,   349,    -1,
     351,   352,   353,   354,   355,   356,    -1,   358,   359,    -1,
      -1,   362,   363,   364,   365,    -1,   367,   368,   369,   370,
     371,   372,   373,    -1,    -1,   376,   377,   378,   379,   380,
      -1,    -1,   383,   384,   385,   386,   387,   388,   389,    -1,
     391,   392,   393,   394,   395,   396,    -1,    -1,   399,    -1,
      -1,   402,   403,   404,   405,   406,   407,   408,   409,   410,
     411,   412,   413,   414,   415,   416,   417,   418,   419,     3,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      14,    15,    16,    17,    18,    19,    20,    21,    -1,    23,
      24,    25,    -1,    -1,    -1,    -1,    30,    -1,    -1,    -1,
      34,    35,    -1,    37,    38,    39,    40,    41,    42,    43,
      44,    45,    46,    47,    -1,    49,    50,    51,    52,    53,
      -1,    -1,    56,    57,    58,    59,    60,    -1,    62,    63,
      64,    65,    66,    -1,    68,    -1,    70,    71,    72,    73,
      74,    75,    76,    -1,    78,    79,    80,    81,    82,    83,
      -1,    85,    86,    87,    -1,    -1,    -1,    91,    -1,    -1,
      94,    95,    96,    97,    98,    99,   100,   101,   102,   103,
      -1,   105,    -1,   107,   108,   109,   110,   111,    -1,   113,
     114,   115,    -1,    -1,   118,   119,   120,   121,   122,    -1,
     124,   125,   126,    -1,   128,   129,   130,    -1,   132,   133,
     134,   135,   136,   137,   138,   139,   140,    -1,   142,    -1,
     144,   145,   146,   147,    -1,   149,    -1,   151,   152,    -1,
     154,   155,   156,   157,    -1,   159,   160,    -1,   162,    -1,
     164,   165,   166,   167,   168,   169,   170,   171,   172,    -1,
     174,   175,   176,   177,   178,   179,    -1,   181,   182,   183,
     184,   185,   186,   187,   188,   189,    -1,   191,    -1,   193,
     194,   195,   196,   197,   198,   199,   200,   201,   202,    -1,
     204,   205,    -1,   207,   208,   209,   210,   211,    -1,   213,
     214,   215,    -1,    -1,   218,   219,   220,   221,   222,   223,
     224,   225,   226,   227,   228,   229,   230,   231,   232,   233,
     234,   235,   236,    -1,   238,   239,   240,   241,    -1,   243,
     244,   245,   246,   247,   248,    -1,   250,    -1,    -1,   253,
     254,   255,    -1,    -1,   258,   259,   260,   261,   262,   263,
     264,   265,   266,   267,   268,   269,   270,    -1,   272,   273,
     274,   275,   276,   277,   278,    -1,   280,   281,   282,   283,
     284,   285,   286,   287,   288,   289,   290,   291,   292,    -1,
     294,   295,   296,   297,   298,   299,   300,   301,   302,   303,
     304,    -1,   306,   307,   308,   309,   310,   311,   312,   313,
     314,   315,   316,   317,   318,   319,    -1,   321,   322,   323,
     324,   325,    -1,   327,   328,   329,   330,   331,   332,   333,
     334,    -1,   336,   337,   338,   339,   340,   341,   342,   343,
     344,   345,   346,    -1,   348,   349,    -1,   351,   352,   353,
     354,   355,   356,    -1,   358,   359,    -1,    -1,   362,   363,
     364,   365,    -1,   367,   368,   369,   370,   371,   372,   373,
      -1,    -1,   376,   377,   378,   379,   380,   381,    -1,   383,
     384,   385,   386,   387,   388,   389,    -1,   391,   392,   393,
     394,   395,   396,    -1,    -1,   399,    -1,    -1,   402,   403,
     404,   405,   406,   407,   408,   409,   410,   411,   412,   413,
     414,   415,   416,   417,   418,   419,     3,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    14,    15,    16,
      17,    18,    19,    20,    21,    -1,    23,    24,    25,    26,
      27,    -1,    -1,    30,    -1,    -1,    -1,    34,    35,    -1,
      37,    38,    39,    40,    41,    42,    43,    44,    45,    46,
      47,    -1,    49,    50,    51,    52,    53,    -1,    -1,    56,
      57,    58,    59,    60,    -1,    62,    63,    64,    65,    66,
      -1,    68,    -1,    70,    71,    72,    73,    74,    75,    76,
      -1,    78,    79,    80,    81,    82,    83,    -1,    85,    86,
      87,    -1,    -1,    -1,    91,    -1,    -1,    -1,    95,    96,
      97,    98,    99,   100,   101,   102,   103,    -1,   105,    -1,
     107,   108,   109,   110,   111,    -1,   113,   114,   115,    -1,
      -1,   118,   119,   120,   121,   122,    -1,   124,   125,   126,
      -1,   128,   129,   130,    -1,   132,   133,   134,   135,   136,
     137,   138,   139,   140,    -1,   142,    -1,   144,   145,   146,
     147,    -1,   149,    -1,   151,   152,    -1,   154,   155,   156,
     157,    -1,   159,   160,    -1,   162,    -1,   164,   165,   166,
     167,   168,   169,   170,   171,   172,    -1,   174,   175,   176,
     177,   178,   179,    -1,   181,   182,   183,   184,   185,   186,
     187,   188,   189,    -1,   191,    -1,   193,   194,   195,   196,
     197,   198,   199,   200,   201,   202,    -1,   204,   205,    -1,
     207,   208,   209,   210,   211,    -1,   213,   214,   215,    -1,
      -1,   218,   219,   220,   221,   222,   223,   224,   225,   226,
     227,   228,   229,   230,   231,   232,   233,   234,   235,   236,
      -1,   238,   239,   240,   241,    -1,   243,   244,   245,   246,
     247,   248,    -1,   250,    -1,    -1,   253,   254,   255,    -1,
      -1,   258,   259,   260,   261,   262,   263,   264,   265,   266,
     267,   268,   269,   270,    -1,   272,   273,   274,   275,   276,
     277,   278,    -1,   280,   281,   282,   283,   284,   285,   286,
     287,   288,   289,   290,   291,   292,    -1,   294,   295,   296,
     297,   298,   299,   300,   301,   302,   303,   304,    -1,   306,
     307,   308,   309,   310,   311,   312,   313,   314,   315,   316,
     317,   318,   319,    -1,   321,   322,   323,   324,   325,    -1,
     327,   328,   329,   330,   331,   332,   333,   334,    -1,   336,
     337,   338,   339,   340,   341,   342,   343,   344,   345,   346,
      -1,   348,   349,    -1,   351,   352,   353,   354,   355,   356,
      -1,   358,   359,    -1,    -1,   362,   363,   364,   365,    -1,
     367,   368,   369,   370,   371,   372,   373,    -1,    -1,   376,
     377,   378,   379,   380,    -1,    -1,   383,   384,   385,   386,
     387,   388,   389,    -1,   391,   392,   393,   394,   395,   396,
      -1,    -1,   399,    -1,    -1,   402,   403,   404,   405,   406,
     407,   408,   409,   410,   411,   412,   413,   414,   415,   416,
     417,   418,   419,     3,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    14,    15,    16,    17,    18,    19,
      20,    21,    22,    23,    24,    25,    -1,    -1,    -1,    -1,
      30,    -1,    -1,    -1,    34,    35,    -1,    37,    38,    39,
      40,    41,    42,    43,    44,    45,    46,    47,    -1,    49,
      50,    51,    52,    53,    -1,    -1,    56,    57,    58,    59,
      60,    -1,    62,    63,    64,    65,    66,    -1,    68,    -1,
      70,    71,    72,    73,    74,    75,    76,    -1,    78,    79,
      80,    81,    82,    83,    -1,    85,    86,    87,    -1,    -1,
      -1,    91,    -1,    -1,    -1,    95,    96,    97,    98,    99,
     100,   101,   102,   103,    -1,   105,    -1,   107,   108,   109,
     110,   111,    -1,   113,   114,   115,    -1,    -1,   118,   119,
     120,   121,   122,    -1,   124,   125,   126,    -1,   128,   129,
     130,    -1,   132,   133,   134,   135,   136,   137,   138,   139,
     140,    -1,   142,    -1,   144,   145,   146,   147,    -1,   149,
      -1,   151,   152,    -1,   154,   155,   156,   157,    -1,   159,
     160,    -1,   162,    -1,   164,   165,   166,   167,   168,   169,
     170,   171,   172,    -1,   174,   175,   176,   177,   178,   179,
      -1,   181,   182,   183,   184,   185,   186,   187,   188,   189,
      -1,   191,    -1,   193,   194,   195,   196,   197,   198,   199,
     200,   201,   202,    -1,   204,   205,    -1,   207,   208,   209,
     210,   211,    -1,   213,   214,   215,    -1,    -1,   218,   219,
     220,   221,   222,   223,   224,   225,   226,   227,   228,   229,
     230,   231,   232,   233,   234,   235,   236,    -1,   238,   239,
     240,   241,    -1,   243,   244,   245,   246,   247,   248,    -1,
     250,    -1,    -1,   253,   254,   255,    -1,    -1,   258,   259,
     260,   261,   262,   263,   264,   265,   266,   267,   268,   269,
     270,    -1,   272,   273,   274,   275,   276,   277,   278,    -1,
     280,   281,   282,   283,   284,   285,   286,   287,   288,   289,
     290,   291,   292,    -1,   294,   295,   296,   297,   298,   299,
     300,   301,   302,   303,   304,    -1,   306,   307,   308,   309,
     310,   311,   312,   313,   314,   315,   316,   317,   318,   319,
      -1,   321,   322,   323,   324,   325,    -1,   327,   328,   329,
     330,   331,   332,   333,   334,    -1,   336,   337,   338,   339,
     340,   341,   342,   343,   344,   345,   346,    -1,   348,   349,
      -1,   351,   352,   353,   354,   355,   356,    -1,   358,   359,
      -1,    -1,   362,   363,   364,   365,    -1,   367,   368,   369,
     370,   371,   372,   373,    -1,    -1,   376,   377,   378,   379,
     380,    -1,    -1,   383,   384,   385,   386,   387,   388,   389,
      -1,   391,   392,   393,   394,   395,   396,    -1,    -1,   399,
      -1,    -1,   402,   403,   404,   405,   406,   407,   408,   409,
     410,   411,   412,   413,   414,   415,   416,   417,   418,   419,
       3,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    14,    15,    16,    17,    18,    19,    20,    21,    22,
      23,    24,    25,    -1,    -1,    -1,    -1,    30,    -1,    -1,
      -1,    34,    35,    -1,    37,    38,    39,    40,    41,    42,
      43,    44,    45,    46,    47,    -1,    49,    50,    51,    52,
      53,    -1,    -1,    56,    57,    58,    59,    60,    -1,    62,
      63,    64,    65,    66,    -1,    68,    -1,    70,    71,    72,
      73,    74,    75,    76,    -1,    78,    79,    80,    81,    82,
      83,    -1,    85,    86,    87,    -1,    -1,    -1,    91,    -1,
      -1,    -1,    95,    96,    97,    98,    99,   100,   101,   102,
     103,    -1,   105,    -1,   107,   108,   109,   110,   111,    -1,
     113,   114,   115,    -1,    -1,   118,   119,   120,   121,   122,
      -1,   124,   125,   126,    -1,   128,   129,   130,    -1,   132,
     133,   134,   135,   136,   137,   138,   139,   140,    -1,   142,
      -1,   144,   145,   146,   147,    -1,   149,    -1,   151,   152,
      -1,   154,   155,   156,   157,    -1,   159,   160,    -1,   162,
      -1,   164,   165,   166,   167,   168,   169,   170,   171,   172,
      -1,   174,   175,   176,   177,   178,   179,    -1,   181,   182,
     183,   184,   185,   186,   187,   188,   189,    -1,   191,    -1,
     193,   194,   195,   196,   197,   198,   199,   200,   201,   202,
      -1,   204,   205,    -1,   207,   208,   209,   210,   211,    -1,
     213,   214,   215,    -1,    -1,   218,   219,   220,   221,   222,
     223,   224,   225,   226,   227,   228,   229,   230,   231,   232,
     233,   234,   235,   236,    -1,   238,   239,   240,   241,    -1,
     243,   244,   245,   246,   247,   248,    -1,   250,    -1,    -1,
     253,   254,   255,    -1,    -1,   258,   259,   260,   261,   262,
     263,   264,   265,   266,   267,   268,   269,   270,    -1,   272,
     273,   274,   275,   276,   277,   278,    -1,   280,   281,   282,
     283,   284,   285,   286,   287,   288,   289,   290,   291,   292,
      -1,   294,   295,   296,   297,   298,   299,   300,   301,   302,
     303,   304,    -1,   306,   307,   308,   309,   310,   311,   312,
     313,   314,   315,   316,   317,   318,   319,    -1,   321,   322,
     323,   324,   325,    -1,   327,   328,   329,   330,   331,   332,
     333,   334,    -1,   336,   337,   338,   339,   340,   341,   342,
     343,   344,   345,   346,    -1,   348,   349,    -1,   351,   352,
     353,   354,   355,   356,    -1,   358,   359,    -1,    -1,   362,
     363,   364,   365,    -1,   367,   368,   369,   370,   371,   372,
     373,    -1,    -1,   376,   377,   378,   379,   380,    -1,    -1,
     383,   384,   385,   386,   387,   388,   389,    -1,   391,   392,
     393,   394,   395,   396,    -1,    -1,   399,    -1,    -1,   402,
     403,   404,   405,   406,   407,   408,   409,   410,   411,   412,
     413,   414,   415,   416,   417,   418,   419,     3,    -1,     5,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    14,    15,
      16,    17,    18,    19,    20,    21,    -1,    23,    24,    25,
      -1,    -1,    -1,    -1,    30,    -1,    -1,    -1,    34,    35,
      -1,    37,    38,    39,    40,    41,    42,    43,    44,    45,
      46,    47,    -1,    49,    50,    51,    52,    53,    -1,    -1,
      56,    57,    58,    59,    60,    -1,    62,    63,    64,    65,
      66,    -1,    68,    -1,    70,    71,    72,    73,    74,    75,
      76,    -1,    78,    79,    80,    81,    82,    83,    -1,    85,
      86,    87,    -1,    -1,    -1,    91,    -1,    -1,    -1,    95,
      96,    97,    98,    99,   100,   101,   102,   103,    -1,   105,
      -1,   107,   108,   109,   110,   111,    -1,   113,   114,   115,
      -1,    -1,   118,   119,   120,   121,   122,    -1,   124,   125,
     126,    -1,   128,   129,   130,    -1,   132,   133,   134,   135,
     136,   137,   138,   139,   140,    -1,   142,    -1,   144,   145,
     146,   147,    -1,   149,    -1,   151,   152,    -1,   154,   155,
     156,   157,    -1,   159,   160,    -1,   162,    -1,   164,   165,
     166,   167,   168,   169,   170,   171,   172,    -1,   174,   175,
     176,   177,   178,   179,    -1,   181,   182,   183,   184,   185,
     186,   187,   188,   189,    -1,   191,    -1,   193,   194,   195,
     196,   197,   198,   199,   200,   201,   202,    -1,   204,   205,
      -1,   207,   208,   209,   210,   211,    -1,   213,   214,   215,
      -1,    -1,   218,   219,   220,   221,   222,   223,   224,   225,
     226,   227,   228,   229,   230,   231,   232,   233,   234,   235,
     236,    -1,   238,   239,   240,   241,    -1,   243,   244,   245,
     246,   247,   248,    -1,   250,    -1,    -1,   253,   254,   255,
      -1,    -1,   258,   259,   260,   261,   262,   263,   264,   265,
     266,   267,   268,   269,   270,    -1,   272,   273,   274,   275,
     276,   277,   278,    -1,   280,   281,   282,   283,   284,   285,
     286,   287,   288,   289,   290,   291,   292,    -1,   294,   295,
     296,   297,   298,   299,   300,   301,   302,   303,   304,    -1,
     306,   307,   308,   309,   310,   311,   312,   313,   314,   315,
     316,   317,   318,   319,    -1,   321,   322,   323,   324,   325,
      -1,   327,   328,   329,   330,   331,   332,   333,   334,    -1,
     336,   337,   338,   339,   340,   341,   342,   343,   344,   345,
     346,    -1,   348,   349,    -1,   351,   352,   353,   354,   355,
     356,    -1,   358,   359,    -1,    -1,   362,   363,   364,   365,
      -1,   367,   368,   369,   370,   371,   372,   373,    -1,    -1,
     376,   377,   378,   379,   380,    -1,    -1,   383,   384,   385,
     386,   387,   388,   389,    -1,   391,   392,   393,   394,   395,
     396,    -1,    -1,   399,    -1,    -1,   402,   403,   404,   405,
     406,   407,   408,   409,   410,   411,   412,   413,   414,   415,
     416,   417,   418,   419,     3,    -1,     5,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    14,    15,    16,    17,    18,
      19,    20,    21,    -1,    23,    24,    25,    -1,    -1,    -1,
      -1,    30,    -1,    -1,    -1,    34,    35,    -1,    37,    38,
      39,    40,    41,    42,    43,    44,    45,    46,    47,    -1,
      49,    50,    51,    52,    53,    -1,    -1,    56,    57,    58,
      59,    60,    -1,    62,    63,    64,    65,    66,    -1,    68,
      -1,    70,    71,    72,    73,    74,    75,    76,    -1,    78,
      79,    80,    81,    82,    83,    -1,    85,    86,    87,    -1,
      -1,    -1,    91,    -1,    -1,    -1,    95,    96,    97,    98,
      99,   100,   101,   102,   103,    -1,   105,    -1,   107,   108,
     109,   110,   111,    -1,   113,   114,   115,    -1,    -1,   118,
     119,   120,   121,   122,    -1,   124,   125,   126,    -1,   128,
     129,   130,    -1,   132,   133,   134,   135,   136,   137,   138,
     139,   140,    -1,   142,    -1,   144,   145,   146,   147,    -1,
     149,    -1,   151,   152,    -1,   154,   155,   156,   157,    -1,
     159,   160,    -1,   162,    -1,   164,   165,   166,   167,   168,
     169,   170,   171,   172,    -1,   174,   175,   176,   177,   178,
     179,    -1,   181,   182,   183,   184,   185,   186,   187,   188,
     189,    -1,   191,    -1,   193,   194,   195,   196,   197,   198,
     199,   200,   201,   202,    -1,   204,   205,    -1,   207,   208,
     209,   210,   211,    -1,   213,   214,   215,    -1,    -1,   218,
     219,   220,   221,   222,   223,   224,   225,   226,   227,   228,
     229,   230,   231,   232,   233,   234,   235,   236,    -1,   238,
     239,   240,   241,    -1,   243,   244,   245,   246,   247,   248,
      -1,   250,    -1,    -1,   253,   254,   255,    -1,    -1,   258,
     259,   260,   261,   262,   263,   264,   265,   266,   267,   268,
     269,   270,    -1,   272,   273,   274,   275,   276,   277,   278,
      -1,   280,   281,   282,   283,   284,   285,   286,   287,   288,
     289,   290,   291,   292,    -1,   294,   295,   296,   297,   298,
     299,   300,   301,   302,   303,   304,    -1,   306,   307,   308,
     309,   310,   311,   312,   313,   314,   315,   316,   317,   318,
     319,    -1,   321,   322,   323,   324,   325,    -1,   327,   328,
     329,   330,   331,   332,   333,   334,    -1,   336,   337,   338,
     339,   340,   341,   342,   343,   344,   345,   346,    -1,   348,
     349,    -1,   351,   352,   353,   354,   355,   356,    -1,   358,
     359,    -1,    -1,   362,   363,   364,   365,    -1,   367,   368,
     369,   370,   371,   372,   373,    -1,    -1,   376,   377,   378,
     379,   380,    -1,    -1,   383,   384,   385,   386,   387,   388,
     389,    -1,   391,   392,   393,   394,   395,   396,    -1,    -1,
     399,    -1,    -1,   402,   403,   404,   405,   406,   407,   408,
     409,   410,   411,   412,   413,   414,   415,   416,   417,   418,
     419,     3,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    14,    15,    16,    17,    18,    19,    20,    21,
      -1,    23,    24,    25,    -1,    -1,    -1,    -1,    30,    -1,
      -1,    -1,    34,    35,    -1,    37,    38,    39,    40,    41,
      42,    43,    44,    45,    46,    47,    -1,    49,    50,    51,
      52,    53,    -1,    -1,    56,    57,    58,    59,    60,    -1,
      62,    63,    64,    65,    66,    -1,    68,    -1,    70,    71,
      72,    73,    74,    75,    76,    -1,    78,    79,    80,    81,
      82,    83,    -1,    85,    86,    87,    -1,    -1,    -1,    91,
      -1,    -1,    -1,    95,    96,    97,    98,    99,   100,   101,
     102,   103,    -1,   105,    -1,   107,   108,   109,   110,   111,
      -1,   113,   114,   115,    -1,    -1,   118,   119,   120,   121,
     122,    -1,   124,   125,   126,    -1,   128,   129,   130,    -1,
     132,   133,   134,   135,   136,   137,   138,   139,   140,    -1,
     142,    -1,   144,   145,   146,   147,    -1,   149,    -1,   151,
     152,    -1,   154,   155,   156,   157,    -1,   159,   160,   161,
     162,    -1,   164,   165,   166,   167,   168,   169,   170,   171,
     172,    -1,   174,   175,   176,   177,   178,   179,    -1,   181,
     182,   183,   184,   185,   186,   187,   188,   189,    -1,   191,
      -1,   193,   194,   195,   196,   197,   198,   199,   200,   201,
     202,    -1,   204,   205,    -1,   207,   208,   209,   210,   211,
      -1,   213,   214,   215,    -1,    -1,   218,   219,   220,   221,
     222,   223,   224,   225,   226,   227,   228,   229,   230,   231,
     232,   233,   234,   235,   236,    -1,   238,   239,   240,   241,
      -1,   243,   244,   245,   246,   247,   248,    -1,   250,    -1,
      -1,   253,   254,   255,    -1,    -1,   258,   259,   260,   261,
     262,   263,   264,   265,   266,   267,   268,   269,   270,    -1,
     272,   273,   274,   275,   276,   277,   278,    -1,   280,   281,
     282,   283,   284,   285,   286,   287,   288,   289,   290,   291,
     292,    -1,   294,   295,   296,   297,   298,   299,   300,   301,
     302,   303,   304,    -1,   306,   307,   308,   309,   310,   311,
     312,   313,   314,   315,   316,   317,   318,   319,    -1,   321,
     322,   323,   324,   325,    -1,   327,   328,   329,   330,   331,
     332,   333,   334,    -1,   336,   337,   338,   339,   340,   341,
     342,   343,   344,   345,   346,    -1,   348,   349,    -1,   351,
     352,   353,   354,   355,   356,    -1,   358,   359,    -1,    -1,
     362,   363,   364,   365,    -1,   367,   368,   369,   370,   371,
     372,   373,    -1,    -1,   376,   377,   378,   379,   380,    -1,
      -1,   383,   384,   385,   386,   387,   388,   389,    -1,   391,
     392,   393,   394,   395,   396,    -1,    -1,   399,    -1,    -1,
     402,   403,   404,   405,   406,   407,   408,   409,   410,   411,
     412,   413,   414,   415,   416,   417,   418,   419,     3,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    14,
      15,    16,    17,    18,    19,    20,    21,    -1,    23,    24,
      25,    -1,    -1,    -1,    -1,    30,    -1,    -1,    -1,    34,
      35,    -1,    37,    38,    39,    40,    41,    42,    43,    44,
      45,    46,    47,    -1,    49,    50,    51,    52,    53,    -1,
      -1,    56,    57,    58,    59,    60,    -1,    62,    63,    64,
      65,    66,    -1,    68,    -1,    70,    71,    72,    73,    74,
      75,    76,    -1,    78,    79,    80,    81,    82,    83,    -1,
      85,    86,    87,    -1,    -1,    -1,    91,    -1,    -1,    -1,
      95,    96,    97,    98,    99,   100,   101,   102,   103,    -1,
     105,    -1,   107,   108,   109,   110,   111,    -1,   113,   114,
     115,    -1,    -1,   118,   119,   120,   121,   122,    -1,   124,
     125,   126,    -1,   128,   129,   130,    -1,   132,   133,   134,
     135,   136,   137,   138,   139,   140,    -1,   142,    -1,   144,
     145,   146,   147,    -1,   149,    -1,   151,   152,    -1,   154,
     155,   156,   157,    -1,   159,   160,    -1,   162,    -1,   164,
     165,   166,   167,   168,   169,   170,   171,   172,    -1,   174,
     175,   176,   177,   178,   179,    -1,   181,   182,   183,   184,
     185,   186,   187,   188,   189,    -1,   191,    -1,   193,   194,
     195,   196,   197,   198,   199,   200,   201,   202,    -1,   204,
     205,    -1,   207,   208,   209,   210,   211,    -1,   213,   214,
     215,    -1,    -1,   218,   219,   220,   221,   222,   223,   224,
     225,   226,   227,   228,   229,   230,   231,   232,   233,   234,
     235,   236,    -1,   238,   239,   240,   241,    -1,   243,   244,
     245,   246,   247,   248,    -1,   250,    -1,    -1,   253,   254,
     255,    -1,    -1,   258,   259,   260,   261,   262,   263,   264,
     265,   266,   267,   268,   269,   270,    -1,   272,   273,   274,
     275,   276,   277,   278,    -1,   280,   281,   282,   283,   284,
     285,   286,   287,   288,   289,   290,   291,   292,    -1,   294,
     295,   296,   297,   298,   299,   300,   301,   302,   303,   304,
      -1,   306,   307,   308,   309,   310,   311,   312,   313,   314,
     315,   316,   317,   318,   319,    -1,   321,   322,   323,   324,
     325,    -1,   327,   328,   329,   330,   331,   332,   333,   334,
      -1,   336,   337,   338,   339,   340,   341,   342,   343,   344,
     345,   346,    -1,   348,   349,    -1,   351,   352,   353,   354,
     355,   356,    -1,   358,   359,    -1,    -1,   362,   363,   364,
     365,    -1,   367,   368,   369,   370,   371,   372,   373,    -1,
      -1,   376,   377,   378,   379,   380,    -1,    -1,   383,   384,
     385,   386,   387,   388,   389,    -1,   391,   392,   393,   394,
     395,   396,    -1,    -1,   399,    -1,    -1,   402,   403,   404,
     405,   406,   407,   408,   409,   410,   411,   412,   413,   414,
     415,   416,   417,   418,   419,     3,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    14,    15,    16,    17,
      18,    19,    20,    21,    -1,    23,    24,    25,    -1,    -1,
      -1,    -1,    30,    -1,    -1,    -1,    34,    35,    -1,    37,
      38,    39,    40,    41,    42,    43,    44,    45,    46,    47,
      -1,    49,    50,    51,    52,    53,    -1,    -1,    56,    57,
      58,    59,    60,    -1,    62,    63,    64,    65,    66,    -1,
      68,    -1,    70,    71,    72,    73,    74,    75,    76,    -1,
      78,    79,    80,    81,    82,    83,    -1,    85,    86,    87,
      -1,    -1,    -1,    91,    -1,    -1,    -1,    95,    96,    97,
      98,    99,   100,   101,   102,   103,    -1,   105,    -1,   107,
     108,   109,   110,   111,    -1,   113,   114,   115,    -1,    -1,
     118,   119,   120,   121,   122,    -1,   124,   125,   126,    -1,
     128,   129,   130,    -1,   132,   133,   134,   135,   136,   137,
     138,   139,   140,    -1,   142,    -1,   144,   145,   146,   147,
      -1,   149,    -1,   151,   152,    -1,   154,   155,   156,   157,
      -1,   159,   160,    -1,   162,    -1,   164,   165,   166,   167,
     168,   169,   170,   171,   172,    -1,   174,   175,   176,   177,
     178,   179,    -1,   181,   182,   183,   184,   185,   186,   187,
     188,   189,    -1,   191,    -1,   193,   194,   195,   196,   197,
     198,   199,   200,   201,   202,    -1,   204,   205,    -1,   207,
     208,   209,   210,   211,    -1,   213,   214,   215,    -1,    -1,
     218,   219,   220,   221,   222,   223,   224,   225,   226,   227,
     228,   229,   230,   231,   232,   233,   234,   235,   236,    -1,
     238,   239,   240,   241,    -1,   243,   244,   245,   246,   247,
     248,    -1,   250,    -1,    -1,   253,   254,   255,    -1,    -1,
     258,   259,   260,   261,   262,   263,   264,   265,   266,   267,
     268,   269,   270,    -1,   272,   273,   274,   275,   276,   277,
     278,    -1,   280,   281,   282,   283,   284,   285,   286,   287,
     288,   289,   290,   291,   292,    -1,   294,   295,   296,   297,
     298,   299,   300,   301,   302,   303,   304,    -1,   306,   307,
     308,   309,   310,   311,   312,   313,   314,   315,   316,   317,
     318,   319,    -1,   321,   322,   323,   324,   325,    -1,   327,
     328,   329,   330,   331,   332,   333,   334,    -1,   336,   337,
     338,   339,   340,   341,   342,   343,   344,   345,   346,    -1,
     348,   349,    -1,   351,   352,   353,   354,   355,   356,    -1,
     358,   359,    -1,    -1,   362,   363,   364,   365,    -1,   367,
     368,   369,   370,   371,   372,   373,    -1,    -1,   376,   377,
     378,   379,   380,    -1,    -1,   383,   384,   385,   386,   387,
     388,   389,    -1,   391,   392,   393,   394,   395,   396,    -1,
      -1,   399,    -1,    -1,   402,   403,   404,   405,   406,   407,
     408,   409,   410,   411,   412,   413,   414,   415,   416,   417,
     418,   419,     3,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    14,    15,    16,    17,    18,    19,    20,
      21,    -1,    23,    24,    25,    -1,    -1,    -1,    -1,    30,
      -1,    -1,    -1,    34,    35,    -1,    37,    38,    39,    40,
      41,    42,    43,    44,    45,    46,    47,    -1,    49,    50,
      51,    52,    53,    -1,    -1,    56,    57,    58,    59,    60,
      -1,    62,    63,    64,    65,    66,    -1,    68,    -1,    70,
      71,    72,    73,    74,    75,    76,    -1,    78,    79,    80,
      81,    82,    83,    -1,    85,    86,    87,    -1,    -1,    -1,
      91,    -1,    -1,    -1,    95,    96,    97,    98,    99,   100,
     101,   102,   103,    -1,   105,    -1,   107,   108,   109,   110,
     111,    -1,   113,   114,   115,    -1,    -1,   118,   119,   120,
     121,   122,    -1,   124,   125,   126,    -1,   128,   129,   130,
      -1,   132,   133,   134,   135,   136,   137,   138,   139,   140,
      -1,   142,    -1,   144,   145,   146,   147,    -1,   149,    -1,
     151,   152,    -1,   154,   155,   156,   157,    -1,   159,   160,
      -1,   162,    -1,   164,   165,   166,   167,   168,   169,   170,
     171,   172,    -1,   174,   175,   176,   177,   178,   179,    -1,
     181,   182,   183,   184,   185,   186,   187,   188,   189,    -1,
     191,    -1,   193,   194,   195,   196,   197,   198,   199,   200,
     201,   202,    -1,   204,   205,    -1,   207,   208,   209,   210,
     211,    -1,   213,   214,   215,    -1,    -1,   218,   219,   220,
     221,   222,   223,   224,   225,   226,   227,   228,   229,   230,
     231,   232,   233,   234,   235,   236,    -1,   238,   239,   240,
     241,    -1,   243,   244,   245,   246,   247,   248,    -1,   250,
      -1,    -1,   253,   254,   255,    -1,    -1,   258,   259,   260,
     261,   262,   263,   264,   265,   266,   267,   268,   269,   270,
      -1,   272,   273,   274,   275,   276,   277,   278,    -1,   280,
     281,   282,   283,   284,   285,   286,   287,   288,   289,   290,
     291,   292,    -1,   294,   295,   296,   297,   298,   299,   300,
     301,   302,   303,   304,    -1,   306,   307,   308,   309,   310,
     311,   312,   313,   314,   315,   316,   317,   318,   319,    -1,
     321,   322,   323,   324,   325,    -1,   327,   328,   329,   330,
     331,   332,   333,   334,    -1,   336,   337,   338,   339,   340,
     341,   342,   343,   344,   345,   346,    -1,   348,   349,    -1,
     351,   352,   353,   354,   355,   356,    -1,   358,   359,    -1,
      -1,   362,   363,   364,   365,    -1,   367,   368,   369,   370,
     371,   372,   373,    -1,    -1,   376,   377,   378,   379,   380,
      -1,    -1,   383,   384,   385,   386,   387,   388,   389,    -1,
     391,   392,   393,   394,   395,   396,    -1,    -1,   399,    -1,
      -1,   402,   403,   404,   405,   406,   407,   408,   409,   410,
     411,   412,   413,   414,   415,   416,   417,   418,   419,     3,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      14,    15,    16,    17,    18,    19,    20,    21,    -1,    23,
      24,    25,    -1,    -1,    -1,    -1,    30,    -1,    -1,    -1,
      34,    35,    -1,    37,    38,    39,    40,    41,    42,    43,
      44,    45,    46,    47,    -1,    49,    50,    51,    52,    53,
      -1,    -1,    56,    57,    58,    59,    60,    -1,    62,    63,
      64,    65,    66,    -1,    68,    -1,    70,    71,    72,    73,
      74,    75,    76,    -1,    78,    79,    80,    81,    82,    83,
      -1,    85,    86,    87,    -1,    -1,    -1,    91,    -1,    -1,
      -1,    95,    96,    97,    98,    99,   100,   101,   102,   103,
      -1,   105,    -1,   107,   108,   109,   110,   111,    -1,   113,
     114,   115,    -1,    -1,   118,   119,   120,   121,   122,    -1,
     124,   125,   126,    -1,   128,   129,   130,    -1,   132,   133,
     134,   135,   136,   137,   138,   139,   140,    -1,   142,    -1,
     144,   145,   146,   147,    -1,   149,    -1,   151,   152,    -1,
     154,   155,   156,   157,    -1,   159,   160,    -1,   162,    -1,
     164,   165,   166,   167,   168,   169,   170,   171,   172,    -1,
     174,   175,   176,   177,   178,   179,    -1,   181,   182,   183,
     184,   185,   186,   187,   188,   189,    -1,   191,    -1,   193,
     194,   195,   196,   197,   198,   199,   200,   201,   202,    -1,
     204,   205,    -1,   207,   208,   209,   210,   211,    -1,   213,
     214,   215,    -1,    -1,   218,   219,   220,   221,   222,   223,
     224,   225,   226,   227,   228,   229,   230,   231,   232,   233,
     234,   235,   236,    -1,   238,   239,   240,   241,    -1,   243,
     244,   245,   246,   247,   248,    -1,   250,    -1,    -1,   253,
     254,   255,    -1,    -1,   258,   259,   260,   261,   262,   263,
     264,   265,   266,   267,   268,   269,   270,    -1,   272,   273,
     274,   275,   276,   277,   278,    -1,   280,   281,   282,   283,
     284,   285,   286,   287,   288,   289,   290,   291,   292,    -1,
     294,   295,   296,   297,   298,   299,   300,   301,   302,   303,
     304,    -1,   306,   307,   308,   309,   310,   311,   312,   313,
     314,   315,   316,   317,   318,   319,    -1,   321,   322,   323,
     324,   325,    -1,   327,   328,   329,   330,   331,   332,   333,
     334,    -1,   336,   337,   338,   339,   340,   341,   342,   343,
     344,   345,   346,    -1,   348,   349,    -1,   351,   352,   353,
     354,   355,   356,    -1,   358,   359,    -1,    -1,   362,   363,
     364,   365,    -1,   367,   368,   369,   370,   371,   372,   373,
      -1,    -1,   376,   377,   378,   379,   380,    -1,    -1,   383,
     384,   385,   386,   387,   388,   389,    -1,   391,   392,   393,
     394,   395,   396,    -1,    -1,   399,    -1,    -1,   402,   403,
     404,   405,   406,   407,   408,   409,   410,   411,   412,   413,
     414,   415,   416,   417,   418,   419,     3,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    14,    15,    16,
      17,    18,    19,    20,    21,    -1,    23,    24,    25,    -1,
      -1,    -1,    -1,    30,    -1,    -1,    -1,    34,    35,    -1,
      37,    38,    39,    40,    41,    42,    43,    44,    45,    46,
      47,    -1,    49,    50,    51,    52,    53,    -1,    -1,    56,
      57,    58,    59,    60,    -1,    62,    63,    64,    65,    66,
      -1,    68,    -1,    70,    71,    72,    73,    74,    75,    76,
      -1,    78,    79,    80,    81,    82,    83,    -1,    85,    86,
      87,    -1,    -1,    -1,    91,    -1,    -1,    -1,    95,    96,
      97,    98,    99,   100,   101,   102,   103,    -1,   105,    -1,
     107,   108,   109,   110,   111,    -1,   113,   114,   115,    -1,
      -1,   118,   119,   120,   121,   122,    -1,   124,   125,   126,
      -1,   128,   129,   130,    -1,   132,   133,   134,   135,   136,
     137,   138,   139,   140,    -1,   142,    -1,   144,   145,   146,
     147,    -1,   149,    -1,   151,   152,    -1,   154,   155,   156,
     157,    -1,   159,   160,    -1,   162,    -1,   164,   165,   166,
     167,   168,   169,   170,   171,   172,    -1,   174,   175,   176,
     177,   178,   179,    -1,   181,   182,   183,   184,   185,   186,
     187,   188,   189,    -1,   191,    -1,   193,   194,   195,   196,
     197,   198,   199,   200,   201,   202,    -1,   204,   205,    -1,
     207,   208,   209,   210,   211,    -1,   213,   214,   215,    -1,
      -1,   218,   219,   220,   221,   222,   223,   224,   225,   226,
     227,   228,   229,   230,   231,   232,   233,   234,   235,   236,
      -1,   238,   239,   240,   241,    -1,   243,   244,   245,   246,
     247,   248,    -1,   250,    -1,    -1,   253,   254,   255,    -1,
      -1,   258,   259,   260,   261,   262,   263,   264,   265,   266,
     267,   268,   269,   270,    -1,   272,   273,   274,   275,   276,
     277,   278,    -1,   280,   281,   282,   283,   284,   285,   286,
     287,   288,   289,   290,   291,   292,    -1,   294,   295,   296,
     297,   298,   299,   300,   301,   302,   303,   304,    -1,   306,
     307,   308,   309,   310,   311,   312,   313,   314,   315,   316,
     317,   318,   319,    -1,   321,   322,   323,   324,   325,    -1,
     327,   328,   329,   330,   331,   332,   333,   334,    -1,   336,
     337,   338,   339,   340,   341,   342,   343,   344,   345,   346,
      -1,   348,   349,    -1,   351,   352,   353,   354,   355,   356,
      -1,   358,   359,    -1,    -1,   362,   363,   364,   365,    -1,
     367,   368,   369,   370,   371,   372,   373,    -1,    -1,   376,
     377,   378,   379,   380,    -1,    -1,   383,   384,   385,   386,
     387,   388,   389,    -1,   391,   392,   393,   394,   395,   396,
      -1,    -1,   399,    -1,    -1,   402,   403,   404,   405,   406,
     407,   408,   409,   410,   411,   412,   413,   414,   415,   416,
     417,   418,   419,     3,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    14,    15,    16,    17,    18,    19,
      20,    21,    -1,    23,    24,    25,    -1,    -1,    -1,    -1,
      30,    -1,    -1,    -1,    34,    35,    -1,    37,    38,    39,
      40,    41,    42,    43,    44,    45,    46,    47,    -1,    49,
      50,    51,    52,    53,    -1,    -1,    56,    57,    58,    59,
      60,    -1,    62,    63,    64,    65,    66,    -1,    68,    -1,
      70,    71,    72,    73,    74,    75,    76,    -1,    78,    79,
      80,    81,    82,    83,    -1,    85,    86,    87,    -1,    -1,
      -1,    91,    -1,    -1,    -1,    95,    96,    97,    98,    99,
     100,   101,   102,   103,    -1,   105,    -1,   107,   108,   109,
     110,   111,    -1,   113,   114,   115,    -1,    -1,   118,   119,
     120,   121,   122,    -1,   124,   125,   126,    -1,   128,   129,
     130,    -1,   132,   133,   134,   135,   136,   137,   138,   139,
     140,    -1,   142,    -1,   144,   145,   146,   147,    -1,   149,
      -1,   151,   152,    -1,   154,   155,   156,   157,    -1,   159,
     160,    -1,   162,    -1,   164,   165,   166,   167,   168,   169,
     170,   171,   172,    -1,   174,   175,   176,   177,   178,   179,
      -1,   181,   182,   183,   184,   185,   186,   187,   188,   189,
      -1,   191,    -1,   193,   194,   195,   196,   197,   198,   199,
     200,   201,   202,    -1,   204,   205,    -1,   207,   208,   209,
     210,   211,    -1,   213,   214,   215,    -1,    -1,   218,   219,
     220,   221,   222,   223,   224,   225,   226,   227,   228,   229,
     230,   231,   232,   233,   234,   235,   236,    -1,   238,   239,
     240,   241,    -1,   243,   244,   245,   246,   247,   248,    -1,
     250,    -1,    -1,   253,   254,   255,    -1,    -1,   258,   259,
     260,   261,   262,   263,   264,   265,   266,   267,   268,   269,
     270,    -1,   272,   273,   274,   275,   276,   277,   278,    -1,
     280,   281,   282,   283,   284,   285,   286,   287,   288,   289,
     290,   291,   292,    -1,   294,   295,   296,   297,   298,   299,
     300,   301,   302,   303,   304,    -1,   306,   307,   308,   309,
     310,   311,   312,   313,   314,   315,   316,   317,   318,   319,
      -1,   321,   322,   323,   324,   325,    -1,   327,   328,   329,
     330,   331,   332,   333,   334,    -1,   336,   337,   338,   339,
     340,   341,   342,   343,   344,   345,   346,    -1,   348,   349,
      -1,   351,   352,   353,   354,   355,   356,    -1,   358,   359,
      -1,    -1,   362,   363,   364,   365,    -1,   367,   368,   369,
     370,   371,   372,   373,    -1,    -1,   376,   377,   378,   379,
     380,    -1,    -1,   383,   384,   385,   386,   387,   388,   389,
      -1,   391,   392,   393,   394,   395,   396,    -1,    -1,   399,
      -1,    -1,   402,   403,   404,   405,   406,   407,   408,   409,
     410,   411,   412,   413,   414,   415,   416,   417,   418,   419,
       3,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    14,    15,    16,    17,    18,    19,    20,    21,    -1,
      23,    24,    25,    -1,    -1,    -1,    -1,    30,    -1,    -1,
      -1,    34,    35,    -1,    37,    38,    39,    40,    41,    42,
      43,    44,    45,    46,    47,    -1,    49,    50,    51,    52,
      53,    -1,    -1,    56,    57,    58,    59,    60,    -1,    62,
      63,    64,    65,    66,    -1,    68,    -1,    70,    71,    72,
      73,    74,    75,    76,    -1,    78,    79,    80,    81,    82,
      83,    -1,    85,    86,    87,    -1,    -1,    -1,    91,    -1,
      -1,    -1,    95,    96,    97,    98,    99,   100,   101,   102,
     103,    -1,   105,    -1,   107,   108,   109,   110,   111,    -1,
     113,   114,   115,    -1,    -1,   118,   119,   120,   121,   122,
      -1,   124,   125,   126,    -1,   128,   129,   130,    -1,   132,
     133,   134,   135,   136,   137,   138,   139,   140,    -1,   142,
      -1,   144,   145,   146,   147,    -1,   149,    -1,   151,   152,
      -1,   154,   155,   156,   157,    -1,   159,   160,    -1,   162,
      -1,   164,   165,   166,   167,   168,   169,   170,   171,   172,
      -1,   174,   175,   176,   177,   178,   179,    -1,   181,   182,
     183,   184,   185,   186,   187,   188,   189,    -1,   191,    -1,
     193,   194,   195,   196,   197,   198,   199,   200,   201,   202,
      -1,   204,   205,    -1,   207,   208,   209,   210,   211,    -1,
     213,   214,   215,    -1,    -1,   218,   219,   220,   221,   222,
     223,   224,   225,   226,   227,   228,   229,   230,   231,   232,
     233,   234,   235,   236,    -1,   238,   239,   240,   241,    -1,
     243,   244,   245,   246,   247,   248,    -1,   250,    -1,    -1,
     253,   254,   255,    -1,    -1,   258,   259,   260,   261,   262,
     263,   264,   265,   266,   267,   268,   269,   270,    -1,   272,
     273,   274,   275,   276,   277,   278,    -1,   280,   281,   282,
     283,   284,   285,   286,   287,   288,   289,   290,   291,   292,
      -1,   294,   295,   296,   297,   298,   299,   300,   301,   302,
     303,   304,    -1,   306,   307,   308,   309,   310,   311,   312,
     313,   314,   315,   316,   317,   318,   319,    -1,   321,   322,
     323,   324,   325,    -1,   327,   328,   329,   330,   331,   332,
     333,   334,    -1,   336,   337,   338,   339,   340,   341,   342,
     343,   344,   345,   346,    -1,   348,   349,    -1,   351,   352,
     353,   354,   355,   356,    -1,   358,   359,    -1,    -1,   362,
     363,   364,   365,    -1,   367,   368,   369,   370,   371,   372,
     373,    -1,    -1,   376,   377,   378,   379,   380,    -1,    -1,
     383,   384,   385,   386,   387,   388,   389,    -1,   391,   392,
     393,   394,   395,   396,    -1,    -1,   399,    -1,    -1,   402,
     403,   404,   405,   406,   407,   408,   409,   410,   411,   412,
     413,   414,   415,   416,   417,   418,   419,     3,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    14,    15,
      16,    17,    18,    19,    20,    21,    -1,    23,    24,    25,
      -1,    -1,    -1,    -1,    30,    -1,    -1,    -1,    34,    35,
      -1,    37,    38,    39,    40,    41,    42,    43,    44,    45,
      46,    47,    -1,    49,    50,    51,    52,    53,    -1,    -1,
      56,    57,    58,    59,    60,    -1,    62,    63,    64,    65,
      66,    -1,    68,    -1,    70,    71,    72,    73,    74,    75,
      76,    -1,    78,    79,    80,    81,    82,    83,    -1,    85,
      86,    87,    -1,    -1,    -1,    91,    -1,    -1,    -1,    95,
      96,    97,    98,    99,   100,   101,   102,   103,    -1,   105,
      -1,   107,   108,   109,   110,   111,    -1,   113,   114,   115,
      -1,    -1,   118,   119,   120,   121,   122,    -1,   124,   125,
     126,    -1,   128,   129,   130,    -1,   132,   133,   134,   135,
     136,   137,   138,   139,   140,    -1,   142,    -1,   144,   145,
     146,   147,    -1,   149,    -1,   151,   152,    -1,   154,   155,
     156,   157,    -1,   159,   160,    -1,   162,    -1,   164,   165,
     166,   167,   168,   169,   170,   171,   172,    -1,   174,   175,
     176,   177,   178,   179,    -1,   181,   182,   183,   184,   185,
     186,   187,   188,   189,    -1,   191,    -1,   193,   194,   195,
     196,   197,   198,   199,   200,   201,   202,    -1,   204,   205,
      -1,   207,   208,   209,   210,   211,    -1,   213,   214,   215,
      -1,    -1,   218,   219,   220,   221,   222,   223,   224,   225,
     226,   227,   228,   229,   230,   231,   232,   233,   234,   235,
     236,    -1,   238,   239,   240,   241,    -1,   243,   244,   245,
     246,   247,   248,    -1,   250,    -1,    -1,   253,   254,   255,
      -1,    -1,   258,   259,   260,   261,   262,   263,   264,   265,
     266,   267,   268,   269,   270,    -1,   272,   273,   274,   275,
     276,   277,   278,    -1,   280,   281,   282,   283,   284,   285,
     286,   287,   288,   289,   290,   291,   292,    -1,   294,   295,
     296,   297,   298,   299,   300,   301,   302,   303,   304,    -1,
     306,   307,   308,   309,   310,   311,   312,   313,   314,   315,
     316,   317,   318,   319,    -1,   321,   322,   323,   324,   325,
      -1,   327,   328,   329,   330,   331,   332,   333,   334,    -1,
     336,   337,   338,   339,   340,   341,   342,   343,   344,   345,
     346,    -1,   348,   349,    -1,   351,   352,   353,   354,   355,
     356,    -1,   358,   359,    -1,    -1,   362,   363,   364,   365,
      -1,   367,   368,   369,   370,   371,   372,   373,    -1,    -1,
     376,   377,   378,   379,   380,    -1,    -1,   383,   384,   385,
     386,   387,   388,   389,    -1,   391,   392,   393,   394,   395,
     396,    -1,    -1,   399,    -1,    -1,   402,   403,   404,   405,
     406,   407,   408,   409,   410,   411,   412,   413,   414,   415,
     416,   417,   418,   419,     3,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    14,    15,    16,    17,    18,
      19,    20,    21,    -1,    23,    24,    25,    -1,    -1,    -1,
      -1,    30,    -1,    -1,    -1,    34,    35,    -1,    37,    38,
      -1,    40,    41,    42,    43,    44,    -1,    46,    47,    -1,
      49,    50,    51,    52,    53,    -1,    -1,    56,    57,    58,
      59,    60,    61,    62,    63,    64,    65,    66,    -1,    -1,
      69,    70,    71,    72,    73,    -1,    75,    76,    77,    78,
      79,    80,    81,    82,    83,    -1,    -1,    86,    87,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    95,    96,    97,    98,
      99,   100,   101,   102,   103,    -1,   105,    -1,   107,   108,
     109,   110,   111,    -1,   113,   114,   115,    -1,    -1,   118,
     119,   120,   121,   122,    -1,   124,   125,   126,    -1,   128,
     129,   130,    -1,   132,   133,   134,   135,   136,   137,   138,
     139,   140,    -1,   142,    -1,   144,   145,   146,   147,    -1,
     149,   150,   151,    -1,    -1,    -1,   155,   156,   157,    -1,
     159,   160,    -1,   162,    -1,   164,   165,   166,   167,   168,
      -1,   170,   171,   172,    -1,   174,   175,   176,   177,   178,
     179,    -1,   181,    -1,   183,   184,   185,   186,   187,   188,
     189,    -1,   191,    -1,   193,    -1,    -1,   196,    -1,   198,
     199,   200,   201,   202,    -1,   204,   205,    -1,   207,   208,
      -1,   210,    -1,    -1,   213,   214,   215,    -1,    -1,   218,
     219,   220,   221,   222,   223,   224,   225,   226,   227,   228,
     229,   230,   231,    -1,   233,   234,   235,   236,    -1,   238,
     239,    -1,   241,    -1,   243,   244,   245,   246,   247,   248,
      -1,   250,    -1,    -1,   253,   254,   255,    -1,    -1,   258,
     259,    -1,   261,    -1,   263,   264,   265,   266,   267,   268,
     269,   270,    -1,   272,   273,   274,   275,   276,   277,   278,
     279,   280,   281,   282,   283,   284,   285,   286,   287,   288,
     289,   290,   291,   292,    -1,   294,   295,   296,   297,   298,
     299,   300,   301,   302,   303,   304,    -1,   306,   307,    -1,
     309,   310,   311,   312,   313,   314,   315,   316,   317,   318,
     319,    -1,   321,   322,   323,   324,   325,    -1,   327,   328,
     329,   330,    -1,   332,   333,   334,    -1,   336,   337,   338,
     339,   340,   341,   342,   343,   344,   345,   346,    -1,   348,
     349,    -1,   351,   352,   353,   354,   355,   356,    -1,   358,
     359,    -1,    -1,   362,   363,   364,   365,    -1,   367,   368,
     369,   370,   371,   372,   373,    -1,   375,   376,   377,   378,
     379,   380,    -1,    -1,   383,   384,   385,   386,   387,   388,
     389,    -1,   391,    -1,   393,   394,   395,   396,    -1,    -1,
     399,    -1,    -1,   402,   403,   404,   405,   406,   407,   408,
     409,   410,   411,   412,   413,   414,   415,   416,   417,   418,
     419,     3,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    14,    15,    16,    17,    18,    19,    20,    21,
      -1,    23,    24,    25,    -1,    -1,    -1,    -1,    30,    -1,
      -1,    -1,    34,    35,    -1,    37,    38,    -1,    40,    41,
      42,    43,    44,    -1,    46,    47,    -1,    49,    50,    51,
      52,    53,    -1,    -1,    56,    57,    58,    59,    60,    61,
      62,    63,    64,    65,    66,    -1,    -1,    -1,    70,    71,
      72,    73,    -1,    75,    76,    77,    78,    79,    80,    81,
      82,    83,    -1,    -1,    86,    87,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    95,    96,    97,    98,    99,   100,   101,
     102,   103,    -1,   105,    -1,   107,   108,   109,   110,   111,
      -1,   113,   114,   115,    -1,    -1,   118,   119,   120,   121,
     122,    -1,   124,   125,   126,    -1,   128,   129,   130,    -1,
     132,   133,   134,   135,   136,   137,   138,   139,   140,    -1,
     142,    -1,   144,   145,   146,   147,    -1,   149,   150,   151,
      -1,    -1,    -1,   155,   156,   157,    -1,   159,   160,    -1,
     162,    -1,   164,   165,   166,   167,   168,    -1,   170,   171,
     172,    -1,   174,   175,   176,   177,   178,   179,    -1,   181,
      -1,   183,   184,   185,   186,   187,   188,   189,    -1,   191,
      -1,   193,    -1,    -1,   196,    -1,   198,   199,   200,   201,
     202,    -1,   204,   205,    -1,   207,   208,    -1,   210,   211,
      -1,   213,   214,   215,    -1,    -1,   218,   219,   220,   221,
     222,   223,   224,   225,   226,   227,   228,   229,   230,   231,
      -1,   233,   234,   235,   236,    -1,   238,   239,    -1,   241,
      -1,   243,   244,   245,   246,   247,   248,    -1,   250,    -1,
      -1,   253,   254,   255,    -1,    -1,   258,   259,    -1,   261,
      -1,   263,   264,   265,   266,   267,   268,   269,   270,    -1,
     272,   273,   274,   275,   276,   277,   278,   279,   280,   281,
     282,   283,   284,   285,   286,   287,   288,   289,   290,   291,
     292,    -1,   294,   295,   296,   297,   298,   299,   300,   301,
     302,   303,   304,    -1,   306,   307,    -1,   309,   310,   311,
     312,   313,   314,   315,   316,   317,   318,   319,    -1,   321,
     322,   323,   324,   325,    -1,   327,   328,   329,   330,    -1,
     332,   333,   334,    -1,   336,   337,   338,   339,   340,   341,
     342,   343,   344,   345,   346,    -1,   348,   349,    -1,   351,
     352,   353,   354,   355,   356,    -1,   358,   359,    -1,    -1,
     362,   363,   364,   365,    -1,   367,   368,   369,   370,   371,
     372,   373,    -1,   375,   376,   377,   378,   379,   380,    -1,
      -1,   383,   384,   385,   386,   387,   388,   389,    -1,   391,
      -1,   393,   394,   395,   396,    -1,    -1,   399,    -1,    -1,
     402,   403,   404,   405,   406,   407,   408,   409,   410,   411,
     412,   413,   414,   415,   416,   417,   418,   419,     3,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    14,
      15,    16,    17,    18,    19,    20,    21,    22,    23,    24,
      25,    -1,    -1,    -1,    -1,    30,    -1,    -1,    -1,    34,
      35,    -1,    37,    38,    -1,    40,    41,    42,    43,    44,
      -1,    46,    47,    -1,    49,    50,    51,    52,    53,    -1,
      -1,    56,    57,    58,    59,    60,    -1,    62,    63,    64,
      65,    66,    -1,    -1,    -1,    70,    71,    72,    73,    -1,
      75,    76,    -1,    78,    79,    80,    81,    82,    83,    84,
      -1,    86,    87,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      95,    96,    97,    98,    99,   100,   101,   102,   103,    -1,
     105,    -1,   107,   108,   109,   110,   111,    -1,   113,   114,
     115,    -1,    -1,   118,   119,   120,   121,   122,    -1,   124,
     125,   126,    -1,   128,   129,   130,    -1,   132,   133,   134,
     135,   136,   137,   138,   139,   140,    -1,   142,    -1,   144,
     145,   146,   147,    -1,   149,    -1,   151,    -1,    -1,    -1,
     155,   156,   157,   158,   159,   160,    -1,   162,    -1,   164,
     165,   166,   167,   168,    -1,   170,   171,   172,    -1,   174,
     175,   176,   177,   178,   179,    -1,   181,    -1,   183,   184,
     185,   186,   187,   188,   189,    -1,   191,    -1,   193,    -1,
      -1,   196,    -1,   198,   199,   200,   201,   202,    -1,   204,
     205,    -1,   207,   208,    -1,   210,    -1,    -1,   213,   214,
     215,    -1,    -1,   218,   219,   220,   221,   222,   223,   224,
     225,   226,   227,   228,   229,   230,   231,    -1,   233,   234,
     235,   236,    -1,   238,   239,    -1,   241,    -1,   243,   244,
     245,   246,   247,   248,    -1,   250,    -1,    -1,   253,   254,
     255,    -1,    -1,   258,   259,    -1,   261,    -1,   263,   264,
     265,   266,   267,   268,   269,   270,    -1,   272,   273,   274,
     275,   276,   277,   278,    -1,   280,   281,   282,   283,   284,
     285,   286,   287,   288,   289,   290,   291,   292,   293,   294,
     295,   296,   297,   298,   299,   300,   301,   302,   303,   304,
      -1,   306,   307,    -1,   309,   310,   311,   312,   313,   314,
     315,   316,   317,   318,   319,   320,   321,   322,   323,   324,
     325,    -1,   327,   328,   329,   330,    -1,   332,   333,   334,
      -1,   336,   337,   338,   339,   340,   341,   342,   343,   344,
     345,   346,    -1,   348,   349,    -1,   351,   352,   353,   354,
     355,   356,    -1,   358,   359,    -1,    -1,   362,   363,   364,
     365,    -1,   367,   368,   369,   370,   371,   372,   373,    -1,
      -1,   376,   377,   378,   379,   380,    -1,    -1,   383,   384,
     385,   386,   387,   388,   389,    -1,   391,    -1,   393,   394,
     395,   396,    -1,    -1,   399,    -1,    -1,   402,   403,   404,
     405,   406,   407,   408,   409,   410,   411,   412,   413,   414,
     415,   416,   417,   418,   419,     3,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    14,    15,    16,    17,
      18,    19,    20,    21,    22,    23,    24,    25,    -1,    -1,
      -1,    -1,    30,    -1,    -1,    -1,    34,    35,    -1,    37,
      38,    -1,    40,    41,    42,    43,    44,    -1,    46,    47,
      -1,    49,    50,    51,    52,    53,    -1,    -1,    56,    57,
      58,    59,    60,    -1,    62,    63,    64,    65,    66,    -1,
      -1,    -1,    70,    71,    72,    73,    -1,    75,    76,    -1,
      78,    79,    80,    81,    82,    83,    84,    -1,    86,    87,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    95,    96,    97,
      98,    99,   100,   101,   102,   103,    -1,   105,    -1,   107,
     108,   109,   110,   111,    -1,   113,   114,   115,    -1,    -1,
     118,   119,   120,   121,   122,    -1,   124,   125,   126,    -1,
     128,   129,   130,    -1,   132,   133,   134,   135,   136,   137,
     138,   139,   140,    -1,   142,    -1,   144,   145,   146,   147,
      -1,   149,    -1,   151,    -1,    -1,    -1,   155,   156,   157,
     158,   159,   160,    -1,   162,    -1,   164,   165,   166,   167,
     168,    -1,   170,   171,   172,    -1,   174,   175,   176,   177,
     178,   179,    -1,   181,    -1,   183,   184,   185,   186,   187,
     188,   189,    -1,   191,    -1,   193,    -1,    -1,   196,    -1,
     198,   199,   200,   201,   202,    -1,   204,   205,    -1,   207,
     208,    -1,   210,    -1,    -1,   213,   214,   215,    -1,    -1,
     218,   219,   220,   221,   222,   223,   224,   225,   226,   227,
     228,   229,   230,   231,    -1,   233,   234,   235,   236,    -1,
     238,   239,    -1,   241,    -1,   243,   244,   245,   246,   247,
     248,    -1,   250,    -1,    -1,   253,   254,   255,    -1,    -1,
     258,   259,    -1,   261,    -1,   263,   264,   265,   266,   267,
     268,   269,   270,    -1,   272,   273,   274,   275,   276,   277,
     278,    -1,   280,   281,   282,   283,   284,   285,   286,   287,
     288,   289,   290,   291,   292,   293,   294,   295,   296,   297,
     298,   299,   300,   301,   302,   303,   304,    -1,   306,   307,
      -1,   309,   310,   311,   312,   313,   314,   315,   316,   317,
     318,   319,   320,   321,   322,   323,   324,   325,    -1,   327,
     328,   329,   330,    -1,   332,   333,   334,    -1,   336,   337,
     338,   339,   340,   341,   342,   343,   344,   345,   346,    -1,
     348,   349,    -1,   351,   352,   353,   354,   355,   356,    -1,
     358,   359,    -1,    -1,   362,   363,   364,   365,    -1,   367,
     368,   369,   370,   371,   372,   373,    -1,    -1,   376,   377,
     378,   379,   380,    -1,    -1,   383,   384,   385,   386,   387,
     388,   389,    -1,   391,    -1,   393,   394,   395,   396,    -1,
      -1,   399,    -1,    -1,   402,   403,   404,   405,   406,   407,
     408,   409,   410,   411,   412,   413,   414,   415,   416,   417,
     418,   419,     3,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    14,    15,    16,    17,    18,    19,    20,
      21,    -1,    23,    24,    25,    -1,    -1,    -1,    -1,    30,
      -1,    -1,    -1,    34,    35,    -1,    37,    38,    -1,    40,
      41,    42,    43,    44,    -1,    46,    47,    -1,    49,    50,
      51,    52,    53,    -1,    -1,    56,    57,    58,    59,    60,
      61,    62,    63,    64,    65,    66,    -1,    -1,    -1,    70,
      71,    72,    73,    -1,    75,    76,    77,    78,    79,    80,
      81,    82,    83,    -1,    -1,    86,    87,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    95,    96,    97,    98,    99,   100,
     101,   102,   103,    -1,   105,    -1,   107,   108,   109,   110,
     111,    -1,   113,   114,   115,    -1,    -1,   118,   119,   120,
     121,   122,    -1,   124,   125,   126,    -1,   128,   129,   130,
      -1,   132,   133,   134,   135,   136,   137,   138,   139,   140,
      -1,   142,    -1,   144,   145,   146,   147,    -1,   149,   150,
     151,    -1,    -1,    -1,   155,   156,   157,    -1,   159,   160,
      -1,   162,    -1,   164,   165,   166,   167,   168,    -1,   170,
     171,   172,    -1,   174,   175,   176,   177,   178,   179,    -1,
     181,    -1,   183,   184,   185,   186,   187,   188,   189,    -1,
     191,    -1,   193,    -1,    -1,   196,    -1,   198,   199,   200,
     201,   202,    -1,   204,   205,    -1,   207,   208,    -1,   210,
      -1,    -1,   213,   214,   215,    -1,    -1,   218,   219,   220,
     221,   222,   223,   224,   225,   226,   227,   228,   229,   230,
     231,    -1,   233,   234,   235,   236,    -1,   238,   239,    -1,
     241,    -1,   243,   244,   245,   246,   247,   248,    -1,   250,
      -1,    -1,   253,   254,   255,    -1,    -1,   258,   259,    -1,
     261,    -1,   263,   264,   265,   266,   267,   268,   269,   270,
      -1,   272,   273,   274,   275,   276,   277,   278,   279,   280,
     281,   282,   283,   284,   285,   286,   287,   288,   289,   290,
     291,   292,    -1,   294,   295,   296,   297,   298,   299,   300,
     301,   302,   303,   304,    -1,   306,   307,    -1,   309,   310,
     311,   312,   313,   314,   315,   316,   317,   318,   319,    -1,
     321,   322,   323,   324,   325,    -1,   327,   328,   329,   330,
      -1,   332,   333,   334,    -1,   336,   337,   338,   339,   340,
     341,   342,   343,   344,   345,   346,    -1,   348,   349,    -1,
     351,   352,   353,   354,   355,   356,    -1,   358,   359,    -1,
      -1,   362,   363,   364,   365,    -1,   367,   368,   369,   370,
     371,   372,   373,    -1,   375,   376,   377,   378,   379,   380,
      -1,    -1,   383,   384,   385,   386,   387,   388,   389,    -1,
     391,    -1,   393,   394,   395,   396,    -1,    -1,   399,    -1,
      -1,   402,   403,   404,   405,   406,   407,   408,   409,   410,
     411,   412,   413,   414,   415,   416,   417,   418,   419,     3,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      14,    15,    16,    17,    18,    19,    20,    21,    22,    23,
      24,    25,    -1,    -1,    -1,    -1,    30,    -1,    -1,    -1,
      34,    35,    -1,    37,    38,    -1,    40,    41,    42,    43,
      44,    -1,    46,    47,    -1,    49,    50,    51,    52,    53,
      -1,    -1,    56,    57,    58,    59,    60,    -1,    62,    63,
      64,    65,    66,    -1,    -1,    -1,    70,    71,    72,    73,
      -1,    75,    76,    -1,    78,    79,    80,    81,    82,    83,
      84,    -1,    86,    87,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    95,    96,    97,    98,    99,   100,   101,   102,   103,
      -1,   105,    -1,   107,   108,   109,   110,   111,    -1,   113,
     114,   115,    -1,    -1,   118,   119,   120,   121,   122,    -1,
     124,   125,   126,    -1,   128,   129,   130,    -1,   132,   133,
     134,   135,   136,   137,   138,   139,   140,    -1,   142,    -1,
     144,   145,   146,   147,    -1,   149,    -1,   151,    -1,    -1,
      -1,   155,   156,   157,    -1,   159,   160,    -1,   162,    -1,
     164,   165,   166,   167,   168,    -1,   170,   171,   172,    -1,
     174,   175,   176,   177,   178,   179,    -1,   181,    -1,   183,
     184,   185,   186,   187,   188,   189,    -1,   191,    -1,   193,
      -1,    -1,   196,    -1,   198,   199,   200,   201,   202,    -1,
     204,   205,    -1,   207,   208,    -1,   210,    -1,    -1,   213,
     214,   215,    -1,    -1,   218,   219,   220,   221,   222,   223,
     224,   225,   226,   227,   228,   229,   230,   231,    -1,   233,
     234,   235,   236,    -1,   238,   239,    -1,   241,    -1,   243,
     244,   245,   246,   247,   248,    -1,   250,    -1,    -1,   253,
     254,   255,    -1,    -1,   258,   259,    -1,   261,    -1,   263,
     264,   265,   266,   267,   268,   269,   270,    -1,   272,   273,
     274,   275,   276,   277,   278,    -1,   280,   281,   282,   283,
     284,   285,   286,   287,   288,   289,   290,   291,   292,   293,
     294,   295,   296,   297,   298,   299,   300,   301,   302,   303,
     304,    -1,   306,   307,    -1,   309,   310,   311,   312,   313,
     314,   315,   316,   317,   318,   319,   320,   321,   322,   323,
     324,   325,    -1,   327,   328,   329,   330,    -1,   332,   333,
     334,    -1,   336,   337,   338,   339,   340,   341,   342,   343,
     344,   345,   346,    -1,   348,   349,    -1,   351,   352,   353,
     354,   355,   356,    -1,   358,   359,    -1,    -1,   362,   363,
     364,   365,    -1,   367,   368,   369,   370,   371,   372,   373,
      -1,    -1,   376,   377,   378,   379,   380,    -1,    -1,   383,
     384,   385,   386,   387,   388,   389,    -1,   391,    -1,   393,
     394,   395,   396,    -1,    -1,   399,    -1,    -1,   402,   403,
     404,   405,   406,   407,   408,   409,   410,   411,   412,   413,
     414,   415,   416,   417,   418,   419,     3,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    14,    15,    16,
      17,    18,    19,    20,    21,    22,    23,    24,    25,    -1,
      -1,    -1,    -1,    30,    -1,    -1,    -1,    34,    35,    -1,
      37,    38,    -1,    40,    41,    42,    43,    44,    -1,    46,
      47,    -1,    49,    50,    51,    52,    53,    -1,    -1,    56,
      57,    58,    59,    60,    -1,    62,    63,    64,    65,    66,
      -1,    -1,    -1,    70,    71,    72,    73,    -1,    75,    76,
      -1,    78,    79,    80,    81,    82,    83,    -1,    -1,    86,
      87,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    95,    96,
      97,    98,    99,   100,   101,   102,   103,    -1,   105,    -1,
     107,   108,   109,   110,   111,    -1,   113,   114,   115,    -1,
      -1,   118,   119,   120,   121,   122,    -1,   124,   125,   126,
      -1,   128,   129,   130,    -1,   132,   133,   134,   135,   136,
     137,   138,   139,   140,    -1,   142,    -1,   144,   145,   146,
     147,    -1,   149,   150,   151,    -1,    -1,    -1,   155,   156,
     157,    -1,   159,   160,    -1,   162,    -1,   164,   165,   166,
     167,   168,    -1,   170,   171,   172,    -1,   174,   175,   176,
     177,   178,   179,    -1,   181,    -1,   183,   184,   185,   186,
     187,   188,   189,    -1,   191,    -1,   193,    -1,    -1,   196,
      -1,   198,   199,   200,   201,   202,    -1,   204,   205,    -1,
     207,   208,    -1,   210,    -1,    -1,   213,   214,   215,    -1,
      -1,   218,   219,   220,   221,   222,   223,   224,   225,   226,
     227,   228,   229,   230,   231,    -1,   233,   234,   235,   236,
      -1,   238,   239,    -1,   241,    -1,   243,   244,   245,   246,
     247,   248,    -1,   250,    -1,    -1,   253,   254,   255,    -1,
      -1,   258,   259,    -1,   261,    -1,   263,   264,   265,   266,
     267,   268,   269,   270,    -1,   272,   273,   274,   275,   276,
     277,   278,    -1,   280,   281,   282,   283,   284,   285,   286,
     287,   288,   289,   290,   291,   292,    -1,   294,   295,   296,
     297,   298,   299,   300,   301,   302,   303,   304,    -1,   306,
     307,    -1,   309,   310,   311,   312,   313,   314,   315,   316,
     317,   318,   319,    -1,   321,   322,   323,   324,   325,    -1,
     327,   328,   329,   330,    -1,   332,   333,   334,    -1,   336,
     337,   338,   339,   340,   341,   342,   343,   344,   345,   346,
      -1,   348,   349,   350,   351,   352,   353,   354,   355,   356,
      -1,   358,   359,    -1,    -1,   362,   363,   364,   365,    -1,
     367,   368,   369,   370,   371,   372,   373,    -1,    -1,   376,
     377,   378,   379,   380,    -1,    -1,   383,   384,   385,   386,
     387,   388,   389,    -1,   391,    -1,   393,   394,   395,   396,
      -1,    -1,   399,    -1,    -1,   402,   403,   404,   405,   406,
     407,   408,   409,   410,   411,   412,   413,   414,   415,   416,
     417,   418,   419,     3,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    14,    15,    16,    17,    18,    19,
      20,    21,    -1,    23,    24,    25,    -1,    -1,    -1,    -1,
      30,    -1,    -1,    -1,    34,    35,    -1,    37,    38,    -1,
      40,    41,    42,    43,    44,    -1,    46,    47,    -1,    49,
      50,    51,    52,    53,    -1,    -1,    56,    57,    58,    59,
      60,    -1,    62,    63,    64,    65,    66,    -1,    -1,    -1,
      70,    71,    72,    73,    -1,    75,    76,    -1,    78,    79,
      80,    81,    82,    83,    84,    -1,    86,    87,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    95,    96,    97,    98,    99,
     100,   101,   102,   103,    -1,   105,    -1,   107,   108,   109,
     110,   111,    -1,   113,   114,   115,    -1,    -1,   118,   119,
     120,   121,   122,    -1,   124,   125,   126,    -1,   128,   129,
     130,    -1,   132,   133,   134,   135,   136,   137,   138,   139,
     140,    -1,   142,    -1,   144,   145,   146,   147,    -1,   149,
      -1,   151,    -1,    -1,    -1,   155,   156,   157,    -1,   159,
     160,    -1,   162,    -1,   164,   165,   166,   167,   168,    -1,
     170,   171,   172,    -1,   174,   175,   176,   177,   178,   179,
      -1,   181,    -1,   183,   184,   185,   186,   187,   188,   189,
      -1,   191,    -1,   193,    -1,    -1,   196,    -1,   198,   199,
     200,   201,   202,    -1,   204,   205,    -1,   207,   208,    -1,
     210,    -1,    -1,   213,   214,   215,    -1,    -1,   218,   219,
     220,   221,   222,   223,   224,   225,   226,   227,   228,   229,
     230,   231,    -1,   233,   234,   235,   236,    -1,   238,   239,
      -1,   241,    -1,   243,   244,   245,   246,   247,   248,    -1,
     250,    -1,    -1,   253,   254,   255,    -1,    -1,   258,   259,
      -1,   261,    -1,   263,   264,   265,   266,   267,   268,   269,
     270,    -1,   272,   273,   274,   275,   276,   277,   278,    -1,
     280,   281,   282,   283,   284,   285,   286,   287,   288,   289,
     290,   291,   292,   293,   294,   295,   296,   297,   298,   299,
     300,   301,   302,   303,   304,    -1,   306,   307,    -1,   309,
     310,   311,   312,   313,   314,   315,   316,   317,   318,   319,
     320,   321,   322,   323,   324,   325,    -1,   327,   328,   329,
     330,    -1,   332,   333,   334,    -1,   336,   337,   338,   339,
     340,   341,   342,   343,   344,   345,   346,    -1,   348,   349,
      -1,   351,   352,   353,   354,   355,   356,    -1,   358,   359,
      -1,    -1,   362,   363,   364,   365,    -1,   367,   368,   369,
     370,   371,   372,   373,    -1,    -1,   376,   377,   378,   379,
     380,    -1,    -1,   383,   384,   385,   386,   387,   388,   389,
      -1,   391,    -1,   393,   394,   395,   396,    -1,    -1,   399,
      -1,    -1,   402,   403,   404,   405,   406,   407,   408,   409,
     410,   411,   412,   413,   414,   415,   416,   417,   418,   419,
       3,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    14,    15,    16,    17,    18,    19,    20,    21,    22,
      23,    24,    25,    -1,    -1,    -1,    -1,    30,    -1,    -1,
      -1,    34,    35,    -1,    37,    38,    -1,    40,    41,    42,
      43,    44,    -1,    46,    47,    -1,    49,    50,    51,    52,
      53,    -1,    -1,    56,    57,    58,    59,    60,    -1,    62,
      63,    64,    65,    66,    -1,    -1,    -1,    70,    71,    72,
      73,    -1,    75,    76,    -1,    78,    79,    80,    81,    82,
      83,    -1,    -1,    86,    87,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    95,    96,    97,    98,    99,   100,   101,   102,
     103,    -1,   105,    -1,   107,   108,   109,   110,   111,    -1,
     113,   114,   115,    -1,    -1,   118,   119,   120,   121,   122,
      -1,   124,   125,   126,    -1,   128,   129,   130,    -1,   132,
     133,   134,   135,   136,   137,   138,   139,   140,    -1,   142,
      -1,   144,   145,   146,   147,    -1,   149,    -1,   151,    -1,
      -1,    -1,   155,   156,   157,    -1,   159,   160,    -1,   162,
      -1,   164,   165,   166,   167,   168,    -1,   170,   171,   172,
      -1,   174,   175,   176,   177,   178,   179,    -1,   181,    -1,
     183,   184,   185,   186,   187,   188,   189,    -1,   191,    -1,
     193,    -1,    -1,   196,    -1,   198,   199,   200,   201,   202,
      -1,   204,   205,    -1,   207,   208,    -1,   210,    -1,    -1,
     213,   214,   215,    -1,    -1,   218,   219,   220,   221,   222,
     223,   224,   225,   226,   227,   228,   229,   230,   231,    -1,
     233,   234,   235,   236,    -1,   238,   239,    -1,   241,    -1,
     243,   244,   245,   246,   247,   248,    -1,   250,    -1,   252,
     253,   254,   255,    -1,    -1,   258,   259,    -1,   261,    -1,
     263,   264,   265,   266,   267,   268,   269,   270,    -1,   272,
     273,   274,   275,   276,   277,   278,    -1,   280,   281,   282,
     283,   284,   285,   286,   287,   288,   289,   290,   291,   292,
      -1,   294,   295,   296,   297,   298,   299,   300,   301,   302,
     303,   304,    -1,   306,   307,    -1,   309,   310,   311,   312,
     313,   314,   315,   316,   317,   318,   319,    -1,   321,   322,
     323,   324,   325,    -1,   327,   328,   329,   330,    -1,   332,
     333,   334,    -1,   336,   337,   338,   339,   340,   341,   342,
     343,   344,   345,   346,    -1,   348,   349,    -1,   351,   352,
     353,   354,   355,   356,    -1,   358,   359,    -1,    -1,   362,
     363,   364,   365,    -1,   367,   368,   369,   370,   371,   372,
     373,    -1,    -1,   376,   377,   378,   379,   380,    -1,    -1,
     383,   384,   385,   386,   387,   388,   389,    -1,   391,    -1,
     393,   394,   395,   396,    -1,    -1,   399,    -1,    -1,   402,
     403,   404,   405,   406,   407,   408,   409,   410,   411,   412,
     413,   414,   415,   416,   417,   418,   419,     3,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    14,    15,
      16,    17,    18,    19,    20,    21,    -1,    23,    24,    25,
      26,    27,    -1,    -1,    30,    -1,    -1,    -1,    34,    35,
      -1,    37,    38,    -1,    40,    41,    42,    43,    44,    -1,
      46,    47,    -1,    49,    50,    51,    52,    53,    -1,    -1,
      56,    57,    58,    59,    60,    -1,    62,    63,    64,    65,
      66,    -1,    -1,    -1,    70,    71,    72,    73,    -1,    75,
      76,    -1,    78,    79,    80,    81,    82,    83,    -1,    -1,
      86,    87,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    95,
      96,    97,    98,    99,   100,   101,   102,   103,    -1,   105,
      -1,   107,   108,   109,   110,   111,    -1,   113,   114,   115,
      -1,    -1,   118,   119,   120,   121,   122,    -1,   124,   125,
     126,    -1,   128,   129,   130,    -1,   132,   133,   134,   135,
     136,   137,   138,   139,   140,    -1,   142,    -1,   144,   145,
     146,   147,    -1,   149,    -1,   151,    -1,    -1,    -1,   155,
     156,   157,    -1,   159,   160,    -1,   162,    -1,   164,   165,
     166,   167,   168,    -1,   170,   171,   172,    -1,   174,   175,
     176,   177,   178,   179,    -1,   181,    -1,   183,   184,   185,
     186,   187,   188,   189,    -1,   191,    -1,   193,    -1,    -1,
     196,    -1,   198,   199,   200,   201,   202,    -1,   204,   205,
      -1,   207,   208,    -1,   210,    -1,    -1,   213,   214,   215,
      -1,    -1,   218,   219,   220,   221,   222,   223,   224,   225,
     226,   227,   228,   229,   230,   231,    -1,   233,   234,   235,
     236,    -1,   238,   239,    -1,   241,    -1,   243,   244,   245,
     246,   247,   248,    -1,   250,    -1,    -1,   253,   254,   255,
      -1,    -1,   258,   259,    -1,   261,    -1,   263,   264,   265,
     266,   267,   268,   269,   270,    -1,   272,   273,   274,   275,
     276,   277,   278,    -1,   280,   281,   282,   283,   284,   285,
     286,   287,   288,   289,   290,   291,   292,    -1,   294,   295,
     296,   297,   298,   299,   300,   301,   302,   303,   304,    -1,
     306,   307,    -1,   309,   310,   311,   312,   313,   314,   315,
     316,   317,   318,   319,    -1,   321,   322,   323,   324,   325,
      -1,   327,   328,   329,   330,    -1,   332,   333,   334,    -1,
     336,   337,   338,   339,   340,   341,   342,   343,   344,   345,
     346,    -1,   348,   349,    -1,   351,   352,   353,   354,   355,
     356,    -1,   358,   359,    -1,    -1,   362,   363,   364,   365,
      -1,   367,   368,   369,   370,   371,   372,   373,    -1,    -1,
     376,   377,   378,   379,   380,    -1,    -1,   383,   384,   385,
     386,   387,   388,   389,    -1,   391,    -1,   393,   394,   395,
     396,    -1,    -1,   399,    -1,    -1,   402,   403,   404,   405,
     406,   407,   408,   409,   410,   411,   412,   413,   414,   415,
     416,   417,   418,   419,     3,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    14,    15,    16,    17,    18,
      19,    20,    21,    22,    23,    24,    25,    -1,    -1,    -1,
      -1,    30,    -1,    -1,    -1,    34,    35,    -1,    37,    38,
      -1,    40,    41,    42,    43,    44,    -1,    46,    47,    -1,
      49,    50,    51,    52,    53,    -1,    -1,    56,    57,    58,
      59,    60,    -1,    62,    63,    64,    65,    66,    -1,    -1,
      -1,    70,    71,    72,    73,    -1,    75,    76,    -1,    78,
      79,    80,    81,    82,    83,    -1,    -1,    86,    87,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    95,    96,    97,    98,
      99,   100,   101,   102,   103,    -1,   105,    -1,   107,   108,
     109,   110,   111,    -1,   113,   114,   115,    -1,    -1,   118,
     119,   120,   121,   122,    -1,   124,   125,   126,    -1,   128,
     129,   130,    -1,   132,   133,   134,   135,   136,   137,   138,
     139,   140,    -1,   142,    -1,   144,   145,   146,   147,    -1,
     149,    -1,   151,    -1,    -1,    -1,   155,   156,   157,    -1,
     159,   160,    -1,   162,    -1,   164,   165,   166,   167,   168,
      -1,   170,   171,   172,    -1,   174,   175,   176,   177,   178,
     179,    -1,   181,    -1,   183,   184,   185,   186,   187,   188,
     189,    -1,   191,    -1,   193,    -1,    -1,   196,    -1,   198,
     199,   200,   201,   202,    -1,   204,   205,    -1,   207,   208,
      -1,   210,    -1,    -1,   213,   214,   215,    -1,    -1,   218,
     219,   220,   221,   222,   223,   224,   225,   226,   227,   228,
     229,   230,   231,    -1,   233,   234,   235,   236,    -1,   238,
     239,    -1,   241,    -1,   243,   244,   245,   246,   247,   248,
      -1,   250,    -1,    -1,   253,   254,   255,    -1,    -1,   258,
     259,    -1,   261,    -1,   263,   264,   265,   266,   267,   268,
     269,   270,    -1,   272,   273,   274,   275,   276,   277,   278,
      -1,   280,   281,   282,   283,   284,   285,   286,   287,   288,
     289,   290,   291,   292,    -1,   294,   295,   296,   297,   298,
     299,   300,   301,   302,   303,   304,    -1,   306,   307,    -1,
     309,   310,   311,   312,   313,   314,   315,   316,   317,   318,
     319,    -1,   321,   322,   323,   324,   325,    -1,   327,   328,
     329,   330,    -1,   332,   333,   334,    -1,   336,   337,   338,
     339,   340,   341,   342,   343,   344,   345,   346,    -1,   348,
     349,    -1,   351,   352,   353,   354,   355,   356,    -1,   358,
     359,    -1,    -1,   362,   363,   364,   365,    -1,   367,   368,
     369,   370,   371,   372,   373,    -1,    -1,   376,   377,   378,
     379,   380,   381,    -1,   383,   384,   385,   386,   387,   388,
     389,    -1,   391,    -1,   393,   394,   395,   396,    -1,    -1,
     399,    -1,    -1,   402,   403,   404,   405,   406,   407,   408,
     409,   410,   411,   412,   413,   414,   415,   416,   417,   418,
     419,     3,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    14,    15,    16,    17,    18,    19,    20,    21,
      22,    23,    24,    25,    -1,    -1,    -1,    -1,    30,    -1,
      -1,    -1,    34,    35,    -1,    37,    38,    -1,    40,    41,
      42,    43,    44,    -1,    46,    47,    -1,    49,    50,    51,
      52,    53,    -1,    -1,    56,    57,    58,    59,    60,    -1,
      62,    63,    64,    65,    66,    -1,    -1,    -1,    70,    71,
      72,    73,    -1,    75,    76,    -1,    78,    79,    80,    81,
      82,    83,    -1,    -1,    86,    87,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    95,    96,    97,    98,    99,   100,   101,
     102,   103,    -1,   105,    -1,   107,   108,   109,   110,   111,
      -1,   113,   114,   115,    -1,    -1,   118,   119,   120,   121,
     122,    -1,   124,   125,   126,    -1,   128,   129,   130,    -1,
     132,   133,   134,   135,   136,   137,   138,   139,   140,    -1,
     142,    -1,   144,   145,   146,   147,    -1,   149,    -1,   151,
      -1,    -1,    -1,   155,   156,   157,    -1,   159,   160,    -1,
     162,    -1,   164,   165,   166,   167,   168,    -1,   170,   171,
     172,    -1,   174,   175,   176,   177,   178,   179,    -1,   181,
      -1,   183,   184,   185,   186,   187,   188,   189,    -1,   191,
      -1,   193,    -1,    -1,   196,    -1,   198,   199,   200,   201,
     202,    -1,   204,   205,    -1,   207,   208,    -1,   210,    -1,
      -1,   213,   214,   215,    -1,    -1,   218,   219,   220,   221,
     222,   223,   224,   225,   226,   227,   228,   229,   230,   231,
      -1,   233,   234,   235,   236,    -1,   238,   239,    -1,   241,
      -1,   243,   244,   245,   246,   247,   248,    -1,   250,    -1,
      -1,   253,   254,   255,    -1,    -1,   258,   259,    -1,   261,
      -1,   263,   264,   265,   266,   267,   268,   269,   270,    -1,
     272,   273,   274,   275,   276,   277,   278,    -1,   280,   281,
     282,   283,   284,   285,   286,   287,   288,   289,   290,   291,
     292,    -1,   294,   295,   296,   297,   298,   299,   300,   301,
     302,   303,   304,    -1,   306,   307,    -1,   309,   310,   311,
     312,   313,   314,   315,   316,   317,   318,   319,    -1,   321,
     322,   323,   324,   325,    -1,   327,   328,   329,   330,    -1,
     332,   333,   334,    -1,   336,   337,   338,   339,   340,   341,
     342,   343,   344,   345,   346,    -1,   348,   349,    -1,   351,
     352,   353,   354,   355,   356,    -1,   358,   359,    -1,    -1,
     362,   363,   364,   365,    -1,   367,   368,   369,   370,   371,
     372,   373,    -1,    -1,   376,   377,   378,   379,   380,   381,
      -1,   383,   384,   385,   386,   387,   388,   389,    -1,   391,
      -1,   393,   394,   395,   396,    -1,    -1,   399,    -1,    -1,
     402,   403,   404,   405,   406,   407,   408,   409,   410,   411,
     412,   413,   414,   415,   416,   417,   418,   419,     3,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    14,
      15,    16,    17,    18,    19,    20,    21,    22,    23,    24,
      25,    -1,    -1,    -1,    -1,    30,    -1,    -1,    -1,    34,
      35,    -1,    37,    38,    -1,    40,    41,    42,    43,    44,
      -1,    46,    47,    -1,    49,    50,    51,    52,    53,    -1,
      -1,    56,    57,    58,    59,    60,    -1,    62,    63,    64,
      65,    66,    -1,    -1,    -1,    70,    71,    72,    73,    -1,
      75,    76,    -1,    78,    79,    80,    81,    82,    83,    -1,
      -1,    86,    87,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      95,    96,    97,    98,    99,   100,   101,   102,   103,    -1,
     105,    -1,   107,   108,   109,   110,   111,    -1,   113,   114,
     115,    -1,    -1,   118,   119,   120,   121,   122,    -1,   124,
     125,   126,    -1,   128,   129,   130,    -1,   132,   133,   134,
     135,   136,   137,   138,   139,   140,    -1,   142,    -1,   144,
     145,   146,   147,    -1,   149,    -1,   151,    -1,    -1,    -1,
     155,   156,   157,    -1,   159,   160,    -1,   162,    -1,   164,
     165,   166,   167,   168,    -1,   170,   171,   172,    -1,   174,
     175,   176,   177,   178,   179,    -1,   181,    -1,   183,   184,
     185,   186,   187,   188,   189,    -1,   191,    -1,   193,    -1,
      -1,   196,    -1,   198,   199,   200,   201,   202,    -1,   204,
     205,    -1,   207,   208,    -1,   210,    -1,    -1,   213,   214,
     215,    -1,    -1,   218,   219,   220,   221,   222,   223,   224,
     225,   226,   227,   228,   229,   230,   231,    -1,   233,   234,
     235,   236,    -1,   238,   239,    -1,   241,    -1,   243,   244,
     245,   246,   247,   248,    -1,   250,    -1,    -1,   253,   254,
     255,    -1,    -1,   258,   259,    -1,   261,    -1,   263,   264,
     265,   266,   267,   268,   269,   270,    -1,   272,   273,   274,
     275,   276,   277,   278,    -1,   280,   281,   282,   283,   284,
     285,   286,   287,   288,   289,   290,   291,   292,    -1,   294,
     295,   296,   297,   298,   299,   300,   301,   302,   303,   304,
      -1,   306,   307,    -1,   309,   310,   311,   312,   313,   314,
     315,   316,   317,   318,   319,    -1,   321,   322,   323,   324,
     325,    -1,   327,   328,   329,   330,    -1,   332,   333,   334,
      -1,   336,   337,   338,   339,   340,   341,   342,   343,   344,
     345,   346,    -1,   348,   349,    -1,   351,   352,   353,   354,
     355,   356,    -1,   358,   359,    -1,    -1,   362,   363,   364,
     365,    -1,   367,   368,   369,   370,   371,   372,   373,    -1,
      -1,   376,   377,   378,   379,   380,    -1,    -1,   383,   384,
     385,   386,   387,   388,   389,    -1,   391,    -1,   393,   394,
     395,   396,    -1,    -1,   399,    -1,    -1,   402,   403,   404,
     405,   406,   407,   408,   409,   410,   411,   412,   413,   414,
     415,   416,   417,   418,   419,     3,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    14,    15,    16,    17,
      18,    19,    20,    21,    22,    23,    24,    25,    -1,    -1,
      -1,    -1,    30,    -1,    -1,    -1,    34,    35,    -1,    37,
      38,    -1,    40,    41,    42,    43,    44,    -1,    46,    47,
      -1,    49,    50,    51,    52,    53,    -1,    -1,    56,    57,
      58,    59,    60,    -1,    62,    63,    64,    65,    66,    -1,
      -1,    -1,    70,    71,    72,    73,    -1,    75,    76,    -1,
      78,    79,    80,    81,    82,    83,    -1,    -1,    86,    87,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    95,    96,    97,
      98,    99,   100,   101,   102,   103,    -1,   105,    -1,   107,
     108,   109,   110,   111,    -1,   113,   114,   115,    -1,    -1,
     118,   119,   120,   121,   122,    -1,   124,   125,   126,    -1,
     128,   129,   130,    -1,   132,   133,   134,   135,   136,   137,
     138,   139,   140,    -1,   142,    -1,   144,   145,   146,   147,
      -1,   149,    -1,   151,    -1,    -1,    -1,   155,   156,   157,
      -1,   159,   160,    -1,   162,    -1,   164,   165,   166,   167,
     168,    -1,   170,   171,   172,    -1,   174,   175,   176,   177,
     178,   179,    -1,   181,    -1,   183,   184,   185,   186,   187,
     188,   189,    -1,   191,    -1,   193,    -1,    -1,   196,    -1,
     198,   199,   200,   201,   202,    -1,   204,   205,    -1,   207,
     208,    -1,   210,    -1,    -1,   213,   214,   215,    -1,    -1,
     218,   219,   220,   221,   222,   223,   224,   225,   226,   227,
     228,   229,   230,   231,    -1,   233,   234,   235,   236,    -1,
     238,   239,    -1,   241,    -1,   243,   244,   245,   246,   247,
     248,    -1,   250,    -1,    -1,   253,   254,   255,    -1,    -1,
     258,   259,    -1,   261,    -1,   263,   264,   265,   266,   267,
     268,   269,   270,    -1,   272,   273,   274,   275,   276,   277,
     278,    -1,   280,   281,   282,   283,   284,   285,   286,   287,
     288,   289,   290,   291,   292,    -1,   294,   295,   296,   297,
     298,   299,   300,   301,   302,   303,   304,    -1,   306,   307,
      -1,   309,   310,   311,   312,   313,   314,   315,   316,   317,
     318,   319,    -1,   321,   322,   323,   324,   325,    -1,   327,
     328,   329,   330,    -1,   332,   333,   334,    -1,   336,   337,
     338,   339,   340,   341,   342,   343,   344,   345,   346,    -1,
     348,   349,    -1,   351,   352,   353,   354,   355,   356,    -1,
     358,   359,    -1,    -1,   362,   363,   364,   365,    -1,   367,
     368,   369,   370,   371,   372,   373,    -1,    -1,   376,   377,
     378,   379,   380,    -1,    -1,   383,   384,   385,   386,   387,
     388,   389,    -1,   391,    -1,   393,   394,   395,   396,    -1,
      -1,   399,    -1,    -1,   402,   403,   404,   405,   406,   407,
     408,   409,   410,   411,   412,   413,   414,   415,   416,   417,
     418,   419,     3,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    14,    15,    16,    17,    18,    19,    20,
      21,    22,    23,    24,    25,    -1,    -1,    -1,    -1,    30,
      -1,    -1,    -1,    34,    35,    -1,    37,    38,    -1,    40,
      41,    42,    43,    44,    -1,    46,    47,    -1,    49,    50,
      51,    52,    53,    -1,    -1,    56,    57,    58,    59,    60,
      -1,    62,    63,    64,    65,    66,    -1,    -1,    -1,    70,
      71,    72,    73,    -1,    75,    76,    -1,    78,    79,    80,
      81,    82,    83,    -1,    -1,    86,    87,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    95,    96,    97,    98,    99,   100,
     101,   102,   103,    -1,   105,    -1,   107,   108,   109,   110,
     111,    -1,   113,   114,   115,    -1,    -1,   118,   119,   120,
     121,   122,    -1,   124,   125,   126,    -1,   128,   129,   130,
      -1,   132,   133,   134,   135,   136,   137,   138,   139,   140,
      -1,   142,    -1,   144,   145,   146,   147,    -1,   149,    -1,
     151,    -1,    -1,    -1,   155,   156,   157,    -1,   159,   160,
      -1,   162,    -1,   164,   165,   166,   167,   168,    -1,   170,
     171,   172,    -1,   174,   175,   176,   177,   178,   179,    -1,
     181,    -1,   183,   184,   185,   186,   187,   188,   189,    -1,
     191,    -1,   193,    -1,    -1,   196,    -1,   198,   199,   200,
     201,   202,    -1,   204,   205,    -1,   207,   208,    -1,   210,
      -1,    -1,   213,   214,   215,    -1,    -1,   218,   219,   220,
     221,   222,   223,   224,   225,   226,   227,   228,   229,   230,
     231,    -1,   233,   234,   235,   236,    -1,   238,   239,    -1,
     241,    -1,   243,   244,   245,   246,   247,   248,    -1,   250,
      -1,    -1,   253,   254,   255,    -1,    -1,   258,   259,    -1,
     261,    -1,   263,   264,   265,   266,   267,   268,   269,   270,
      -1,   272,   273,   274,   275,   276,   277,   278,    -1,   280,
     281,   282,   283,   284,   285,   286,   287,   288,   289,   290,
     291,   292,    -1,   294,   295,   296,   297,   298,   299,   300,
     301,   302,   303,   304,    -1,   306,   307,    -1,   309,   310,
     311,   312,   313,   314,   315,   316,   317,   318,   319,    -1,
     321,   322,   323,   324,   325,    -1,   327,   328,   329,   330,
      -1,   332,   333,   334,    -1,   336,   337,   338,   339,   340,
     341,   342,   343,   344,   345,   346,    -1,   348,   349,    -1,
     351,   352,   353,   354,   355,   356,    -1,   358,   359,    -1,
      -1,   362,   363,   364,   365,    -1,   367,   368,   369,   370,
     371,   372,   373,    -1,    -1,   376,   377,   378,   379,   380,
      -1,    -1,   383,   384,   385,   386,   387,   388,   389,    -1,
     391,    -1,   393,   394,   395,   396,    -1,    -1,   399,    -1,
      -1,   402,   403,   404,   405,   406,   407,   408,   409,   410,
     411,   412,   413,   414,   415,   416,   417,   418,   419,     3,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      14,    15,    16,    17,    18,    19,    20,    21,    22,    23,
      24,    25,    -1,    -1,    -1,    -1,    30,    -1,    -1,    -1,
      34,    35,    -1,    37,    38,    -1,    40,    41,    42,    43,
      44,    -1,    46,    47,    -1,    49,    50,    51,    52,    53,
      -1,    -1,    56,    57,    58,    59,    60,    -1,    62,    63,
      64,    65,    66,    -1,    -1,    -1,    70,    71,    72,    73,
      -1,    75,    76,    -1,    78,    79,    80,    81,    82,    83,
      -1,    -1,    86,    87,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    95,    96,    97,    98,    99,   100,   101,   102,   103,
      -1,   105,    -1,   107,   108,   109,   110,   111,    -1,   113,
     114,   115,    -1,    -1,   118,   119,   120,   121,   122,    -1,
     124,   125,   126,    -1,   128,   129,   130,    -1,   132,   133,
     134,   135,   136,   137,   138,   139,   140,    -1,   142,    -1,
     144,   145,   146,   147,    -1,   149,    -1,   151,    -1,    -1,
      -1,   155,   156,   157,    -1,   159,   160,    -1,   162,    -1,
     164,   165,   166,   167,   168,    -1,   170,   171,   172,    -1,
     174,   175,   176,   177,   178,   179,    -1,   181,    -1,   183,
     184,   185,   186,   187,   188,   189,    -1,   191,    -1,   193,
      -1,    -1,   196,    -1,   198,   199,   200,   201,   202,    -1,
     204,   205,    -1,   207,   208,    -1,   210,    -1,    -1,   213,
     214,   215,    -1,    -1,   218,   219,   220,   221,   222,   223,
     224,   225,   226,   227,   228,   229,   230,   231,    -1,   233,
     234,   235,   236,    -1,   238,   239,    -1,   241,    -1,   243,
     244,   245,   246,   247,   248,    -1,   250,    -1,    -1,   253,
     254,   255,    -1,    -1,   258,   259,    -1,   261,    -1,   263,
     264,   265,   266,   267,   268,   269,   270,    -1,   272,   273,
     274,   275,   276,   277,   278,    -1,   280,   281,   282,   283,
     284,   285,   286,   287,   288,   289,   290,   291,   292,    -1,
     294,   295,   296,   297,   298,   299,   300,   301,   302,   303,
     304,    -1,   306,   307,    -1,   309,   310,   311,   312,   313,
     314,   315,   316,   317,   318,   319,    -1,   321,   322,   323,
     324,   325,    -1,   327,   328,   329,   330,    -1,   332,   333,
     334,    -1,   336,   337,   338,   339,   340,   341,   342,   343,
     344,   345,   346,    -1,   348,   349,    -1,   351,   352,   353,
     354,   355,   356,    -1,   358,   359,    -1,    -1,   362,   363,
     364,   365,    -1,   367,   368,   369,   370,   371,   372,   373,
      -1,    -1,   376,   377,   378,   379,   380,    -1,    -1,   383,
     384,   385,   386,   387,   388,   389,    -1,   391,    -1,   393,
     394,   395,   396,    -1,    -1,   399,    -1,    -1,   402,   403,
     404,   405,   406,   407,   408,   409,   410,   411,   412,   413,
     414,   415,   416,   417,   418,   419,     3,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    14,    15,    16,
      17,    18,    19,    20,    21,    -1,    23,    24,    25,    -1,
      -1,    -1,    -1,    30,    -1,    -1,    -1,    34,    35,    -1,
      37,    38,    -1,    40,    41,    42,    43,    44,    -1,    46,
      47,    -1,    49,    50,    51,    52,    53,    -1,    -1,    56,
      57,    58,    59,    60,    -1,    62,    63,    64,    65,    66,
      -1,    -1,    -1,    70,    71,    72,    73,    -1,    75,    76,
      -1,    78,    79,    80,    81,    82,    83,    -1,    -1,    86,
      87,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    95,    96,
      97,    98,    99,   100,   101,   102,   103,    -1,   105,    -1,
     107,   108,   109,   110,   111,    -1,   113,   114,   115,    -1,
      -1,   118,   119,   120,   121,   122,    -1,   124,   125,   126,
      -1,   128,   129,   130,    -1,   132,   133,   134,   135,   136,
     137,   138,   139,   140,    -1,   142,    -1,   144,   145,   146,
     147,    -1,   149,    -1,   151,    -1,    -1,    -1,   155,   156,
     157,    -1,   159,   160,    -1,   162,    -1,   164,   165,   166,
     167,   168,    -1,   170,   171,   172,    -1,   174,   175,   176,
     177,   178,   179,    -1,   181,    -1,   183,   184,   185,   186,
     187,   188,   189,    -1,   191,    -1,   193,    -1,    -1,   196,
      -1,   198,   199,   200,   201,   202,    -1,   204,   205,    -1,
     207,   208,    -1,   210,    -1,    -1,   213,   214,   215,    -1,
      -1,   218,   219,   220,   221,   222,   223,   224,   225,   226,
     227,   228,   229,   230,   231,    -1,   233,   234,   235,   236,
      -1,   238,   239,    -1,   241,    -1,   243,   244,   245,   246,
     247,   248,    -1,   250,    -1,   252,   253,   254,   255,    -1,
      -1,   258,   259,    -1,   261,    -1,   263,   264,   265,   266,
     267,   268,   269,   270,    -1,   272,   273,   274,   275,   276,
     277,   278,    -1,   280,   281,   282,   283,   284,   285,   286,
     287,   288,   289,   290,   291,   292,    -1,   294,   295,   296,
     297,   298,   299,   300,   301,   302,   303,   304,    -1,   306,
     307,    -1,   309,   310,   311,   312,   313,   314,   315,   316,
     317,   318,   319,    -1,   321,   322,   323,   324,   325,    -1,
     327,   328,   329,   330,    -1,   332,   333,   334,    -1,   336,
     337,   338,   339,   340,   341,   342,   343,   344,   345,   346,
      -1,   348,   349,    -1,   351,   352,   353,   354,   355,   356,
      -1,   358,   359,    -1,    -1,   362,   363,   364,   365,    -1,
     367,   368,   369,   370,   371,   372,   373,    -1,    -1,   376,
     377,   378,   379,   380,    -1,    -1,   383,   384,   385,   386,
     387,   388,   389,    -1,   391,    -1,   393,   394,   395,   396,
      -1,    -1,   399,    -1,    -1,   402,   403,   404,   405,   406,
     407,   408,   409,   410,   411,   412,   413,   414,   415,   416,
     417,   418,   419,     3,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    14,    15,    16,    17,    18,    19,
      20,    21,    22,    23,    24,    25,    -1,    -1,    -1,    -1,
      30,    -1,    -1,    -1,    34,    35,    -1,    37,    38,    -1,
      40,    41,    42,    43,    44,    -1,    46,    47,    -1,    49,
      50,    51,    52,    53,    -1,    -1,    56,    57,    58,    59,
      60,    -1,    62,    63,    64,    65,    66,    -1,    -1,    -1,
      70,    71,    72,    73,    -1,    75,    76,    -1,    78,    79,
      80,    81,    82,    83,    -1,    -1,    86,    87,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    95,    96,    97,    98,    99,
     100,   101,   102,   103,    -1,   105,    -1,   107,   108,   109,
     110,   111,    -1,   113,   114,   115,    -1,    -1,   118,   119,
     120,   121,   122,    -1,   124,   125,   126,    -1,   128,   129,
     130,    -1,   132,   133,   134,   135,   136,   137,   138,   139,
     140,    -1,   142,    -1,   144,   145,   146,   147,    -1,   149,
      -1,   151,    -1,    -1,    -1,   155,   156,   157,    -1,   159,
     160,    -1,   162,    -1,   164,   165,   166,   167,   168,    -1,
     170,   171,   172,    -1,   174,   175,   176,   177,   178,   179,
      -1,   181,    -1,   183,   184,   185,   186,   187,   188,   189,
      -1,   191,    -1,   193,    -1,    -1,   196,    -1,   198,   199,
     200,   201,   202,    -1,   204,   205,    -1,   207,   208,    -1,
     210,    -1,    -1,   213,   214,   215,    -1,    -1,   218,   219,
     220,   221,   222,   223,   224,   225,   226,   227,   228,   229,
     230,   231,    -1,   233,   234,   235,   236,    -1,   238,   239,
      -1,   241,    -1,   243,   244,   245,   246,   247,   248,    -1,
     250,    -1,    -1,   253,   254,   255,    -1,    -1,   258,   259,
      -1,   261,    -1,   263,   264,   265,   266,   267,   268,   269,
     270,    -1,   272,   273,   274,   275,   276,   277,   278,    -1,
     280,   281,   282,   283,   284,   285,   286,   287,   288,   289,
     290,   291,   292,    -1,   294,   295,   296,   297,   298,   299,
     300,   301,   302,   303,   304,    -1,   306,   307,    -1,   309,
     310,   311,   312,   313,   314,   315,   316,   317,   318,   319,
      -1,   321,   322,   323,   324,   325,    -1,   327,   328,   329,
     330,    -1,   332,   333,   334,    -1,   336,   337,   338,   339,
     340,   341,   342,   343,   344,   345,   346,    -1,   348,   349,
      -1,   351,   352,   353,   354,   355,   356,    -1,   358,   359,
      -1,    -1,   362,   363,   364,   365,    -1,   367,   368,   369,
     370,   371,   372,   373,    -1,    -1,   376,   377,   378,   379,
     380,    -1,    -1,   383,   384,   385,   386,   387,   388,   389,
      -1,   391,    -1,   393,   394,   395,   396,    -1,    -1,   399,
      -1,    -1,   402,   403,   404,   405,   406,   407,   408,   409,
     410,   411,   412,   413,   414,   415,   416,   417,   418,   419,
       3,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    14,    15,    16,    17,    18,    19,    20,    21,    22,
      23,    24,    25,    -1,    -1,    -1,    -1,    30,    -1,    -1,
      -1,    34,    35,    -1,    37,    38,    -1,    40,    41,    42,
      43,    44,    -1,    46,    47,    -1,    49,    50,    51,    52,
      53,    -1,    -1,    56,    57,    58,    59,    60,    -1,    62,
      63,    64,    65,    66,    -1,    -1,    -1,    70,    71,    72,
      73,    -1,    75,    76,    -1,    78,    79,    80,    81,    82,
      83,    -1,    -1,    86,    87,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    95,    96,    97,    98,    99,   100,   101,   102,
     103,    -1,   105,    -1,   107,   108,   109,   110,   111,    -1,
     113,   114,   115,    -1,    -1,   118,   119,   120,   121,   122,
      -1,   124,   125,   126,    -1,   128,   129,   130,    -1,   132,
     133,   134,   135,   136,   137,   138,   139,   140,    -1,   142,
      -1,   144,   145,   146,   147,    -1,   149,    -1,   151,    -1,
      -1,    -1,   155,   156,   157,    -1,   159,   160,    -1,   162,
      -1,   164,   165,   166,   167,   168,    -1,   170,   171,   172,
      -1,   174,   175,   176,   177,   178,   179,    -1,   181,    -1,
     183,   184,   185,   186,   187,   188,   189,    -1,   191,    -1,
     193,    -1,    -1,   196,    -1,   198,   199,   200,   201,   202,
      -1,   204,   205,    -1,   207,   208,    -1,   210,    -1,    -1,
     213,   214,   215,    -1,    -1,   218,   219,   220,   221,   222,
     223,   224,   225,   226,   227,   228,   229,   230,   231,    -1,
     233,   234,   235,   236,    -1,   238,   239,    -1,   241,    -1,
     243,   244,   245,   246,   247,   248,    -1,   250,    -1,    -1,
     253,   254,   255,    -1,    -1,   258,   259,    -1,   261,    -1,
     263,   264,   265,   266,   267,   268,   269,   270,    -1,   272,
     273,   274,   275,   276,   277,   278,    -1,   280,   281,   282,
     283,   284,   285,   286,   287,   288,   289,   290,   291,   292,
      -1,   294,   295,   296,   297,   298,   299,   300,   301,   302,
     303,   304,    -1,   306,   307,    -1,   309,   310,   311,   312,
     313,   314,   315,   316,   317,   318,   319,    -1,   321,   322,
     323,   324,   325,    -1,   327,   328,   329,   330,    -1,   332,
     333,   334,    -1,   336,   337,   338,   339,   340,   341,   342,
     343,   344,   345,   346,    -1,   348,   349,    -1,   351,   352,
     353,   354,   355,   356,    -1,   358,   359,    -1,    -1,   362,
     363,   364,   365,    -1,   367,   368,   369,   370,   371,   372,
     373,    -1,    -1,   376,   377,   378,   379,   380,    -1,    -1,
     383,   384,   385,   386,   387,   388,   389,    -1,   391,    -1,
     393,   394,   395,   396,    -1,    -1,   399,    -1,    -1,   402,
     403,   404,   405,   406,   407,   408,   409,   410,   411,   412,
     413,   414,   415,   416,   417,   418,   419,     3,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    14,    15,
      16,    17,    18,    19,    20,    21,    22,    23,    24,    25,
      -1,    -1,    -1,    -1,    30,    -1,    -1,    -1,    34,    35,
      -1,    37,    38,    -1,    40,    41,    42,    43,    44,    -1,
      46,    47,    -1,    49,    50,    51,    52,    53,    -1,    -1,
      56,    57,    58,    59,    60,    -1,    62,    63,    64,    65,
      66,    -1,    -1,    -1,    70,    71,    72,    73,    -1,    75,
      76,    -1,    78,    79,    80,    81,    82,    83,    -1,    -1,
      86,    87,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    95,
      96,    97,    98,    99,   100,   101,   102,   103,    -1,   105,
      -1,   107,   108,   109,   110,   111,    -1,   113,   114,   115,
      -1,    -1,   118,   119,   120,   121,   122,    -1,   124,   125,
     126,    -1,   128,   129,   130,    -1,   132,   133,   134,   135,
     136,   137,   138,   139,   140,    -1,   142,    -1,   144,   145,
     146,   147,    -1,   149,    -1,   151,    -1,    -1,    -1,   155,
     156,   157,    -1,   159,   160,    -1,   162,    -1,   164,   165,
     166,   167,   168,    -1,   170,   171,   172,    -1,   174,   175,
     176,   177,   178,   179,    -1,   181,    -1,   183,   184,   185,
     186,   187,   188,   189,    -1,   191,    -1,   193,    -1,    -1,
     196,    -1,   198,   199,   200,   201,   202,    -1,   204,   205,
      -1,   207,   208,    -1,   210,    -1,    -1,   213,   214,   215,
      -1,    -1,   218,   219,   220,   221,   222,   223,   224,   225,
     226,   227,   228,   229,   230,   231,    -1,   233,   234,   235,
     236,    -1,   238,   239,    -1,   241,    -1,   243,   244,   245,
     246,   247,   248,    -1,   250,    -1,    -1,   253,   254,   255,
      -1,    -1,   258,   259,    -1,   261,    -1,   263,   264,   265,
     266,   267,   268,   269,   270,    -1,   272,   273,   274,   275,
     276,   277,   278,    -1,   280,   281,   282,   283,   284,   285,
     286,   287,   288,   289,   290,   291,   292,    -1,   294,   295,
     296,   297,   298,   299,   300,   301,   302,   303,   304,    -1,
     306,   307,    -1,   309,   310,   311,   312,   313,   314,   315,
     316,   317,   318,   319,    -1,   321,   322,   323,   324,   325,
      -1,   327,   328,   329,   330,    -1,   332,   333,   334,    -1,
     336,   337,   338,   339,   340,   341,   342,   343,   344,   345,
     346,    -1,   348,   349,    -1,   351,   352,   353,   354,   355,
     356,    -1,   358,   359,    -1,    -1,   362,   363,   364,   365,
      -1,   367,   368,   369,   370,   371,   372,   373,    -1,    -1,
     376,   377,   378,   379,   380,    -1,    -1,   383,   384,   385,
     386,   387,   388,   389,    -1,   391,    -1,   393,   394,   395,
     396,    -1,    -1,   399,    -1,    -1,   402,   403,   404,   405,
     406,   407,   408,   409,   410,   411,   412,   413,   414,   415,
     416,   417,   418,   419,     3,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    14,    15,    16,    17,    18,
      19,    20,    21,    -1,    23,    24,    25,    -1,    -1,    -1,
      -1,    30,    -1,    -1,    -1,    34,    35,    -1,    37,    38,
      39,    40,    41,    42,    43,    44,    -1,    46,    47,    -1,
      49,    50,    51,    52,    53,    -1,    -1,    56,    57,    58,
      59,    60,    -1,    62,    63,    64,    65,    66,    -1,    -1,
      -1,    70,    71,    72,    73,    -1,    75,    76,    -1,    78,
      79,    80,    81,    82,    83,    -1,    -1,    86,    87,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    95,    96,    97,    98,
      99,   100,   101,   102,   103,    -1,   105,    -1,   107,   108,
     109,   110,   111,    -1,   113,   114,   115,    -1,    -1,   118,
     119,   120,   121,   122,    -1,   124,   125,   126,    -1,   128,
     129,   130,    -1,   132,   133,   134,   135,   136,   137,   138,
     139,   140,    -1,   142,    -1,   144,   145,   146,   147,    -1,
     149,    -1,   151,    -1,    -1,    -1,   155,   156,   157,    -1,
     159,   160,    -1,   162,    -1,   164,   165,   166,   167,   168,
      -1,   170,   171,   172,    -1,   174,   175,   176,   177,   178,
     179,    -1,   181,    -1,   183,   184,   185,   186,   187,   188,
     189,    -1,   191,    -1,   193,    -1,    -1,   196,    -1,   198,
     199,   200,   201,   202,    -1,   204,   205,    -1,   207,   208,
      -1,   210,    -1,    -1,   213,   214,   215,    -1,    -1,   218,
     219,   220,   221,   222,   223,   224,   225,   226,   227,   228,
     229,   230,   231,    -1,   233,   234,   235,   236,    -1,   238,
     239,    -1,   241,    -1,   243,   244,   245,   246,   247,   248,
      -1,   250,    -1,    -1,   253,   254,   255,    -1,    -1,   258,
     259,    -1,   261,    -1,   263,   264,   265,   266,   267,   268,
     269,   270,    -1,   272,   273,   274,   275,   276,   277,   278,
      -1,   280,   281,   282,   283,   284,   285,   286,   287,   288,
     289,   290,   291,   292,    -1,   294,   295,   296,   297,   298,
     299,   300,   301,   302,   303,   304,    -1,   306,   307,    -1,
     309,   310,   311,   312,   313,   314,   315,   316,   317,   318,
     319,    -1,   321,   322,   323,   324,   325,    -1,   327,   328,
     329,   330,    -1,   332,   333,   334,    -1,   336,   337,   338,
     339,   340,   341,   342,   343,   344,   345,   346,    -1,   348,
     349,    -1,   351,   352,   353,   354,   355,   356,    -1,   358,
     359,    -1,    -1,   362,   363,   364,   365,    -1,   367,   368,
     369,   370,   371,   372,   373,    -1,    -1,   376,   377,   378,
     379,   380,    -1,    -1,   383,   384,   385,   386,   387,   388,
     389,    -1,   391,    -1,   393,   394,   395,   396,    -1,    -1,
     399,    -1,    -1,   402,   403,   404,   405,   406,   407,   408,
     409,   410,   411,   412,   413,   414,   415,   416,   417,   418,
     419,     3,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    14,    15,    16,    17,    18,    19,    20,    21,
      -1,    23,    24,    25,    -1,    -1,    -1,    -1,    30,    -1,
      -1,    -1,    34,    35,    -1,    37,    38,    -1,    40,    41,
      42,    43,    44,    -1,    46,    47,    -1,    49,    50,    51,
      52,    53,    -1,    -1,    56,    57,    58,    59,    60,    -1,
      62,    63,    64,    65,    66,    -1,    -1,    -1,    70,    71,
      72,    73,    -1,    75,    76,    -1,    78,    79,    80,    81,
      82,    83,    -1,    -1,    86,    87,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    95,    96,    97,    98,    99,   100,   101,
     102,   103,    -1,   105,    -1,   107,   108,   109,   110,   111,
      -1,   113,   114,   115,    -1,    -1,   118,   119,   120,   121,
     122,    -1,   124,   125,   126,    -1,   128,   129,   130,    -1,
     132,   133,   134,   135,   136,   137,   138,   139,   140,    -1,
     142,    -1,   144,   145,   146,   147,    -1,   149,    -1,   151,
      -1,    -1,    -1,   155,   156,   157,    -1,   159,   160,    -1,
     162,    -1,   164,   165,   166,   167,   168,    -1,   170,   171,
     172,    -1,   174,   175,   176,   177,   178,   179,    -1,   181,
      -1,   183,   184,   185,   186,   187,   188,   189,    -1,   191,
      -1,   193,    -1,    -1,   196,    -1,   198,   199,   200,   201,
     202,    -1,   204,   205,    -1,   207,   208,    -1,   210,    -1,
      -1,   213,   214,   215,    -1,    -1,   218,   219,   220,   221,
     222,   223,   224,   225,   226,   227,   228,   229,   230,   231,
      -1,   233,   234,   235,   236,    -1,   238,   239,    -1,   241,
      -1,   243,   244,   245,   246,   247,   248,    -1,   250,    -1,
     252,   253,   254,   255,    -1,    -1,   258,   259,    -1,   261,
      -1,   263,   264,   265,   266,   267,   268,   269,   270,    -1,
     272,   273,   274,   275,   276,   277,   278,    -1,   280,   281,
     282,   283,   284,   285,   286,   287,   288,   289,   290,   291,
     292,    -1,   294,   295,   296,   297,   298,   299,   300,   301,
     302,   303,   304,    -1,   306,   307,    -1,   309,   310,   311,
     312,   313,   314,   315,   316,   317,   318,   319,    -1,   321,
     322,   323,   324,   325,    -1,   327,   328,   329,   330,    -1,
     332,   333,   334,    -1,   336,   337,   338,   339,   340,   341,
     342,   343,   344,   345,   346,    -1,   348,   349,    -1,   351,
     352,   353,   354,   355,   356,    -1,   358,   359,    -1,    -1,
     362,   363,   364,   365,    -1,   367,   368,   369,   370,   371,
     372,   373,    -1,    -1,   376,   377,   378,   379,   380,    -1,
      -1,   383,   384,   385,   386,   387,   388,   389,    -1,   391,
      -1,   393,   394,   395,   396,    -1,    -1,   399,    -1,    -1,
     402,   403,   404,   405,   406,   407,   408,   409,   410,   411,
     412,   413,   414,   415,   416,   417,   418,   419,     3,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    14,
      15,    16,    17,    18,    19,    20,    21,    22,    23,    24,
      25,    -1,    -1,    -1,    -1,    30,    -1,    -1,    -1,    34,
      35,    -1,    37,    38,    -1,    40,    41,    42,    43,    44,
      -1,    46,    47,    -1,    49,    50,    51,    52,    53,    -1,
      -1,    56,    57,    58,    59,    60,    -1,    62,    63,    64,
      65,    66,    -1,    -1,    -1,    70,    71,    72,    73,    -1,
      75,    76,    -1,    78,    79,    80,    81,    82,    83,    -1,
      -1,    86,    87,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      95,    96,    97,    98,    99,   100,   101,   102,   103,    -1,
     105,    -1,   107,   108,   109,   110,   111,    -1,   113,   114,
     115,    -1,    -1,   118,   119,   120,   121,   122,    -1,   124,
     125,   126,    -1,   128,   129,   130,    -1,   132,   133,   134,
     135,   136,   137,   138,   139,   140,    -1,   142,    -1,   144,
     145,   146,   147,    -1,   149,    -1,   151,    -1,    -1,    -1,
     155,   156,   157,    -1,   159,   160,    -1,   162,    -1,   164,
     165,   166,   167,   168,    -1,   170,   171,   172,    -1,   174,
     175,   176,   177,   178,   179,    -1,   181,    -1,   183,   184,
     185,   186,   187,   188,   189,    -1,   191,    -1,   193,    -1,
      -1,   196,    -1,   198,   199,   200,   201,   202,    -1,   204,
     205,    -1,   207,   208,    -1,   210,    -1,    -1,   213,   214,
     215,    -1,    -1,   218,   219,   220,   221,   222,   223,   224,
     225,   226,   227,   228,   229,   230,   231,    -1,   233,   234,
     235,   236,    -1,   238,   239,    -1,   241,    -1,   243,   244,
     245,   246,   247,   248,    -1,   250,    -1,    -1,   253,   254,
     255,    -1,    -1,   258,   259,    -1,   261,    -1,   263,   264,
     265,   266,   267,   268,   269,   270,    -1,   272,   273,   274,
     275,   276,   277,   278,    -1,   280,   281,   282,   283,   284,
     285,   286,   287,   288,   289,   290,   291,   292,    -1,   294,
     295,   296,   297,   298,   299,   300,   301,   302,   303,   304,
      -1,   306,   307,    -1,   309,   310,   311,   312,   313,   314,
     315,   316,   317,   318,   319,    -1,   321,   322,   323,   324,
     325,    -1,   327,   328,   329,   330,    -1,   332,   333,   334,
      -1,   336,   337,   338,   339,   340,   341,   342,   343,   344,
     345,   346,    -1,   348,   349,    -1,   351,   352,   353,   354,
     355,   356,    -1,   358,   359,    -1,    -1,   362,   363,   364,
     365,    -1,   367,   368,   369,   370,   371,   372,   373,    -1,
      -1,   376,   377,   378,   379,   380,    -1,    -1,   383,   384,
     385,   386,   387,   388,   389,    -1,   391,    -1,   393,   394,
     395,   396,    -1,    -1,   399,    -1,    -1,   402,   403,   404,
     405,   406,   407,   408,   409,   410,   411,   412,   413,   414,
     415,   416,   417,   418,   419,     3,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    14,    15,    16,    17,
      18,    19,    20,    21,    22,    23,    24,    25,    -1,    -1,
      -1,    -1,    30,    -1,    -1,    -1,    34,    35,    -1,    37,
      38,    -1,    40,    41,    42,    43,    44,    -1,    46,    47,
      -1,    49,    50,    51,    52,    53,    -1,    -1,    56,    57,
      58,    59,    60,    -1,    62,    63,    64,    65,    66,    -1,
      -1,    -1,    70,    71,    72,    73,    -1,    75,    76,    -1,
      78,    79,    80,    81,    82,    83,    -1,    -1,    86,    87,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    95,    96,    97,
      98,    99,   100,   101,   102,   103,    -1,   105,    -1,   107,
     108,   109,   110,   111,    -1,   113,   114,   115,    -1,    -1,
     118,   119,   120,   121,   122,    -1,   124,   125,   126,    -1,
     128,   129,   130,    -1,   132,   133,   134,   135,   136,   137,
     138,   139,   140,    -1,   142,    -1,   144,   145,   146,   147,
      -1,   149,    -1,   151,    -1,    -1,    -1,   155,   156,   157,
      -1,   159,   160,    -1,   162,    -1,   164,   165,   166,   167,
     168,    -1,   170,   171,   172,    -1,   174,   175,   176,   177,
     178,   179,    -1,   181,    -1,   183,   184,   185,   186,   187,
     188,   189,    -1,   191,    -1,   193,    -1,    -1,   196,    -1,
     198,   199,   200,   201,   202,    -1,   204,   205,    -1,   207,
     208,    -1,   210,    -1,    -1,   213,   214,   215,    -1,    -1,
     218,   219,   220,   221,   222,   223,   224,   225,   226,   227,
     228,   229,   230,   231,    -1,   233,   234,   235,   236,    -1,
     238,   239,    -1,   241,    -1,   243,   244,   245,   246,   247,
     248,    -1,   250,    -1,    -1,   253,   254,   255,    -1,    -1,
     258,   259,    -1,   261,    -1,   263,   264,   265,   266,   267,
     268,   269,   270,    -1,   272,   273,   274,   275,   276,   277,
     278,    -1,   280,   281,   282,   283,   284,   285,   286,   287,
     288,   289,   290,   291,   292,    -1,   294,   295,   296,   297,
     298,   299,   300,   301,   302,   303,   304,    -1,   306,   307,
      -1,   309,   310,   311,   312,   313,   314,   315,   316,   317,
     318,   319,    -1,   321,   322,   323,   324,   325,    -1,   327,
     328,   329,   330,    -1,   332,   333,   334,    -1,   336,   337,
     338,   339,   340,   341,   342,   343,   344,   345,   346,    -1,
     348,   349,    -1,   351,   352,   353,   354,   355,   356,    -1,
     358,   359,    -1,    -1,   362,   363,   364,   365,    -1,   367,
     368,   369,   370,   371,   372,   373,    -1,    -1,   376,   377,
     378,   379,   380,    -1,    -1,   383,   384,   385,   386,   387,
     388,   389,    -1,   391,    -1,   393,   394,   395,   396,    -1,
      -1,   399,    -1,    -1,   402,   403,   404,   405,   406,   407,
     408,   409,   410,   411,   412,   413,   414,   415,   416,   417,
     418,   419,     3,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    14,    15,    16,    17,    18,    19,    20,
      21,    -1,    23,    24,    25,    -1,    -1,    -1,    -1,    30,
      -1,    -1,    -1,    34,    35,    -1,    37,    38,    -1,    40,
      41,    42,    43,    44,    -1,    46,    47,    -1,    49,    50,
      51,    52,    53,    -1,    -1,    56,    57,    58,    59,    60,
      -1,    62,    63,    64,    65,    66,    -1,    -1,    -1,    70,
      71,    72,    73,    -1,    75,    76,    -1,    78,    79,    80,
      81,    82,    83,    -1,    -1,    86,    87,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    95,    96,    97,    98,    99,   100,
     101,   102,   103,    -1,   105,    -1,   107,   108,   109,   110,
     111,    -1,   113,   114,   115,    -1,    -1,   118,   119,   120,
     121,   122,    -1,   124,   125,   126,    -1,   128,   129,   130,
      -1,   132,   133,   134,   135,   136,   137,   138,   139,   140,
      -1,   142,    -1,   144,   145,   146,   147,    -1,   149,    -1,
     151,    -1,    -1,    -1,   155,   156,   157,    -1,   159,   160,
      -1,   162,    -1,   164,   165,   166,   167,   168,    -1,   170,
     171,   172,    -1,   174,   175,   176,   177,   178,   179,    -1,
     181,    -1,   183,   184,   185,   186,   187,   188,   189,    -1,
     191,    -1,   193,    -1,    -1,   196,    -1,   198,   199,   200,
     201,   202,    -1,   204,   205,    -1,   207,   208,    -1,   210,
      -1,    -1,   213,   214,   215,    -1,    -1,   218,   219,   220,
     221,   222,   223,   224,   225,   226,   227,   228,   229,   230,
     231,    -1,   233,   234,   235,   236,    -1,   238,   239,    -1,
     241,    -1,   243,   244,   245,   246,   247,   248,    -1,   250,
      -1,    -1,   253,   254,   255,    -1,    -1,   258,   259,    -1,
     261,    -1,   263,   264,   265,   266,   267,   268,   269,   270,
      -1,   272,   273,   274,   275,   276,   277,   278,    -1,   280,
     281,   282,   283,   284,   285,   286,   287,   288,   289,   290,
     291,   292,    -1,   294,   295,   296,   297,   298,   299,   300,
     301,   302,   303,   304,    -1,   306,   307,    -1,   309,   310,
     311,   312,   313,   314,   315,   316,   317,   318,   319,    -1,
     321,   322,   323,   324,   325,    -1,   327,   328,   329,   330,
      -1,   332,   333,   334,    -1,   336,   337,   338,   339,   340,
     341,   342,   343,   344,   345,   346,    -1,   348,   349,   350,
     351,   352,   353,   354,   355,   356,    -1,   358,   359,    -1,
      -1,   362,   363,   364,   365,    -1,   367,   368,   369,   370,
     371,   372,   373,    -1,    -1,   376,   377,   378,   379,   380,
      -1,    -1,   383,   384,   385,   386,   387,   388,   389,    -1,
     391,    -1,   393,   394,   395,   396,    -1,    -1,   399,    -1,
      -1,   402,   403,   404,   405,   406,   407,   408,   409,   410,
     411,   412,   413,   414,   415,   416,   417,   418,   419,     3,
      -1,     5,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      14,    15,    16,    17,    18,    19,    20,    21,    -1,    23,
      24,    25,    -1,    -1,    -1,    -1,    30,    -1,    -1,    -1,
      34,    35,    -1,    37,    38,    -1,    40,    41,    42,    43,
      44,    -1,    46,    47,    -1,    49,    50,    51,    52,    53,
      -1,    -1,    56,    57,    58,    59,    60,    -1,    62,    63,
      64,    65,    66,    -1,    -1,    -1,    70,    71,    72,    73,
      -1,    75,    76,    -1,    78,    79,    80,    81,    82,    83,
      -1,    -1,    86,    87,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    95,    96,    97,    98,    99,   100,   101,   102,   103,
      -1,   105,    -1,   107,   108,   109,   110,   111,    -1,   113,
     114,   115,    -1,    -1,   118,   119,   120,   121,   122,    -1,
     124,   125,   126,    -1,   128,   129,   130,    -1,   132,   133,
     134,   135,   136,   137,   138,   139,   140,    -1,   142,    -1,
     144,   145,   146,   147,    -1,   149,    -1,   151,    -1,    -1,
      -1,   155,   156,   157,    -1,   159,   160,    -1,   162,    -1,
     164,   165,   166,   167,   168,    -1,   170,   171,   172,    -1,
     174,   175,   176,   177,   178,   179,    -1,   181,    -1,   183,
     184,   185,   186,   187,   188,   189,    -1,   191,    -1,   193,
      -1,    -1,   196,    -1,   198,   199,   200,   201,   202,    -1,
     204,   205,    -1,   207,   208,    -1,   210,    -1,    -1,   213,
     214,   215,    -1,    -1,   218,   219,   220,   221,   222,   223,
     224,   225,   226,   227,   228,   229,   230,   231,    -1,   233,
     234,   235,   236,    -1,   238,   239,    -1,   241,    -1,   243,
     244,   245,   246,   247,   248,    -1,   250,    -1,    -1,   253,
     254,   255,    -1,    -1,   258,   259,    -1,   261,    -1,   263,
     264,   265,   266,   267,   268,   269,   270,    -1,   272,   273,
     274,   275,   276,   277,   278,    -1,   280,   281,   282,   283,
     284,   285,   286,   287,   288,   289,   290,   291,   292,    -1,
     294,   295,   296,   297,   298,   299,   300,   301,   302,   303,
     304,    -1,   306,   307,    -1,   309,   310,   311,   312,   313,
     314,   315,   316,   317,   318,   319,    -1,   321,   322,   323,
     324,   325,    -1,   327,   328,   329,   330,    -1,   332,   333,
     334,    -1,   336,   337,   338,   339,   340,   341,   342,   343,
     344,   345,   346,    -1,   348,   349,    -1,   351,   352,   353,
     354,   355,   356,    -1,   358,   359,    -1,    -1,   362,   363,
     364,   365,    -1,   367,   368,   369,   370,   371,   372,   373,
      -1,    -1,   376,   377,   378,   379,   380,    -1,    -1,   383,
     384,   385,   386,   387,   388,   389,    -1,   391,    -1,   393,
     394,   395,   396,    -1,    -1,   399,    -1,    -1,   402,   403,
     404,   405,   406,   407,   408,   409,   410,   411,   412,   413,
     414,   415,   416,   417,   418,   419,     3,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    14,    15,    16,
      17,    18,    19,    20,    21,    -1,    23,    24,    25,    -1,
      -1,    -1,    -1,    30,    -1,    32,    -1,    34,    35,    -1,
      37,    38,    -1,    40,    41,    42,    43,    44,    -1,    46,
      47,    -1,    49,    50,    51,    52,    53,    -1,    -1,    56,
      57,    58,    59,    60,    -1,    62,    63,    64,    65,    66,
      -1,    -1,    -1,    70,    71,    72,    73,    -1,    75,    76,
      -1,    78,    79,    80,    81,    82,    83,    -1,    -1,    86,
      87,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    95,    96,
      97,    98,    99,   100,   101,   102,   103,    -1,   105,    -1,
     107,   108,   109,   110,   111,    -1,   113,   114,   115,    -1,
      -1,   118,   119,   120,   121,   122,    -1,   124,   125,   126,
      -1,   128,   129,   130,    -1,   132,   133,   134,   135,   136,
     137,   138,   139,   140,    -1,   142,    -1,   144,   145,   146,
     147,    -1,   149,    -1,   151,    -1,    -1,    -1,   155,   156,
     157,    -1,   159,   160,    -1,   162,    -1,   164,   165,   166,
     167,   168,    -1,   170,   171,   172,    -1,   174,   175,   176,
     177,   178,   179,    -1,   181,    -1,   183,   184,   185,   186,
     187,   188,   189,    -1,   191,    -1,   193,    -1,    -1,   196,
      -1,   198,   199,   200,   201,   202,    -1,   204,   205,    -1,
     207,   208,    -1,   210,    -1,    -1,   213,   214,   215,    -1,
      -1,   218,   219,   220,   221,   222,   223,   224,   225,   226,
     227,   228,   229,   230,   231,    -1,   233,   234,   235,   236,
      -1,   238,   239,    -1,   241,    -1,   243,   244,   245,   246,
     247,   248,    -1,   250,    -1,    -1,   253,   254,   255,    -1,
      -1,   258,   259,    -1,   261,    -1,   263,   264,   265,   266,
     267,   268,   269,   270,    -1,   272,   273,   274,   275,   276,
     277,   278,    -1,   280,   281,   282,   283,   284,   285,   286,
     287,   288,   289,   290,   291,   292,    -1,   294,   295,   296,
     297,   298,   299,   300,   301,   302,   303,   304,    -1,   306,
     307,    -1,   309,   310,   311,   312,   313,   314,   315,   316,
     317,   318,   319,    -1,   321,   322,   323,   324,   325,    -1,
     327,   328,   329,   330,    -1,   332,   333,   334,    -1,   336,
     337,   338,   339,   340,   341,   342,   343,   344,   345,   346,
      -1,   348,   349,    -1,   351,   352,   353,   354,   355,   356,
      -1,   358,   359,    -1,    -1,   362,   363,   364,   365,    -1,
     367,   368,   369,   370,   371,   372,   373,    -1,    -1,   376,
     377,   378,   379,   380,    -1,    -1,   383,   384,   385,   386,
     387,   388,   389,    -1,   391,    -1,   393,   394,   395,   396,
      -1,    -1,   399,    -1,    -1,   402,   403,   404,   405,   406,
     407,   408,   409,   410,   411,   412,   413,   414,   415,   416,
     417,   418,   419,     3,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    14,    15,    16,    17,    18,    19,
      20,    21,    -1,    23,    24,    25,    -1,    -1,    -1,    -1,
      30,    -1,    32,    -1,    34,    35,    -1,    37,    38,    -1,
      40,    41,    42,    43,    44,    -1,    46,    47,    -1,    49,
      50,    51,    52,    53,    -1,    -1,    56,    57,    58,    59,
      60,    -1,    62,    63,    64,    65,    66,    -1,    -1,    -1,
      70,    71,    72,    73,    -1,    75,    76,    -1,    78,    79,
      80,    81,    82,    83,    -1,    -1,    86,    87,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    95,    96,    97,    98,    99,
     100,   101,   102,   103,    -1,   105,    -1,   107,   108,   109,
     110,   111,    -1,   113,   114,   115,    -1,    -1,   118,   119,
     120,   121,   122,    -1,   124,   125,   126,    -1,   128,   129,
     130,    -1,   132,   133,   134,   135,   136,   137,   138,   139,
     140,    -1,   142,    -1,   144,   145,   146,   147,    -1,   149,
      -1,   151,    -1,    -1,    -1,   155,   156,   157,    -1,   159,
     160,    -1,   162,    -1,   164,   165,   166,   167,   168,    -1,
     170,   171,   172,    -1,   174,   175,   176,   177,   178,   179,
      -1,   181,    -1,   183,   184,   185,   186,   187,   188,   189,
      -1,   191,    -1,   193,    -1,    -1,   196,    -1,   198,   199,
     200,   201,   202,    -1,   204,   205,    -1,   207,   208,    -1,
     210,    -1,    -1,   213,   214,   215,    -1,    -1,   218,   219,
     220,   221,   222,   223,   224,   225,   226,   227,   228,   229,
     230,   231,    -1,   233,   234,   235,   236,    -1,   238,   239,
      -1,   241,    -1,   243,   244,   245,   246,   247,   248,    -1,
     250,    -1,    -1,   253,   254,   255,    -1,    -1,   258,   259,
      -1,   261,    -1,   263,   264,   265,   266,   267,   268,   269,
     270,    -1,   272,   273,   274,   275,   276,   277,   278,    -1,
     280,   281,   282,   283,   284,   285,   286,   287,   288,   289,
     290,   291,   292,    -1,   294,   295,   296,   297,   298,   299,
     300,   301,   302,   303,   304,    -1,   306,   307,    -1,   309,
     310,   311,   312,   313,   314,   315,   316,   317,   318,   319,
      -1,   321,   322,   323,   324,   325,    -1,   327,   328,   329,
     330,    -1,   332,   333,   334,    -1,   336,   337,   338,   339,
     340,   341,   342,   343,   344,   345,   346,    -1,   348,   349,
      -1,   351,   352,   353,   354,   355,   356,    -1,   358,   359,
      -1,    -1,   362,   363,   364,   365,    -1,   367,   368,   369,
     370,   371,   372,   373,    -1,    -1,   376,   377,   378,   379,
     380,    -1,    -1,   383,   384,   385,   386,   387,   388,   389,
      -1,   391,    -1,   393,   394,   395,   396,    -1,    -1,   399,
      -1,    -1,   402,   403,   404,   405,   406,   407,   408,   409,
     410,   411,   412,   413,   414,   415,   416,   417,   418,   419,
       3,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    14,    15,    16,    17,    18,    19,    20,    21,    -1,
      23,    24,    25,    -1,    -1,    -1,    -1,    30,    -1,    -1,
      -1,    34,    35,    -1,    37,    38,    -1,    40,    41,    42,
      43,    44,    -1,    46,    47,    -1,    49,    50,    51,    52,
      53,    -1,    -1,    56,    57,    58,    59,    60,    -1,    62,
      63,    64,    65,    66,    -1,    -1,    -1,    70,    71,    72,
      73,    -1,    75,    76,    -1,    78,    79,    80,    81,    82,
      83,    -1,    -1,    86,    87,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    95,    96,    97,    98,    99,   100,   101,   102,
     103,   104,   105,    -1,   107,   108,   109,   110,   111,    -1,
     113,   114,   115,    -1,    -1,   118,   119,   120,   121,   122,
      -1,   124,   125,   126,    -1,   128,   129,   130,    -1,   132,
     133,   134,   135,   136,   137,   138,   139,   140,    -1,   142,
      -1,   144,   145,   146,   147,    -1,   149,    -1,   151,    -1,
      -1,    -1,   155,   156,   157,    -1,   159,   160,    -1,   162,
      -1,   164,   165,   166,   167,   168,    -1,   170,   171,   172,
      -1,   174,   175,   176,   177,   178,   179,    -1,   181,    -1,
     183,   184,   185,   186,   187,   188,   189,    -1,   191,    -1,
     193,    -1,    -1,   196,    -1,   198,   199,   200,   201,   202,
      -1,   204,   205,    -1,   207,   208,    -1,   210,    -1,    -1,
     213,   214,   215,    -1,    -1,   218,   219,   220,   221,   222,
     223,   224,   225,   226,   227,   228,   229,   230,   231,    -1,
     233,   234,   235,   236,    -1,   238,   239,    -1,   241,    -1,
     243,   244,   245,   246,   247,   248,    -1,   250,    -1,    -1,
     253,   254,   255,    -1,    -1,   258,   259,    -1,   261,    -1,
     263,   264,   265,   266,   267,   268,   269,   270,    -1,   272,
     273,   274,   275,   276,   277,   278,    -1,   280,   281,   282,
     283,   284,   285,   286,   287,   288,   289,   290,   291,   292,
      -1,   294,   295,   296,   297,   298,   299,   300,   301,   302,
     303,   304,    -1,   306,   307,    -1,   309,   310,   311,   312,
     313,   314,   315,   316,   317,   318,   319,    -1,   321,   322,
     323,   324,   325,    -1,   327,   328,   329,   330,    -1,   332,
     333,   334,    -1,   336,   337,   338,   339,   340,   341,   342,
     343,   344,   345,   346,    -1,   348,   349,    -1,   351,   352,
     353,   354,   355,   356,    -1,   358,   359,    -1,    -1,   362,
     363,   364,   365,    -1,   367,   368,   369,   370,   371,   372,
     373,    -1,    -1,   376,   377,   378,   379,   380,    -1,    -1,
     383,   384,   385,   386,   387,   388,   389,    -1,   391,    -1,
     393,   394,   395,   396,    -1,    -1,   399,    -1,    -1,   402,
     403,   404,   405,   406,   407,   408,   409,   410,   411,   412,
     413,   414,   415,   416,   417,   418,   419,     3,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    14,    15,
      16,    17,    18,    19,    20,    21,    -1,    23,    24,    25,
      -1,    -1,    -1,    -1,    30,    -1,    -1,    -1,    34,    35,
      -1,    37,    38,    -1,    40,    41,    42,    43,    44,    -1,
      46,    47,    -1,    49,    50,    51,    52,    53,    -1,    -1,
      56,    57,    58,    59,    60,    -1,    62,    63,    64,    65,
      66,    -1,    -1,    -1,    70,    71,    72,    73,    -1,    75,
      76,    -1,    78,    79,    80,    81,    82,    83,    -1,    -1,
      86,    87,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    95,
      96,    97,    98,    99,   100,   101,   102,   103,   104,   105,
      -1,   107,   108,   109,   110,   111,    -1,   113,   114,   115,
      -1,    -1,   118,   119,   120,   121,   122,    -1,   124,   125,
     126,    -1,   128,   129,   130,    -1,   132,   133,   134,   135,
     136,   137,   138,   139,   140,    -1,   142,    -1,   144,   145,
     146,   147,    -1,   149,    -1,   151,    -1,    -1,    -1,   155,
     156,   157,    -1,   159,   160,    -1,   162,    -1,   164,   165,
     166,   167,   168,    -1,   170,   171,   172,    -1,   174,   175,
     176,   177,   178,   179,    -1,   181,    -1,   183,   184,   185,
     186,   187,   188,   189,    -1,   191,    -1,   193,    -1,    -1,
     196,    -1,   198,   199,   200,   201,   202,    -1,   204,   205,
      -1,   207,   208,    -1,   210,    -1,    -1,   213,   214,   215,
      -1,    -1,   218,   219,   220,   221,   222,   223,   224,   225,
     226,   227,   228,   229,   230,   231,    -1,   233,   234,   235,
     236,    -1,   238,   239,    -1,   241,    -1,   243,   244,   245,
     246,   247,   248,    -1,   250,    -1,    -1,   253,   254,   255,
      -1,    -1,   258,   259,    -1,   261,    -1,   263,   264,   265,
     266,   267,   268,   269,   270,    -1,   272,   273,   274,   275,
     276,   277,   278,    -1,   280,   281,   282,   283,   284,   285,
     286,   287,   288,   289,   290,   291,   292,    -1,   294,   295,
     296,   297,   298,   299,   300,   301,   302,   303,   304,    -1,
     306,   307,    -1,   309,   310,   311,   312,   313,   314,   315,
     316,   317,   318,   319,    -1,   321,   322,   323,   324,   325,
      -1,   327,   328,   329,   330,    -1,   332,   333,   334,    -1,
     336,   337,   338,   339,   340,   341,   342,   343,   344,   345,
     346,    -1,   348,   349,    -1,   351,   352,   353,   354,   355,
     356,    -1,   358,   359,    -1,    -1,   362,   363,   364,   365,
      -1,   367,   368,   369,   370,   371,   372,   373,    -1,    -1,
     376,   377,   378,   379,   380,    -1,    -1,   383,   384,   385,
     386,   387,   388,   389,    -1,   391,    -1,   393,   394,   395,
     396,    -1,    -1,   399,    -1,    -1,   402,   403,   404,   405,
     406,   407,   408,   409,   410,   411,   412,   413,   414,   415,
     416,   417,   418,   419,     3,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    14,    15,    16,    17,    18,
      19,    20,    21,    -1,    23,    24,    25,    -1,    -1,    -1,
      -1,    30,    -1,    -1,    -1,    34,    35,    -1,    37,    38,
      -1,    40,    41,    42,    43,    44,    -1,    46,    47,    -1,
      49,    50,    51,    52,    53,    -1,    -1,    56,    57,    58,
      59,    60,    -1,    62,    63,    64,    65,    66,    -1,    -1,
      -1,    70,    71,    72,    73,    -1,    75,    76,    -1,    78,
      79,    80,    81,    82,    83,    -1,    -1,    86,    87,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    95,    96,    97,    98,
      99,   100,   101,   102,   103,   104,   105,    -1,   107,   108,
     109,   110,   111,    -1,   113,   114,   115,    -1,    -1,   118,
     119,   120,   121,   122,    -1,   124,   125,   126,    -1,   128,
     129,   130,    -1,   132,   133,   134,   135,   136,   137,   138,
     139,   140,    -1,   142,    -1,   144,   145,   146,   147,    -1,
     149,    -1,   151,    -1,    -1,    -1,   155,   156,   157,    -1,
     159,   160,    -1,   162,    -1,   164,   165,   166,   167,   168,
      -1,   170,   171,   172,    -1,   174,   175,   176,   177,   178,
     179,    -1,   181,    -1,   183,   184,   185,   186,   187,   188,
     189,    -1,   191,    -1,   193,    -1,    -1,   196,    -1,   198,
     199,   200,   201,   202,    -1,   204,   205,    -1,   207,   208,
      -1,   210,    -1,    -1,   213,   214,   215,    -1,    -1,   218,
     219,   220,   221,   222,   223,   224,   225,   226,   227,   228,
     229,   230,   231,    -1,   233,   234,   235,   236,    -1,   238,
     239,    -1,   241,    -1,   243,   244,   245,   246,   247,   248,
      -1,   250,    -1,    -1,   253,   254,   255,    -1,    -1,   258,
     259,    -1,   261,    -1,   263,   264,   265,   266,   267,   268,
     269,   270,    -1,   272,   273,   274,   275,   276,   277,   278,
      -1,   280,   281,   282,   283,   284,   285,   286,   287,   288,
     289,   290,   291,   292,    -1,   294,   295,   296,   297,   298,
     299,   300,   301,   302,   303,   304,    -1,   306,   307,    -1,
     309,   310,   311,   312,   313,   314,   315,   316,   317,   318,
     319,    -1,   321,   322,   323,   324,   325,    -1,   327,   328,
     329,   330,    -1,   332,   333,   334,    -1,   336,   337,   338,
     339,   340,   341,   342,   343,   344,   345,   346,    -1,   348,
     349,    -1,   351,   352,   353,   354,   355,   356,    -1,   358,
     359,    -1,    -1,   362,   363,   364,   365,    -1,   367,   368,
     369,   370,   371,   372,   373,    -1,    -1,   376,   377,   378,
     379,   380,    -1,    -1,   383,   384,   385,   386,   387,   388,
     389,    -1,   391,    -1,   393,   394,   395,   396,    -1,    -1,
     399,    -1,    -1,   402,   403,   404,   405,   406,   407,   408,
     409,   410,   411,   412,   413,   414,   415,   416,   417,   418,
     419,     3,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    14,    15,    16,    17,    18,    19,    20,    21,
      -1,    23,    24,    25,    -1,    -1,    -1,    -1,    30,    -1,
      -1,    -1,    34,    35,    -1,    37,    38,    -1,    40,    41,
      42,    43,    44,    -1,    46,    47,    -1,    49,    50,    51,
      52,    53,    -1,    -1,    56,    57,    58,    59,    60,    -1,
      62,    63,    64,    65,    66,    -1,    -1,    -1,    70,    71,
      72,    73,    -1,    75,    76,    -1,    78,    79,    80,    81,
      82,    83,    -1,    -1,    86,    87,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    95,    96,    97,    98,    99,   100,   101,
     102,   103,    -1,   105,    -1,   107,   108,   109,   110,   111,
      -1,   113,   114,   115,    -1,    -1,   118,   119,   120,   121,
     122,    -1,   124,   125,   126,    -1,   128,   129,   130,    -1,
     132,   133,   134,   135,   136,   137,   138,   139,   140,    -1,
     142,    -1,   144,   145,   146,   147,    -1,   149,    -1,   151,
      -1,    -1,    -1,   155,   156,   157,    -1,   159,   160,    -1,
     162,    -1,   164,   165,   166,   167,   168,    -1,   170,   171,
     172,    -1,   174,   175,   176,   177,   178,   179,    -1,   181,
      -1,   183,   184,   185,   186,   187,   188,   189,    -1,   191,
      -1,   193,    -1,    -1,   196,    -1,   198,   199,   200,   201,
     202,    -1,   204,   205,    -1,   207,   208,    -1,   210,    -1,
      -1,   213,   214,   215,    -1,    -1,   218,   219,   220,   221,
     222,   223,   224,   225,   226,   227,   228,   229,   230,   231,
      -1,   233,   234,   235,   236,    -1,   238,   239,    -1,   241,
      -1,   243,   244,   245,   246,   247,   248,    -1,   250,    -1,
      -1,   253,   254,   255,    -1,    -1,   258,   259,    -1,   261,
      -1,   263,   264,   265,   266,   267,   268,   269,   270,    -1,
     272,   273,   274,   275,   276,   277,   278,    -1,   280,   281,
     282,   283,   284,   285,   286,   287,   288,   289,   290,   291,
     292,    -1,   294,   295,   296,   297,   298,   299,   300,   301,
     302,   303,   304,    -1,   306,   307,    -1,   309,   310,   311,
     312,   313,   314,   315,   316,   317,   318,   319,    -1,   321,
     322,   323,   324,   325,    -1,   327,   328,   329,   330,    -1,
     332,   333,   334,    -1,   336,   337,   338,   339,   340,   341,
     342,   343,   344,   345,   346,    -1,   348,   349,    -1,   351,
     352,   353,   354,   355,   356,    -1,   358,   359,    -1,    -1,
     362,   363,   364,   365,    -1,   367,   368,   369,   370,   371,
     372,   373,    -1,    -1,   376,   377,   378,   379,   380,    -1,
     382,   383,   384,   385,   386,   387,   388,   389,    -1,   391,
      -1,   393,   394,   395,   396,    -1,    -1,   399,    -1,    -1,
     402,   403,   404,   405,   406,   407,   408,   409,   410,   411,
     412,   413,   414,   415,   416,   417,   418,   419,     3,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    14,
      15,    16,    17,    18,    19,    20,    21,    -1,    23,    24,
      25,    -1,    -1,    -1,    -1,    30,    -1,    -1,    -1,    34,
      35,    -1,    37,    38,    -1,    40,    41,    42,    43,    44,
      -1,    46,    47,    -1,    49,    50,    51,    52,    53,    -1,
      -1,    56,    57,    58,    59,    60,    -1,    62,    63,    64,
      65,    66,    -1,    -1,    -1,    70,    71,    72,    73,    -1,
      75,    76,    -1,    78,    79,    80,    81,    82,    83,    -1,
      -1,    86,    87,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      95,    96,    97,    98,    99,   100,   101,   102,   103,    -1,
     105,    -1,   107,   108,   109,   110,   111,    -1,   113,   114,
     115,    -1,    -1,   118,   119,   120,   121,   122,    -1,   124,
     125,   126,    -1,   128,   129,   130,    -1,   132,   133,   134,
     135,   136,   137,   138,   139,   140,    -1,   142,    -1,   144,
     145,   146,   147,    -1,   149,    -1,   151,    -1,    -1,    -1,
     155,   156,   157,    -1,   159,   160,    -1,   162,    -1,   164,
     165,   166,   167,   168,    -1,   170,   171,   172,    -1,   174,
     175,   176,   177,   178,   179,    -1,   181,    -1,   183,   184,
     185,   186,   187,   188,   189,    -1,   191,    -1,   193,    -1,
      -1,   196,    -1,   198,   199,   200,   201,   202,    -1,   204,
     205,    -1,   207,   208,    -1,   210,    -1,    -1,   213,   214,
     215,    -1,    -1,   218,   219,   220,   221,   222,   223,   224,
     225,   226,   227,   228,   229,   230,   231,    -1,   233,   234,
     235,   236,    -1,   238,   239,    -1,   241,    -1,   243,   244,
     245,   246,   247,   248,    -1,   250,    -1,    -1,   253,   254,
     255,    -1,    -1,   258,   259,    -1,   261,    -1,   263,   264,
     265,   266,   267,   268,   269,   270,    -1,   272,   273,   274,
     275,   276,   277,   278,    -1,   280,   281,   282,   283,   284,
     285,   286,   287,   288,   289,   290,   291,   292,    -1,   294,
     295,   296,   297,   298,   299,   300,   301,   302,   303,   304,
      -1,   306,   307,    -1,   309,   310,   311,   312,   313,   314,
     315,   316,   317,   318,   319,    -1,   321,   322,   323,   324,
     325,    -1,   327,   328,   329,   330,    -1,   332,   333,   334,
      -1,   336,   337,   338,   339,   340,   341,   342,   343,   344,
     345,   346,    -1,   348,   349,    -1,   351,   352,   353,   354,
     355,   356,    -1,   358,   359,    -1,    -1,   362,   363,   364,
     365,    -1,   367,   368,   369,   370,   371,   372,   373,    -1,
      -1,   376,   377,   378,   379,   380,    -1,    -1,   383,   384,
     385,   386,   387,   388,   389,    -1,   391,    -1,   393,   394,
     395,   396,    -1,    -1,   399,    -1,    -1,   402,   403,   404,
     405,   406,   407,   408,   409,   410,   411,   412,   413,   414,
     415,   416,   417,   418,   419,     3,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    14,    15,    16,    17,
      18,    19,    20,    21,    -1,    23,    24,    25,    -1,    -1,
      -1,    -1,    30,    -1,    -1,    -1,    34,    35,    -1,    37,
      38,    -1,    40,    41,    42,    43,    44,    -1,    46,    47,
      -1,    49,    50,    51,    52,    53,    -1,    -1,    56,    57,
      58,    59,    60,    -1,    62,    63,    64,    65,    66,    -1,
      -1,    -1,    70,    71,    72,    73,    -1,    75,    76,    -1,
      78,    79,    80,    81,    82,    83,    -1,    -1,    86,    87,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    95,    96,    97,
      98,    99,   100,   101,   102,   103,    -1,   105,    -1,   107,
     108,   109,   110,   111,    -1,   113,   114,   115,    -1,    -1,
     118,   119,   120,   121,   122,    -1,   124,   125,   126,    -1,
     128,   129,   130,    -1,   132,   133,   134,   135,   136,   137,
     138,   139,   140,    -1,   142,    -1,   144,   145,   146,   147,
      -1,   149,    -1,   151,    -1,    -1,    -1,   155,   156,   157,
      -1,   159,   160,    -1,   162,    -1,   164,   165,   166,   167,
     168,    -1,   170,   171,   172,    -1,   174,   175,   176,   177,
     178,   179,    -1,   181,    -1,   183,   184,   185,   186,   187,
     188,   189,    -1,   191,    -1,   193,    -1,    -1,   196,    -1,
     198,   199,   200,   201,   202,    -1,   204,   205,    -1,   207,
     208,    -1,   210,    -1,    -1,   213,   214,   215,    -1,    -1,
     218,   219,   220,   221,   222,   223,   224,   225,   226,   227,
     228,   229,   230,   231,    -1,   233,   234,   235,   236,    -1,
     238,   239,    -1,   241,    -1,   243,   244,   245,   246,   247,
     248,    -1,   250,    -1,    -1,   253,   254,   255,    -1,    -1,
     258,   259,    -1,   261,    -1,   263,   264,   265,   266,   267,
     268,   269,   270,    -1,   272,   273,   274,   275,   276,   277,
     278,    -1,   280,   281,   282,   283,   284,   285,   286,   287,
     288,   289,   290,   291,   292,    -1,   294,   295,   296,   297,
     298,   299,   300,   301,   302,   303,   304,    -1,   306,   307,
      -1,   309,   310,   311,   312,   313,   314,   315,   316,   317,
     318,   319,    -1,   321,   322,   323,   324,   325,    -1,   327,
     328,   329,   330,    -1,   332,   333,   334,    -1,   336,   337,
     338,   339,   340,   341,   342,   343,   344,   345,   346,    -1,
     348,   349,    -1,   351,   352,   353,   354,   355,   356,    -1,
     358,   359,    -1,    -1,   362,   363,   364,   365,    -1,   367,
     368,   369,   370,   371,   372,   373,    -1,    -1,   376,   377,
     378,   379,   380,    -1,    -1,   383,   384,   385,   386,   387,
     388,   389,    -1,   391,    -1,   393,   394,   395,   396,    -1,
      -1,   399,    -1,    -1,   402,   403,   404,   405,   406,   407,
     408,   409,   410,   411,   412,   413,   414,   415,   416,   417,
     418,   419,     3,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    14,    15,    16,    17,    18,    19,    20,
      21,    -1,    23,    24,    25,    -1,    -1,    -1,    -1,    30,
      -1,    -1,    -1,    34,    35,    -1,    37,    38,    -1,    40,
      41,    42,    43,    44,    -1,    46,    47,    -1,    49,    50,
      51,    52,    53,    -1,    -1,    56,    57,    58,    59,    60,
      -1,    62,    63,    64,    65,    66,    -1,    -1,    -1,    70,
      71,    72,    73,    -1,    75,    76,    -1,    78,    79,    80,
      81,    82,    83,    -1,    -1,    86,    87,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    95,    96,    97,    98,    99,   100,
     101,   102,   103,    -1,   105,    -1,   107,   108,   109,   110,
     111,    -1,   113,   114,   115,    -1,    -1,   118,   119,   120,
     121,   122,    -1,   124,   125,   126,    -1,   128,   129,   130,
      -1,   132,   133,   134,   135,   136,   137,   138,   139,   140,
      -1,   142,    -1,   144,   145,   146,   147,    -1,   149,    -1,
     151,    -1,    -1,    -1,   155,   156,   157,    -1,   159,   160,
      -1,   162,    -1,   164,   165,   166,   167,   168,    -1,   170,
     171,   172,    -1,   174,   175,   176,   177,   178,   179,    -1,
     181,    -1,   183,   184,   185,   186,   187,   188,   189,    -1,
     191,    -1,   193,    -1,    -1,   196,    -1,   198,   199,   200,
     201,   202,    -1,   204,   205,    -1,   207,   208,    -1,   210,
      -1,    -1,   213,   214,   215,    -1,    -1,   218,   219,   220,
     221,   222,   223,   224,   225,   226,   227,   228,   229,   230,
     231,    -1,   233,   234,   235,   236,    -1,   238,   239,    -1,
     241,    -1,   243,   244,   245,   246,   247,   248,    -1,   250,
      -1,    -1,   253,   254,   255,    -1,    -1,   258,   259,    -1,
     261,    -1,   263,   264,   265,   266,   267,   268,   269,   270,
      -1,   272,   273,   274,   275,   276,   277,   278,    -1,   280,
     281,   282,   283,   284,   285,   286,   287,   288,   289,   290,
     291,   292,    -1,   294,   295,   296,   297,   298,   299,   300,
     301,   302,   303,   304,    -1,   306,   307,    -1,   309,   310,
     311,   312,   313,   314,   315,   316,   317,   318,   319,    -1,
     321,   322,   323,   324,   325,    -1,   327,   328,   329,   330,
      -1,   332,   333,   334,    -1,   336,   337,   338,   339,   340,
     341,   342,   343,   344,   345,   346,    -1,   348,   349,    -1,
     351,   352,   353,   354,   355,   356,    -1,   358,   359,    -1,
      -1,   362,   363,   364,   365,    -1,   367,   368,   369,   370,
     371,   372,   373,    -1,    -1,   376,   377,   378,   379,   380,
      -1,    -1,   383,   384,   385,   386,   387,   388,   389,    -1,
     391,    -1,   393,   394,   395,   396,    -1,    -1,   399,    -1,
      -1,   402,   403,   404,   405,   406,   407,   408,   409,   410,
     411,   412,   413,   414,   415,   416,   417,   418,   419,     3,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      14,    15,    16,    17,    18,    19,    20,    21,    -1,    23,
      24,    25,    -1,    -1,    -1,    -1,    30,    -1,    -1,    -1,
      34,    35,    -1,    37,    38,    -1,    40,    41,    42,    43,
      44,    -1,    46,    47,    -1,    49,    50,    51,    52,    53,
      -1,    -1,    56,    57,    58,    59,    60,    -1,    62,    63,
      64,    65,    66,    -1,    -1,    -1,    70,    71,    72,    73,
      -1,    75,    76,    -1,    78,    79,    80,    81,    82,    83,
      -1,    -1,    86,    87,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    95,    96,    97,    98,    99,   100,   101,   102,   103,
      -1,   105,    -1,   107,   108,   109,   110,   111,    -1,   113,
     114,   115,    -1,    -1,   118,   119,   120,   121,   122,    -1,
     124,   125,   126,    -1,   128,   129,   130,    -1,   132,   133,
     134,   135,   136,   137,   138,   139,   140,    -1,   142,    -1,
     144,   145,   146,   147,    -1,   149,    -1,   151,    -1,    -1,
      -1,   155,   156,   157,    -1,   159,   160,    -1,   162,    -1,
     164,   165,   166,   167,   168,    -1,   170,   171,   172,    -1,
     174,   175,   176,   177,   178,   179,    -1,   181,    -1,   183,
     184,   185,   186,   187,   188,   189,    -1,   191,    -1,   193,
      -1,    -1,   196,    -1,   198,   199,   200,   201,   202,    -1,
     204,   205,    -1,   207,   208,    -1,   210,    -1,    -1,   213,
     214,   215,    -1,    -1,   218,   219,   220,   221,   222,   223,
     224,   225,   226,   227,   228,   229,   230,   231,    -1,   233,
     234,   235,   236,    -1,   238,   239,    -1,   241,    -1,   243,
     244,   245,   246,   247,   248,    -1,   250,    -1,    -1,   253,
     254,   255,    -1,    -1,   258,   259,    -1,   261,    -1,   263,
     264,   265,   266,   267,   268,   269,   270,    -1,   272,   273,
     274,   275,   276,   277,   278,    -1,   280,   281,   282,   283,
     284,   285,   286,   287,   288,   289,   290,   291,   292,    -1,
     294,   295,   296,   297,   298,   299,   300,   301,   302,   303,
     304,    -1,   306,   307,    -1,   309,   310,   311,   312,   313,
     314,   315,   316,   317,   318,   319,    -1,   321,   322,   323,
     324,   325,    -1,   327,   328,   329,   330,    -1,   332,   333,
     334,    -1,   336,   337,   338,   339,   340,   341,   342,   343,
     344,   345,   346,    -1,   348,   349,    -1,   351,   352,   353,
     354,   355,   356,    -1,   358,   359,    -1,    -1,   362,   363,
     364,   365,    -1,   367,   368,   369,   370,   371,   372,   373,
      -1,    -1,   376,   377,   378,   379,   380,    -1,    -1,   383,
     384,   385,   386,   387,   388,   389,    -1,   391,    -1,   393,
     394,   395,   396,    -1,    -1,   399,    -1,    -1,   402,   403,
     404,   405,   406,   407,   408,   409,   410,   411,   412,   413,
     414,   415,   416,   417,   418,   419,     3,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    14,    15,    16,
      17,    18,    19,    20,    21,    -1,    23,    24,    25,    -1,
      -1,    -1,    -1,    30,    -1,    -1,    -1,    34,    35,    -1,
      37,    38,    -1,    40,    41,    42,    43,    44,    -1,    46,
      47,    -1,    49,    50,    51,    52,    53,    -1,    -1,    56,
      57,    58,    59,    60,    -1,    62,    63,    64,    65,    66,
      -1,    -1,    -1,    70,    71,    72,    73,    -1,    75,    76,
      -1,    78,    79,    80,    81,    82,    83,    -1,    -1,    86,
      87,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    95,    96,
      97,    98,    99,   100,   101,   102,   103,    -1,   105,    -1,
     107,   108,   109,   110,   111,    -1,   113,   114,   115,    -1,
      -1,   118,   119,   120,   121,   122,    -1,   124,   125,   126,
      -1,   128,   129,   130,    -1,   132,   133,   134,   135,   136,
     137,   138,   139,   140,    -1,   142,    -1,   144,   145,   146,
     147,    -1,   149,    -1,   151,    -1,    -1,    -1,   155,   156,
     157,    -1,   159,   160,    -1,   162,    -1,   164,   165,   166,
     167,   168,    -1,   170,   171,   172,    -1,   174,   175,   176,
     177,   178,   179,    -1,   181,    -1,   183,   184,   185,   186,
     187,   188,   189,    -1,   191,    -1,   193,    -1,    -1,   196,
      -1,   198,   199,   200,   201,   202,    -1,   204,   205,    -1,
     207,   208,    -1,   210,    -1,    -1,   213,   214,   215,    -1,
      -1,   218,   219,   220,   221,   222,   223,   224,   225,   226,
     227,   228,   229,   230,   231,    -1,   233,   234,   235,   236,
      -1,   238,   239,    -1,   241,    -1,   243,   244,   245,   246,
     247,   248,    -1,   250,    -1,    -1,   253,   254,   255,    -1,
      -1,   258,   259,    -1,   261,    -1,   263,   264,   265,   266,
     267,   268,   269,   270,    -1,   272,   273,   274,   275,   276,
     277,   278,    -1,   280,   281,   282,   283,   284,   285,   286,
     287,   288,   289,   290,   291,   292,    -1,   294,   295,   296,
     297,   298,   299,   300,   301,   302,   303,   304,    -1,   306,
     307,    -1,   309,   310,   311,   312,   313,   314,   315,   316,
     317,   318,   319,    -1,   321,   322,   323,   324,   325,    -1,
     327,   328,   329,   330,    -1,   332,   333,   334,    -1,   336,
     337,   338,   339,   340,   341,   342,   343,   344,   345,   346,
      -1,   348,   349,    -1,   351,   352,   353,   354,   355,   356,
      -1,   358,   359,    -1,    -1,   362,   363,   364,   365,    -1,
     367,   368,   369,   370,   371,   372,   373,    -1,    -1,   376,
     377,   378,   379,   380,    -1,    -1,   383,   384,   385,   386,
     387,   388,   389,    -1,   391,    -1,   393,   394,   395,   396,
      -1,    -1,   399,    -1,    -1,   402,   403,   404,   405,   406,
     407,   408,   409,   410,   411,   412,   413,   414,   415,   416,
     417,   418,   419,     3,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    14,    15,    16,    17,    18,    19,
      20,    21,    -1,    23,    24,    25,    -1,    -1,    -1,    -1,
      30,    -1,    -1,    -1,    34,    35,    -1,    37,    38,    -1,
      40,    41,    42,    43,    44,    -1,    46,    47,    -1,    49,
      50,    51,    52,    53,    -1,    -1,    56,    57,    58,    59,
      60,    -1,    62,    63,    64,    65,    66,    -1,    -1,    -1,
      70,    71,    72,    73,    -1,    75,    76,    -1,    78,    79,
      80,    81,    82,    83,    -1,    -1,    86,    87,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    95,    96,    97,    98,    99,
     100,   101,   102,   103,    -1,   105,    -1,   107,   108,   109,
     110,   111,    -1,   113,   114,   115,    -1,    -1,   118,   119,
     120,   121,   122,    -1,   124,   125,   126,    -1,   128,   129,
     130,    -1,   132,   133,   134,   135,   136,   137,   138,   139,
     140,    -1,   142,    -1,   144,   145,   146,   147,    -1,   149,
      -1,   151,    -1,    -1,    -1,   155,   156,   157,    -1,   159,
     160,    -1,   162,    -1,   164,   165,   166,   167,   168,    -1,
     170,   171,   172,    -1,   174,   175,   176,   177,   178,   179,
      -1,   181,    -1,   183,   184,   185,   186,   187,   188,   189,
      -1,   191,    -1,   193,    -1,    -1,   196,    -1,   198,   199,
     200,   201,   202,    -1,   204,   205,    -1,   207,   208,    -1,
     210,    -1,    -1,   213,   214,   215,    -1,    -1,   218,   219,
     220,   221,   222,   223,   224,   225,   226,   227,   228,   229,
     230,   231,    -1,   233,   234,   235,   236,    -1,   238,   239,
      -1,   241,    -1,   243,   244,   245,   246,   247,   248,    -1,
     250,    -1,    -1,   253,   254,   255,    -1,    -1,   258,   259,
      -1,   261,    -1,   263,   264,   265,   266,   267,   268,   269,
     270,    -1,   272,   273,   274,   275,   276,   277,   278,    -1,
     280,   281,   282,   283,   284,   285,   286,   287,   288,   289,
     290,   291,   292,    -1,   294,   295,   296,   297,   298,   299,
     300,   301,   302,   303,   304,    -1,   306,   307,    -1,   309,
     310,   311,   312,   313,   314,   315,   316,   317,   318,   319,
      -1,   321,   322,   323,   324,   325,    -1,   327,   328,   329,
     330,    -1,   332,   333,   334,    -1,   336,   337,   338,   339,
     340,   341,   342,   343,   344,   345,   346,    -1,   348,   349,
      -1,   351,   352,   353,   354,   355,   356,    -1,   358,   359,
      -1,    -1,   362,   363,   364,   365,    -1,   367,   368,   369,
     370,   371,   372,   373,    -1,    -1,   376,   377,   378,   379,
     380,    -1,    -1,   383,   384,   385,   386,   387,   388,   389,
      -1,   391,    -1,   393,   394,   395,   396,    -1,    -1,   399,
      -1,    -1,   402,   403,   404,   405,   406,   407,   408,   409,
     410,   411,   412,   413,   414,   415,   416,   417,   418,   419,
       3,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    14,    15,    16,    17,    18,    19,    20,    21,    -1,
      23,    24,    25,    -1,    -1,    -1,    -1,    30,    -1,    -1,
      -1,    34,    35,    -1,    37,    38,    -1,    40,    41,    42,
      43,    44,    -1,    46,    47,    -1,    49,    50,    51,    52,
      53,    -1,    -1,    56,    57,    58,    59,    60,    -1,    62,
      63,    64,    65,    66,    -1,    -1,    -1,    70,    71,    72,
      73,    -1,    75,    76,    -1,    78,    79,    80,    81,    82,
      83,    -1,    -1,    86,    87,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    95,    96,    97,    98,    99,   100,   101,   102,
     103,    -1,   105,    -1,   107,   108,   109,   110,   111,    -1,
     113,   114,   115,    -1,    -1,   118,   119,   120,   121,   122,
      -1,   124,   125,   126,    -1,   128,   129,   130,    -1,   132,
     133,   134,   135,   136,   137,   138,   139,   140,    -1,   142,
      -1,   144,   145,   146,   147,    -1,   149,    -1,   151,    -1,
      -1,    -1,   155,   156,   157,    -1,   159,   160,    -1,   162,
      -1,   164,   165,   166,   167,   168,    -1,   170,   171,   172,
      -1,   174,   175,   176,   177,   178,   179,    -1,   181,    -1,
     183,   184,   185,   186,   187,   188,   189,    -1,   191,    -1,
     193,    -1,    -1,   196,    -1,   198,   199,   200,   201,   202,
      -1,   204,   205,    -1,   207,   208,    -1,   210,    -1,    -1,
     213,   214,   215,    -1,    -1,   218,   219,   220,   221,   222,
     223,   224,   225,   226,   227,   228,   229,   230,   231,    -1,
     233,   234,   235,   236,    -1,   238,   239,    -1,   241,    -1,
     243,   244,   245,   246,   247,   248,    -1,   250,    -1,    -1,
     253,   254,   255,    -1,    -1,   258,   259,    -1,   261,    -1,
     263,   264,   265,   266,   267,   268,   269,   270,    -1,   272,
     273,   274,   275,   276,   277,   278,    -1,   280,   281,   282,
     283,   284,   285,   286,   287,   288,   289,   290,   291,   292,
      -1,   294,   295,   296,   297,   298,   299,   300,   301,   302,
     303,   304,    -1,   306,   307,    -1,   309,   310,   311,   312,
     313,   314,   315,   316,   317,   318,   319,    -1,   321,   322,
     323,   324,   325,    -1,   327,   328,   329,   330,    -1,   332,
     333,   334,    -1,   336,   337,   338,   339,   340,   341,   342,
     343,   344,   345,   346,    -1,   348,   349,    -1,   351,   352,
     353,   354,   355,   356,    -1,   358,   359,    -1,    -1,   362,
     363,   364,   365,    -1,   367,   368,   369,   370,   371,   372,
     373,    -1,    -1,   376,   377,   378,   379,   380,    -1,    -1,
     383,   384,   385,   386,   387,   388,   389,    -1,   391,    -1,
     393,   394,   395,   396,    -1,    -1,   399,    -1,    -1,   402,
     403,   404,   405,   406,   407,   408,   409,   410,   411,   412,
     413,   414,   415,   416,   417,   418,   419,     3,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    14,    15,
      16,    17,    18,    19,    20,    21,    -1,    23,    24,    25,
      -1,    -1,    -1,    -1,    30,    -1,    -1,    -1,    34,    35,
      -1,    37,    38,    -1,    40,    41,    42,    43,    44,    -1,
      46,    47,    -1,    49,    50,    51,    52,    53,    -1,    -1,
      56,    57,    58,    59,    60,    -1,    62,    63,    64,    65,
      66,    -1,    -1,    -1,    70,    71,    72,    73,    -1,    75,
      76,    -1,    78,    79,    80,    81,    82,    83,    -1,    -1,
      86,    87,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    95,
      96,    97,    98,    99,   100,   101,   102,   103,    -1,   105,
      -1,   107,   108,   109,   110,   111,    -1,   113,   114,   115,
      -1,    -1,   118,   119,   120,   121,   122,    -1,   124,   125,
     126,    -1,   128,   129,   130,    -1,   132,   133,   134,   135,
     136,   137,   138,   139,   140,    -1,   142,    -1,   144,   145,
     146,   147,    -1,   149,    -1,   151,    -1,    -1,    -1,   155,
     156,   157,    -1,   159,   160,    -1,   162,    -1,   164,   165,
     166,   167,   168,    -1,   170,   171,   172,    -1,   174,   175,
     176,   177,   178,   179,    -1,   181,    -1,   183,   184,   185,
     186,   187,   188,   189,    -1,   191,    -1,   193,    -1,    -1,
     196,    -1,   198,   199,   200,   201,   202,    -1,   204,   205,
      -1,   207,   208,    -1,   210,    -1,    -1,   213,   214,   215,
      -1,    -1,   218,   219,   220,   221,   222,   223,   224,   225,
     226,   227,   228,   229,   230,   231,    -1,   233,   234,   235,
     236,    -1,   238,   239,    -1,   241,    -1,   243,   244,   245,
     246,   247,   248,    -1,   250,    -1,    -1,   253,   254,   255,
      -1,    -1,   258,   259,    -1,   261,    -1,   263,   264,   265,
     266,   267,   268,   269,   270,    -1,   272,   273,   274,   275,
     276,   277,   278,    -1,   280,   281,   282,   283,   284,   285,
     286,   287,   288,   289,   290,   291,   292,    -1,   294,   295,
     296,   297,   298,   299,   300,   301,   302,   303,   304,    -1,
     306,   307,    -1,   309,   310,   311,   312,   313,   314,   315,
     316,   317,   318,   319,    -1,   321,   322,   323,   324,   325,
      -1,   327,   328,   329,   330,    -1,   332,   333,   334,    -1,
     336,   337,   338,   339,   340,   341,   342,   343,   344,   345,
     346,    -1,   348,   349,    -1,   351,   352,   353,   354,   355,
     356,    -1,   358,   359,    -1,    -1,   362,   363,   364,   365,
      -1,   367,   368,   369,   370,   371,   372,   373,    -1,    -1,
     376,   377,   378,   379,   380,    -1,    -1,   383,   384,   385,
     386,   387,   388,   389,    -1,   391,    -1,   393,   394,   395,
     396,    -1,    -1,   399,    -1,    -1,   402,   403,   404,   405,
     406,   407,   408,   409,   410,   411,   412,   413,   414,   415,
     416,   417,   418,   419,     3,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    14,    15,    16,    17,    18,
      19,    20,    21,    -1,    23,    24,    25,    -1,    -1,    -1,
      -1,    30,    -1,    -1,    -1,    34,    35,    -1,    37,    38,
      -1,    40,    41,    42,    43,    44,    -1,    46,    47,    -1,
      49,    50,    51,    52,    53,    -1,    -1,    56,    57,    58,
      59,    60,    -1,    62,    63,    64,    65,    66,    -1,    -1,
      -1,    70,    71,    72,    73,    -1,    75,    76,    -1,    78,
      79,    80,    81,    82,    83,    -1,    -1,    86,    87,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    95,    96,    97,    98,
      99,   100,   101,   102,   103,    -1,   105,    -1,   107,   108,
     109,   110,   111,    -1,   113,   114,   115,    -1,    -1,   118,
     119,   120,   121,   122,    -1,   124,   125,   126,    -1,   128,
     129,   130,    -1,   132,   133,   134,   135,   136,   137,   138,
     139,   140,    -1,   142,    -1,   144,   145,   146,   147,    -1,
     149,    -1,   151,    -1,    -1,    -1,   155,   156,   157,    -1,
     159,   160,    -1,   162,    -1,   164,   165,   166,   167,   168,
      -1,   170,   171,   172,    -1,   174,   175,   176,   177,   178,
     179,    -1,   181,    -1,   183,   184,   185,   186,   187,   188,
     189,    -1,   191,    -1,   193,    -1,    -1,   196,    -1,   198,
     199,   200,   201,   202,    -1,   204,   205,    -1,   207,   208,
      -1,   210,    -1,    -1,   213,   214,   215,    -1,    -1,   218,
     219,   220,   221,   222,   223,   224,   225,   226,   227,   228,
     229,   230,   231,    -1,   233,   234,   235,   236,    -1,   238,
     239,    -1,   241,    -1,   243,   244,   245,   246,   247,   248,
      -1,   250,    -1,    -1,   253,   254,   255,    -1,    -1,   258,
     259,    -1,   261,    -1,   263,   264,   265,   266,   267,   268,
     269,   270,    -1,   272,   273,   274,   275,   276,   277,   278,
      -1,   280,   281,   282,   283,   284,   285,   286,   287,   288,
     289,   290,   291,   292,    -1,   294,   295,   296,   297,   298,
     299,   300,   301,   302,   303,   304,    -1,   306,   307,    -1,
     309,   310,   311,   312,   313,   314,   315,   316,   317,   318,
     319,    -1,   321,   322,   323,   324,   325,    -1,   327,   328,
     329,   330,    -1,   332,   333,   334,    -1,   336,   337,   338,
     339,   340,   341,   342,   343,   344,   345,   346,    -1,   348,
     349,    -1,   351,   352,   353,   354,   355,   356,    -1,   358,
     359,    -1,    -1,   362,   363,   364,   365,    -1,   367,   368,
     369,   370,   371,   372,   373,    -1,    -1,   376,   377,   378,
     379,   380,    -1,    -1,   383,   384,   385,   386,   387,   388,
     389,    -1,   391,    -1,   393,   394,   395,   396,    -1,    -1,
     399,    -1,    -1,   402,   403,   404,   405,   406,   407,   408,
     409,   410,   411,   412,   413,   414,   415,   416,   417,   418,
     419,     3,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    14,    15,    16,    17,    18,    19,    20,    21,
      -1,    23,    24,    25,    -1,    -1,    -1,    -1,    30,    -1,
      -1,    -1,    34,    35,    -1,    37,    38,    -1,    40,    41,
      42,    43,    44,    -1,    46,    47,    -1,    49,    50,    51,
      52,    53,    -1,    -1,    56,    57,    58,    59,    60,    -1,
      62,    63,    64,    65,    66,    -1,    -1,    -1,    70,    71,
      72,    73,    -1,    75,    76,    -1,    78,    79,    80,    81,
      82,    83,    -1,    -1,    86,    87,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    95,    96,    97,    98,    99,   100,   101,
     102,   103,    -1,   105,    -1,   107,   108,   109,   110,   111,
      -1,   113,   114,   115,    -1,    -1,   118,   119,   120,   121,
     122,    -1,   124,   125,   126,    -1,   128,   129,   130,    -1,
     132,   133,   134,   135,   136,   137,   138,   139,   140,    -1,
     142,    -1,   144,   145,   146,   147,    -1,   149,    -1,   151,
      -1,    -1,    -1,   155,   156,   157,    -1,   159,   160,    -1,
     162,    -1,   164,   165,   166,   167,   168,    -1,   170,   171,
     172,    -1,   174,   175,   176,   177,   178,   179,    -1,   181,
      -1,   183,   184,   185,   186,   187,   188,   189,    -1,   191,
      -1,   193,    -1,    -1,   196,    -1,   198,   199,   200,   201,
     202,    -1,   204,   205,    -1,   207,   208,    -1,   210,    -1,
      -1,   213,   214,   215,    -1,    -1,   218,   219,   220,   221,
     222,   223,   224,   225,   226,   227,   228,   229,   230,   231,
      -1,   233,   234,   235,   236,    -1,   238,   239,    -1,   241,
      -1,   243,   244,   245,   246,   247,   248,    -1,   250,    -1,
      -1,   253,   254,   255,    -1,    -1,   258,   259,    -1,   261,
      -1,   263,   264,   265,   266,   267,   268,   269,   270,    -1,
     272,   273,   274,   275,   276,   277,   278,    -1,   280,   281,
     282,   283,   284,   285,   286,   287,   288,   289,   290,   291,
     292,    -1,   294,   295,   296,   297,   298,   299,   300,   301,
     302,   303,   304,    -1,   306,   307,    -1,   309,   310,   311,
     312,   313,   314,   315,   316,   317,   318,   319,    -1,   321,
     322,   323,   324,   325,    -1,   327,   328,   329,   330,    -1,
     332,   333,   334,    -1,   336,   337,   338,   339,   340,   341,
     342,   343,   344,   345,   346,    -1,   348,   349,    -1,   351,
     352,   353,   354,   355,   356,    -1,   358,   359,    -1,    -1,
     362,   363,   364,   365,    -1,   367,   368,   369,   370,   371,
     372,   373,    -1,    -1,   376,   377,   378,   379,   380,    -1,
      -1,   383,   384,   385,   386,   387,   388,   389,    -1,   391,
      -1,   393,   394,   395,   396,    -1,    -1,   399,    -1,    -1,
     402,   403,   404,   405,   406,   407,   408,   409,   410,   411,
     412,   413,   414,   415,   416,   417,   418,   419,     3,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    14,
      15,    16,    17,    18,    19,    20,    21,    -1,    23,    24,
      25,    -1,    -1,    -1,    -1,    30,    -1,    -1,    -1,    34,
      35,    -1,    37,    38,    -1,    40,    41,    42,    43,    44,
      -1,    46,    47,    -1,    49,    50,    51,    52,    53,    -1,
      -1,    56,    57,    58,    59,    60,    -1,    62,    63,    64,
      65,    66,    -1,    -1,    -1,    70,    71,    72,    73,    -1,
      75,    76,    -1,    78,    79,    80,    81,    82,    83,    -1,
      -1,    86,    87,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      95,    96,    97,    98,    99,   100,   101,   102,   103,    -1,
     105,    -1,   107,   108,   109,   110,   111,    -1,   113,   114,
     115,    -1,    -1,   118,   119,   120,   121,   122,    -1,   124,
     125,   126,    -1,   128,   129,   130,    -1,   132,   133,   134,
     135,   136,   137,   138,   139,   140,    -1,   142,    -1,   144,
     145,   146,   147,    -1,   149,    -1,   151,    -1,    -1,    -1,
     155,   156,   157,    -1,   159,   160,    -1,   162,    -1,   164,
     165,   166,   167,   168,    -1,   170,   171,   172,    -1,   174,
     175,   176,   177,   178,   179,    -1,   181,    -1,   183,   184,
     185,   186,   187,   188,   189,    -1,   191,    -1,   193,    -1,
      -1,   196,    -1,   198,   199,   200,   201,   202,    -1,   204,
     205,    -1,   207,   208,    -1,   210,    -1,    -1,   213,   214,
     215,    -1,    -1,   218,   219,   220,   221,   222,   223,   224,
     225,   226,   227,   228,   229,   230,   231,    -1,   233,   234,
     235,   236,    -1,   238,   239,    -1,   241,    -1,   243,   244,
     245,   246,   247,   248,    -1,   250,    -1,    -1,   253,   254,
     255,    -1,    -1,   258,   259,    -1,   261,    -1,   263,   264,
     265,   266,   267,   268,   269,   270,    -1,   272,   273,   274,
     275,   276,   277,   278,    -1,   280,   281,   282,   283,   284,
     285,   286,   287,   288,   289,   290,   291,   292,    -1,   294,
     295,   296,   297,   298,   299,   300,   301,   302,   303,   304,
      -1,   306,   307,    -1,   309,   310,   311,   312,   313,   314,
     315,   316,   317,   318,   319,    -1,   321,   322,   323,   324,
     325,    -1,   327,   328,   329,   330,    -1,   332,   333,   334,
      -1,   336,   337,   338,   339,   340,   341,   342,   343,   344,
     345,   346,    -1,   348,   349,    -1,   351,   352,   353,   354,
     355,   356,    -1,   358,   359,    -1,    -1,   362,   363,   364,
     365,    -1,   367,   368,   369,   370,   371,   372,   373,    -1,
      -1,   376,   377,   378,   379,   380,    -1,    -1,   383,   384,
     385,   386,   387,   388,   389,    -1,   391,    -1,   393,   394,
     395,   396,    -1,    -1,   399,    -1,    -1,   402,   403,   404,
     405,   406,   407,   408,   409,   410,   411,   412,   413,   414,
     415,   416,   417,   418,   419,     3,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    14,    15,    16,    17,
      18,    19,    20,    21,    -1,    23,    24,    25,    -1,    -1,
      -1,    -1,    30,    -1,    -1,    -1,    34,    35,    -1,    37,
      38,    -1,    40,    41,    42,    43,    44,    -1,    46,    47,
      -1,    49,    50,    51,    52,    53,    -1,    -1,    56,    57,
      58,    59,    60,    -1,    62,    63,    64,    65,    66,    -1,
      -1,    -1,    70,    71,    72,    73,    -1,    75,    76,    -1,
      78,    79,    80,    81,    82,    83,    -1,    -1,    86,    87,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    95,    96,    97,
      98,    99,   100,   101,   102,   103,    -1,   105,    -1,   107,
     108,   109,   110,   111,    -1,   113,   114,   115,    -1,    -1,
     118,   119,   120,   121,   122,    -1,   124,   125,   126,    -1,
     128,   129,   130,    -1,   132,   133,   134,   135,   136,   137,
     138,   139,   140,    -1,   142,    -1,   144,   145,   146,   147,
      -1,   149,    -1,   151,    -1,    -1,    -1,   155,   156,   157,
      -1,   159,   160,    -1,   162,    -1,   164,   165,   166,   167,
     168,    -1,   170,   171,   172,    -1,   174,   175,   176,   177,
     178,   179,    -1,   181,    -1,   183,   184,   185,   186,   187,
     188,   189,    -1,   191,    -1,   193,    -1,    -1,   196,    -1,
     198,   199,   200,   201,   202,    -1,   204,   205,    -1,   207,
     208,    -1,   210,    -1,    -1,   213,   214,   215,    -1,    -1,
     218,   219,   220,   221,   222,   223,   224,   225,   226,   227,
     228,   229,   230,   231,    -1,   233,   234,   235,   236,    -1,
     238,   239,    -1,   241,    -1,   243,   244,   245,   246,   247,
     248,    -1,   250,    -1,    -1,   253,   254,   255,    -1,    -1,
     258,   259,    -1,   261,    -1,   263,   264,   265,   266,   267,
     268,   269,   270,    -1,   272,   273,   274,   275,   276,   277,
     278,    -1,   280,   281,   282,   283,   284,   285,   286,   287,
     288,   289,   290,   291,   292,    -1,   294,   295,   296,   297,
     298,   299,   300,   301,   302,   303,   304,    -1,   306,   307,
      -1,   309,   310,   311,   312,   313,   314,   315,   316,   317,
     318,   319,    -1,   321,   322,   323,   324,   325,    -1,   327,
     328,   329,   330,    -1,   332,   333,   334,    -1,   336,   337,
     338,   339,   340,   341,   342,   343,   344,   345,   346,    -1,
     348,   349,    -1,   351,   352,   353,   354,   355,   356,    -1,
     358,   359,    -1,    -1,   362,   363,   364,   365,    -1,   367,
     368,   369,   370,   371,   372,   373,    -1,    -1,   376,   377,
     378,   379,   380,    -1,    -1,   383,   384,   385,   386,   387,
     388,   389,    -1,   391,    -1,   393,   394,   395,   396,    -1,
      -1,   399,    -1,    -1,   402,   403,   404,   405,   406,   407,
     408,   409,   410,   411,   412,   413,   414,   415,   416,   417,
     418,   419,     3,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    14,    15,    16,    17,    18,    19,    20,
      21,    -1,    23,    24,    25,    -1,    -1,    -1,    -1,    30,
      -1,    -1,    -1,    34,    35,    -1,    37,    38,    -1,    40,
      41,    42,    43,    44,    -1,    46,    47,    -1,    49,    50,
      51,    52,    53,    -1,    -1,    56,    57,    58,    59,    60,
      -1,    62,    63,    64,    65,    66,    -1,    -1,    -1,    70,
      71,    72,    73,    -1,    75,    76,    -1,    78,    79,    80,
      81,    82,    83,    -1,    -1,    86,    87,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    95,    96,    97,    98,    99,   100,
     101,   102,   103,    -1,   105,    -1,   107,   108,   109,   110,
     111,    -1,   113,   114,   115,    -1,    -1,   118,   119,   120,
     121,   122,    -1,   124,   125,   126,    -1,   128,   129,   130,
      -1,   132,   133,   134,   135,   136,   137,   138,   139,   140,
      -1,   142,    -1,   144,   145,   146,   147,    -1,   149,    -1,
     151,    -1,    -1,    -1,   155,   156,   157,    -1,   159,   160,
      -1,   162,    -1,   164,   165,   166,   167,   168,    -1,   170,
     171,   172,    -1,   174,   175,   176,   177,   178,   179,    -1,
     181,    -1,   183,   184,   185,   186,   187,   188,   189,    -1,
     191,    -1,   193,    -1,    -1,   196,    -1,   198,   199,   200,
     201,   202,    -1,   204,   205,    -1,   207,   208,    -1,   210,
      -1,    -1,   213,   214,   215,    -1,    -1,   218,   219,   220,
     221,   222,   223,   224,   225,   226,   227,   228,   229,   230,
     231,    -1,   233,   234,   235,   236,    -1,   238,   239,    -1,
     241,    -1,   243,   244,   245,   246,   247,   248,    -1,   250,
      -1,    -1,   253,   254,   255,    -1,    -1,   258,   259,    -1,
     261,    -1,   263,   264,   265,   266,   267,   268,   269,   270,
      -1,   272,   273,   274,   275,   276,   277,   278,    -1,   280,
     281,   282,   283,   284,   285,   286,   287,   288,   289,   290,
     291,   292,    -1,   294,   295,   296,   297,   298,   299,   300,
     301,   302,   303,   304,    -1,   306,   307,    -1,   309,   310,
     311,   312,   313,   314,   315,   316,   317,   318,   319,    -1,
     321,   322,   323,   324,   325,    -1,   327,   328,   329,   330,
      -1,   332,   333,   334,    -1,   336,   337,   338,   339,   340,
     341,   342,   343,   344,   345,   346,    -1,   348,   349,    -1,
     351,   352,   353,   354,   355,   356,    -1,   358,   359,    -1,
      -1,   362,   363,   364,   365,    -1,   367,   368,   369,   370,
     371,   372,   373,    -1,    -1,   376,   377,   378,   379,   380,
      -1,    -1,   383,   384,   385,   386,   387,   388,   389,    -1,
     391,    -1,   393,   394,   395,   396,    -1,    -1,   399,    -1,
      -1,   402,   403,   404,   405,   406,   407,   408,   409,   410,
     411,   412,   413,   414,   415,   416,   417,   418,   419,     3,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      14,    15,    16,    17,    18,    19,    20,    21,    -1,    23,
      24,    25,    -1,    -1,    -1,    -1,    30,    -1,    -1,    -1,
      34,    35,    -1,    37,    38,    -1,    40,    41,    42,    43,
      44,    -1,    46,    47,    -1,    49,    50,    51,    52,    53,
      -1,    -1,    56,    57,    58,    59,    60,    -1,    62,    63,
      64,    65,    66,    -1,    -1,    -1,    70,    71,    72,    73,
      -1,    75,    76,    -1,    78,    79,    80,    81,    82,    83,
      -1,    -1,    86,    87,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    95,    96,    97,    98,    99,   100,   101,   102,   103,
      -1,   105,    -1,   107,   108,   109,   110,   111,    -1,   113,
     114,   115,    -1,    -1,   118,   119,   120,   121,   122,    -1,
     124,   125,   126,    -1,   128,   129,   130,    -1,   132,   133,
     134,   135,   136,   137,   138,   139,   140,    -1,   142,    -1,
     144,   145,   146,   147,    -1,   149,    -1,   151,    -1,    -1,
      -1,   155,   156,   157,    -1,   159,   160,    -1,   162,    -1,
     164,   165,   166,   167,   168,    -1,   170,   171,   172,    -1,
     174,   175,   176,   177,   178,   179,    -1,   181,    -1,   183,
     184,   185,   186,   187,   188,   189,    -1,   191,    -1,   193,
      -1,    -1,   196,    -1,   198,   199,   200,   201,   202,    -1,
     204,   205,    -1,   207,   208,    -1,   210,    -1,    -1,   213,
     214,   215,    -1,    -1,   218,   219,   220,   221,   222,   223,
     224,   225,   226,   227,   228,   229,   230,   231,    -1,   233,
     234,   235,   236,    -1,   238,   239,    -1,   241,    -1,   243,
     244,   245,   246,   247,   248,    -1,   250,    -1,    -1,   253,
     254,   255,    -1,    -1,   258,   259,    -1,   261,    -1,   263,
     264,   265,   266,   267,   268,   269,   270,    -1,   272,   273,
     274,   275,   276,   277,   278,    -1,   280,   281,   282,   283,
     284,   285,   286,   287,   288,   289,   290,   291,   292,    -1,
     294,   295,   296,   297,   298,   299,   300,   301,   302,   303,
     304,    -1,   306,   307,    -1,   309,   310,   311,   312,   313,
     314,   315,   316,   317,   318,   319,    -1,   321,   322,   323,
     324,   325,    -1,   327,   328,   329,   330,    -1,   332,   333,
     334,    -1,   336,   337,   338,   339,   340,   341,   342,   343,
     344,   345,   346,    -1,   348,   349,    -1,   351,   352,   353,
     354,   355,   356,    -1,   358,   359,    -1,    -1,   362,   363,
     364,   365,    -1,   367,   368,   369,   370,   371,   372,   373,
      -1,    -1,   376,   377,   378,   379,   380,    -1,    -1,   383,
     384,   385,   386,   387,   388,   389,    -1,   391,    -1,   393,
     394,   395,   396,    -1,    -1,   399,    -1,    -1,   402,   403,
     404,   405,   406,   407,   408,   409,   410,   411,   412,   413,
     414,   415,   416,   417,   418,   419,     3,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    14,    15,    16,
      17,    18,    19,    20,    21,    -1,    23,    24,    25,    -1,
      -1,    -1,    -1,    30,    -1,    -1,    -1,    34,    35,    -1,
      37,    38,    -1,    40,    41,    42,    43,    44,    -1,    46,
      47,    -1,    49,    50,    51,    52,    53,    -1,    -1,    56,
      57,    58,    59,    60,    -1,    62,    63,    64,    65,    66,
      -1,    -1,    -1,    70,    71,    72,    73,    -1,    75,    76,
      -1,    78,    79,    80,    81,    82,    83,    -1,    -1,    86,
      87,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    95,    96,
      97,    98,    99,   100,   101,   102,   103,    -1,   105,    -1,
     107,   108,   109,   110,   111,    -1,   113,   114,   115,    -1,
      -1,   118,   119,   120,   121,   122,    -1,   124,   125,   126,
      -1,   128,   129,   130,    -1,   132,   133,   134,   135,   136,
     137,   138,   139,   140,    -1,   142,    -1,   144,   145,   146,
     147,    -1,   149,    -1,   151,    -1,    -1,    -1,   155,   156,
     157,    -1,   159,   160,    -1,   162,    -1,   164,   165,   166,
     167,   168,    -1,   170,   171,   172,    -1,   174,   175,   176,
     177,   178,   179,    -1,   181,    -1,   183,   184,   185,   186,
     187,   188,   189,    -1,   191,    -1,   193,    -1,    -1,   196,
      -1,   198,   199,   200,   201,   202,    -1,   204,   205,    -1,
     207,   208,    -1,   210,    -1,    -1,   213,   214,   215,    -1,
      -1,   218,   219,   220,   221,   222,   223,   224,   225,   226,
     227,   228,   229,   230,   231,    -1,   233,   234,   235,   236,
      -1,   238,   239,    -1,   241,    -1,   243,   244,   245,   246,
     247,   248,    -1,   250,    -1,    -1,   253,   254,   255,    -1,
      -1,   258,   259,    -1,   261,    -1,   263,   264,   265,   266,
     267,   268,   269,   270,    -1,   272,   273,   274,   275,   276,
     277,   278,    -1,   280,   281,   282,   283,   284,   285,   286,
     287,   288,   289,   290,   291,   292,    -1,   294,   295,   296,
     297,   298,   299,   300,   301,   302,   303,   304,    -1,   306,
     307,    -1,   309,   310,   311,   312,   313,   314,   315,   316,
     317,   318,   319,    -1,   321,   322,   323,   324,   325,    -1,
     327,   328,   329,   330,    -1,   332,   333,   334,    -1,   336,
     337,   338,   339,   340,   341,   342,   343,   344,   345,   346,
      -1,   348,   349,    -1,   351,   352,   353,   354,   355,   356,
      -1,   358,   359,    -1,    -1,   362,   363,   364,   365,    -1,
     367,   368,   369,   370,   371,   372,   373,    -1,    -1,   376,
     377,   378,   379,   380,    -1,    -1,   383,   384,   385,   386,
     387,   388,   389,    -1,   391,    -1,   393,   394,   395,   396,
      -1,    -1,   399,    -1,    -1,   402,   403,   404,   405,   406,
     407,   408,   409,   410,   411,   412,   413,   414,   415,   416,
     417,   418,   419,     3,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    14,    15,    16,    17,    18,    19,
      20,    21,    -1,    23,    24,    25,    -1,    -1,    -1,    -1,
      30,    -1,    -1,    -1,    34,    35,    -1,    37,    38,    -1,
      40,    41,    42,    43,    44,    -1,    46,    47,    -1,    49,
      50,    51,    52,    53,    -1,    -1,    56,    57,    58,    59,
      60,    -1,    62,    63,    64,    65,    66,    -1,    -1,    -1,
      70,    71,    72,    73,    -1,    75,    76,    -1,    78,    79,
      80,    81,    82,    83,    -1,    -1,    86,    87,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    95,    96,    97,    98,    99,
     100,   101,   102,   103,    -1,   105,    -1,   107,   108,   109,
     110,   111,    -1,   113,   114,   115,    -1,    -1,   118,   119,
     120,   121,   122,    -1,   124,   125,   126,    -1,   128,   129,
     130,    -1,   132,   133,   134,   135,   136,   137,   138,   139,
     140,    -1,   142,    -1,   144,   145,   146,   147,    -1,   149,
      -1,   151,    -1,    -1,    -1,   155,   156,   157,    -1,   159,
     160,    -1,   162,    -1,   164,   165,   166,   167,   168,    -1,
     170,   171,   172,    -1,   174,   175,   176,   177,   178,   179,
      -1,   181,    -1,   183,   184,   185,   186,   187,   188,   189,
      -1,   191,    -1,   193,    -1,    -1,   196,    -1,   198,   199,
     200,   201,   202,    -1,   204,   205,    -1,   207,   208,    -1,
     210,    -1,    -1,   213,   214,   215,    -1,    -1,   218,   219,
     220,   221,   222,   223,   224,   225,   226,   227,   228,   229,
     230,   231,    -1,   233,   234,   235,   236,    -1,   238,   239,
      -1,   241,    -1,   243,   244,   245,   246,   247,   248,    -1,
     250,    -1,    -1,   253,   254,   255,    -1,    -1,   258,   259,
      -1,   261,    -1,   263,   264,   265,   266,   267,   268,   269,
     270,    -1,   272,   273,   274,   275,   276,   277,   278,    -1,
     280,   281,   282,   283,   284,   285,   286,   287,   288,   289,
     290,   291,   292,    -1,   294,   295,   296,   297,   298,   299,
     300,   301,   302,   303,   304,    -1,   306,   307,    -1,   309,
     310,   311,   312,   313,   314,   315,   316,   317,   318,   319,
      -1,   321,   322,   323,   324,   325,    -1,   327,   328,   329,
     330,    -1,   332,   333,   334,    -1,   336,   337,   338,   339,
     340,   341,   342,   343,   344,   345,   346,    -1,   348,   349,
      -1,   351,   352,   353,   354,   355,   356,    -1,   358,   359,
      -1,    -1,   362,   363,   364,   365,    -1,   367,   368,   369,
     370,   371,   372,   373,    -1,    -1,   376,   377,   378,   379,
     380,    -1,    -1,   383,   384,   385,   386,   387,   388,   389,
      -1,   391,    -1,   393,   394,   395,   396,    -1,    -1,   399,
      -1,    -1,   402,   403,   404,   405,   406,   407,   408,   409,
     410,   411,   412,   413,   414,   415,   416,   417,   418,   419,
       3,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    14,    15,    16,    17,    18,    19,    20,    21,    -1,
      23,    24,    25,    -1,    -1,    -1,    -1,    30,    -1,    -1,
      -1,    34,    35,    -1,    37,    38,    -1,    40,    41,    42,
      43,    44,    -1,    46,    47,    -1,    49,    50,    51,    52,
      53,    -1,    -1,    56,    57,    58,    59,    60,    -1,    62,
      63,    64,    65,    66,    -1,    -1,    -1,    70,    71,    72,
      73,    -1,    75,    76,    -1,    78,    79,    80,    81,    82,
      83,    -1,    -1,    86,    87,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    95,    96,    97,    98,    99,   100,   101,   102,
     103,    -1,   105,    -1,   107,   108,   109,   110,   111,    -1,
     113,   114,   115,    -1,    -1,   118,   119,   120,   121,   122,
      -1,   124,   125,   126,    -1,   128,   129,   130,    -1,   132,
     133,   134,   135,   136,   137,   138,   139,   140,    -1,   142,
      -1,   144,   145,   146,   147,    -1,   149,    -1,   151,    -1,
      -1,    -1,   155,   156,   157,    -1,   159,   160,    -1,   162,
      -1,   164,   165,   166,   167,   168,    -1,   170,   171,   172,
      -1,   174,   175,   176,   177,   178,   179,    -1,   181,    -1,
     183,   184,   185,   186,   187,   188,   189,    -1,   191,    -1,
     193,    -1,    -1,   196,    -1,   198,   199,   200,   201,   202,
      -1,   204,   205,    -1,   207,   208,    -1,   210,    -1,    -1,
     213,   214,   215,    -1,    -1,   218,   219,   220,   221,   222,
     223,   224,   225,   226,   227,   228,   229,   230,   231,    -1,
     233,   234,   235,   236,    -1,   238,   239,    -1,   241,    -1,
     243,   244,   245,   246,   247,   248,    -1,   250,    -1,    -1,
     253,   254,   255,    -1,    -1,   258,   259,    -1,   261,    -1,
     263,   264,   265,   266,   267,   268,   269,   270,    -1,   272,
     273,   274,   275,   276,   277,   278,    -1,   280,   281,   282,
     283,   284,   285,   286,   287,   288,   289,   290,   291,   292,
      -1,   294,   295,   296,   297,   298,   299,   300,   301,   302,
     303,   304,    -1,   306,   307,    -1,   309,   310,   311,   312,
     313,   314,   315,   316,   317,   318,   319,    -1,   321,   322,
     323,   324,   325,    -1,   327,   328,   329,   330,    -1,   332,
     333,   334,    -1,   336,   337,   338,   339,   340,   341,   342,
     343,   344,   345,   346,    -1,   348,   349,    -1,   351,   352,
     353,   354,   355,   356,    -1,   358,   359,    -1,    -1,   362,
     363,   364,   365,    -1,   367,   368,   369,   370,   371,   372,
     373,    -1,    -1,   376,   377,   378,   379,   380,    -1,    -1,
     383,   384,   385,   386,   387,   388,   389,    -1,   391,    -1,
     393,   394,   395,   396,    -1,    -1,   399,    -1,    -1,   402,
     403,   404,   405,   406,   407,   408,   409,   410,   411,   412,
     413,   414,   415,   416,   417,   418,   419,     3,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    14,    15,
      16,    17,    18,    19,    20,    21,    -1,    23,    24,    25,
      -1,    -1,    -1,    -1,    30,    -1,    -1,    -1,    34,    35,
      -1,    37,    38,    -1,    40,    41,    42,    43,    44,    -1,
      46,    47,    -1,    49,    50,    51,    52,    53,    -1,    -1,
      56,    57,    58,    59,    60,    -1,    62,    63,    64,    65,
      66,    -1,    -1,    -1,    70,    71,    72,    73,    -1,    75,
      76,    -1,    78,    79,    80,    81,    82,    83,    -1,    -1,
      86,    87,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    95,
      96,    97,    98,    99,   100,   101,   102,   103,    -1,   105,
      -1,   107,   108,   109,   110,   111,    -1,   113,   114,   115,
      -1,    -1,   118,   119,   120,   121,   122,    -1,   124,   125,
     126,    -1,   128,   129,   130,    -1,   132,   133,   134,   135,
     136,   137,   138,   139,   140,    -1,   142,    -1,   144,   145,
     146,   147,    -1,   149,    -1,   151,    -1,    -1,    -1,   155,
     156,   157,    -1,   159,   160,    -1,   162,    -1,   164,   165,
     166,   167,   168,    -1,   170,   171,   172,    -1,   174,   175,
     176,   177,   178,   179,    -1,   181,    -1,   183,   184,   185,
     186,   187,   188,   189,    -1,   191,    -1,   193,    -1,    -1,
     196,    -1,   198,   199,   200,   201,   202,    -1,   204,   205,
      -1,   207,   208,    -1,   210,    -1,    -1,   213,   214,   215,
      -1,    -1,   218,   219,   220,   221,   222,   223,   224,   225,
     226,   227,   228,   229,   230,   231,    -1,   233,   234,   235,
     236,    -1,   238,   239,    -1,   241,    -1,   243,   244,   245,
     246,   247,   248,    -1,   250,    -1,    -1,   253,   254,   255,
      -1,    -1,   258,   259,    -1,   261,    -1,   263,   264,   265,
     266,   267,   268,   269,   270,    -1,   272,   273,   274,   275,
     276,   277,   278,    -1,   280,   281,   282,   283,   284,   285,
     286,   287,   288,   289,   290,   291,   292,    -1,   294,   295,
     296,   297,   298,   299,   300,   301,   302,   303,   304,    -1,
     306,   307,    -1,   309,   310,   311,   312,   313,   314,   315,
     316,   317,   318,   319,    -1,   321,   322,   323,   324,   325,
      -1,   327,   328,   329,   330,    -1,   332,   333,   334,    -1,
     336,   337,   338,   339,   340,   341,   342,   343,   344,   345,
     346,    -1,   348,   349,    -1,   351,   352,   353,   354,   355,
     356,    -1,   358,   359,    -1,    -1,   362,   363,   364,   365,
      -1,   367,   368,   369,   370,   371,   372,   373,    -1,    -1,
     376,   377,   378,   379,   380,    -1,    -1,   383,   384,   385,
     386,   387,   388,   389,    -1,   391,    -1,   393,   394,   395,
     396,    -1,    -1,   399,    -1,    -1,   402,   403,   404,   405,
     406,   407,   408,   409,   410,   411,   412,   413,   414,   415,
     416,   417,   418,   419,     3,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    14,    15,    16,    17,    18,
      19,    20,    21,    -1,    23,    24,    25,    -1,    -1,    -1,
      -1,    30,    -1,    -1,    -1,    34,    35,    -1,    37,    38,
      -1,    40,    41,    42,    43,    44,    -1,    46,    47,    -1,
      49,    50,    51,    52,    53,    -1,    -1,    56,    57,    58,
      59,    60,    -1,    62,    63,    64,    65,    66,    -1,    -1,
      -1,    70,    71,    72,    73,    -1,    75,    76,    -1,    78,
      79,    80,    81,    82,    83,    -1,    -1,    86,    87,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    95,    96,    97,    98,
      99,   100,   101,   102,   103,    -1,   105,    -1,   107,   108,
     109,   110,   111,    -1,   113,   114,   115,    -1,    -1,   118,
     119,   120,   121,   122,    -1,   124,   125,   126,    -1,   128,
     129,   130,    -1,   132,   133,   134,   135,   136,   137,   138,
     139,   140,    -1,   142,    -1,   144,   145,   146,   147,    -1,
     149,    -1,   151,    -1,    -1,    -1,   155,   156,   157,    -1,
     159,   160,    -1,   162,    -1,   164,   165,   166,   167,   168,
      -1,   170,   171,   172,    -1,   174,   175,   176,   177,   178,
     179,    -1,   181,    -1,   183,   184,   185,   186,   187,   188,
     189,    -1,   191,    -1,   193,    -1,    -1,   196,    -1,   198,
     199,   200,   201,   202,    -1,   204,   205,    -1,   207,   208,
      -1,   210,    -1,    -1,   213,   214,   215,    -1,    -1,   218,
     219,   220,   221,   222,   223,   224,   225,   226,   227,   228,
     229,   230,   231,    -1,   233,   234,   235,   236,    -1,   238,
     239,    -1,   241,    -1,   243,   244,   245,   246,   247,   248,
      -1,   250,    -1,    -1,   253,   254,   255,    -1,    -1,   258,
     259,    -1,   261,    -1,   263,   264,   265,   266,   267,   268,
     269,   270,    -1,   272,   273,   274,   275,   276,   277,   278,
      -1,   280,   281,   282,   283,   284,   285,   286,   287,   288,
     289,   290,   291,   292,    -1,   294,   295,   296,   297,   298,
     299,   300,   301,   302,   303,   304,    -1,   306,   307,    -1,
     309,   310,   311,   312,   313,   314,   315,   316,   317,   318,
     319,    -1,   321,   322,   323,   324,   325,    -1,   327,   328,
     329,   330,    -1,   332,   333,   334,    -1,   336,   337,   338,
     339,   340,   341,   342,   343,   344,   345,   346,    -1,   348,
     349,    -1,   351,   352,   353,   354,   355,   356,    -1,   358,
     359,    -1,    -1,   362,   363,   364,   365,    -1,   367,   368,
     369,   370,   371,   372,   373,    -1,    -1,   376,   377,   378,
     379,   380,    -1,    -1,   383,   384,   385,   386,   387,   388,
     389,    -1,   391,    -1,   393,   394,   395,   396,    -1,    -1,
     399,    -1,    -1,   402,   403,   404,   405,   406,   407,   408,
     409,   410,   411,   412,   413,   414,   415,   416,   417,   418,
     419,     3,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    14,    15,    16,    17,    18,    19,    20,    21,
      -1,    23,    24,    25,    -1,    -1,    -1,    -1,    30,    -1,
      -1,    -1,    34,    35,    -1,    37,    38,    -1,    40,    41,
      42,    43,    44,    -1,    46,    47,    -1,    49,    50,    51,
      52,    53,    -1,    -1,    56,    57,    58,    59,    60,    -1,
      62,    63,    64,    65,    66,    -1,    -1,    -1,    70,    71,
      72,    73,    -1,    75,    76,    -1,    78,    79,    80,    81,
      82,    83,    -1,    -1,    86,    87,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    95,    96,    97,    98,    99,   100,   101,
     102,   103,    -1,   105,    -1,   107,   108,   109,   110,   111,
      -1,   113,   114,   115,    -1,    -1,   118,   119,   120,   121,
     122,    -1,   124,   125,   126,    -1,   128,   129,   130,    -1,
     132,   133,   134,   135,   136,   137,   138,   139,   140,    -1,
     142,    -1,   144,   145,   146,   147,    -1,   149,    -1,   151,
      -1,    -1,    -1,   155,   156,   157,    -1,   159,   160,    -1,
     162,    -1,   164,   165,   166,   167,   168,    -1,   170,   171,
     172,    -1,   174,   175,   176,   177,   178,   179,    -1,   181,
      -1,   183,   184,   185,   186,   187,   188,   189,    -1,   191,
      -1,   193,    -1,    -1,   196,    -1,   198,   199,   200,   201,
     202,    -1,   204,   205,    -1,   207,   208,    -1,   210,    -1,
      -1,   213,   214,   215,    -1,    -1,   218,   219,   220,   221,
     222,   223,   224,   225,   226,   227,   228,   229,   230,   231,
      -1,   233,   234,   235,   236,    -1,   238,   239,    -1,   241,
      -1,   243,   244,   245,   246,   247,   248,    -1,   250,    -1,
      -1,   253,   254,   255,    -1,    -1,   258,   259,    -1,   261,
      -1,   263,   264,   265,   266,   267,   268,   269,   270,    -1,
     272,   273,   274,   275,   276,   277,   278,    -1,   280,   281,
     282,   283,   284,   285,   286,   287,   288,   289,   290,   291,
     292,    -1,   294,   295,   296,   297,   298,   299,   300,   301,
     302,   303,   304,    -1,   306,   307,    -1,   309,   310,   311,
     312,   313,   314,   315,   316,   317,   318,   319,    -1,   321,
     322,   323,   324,   325,    -1,   327,   328,   329,   330,    -1,
     332,   333,   334,    -1,   336,   337,   338,   339,   340,   341,
     342,   343,   344,   345,   346,    -1,   348,   349,    -1,   351,
     352,   353,   354,   355,   356,    -1,   358,   359,    -1,    -1,
     362,   363,   364,   365,    -1,   367,   368,   369,   370,   371,
     372,   373,    -1,    -1,   376,   377,   378,   379,   380,    -1,
      -1,   383,   384,   385,   386,   387,   388,   389,    -1,   391,
      -1,   393,   394,   395,   396,    -1,    -1,   399,    -1,    -1,
     402,   403,   404,   405,   406,   407,   408,   409,   410,   411,
     412,   413,   414,   415,   416,   417,   418,   419,     3,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    14,
      15,    16,    17,    18,    19,    20,    21,    -1,    23,    24,
      25,    -1,    -1,    -1,    -1,    30,    -1,    -1,    -1,    34,
      35,    -1,    37,    38,    -1,    40,    41,    42,    43,    44,
      -1,    46,    47,    -1,    49,    50,    51,    52,    53,    -1,
      -1,    56,    57,    58,    59,    60,    -1,    62,    63,    64,
      65,    66,    -1,    -1,    -1,    70,    71,    72,    73,    -1,
      75,    76,    -1,    78,    79,    80,    81,    82,    83,    -1,
      -1,    86,    87,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      95,    96,    97,    98,    99,   100,   101,   102,   103,    -1,
     105,    -1,   107,   108,   109,   110,   111,    -1,   113,   114,
     115,    -1,    -1,   118,   119,   120,   121,   122,    -1,   124,
     125,   126,    -1,   128,   129,   130,    -1,   132,   133,   134,
     135,   136,   137,   138,   139,   140,    -1,   142,    -1,   144,
     145,   146,   147,    -1,   149,    -1,   151,    -1,    -1,    -1,
     155,   156,   157,    -1,   159,   160,    -1,   162,    -1,   164,
     165,   166,   167,   168,    -1,   170,   171,   172,    -1,   174,
     175,   176,   177,   178,   179,    -1,   181,    -1,   183,   184,
     185,   186,   187,   188,   189,    -1,   191,    -1,   193,    -1,
      -1,   196,    -1,   198,   199,   200,   201,   202,    -1,   204,
     205,    -1,   207,   208,    -1,   210,    -1,    -1,   213,   214,
     215,    -1,    -1,   218,   219,   220,   221,   222,   223,   224,
     225,   226,   227,   228,   229,   230,   231,    -1,   233,   234,
     235,   236,    -1,   238,   239,    -1,   241,    -1,   243,   244,
     245,   246,   247,   248,    -1,   250,    -1,    -1,   253,   254,
     255,    -1,    -1,   258,   259,    -1,   261,    -1,   263,   264,
     265,   266,   267,   268,   269,   270,    -1,   272,   273,   274,
     275,   276,   277,   278,    -1,   280,   281,   282,   283,   284,
     285,   286,   287,   288,   289,   290,   291,   292,    -1,   294,
     295,   296,   297,   298,   299,   300,   301,   302,   303,   304,
      -1,   306,   307,    -1,   309,   310,   311,   312,   313,   314,
     315,   316,   317,   318,   319,    -1,   321,   322,   323,   324,
     325,    -1,   327,   328,   329,   330,    -1,   332,   333,   334,
      -1,   336,   337,   338,   339,   340,   341,   342,   343,   344,
     345,   346,    -1,   348,   349,    -1,   351,   352,   353,   354,
     355,   356,    -1,   358,   359,    -1,    -1,   362,   363,   364,
     365,    -1,   367,   368,   369,   370,   371,   372,   373,    -1,
      -1,   376,   377,   378,   379,   380,    -1,    -1,   383,   384,
     385,   386,   387,   388,   389,    -1,   391,    -1,   393,   394,
     395,   396,    -1,    -1,   399,    -1,    -1,   402,   403,   404,
     405,   406,   407,   408,   409,   410,   411,   412,   413,   414,
     415,   416,   417,   418,   419,     3,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    14,    15,    16,    17,
      18,    19,    20,    21,    -1,    23,    24,    25,    -1,    -1,
      -1,    -1,    30,    -1,    -1,    -1,    34,    35,    -1,    37,
      38,    -1,    40,    41,    42,    43,    44,    -1,    46,    47,
      -1,    49,    50,    51,    52,    53,    -1,    -1,    56,    57,
      58,    59,    60,    -1,    62,    63,    64,    65,    66,    -1,
      -1,    -1,    70,    71,    72,    73,    -1,    75,    76,    -1,
      78,    79,    80,    81,    82,    83,    -1,    -1,    86,    87,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    95,    96,    97,
      98,    99,   100,   101,   102,   103,    -1,   105,    -1,   107,
     108,   109,   110,   111,    -1,   113,   114,   115,    -1,    -1,
     118,   119,   120,   121,   122,    -1,   124,   125,   126,    -1,
     128,   129,   130,    -1,   132,   133,   134,   135,   136,   137,
     138,   139,   140,    -1,   142,    -1,   144,   145,   146,   147,
      -1,   149,    -1,   151,    -1,    -1,    -1,   155,   156,   157,
      -1,   159,   160,    -1,   162,    -1,   164,   165,   166,   167,
     168,    -1,   170,   171,   172,    -1,   174,   175,   176,   177,
     178,   179,    -1,   181,    -1,   183,   184,   185,   186,   187,
     188,   189,    -1,   191,    -1,   193,    -1,    -1,   196,    -1,
     198,   199,   200,   201,   202,    -1,   204,   205,    -1,   207,
     208,    -1,   210,    -1,    -1,   213,   214,   215,    -1,    -1,
     218,   219,   220,   221,   222,   223,   224,   225,   226,   227,
     228,   229,   230,   231,    -1,   233,   234,   235,   236,    -1,
     238,   239,    -1,   241,    -1,   243,   244,   245,   246,   247,
     248,    -1,   250,    -1,    -1,   253,   254,   255,    -1,    -1,
     258,   259,    -1,   261,    -1,   263,   264,   265,   266,   267,
     268,   269,   270,    -1,   272,   273,   274,   275,   276,   277,
     278,    -1,   280,   281,   282,   283,   284,   285,   286,   287,
     288,   289,   290,   291,   292,    -1,   294,   295,   296,   297,
     298,   299,   300,   301,   302,   303,   304,    -1,   306,   307,
      -1,   309,   310,   311,   312,   313,   314,   315,   316,   317,
     318,   319,    -1,   321,   322,   323,   324,   325,    -1,   327,
     328,   329,   330,    -1,   332,   333,   334,    -1,   336,   337,
     338,   339,   340,   341,   342,   343,   344,   345,   346,    -1,
     348,   349,    -1,   351,   352,   353,   354,   355,   356,    -1,
     358,   359,    -1,    -1,   362,   363,   364,   365,    -1,   367,
     368,   369,   370,   371,   372,   373,    -1,    -1,   376,   377,
     378,   379,   380,    -1,    -1,   383,   384,   385,   386,   387,
     388,   389,    -1,   391,    -1,   393,   394,   395,   396,    -1,
      -1,   399,    -1,    -1,   402,   403,   404,   405,   406,   407,
     408,   409,   410,   411,   412,   413,   414,   415,   416,   417,
     418,   419,     3,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    14,    15,    16,    17,    18,    19,    20,
      21,    -1,    23,    24,    25,    -1,    -1,    -1,    -1,    30,
      -1,    32,    -1,    34,    35,    -1,    37,    38,    -1,    40,
      41,    42,    43,    44,    -1,    46,    47,    -1,    49,    50,
      51,    52,    53,    -1,    -1,    56,    57,    58,    59,    60,
      -1,    62,    63,    64,    65,    66,    -1,    -1,    -1,    70,
      71,    72,    73,    -1,    75,    76,    -1,    78,    79,    80,
      81,    82,    83,    -1,    -1,    86,    87,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    95,    96,    97,    98,    99,   100,
     101,   102,   103,    -1,   105,    -1,   107,   108,   109,   110,
     111,    -1,   113,   114,   115,    -1,    -1,   118,   119,   120,
     121,   122,    -1,   124,   125,   126,    -1,   128,   129,   130,
      -1,   132,   133,   134,   135,   136,   137,   138,   139,   140,
      -1,   142,    -1,   144,   145,   146,   147,    -1,   149,    -1,
     151,    -1,    -1,    -1,   155,   156,   157,    -1,   159,   160,
      -1,   162,    -1,   164,   165,   166,   167,   168,    -1,   170,
     171,   172,    -1,   174,   175,   176,   177,   178,   179,    -1,
     181,    -1,   183,   184,   185,   186,   187,   188,   189,    -1,
     191,    -1,   193,    -1,    -1,   196,    -1,   198,   199,   200,
     201,   202,    -1,   204,   205,    -1,   207,   208,    -1,   210,
      -1,    -1,   213,   214,   215,    -1,    -1,   218,   219,   220,
     221,   222,   223,   224,   225,   226,   227,   228,   229,   230,
     231,    -1,   233,   234,   235,   236,    -1,   238,   239,    -1,
     241,    -1,   243,   244,   245,   246,   247,   248,    -1,   250,
      -1,    -1,   253,   254,   255,    -1,    -1,   258,   259,    -1,
     261,    -1,   263,   264,   265,   266,   267,   268,   269,   270,
      -1,   272,   273,   274,   275,   276,   277,   278,    -1,   280,
     281,   282,   283,   284,   285,   286,   287,   288,   289,   290,
     291,   292,    -1,   294,   295,   296,   297,   298,   299,   300,
     301,   302,   303,   304,    -1,   306,   307,    -1,   309,   310,
     311,   312,   313,   314,   315,   316,   317,   318,   319,    -1,
     321,   322,   323,   324,   325,    -1,    -1,   328,   329,   330,
      -1,   332,   333,   334,    -1,   336,   337,   338,   339,   340,
     341,   342,   343,   344,   345,   346,    -1,   348,   349,    -1,
     351,   352,   353,   354,   355,   356,    -1,   358,   359,    -1,
      -1,   362,   363,   364,   365,    -1,   367,   368,   369,   370,
     371,   372,   373,    -1,    -1,   376,   377,   378,   379,   380,
      -1,    -1,   383,   384,   385,   386,   387,   388,   389,    -1,
     391,    -1,   393,   394,   395,   396,    -1,    -1,   399,    -1,
      -1,   402,   403,   404,   405,   406,   407,   408,   409,   410,
     411,   412,   413,   414,   415,   416,   417,   418,   419,     3,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      14,    15,    16,    17,    18,    19,    20,    21,    -1,    23,
      24,    25,    -1,    -1,    -1,    -1,    30,    -1,    -1,    -1,
      34,    35,    -1,    37,    38,    -1,    40,    41,    42,    43,
      44,    -1,    46,    47,    -1,    49,    50,    51,    52,    53,
      -1,    -1,    56,    57,    58,    59,    60,    -1,    62,    63,
      64,    65,    66,    -1,    -1,    -1,    70,    71,    72,    73,
      -1,    75,    76,    -1,    78,    79,    80,    81,    82,    83,
      -1,    -1,    86,    87,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    95,    96,    97,    98,    99,   100,   101,   102,   103,
      -1,   105,    -1,   107,   108,   109,   110,   111,    -1,   113,
     114,   115,    -1,    -1,   118,   119,   120,   121,   122,    -1,
     124,   125,   126,    -1,   128,   129,   130,    -1,   132,   133,
     134,   135,   136,   137,   138,   139,   140,    -1,   142,    -1,
     144,   145,   146,   147,    -1,   149,    -1,   151,    -1,    -1,
      -1,   155,   156,   157,    -1,   159,   160,    -1,   162,    -1,
     164,   165,   166,   167,   168,    -1,   170,   171,   172,    -1,
     174,   175,   176,   177,   178,   179,    -1,   181,    -1,   183,
     184,   185,   186,   187,   188,   189,    -1,   191,    -1,   193,
      -1,    -1,   196,    -1,   198,   199,   200,   201,   202,    -1,
     204,   205,    -1,   207,   208,    -1,   210,    -1,    -1,   213,
     214,   215,    -1,    -1,   218,   219,   220,   221,   222,   223,
     224,   225,   226,   227,   228,   229,   230,   231,    -1,   233,
     234,   235,   236,    -1,   238,   239,    -1,   241,    -1,   243,
     244,   245,   246,   247,   248,    -1,   250,    -1,    -1,   253,
     254,   255,    -1,    -1,   258,   259,    -1,   261,    -1,   263,
     264,   265,   266,   267,   268,   269,   270,    -1,   272,   273,
     274,   275,   276,   277,   278,    -1,   280,   281,   282,   283,
     284,   285,   286,   287,   288,   289,   290,   291,   292,    -1,
     294,   295,   296,   297,   298,   299,   300,   301,   302,   303,
     304,    -1,   306,   307,    -1,   309,   310,   311,   312,   313,
     314,   315,   316,   317,   318,   319,    -1,   321,   322,   323,
     324,   325,    -1,   327,   328,   329,   330,    -1,   332,   333,
     334,    -1,   336,   337,   338,   339,   340,   341,   342,   343,
     344,   345,   346,    -1,   348,   349,    -1,   351,   352,   353,
     354,   355,   356,    -1,   358,   359,    -1,    -1,   362,   363,
     364,   365,    -1,   367,   368,   369,   370,   371,   372,   373,
      -1,    -1,   376,   377,   378,   379,   380,    -1,    -1,   383,
     384,   385,   386,   387,   388,   389,    -1,   391,    -1,   393,
     394,   395,   396,    -1,    -1,   399,    -1,    -1,   402,   403,
     404,   405,   406,   407,   408,   409,   410,   411,   412,   413,
     414,   415,   416,   417,   418,   419,     3,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    14,    15,    16,
      17,    18,    19,    20,    21,    -1,    23,    24,    25,    -1,
      -1,    -1,    -1,    30,    -1,    -1,    -1,    34,    35,    -1,
      37,    38,    -1,    40,    41,    42,    43,    44,    -1,    46,
      47,    -1,    49,    50,    51,    52,    53,    -1,    -1,    56,
      57,    58,    59,    60,    -1,    62,    63,    64,    65,    66,
      -1,    -1,    -1,    70,    71,    72,    73,    -1,    75,    76,
      -1,    78,    79,    80,    81,    82,    83,    -1,    -1,    86,
      87,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    95,    96,
      97,    98,    99,   100,   101,   102,   103,    -1,   105,    -1,
     107,   108,   109,   110,   111,    -1,   113,   114,   115,    -1,
      -1,   118,   119,   120,   121,   122,    -1,   124,   125,   126,
      -1,   128,   129,   130,    -1,   132,   133,   134,   135,   136,
     137,   138,   139,   140,    -1,   142,    -1,   144,   145,   146,
     147,    -1,   149,    -1,   151,    -1,    -1,    -1,   155,   156,
     157,    -1,   159,   160,    -1,   162,    -1,   164,   165,   166,
     167,   168,    -1,   170,   171,   172,    -1,   174,   175,   176,
     177,   178,   179,    -1,   181,    -1,   183,   184,   185,   186,
     187,   188,   189,    -1,   191,    -1,   193,    -1,    -1,   196,
      -1,   198,   199,   200,   201,   202,    -1,   204,   205,    -1,
     207,   208,    -1,   210,    -1,    -1,   213,   214,   215,    -1,
      -1,   218,   219,   220,   221,   222,   223,   224,   225,   226,
     227,   228,   229,   230,   231,    -1,   233,   234,   235,   236,
      -1,   238,   239,    -1,   241,    -1,   243,   244,   245,   246,
     247,   248,    -1,   250,    -1,    -1,   253,   254,   255,    -1,
      -1,   258,   259,    -1,   261,    -1,   263,   264,   265,   266,
     267,   268,   269,   270,    -1,   272,   273,   274,   275,   276,
     277,   278,    -1,   280,   281,   282,   283,   284,   285,   286,
     287,   288,   289,   290,   291,   292,    -1,   294,   295,   296,
     297,   298,   299,   300,   301,   302,   303,   304,    -1,   306,
     307,    -1,   309,   310,   311,   312,   313,   314,   315,   316,
     317,   318,   319,    -1,   321,   322,   323,   324,   325,    -1,
     327,   328,   329,   330,    -1,   332,   333,   334,    -1,   336,
     337,   338,   339,   340,   341,   342,   343,   344,   345,   346,
      -1,   348,   349,    -1,   351,   352,   353,   354,   355,   356,
      -1,   358,   359,    -1,    -1,   362,   363,   364,   365,    -1,
     367,   368,   369,   370,   371,   372,   373,    -1,    -1,   376,
     377,   378,   379,   380,    -1,    -1,   383,   384,   385,   386,
     387,   388,   389,    -1,   391,    -1,   393,   394,   395,   396,
      -1,    -1,   399,    -1,    -1,   402,   403,   404,   405,   406,
     407,   408,   409,   410,   411,   412,   413,   414,   415,   416,
     417,   418,   419,     3,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    14,    15,    16,    17,    18,    19,
      20,    21,    -1,    23,    24,    25,    -1,    -1,    -1,    -1,
      30,    -1,    -1,    -1,    34,    35,    -1,    37,    38,    -1,
      40,    41,    42,    43,    44,    -1,    46,    47,    -1,    49,
      50,    51,    52,    53,    -1,    -1,    56,    57,    58,    59,
      60,    -1,    62,    63,    64,    65,    66,    -1,    -1,    -1,
      70,    71,    72,    73,    -1,    75,    76,    -1,    78,    79,
      80,    81,    82,    83,    -1,    -1,    86,    87,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    95,    96,    97,    98,    99,
     100,   101,   102,   103,    -1,   105,    -1,   107,   108,   109,
     110,   111,    -1,   113,   114,   115,    -1,    -1,   118,   119,
     120,   121,   122,    -1,   124,   125,   126,    -1,   128,   129,
     130,    -1,   132,   133,   134,   135,   136,   137,   138,   139,
     140,    -1,   142,    -1,   144,   145,   146,   147,    -1,   149,
      -1,   151,    -1,    -1,    -1,   155,   156,   157,    -1,   159,
     160,    -1,   162,    -1,   164,   165,   166,   167,   168,    -1,
     170,   171,   172,    -1,   174,   175,   176,   177,   178,   179,
      -1,   181,    -1,   183,   184,   185,   186,   187,   188,   189,
      -1,   191,    -1,   193,    -1,    -1,   196,    -1,   198,   199,
     200,   201,   202,    -1,   204,   205,    -1,   207,   208,    -1,
     210,    -1,    -1,   213,   214,   215,    -1,    -1,   218,   219,
     220,   221,   222,   223,   224,   225,   226,   227,   228,   229,
     230,   231,    -1,   233,   234,   235,   236,    -1,   238,   239,
      -1,   241,    -1,   243,   244,   245,   246,   247,   248,    -1,
     250,    -1,    -1,   253,   254,   255,    -1,    -1,   258,   259,
      -1,   261,    -1,   263,   264,   265,   266,   267,   268,   269,
     270,    -1,   272,   273,   274,   275,   276,   277,   278,    -1,
     280,   281,   282,   283,   284,   285,   286,   287,   288,   289,
     290,   291,   292,    -1,   294,   295,   296,   297,   298,   299,
     300,   301,   302,   303,   304,    -1,   306,   307,    -1,   309,
     310,   311,   312,   313,   314,   315,   316,   317,   318,   319,
      -1,   321,   322,   323,   324,   325,    -1,   327,   328,   329,
     330,    -1,   332,   333,   334,    -1,   336,   337,   338,   339,
     340,   341,   342,   343,   344,   345,   346,    -1,   348,   349,
      -1,   351,   352,   353,   354,   355,   356,    -1,   358,   359,
      -1,    -1,   362,   363,   364,   365,    -1,   367,   368,   369,
     370,   371,   372,   373,    -1,    -1,   376,   377,   378,   379,
     380,    -1,    -1,   383,   384,   385,   386,   387,   388,   389,
      -1,   391,    -1,   393,   394,   395,   396,    -1,    -1,   399,
      -1,    -1,   402,   403,   404,   405,   406,   407,   408,   409,
     410,   411,   412,   413,   414,   415,   416,   417,   418,   419,
       3,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    14,    15,    16,    17,    18,    19,    20,    21,    -1,
      23,    24,    25,    -1,    -1,    -1,    -1,    30,    -1,    -1,
      -1,    34,    35,    -1,    37,    38,    -1,    40,    41,    42,
      43,    44,    -1,    46,    47,    -1,    49,    50,    51,    52,
      53,    -1,    -1,    56,    57,    58,    59,    60,    -1,    62,
      63,    64,    65,    66,    -1,    -1,    -1,    70,    71,    72,
      73,    -1,    75,    76,    -1,    78,    79,    80,    81,    82,
      83,    -1,    -1,    86,    87,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    95,    96,    97,    98,    99,   100,   101,   102,
     103,    -1,   105,    -1,   107,   108,   109,   110,   111,    -1,
     113,   114,   115,    -1,    -1,   118,   119,   120,   121,   122,
      -1,   124,   125,   126,    -1,   128,   129,   130,    -1,   132,
     133,   134,   135,   136,   137,   138,   139,   140,    -1,   142,
      -1,   144,   145,   146,   147,    -1,   149,    -1,   151,    -1,
      -1,    -1,   155,   156,   157,    -1,   159,   160,    -1,   162,
      -1,   164,   165,   166,   167,   168,    -1,   170,   171,   172,
      -1,   174,   175,   176,   177,   178,   179,    -1,   181,    -1,
     183,   184,   185,   186,   187,   188,   189,    -1,   191,    -1,
     193,    -1,    -1,   196,    -1,   198,   199,   200,   201,   202,
      -1,   204,   205,    -1,   207,   208,    -1,   210,    -1,    -1,
     213,   214,   215,    -1,    -1,   218,   219,   220,   221,   222,
     223,   224,   225,   226,   227,   228,   229,   230,   231,    -1,
     233,   234,   235,   236,    -1,   238,   239,    -1,   241,    -1,
     243,   244,   245,   246,   247,   248,    -1,   250,    -1,    -1,
     253,   254,   255,    -1,    -1,   258,   259,    -1,   261,    -1,
     263,   264,   265,   266,   267,   268,   269,   270,    -1,   272,
     273,   274,   275,   276,   277,   278,    -1,   280,   281,   282,
     283,   284,   285,   286,   287,   288,   289,   290,   291,   292,
      -1,   294,   295,   296,   297,   298,   299,   300,   301,   302,
     303,   304,    -1,   306,   307,    -1,   309,   310,   311,   312,
     313,   314,   315,   316,   317,   318,   319,    -1,   321,   322,
     323,   324,   325,    -1,   327,   328,   329,   330,    -1,   332,
     333,   334,    -1,   336,   337,   338,   339,   340,   341,   342,
     343,   344,   345,   346,    -1,   348,   349,    -1,   351,   352,
     353,   354,   355,   356,    -1,   358,   359,    -1,    -1,   362,
     363,   364,   365,    -1,   367,   368,   369,   370,   371,   372,
     373,    -1,    -1,   376,   377,   378,   379,   380,    -1,    -1,
     383,   384,   385,   386,   387,   388,   389,    -1,   391,    -1,
     393,   394,   395,   396,    -1,    -1,   399,    -1,    -1,   402,
     403,   404,   405,   406,   407,   408,   409,   410,   411,   412,
     413,   414,   415,   416,   417,   418,   419,     3,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    14,    15,
      16,    17,    18,    19,    20,    21,    -1,    23,    24,    25,
      -1,    -1,    -1,    -1,    30,    -1,    -1,    -1,    34,    35,
      -1,    37,    38,    -1,    40,    41,    42,    43,    44,    -1,
      46,    47,    -1,    49,    50,    51,    52,    53,    -1,    -1,
      56,    57,    58,    59,    60,    -1,    62,    63,    64,    65,
      66,    -1,    -1,    -1,    70,    71,    72,    73,    -1,    75,
      76,    -1,    78,    79,    80,    81,    82,    83,    -1,    -1,
      86,    87,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    95,
      96,    97,    98,    99,   100,   101,   102,   103,    -1,   105,
      -1,   107,   108,   109,   110,   111,    -1,   113,   114,   115,
      -1,    -1,   118,   119,   120,   121,   122,    -1,   124,   125,
     126,    -1,   128,   129,   130,    -1,   132,   133,   134,   135,
     136,   137,   138,   139,   140,    -1,   142,    -1,   144,   145,
     146,   147,    -1,   149,    -1,   151,    -1,    -1,    -1,   155,
     156,   157,    -1,   159,   160,    -1,   162,    -1,   164,   165,
     166,   167,   168,    -1,   170,   171,   172,    -1,   174,   175,
     176,   177,   178,   179,    -1,   181,    -1,   183,   184,   185,
     186,   187,   188,   189,    -1,   191,    -1,   193,    -1,    -1,
     196,    -1,   198,   199,   200,   201,   202,    -1,   204,   205,
      -1,   207,   208,    -1,   210,    -1,    -1,   213,   214,   215,
      -1,    -1,   218,   219,   220,   221,   222,   223,   224,   225,
     226,   227,   228,   229,   230,   231,    -1,   233,   234,   235,
     236,    -1,   238,   239,    -1,   241,    -1,   243,   244,   245,
     246,   247,   248,    -1,   250,    -1,    -1,   253,   254,   255,
      -1,    -1,   258,   259,    -1,   261,    -1,   263,   264,   265,
     266,   267,   268,   269,   270,    -1,   272,   273,   274,   275,
     276,   277,   278,    -1,   280,   281,   282,   283,   284,   285,
     286,   287,   288,   289,   290,   291,   292,    -1,   294,   295,
     296,   297,   298,   299,   300,   301,   302,   303,   304,    -1,
     306,   307,    -1,   309,   310,   311,   312,   313,   314,   315,
     316,   317,   318,   319,    -1,   321,   322,   323,   324,   325,
      -1,   327,   328,   329,   330,    -1,   332,   333,   334,    -1,
     336,   337,   338,   339,   340,   341,   342,   343,   344,   345,
     346,    -1,   348,   349,    -1,   351,   352,   353,   354,   355,
     356,    -1,   358,   359,    -1,    -1,   362,   363,   364,   365,
      -1,   367,   368,   369,   370,   371,   372,   373,    -1,    -1,
     376,   377,   378,   379,   380,    -1,    -1,   383,   384,   385,
     386,   387,   388,   389,    -1,   391,    -1,   393,   394,   395,
     396,    -1,    -1,   399,    -1,    -1,   402,   403,   404,   405,
     406,   407,   408,   409,   410,   411,   412,   413,   414,   415,
     416,   417,   418,   419,     3,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    14,    15,    16,    17,    18,
      19,    20,    21,    -1,    23,    24,    25,    -1,    -1,    -1,
      -1,    30,    -1,    -1,    -1,    34,    35,    -1,    37,    38,
      -1,    40,    41,    42,    43,    44,    -1,    46,    47,    -1,
      49,    50,    51,    52,    53,    -1,    -1,    56,    57,    58,
      59,    60,    -1,    62,    63,    64,    65,    66,    -1,    -1,
      -1,    70,    71,    72,    73,    -1,    75,    76,    -1,    78,
      79,    80,    81,    82,    83,    -1,    -1,    86,    87,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    95,    96,    97,    98,
      99,   100,   101,   102,   103,    -1,   105,    -1,   107,   108,
     109,   110,   111,    -1,   113,   114,   115,    -1,    -1,   118,
     119,   120,   121,   122,    -1,   124,   125,   126,    -1,   128,
     129,   130,    -1,   132,   133,   134,   135,   136,   137,   138,
     139,   140,    -1,   142,    -1,   144,   145,   146,   147,    -1,
     149,    -1,   151,    -1,    -1,    -1,   155,   156,   157,    -1,
     159,   160,    -1,   162,    -1,   164,   165,   166,   167,   168,
      -1,   170,   171,   172,    -1,   174,   175,   176,   177,   178,
     179,    -1,   181,    -1,   183,   184,   185,   186,   187,   188,
     189,    -1,   191,    -1,   193,    -1,    -1,   196,    -1,   198,
     199,   200,   201,   202,    -1,   204,   205,    -1,   207,   208,
      -1,   210,    -1,    -1,   213,   214,   215,    -1,    -1,   218,
     219,   220,   221,   222,   223,   224,   225,   226,   227,   228,
     229,   230,   231,    -1,   233,   234,   235,   236,    -1,   238,
     239,    -1,   241,    -1,   243,   244,   245,   246,   247,   248,
      -1,   250,    -1,    -1,   253,   254,   255,    -1,    -1,   258,
     259,    -1,   261,    -1,   263,   264,   265,   266,   267,   268,
     269,   270,    -1,   272,   273,   274,   275,   276,   277,   278,
      -1,   280,   281,   282,   283,   284,   285,   286,   287,   288,
     289,   290,   291,   292,    -1,   294,   295,   296,   297,   298,
     299,   300,   301,   302,   303,   304,    -1,   306,   307,    -1,
     309,   310,   311,   312,   313,   314,   315,   316,   317,   318,
     319,    -1,   321,   322,   323,   324,   325,    -1,   327,   328,
     329,   330,    -1,   332,   333,   334,    -1,   336,   337,   338,
     339,   340,   341,   342,   343,   344,   345,   346,    -1,   348,
     349,    -1,   351,   352,   353,   354,   355,   356,    -1,   358,
     359,    -1,    -1,   362,   363,   364,   365,    -1,   367,   368,
     369,   370,   371,   372,   373,    -1,    -1,   376,   377,   378,
     379,   380,    -1,    -1,   383,   384,   385,   386,   387,   388,
     389,    -1,   391,    -1,   393,   394,   395,   396,    -1,    -1,
     399,    -1,    -1,   402,   403,   404,   405,   406,   407,   408,
     409,   410,   411,   412,   413,   414,   415,   416,   417,   418,
     419,     3,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    14,    15,    16,    17,    18,    19,    20,    21,
      -1,    23,    24,    25,    -1,    -1,    -1,    -1,    30,    -1,
      -1,    -1,    34,    35,    -1,    37,    38,    -1,    40,    41,
      42,    43,    44,    -1,    46,    47,    -1,    49,    50,    51,
      52,    53,    -1,    -1,    56,    57,    58,    59,    60,    -1,
      62,    63,    64,    65,    66,    -1,    -1,    -1,    70,    71,
      72,    73,    -1,    75,    76,    -1,    78,    79,    80,    81,
      82,    83,    -1,    -1,    86,    87,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    95,    96,    97,    98,    99,   100,   101,
     102,   103,    -1,   105,    -1,   107,   108,   109,   110,   111,
      -1,   113,   114,   115,    -1,    -1,   118,   119,   120,   121,
     122,    -1,   124,   125,   126,    -1,   128,   129,   130,    -1,
     132,   133,   134,   135,   136,   137,   138,   139,   140,    -1,
     142,    -1,   144,   145,   146,   147,    -1,   149,    -1,   151,
      -1,    -1,    -1,   155,   156,   157,    -1,   159,   160,    -1,
     162,    -1,   164,   165,   166,   167,   168,    -1,   170,   171,
     172,    -1,   174,   175,   176,   177,   178,   179,    -1,   181,
      -1,   183,   184,   185,   186,   187,   188,   189,    -1,   191,
      -1,   193,    -1,    -1,   196,    -1,   198,   199,   200,   201,
     202,    -1,   204,   205,    -1,   207,   208,    -1,   210,    -1,
      -1,   213,   214,   215,    -1,    -1,   218,   219,   220,   221,
     222,   223,   224,   225,   226,   227,   228,   229,   230,   231,
      -1,   233,   234,   235,   236,    -1,   238,   239,    -1,   241,
      -1,   243,   244,   245,   246,   247,   248,    -1,   250,    -1,
      -1,   253,   254,   255,    -1,    -1,   258,   259,    -1,   261,
      -1,   263,   264,   265,   266,   267,   268,   269,   270,    -1,
     272,   273,   274,   275,   276,   277,   278,    -1,   280,   281,
     282,   283,   284,   285,   286,   287,   288,   289,   290,   291,
     292,    -1,   294,   295,   296,   297,   298,   299,   300,   301,
     302,   303,   304,    -1,   306,   307,    -1,   309,   310,   311,
     312,   313,   314,   315,   316,   317,   318,   319,    -1,   321,
     322,   323,   324,   325,    -1,   327,   328,   329,   330,    -1,
     332,   333,   334,    -1,   336,   337,   338,   339,   340,   341,
     342,   343,   344,   345,   346,    -1,   348,   349,    -1,   351,
     352,   353,   354,   355,   356,    -1,   358,   359,    -1,    -1,
     362,   363,   364,   365,    -1,   367,   368,   369,   370,   371,
     372,   373,    -1,    -1,   376,   377,   378,   379,   380,    -1,
      -1,   383,   384,   385,   386,   387,   388,   389,    -1,   391,
      -1,   393,   394,   395,   396,    -1,    -1,   399,    -1,    -1,
     402,   403,   404,   405,   406,   407,   408,   409,   410,   411,
     412,   413,   414,   415,   416,   417,   418,   419,     3,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    14,
      15,    16,    17,    18,    19,    20,    21,    -1,    23,    24,
      25,    -1,    -1,    -1,    -1,    30,    -1,    -1,    -1,    34,
      35,    -1,    37,    38,    -1,    40,    41,    42,    43,    44,
      -1,    46,    47,    -1,    49,    50,    51,    52,    53,    -1,
      -1,    56,    57,    58,    59,    60,    -1,    62,    63,    64,
      65,    66,    -1,    -1,    -1,    70,    71,    72,    73,    -1,
      75,    76,    -1,    78,    79,    80,    81,    82,    83,    -1,
      -1,    86,    87,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      95,    96,    97,    98,    99,   100,   101,   102,   103,    -1,
     105,    -1,   107,   108,   109,   110,   111,    -1,   113,   114,
     115,    -1,    -1,   118,   119,   120,   121,   122,    -1,   124,
     125,   126,    -1,   128,   129,   130,    -1,   132,   133,   134,
     135,   136,   137,   138,   139,   140,    -1,   142,    -1,   144,
     145,   146,   147,    -1,   149,    -1,   151,    -1,    -1,    -1,
     155,   156,   157,    -1,   159,   160,    -1,   162,    -1,   164,
     165,   166,   167,   168,    -1,   170,   171,   172,    -1,   174,
     175,   176,   177,   178,   179,    -1,   181,    -1,   183,   184,
     185,   186,   187,   188,   189,    -1,   191,    -1,   193,    -1,
      -1,   196,    -1,   198,   199,   200,   201,   202,    -1,   204,
     205,    -1,   207,   208,    -1,   210,    -1,    -1,   213,   214,
     215,    -1,    -1,   218,   219,   220,   221,   222,   223,   224,
     225,   226,   227,   228,   229,   230,   231,    -1,   233,   234,
     235,   236,    -1,   238,   239,    -1,   241,    -1,   243,   244,
     245,   246,   247,   248,    -1,   250,    -1,    -1,   253,   254,
     255,    -1,    -1,   258,   259,    -1,   261,    -1,   263,   264,
     265,   266,   267,   268,   269,   270,    -1,   272,   273,   274,
     275,   276,   277,   278,    -1,   280,   281,   282,   283,   284,
     285,   286,   287,   288,   289,   290,   291,   292,    -1,   294,
     295,   296,   297,   298,   299,   300,   301,   302,   303,   304,
      -1,   306,   307,    -1,   309,   310,   311,   312,   313,   314,
     315,   316,   317,   318,   319,    -1,   321,   322,   323,   324,
     325,    -1,   327,   328,   329,   330,    -1,   332,   333,   334,
      -1,   336,   337,   338,   339,   340,   341,   342,   343,   344,
     345,   346,    -1,   348,   349,    -1,   351,   352,   353,   354,
     355,   356,    -1,   358,   359,    -1,    -1,   362,   363,   364,
     365,    -1,   367,   368,   369,   370,   371,   372,   373,    -1,
      -1,   376,   377,   378,   379,   380,    -1,    -1,   383,   384,
     385,   386,   387,   388,   389,    -1,   391,    -1,   393,   394,
     395,   396,    -1,    -1,   399,    -1,    -1,   402,   403,   404,
     405,   406,   407,   408,   409,   410,   411,   412,   413,   414,
     415,   416,   417,   418,   419,     3,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    14,    15,    16,    17,
      18,    19,    20,    21,    -1,    23,    24,    25,    -1,    -1,
      -1,    -1,    30,    -1,    -1,    -1,    34,    35,    -1,    37,
      38,    39,    40,    41,    42,    -1,    44,    45,    46,    47,
      -1,    49,    50,    51,    52,    53,    -1,    -1,    56,    57,
      58,    59,    60,    -1,    62,    63,    64,    65,    -1,    -1,
      68,    -1,    70,    71,    72,    73,    74,    75,    76,    -1,
      78,    79,    80,    81,    82,    83,    -1,    85,    86,    87,
      -1,    -1,    -1,    91,    -1,    -1,    -1,    95,    96,    97,
      98,    99,   100,   101,   102,   103,    -1,   105,    -1,   107,
     108,   109,   110,   111,    -1,   113,   114,   115,    -1,    -1,
     118,   119,   120,   121,   122,    -1,   124,   125,   126,    -1,
     128,   129,   130,    -1,   132,   133,   134,   135,    -1,   137,
     138,   139,    -1,    -1,   142,    -1,   144,   145,   146,   147,
      -1,   149,    -1,   151,   152,    -1,   154,   155,   156,   157,
      -1,   159,    -1,    -1,   162,    -1,   164,   165,   166,   167,
     168,   169,   170,   171,   172,   173,   174,   175,   176,   177,
     178,   179,    -1,   181,   182,   183,   184,   185,   186,   187,
     188,   189,    -1,   191,    -1,   193,   194,   195,   196,   197,
     198,   199,   200,   201,   202,    -1,   204,   205,    -1,   207,
      -1,   209,   210,   211,    -1,   213,   214,   215,    -1,    -1,
     218,   219,   220,   221,   222,   223,   224,   225,   226,   227,
     228,   229,   230,   231,   232,   233,   234,   235,    -1,    -1,
     238,   239,   240,   241,    -1,    -1,   244,   245,   246,   247,
     248,    -1,   250,    -1,    -1,   253,   254,   255,    -1,    -1,
     258,   259,   260,   261,   262,    -1,   264,   265,   266,   267,
     268,   269,   270,    -1,   272,    -1,   274,    -1,   276,   277,
     278,    -1,   280,   281,   282,   283,   284,   285,   286,   287,
     288,   289,   290,   291,   292,    -1,   294,   295,   296,   297,
     298,   299,   300,   301,   302,   303,   304,    -1,   306,   307,
     308,   309,   310,    -1,   312,   313,   314,   315,   316,   317,
     318,   319,    -1,   321,   322,   323,   324,   325,    -1,   327,
     328,   329,   330,   331,   332,   333,   334,    -1,   336,   337,
     338,   339,   340,   341,   342,   343,   344,   345,    -1,    -1,
     348,   349,    -1,   351,   352,   353,   354,   355,   356,    -1,
     358,   359,    -1,    -1,   362,    -1,   364,    -1,    -1,   367,
     368,   369,   370,   371,   372,   373,    -1,    -1,   376,   377,
     378,   379,   380,    -1,    -1,   383,   384,   385,   386,   387,
      -1,   389,   390,   391,   392,   393,   394,   395,   396,    -1,
      -1,   399,    -1,    -1,   402,   403,   404,   405,   406,   407,
      -1,     3,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   417,
     418,   419,    14,    15,    16,    17,    18,    19,    20,    21,
      -1,    23,    24,    25,    -1,    -1,    -1,    -1,    30,    -1,
      -1,    -1,    34,    35,    -1,    37,    38,    39,    40,    41,
      42,    -1,    44,    45,    46,    47,    -1,    49,    50,    51,
      52,    53,    -1,    -1,    56,    57,    58,    59,    60,    -1,
      62,    63,    64,    65,    -1,    -1,    68,    -1,    70,    71,
      72,    73,    74,    75,    76,    -1,    78,    79,    80,    81,
      82,    83,    -1,    85,    86,    87,    -1,    -1,    -1,    91,
      -1,    -1,    -1,    95,    96,    97,    98,    99,   100,   101,
     102,   103,    -1,   105,    -1,   107,   108,   109,   110,   111,
      -1,   113,   114,   115,    -1,    -1,   118,   119,   120,   121,
     122,    -1,   124,   125,   126,    -1,   128,   129,   130,    -1,
     132,   133,   134,   135,    -1,   137,   138,   139,    -1,    -1,
     142,    -1,   144,   145,   146,   147,    -1,   149,    -1,   151,
     152,    -1,   154,   155,   156,   157,    -1,   159,    -1,    -1,
     162,    -1,   164,   165,   166,   167,   168,   169,   170,   171,
     172,    -1,   174,   175,   176,   177,   178,   179,    -1,   181,
     182,    -1,   184,   185,   186,   187,   188,   189,    -1,   191,
      -1,   193,   194,   195,   196,   197,   198,   199,   200,   201,
     202,    -1,   204,   205,    -1,   207,    -1,   209,   210,   211,
      -1,   213,   214,   215,    -1,    -1,   218,   219,   220,   221,
     222,   223,   224,   225,   226,   227,   228,   229,   230,   231,
     232,   233,   234,   235,    -1,    -1,   238,   239,   240,   241,
     242,    -1,   244,   245,   246,   247,   248,    -1,   250,    -1,
      -1,   253,   254,   255,    -1,    -1,   258,    -1,   260,   261,
     262,    -1,   264,   265,   266,   267,   268,   269,   270,    -1,
     272,    -1,   274,    -1,   276,   277,   278,    -1,   280,   281,
     282,   283,   284,   285,   286,   287,   288,   289,   290,   291,
     292,    -1,   294,   295,   296,   297,   298,   299,   300,   301,
     302,   303,   304,    -1,   306,   307,   308,   309,   310,    -1,
     312,   313,   314,   315,   316,   317,   318,   319,    -1,   321,
     322,   323,   324,   325,    -1,   327,   328,   329,   330,   331,
     332,   333,   334,    -1,   336,   337,   338,   339,   340,   341,
     342,   343,   344,   345,    -1,    -1,   348,   349,   350,   351,
     352,   353,   354,   355,   356,    -1,   358,   359,    -1,    -1,
     362,    -1,   364,    -1,    -1,   367,   368,   369,   370,   371,
     372,   373,    -1,    -1,   376,   377,   378,   379,   380,    -1,
      -1,   383,   384,   385,   386,   387,    -1,   389,    -1,   391,
     392,   393,   394,   395,   396,    -1,    -1,   399,    -1,    -1,
     402,   403,   404,   405,   406,   407,    -1,     3,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,   417,   418,   419,    14,    15,
      16,    17,    18,    19,    20,    21,    -1,    23,    24,    25,
      -1,    -1,    -1,    -1,    30,    -1,    -1,    -1,    34,    35,
      -1,    37,    38,    -1,    40,    41,    42,    43,    44,    -1,
      46,    47,    -1,    49,    50,    51,    52,    53,    -1,    -1,
      56,    57,    58,    59,    60,    -1,    62,    63,    64,    65,
      66,    -1,    -1,    -1,    70,    71,    72,    73,    -1,    75,
      76,    -1,    78,    79,    80,    81,    82,    83,    -1,    -1,
      86,    87,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    95,
      96,    97,    98,    99,   100,   101,   102,   103,    -1,   105,
      -1,   107,   108,   109,   110,   111,    -1,   113,   114,   115,
      -1,    -1,   118,   119,   120,   121,   122,    -1,   124,   125,
     126,    -1,   128,   129,   130,    -1,   132,   133,   134,   135,
     136,   137,   138,   139,   140,    -1,   142,    -1,   144,   145,
     146,   147,    -1,   149,    -1,   151,    -1,    -1,    -1,   155,
     156,   157,    -1,   159,   160,    -1,   162,    -1,   164,   165,
     166,   167,   168,    -1,   170,   171,   172,    -1,   174,   175,
     176,   177,   178,   179,    -1,   181,    -1,   183,   184,   185,
     186,   187,   188,   189,    -1,   191,    -1,   193,    -1,    -1,
     196,    -1,   198,   199,   200,   201,   202,    -1,   204,   205,
      -1,   207,   208,    -1,   210,    -1,    -1,   213,   214,   215,
      -1,    -1,   218,   219,   220,   221,   222,   223,   224,   225,
     226,   227,   228,   229,   230,   231,    -1,   233,   234,   235,
     236,    -1,   238,   239,    -1,   241,    -1,   243,   244,   245,
     246,   247,   248,    -1,   250,    -1,    -1,   253,   254,   255,
      -1,    -1,   258,   259,    -1,   261,    -1,   263,   264,   265,
     266,   267,    -1,   269,   270,    -1,   272,   273,   274,   275,
     276,   277,   278,    -1,   280,   281,   282,   283,   284,   285,
      -1,   287,   288,   289,   290,   291,   292,    -1,   294,   295,
     296,   297,   298,   299,   300,   301,   302,   303,   304,    -1,
     306,   307,    -1,   309,   310,   311,    -1,   313,   314,   315,
     316,   317,   318,   319,    -1,   321,   322,   323,   324,   325,
      -1,   327,   328,   329,   330,    -1,   332,   333,   334,    -1,
     336,   337,   338,   339,   340,   341,   342,   343,   344,   345,
     346,    -1,   348,   349,    -1,   351,   352,   353,   354,   355,
     356,    -1,   358,   359,    -1,    -1,   362,   363,   364,   365,
      -1,   367,   368,   369,   370,   371,   372,   373,    -1,    -1,
     376,   377,   378,   379,   380,    -1,    -1,   383,   384,   385,
     386,   387,   388,   389,    -1,   391,    -1,   393,   394,   395,
     396,    -1,    -1,   399,    -1,    -1,   402,   403,   404,   405,
     406,   407,   408,   409,   410,   411,   412,   413,   414,   415,
     416,   417,   418,   419,     3,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    14,    15,    16,    17,    18,
      19,    20,    21,    -1,    23,    24,    25,    -1,    -1,    -1,
      -1,    30,    -1,    -1,    -1,    34,    35,    -1,    37,    38,
      39,    40,    41,    42,    -1,    44,    45,    46,    47,    -1,
      49,    50,    51,    52,    53,    -1,    -1,    56,    57,    58,
      59,    60,    -1,    62,    63,    64,    65,    -1,    -1,    68,
      -1,    70,    71,    72,    73,    74,    75,    76,    -1,    78,
      79,    80,    81,    82,    83,    -1,    85,    86,    87,    -1,
      -1,    -1,    91,    -1,    -1,    -1,    95,    96,    97,    98,
      99,   100,   101,   102,   103,    -1,   105,    -1,   107,   108,
     109,   110,   111,    -1,   113,   114,   115,    -1,    -1,   118,
     119,   120,   121,   122,    -1,   124,   125,   126,    -1,   128,
     129,   130,    -1,   132,   133,   134,   135,    -1,   137,   138,
     139,    -1,    -1,   142,    -1,   144,   145,   146,   147,    -1,
     149,    -1,   151,   152,    -1,   154,   155,   156,   157,    -1,
     159,    -1,    -1,   162,    -1,   164,   165,   166,   167,   168,
     169,   170,   171,   172,    -1,   174,   175,   176,   177,   178,
     179,    -1,   181,   182,    -1,   184,   185,   186,   187,   188,
     189,    -1,   191,    -1,   193,   194,   195,   196,   197,   198,
     199,   200,   201,   202,    -1,   204,   205,    -1,   207,    -1,
     209,   210,   211,    -1,   213,   214,   215,    -1,    -1,   218,
     219,   220,   221,   222,   223,   224,   225,   226,   227,   228,
     229,   230,   231,   232,   233,   234,   235,   236,    -1,   238,
     239,   240,   241,    -1,    -1,   244,   245,   246,   247,   248,
      -1,   250,    -1,    -1,   253,   254,   255,    -1,    -1,   258,
      -1,   260,   261,   262,    -1,   264,   265,   266,   267,   268,
     269,   270,    -1,   272,    -1,   274,    -1,   276,   277,   278,
      -1,   280,   281,   282,   283,   284,   285,   286,   287,   288,
     289,   290,   291,   292,    -1,   294,   295,   296,   297,   298,
     299,   300,   301,   302,   303,   304,    -1,   306,   307,   308,
     309,   310,    -1,   312,   313,   314,   315,   316,   317,   318,
     319,    -1,   321,   322,   323,   324,   325,    -1,   327,   328,
     329,   330,   331,   332,   333,   334,    -1,   336,   337,   338,
     339,   340,   341,   342,   343,   344,   345,    -1,    -1,   348,
     349,    -1,   351,   352,   353,   354,   355,   356,    -1,   358,
     359,    -1,    -1,   362,    -1,   364,    -1,    -1,   367,   368,
     369,   370,   371,   372,   373,    -1,    -1,   376,   377,   378,
     379,   380,    -1,    -1,   383,   384,   385,   386,   387,    -1,
     389,    -1,   391,   392,   393,   394,   395,   396,    -1,    -1,
     399,    -1,    -1,   402,   403,   404,   405,   406,   407,    -1,
       3,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   417,   418,
     419,    14,    15,    16,    17,    18,    19,    20,    21,    -1,
      23,    24,    25,    -1,    -1,    -1,    -1,    30,    -1,    -1,
      -1,    34,    35,    -1,    37,    38,    39,    40,    41,    42,
      -1,    44,    45,    46,    47,    -1,    49,    50,    51,    52,
      53,    -1,    -1,    56,    57,    58,    59,    60,    -1,    62,
      63,    64,    65,    -1,    -1,    68,    -1,    70,    71,    72,
      73,    74,    75,    76,    -1,    78,    79,    80,    81,    82,
      83,    -1,    85,    86,    87,    -1,    -1,    -1,    91,    -1,
      -1,    -1,    95,    96,    97,    98,    99,   100,   101,   102,
     103,    -1,   105,    -1,   107,   108,   109,   110,   111,    -1,
     113,   114,   115,    -1,    -1,   118,   119,   120,   121,   122,
      -1,   124,   125,   126,    -1,   128,   129,   130,    -1,   132,
     133,   134,   135,    -1,   137,   138,   139,    -1,    -1,   142,
      -1,   144,   145,   146,   147,    -1,   149,    -1,   151,   152,
      -1,   154,   155,   156,   157,    -1,   159,    -1,    -1,   162,
      -1,   164,   165,   166,   167,   168,   169,   170,   171,   172,
      -1,   174,   175,   176,   177,   178,   179,    -1,   181,   182,
      -1,   184,   185,   186,   187,   188,   189,    -1,   191,    -1,
     193,   194,   195,   196,   197,   198,   199,   200,   201,   202,
      -1,   204,   205,    -1,   207,    -1,   209,   210,   211,    -1,
     213,   214,   215,    -1,    -1,   218,   219,   220,   221,   222,
     223,   224,   225,   226,   227,   228,   229,   230,   231,   232,
     233,   234,   235,   236,    -1,   238,   239,   240,   241,    -1,
      -1,   244,   245,   246,   247,   248,    -1,   250,    -1,    -1,
     253,   254,   255,    -1,    -1,   258,    -1,   260,   261,   262,
      -1,   264,   265,   266,   267,   268,   269,   270,    -1,   272,
      -1,   274,    -1,   276,   277,   278,    -1,   280,   281,   282,
     283,   284,   285,   286,   287,   288,   289,   290,   291,   292,
      -1,   294,   295,   296,   297,   298,   299,   300,   301,   302,
     303,   304,    -1,   306,   307,   308,   309,   310,    -1,   312,
     313,   314,   315,   316,   317,   318,   319,    -1,   321,   322,
     323,   324,   325,    -1,   327,   328,   329,   330,   331,   332,
     333,   334,    -1,   336,   337,   338,   339,   340,   341,   342,
     343,   344,   345,    -1,    -1,   348,   349,    -1,   351,   352,
     353,   354,   355,   356,    -1,   358,   359,    -1,    -1,   362,
      -1,   364,    -1,    -1,   367,   368,   369,   370,   371,   372,
     373,    -1,    -1,   376,   377,   378,   379,   380,    -1,    -1,
     383,   384,   385,   386,   387,    -1,   389,    -1,   391,   392,
     393,   394,   395,   396,    -1,    -1,   399,    -1,    -1,   402,
     403,   404,   405,   406,   407,    -1,     3,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,   417,   418,   419,    14,    15,    16,
      17,    18,    19,    20,    21,    -1,    23,    24,    25,    -1,
      -1,    -1,    -1,    30,    -1,    -1,    -1,    34,    35,    -1,
      37,    38,    39,    40,    41,    42,    -1,    44,    45,    46,
      47,    -1,    49,    50,    51,    52,    53,    -1,    -1,    56,
      57,    58,    59,    60,    -1,    62,    63,    64,    65,    -1,
      -1,    68,    -1,    70,    71,    72,    73,    74,    75,    76,
      -1,    78,    79,    80,    81,    82,    83,    -1,    85,    86,
      87,    -1,    -1,    -1,    91,    -1,    -1,    -1,    95,    96,
      97,    98,    99,   100,   101,   102,   103,    -1,   105,    -1,
     107,   108,   109,   110,   111,    -1,   113,   114,   115,    -1,
      -1,   118,   119,   120,   121,   122,    -1,   124,   125,   126,
      -1,   128,   129,   130,    -1,   132,   133,   134,   135,    -1,
     137,   138,   139,    -1,    -1,   142,    -1,   144,   145,   146,
     147,    -1,   149,    -1,   151,   152,    -1,   154,   155,   156,
     157,    -1,   159,    -1,    -1,   162,    -1,   164,   165,   166,
     167,   168,   169,   170,   171,   172,    -1,   174,   175,   176,
     177,   178,   179,    -1,   181,   182,    -1,   184,   185,   186,
     187,   188,   189,    -1,   191,    -1,   193,   194,   195,   196,
     197,   198,   199,   200,   201,   202,    -1,   204,   205,    -1,
     207,    -1,   209,   210,   211,    -1,   213,   214,   215,    -1,
      -1,   218,   219,   220,   221,   222,   223,   224,   225,   226,
     227,   228,   229,   230,   231,   232,   233,   234,   235,    -1,
      -1,   238,   239,   240,   241,    -1,    -1,   244,   245,   246,
     247,   248,    -1,   250,    -1,    -1,   253,   254,   255,    -1,
      -1,   258,    -1,   260,   261,   262,    -1,   264,   265,   266,
     267,   268,   269,   270,    -1,   272,    -1,   274,    -1,   276,
     277,   278,    -1,   280,   281,   282,   283,   284,   285,   286,
     287,   288,   289,   290,   291,   292,    -1,   294,   295,   296,
     297,   298,   299,   300,   301,   302,   303,   304,    -1,   306,
     307,   308,   309,   310,    -1,   312,   313,   314,   315,   316,
     317,   318,   319,    -1,   321,   322,   323,   324,   325,    -1,
     327,   328,   329,   330,   331,   332,   333,   334,    -1,   336,
     337,   338,   339,   340,   341,   342,   343,   344,   345,    -1,
      -1,   348,   349,    -1,   351,   352,   353,   354,   355,   356,
      -1,   358,   359,    -1,    -1,   362,    -1,   364,    -1,    -1,
     367,   368,   369,   370,   371,   372,   373,    -1,    -1,   376,
     377,   378,   379,   380,    -1,    -1,   383,   384,   385,   386,
     387,    -1,   389,    -1,   391,   392,   393,   394,   395,   396,
      -1,    -1,   399,    -1,    -1,   402,   403,   404,   405,   406,
     407,    -1,     3,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
     417,   418,   419,    14,    15,    16,    17,    18,    19,    20,
      21,    -1,    23,    24,    25,    -1,    -1,    -1,    -1,    30,
      -1,    -1,    -1,    34,    35,    -1,    37,    38,    39,    40,
      41,    42,    -1,    44,    45,    46,    47,    -1,    49,    50,
      51,    52,    53,    -1,    -1,    56,    57,    58,    59,    60,
      -1,    62,    63,    64,    65,    -1,    -1,    68,    -1,    70,
      71,    72,    73,    74,    75,    76,    -1,    78,    79,    80,
      81,    82,    83,    -1,    85,    86,    87,    -1,    -1,    -1,
      91,    -1,    -1,    -1,    95,    96,    97,    98,    99,   100,
     101,   102,   103,    -1,   105,    -1,   107,   108,   109,   110,
     111,    -1,   113,   114,   115,    -1,    -1,   118,   119,   120,
     121,   122,    -1,   124,   125,   126,    -1,   128,   129,   130,
      -1,   132,   133,   134,   135,    -1,   137,   138,   139,    -1,
      -1,   142,    -1,   144,   145,   146,   147,    -1,   149,    -1,
     151,   152,    -1,   154,   155,   156,   157,    -1,   159,    -1,
      -1,   162,    -1,   164,   165,   166,   167,   168,   169,   170,
     171,   172,    -1,   174,   175,   176,   177,   178,   179,    -1,
     181,   182,    -1,   184,   185,   186,   187,   188,   189,    -1,
     191,    -1,   193,   194,   195,   196,   197,   198,   199,   200,
     201,   202,    -1,   204,   205,    -1,   207,    -1,   209,   210,
     211,    -1,   213,   214,   215,    -1,    -1,   218,   219,   220,
     221,   222,   223,   224,   225,   226,   227,   228,   229,   230,
     231,   232,   233,   234,   235,    -1,    -1,   238,   239,   240,
     241,    -1,    -1,   244,   245,   246,   247,   248,    -1,   250,
      -1,    -1,   253,   254,   255,    -1,    -1,   258,    -1,   260,
     261,   262,    -1,   264,   265,   266,   267,   268,   269,   270,
      -1,   272,    -1,   274,    -1,   276,   277,   278,    -1,   280,
     281,   282,   283,   284,   285,   286,   287,   288,   289,   290,
     291,   292,    -1,   294,   295,   296,   297,   298,   299,   300,
     301,   302,   303,   304,    -1,   306,   307,   308,   309,   310,
      -1,   312,   313,   314,   315,   316,   317,   318,   319,    -1,
     321,   322,   323,   324,   325,    -1,   327,   328,   329,   330,
     331,   332,   333,   334,    -1,   336,   337,   338,   339,   340,
     341,   342,   343,   344,   345,    -1,    -1,   348,   349,    -1,
     351,   352,   353,   354,   355,   356,    -1,   358,   359,    -1,
      -1,   362,    -1,   364,    -1,    -1,   367,   368,   369,   370,
     371,   372,   373,    -1,    -1,   376,   377,   378,   379,   380,
      -1,    -1,   383,   384,   385,   386,   387,    -1,   389,    -1,
     391,   392,   393,   394,   395,   396,    -1,    -1,   399,    -1,
      -1,   402,   403,   404,   405,   406,   407,    -1,     3,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,   417,   418,   419,    14,
      15,    16,    17,    18,    19,    20,    21,    -1,    23,    24,
      25,    -1,    -1,    -1,    -1,    30,    -1,    -1,    -1,    34,
      35,    -1,    37,    38,    39,    40,    41,    42,    -1,    44,
      45,    46,    47,    -1,    49,    50,    51,    52,    53,    -1,
      -1,    56,    57,    58,    59,    60,    -1,    62,    63,    64,
      65,    -1,    -1,    68,    -1,    70,    71,    72,    73,    74,
      75,    76,    -1,    78,    79,    80,    81,    82,    83,    -1,
      85,    86,    87,    -1,    -1,    -1,    91,    -1,    -1,    -1,
      95,    96,    97,    98,    99,   100,   101,   102,   103,    -1,
     105,    -1,   107,   108,   109,   110,   111,    -1,   113,   114,
     115,    -1,    -1,   118,   119,   120,   121,   122,    -1,   124,
     125,   126,    -1,   128,   129,   130,    -1,   132,   133,   134,
     135,    -1,   137,   138,   139,    -1,    -1,   142,    -1,   144,
     145,   146,   147,    -1,   149,    -1,   151,   152,    -1,   154,
     155,   156,   157,    -1,   159,    -1,    -1,   162,    -1,   164,
     165,   166,   167,   168,   169,   170,   171,   172,    -1,   174,
     175,   176,   177,   178,   179,    -1,   181,   182,    -1,   184,
     185,   186,   187,   188,   189,    -1,   191,    -1,   193,   194,
     195,   196,   197,   198,   199,   200,   201,   202,    -1,   204,
     205,    -1,   207,    -1,   209,   210,   211,    -1,   213,   214,
     215,    -1,    -1,   218,   219,   220,   221,   222,   223,   224,
     225,   226,   227,   228,   229,   230,   231,   232,   233,   234,
     235,    -1,    -1,   238,   239,   240,   241,    -1,    -1,   244,
     245,   246,   247,   248,    -1,   250,    -1,    -1,   253,   254,
     255,    -1,    -1,   258,    -1,   260,   261,   262,    -1,   264,
     265,   266,   267,   268,   269,   270,    -1,   272,    -1,   274,
      -1,   276,   277,   278,    -1,   280,   281,   282,   283,   284,
     285,   286,   287,   288,   289,   290,   291,   292,    -1,   294,
     295,   296,   297,   298,   299,   300,   301,   302,   303,   304,
      -1,   306,   307,   308,   309,   310,    -1,   312,   313,   314,
     315,   316,   317,   318,   319,    -1,   321,   322,   323,   324,
     325,    -1,   327,    -1,   329,   330,   331,   332,   333,   334,
      -1,   336,   337,   338,   339,   340,   341,   342,   343,   344,
     345,    -1,    -1,   348,   349,    -1,   351,   352,   353,   354,
     355,   356,    -1,   358,   359,    -1,    -1,   362,    -1,   364,
      -1,    -1,   367,   368,   369,   370,   371,   372,   373,    -1,
      -1,   376,   377,   378,   379,   380,    -1,    -1,   383,   384,
     385,   386,   387,    -1,   389,    -1,   391,   392,   393,   394,
     395,   396,    -1,    -1,   399,    -1,    -1,   402,   403,   404,
     405,   406,   407,    -1,     3,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,   417,   418,   419,    14,    15,    16,    17,    18,
      19,    20,    21,    -1,    23,    24,    25,    -1,    -1,    -1,
      -1,    30,    -1,    -1,    -1,    34,    35,    -1,    37,    38,
      39,    40,    41,    42,    -1,    -1,    45,    -1,    -1,    -1,
      49,    50,    51,    52,    53,    -1,    -1,    56,    57,    -1,
      -1,    60,    -1,    62,    63,    64,    65,    -1,    -1,    68,
      -1,    70,    71,    72,    73,    74,    75,    76,    -1,    78,
      79,    80,    81,    82,    83,    -1,    85,    86,    87,    -1,
      -1,    -1,    91,    -1,    -1,    -1,    95,    96,    97,    98,
      99,   100,    -1,    -1,   103,    -1,   105,    -1,   107,   108,
     109,   110,   111,    -1,   113,   114,   115,    -1,    -1,   118,
     119,   120,   121,   122,    -1,   124,   125,   126,    -1,   128,
     129,   130,    -1,   132,   133,   134,   135,    -1,   137,   138,
     139,    -1,    -1,   142,    -1,   144,   145,    -1,   147,    -1,
     149,    -1,   151,   152,    -1,   154,   155,   156,   157,    -1,
     159,    -1,    -1,   162,    -1,   164,   165,   166,   167,   168,
     169,   170,   171,   172,    -1,   174,   175,   176,   177,   178,
     179,    -1,   181,   182,    -1,   184,   185,   186,   187,    -1,
      -1,    -1,    -1,    -1,   193,   194,   195,   196,   197,   198,
     199,   200,   201,   202,    -1,   204,   205,    -1,   207,    -1,
     209,   210,   211,    -1,   213,   214,   215,    -1,    -1,   218,
     219,   220,   221,   222,   223,   224,   225,   226,   227,   228,
     229,   230,    -1,   232,    -1,   234,   235,    -1,    -1,   238,
     239,   240,   241,    -1,    -1,   244,    -1,   246,   247,   248,
      -1,   250,    -1,    -1,   253,   254,   255,    -1,    -1,   258,
      -1,   260,   261,   262,    -1,   264,   265,   266,   267,   268,
     269,   270,    -1,   272,    -1,   274,    -1,   276,   277,   278,
      -1,   280,   281,   282,   283,   284,   285,   286,   287,    -1,
     289,   290,   291,   292,    -1,   294,   295,   296,   297,   298,
     299,   300,   301,   302,   303,   304,    -1,   306,   307,   308,
     309,   310,    -1,   312,   313,   314,   315,   316,   317,   318,
     319,    -1,   321,   322,   323,   324,   325,    -1,   327,    -1,
     329,   330,   331,   332,    -1,   334,    -1,   336,   337,   338,
     339,   340,   341,   342,   343,   344,   345,    -1,    -1,   348,
     349,    -1,   351,   352,   353,   354,   355,   356,    -1,    -1,
      -1,    -1,    -1,   362,    -1,   364,    -1,    -1,   367,   368,
     369,   370,   371,   372,   373,    -1,    -1,   376,   377,   378,
     379,   380,    -1,    -1,   383,   384,   385,   386,   387,    -1,
      -1,    -1,   391,   392,   393,   394,   395,   396,    -1,    -1,
     399,    -1,    -1,   402,   403,   404,   405,   406,   407,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   417,   418,
     419
};

/* YYSTOS[STATE-NUM] -- The (internal number of the) accessing
   symbol of state STATE-NUM.  */
static const yytype_uint16 yystos[] =
{
       0,    14,    24,    26,    27,    42,    62,    64,    65,    70,
      72,    82,    84,   100,   103,   115,   117,   121,   127,   135,
     137,   143,   158,   213,   214,   219,   228,   239,   277,   289,
     294,   295,   297,   302,   307,   310,   314,   319,   320,   327,
     330,   338,   350,   367,   377,   383,   388,   401,   437,   444,
     445,   446,   447,   453,   454,   456,   457,   458,   459,   460,
     461,   462,   464,   465,   469,   481,   486,   487,   490,   491,
     492,   504,   507,   508,   524,   561,   564,   567,   568,   569,
     576,   582,   584,   586,   587,   590,   593,   594,   598,   599,
     608,   612,   613,   614,   615,   616,   618,   619,   620,   633,
     634,   638,   640,   641,   642,   652,   654,   661,   662,   665,
     666,   667,   668,   669,   674,   676,   679,   683,   687,   688,
     698,   699,   702,   707,   718,   740,   743,   744,   745,   748,
     751,   753,   755,   758,   759,   762,   763,   764,   771,   772,
     774,   775,   776,   781,   783,   784,   788,   789,   792,   793,
     794,   795,   797,   798,   799,   800,   802,   805,   806,   811,
     817,   820,   822,   823,   828,   830,   834,   841,   845,   846,
     847,   848,   849,   850,   853,   881,   362,   404,   777,    21,
      68,    81,    98,   104,   119,   130,   138,   150,   155,   161,
     176,   201,   222,   253,   282,   309,   313,   315,   321,   324,
     349,   350,   352,   356,   364,   369,   381,   394,   583,   777,
       3,    14,    15,    16,    17,    18,    19,    20,    21,    22,
      23,    24,    25,    30,    34,    35,    37,    38,    40,    41,
      42,    43,    44,    46,    47,    49,    50,    51,    52,    53,
      56,    57,    58,    59,    60,    62,    63,    64,    65,    66,
      70,    71,    72,    73,    75,    76,    78,    79,    80,    81,
      82,    83,    86,    87,    95,    96,    97,    98,    99,   100,
     101,   102,   103,   105,   107,   108,   109,   110,   111,   113,
     114,   115,   118,   119,   120,   121,   122,   124,   125,   126,
     128,   129,   130,   132,   133,   134,   135,   136,   137,   138,
     139,   140,   142,   144,   145,   146,   147,   149,   151,   155,
     156,   157,   159,   160,   162,   164,   165,   166,   167,   168,
     170,   171,   172,   174,   175,   176,   177,   178,   179,   181,
     183,   184,   185,   186,   187,   188,   189,   191,   193,   196,
     198,   199,   200,   201,   202,   204,   205,   207,   208,   210,
     213,   214,   215,   218,   219,   220,   221,   222,   223,   224,
     225,   226,   227,   228,   229,   230,   231,   233,   234,   235,
     236,   238,   239,   241,   243,   244,   245,   246,   247,   248,
     250,   253,   254,   255,   258,   259,   261,   263,   264,   265,
     266,   267,   268,   269,   270,   272,   273,   274,   275,   276,
     277,   278,   280,   281,   282,   283,   284,   285,   286,   287,
     288,   289,   290,   291,   292,   294,   295,   296,   297,   298,
     299,   300,   301,   302,   303,   304,   306,   307,   309,   310,
     311,   312,   313,   314,   315,   316,   317,   318,   319,   321,
     322,   323,   324,   325,   327,   328,   329,   330,   332,   333,
     334,   336,   337,   338,   339,   340,   341,   342,   343,   344,
     345,   346,   348,   349,   351,   352,   353,   354,   355,   356,
     358,   359,   362,   363,   364,   365,   367,   368,   369,   370,
     371,   372,   373,   376,   377,   378,   379,   380,   383,   384,
     385,   386,   387,   388,   389,   391,   393,   394,   395,   396,
     399,   402,   403,   404,   405,   406,   407,   408,   409,   410,
     411,   412,   413,   414,   415,   416,   417,   418,   419,   842,
     998,  1011,  1015,  1016,   392,   807,   251,   278,   777,    45,
     515,   846,    21,    34,    55,    68,    77,    98,   104,   119,
     130,   138,   150,   157,   161,   215,   253,   256,   309,   315,
     324,   352,   353,   355,   356,   364,   369,   375,   378,   381,
     525,   566,   657,   708,   719,    22,   277,   998,   842,    22,
     272,   322,   353,   355,     5,   200,   749,   750,  1007,    21,
      34,    55,    68,    81,    98,   119,   130,   138,   150,   155,
     161,   176,   222,   253,   264,   309,   313,   315,   321,   324,
     350,   352,   356,   364,   369,   381,   394,   583,   670,   777,
     998,    84,   392,   437,   561,   564,   567,   806,   812,   820,
     823,   828,   834,   841,   845,     9,    15,    22,    40,   145,
     151,   153,   173,   202,   234,   280,   296,   428,   429,   684,
     685,   842,  1006,  1010,    22,    84,   293,   320,   689,   690,
     691,  1011,  1011,  1003,  1007,   350,   856,   684,  1011,   362,
     998,   264,   222,    98,   176,   349,   350,   756,   314,  1011,
      22,   325,   358,   362,   473,   482,   483,  1011,    19,   158,
     689,   690,   278,   777,  1011,   199,    22,   116,   858,    56,
      78,   215,   230,   309,   315,   325,   358,   362,   407,   470,
     471,   472,   473,    22,   325,   358,   362,   473,   362,   252,
     892,   996,  1011,   856,   430,  1011,   154,   437,   808,   437,
     991,   291,   851,   852,   998,   846,   847,   850,     0,   440,
     807,   131,   190,   257,   374,   859,   860,   846,   848,   849,
     109,   186,   380,   441,     3,    39,    45,    68,    74,    85,
      91,   152,   154,   169,   182,   194,   195,   197,   209,   211,
     232,   240,   260,   262,   308,   331,   392,  1004,  1011,  1012,
    1015,  1017,   672,  1011,   672,   999,  1011,   281,   672,   364,
     672,   998,  1011,    97,   350,   697,  1004,     3,  1008,  1013,
    1015,  1016,  1017,    22,   168,   996,   246,   394,     8,    63,
     142,   424,   425,   426,   428,   429,   430,   431,   432,   433,
     747,   958,   959,  1011,    22,  1008,   998,   998,   168,   996,
     998,   302,   327,    22,   168,   892,   998,   317,   998,   672,
      22,   220,  1008,   168,   996,   200,   106,   196,   237,   287,
     778,   779,   780,   996,  1002,  1011,    21,    55,    68,    69,
      77,    81,    98,   119,   130,   138,   150,   155,   176,   201,
     222,   253,   309,   313,   315,   321,   324,   350,   352,   356,
     364,   369,   394,   583,   677,  1007,   996,   360,  1004,   998,
     437,   672,   364,   999,   672,   364,   168,   998,    97,   350,
     353,   355,  1008,   353,   355,    63,   142,   747,   300,  1008,
     168,   466,  1011,   998,   998,   317,   998,   672,   220,  1008,
     291,   321,   350,   394,   222,    81,   176,   155,   313,   368,
     577,    22,   998,   843,   480,  1007,  1013,   750,   168,  1004,
     998,   168,   754,   168,   999,   364,    97,   350,   168,  1004,
     168,  1008,  1009,    74,   394,    63,   142,   168,   747,    49,
     168,  1009,   168,   998,   168,   998,   168,   998,   317,   168,
     998,   168,   220,  1009,   200,   168,   671,   672,   437,   821,
     525,   812,   388,   806,   813,   814,   815,  1013,   807,  1010,
     685,   686,    22,   686,  1010,   686,    22,   686,  1010,   686,
     686,   686,  1010,  1006,  1006,   842,   686,   281,   437,   437,
     544,   544,   544,   251,   360,   441,   544,   892,   893,   441,
     773,  1007,   437,   818,    49,   394,   998,   998,   996,  1011,
      39,   419,   196,   439,   254,   254,   251,   153,  1007,   360,
     148,   680,   251,     4,     6,     7,     8,    10,    31,    44,
      46,    47,    54,    55,    58,    59,    66,    68,    88,    89,
      90,    91,    92,    93,    94,   101,   102,   120,   136,   140,
     141,   146,   160,   188,   189,   191,   208,   216,   217,   231,
     233,   237,   242,   243,   245,   253,   263,   273,   288,   311,
     326,   333,   346,   358,   359,   363,   365,   366,   375,   381,
     389,   409,   410,   411,   412,   413,   414,   415,   416,   428,
     429,   430,   437,   846,   908,   911,   914,   915,   916,   918,
     919,   920,   921,   924,   925,   929,   931,   932,   933,   935,
     956,   960,   979,   984,   992,   993,   994,  1004,  1005,  1006,
    1007,  1011,  1007,    22,   488,   995,   996,   325,   470,   104,
     479,  1007,   480,  1007,    39,    60,   470,   419,   334,   779,
     254,   153,   360,   424,    39,   419,   196,   780,   437,   996,
     430,   435,   439,   985,   986,   893,   152,   154,   392,   803,
     804,   806,   152,   809,   104,   929,   989,   990,   851,   441,
     437,   810,   438,   438,   446,   996,    22,   116,   857,   857,
      49,   857,   143,   148,   212,   249,   863,   865,   866,   875,
     877,   878,   879,   859,   860,   153,   192,   892,   894,   991,
     437,   731,   986,   265,   298,   327,   439,   673,   265,   298,
     327,   265,   298,   327,   401,   448,   481,   484,   703,    18,
     121,   265,   298,   327,   385,   495,   998,   327,    18,   121,
     380,   463,   405,   168,   892,    51,    83,   139,   171,   207,
     237,   265,   298,   306,   312,   319,   327,   336,   344,   396,
     481,   485,   734,   741,   437,   720,   298,   463,   173,   136,
      18,    24,    65,   114,   121,   124,   178,   235,   237,   247,
     255,   265,   298,   301,   302,   327,   385,   493,   494,   602,
       4,   428,   429,   574,  1010,    22,   168,   996,   672,   672,
     437,   746,   439,   173,   455,   298,   448,   455,   251,   265,
     298,   136,    50,    96,   175,   223,   225,   235,   264,   298,
     303,   327,   338,   493,   571,   572,   265,   298,   393,   602,
     610,   483,   471,   473,   173,   136,   298,   327,   493,   265,
     298,   302,   327,    75,   113,   266,   354,   251,    18,    24,
     121,   265,   298,   327,   505,   506,   455,   148,   298,   448,
     455,   136,   298,   327,   493,   998,   210,   106,   252,   406,
     441,   778,   382,   801,   251,  1004,   437,   998,   364,    97,
     350,  1004,   246,   394,    63,   142,   747,   998,   317,   998,
     200,   672,   544,   284,   510,   437,   647,   731,    61,     3,
      44,    46,    47,    58,    59,   101,   102,   146,   188,   189,
     191,   231,   233,   245,   288,   328,   333,   358,   359,   389,
     905,   907,   909,   911,   913,   915,   916,   917,   919,   920,
     924,   925,  1012,  1015,   153,   437,   643,   998,   448,    32,
     796,   998,   237,   448,   405,   168,   996,   448,   672,   672,
     643,   378,   525,   448,   237,    39,   467,   369,   609,   265,
     585,    75,   113,   266,   354,    20,    41,   187,   621,    32,
     643,   148,   448,   394,   996,   168,   562,   996,   996,   394,
     672,    74,   709,  1004,   998,   583,    45,    95,   185,   235,
     316,   136,   731,    52,   304,   496,   136,   437,   136,   405,
     136,   720,   136,   441,   168,   671,   168,   672,   168,   672,
     136,   746,  1009,   136,   136,   251,   136,   496,   136,    75,
     113,   266,   354,   136,   251,   136,   148,   168,   168,   480,
     136,   441,   496,   929,   963,   350,   438,   441,   141,   251,
     366,   477,   480,   574,   816,   812,   686,   842,   686,   842,
     686,   842,   686,   842,   686,   842,   842,   842,   686,   842,
     437,   545,   546,  1011,   545,    22,    98,   119,   150,   155,
     200,   201,   315,   321,   350,   352,   369,   692,   995,  1009,
     691,   173,   441,   831,  1007,   905,   966,    32,  1009,   709,
     149,   757,   757,   757,   210,  1011,   148,   148,   692,  1009,
     314,  1011,   480,   251,   437,   987,   435,   846,   967,   391,
     922,   929,   983,   437,   922,   922,   437,   148,   437,   437,
     437,   910,   910,   275,   846,   437,   437,   912,   437,   437,
     437,   437,    58,    59,   922,   929,   437,   910,   437,   437,
     437,   437,   437,   403,   423,   437,   926,   437,   926,   437,
     437,   846,   437,   437,   437,   437,   437,   437,   437,   437,
     929,   929,   846,   929,   963,   986,  1007,    59,   437,   923,
     437,  1007,     3,     8,    11,    28,    32,    37,    43,    67,
     169,   173,   194,   195,   211,   237,   240,   253,   256,   331,
     424,   425,   426,   428,   429,   430,   431,   432,   433,   958,
     960,   962,   402,   944,   262,   929,   192,   854,   441,   437,
    1007,   986,   107,   170,   489,   441,    60,   104,   480,    32,
       3,   104,   215,   478,   574,   925,  1007,  1007,    79,   118,
     941,    87,   104,   474,   475,   477,   574,   104,   474,   210,
     996,   929,     3,    22,    26,    27,    28,    29,    31,    32,
      33,    36,    48,    54,    55,    61,    67,    69,    77,    84,
      88,    89,    90,    92,    93,    94,   104,   106,   112,   116,
     117,   123,   127,   131,   141,   143,   148,   150,   153,   158,
     161,   163,   173,   180,   190,   192,   203,   206,   212,   216,
     217,   237,   242,   249,   251,   252,   256,   257,   271,   279,
     293,   305,   320,   326,   335,   347,   350,   357,   360,   361,
     366,   374,   375,   381,   382,   390,   397,   398,   400,   401,
     430,  1001,  1014,  1015,  1016,  1017,  1018,   985,    80,   303,
     675,   438,   441,   807,   438,   441,   852,   997,   998,    32,
     810,   848,   848,   861,   862,   929,   848,   145,   234,   872,
     198,   235,   287,   329,   380,    22,   867,   929,   868,   870,
     929,   931,   875,   876,   866,   865,   863,   864,   148,   878,
     247,   880,   863,   875,   894,   996,    32,  1011,   327,   173,
     183,   257,   259,   328,   390,   430,   724,   725,   726,   728,
     730,   732,   905,  1012,   265,   298,   327,   360,   360,   315,
    1001,   439,   360,   360,   315,   360,   360,   352,   470,   790,
     148,   158,   173,   307,   704,   705,    61,    77,   132,   150,
     279,   375,   541,   542,    77,   104,   237,   360,    77,   360,
     104,   237,   315,    77,   114,   124,   265,   298,   639,   315,
     591,    21,    55,    68,    81,   119,   130,   150,   155,   222,
     253,   315,   321,   324,   350,   356,   369,   394,   583,   998,
     136,   298,   327,   493,   251,   574,   319,   207,   360,   360,
     242,   574,   108,   193,   315,   325,   362,   472,   304,   327,
     734,   742,   438,   721,   724,   360,   381,   352,   996,    69,
     132,   532,   541,  1011,    69,    77,   760,   251,   313,   364,
      77,   760,    25,   301,   313,   364,   996,   178,   247,   672,
     437,   360,   360,   167,   437,   500,   352,   401,   403,   500,
      77,   441,     4,     4,   265,   173,   136,   298,   327,   493,
     382,   382,   236,   905,   265,   327,   747,    98,   327,   484,
     360,   450,   484,   996,   360,   360,   996,   574,    49,   573,
     574,   574,    96,   223,   225,    49,   360,   448,   315,   448,
     235,   572,   360,   360,   242,  1007,   602,   352,   892,    77,
     360,   760,   315,   360,   360,   500,   500,   672,   672,   672,
     672,   996,    38,   387,    38,    38,   360,    38,   360,   315,
     441,   484,    94,   381,   617,  1008,   360,   450,   484,   996,
     360,   315,   265,   298,   287,   299,   323,   476,   778,  1002,
    1011,   996,   731,   905,   251,   405,   720,   574,   672,   672,
     746,   194,   251,    75,   113,   266,   354,   251,   672,   194,
     401,   516,   341,   342,   511,  1007,     3,   648,   649,   643,
     437,   907,    32,    31,   906,    99,   166,   224,   227,   318,
     417,   437,   927,   928,   673,   910,   672,   644,   645,  1014,
      20,   785,   905,   251,   136,   588,   998,   237,   437,   449,
     657,   382,   291,   394,   449,   136,  1008,    84,   158,   468,
     524,   568,   620,   687,   707,   781,  1007,   610,   611,   998,
     218,   672,   672,   672,   672,   247,   109,   186,   367,   380,
     622,   623,   128,   286,   437,   617,   449,   996,   570,   571,
     237,    32,   247,   437,   544,   544,   565,   996,   148,   710,
    1002,   437,   722,    32,   200,   401,   403,   844,   316,  1004,
     496,   905,   999,   168,   998,  1004,   496,  1009,  1008,   136,
     496,   136,   382,   136,   382,   747,   496,   496,  1009,   998,
     672,   998,   998,   998,   672,  1009,   617,   136,   136,   496,
     671,   672,   438,   441,   996,   812,   814,   842,   842,   842,
     842,   842,   842,   545,   438,   441,   438,   156,   322,   351,
     997,   671,    97,   324,   696,   697,   997,   246,   997,   995,
     995,   997,   671,   360,   401,   700,    16,    30,   134,   311,
     329,   832,   892,   241,   833,   438,   441,   819,   823,   828,
     834,   845,   360,   996,   690,   689,   690,   153,   159,   701,
    1011,    21,    69,    98,   119,   130,   150,   155,   201,   222,
     309,   315,   321,   350,   352,   369,   394,   583,   681,   963,
     985,   436,   963,   967,   968,   437,   397,   980,   981,   929,
     963,   437,  1006,  1006,   963,     3,    99,   166,   224,   227,
     318,   417,   969,   970,  1007,  1006,   963,   963,  1006,  1006,
     922,   922,   929,   747,   929,   971,   428,   429,   930,   931,
     956,   960,   973,   438,   963,   929,   963,   974,   358,   419,
    1006,  1006,   929,    48,   153,   206,   361,   929,   963,   977,
     963,   229,   931,   929,   939,   940,   941,   229,   929,   941,
     438,   441,   327,  1006,  1006,   927,   905,   929,  1014,   358,
      36,   347,   988,   672,   929,   437,   846,   978,   116,   118,
     141,   237,   242,   247,   366,   376,   929,    43,   169,   173,
     211,   331,   437,   929,   360,   929,   929,   929,   929,   929,
     929,   929,   929,   929,   929,    22,    29,   335,   957,   161,
     144,   945,   311,   437,   956,   157,   215,   350,   353,   355,
     378,   855,   996,   153,   882,   994,    22,   116,   390,   430,
     438,   726,   929,   964,   965,  1012,   996,   362,   437,  1007,
     441,   438,   436,   442,   167,   167,   496,   996,   804,   805,
     996,   989,   438,   441,   437,   441,    33,   112,   382,   716,
     437,   869,  1010,   329,   198,   252,   441,   311,   312,   871,
     995,   833,   876,   864,   382,   829,   104,   437,   824,   845,
    1011,   437,   835,   836,   837,   838,   839,  1011,   259,    49,
    1012,   438,   726,   728,   725,   728,  1012,   257,   438,   441,
     673,   360,   360,   315,  1008,   998,   998,  1001,  1008,   998,
     998,  1008,   999,   998,    76,   791,   309,   381,   689,   315,
     158,   689,   437,   998,   382,   711,   198,   198,   382,   437,
     560,   168,   998,   242,  1008,   998,   998,   929,   242,   998,
     998,    25,   301,   360,   360,   998,   360,   592,  1004,   437,
     672,   672,   672,   364,    97,   350,   697,   394,    63,   142,
     747,   998,   672,   998,   672,   317,   672,   672,   200,   162,
     235,   265,   298,   386,   595,   596,   597,   892,   360,   760,
     315,   242,   108,   193,  1008,   998,   251,   998,   438,   441,
    1008,  1009,   998,   298,   493,   532,   905,   998,  1011,   998,
     998,    22,   381,   998,   168,   998,   168,  1011,   313,   364,
     313,   364,   998,    22,   381,   998,   996,    18,   121,   327,
     603,   604,   605,   606,  1014,  1008,   998,   104,   154,   238,
     382,   499,   502,   503,  1014,   998,   250,    65,   250,   998,
     494,   360,   352,   996,   360,   760,   315,  1000,  1011,  1000,
     441,   438,   441,   360,   315,   999,  1008,     3,    76,   126,
     178,   270,   373,   381,   384,   451,   298,  1008,   998,   298,
     327,   493,   571,   574,   672,   998,   574,   998,   574,  1008,
     998,   998,   298,   327,   493,   998,   998,   998,   998,  1008,
     998,    18,    24,   121,   265,   298,   327,   265,   298,   327,
     643,   298,   327,   298,   327,   298,   904,  1011,   168,   653,
    1011,   168,  1011,  1008,   998,   998,   998,    18,   506,   324,
    1008,   298,   327,   493,   998,   998,   360,   360,    73,   372,
     287,   194,    32,   672,   194,   194,   382,   382,   194,   242,
     678,  1007,   672,   672,   194,   678,   250,   153,   360,   509,
     448,   424,   438,   441,   929,    31,   906,   905,   435,   435,
     360,   360,   360,   437,   360,  1006,   910,   438,   441,   424,
     622,    76,   125,   204,   205,   218,   265,   352,   354,   786,
     534,  1014,   998,   153,   315,   393,   589,   596,   597,   136,
     211,   526,   528,   530,   532,   538,   541,    19,   173,   309,
     348,   451,   452,   148,  1000,   394,   996,   466,  1011,   467,
     256,   525,   150,  1007,   643,   643,   643,   643,   247,   251,
     256,   437,   643,   902,   903,   904,   324,   437,   136,   135,
     845,   672,   526,  1011,   401,   403,   556,   401,   501,    32,
     544,  1007,   251,   438,   723,   724,   729,    32,   200,   306,
     400,   733,   734,   735,   251,   480,   165,   165,   148,   731,
      32,   136,   496,   720,   671,   672,  1000,   672,  1000,   746,
     251,   496,   496,   251,   496,   324,   148,   480,   496,   929,
     438,   546,   173,   173,   173,   405,   997,   441,   574,   575,
     161,   693,   694,  1008,    19,   701,   134,   329,   134,   329,
     134,   329,   311,   380,   226,   905,   998,   401,   563,   153,
     251,   693,    49,   496,  1004,   364,   350,  1004,   246,   394,
     200,   672,   438,   436,   436,   441,   963,   929,   123,   981,
     982,    32,   438,   929,   438,   438,   438,   438,   153,   438,
     438,   438,   438,   438,   441,   438,   271,   972,   438,   930,
     930,    11,   173,   194,   253,   424,   425,   426,   428,   429,
     430,   431,   432,   433,   960,   930,   438,   438,   148,   153,
     975,   976,   438,   419,   438,   438,    32,   977,   963,   977,
     977,   153,   438,   438,  1014,   269,   943,    32,   438,   441,
     929,  1014,   441,   929,   987,   929,  1011,   438,   438,   419,
     930,   930,   129,   963,   153,   116,   118,   141,   242,   247,
     366,   376,   437,   129,   347,   988,   929,   978,   929,   360,
     747,   929,   437,   846,   437,   437,   261,   949,   353,   355,
     353,   355,   996,   856,   856,   856,   203,   312,   437,   846,
     883,   884,   885,   892,   895,   932,   934,   935,  1004,  1011,
     398,   900,   964,   964,   965,   438,    13,   441,   859,   860,
     779,  1006,   927,   475,   929,   810,   998,   819,   862,   253,
     958,   961,   420,   421,   717,   929,   871,   380,   868,   883,
     398,   901,   388,   825,   826,  1011,   305,   827,   839,   840,
     441,   882,   424,   987,   732,   673,   728,   728,    49,   730,
     432,  1008,   998,   998,   212,  1009,  1009,   251,   997,   254,
     251,   929,   542,  1000,   437,   437,   437,   560,   176,   545,
     631,   136,   496,   360,  1008,   998,   480,   731,   905,   998,
     405,   672,   672,   672,   672,   746,    75,   113,   266,   354,
     998,   578,   998,   162,   386,   360,   360,   578,   595,   602,
     298,   327,   493,   998,   998,   998,   184,   242,   724,   264,
     327,   360,   255,   600,   631,   121,   302,   327,   495,   602,
     761,   136,   496,   136,   496,   998,   998,   998,   998,   605,
     606,   605,   438,   441,   607,  1007,   176,   438,   441,   424,
     439,  1008,   998,   298,   327,   493,   998,   998,   998,   265,
     298,   327,    18,   121,   265,   298,   327,   905,   236,   905,
    1008,   998,   212,   270,   242,  1007,   270,  1009,   379,   360,
     360,   315,   264,   327,   360,   760,   315,   360,   360,   220,
     220,   220,   360,   360,   315,   360,   360,   315,   360,   315,
     360,   315,   360,   496,   905,   237,  1007,   327,   761,   136,
     496,   360,   998,   360,   315,  1008,   998,   678,   905,   194,
     678,   678,  1000,  1000,   678,   194,   194,   678,   510,   437,
     512,   513,   253,   428,   429,   574,   646,   728,   961,  1007,
    1018,     3,   649,   438,   435,   438,  1006,   436,  1006,   166,
     224,   928,   224,   928,   928,  1006,   227,   438,   645,   646,
     251,   212,   424,   787,   787,   787,   787,   787,   787,   787,
      61,    67,    77,   104,   106,   180,   237,   242,   279,   293,
     375,   535,   536,   537,   135,   397,   448,   480,   998,   480,
     600,   996,   996,   438,   441,  1009,   161,   309,  1009,  1006,
     369,   996,   544,    39,   467,   300,   350,    97,   501,   545,
     996,   623,   650,   651,  1007,   438,   441,   998,   545,   996,
     998,   563,   437,   527,   438,   250,   500,   250,   251,   557,
     500,    32,   845,   501,   360,   996,   438,   441,   104,   424,
     736,  1007,   480,   350,   727,   728,   401,   735,   737,   109,
     186,   320,   380,   769,   162,   845,   496,   905,   998,   496,
     496,   382,   496,   382,   496,   496,   672,   672,   998,   617,
     496,   315,   315,   315,   997,   697,   441,  1008,   401,   441,
     695,   254,   134,   134,    97,   235,  1009,   692,   496,  1008,
     731,   720,   574,   672,   194,   967,   438,   357,   929,   127,
     905,   438,   929,   929,   929,   975,   905,   930,   116,   118,
     237,   247,   930,   930,   930,   930,   930,   930,   930,   930,
     930,   930,   929,   929,   976,   975,   926,   926,   905,   438,
     438,   438,   963,   438,   441,    49,   931,   438,  1014,   940,
     276,   345,   942,   438,   441,   393,   936,    32,   438,   923,
    1007,   929,    28,    28,   929,   438,   929,   153,   437,   966,
     929,   930,   930,   129,   129,   929,   438,   129,   929,   860,
     398,   437,   950,  1011,   856,   856,   856,   856,   996,   996,
     996,   846,   895,   153,   846,   884,   885,    32,   886,   887,
    1011,   441,    85,   154,   182,   197,   209,   232,   308,   889,
     887,    32,   886,   888,  1011,   422,   899,   437,   986,   929,
     161,   873,   441,   859,   859,   859,   929,   390,   965,   438,
     438,   436,   438,   437,   717,   438,   252,    87,   929,   827,
     438,   441,   987,   993,   438,   441,   836,   901,   989,   438,
     432,   732,   369,   787,   156,   322,   351,   370,   706,   148,
     706,   438,   437,   548,   549,   713,   934,  1011,   545,   545,
     631,  1002,   438,   106,   180,   235,   237,   632,   998,   998,
      32,   998,   382,   382,   672,   672,   672,   672,   673,  1008,
     998,   360,   760,   315,   360,   184,    49,   352,   998,   437,
     534,   237,   500,    97,   237,   340,   343,   500,   369,   998,
    1011,   604,   998,   503,   646,  1014,   264,   327,   360,   760,
     315,   360,   360,   360,   315,   155,   253,   343,   655,   656,
     155,   253,   663,   664,   360,   360,   315,   438,   438,   438,
    1010,  1007,  1007,  1007,   998,   998,   998,    49,   352,   998,
     998,   998,   998,   998,   148,   148,   300,   148,   168,  1008,
     998,   998,  1008,   998,   998,   998,   998,   998,   998,   998,
      67,   497,   136,    20,    41,   369,  1011,   998,   602,   998,
     998,   438,   678,   194,   194,   678,   678,   511,   519,   520,
    1014,    45,    86,   110,   125,   129,   149,   152,   164,   242,
     250,   285,   514,   631,  1006,   401,   403,   436,   436,   438,
     927,   996,   787,   104,  1006,  1007,   104,  1007,   104,  1007,
     104,  1007,   104,   998,   104,   998,   104,   998,   437,   672,
     998,   930,   107,   170,   106,   242,   198,   996,   737,   283,
     635,   636,  1011,   588,   437,   539,   324,   530,  1009,  1009,
     905,   437,   501,  1008,   996,   405,   148,   624,   438,   441,
     904,   600,   438,   247,   437,   821,   529,   531,   533,   541,
    1011,   556,   179,   555,    72,   352,   558,   845,   563,   558,
    1007,   711,   729,   929,   929,   441,   437,   733,   643,   360,
     578,   438,   496,  1000,  1000,   496,   496,   324,   997,   997,
     997,   574,   158,   694,    97,   701,   153,   194,   194,   194,
     194,   242,   682,  1007,   929,   438,   438,   976,   153,   116,
     118,   247,   437,   438,   408,   938,   963,   292,    49,   399,
     399,   438,   929,   235,   929,   441,   937,   907,   927,   930,
     930,   929,   966,   438,    28,    28,   929,   929,   129,   929,
     438,   438,   929,   951,  1011,   996,   996,   996,   996,   887,
     888,   437,   438,  1011,   437,   884,   197,   260,   890,   884,
     890,   197,   889,   890,   197,   437,  1011,   437,   964,    49,
     163,   874,   438,   438,   438,   965,  1007,  1007,   747,   247,
     845,   826,   424,   839,   827,   369,   438,  1010,   360,   689,
     153,   631,   929,   438,   441,   401,    67,   714,   714,   438,
     438,   737,   107,   170,   178,   106,   384,   496,   905,  1000,
    1000,   998,   998,   998,   998,  1009,   998,   601,   605,   242,
     242,  1010,  1011,   905,   496,   496,   424,    49,   352,   998,
     998,   998,   998,  1008,   998,   998,  1006,  1006,   905,   441,
    1006,  1006,   441,  1008,   998,   998,  1009,   998,   360,   997,
     997,   672,   997,   136,   672,  1007,  1007,   905,   496,   496,
     194,   678,   678,   382,   517,   518,   438,   441,   430,   437,
     477,   521,   574,   796,  1007,   796,   237,   242,   285,   796,
     796,   436,   155,   183,   155,   153,   630,  1010,   929,   237,
     536,   737,   544,   382,   559,  1004,    28,   135,   173,   526,
     133,   174,   998,   382,   545,    32,   467,   437,   998,   122,
     625,   397,   627,  1007,   501,   672,   526,   563,   438,   441,
     401,   557,   437,   556,   109,   121,   276,   998,   401,   782,
     153,   437,  1007,   726,   738,   739,  1012,   737,   996,   181,
     579,   496,   496,   496,   998,   254,   496,   693,   682,   682,
     682,   682,   930,   153,   437,   966,   437,   438,   441,   438,
     931,   292,   438,   387,   337,   438,   438,   438,   930,   930,
     929,   438,   268,   952,   896,   897,   934,   886,   437,   997,
     884,   251,   382,   891,   884,   197,   884,   903,   437,   903,
    1011,   859,   963,   929,   400,   946,   859,   927,   438,   842,
     991,   693,   251,   693,   438,   737,   549,   253,   747,   672,
     382,   672,   715,   715,   293,   737,   559,   438,   360,   327,
     833,   438,   441,   497,   646,  1009,   998,   360,   437,  1004,
     747,   656,   437,   437,   664,   327,   833,   998,   401,   300,
     401,   401,   148,   497,   678,   448,   111,   520,   477,   522,
     523,  1007,  1007,   242,   545,   430,   545,  1007,  1007,   697,
      32,   752,   752,   996,   631,   438,   559,   221,   547,   176,
     437,   636,   283,   437,   438,    22,    71,    78,   105,   177,
     343,   540,   540,   600,  1000,   438,   845,   600,   311,   339,
     626,   437,   135,    32,   527,   438,   531,   255,   558,   995,
     557,   312,   312,    53,    61,   215,   672,   712,   713,   728,
     438,   441,   900,   578,   235,   386,   580,   581,   496,   930,
     966,   438,   939,   963,    49,   235,   418,    49,   859,   438,
     441,    32,   898,   997,   438,   929,   437,   884,   891,   438,
     903,   438,   438,   947,   948,  1011,   438,   695,   706,   496,
     714,   559,   437,   672,   716,   716,   996,   559,   631,   998,
     352,   605,   382,   498,   327,   833,   998,   966,   720,   148,
     659,   746,   966,   966,   352,   671,   672,   671,   672,   997,
     496,   512,  1007,   438,   441,   545,   752,    35,   172,   148,
     235,   543,   154,   267,   332,   251,   551,   552,   553,   352,
     438,  1004,     5,   637,   324,   142,   658,   501,   782,   929,
     283,   845,   556,   555,   534,   438,   558,    61,   254,    61,
     438,   441,   733,   738,   117,   386,   578,   438,   438,   438,
     292,   387,   963,   286,   312,   953,   899,   896,   437,   438,
     997,   438,   441,    32,   153,   715,   398,   550,   747,   717,
     717,   544,   631,   998,   929,   352,   438,   257,   317,   290,
     660,   659,   438,   438,   998,   401,   523,   122,   178,   109,
     380,   251,   553,   251,   552,   998,   437,   438,   441,   998,
     672,    32,    32,   438,  1004,   782,   557,   556,   254,   254,
     501,   713,   737,    23,   187,   770,    43,    87,   371,   929,
     954,   955,   954,   438,   903,   438,   948,   950,   693,   716,
     437,   631,   438,   547,   833,   998,  1004,    49,   660,   833,
     672,   311,    52,   235,   304,   327,   554,   554,   438,     5,
     600,   655,   845,   437,   558,   557,   558,   238,   437,   765,
     767,   772,   823,   828,   834,   845,   955,   311,   147,   274,
     147,   274,   438,   496,   717,   929,   551,   833,   720,   672,
     627,    17,   104,   242,   782,     4,   628,   629,  1006,  1007,
    1014,   558,   900,   766,   767,   768,   846,   847,    28,   438,
     631,   135,   438,   441,   438,   440,   955,   283,   629,   768,
    1004,   437,   628,   438
};

#define yyerrok		(yyerrstatus = 0)
#define yyclearin	(yychar = YYEMPTY)
#define YYEMPTY		(-2)
#define YYEOF		0

#define YYACCEPT	goto yyacceptlab
#define YYABORT		goto yyabortlab
#define YYERROR		goto yyerrorlab


/* Like YYERROR except do call yyerror.  This remains here temporarily
   to ease the transition to the new meaning of YYERROR, for GCC.
   Once GCC version 2 has supplanted version 1, this can go.  However,
   YYFAIL appears to be in use.  Nevertheless, it is formally deprecated
   in Bison 2.4.2's NEWS entry, where a plan to phase it out is
   discussed.  */

#define YYFAIL		goto yyerrlab
#if defined YYFAIL
  /* This is here to suppress warnings from the GCC cpp's
     -Wunused-macros.  Normally we don't worry about that warning, but
     some users do, and we want to make it easy for users to remove
     YYFAIL uses, which will produce warnings from Bison 2.5.  */
#endif

#define YYRECOVERING()  (!!yyerrstatus)

#define YYBACKUP(Token, Value)                                  \
do                                                              \
  if (yychar == YYEMPTY)                                        \
    {                                                           \
      yychar = (Token);                                         \
      yylval = (Value);                                         \
      YYPOPSTACK (yylen);                                       \
      yystate = *yyssp;                                         \
      goto yybackup;                                            \
    }                                                           \
  else                                                          \
    {                                                           \
      yyerror (&yylloc, yyscanner, YY_("syntax error: cannot back up")); \
      YYERROR;							\
    }								\
while (YYID (0))

/* Error token number */
#define YYTERROR	1
#define YYERRCODE	256


/* YYLLOC_DEFAULT -- Set CURRENT to span from RHS[1] to RHS[N].
   If N is 0, then set CURRENT to the empty location which ends
   the previous symbol: RHS[0] (always defined).  */

#ifndef YYLLOC_DEFAULT
# define YYLLOC_DEFAULT(Current, Rhs, N)                                \
    do                                                                  \
      if (YYID (N))                                                     \
        {                                                               \
          (Current).first_line   = YYRHSLOC (Rhs, 1).first_line;        \
          (Current).first_column = YYRHSLOC (Rhs, 1).first_column;      \
          (Current).last_line    = YYRHSLOC (Rhs, N).last_line;         \
          (Current).last_column  = YYRHSLOC (Rhs, N).last_column;       \
        }                                                               \
      else                                                              \
        {                                                               \
          (Current).first_line   = (Current).last_line   =              \
            YYRHSLOC (Rhs, 0).last_line;                                \
          (Current).first_column = (Current).last_column =              \
            YYRHSLOC (Rhs, 0).last_column;                              \
        }                                                               \
    while (YYID (0))
#endif

#define YYRHSLOC(Rhs, K) ((Rhs)[K])


/* YY_LOCATION_PRINT -- Print the location on the stream.
   This macro was not mandated originally: define only if we know
   we won't break user code: when these are the locations we know.  */

#ifndef YY_LOCATION_PRINT
# if defined YYLTYPE_IS_TRIVIAL && YYLTYPE_IS_TRIVIAL

/* Print *YYLOCP on YYO.  Private, do not rely on its existence. */

__attribute__((__unused__))
#if (defined __STDC__ || defined __C99__FUNC__ \
     || defined __cplusplus || defined _MSC_VER)
static unsigned
yy_location_print_ (FILE *yyo, YYLTYPE const * const yylocp)
#else
static unsigned
yy_location_print_ (yyo, yylocp)
    FILE *yyo;
    YYLTYPE const * const yylocp;
#endif
{
  unsigned res = 0;
  int end_col = 0 != yylocp->last_column ? yylocp->last_column - 1 : 0;
  if (0 <= yylocp->first_line)
    {
      res += fprintf (yyo, "%d", yylocp->first_line);
      if (0 <= yylocp->first_column)
        res += fprintf (yyo, ".%d", yylocp->first_column);
    }
  if (0 <= yylocp->last_line)
    {
      if (yylocp->first_line < yylocp->last_line)
        {
          res += fprintf (yyo, "-%d", yylocp->last_line);
          if (0 <= end_col)
            res += fprintf (yyo, ".%d", end_col);
        }
      else if (0 <= end_col && yylocp->first_column < end_col)
        res += fprintf (yyo, "-%d", end_col);
    }
  return res;
 }

#  define YY_LOCATION_PRINT(File, Loc)          \
  yy_location_print_ (File, &(Loc))

# else
#  define YY_LOCATION_PRINT(File, Loc) ((void) 0)
# endif
#endif


/* YYLEX -- calling `yylex' with the right arguments.  */
#ifdef YYLEX_PARAM
# define YYLEX yylex (&yylval, &yylloc, YYLEX_PARAM)
#else
# define YYLEX yylex (&yylval, &yylloc, yyscanner)
#endif

/* Enable debugging if requested.  */
#if YYDEBUG

# ifndef YYFPRINTF
#  include <stdio.h> /* INFRINGES ON USER NAME SPACE */
#  define YYFPRINTF fprintf
# endif

# define YYDPRINTF(Args)			\
do {						\
  if (yydebug)					\
    YYFPRINTF Args;				\
} while (YYID (0))

# define YY_SYMBOL_PRINT(Title, Type, Value, Location)			  \
do {									  \
  if (yydebug)								  \
    {									  \
      YYFPRINTF (stderr, "%s ", Title);					  \
      yy_symbol_print (stderr,						  \
		  Type, Value, Location, yyscanner); \
      YYFPRINTF (stderr, "\n");						  \
    }									  \
} while (YYID (0))


/*--------------------------------.
| Print this symbol on YYOUTPUT.  |
`--------------------------------*/

/*ARGSUSED*/
#if (defined __STDC__ || defined __C99__FUNC__ \
     || defined __cplusplus || defined _MSC_VER)
static void
yy_symbol_value_print (FILE *yyoutput, int yytype, YYSTYPE const * const yyvaluep, YYLTYPE const * const yylocationp, core_yyscan_t yyscanner)
#else
static void
yy_symbol_value_print (yyoutput, yytype, yyvaluep, yylocationp, yyscanner)
    FILE *yyoutput;
    int yytype;
    YYSTYPE const * const yyvaluep;
    YYLTYPE const * const yylocationp;
    core_yyscan_t yyscanner;
#endif
{
  FILE *yyo = yyoutput;
  YYUSE (yyo);
  if (!yyvaluep)
    return;
  YYUSE (yylocationp);
  YYUSE (yyscanner);
# ifdef YYPRINT
  if (yytype < YYNTOKENS)
    YYPRINT (yyoutput, yytoknum[yytype], *yyvaluep);
# else
  YYUSE (yyoutput);
# endif
  YYUSE (yytype);
}


/*--------------------------------.
| Print this symbol on YYOUTPUT.  |
`--------------------------------*/

#if (defined __STDC__ || defined __C99__FUNC__ \
     || defined __cplusplus || defined _MSC_VER)
static void
yy_symbol_print (FILE *yyoutput, int yytype, YYSTYPE const * const yyvaluep, YYLTYPE const * const yylocationp, core_yyscan_t yyscanner)
#else
static void
yy_symbol_print (yyoutput, yytype, yyvaluep, yylocationp, yyscanner)
    FILE *yyoutput;
    int yytype;
    YYSTYPE const * const yyvaluep;
    YYLTYPE const * const yylocationp;
    core_yyscan_t yyscanner;
#endif
{
  if (yytype < YYNTOKENS)
    YYFPRINTF (yyoutput, "token %s (", yytname[yytype]);
  else
    YYFPRINTF (yyoutput, "nterm %s (", yytname[yytype]);

  YY_LOCATION_PRINT (yyoutput, *yylocationp);
  YYFPRINTF (yyoutput, ": ");
  yy_symbol_value_print (yyoutput, yytype, yyvaluep, yylocationp, yyscanner);
  YYFPRINTF (yyoutput, ")");
}

/*------------------------------------------------------------------.
| yy_stack_print -- Print the state stack from its BOTTOM up to its |
| TOP (included).                                                   |
`------------------------------------------------------------------*/

#if (defined __STDC__ || defined __C99__FUNC__ \
     || defined __cplusplus || defined _MSC_VER)
static void
yy_stack_print (yytype_int16 *yybottom, yytype_int16 *yytop)
#else
static void
yy_stack_print (yybottom, yytop)
    yytype_int16 *yybottom;
    yytype_int16 *yytop;
#endif
{
  YYFPRINTF (stderr, "Stack now");
  for (; yybottom <= yytop; yybottom++)
    {
      int yybot = *yybottom;
      YYFPRINTF (stderr, " %d", yybot);
    }
  YYFPRINTF (stderr, "\n");
}

# define YY_STACK_PRINT(Bottom, Top)				\
do {								\
  if (yydebug)							\
    yy_stack_print ((Bottom), (Top));				\
} while (YYID (0))


/*------------------------------------------------.
| Report that the YYRULE is going to be reduced.  |
`------------------------------------------------*/

#if (defined __STDC__ || defined __C99__FUNC__ \
     || defined __cplusplus || defined _MSC_VER)
static void
yy_reduce_print (YYSTYPE *yyvsp, YYLTYPE *yylsp, int yyrule, core_yyscan_t yyscanner)
#else
static void
yy_reduce_print (yyvsp, yylsp, yyrule, yyscanner)
    YYSTYPE *yyvsp;
    YYLTYPE *yylsp;
    int yyrule;
    core_yyscan_t yyscanner;
#endif
{
  int yynrhs = yyr2[yyrule];
  int yyi;
  unsigned long int yylno = yyrline[yyrule];
  YYFPRINTF (stderr, "Reducing stack by rule %d (line %lu):\n",
	     yyrule - 1, yylno);
  /* The symbols being reduced.  */
  for (yyi = 0; yyi < yynrhs; yyi++)
    {
      YYFPRINTF (stderr, "   $%d = ", yyi + 1);
      yy_symbol_print (stderr, yyrhs[yyprhs[yyrule] + yyi],
		       &(yyvsp[(yyi + 1) - (yynrhs)])
		       , &(yylsp[(yyi + 1) - (yynrhs)])		       , yyscanner);
      YYFPRINTF (stderr, "\n");
    }
}

# define YY_REDUCE_PRINT(Rule)		\
do {					\
  if (yydebug)				\
    yy_reduce_print (yyvsp, yylsp, Rule, yyscanner); \
} while (YYID (0))

/* Nonzero means print parse trace.  It is left uninitialized so that
   multiple parsers can coexist.  */
int yydebug;
#else /* !YYDEBUG */
# define YYDPRINTF(Args)
# define YY_SYMBOL_PRINT(Title, Type, Value, Location)
# define YY_STACK_PRINT(Bottom, Top)
# define YY_REDUCE_PRINT(Rule)
#endif /* !YYDEBUG */


/* YYINITDEPTH -- initial size of the parser's stacks.  */
#ifndef	YYINITDEPTH
# define YYINITDEPTH 200
#endif

/* YYMAXDEPTH -- maximum size the stacks can grow to (effective only
   if the built-in stack extension method is used).

   Do not make this value too large; the results are undefined if
   YYSTACK_ALLOC_MAXIMUM < YYSTACK_BYTES (YYMAXDEPTH)
   evaluated with infinite-precision integer arithmetic.  */

#ifndef YYMAXDEPTH
# define YYMAXDEPTH 10000
#endif


#if YYERROR_VERBOSE

# ifndef yystrlen
#  if defined __GLIBC__ && defined _STRING_H
#   define yystrlen strlen
#  else
/* Return the length of YYSTR.  */
#if (defined __STDC__ || defined __C99__FUNC__ \
     || defined __cplusplus || defined _MSC_VER)
static YYSIZE_T
yystrlen (const char *yystr)
#else
static YYSIZE_T
yystrlen (yystr)
    const char *yystr;
#endif
{
  YYSIZE_T yylen;
  for (yylen = 0; yystr[yylen]; yylen++)
    continue;
  return yylen;
}
#  endif
# endif

# ifndef yystpcpy
#  if defined __GLIBC__ && defined _STRING_H && defined _GNU_SOURCE
#   define yystpcpy stpcpy
#  else
/* Copy YYSRC to YYDEST, returning the address of the terminating '\0' in
   YYDEST.  */
#if (defined __STDC__ || defined __C99__FUNC__ \
     || defined __cplusplus || defined _MSC_VER)
static char *
yystpcpy (char *yydest, const char *yysrc)
#else
static char *
yystpcpy (yydest, yysrc)
    char *yydest;
    const char *yysrc;
#endif
{
  char *yyd = yydest;
  const char *yys = yysrc;

  while ((*yyd++ = *yys++) != '\0')
    continue;

  return yyd - 1;
}
#  endif
# endif

# ifndef yytnamerr
/* Copy to YYRES the contents of YYSTR after stripping away unnecessary
   quotes and backslashes, so that it's suitable for yyerror.  The
   heuristic is that double-quoting is unnecessary unless the string
   contains an apostrophe, a comma, or backslash (other than
   backslash-backslash).  YYSTR is taken from yytname.  If YYRES is
   null, do not copy; instead, return the length of what the result
   would have been.  */
static YYSIZE_T
yytnamerr (char *yyres, const char *yystr)
{
  if (*yystr == '"')
    {
      YYSIZE_T yyn = 0;
      char const *yyp = yystr;

      for (;;)
	switch (*++yyp)
	  {
	  case '\'':
	  case ',':
	    goto do_not_strip_quotes;

	  case '\\':
	    if (*++yyp != '\\')
	      goto do_not_strip_quotes;
	    /* Fall through.  */
	  default:
	    if (yyres)
	      yyres[yyn] = *yyp;
	    yyn++;
	    break;

	  case '"':
	    if (yyres)
	      yyres[yyn] = '\0';
	    return yyn;
	  }
    do_not_strip_quotes: ;
    }

  if (! yyres)
    return yystrlen (yystr);

  return yystpcpy (yyres, yystr) - yyres;
}
# endif

/* Copy into *YYMSG, which is of size *YYMSG_ALLOC, an error message
   about the unexpected token YYTOKEN for the state stack whose top is
   YYSSP.

   Return 0 if *YYMSG was successfully written.  Return 1 if *YYMSG is
   not large enough to hold the message.  In that case, also set
   *YYMSG_ALLOC to the required number of bytes.  Return 2 if the
   required number of bytes is too large to store.  */
static int
yysyntax_error (YYSIZE_T *yymsg_alloc, char **yymsg,
                yytype_int16 *yyssp, int yytoken)
{
  YYSIZE_T yysize0 = yytnamerr (YY_NULL, yytname[yytoken]);
  YYSIZE_T yysize = yysize0;
  enum { YYERROR_VERBOSE_ARGS_MAXIMUM = 5 };
  /* Internationalized format string. */
  const char *yyformat = YY_NULL;
  /* Arguments of yyformat. */
  char const *yyarg[YYERROR_VERBOSE_ARGS_MAXIMUM];
  /* Number of reported tokens (one for the "unexpected", one per
     "expected"). */
  int yycount = 0;

  /* There are many possibilities here to consider:
     - Assume YYFAIL is not used.  It's too flawed to consider.  See
       <http://lists.gnu.org/archive/html/bison-patches/2009-12/msg00024.html>
       for details.  YYERROR is fine as it does not invoke this
       function.
     - If this state is a consistent state with a default action, then
       the only way this function was invoked is if the default action
       is an error action.  In that case, don't check for expected
       tokens because there are none.
     - The only way there can be no lookahead present (in yychar) is if
       this state is a consistent state with a default action.  Thus,
       detecting the absence of a lookahead is sufficient to determine
       that there is no unexpected or expected token to report.  In that
       case, just report a simple "syntax error".
     - Don't assume there isn't a lookahead just because this state is a
       consistent state with a default action.  There might have been a
       previous inconsistent state, consistent state with a non-default
       action, or user semantic action that manipulated yychar.
     - Of course, the expected token list depends on states to have
       correct lookahead information, and it depends on the parser not
       to perform extra reductions after fetching a lookahead from the
       scanner and before detecting a syntax error.  Thus, state merging
       (from LALR or IELR) and default reductions corrupt the expected
       token list.  However, the list is correct for canonical LR with
       one exception: it will still contain any token that will not be
       accepted due to an error action in a later state.
  */
  if (yytoken != YYEMPTY)
    {
      int yyn = yypact[*yyssp];
      yyarg[yycount++] = yytname[yytoken];
      if (!yypact_value_is_default (yyn))
        {
          /* Start YYX at -YYN if negative to avoid negative indexes in
             YYCHECK.  In other words, skip the first -YYN actions for
             this state because they are default actions.  */
          int yyxbegin = yyn < 0 ? -yyn : 0;
          /* Stay within bounds of both yycheck and yytname.  */
          int yychecklim = YYLAST - yyn + 1;
          int yyxend = yychecklim < YYNTOKENS ? yychecklim : YYNTOKENS;
          int yyx;

          for (yyx = yyxbegin; yyx < yyxend; ++yyx)
            if (yycheck[yyx + yyn] == yyx && yyx != YYTERROR
                && !yytable_value_is_error (yytable[yyx + yyn]))
              {
                if (yycount == YYERROR_VERBOSE_ARGS_MAXIMUM)
                  {
                    yycount = 1;
                    yysize = yysize0;
                    break;
                  }
                yyarg[yycount++] = yytname[yyx];
                {
                  YYSIZE_T yysize1 = yysize + yytnamerr (YY_NULL, yytname[yyx]);
                  if (! (yysize <= yysize1
                         && yysize1 <= YYSTACK_ALLOC_MAXIMUM))
                    return 2;
                  yysize = yysize1;
                }
              }
        }
    }

  switch (yycount)
    {
# define YYCASE_(N, S)                      \
      case N:                               \
        yyformat = S;                       \
      break
      YYCASE_(0, YY_("syntax error"));
      YYCASE_(1, YY_("syntax error, unexpected %s"));
      YYCASE_(2, YY_("syntax error, unexpected %s, expecting %s"));
      YYCASE_(3, YY_("syntax error, unexpected %s, expecting %s or %s"));
      YYCASE_(4, YY_("syntax error, unexpected %s, expecting %s or %s or %s"));
      YYCASE_(5, YY_("syntax error, unexpected %s, expecting %s or %s or %s or %s"));
# undef YYCASE_
    }

  {
    YYSIZE_T yysize1 = yysize + yystrlen (yyformat);
    if (! (yysize <= yysize1 && yysize1 <= YYSTACK_ALLOC_MAXIMUM))
      return 2;
    yysize = yysize1;
  }

  if (*yymsg_alloc < yysize)
    {
      *yymsg_alloc = 2 * yysize;
      if (! (yysize <= *yymsg_alloc
             && *yymsg_alloc <= YYSTACK_ALLOC_MAXIMUM))
        *yymsg_alloc = YYSTACK_ALLOC_MAXIMUM;
      return 1;
    }

  /* Avoid sprintf, as that infringes on the user's name space.
     Don't have undefined behavior even if the translation
     produced a string with the wrong number of "%s"s.  */
  {
    char *yyp = *yymsg;
    int yyi = 0;
    while ((*yyp = *yyformat) != '\0')
      if (*yyp == '%' && yyformat[1] == 's' && yyi < yycount)
        {
          yyp += yytnamerr (yyp, yyarg[yyi++]);
          yyformat += 2;
        }
      else
        {
          yyp++;
          yyformat++;
        }
  }
  return 0;
}
#endif /* YYERROR_VERBOSE */

/*-----------------------------------------------.
| Release the memory associated to this symbol.  |
`-----------------------------------------------*/

/*ARGSUSED*/
#if (defined __STDC__ || defined __C99__FUNC__ \
     || defined __cplusplus || defined _MSC_VER)
static void
yydestruct (const char *yymsg, int yytype, YYSTYPE *yyvaluep, YYLTYPE *yylocationp, core_yyscan_t yyscanner)
#else
static void
yydestruct (yymsg, yytype, yyvaluep, yylocationp, yyscanner)
    const char *yymsg;
    int yytype;
    YYSTYPE *yyvaluep;
    YYLTYPE *yylocationp;
    core_yyscan_t yyscanner;
#endif
{
  YYUSE (yyvaluep);
  YYUSE (yylocationp);
  YYUSE (yyscanner);

  if (!yymsg)
    yymsg = "Deleting";
  YY_SYMBOL_PRINT (yymsg, yytype, yyvaluep, yylocationp);

  YYUSE (yytype);
}




/*----------.
| yyparse.  |
`----------*/

#ifdef YYPARSE_PARAM
#if (defined __STDC__ || defined __C99__FUNC__ \
     || defined __cplusplus || defined _MSC_VER)
int
yyparse (void *YYPARSE_PARAM)
#else
int
yyparse (YYPARSE_PARAM)
    void *YYPARSE_PARAM;
#endif
#else /* ! YYPARSE_PARAM */
#if (defined __STDC__ || defined __C99__FUNC__ \
     || defined __cplusplus || defined _MSC_VER)
int
yyparse (core_yyscan_t yyscanner)
#else
int
yyparse (yyscanner)
    core_yyscan_t yyscanner;
#endif
#endif
{
/* The lookahead symbol.  */
int yychar;


#if defined __GNUC__ && 407 <= __GNUC__ * 100 + __GNUC_MINOR__
/* Suppress an incorrect diagnostic about yylval being uninitialized.  */
# define YY_IGNORE_MAYBE_UNINITIALIZED_BEGIN \
    _Pragma ("GCC diagnostic push") \
    _Pragma ("GCC diagnostic ignored \"-Wuninitialized\"")\
    _Pragma ("GCC diagnostic ignored \"-Wmaybe-uninitialized\"")
# define YY_IGNORE_MAYBE_UNINITIALIZED_END \
    _Pragma ("GCC diagnostic pop")
#else
/* Default value used for initialization, for pacifying older GCCs
   or non-GCC compilers.  */
static YYSTYPE yyval_default;
# define YY_INITIAL_VALUE(Value) = Value
#endif
static YYLTYPE yyloc_default
# if defined YYLTYPE_IS_TRIVIAL && YYLTYPE_IS_TRIVIAL
  = { 1, 1, 1, 1 }
# endif
;
#ifndef YY_IGNORE_MAYBE_UNINITIALIZED_BEGIN
# define YY_IGNORE_MAYBE_UNINITIALIZED_BEGIN
# define YY_IGNORE_MAYBE_UNINITIALIZED_END
#endif
#ifndef YY_INITIAL_VALUE
# define YY_INITIAL_VALUE(Value) /* Nothing. */
#endif

/* The semantic value of the lookahead symbol.  */
YYSTYPE yylval YY_INITIAL_VALUE(yyval_default);

/* Location data for the lookahead symbol.  */
YYLTYPE yylloc = yyloc_default;


    /* Number of syntax errors so far.  */
    int yynerrs;

    int yystate;
    /* Number of tokens to shift before error messages enabled.  */
    int yyerrstatus;

    /* The stacks and their tools:
       `yyss': related to states.
       `yyvs': related to semantic values.
       `yyls': related to locations.

       Refer to the stacks through separate pointers, to allow yyoverflow
       to reallocate them elsewhere.  */

    /* The state stack.  */
    yytype_int16 yyssa[YYINITDEPTH];
    yytype_int16 *yyss;
    yytype_int16 *yyssp;

    /* The semantic value stack.  */
    YYSTYPE yyvsa[YYINITDEPTH];
    YYSTYPE *yyvs;
    YYSTYPE *yyvsp;

    /* The location stack.  */
    YYLTYPE yylsa[YYINITDEPTH];
    YYLTYPE *yyls;
    YYLTYPE *yylsp;

    /* The locations where the error started and ended.  */
    YYLTYPE yyerror_range[3];

    YYSIZE_T yystacksize;

  int yyn;
  int yyresult;
  /* Lookahead token as an internal (translated) token number.  */
  int yytoken = 0;
  /* The variables used to return semantic value and location from the
     action routines.  */
  YYSTYPE yyval;
  YYLTYPE yyloc;

#if YYERROR_VERBOSE
  /* Buffer for error messages, and its allocated size.  */
  char yymsgbuf[128];
  char *yymsg = yymsgbuf;
  YYSIZE_T yymsg_alloc = sizeof yymsgbuf;
#endif

#define YYPOPSTACK(N)   (yyvsp -= (N), yyssp -= (N), yylsp -= (N))

  /* The number of symbols on the RHS of the reduced rule.
     Keep to zero when no symbol should be popped.  */
  int yylen = 0;

  yyssp = yyss = yyssa;
  yyvsp = yyvs = yyvsa;
  yylsp = yyls = yylsa;
  yystacksize = YYINITDEPTH;

  YYDPRINTF ((stderr, "Starting parse\n"));

  yystate = 0;
  yyerrstatus = 0;
  yynerrs = 0;
  yychar = YYEMPTY; /* Cause a token to be read.  */
  yylsp[0] = yylloc;
  goto yysetstate;

/*------------------------------------------------------------.
| yynewstate -- Push a new state, which is found in yystate.  |
`------------------------------------------------------------*/
 yynewstate:
  /* In all cases, when you get here, the value and location stacks
     have just been pushed.  So pushing a state here evens the stacks.  */
  yyssp++;

 yysetstate:
  *yyssp = yystate;

  if (yyss + yystacksize - 1 <= yyssp)
    {
      /* Get the current used size of the three stacks, in elements.  */
      YYSIZE_T yysize = yyssp - yyss + 1;

#ifdef yyoverflow
      {
	/* Give user a chance to reallocate the stack.  Use copies of
	   these so that the &'s don't force the real ones into
	   memory.  */
	YYSTYPE *yyvs1 = yyvs;
	yytype_int16 *yyss1 = yyss;
	YYLTYPE *yyls1 = yyls;

	/* Each stack pointer address is followed by the size of the
	   data in use in that stack, in bytes.  This used to be a
	   conditional around just the two extra args, but that might
	   be undefined if yyoverflow is a macro.  */
	yyoverflow (YY_("memory exhausted"),
		    &yyss1, yysize * sizeof (*yyssp),
		    &yyvs1, yysize * sizeof (*yyvsp),
		    &yyls1, yysize * sizeof (*yylsp),
		    &yystacksize);

	yyls = yyls1;
	yyss = yyss1;
	yyvs = yyvs1;
      }
#else /* no yyoverflow */
# ifndef YYSTACK_RELOCATE
      goto yyexhaustedlab;
# else
      /* Extend the stack our own way.  */
      if (YYMAXDEPTH <= yystacksize)
	goto yyexhaustedlab;
      yystacksize *= 2;
      if (YYMAXDEPTH < yystacksize)
	yystacksize = YYMAXDEPTH;

      {
	yytype_int16 *yyss1 = yyss;
	union yyalloc *yyptr =
	  (union yyalloc *) YYSTACK_ALLOC (YYSTACK_BYTES (yystacksize));
	if (! yyptr)
	  goto yyexhaustedlab;
	YYSTACK_RELOCATE (yyss_alloc, yyss);
	YYSTACK_RELOCATE (yyvs_alloc, yyvs);
	YYSTACK_RELOCATE (yyls_alloc, yyls);
#  undef YYSTACK_RELOCATE
	if (yyss1 != yyssa)
	  YYSTACK_FREE (yyss1);
      }
# endif
#endif /* no yyoverflow */

      yyssp = yyss + yysize - 1;
      yyvsp = yyvs + yysize - 1;
      yylsp = yyls + yysize - 1;

      YYDPRINTF ((stderr, "Stack size increased to %lu\n",
		  (unsigned long int) yystacksize));

      if (yyss + yystacksize - 1 <= yyssp)
	YYABORT;
    }

  YYDPRINTF ((stderr, "Entering state %d\n", yystate));

  if (yystate == YYFINAL)
    YYACCEPT;

  goto yybackup;

/*-----------.
| yybackup.  |
`-----------*/
yybackup:

  /* Do appropriate processing given the current state.  Read a
     lookahead token if we need one and don't already have one.  */

  /* First try to decide what to do without reference to lookahead token.  */
  yyn = yypact[yystate];
  if (yypact_value_is_default (yyn))
    goto yydefault;

  /* Not known => get a lookahead token if don't already have one.  */

  /* YYCHAR is either YYEMPTY or YYEOF or a valid lookahead symbol.  */
  if (yychar == YYEMPTY)
    {
      YYDPRINTF ((stderr, "Reading a token: "));
      yychar = YYLEX;
    }

  if (yychar <= YYEOF)
    {
      yychar = yytoken = YYEOF;
      YYDPRINTF ((stderr, "Now at end of input.\n"));
    }
  else
    {
      yytoken = YYTRANSLATE (yychar);
      YY_SYMBOL_PRINT ("Next token is", yytoken, &yylval, &yylloc);
    }

  /* If the proper action on seeing token YYTOKEN is to reduce or to
     detect an error, take that action.  */
  yyn += yytoken;
  if (yyn < 0 || YYLAST < yyn || yycheck[yyn] != yytoken)
    goto yydefault;
  yyn = yytable[yyn];
  if (yyn <= 0)
    {
      if (yytable_value_is_error (yyn))
        goto yyerrlab;
      yyn = -yyn;
      goto yyreduce;
    }

  /* Count tokens shifted since error; after three, turn off error
     status.  */
  if (yyerrstatus)
    yyerrstatus--;

  /* Shift the lookahead token.  */
  YY_SYMBOL_PRINT ("Shifting", yytoken, &yylval, &yylloc);

  /* Discard the shifted token.  */
  yychar = YYEMPTY;

  yystate = yyn;
  YY_IGNORE_MAYBE_UNINITIALIZED_BEGIN
  *++yyvsp = yylval;
  YY_IGNORE_MAYBE_UNINITIALIZED_END
  *++yylsp = yylloc;
  goto yynewstate;


/*-----------------------------------------------------------.
| yydefault -- do the default action for the current state.  |
`-----------------------------------------------------------*/
yydefault:
  yyn = yydefact[yystate];
  if (yyn == 0)
    goto yyerrlab;
  goto yyreduce;


/*-----------------------------.
| yyreduce -- Do a reduction.  |
`-----------------------------*/
yyreduce:
  /* yyn is the number of a rule to reduce with.  */
  yylen = yyr2[yyn];

  /* If YYLEN is nonzero, implement the default value of the action:
     `$$ = $1'.

     Otherwise, the following line sets YYVAL to garbage.
     This behavior is undocumented and Bison
     users should not rely upon it.  Assigning to YYVAL
     unconditionally makes the parser a bit smaller, and it avoids a
     GCC warning that YYVAL may be used uninitialized.  */
  yyval = yyvsp[1-yylen];

  /* Default location.  */
  YYLLOC_DEFAULT (yyloc, (yylsp - yylen), yylen);
  YY_REDUCE_PRINT (yyn);
  switch (yyn)
    {
        case 2:
/* Line 1787 of yacc.c  */
#line 691 "gram.y"
    {
				pg_yyget_extra(yyscanner)->parsetree = (yyvsp[(1) - (1)].list);
			}
    break;

  case 3:
/* Line 1787 of yacc.c  */
#line 698 "gram.y"
    {
					if ((yyvsp[(3) - (3)].node) != NULL)
						(yyval.list) = lappend((yyvsp[(1) - (3)].list), (yyvsp[(3) - (3)].node));
					else
						(yyval.list) = (yyvsp[(1) - (3)].list);
				}
    break;

  case 4:
/* Line 1787 of yacc.c  */
#line 705 "gram.y"
    {
					if ((yyvsp[(1) - (1)].node) != NULL)
						(yyval.list) = list_make1((yyvsp[(1) - (1)].node));
					else
						(yyval.list) = NIL;
				}
    break;

  case 121:
/* Line 1787 of yacc.c  */
#line 831 "gram.y"
    { (yyval.node) = NULL; }
    break;

  case 122:
/* Line 1787 of yacc.c  */
#line 842 "gram.y"
    {
					CreateRoleStmt *n = makeNode(CreateRoleStmt);
					n->stmt_type = ROLESTMT_ROLE;
					n->role = (yyvsp[(3) - (5)].str);
					n->options = (yyvsp[(5) - (5)].list);
					(yyval.node) = (Node *)n;
				}
    break;

  case 123:
/* Line 1787 of yacc.c  */
#line 852 "gram.y"
    {}
    break;

  case 124:
/* Line 1787 of yacc.c  */
#line 853 "gram.y"
    {}
    break;

  case 125:
/* Line 1787 of yacc.c  */
#line 862 "gram.y"
    { (yyval.list) = lappend((yyvsp[(1) - (2)].list), (yyvsp[(2) - (2)].defelt)); }
    break;

  case 126:
/* Line 1787 of yacc.c  */
#line 863 "gram.y"
    { (yyval.list) = NIL; }
    break;

  case 127:
/* Line 1787 of yacc.c  */
#line 867 "gram.y"
    { (yyval.list) = lappend((yyvsp[(1) - (2)].list), (yyvsp[(2) - (2)].defelt)); }
    break;

  case 128:
/* Line 1787 of yacc.c  */
#line 868 "gram.y"
    { (yyval.list) = NIL; }
    break;

  case 129:
/* Line 1787 of yacc.c  */
#line 873 "gram.y"
    {
					(yyval.defelt) = makeDefElem("password",
									 (Node *)makeString((yyvsp[(2) - (2)].str)));
				}
    break;

  case 130:
/* Line 1787 of yacc.c  */
#line 878 "gram.y"
    {
					(yyval.defelt) = makeDefElem("password", NULL);
				}
    break;

  case 131:
/* Line 1787 of yacc.c  */
#line 882 "gram.y"
    {
					(yyval.defelt) = makeDefElem("encryptedPassword",
									 (Node *)makeString((yyvsp[(3) - (3)].str)));
				}
    break;

  case 132:
/* Line 1787 of yacc.c  */
#line 887 "gram.y"
    {
					(yyval.defelt) = makeDefElem("unencryptedPassword",
									 (Node *)makeString((yyvsp[(3) - (3)].str)));
				}
    break;

  case 133:
/* Line 1787 of yacc.c  */
#line 892 "gram.y"
    {
					(yyval.defelt) = makeDefElem("inherit", (Node *)makeInteger(TRUE));
				}
    break;

  case 134:
/* Line 1787 of yacc.c  */
#line 896 "gram.y"
    {
					(yyval.defelt) = makeDefElem("connectionlimit", (Node *)makeInteger((yyvsp[(3) - (3)].ival)));
				}
    break;

  case 135:
/* Line 1787 of yacc.c  */
#line 900 "gram.y"
    {
					(yyval.defelt) = makeDefElem("validUntil", (Node *)makeString((yyvsp[(3) - (3)].str)));
				}
    break;

  case 136:
/* Line 1787 of yacc.c  */
#line 905 "gram.y"
    {
					(yyval.defelt) = makeDefElem("rolemembers", (Node *)(yyvsp[(2) - (2)].list));
				}
    break;

  case 137:
/* Line 1787 of yacc.c  */
#line 909 "gram.y"
    {
					/*
					 * We handle identifiers that aren't parser keywords with
					 * the following special-case codes, to avoid bloating the
					 * size of the main parser.
					 */
					if (strcmp((yyvsp[(1) - (1)].str), "superuser") == 0)
						(yyval.defelt) = makeDefElem("superuser", (Node *)makeInteger(TRUE));
					else if (strcmp((yyvsp[(1) - (1)].str), "nosuperuser") == 0)
						(yyval.defelt) = makeDefElem("superuser", (Node *)makeInteger(FALSE));
					else if (strcmp((yyvsp[(1) - (1)].str), "createuser") == 0)
					{
						/* For backwards compatibility, synonym for SUPERUSER */
						(yyval.defelt) = makeDefElem("superuser", (Node *)makeInteger(TRUE));
					}
					else if (strcmp((yyvsp[(1) - (1)].str), "nocreateuser") == 0)
					{
						/* For backwards compatibility, synonym for SUPERUSER */
						(yyval.defelt) = makeDefElem("superuser", (Node *)makeInteger(FALSE));
					}
					else if (strcmp((yyvsp[(1) - (1)].str), "createrole") == 0)
						(yyval.defelt) = makeDefElem("createrole", (Node *)makeInteger(TRUE));
					else if (strcmp((yyvsp[(1) - (1)].str), "nocreaterole") == 0)
						(yyval.defelt) = makeDefElem("createrole", (Node *)makeInteger(FALSE));
					else if (strcmp((yyvsp[(1) - (1)].str), "replication") == 0)
						(yyval.defelt) = makeDefElem("isreplication", (Node *)makeInteger(TRUE));
					else if (strcmp((yyvsp[(1) - (1)].str), "noreplication") == 0)
						(yyval.defelt) = makeDefElem("isreplication", (Node *)makeInteger(FALSE));
					else if (strcmp((yyvsp[(1) - (1)].str), "createdb") == 0)
						(yyval.defelt) = makeDefElem("createdb", (Node *)makeInteger(TRUE));
					else if (strcmp((yyvsp[(1) - (1)].str), "nocreatedb") == 0)
						(yyval.defelt) = makeDefElem("createdb", (Node *)makeInteger(FALSE));
					else if (strcmp((yyvsp[(1) - (1)].str), "login") == 0)
						(yyval.defelt) = makeDefElem("canlogin", (Node *)makeInteger(TRUE));
					else if (strcmp((yyvsp[(1) - (1)].str), "nologin") == 0)
						(yyval.defelt) = makeDefElem("canlogin", (Node *)makeInteger(FALSE));
					else if (strcmp((yyvsp[(1) - (1)].str), "noinherit") == 0)
					{
						/*
						 * Note that INHERIT is a keyword, so it's handled by main parser, but
						 * NOINHERIT is handled here.
						 */
						(yyval.defelt) = makeDefElem("inherit", (Node *)makeInteger(FALSE));
					}
					else
						ereport(ERROR,
								(errcode(ERRCODE_SYNTAX_ERROR),
								 errmsg("unrecognized role option \"%s\"", (yyvsp[(1) - (1)].str)),
									 parser_errposition((yylsp[(1) - (1)]))));
				}
    break;

  case 138:
/* Line 1787 of yacc.c  */
#line 962 "gram.y"
    { (yyval.defelt) = (yyvsp[(1) - (1)].defelt); }
    break;

  case 139:
/* Line 1787 of yacc.c  */
#line 965 "gram.y"
    {
					(yyval.defelt) = makeDefElem("sysid", (Node *)makeInteger((yyvsp[(2) - (2)].ival)));
				}
    break;

  case 140:
/* Line 1787 of yacc.c  */
#line 969 "gram.y"
    {
					(yyval.defelt) = makeDefElem("adminmembers", (Node *)(yyvsp[(2) - (2)].list));
				}
    break;

  case 141:
/* Line 1787 of yacc.c  */
#line 973 "gram.y"
    {
					(yyval.defelt) = makeDefElem("rolemembers", (Node *)(yyvsp[(2) - (2)].list));
				}
    break;

  case 142:
/* Line 1787 of yacc.c  */
#line 977 "gram.y"
    {
					(yyval.defelt) = makeDefElem("addroleto", (Node *)(yyvsp[(3) - (3)].list));
				}
    break;

  case 143:
/* Line 1787 of yacc.c  */
#line 981 "gram.y"
    {
					(yyval.defelt) = makeDefElem("addroleto", (Node *)(yyvsp[(3) - (3)].list));
				}
    break;

  case 144:
/* Line 1787 of yacc.c  */
#line 995 "gram.y"
    {
					CreateRoleStmt *n = makeNode(CreateRoleStmt);
					n->stmt_type = ROLESTMT_USER;
					n->role = (yyvsp[(3) - (5)].str);
					n->options = (yyvsp[(5) - (5)].list);
					(yyval.node) = (Node *)n;
				}
    break;

  case 145:
/* Line 1787 of yacc.c  */
#line 1013 "gram.y"
    {
					AlterRoleStmt *n = makeNode(AlterRoleStmt);
					n->role = (yyvsp[(3) - (5)].str);
					n->action = +1;	/* add, if there are members */
					n->options = (yyvsp[(5) - (5)].list);
					(yyval.node) = (Node *)n;
				 }
    break;

  case 146:
/* Line 1787 of yacc.c  */
#line 1023 "gram.y"
    { (yyval.str) = NULL; }
    break;

  case 147:
/* Line 1787 of yacc.c  */
#line 1024 "gram.y"
    { (yyval.str) = (yyvsp[(3) - (3)].str); }
    break;

  case 148:
/* Line 1787 of yacc.c  */
#line 1029 "gram.y"
    {
					AlterRoleSetStmt *n = makeNode(AlterRoleSetStmt);
					n->role = (yyvsp[(3) - (5)].str);
					n->database = (yyvsp[(4) - (5)].str);
					n->setstmt = (yyvsp[(5) - (5)].vsetstmt);
					(yyval.node) = (Node *)n;
				}
    break;

  case 149:
/* Line 1787 of yacc.c  */
#line 1037 "gram.y"
    {
					AlterRoleSetStmt *n = makeNode(AlterRoleSetStmt);
					n->role = NULL;
					n->database = (yyvsp[(4) - (5)].str);
					n->setstmt = (yyvsp[(5) - (5)].vsetstmt);
					(yyval.node) = (Node *)n;
				}
    break;

  case 150:
/* Line 1787 of yacc.c  */
#line 1055 "gram.y"
    {
					AlterRoleStmt *n = makeNode(AlterRoleStmt);
					n->role = (yyvsp[(3) - (5)].str);
					n->action = +1;	/* add, if there are members */
					n->options = (yyvsp[(5) - (5)].list);
					(yyval.node) = (Node *)n;
				 }
    break;

  case 151:
/* Line 1787 of yacc.c  */
#line 1067 "gram.y"
    {
					AlterRoleSetStmt *n = makeNode(AlterRoleSetStmt);
					n->role = (yyvsp[(3) - (5)].str);
					n->database = (yyvsp[(4) - (5)].str);
					n->setstmt = (yyvsp[(5) - (5)].vsetstmt);
					(yyval.node) = (Node *)n;
				}
    break;

  case 152:
/* Line 1787 of yacc.c  */
#line 1075 "gram.y"
    {
					AlterRoleSetStmt *n = makeNode(AlterRoleSetStmt);
					n->role = NULL;
					n->database = (yyvsp[(4) - (5)].str);
					n->setstmt = (yyvsp[(5) - (5)].vsetstmt);
					(yyval.node) = (Node *)n;
				}
    break;

  case 153:
/* Line 1787 of yacc.c  */
#line 1096 "gram.y"
    {
					DropRoleStmt *n = makeNode(DropRoleStmt);
					n->missing_ok = FALSE;
					n->roles = (yyvsp[(3) - (3)].list);
					(yyval.node) = (Node *)n;
				}
    break;

  case 154:
/* Line 1787 of yacc.c  */
#line 1103 "gram.y"
    {
					DropRoleStmt *n = makeNode(DropRoleStmt);
					n->missing_ok = TRUE;
					n->roles = (yyvsp[(5) - (5)].list);
					(yyval.node) = (Node *)n;
				}
    break;

  case 155:
/* Line 1787 of yacc.c  */
#line 1122 "gram.y"
    {
					DropRoleStmt *n = makeNode(DropRoleStmt);
					n->missing_ok = FALSE;
					n->roles = (yyvsp[(3) - (3)].list);
					(yyval.node) = (Node *)n;
				}
    break;

  case 156:
/* Line 1787 of yacc.c  */
#line 1129 "gram.y"
    {
					DropRoleStmt *n = makeNode(DropRoleStmt);
					n->roles = (yyvsp[(5) - (5)].list);
					n->missing_ok = TRUE;
					(yyval.node) = (Node *)n;
				}
    break;

  case 157:
/* Line 1787 of yacc.c  */
#line 1146 "gram.y"
    {
					CreateRoleStmt *n = makeNode(CreateRoleStmt);
					n->stmt_type = ROLESTMT_GROUP;
					n->role = (yyvsp[(3) - (5)].str);
					n->options = (yyvsp[(5) - (5)].list);
					(yyval.node) = (Node *)n;
				}
    break;

  case 158:
/* Line 1787 of yacc.c  */
#line 1164 "gram.y"
    {
					AlterRoleStmt *n = makeNode(AlterRoleStmt);
					n->role = (yyvsp[(3) - (6)].str);
					n->action = (yyvsp[(4) - (6)].ival);
					n->options = list_make1(makeDefElem("rolemembers",
														(Node *)(yyvsp[(6) - (6)].list)));
					(yyval.node) = (Node *)n;
				}
    break;

  case 159:
/* Line 1787 of yacc.c  */
#line 1174 "gram.y"
    { (yyval.ival) = +1; }
    break;

  case 160:
/* Line 1787 of yacc.c  */
#line 1175 "gram.y"
    { (yyval.ival) = -1; }
    break;

  case 161:
/* Line 1787 of yacc.c  */
#line 1188 "gram.y"
    {
					DropRoleStmt *n = makeNode(DropRoleStmt);
					n->missing_ok = FALSE;
					n->roles = (yyvsp[(3) - (3)].list);
					(yyval.node) = (Node *)n;
				}
    break;

  case 162:
/* Line 1787 of yacc.c  */
#line 1195 "gram.y"
    {
					DropRoleStmt *n = makeNode(DropRoleStmt);
					n->missing_ok = TRUE;
					n->roles = (yyvsp[(5) - (5)].list);
					(yyval.node) = (Node *)n;
				}
    break;

  case 163:
/* Line 1787 of yacc.c  */
#line 1212 "gram.y"
    {
					CreateSchemaStmt *n = makeNode(CreateSchemaStmt);
					/* One can omit the schema name or the authorization id. */
					if ((yyvsp[(3) - (6)].str) != NULL)
						n->schemaname = (yyvsp[(3) - (6)].str);
					else
						n->schemaname = (yyvsp[(5) - (6)].str);
					n->authid = (yyvsp[(5) - (6)].str);
					n->schemaElts = (yyvsp[(6) - (6)].list);
					n->if_not_exists = false;
					(yyval.node) = (Node *)n;
				}
    break;

  case 164:
/* Line 1787 of yacc.c  */
#line 1225 "gram.y"
    {
					CreateSchemaStmt *n = makeNode(CreateSchemaStmt);
					/* ...but not both */
					n->schemaname = (yyvsp[(3) - (4)].str);
					n->authid = NULL;
					n->schemaElts = (yyvsp[(4) - (4)].list);
					n->if_not_exists = false;
					(yyval.node) = (Node *)n;
				}
    break;

  case 165:
/* Line 1787 of yacc.c  */
#line 1235 "gram.y"
    {
					CreateSchemaStmt *n = makeNode(CreateSchemaStmt);
					/* One can omit the schema name or the authorization id. */
					if ((yyvsp[(6) - (9)].str) != NULL)
						n->schemaname = (yyvsp[(6) - (9)].str);
					else
						n->schemaname = (yyvsp[(8) - (9)].str);
					n->authid = (yyvsp[(8) - (9)].str);
					if ((yyvsp[(9) - (9)].list) != NIL)
						ereport(ERROR,
								(errcode(ERRCODE_FEATURE_NOT_SUPPORTED),
								 errmsg("CREATE SCHEMA IF NOT EXISTS cannot include schema elements"),
								 parser_errposition((yylsp[(9) - (9)]))));
					n->schemaElts = (yyvsp[(9) - (9)].list);
					n->if_not_exists = true;
					(yyval.node) = (Node *)n;
				}
    break;

  case 166:
/* Line 1787 of yacc.c  */
#line 1253 "gram.y"
    {
					CreateSchemaStmt *n = makeNode(CreateSchemaStmt);
					/* ...but not both */
					n->schemaname = (yyvsp[(6) - (7)].str);
					n->authid = NULL;
					if ((yyvsp[(7) - (7)].list) != NIL)
						ereport(ERROR,
								(errcode(ERRCODE_FEATURE_NOT_SUPPORTED),
								 errmsg("CREATE SCHEMA IF NOT EXISTS cannot include schema elements"),
								 parser_errposition((yylsp[(7) - (7)]))));
					n->schemaElts = (yyvsp[(7) - (7)].list);
					n->if_not_exists = true;
					(yyval.node) = (Node *)n;
				}
    break;

  case 167:
/* Line 1787 of yacc.c  */
#line 1270 "gram.y"
    { (yyval.str) = (yyvsp[(1) - (1)].str); }
    break;

  case 168:
/* Line 1787 of yacc.c  */
#line 1271 "gram.y"
    { (yyval.str) = NULL; }
    break;

  case 169:
/* Line 1787 of yacc.c  */
#line 1276 "gram.y"
    {
					if ((yyloc) < 0)			/* see comments for YYLLOC_DEFAULT */
						(yyloc) = (yylsp[(2) - (2)]);
					(yyval.list) = lappend((yyvsp[(1) - (2)].list), (yyvsp[(2) - (2)].node));
				}
    break;

  case 170:
/* Line 1787 of yacc.c  */
#line 1282 "gram.y"
    { (yyval.list) = NIL; }
    break;

  case 177:
/* Line 1787 of yacc.c  */
#line 1310 "gram.y"
    {
					VariableSetStmt *n = (yyvsp[(2) - (2)].vsetstmt);
					n->is_local = false;
					(yyval.node) = (Node *) n;
				}
    break;

  case 178:
/* Line 1787 of yacc.c  */
#line 1316 "gram.y"
    {
					VariableSetStmt *n = (yyvsp[(3) - (3)].vsetstmt);
					n->is_local = true;
					(yyval.node) = (Node *) n;
				}
    break;

  case 179:
/* Line 1787 of yacc.c  */
#line 1322 "gram.y"
    {
					VariableSetStmt *n = (yyvsp[(3) - (3)].vsetstmt);
					n->is_local = false;
					(yyval.node) = (Node *) n;
				}
    break;

  case 180:
/* Line 1787 of yacc.c  */
#line 1331 "gram.y"
    {
					VariableSetStmt *n = makeNode(VariableSetStmt);
					n->kind = VAR_SET_MULTI;
					n->name = "TRANSACTION";
					n->args = (yyvsp[(2) - (2)].list);
					(yyval.vsetstmt) = n;
				}
    break;

  case 181:
/* Line 1787 of yacc.c  */
#line 1339 "gram.y"
    {
					VariableSetStmt *n = makeNode(VariableSetStmt);
					n->kind = VAR_SET_MULTI;
					n->name = "SESSION CHARACTERISTICS";
					n->args = (yyvsp[(5) - (5)].list);
					(yyval.vsetstmt) = n;
				}
    break;

  case 183:
/* Line 1787 of yacc.c  */
#line 1351 "gram.y"
    {
					VariableSetStmt *n = makeNode(VariableSetStmt);
					n->kind = VAR_SET_VALUE;
					n->name = (yyvsp[(1) - (3)].str);
					n->args = (yyvsp[(3) - (3)].list);
					(yyval.vsetstmt) = n;
				}
    break;

  case 184:
/* Line 1787 of yacc.c  */
#line 1359 "gram.y"
    {
					VariableSetStmt *n = makeNode(VariableSetStmt);
					n->kind = VAR_SET_VALUE;
					n->name = (yyvsp[(1) - (3)].str);
					n->args = (yyvsp[(3) - (3)].list);
					(yyval.vsetstmt) = n;
				}
    break;

  case 185:
/* Line 1787 of yacc.c  */
#line 1367 "gram.y"
    {
					VariableSetStmt *n = makeNode(VariableSetStmt);
					n->kind = VAR_SET_DEFAULT;
					n->name = (yyvsp[(1) - (3)].str);
					(yyval.vsetstmt) = n;
				}
    break;

  case 186:
/* Line 1787 of yacc.c  */
#line 1374 "gram.y"
    {
					VariableSetStmt *n = makeNode(VariableSetStmt);
					n->kind = VAR_SET_DEFAULT;
					n->name = (yyvsp[(1) - (3)].str);
					(yyval.vsetstmt) = n;
				}
    break;

  case 187:
/* Line 1787 of yacc.c  */
#line 1382 "gram.y"
    {(yyval.vsetstmt) = (yyvsp[(1) - (1)].vsetstmt);}
    break;

  case 188:
/* Line 1787 of yacc.c  */
#line 1384 "gram.y"
    {
					VariableSetStmt *n = makeNode(VariableSetStmt);
					n->kind = VAR_SET_CURRENT;
					n->name = (yyvsp[(1) - (3)].str);
					(yyval.vsetstmt) = n;
				}
    break;

  case 189:
/* Line 1787 of yacc.c  */
#line 1392 "gram.y"
    {
					VariableSetStmt *n = makeNode(VariableSetStmt);
					n->kind = VAR_SET_VALUE;
					n->name = "timezone";
					if ((yyvsp[(3) - (3)].node) != NULL)
						n->args = list_make1((yyvsp[(3) - (3)].node));
					else
						n->kind = VAR_SET_DEFAULT;
					(yyval.vsetstmt) = n;
				}
    break;

  case 190:
/* Line 1787 of yacc.c  */
#line 1403 "gram.y"
    {
					ereport(ERROR,
							(errcode(ERRCODE_FEATURE_NOT_SUPPORTED),
							 errmsg("current database cannot be changed"),
							 parser_errposition((yylsp[(2) - (2)]))));
					(yyval.vsetstmt) = NULL; /*not reached*/
				}
    break;

  case 191:
/* Line 1787 of yacc.c  */
#line 1411 "gram.y"
    {
					VariableSetStmt *n = makeNode(VariableSetStmt);
					n->kind = VAR_SET_VALUE;
					n->name = "search_path";
					n->args = list_make1(makeStringConst((yyvsp[(2) - (2)].str), (yylsp[(2) - (2)])));
					(yyval.vsetstmt) = n;
				}
    break;

  case 192:
/* Line 1787 of yacc.c  */
#line 1419 "gram.y"
    {
					VariableSetStmt *n = makeNode(VariableSetStmt);
					n->kind = VAR_SET_VALUE;
					n->name = "client_encoding";
					if ((yyvsp[(2) - (2)].str) != NULL)
						n->args = list_make1(makeStringConst((yyvsp[(2) - (2)].str), (yylsp[(2) - (2)])));
					else
						n->kind = VAR_SET_DEFAULT;
					(yyval.vsetstmt) = n;
				}
    break;

  case 193:
/* Line 1787 of yacc.c  */
#line 1430 "gram.y"
    {
					VariableSetStmt *n = makeNode(VariableSetStmt);
					n->kind = VAR_SET_VALUE;
					n->name = "role";
					n->args = list_make1(makeStringConst((yyvsp[(2) - (2)].str), (yylsp[(2) - (2)])));
					(yyval.vsetstmt) = n;
				}
    break;

  case 194:
/* Line 1787 of yacc.c  */
#line 1438 "gram.y"
    {
					VariableSetStmt *n = makeNode(VariableSetStmt);
					n->kind = VAR_SET_VALUE;
					n->name = "session_authorization";
					n->args = list_make1(makeStringConst((yyvsp[(3) - (3)].str), (yylsp[(3) - (3)])));
					(yyval.vsetstmt) = n;
				}
    break;

  case 195:
/* Line 1787 of yacc.c  */
#line 1446 "gram.y"
    {
					VariableSetStmt *n = makeNode(VariableSetStmt);
					n->kind = VAR_SET_DEFAULT;
					n->name = "session_authorization";
					(yyval.vsetstmt) = n;
				}
    break;

  case 196:
/* Line 1787 of yacc.c  */
#line 1453 "gram.y"
    {
					VariableSetStmt *n = makeNode(VariableSetStmt);
					n->kind = VAR_SET_VALUE;
					n->name = "xmloption";
					n->args = list_make1(makeStringConst((yyvsp[(3) - (3)].ival) == XMLOPTION_DOCUMENT ? "DOCUMENT" : "CONTENT", (yylsp[(3) - (3)])));
					(yyval.vsetstmt) = n;
				}
    break;

  case 197:
/* Line 1787 of yacc.c  */
#line 1462 "gram.y"
    {
					VariableSetStmt *n = makeNode(VariableSetStmt);
					n->kind = VAR_SET_MULTI;
					n->name = "TRANSACTION SNAPSHOT";
					n->args = list_make1(makeStringConst((yyvsp[(3) - (3)].str), (yylsp[(3) - (3)])));
					(yyval.vsetstmt) = n;
				}
    break;

  case 198:
/* Line 1787 of yacc.c  */
#line 1471 "gram.y"
    { (yyval.str) = (yyvsp[(1) - (1)].str); }
    break;

  case 199:
/* Line 1787 of yacc.c  */
#line 1473 "gram.y"
    { (yyval.str) = psprintf("%s.%s", (yyvsp[(1) - (3)].str), (yyvsp[(3) - (3)].str)); }
    break;

  case 200:
/* Line 1787 of yacc.c  */
#line 1476 "gram.y"
    { (yyval.list) = list_make1((yyvsp[(1) - (1)].node)); }
    break;

  case 201:
/* Line 1787 of yacc.c  */
#line 1477 "gram.y"
    { (yyval.list) = lappend((yyvsp[(1) - (3)].list), (yyvsp[(3) - (3)].node)); }
    break;

  case 202:
/* Line 1787 of yacc.c  */
#line 1481 "gram.y"
    { (yyval.node) = makeStringConst((yyvsp[(1) - (1)].str), (yylsp[(1) - (1)])); }
    break;

  case 203:
/* Line 1787 of yacc.c  */
#line 1483 "gram.y"
    { (yyval.node) = makeAConst((yyvsp[(1) - (1)].value), (yylsp[(1) - (1)])); }
    break;

  case 204:
/* Line 1787 of yacc.c  */
#line 1486 "gram.y"
    { (yyval.str) = "read uncommitted"; }
    break;

  case 205:
/* Line 1787 of yacc.c  */
#line 1487 "gram.y"
    { (yyval.str) = "read committed"; }
    break;

  case 206:
/* Line 1787 of yacc.c  */
#line 1488 "gram.y"
    { (yyval.str) = "repeatable read"; }
    break;

  case 207:
/* Line 1787 of yacc.c  */
#line 1489 "gram.y"
    { (yyval.str) = "serializable"; }
    break;

  case 208:
/* Line 1787 of yacc.c  */
#line 1493 "gram.y"
    { (yyval.str) = "true"; }
    break;

  case 209:
/* Line 1787 of yacc.c  */
#line 1494 "gram.y"
    { (yyval.str) = "false"; }
    break;

  case 210:
/* Line 1787 of yacc.c  */
#line 1495 "gram.y"
    { (yyval.str) = "on"; }
    break;

  case 211:
/* Line 1787 of yacc.c  */
#line 1501 "gram.y"
    { (yyval.str) = (yyvsp[(1) - (1)].str); }
    break;

  case 212:
/* Line 1787 of yacc.c  */
#line 1514 "gram.y"
    {
					(yyval.node) = makeStringConst((yyvsp[(1) - (1)].str), (yylsp[(1) - (1)]));
				}
    break;

  case 213:
/* Line 1787 of yacc.c  */
#line 1518 "gram.y"
    {
					(yyval.node) = makeStringConst((yyvsp[(1) - (1)].str), (yylsp[(1) - (1)]));
				}
    break;

  case 214:
/* Line 1787 of yacc.c  */
#line 1522 "gram.y"
    {
					TypeName *t = (yyvsp[(1) - (3)].typnam);
					if ((yyvsp[(3) - (3)].list) != NIL)
					{
						A_Const *n = (A_Const *) linitial((yyvsp[(3) - (3)].list));
						if ((n->val.val.ival & ~(INTERVAL_MASK(HOUR) | INTERVAL_MASK(MINUTE))) != 0)
							ereport(ERROR,
									(errcode(ERRCODE_SYNTAX_ERROR),
									 errmsg("time zone interval must be HOUR or HOUR TO MINUTE"),
									 parser_errposition((yylsp[(3) - (3)]))));
					}
					t->typmods = (yyvsp[(3) - (3)].list);
					(yyval.node) = makeStringConstCast((yyvsp[(2) - (3)].str), (yylsp[(2) - (3)]), t);
				}
    break;

  case 215:
/* Line 1787 of yacc.c  */
#line 1537 "gram.y"
    {
					TypeName *t = (yyvsp[(1) - (6)].typnam);
					if ((yyvsp[(6) - (6)].list) != NIL)
					{
						A_Const *n = (A_Const *) linitial((yyvsp[(6) - (6)].list));
						if ((n->val.val.ival & ~(INTERVAL_MASK(HOUR) | INTERVAL_MASK(MINUTE))) != 0)
							ereport(ERROR,
									(errcode(ERRCODE_SYNTAX_ERROR),
									 errmsg("time zone interval must be HOUR or HOUR TO MINUTE"),
									 parser_errposition((yylsp[(6) - (6)]))));
						if (list_length((yyvsp[(6) - (6)].list)) != 1)
							ereport(ERROR,
									(errcode(ERRCODE_SYNTAX_ERROR),
									 errmsg("interval precision specified twice"),
									 parser_errposition((yylsp[(1) - (6)]))));
						t->typmods = lappend((yyvsp[(6) - (6)].list), makeIntConst((yyvsp[(3) - (6)].ival), (yylsp[(3) - (6)])));
					}
					else
						t->typmods = list_make2(makeIntConst(INTERVAL_FULL_RANGE, -1),
												makeIntConst((yyvsp[(3) - (6)].ival), (yylsp[(3) - (6)])));
					(yyval.node) = makeStringConstCast((yyvsp[(5) - (6)].str), (yylsp[(5) - (6)]), t);
				}
    break;

  case 216:
/* Line 1787 of yacc.c  */
#line 1559 "gram.y"
    { (yyval.node) = makeAConst((yyvsp[(1) - (1)].value), (yylsp[(1) - (1)])); }
    break;

  case 217:
/* Line 1787 of yacc.c  */
#line 1560 "gram.y"
    { (yyval.node) = NULL; }
    break;

  case 218:
/* Line 1787 of yacc.c  */
#line 1561 "gram.y"
    { (yyval.node) = NULL; }
    break;

  case 219:
/* Line 1787 of yacc.c  */
#line 1565 "gram.y"
    { (yyval.str) = (yyvsp[(1) - (1)].str); }
    break;

  case 220:
/* Line 1787 of yacc.c  */
#line 1566 "gram.y"
    { (yyval.str) = NULL; }
    break;

  case 221:
/* Line 1787 of yacc.c  */
#line 1567 "gram.y"
    { (yyval.str) = NULL; }
    break;

  case 222:
/* Line 1787 of yacc.c  */
#line 1571 "gram.y"
    { (yyval.str) = (yyvsp[(1) - (1)].str); }
    break;

  case 223:
/* Line 1787 of yacc.c  */
#line 1572 "gram.y"
    { (yyval.str) = (yyvsp[(1) - (1)].str); }
    break;

  case 224:
/* Line 1787 of yacc.c  */
#line 1576 "gram.y"
    { (yyval.node) = (Node *) (yyvsp[(2) - (2)].vsetstmt); }
    break;

  case 225:
/* Line 1787 of yacc.c  */
#line 1580 "gram.y"
    { (yyval.vsetstmt) = (yyvsp[(1) - (1)].vsetstmt); }
    break;

  case 226:
/* Line 1787 of yacc.c  */
#line 1582 "gram.y"
    {
					VariableSetStmt *n = makeNode(VariableSetStmt);
					n->kind = VAR_RESET;
					n->name = "timezone";
					(yyval.vsetstmt) = n;
				}
    break;

  case 227:
/* Line 1787 of yacc.c  */
#line 1589 "gram.y"
    {
					VariableSetStmt *n = makeNode(VariableSetStmt);
					n->kind = VAR_RESET;
					n->name = "transaction_isolation";
					(yyval.vsetstmt) = n;
				}
    break;

  case 228:
/* Line 1787 of yacc.c  */
#line 1596 "gram.y"
    {
					VariableSetStmt *n = makeNode(VariableSetStmt);
					n->kind = VAR_RESET;
					n->name = "session_authorization";
					(yyval.vsetstmt) = n;
				}
    break;

  case 229:
/* Line 1787 of yacc.c  */
#line 1606 "gram.y"
    {
					VariableSetStmt *n = makeNode(VariableSetStmt);
					n->kind = VAR_RESET;
					n->name = (yyvsp[(1) - (1)].str);
					(yyval.vsetstmt) = n;
				}
    break;

  case 230:
/* Line 1787 of yacc.c  */
#line 1613 "gram.y"
    {
					VariableSetStmt *n = makeNode(VariableSetStmt);
					n->kind = VAR_RESET_ALL;
					(yyval.vsetstmt) = n;
				}
    break;

  case 231:
/* Line 1787 of yacc.c  */
#line 1622 "gram.y"
    { (yyval.vsetstmt) = (yyvsp[(2) - (2)].vsetstmt); }
    break;

  case 232:
/* Line 1787 of yacc.c  */
#line 1623 "gram.y"
    { (yyval.vsetstmt) = (VariableSetStmt *) (yyvsp[(1) - (1)].node); }
    break;

  case 233:
/* Line 1787 of yacc.c  */
#line 1628 "gram.y"
    { (yyval.vsetstmt) = (yyvsp[(2) - (2)].vsetstmt); }
    break;

  case 234:
/* Line 1787 of yacc.c  */
#line 1629 "gram.y"
    { (yyval.vsetstmt) = (VariableSetStmt *) (yyvsp[(1) - (1)].node); }
    break;

  case 235:
/* Line 1787 of yacc.c  */
#line 1635 "gram.y"
    {
					VariableShowStmt *n = makeNode(VariableShowStmt);
					n->name = (yyvsp[(2) - (2)].str);
					(yyval.node) = (Node *) n;
				}
    break;

  case 236:
/* Line 1787 of yacc.c  */
#line 1641 "gram.y"
    {
					VariableShowStmt *n = makeNode(VariableShowStmt);
					n->name = "timezone";
					(yyval.node) = (Node *) n;
				}
    break;

  case 237:
/* Line 1787 of yacc.c  */
#line 1647 "gram.y"
    {
					VariableShowStmt *n = makeNode(VariableShowStmt);
					n->name = "transaction_isolation";
					(yyval.node) = (Node *) n;
				}
    break;

  case 238:
/* Line 1787 of yacc.c  */
#line 1653 "gram.y"
    {
					VariableShowStmt *n = makeNode(VariableShowStmt);
					n->name = "session_authorization";
					(yyval.node) = (Node *) n;
				}
    break;

  case 239:
/* Line 1787 of yacc.c  */
#line 1659 "gram.y"
    {
					VariableShowStmt *n = makeNode(VariableShowStmt);
					n->name = "all";
					(yyval.node) = (Node *) n;
				}
    break;

  case 240:
/* Line 1787 of yacc.c  */
#line 1669 "gram.y"
    {
					ConstraintsSetStmt *n = makeNode(ConstraintsSetStmt);
					n->constraints = (yyvsp[(3) - (4)].list);
					n->deferred = (yyvsp[(4) - (4)].boolean);
					(yyval.node) = (Node *) n;
				}
    break;

  case 241:
/* Line 1787 of yacc.c  */
#line 1678 "gram.y"
    { (yyval.list) = NIL; }
    break;

  case 242:
/* Line 1787 of yacc.c  */
#line 1679 "gram.y"
    { (yyval.list) = (yyvsp[(1) - (1)].list); }
    break;

  case 243:
/* Line 1787 of yacc.c  */
#line 1683 "gram.y"
    { (yyval.boolean) = TRUE; }
    break;

  case 244:
/* Line 1787 of yacc.c  */
#line 1684 "gram.y"
    { (yyval.boolean) = FALSE; }
    break;

  case 245:
/* Line 1787 of yacc.c  */
#line 1693 "gram.y"
    {
					CheckPointStmt *n = makeNode(CheckPointStmt);
					(yyval.node) = (Node *)n;
				}
    break;

  case 246:
/* Line 1787 of yacc.c  */
#line 1708 "gram.y"
    {
					DiscardStmt *n = makeNode(DiscardStmt);
					n->target = DISCARD_ALL;
					(yyval.node) = (Node *) n;
				}
    break;

  case 247:
/* Line 1787 of yacc.c  */
#line 1714 "gram.y"
    {
					DiscardStmt *n = makeNode(DiscardStmt);
					n->target = DISCARD_TEMP;
					(yyval.node) = (Node *) n;
				}
    break;

  case 248:
/* Line 1787 of yacc.c  */
#line 1720 "gram.y"
    {
					DiscardStmt *n = makeNode(DiscardStmt);
					n->target = DISCARD_TEMP;
					(yyval.node) = (Node *) n;
				}
    break;

  case 249:
/* Line 1787 of yacc.c  */
#line 1726 "gram.y"
    {
					DiscardStmt *n = makeNode(DiscardStmt);
					n->target = DISCARD_PLANS;
					(yyval.node) = (Node *) n;
				}
    break;

  case 250:
/* Line 1787 of yacc.c  */
#line 1732 "gram.y"
    {
					DiscardStmt *n = makeNode(DiscardStmt);
					n->target = DISCARD_SEQUENCES;
					(yyval.node) = (Node *) n;
				}
    break;

  case 251:
/* Line 1787 of yacc.c  */
#line 1751 "gram.y"
    {
					AlterTableStmt *n = makeNode(AlterTableStmt);
					n->relation = (yyvsp[(3) - (4)].range);
					n->cmds = (yyvsp[(4) - (4)].list);
					n->relkind = OBJECT_TABLE;
					n->missing_ok = false;
					(yyval.node) = (Node *)n;
				}
    break;

  case 252:
/* Line 1787 of yacc.c  */
#line 1760 "gram.y"
    {
					AlterTableStmt *n = makeNode(AlterTableStmt);
					n->relation = (yyvsp[(5) - (6)].range);
					n->cmds = (yyvsp[(6) - (6)].list);
					n->relkind = OBJECT_TABLE;
					n->missing_ok = true;
					(yyval.node) = (Node *)n;
				}
    break;

  case 253:
/* Line 1787 of yacc.c  */
#line 1769 "gram.y"
    {
					AlterTableMoveAllStmt *n =
						makeNode(AlterTableMoveAllStmt);
					n->orig_tablespacename = (yyvsp[(6) - (10)].str);
					n->objtype = OBJECT_TABLE;
					n->roles = NIL;
					n->new_tablespacename = (yyvsp[(9) - (10)].str);
					n->nowait = (yyvsp[(10) - (10)].boolean);
					(yyval.node) = (Node *)n;
				}
    break;

  case 254:
/* Line 1787 of yacc.c  */
#line 1780 "gram.y"
    {
					AlterTableMoveAllStmt *n =
						makeNode(AlterTableMoveAllStmt);
					n->orig_tablespacename = (yyvsp[(6) - (13)].str);
					n->objtype = OBJECT_TABLE;
					n->roles = (yyvsp[(9) - (13)].list);
					n->new_tablespacename = (yyvsp[(12) - (13)].str);
					n->nowait = (yyvsp[(13) - (13)].boolean);
					(yyval.node) = (Node *)n;
				}
    break;

  case 255:
/* Line 1787 of yacc.c  */
#line 1791 "gram.y"
    {
					AlterTableStmt *n = makeNode(AlterTableStmt);
					n->relation = (yyvsp[(3) - (4)].range);
					n->cmds = (yyvsp[(4) - (4)].list);
					n->relkind = OBJECT_INDEX;
					n->missing_ok = false;
					(yyval.node) = (Node *)n;
				}
    break;

  case 256:
/* Line 1787 of yacc.c  */
#line 1800 "gram.y"
    {
					AlterTableStmt *n = makeNode(AlterTableStmt);
					n->relation = (yyvsp[(5) - (6)].range);
					n->cmds = (yyvsp[(6) - (6)].list);
					n->relkind = OBJECT_INDEX;
					n->missing_ok = true;
					(yyval.node) = (Node *)n;
				}
    break;

  case 257:
/* Line 1787 of yacc.c  */
#line 1809 "gram.y"
    {
					AlterTableMoveAllStmt *n =
						makeNode(AlterTableMoveAllStmt);
					n->orig_tablespacename = (yyvsp[(6) - (10)].str);
					n->objtype = OBJECT_INDEX;
					n->roles = NIL;
					n->new_tablespacename = (yyvsp[(9) - (10)].str);
					n->nowait = (yyvsp[(10) - (10)].boolean);
					(yyval.node) = (Node *)n;
				}
    break;

  case 258:
/* Line 1787 of yacc.c  */
#line 1820 "gram.y"
    {
					AlterTableMoveAllStmt *n =
						makeNode(AlterTableMoveAllStmt);
					n->orig_tablespacename = (yyvsp[(6) - (13)].str);
					n->objtype = OBJECT_INDEX;
					n->roles = (yyvsp[(9) - (13)].list);
					n->new_tablespacename = (yyvsp[(12) - (13)].str);
					n->nowait = (yyvsp[(13) - (13)].boolean);
					(yyval.node) = (Node *)n;
				}
    break;

  case 259:
/* Line 1787 of yacc.c  */
#line 1831 "gram.y"
    {
					AlterTableStmt *n = makeNode(AlterTableStmt);
					n->relation = (yyvsp[(3) - (4)].range);
					n->cmds = (yyvsp[(4) - (4)].list);
					n->relkind = OBJECT_SEQUENCE;
					n->missing_ok = false;
					(yyval.node) = (Node *)n;
				}
    break;

  case 260:
/* Line 1787 of yacc.c  */
#line 1840 "gram.y"
    {
					AlterTableStmt *n = makeNode(AlterTableStmt);
					n->relation = (yyvsp[(5) - (6)].range);
					n->cmds = (yyvsp[(6) - (6)].list);
					n->relkind = OBJECT_SEQUENCE;
					n->missing_ok = true;
					(yyval.node) = (Node *)n;
				}
    break;

  case 261:
/* Line 1787 of yacc.c  */
#line 1849 "gram.y"
    {
					AlterTableStmt *n = makeNode(AlterTableStmt);
					n->relation = (yyvsp[(3) - (4)].range);
					n->cmds = (yyvsp[(4) - (4)].list);
					n->relkind = OBJECT_VIEW;
					n->missing_ok = false;
					(yyval.node) = (Node *)n;
				}
    break;

  case 262:
/* Line 1787 of yacc.c  */
#line 1858 "gram.y"
    {
					AlterTableStmt *n = makeNode(AlterTableStmt);
					n->relation = (yyvsp[(5) - (6)].range);
					n->cmds = (yyvsp[(6) - (6)].list);
					n->relkind = OBJECT_VIEW;
					n->missing_ok = true;
					(yyval.node) = (Node *)n;
				}
    break;

  case 263:
/* Line 1787 of yacc.c  */
#line 1867 "gram.y"
    {
					AlterTableStmt *n = makeNode(AlterTableStmt);
					n->relation = (yyvsp[(4) - (5)].range);
					n->cmds = (yyvsp[(5) - (5)].list);
					n->relkind = OBJECT_MATVIEW;
					n->missing_ok = false;
					(yyval.node) = (Node *)n;
				}
    break;

  case 264:
/* Line 1787 of yacc.c  */
#line 1876 "gram.y"
    {
					AlterTableStmt *n = makeNode(AlterTableStmt);
					n->relation = (yyvsp[(6) - (7)].range);
					n->cmds = (yyvsp[(7) - (7)].list);
					n->relkind = OBJECT_MATVIEW;
					n->missing_ok = true;
					(yyval.node) = (Node *)n;
				}
    break;

  case 265:
/* Line 1787 of yacc.c  */
#line 1885 "gram.y"
    {
					AlterTableMoveAllStmt *n =
						makeNode(AlterTableMoveAllStmt);
					n->orig_tablespacename = (yyvsp[(7) - (11)].str);
					n->objtype = OBJECT_MATVIEW;
					n->roles = NIL;
					n->new_tablespacename = (yyvsp[(10) - (11)].str);
					n->nowait = (yyvsp[(11) - (11)].boolean);
					(yyval.node) = (Node *)n;
				}
    break;

  case 266:
/* Line 1787 of yacc.c  */
#line 1896 "gram.y"
    {
					AlterTableMoveAllStmt *n =
						makeNode(AlterTableMoveAllStmt);
					n->orig_tablespacename = (yyvsp[(7) - (14)].str);
					n->objtype = OBJECT_MATVIEW;
					n->roles = (yyvsp[(10) - (14)].list);
					n->new_tablespacename = (yyvsp[(13) - (14)].str);
					n->nowait = (yyvsp[(14) - (14)].boolean);
					(yyval.node) = (Node *)n;
				}
    break;

  case 267:
/* Line 1787 of yacc.c  */
#line 1909 "gram.y"
    { (yyval.list) = list_make1((yyvsp[(1) - (1)].node)); }
    break;

  case 268:
/* Line 1787 of yacc.c  */
#line 1910 "gram.y"
    { (yyval.list) = lappend((yyvsp[(1) - (3)].list), (yyvsp[(3) - (3)].node)); }
    break;

  case 269:
/* Line 1787 of yacc.c  */
#line 1916 "gram.y"
    {
					AlterTableCmd *n = makeNode(AlterTableCmd);
					n->subtype = AT_AddColumn;
					n->def = (yyvsp[(2) - (2)].node);
					(yyval.node) = (Node *)n;
				}
    break;

  case 270:
/* Line 1787 of yacc.c  */
#line 1924 "gram.y"
    {
					AlterTableCmd *n = makeNode(AlterTableCmd);
					n->subtype = AT_AddColumn;
					n->def = (yyvsp[(3) - (3)].node);
					(yyval.node) = (Node *)n;
				}
    break;

  case 271:
/* Line 1787 of yacc.c  */
#line 1932 "gram.y"
    {
					AlterTableCmd *n = makeNode(AlterTableCmd);
					n->subtype = AT_ColumnDefault;
					n->name = (yyvsp[(3) - (4)].str);
					n->def = (yyvsp[(4) - (4)].node);
					(yyval.node) = (Node *)n;
				}
    break;

  case 272:
/* Line 1787 of yacc.c  */
#line 1941 "gram.y"
    {
					AlterTableCmd *n = makeNode(AlterTableCmd);
					n->subtype = AT_DropNotNull;
					n->name = (yyvsp[(3) - (6)].str);
					(yyval.node) = (Node *)n;
				}
    break;

  case 273:
/* Line 1787 of yacc.c  */
#line 1949 "gram.y"
    {
					AlterTableCmd *n = makeNode(AlterTableCmd);
					n->subtype = AT_SetNotNull;
					n->name = (yyvsp[(3) - (6)].str);
					(yyval.node) = (Node *)n;
				}
    break;

  case 274:
/* Line 1787 of yacc.c  */
#line 1957 "gram.y"
    {
					AlterTableCmd *n = makeNode(AlterTableCmd);
					n->subtype = AT_SetStatistics;
					n->name = (yyvsp[(3) - (6)].str);
					n->def = (Node *) makeInteger((yyvsp[(6) - (6)].ival));
					(yyval.node) = (Node *)n;
				}
    break;

  case 275:
/* Line 1787 of yacc.c  */
#line 1966 "gram.y"
    {
					AlterTableCmd *n = makeNode(AlterTableCmd);
					n->subtype = AT_SetOptions;
					n->name = (yyvsp[(3) - (5)].str);
					n->def = (Node *) (yyvsp[(5) - (5)].list);
					(yyval.node) = (Node *)n;
				}
    break;

  case 276:
/* Line 1787 of yacc.c  */
#line 1975 "gram.y"
    {
					AlterTableCmd *n = makeNode(AlterTableCmd);
					n->subtype = AT_ResetOptions;
					n->name = (yyvsp[(3) - (5)].str);
					n->def = (Node *) (yyvsp[(5) - (5)].list);
					(yyval.node) = (Node *)n;
				}
    break;

  case 277:
/* Line 1787 of yacc.c  */
#line 1984 "gram.y"
    {
					AlterTableCmd *n = makeNode(AlterTableCmd);
					n->subtype = AT_SetStorage;
					n->name = (yyvsp[(3) - (6)].str);
					n->def = (Node *) makeString((yyvsp[(6) - (6)].str));
					(yyval.node) = (Node *)n;
				}
    break;

  case 278:
/* Line 1787 of yacc.c  */
#line 1993 "gram.y"
    {
					AlterTableCmd *n = makeNode(AlterTableCmd);
					n->subtype = AT_DropColumn;
					n->name = (yyvsp[(5) - (6)].str);
					n->behavior = (yyvsp[(6) - (6)].dbehavior);
					n->missing_ok = TRUE;
					(yyval.node) = (Node *)n;
				}
    break;

  case 279:
/* Line 1787 of yacc.c  */
#line 2003 "gram.y"
    {
					AlterTableCmd *n = makeNode(AlterTableCmd);
					n->subtype = AT_DropColumn;
					n->name = (yyvsp[(3) - (4)].str);
					n->behavior = (yyvsp[(4) - (4)].dbehavior);
					n->missing_ok = FALSE;
					(yyval.node) = (Node *)n;
				}
    break;

  case 280:
/* Line 1787 of yacc.c  */
#line 2016 "gram.y"
    {
					AlterTableCmd *n = makeNode(AlterTableCmd);
					ColumnDef *def = makeNode(ColumnDef);
					n->subtype = AT_AlterColumnType;
					n->name = (yyvsp[(3) - (8)].str);
					n->def = (Node *) def;
					/* We only use these fields of the ColumnDef node */
					def->typeName = (yyvsp[(6) - (8)].typnam);
					def->collClause = (CollateClause *) (yyvsp[(7) - (8)].node);
					def->raw_default = (yyvsp[(8) - (8)].node);
					def->location = (yylsp[(3) - (8)]);
					(yyval.node) = (Node *)n;
				}
    break;

  case 281:
/* Line 1787 of yacc.c  */
#line 2031 "gram.y"
    {
					AlterTableCmd *n = makeNode(AlterTableCmd);
					n->subtype = AT_AlterColumnGenericOptions;
					n->name = (yyvsp[(3) - (4)].str);
					n->def = (Node *) (yyvsp[(4) - (4)].list);
					(yyval.node) = (Node *)n;
				}
    break;

  case 282:
/* Line 1787 of yacc.c  */
#line 2040 "gram.y"
    {
					AlterTableCmd *n = makeNode(AlterTableCmd);
					n->subtype = AT_AddConstraint;
					n->def = (yyvsp[(2) - (2)].node);
					(yyval.node) = (Node *)n;
				}
    break;

  case 283:
/* Line 1787 of yacc.c  */
#line 2048 "gram.y"
    {
					AlterTableCmd *n = makeNode(AlterTableCmd);
					Constraint *c = makeNode(Constraint);
					n->subtype = AT_AlterConstraint;
					n->def = (Node *) c;
					c->contype = CONSTR_FOREIGN; /* others not supported, yet */
					c->conname = (yyvsp[(3) - (4)].str);
					processCASbits((yyvsp[(4) - (4)].ival), (yylsp[(4) - (4)]), "ALTER CONSTRAINT statement",
									&c->deferrable,
									&c->initdeferred,
									NULL, NULL, yyscanner);
					(yyval.node) = (Node *)n;
				}
    break;

  case 284:
/* Line 1787 of yacc.c  */
#line 2063 "gram.y"
    {
					AlterTableCmd *n = makeNode(AlterTableCmd);
					n->subtype = AT_ValidateConstraint;
					n->name = (yyvsp[(3) - (3)].str);
					(yyval.node) = (Node *)n;
				}
    break;

  case 285:
/* Line 1787 of yacc.c  */
#line 2071 "gram.y"
    {
					AlterTableCmd *n = makeNode(AlterTableCmd);
					n->subtype = AT_DropConstraint;
					n->name = (yyvsp[(5) - (6)].str);
					n->behavior = (yyvsp[(6) - (6)].dbehavior);
					n->missing_ok = TRUE;
					(yyval.node) = (Node *)n;
				}
    break;

  case 286:
/* Line 1787 of yacc.c  */
#line 2081 "gram.y"
    {
					AlterTableCmd *n = makeNode(AlterTableCmd);
					n->subtype = AT_DropConstraint;
					n->name = (yyvsp[(3) - (4)].str);
					n->behavior = (yyvsp[(4) - (4)].dbehavior);
					n->missing_ok = FALSE;
					(yyval.node) = (Node *)n;
				}
    break;

  case 287:
/* Line 1787 of yacc.c  */
#line 2091 "gram.y"
    {
					AlterTableCmd *n = makeNode(AlterTableCmd);
					n->subtype = AT_AddOids;
					(yyval.node) = (Node *)n;
				}
    break;

  case 288:
/* Line 1787 of yacc.c  */
#line 2098 "gram.y"
    {
					AlterTableCmd *n = makeNode(AlterTableCmd);
					n->subtype = AT_DropOids;
					(yyval.node) = (Node *)n;
				}
    break;

  case 289:
/* Line 1787 of yacc.c  */
#line 2105 "gram.y"
    {
					AlterTableCmd *n = makeNode(AlterTableCmd);
					n->subtype = AT_ClusterOn;
					n->name = (yyvsp[(3) - (3)].str);
					(yyval.node) = (Node *)n;
				}
    break;

  case 290:
/* Line 1787 of yacc.c  */
#line 2113 "gram.y"
    {
					AlterTableCmd *n = makeNode(AlterTableCmd);
					n->subtype = AT_DropCluster;
					n->name = NULL;
					(yyval.node) = (Node *)n;
				}
    break;

  case 291:
/* Line 1787 of yacc.c  */
#line 2121 "gram.y"
    {
					AlterTableCmd *n = makeNode(AlterTableCmd);
					n->subtype = AT_EnableTrig;
					n->name = (yyvsp[(3) - (3)].str);
					(yyval.node) = (Node *)n;
				}
    break;

  case 292:
/* Line 1787 of yacc.c  */
#line 2129 "gram.y"
    {
					AlterTableCmd *n = makeNode(AlterTableCmd);
					n->subtype = AT_EnableAlwaysTrig;
					n->name = (yyvsp[(4) - (4)].str);
					(yyval.node) = (Node *)n;
				}
    break;

  case 293:
/* Line 1787 of yacc.c  */
#line 2137 "gram.y"
    {
					AlterTableCmd *n = makeNode(AlterTableCmd);
					n->subtype = AT_EnableReplicaTrig;
					n->name = (yyvsp[(4) - (4)].str);
					(yyval.node) = (Node *)n;
				}
    break;

  case 294:
/* Line 1787 of yacc.c  */
#line 2145 "gram.y"
    {
					AlterTableCmd *n = makeNode(AlterTableCmd);
					n->subtype = AT_EnableTrigAll;
					(yyval.node) = (Node *)n;
				}
    break;

  case 295:
/* Line 1787 of yacc.c  */
#line 2152 "gram.y"
    {
					AlterTableCmd *n = makeNode(AlterTableCmd);
					n->subtype = AT_EnableTrigUser;
					(yyval.node) = (Node *)n;
				}
    break;

  case 296:
/* Line 1787 of yacc.c  */
#line 2159 "gram.y"
    {
					AlterTableCmd *n = makeNode(AlterTableCmd);
					n->subtype = AT_DisableTrig;
					n->name = (yyvsp[(3) - (3)].str);
					(yyval.node) = (Node *)n;
				}
    break;

  case 297:
/* Line 1787 of yacc.c  */
#line 2167 "gram.y"
    {
					AlterTableCmd *n = makeNode(AlterTableCmd);
					n->subtype = AT_DisableTrigAll;
					(yyval.node) = (Node *)n;
				}
    break;

  case 298:
/* Line 1787 of yacc.c  */
#line 2174 "gram.y"
    {
					AlterTableCmd *n = makeNode(AlterTableCmd);
					n->subtype = AT_DisableTrigUser;
					(yyval.node) = (Node *)n;
				}
    break;

  case 299:
/* Line 1787 of yacc.c  */
#line 2181 "gram.y"
    {
					AlterTableCmd *n = makeNode(AlterTableCmd);
					n->subtype = AT_EnableRule;
					n->name = (yyvsp[(3) - (3)].str);
					(yyval.node) = (Node *)n;
				}
    break;

  case 300:
/* Line 1787 of yacc.c  */
#line 2189 "gram.y"
    {
					AlterTableCmd *n = makeNode(AlterTableCmd);
					n->subtype = AT_EnableAlwaysRule;
					n->name = (yyvsp[(4) - (4)].str);
					(yyval.node) = (Node *)n;
				}
    break;

  case 301:
/* Line 1787 of yacc.c  */
#line 2197 "gram.y"
    {
					AlterTableCmd *n = makeNode(AlterTableCmd);
					n->subtype = AT_EnableReplicaRule;
					n->name = (yyvsp[(4) - (4)].str);
					(yyval.node) = (Node *)n;
				}
    break;

  case 302:
/* Line 1787 of yacc.c  */
#line 2205 "gram.y"
    {
					AlterTableCmd *n = makeNode(AlterTableCmd);
					n->subtype = AT_DisableRule;
					n->name = (yyvsp[(3) - (3)].str);
					(yyval.node) = (Node *)n;
				}
    break;

  case 303:
/* Line 1787 of yacc.c  */
#line 2213 "gram.y"
    {
					AlterTableCmd *n = makeNode(AlterTableCmd);
					n->subtype = AT_AddInherit;
					n->def = (Node *) (yyvsp[(2) - (2)].range);
					(yyval.node) = (Node *)n;
				}
    break;

  case 304:
/* Line 1787 of yacc.c  */
#line 2221 "gram.y"
    {
					AlterTableCmd *n = makeNode(AlterTableCmd);
					n->subtype = AT_DropInherit;
					n->def = (Node *) (yyvsp[(3) - (3)].range);
					(yyval.node) = (Node *)n;
				}
    break;

  case 305:
/* Line 1787 of yacc.c  */
#line 2229 "gram.y"
    {
					AlterTableCmd *n = makeNode(AlterTableCmd);
					TypeName *def = makeTypeNameFromNameList((yyvsp[(2) - (2)].list));
					def->location = (yylsp[(2) - (2)]);
					n->subtype = AT_AddOf;
					n->def = (Node *) def;
					(yyval.node) = (Node *)n;
				}
    break;

  case 306:
/* Line 1787 of yacc.c  */
#line 2239 "gram.y"
    {
					AlterTableCmd *n = makeNode(AlterTableCmd);
					n->subtype = AT_DropOf;
					(yyval.node) = (Node *)n;
				}
    break;

  case 307:
/* Line 1787 of yacc.c  */
#line 2246 "gram.y"
    {
					AlterTableCmd *n = makeNode(AlterTableCmd);
					n->subtype = AT_ChangeOwner;
					n->name = (yyvsp[(3) - (3)].str);
					(yyval.node) = (Node *)n;
				}
    break;

  case 308:
/* Line 1787 of yacc.c  */
#line 2254 "gram.y"
    {
					AlterTableCmd *n = makeNode(AlterTableCmd);
					n->subtype = AT_SetTableSpace;
					n->name = (yyvsp[(3) - (3)].str);
					(yyval.node) = (Node *)n;
				}
    break;

  case 309:
/* Line 1787 of yacc.c  */
#line 2262 "gram.y"
    {
					AlterTableCmd *n = makeNode(AlterTableCmd);
					n->subtype = AT_SetRelOptions;
					n->def = (Node *)(yyvsp[(2) - (2)].list);
					(yyval.node) = (Node *)n;
				}
    break;

  case 310:
/* Line 1787 of yacc.c  */
#line 2270 "gram.y"
    {
					AlterTableCmd *n = makeNode(AlterTableCmd);
					n->subtype = AT_ResetRelOptions;
					n->def = (Node *)(yyvsp[(2) - (2)].list);
					(yyval.node) = (Node *)n;
				}
    break;

  case 311:
/* Line 1787 of yacc.c  */
#line 2278 "gram.y"
    {
					AlterTableCmd *n = makeNode(AlterTableCmd);
					n->subtype = AT_ReplicaIdentity;
					n->def = (yyvsp[(3) - (3)].node);
					(yyval.node) = (Node *)n;
				}
    break;

  case 312:
/* Line 1787 of yacc.c  */
#line 2285 "gram.y"
    {
					AlterTableCmd *n = makeNode(AlterTableCmd);
					n->subtype = AT_GenericOptions;
					n->def = (Node *)(yyvsp[(1) - (1)].list);
					(yyval.node) = (Node *) n;
				}
    break;

  case 313:
/* Line 1787 of yacc.c  */
#line 2294 "gram.y"
    { (yyval.node) = (yyvsp[(3) - (3)].node); }
    break;

  case 314:
/* Line 1787 of yacc.c  */
#line 2295 "gram.y"
    { (yyval.node) = NULL; }
    break;

  case 315:
/* Line 1787 of yacc.c  */
#line 2299 "gram.y"
    { (yyval.dbehavior) = DROP_CASCADE; }
    break;

  case 316:
/* Line 1787 of yacc.c  */
#line 2300 "gram.y"
    { (yyval.dbehavior) = DROP_RESTRICT; }
    break;

  case 317:
/* Line 1787 of yacc.c  */
#line 2301 "gram.y"
    { (yyval.dbehavior) = DROP_RESTRICT; /* default */ }
    break;

  case 318:
/* Line 1787 of yacc.c  */
#line 2306 "gram.y"
    {
					CollateClause *n = makeNode(CollateClause);
					n->arg = NULL;
					n->collname = (yyvsp[(2) - (2)].list);
					n->location = (yylsp[(1) - (2)]);
					(yyval.node) = (Node *) n;
				}
    break;

  case 319:
/* Line 1787 of yacc.c  */
#line 2313 "gram.y"
    { (yyval.node) = NULL; }
    break;

  case 320:
/* Line 1787 of yacc.c  */
#line 2317 "gram.y"
    { (yyval.node) = (yyvsp[(2) - (2)].node); }
    break;

  case 321:
/* Line 1787 of yacc.c  */
#line 2318 "gram.y"
    { (yyval.node) = NULL; }
    break;

  case 322:
/* Line 1787 of yacc.c  */
#line 2323 "gram.y"
    {
					ReplicaIdentityStmt *n = makeNode(ReplicaIdentityStmt);
					n->identity_type = REPLICA_IDENTITY_NOTHING;
					n->name = NULL;
					(yyval.node) = (Node *) n;
				}
    break;

  case 323:
/* Line 1787 of yacc.c  */
#line 2330 "gram.y"
    {
					ReplicaIdentityStmt *n = makeNode(ReplicaIdentityStmt);
					n->identity_type = REPLICA_IDENTITY_FULL;
					n->name = NULL;
					(yyval.node) = (Node *) n;
				}
    break;

  case 324:
/* Line 1787 of yacc.c  */
#line 2337 "gram.y"
    {
					ReplicaIdentityStmt *n = makeNode(ReplicaIdentityStmt);
					n->identity_type = REPLICA_IDENTITY_DEFAULT;
					n->name = NULL;
					(yyval.node) = (Node *) n;
				}
    break;

  case 325:
/* Line 1787 of yacc.c  */
#line 2344 "gram.y"
    {
					ReplicaIdentityStmt *n = makeNode(ReplicaIdentityStmt);
					n->identity_type = REPLICA_IDENTITY_INDEX;
					n->name = (yyvsp[(3) - (3)].str);
					(yyval.node) = (Node *) n;
				}
    break;

  case 326:
/* Line 1787 of yacc.c  */
#line 2353 "gram.y"
    { (yyval.list) = (yyvsp[(2) - (3)].list); }
    break;

  case 327:
/* Line 1787 of yacc.c  */
#line 2356 "gram.y"
    { (yyval.list) = (yyvsp[(2) - (2)].list); }
    break;

  case 328:
/* Line 1787 of yacc.c  */
#line 2357 "gram.y"
    { (yyval.list) = NIL; }
    break;

  case 329:
/* Line 1787 of yacc.c  */
#line 2361 "gram.y"
    { (yyval.list) = list_make1((yyvsp[(1) - (1)].defelt)); }
    break;

  case 330:
/* Line 1787 of yacc.c  */
#line 2362 "gram.y"
    { (yyval.list) = lappend((yyvsp[(1) - (3)].list), (yyvsp[(3) - (3)].defelt)); }
    break;

  case 331:
/* Line 1787 of yacc.c  */
#line 2368 "gram.y"
    {
					(yyval.defelt) = makeDefElem((yyvsp[(1) - (3)].str), (Node *) (yyvsp[(3) - (3)].node));
				}
    break;

  case 332:
/* Line 1787 of yacc.c  */
#line 2372 "gram.y"
    {
					(yyval.defelt) = makeDefElem((yyvsp[(1) - (1)].str), NULL);
				}
    break;

  case 333:
/* Line 1787 of yacc.c  */
#line 2376 "gram.y"
    {
					(yyval.defelt) = makeDefElemExtended((yyvsp[(1) - (5)].str), (yyvsp[(3) - (5)].str), (Node *) (yyvsp[(5) - (5)].node),
											 DEFELEM_UNSPEC);
				}
    break;

  case 334:
/* Line 1787 of yacc.c  */
#line 2381 "gram.y"
    {
					(yyval.defelt) = makeDefElemExtended((yyvsp[(1) - (3)].str), (yyvsp[(3) - (3)].str), NULL, DEFELEM_UNSPEC);
				}
    break;

  case 335:
/* Line 1787 of yacc.c  */
#line 2396 "gram.y"
    {
					AlterTableStmt *n = makeNode(AlterTableStmt);

					/* can't use qualified_name, sigh */
					n->relation = makeRangeVarFromAnyName((yyvsp[(3) - (4)].list), (yylsp[(3) - (4)]), yyscanner);
					n->cmds = (yyvsp[(4) - (4)].list);
					n->relkind = OBJECT_TYPE;
					(yyval.node) = (Node *)n;
				}
    break;

  case 336:
/* Line 1787 of yacc.c  */
#line 2408 "gram.y"
    { (yyval.list) = list_make1((yyvsp[(1) - (1)].node)); }
    break;

  case 337:
/* Line 1787 of yacc.c  */
#line 2409 "gram.y"
    { (yyval.list) = lappend((yyvsp[(1) - (3)].list), (yyvsp[(3) - (3)].node)); }
    break;

  case 338:
/* Line 1787 of yacc.c  */
#line 2415 "gram.y"
    {
					AlterTableCmd *n = makeNode(AlterTableCmd);
					n->subtype = AT_AddColumn;
					n->def = (yyvsp[(3) - (4)].node);
					n->behavior = (yyvsp[(4) - (4)].dbehavior);
					(yyval.node) = (Node *)n;
				}
    break;

  case 339:
/* Line 1787 of yacc.c  */
#line 2424 "gram.y"
    {
					AlterTableCmd *n = makeNode(AlterTableCmd);
					n->subtype = AT_DropColumn;
					n->name = (yyvsp[(5) - (6)].str);
					n->behavior = (yyvsp[(6) - (6)].dbehavior);
					n->missing_ok = TRUE;
					(yyval.node) = (Node *)n;
				}
    break;

  case 340:
/* Line 1787 of yacc.c  */
#line 2434 "gram.y"
    {
					AlterTableCmd *n = makeNode(AlterTableCmd);
					n->subtype = AT_DropColumn;
					n->name = (yyvsp[(3) - (4)].str);
					n->behavior = (yyvsp[(4) - (4)].dbehavior);
					n->missing_ok = FALSE;
					(yyval.node) = (Node *)n;
				}
    break;

  case 341:
/* Line 1787 of yacc.c  */
#line 2444 "gram.y"
    {
					AlterTableCmd *n = makeNode(AlterTableCmd);
					ColumnDef *def = makeNode(ColumnDef);
					n->subtype = AT_AlterColumnType;
					n->name = (yyvsp[(3) - (8)].str);
					n->def = (Node *) def;
					n->behavior = (yyvsp[(8) - (8)].dbehavior);
					/* We only use these fields of the ColumnDef node */
					def->typeName = (yyvsp[(6) - (8)].typnam);
					def->collClause = (CollateClause *) (yyvsp[(7) - (8)].node);
					def->raw_default = NULL;
					def->location = (yylsp[(3) - (8)]);
					(yyval.node) = (Node *)n;
				}
    break;

  case 342:
/* Line 1787 of yacc.c  */
#line 2470 "gram.y"
    {
					ClosePortalStmt *n = makeNode(ClosePortalStmt);
					n->portalname = (yyvsp[(2) - (2)].str);
					(yyval.node) = (Node *)n;
				}
    break;

  case 343:
/* Line 1787 of yacc.c  */
#line 2476 "gram.y"
    {
					ClosePortalStmt *n = makeNode(ClosePortalStmt);
					n->portalname = NULL;
					(yyval.node) = (Node *)n;
				}
    break;

  case 344:
/* Line 1787 of yacc.c  */
#line 2507 "gram.y"
    {
					CopyStmt *n = makeNode(CopyStmt);
					n->relation = (yyvsp[(3) - (11)].range);
					n->query = NULL;
					n->attlist = (yyvsp[(4) - (11)].list);
					n->is_from = (yyvsp[(6) - (11)].boolean);
					n->is_program = (yyvsp[(7) - (11)].boolean);
					n->filename = (yyvsp[(8) - (11)].str);

					if (n->is_program && n->filename == NULL)
						ereport(ERROR,
								(errcode(ERRCODE_SYNTAX_ERROR),
								 errmsg("STDIN/STDOUT not allowed with PROGRAM"),
								 parser_errposition((yylsp[(8) - (11)]))));

					n->options = NIL;
					/* Concatenate user-supplied flags */
					if ((yyvsp[(2) - (11)].defelt))
						n->options = lappend(n->options, (yyvsp[(2) - (11)].defelt));
					if ((yyvsp[(5) - (11)].defelt))
						n->options = lappend(n->options, (yyvsp[(5) - (11)].defelt));
					if ((yyvsp[(9) - (11)].defelt))
						n->options = lappend(n->options, (yyvsp[(9) - (11)].defelt));
					if ((yyvsp[(11) - (11)].list))
						n->options = list_concat(n->options, (yyvsp[(11) - (11)].list));
					(yyval.node) = (Node *)n;
				}
    break;

  case 345:
/* Line 1787 of yacc.c  */
#line 2535 "gram.y"
    {
					CopyStmt *n = makeNode(CopyStmt);
					n->relation = NULL;
					n->query = (yyvsp[(2) - (7)].node);
					n->attlist = NIL;
					n->is_from = false;
					n->is_program = (yyvsp[(4) - (7)].boolean);
					n->filename = (yyvsp[(5) - (7)].str);
					n->options = (yyvsp[(7) - (7)].list);

					if (n->is_program && n->filename == NULL)
						ereport(ERROR,
								(errcode(ERRCODE_SYNTAX_ERROR),
								 errmsg("STDIN/STDOUT not allowed with PROGRAM"),
								 parser_errposition((yylsp[(5) - (7)]))));

					(yyval.node) = (Node *)n;
				}
    break;

  case 346:
/* Line 1787 of yacc.c  */
#line 2556 "gram.y"
    { (yyval.boolean) = TRUE; }
    break;

  case 347:
/* Line 1787 of yacc.c  */
#line 2557 "gram.y"
    { (yyval.boolean) = FALSE; }
    break;

  case 348:
/* Line 1787 of yacc.c  */
#line 2561 "gram.y"
    { (yyval.boolean) = TRUE; }
    break;

  case 349:
/* Line 1787 of yacc.c  */
#line 2562 "gram.y"
    { (yyval.boolean) = FALSE; }
    break;

  case 350:
/* Line 1787 of yacc.c  */
#line 2571 "gram.y"
    { (yyval.str) = (yyvsp[(1) - (1)].str); }
    break;

  case 351:
/* Line 1787 of yacc.c  */
#line 2572 "gram.y"
    { (yyval.str) = NULL; }
    break;

  case 352:
/* Line 1787 of yacc.c  */
#line 2573 "gram.y"
    { (yyval.str) = NULL; }
    break;

  case 353:
/* Line 1787 of yacc.c  */
#line 2576 "gram.y"
    { (yyval.list) = (yyvsp[(1) - (1)].list); }
    break;

  case 354:
/* Line 1787 of yacc.c  */
#line 2577 "gram.y"
    { (yyval.list) = (yyvsp[(2) - (3)].list); }
    break;

  case 355:
/* Line 1787 of yacc.c  */
#line 2582 "gram.y"
    { (yyval.list) = lappend((yyvsp[(1) - (2)].list), (yyvsp[(2) - (2)].defelt)); }
    break;

  case 356:
/* Line 1787 of yacc.c  */
#line 2583 "gram.y"
    { (yyval.list) = NIL; }
    break;

  case 357:
/* Line 1787 of yacc.c  */
#line 2588 "gram.y"
    {
					(yyval.defelt) = makeDefElem("format", (Node *)makeString("binary"));
				}
    break;

  case 358:
/* Line 1787 of yacc.c  */
#line 2592 "gram.y"
    {
					(yyval.defelt) = makeDefElem("oids", (Node *)makeInteger(TRUE));
				}
    break;

  case 359:
/* Line 1787 of yacc.c  */
#line 2596 "gram.y"
    {
					(yyval.defelt) = makeDefElem("freeze", (Node *)makeInteger(TRUE));
				}
    break;

  case 360:
/* Line 1787 of yacc.c  */
#line 2600 "gram.y"
    {
					(yyval.defelt) = makeDefElem("delimiter", (Node *)makeString((yyvsp[(3) - (3)].str)));
				}
    break;

  case 361:
/* Line 1787 of yacc.c  */
#line 2604 "gram.y"
    {
					(yyval.defelt) = makeDefElem("null", (Node *)makeString((yyvsp[(3) - (3)].str)));
				}
    break;

  case 362:
/* Line 1787 of yacc.c  */
#line 2608 "gram.y"
    {
					(yyval.defelt) = makeDefElem("format", (Node *)makeString("csv"));
				}
    break;

  case 363:
/* Line 1787 of yacc.c  */
#line 2612 "gram.y"
    {
					(yyval.defelt) = makeDefElem("header", (Node *)makeInteger(TRUE));
				}
    break;

  case 364:
/* Line 1787 of yacc.c  */
#line 2616 "gram.y"
    {
					(yyval.defelt) = makeDefElem("quote", (Node *)makeString((yyvsp[(3) - (3)].str)));
				}
    break;

  case 365:
/* Line 1787 of yacc.c  */
#line 2620 "gram.y"
    {
					(yyval.defelt) = makeDefElem("escape", (Node *)makeString((yyvsp[(3) - (3)].str)));
				}
    break;

  case 366:
/* Line 1787 of yacc.c  */
#line 2624 "gram.y"
    {
					(yyval.defelt) = makeDefElem("force_quote", (Node *)(yyvsp[(3) - (3)].list));
				}
    break;

  case 367:
/* Line 1787 of yacc.c  */
#line 2628 "gram.y"
    {
					(yyval.defelt) = makeDefElem("force_quote", (Node *)makeNode(A_Star));
				}
    break;

  case 368:
/* Line 1787 of yacc.c  */
#line 2632 "gram.y"
    {
					(yyval.defelt) = makeDefElem("force_not_null", (Node *)(yyvsp[(4) - (4)].list));
				}
    break;

  case 369:
/* Line 1787 of yacc.c  */
#line 2636 "gram.y"
    {
					(yyval.defelt) = makeDefElem("force_null", (Node *)(yyvsp[(3) - (3)].list));
				}
    break;

  case 370:
/* Line 1787 of yacc.c  */
#line 2640 "gram.y"
    {
					(yyval.defelt) = makeDefElem("encoding", (Node *)makeString((yyvsp[(2) - (2)].str)));
				}
    break;

  case 371:
/* Line 1787 of yacc.c  */
#line 2649 "gram.y"
    {
					(yyval.defelt) = makeDefElem("format", (Node *)makeString("binary"));
				}
    break;

  case 372:
/* Line 1787 of yacc.c  */
#line 2652 "gram.y"
    { (yyval.defelt) = NULL; }
    break;

  case 373:
/* Line 1787 of yacc.c  */
#line 2657 "gram.y"
    {
					(yyval.defelt) = makeDefElem("oids", (Node *)makeInteger(TRUE));
				}
    break;

  case 374:
/* Line 1787 of yacc.c  */
#line 2660 "gram.y"
    { (yyval.defelt) = NULL; }
    break;

  case 375:
/* Line 1787 of yacc.c  */
#line 2665 "gram.y"
    {
					(yyval.defelt) = makeDefElem("delimiter", (Node *)makeString((yyvsp[(3) - (3)].str)));
				}
    break;

  case 376:
/* Line 1787 of yacc.c  */
#line 2668 "gram.y"
    { (yyval.defelt) = NULL; }
    break;

  case 377:
/* Line 1787 of yacc.c  */
#line 2672 "gram.y"
    {}
    break;

  case 378:
/* Line 1787 of yacc.c  */
#line 2673 "gram.y"
    {}
    break;

  case 379:
/* Line 1787 of yacc.c  */
#line 2679 "gram.y"
    {
					(yyval.list) = list_make1((yyvsp[(1) - (1)].defelt));
				}
    break;

  case 380:
/* Line 1787 of yacc.c  */
#line 2683 "gram.y"
    {
					(yyval.list) = lappend((yyvsp[(1) - (3)].list), (yyvsp[(3) - (3)].defelt));
				}
    break;

  case 381:
/* Line 1787 of yacc.c  */
#line 2690 "gram.y"
    {
					(yyval.defelt) = makeDefElem((yyvsp[(1) - (2)].str), (yyvsp[(2) - (2)].node));
				}
    break;

  case 382:
/* Line 1787 of yacc.c  */
#line 2696 "gram.y"
    { (yyval.node) = (Node *) makeString((yyvsp[(1) - (1)].str)); }
    break;

  case 383:
/* Line 1787 of yacc.c  */
#line 2697 "gram.y"
    { (yyval.node) = (Node *) (yyvsp[(1) - (1)].value); }
    break;

  case 384:
/* Line 1787 of yacc.c  */
#line 2698 "gram.y"
    { (yyval.node) = (Node *) makeNode(A_Star); }
    break;

  case 385:
/* Line 1787 of yacc.c  */
#line 2699 "gram.y"
    { (yyval.node) = (Node *) (yyvsp[(2) - (3)].list); }
    break;

  case 386:
/* Line 1787 of yacc.c  */
#line 2700 "gram.y"
    { (yyval.node) = NULL; }
    break;

  case 387:
/* Line 1787 of yacc.c  */
#line 2705 "gram.y"
    {
					(yyval.list) = list_make1((yyvsp[(1) - (1)].node));
				}
    break;

  case 388:
/* Line 1787 of yacc.c  */
#line 2709 "gram.y"
    {
					(yyval.list) = lappend((yyvsp[(1) - (3)].list), (yyvsp[(3) - (3)].node));
				}
    break;

  case 389:
/* Line 1787 of yacc.c  */
#line 2716 "gram.y"
    { (yyval.node) = (Node *) makeString((yyvsp[(1) - (1)].str)); }
    break;

  case 390:
/* Line 1787 of yacc.c  */
#line 2729 "gram.y"
    {
					CreateStmt *n = makeNode(CreateStmt);
					(yyvsp[(4) - (11)].range)->relpersistence = (yyvsp[(2) - (11)].ival);
					n->relation = (yyvsp[(4) - (11)].range);
					n->tableElts = (yyvsp[(6) - (11)].list);
					n->inhRelations = (yyvsp[(8) - (11)].list);
					n->constraints = NIL;
					n->options = (yyvsp[(9) - (11)].list);
					n->oncommit = (yyvsp[(10) - (11)].oncommit);
					n->tablespacename = (yyvsp[(11) - (11)].str);
					n->if_not_exists = false;
					(yyval.node) = (Node *)n;
				}
    break;

  case 391:
/* Line 1787 of yacc.c  */
#line 2745 "gram.y"
    {
					CreateStmt *n = makeNode(CreateStmt);
					(yyvsp[(7) - (14)].range)->relpersistence = (yyvsp[(2) - (14)].ival);
					n->relation = (yyvsp[(7) - (14)].range);
					n->tableElts = (yyvsp[(9) - (14)].list);
					n->inhRelations = (yyvsp[(11) - (14)].list);
					n->constraints = NIL;
					n->options = (yyvsp[(12) - (14)].list);
					n->oncommit = (yyvsp[(13) - (14)].oncommit);
					n->tablespacename = (yyvsp[(14) - (14)].str);
					n->if_not_exists = true;
					(yyval.node) = (Node *)n;
				}
    break;

  case 392:
/* Line 1787 of yacc.c  */
#line 2760 "gram.y"
    {
					CreateStmt *n = makeNode(CreateStmt);
					(yyvsp[(4) - (10)].range)->relpersistence = (yyvsp[(2) - (10)].ival);
					n->relation = (yyvsp[(4) - (10)].range);
					n->tableElts = (yyvsp[(7) - (10)].list);
					n->ofTypename = makeTypeNameFromNameList((yyvsp[(6) - (10)].list));
					n->ofTypename->location = (yylsp[(6) - (10)]);
					n->constraints = NIL;
					n->options = (yyvsp[(8) - (10)].list);
					n->oncommit = (yyvsp[(9) - (10)].oncommit);
					n->tablespacename = (yyvsp[(10) - (10)].str);
					n->if_not_exists = false;
					(yyval.node) = (Node *)n;
				}
    break;

  case 393:
/* Line 1787 of yacc.c  */
#line 2776 "gram.y"
    {
					CreateStmt *n = makeNode(CreateStmt);
					(yyvsp[(7) - (13)].range)->relpersistence = (yyvsp[(2) - (13)].ival);
					n->relation = (yyvsp[(7) - (13)].range);
					n->tableElts = (yyvsp[(10) - (13)].list);
					n->ofTypename = makeTypeNameFromNameList((yyvsp[(9) - (13)].list));
					n->ofTypename->location = (yylsp[(9) - (13)]);
					n->constraints = NIL;
					n->options = (yyvsp[(11) - (13)].list);
					n->oncommit = (yyvsp[(12) - (13)].oncommit);
					n->tablespacename = (yyvsp[(13) - (13)].str);
					n->if_not_exists = true;
					(yyval.node) = (Node *)n;
				}
    break;

  case 394:
/* Line 1787 of yacc.c  */
#line 2803 "gram.y"
    { (yyval.ival) = RELPERSISTENCE_TEMP; }
    break;

  case 395:
/* Line 1787 of yacc.c  */
#line 2804 "gram.y"
    { (yyval.ival) = RELPERSISTENCE_TEMP; }
    break;

  case 396:
/* Line 1787 of yacc.c  */
#line 2805 "gram.y"
    { (yyval.ival) = RELPERSISTENCE_TEMP; }
    break;

  case 397:
/* Line 1787 of yacc.c  */
#line 2806 "gram.y"
    { (yyval.ival) = RELPERSISTENCE_TEMP; }
    break;

  case 398:
/* Line 1787 of yacc.c  */
#line 2808 "gram.y"
    {
					ereport(WARNING,
							(errmsg("GLOBAL is deprecated in temporary table creation"),
							 parser_errposition((yylsp[(1) - (2)]))));
					(yyval.ival) = RELPERSISTENCE_TEMP;
				}
    break;

  case 399:
/* Line 1787 of yacc.c  */
#line 2815 "gram.y"
    {
					ereport(WARNING,
							(errmsg("GLOBAL is deprecated in temporary table creation"),
							 parser_errposition((yylsp[(1) - (2)]))));
					(yyval.ival) = RELPERSISTENCE_TEMP;
				}
    break;

  case 400:
/* Line 1787 of yacc.c  */
#line 2821 "gram.y"
    { (yyval.ival) = RELPERSISTENCE_UNLOGGED; }
    break;

  case 401:
/* Line 1787 of yacc.c  */
#line 2822 "gram.y"
    { (yyval.ival) = RELPERSISTENCE_PERMANENT; }
    break;

  case 402:
/* Line 1787 of yacc.c  */
#line 2826 "gram.y"
    { (yyval.list) = (yyvsp[(1) - (1)].list); }
    break;

  case 403:
/* Line 1787 of yacc.c  */
#line 2827 "gram.y"
    { (yyval.list) = NIL; }
    break;

  case 404:
/* Line 1787 of yacc.c  */
#line 2831 "gram.y"
    { (yyval.list) = (yyvsp[(2) - (3)].list); }
    break;

  case 405:
/* Line 1787 of yacc.c  */
#line 2832 "gram.y"
    { (yyval.list) = NIL; }
    break;

  case 406:
/* Line 1787 of yacc.c  */
#line 2837 "gram.y"
    {
					(yyval.list) = list_make1((yyvsp[(1) - (1)].node));
				}
    break;

  case 407:
/* Line 1787 of yacc.c  */
#line 2841 "gram.y"
    {
					(yyval.list) = lappend((yyvsp[(1) - (3)].list), (yyvsp[(3) - (3)].node));
				}
    break;

  case 408:
/* Line 1787 of yacc.c  */
#line 2848 "gram.y"
    {
					(yyval.list) = list_make1((yyvsp[(1) - (1)].node));
				}
    break;

  case 409:
/* Line 1787 of yacc.c  */
#line 2852 "gram.y"
    {
					(yyval.list) = lappend((yyvsp[(1) - (3)].list), (yyvsp[(3) - (3)].node));
				}
    break;

  case 410:
/* Line 1787 of yacc.c  */
#line 2858 "gram.y"
    { (yyval.node) = (yyvsp[(1) - (1)].node); }
    break;

  case 411:
/* Line 1787 of yacc.c  */
#line 2859 "gram.y"
    { (yyval.node) = (yyvsp[(1) - (1)].node); }
    break;

  case 412:
/* Line 1787 of yacc.c  */
#line 2860 "gram.y"
    { (yyval.node) = (yyvsp[(1) - (1)].node); }
    break;

  case 413:
/* Line 1787 of yacc.c  */
#line 2864 "gram.y"
    { (yyval.node) = (yyvsp[(1) - (1)].node); }
    break;

  case 414:
/* Line 1787 of yacc.c  */
#line 2865 "gram.y"
    { (yyval.node) = (yyvsp[(1) - (1)].node); }
    break;

  case 415:
/* Line 1787 of yacc.c  */
#line 2869 "gram.y"
    {
					ColumnDef *n = makeNode(ColumnDef);
					n->colname = (yyvsp[(1) - (4)].str);
					n->typeName = (yyvsp[(2) - (4)].typnam);
					n->inhcount = 0;
					n->is_local = true;
					n->is_not_null = false;
					n->is_from_type = false;
					n->storage = 0;
					n->raw_default = NULL;
					n->cooked_default = NULL;
					n->collOid = InvalidOid;
					n->fdwoptions = (yyvsp[(3) - (4)].list);
					SplitColQualList((yyvsp[(4) - (4)].list), &n->constraints, &n->collClause,
									 yyscanner);
					n->location = (yylsp[(1) - (4)]);
					(yyval.node) = (Node *)n;
				}
    break;

  case 416:
/* Line 1787 of yacc.c  */
#line 2890 "gram.y"
    {
					ColumnDef *n = makeNode(ColumnDef);
					n->colname = (yyvsp[(1) - (4)].str);
					n->typeName = NULL;
					n->inhcount = 0;
					n->is_local = true;
					n->is_not_null = false;
					n->is_from_type = false;
					n->storage = 0;
					n->raw_default = NULL;
					n->cooked_default = NULL;
					n->collOid = InvalidOid;
					SplitColQualList((yyvsp[(4) - (4)].list), &n->constraints, &n->collClause,
									 yyscanner);
					n->location = (yylsp[(1) - (4)]);
					(yyval.node) = (Node *)n;
				}
    break;

  case 417:
/* Line 1787 of yacc.c  */
#line 2910 "gram.y"
    { (yyval.list) = lappend((yyvsp[(1) - (2)].list), (yyvsp[(2) - (2)].node)); }
    break;

  case 418:
/* Line 1787 of yacc.c  */
#line 2911 "gram.y"
    { (yyval.list) = NIL; }
    break;

  case 419:
/* Line 1787 of yacc.c  */
#line 2916 "gram.y"
    {
					Constraint *n = (Constraint *) (yyvsp[(3) - (3)].node);
					Assert(IsA(n, Constraint));
					n->conname = (yyvsp[(2) - (3)].str);
					n->location = (yylsp[(1) - (3)]);
					(yyval.node) = (Node *) n;
				}
    break;

  case 420:
/* Line 1787 of yacc.c  */
#line 2923 "gram.y"
    { (yyval.node) = (yyvsp[(1) - (1)].node); }
    break;

  case 421:
/* Line 1787 of yacc.c  */
#line 2924 "gram.y"
    { (yyval.node) = (yyvsp[(1) - (1)].node); }
    break;

  case 422:
/* Line 1787 of yacc.c  */
#line 2926 "gram.y"
    {
					/*
					 * Note: the CollateClause is momentarily included in
					 * the list built by ColQualList, but we split it out
					 * again in SplitColQualList.
					 */
					CollateClause *n = makeNode(CollateClause);
					n->arg = NULL;
					n->collname = (yyvsp[(2) - (2)].list);
					n->location = (yylsp[(1) - (2)]);
					(yyval.node) = (Node *) n;
				}
    break;

  case 423:
/* Line 1787 of yacc.c  */
#line 2957 "gram.y"
    {
					Constraint *n = makeNode(Constraint);
					n->contype = CONSTR_NOTNULL;
					n->location = (yylsp[(1) - (2)]);
					(yyval.node) = (Node *)n;
				}
    break;

  case 424:
/* Line 1787 of yacc.c  */
#line 2964 "gram.y"
    {
					Constraint *n = makeNode(Constraint);
					n->contype = CONSTR_NULL;
					n->location = (yylsp[(1) - (1)]);
					(yyval.node) = (Node *)n;
				}
    break;

  case 425:
/* Line 1787 of yacc.c  */
#line 2971 "gram.y"
    {
					Constraint *n = makeNode(Constraint);
					n->contype = CONSTR_UNIQUE;
					n->location = (yylsp[(1) - (3)]);
					n->keys = NULL;
					n->options = (yyvsp[(2) - (3)].list);
					n->indexname = NULL;
					n->indexspace = (yyvsp[(3) - (3)].str);
					(yyval.node) = (Node *)n;
				}
    break;

  case 426:
/* Line 1787 of yacc.c  */
#line 2982 "gram.y"
    {
					Constraint *n = makeNode(Constraint);
					n->contype = CONSTR_PRIMARY;
					n->location = (yylsp[(1) - (4)]);
					n->keys = NULL;
					n->options = (yyvsp[(3) - (4)].list);
					n->indexname = NULL;
					n->indexspace = (yyvsp[(4) - (4)].str);
					(yyval.node) = (Node *)n;
				}
    break;

  case 427:
/* Line 1787 of yacc.c  */
#line 2993 "gram.y"
    {
					Constraint *n = makeNode(Constraint);
					n->contype = CONSTR_CHECK;
					n->location = (yylsp[(1) - (5)]);
					n->is_no_inherit = (yyvsp[(5) - (5)].boolean);
					n->raw_expr = (yyvsp[(3) - (5)].node);
					n->cooked_expr = NULL;
					(yyval.node) = (Node *)n;
				}
    break;

  case 428:
/* Line 1787 of yacc.c  */
#line 3003 "gram.y"
    {
					Constraint *n = makeNode(Constraint);
					n->contype = CONSTR_DEFAULT;
					n->location = (yylsp[(1) - (2)]);
					n->raw_expr = (yyvsp[(2) - (2)].node);
					n->cooked_expr = NULL;
					(yyval.node) = (Node *)n;
				}
    break;

  case 429:
/* Line 1787 of yacc.c  */
#line 3012 "gram.y"
    {
					Constraint *n = makeNode(Constraint);
					n->contype = CONSTR_FOREIGN;
					n->location = (yylsp[(1) - (5)]);
					n->pktable			= (yyvsp[(2) - (5)].range);
					n->fk_attrs			= NIL;
					n->pk_attrs			= (yyvsp[(3) - (5)].list);
					n->fk_matchtype		= (yyvsp[(4) - (5)].ival);
					n->fk_upd_action	= (char) ((yyvsp[(5) - (5)].ival) >> 8);
					n->fk_del_action	= (char) ((yyvsp[(5) - (5)].ival) & 0xFF);
					n->skip_validation  = false;
					n->initially_valid  = true;
					(yyval.node) = (Node *)n;
				}
    break;

  case 430:
/* Line 1787 of yacc.c  */
#line 3045 "gram.y"
    {
					Constraint *n = makeNode(Constraint);
					n->contype = CONSTR_ATTR_DEFERRABLE;
					n->location = (yylsp[(1) - (1)]);
					(yyval.node) = (Node *)n;
				}
    break;

  case 431:
/* Line 1787 of yacc.c  */
#line 3052 "gram.y"
    {
					Constraint *n = makeNode(Constraint);
					n->contype = CONSTR_ATTR_NOT_DEFERRABLE;
					n->location = (yylsp[(1) - (2)]);
					(yyval.node) = (Node *)n;
				}
    break;

  case 432:
/* Line 1787 of yacc.c  */
#line 3059 "gram.y"
    {
					Constraint *n = makeNode(Constraint);
					n->contype = CONSTR_ATTR_DEFERRED;
					n->location = (yylsp[(1) - (2)]);
					(yyval.node) = (Node *)n;
				}
    break;

  case 433:
/* Line 1787 of yacc.c  */
#line 3066 "gram.y"
    {
					Constraint *n = makeNode(Constraint);
					n->contype = CONSTR_ATTR_IMMEDIATE;
					n->location = (yylsp[(1) - (2)]);
					(yyval.node) = (Node *)n;
				}
    break;

  case 434:
/* Line 1787 of yacc.c  */
#line 3077 "gram.y"
    {
					TableLikeClause *n = makeNode(TableLikeClause);
					n->relation = (yyvsp[(2) - (3)].range);
					n->options = (yyvsp[(3) - (3)].ival);
					(yyval.node) = (Node *)n;
				}
    break;

  case 435:
/* Line 1787 of yacc.c  */
#line 3086 "gram.y"
    { (yyval.ival) = (yyvsp[(1) - (3)].ival) | (yyvsp[(3) - (3)].ival); }
    break;

  case 436:
/* Line 1787 of yacc.c  */
#line 3087 "gram.y"
    { (yyval.ival) = (yyvsp[(1) - (3)].ival) & ~(yyvsp[(3) - (3)].ival); }
    break;

  case 437:
/* Line 1787 of yacc.c  */
#line 3088 "gram.y"
    { (yyval.ival) = 0; }
    break;

  case 438:
/* Line 1787 of yacc.c  */
#line 3092 "gram.y"
    { (yyval.ival) = CREATE_TABLE_LIKE_DEFAULTS; }
    break;

  case 439:
/* Line 1787 of yacc.c  */
#line 3093 "gram.y"
    { (yyval.ival) = CREATE_TABLE_LIKE_CONSTRAINTS; }
    break;

  case 440:
/* Line 1787 of yacc.c  */
#line 3094 "gram.y"
    { (yyval.ival) = CREATE_TABLE_LIKE_INDEXES; }
    break;

  case 441:
/* Line 1787 of yacc.c  */
#line 3095 "gram.y"
    { (yyval.ival) = CREATE_TABLE_LIKE_STORAGE; }
    break;

  case 442:
/* Line 1787 of yacc.c  */
#line 3096 "gram.y"
    { (yyval.ival) = CREATE_TABLE_LIKE_COMMENTS; }
    break;

  case 443:
/* Line 1787 of yacc.c  */
#line 3097 "gram.y"
    { (yyval.ival) = CREATE_TABLE_LIKE_ALL; }
    break;

  case 444:
/* Line 1787 of yacc.c  */
#line 3107 "gram.y"
    {
					Constraint *n = (Constraint *) (yyvsp[(3) - (3)].node);
					Assert(IsA(n, Constraint));
					n->conname = (yyvsp[(2) - (3)].str);
					n->location = (yylsp[(1) - (3)]);
					(yyval.node) = (Node *) n;
				}
    break;

  case 445:
/* Line 1787 of yacc.c  */
#line 3114 "gram.y"
    { (yyval.node) = (yyvsp[(1) - (1)].node); }
    break;

  case 446:
/* Line 1787 of yacc.c  */
#line 3119 "gram.y"
    {
					Constraint *n = makeNode(Constraint);
					n->contype = CONSTR_CHECK;
					n->location = (yylsp[(1) - (5)]);
					n->raw_expr = (yyvsp[(3) - (5)].node);
					n->cooked_expr = NULL;
					processCASbits((yyvsp[(5) - (5)].ival), (yylsp[(5) - (5)]), "CHECK",
								   NULL, NULL, &n->skip_validation,
								   &n->is_no_inherit, yyscanner);
					n->initially_valid = !n->skip_validation;
					(yyval.node) = (Node *)n;
				}
    break;

  case 447:
/* Line 1787 of yacc.c  */
#line 3133 "gram.y"
    {
					Constraint *n = makeNode(Constraint);
					n->contype = CONSTR_UNIQUE;
					n->location = (yylsp[(1) - (7)]);
					n->keys = (yyvsp[(3) - (7)].list);
					n->options = (yyvsp[(5) - (7)].list);
					n->indexname = NULL;
					n->indexspace = (yyvsp[(6) - (7)].str);
					processCASbits((yyvsp[(7) - (7)].ival), (yylsp[(7) - (7)]), "UNIQUE",
								   &n->deferrable, &n->initdeferred, NULL,
								   NULL, yyscanner);
					(yyval.node) = (Node *)n;
				}
    break;

  case 448:
/* Line 1787 of yacc.c  */
#line 3147 "gram.y"
    {
					Constraint *n = makeNode(Constraint);
					n->contype = CONSTR_UNIQUE;
					n->location = (yylsp[(1) - (3)]);
					n->keys = NIL;
					n->options = NIL;
					n->indexname = (yyvsp[(2) - (3)].str);
					n->indexspace = NULL;
					processCASbits((yyvsp[(3) - (3)].ival), (yylsp[(3) - (3)]), "UNIQUE",
								   &n->deferrable, &n->initdeferred, NULL,
								   NULL, yyscanner);
					(yyval.node) = (Node *)n;
				}
    break;

  case 449:
/* Line 1787 of yacc.c  */
#line 3162 "gram.y"
    {
					Constraint *n = makeNode(Constraint);
					n->contype = CONSTR_PRIMARY;
					n->location = (yylsp[(1) - (8)]);
					n->keys = (yyvsp[(4) - (8)].list);
					n->options = (yyvsp[(6) - (8)].list);
					n->indexname = NULL;
					n->indexspace = (yyvsp[(7) - (8)].str);
					processCASbits((yyvsp[(8) - (8)].ival), (yylsp[(8) - (8)]), "PRIMARY KEY",
								   &n->deferrable, &n->initdeferred, NULL,
								   NULL, yyscanner);
					(yyval.node) = (Node *)n;
				}
    break;

  case 450:
/* Line 1787 of yacc.c  */
#line 3176 "gram.y"
    {
					Constraint *n = makeNode(Constraint);
					n->contype = CONSTR_PRIMARY;
					n->location = (yylsp[(1) - (4)]);
					n->keys = NIL;
					n->options = NIL;
					n->indexname = (yyvsp[(3) - (4)].str);
					n->indexspace = NULL;
					processCASbits((yyvsp[(4) - (4)].ival), (yylsp[(4) - (4)]), "PRIMARY KEY",
								   &n->deferrable, &n->initdeferred, NULL,
								   NULL, yyscanner);
					(yyval.node) = (Node *)n;
				}
    break;

  case 451:
/* Line 1787 of yacc.c  */
#line 3192 "gram.y"
    {
					Constraint *n = makeNode(Constraint);
					n->contype = CONSTR_EXCLUSION;
					n->location = (yylsp[(1) - (9)]);
					n->access_method	= (yyvsp[(2) - (9)].str);
					n->exclusions		= (yyvsp[(4) - (9)].list);
					n->options			= (yyvsp[(6) - (9)].list);
					n->indexname		= NULL;
					n->indexspace		= (yyvsp[(7) - (9)].str);
					n->where_clause		= (yyvsp[(8) - (9)].node);
					processCASbits((yyvsp[(9) - (9)].ival), (yylsp[(9) - (9)]), "EXCLUDE",
								   &n->deferrable, &n->initdeferred, NULL,
								   NULL, yyscanner);
					(yyval.node) = (Node *)n;
				}
    break;

  case 452:
/* Line 1787 of yacc.c  */
#line 3209 "gram.y"
    {
					Constraint *n = makeNode(Constraint);
					n->contype = CONSTR_FOREIGN;
					n->location = (yylsp[(1) - (11)]);
					n->pktable			= (yyvsp[(7) - (11)].range);
					n->fk_attrs			= (yyvsp[(4) - (11)].list);
					n->pk_attrs			= (yyvsp[(8) - (11)].list);
					n->fk_matchtype		= (yyvsp[(9) - (11)].ival);
					n->fk_upd_action	= (char) ((yyvsp[(10) - (11)].ival) >> 8);
					n->fk_del_action	= (char) ((yyvsp[(10) - (11)].ival) & 0xFF);
					processCASbits((yyvsp[(11) - (11)].ival), (yylsp[(11) - (11)]), "FOREIGN KEY",
								   &n->deferrable, &n->initdeferred,
								   &n->skip_validation, NULL,
								   yyscanner);
					n->initially_valid = !n->skip_validation;
					(yyval.node) = (Node *)n;
				}
    break;

  case 453:
/* Line 1787 of yacc.c  */
#line 3228 "gram.y"
    {  (yyval.boolean) = TRUE; }
    break;

  case 454:
/* Line 1787 of yacc.c  */
#line 3229 "gram.y"
    {  (yyval.boolean) = FALSE; }
    break;

  case 455:
/* Line 1787 of yacc.c  */
#line 3233 "gram.y"
    { (yyval.list) = (yyvsp[(2) - (3)].list); }
    break;

  case 456:
/* Line 1787 of yacc.c  */
#line 3234 "gram.y"
    { (yyval.list) = NIL; }
    break;

  case 457:
/* Line 1787 of yacc.c  */
#line 3238 "gram.y"
    { (yyval.list) = list_make1((yyvsp[(1) - (1)].node)); }
    break;

  case 458:
/* Line 1787 of yacc.c  */
#line 3239 "gram.y"
    { (yyval.list) = lappend((yyvsp[(1) - (3)].list), (yyvsp[(3) - (3)].node)); }
    break;

  case 459:
/* Line 1787 of yacc.c  */
#line 3243 "gram.y"
    {
					(yyval.node) = (Node *) makeString((yyvsp[(1) - (1)].str));
				}
    break;

  case 460:
/* Line 1787 of yacc.c  */
#line 3249 "gram.y"
    {
				(yyval.ival) = FKCONSTR_MATCH_FULL;
			}
    break;

  case 461:
/* Line 1787 of yacc.c  */
#line 3253 "gram.y"
    {
				ereport(ERROR,
						(errcode(ERRCODE_FEATURE_NOT_SUPPORTED),
						 errmsg("MATCH PARTIAL not yet implemented"),
						 parser_errposition((yylsp[(1) - (2)]))));
				(yyval.ival) = FKCONSTR_MATCH_PARTIAL;
			}
    break;

  case 462:
/* Line 1787 of yacc.c  */
#line 3261 "gram.y"
    {
				(yyval.ival) = FKCONSTR_MATCH_SIMPLE;
			}
    break;

  case 463:
/* Line 1787 of yacc.c  */
#line 3265 "gram.y"
    {
				(yyval.ival) = FKCONSTR_MATCH_SIMPLE;
			}
    break;

  case 464:
/* Line 1787 of yacc.c  */
#line 3271 "gram.y"
    { (yyval.list) = list_make1((yyvsp[(1) - (1)].list)); }
    break;

  case 465:
/* Line 1787 of yacc.c  */
#line 3273 "gram.y"
    { (yyval.list) = lappend((yyvsp[(1) - (3)].list), (yyvsp[(3) - (3)].list)); }
    break;

  case 466:
/* Line 1787 of yacc.c  */
#line 3277 "gram.y"
    {
				(yyval.list) = list_make2((yyvsp[(1) - (3)].ielem), (yyvsp[(3) - (3)].list));
			}
    break;

  case 467:
/* Line 1787 of yacc.c  */
#line 3282 "gram.y"
    {
				(yyval.list) = list_make2((yyvsp[(1) - (6)].ielem), (yyvsp[(5) - (6)].list));
			}
    break;

  case 468:
/* Line 1787 of yacc.c  */
#line 3288 "gram.y"
    { (yyval.node) = (yyvsp[(3) - (4)].node); }
    break;

  case 469:
/* Line 1787 of yacc.c  */
#line 3289 "gram.y"
    { (yyval.node) = NULL; }
    break;

  case 470:
/* Line 1787 of yacc.c  */
#line 3300 "gram.y"
    { (yyval.ival) = ((yyvsp[(1) - (1)].ival) << 8) | (FKCONSTR_ACTION_NOACTION & 0xFF); }
    break;

  case 471:
/* Line 1787 of yacc.c  */
#line 3302 "gram.y"
    { (yyval.ival) = (FKCONSTR_ACTION_NOACTION << 8) | ((yyvsp[(1) - (1)].ival) & 0xFF); }
    break;

  case 472:
/* Line 1787 of yacc.c  */
#line 3304 "gram.y"
    { (yyval.ival) = ((yyvsp[(1) - (2)].ival) << 8) | ((yyvsp[(2) - (2)].ival) & 0xFF); }
    break;

  case 473:
/* Line 1787 of yacc.c  */
#line 3306 "gram.y"
    { (yyval.ival) = ((yyvsp[(2) - (2)].ival) << 8) | ((yyvsp[(1) - (2)].ival) & 0xFF); }
    break;

  case 474:
/* Line 1787 of yacc.c  */
#line 3308 "gram.y"
    { (yyval.ival) = (FKCONSTR_ACTION_NOACTION << 8) | (FKCONSTR_ACTION_NOACTION & 0xFF); }
    break;

  case 475:
/* Line 1787 of yacc.c  */
#line 3311 "gram.y"
    { (yyval.ival) = (yyvsp[(3) - (3)].ival); }
    break;

  case 476:
/* Line 1787 of yacc.c  */
#line 3314 "gram.y"
    { (yyval.ival) = (yyvsp[(3) - (3)].ival); }
    break;

  case 477:
/* Line 1787 of yacc.c  */
#line 3318 "gram.y"
    { (yyval.ival) = FKCONSTR_ACTION_NOACTION; }
    break;

  case 478:
/* Line 1787 of yacc.c  */
#line 3319 "gram.y"
    { (yyval.ival) = FKCONSTR_ACTION_RESTRICT; }
    break;

  case 479:
/* Line 1787 of yacc.c  */
#line 3320 "gram.y"
    { (yyval.ival) = FKCONSTR_ACTION_CASCADE; }
    break;

  case 480:
/* Line 1787 of yacc.c  */
#line 3321 "gram.y"
    { (yyval.ival) = FKCONSTR_ACTION_SETNULL; }
    break;

  case 481:
/* Line 1787 of yacc.c  */
#line 3322 "gram.y"
    { (yyval.ival) = FKCONSTR_ACTION_SETDEFAULT; }
    break;

  case 482:
/* Line 1787 of yacc.c  */
#line 3325 "gram.y"
    { (yyval.list) = (yyvsp[(3) - (4)].list); }
    break;

  case 483:
/* Line 1787 of yacc.c  */
#line 3326 "gram.y"
    { (yyval.list) = NIL; }
    break;

  case 484:
/* Line 1787 of yacc.c  */
#line 3331 "gram.y"
    { (yyval.list) = (yyvsp[(2) - (2)].list); }
    break;

  case 485:
/* Line 1787 of yacc.c  */
#line 3332 "gram.y"
    { (yyval.list) = list_make1(defWithOids(true)); }
    break;

  case 486:
/* Line 1787 of yacc.c  */
#line 3333 "gram.y"
    { (yyval.list) = list_make1(defWithOids(false)); }
    break;

  case 487:
/* Line 1787 of yacc.c  */
#line 3334 "gram.y"
    { (yyval.list) = NIL; }
    break;

  case 488:
/* Line 1787 of yacc.c  */
#line 3337 "gram.y"
    { (yyval.oncommit) = ONCOMMIT_DROP; }
    break;

  case 489:
/* Line 1787 of yacc.c  */
#line 3338 "gram.y"
    { (yyval.oncommit) = ONCOMMIT_DELETE_ROWS; }
    break;

  case 490:
/* Line 1787 of yacc.c  */
#line 3339 "gram.y"
    { (yyval.oncommit) = ONCOMMIT_PRESERVE_ROWS; }
    break;

  case 491:
/* Line 1787 of yacc.c  */
#line 3340 "gram.y"
    { (yyval.oncommit) = ONCOMMIT_NOOP; }
    break;

  case 492:
/* Line 1787 of yacc.c  */
#line 3343 "gram.y"
    { (yyval.str) = (yyvsp[(2) - (2)].str); }
    break;

  case 493:
/* Line 1787 of yacc.c  */
#line 3344 "gram.y"
    { (yyval.str) = NULL; }
    break;

  case 494:
/* Line 1787 of yacc.c  */
#line 3347 "gram.y"
    { (yyval.str) = (yyvsp[(4) - (4)].str); }
    break;

  case 495:
/* Line 1787 of yacc.c  */
#line 3348 "gram.y"
    { (yyval.str) = NULL; }
    break;

  case 496:
/* Line 1787 of yacc.c  */
#line 3351 "gram.y"
    { (yyval.str) = (yyvsp[(3) - (3)].str); }
    break;

  case 497:
/* Line 1787 of yacc.c  */
#line 3367 "gram.y"
    {
					CreateTableAsStmt *ctas = makeNode(CreateTableAsStmt);
					ctas->query = (yyvsp[(6) - (7)].node);
					ctas->into = (yyvsp[(4) - (7)].into);
					ctas->relkind = OBJECT_TABLE;
					ctas->is_select_into = false;
					/* cram additional flags into the IntoClause */
					(yyvsp[(4) - (7)].into)->rel->relpersistence = (yyvsp[(2) - (7)].ival);
					(yyvsp[(4) - (7)].into)->skipData = !((yyvsp[(7) - (7)].boolean));
					(yyval.node) = (Node *) ctas;
				}
    break;

  case 498:
/* Line 1787 of yacc.c  */
#line 3382 "gram.y"
    {
					(yyval.into) = makeNode(IntoClause);
					(yyval.into)->rel = (yyvsp[(1) - (5)].range);
					(yyval.into)->colNames = (yyvsp[(2) - (5)].list);
					(yyval.into)->options = (yyvsp[(3) - (5)].list);
					(yyval.into)->onCommit = (yyvsp[(4) - (5)].oncommit);
					(yyval.into)->tableSpaceName = (yyvsp[(5) - (5)].str);
					(yyval.into)->viewQuery = NULL;
					(yyval.into)->skipData = false;		/* might get changed later */
				}
    break;

  case 499:
/* Line 1787 of yacc.c  */
#line 3395 "gram.y"
    { (yyval.boolean) = TRUE; }
    break;

  case 500:
/* Line 1787 of yacc.c  */
#line 3396 "gram.y"
    { (yyval.boolean) = FALSE; }
    break;

  case 501:
/* Line 1787 of yacc.c  */
#line 3397 "gram.y"
    { (yyval.boolean) = TRUE; }
    break;

  case 502:
/* Line 1787 of yacc.c  */
#line 3410 "gram.y"
    {
					CreateTableAsStmt *ctas = makeNode(CreateTableAsStmt);
					ctas->query = (yyvsp[(7) - (8)].node);
					ctas->into = (yyvsp[(5) - (8)].into);
					ctas->relkind = OBJECT_MATVIEW;
					ctas->is_select_into = false;
					/* cram additional flags into the IntoClause */
					(yyvsp[(5) - (8)].into)->rel->relpersistence = (yyvsp[(2) - (8)].ival);
					(yyvsp[(5) - (8)].into)->skipData = !((yyvsp[(8) - (8)].boolean));
					(yyval.node) = (Node *) ctas;
				}
    break;

  case 503:
/* Line 1787 of yacc.c  */
#line 3425 "gram.y"
    {
					(yyval.into) = makeNode(IntoClause);
					(yyval.into)->rel = (yyvsp[(1) - (4)].range);
					(yyval.into)->colNames = (yyvsp[(2) - (4)].list);
					(yyval.into)->options = (yyvsp[(3) - (4)].list);
					(yyval.into)->onCommit = ONCOMMIT_NOOP;
					(yyval.into)->tableSpaceName = (yyvsp[(4) - (4)].str);
					(yyval.into)->viewQuery = NULL;		/* filled at analysis time */
					(yyval.into)->skipData = false;		/* might get changed later */
				}
    break;

  case 504:
/* Line 1787 of yacc.c  */
#line 3437 "gram.y"
    { (yyval.ival) = RELPERSISTENCE_UNLOGGED; }
    break;

  case 505:
/* Line 1787 of yacc.c  */
#line 3438 "gram.y"
    { (yyval.ival) = RELPERSISTENCE_PERMANENT; }
    break;

  case 506:
/* Line 1787 of yacc.c  */
#line 3451 "gram.y"
    {
					RefreshMatViewStmt *n = makeNode(RefreshMatViewStmt);
					n->concurrent = (yyvsp[(4) - (6)].boolean);
					n->relation = (yyvsp[(5) - (6)].range);
					n->skipData = !((yyvsp[(6) - (6)].boolean));
					(yyval.node) = (Node *) n;
				}
    break;

  case 507:
/* Line 1787 of yacc.c  */
#line 3471 "gram.y"
    {
					CreateSeqStmt *n = makeNode(CreateSeqStmt);
					(yyvsp[(4) - (5)].range)->relpersistence = (yyvsp[(2) - (5)].ival);
					n->sequence = (yyvsp[(4) - (5)].range);
					n->options = (yyvsp[(5) - (5)].list);
					n->ownerId = InvalidOid;
					(yyval.node) = (Node *)n;
				}
    break;

  case 508:
/* Line 1787 of yacc.c  */
#line 3483 "gram.y"
    {
					AlterSeqStmt *n = makeNode(AlterSeqStmt);
					n->sequence = (yyvsp[(3) - (4)].range);
					n->options = (yyvsp[(4) - (4)].list);
					n->missing_ok = false;
					(yyval.node) = (Node *)n;
				}
    break;

  case 509:
/* Line 1787 of yacc.c  */
#line 3491 "gram.y"
    {
					AlterSeqStmt *n = makeNode(AlterSeqStmt);
					n->sequence = (yyvsp[(5) - (6)].range);
					n->options = (yyvsp[(6) - (6)].list);
					n->missing_ok = true;
					(yyval.node) = (Node *)n;
				}
    break;

  case 510:
/* Line 1787 of yacc.c  */
#line 3501 "gram.y"
    { (yyval.list) = (yyvsp[(1) - (1)].list); }
    break;

  case 511:
/* Line 1787 of yacc.c  */
#line 3502 "gram.y"
    { (yyval.list) = NIL; }
    break;

  case 512:
/* Line 1787 of yacc.c  */
#line 3505 "gram.y"
    { (yyval.list) = list_make1((yyvsp[(1) - (1)].defelt)); }
    break;

  case 513:
/* Line 1787 of yacc.c  */
#line 3506 "gram.y"
    { (yyval.list) = lappend((yyvsp[(1) - (2)].list), (yyvsp[(2) - (2)].defelt)); }
    break;

  case 514:
/* Line 1787 of yacc.c  */
#line 3510 "gram.y"
    {
					(yyval.defelt) = makeDefElem("cache", (Node *)(yyvsp[(2) - (2)].value));
				}
    break;

  case 515:
/* Line 1787 of yacc.c  */
#line 3514 "gram.y"
    {
					(yyval.defelt) = makeDefElem("cycle", (Node *)makeInteger(TRUE));
				}
    break;

  case 516:
/* Line 1787 of yacc.c  */
#line 3518 "gram.y"
    {
					(yyval.defelt) = makeDefElem("cycle", (Node *)makeInteger(FALSE));
				}
    break;

  case 517:
/* Line 1787 of yacc.c  */
#line 3522 "gram.y"
    {
					(yyval.defelt) = makeDefElem("increment", (Node *)(yyvsp[(3) - (3)].value));
				}
    break;

  case 518:
/* Line 1787 of yacc.c  */
#line 3526 "gram.y"
    {
					(yyval.defelt) = makeDefElem("maxvalue", (Node *)(yyvsp[(2) - (2)].value));
				}
    break;

  case 519:
/* Line 1787 of yacc.c  */
#line 3530 "gram.y"
    {
					(yyval.defelt) = makeDefElem("minvalue", (Node *)(yyvsp[(2) - (2)].value));
				}
    break;

  case 520:
/* Line 1787 of yacc.c  */
#line 3534 "gram.y"
    {
					(yyval.defelt) = makeDefElem("maxvalue", NULL);
				}
    break;

  case 521:
/* Line 1787 of yacc.c  */
#line 3538 "gram.y"
    {
					(yyval.defelt) = makeDefElem("minvalue", NULL);
				}
    break;

  case 522:
/* Line 1787 of yacc.c  */
#line 3542 "gram.y"
    {
					(yyval.defelt) = makeDefElem("owned_by", (Node *)(yyvsp[(3) - (3)].list));
				}
    break;

  case 523:
/* Line 1787 of yacc.c  */
#line 3546 "gram.y"
    {
					(yyval.defelt) = makeDefElem("start", (Node *)(yyvsp[(3) - (3)].value));
				}
    break;

  case 524:
/* Line 1787 of yacc.c  */
#line 3550 "gram.y"
    {
					(yyval.defelt) = makeDefElem("restart", NULL);
				}
    break;

  case 525:
/* Line 1787 of yacc.c  */
#line 3554 "gram.y"
    {
					(yyval.defelt) = makeDefElem("restart", (Node *)(yyvsp[(3) - (3)].value));
				}
    break;

  case 526:
/* Line 1787 of yacc.c  */
#line 3559 "gram.y"
    {}
    break;

  case 527:
/* Line 1787 of yacc.c  */
#line 3560 "gram.y"
    {}
    break;

  case 528:
/* Line 1787 of yacc.c  */
#line 3564 "gram.y"
    { (yyval.value) = makeFloat((yyvsp[(1) - (1)].str)); }
    break;

  case 529:
/* Line 1787 of yacc.c  */
#line 3565 "gram.y"
    { (yyval.value) = makeFloat((yyvsp[(2) - (2)].str)); }
    break;

  case 530:
/* Line 1787 of yacc.c  */
#line 3567 "gram.y"
    {
					(yyval.value) = makeFloat((yyvsp[(2) - (2)].str));
					doNegateFloat((yyval.value));
				}
    break;

  case 531:
/* Line 1787 of yacc.c  */
#line 3571 "gram.y"
    { (yyval.value) = makeInteger((yyvsp[(1) - (1)].ival)); }
    break;

  case 532:
/* Line 1787 of yacc.c  */
#line 3574 "gram.y"
    { (yyval.list) = list_make1((yyvsp[(1) - (1)].value)); }
    break;

  case 533:
/* Line 1787 of yacc.c  */
#line 3575 "gram.y"
    { (yyval.list) = lappend((yyvsp[(1) - (3)].list), (yyvsp[(3) - (3)].value)); }
    break;

  case 534:
/* Line 1787 of yacc.c  */
#line 3588 "gram.y"
    {
				CreatePLangStmt *n = makeNode(CreatePLangStmt);
				n->replace = (yyvsp[(2) - (6)].boolean);
				n->plname = (yyvsp[(6) - (6)].str);
				/* parameters are all to be supplied by system */
				n->plhandler = NIL;
				n->plinline = NIL;
				n->plvalidator = NIL;
				n->pltrusted = false;
				(yyval.node) = (Node *)n;
			}
    break;

  case 535:
/* Line 1787 of yacc.c  */
#line 3601 "gram.y"
    {
				CreatePLangStmt *n = makeNode(CreatePLangStmt);
				n->replace = (yyvsp[(2) - (10)].boolean);
				n->plname = (yyvsp[(6) - (10)].str);
				n->plhandler = (yyvsp[(8) - (10)].list);
				n->plinline = (yyvsp[(9) - (10)].list);
				n->plvalidator = (yyvsp[(10) - (10)].list);
				n->pltrusted = (yyvsp[(3) - (10)].boolean);
				(yyval.node) = (Node *)n;
			}
    break;

  case 536:
/* Line 1787 of yacc.c  */
#line 3614 "gram.y"
    { (yyval.boolean) = TRUE; }
    break;

  case 537:
/* Line 1787 of yacc.c  */
#line 3615 "gram.y"
    { (yyval.boolean) = FALSE; }
    break;

  case 538:
/* Line 1787 of yacc.c  */
#line 3623 "gram.y"
    { (yyval.list) = list_make1(makeString((yyvsp[(1) - (1)].str))); }
    break;

  case 539:
/* Line 1787 of yacc.c  */
#line 3624 "gram.y"
    { (yyval.list) = lcons(makeString((yyvsp[(1) - (2)].str)), (yyvsp[(2) - (2)].list)); }
    break;

  case 540:
/* Line 1787 of yacc.c  */
#line 3628 "gram.y"
    { (yyval.list) = (yyvsp[(2) - (2)].list); }
    break;

  case 541:
/* Line 1787 of yacc.c  */
#line 3629 "gram.y"
    { (yyval.list) = NIL; }
    break;

  case 542:
/* Line 1787 of yacc.c  */
#line 3633 "gram.y"
    { (yyval.list) = (yyvsp[(2) - (2)].list); }
    break;

  case 543:
/* Line 1787 of yacc.c  */
#line 3634 "gram.y"
    { (yyval.list) = NIL; }
    break;

  case 544:
/* Line 1787 of yacc.c  */
#line 3638 "gram.y"
    { (yyval.list) = (yyvsp[(1) - (1)].list); }
    break;

  case 545:
/* Line 1787 of yacc.c  */
#line 3639 "gram.y"
    { (yyval.list) = NIL; }
    break;

  case 546:
/* Line 1787 of yacc.c  */
#line 3644 "gram.y"
    {
					DropStmt *n = makeNode(DropStmt);
					n->removeType = OBJECT_LANGUAGE;
					n->objects = list_make1(list_make1(makeString((yyvsp[(4) - (5)].str))));
					n->arguments = NIL;
					n->behavior = (yyvsp[(5) - (5)].dbehavior);
					n->missing_ok = false;
					n->concurrent = false;
					(yyval.node) = (Node *)n;
				}
    break;

  case 547:
/* Line 1787 of yacc.c  */
#line 3655 "gram.y"
    {
					DropStmt *n = makeNode(DropStmt);
					n->removeType = OBJECT_LANGUAGE;
					n->objects = list_make1(list_make1(makeString((yyvsp[(6) - (7)].str))));
					n->behavior = (yyvsp[(7) - (7)].dbehavior);
					n->missing_ok = true;
					n->concurrent = false;
					(yyval.node) = (Node *)n;
				}
    break;

  case 548:
/* Line 1787 of yacc.c  */
#line 3667 "gram.y"
    {}
    break;

  case 549:
/* Line 1787 of yacc.c  */
#line 3668 "gram.y"
    {}
    break;

  case 550:
/* Line 1787 of yacc.c  */
#line 3679 "gram.y"
    {
					CreateTableSpaceStmt *n = makeNode(CreateTableSpaceStmt);
					n->tablespacename = (yyvsp[(3) - (7)].str);
					n->owner = (yyvsp[(4) - (7)].str);
					n->location = (yyvsp[(6) - (7)].str);
					n->options = (yyvsp[(7) - (7)].list);
					(yyval.node) = (Node *) n;
				}
    break;

  case 551:
/* Line 1787 of yacc.c  */
#line 3689 "gram.y"
    { (yyval.str) = (yyvsp[(2) - (2)].str); }
    break;

  case 552:
/* Line 1787 of yacc.c  */
#line 3690 "gram.y"
    { (yyval.str) = NULL; }
    break;

  case 553:
/* Line 1787 of yacc.c  */
#line 3704 "gram.y"
    {
					DropTableSpaceStmt *n = makeNode(DropTableSpaceStmt);
					n->tablespacename = (yyvsp[(3) - (3)].str);
					n->missing_ok = false;
					(yyval.node) = (Node *) n;
				}
    break;

  case 554:
/* Line 1787 of yacc.c  */
#line 3711 "gram.y"
    {
					DropTableSpaceStmt *n = makeNode(DropTableSpaceStmt);
					n->tablespacename = (yyvsp[(5) - (5)].str);
					n->missing_ok = true;
					(yyval.node) = (Node *) n;
				}
    break;

  case 555:
/* Line 1787 of yacc.c  */
#line 3728 "gram.y"
    {
					CreateExtensionStmt *n = makeNode(CreateExtensionStmt);
					n->extname = (yyvsp[(3) - (5)].str);
					n->if_not_exists = false;
					n->options = (yyvsp[(5) - (5)].list);
					(yyval.node) = (Node *) n;
				}
    break;

  case 556:
/* Line 1787 of yacc.c  */
#line 3736 "gram.y"
    {
					CreateExtensionStmt *n = makeNode(CreateExtensionStmt);
					n->extname = (yyvsp[(6) - (8)].str);
					n->if_not_exists = true;
					n->options = (yyvsp[(8) - (8)].list);
					(yyval.node) = (Node *) n;
				}
    break;

  case 557:
/* Line 1787 of yacc.c  */
#line 3747 "gram.y"
    { (yyval.list) = lappend((yyvsp[(1) - (2)].list), (yyvsp[(2) - (2)].defelt)); }
    break;

  case 558:
/* Line 1787 of yacc.c  */
#line 3749 "gram.y"
    { (yyval.list) = NIL; }
    break;

  case 559:
/* Line 1787 of yacc.c  */
#line 3754 "gram.y"
    {
					(yyval.defelt) = makeDefElem("schema", (Node *)makeString((yyvsp[(2) - (2)].str)));
				}
    break;

  case 560:
/* Line 1787 of yacc.c  */
#line 3758 "gram.y"
    {
					(yyval.defelt) = makeDefElem("new_version", (Node *)makeString((yyvsp[(2) - (2)].str)));
				}
    break;

  case 561:
/* Line 1787 of yacc.c  */
#line 3762 "gram.y"
    {
					(yyval.defelt) = makeDefElem("old_version", (Node *)makeString((yyvsp[(2) - (2)].str)));
				}
    break;

  case 562:
/* Line 1787 of yacc.c  */
#line 3774 "gram.y"
    {
					AlterExtensionStmt *n = makeNode(AlterExtensionStmt);
					n->extname = (yyvsp[(3) - (5)].str);
					n->options = (yyvsp[(5) - (5)].list);
					(yyval.node) = (Node *) n;
				}
    break;

  case 563:
/* Line 1787 of yacc.c  */
#line 3784 "gram.y"
    { (yyval.list) = lappend((yyvsp[(1) - (2)].list), (yyvsp[(2) - (2)].defelt)); }
    break;

  case 564:
/* Line 1787 of yacc.c  */
#line 3786 "gram.y"
    { (yyval.list) = NIL; }
    break;

  case 565:
/* Line 1787 of yacc.c  */
#line 3791 "gram.y"
    {
					(yyval.defelt) = makeDefElem("new_version", (Node *)makeString((yyvsp[(2) - (2)].str)));
				}
    break;

  case 566:
/* Line 1787 of yacc.c  */
#line 3804 "gram.y"
    {
					AlterExtensionContentsStmt *n = makeNode(AlterExtensionContentsStmt);
					n->extname = (yyvsp[(3) - (7)].str);
					n->action = (yyvsp[(4) - (7)].ival);
					n->objtype = OBJECT_AGGREGATE;
					n->objname = (yyvsp[(6) - (7)].list);
					n->objargs = extractAggrArgTypes((yyvsp[(7) - (7)].list));
					(yyval.node) = (Node *)n;
				}
    break;

  case 567:
/* Line 1787 of yacc.c  */
#line 3814 "gram.y"
    {
					AlterExtensionContentsStmt *n = makeNode(AlterExtensionContentsStmt);
					n->extname = (yyvsp[(3) - (10)].str);
					n->action = (yyvsp[(4) - (10)].ival);
					n->objtype = OBJECT_CAST;
					n->objname = list_make1((yyvsp[(7) - (10)].typnam));
					n->objargs = list_make1((yyvsp[(9) - (10)].typnam));
					(yyval.node) = (Node *) n;
				}
    break;

  case 568:
/* Line 1787 of yacc.c  */
#line 3824 "gram.y"
    {
					AlterExtensionContentsStmt *n = makeNode(AlterExtensionContentsStmt);
					n->extname = (yyvsp[(3) - (6)].str);
					n->action = (yyvsp[(4) - (6)].ival);
					n->objtype = OBJECT_COLLATION;
					n->objname = (yyvsp[(6) - (6)].list);
					(yyval.node) = (Node *)n;
				}
    break;

  case 569:
/* Line 1787 of yacc.c  */
#line 3833 "gram.y"
    {
					AlterExtensionContentsStmt *n = makeNode(AlterExtensionContentsStmt);
					n->extname = (yyvsp[(3) - (6)].str);
					n->action = (yyvsp[(4) - (6)].ival);
					n->objtype = OBJECT_CONVERSION;
					n->objname = (yyvsp[(6) - (6)].list);
					(yyval.node) = (Node *)n;
				}
    break;

  case 570:
/* Line 1787 of yacc.c  */
#line 3842 "gram.y"
    {
					AlterExtensionContentsStmt *n = makeNode(AlterExtensionContentsStmt);
					n->extname = (yyvsp[(3) - (6)].str);
					n->action = (yyvsp[(4) - (6)].ival);
					n->objtype = OBJECT_DOMAIN;
					n->objname = (yyvsp[(6) - (6)].list);
					(yyval.node) = (Node *)n;
				}
    break;

  case 571:
/* Line 1787 of yacc.c  */
#line 3851 "gram.y"
    {
					AlterExtensionContentsStmt *n = makeNode(AlterExtensionContentsStmt);
					n->extname = (yyvsp[(3) - (6)].str);
					n->action = (yyvsp[(4) - (6)].ival);
					n->objtype = OBJECT_FUNCTION;
					n->objname = (yyvsp[(6) - (6)].funwithargs)->funcname;
					n->objargs = (yyvsp[(6) - (6)].funwithargs)->funcargs;
					(yyval.node) = (Node *)n;
				}
    break;

  case 572:
/* Line 1787 of yacc.c  */
#line 3861 "gram.y"
    {
					AlterExtensionContentsStmt *n = makeNode(AlterExtensionContentsStmt);
					n->extname = (yyvsp[(3) - (7)].str);
					n->action = (yyvsp[(4) - (7)].ival);
					n->objtype = OBJECT_LANGUAGE;
					n->objname = list_make1(makeString((yyvsp[(7) - (7)].str)));
					(yyval.node) = (Node *)n;
				}
    break;

  case 573:
/* Line 1787 of yacc.c  */
#line 3870 "gram.y"
    {
					AlterExtensionContentsStmt *n = makeNode(AlterExtensionContentsStmt);
					n->extname = (yyvsp[(3) - (7)].str);
					n->action = (yyvsp[(4) - (7)].ival);
					n->objtype = OBJECT_OPERATOR;
					n->objname = (yyvsp[(6) - (7)].list);
					n->objargs = (yyvsp[(7) - (7)].list);
					(yyval.node) = (Node *)n;
				}
    break;

  case 574:
/* Line 1787 of yacc.c  */
#line 3880 "gram.y"
    {
					AlterExtensionContentsStmt *n = makeNode(AlterExtensionContentsStmt);
					n->extname = (yyvsp[(3) - (9)].str);
					n->action = (yyvsp[(4) - (9)].ival);
					n->objtype = OBJECT_OPCLASS;
					n->objname = (yyvsp[(7) - (9)].list);
					n->objargs = list_make1(makeString((yyvsp[(9) - (9)].str)));
					(yyval.node) = (Node *)n;
				}
    break;

  case 575:
/* Line 1787 of yacc.c  */
#line 3890 "gram.y"
    {
					AlterExtensionContentsStmt *n = makeNode(AlterExtensionContentsStmt);
					n->extname = (yyvsp[(3) - (9)].str);
					n->action = (yyvsp[(4) - (9)].ival);
					n->objtype = OBJECT_OPFAMILY;
					n->objname = (yyvsp[(7) - (9)].list);
					n->objargs = list_make1(makeString((yyvsp[(9) - (9)].str)));
					(yyval.node) = (Node *)n;
				}
    break;

  case 576:
/* Line 1787 of yacc.c  */
#line 3900 "gram.y"
    {
					AlterExtensionContentsStmt *n = makeNode(AlterExtensionContentsStmt);
					n->extname = (yyvsp[(3) - (6)].str);
					n->action = (yyvsp[(4) - (6)].ival);
					n->objtype = OBJECT_SCHEMA;
					n->objname = list_make1(makeString((yyvsp[(6) - (6)].str)));
					(yyval.node) = (Node *)n;
				}
    break;

  case 577:
/* Line 1787 of yacc.c  */
#line 3909 "gram.y"
    {
					AlterExtensionContentsStmt *n = makeNode(AlterExtensionContentsStmt);
					n->extname = (yyvsp[(3) - (7)].str);
					n->action = (yyvsp[(4) - (7)].ival);
					n->objtype = OBJECT_EVENT_TRIGGER;
					n->objname = list_make1(makeString((yyvsp[(7) - (7)].str)));
					(yyval.node) = (Node *)n;
				}
    break;

  case 578:
/* Line 1787 of yacc.c  */
#line 3918 "gram.y"
    {
					AlterExtensionContentsStmt *n = makeNode(AlterExtensionContentsStmt);
					n->extname = (yyvsp[(3) - (6)].str);
					n->action = (yyvsp[(4) - (6)].ival);
					n->objtype = OBJECT_TABLE;
					n->objname = (yyvsp[(6) - (6)].list);
					(yyval.node) = (Node *)n;
				}
    break;

  case 579:
/* Line 1787 of yacc.c  */
#line 3927 "gram.y"
    {
					AlterExtensionContentsStmt *n = makeNode(AlterExtensionContentsStmt);
					n->extname = (yyvsp[(3) - (8)].str);
					n->action = (yyvsp[(4) - (8)].ival);
					n->objtype = OBJECT_TSPARSER;
					n->objname = (yyvsp[(8) - (8)].list);
					(yyval.node) = (Node *)n;
				}
    break;

  case 580:
/* Line 1787 of yacc.c  */
#line 3936 "gram.y"
    {
					AlterExtensionContentsStmt *n = makeNode(AlterExtensionContentsStmt);
					n->extname = (yyvsp[(3) - (8)].str);
					n->action = (yyvsp[(4) - (8)].ival);
					n->objtype = OBJECT_TSDICTIONARY;
					n->objname = (yyvsp[(8) - (8)].list);
					(yyval.node) = (Node *)n;
				}
    break;

  case 581:
/* Line 1787 of yacc.c  */
#line 3945 "gram.y"
    {
					AlterExtensionContentsStmt *n = makeNode(AlterExtensionContentsStmt);
					n->extname = (yyvsp[(3) - (8)].str);
					n->action = (yyvsp[(4) - (8)].ival);
					n->objtype = OBJECT_TSTEMPLATE;
					n->objname = (yyvsp[(8) - (8)].list);
					(yyval.node) = (Node *)n;
				}
    break;

  case 582:
/* Line 1787 of yacc.c  */
#line 3954 "gram.y"
    {
					AlterExtensionContentsStmt *n = makeNode(AlterExtensionContentsStmt);
					n->extname = (yyvsp[(3) - (8)].str);
					n->action = (yyvsp[(4) - (8)].ival);
					n->objtype = OBJECT_TSCONFIGURATION;
					n->objname = (yyvsp[(8) - (8)].list);
					(yyval.node) = (Node *)n;
				}
    break;

  case 583:
/* Line 1787 of yacc.c  */
#line 3963 "gram.y"
    {
					AlterExtensionContentsStmt *n = makeNode(AlterExtensionContentsStmt);
					n->extname = (yyvsp[(3) - (6)].str);
					n->action = (yyvsp[(4) - (6)].ival);
					n->objtype = OBJECT_SEQUENCE;
					n->objname = (yyvsp[(6) - (6)].list);
					(yyval.node) = (Node *)n;
				}
    break;

  case 584:
/* Line 1787 of yacc.c  */
#line 3972 "gram.y"
    {
					AlterExtensionContentsStmt *n = makeNode(AlterExtensionContentsStmt);
					n->extname = (yyvsp[(3) - (6)].str);
					n->action = (yyvsp[(4) - (6)].ival);
					n->objtype = OBJECT_VIEW;
					n->objname = (yyvsp[(6) - (6)].list);
					(yyval.node) = (Node *)n;
				}
    break;

  case 585:
/* Line 1787 of yacc.c  */
#line 3981 "gram.y"
    {
					AlterExtensionContentsStmt *n = makeNode(AlterExtensionContentsStmt);
					n->extname = (yyvsp[(3) - (7)].str);
					n->action = (yyvsp[(4) - (7)].ival);
					n->objtype = OBJECT_MATVIEW;
					n->objname = (yyvsp[(7) - (7)].list);
					(yyval.node) = (Node *)n;
				}
    break;

  case 586:
/* Line 1787 of yacc.c  */
#line 3990 "gram.y"
    {
					AlterExtensionContentsStmt *n = makeNode(AlterExtensionContentsStmt);
					n->extname = (yyvsp[(3) - (7)].str);
					n->action = (yyvsp[(4) - (7)].ival);
					n->objtype = OBJECT_FOREIGN_TABLE;
					n->objname = (yyvsp[(7) - (7)].list);
					(yyval.node) = (Node *)n;
				}
    break;

  case 587:
/* Line 1787 of yacc.c  */
#line 3999 "gram.y"
    {
					AlterExtensionContentsStmt *n = makeNode(AlterExtensionContentsStmt);
					n->extname = (yyvsp[(3) - (8)].str);
					n->action = (yyvsp[(4) - (8)].ival);
					n->objtype = OBJECT_FDW;
					n->objname = list_make1(makeString((yyvsp[(8) - (8)].str)));
					(yyval.node) = (Node *)n;
				}
    break;

  case 588:
/* Line 1787 of yacc.c  */
#line 4008 "gram.y"
    {
					AlterExtensionContentsStmt *n = makeNode(AlterExtensionContentsStmt);
					n->extname = (yyvsp[(3) - (6)].str);
					n->action = (yyvsp[(4) - (6)].ival);
					n->objtype = OBJECT_FOREIGN_SERVER;
					n->objname = list_make1(makeString((yyvsp[(6) - (6)].str)));
					(yyval.node) = (Node *)n;
				}
    break;

  case 589:
/* Line 1787 of yacc.c  */
#line 4017 "gram.y"
    {
					AlterExtensionContentsStmt *n = makeNode(AlterExtensionContentsStmt);
					n->extname = (yyvsp[(3) - (6)].str);
					n->action = (yyvsp[(4) - (6)].ival);
					n->objtype = OBJECT_TYPE;
					n->objname = (yyvsp[(6) - (6)].list);
					(yyval.node) = (Node *)n;
				}
    break;

  case 590:
/* Line 1787 of yacc.c  */
#line 4035 "gram.y"
    {
					CreateFdwStmt *n = makeNode(CreateFdwStmt);
					n->fdwname = (yyvsp[(5) - (7)].str);
					n->func_options = (yyvsp[(6) - (7)].list);
					n->options = (yyvsp[(7) - (7)].list);
					(yyval.node) = (Node *) n;
				}
    break;

  case 591:
/* Line 1787 of yacc.c  */
#line 4045 "gram.y"
    { (yyval.defelt) = makeDefElem("handler", (Node *)(yyvsp[(2) - (2)].list)); }
    break;

  case 592:
/* Line 1787 of yacc.c  */
#line 4046 "gram.y"
    { (yyval.defelt) = makeDefElem("handler", NULL); }
    break;

  case 593:
/* Line 1787 of yacc.c  */
#line 4047 "gram.y"
    { (yyval.defelt) = makeDefElem("validator", (Node *)(yyvsp[(2) - (2)].list)); }
    break;

  case 594:
/* Line 1787 of yacc.c  */
#line 4048 "gram.y"
    { (yyval.defelt) = makeDefElem("validator", NULL); }
    break;

  case 595:
/* Line 1787 of yacc.c  */
#line 4052 "gram.y"
    { (yyval.list) = list_make1((yyvsp[(1) - (1)].defelt)); }
    break;

  case 596:
/* Line 1787 of yacc.c  */
#line 4053 "gram.y"
    { (yyval.list) = lappend((yyvsp[(1) - (2)].list), (yyvsp[(2) - (2)].defelt)); }
    break;

  case 597:
/* Line 1787 of yacc.c  */
#line 4057 "gram.y"
    { (yyval.list) = (yyvsp[(1) - (1)].list); }
    break;

  case 598:
/* Line 1787 of yacc.c  */
#line 4058 "gram.y"
    { (yyval.list) = NIL; }
    break;

  case 599:
/* Line 1787 of yacc.c  */
#line 4069 "gram.y"
    {
					DropStmt *n = makeNode(DropStmt);
					n->removeType = OBJECT_FDW;
					n->objects = list_make1(list_make1(makeString((yyvsp[(5) - (6)].str))));
					n->arguments = NIL;
					n->missing_ok = false;
					n->behavior = (yyvsp[(6) - (6)].dbehavior);
					n->concurrent = false;
					(yyval.node) = (Node *) n;
				}
    break;

  case 600:
/* Line 1787 of yacc.c  */
#line 4080 "gram.y"
    {
					DropStmt *n = makeNode(DropStmt);
					n->removeType = OBJECT_FDW;
					n->objects = list_make1(list_make1(makeString((yyvsp[(7) - (8)].str))));
					n->arguments = NIL;
					n->missing_ok = true;
					n->behavior = (yyvsp[(8) - (8)].dbehavior);
					n->concurrent = false;
					(yyval.node) = (Node *) n;
				}
    break;

  case 601:
/* Line 1787 of yacc.c  */
#line 4100 "gram.y"
    {
					AlterFdwStmt *n = makeNode(AlterFdwStmt);
					n->fdwname = (yyvsp[(5) - (7)].str);
					n->func_options = (yyvsp[(6) - (7)].list);
					n->options = (yyvsp[(7) - (7)].list);
					(yyval.node) = (Node *) n;
				}
    break;

  case 602:
/* Line 1787 of yacc.c  */
#line 4108 "gram.y"
    {
					AlterFdwStmt *n = makeNode(AlterFdwStmt);
					n->fdwname = (yyvsp[(5) - (6)].str);
					n->func_options = (yyvsp[(6) - (6)].list);
					n->options = NIL;
					(yyval.node) = (Node *) n;
				}
    break;

  case 603:
/* Line 1787 of yacc.c  */
#line 4119 "gram.y"
    { (yyval.list) = (yyvsp[(3) - (4)].list); }
    break;

  case 604:
/* Line 1787 of yacc.c  */
#line 4120 "gram.y"
    { (yyval.list) = NIL; }
    break;

  case 605:
/* Line 1787 of yacc.c  */
#line 4125 "gram.y"
    {
					(yyval.list) = list_make1((yyvsp[(1) - (1)].defelt));
				}
    break;

  case 606:
/* Line 1787 of yacc.c  */
#line 4129 "gram.y"
    {
					(yyval.list) = lappend((yyvsp[(1) - (3)].list), (yyvsp[(3) - (3)].defelt));
				}
    break;

  case 607:
/* Line 1787 of yacc.c  */
#line 4136 "gram.y"
    { (yyval.list) = (yyvsp[(3) - (4)].list); }
    break;

  case 608:
/* Line 1787 of yacc.c  */
#line 4141 "gram.y"
    {
					(yyval.list) = list_make1((yyvsp[(1) - (1)].defelt));
				}
    break;

  case 609:
/* Line 1787 of yacc.c  */
#line 4145 "gram.y"
    {
					(yyval.list) = lappend((yyvsp[(1) - (3)].list), (yyvsp[(3) - (3)].defelt));
				}
    break;

  case 610:
/* Line 1787 of yacc.c  */
#line 4152 "gram.y"
    {
					(yyval.defelt) = (yyvsp[(1) - (1)].defelt);
				}
    break;

  case 611:
/* Line 1787 of yacc.c  */
#line 4156 "gram.y"
    {
					(yyval.defelt) = (yyvsp[(2) - (2)].defelt);
					(yyval.defelt)->defaction = DEFELEM_SET;
				}
    break;

  case 612:
/* Line 1787 of yacc.c  */
#line 4161 "gram.y"
    {
					(yyval.defelt) = (yyvsp[(2) - (2)].defelt);
					(yyval.defelt)->defaction = DEFELEM_ADD;
				}
    break;

  case 613:
/* Line 1787 of yacc.c  */
#line 4166 "gram.y"
    {
					(yyval.defelt) = makeDefElemExtended(NULL, (yyvsp[(2) - (2)].str), NULL, DEFELEM_DROP);
				}
    break;

  case 614:
/* Line 1787 of yacc.c  */
#line 4173 "gram.y"
    {
					(yyval.defelt) = makeDefElem((yyvsp[(1) - (2)].str), (yyvsp[(2) - (2)].node));
				}
    break;

  case 615:
/* Line 1787 of yacc.c  */
#line 4179 "gram.y"
    { (yyval.str) = (yyvsp[(1) - (1)].str); }
    break;

  case 616:
/* Line 1787 of yacc.c  */
#line 4184 "gram.y"
    { (yyval.node) = (Node *) makeString((yyvsp[(1) - (1)].str)); }
    break;

  case 617:
/* Line 1787 of yacc.c  */
#line 4196 "gram.y"
    {
					CreateForeignServerStmt *n = makeNode(CreateForeignServerStmt);
					n->servername = (yyvsp[(3) - (10)].str);
					n->servertype = (yyvsp[(4) - (10)].str);
					n->version = (yyvsp[(5) - (10)].str);
					n->fdwname = (yyvsp[(9) - (10)].str);
					n->options = (yyvsp[(10) - (10)].list);
					(yyval.node) = (Node *) n;
				}
    break;

  case 618:
/* Line 1787 of yacc.c  */
#line 4208 "gram.y"
    { (yyval.str) = (yyvsp[(2) - (2)].str); }
    break;

  case 619:
/* Line 1787 of yacc.c  */
#line 4209 "gram.y"
    { (yyval.str) = NULL; }
    break;

  case 620:
/* Line 1787 of yacc.c  */
#line 4214 "gram.y"
    { (yyval.str) = (yyvsp[(2) - (2)].str); }
    break;

  case 621:
/* Line 1787 of yacc.c  */
#line 4215 "gram.y"
    { (yyval.str) = NULL; }
    break;

  case 622:
/* Line 1787 of yacc.c  */
#line 4219 "gram.y"
    { (yyval.str) = (yyvsp[(1) - (1)].str); }
    break;

  case 623:
/* Line 1787 of yacc.c  */
#line 4220 "gram.y"
    { (yyval.str) = NULL; }
    break;

  case 624:
/* Line 1787 of yacc.c  */
#line 4231 "gram.y"
    {
					DropStmt *n = makeNode(DropStmt);
					n->removeType = OBJECT_FOREIGN_SERVER;
					n->objects = list_make1(list_make1(makeString((yyvsp[(3) - (4)].str))));
					n->arguments = NIL;
					n->missing_ok = false;
					n->behavior = (yyvsp[(4) - (4)].dbehavior);
					n->concurrent = false;
					(yyval.node) = (Node *) n;
				}
    break;

  case 625:
/* Line 1787 of yacc.c  */
#line 4242 "gram.y"
    {
					DropStmt *n = makeNode(DropStmt);
					n->removeType = OBJECT_FOREIGN_SERVER;
					n->objects = list_make1(list_make1(makeString((yyvsp[(5) - (6)].str))));
					n->arguments = NIL;
					n->missing_ok = true;
					n->behavior = (yyvsp[(6) - (6)].dbehavior);
					n->concurrent = false;
					(yyval.node) = (Node *) n;
				}
    break;

  case 626:
/* Line 1787 of yacc.c  */
#line 4262 "gram.y"
    {
					AlterForeignServerStmt *n = makeNode(AlterForeignServerStmt);
					n->servername = (yyvsp[(3) - (5)].str);
					n->version = (yyvsp[(4) - (5)].str);
					n->options = (yyvsp[(5) - (5)].list);
					n->has_version = true;
					(yyval.node) = (Node *) n;
				}
    break;

  case 627:
/* Line 1787 of yacc.c  */
#line 4271 "gram.y"
    {
					AlterForeignServerStmt *n = makeNode(AlterForeignServerStmt);
					n->servername = (yyvsp[(3) - (4)].str);
					n->version = (yyvsp[(4) - (4)].str);
					n->has_version = true;
					(yyval.node) = (Node *) n;
				}
    break;

  case 628:
/* Line 1787 of yacc.c  */
#line 4279 "gram.y"
    {
					AlterForeignServerStmt *n = makeNode(AlterForeignServerStmt);
					n->servername = (yyvsp[(3) - (4)].str);
					n->options = (yyvsp[(4) - (4)].list);
					(yyval.node) = (Node *) n;
				}
    break;

  case 629:
/* Line 1787 of yacc.c  */
#line 4298 "gram.y"
    {
					CreateForeignTableStmt *n = makeNode(CreateForeignTableStmt);
					(yyvsp[(4) - (10)].range)->relpersistence = RELPERSISTENCE_PERMANENT;
					n->base.relation = (yyvsp[(4) - (10)].range);
					n->base.tableElts = (yyvsp[(6) - (10)].list);
					n->base.inhRelations = NIL;
					n->base.if_not_exists = false;
					/* FDW-specific data */
					n->servername = (yyvsp[(9) - (10)].str);
					n->options = (yyvsp[(10) - (10)].list);
					(yyval.node) = (Node *) n;
				}
    break;

  case 630:
/* Line 1787 of yacc.c  */
#line 4313 "gram.y"
    {
					CreateForeignTableStmt *n = makeNode(CreateForeignTableStmt);
					(yyvsp[(7) - (13)].range)->relpersistence = RELPERSISTENCE_PERMANENT;
					n->base.relation = (yyvsp[(7) - (13)].range);
					n->base.tableElts = (yyvsp[(9) - (13)].list);
					n->base.inhRelations = NIL;
					n->base.if_not_exists = true;
					/* FDW-specific data */
					n->servername = (yyvsp[(12) - (13)].str);
					n->options = (yyvsp[(13) - (13)].list);
					(yyval.node) = (Node *) n;
				}
    break;

  case 631:
/* Line 1787 of yacc.c  */
#line 4336 "gram.y"
    {
					AlterTableStmt *n = makeNode(AlterTableStmt);
					n->relation = (yyvsp[(4) - (5)].range);
					n->cmds = (yyvsp[(5) - (5)].list);
					n->relkind = OBJECT_FOREIGN_TABLE;
					n->missing_ok = false;
					(yyval.node) = (Node *)n;
				}
    break;

  case 632:
/* Line 1787 of yacc.c  */
#line 4345 "gram.y"
    {
					AlterTableStmt *n = makeNode(AlterTableStmt);
					n->relation = (yyvsp[(6) - (7)].range);
					n->cmds = (yyvsp[(7) - (7)].list);
					n->relkind = OBJECT_FOREIGN_TABLE;
					n->missing_ok = true;
					(yyval.node) = (Node *)n;
				}
    break;

  case 633:
/* Line 1787 of yacc.c  */
#line 4363 "gram.y"
    {
					CreateUserMappingStmt *n = makeNode(CreateUserMappingStmt);
					n->username = (yyvsp[(5) - (8)].str);
					n->servername = (yyvsp[(7) - (8)].str);
					n->options = (yyvsp[(8) - (8)].list);
					(yyval.node) = (Node *) n;
				}
    break;

  case 634:
/* Line 1787 of yacc.c  */
#line 4374 "gram.y"
    { (yyval.str) = "current_user"; }
    break;

  case 635:
/* Line 1787 of yacc.c  */
#line 4375 "gram.y"
    { (yyval.str) = "current_user"; }
    break;

  case 636:
/* Line 1787 of yacc.c  */
#line 4376 "gram.y"
    { (yyval.str) = (strcmp((yyvsp[(1) - (1)].str), "public") == 0) ? NULL : (yyvsp[(1) - (1)].str); }
    break;

  case 637:
/* Line 1787 of yacc.c  */
#line 4387 "gram.y"
    {
					DropUserMappingStmt *n = makeNode(DropUserMappingStmt);
					n->username = (yyvsp[(5) - (7)].str);
					n->servername = (yyvsp[(7) - (7)].str);
					n->missing_ok = false;
					(yyval.node) = (Node *) n;
				}
    break;

  case 638:
/* Line 1787 of yacc.c  */
#line 4395 "gram.y"
    {
					DropUserMappingStmt *n = makeNode(DropUserMappingStmt);
					n->username = (yyvsp[(7) - (9)].str);
					n->servername = (yyvsp[(9) - (9)].str);
					n->missing_ok = true;
					(yyval.node) = (Node *) n;
				}
    break;

  case 639:
/* Line 1787 of yacc.c  */
#line 4412 "gram.y"
    {
					AlterUserMappingStmt *n = makeNode(AlterUserMappingStmt);
					n->username = (yyvsp[(5) - (8)].str);
					n->servername = (yyvsp[(7) - (8)].str);
					n->options = (yyvsp[(8) - (8)].list);
					(yyval.node) = (Node *) n;
				}
    break;

  case 640:
/* Line 1787 of yacc.c  */
#line 4433 "gram.y"
    {
					CreateTrigStmt *n = makeNode(CreateTrigStmt);
					n->trigname = (yyvsp[(3) - (15)].str);
					n->relation = (yyvsp[(7) - (15)].range);
					n->funcname = (yyvsp[(12) - (15)].list);
					n->args = (yyvsp[(14) - (15)].list);
					n->row = (yyvsp[(8) - (15)].boolean);
					n->timing = (yyvsp[(4) - (15)].ival);
					n->events = intVal(linitial((yyvsp[(5) - (15)].list)));
					n->columns = (List *) lsecond((yyvsp[(5) - (15)].list));
					n->whenClause = (yyvsp[(9) - (15)].node);
					n->isconstraint  = FALSE;
					n->deferrable	 = FALSE;
					n->initdeferred  = FALSE;
					n->constrrel = NULL;
					(yyval.node) = (Node *)n;
				}
    break;

  case 641:
/* Line 1787 of yacc.c  */
#line 4454 "gram.y"
    {
					CreateTrigStmt *n = makeNode(CreateTrigStmt);
					n->trigname = (yyvsp[(4) - (20)].str);
					n->relation = (yyvsp[(8) - (20)].range);
					n->funcname = (yyvsp[(17) - (20)].list);
					n->args = (yyvsp[(19) - (20)].list);
					n->row = TRUE;
					n->timing = TRIGGER_TYPE_AFTER;
					n->events = intVal(linitial((yyvsp[(6) - (20)].list)));
					n->columns = (List *) lsecond((yyvsp[(6) - (20)].list));
					n->whenClause = (yyvsp[(14) - (20)].node);
					n->isconstraint  = TRUE;
					processCASbits((yyvsp[(10) - (20)].ival), (yylsp[(10) - (20)]), "TRIGGER",
								   &n->deferrable, &n->initdeferred, NULL,
								   NULL, yyscanner);
					n->constrrel = (yyvsp[(9) - (20)].range);
					(yyval.node) = (Node *)n;
				}
    break;

  case 642:
/* Line 1787 of yacc.c  */
#line 4475 "gram.y"
    { (yyval.ival) = TRIGGER_TYPE_BEFORE; }
    break;

  case 643:
/* Line 1787 of yacc.c  */
#line 4476 "gram.y"
    { (yyval.ival) = TRIGGER_TYPE_AFTER; }
    break;

  case 644:
/* Line 1787 of yacc.c  */
#line 4477 "gram.y"
    { (yyval.ival) = TRIGGER_TYPE_INSTEAD; }
    break;

  case 645:
/* Line 1787 of yacc.c  */
#line 4482 "gram.y"
    { (yyval.list) = (yyvsp[(1) - (1)].list); }
    break;

  case 646:
/* Line 1787 of yacc.c  */
#line 4484 "gram.y"
    {
					int		events1 = intVal(linitial((yyvsp[(1) - (3)].list)));
					int		events2 = intVal(linitial((yyvsp[(3) - (3)].list)));
					List   *columns1 = (List *) lsecond((yyvsp[(1) - (3)].list));
					List   *columns2 = (List *) lsecond((yyvsp[(3) - (3)].list));

					if (events1 & events2)
						parser_yyerror("duplicate trigger events specified");
					/*
					 * concat'ing the columns lists loses information about
					 * which columns went with which event, but so long as
					 * only UPDATE carries columns and we disallow multiple
					 * UPDATE items, it doesn't matter.  Command execution
					 * should just ignore the columns for non-UPDATE events.
					 */
					(yyval.list) = list_make2(makeInteger(events1 | events2),
									list_concat(columns1, columns2));
				}
    break;

  case 647:
/* Line 1787 of yacc.c  */
#line 4506 "gram.y"
    { (yyval.list) = list_make2(makeInteger(TRIGGER_TYPE_INSERT), NIL); }
    break;

  case 648:
/* Line 1787 of yacc.c  */
#line 4508 "gram.y"
    { (yyval.list) = list_make2(makeInteger(TRIGGER_TYPE_DELETE), NIL); }
    break;

  case 649:
/* Line 1787 of yacc.c  */
#line 4510 "gram.y"
    { (yyval.list) = list_make2(makeInteger(TRIGGER_TYPE_UPDATE), NIL); }
    break;

  case 650:
/* Line 1787 of yacc.c  */
#line 4512 "gram.y"
    { (yyval.list) = list_make2(makeInteger(TRIGGER_TYPE_UPDATE), (yyvsp[(3) - (3)].list)); }
    break;

  case 651:
/* Line 1787 of yacc.c  */
#line 4514 "gram.y"
    { (yyval.list) = list_make2(makeInteger(TRIGGER_TYPE_TRUNCATE), NIL); }
    break;

  case 652:
/* Line 1787 of yacc.c  */
#line 4519 "gram.y"
    {
					(yyval.boolean) = (yyvsp[(3) - (3)].boolean);
				}
    break;

  case 653:
/* Line 1787 of yacc.c  */
#line 4523 "gram.y"
    {
					/*
					 * If ROW/STATEMENT not specified, default to
					 * STATEMENT, per SQL
					 */
					(yyval.boolean) = FALSE;
				}
    break;

  case 654:
/* Line 1787 of yacc.c  */
#line 4533 "gram.y"
    {}
    break;

  case 655:
/* Line 1787 of yacc.c  */
#line 4534 "gram.y"
    {}
    break;

  case 656:
/* Line 1787 of yacc.c  */
#line 4538 "gram.y"
    { (yyval.boolean) = TRUE; }
    break;

  case 657:
/* Line 1787 of yacc.c  */
#line 4539 "gram.y"
    { (yyval.boolean) = FALSE; }
    break;

  case 658:
/* Line 1787 of yacc.c  */
#line 4543 "gram.y"
    { (yyval.node) = (yyvsp[(3) - (4)].node); }
    break;

  case 659:
/* Line 1787 of yacc.c  */
#line 4544 "gram.y"
    { (yyval.node) = NULL; }
    break;

  case 660:
/* Line 1787 of yacc.c  */
#line 4548 "gram.y"
    { (yyval.list) = list_make1((yyvsp[(1) - (1)].value)); }
    break;

  case 661:
/* Line 1787 of yacc.c  */
#line 4549 "gram.y"
    { (yyval.list) = lappend((yyvsp[(1) - (3)].list), (yyvsp[(3) - (3)].value)); }
    break;

  case 662:
/* Line 1787 of yacc.c  */
#line 4550 "gram.y"
    { (yyval.list) = NIL; }
    break;

  case 663:
/* Line 1787 of yacc.c  */
#line 4555 "gram.y"
    {
					char buf[64];
					snprintf(buf, sizeof(buf), "%d", (yyvsp[(1) - (1)].ival));
					(yyval.value) = makeString(pstrdup(buf));
				}
    break;

  case 664:
/* Line 1787 of yacc.c  */
#line 4560 "gram.y"
    { (yyval.value) = makeString((yyvsp[(1) - (1)].str)); }
    break;

  case 665:
/* Line 1787 of yacc.c  */
#line 4561 "gram.y"
    { (yyval.value) = makeString((yyvsp[(1) - (1)].str)); }
    break;

  case 666:
/* Line 1787 of yacc.c  */
#line 4562 "gram.y"
    { (yyval.value) = makeString((yyvsp[(1) - (1)].str)); }
    break;

  case 667:
/* Line 1787 of yacc.c  */
#line 4566 "gram.y"
    { (yyval.range) = (yyvsp[(2) - (2)].range); }
    break;

  case 668:
/* Line 1787 of yacc.c  */
#line 4567 "gram.y"
    { (yyval.range) = NULL; }
    break;

  case 669:
/* Line 1787 of yacc.c  */
#line 4572 "gram.y"
    { (yyval.ival) = 0; }
    break;

  case 670:
/* Line 1787 of yacc.c  */
#line 4574 "gram.y"
    {
					/*
					 * We must complain about conflicting options.
					 * We could, but choose not to, complain about redundant
					 * options (ie, where $2's bit is already set in $1).
					 */
					int		newspec = (yyvsp[(1) - (2)].ival) | (yyvsp[(2) - (2)].ival);

					/* special message for this case */
					if ((newspec & (CAS_NOT_DEFERRABLE | CAS_INITIALLY_DEFERRED)) == (CAS_NOT_DEFERRABLE | CAS_INITIALLY_DEFERRED))
						ereport(ERROR,
								(errcode(ERRCODE_SYNTAX_ERROR),
								 errmsg("constraint declared INITIALLY DEFERRED must be DEFERRABLE"),
								 parser_errposition((yylsp[(2) - (2)]))));
					/* generic message for other conflicts */
					if ((newspec & (CAS_NOT_DEFERRABLE | CAS_DEFERRABLE)) == (CAS_NOT_DEFERRABLE | CAS_DEFERRABLE) ||
						(newspec & (CAS_INITIALLY_IMMEDIATE | CAS_INITIALLY_DEFERRED)) == (CAS_INITIALLY_IMMEDIATE | CAS_INITIALLY_DEFERRED))
						ereport(ERROR,
								(errcode(ERRCODE_SYNTAX_ERROR),
								 errmsg("conflicting constraint properties"),
								 parser_errposition((yylsp[(2) - (2)]))));
					(yyval.ival) = newspec;
				}
    break;

  case 671:
/* Line 1787 of yacc.c  */
#line 4600 "gram.y"
    { (yyval.ival) = CAS_NOT_DEFERRABLE; }
    break;

  case 672:
/* Line 1787 of yacc.c  */
#line 4601 "gram.y"
    { (yyval.ival) = CAS_DEFERRABLE; }
    break;

  case 673:
/* Line 1787 of yacc.c  */
#line 4602 "gram.y"
    { (yyval.ival) = CAS_INITIALLY_IMMEDIATE; }
    break;

  case 674:
/* Line 1787 of yacc.c  */
#line 4603 "gram.y"
    { (yyval.ival) = CAS_INITIALLY_DEFERRED; }
    break;

  case 675:
/* Line 1787 of yacc.c  */
#line 4604 "gram.y"
    { (yyval.ival) = CAS_NOT_VALID; }
    break;

  case 676:
/* Line 1787 of yacc.c  */
#line 4605 "gram.y"
    { (yyval.ival) = CAS_NO_INHERIT; }
    break;

  case 677:
/* Line 1787 of yacc.c  */
#line 4611 "gram.y"
    {
					DropStmt *n = makeNode(DropStmt);
					n->removeType = OBJECT_TRIGGER;
					n->objects = list_make1(lappend((yyvsp[(5) - (6)].list), makeString((yyvsp[(3) - (6)].str))));
					n->arguments = NIL;
					n->behavior = (yyvsp[(6) - (6)].dbehavior);
					n->missing_ok = false;
					n->concurrent = false;
					(yyval.node) = (Node *) n;
				}
    break;

  case 678:
/* Line 1787 of yacc.c  */
#line 4622 "gram.y"
    {
					DropStmt *n = makeNode(DropStmt);
					n->removeType = OBJECT_TRIGGER;
					n->objects = list_make1(lappend((yyvsp[(7) - (8)].list), makeString((yyvsp[(5) - (8)].str))));
					n->arguments = NIL;
					n->behavior = (yyvsp[(8) - (8)].dbehavior);
					n->missing_ok = true;
					n->concurrent = false;
					(yyval.node) = (Node *) n;
				}
    break;

  case 679:
/* Line 1787 of yacc.c  */
#line 4646 "gram.y"
    {
					CreateEventTrigStmt *n = makeNode(CreateEventTrigStmt);
					n->trigname = (yyvsp[(4) - (11)].str);
					n->eventname = (yyvsp[(6) - (11)].str);
					n->whenclause = NULL;
					n->funcname = (yyvsp[(9) - (11)].list);
					(yyval.node) = (Node *)n;
				}
    break;

  case 680:
/* Line 1787 of yacc.c  */
#line 4657 "gram.y"
    {
					CreateEventTrigStmt *n = makeNode(CreateEventTrigStmt);
					n->trigname = (yyvsp[(4) - (13)].str);
					n->eventname = (yyvsp[(6) - (13)].str);
					n->whenclause = (yyvsp[(8) - (13)].list);
					n->funcname = (yyvsp[(11) - (13)].list);
					(yyval.node) = (Node *)n;
				}
    break;

  case 681:
/* Line 1787 of yacc.c  */
#line 4669 "gram.y"
    { (yyval.list) = list_make1((yyvsp[(1) - (1)].defelt)); }
    break;

  case 682:
/* Line 1787 of yacc.c  */
#line 4671 "gram.y"
    { (yyval.list) = lappend((yyvsp[(1) - (3)].list), (yyvsp[(3) - (3)].defelt)); }
    break;

  case 683:
/* Line 1787 of yacc.c  */
#line 4676 "gram.y"
    { (yyval.defelt) = makeDefElem((yyvsp[(1) - (5)].str), (Node *) (yyvsp[(4) - (5)].list)); }
    break;

  case 684:
/* Line 1787 of yacc.c  */
#line 4681 "gram.y"
    { (yyval.list) = list_make1(makeString((yyvsp[(1) - (1)].str))); }
    break;

  case 685:
/* Line 1787 of yacc.c  */
#line 4683 "gram.y"
    { (yyval.list) = lappend((yyvsp[(1) - (3)].list), makeString((yyvsp[(3) - (3)].str))); }
    break;

  case 686:
/* Line 1787 of yacc.c  */
#line 4688 "gram.y"
    {
					AlterEventTrigStmt *n = makeNode(AlterEventTrigStmt);
					n->trigname = (yyvsp[(4) - (5)].str);
					n->tgenabled = (yyvsp[(5) - (5)].chr);
					(yyval.node) = (Node *) n;
				}
    break;

  case 687:
/* Line 1787 of yacc.c  */
#line 4697 "gram.y"
    { (yyval.chr) = TRIGGER_FIRES_ON_ORIGIN; }
    break;

  case 688:
/* Line 1787 of yacc.c  */
#line 4698 "gram.y"
    { (yyval.chr) = TRIGGER_FIRES_ON_REPLICA; }
    break;

  case 689:
/* Line 1787 of yacc.c  */
#line 4699 "gram.y"
    { (yyval.chr) = TRIGGER_FIRES_ALWAYS; }
    break;

  case 690:
/* Line 1787 of yacc.c  */
#line 4700 "gram.y"
    { (yyval.chr) = TRIGGER_DISABLED; }
    break;

  case 691:
/* Line 1787 of yacc.c  */
#line 4714 "gram.y"
    {
					CreateTrigStmt *n = makeNode(CreateTrigStmt);
					n->trigname = (yyvsp[(3) - (8)].str);
					n->args = list_make1((yyvsp[(6) - (8)].node));
					n->isconstraint  = TRUE;
					processCASbits((yyvsp[(8) - (8)].ival), (yylsp[(8) - (8)]), "ASSERTION",
								   &n->deferrable, &n->initdeferred, NULL,
								   NULL, yyscanner);

					ereport(ERROR,
							(errcode(ERRCODE_FEATURE_NOT_SUPPORTED),
							 errmsg("CREATE ASSERTION is not yet implemented")));

					(yyval.node) = (Node *)n;
				}
    break;

  case 692:
/* Line 1787 of yacc.c  */
#line 4733 "gram.y"
    {
					DropStmt *n = makeNode(DropStmt);
					n->objects = NIL;
					n->arguments = NIL;
					n->behavior = (yyvsp[(4) - (4)].dbehavior);
					n->removeType = OBJECT_TRIGGER; /* XXX */
					ereport(ERROR,
							(errcode(ERRCODE_FEATURE_NOT_SUPPORTED),
							 errmsg("DROP ASSERTION is not yet implemented")));
					(yyval.node) = (Node *) n;
				}
    break;

  case 693:
/* Line 1787 of yacc.c  */
#line 4756 "gram.y"
    {
					DefineStmt *n = makeNode(DefineStmt);
					n->kind = OBJECT_AGGREGATE;
					n->oldstyle = false;
					n->defnames = (yyvsp[(3) - (5)].list);
					n->args = (yyvsp[(4) - (5)].list);
					n->definition = (yyvsp[(5) - (5)].list);
					(yyval.node) = (Node *)n;
				}
    break;

  case 694:
/* Line 1787 of yacc.c  */
#line 4766 "gram.y"
    {
					/* old-style (pre-8.2) syntax for CREATE AGGREGATE */
					DefineStmt *n = makeNode(DefineStmt);
					n->kind = OBJECT_AGGREGATE;
					n->oldstyle = true;
					n->defnames = (yyvsp[(3) - (4)].list);
					n->args = NIL;
					n->definition = (yyvsp[(4) - (4)].list);
					(yyval.node) = (Node *)n;
				}
    break;

  case 695:
/* Line 1787 of yacc.c  */
#line 4777 "gram.y"
    {
					DefineStmt *n = makeNode(DefineStmt);
					n->kind = OBJECT_OPERATOR;
					n->oldstyle = false;
					n->defnames = (yyvsp[(3) - (4)].list);
					n->args = NIL;
					n->definition = (yyvsp[(4) - (4)].list);
					(yyval.node) = (Node *)n;
				}
    break;

  case 696:
/* Line 1787 of yacc.c  */
#line 4787 "gram.y"
    {
					DefineStmt *n = makeNode(DefineStmt);
					n->kind = OBJECT_TYPE;
					n->oldstyle = false;
					n->defnames = (yyvsp[(3) - (4)].list);
					n->args = NIL;
					n->definition = (yyvsp[(4) - (4)].list);
					(yyval.node) = (Node *)n;
				}
    break;

  case 697:
/* Line 1787 of yacc.c  */
#line 4797 "gram.y"
    {
					/* Shell type (identified by lack of definition) */
					DefineStmt *n = makeNode(DefineStmt);
					n->kind = OBJECT_TYPE;
					n->oldstyle = false;
					n->defnames = (yyvsp[(3) - (3)].list);
					n->args = NIL;
					n->definition = NIL;
					(yyval.node) = (Node *)n;
				}
    break;

  case 698:
/* Line 1787 of yacc.c  */
#line 4808 "gram.y"
    {
					CompositeTypeStmt *n = makeNode(CompositeTypeStmt);

					/* can't use qualified_name, sigh */
					n->typevar = makeRangeVarFromAnyName((yyvsp[(3) - (7)].list), (yylsp[(3) - (7)]), yyscanner);
					n->coldeflist = (yyvsp[(6) - (7)].list);
					(yyval.node) = (Node *)n;
				}
    break;

  case 699:
/* Line 1787 of yacc.c  */
#line 4817 "gram.y"
    {
					CreateEnumStmt *n = makeNode(CreateEnumStmt);
					n->typeName = (yyvsp[(3) - (8)].list);
					n->vals = (yyvsp[(7) - (8)].list);
					(yyval.node) = (Node *)n;
				}
    break;

  case 700:
/* Line 1787 of yacc.c  */
#line 4824 "gram.y"
    {
					CreateRangeStmt *n = makeNode(CreateRangeStmt);
					n->typeName = (yyvsp[(3) - (6)].list);
					n->params	= (yyvsp[(6) - (6)].list);
					(yyval.node) = (Node *)n;
				}
    break;

  case 701:
/* Line 1787 of yacc.c  */
#line 4831 "gram.y"
    {
					DefineStmt *n = makeNode(DefineStmt);
					n->kind = OBJECT_TSPARSER;
					n->args = NIL;
					n->defnames = (yyvsp[(5) - (6)].list);
					n->definition = (yyvsp[(6) - (6)].list);
					(yyval.node) = (Node *)n;
				}
    break;

  case 702:
/* Line 1787 of yacc.c  */
#line 4840 "gram.y"
    {
					DefineStmt *n = makeNode(DefineStmt);
					n->kind = OBJECT_TSDICTIONARY;
					n->args = NIL;
					n->defnames = (yyvsp[(5) - (6)].list);
					n->definition = (yyvsp[(6) - (6)].list);
					(yyval.node) = (Node *)n;
				}
    break;

  case 703:
/* Line 1787 of yacc.c  */
#line 4849 "gram.y"
    {
					DefineStmt *n = makeNode(DefineStmt);
					n->kind = OBJECT_TSTEMPLATE;
					n->args = NIL;
					n->defnames = (yyvsp[(5) - (6)].list);
					n->definition = (yyvsp[(6) - (6)].list);
					(yyval.node) = (Node *)n;
				}
    break;

  case 704:
/* Line 1787 of yacc.c  */
#line 4858 "gram.y"
    {
					DefineStmt *n = makeNode(DefineStmt);
					n->kind = OBJECT_TSCONFIGURATION;
					n->args = NIL;
					n->defnames = (yyvsp[(5) - (6)].list);
					n->definition = (yyvsp[(6) - (6)].list);
					(yyval.node) = (Node *)n;
				}
    break;

  case 705:
/* Line 1787 of yacc.c  */
#line 4867 "gram.y"
    {
					DefineStmt *n = makeNode(DefineStmt);
					n->kind = OBJECT_COLLATION;
					n->args = NIL;
					n->defnames = (yyvsp[(3) - (4)].list);
					n->definition = (yyvsp[(4) - (4)].list);
					(yyval.node) = (Node *)n;
				}
    break;

  case 706:
/* Line 1787 of yacc.c  */
#line 4876 "gram.y"
    {
					DefineStmt *n = makeNode(DefineStmt);
					n->kind = OBJECT_COLLATION;
					n->args = NIL;
					n->defnames = (yyvsp[(3) - (5)].list);
					n->definition = list_make1(makeDefElem("from", (Node *) (yyvsp[(5) - (5)].list)));
					(yyval.node) = (Node *)n;
				}
    break;

  case 707:
/* Line 1787 of yacc.c  */
#line 4886 "gram.y"
    { (yyval.list) = (yyvsp[(2) - (3)].list); }
    break;

  case 708:
/* Line 1787 of yacc.c  */
#line 4889 "gram.y"
    { (yyval.list) = list_make1((yyvsp[(1) - (1)].defelt)); }
    break;

  case 709:
/* Line 1787 of yacc.c  */
#line 4890 "gram.y"
    { (yyval.list) = lappend((yyvsp[(1) - (3)].list), (yyvsp[(3) - (3)].defelt)); }
    break;

  case 710:
/* Line 1787 of yacc.c  */
#line 4894 "gram.y"
    {
					(yyval.defelt) = makeDefElem((yyvsp[(1) - (3)].str), (Node *) (yyvsp[(3) - (3)].node));
				}
    break;

  case 711:
/* Line 1787 of yacc.c  */
#line 4898 "gram.y"
    {
					(yyval.defelt) = makeDefElem((yyvsp[(1) - (1)].str), NULL);
				}
    break;

  case 712:
/* Line 1787 of yacc.c  */
#line 4904 "gram.y"
    { (yyval.node) = (Node *)(yyvsp[(1) - (1)].typnam); }
    break;

  case 713:
/* Line 1787 of yacc.c  */
#line 4905 "gram.y"
    { (yyval.node) = (Node *)makeString(pstrdup((yyvsp[(1) - (1)].keyword))); }
    break;

  case 714:
/* Line 1787 of yacc.c  */
#line 4906 "gram.y"
    { (yyval.node) = (Node *)(yyvsp[(1) - (1)].list); }
    break;

  case 715:
/* Line 1787 of yacc.c  */
#line 4907 "gram.y"
    { (yyval.node) = (Node *)(yyvsp[(1) - (1)].value); }
    break;

  case 716:
/* Line 1787 of yacc.c  */
#line 4908 "gram.y"
    { (yyval.node) = (Node *)makeString((yyvsp[(1) - (1)].str)); }
    break;

  case 717:
/* Line 1787 of yacc.c  */
#line 4911 "gram.y"
    { (yyval.list) = (yyvsp[(2) - (3)].list); }
    break;

  case 718:
/* Line 1787 of yacc.c  */
#line 4914 "gram.y"
    { (yyval.list) = list_make1((yyvsp[(1) - (1)].defelt)); }
    break;

  case 719:
/* Line 1787 of yacc.c  */
#line 4915 "gram.y"
    { (yyval.list) = lappend((yyvsp[(1) - (3)].list), (yyvsp[(3) - (3)].defelt)); }
    break;

  case 720:
/* Line 1787 of yacc.c  */
#line 4924 "gram.y"
    {
					(yyval.defelt) = makeDefElem((yyvsp[(1) - (3)].str), (Node *)(yyvsp[(3) - (3)].node));
				}
    break;

  case 721:
/* Line 1787 of yacc.c  */
#line 4930 "gram.y"
    { (yyval.list) = (yyvsp[(1) - (1)].list); }
    break;

  case 722:
/* Line 1787 of yacc.c  */
#line 4931 "gram.y"
    { (yyval.list) = NIL; }
    break;

  case 723:
/* Line 1787 of yacc.c  */
#line 4935 "gram.y"
    { (yyval.list) = list_make1(makeString((yyvsp[(1) - (1)].str))); }
    break;

  case 724:
/* Line 1787 of yacc.c  */
#line 4937 "gram.y"
    { (yyval.list) = lappend((yyvsp[(1) - (3)].list), makeString((yyvsp[(3) - (3)].str))); }
    break;

  case 725:
/* Line 1787 of yacc.c  */
#line 4948 "gram.y"
    {
				AlterEnumStmt *n = makeNode(AlterEnumStmt);
				n->typeName = (yyvsp[(3) - (7)].list);
				n->newVal = (yyvsp[(7) - (7)].str);
				n->newValNeighbor = NULL;
				n->newValIsAfter = true;
				n->skipIfExists = (yyvsp[(6) - (7)].boolean);
				(yyval.node) = (Node *) n;
			}
    break;

  case 726:
/* Line 1787 of yacc.c  */
#line 4958 "gram.y"
    {
				AlterEnumStmt *n = makeNode(AlterEnumStmt);
				n->typeName = (yyvsp[(3) - (9)].list);
				n->newVal = (yyvsp[(7) - (9)].str);
				n->newValNeighbor = (yyvsp[(9) - (9)].str);
				n->newValIsAfter = false;
				n->skipIfExists = (yyvsp[(6) - (9)].boolean);
				(yyval.node) = (Node *) n;
			}
    break;

  case 727:
/* Line 1787 of yacc.c  */
#line 4968 "gram.y"
    {
				AlterEnumStmt *n = makeNode(AlterEnumStmt);
				n->typeName = (yyvsp[(3) - (9)].list);
				n->newVal = (yyvsp[(7) - (9)].str);
				n->newValNeighbor = (yyvsp[(9) - (9)].str);
				n->newValIsAfter = true;
				n->skipIfExists = (yyvsp[(6) - (9)].boolean);
				(yyval.node) = (Node *) n;
			}
    break;

  case 728:
/* Line 1787 of yacc.c  */
#line 4979 "gram.y"
    { (yyval.boolean) = true; }
    break;

  case 729:
/* Line 1787 of yacc.c  */
#line 4980 "gram.y"
    { (yyval.boolean) = false; }
    break;

  case 730:
/* Line 1787 of yacc.c  */
#line 4998 "gram.y"
    {
					CreateOpClassStmt *n = makeNode(CreateOpClassStmt);
					n->opclassname = (yyvsp[(4) - (13)].list);
					n->isDefault = (yyvsp[(5) - (13)].boolean);
					n->datatype = (yyvsp[(8) - (13)].typnam);
					n->amname = (yyvsp[(10) - (13)].str);
					n->opfamilyname = (yyvsp[(11) - (13)].list);
					n->items = (yyvsp[(13) - (13)].list);
					(yyval.node) = (Node *) n;
				}
    break;

  case 731:
/* Line 1787 of yacc.c  */
#line 5011 "gram.y"
    { (yyval.list) = list_make1((yyvsp[(1) - (1)].node)); }
    break;

  case 732:
/* Line 1787 of yacc.c  */
#line 5012 "gram.y"
    { (yyval.list) = lappend((yyvsp[(1) - (3)].list), (yyvsp[(3) - (3)].node)); }
    break;

  case 733:
/* Line 1787 of yacc.c  */
#line 5017 "gram.y"
    {
					CreateOpClassItem *n = makeNode(CreateOpClassItem);
					n->itemtype = OPCLASS_ITEM_OPERATOR;
					n->name = (yyvsp[(3) - (5)].list);
					n->args = NIL;
					n->number = (yyvsp[(2) - (5)].ival);
					n->order_family = (yyvsp[(4) - (5)].list);
					(yyval.node) = (Node *) n;
				}
    break;

  case 734:
/* Line 1787 of yacc.c  */
#line 5028 "gram.y"
    {
					CreateOpClassItem *n = makeNode(CreateOpClassItem);
					n->itemtype = OPCLASS_ITEM_OPERATOR;
					n->name = (yyvsp[(3) - (6)].list);
					n->args = (yyvsp[(4) - (6)].list);
					n->number = (yyvsp[(2) - (6)].ival);
					n->order_family = (yyvsp[(5) - (6)].list);
					(yyval.node) = (Node *) n;
				}
    break;

  case 735:
/* Line 1787 of yacc.c  */
#line 5038 "gram.y"
    {
					CreateOpClassItem *n = makeNode(CreateOpClassItem);
					n->itemtype = OPCLASS_ITEM_FUNCTION;
					n->name = (yyvsp[(3) - (4)].list);
					n->args = extractArgTypes((yyvsp[(4) - (4)].list));
					n->number = (yyvsp[(2) - (4)].ival);
					(yyval.node) = (Node *) n;
				}
    break;

  case 736:
/* Line 1787 of yacc.c  */
#line 5047 "gram.y"
    {
					CreateOpClassItem *n = makeNode(CreateOpClassItem);
					n->itemtype = OPCLASS_ITEM_FUNCTION;
					n->name = (yyvsp[(6) - (7)].list);
					n->args = extractArgTypes((yyvsp[(7) - (7)].list));
					n->number = (yyvsp[(2) - (7)].ival);
					n->class_args = (yyvsp[(4) - (7)].list);
					(yyval.node) = (Node *) n;
				}
    break;

  case 737:
/* Line 1787 of yacc.c  */
#line 5057 "gram.y"
    {
					CreateOpClassItem *n = makeNode(CreateOpClassItem);
					n->itemtype = OPCLASS_ITEM_STORAGETYPE;
					n->storedtype = (yyvsp[(2) - (2)].typnam);
					(yyval.node) = (Node *) n;
				}
    break;

  case 738:
/* Line 1787 of yacc.c  */
#line 5065 "gram.y"
    { (yyval.boolean) = TRUE; }
    break;

  case 739:
/* Line 1787 of yacc.c  */
#line 5066 "gram.y"
    { (yyval.boolean) = FALSE; }
    break;

  case 740:
/* Line 1787 of yacc.c  */
#line 5069 "gram.y"
    { (yyval.list) = (yyvsp[(2) - (2)].list); }
    break;

  case 741:
/* Line 1787 of yacc.c  */
#line 5070 "gram.y"
    { (yyval.list) = NIL; }
    break;

  case 742:
/* Line 1787 of yacc.c  */
#line 5073 "gram.y"
    { (yyval.list) = NIL; }
    break;

  case 743:
/* Line 1787 of yacc.c  */
#line 5074 "gram.y"
    { (yyval.list) = (yyvsp[(4) - (4)].list); }
    break;

  case 744:
/* Line 1787 of yacc.c  */
#line 5075 "gram.y"
    { (yyval.list) = NIL; }
    break;

  case 745:
/* Line 1787 of yacc.c  */
#line 5079 "gram.y"
    {
					/*
					 * RECHECK no longer does anything in opclass definitions,
					 * but we still accept it to ease porting of old database
					 * dumps.
					 */
					ereport(NOTICE,
							(errcode(ERRCODE_FEATURE_NOT_SUPPORTED),
							 errmsg("RECHECK is no longer required"),
							 errhint("Update your data type."),
							 parser_errposition((yylsp[(1) - (1)]))));
					(yyval.boolean) = TRUE;
				}
    break;

  case 746:
/* Line 1787 of yacc.c  */
#line 5092 "gram.y"
    { (yyval.boolean) = FALSE; }
    break;

  case 747:
/* Line 1787 of yacc.c  */
#line 5098 "gram.y"
    {
					CreateOpFamilyStmt *n = makeNode(CreateOpFamilyStmt);
					n->opfamilyname = (yyvsp[(4) - (6)].list);
					n->amname = (yyvsp[(6) - (6)].str);
					(yyval.node) = (Node *) n;
				}
    break;

  case 748:
/* Line 1787 of yacc.c  */
#line 5108 "gram.y"
    {
					AlterOpFamilyStmt *n = makeNode(AlterOpFamilyStmt);
					n->opfamilyname = (yyvsp[(4) - (8)].list);
					n->amname = (yyvsp[(6) - (8)].str);
					n->isDrop = false;
					n->items = (yyvsp[(8) - (8)].list);
					(yyval.node) = (Node *) n;
				}
    break;

  case 749:
/* Line 1787 of yacc.c  */
#line 5117 "gram.y"
    {
					AlterOpFamilyStmt *n = makeNode(AlterOpFamilyStmt);
					n->opfamilyname = (yyvsp[(4) - (8)].list);
					n->amname = (yyvsp[(6) - (8)].str);
					n->isDrop = true;
					n->items = (yyvsp[(8) - (8)].list);
					(yyval.node) = (Node *) n;
				}
    break;

  case 750:
/* Line 1787 of yacc.c  */
#line 5128 "gram.y"
    { (yyval.list) = list_make1((yyvsp[(1) - (1)].node)); }
    break;

  case 751:
/* Line 1787 of yacc.c  */
#line 5129 "gram.y"
    { (yyval.list) = lappend((yyvsp[(1) - (3)].list), (yyvsp[(3) - (3)].node)); }
    break;

  case 752:
/* Line 1787 of yacc.c  */
#line 5134 "gram.y"
    {
					CreateOpClassItem *n = makeNode(CreateOpClassItem);
					n->itemtype = OPCLASS_ITEM_OPERATOR;
					n->number = (yyvsp[(2) - (5)].ival);
					n->args = (yyvsp[(4) - (5)].list);
					(yyval.node) = (Node *) n;
				}
    break;

  case 753:
/* Line 1787 of yacc.c  */
#line 5142 "gram.y"
    {
					CreateOpClassItem *n = makeNode(CreateOpClassItem);
					n->itemtype = OPCLASS_ITEM_FUNCTION;
					n->number = (yyvsp[(2) - (5)].ival);
					n->args = (yyvsp[(4) - (5)].list);
					(yyval.node) = (Node *) n;
				}
    break;

  case 754:
/* Line 1787 of yacc.c  */
#line 5154 "gram.y"
    {
					DropStmt *n = makeNode(DropStmt);
					n->objects = list_make1((yyvsp[(4) - (7)].list));
					n->arguments = list_make1(list_make1(makeString((yyvsp[(6) - (7)].str))));
					n->removeType = OBJECT_OPCLASS;
					n->behavior = (yyvsp[(7) - (7)].dbehavior);
					n->missing_ok = false;
					n->concurrent = false;
					(yyval.node) = (Node *) n;
				}
    break;

  case 755:
/* Line 1787 of yacc.c  */
#line 5165 "gram.y"
    {
					DropStmt *n = makeNode(DropStmt);
					n->objects = list_make1((yyvsp[(6) - (9)].list));
					n->arguments = list_make1(list_make1(makeString((yyvsp[(8) - (9)].str))));
					n->removeType = OBJECT_OPCLASS;
					n->behavior = (yyvsp[(9) - (9)].dbehavior);
					n->missing_ok = true;
					n->concurrent = false;
					(yyval.node) = (Node *) n;
				}
    break;

  case 756:
/* Line 1787 of yacc.c  */
#line 5179 "gram.y"
    {
					DropStmt *n = makeNode(DropStmt);
					n->objects = list_make1((yyvsp[(4) - (7)].list));
					n->arguments = list_make1(list_make1(makeString((yyvsp[(6) - (7)].str))));
					n->removeType = OBJECT_OPFAMILY;
					n->behavior = (yyvsp[(7) - (7)].dbehavior);
					n->missing_ok = false;
					n->concurrent = false;
					(yyval.node) = (Node *) n;
				}
    break;

  case 757:
/* Line 1787 of yacc.c  */
#line 5190 "gram.y"
    {
					DropStmt *n = makeNode(DropStmt);
					n->objects = list_make1((yyvsp[(6) - (9)].list));
					n->arguments = list_make1(list_make1(makeString((yyvsp[(8) - (9)].str))));
					n->removeType = OBJECT_OPFAMILY;
					n->behavior = (yyvsp[(9) - (9)].dbehavior);
					n->missing_ok = true;
					n->concurrent = false;
					(yyval.node) = (Node *) n;
				}
    break;

  case 758:
/* Line 1787 of yacc.c  */
#line 5213 "gram.y"
    {
					DropOwnedStmt *n = makeNode(DropOwnedStmt);
					n->roles = (yyvsp[(4) - (5)].list);
					n->behavior = (yyvsp[(5) - (5)].dbehavior);
					(yyval.node) = (Node *)n;
				}
    break;

  case 759:
/* Line 1787 of yacc.c  */
#line 5223 "gram.y"
    {
					ReassignOwnedStmt *n = makeNode(ReassignOwnedStmt);
					n->roles = (yyvsp[(4) - (6)].list);
					n->newrole = (yyvsp[(6) - (6)].str);
					(yyval.node) = (Node *)n;
				}
    break;

  case 760:
/* Line 1787 of yacc.c  */
#line 5241 "gram.y"
    {
					DropStmt *n = makeNode(DropStmt);
					n->removeType = (yyvsp[(2) - (6)].objtype);
					n->missing_ok = TRUE;
					n->objects = (yyvsp[(5) - (6)].list);
					n->arguments = NIL;
					n->behavior = (yyvsp[(6) - (6)].dbehavior);
					n->concurrent = false;
					(yyval.node) = (Node *)n;
				}
    break;

  case 761:
/* Line 1787 of yacc.c  */
#line 5252 "gram.y"
    {
					DropStmt *n = makeNode(DropStmt);
					n->removeType = (yyvsp[(2) - (4)].objtype);
					n->missing_ok = FALSE;
					n->objects = (yyvsp[(3) - (4)].list);
					n->arguments = NIL;
					n->behavior = (yyvsp[(4) - (4)].dbehavior);
					n->concurrent = false;
					(yyval.node) = (Node *)n;
				}
    break;

  case 762:
/* Line 1787 of yacc.c  */
#line 5263 "gram.y"
    {
					DropStmt *n = makeNode(DropStmt);
					n->removeType = OBJECT_INDEX;
					n->missing_ok = FALSE;
					n->objects = (yyvsp[(4) - (5)].list);
					n->arguments = NIL;
					n->behavior = (yyvsp[(5) - (5)].dbehavior);
					n->concurrent = true;
					(yyval.node) = (Node *)n;
				}
    break;

  case 763:
/* Line 1787 of yacc.c  */
#line 5274 "gram.y"
    {
					DropStmt *n = makeNode(DropStmt);
					n->removeType = OBJECT_INDEX;
					n->missing_ok = TRUE;
					n->objects = (yyvsp[(6) - (7)].list);
					n->arguments = NIL;
					n->behavior = (yyvsp[(7) - (7)].dbehavior);
					n->concurrent = true;
					(yyval.node) = (Node *)n;
				}
    break;

  case 764:
/* Line 1787 of yacc.c  */
#line 5287 "gram.y"
    { (yyval.objtype) = OBJECT_TABLE; }
    break;

  case 765:
/* Line 1787 of yacc.c  */
#line 5288 "gram.y"
    { (yyval.objtype) = OBJECT_SEQUENCE; }
    break;

  case 766:
/* Line 1787 of yacc.c  */
#line 5289 "gram.y"
    { (yyval.objtype) = OBJECT_VIEW; }
    break;

  case 767:
/* Line 1787 of yacc.c  */
#line 5290 "gram.y"
    { (yyval.objtype) = OBJECT_MATVIEW; }
    break;

  case 768:
/* Line 1787 of yacc.c  */
#line 5291 "gram.y"
    { (yyval.objtype) = OBJECT_INDEX; }
    break;

  case 769:
/* Line 1787 of yacc.c  */
#line 5292 "gram.y"
    { (yyval.objtype) = OBJECT_FOREIGN_TABLE; }
    break;

  case 770:
/* Line 1787 of yacc.c  */
#line 5293 "gram.y"
    { (yyval.objtype) = OBJECT_EVENT_TRIGGER; }
    break;

  case 771:
/* Line 1787 of yacc.c  */
#line 5294 "gram.y"
    { (yyval.objtype) = OBJECT_TYPE; }
    break;

  case 772:
/* Line 1787 of yacc.c  */
#line 5295 "gram.y"
    { (yyval.objtype) = OBJECT_DOMAIN; }
    break;

  case 773:
/* Line 1787 of yacc.c  */
#line 5296 "gram.y"
    { (yyval.objtype) = OBJECT_COLLATION; }
    break;

  case 774:
/* Line 1787 of yacc.c  */
#line 5297 "gram.y"
    { (yyval.objtype) = OBJECT_CONVERSION; }
    break;

  case 775:
/* Line 1787 of yacc.c  */
#line 5298 "gram.y"
    { (yyval.objtype) = OBJECT_SCHEMA; }
    break;

  case 776:
/* Line 1787 of yacc.c  */
#line 5299 "gram.y"
    { (yyval.objtype) = OBJECT_EXTENSION; }
    break;

  case 777:
/* Line 1787 of yacc.c  */
#line 5300 "gram.y"
    { (yyval.objtype) = OBJECT_TSPARSER; }
    break;

  case 778:
/* Line 1787 of yacc.c  */
#line 5301 "gram.y"
    { (yyval.objtype) = OBJECT_TSDICTIONARY; }
    break;

  case 779:
/* Line 1787 of yacc.c  */
#line 5302 "gram.y"
    { (yyval.objtype) = OBJECT_TSTEMPLATE; }
    break;

  case 780:
/* Line 1787 of yacc.c  */
#line 5303 "gram.y"
    { (yyval.objtype) = OBJECT_TSCONFIGURATION; }
    break;

  case 781:
/* Line 1787 of yacc.c  */
#line 5307 "gram.y"
    { (yyval.list) = list_make1((yyvsp[(1) - (1)].list)); }
    break;

  case 782:
/* Line 1787 of yacc.c  */
#line 5308 "gram.y"
    { (yyval.list) = lappend((yyvsp[(1) - (3)].list), (yyvsp[(3) - (3)].list)); }
    break;

  case 783:
/* Line 1787 of yacc.c  */
#line 5311 "gram.y"
    { (yyval.list) = list_make1(makeString((yyvsp[(1) - (1)].str))); }
    break;

  case 784:
/* Line 1787 of yacc.c  */
#line 5312 "gram.y"
    { (yyval.list) = lcons(makeString((yyvsp[(1) - (2)].str)), (yyvsp[(2) - (2)].list)); }
    break;

  case 785:
/* Line 1787 of yacc.c  */
#line 5316 "gram.y"
    { (yyval.list) = list_make1(makeString((yyvsp[(2) - (2)].str))); }
    break;

  case 786:
/* Line 1787 of yacc.c  */
#line 5318 "gram.y"
    { (yyval.list) = lappend((yyvsp[(1) - (3)].list), makeString((yyvsp[(3) - (3)].str))); }
    break;

  case 787:
/* Line 1787 of yacc.c  */
#line 5331 "gram.y"
    {
					TruncateStmt *n = makeNode(TruncateStmt);
					n->relations = (yyvsp[(3) - (5)].list);
					n->restart_seqs = (yyvsp[(4) - (5)].boolean);
					n->behavior = (yyvsp[(5) - (5)].dbehavior);
					(yyval.node) = (Node *)n;
				}
    break;

  case 788:
/* Line 1787 of yacc.c  */
#line 5341 "gram.y"
    { (yyval.boolean) = false; }
    break;

  case 789:
/* Line 1787 of yacc.c  */
#line 5342 "gram.y"
    { (yyval.boolean) = true; }
    break;

  case 790:
/* Line 1787 of yacc.c  */
#line 5343 "gram.y"
    { (yyval.boolean) = false; }
    break;

  case 791:
/* Line 1787 of yacc.c  */
#line 5376 "gram.y"
    {
					CommentStmt *n = makeNode(CommentStmt);
					n->objtype = (yyvsp[(3) - (6)].objtype);
					n->objname = (yyvsp[(4) - (6)].list);
					n->objargs = NIL;
					n->comment = (yyvsp[(6) - (6)].str);
					(yyval.node) = (Node *) n;
				}
    break;

  case 792:
/* Line 1787 of yacc.c  */
#line 5385 "gram.y"
    {
					CommentStmt *n = makeNode(CommentStmt);
					n->objtype = OBJECT_AGGREGATE;
					n->objname = (yyvsp[(4) - (7)].list);
					n->objargs = extractAggrArgTypes((yyvsp[(5) - (7)].list));
					n->comment = (yyvsp[(7) - (7)].str);
					(yyval.node) = (Node *) n;
				}
    break;

  case 793:
/* Line 1787 of yacc.c  */
#line 5394 "gram.y"
    {
					CommentStmt *n = makeNode(CommentStmt);
					n->objtype = OBJECT_FUNCTION;
					n->objname = (yyvsp[(4) - (7)].list);
					n->objargs = extractArgTypes((yyvsp[(5) - (7)].list));
					n->comment = (yyvsp[(7) - (7)].str);
					(yyval.node) = (Node *) n;
				}
    break;

  case 794:
/* Line 1787 of yacc.c  */
#line 5403 "gram.y"
    {
					CommentStmt *n = makeNode(CommentStmt);
					n->objtype = OBJECT_OPERATOR;
					n->objname = (yyvsp[(4) - (7)].list);
					n->objargs = (yyvsp[(5) - (7)].list);
					n->comment = (yyvsp[(7) - (7)].str);
					(yyval.node) = (Node *) n;
				}
    break;

  case 795:
/* Line 1787 of yacc.c  */
#line 5412 "gram.y"
    {
					CommentStmt *n = makeNode(CommentStmt);
					n->objtype = OBJECT_CONSTRAINT;
					n->objname = lappend((yyvsp[(6) - (8)].list), makeString((yyvsp[(4) - (8)].str)));
					n->objargs = NIL;
					n->comment = (yyvsp[(8) - (8)].str);
					(yyval.node) = (Node *) n;
				}
    break;

  case 796:
/* Line 1787 of yacc.c  */
#line 5421 "gram.y"
    {
					CommentStmt *n = makeNode(CommentStmt);
					n->objtype = OBJECT_RULE;
					n->objname = lappend((yyvsp[(6) - (8)].list), makeString((yyvsp[(4) - (8)].str)));
					n->objargs = NIL;
					n->comment = (yyvsp[(8) - (8)].str);
					(yyval.node) = (Node *) n;
				}
    break;

  case 797:
/* Line 1787 of yacc.c  */
#line 5430 "gram.y"
    {
					/* Obsolete syntax supported for awhile for compatibility */
					CommentStmt *n = makeNode(CommentStmt);
					n->objtype = OBJECT_RULE;
					n->objname = list_make1(makeString((yyvsp[(4) - (6)].str)));
					n->objargs = NIL;
					n->comment = (yyvsp[(6) - (6)].str);
					(yyval.node) = (Node *) n;
				}
    break;

  case 798:
/* Line 1787 of yacc.c  */
#line 5440 "gram.y"
    {
					CommentStmt *n = makeNode(CommentStmt);
					n->objtype = OBJECT_TRIGGER;
					n->objname = lappend((yyvsp[(6) - (8)].list), makeString((yyvsp[(4) - (8)].str)));
					n->objargs = NIL;
					n->comment = (yyvsp[(8) - (8)].str);
					(yyval.node) = (Node *) n;
				}
    break;

  case 799:
/* Line 1787 of yacc.c  */
#line 5449 "gram.y"
    {
					CommentStmt *n = makeNode(CommentStmt);
					n->objtype = OBJECT_OPCLASS;
					n->objname = (yyvsp[(5) - (9)].list);
					n->objargs = list_make1(makeString((yyvsp[(7) - (9)].str)));
					n->comment = (yyvsp[(9) - (9)].str);
					(yyval.node) = (Node *) n;
				}
    break;

  case 800:
/* Line 1787 of yacc.c  */
#line 5458 "gram.y"
    {
					CommentStmt *n = makeNode(CommentStmt);
					n->objtype = OBJECT_OPFAMILY;
					n->objname = (yyvsp[(5) - (9)].list);
					n->objargs = list_make1(makeString((yyvsp[(7) - (9)].str)));
					n->comment = (yyvsp[(9) - (9)].str);
					(yyval.node) = (Node *) n;
				}
    break;

  case 801:
/* Line 1787 of yacc.c  */
#line 5467 "gram.y"
    {
					CommentStmt *n = makeNode(CommentStmt);
					n->objtype = OBJECT_LARGEOBJECT;
					n->objname = list_make1((yyvsp[(5) - (7)].value));
					n->objargs = NIL;
					n->comment = (yyvsp[(7) - (7)].str);
					(yyval.node) = (Node *) n;
				}
    break;

  case 802:
/* Line 1787 of yacc.c  */
#line 5476 "gram.y"
    {
					CommentStmt *n = makeNode(CommentStmt);
					n->objtype = OBJECT_CAST;
					n->objname = list_make1((yyvsp[(5) - (10)].typnam));
					n->objargs = list_make1((yyvsp[(7) - (10)].typnam));
					n->comment = (yyvsp[(10) - (10)].str);
					(yyval.node) = (Node *) n;
				}
    break;

  case 803:
/* Line 1787 of yacc.c  */
#line 5485 "gram.y"
    {
					CommentStmt *n = makeNode(CommentStmt);
					n->objtype = OBJECT_LANGUAGE;
					n->objname = (yyvsp[(5) - (7)].list);
					n->objargs = NIL;
					n->comment = (yyvsp[(7) - (7)].str);
					(yyval.node) = (Node *) n;
				}
    break;

  case 804:
/* Line 1787 of yacc.c  */
#line 5496 "gram.y"
    { (yyval.objtype) = OBJECT_COLUMN; }
    break;

  case 805:
/* Line 1787 of yacc.c  */
#line 5497 "gram.y"
    { (yyval.objtype) = OBJECT_DATABASE; }
    break;

  case 806:
/* Line 1787 of yacc.c  */
#line 5498 "gram.y"
    { (yyval.objtype) = OBJECT_SCHEMA; }
    break;

  case 807:
/* Line 1787 of yacc.c  */
#line 5499 "gram.y"
    { (yyval.objtype) = OBJECT_INDEX; }
    break;

  case 808:
/* Line 1787 of yacc.c  */
#line 5500 "gram.y"
    { (yyval.objtype) = OBJECT_SEQUENCE; }
    break;

  case 809:
/* Line 1787 of yacc.c  */
#line 5501 "gram.y"
    { (yyval.objtype) = OBJECT_TABLE; }
    break;

  case 810:
/* Line 1787 of yacc.c  */
#line 5502 "gram.y"
    { (yyval.objtype) = OBJECT_DOMAIN; }
    break;

  case 811:
/* Line 1787 of yacc.c  */
#line 5503 "gram.y"
    { (yyval.objtype) = OBJECT_TYPE; }
    break;

  case 812:
/* Line 1787 of yacc.c  */
#line 5504 "gram.y"
    { (yyval.objtype) = OBJECT_VIEW; }
    break;

  case 813:
/* Line 1787 of yacc.c  */
#line 5505 "gram.y"
    { (yyval.objtype) = OBJECT_MATVIEW; }
    break;

  case 814:
/* Line 1787 of yacc.c  */
#line 5506 "gram.y"
    { (yyval.objtype) = OBJECT_COLLATION; }
    break;

  case 815:
/* Line 1787 of yacc.c  */
#line 5507 "gram.y"
    { (yyval.objtype) = OBJECT_CONVERSION; }
    break;

  case 816:
/* Line 1787 of yacc.c  */
#line 5508 "gram.y"
    { (yyval.objtype) = OBJECT_TABLESPACE; }
    break;

  case 817:
/* Line 1787 of yacc.c  */
#line 5509 "gram.y"
    { (yyval.objtype) = OBJECT_EXTENSION; }
    break;

  case 818:
/* Line 1787 of yacc.c  */
#line 5510 "gram.y"
    { (yyval.objtype) = OBJECT_ROLE; }
    break;

  case 819:
/* Line 1787 of yacc.c  */
#line 5511 "gram.y"
    { (yyval.objtype) = OBJECT_FOREIGN_TABLE; }
    break;

  case 820:
/* Line 1787 of yacc.c  */
#line 5512 "gram.y"
    { (yyval.objtype) = OBJECT_FOREIGN_SERVER; }
    break;

  case 821:
/* Line 1787 of yacc.c  */
#line 5513 "gram.y"
    { (yyval.objtype) = OBJECT_FDW; }
    break;

  case 822:
/* Line 1787 of yacc.c  */
#line 5514 "gram.y"
    { (yyval.objtype) = OBJECT_EVENT_TRIGGER; }
    break;

  case 823:
/* Line 1787 of yacc.c  */
#line 5515 "gram.y"
    { (yyval.objtype) = OBJECT_TSCONFIGURATION; }
    break;

  case 824:
/* Line 1787 of yacc.c  */
#line 5516 "gram.y"
    { (yyval.objtype) = OBJECT_TSDICTIONARY; }
    break;

  case 825:
/* Line 1787 of yacc.c  */
#line 5517 "gram.y"
    { (yyval.objtype) = OBJECT_TSPARSER; }
    break;

  case 826:
/* Line 1787 of yacc.c  */
#line 5518 "gram.y"
    { (yyval.objtype) = OBJECT_TSTEMPLATE; }
    break;

  case 827:
/* Line 1787 of yacc.c  */
#line 5522 "gram.y"
    { (yyval.str) = (yyvsp[(1) - (1)].str); }
    break;

  case 828:
/* Line 1787 of yacc.c  */
#line 5523 "gram.y"
    { (yyval.str) = NULL; }
    break;

  case 829:
/* Line 1787 of yacc.c  */
#line 5539 "gram.y"
    {
					SecLabelStmt *n = makeNode(SecLabelStmt);
					n->provider = (yyvsp[(3) - (8)].str);
					n->objtype = (yyvsp[(5) - (8)].objtype);
					n->objname = (yyvsp[(6) - (8)].list);
					n->objargs = NIL;
					n->label = (yyvsp[(8) - (8)].str);
					(yyval.node) = (Node *) n;
				}
    break;

  case 830:
/* Line 1787 of yacc.c  */
#line 5550 "gram.y"
    {
					SecLabelStmt *n = makeNode(SecLabelStmt);
					n->provider = (yyvsp[(3) - (9)].str);
					n->objtype = OBJECT_AGGREGATE;
					n->objname = (yyvsp[(6) - (9)].list);
					n->objargs = extractAggrArgTypes((yyvsp[(7) - (9)].list));
					n->label = (yyvsp[(9) - (9)].str);
					(yyval.node) = (Node *) n;
				}
    break;

  case 831:
/* Line 1787 of yacc.c  */
#line 5561 "gram.y"
    {
					SecLabelStmt *n = makeNode(SecLabelStmt);
					n->provider = (yyvsp[(3) - (9)].str);
					n->objtype = OBJECT_FUNCTION;
					n->objname = (yyvsp[(6) - (9)].list);
					n->objargs = extractArgTypes((yyvsp[(7) - (9)].list));
					n->label = (yyvsp[(9) - (9)].str);
					(yyval.node) = (Node *) n;
				}
    break;

  case 832:
/* Line 1787 of yacc.c  */
#line 5572 "gram.y"
    {
					SecLabelStmt *n = makeNode(SecLabelStmt);
					n->provider = (yyvsp[(3) - (9)].str);
					n->objtype = OBJECT_LARGEOBJECT;
					n->objname = list_make1((yyvsp[(7) - (9)].value));
					n->objargs = NIL;
					n->label = (yyvsp[(9) - (9)].str);
					(yyval.node) = (Node *) n;
				}
    break;

  case 833:
/* Line 1787 of yacc.c  */
#line 5583 "gram.y"
    {
					SecLabelStmt *n = makeNode(SecLabelStmt);
					n->provider = (yyvsp[(3) - (9)].str);
					n->objtype = OBJECT_LANGUAGE;
					n->objname = (yyvsp[(7) - (9)].list);
					n->objargs = NIL;
					n->label = (yyvsp[(9) - (9)].str);
					(yyval.node) = (Node *) n;
				}
    break;

  case 834:
/* Line 1787 of yacc.c  */
#line 5594 "gram.y"
    { (yyval.str) = (yyvsp[(2) - (2)].str); }
    break;

  case 835:
/* Line 1787 of yacc.c  */
#line 5595 "gram.y"
    { (yyval.str) = NULL; }
    break;

  case 836:
/* Line 1787 of yacc.c  */
#line 5599 "gram.y"
    { (yyval.objtype) = OBJECT_COLUMN; }
    break;

  case 837:
/* Line 1787 of yacc.c  */
#line 5600 "gram.y"
    { (yyval.objtype) = OBJECT_DATABASE; }
    break;

  case 838:
/* Line 1787 of yacc.c  */
#line 5601 "gram.y"
    { (yyval.objtype) = OBJECT_EVENT_TRIGGER; }
    break;

  case 839:
/* Line 1787 of yacc.c  */
#line 5602 "gram.y"
    { (yyval.objtype) = OBJECT_FOREIGN_TABLE; }
    break;

  case 840:
/* Line 1787 of yacc.c  */
#line 5603 "gram.y"
    { (yyval.objtype) = OBJECT_SCHEMA; }
    break;

  case 841:
/* Line 1787 of yacc.c  */
#line 5604 "gram.y"
    { (yyval.objtype) = OBJECT_SEQUENCE; }
    break;

  case 842:
/* Line 1787 of yacc.c  */
#line 5605 "gram.y"
    { (yyval.objtype) = OBJECT_TABLE; }
    break;

  case 843:
/* Line 1787 of yacc.c  */
#line 5606 "gram.y"
    { (yyval.objtype) = OBJECT_TYPE; }
    break;

  case 844:
/* Line 1787 of yacc.c  */
#line 5607 "gram.y"
    { (yyval.objtype) = OBJECT_ROLE; }
    break;

  case 845:
/* Line 1787 of yacc.c  */
#line 5608 "gram.y"
    { (yyval.objtype) = OBJECT_TABLESPACE; }
    break;

  case 846:
/* Line 1787 of yacc.c  */
#line 5609 "gram.y"
    { (yyval.objtype) = OBJECT_TYPE; }
    break;

  case 847:
/* Line 1787 of yacc.c  */
#line 5610 "gram.y"
    { (yyval.objtype) = OBJECT_VIEW; }
    break;

  case 848:
/* Line 1787 of yacc.c  */
#line 5611 "gram.y"
    { (yyval.objtype) = OBJECT_MATVIEW; }
    break;

  case 849:
/* Line 1787 of yacc.c  */
#line 5614 "gram.y"
    { (yyval.str) = (yyvsp[(1) - (1)].str); }
    break;

  case 850:
/* Line 1787 of yacc.c  */
#line 5615 "gram.y"
    { (yyval.str) = NULL; }
    break;

  case 851:
/* Line 1787 of yacc.c  */
#line 5626 "gram.y"
    {
					FetchStmt *n = (FetchStmt *) (yyvsp[(2) - (2)].node);
					n->ismove = FALSE;
					(yyval.node) = (Node *)n;
				}
    break;

  case 852:
/* Line 1787 of yacc.c  */
#line 5632 "gram.y"
    {
					FetchStmt *n = (FetchStmt *) (yyvsp[(2) - (2)].node);
					n->ismove = TRUE;
					(yyval.node) = (Node *)n;
				}
    break;

  case 853:
/* Line 1787 of yacc.c  */
#line 5640 "gram.y"
    {
					FetchStmt *n = makeNode(FetchStmt);
					n->portalname = (yyvsp[(1) - (1)].str);
					n->direction = FETCH_FORWARD;
					n->howMany = 1;
					(yyval.node) = (Node *)n;
				}
    break;

  case 854:
/* Line 1787 of yacc.c  */
#line 5648 "gram.y"
    {
					FetchStmt *n = makeNode(FetchStmt);
					n->portalname = (yyvsp[(2) - (2)].str);
					n->direction = FETCH_FORWARD;
					n->howMany = 1;
					(yyval.node) = (Node *)n;
				}
    break;

  case 855:
/* Line 1787 of yacc.c  */
#line 5656 "gram.y"
    {
					FetchStmt *n = makeNode(FetchStmt);
					n->portalname = (yyvsp[(3) - (3)].str);
					n->direction = FETCH_FORWARD;
					n->howMany = 1;
					(yyval.node) = (Node *)n;
				}
    break;

  case 856:
/* Line 1787 of yacc.c  */
#line 5664 "gram.y"
    {
					FetchStmt *n = makeNode(FetchStmt);
					n->portalname = (yyvsp[(3) - (3)].str);
					n->direction = FETCH_BACKWARD;
					n->howMany = 1;
					(yyval.node) = (Node *)n;
				}
    break;

  case 857:
/* Line 1787 of yacc.c  */
#line 5672 "gram.y"
    {
					FetchStmt *n = makeNode(FetchStmt);
					n->portalname = (yyvsp[(3) - (3)].str);
					n->direction = FETCH_ABSOLUTE;
					n->howMany = 1;
					(yyval.node) = (Node *)n;
				}
    break;

  case 858:
/* Line 1787 of yacc.c  */
#line 5680 "gram.y"
    {
					FetchStmt *n = makeNode(FetchStmt);
					n->portalname = (yyvsp[(3) - (3)].str);
					n->direction = FETCH_ABSOLUTE;
					n->howMany = -1;
					(yyval.node) = (Node *)n;
				}
    break;

  case 859:
/* Line 1787 of yacc.c  */
#line 5688 "gram.y"
    {
					FetchStmt *n = makeNode(FetchStmt);
					n->portalname = (yyvsp[(4) - (4)].str);
					n->direction = FETCH_ABSOLUTE;
					n->howMany = (yyvsp[(2) - (4)].ival);
					(yyval.node) = (Node *)n;
				}
    break;

  case 860:
/* Line 1787 of yacc.c  */
#line 5696 "gram.y"
    {
					FetchStmt *n = makeNode(FetchStmt);
					n->portalname = (yyvsp[(4) - (4)].str);
					n->direction = FETCH_RELATIVE;
					n->howMany = (yyvsp[(2) - (4)].ival);
					(yyval.node) = (Node *)n;
				}
    break;

  case 861:
/* Line 1787 of yacc.c  */
#line 5704 "gram.y"
    {
					FetchStmt *n = makeNode(FetchStmt);
					n->portalname = (yyvsp[(3) - (3)].str);
					n->direction = FETCH_FORWARD;
					n->howMany = (yyvsp[(1) - (3)].ival);
					(yyval.node) = (Node *)n;
				}
    break;

  case 862:
/* Line 1787 of yacc.c  */
#line 5712 "gram.y"
    {
					FetchStmt *n = makeNode(FetchStmt);
					n->portalname = (yyvsp[(3) - (3)].str);
					n->direction = FETCH_FORWARD;
					n->howMany = FETCH_ALL;
					(yyval.node) = (Node *)n;
				}
    break;

  case 863:
/* Line 1787 of yacc.c  */
#line 5720 "gram.y"
    {
					FetchStmt *n = makeNode(FetchStmt);
					n->portalname = (yyvsp[(3) - (3)].str);
					n->direction = FETCH_FORWARD;
					n->howMany = 1;
					(yyval.node) = (Node *)n;
				}
    break;

  case 864:
/* Line 1787 of yacc.c  */
#line 5728 "gram.y"
    {
					FetchStmt *n = makeNode(FetchStmt);
					n->portalname = (yyvsp[(4) - (4)].str);
					n->direction = FETCH_FORWARD;
					n->howMany = (yyvsp[(2) - (4)].ival);
					(yyval.node) = (Node *)n;
				}
    break;

  case 865:
/* Line 1787 of yacc.c  */
#line 5736 "gram.y"
    {
					FetchStmt *n = makeNode(FetchStmt);
					n->portalname = (yyvsp[(4) - (4)].str);
					n->direction = FETCH_FORWARD;
					n->howMany = FETCH_ALL;
					(yyval.node) = (Node *)n;
				}
    break;

  case 866:
/* Line 1787 of yacc.c  */
#line 5744 "gram.y"
    {
					FetchStmt *n = makeNode(FetchStmt);
					n->portalname = (yyvsp[(3) - (3)].str);
					n->direction = FETCH_BACKWARD;
					n->howMany = 1;
					(yyval.node) = (Node *)n;
				}
    break;

  case 867:
/* Line 1787 of yacc.c  */
#line 5752 "gram.y"
    {
					FetchStmt *n = makeNode(FetchStmt);
					n->portalname = (yyvsp[(4) - (4)].str);
					n->direction = FETCH_BACKWARD;
					n->howMany = (yyvsp[(2) - (4)].ival);
					(yyval.node) = (Node *)n;
				}
    break;

  case 868:
/* Line 1787 of yacc.c  */
#line 5760 "gram.y"
    {
					FetchStmt *n = makeNode(FetchStmt);
					n->portalname = (yyvsp[(4) - (4)].str);
					n->direction = FETCH_BACKWARD;
					n->howMany = FETCH_ALL;
					(yyval.node) = (Node *)n;
				}
    break;

  case 869:
/* Line 1787 of yacc.c  */
#line 5769 "gram.y"
    {}
    break;

  case 870:
/* Line 1787 of yacc.c  */
#line 5770 "gram.y"
    {}
    break;

  case 871:
/* Line 1787 of yacc.c  */
#line 5773 "gram.y"
    {}
    break;

  case 872:
/* Line 1787 of yacc.c  */
#line 5774 "gram.y"
    {}
    break;

  case 873:
/* Line 1787 of yacc.c  */
#line 5786 "gram.y"
    {
					GrantStmt *n = makeNode(GrantStmt);
					n->is_grant = true;
					n->privileges = (yyvsp[(2) - (7)].list);
					n->targtype = ((yyvsp[(4) - (7)].privtarget))->targtype;
					n->objtype = ((yyvsp[(4) - (7)].privtarget))->objtype;
					n->objects = ((yyvsp[(4) - (7)].privtarget))->objs;
					n->grantees = (yyvsp[(6) - (7)].list);
					n->grant_option = (yyvsp[(7) - (7)].boolean);
					(yyval.node) = (Node*)n;
				}
    break;

  case 874:
/* Line 1787 of yacc.c  */
#line 5802 "gram.y"
    {
					GrantStmt *n = makeNode(GrantStmt);
					n->is_grant = false;
					n->grant_option = false;
					n->privileges = (yyvsp[(2) - (7)].list);
					n->targtype = ((yyvsp[(4) - (7)].privtarget))->targtype;
					n->objtype = ((yyvsp[(4) - (7)].privtarget))->objtype;
					n->objects = ((yyvsp[(4) - (7)].privtarget))->objs;
					n->grantees = (yyvsp[(6) - (7)].list);
					n->behavior = (yyvsp[(7) - (7)].dbehavior);
					(yyval.node) = (Node *)n;
				}
    break;

  case 875:
/* Line 1787 of yacc.c  */
#line 5816 "gram.y"
    {
					GrantStmt *n = makeNode(GrantStmt);
					n->is_grant = false;
					n->grant_option = true;
					n->privileges = (yyvsp[(5) - (10)].list);
					n->targtype = ((yyvsp[(7) - (10)].privtarget))->targtype;
					n->objtype = ((yyvsp[(7) - (10)].privtarget))->objtype;
					n->objects = ((yyvsp[(7) - (10)].privtarget))->objs;
					n->grantees = (yyvsp[(9) - (10)].list);
					n->behavior = (yyvsp[(10) - (10)].dbehavior);
					(yyval.node) = (Node *)n;
				}
    break;

  case 876:
/* Line 1787 of yacc.c  */
#line 5841 "gram.y"
    { (yyval.list) = (yyvsp[(1) - (1)].list); }
    break;

  case 877:
/* Line 1787 of yacc.c  */
#line 5843 "gram.y"
    { (yyval.list) = NIL; }
    break;

  case 878:
/* Line 1787 of yacc.c  */
#line 5845 "gram.y"
    { (yyval.list) = NIL; }
    break;

  case 879:
/* Line 1787 of yacc.c  */
#line 5847 "gram.y"
    {
					AccessPriv *n = makeNode(AccessPriv);
					n->priv_name = NULL;
					n->cols = (yyvsp[(3) - (4)].list);
					(yyval.list) = list_make1(n);
				}
    break;

  case 880:
/* Line 1787 of yacc.c  */
#line 5854 "gram.y"
    {
					AccessPriv *n = makeNode(AccessPriv);
					n->priv_name = NULL;
					n->cols = (yyvsp[(4) - (5)].list);
					(yyval.list) = list_make1(n);
				}
    break;

  case 881:
/* Line 1787 of yacc.c  */
#line 5862 "gram.y"
    { (yyval.list) = list_make1((yyvsp[(1) - (1)].accesspriv)); }
    break;

  case 882:
/* Line 1787 of yacc.c  */
#line 5863 "gram.y"
    { (yyval.list) = lappend((yyvsp[(1) - (3)].list), (yyvsp[(3) - (3)].accesspriv)); }
    break;

  case 883:
/* Line 1787 of yacc.c  */
#line 5867 "gram.y"
    {
				AccessPriv *n = makeNode(AccessPriv);
				n->priv_name = pstrdup((yyvsp[(1) - (2)].keyword));
				n->cols = (yyvsp[(2) - (2)].list);
				(yyval.accesspriv) = n;
			}
    break;

  case 884:
/* Line 1787 of yacc.c  */
#line 5874 "gram.y"
    {
				AccessPriv *n = makeNode(AccessPriv);
				n->priv_name = pstrdup((yyvsp[(1) - (2)].keyword));
				n->cols = (yyvsp[(2) - (2)].list);
				(yyval.accesspriv) = n;
			}
    break;

  case 885:
/* Line 1787 of yacc.c  */
#line 5881 "gram.y"
    {
				AccessPriv *n = makeNode(AccessPriv);
				n->priv_name = pstrdup((yyvsp[(1) - (2)].keyword));
				n->cols = (yyvsp[(2) - (2)].list);
				(yyval.accesspriv) = n;
			}
    break;

  case 886:
/* Line 1787 of yacc.c  */
#line 5888 "gram.y"
    {
				AccessPriv *n = makeNode(AccessPriv);
				n->priv_name = (yyvsp[(1) - (2)].str);
				n->cols = (yyvsp[(2) - (2)].list);
				(yyval.accesspriv) = n;
			}
    break;

  case 887:
/* Line 1787 of yacc.c  */
#line 5902 "gram.y"
    {
					PrivTarget *n = (PrivTarget *) palloc(sizeof(PrivTarget));
					n->targtype = ACL_TARGET_OBJECT;
					n->objtype = ACL_OBJECT_RELATION;
					n->objs = (yyvsp[(1) - (1)].list);
					(yyval.privtarget) = n;
				}
    break;

  case 888:
/* Line 1787 of yacc.c  */
#line 5910 "gram.y"
    {
					PrivTarget *n = (PrivTarget *) palloc(sizeof(PrivTarget));
					n->targtype = ACL_TARGET_OBJECT;
					n->objtype = ACL_OBJECT_RELATION;
					n->objs = (yyvsp[(2) - (2)].list);
					(yyval.privtarget) = n;
				}
    break;

  case 889:
/* Line 1787 of yacc.c  */
#line 5918 "gram.y"
    {
					PrivTarget *n = (PrivTarget *) palloc(sizeof(PrivTarget));
					n->targtype = ACL_TARGET_OBJECT;
					n->objtype = ACL_OBJECT_SEQUENCE;
					n->objs = (yyvsp[(2) - (2)].list);
					(yyval.privtarget) = n;
				}
    break;

  case 890:
/* Line 1787 of yacc.c  */
#line 5926 "gram.y"
    {
					PrivTarget *n = (PrivTarget *) palloc(sizeof(PrivTarget));
					n->targtype = ACL_TARGET_OBJECT;
					n->objtype = ACL_OBJECT_FDW;
					n->objs = (yyvsp[(4) - (4)].list);
					(yyval.privtarget) = n;
				}
    break;

  case 891:
/* Line 1787 of yacc.c  */
#line 5934 "gram.y"
    {
					PrivTarget *n = (PrivTarget *) palloc(sizeof(PrivTarget));
					n->targtype = ACL_TARGET_OBJECT;
					n->objtype = ACL_OBJECT_FOREIGN_SERVER;
					n->objs = (yyvsp[(3) - (3)].list);
					(yyval.privtarget) = n;
				}
    break;

  case 892:
/* Line 1787 of yacc.c  */
#line 5942 "gram.y"
    {
					PrivTarget *n = (PrivTarget *) palloc(sizeof(PrivTarget));
					n->targtype = ACL_TARGET_OBJECT;
					n->objtype = ACL_OBJECT_FUNCTION;
					n->objs = (yyvsp[(2) - (2)].list);
					(yyval.privtarget) = n;
				}
    break;

  case 893:
/* Line 1787 of yacc.c  */
#line 5950 "gram.y"
    {
					PrivTarget *n = (PrivTarget *) palloc(sizeof(PrivTarget));
					n->targtype = ACL_TARGET_OBJECT;
					n->objtype = ACL_OBJECT_DATABASE;
					n->objs = (yyvsp[(2) - (2)].list);
					(yyval.privtarget) = n;
				}
    break;

  case 894:
/* Line 1787 of yacc.c  */
#line 5958 "gram.y"
    {
					PrivTarget *n = (PrivTarget *) palloc(sizeof(PrivTarget));
					n->targtype = ACL_TARGET_OBJECT;
					n->objtype = ACL_OBJECT_DOMAIN;
					n->objs = (yyvsp[(2) - (2)].list);
					(yyval.privtarget) = n;
				}
    break;

  case 895:
/* Line 1787 of yacc.c  */
#line 5966 "gram.y"
    {
					PrivTarget *n = (PrivTarget *) palloc(sizeof(PrivTarget));
					n->targtype = ACL_TARGET_OBJECT;
					n->objtype = ACL_OBJECT_LANGUAGE;
					n->objs = (yyvsp[(2) - (2)].list);
					(yyval.privtarget) = n;
				}
    break;

  case 896:
/* Line 1787 of yacc.c  */
#line 5974 "gram.y"
    {
					PrivTarget *n = (PrivTarget *) palloc(sizeof(PrivTarget));
					n->targtype = ACL_TARGET_OBJECT;
					n->objtype = ACL_OBJECT_LARGEOBJECT;
					n->objs = (yyvsp[(3) - (3)].list);
					(yyval.privtarget) = n;
				}
    break;

  case 897:
/* Line 1787 of yacc.c  */
#line 5982 "gram.y"
    {
					PrivTarget *n = (PrivTarget *) palloc(sizeof(PrivTarget));
					n->targtype = ACL_TARGET_OBJECT;
					n->objtype = ACL_OBJECT_NAMESPACE;
					n->objs = (yyvsp[(2) - (2)].list);
					(yyval.privtarget) = n;
				}
    break;

  case 898:
/* Line 1787 of yacc.c  */
#line 5990 "gram.y"
    {
					PrivTarget *n = (PrivTarget *) palloc(sizeof(PrivTarget));
					n->targtype = ACL_TARGET_OBJECT;
					n->objtype = ACL_OBJECT_TABLESPACE;
					n->objs = (yyvsp[(2) - (2)].list);
					(yyval.privtarget) = n;
				}
    break;

  case 899:
/* Line 1787 of yacc.c  */
#line 5998 "gram.y"
    {
					PrivTarget *n = (PrivTarget *) palloc(sizeof(PrivTarget));
					n->targtype = ACL_TARGET_OBJECT;
					n->objtype = ACL_OBJECT_TYPE;
					n->objs = (yyvsp[(2) - (2)].list);
					(yyval.privtarget) = n;
				}
    break;

  case 900:
/* Line 1787 of yacc.c  */
#line 6006 "gram.y"
    {
					PrivTarget *n = (PrivTarget *) palloc(sizeof(PrivTarget));
					n->targtype = ACL_TARGET_ALL_IN_SCHEMA;
					n->objtype = ACL_OBJECT_RELATION;
					n->objs = (yyvsp[(5) - (5)].list);
					(yyval.privtarget) = n;
				}
    break;

  case 901:
/* Line 1787 of yacc.c  */
#line 6014 "gram.y"
    {
					PrivTarget *n = (PrivTarget *) palloc(sizeof(PrivTarget));
					n->targtype = ACL_TARGET_ALL_IN_SCHEMA;
					n->objtype = ACL_OBJECT_SEQUENCE;
					n->objs = (yyvsp[(5) - (5)].list);
					(yyval.privtarget) = n;
				}
    break;

  case 902:
/* Line 1787 of yacc.c  */
#line 6022 "gram.y"
    {
					PrivTarget *n = (PrivTarget *) palloc(sizeof(PrivTarget));
					n->targtype = ACL_TARGET_ALL_IN_SCHEMA;
					n->objtype = ACL_OBJECT_FUNCTION;
					n->objs = (yyvsp[(5) - (5)].list);
					(yyval.privtarget) = n;
				}
    break;

  case 903:
/* Line 1787 of yacc.c  */
#line 6033 "gram.y"
    { (yyval.list) = list_make1((yyvsp[(1) - (1)].node)); }
    break;

  case 904:
/* Line 1787 of yacc.c  */
#line 6034 "gram.y"
    { (yyval.list) = lappend((yyvsp[(1) - (3)].list), (yyvsp[(3) - (3)].node)); }
    break;

  case 905:
/* Line 1787 of yacc.c  */
#line 6038 "gram.y"
    {
					PrivGrantee *n = makeNode(PrivGrantee);
					/* This hack lets us avoid reserving PUBLIC as a keyword*/
					if (strcmp((yyvsp[(1) - (1)].str), "public") == 0)
						n->rolname = NULL;
					else
						n->rolname = (yyvsp[(1) - (1)].str);
					(yyval.node) = (Node *)n;
				}
    break;

  case 906:
/* Line 1787 of yacc.c  */
#line 6048 "gram.y"
    {
					PrivGrantee *n = makeNode(PrivGrantee);
					/* Treat GROUP PUBLIC as a synonym for PUBLIC */
					if (strcmp((yyvsp[(2) - (2)].str), "public") == 0)
						n->rolname = NULL;
					else
						n->rolname = (yyvsp[(2) - (2)].str);
					(yyval.node) = (Node *)n;
				}
    break;

  case 907:
/* Line 1787 of yacc.c  */
#line 6061 "gram.y"
    { (yyval.boolean) = TRUE; }
    break;

  case 908:
/* Line 1787 of yacc.c  */
#line 6062 "gram.y"
    { (yyval.boolean) = FALSE; }
    break;

  case 909:
/* Line 1787 of yacc.c  */
#line 6066 "gram.y"
    { (yyval.list) = list_make1((yyvsp[(1) - (1)].funwithargs)); }
    break;

  case 910:
/* Line 1787 of yacc.c  */
#line 6068 "gram.y"
    { (yyval.list) = lappend((yyvsp[(1) - (3)].list), (yyvsp[(3) - (3)].funwithargs)); }
    break;

  case 911:
/* Line 1787 of yacc.c  */
#line 6073 "gram.y"
    {
					FuncWithArgs *n = makeNode(FuncWithArgs);
					n->funcname = (yyvsp[(1) - (2)].list);
					n->funcargs = extractArgTypes((yyvsp[(2) - (2)].list));
					(yyval.funwithargs) = n;
				}
    break;

  case 912:
/* Line 1787 of yacc.c  */
#line 6089 "gram.y"
    {
					GrantRoleStmt *n = makeNode(GrantRoleStmt);
					n->is_grant = true;
					n->granted_roles = (yyvsp[(2) - (6)].list);
					n->grantee_roles = (yyvsp[(4) - (6)].list);
					n->admin_opt = (yyvsp[(5) - (6)].boolean);
					n->grantor = (yyvsp[(6) - (6)].str);
					(yyval.node) = (Node*)n;
				}
    break;

  case 913:
/* Line 1787 of yacc.c  */
#line 6102 "gram.y"
    {
					GrantRoleStmt *n = makeNode(GrantRoleStmt);
					n->is_grant = false;
					n->admin_opt = false;
					n->granted_roles = (yyvsp[(2) - (6)].list);
					n->grantee_roles = (yyvsp[(4) - (6)].list);
					n->behavior = (yyvsp[(6) - (6)].dbehavior);
					(yyval.node) = (Node*)n;
				}
    break;

  case 914:
/* Line 1787 of yacc.c  */
#line 6112 "gram.y"
    {
					GrantRoleStmt *n = makeNode(GrantRoleStmt);
					n->is_grant = false;
					n->admin_opt = true;
					n->granted_roles = (yyvsp[(5) - (9)].list);
					n->grantee_roles = (yyvsp[(7) - (9)].list);
					n->behavior = (yyvsp[(9) - (9)].dbehavior);
					(yyval.node) = (Node*)n;
				}
    break;

  case 915:
/* Line 1787 of yacc.c  */
#line 6123 "gram.y"
    { (yyval.boolean) = TRUE; }
    break;

  case 916:
/* Line 1787 of yacc.c  */
#line 6124 "gram.y"
    { (yyval.boolean) = FALSE; }
    break;

  case 917:
/* Line 1787 of yacc.c  */
#line 6127 "gram.y"
    { (yyval.str) = (yyvsp[(3) - (3)].str); }
    break;

  case 918:
/* Line 1787 of yacc.c  */
#line 6128 "gram.y"
    { (yyval.str) = NULL; }
    break;

  case 919:
/* Line 1787 of yacc.c  */
#line 6139 "gram.y"
    {
					AlterDefaultPrivilegesStmt *n = makeNode(AlterDefaultPrivilegesStmt);
					n->options = (yyvsp[(4) - (5)].list);
					n->action = (GrantStmt *) (yyvsp[(5) - (5)].node);
					(yyval.node) = (Node*)n;
				}
    break;

  case 920:
/* Line 1787 of yacc.c  */
#line 6148 "gram.y"
    { (yyval.list) = lappend((yyvsp[(1) - (2)].list), (yyvsp[(2) - (2)].defelt)); }
    break;

  case 921:
/* Line 1787 of yacc.c  */
#line 6149 "gram.y"
    { (yyval.list) = NIL; }
    break;

  case 922:
/* Line 1787 of yacc.c  */
#line 6154 "gram.y"
    {
					(yyval.defelt) = makeDefElem("schemas", (Node *)(yyvsp[(3) - (3)].list));
				}
    break;

  case 923:
/* Line 1787 of yacc.c  */
#line 6158 "gram.y"
    {
					(yyval.defelt) = makeDefElem("roles", (Node *)(yyvsp[(3) - (3)].list));
				}
    break;

  case 924:
/* Line 1787 of yacc.c  */
#line 6162 "gram.y"
    {
					(yyval.defelt) = makeDefElem("roles", (Node *)(yyvsp[(3) - (3)].list));
				}
    break;

  case 925:
/* Line 1787 of yacc.c  */
#line 6174 "gram.y"
    {
					GrantStmt *n = makeNode(GrantStmt);
					n->is_grant = true;
					n->privileges = (yyvsp[(2) - (7)].list);
					n->targtype = ACL_TARGET_DEFAULTS;
					n->objtype = (yyvsp[(4) - (7)].ival);
					n->objects = NIL;
					n->grantees = (yyvsp[(6) - (7)].list);
					n->grant_option = (yyvsp[(7) - (7)].boolean);
					(yyval.node) = (Node*)n;
				}
    break;

  case 926:
/* Line 1787 of yacc.c  */
#line 6187 "gram.y"
    {
					GrantStmt *n = makeNode(GrantStmt);
					n->is_grant = false;
					n->grant_option = false;
					n->privileges = (yyvsp[(2) - (7)].list);
					n->targtype = ACL_TARGET_DEFAULTS;
					n->objtype = (yyvsp[(4) - (7)].ival);
					n->objects = NIL;
					n->grantees = (yyvsp[(6) - (7)].list);
					n->behavior = (yyvsp[(7) - (7)].dbehavior);
					(yyval.node) = (Node *)n;
				}
    break;

  case 927:
/* Line 1787 of yacc.c  */
#line 6201 "gram.y"
    {
					GrantStmt *n = makeNode(GrantStmt);
					n->is_grant = false;
					n->grant_option = true;
					n->privileges = (yyvsp[(5) - (10)].list);
					n->targtype = ACL_TARGET_DEFAULTS;
					n->objtype = (yyvsp[(7) - (10)].ival);
					n->objects = NIL;
					n->grantees = (yyvsp[(9) - (10)].list);
					n->behavior = (yyvsp[(10) - (10)].dbehavior);
					(yyval.node) = (Node *)n;
				}
    break;

  case 928:
/* Line 1787 of yacc.c  */
#line 6216 "gram.y"
    { (yyval.ival) = ACL_OBJECT_RELATION; }
    break;

  case 929:
/* Line 1787 of yacc.c  */
#line 6217 "gram.y"
    { (yyval.ival) = ACL_OBJECT_FUNCTION; }
    break;

  case 930:
/* Line 1787 of yacc.c  */
#line 6218 "gram.y"
    { (yyval.ival) = ACL_OBJECT_SEQUENCE; }
    break;

  case 931:
/* Line 1787 of yacc.c  */
#line 6219 "gram.y"
    { (yyval.ival) = ACL_OBJECT_TYPE; }
    break;

  case 932:
/* Line 1787 of yacc.c  */
#line 6234 "gram.y"
    {
					IndexStmt *n = makeNode(IndexStmt);
					n->unique = (yyvsp[(2) - (14)].boolean);
					n->concurrent = (yyvsp[(4) - (14)].boolean);
					n->idxname = (yyvsp[(5) - (14)].str);
					n->relation = (yyvsp[(7) - (14)].range);
					n->accessMethod = (yyvsp[(8) - (14)].str);
					n->indexParams = (yyvsp[(10) - (14)].list);
					n->options = (yyvsp[(12) - (14)].list);
					n->tableSpace = (yyvsp[(13) - (14)].str);
					n->whereClause = (yyvsp[(14) - (14)].node);
					n->excludeOpNames = NIL;
					n->idxcomment = NULL;
					n->indexOid = InvalidOid;
					n->oldNode = InvalidOid;
					n->primary = false;
					n->isconstraint = false;
					n->deferrable = false;
					n->initdeferred = false;
					(yyval.node) = (Node *)n;
				}
    break;

  case 933:
/* Line 1787 of yacc.c  */
#line 6258 "gram.y"
    { (yyval.boolean) = TRUE; }
    break;

  case 934:
/* Line 1787 of yacc.c  */
#line 6259 "gram.y"
    { (yyval.boolean) = FALSE; }
    break;

  case 935:
/* Line 1787 of yacc.c  */
#line 6263 "gram.y"
    { (yyval.boolean) = TRUE; }
    break;

  case 936:
/* Line 1787 of yacc.c  */
#line 6264 "gram.y"
    { (yyval.boolean) = FALSE; }
    break;

  case 937:
/* Line 1787 of yacc.c  */
#line 6268 "gram.y"
    { (yyval.str) = (yyvsp[(1) - (1)].str); }
    break;

  case 938:
/* Line 1787 of yacc.c  */
#line 6269 "gram.y"
    { (yyval.str) = NULL; }
    break;

  case 939:
/* Line 1787 of yacc.c  */
#line 6273 "gram.y"
    { (yyval.str) = (yyvsp[(2) - (2)].str); }
    break;

  case 940:
/* Line 1787 of yacc.c  */
#line 6274 "gram.y"
    { (yyval.str) = DEFAULT_INDEX_TYPE; }
    break;

  case 941:
/* Line 1787 of yacc.c  */
#line 6277 "gram.y"
    { (yyval.list) = list_make1((yyvsp[(1) - (1)].ielem)); }
    break;

  case 942:
/* Line 1787 of yacc.c  */
#line 6278 "gram.y"
    { (yyval.list) = lappend((yyvsp[(1) - (3)].list), (yyvsp[(3) - (3)].ielem)); }
    break;

  case 943:
/* Line 1787 of yacc.c  */
#line 6287 "gram.y"
    {
					(yyval.ielem) = makeNode(IndexElem);
					(yyval.ielem)->name = (yyvsp[(1) - (5)].str);
					(yyval.ielem)->expr = NULL;
					(yyval.ielem)->indexcolname = NULL;
					(yyval.ielem)->collation = (yyvsp[(2) - (5)].list);
					(yyval.ielem)->opclass = (yyvsp[(3) - (5)].list);
					(yyval.ielem)->ordering = (yyvsp[(4) - (5)].ival);
					(yyval.ielem)->nulls_ordering = (yyvsp[(5) - (5)].ival);
				}
    break;

  case 944:
/* Line 1787 of yacc.c  */
#line 6298 "gram.y"
    {
					(yyval.ielem) = makeNode(IndexElem);
					(yyval.ielem)->name = NULL;
					(yyval.ielem)->expr = (yyvsp[(1) - (5)].node);
					(yyval.ielem)->indexcolname = NULL;
					(yyval.ielem)->collation = (yyvsp[(2) - (5)].list);
					(yyval.ielem)->opclass = (yyvsp[(3) - (5)].list);
					(yyval.ielem)->ordering = (yyvsp[(4) - (5)].ival);
					(yyval.ielem)->nulls_ordering = (yyvsp[(5) - (5)].ival);
				}
    break;

  case 945:
/* Line 1787 of yacc.c  */
#line 6309 "gram.y"
    {
					(yyval.ielem) = makeNode(IndexElem);
					(yyval.ielem)->name = NULL;
					(yyval.ielem)->expr = (yyvsp[(2) - (7)].node);
					(yyval.ielem)->indexcolname = NULL;
					(yyval.ielem)->collation = (yyvsp[(4) - (7)].list);
					(yyval.ielem)->opclass = (yyvsp[(5) - (7)].list);
					(yyval.ielem)->ordering = (yyvsp[(6) - (7)].ival);
					(yyval.ielem)->nulls_ordering = (yyvsp[(7) - (7)].ival);
				}
    break;

  case 946:
/* Line 1787 of yacc.c  */
#line 6321 "gram.y"
    { (yyval.list) = (yyvsp[(2) - (2)].list); }
    break;

  case 947:
/* Line 1787 of yacc.c  */
#line 6322 "gram.y"
    { (yyval.list) = NIL; }
    break;

  case 948:
/* Line 1787 of yacc.c  */
#line 6325 "gram.y"
    { (yyval.list) = (yyvsp[(1) - (1)].list); }
    break;

  case 949:
/* Line 1787 of yacc.c  */
#line 6326 "gram.y"
    { (yyval.list) = (yyvsp[(2) - (2)].list); }
    break;

  case 950:
/* Line 1787 of yacc.c  */
#line 6327 "gram.y"
    { (yyval.list) = NIL; }
    break;

  case 951:
/* Line 1787 of yacc.c  */
#line 6330 "gram.y"
    { (yyval.ival) = SORTBY_ASC; }
    break;

  case 952:
/* Line 1787 of yacc.c  */
#line 6331 "gram.y"
    { (yyval.ival) = SORTBY_DESC; }
    break;

  case 953:
/* Line 1787 of yacc.c  */
#line 6332 "gram.y"
    { (yyval.ival) = SORTBY_DEFAULT; }
    break;

  case 954:
/* Line 1787 of yacc.c  */
#line 6335 "gram.y"
    { (yyval.ival) = SORTBY_NULLS_FIRST; }
    break;

  case 955:
/* Line 1787 of yacc.c  */
#line 6336 "gram.y"
    { (yyval.ival) = SORTBY_NULLS_LAST; }
    break;

  case 956:
/* Line 1787 of yacc.c  */
#line 6337 "gram.y"
    { (yyval.ival) = SORTBY_NULLS_DEFAULT; }
    break;

  case 957:
/* Line 1787 of yacc.c  */
#line 6355 "gram.y"
    {
					CreateFunctionStmt *n = makeNode(CreateFunctionStmt);
					n->replace = (yyvsp[(2) - (9)].boolean);
					n->funcname = (yyvsp[(4) - (9)].list);
					n->parameters = (yyvsp[(5) - (9)].list);
					n->returnType = (yyvsp[(7) - (9)].typnam);
					n->options = (yyvsp[(8) - (9)].list);
					n->withClause = (yyvsp[(9) - (9)].list);
					(yyval.node) = (Node *)n;
				}
    break;

  case 958:
/* Line 1787 of yacc.c  */
#line 6367 "gram.y"
    {
					CreateFunctionStmt *n = makeNode(CreateFunctionStmt);
					n->replace = (yyvsp[(2) - (12)].boolean);
					n->funcname = (yyvsp[(4) - (12)].list);
					n->parameters = mergeTableFuncParameters((yyvsp[(5) - (12)].list), (yyvsp[(9) - (12)].list));
					n->returnType = TableFuncTypeName((yyvsp[(9) - (12)].list));
					n->returnType->location = (yylsp[(7) - (12)]);
					n->options = (yyvsp[(11) - (12)].list);
					n->withClause = (yyvsp[(12) - (12)].list);
					(yyval.node) = (Node *)n;
				}
    break;

  case 959:
/* Line 1787 of yacc.c  */
#line 6380 "gram.y"
    {
					CreateFunctionStmt *n = makeNode(CreateFunctionStmt);
					n->replace = (yyvsp[(2) - (7)].boolean);
					n->funcname = (yyvsp[(4) - (7)].list);
					n->parameters = (yyvsp[(5) - (7)].list);
					n->returnType = NULL;
					n->options = (yyvsp[(6) - (7)].list);
					n->withClause = (yyvsp[(7) - (7)].list);
					(yyval.node) = (Node *)n;
				}
    break;

  case 960:
/* Line 1787 of yacc.c  */
#line 6393 "gram.y"
    { (yyval.boolean) = TRUE; }
    break;

  case 961:
/* Line 1787 of yacc.c  */
#line 6394 "gram.y"
    { (yyval.boolean) = FALSE; }
    break;

  case 962:
/* Line 1787 of yacc.c  */
#line 6397 "gram.y"
    { (yyval.list) = (yyvsp[(2) - (3)].list); }
    break;

  case 963:
/* Line 1787 of yacc.c  */
#line 6398 "gram.y"
    { (yyval.list) = NIL; }
    break;

  case 964:
/* Line 1787 of yacc.c  */
#line 6402 "gram.y"
    { (yyval.list) = list_make1((yyvsp[(1) - (1)].fun_param)); }
    break;

  case 965:
/* Line 1787 of yacc.c  */
#line 6403 "gram.y"
    { (yyval.list) = lappend((yyvsp[(1) - (3)].list), (yyvsp[(3) - (3)].fun_param)); }
    break;

  case 966:
/* Line 1787 of yacc.c  */
#line 6411 "gram.y"
    { (yyval.list) = (yyvsp[(2) - (3)].list); }
    break;

  case 967:
/* Line 1787 of yacc.c  */
#line 6412 "gram.y"
    { (yyval.list) = NIL; }
    break;

  case 968:
/* Line 1787 of yacc.c  */
#line 6416 "gram.y"
    { (yyval.list) = list_make1((yyvsp[(1) - (1)].fun_param)); }
    break;

  case 969:
/* Line 1787 of yacc.c  */
#line 6418 "gram.y"
    { (yyval.list) = lappend((yyvsp[(1) - (3)].list), (yyvsp[(3) - (3)].fun_param)); }
    break;

  case 970:
/* Line 1787 of yacc.c  */
#line 6433 "gram.y"
    {
					FunctionParameter *n = makeNode(FunctionParameter);
					n->name = (yyvsp[(2) - (3)].str);
					n->argType = (yyvsp[(3) - (3)].typnam);
					n->mode = (yyvsp[(1) - (3)].fun_param_mode);
					n->defexpr = NULL;
					(yyval.fun_param) = n;
				}
    break;

  case 971:
/* Line 1787 of yacc.c  */
#line 6442 "gram.y"
    {
					FunctionParameter *n = makeNode(FunctionParameter);
					n->name = (yyvsp[(1) - (3)].str);
					n->argType = (yyvsp[(3) - (3)].typnam);
					n->mode = (yyvsp[(2) - (3)].fun_param_mode);
					n->defexpr = NULL;
					(yyval.fun_param) = n;
				}
    break;

  case 972:
/* Line 1787 of yacc.c  */
#line 6451 "gram.y"
    {
					FunctionParameter *n = makeNode(FunctionParameter);
					n->name = (yyvsp[(1) - (2)].str);
					n->argType = (yyvsp[(2) - (2)].typnam);
					n->mode = FUNC_PARAM_IN;
					n->defexpr = NULL;
					(yyval.fun_param) = n;
				}
    break;

  case 973:
/* Line 1787 of yacc.c  */
#line 6460 "gram.y"
    {
					FunctionParameter *n = makeNode(FunctionParameter);
					n->name = NULL;
					n->argType = (yyvsp[(2) - (2)].typnam);
					n->mode = (yyvsp[(1) - (2)].fun_param_mode);
					n->defexpr = NULL;
					(yyval.fun_param) = n;
				}
    break;

  case 974:
/* Line 1787 of yacc.c  */
#line 6469 "gram.y"
    {
					FunctionParameter *n = makeNode(FunctionParameter);
					n->name = NULL;
					n->argType = (yyvsp[(1) - (1)].typnam);
					n->mode = FUNC_PARAM_IN;
					n->defexpr = NULL;
					(yyval.fun_param) = n;
				}
    break;

  case 975:
/* Line 1787 of yacc.c  */
#line 6480 "gram.y"
    { (yyval.fun_param_mode) = FUNC_PARAM_IN; }
    break;

  case 976:
/* Line 1787 of yacc.c  */
#line 6481 "gram.y"
    { (yyval.fun_param_mode) = FUNC_PARAM_OUT; }
    break;

  case 977:
/* Line 1787 of yacc.c  */
#line 6482 "gram.y"
    { (yyval.fun_param_mode) = FUNC_PARAM_INOUT; }
    break;

  case 978:
/* Line 1787 of yacc.c  */
#line 6483 "gram.y"
    { (yyval.fun_param_mode) = FUNC_PARAM_INOUT; }
    break;

  case 979:
/* Line 1787 of yacc.c  */
#line 6484 "gram.y"
    { (yyval.fun_param_mode) = FUNC_PARAM_VARIADIC; }
    break;

  case 981:
/* Line 1787 of yacc.c  */
#line 6495 "gram.y"
    {
					/* We can catch over-specified results here if we want to,
					 * but for now better to silently swallow typmod, etc.
					 * - thomas 2000-03-22
					 */
					(yyval.typnam) = (yyvsp[(1) - (1)].typnam);
				}
    break;

  case 982:
/* Line 1787 of yacc.c  */
#line 6509 "gram.y"
    { (yyval.typnam) = (yyvsp[(1) - (1)].typnam); }
    break;

  case 983:
/* Line 1787 of yacc.c  */
#line 6511 "gram.y"
    {
					(yyval.typnam) = makeTypeNameFromNameList(lcons(makeString((yyvsp[(1) - (4)].str)), (yyvsp[(2) - (4)].list)));
					(yyval.typnam)->pct_type = true;
					(yyval.typnam)->location = (yylsp[(1) - (4)]);
				}
    break;

  case 984:
/* Line 1787 of yacc.c  */
#line 6517 "gram.y"
    {
					(yyval.typnam) = makeTypeNameFromNameList(lcons(makeString((yyvsp[(2) - (5)].str)), (yyvsp[(3) - (5)].list)));
					(yyval.typnam)->pct_type = true;
					(yyval.typnam)->setof = TRUE;
					(yyval.typnam)->location = (yylsp[(2) - (5)]);
				}
    break;

  case 985:
/* Line 1787 of yacc.c  */
#line 6527 "gram.y"
    {
					(yyval.fun_param) = (yyvsp[(1) - (1)].fun_param);
				}
    break;

  case 986:
/* Line 1787 of yacc.c  */
#line 6531 "gram.y"
    {
					(yyval.fun_param) = (yyvsp[(1) - (3)].fun_param);
					(yyval.fun_param)->defexpr = (yyvsp[(3) - (3)].node);
				}
    break;

  case 987:
/* Line 1787 of yacc.c  */
#line 6536 "gram.y"
    {
					(yyval.fun_param) = (yyvsp[(1) - (3)].fun_param);
					(yyval.fun_param)->defexpr = (yyvsp[(3) - (3)].node);
				}
    break;

  case 988:
/* Line 1787 of yacc.c  */
#line 6544 "gram.y"
    {
					if (!((yyvsp[(1) - (1)].fun_param)->mode == FUNC_PARAM_IN ||
						  (yyvsp[(1) - (1)].fun_param)->mode == FUNC_PARAM_VARIADIC))
						ereport(ERROR,
								(errcode(ERRCODE_FEATURE_NOT_SUPPORTED),
								 errmsg("aggregates cannot have output arguments"),
								 parser_errposition((yylsp[(1) - (1)]))));
					(yyval.fun_param) = (yyvsp[(1) - (1)].fun_param);
				}
    break;

  case 989:
/* Line 1787 of yacc.c  */
#line 6585 "gram.y"
    {
					(yyval.list) = list_make2(NIL, makeInteger(-1));
				}
    break;

  case 990:
/* Line 1787 of yacc.c  */
#line 6589 "gram.y"
    {
					(yyval.list) = list_make2((yyvsp[(2) - (3)].list), makeInteger(-1));
				}
    break;

  case 991:
/* Line 1787 of yacc.c  */
#line 6593 "gram.y"
    {
					(yyval.list) = list_make2((yyvsp[(4) - (5)].list), makeInteger(0));
				}
    break;

  case 992:
/* Line 1787 of yacc.c  */
#line 6597 "gram.y"
    {
					/* this is the only case requiring consistency checking */
					(yyval.list) = makeOrderedSetArgs((yyvsp[(2) - (6)].list), (yyvsp[(5) - (6)].list), yyscanner);
				}
    break;

  case 993:
/* Line 1787 of yacc.c  */
#line 6604 "gram.y"
    { (yyval.list) = list_make1((yyvsp[(1) - (1)].fun_param)); }
    break;

  case 994:
/* Line 1787 of yacc.c  */
#line 6605 "gram.y"
    { (yyval.list) = lappend((yyvsp[(1) - (3)].list), (yyvsp[(3) - (3)].fun_param)); }
    break;

  case 995:
/* Line 1787 of yacc.c  */
#line 6610 "gram.y"
    { (yyval.list) = list_make1((yyvsp[(1) - (1)].defelt)); }
    break;

  case 996:
/* Line 1787 of yacc.c  */
#line 6611 "gram.y"
    { (yyval.list) = lappend((yyvsp[(1) - (2)].list), (yyvsp[(2) - (2)].defelt)); }
    break;

  case 997:
/* Line 1787 of yacc.c  */
#line 6619 "gram.y"
    {
					(yyval.defelt) = makeDefElem("strict", (Node *)makeInteger(FALSE));
				}
    break;

  case 998:
/* Line 1787 of yacc.c  */
#line 6623 "gram.y"
    {
					(yyval.defelt) = makeDefElem("strict", (Node *)makeInteger(TRUE));
				}
    break;

  case 999:
/* Line 1787 of yacc.c  */
#line 6627 "gram.y"
    {
					(yyval.defelt) = makeDefElem("strict", (Node *)makeInteger(TRUE));
				}
    break;

  case 1000:
/* Line 1787 of yacc.c  */
#line 6631 "gram.y"
    {
					(yyval.defelt) = makeDefElem("volatility", (Node *)makeString("immutable"));
				}
    break;

  case 1001:
/* Line 1787 of yacc.c  */
#line 6635 "gram.y"
    {
					(yyval.defelt) = makeDefElem("volatility", (Node *)makeString("stable"));
				}
    break;

  case 1002:
/* Line 1787 of yacc.c  */
#line 6639 "gram.y"
    {
					(yyval.defelt) = makeDefElem("volatility", (Node *)makeString("volatile"));
				}
    break;

  case 1003:
/* Line 1787 of yacc.c  */
#line 6643 "gram.y"
    {
					(yyval.defelt) = makeDefElem("security", (Node *)makeInteger(TRUE));
				}
    break;

  case 1004:
/* Line 1787 of yacc.c  */
#line 6647 "gram.y"
    {
					(yyval.defelt) = makeDefElem("security", (Node *)makeInteger(FALSE));
				}
    break;

  case 1005:
/* Line 1787 of yacc.c  */
#line 6651 "gram.y"
    {
					(yyval.defelt) = makeDefElem("security", (Node *)makeInteger(TRUE));
				}
    break;

  case 1006:
/* Line 1787 of yacc.c  */
#line 6655 "gram.y"
    {
					(yyval.defelt) = makeDefElem("security", (Node *)makeInteger(FALSE));
				}
    break;

  case 1007:
/* Line 1787 of yacc.c  */
#line 6659 "gram.y"
    {
					(yyval.defelt) = makeDefElem("leakproof", (Node *)makeInteger(TRUE));
				}
    break;

  case 1008:
/* Line 1787 of yacc.c  */
#line 6663 "gram.y"
    {
					(yyval.defelt) = makeDefElem("leakproof", (Node *)makeInteger(FALSE));
				}
    break;

  case 1009:
/* Line 1787 of yacc.c  */
#line 6667 "gram.y"
    {
					(yyval.defelt) = makeDefElem("cost", (Node *)(yyvsp[(2) - (2)].value));
				}
    break;

  case 1010:
/* Line 1787 of yacc.c  */
#line 6671 "gram.y"
    {
					(yyval.defelt) = makeDefElem("rows", (Node *)(yyvsp[(2) - (2)].value));
				}
    break;

  case 1011:
/* Line 1787 of yacc.c  */
#line 6675 "gram.y"
    {
					/* we abuse the normal content of a DefElem here */
					(yyval.defelt) = makeDefElem("set", (Node *)(yyvsp[(1) - (1)].vsetstmt));
				}
    break;

  case 1012:
/* Line 1787 of yacc.c  */
#line 6683 "gram.y"
    {
					(yyval.defelt) = makeDefElem("as", (Node *)(yyvsp[(2) - (2)].list));
				}
    break;

  case 1013:
/* Line 1787 of yacc.c  */
#line 6687 "gram.y"
    {
					(yyval.defelt) = makeDefElem("language", (Node *)makeString((yyvsp[(2) - (2)].str)));
				}
    break;

  case 1014:
/* Line 1787 of yacc.c  */
#line 6691 "gram.y"
    {
					(yyval.defelt) = makeDefElem("window", (Node *)makeInteger(TRUE));
				}
    break;

  case 1015:
/* Line 1787 of yacc.c  */
#line 6695 "gram.y"
    {
					(yyval.defelt) = (yyvsp[(1) - (1)].defelt);
				}
    break;

  case 1016:
/* Line 1787 of yacc.c  */
#line 6700 "gram.y"
    { (yyval.list) = list_make1(makeString((yyvsp[(1) - (1)].str))); }
    break;

  case 1017:
/* Line 1787 of yacc.c  */
#line 6702 "gram.y"
    {
					(yyval.list) = list_make2(makeString((yyvsp[(1) - (3)].str)), makeString((yyvsp[(3) - (3)].str)));
				}
    break;

  case 1018:
/* Line 1787 of yacc.c  */
#line 6708 "gram.y"
    { (yyval.list) = (yyvsp[(2) - (2)].list); }
    break;

  case 1019:
/* Line 1787 of yacc.c  */
#line 6709 "gram.y"
    { (yyval.list) = NIL; }
    break;

  case 1020:
/* Line 1787 of yacc.c  */
#line 6713 "gram.y"
    {
					FunctionParameter *n = makeNode(FunctionParameter);
					n->name = (yyvsp[(1) - (2)].str);
					n->argType = (yyvsp[(2) - (2)].typnam);
					n->mode = FUNC_PARAM_TABLE;
					n->defexpr = NULL;
					(yyval.fun_param) = n;
				}
    break;

  case 1021:
/* Line 1787 of yacc.c  */
#line 6725 "gram.y"
    {
					(yyval.list) = list_make1((yyvsp[(1) - (1)].fun_param));
				}
    break;

  case 1022:
/* Line 1787 of yacc.c  */
#line 6729 "gram.y"
    {
					(yyval.list) = lappend((yyvsp[(1) - (3)].list), (yyvsp[(3) - (3)].fun_param));
				}
    break;

  case 1023:
/* Line 1787 of yacc.c  */
#line 6744 "gram.y"
    {
					AlterFunctionStmt *n = makeNode(AlterFunctionStmt);
					n->func = (yyvsp[(3) - (5)].funwithargs);
					n->actions = (yyvsp[(4) - (5)].list);
					(yyval.node) = (Node *) n;
				}
    break;

  case 1024:
/* Line 1787 of yacc.c  */
#line 6754 "gram.y"
    { (yyval.list) = list_make1((yyvsp[(1) - (1)].defelt)); }
    break;

  case 1025:
/* Line 1787 of yacc.c  */
#line 6755 "gram.y"
    { (yyval.list) = lappend((yyvsp[(1) - (2)].list), (yyvsp[(2) - (2)].defelt)); }
    break;

  case 1028:
/* Line 1787 of yacc.c  */
#line 6777 "gram.y"
    {
					DropStmt *n = makeNode(DropStmt);
					n->removeType = OBJECT_FUNCTION;
					n->objects = list_make1((yyvsp[(3) - (5)].list));
					n->arguments = list_make1(extractArgTypes((yyvsp[(4) - (5)].list)));
					n->behavior = (yyvsp[(5) - (5)].dbehavior);
					n->missing_ok = false;
					n->concurrent = false;
					(yyval.node) = (Node *)n;
				}
    break;

  case 1029:
/* Line 1787 of yacc.c  */
#line 6788 "gram.y"
    {
					DropStmt *n = makeNode(DropStmt);
					n->removeType = OBJECT_FUNCTION;
					n->objects = list_make1((yyvsp[(5) - (7)].list));
					n->arguments = list_make1(extractArgTypes((yyvsp[(6) - (7)].list)));
					n->behavior = (yyvsp[(7) - (7)].dbehavior);
					n->missing_ok = true;
					n->concurrent = false;
					(yyval.node) = (Node *)n;
				}
    break;

  case 1030:
/* Line 1787 of yacc.c  */
#line 6802 "gram.y"
    {
					DropStmt *n = makeNode(DropStmt);
					n->removeType = OBJECT_AGGREGATE;
					n->objects = list_make1((yyvsp[(3) - (5)].list));
					n->arguments = list_make1(extractAggrArgTypes((yyvsp[(4) - (5)].list)));
					n->behavior = (yyvsp[(5) - (5)].dbehavior);
					n->missing_ok = false;
					n->concurrent = false;
					(yyval.node) = (Node *)n;
				}
    break;

  case 1031:
/* Line 1787 of yacc.c  */
#line 6813 "gram.y"
    {
					DropStmt *n = makeNode(DropStmt);
					n->removeType = OBJECT_AGGREGATE;
					n->objects = list_make1((yyvsp[(5) - (7)].list));
					n->arguments = list_make1(extractAggrArgTypes((yyvsp[(6) - (7)].list)));
					n->behavior = (yyvsp[(7) - (7)].dbehavior);
					n->missing_ok = true;
					n->concurrent = false;
					(yyval.node) = (Node *)n;
				}
    break;

  case 1032:
/* Line 1787 of yacc.c  */
#line 6827 "gram.y"
    {
					DropStmt *n = makeNode(DropStmt);
					n->removeType = OBJECT_OPERATOR;
					n->objects = list_make1((yyvsp[(3) - (5)].list));
					n->arguments = list_make1((yyvsp[(4) - (5)].list));
					n->behavior = (yyvsp[(5) - (5)].dbehavior);
					n->missing_ok = false;
					n->concurrent = false;
					(yyval.node) = (Node *)n;
				}
    break;

  case 1033:
/* Line 1787 of yacc.c  */
#line 6838 "gram.y"
    {
					DropStmt *n = makeNode(DropStmt);
					n->removeType = OBJECT_OPERATOR;
					n->objects = list_make1((yyvsp[(5) - (7)].list));
					n->arguments = list_make1((yyvsp[(6) - (7)].list));
					n->behavior = (yyvsp[(7) - (7)].dbehavior);
					n->missing_ok = true;
					n->concurrent = false;
					(yyval.node) = (Node *)n;
				}
    break;

  case 1034:
/* Line 1787 of yacc.c  */
#line 6852 "gram.y"
    {
				   ereport(ERROR,
						   (errcode(ERRCODE_SYNTAX_ERROR),
							errmsg("missing argument"),
							errhint("Use NONE to denote the missing argument of a unary operator."),
							parser_errposition((yylsp[(3) - (3)]))));
				}
    break;

  case 1035:
/* Line 1787 of yacc.c  */
#line 6860 "gram.y"
    { (yyval.list) = list_make2((yyvsp[(2) - (5)].typnam), (yyvsp[(4) - (5)].typnam)); }
    break;

  case 1036:
/* Line 1787 of yacc.c  */
#line 6862 "gram.y"
    { (yyval.list) = list_make2(NULL, (yyvsp[(4) - (5)].typnam)); }
    break;

  case 1037:
/* Line 1787 of yacc.c  */
#line 6864 "gram.y"
    { (yyval.list) = list_make2((yyvsp[(2) - (5)].typnam), NULL); }
    break;

  case 1038:
/* Line 1787 of yacc.c  */
#line 6869 "gram.y"
    { (yyval.list) = list_make1(makeString((yyvsp[(1) - (1)].str))); }
    break;

  case 1039:
/* Line 1787 of yacc.c  */
#line 6871 "gram.y"
    { (yyval.list) = lcons(makeString((yyvsp[(1) - (3)].str)), (yyvsp[(3) - (3)].list)); }
    break;

  case 1040:
/* Line 1787 of yacc.c  */
#line 6884 "gram.y"
    {
					DoStmt *n = makeNode(DoStmt);
					n->args = (yyvsp[(2) - (2)].list);
					(yyval.node) = (Node *)n;
				}
    break;

  case 1041:
/* Line 1787 of yacc.c  */
#line 6892 "gram.y"
    { (yyval.list) = list_make1((yyvsp[(1) - (1)].defelt)); }
    break;

  case 1042:
/* Line 1787 of yacc.c  */
#line 6893 "gram.y"
    { (yyval.list) = lappend((yyvsp[(1) - (2)].list), (yyvsp[(2) - (2)].defelt)); }
    break;

  case 1043:
/* Line 1787 of yacc.c  */
#line 6898 "gram.y"
    {
					(yyval.defelt) = makeDefElem("as", (Node *)makeString((yyvsp[(1) - (1)].str)));
				}
    break;

  case 1044:
/* Line 1787 of yacc.c  */
#line 6902 "gram.y"
    {
					(yyval.defelt) = makeDefElem("language", (Node *)makeString((yyvsp[(2) - (2)].str)));
				}
    break;

  case 1045:
/* Line 1787 of yacc.c  */
#line 6915 "gram.y"
    {
					CreateCastStmt *n = makeNode(CreateCastStmt);
					n->sourcetype = (yyvsp[(4) - (11)].typnam);
					n->targettype = (yyvsp[(6) - (11)].typnam);
					n->func = (yyvsp[(10) - (11)].funwithargs);
					n->context = (CoercionContext) (yyvsp[(11) - (11)].ival);
					n->inout = false;
					(yyval.node) = (Node *)n;
				}
    break;

  case 1046:
/* Line 1787 of yacc.c  */
#line 6926 "gram.y"
    {
					CreateCastStmt *n = makeNode(CreateCastStmt);
					n->sourcetype = (yyvsp[(4) - (10)].typnam);
					n->targettype = (yyvsp[(6) - (10)].typnam);
					n->func = NULL;
					n->context = (CoercionContext) (yyvsp[(10) - (10)].ival);
					n->inout = false;
					(yyval.node) = (Node *)n;
				}
    break;

  case 1047:
/* Line 1787 of yacc.c  */
#line 6937 "gram.y"
    {
					CreateCastStmt *n = makeNode(CreateCastStmt);
					n->sourcetype = (yyvsp[(4) - (10)].typnam);
					n->targettype = (yyvsp[(6) - (10)].typnam);
					n->func = NULL;
					n->context = (CoercionContext) (yyvsp[(10) - (10)].ival);
					n->inout = true;
					(yyval.node) = (Node *)n;
				}
    break;

  case 1048:
/* Line 1787 of yacc.c  */
#line 6948 "gram.y"
    { (yyval.ival) = COERCION_IMPLICIT; }
    break;

  case 1049:
/* Line 1787 of yacc.c  */
#line 6949 "gram.y"
    { (yyval.ival) = COERCION_ASSIGNMENT; }
    break;

  case 1050:
/* Line 1787 of yacc.c  */
#line 6950 "gram.y"
    { (yyval.ival) = COERCION_EXPLICIT; }
    break;

  case 1051:
/* Line 1787 of yacc.c  */
#line 6955 "gram.y"
    {
					DropStmt *n = makeNode(DropStmt);
					n->removeType = OBJECT_CAST;
					n->objects = list_make1(list_make1((yyvsp[(5) - (9)].typnam)));
					n->arguments = list_make1(list_make1((yyvsp[(7) - (9)].typnam)));
					n->behavior = (yyvsp[(9) - (9)].dbehavior);
					n->missing_ok = (yyvsp[(3) - (9)].boolean);
					n->concurrent = false;
					(yyval.node) = (Node *)n;
				}
    break;

  case 1052:
/* Line 1787 of yacc.c  */
#line 6967 "gram.y"
    { (yyval.boolean) = TRUE; }
    break;

  case 1053:
/* Line 1787 of yacc.c  */
#line 6968 "gram.y"
    { (yyval.boolean) = FALSE; }
    break;

  case 1054:
/* Line 1787 of yacc.c  */
#line 6983 "gram.y"
    {
					ReindexStmt *n = makeNode(ReindexStmt);
					n->kind = (yyvsp[(2) - (4)].objtype);
					n->relation = (yyvsp[(3) - (4)].range);
					n->name = NULL;
					(yyval.node) = (Node *)n;
				}
    break;

  case 1055:
/* Line 1787 of yacc.c  */
#line 6991 "gram.y"
    {
					ReindexStmt *n = makeNode(ReindexStmt);
					n->kind = OBJECT_DATABASE;
					n->name = (yyvsp[(3) - (4)].str);
					n->relation = NULL;
					n->do_system = true;
					n->do_user = false;
					(yyval.node) = (Node *)n;
				}
    break;

  case 1056:
/* Line 1787 of yacc.c  */
#line 7001 "gram.y"
    {
					ReindexStmt *n = makeNode(ReindexStmt);
					n->kind = OBJECT_DATABASE;
					n->name = (yyvsp[(3) - (4)].str);
					n->relation = NULL;
					n->do_system = true;
					n->do_user = true;
					(yyval.node) = (Node *)n;
				}
    break;

  case 1057:
/* Line 1787 of yacc.c  */
#line 7013 "gram.y"
    { (yyval.objtype) = OBJECT_INDEX; }
    break;

  case 1058:
/* Line 1787 of yacc.c  */
#line 7014 "gram.y"
    { (yyval.objtype) = OBJECT_TABLE; }
    break;

  case 1059:
/* Line 1787 of yacc.c  */
#line 7017 "gram.y"
    {  (yyval.boolean) = TRUE; }
    break;

  case 1060:
/* Line 1787 of yacc.c  */
#line 7018 "gram.y"
    {  (yyval.boolean) = FALSE; }
    break;

  case 1061:
/* Line 1787 of yacc.c  */
#line 7030 "gram.y"
    {
					AlterTableSpaceOptionsStmt *n =
						makeNode(AlterTableSpaceOptionsStmt);
					n->tablespacename = (yyvsp[(3) - (5)].str);
					n->options = (yyvsp[(5) - (5)].list);
					n->isReset = FALSE;
					(yyval.node) = (Node *)n;
				}
    break;

  case 1062:
/* Line 1787 of yacc.c  */
#line 7039 "gram.y"
    {
					AlterTableSpaceOptionsStmt *n =
						makeNode(AlterTableSpaceOptionsStmt);
					n->tablespacename = (yyvsp[(3) - (5)].str);
					n->options = (yyvsp[(5) - (5)].list);
					n->isReset = TRUE;
					(yyval.node) = (Node *)n;
				}
    break;

  case 1063:
/* Line 1787 of yacc.c  */
#line 7056 "gram.y"
    {
					RenameStmt *n = makeNode(RenameStmt);
					n->renameType = OBJECT_AGGREGATE;
					n->object = (yyvsp[(3) - (7)].list);
					n->objarg = extractAggrArgTypes((yyvsp[(4) - (7)].list));
					n->newname = (yyvsp[(7) - (7)].str);
					n->missing_ok = false;
					(yyval.node) = (Node *)n;
				}
    break;

  case 1064:
/* Line 1787 of yacc.c  */
#line 7066 "gram.y"
    {
					RenameStmt *n = makeNode(RenameStmt);
					n->renameType = OBJECT_COLLATION;
					n->object = (yyvsp[(3) - (6)].list);
					n->newname = (yyvsp[(6) - (6)].str);
					n->missing_ok = false;
					(yyval.node) = (Node *)n;
				}
    break;

  case 1065:
/* Line 1787 of yacc.c  */
#line 7075 "gram.y"
    {
					RenameStmt *n = makeNode(RenameStmt);
					n->renameType = OBJECT_CONVERSION;
					n->object = (yyvsp[(3) - (6)].list);
					n->newname = (yyvsp[(6) - (6)].str);
					n->missing_ok = false;
					(yyval.node) = (Node *)n;
				}
    break;

  case 1066:
/* Line 1787 of yacc.c  */
#line 7084 "gram.y"
    {
					RenameStmt *n = makeNode(RenameStmt);
					n->renameType = OBJECT_DATABASE;
					n->subname = (yyvsp[(3) - (6)].str);
					n->newname = (yyvsp[(6) - (6)].str);
					n->missing_ok = false;
					(yyval.node) = (Node *)n;
				}
    break;

  case 1067:
/* Line 1787 of yacc.c  */
#line 7093 "gram.y"
    {
					RenameStmt *n = makeNode(RenameStmt);
					n->renameType = OBJECT_DOMAIN;
					n->object = (yyvsp[(3) - (6)].list);
					n->newname = (yyvsp[(6) - (6)].str);
					n->missing_ok = false;
					(yyval.node) = (Node *)n;
				}
    break;

  case 1068:
/* Line 1787 of yacc.c  */
#line 7102 "gram.y"
    {
					RenameStmt *n = makeNode(RenameStmt);
					n->renameType = OBJECT_CONSTRAINT;
					n->relationType = OBJECT_DOMAIN;
					n->object = (yyvsp[(3) - (8)].list);
					n->subname = (yyvsp[(6) - (8)].str);
					n->newname = (yyvsp[(8) - (8)].str);
					(yyval.node) = (Node *)n;
				}
    break;

  case 1069:
/* Line 1787 of yacc.c  */
#line 7112 "gram.y"
    {
					RenameStmt *n = makeNode(RenameStmt);
					n->renameType = OBJECT_FDW;
					n->object = list_make1(makeString((yyvsp[(5) - (8)].str)));
					n->newname = (yyvsp[(8) - (8)].str);
					n->missing_ok = false;
					(yyval.node) = (Node *)n;
				}
    break;

  case 1070:
/* Line 1787 of yacc.c  */
#line 7121 "gram.y"
    {
					RenameStmt *n = makeNode(RenameStmt);
					n->renameType = OBJECT_FUNCTION;
					n->object = (yyvsp[(3) - (6)].funwithargs)->funcname;
					n->objarg = (yyvsp[(3) - (6)].funwithargs)->funcargs;
					n->newname = (yyvsp[(6) - (6)].str);
					n->missing_ok = false;
					(yyval.node) = (Node *)n;
				}
    break;

  case 1071:
/* Line 1787 of yacc.c  */
#line 7131 "gram.y"
    {
					RenameStmt *n = makeNode(RenameStmt);
					n->renameType = OBJECT_ROLE;
					n->subname = (yyvsp[(3) - (6)].str);
					n->newname = (yyvsp[(6) - (6)].str);
					n->missing_ok = false;
					(yyval.node) = (Node *)n;
				}
    break;

  case 1072:
/* Line 1787 of yacc.c  */
#line 7140 "gram.y"
    {
					RenameStmt *n = makeNode(RenameStmt);
					n->renameType = OBJECT_LANGUAGE;
					n->object = list_make1(makeString((yyvsp[(4) - (7)].str)));
					n->newname = (yyvsp[(7) - (7)].str);
					n->missing_ok = false;
					(yyval.node) = (Node *)n;
				}
    break;

  case 1073:
/* Line 1787 of yacc.c  */
#line 7149 "gram.y"
    {
					RenameStmt *n = makeNode(RenameStmt);
					n->renameType = OBJECT_OPCLASS;
					n->object = (yyvsp[(4) - (9)].list);
					n->objarg = list_make1(makeString((yyvsp[(6) - (9)].str)));
					n->newname = (yyvsp[(9) - (9)].str);
					n->missing_ok = false;
					(yyval.node) = (Node *)n;
				}
    break;

  case 1074:
/* Line 1787 of yacc.c  */
#line 7159 "gram.y"
    {
					RenameStmt *n = makeNode(RenameStmt);
					n->renameType = OBJECT_OPFAMILY;
					n->object = (yyvsp[(4) - (9)].list);
					n->objarg = list_make1(makeString((yyvsp[(6) - (9)].str)));
					n->newname = (yyvsp[(9) - (9)].str);
					n->missing_ok = false;
					(yyval.node) = (Node *)n;
				}
    break;

  case 1075:
/* Line 1787 of yacc.c  */
#line 7169 "gram.y"
    {
					RenameStmt *n = makeNode(RenameStmt);
					n->renameType = OBJECT_SCHEMA;
					n->subname = (yyvsp[(3) - (6)].str);
					n->newname = (yyvsp[(6) - (6)].str);
					n->missing_ok = false;
					(yyval.node) = (Node *)n;
				}
    break;

  case 1076:
/* Line 1787 of yacc.c  */
#line 7178 "gram.y"
    {
					RenameStmt *n = makeNode(RenameStmt);
					n->renameType = OBJECT_FOREIGN_SERVER;
					n->object = list_make1(makeString((yyvsp[(3) - (6)].str)));
					n->newname = (yyvsp[(6) - (6)].str);
					n->missing_ok = false;
					(yyval.node) = (Node *)n;
				}
    break;

  case 1077:
/* Line 1787 of yacc.c  */
#line 7187 "gram.y"
    {
					RenameStmt *n = makeNode(RenameStmt);
					n->renameType = OBJECT_TABLE;
					n->relation = (yyvsp[(3) - (6)].range);
					n->subname = NULL;
					n->newname = (yyvsp[(6) - (6)].str);
					n->missing_ok = false;
					(yyval.node) = (Node *)n;
				}
    break;

  case 1078:
/* Line 1787 of yacc.c  */
#line 7197 "gram.y"
    {
					RenameStmt *n = makeNode(RenameStmt);
					n->renameType = OBJECT_TABLE;
					n->relation = (yyvsp[(5) - (8)].range);
					n->subname = NULL;
					n->newname = (yyvsp[(8) - (8)].str);
					n->missing_ok = true;
					(yyval.node) = (Node *)n;
				}
    break;

  case 1079:
/* Line 1787 of yacc.c  */
#line 7207 "gram.y"
    {
					RenameStmt *n = makeNode(RenameStmt);
					n->renameType = OBJECT_SEQUENCE;
					n->relation = (yyvsp[(3) - (6)].range);
					n->subname = NULL;
					n->newname = (yyvsp[(6) - (6)].str);
					n->missing_ok = false;
					(yyval.node) = (Node *)n;
				}
    break;

  case 1080:
/* Line 1787 of yacc.c  */
#line 7217 "gram.y"
    {
					RenameStmt *n = makeNode(RenameStmt);
					n->renameType = OBJECT_SEQUENCE;
					n->relation = (yyvsp[(5) - (8)].range);
					n->subname = NULL;
					n->newname = (yyvsp[(8) - (8)].str);
					n->missing_ok = true;
					(yyval.node) = (Node *)n;
				}
    break;

  case 1081:
/* Line 1787 of yacc.c  */
#line 7227 "gram.y"
    {
					RenameStmt *n = makeNode(RenameStmt);
					n->renameType = OBJECT_VIEW;
					n->relation = (yyvsp[(3) - (6)].range);
					n->subname = NULL;
					n->newname = (yyvsp[(6) - (6)].str);
					n->missing_ok = false;
					(yyval.node) = (Node *)n;
				}
    break;

  case 1082:
/* Line 1787 of yacc.c  */
#line 7237 "gram.y"
    {
					RenameStmt *n = makeNode(RenameStmt);
					n->renameType = OBJECT_VIEW;
					n->relation = (yyvsp[(5) - (8)].range);
					n->subname = NULL;
					n->newname = (yyvsp[(8) - (8)].str);
					n->missing_ok = true;
					(yyval.node) = (Node *)n;
				}
    break;

  case 1083:
/* Line 1787 of yacc.c  */
#line 7247 "gram.y"
    {
					RenameStmt *n = makeNode(RenameStmt);
					n->renameType = OBJECT_MATVIEW;
					n->relation = (yyvsp[(4) - (7)].range);
					n->subname = NULL;
					n->newname = (yyvsp[(7) - (7)].str);
					n->missing_ok = false;
					(yyval.node) = (Node *)n;
				}
    break;

  case 1084:
/* Line 1787 of yacc.c  */
#line 7257 "gram.y"
    {
					RenameStmt *n = makeNode(RenameStmt);
					n->renameType = OBJECT_MATVIEW;
					n->relation = (yyvsp[(6) - (9)].range);
					n->subname = NULL;
					n->newname = (yyvsp[(9) - (9)].str);
					n->missing_ok = true;
					(yyval.node) = (Node *)n;
				}
    break;

  case 1085:
/* Line 1787 of yacc.c  */
#line 7267 "gram.y"
    {
					RenameStmt *n = makeNode(RenameStmt);
					n->renameType = OBJECT_INDEX;
					n->relation = (yyvsp[(3) - (6)].range);
					n->subname = NULL;
					n->newname = (yyvsp[(6) - (6)].str);
					n->missing_ok = false;
					(yyval.node) = (Node *)n;
				}
    break;

  case 1086:
/* Line 1787 of yacc.c  */
#line 7277 "gram.y"
    {
					RenameStmt *n = makeNode(RenameStmt);
					n->renameType = OBJECT_INDEX;
					n->relation = (yyvsp[(5) - (8)].range);
					n->subname = NULL;
					n->newname = (yyvsp[(8) - (8)].str);
					n->missing_ok = true;
					(yyval.node) = (Node *)n;
				}
    break;

  case 1087:
/* Line 1787 of yacc.c  */
#line 7287 "gram.y"
    {
					RenameStmt *n = makeNode(RenameStmt);
					n->renameType = OBJECT_FOREIGN_TABLE;
					n->relation = (yyvsp[(4) - (7)].range);
					n->subname = NULL;
					n->newname = (yyvsp[(7) - (7)].str);
					n->missing_ok = false;
					(yyval.node) = (Node *)n;
				}
    break;

  case 1088:
/* Line 1787 of yacc.c  */
#line 7297 "gram.y"
    {
					RenameStmt *n = makeNode(RenameStmt);
					n->renameType = OBJECT_FOREIGN_TABLE;
					n->relation = (yyvsp[(6) - (9)].range);
					n->subname = NULL;
					n->newname = (yyvsp[(9) - (9)].str);
					n->missing_ok = true;
					(yyval.node) = (Node *)n;
				}
    break;

  case 1089:
/* Line 1787 of yacc.c  */
#line 7307 "gram.y"
    {
					RenameStmt *n = makeNode(RenameStmt);
					n->renameType = OBJECT_COLUMN;
					n->relationType = OBJECT_TABLE;
					n->relation = (yyvsp[(3) - (8)].range);
					n->subname = (yyvsp[(6) - (8)].str);
					n->newname = (yyvsp[(8) - (8)].str);
					n->missing_ok = false;
					(yyval.node) = (Node *)n;
				}
    break;

  case 1090:
/* Line 1787 of yacc.c  */
#line 7318 "gram.y"
    {
					RenameStmt *n = makeNode(RenameStmt);
					n->renameType = OBJECT_COLUMN;
					n->relationType = OBJECT_TABLE;
					n->relation = (yyvsp[(5) - (10)].range);
					n->subname = (yyvsp[(8) - (10)].str);
					n->newname = (yyvsp[(10) - (10)].str);
					n->missing_ok = true;
					(yyval.node) = (Node *)n;
				}
    break;

  case 1091:
/* Line 1787 of yacc.c  */
#line 7329 "gram.y"
    {
					RenameStmt *n = makeNode(RenameStmt);
					n->renameType = OBJECT_COLUMN;
					n->relationType = OBJECT_MATVIEW;
					n->relation = (yyvsp[(4) - (9)].range);
					n->subname = (yyvsp[(7) - (9)].str);
					n->newname = (yyvsp[(9) - (9)].str);
					n->missing_ok = false;
					(yyval.node) = (Node *)n;
				}
    break;

  case 1092:
/* Line 1787 of yacc.c  */
#line 7340 "gram.y"
    {
					RenameStmt *n = makeNode(RenameStmt);
					n->renameType = OBJECT_COLUMN;
					n->relationType = OBJECT_MATVIEW;
					n->relation = (yyvsp[(6) - (11)].range);
					n->subname = (yyvsp[(9) - (11)].str);
					n->newname = (yyvsp[(11) - (11)].str);
					n->missing_ok = true;
					(yyval.node) = (Node *)n;
				}
    break;

  case 1093:
/* Line 1787 of yacc.c  */
#line 7351 "gram.y"
    {
					RenameStmt *n = makeNode(RenameStmt);
					n->renameType = OBJECT_CONSTRAINT;
					n->relationType = OBJECT_TABLE;
					n->relation = (yyvsp[(3) - (8)].range);
					n->subname = (yyvsp[(6) - (8)].str);
					n->newname = (yyvsp[(8) - (8)].str);
					(yyval.node) = (Node *)n;
				}
    break;

  case 1094:
/* Line 1787 of yacc.c  */
#line 7361 "gram.y"
    {
					RenameStmt *n = makeNode(RenameStmt);
					n->renameType = OBJECT_COLUMN;
					n->relationType = OBJECT_FOREIGN_TABLE;
					n->relation = (yyvsp[(4) - (9)].range);
					n->subname = (yyvsp[(7) - (9)].str);
					n->newname = (yyvsp[(9) - (9)].str);
					n->missing_ok = false;
					(yyval.node) = (Node *)n;
				}
    break;

  case 1095:
/* Line 1787 of yacc.c  */
#line 7372 "gram.y"
    {
					RenameStmt *n = makeNode(RenameStmt);
					n->renameType = OBJECT_COLUMN;
					n->relationType = OBJECT_FOREIGN_TABLE;
					n->relation = (yyvsp[(6) - (11)].range);
					n->subname = (yyvsp[(9) - (11)].str);
					n->newname = (yyvsp[(11) - (11)].str);
					n->missing_ok = true;
					(yyval.node) = (Node *)n;
				}
    break;

  case 1096:
/* Line 1787 of yacc.c  */
#line 7383 "gram.y"
    {
					RenameStmt *n = makeNode(RenameStmt);
					n->renameType = OBJECT_RULE;
					n->relation = (yyvsp[(5) - (8)].range);
					n->subname = (yyvsp[(3) - (8)].str);
					n->newname = (yyvsp[(8) - (8)].str);
					n->missing_ok = false;
					(yyval.node) = (Node *)n;
				}
    break;

  case 1097:
/* Line 1787 of yacc.c  */
#line 7393 "gram.y"
    {
					RenameStmt *n = makeNode(RenameStmt);
					n->renameType = OBJECT_TRIGGER;
					n->relation = (yyvsp[(5) - (8)].range);
					n->subname = (yyvsp[(3) - (8)].str);
					n->newname = (yyvsp[(8) - (8)].str);
					n->missing_ok = false;
					(yyval.node) = (Node *)n;
				}
    break;

  case 1098:
/* Line 1787 of yacc.c  */
#line 7403 "gram.y"
    {
					RenameStmt *n = makeNode(RenameStmt);
					n->renameType = OBJECT_EVENT_TRIGGER;
					n->object = list_make1(makeString((yyvsp[(4) - (7)].str)));
					n->newname = (yyvsp[(7) - (7)].str);
					(yyval.node) = (Node *)n;
				}
    break;

  case 1099:
/* Line 1787 of yacc.c  */
#line 7411 "gram.y"
    {
					RenameStmt *n = makeNode(RenameStmt);
					n->renameType = OBJECT_ROLE;
					n->subname = (yyvsp[(3) - (6)].str);
					n->newname = (yyvsp[(6) - (6)].str);
					n->missing_ok = false;
					(yyval.node) = (Node *)n;
				}
    break;

  case 1100:
/* Line 1787 of yacc.c  */
#line 7420 "gram.y"
    {
					RenameStmt *n = makeNode(RenameStmt);
					n->renameType = OBJECT_ROLE;
					n->subname = (yyvsp[(3) - (6)].str);
					n->newname = (yyvsp[(6) - (6)].str);
					n->missing_ok = false;
					(yyval.node) = (Node *)n;
				}
    break;

  case 1101:
/* Line 1787 of yacc.c  */
#line 7429 "gram.y"
    {
					RenameStmt *n = makeNode(RenameStmt);
					n->renameType = OBJECT_TABLESPACE;
					n->subname = (yyvsp[(3) - (6)].str);
					n->newname = (yyvsp[(6) - (6)].str);
					n->missing_ok = false;
					(yyval.node) = (Node *)n;
				}
    break;

  case 1102:
/* Line 1787 of yacc.c  */
#line 7438 "gram.y"
    {
					RenameStmt *n = makeNode(RenameStmt);
					n->renameType = OBJECT_TSPARSER;
					n->object = (yyvsp[(5) - (8)].list);
					n->newname = (yyvsp[(8) - (8)].str);
					n->missing_ok = false;
					(yyval.node) = (Node *)n;
				}
    break;

  case 1103:
/* Line 1787 of yacc.c  */
#line 7447 "gram.y"
    {
					RenameStmt *n = makeNode(RenameStmt);
					n->renameType = OBJECT_TSDICTIONARY;
					n->object = (yyvsp[(5) - (8)].list);
					n->newname = (yyvsp[(8) - (8)].str);
					n->missing_ok = false;
					(yyval.node) = (Node *)n;
				}
    break;

  case 1104:
/* Line 1787 of yacc.c  */
#line 7456 "gram.y"
    {
					RenameStmt *n = makeNode(RenameStmt);
					n->renameType = OBJECT_TSTEMPLATE;
					n->object = (yyvsp[(5) - (8)].list);
					n->newname = (yyvsp[(8) - (8)].str);
					n->missing_ok = false;
					(yyval.node) = (Node *)n;
				}
    break;

  case 1105:
/* Line 1787 of yacc.c  */
#line 7465 "gram.y"
    {
					RenameStmt *n = makeNode(RenameStmt);
					n->renameType = OBJECT_TSCONFIGURATION;
					n->object = (yyvsp[(5) - (8)].list);
					n->newname = (yyvsp[(8) - (8)].str);
					n->missing_ok = false;
					(yyval.node) = (Node *)n;
				}
    break;

  case 1106:
/* Line 1787 of yacc.c  */
#line 7474 "gram.y"
    {
					RenameStmt *n = makeNode(RenameStmt);
					n->renameType = OBJECT_TYPE;
					n->object = (yyvsp[(3) - (6)].list);
					n->newname = (yyvsp[(6) - (6)].str);
					n->missing_ok = false;
					(yyval.node) = (Node *)n;
				}
    break;

  case 1107:
/* Line 1787 of yacc.c  */
#line 7483 "gram.y"
    {
					RenameStmt *n = makeNode(RenameStmt);
					n->renameType = OBJECT_ATTRIBUTE;
					n->relationType = OBJECT_TYPE;
					n->relation = makeRangeVarFromAnyName((yyvsp[(3) - (9)].list), (yylsp[(3) - (9)]), yyscanner);
					n->subname = (yyvsp[(6) - (9)].str);
					n->newname = (yyvsp[(8) - (9)].str);
					n->behavior = (yyvsp[(9) - (9)].dbehavior);
					n->missing_ok = false;
					(yyval.node) = (Node *)n;
				}
    break;

  case 1108:
/* Line 1787 of yacc.c  */
#line 7496 "gram.y"
    { (yyval.ival) = COLUMN; }
    break;

  case 1109:
/* Line 1787 of yacc.c  */
#line 7497 "gram.y"
    { (yyval.ival) = 0; }
    break;

  case 1110:
/* Line 1787 of yacc.c  */
#line 7500 "gram.y"
    { (yyval.ival) = 1; }
    break;

  case 1111:
/* Line 1787 of yacc.c  */
#line 7501 "gram.y"
    { (yyval.ival) = 0; }
    break;

  case 1112:
/* Line 1787 of yacc.c  */
#line 7512 "gram.y"
    {
					AlterObjectSchemaStmt *n = makeNode(AlterObjectSchemaStmt);
					n->objectType = OBJECT_AGGREGATE;
					n->object = (yyvsp[(3) - (7)].list);
					n->objarg = extractAggrArgTypes((yyvsp[(4) - (7)].list));
					n->newschema = (yyvsp[(7) - (7)].str);
					n->missing_ok = false;
					(yyval.node) = (Node *)n;
				}
    break;

  case 1113:
/* Line 1787 of yacc.c  */
#line 7522 "gram.y"
    {
					AlterObjectSchemaStmt *n = makeNode(AlterObjectSchemaStmt);
					n->objectType = OBJECT_COLLATION;
					n->object = (yyvsp[(3) - (6)].list);
					n->newschema = (yyvsp[(6) - (6)].str);
					n->missing_ok = false;
					(yyval.node) = (Node *)n;
				}
    break;

  case 1114:
/* Line 1787 of yacc.c  */
#line 7531 "gram.y"
    {
					AlterObjectSchemaStmt *n = makeNode(AlterObjectSchemaStmt);
					n->objectType = OBJECT_CONVERSION;
					n->object = (yyvsp[(3) - (6)].list);
					n->newschema = (yyvsp[(6) - (6)].str);
					n->missing_ok = false;
					(yyval.node) = (Node *)n;
				}
    break;

  case 1115:
/* Line 1787 of yacc.c  */
#line 7540 "gram.y"
    {
					AlterObjectSchemaStmt *n = makeNode(AlterObjectSchemaStmt);
					n->objectType = OBJECT_DOMAIN;
					n->object = (yyvsp[(3) - (6)].list);
					n->newschema = (yyvsp[(6) - (6)].str);
					n->missing_ok = false;
					(yyval.node) = (Node *)n;
				}
    break;

  case 1116:
/* Line 1787 of yacc.c  */
#line 7549 "gram.y"
    {
					AlterObjectSchemaStmt *n = makeNode(AlterObjectSchemaStmt);
					n->objectType = OBJECT_EXTENSION;
					n->object = (yyvsp[(3) - (6)].list);
					n->newschema = (yyvsp[(6) - (6)].str);
					n->missing_ok = false;
					(yyval.node) = (Node *)n;
				}
    break;

  case 1117:
/* Line 1787 of yacc.c  */
#line 7558 "gram.y"
    {
					AlterObjectSchemaStmt *n = makeNode(AlterObjectSchemaStmt);
					n->objectType = OBJECT_FUNCTION;
					n->object = (yyvsp[(3) - (6)].funwithargs)->funcname;
					n->objarg = (yyvsp[(3) - (6)].funwithargs)->funcargs;
					n->newschema = (yyvsp[(6) - (6)].str);
					n->missing_ok = false;
					(yyval.node) = (Node *)n;
				}
    break;

  case 1118:
/* Line 1787 of yacc.c  */
#line 7568 "gram.y"
    {
					AlterObjectSchemaStmt *n = makeNode(AlterObjectSchemaStmt);
					n->objectType = OBJECT_OPERATOR;
					n->object = (yyvsp[(3) - (7)].list);
					n->objarg = (yyvsp[(4) - (7)].list);
					n->newschema = (yyvsp[(7) - (7)].str);
					n->missing_ok = false;
					(yyval.node) = (Node *)n;
				}
    break;

  case 1119:
/* Line 1787 of yacc.c  */
#line 7578 "gram.y"
    {
					AlterObjectSchemaStmt *n = makeNode(AlterObjectSchemaStmt);
					n->objectType = OBJECT_OPCLASS;
					n->object = (yyvsp[(4) - (9)].list);
					n->objarg = list_make1(makeString((yyvsp[(6) - (9)].str)));
					n->newschema = (yyvsp[(9) - (9)].str);
					n->missing_ok = false;
					(yyval.node) = (Node *)n;
				}
    break;

  case 1120:
/* Line 1787 of yacc.c  */
#line 7588 "gram.y"
    {
					AlterObjectSchemaStmt *n = makeNode(AlterObjectSchemaStmt);
					n->objectType = OBJECT_OPFAMILY;
					n->object = (yyvsp[(4) - (9)].list);
					n->objarg = list_make1(makeString((yyvsp[(6) - (9)].str)));
					n->newschema = (yyvsp[(9) - (9)].str);
					n->missing_ok = false;
					(yyval.node) = (Node *)n;
				}
    break;

  case 1121:
/* Line 1787 of yacc.c  */
#line 7598 "gram.y"
    {
					AlterObjectSchemaStmt *n = makeNode(AlterObjectSchemaStmt);
					n->objectType = OBJECT_TABLE;
					n->relation = (yyvsp[(3) - (6)].range);
					n->newschema = (yyvsp[(6) - (6)].str);
					n->missing_ok = false;
					(yyval.node) = (Node *)n;
				}
    break;

  case 1122:
/* Line 1787 of yacc.c  */
#line 7607 "gram.y"
    {
					AlterObjectSchemaStmt *n = makeNode(AlterObjectSchemaStmt);
					n->objectType = OBJECT_TABLE;
					n->relation = (yyvsp[(5) - (8)].range);
					n->newschema = (yyvsp[(8) - (8)].str);
					n->missing_ok = true;
					(yyval.node) = (Node *)n;
				}
    break;

  case 1123:
/* Line 1787 of yacc.c  */
#line 7616 "gram.y"
    {
					AlterObjectSchemaStmt *n = makeNode(AlterObjectSchemaStmt);
					n->objectType = OBJECT_TSPARSER;
					n->object = (yyvsp[(5) - (8)].list);
					n->newschema = (yyvsp[(8) - (8)].str);
					n->missing_ok = false;
					(yyval.node) = (Node *)n;
				}
    break;

  case 1124:
/* Line 1787 of yacc.c  */
#line 7625 "gram.y"
    {
					AlterObjectSchemaStmt *n = makeNode(AlterObjectSchemaStmt);
					n->objectType = OBJECT_TSDICTIONARY;
					n->object = (yyvsp[(5) - (8)].list);
					n->newschema = (yyvsp[(8) - (8)].str);
					n->missing_ok = false;
					(yyval.node) = (Node *)n;
				}
    break;

  case 1125:
/* Line 1787 of yacc.c  */
#line 7634 "gram.y"
    {
					AlterObjectSchemaStmt *n = makeNode(AlterObjectSchemaStmt);
					n->objectType = OBJECT_TSTEMPLATE;
					n->object = (yyvsp[(5) - (8)].list);
					n->newschema = (yyvsp[(8) - (8)].str);
					n->missing_ok = false;
					(yyval.node) = (Node *)n;
				}
    break;

  case 1126:
/* Line 1787 of yacc.c  */
#line 7643 "gram.y"
    {
					AlterObjectSchemaStmt *n = makeNode(AlterObjectSchemaStmt);
					n->objectType = OBJECT_TSCONFIGURATION;
					n->object = (yyvsp[(5) - (8)].list);
					n->newschema = (yyvsp[(8) - (8)].str);
					n->missing_ok = false;
					(yyval.node) = (Node *)n;
				}
    break;

  case 1127:
/* Line 1787 of yacc.c  */
#line 7652 "gram.y"
    {
					AlterObjectSchemaStmt *n = makeNode(AlterObjectSchemaStmt);
					n->objectType = OBJECT_SEQUENCE;
					n->relation = (yyvsp[(3) - (6)].range);
					n->newschema = (yyvsp[(6) - (6)].str);
					n->missing_ok = false;
					(yyval.node) = (Node *)n;
				}
    break;

  case 1128:
/* Line 1787 of yacc.c  */
#line 7661 "gram.y"
    {
					AlterObjectSchemaStmt *n = makeNode(AlterObjectSchemaStmt);
					n->objectType = OBJECT_SEQUENCE;
					n->relation = (yyvsp[(5) - (8)].range);
					n->newschema = (yyvsp[(8) - (8)].str);
					n->missing_ok = true;
					(yyval.node) = (Node *)n;
				}
    break;

  case 1129:
/* Line 1787 of yacc.c  */
#line 7670 "gram.y"
    {
					AlterObjectSchemaStmt *n = makeNode(AlterObjectSchemaStmt);
					n->objectType = OBJECT_VIEW;
					n->relation = (yyvsp[(3) - (6)].range);
					n->newschema = (yyvsp[(6) - (6)].str);
					n->missing_ok = false;
					(yyval.node) = (Node *)n;
				}
    break;

  case 1130:
/* Line 1787 of yacc.c  */
#line 7679 "gram.y"
    {
					AlterObjectSchemaStmt *n = makeNode(AlterObjectSchemaStmt);
					n->objectType = OBJECT_VIEW;
					n->relation = (yyvsp[(5) - (8)].range);
					n->newschema = (yyvsp[(8) - (8)].str);
					n->missing_ok = true;
					(yyval.node) = (Node *)n;
				}
    break;

  case 1131:
/* Line 1787 of yacc.c  */
#line 7688 "gram.y"
    {
					AlterObjectSchemaStmt *n = makeNode(AlterObjectSchemaStmt);
					n->objectType = OBJECT_MATVIEW;
					n->relation = (yyvsp[(4) - (7)].range);
					n->newschema = (yyvsp[(7) - (7)].str);
					n->missing_ok = false;
					(yyval.node) = (Node *)n;
				}
    break;

  case 1132:
/* Line 1787 of yacc.c  */
#line 7697 "gram.y"
    {
					AlterObjectSchemaStmt *n = makeNode(AlterObjectSchemaStmt);
					n->objectType = OBJECT_MATVIEW;
					n->relation = (yyvsp[(6) - (9)].range);
					n->newschema = (yyvsp[(9) - (9)].str);
					n->missing_ok = true;
					(yyval.node) = (Node *)n;
				}
    break;

  case 1133:
/* Line 1787 of yacc.c  */
#line 7706 "gram.y"
    {
					AlterObjectSchemaStmt *n = makeNode(AlterObjectSchemaStmt);
					n->objectType = OBJECT_FOREIGN_TABLE;
					n->relation = (yyvsp[(4) - (7)].range);
					n->newschema = (yyvsp[(7) - (7)].str);
					n->missing_ok = false;
					(yyval.node) = (Node *)n;
				}
    break;

  case 1134:
/* Line 1787 of yacc.c  */
#line 7715 "gram.y"
    {
					AlterObjectSchemaStmt *n = makeNode(AlterObjectSchemaStmt);
					n->objectType = OBJECT_FOREIGN_TABLE;
					n->relation = (yyvsp[(6) - (9)].range);
					n->newschema = (yyvsp[(9) - (9)].str);
					n->missing_ok = true;
					(yyval.node) = (Node *)n;
				}
    break;

  case 1135:
/* Line 1787 of yacc.c  */
#line 7724 "gram.y"
    {
					AlterObjectSchemaStmt *n = makeNode(AlterObjectSchemaStmt);
					n->objectType = OBJECT_TYPE;
					n->object = (yyvsp[(3) - (6)].list);
					n->newschema = (yyvsp[(6) - (6)].str);
					n->missing_ok = false;
					(yyval.node) = (Node *)n;
				}
    break;

  case 1136:
/* Line 1787 of yacc.c  */
#line 7741 "gram.y"
    {
					AlterOwnerStmt *n = makeNode(AlterOwnerStmt);
					n->objectType = OBJECT_AGGREGATE;
					n->object = (yyvsp[(3) - (7)].list);
					n->objarg = extractAggrArgTypes((yyvsp[(4) - (7)].list));
					n->newowner = (yyvsp[(7) - (7)].str);
					(yyval.node) = (Node *)n;
				}
    break;

  case 1137:
/* Line 1787 of yacc.c  */
#line 7750 "gram.y"
    {
					AlterOwnerStmt *n = makeNode(AlterOwnerStmt);
					n->objectType = OBJECT_COLLATION;
					n->object = (yyvsp[(3) - (6)].list);
					n->newowner = (yyvsp[(6) - (6)].str);
					(yyval.node) = (Node *)n;
				}
    break;

  case 1138:
/* Line 1787 of yacc.c  */
#line 7758 "gram.y"
    {
					AlterOwnerStmt *n = makeNode(AlterOwnerStmt);
					n->objectType = OBJECT_CONVERSION;
					n->object = (yyvsp[(3) - (6)].list);
					n->newowner = (yyvsp[(6) - (6)].str);
					(yyval.node) = (Node *)n;
				}
    break;

  case 1139:
/* Line 1787 of yacc.c  */
#line 7766 "gram.y"
    {
					AlterOwnerStmt *n = makeNode(AlterOwnerStmt);
					n->objectType = OBJECT_DATABASE;
					n->object = list_make1(makeString((yyvsp[(3) - (6)].str)));
					n->newowner = (yyvsp[(6) - (6)].str);
					(yyval.node) = (Node *)n;
				}
    break;

  case 1140:
/* Line 1787 of yacc.c  */
#line 7774 "gram.y"
    {
					AlterOwnerStmt *n = makeNode(AlterOwnerStmt);
					n->objectType = OBJECT_DOMAIN;
					n->object = (yyvsp[(3) - (6)].list);
					n->newowner = (yyvsp[(6) - (6)].str);
					(yyval.node) = (Node *)n;
				}
    break;

  case 1141:
/* Line 1787 of yacc.c  */
#line 7782 "gram.y"
    {
					AlterOwnerStmt *n = makeNode(AlterOwnerStmt);
					n->objectType = OBJECT_FUNCTION;
					n->object = (yyvsp[(3) - (6)].funwithargs)->funcname;
					n->objarg = (yyvsp[(3) - (6)].funwithargs)->funcargs;
					n->newowner = (yyvsp[(6) - (6)].str);
					(yyval.node) = (Node *)n;
				}
    break;

  case 1142:
/* Line 1787 of yacc.c  */
#line 7791 "gram.y"
    {
					AlterOwnerStmt *n = makeNode(AlterOwnerStmt);
					n->objectType = OBJECT_LANGUAGE;
					n->object = list_make1(makeString((yyvsp[(4) - (7)].str)));
					n->newowner = (yyvsp[(7) - (7)].str);
					(yyval.node) = (Node *)n;
				}
    break;

  case 1143:
/* Line 1787 of yacc.c  */
#line 7799 "gram.y"
    {
					AlterOwnerStmt *n = makeNode(AlterOwnerStmt);
					n->objectType = OBJECT_LARGEOBJECT;
					n->object = list_make1((yyvsp[(4) - (7)].value));
					n->newowner = (yyvsp[(7) - (7)].str);
					(yyval.node) = (Node *)n;
				}
    break;

  case 1144:
/* Line 1787 of yacc.c  */
#line 7807 "gram.y"
    {
					AlterOwnerStmt *n = makeNode(AlterOwnerStmt);
					n->objectType = OBJECT_OPERATOR;
					n->object = (yyvsp[(3) - (7)].list);
					n->objarg = (yyvsp[(4) - (7)].list);
					n->newowner = (yyvsp[(7) - (7)].str);
					(yyval.node) = (Node *)n;
				}
    break;

  case 1145:
/* Line 1787 of yacc.c  */
#line 7816 "gram.y"
    {
					AlterOwnerStmt *n = makeNode(AlterOwnerStmt);
					n->objectType = OBJECT_OPCLASS;
					n->object = (yyvsp[(4) - (9)].list);
					n->objarg = list_make1(makeString((yyvsp[(6) - (9)].str)));
					n->newowner = (yyvsp[(9) - (9)].str);
					(yyval.node) = (Node *)n;
				}
    break;

  case 1146:
/* Line 1787 of yacc.c  */
#line 7825 "gram.y"
    {
					AlterOwnerStmt *n = makeNode(AlterOwnerStmt);
					n->objectType = OBJECT_OPFAMILY;
					n->object = (yyvsp[(4) - (9)].list);
					n->objarg = list_make1(makeString((yyvsp[(6) - (9)].str)));
					n->newowner = (yyvsp[(9) - (9)].str);
					(yyval.node) = (Node *)n;
				}
    break;

  case 1147:
/* Line 1787 of yacc.c  */
#line 7834 "gram.y"
    {
					AlterOwnerStmt *n = makeNode(AlterOwnerStmt);
					n->objectType = OBJECT_SCHEMA;
					n->object = list_make1(makeString((yyvsp[(3) - (6)].str)));
					n->newowner = (yyvsp[(6) - (6)].str);
					(yyval.node) = (Node *)n;
				}
    break;

  case 1148:
/* Line 1787 of yacc.c  */
#line 7842 "gram.y"
    {
					AlterOwnerStmt *n = makeNode(AlterOwnerStmt);
					n->objectType = OBJECT_TYPE;
					n->object = (yyvsp[(3) - (6)].list);
					n->newowner = (yyvsp[(6) - (6)].str);
					(yyval.node) = (Node *)n;
				}
    break;

  case 1149:
/* Line 1787 of yacc.c  */
#line 7850 "gram.y"
    {
					AlterOwnerStmt *n = makeNode(AlterOwnerStmt);
					n->objectType = OBJECT_TABLESPACE;
					n->object = list_make1(makeString((yyvsp[(3) - (6)].str)));
					n->newowner = (yyvsp[(6) - (6)].str);
					(yyval.node) = (Node *)n;
				}
    break;

  case 1150:
/* Line 1787 of yacc.c  */
#line 7858 "gram.y"
    {
					AlterOwnerStmt *n = makeNode(AlterOwnerStmt);
					n->objectType = OBJECT_TSDICTIONARY;
					n->object = (yyvsp[(5) - (8)].list);
					n->newowner = (yyvsp[(8) - (8)].str);
					(yyval.node) = (Node *)n;
				}
    break;

  case 1151:
/* Line 1787 of yacc.c  */
#line 7866 "gram.y"
    {
					AlterOwnerStmt *n = makeNode(AlterOwnerStmt);
					n->objectType = OBJECT_TSCONFIGURATION;
					n->object = (yyvsp[(5) - (8)].list);
					n->newowner = (yyvsp[(8) - (8)].str);
					(yyval.node) = (Node *)n;
				}
    break;

  case 1152:
/* Line 1787 of yacc.c  */
#line 7874 "gram.y"
    {
					AlterOwnerStmt *n = makeNode(AlterOwnerStmt);
					n->objectType = OBJECT_FDW;
					n->object = list_make1(makeString((yyvsp[(5) - (8)].str)));
					n->newowner = (yyvsp[(8) - (8)].str);
					(yyval.node) = (Node *)n;
				}
    break;

  case 1153:
/* Line 1787 of yacc.c  */
#line 7882 "gram.y"
    {
					AlterOwnerStmt *n = makeNode(AlterOwnerStmt);
					n->objectType = OBJECT_FOREIGN_SERVER;
					n->object = list_make1(makeString((yyvsp[(3) - (6)].str)));
					n->newowner = (yyvsp[(6) - (6)].str);
					(yyval.node) = (Node *)n;
				}
    break;

  case 1154:
/* Line 1787 of yacc.c  */
#line 7890 "gram.y"
    {
					AlterOwnerStmt *n = makeNode(AlterOwnerStmt);
					n->objectType = OBJECT_EVENT_TRIGGER;
					n->object = list_make1(makeString((yyvsp[(4) - (7)].str)));
					n->newowner = (yyvsp[(7) - (7)].str);
					(yyval.node) = (Node *)n;
				}
    break;

  case 1155:
/* Line 1787 of yacc.c  */
#line 7909 "gram.y"
    {
					RuleStmt *n = makeNode(RuleStmt);
					n->replace = (yyvsp[(2) - (13)].boolean);
					n->relation = (yyvsp[(9) - (13)].range);
					n->rulename = (yyvsp[(4) - (13)].str);
					n->whereClause = (yyvsp[(10) - (13)].node);
					n->event = (yyvsp[(7) - (13)].ival);
					n->instead = (yyvsp[(12) - (13)].boolean);
					n->actions = (yyvsp[(13) - (13)].list);
					(yyval.node) = (Node *)n;
				}
    break;

  case 1156:
/* Line 1787 of yacc.c  */
#line 7923 "gram.y"
    { (yyval.list) = NIL; }
    break;

  case 1157:
/* Line 1787 of yacc.c  */
#line 7924 "gram.y"
    { (yyval.list) = list_make1((yyvsp[(1) - (1)].node)); }
    break;

  case 1158:
/* Line 1787 of yacc.c  */
#line 7925 "gram.y"
    { (yyval.list) = (yyvsp[(2) - (3)].list); }
    break;

  case 1159:
/* Line 1787 of yacc.c  */
#line 7931 "gram.y"
    { if ((yyvsp[(3) - (3)].node) != NULL)
					(yyval.list) = lappend((yyvsp[(1) - (3)].list), (yyvsp[(3) - (3)].node));
				  else
					(yyval.list) = (yyvsp[(1) - (3)].list);
				}
    break;

  case 1160:
/* Line 1787 of yacc.c  */
#line 7937 "gram.y"
    { if ((yyvsp[(1) - (1)].node) != NULL)
					(yyval.list) = list_make1((yyvsp[(1) - (1)].node));
				  else
					(yyval.list) = NIL;
				}
    break;

  case 1166:
/* Line 1787 of yacc.c  */
#line 7953 "gram.y"
    { (yyval.node) = (yyvsp[(1) - (1)].node); }
    break;

  case 1167:
/* Line 1787 of yacc.c  */
#line 7954 "gram.y"
    { (yyval.node) = NULL; }
    break;

  case 1168:
/* Line 1787 of yacc.c  */
#line 7957 "gram.y"
    { (yyval.ival) = CMD_SELECT; }
    break;

  case 1169:
/* Line 1787 of yacc.c  */
#line 7958 "gram.y"
    { (yyval.ival) = CMD_UPDATE; }
    break;

  case 1170:
/* Line 1787 of yacc.c  */
#line 7959 "gram.y"
    { (yyval.ival) = CMD_DELETE; }
    break;

  case 1171:
/* Line 1787 of yacc.c  */
#line 7960 "gram.y"
    { (yyval.ival) = CMD_INSERT; }
    break;

  case 1172:
/* Line 1787 of yacc.c  */
#line 7964 "gram.y"
    { (yyval.boolean) = TRUE; }
    break;

  case 1173:
/* Line 1787 of yacc.c  */
#line 7965 "gram.y"
    { (yyval.boolean) = FALSE; }
    break;

  case 1174:
/* Line 1787 of yacc.c  */
#line 7966 "gram.y"
    { (yyval.boolean) = FALSE; }
    break;

  case 1175:
/* Line 1787 of yacc.c  */
#line 7972 "gram.y"
    {
					DropStmt *n = makeNode(DropStmt);
					n->removeType = OBJECT_RULE;
					n->objects = list_make1(lappend((yyvsp[(5) - (6)].list), makeString((yyvsp[(3) - (6)].str))));
					n->arguments = NIL;
					n->behavior = (yyvsp[(6) - (6)].dbehavior);
					n->missing_ok = false;
					n->concurrent = false;
					(yyval.node) = (Node *) n;
				}
    break;

  case 1176:
/* Line 1787 of yacc.c  */
#line 7983 "gram.y"
    {
					DropStmt *n = makeNode(DropStmt);
					n->removeType = OBJECT_RULE;
					n->objects = list_make1(lappend((yyvsp[(7) - (8)].list), makeString((yyvsp[(5) - (8)].str))));
					n->arguments = NIL;
					n->behavior = (yyvsp[(8) - (8)].dbehavior);
					n->missing_ok = true;
					n->concurrent = false;
					(yyval.node) = (Node *) n;
				}
    break;

  case 1177:
/* Line 1787 of yacc.c  */
#line 8005 "gram.y"
    {
					NotifyStmt *n = makeNode(NotifyStmt);
					n->conditionname = (yyvsp[(2) - (3)].str);
					n->payload = (yyvsp[(3) - (3)].str);
					(yyval.node) = (Node *)n;
				}
    break;

  case 1178:
/* Line 1787 of yacc.c  */
#line 8014 "gram.y"
    { (yyval.str) = (yyvsp[(2) - (2)].str); }
    break;

  case 1179:
/* Line 1787 of yacc.c  */
#line 8015 "gram.y"
    { (yyval.str) = NULL; }
    break;

  case 1180:
/* Line 1787 of yacc.c  */
#line 8019 "gram.y"
    {
					ListenStmt *n = makeNode(ListenStmt);
					n->conditionname = (yyvsp[(2) - (2)].str);
					(yyval.node) = (Node *)n;
				}
    break;

  case 1181:
/* Line 1787 of yacc.c  */
#line 8028 "gram.y"
    {
					UnlistenStmt *n = makeNode(UnlistenStmt);
					n->conditionname = (yyvsp[(2) - (2)].str);
					(yyval.node) = (Node *)n;
				}
    break;

  case 1182:
/* Line 1787 of yacc.c  */
#line 8034 "gram.y"
    {
					UnlistenStmt *n = makeNode(UnlistenStmt);
					n->conditionname = NULL;
					(yyval.node) = (Node *)n;
				}
    break;

  case 1183:
/* Line 1787 of yacc.c  */
#line 8053 "gram.y"
    {
					TransactionStmt *n = makeNode(TransactionStmt);
					n->kind = TRANS_STMT_ROLLBACK;
					n->options = NIL;
					(yyval.node) = (Node *)n;
				}
    break;

  case 1184:
/* Line 1787 of yacc.c  */
#line 8060 "gram.y"
    {
					TransactionStmt *n = makeNode(TransactionStmt);
					n->kind = TRANS_STMT_BEGIN;
					n->options = (yyvsp[(3) - (3)].list);
					(yyval.node) = (Node *)n;
				}
    break;

  case 1185:
/* Line 1787 of yacc.c  */
#line 8067 "gram.y"
    {
					TransactionStmt *n = makeNode(TransactionStmt);
					n->kind = TRANS_STMT_START;
					n->options = (yyvsp[(3) - (3)].list);
					(yyval.node) = (Node *)n;
				}
    break;

  case 1186:
/* Line 1787 of yacc.c  */
#line 8074 "gram.y"
    {
					TransactionStmt *n = makeNode(TransactionStmt);
					n->kind = TRANS_STMT_COMMIT;
					n->options = NIL;
					(yyval.node) = (Node *)n;
				}
    break;

  case 1187:
/* Line 1787 of yacc.c  */
#line 8081 "gram.y"
    {
					TransactionStmt *n = makeNode(TransactionStmt);
					n->kind = TRANS_STMT_COMMIT;
					n->options = NIL;
					(yyval.node) = (Node *)n;
				}
    break;

  case 1188:
/* Line 1787 of yacc.c  */
#line 8088 "gram.y"
    {
					TransactionStmt *n = makeNode(TransactionStmt);
					n->kind = TRANS_STMT_ROLLBACK;
					n->options = NIL;
					(yyval.node) = (Node *)n;
				}
    break;

  case 1189:
/* Line 1787 of yacc.c  */
#line 8095 "gram.y"
    {
					TransactionStmt *n = makeNode(TransactionStmt);
					n->kind = TRANS_STMT_SAVEPOINT;
					n->options = list_make1(makeDefElem("savepoint_name",
														(Node *)makeString((yyvsp[(2) - (2)].str))));
					(yyval.node) = (Node *)n;
				}
    break;

  case 1190:
/* Line 1787 of yacc.c  */
#line 8103 "gram.y"
    {
					TransactionStmt *n = makeNode(TransactionStmt);
					n->kind = TRANS_STMT_RELEASE;
					n->options = list_make1(makeDefElem("savepoint_name",
														(Node *)makeString((yyvsp[(3) - (3)].str))));
					(yyval.node) = (Node *)n;
				}
    break;

  case 1191:
/* Line 1787 of yacc.c  */
#line 8111 "gram.y"
    {
					TransactionStmt *n = makeNode(TransactionStmt);
					n->kind = TRANS_STMT_RELEASE;
					n->options = list_make1(makeDefElem("savepoint_name",
														(Node *)makeString((yyvsp[(2) - (2)].str))));
					(yyval.node) = (Node *)n;
				}
    break;

  case 1192:
/* Line 1787 of yacc.c  */
#line 8119 "gram.y"
    {
					TransactionStmt *n = makeNode(TransactionStmt);
					n->kind = TRANS_STMT_ROLLBACK_TO;
					n->options = list_make1(makeDefElem("savepoint_name",
														(Node *)makeString((yyvsp[(5) - (5)].str))));
					(yyval.node) = (Node *)n;
				}
    break;

  case 1193:
/* Line 1787 of yacc.c  */
#line 8127 "gram.y"
    {
					TransactionStmt *n = makeNode(TransactionStmt);
					n->kind = TRANS_STMT_ROLLBACK_TO;
					n->options = list_make1(makeDefElem("savepoint_name",
														(Node *)makeString((yyvsp[(4) - (4)].str))));
					(yyval.node) = (Node *)n;
				}
    break;

  case 1194:
/* Line 1787 of yacc.c  */
#line 8135 "gram.y"
    {
					TransactionStmt *n = makeNode(TransactionStmt);
					n->kind = TRANS_STMT_PREPARE;
					n->gid = (yyvsp[(3) - (3)].str);
					(yyval.node) = (Node *)n;
				}
    break;

  case 1195:
/* Line 1787 of yacc.c  */
#line 8142 "gram.y"
    {
					TransactionStmt *n = makeNode(TransactionStmt);
					n->kind = TRANS_STMT_COMMIT_PREPARED;
					n->gid = (yyvsp[(3) - (3)].str);
					(yyval.node) = (Node *)n;
				}
    break;

  case 1196:
/* Line 1787 of yacc.c  */
#line 8149 "gram.y"
    {
					TransactionStmt *n = makeNode(TransactionStmt);
					n->kind = TRANS_STMT_ROLLBACK_PREPARED;
					n->gid = (yyvsp[(3) - (3)].str);
					(yyval.node) = (Node *)n;
				}
    break;

  case 1197:
/* Line 1787 of yacc.c  */
#line 8157 "gram.y"
    {}
    break;

  case 1198:
/* Line 1787 of yacc.c  */
#line 8158 "gram.y"
    {}
    break;

  case 1199:
/* Line 1787 of yacc.c  */
#line 8159 "gram.y"
    {}
    break;

  case 1200:
/* Line 1787 of yacc.c  */
#line 8164 "gram.y"
    { (yyval.defelt) = makeDefElem("transaction_isolation",
									   makeStringConst((yyvsp[(3) - (3)].str), (yylsp[(3) - (3)]))); }
    break;

  case 1201:
/* Line 1787 of yacc.c  */
#line 8167 "gram.y"
    { (yyval.defelt) = makeDefElem("transaction_read_only",
									   makeIntConst(TRUE, (yylsp[(1) - (2)]))); }
    break;

  case 1202:
/* Line 1787 of yacc.c  */
#line 8170 "gram.y"
    { (yyval.defelt) = makeDefElem("transaction_read_only",
									   makeIntConst(FALSE, (yylsp[(1) - (2)]))); }
    break;

  case 1203:
/* Line 1787 of yacc.c  */
#line 8173 "gram.y"
    { (yyval.defelt) = makeDefElem("transaction_deferrable",
									   makeIntConst(TRUE, (yylsp[(1) - (1)]))); }
    break;

  case 1204:
/* Line 1787 of yacc.c  */
#line 8176 "gram.y"
    { (yyval.defelt) = makeDefElem("transaction_deferrable",
									   makeIntConst(FALSE, (yylsp[(1) - (2)]))); }
    break;

  case 1205:
/* Line 1787 of yacc.c  */
#line 8183 "gram.y"
    { (yyval.list) = list_make1((yyvsp[(1) - (1)].defelt)); }
    break;

  case 1206:
/* Line 1787 of yacc.c  */
#line 8185 "gram.y"
    { (yyval.list) = lappend((yyvsp[(1) - (3)].list), (yyvsp[(3) - (3)].defelt)); }
    break;

  case 1207:
/* Line 1787 of yacc.c  */
#line 8187 "gram.y"
    { (yyval.list) = lappend((yyvsp[(1) - (2)].list), (yyvsp[(2) - (2)].defelt)); }
    break;

  case 1209:
/* Line 1787 of yacc.c  */
#line 8193 "gram.y"
    { (yyval.list) = NIL; }
    break;

  case 1210:
/* Line 1787 of yacc.c  */
#line 8207 "gram.y"
    {
					ViewStmt *n = makeNode(ViewStmt);
					n->view = (yyvsp[(4) - (9)].range);
					n->view->relpersistence = (yyvsp[(2) - (9)].ival);
					n->aliases = (yyvsp[(5) - (9)].list);
					n->query = (yyvsp[(8) - (9)].node);
					n->replace = false;
					n->options = (yyvsp[(6) - (9)].list);
					n->withCheckOption = (yyvsp[(9) - (9)].ival);
					(yyval.node) = (Node *) n;
				}
    break;

  case 1211:
/* Line 1787 of yacc.c  */
#line 8220 "gram.y"
    {
					ViewStmt *n = makeNode(ViewStmt);
					n->view = (yyvsp[(6) - (11)].range);
					n->view->relpersistence = (yyvsp[(4) - (11)].ival);
					n->aliases = (yyvsp[(7) - (11)].list);
					n->query = (yyvsp[(10) - (11)].node);
					n->replace = true;
					n->options = (yyvsp[(8) - (11)].list);
					n->withCheckOption = (yyvsp[(11) - (11)].ival);
					(yyval.node) = (Node *) n;
				}
    break;

  case 1212:
/* Line 1787 of yacc.c  */
#line 8233 "gram.y"
    {
					ViewStmt *n = makeNode(ViewStmt);
					n->view = (yyvsp[(5) - (12)].range);
					n->view->relpersistence = (yyvsp[(2) - (12)].ival);
					n->aliases = (yyvsp[(7) - (12)].list);
					n->query = makeRecursiveViewSelect(n->view->relname, n->aliases, (yyvsp[(11) - (12)].node));
					n->replace = false;
					n->options = (yyvsp[(9) - (12)].list);
					n->withCheckOption = (yyvsp[(12) - (12)].ival);
					if (n->withCheckOption != NO_CHECK_OPTION)
						ereport(ERROR,
								(errcode(ERRCODE_FEATURE_NOT_SUPPORTED),
								 errmsg("WITH CHECK OPTION not supported on recursive views"),
								 parser_errposition((yylsp[(12) - (12)]))));
					(yyval.node) = (Node *) n;
				}
    break;

  case 1213:
/* Line 1787 of yacc.c  */
#line 8251 "gram.y"
    {
					ViewStmt *n = makeNode(ViewStmt);
					n->view = (yyvsp[(7) - (14)].range);
					n->view->relpersistence = (yyvsp[(4) - (14)].ival);
					n->aliases = (yyvsp[(9) - (14)].list);
					n->query = makeRecursiveViewSelect(n->view->relname, n->aliases, (yyvsp[(13) - (14)].node));
					n->replace = true;
					n->options = (yyvsp[(11) - (14)].list);
					n->withCheckOption = (yyvsp[(14) - (14)].ival);
					if (n->withCheckOption != NO_CHECK_OPTION)
						ereport(ERROR,
								(errcode(ERRCODE_FEATURE_NOT_SUPPORTED),
								 errmsg("WITH CHECK OPTION not supported on recursive views"),
								 parser_errposition((yylsp[(14) - (14)]))));
					(yyval.node) = (Node *) n;
				}
    break;

  case 1214:
/* Line 1787 of yacc.c  */
#line 8270 "gram.y"
    { (yyval.ival) = CASCADED_CHECK_OPTION; }
    break;

  case 1215:
/* Line 1787 of yacc.c  */
#line 8271 "gram.y"
    { (yyval.ival) = CASCADED_CHECK_OPTION; }
    break;

  case 1216:
/* Line 1787 of yacc.c  */
#line 8272 "gram.y"
    { (yyval.ival) = LOCAL_CHECK_OPTION; }
    break;

  case 1217:
/* Line 1787 of yacc.c  */
#line 8273 "gram.y"
    { (yyval.ival) = NO_CHECK_OPTION; }
    break;

  case 1218:
/* Line 1787 of yacc.c  */
#line 8284 "gram.y"
    {
					LoadStmt *n = makeNode(LoadStmt);
					n->filename = (yyvsp[(2) - (2)].str);
					(yyval.node) = (Node *)n;
				}
    break;

  case 1219:
/* Line 1787 of yacc.c  */
#line 8300 "gram.y"
    {
					CreatedbStmt *n = makeNode(CreatedbStmt);
					n->dbname = (yyvsp[(3) - (5)].str);
					n->options = (yyvsp[(5) - (5)].list);
					(yyval.node) = (Node *)n;
				}
    break;

  case 1220:
/* Line 1787 of yacc.c  */
#line 8309 "gram.y"
    { (yyval.list) = lappend((yyvsp[(1) - (2)].list), (yyvsp[(2) - (2)].defelt)); }
    break;

  case 1221:
/* Line 1787 of yacc.c  */
#line 8310 "gram.y"
    { (yyval.list) = NIL; }
    break;

  case 1222:
/* Line 1787 of yacc.c  */
#line 8315 "gram.y"
    {
					(yyval.defelt) = makeDefElem("tablespace", (Node *)makeString((yyvsp[(3) - (3)].str)));
				}
    break;

  case 1223:
/* Line 1787 of yacc.c  */
#line 8319 "gram.y"
    {
					(yyval.defelt) = makeDefElem("tablespace", NULL);
				}
    break;

  case 1224:
/* Line 1787 of yacc.c  */
#line 8323 "gram.y"
    {
					(yyval.defelt) = makeDefElem("location", (Node *)makeString((yyvsp[(3) - (3)].str)));
				}
    break;

  case 1225:
/* Line 1787 of yacc.c  */
#line 8327 "gram.y"
    {
					(yyval.defelt) = makeDefElem("location", NULL);
				}
    break;

  case 1226:
/* Line 1787 of yacc.c  */
#line 8331 "gram.y"
    {
					(yyval.defelt) = makeDefElem("template", (Node *)makeString((yyvsp[(3) - (3)].str)));
				}
    break;

  case 1227:
/* Line 1787 of yacc.c  */
#line 8335 "gram.y"
    {
					(yyval.defelt) = makeDefElem("template", NULL);
				}
    break;

  case 1228:
/* Line 1787 of yacc.c  */
#line 8339 "gram.y"
    {
					(yyval.defelt) = makeDefElem("encoding", (Node *)makeString((yyvsp[(3) - (3)].str)));
				}
    break;

  case 1229:
/* Line 1787 of yacc.c  */
#line 8343 "gram.y"
    {
					(yyval.defelt) = makeDefElem("encoding", (Node *)makeInteger((yyvsp[(3) - (3)].ival)));
				}
    break;

  case 1230:
/* Line 1787 of yacc.c  */
#line 8347 "gram.y"
    {
					(yyval.defelt) = makeDefElem("encoding", NULL);
				}
    break;

  case 1231:
/* Line 1787 of yacc.c  */
#line 8351 "gram.y"
    {
					(yyval.defelt) = makeDefElem("lc_collate", (Node *)makeString((yyvsp[(3) - (3)].str)));
				}
    break;

  case 1232:
/* Line 1787 of yacc.c  */
#line 8355 "gram.y"
    {
					(yyval.defelt) = makeDefElem("lc_collate", NULL);
				}
    break;

  case 1233:
/* Line 1787 of yacc.c  */
#line 8359 "gram.y"
    {
					(yyval.defelt) = makeDefElem("lc_ctype", (Node *)makeString((yyvsp[(3) - (3)].str)));
				}
    break;

  case 1234:
/* Line 1787 of yacc.c  */
#line 8363 "gram.y"
    {
					(yyval.defelt) = makeDefElem("lc_ctype", NULL);
				}
    break;

  case 1235:
/* Line 1787 of yacc.c  */
#line 8367 "gram.y"
    {
					(yyval.defelt) = makeDefElem("connectionlimit", (Node *)makeInteger((yyvsp[(4) - (4)].ival)));
				}
    break;

  case 1236:
/* Line 1787 of yacc.c  */
#line 8371 "gram.y"
    {
					(yyval.defelt) = makeDefElem("owner", (Node *)makeString((yyvsp[(3) - (3)].str)));
				}
    break;

  case 1237:
/* Line 1787 of yacc.c  */
#line 8375 "gram.y"
    {
					(yyval.defelt) = makeDefElem("owner", NULL);
				}
    break;

  case 1238:
/* Line 1787 of yacc.c  */
#line 8384 "gram.y"
    {}
    break;

  case 1239:
/* Line 1787 of yacc.c  */
#line 8385 "gram.y"
    {}
    break;

  case 1240:
/* Line 1787 of yacc.c  */
#line 8397 "gram.y"
    {
					AlterDatabaseStmt *n = makeNode(AlterDatabaseStmt);
					n->dbname = (yyvsp[(3) - (5)].str);
					n->options = (yyvsp[(5) - (5)].list);
					(yyval.node) = (Node *)n;
				 }
    break;

  case 1241:
/* Line 1787 of yacc.c  */
#line 8404 "gram.y"
    {
					AlterDatabaseStmt *n = makeNode(AlterDatabaseStmt);
					n->dbname = (yyvsp[(3) - (6)].str);
					n->options = list_make1(makeDefElem("tablespace",
													(Node *)makeString((yyvsp[(6) - (6)].str))));
					(yyval.node) = (Node *)n;
				 }
    break;

  case 1242:
/* Line 1787 of yacc.c  */
#line 8415 "gram.y"
    {
					AlterDatabaseSetStmt *n = makeNode(AlterDatabaseSetStmt);
					n->dbname = (yyvsp[(3) - (4)].str);
					n->setstmt = (yyvsp[(4) - (4)].vsetstmt);
					(yyval.node) = (Node *)n;
				}
    break;

  case 1243:
/* Line 1787 of yacc.c  */
#line 8425 "gram.y"
    { (yyval.list) = lappend((yyvsp[(1) - (2)].list), (yyvsp[(2) - (2)].defelt)); }
    break;

  case 1244:
/* Line 1787 of yacc.c  */
#line 8426 "gram.y"
    { (yyval.list) = NIL; }
    break;

  case 1245:
/* Line 1787 of yacc.c  */
#line 8431 "gram.y"
    {
					(yyval.defelt) = makeDefElem("connectionlimit", (Node *)makeInteger((yyvsp[(4) - (4)].ival)));
				}
    break;

  case 1246:
/* Line 1787 of yacc.c  */
#line 8445 "gram.y"
    {
					DropdbStmt *n = makeNode(DropdbStmt);
					n->dbname = (yyvsp[(3) - (3)].str);
					n->missing_ok = FALSE;
					(yyval.node) = (Node *)n;
				}
    break;

  case 1247:
/* Line 1787 of yacc.c  */
#line 8452 "gram.y"
    {
					DropdbStmt *n = makeNode(DropdbStmt);
					n->dbname = (yyvsp[(5) - (5)].str);
					n->missing_ok = TRUE;
					(yyval.node) = (Node *)n;
				}
    break;

  case 1248:
/* Line 1787 of yacc.c  */
#line 8470 "gram.y"
    {
					AlterSystemStmt *n = makeNode(AlterSystemStmt);
					n->setstmt = (yyvsp[(4) - (4)].vsetstmt);
					(yyval.node) = (Node *)n;
				}
    break;

  case 1249:
/* Line 1787 of yacc.c  */
#line 8476 "gram.y"
    {
					AlterSystemStmt *n = makeNode(AlterSystemStmt);
					n->setstmt = (yyvsp[(4) - (4)].vsetstmt);
					(yyval.node) = (Node *)n;
				}
    break;

  case 1250:
/* Line 1787 of yacc.c  */
#line 8492 "gram.y"
    {
					CreateDomainStmt *n = makeNode(CreateDomainStmt);
					n->domainname = (yyvsp[(3) - (6)].list);
					n->typeName = (yyvsp[(5) - (6)].typnam);
					SplitColQualList((yyvsp[(6) - (6)].list), &n->constraints, &n->collClause,
									 yyscanner);
					(yyval.node) = (Node *)n;
				}
    break;

  case 1251:
/* Line 1787 of yacc.c  */
#line 8505 "gram.y"
    {
					AlterDomainStmt *n = makeNode(AlterDomainStmt);
					n->subtype = 'T';
					n->typeName = (yyvsp[(3) - (4)].list);
					n->def = (yyvsp[(4) - (4)].node);
					(yyval.node) = (Node *)n;
				}
    break;

  case 1252:
/* Line 1787 of yacc.c  */
#line 8514 "gram.y"
    {
					AlterDomainStmt *n = makeNode(AlterDomainStmt);
					n->subtype = 'N';
					n->typeName = (yyvsp[(3) - (6)].list);
					(yyval.node) = (Node *)n;
				}
    break;

  case 1253:
/* Line 1787 of yacc.c  */
#line 8522 "gram.y"
    {
					AlterDomainStmt *n = makeNode(AlterDomainStmt);
					n->subtype = 'O';
					n->typeName = (yyvsp[(3) - (6)].list);
					(yyval.node) = (Node *)n;
				}
    break;

  case 1254:
/* Line 1787 of yacc.c  */
#line 8530 "gram.y"
    {
					AlterDomainStmt *n = makeNode(AlterDomainStmt);
					n->subtype = 'C';
					n->typeName = (yyvsp[(3) - (5)].list);
					n->def = (yyvsp[(5) - (5)].node);
					(yyval.node) = (Node *)n;
				}
    break;

  case 1255:
/* Line 1787 of yacc.c  */
#line 8539 "gram.y"
    {
					AlterDomainStmt *n = makeNode(AlterDomainStmt);
					n->subtype = 'X';
					n->typeName = (yyvsp[(3) - (7)].list);
					n->name = (yyvsp[(6) - (7)].str);
					n->behavior = (yyvsp[(7) - (7)].dbehavior);
					n->missing_ok = false;
					(yyval.node) = (Node *)n;
				}
    break;

  case 1256:
/* Line 1787 of yacc.c  */
#line 8550 "gram.y"
    {
					AlterDomainStmt *n = makeNode(AlterDomainStmt);
					n->subtype = 'X';
					n->typeName = (yyvsp[(3) - (9)].list);
					n->name = (yyvsp[(8) - (9)].str);
					n->behavior = (yyvsp[(9) - (9)].dbehavior);
					n->missing_ok = true;
					(yyval.node) = (Node *)n;
				}
    break;

  case 1257:
/* Line 1787 of yacc.c  */
#line 8561 "gram.y"
    {
					AlterDomainStmt *n = makeNode(AlterDomainStmt);
					n->subtype = 'V';
					n->typeName = (yyvsp[(3) - (6)].list);
					n->name = (yyvsp[(6) - (6)].str);
					(yyval.node) = (Node *)n;
				}
    break;

  case 1258:
/* Line 1787 of yacc.c  */
#line 8570 "gram.y"
    {}
    break;

  case 1259:
/* Line 1787 of yacc.c  */
#line 8571 "gram.y"
    {}
    break;

  case 1260:
/* Line 1787 of yacc.c  */
#line 8583 "gram.y"
    {
					AlterTSDictionaryStmt *n = makeNode(AlterTSDictionaryStmt);
					n->dictname = (yyvsp[(5) - (6)].list);
					n->options = (yyvsp[(6) - (6)].list);
					(yyval.node) = (Node *)n;
				}
    break;

  case 1261:
/* Line 1787 of yacc.c  */
#line 8593 "gram.y"
    {
					AlterTSConfigurationStmt *n = makeNode(AlterTSConfigurationStmt);
					n->cfgname = (yyvsp[(5) - (11)].list);
					n->tokentype = (yyvsp[(9) - (11)].list);
					n->dicts = (yyvsp[(11) - (11)].list);
					n->override = false;
					n->replace = false;
					(yyval.node) = (Node*)n;
				}
    break;

  case 1262:
/* Line 1787 of yacc.c  */
#line 8603 "gram.y"
    {
					AlterTSConfigurationStmt *n = makeNode(AlterTSConfigurationStmt);
					n->cfgname = (yyvsp[(5) - (11)].list);
					n->tokentype = (yyvsp[(9) - (11)].list);
					n->dicts = (yyvsp[(11) - (11)].list);
					n->override = true;
					n->replace = false;
					(yyval.node) = (Node*)n;
				}
    break;

  case 1263:
/* Line 1787 of yacc.c  */
#line 8613 "gram.y"
    {
					AlterTSConfigurationStmt *n = makeNode(AlterTSConfigurationStmt);
					n->cfgname = (yyvsp[(5) - (11)].list);
					n->tokentype = NIL;
					n->dicts = list_make2((yyvsp[(9) - (11)].list),(yyvsp[(11) - (11)].list));
					n->override = false;
					n->replace = true;
					(yyval.node) = (Node*)n;
				}
    break;

  case 1264:
/* Line 1787 of yacc.c  */
#line 8623 "gram.y"
    {
					AlterTSConfigurationStmt *n = makeNode(AlterTSConfigurationStmt);
					n->cfgname = (yyvsp[(5) - (13)].list);
					n->tokentype = (yyvsp[(9) - (13)].list);
					n->dicts = list_make2((yyvsp[(11) - (13)].list),(yyvsp[(13) - (13)].list));
					n->override = false;
					n->replace = true;
					(yyval.node) = (Node*)n;
				}
    break;

  case 1265:
/* Line 1787 of yacc.c  */
#line 8633 "gram.y"
    {
					AlterTSConfigurationStmt *n = makeNode(AlterTSConfigurationStmt);
					n->cfgname = (yyvsp[(5) - (9)].list);
					n->tokentype = (yyvsp[(9) - (9)].list);
					n->missing_ok = false;
					(yyval.node) = (Node*)n;
				}
    break;

  case 1266:
/* Line 1787 of yacc.c  */
#line 8641 "gram.y"
    {
					AlterTSConfigurationStmt *n = makeNode(AlterTSConfigurationStmt);
					n->cfgname = (yyvsp[(5) - (11)].list);
					n->tokentype = (yyvsp[(11) - (11)].list);
					n->missing_ok = true;
					(yyval.node) = (Node*)n;
				}
    break;

  case 1267:
/* Line 1787 of yacc.c  */
#line 8663 "gram.y"
    {
				CreateConversionStmt *n = makeNode(CreateConversionStmt);
				n->conversion_name = (yyvsp[(4) - (10)].list);
				n->for_encoding_name = (yyvsp[(6) - (10)].str);
				n->to_encoding_name = (yyvsp[(8) - (10)].str);
				n->func_name = (yyvsp[(10) - (10)].list);
				n->def = (yyvsp[(2) - (10)].boolean);
				(yyval.node) = (Node *)n;
			}
    break;

  case 1268:
/* Line 1787 of yacc.c  */
#line 8685 "gram.y"
    {
					ClusterStmt *n = makeNode(ClusterStmt);
					n->relation = (yyvsp[(3) - (4)].range);
					n->indexname = (yyvsp[(4) - (4)].str);
					n->verbose = (yyvsp[(2) - (4)].boolean);
					(yyval.node) = (Node*)n;
				}
    break;

  case 1269:
/* Line 1787 of yacc.c  */
#line 8693 "gram.y"
    {
					ClusterStmt *n = makeNode(ClusterStmt);
					n->relation = NULL;
					n->indexname = NULL;
					n->verbose = (yyvsp[(2) - (2)].boolean);
					(yyval.node) = (Node*)n;
				}
    break;

  case 1270:
/* Line 1787 of yacc.c  */
#line 8702 "gram.y"
    {
					ClusterStmt *n = makeNode(ClusterStmt);
					n->relation = (yyvsp[(5) - (5)].range);
					n->indexname = (yyvsp[(3) - (5)].str);
					n->verbose = (yyvsp[(2) - (5)].boolean);
					(yyval.node) = (Node*)n;
				}
    break;

  case 1271:
/* Line 1787 of yacc.c  */
#line 8712 "gram.y"
    { (yyval.str) = (yyvsp[(2) - (2)].str); }
    break;

  case 1272:
/* Line 1787 of yacc.c  */
#line 8713 "gram.y"
    { (yyval.str) = NULL; }
    break;

  case 1273:
/* Line 1787 of yacc.c  */
#line 8726 "gram.y"
    {
					VacuumStmt *n = makeNode(VacuumStmt);
					n->options = VACOPT_VACUUM;
					if ((yyvsp[(2) - (4)].boolean))
						n->options |= VACOPT_FULL;
					if ((yyvsp[(4) - (4)].boolean))
						n->options |= VACOPT_VERBOSE;
					n->freeze_min_age = (yyvsp[(3) - (4)].boolean) ? 0 : -1;
					n->freeze_table_age = (yyvsp[(3) - (4)].boolean) ? 0 : -1;
					n->multixact_freeze_min_age = (yyvsp[(3) - (4)].boolean) ? 0 : -1;
					n->multixact_freeze_table_age = (yyvsp[(3) - (4)].boolean) ? 0 : -1;
					n->relation = NULL;
					n->va_cols = NIL;
					(yyval.node) = (Node *)n;
				}
    break;

  case 1274:
/* Line 1787 of yacc.c  */
#line 8742 "gram.y"
    {
					VacuumStmt *n = makeNode(VacuumStmt);
					n->options = VACOPT_VACUUM;
					if ((yyvsp[(2) - (5)].boolean))
						n->options |= VACOPT_FULL;
					if ((yyvsp[(4) - (5)].boolean))
						n->options |= VACOPT_VERBOSE;
					n->freeze_min_age = (yyvsp[(3) - (5)].boolean) ? 0 : -1;
					n->freeze_table_age = (yyvsp[(3) - (5)].boolean) ? 0 : -1;
					n->multixact_freeze_min_age = (yyvsp[(3) - (5)].boolean) ? 0 : -1;
					n->multixact_freeze_table_age = (yyvsp[(3) - (5)].boolean) ? 0 : -1;
					n->relation = (yyvsp[(5) - (5)].range);
					n->va_cols = NIL;
					(yyval.node) = (Node *)n;
				}
    break;

  case 1275:
/* Line 1787 of yacc.c  */
#line 8758 "gram.y"
    {
					VacuumStmt *n = (VacuumStmt *) (yyvsp[(5) - (5)].node);
					n->options |= VACOPT_VACUUM;
					if ((yyvsp[(2) - (5)].boolean))
						n->options |= VACOPT_FULL;
					if ((yyvsp[(4) - (5)].boolean))
						n->options |= VACOPT_VERBOSE;
					n->freeze_min_age = (yyvsp[(3) - (5)].boolean) ? 0 : -1;
					n->freeze_table_age = (yyvsp[(3) - (5)].boolean) ? 0 : -1;
					n->multixact_freeze_min_age = (yyvsp[(3) - (5)].boolean) ? 0 : -1;
					n->multixact_freeze_table_age = (yyvsp[(3) - (5)].boolean) ? 0 : -1;
					(yyval.node) = (Node *)n;
				}
    break;

  case 1276:
/* Line 1787 of yacc.c  */
#line 8772 "gram.y"
    {
					VacuumStmt *n = makeNode(VacuumStmt);
					n->options = VACOPT_VACUUM | (yyvsp[(3) - (4)].ival);
					if (n->options & VACOPT_FREEZE)
					{
						n->freeze_min_age = n->freeze_table_age = 0;
						n->multixact_freeze_min_age = 0;
						n->multixact_freeze_table_age = 0;
					}
					else
					{
						n->freeze_min_age = n->freeze_table_age = -1;
						n->multixact_freeze_min_age = -1;
						n->multixact_freeze_table_age = -1;
					}
					n->relation = NULL;
					n->va_cols = NIL;
					(yyval.node) = (Node *) n;
				}
    break;

  case 1277:
/* Line 1787 of yacc.c  */
#line 8792 "gram.y"
    {
					VacuumStmt *n = makeNode(VacuumStmt);
					n->options = VACOPT_VACUUM | (yyvsp[(3) - (6)].ival);
					if (n->options & VACOPT_FREEZE)
					{
						n->freeze_min_age = n->freeze_table_age = 0;
						n->multixact_freeze_min_age = 0;
						n->multixact_freeze_table_age = 0;
					}
					else
					{
						n->freeze_min_age = n->freeze_table_age = -1;
						n->multixact_freeze_min_age = -1;
						n->multixact_freeze_table_age = -1;
					}
					n->relation = (yyvsp[(5) - (6)].range);
					n->va_cols = (yyvsp[(6) - (6)].list);
					if (n->va_cols != NIL)	/* implies analyze */
						n->options |= VACOPT_ANALYZE;
					(yyval.node) = (Node *) n;
				}
    break;

  case 1278:
/* Line 1787 of yacc.c  */
#line 8816 "gram.y"
    { (yyval.ival) = (yyvsp[(1) - (1)].ival); }
    break;

  case 1279:
/* Line 1787 of yacc.c  */
#line 8817 "gram.y"
    { (yyval.ival) = (yyvsp[(1) - (3)].ival) | (yyvsp[(3) - (3)].ival); }
    break;

  case 1280:
/* Line 1787 of yacc.c  */
#line 8821 "gram.y"
    { (yyval.ival) = VACOPT_ANALYZE; }
    break;

  case 1281:
/* Line 1787 of yacc.c  */
#line 8822 "gram.y"
    { (yyval.ival) = VACOPT_VERBOSE; }
    break;

  case 1282:
/* Line 1787 of yacc.c  */
#line 8823 "gram.y"
    { (yyval.ival) = VACOPT_FREEZE; }
    break;

  case 1283:
/* Line 1787 of yacc.c  */
#line 8824 "gram.y"
    { (yyval.ival) = VACOPT_FULL; }
    break;

  case 1284:
/* Line 1787 of yacc.c  */
#line 8829 "gram.y"
    {
					VacuumStmt *n = makeNode(VacuumStmt);
					n->options = VACOPT_ANALYZE;
					if ((yyvsp[(2) - (2)].boolean))
						n->options |= VACOPT_VERBOSE;
					n->freeze_min_age = -1;
					n->freeze_table_age = -1;
					n->multixact_freeze_min_age = -1;
					n->multixact_freeze_table_age = -1;
					n->relation = NULL;
					n->va_cols = NIL;
					(yyval.node) = (Node *)n;
				}
    break;

  case 1285:
/* Line 1787 of yacc.c  */
#line 8843 "gram.y"
    {
					VacuumStmt *n = makeNode(VacuumStmt);
					n->options = VACOPT_ANALYZE;
					if ((yyvsp[(2) - (4)].boolean))
						n->options |= VACOPT_VERBOSE;
					n->freeze_min_age = -1;
					n->freeze_table_age = -1;
					n->multixact_freeze_min_age = -1;
					n->multixact_freeze_table_age = -1;
					n->relation = (yyvsp[(3) - (4)].range);
					n->va_cols = (yyvsp[(4) - (4)].list);
					(yyval.node) = (Node *)n;
				}
    break;

  case 1286:
/* Line 1787 of yacc.c  */
#line 8859 "gram.y"
    {}
    break;

  case 1287:
/* Line 1787 of yacc.c  */
#line 8860 "gram.y"
    {}
    break;

  case 1288:
/* Line 1787 of yacc.c  */
#line 8864 "gram.y"
    { (yyval.boolean) = TRUE; }
    break;

  case 1289:
/* Line 1787 of yacc.c  */
#line 8865 "gram.y"
    { (yyval.boolean) = FALSE; }
    break;

  case 1290:
/* Line 1787 of yacc.c  */
#line 8868 "gram.y"
    { (yyval.boolean) = TRUE; }
    break;

  case 1291:
/* Line 1787 of yacc.c  */
#line 8869 "gram.y"
    { (yyval.boolean) = FALSE; }
    break;

  case 1292:
/* Line 1787 of yacc.c  */
#line 8872 "gram.y"
    { (yyval.boolean) = TRUE; }
    break;

  case 1293:
/* Line 1787 of yacc.c  */
#line 8873 "gram.y"
    { (yyval.boolean) = FALSE; }
    break;

  case 1294:
/* Line 1787 of yacc.c  */
#line 8877 "gram.y"
    { (yyval.list) = (yyvsp[(2) - (3)].list); }
    break;

  case 1295:
/* Line 1787 of yacc.c  */
#line 8878 "gram.y"
    { (yyval.list) = NIL; }
    break;

  case 1296:
/* Line 1787 of yacc.c  */
#line 8892 "gram.y"
    {
					ExplainStmt *n = makeNode(ExplainStmt);
					n->query = (yyvsp[(2) - (2)].node);
					n->options = NIL;
					(yyval.node) = (Node *) n;
				}
    break;

  case 1297:
/* Line 1787 of yacc.c  */
#line 8899 "gram.y"
    {
					ExplainStmt *n = makeNode(ExplainStmt);
					n->query = (yyvsp[(4) - (4)].node);
					n->options = list_make1(makeDefElem("analyze", NULL));
					if ((yyvsp[(3) - (4)].boolean))
						n->options = lappend(n->options,
											 makeDefElem("verbose", NULL));
					(yyval.node) = (Node *) n;
				}
    break;

  case 1298:
/* Line 1787 of yacc.c  */
#line 8909 "gram.y"
    {
					ExplainStmt *n = makeNode(ExplainStmt);
					n->query = (yyvsp[(3) - (3)].node);
					n->options = list_make1(makeDefElem("verbose", NULL));
					(yyval.node) = (Node *) n;
				}
    break;

  case 1299:
/* Line 1787 of yacc.c  */
#line 8916 "gram.y"
    {
					ExplainStmt *n = makeNode(ExplainStmt);
					n->query = (yyvsp[(5) - (5)].node);
					n->options = (yyvsp[(3) - (5)].list);
					(yyval.node) = (Node *) n;
				}
    break;

  case 1309:
/* Line 1787 of yacc.c  */
#line 8938 "gram.y"
    {
					(yyval.list) = list_make1((yyvsp[(1) - (1)].defelt));
				}
    break;

  case 1310:
/* Line 1787 of yacc.c  */
#line 8942 "gram.y"
    {
					(yyval.list) = lappend((yyvsp[(1) - (3)].list), (yyvsp[(3) - (3)].defelt));
				}
    break;

  case 1311:
/* Line 1787 of yacc.c  */
#line 8949 "gram.y"
    {
					(yyval.defelt) = makeDefElem((yyvsp[(1) - (2)].str), (yyvsp[(2) - (2)].node));
				}
    break;

  case 1312:
/* Line 1787 of yacc.c  */
#line 8955 "gram.y"
    { (yyval.str) = (yyvsp[(1) - (1)].str); }
    break;

  case 1313:
/* Line 1787 of yacc.c  */
#line 8956 "gram.y"
    { (yyval.str) = "analyze"; }
    break;

  case 1314:
/* Line 1787 of yacc.c  */
#line 8960 "gram.y"
    { (yyval.node) = (Node *) makeString((yyvsp[(1) - (1)].str)); }
    break;

  case 1315:
/* Line 1787 of yacc.c  */
#line 8961 "gram.y"
    { (yyval.node) = (Node *) (yyvsp[(1) - (1)].value); }
    break;

  case 1316:
/* Line 1787 of yacc.c  */
#line 8962 "gram.y"
    { (yyval.node) = NULL; }
    break;

  case 1317:
/* Line 1787 of yacc.c  */
#line 8973 "gram.y"
    {
					PrepareStmt *n = makeNode(PrepareStmt);
					n->name = (yyvsp[(2) - (5)].str);
					n->argtypes = (yyvsp[(3) - (5)].list);
					n->query = (yyvsp[(5) - (5)].node);
					(yyval.node) = (Node *) n;
				}
    break;

  case 1318:
/* Line 1787 of yacc.c  */
#line 8982 "gram.y"
    { (yyval.list) = (yyvsp[(2) - (3)].list); }
    break;

  case 1319:
/* Line 1787 of yacc.c  */
#line 8983 "gram.y"
    { (yyval.list) = NIL; }
    break;

  case 1324:
/* Line 1787 of yacc.c  */
#line 9001 "gram.y"
    {
					ExecuteStmt *n = makeNode(ExecuteStmt);
					n->name = (yyvsp[(2) - (3)].str);
					n->params = (yyvsp[(3) - (3)].list);
					(yyval.node) = (Node *) n;
				}
    break;

  case 1325:
/* Line 1787 of yacc.c  */
#line 9009 "gram.y"
    {
					CreateTableAsStmt *ctas = makeNode(CreateTableAsStmt);
					ExecuteStmt *n = makeNode(ExecuteStmt);
					n->name = (yyvsp[(7) - (9)].str);
					n->params = (yyvsp[(8) - (9)].list);
					ctas->query = (Node *) n;
					ctas->into = (yyvsp[(4) - (9)].into);
					ctas->relkind = OBJECT_TABLE;
					ctas->is_select_into = false;
					/* cram additional flags into the IntoClause */
					(yyvsp[(4) - (9)].into)->rel->relpersistence = (yyvsp[(2) - (9)].ival);
					(yyvsp[(4) - (9)].into)->skipData = !((yyvsp[(9) - (9)].boolean));
					(yyval.node) = (Node *) ctas;
				}
    break;

  case 1326:
/* Line 1787 of yacc.c  */
#line 9025 "gram.y"
    { (yyval.list) = (yyvsp[(2) - (3)].list); }
    break;

  case 1327:
/* Line 1787 of yacc.c  */
#line 9026 "gram.y"
    { (yyval.list) = NIL; }
    break;

  case 1328:
/* Line 1787 of yacc.c  */
#line 9037 "gram.y"
    {
						DeallocateStmt *n = makeNode(DeallocateStmt);
						n->name = (yyvsp[(2) - (2)].str);
						(yyval.node) = (Node *) n;
					}
    break;

  case 1329:
/* Line 1787 of yacc.c  */
#line 9043 "gram.y"
    {
						DeallocateStmt *n = makeNode(DeallocateStmt);
						n->name = (yyvsp[(3) - (3)].str);
						(yyval.node) = (Node *) n;
					}
    break;

  case 1330:
/* Line 1787 of yacc.c  */
#line 9049 "gram.y"
    {
						DeallocateStmt *n = makeNode(DeallocateStmt);
						n->name = NULL;
						(yyval.node) = (Node *) n;
					}
    break;

  case 1331:
/* Line 1787 of yacc.c  */
#line 9055 "gram.y"
    {
						DeallocateStmt *n = makeNode(DeallocateStmt);
						n->name = NULL;
						(yyval.node) = (Node *) n;
					}
    break;

  case 1332:
/* Line 1787 of yacc.c  */
#line 9071 "gram.y"
    {
					(yyvsp[(5) - (6)].istmt)->relation = (yyvsp[(4) - (6)].range);
					(yyvsp[(5) - (6)].istmt)->returningList = (yyvsp[(6) - (6)].list);
					(yyvsp[(5) - (6)].istmt)->withClause = (yyvsp[(1) - (6)].with);
					(yyval.node) = (Node *) (yyvsp[(5) - (6)].istmt);
				}
    break;

  case 1333:
/* Line 1787 of yacc.c  */
#line 9081 "gram.y"
    {
					(yyval.istmt) = makeNode(InsertStmt);
					(yyval.istmt)->cols = NIL;
					(yyval.istmt)->selectStmt = (yyvsp[(1) - (1)].node);
				}
    break;

  case 1334:
/* Line 1787 of yacc.c  */
#line 9087 "gram.y"
    {
					(yyval.istmt) = makeNode(InsertStmt);
					(yyval.istmt)->cols = (yyvsp[(2) - (4)].list);
					(yyval.istmt)->selectStmt = (yyvsp[(4) - (4)].node);
				}
    break;

  case 1335:
/* Line 1787 of yacc.c  */
#line 9093 "gram.y"
    {
					(yyval.istmt) = makeNode(InsertStmt);
					(yyval.istmt)->cols = NIL;
					(yyval.istmt)->selectStmt = NULL;
				}
    break;

  case 1336:
/* Line 1787 of yacc.c  */
#line 9102 "gram.y"
    { (yyval.list) = list_make1((yyvsp[(1) - (1)].target)); }
    break;

  case 1337:
/* Line 1787 of yacc.c  */
#line 9104 "gram.y"
    { (yyval.list) = lappend((yyvsp[(1) - (3)].list), (yyvsp[(3) - (3)].target)); }
    break;

  case 1338:
/* Line 1787 of yacc.c  */
#line 9109 "gram.y"
    {
					(yyval.target) = makeNode(ResTarget);
					(yyval.target)->name = (yyvsp[(1) - (2)].str);
					(yyval.target)->indirection = check_indirection((yyvsp[(2) - (2)].list), yyscanner);
					(yyval.target)->val = NULL;
					(yyval.target)->location = (yylsp[(1) - (2)]);
				}
    break;

  case 1339:
/* Line 1787 of yacc.c  */
#line 9119 "gram.y"
    { (yyval.list) = (yyvsp[(2) - (2)].list); }
    break;

  case 1340:
/* Line 1787 of yacc.c  */
#line 9120 "gram.y"
    { (yyval.list) = NIL; }
    break;

  case 1341:
/* Line 1787 of yacc.c  */
#line 9133 "gram.y"
    {
					DeleteStmt *n = makeNode(DeleteStmt);
					n->relation = (yyvsp[(4) - (7)].range);
					n->usingClause = (yyvsp[(5) - (7)].list);
					n->whereClause = (yyvsp[(6) - (7)].node);
					n->returningList = (yyvsp[(7) - (7)].list);
					n->withClause = (yyvsp[(1) - (7)].with);
					(yyval.node) = (Node *)n;
				}
    break;

  case 1342:
/* Line 1787 of yacc.c  */
#line 9145 "gram.y"
    { (yyval.list) = (yyvsp[(2) - (2)].list); }
    break;

  case 1343:
/* Line 1787 of yacc.c  */
#line 9146 "gram.y"
    { (yyval.list) = NIL; }
    break;

  case 1344:
/* Line 1787 of yacc.c  */
#line 9158 "gram.y"
    {
					LockStmt *n = makeNode(LockStmt);

					n->relations = (yyvsp[(3) - (5)].list);
					n->mode = (yyvsp[(4) - (5)].ival);
					n->nowait = (yyvsp[(5) - (5)].boolean);
					(yyval.node) = (Node *)n;
				}
    break;

  case 1345:
/* Line 1787 of yacc.c  */
#line 9168 "gram.y"
    { (yyval.ival) = (yyvsp[(2) - (3)].ival); }
    break;

  case 1346:
/* Line 1787 of yacc.c  */
#line 9169 "gram.y"
    { (yyval.ival) = AccessExclusiveLock; }
    break;

  case 1347:
/* Line 1787 of yacc.c  */
#line 9172 "gram.y"
    { (yyval.ival) = AccessShareLock; }
    break;

  case 1348:
/* Line 1787 of yacc.c  */
#line 9173 "gram.y"
    { (yyval.ival) = RowShareLock; }
    break;

  case 1349:
/* Line 1787 of yacc.c  */
#line 9174 "gram.y"
    { (yyval.ival) = RowExclusiveLock; }
    break;

  case 1350:
/* Line 1787 of yacc.c  */
#line 9175 "gram.y"
    { (yyval.ival) = ApplicationShareLock; }
    break;

  case 1351:
/* Line 1787 of yacc.c  */
#line 9176 "gram.y"
    { (yyval.ival) = ApplicationExclusiveLock; }
    break;

  case 1352:
/* Line 1787 of yacc.c  */
#line 9177 "gram.y"
    { (yyval.ival) = ShareUpdateExclusiveLock; }
    break;

  case 1353:
/* Line 1787 of yacc.c  */
#line 9178 "gram.y"
    { (yyval.ival) = ShareLock; }
    break;

  case 1354:
/* Line 1787 of yacc.c  */
#line 9179 "gram.y"
    { (yyval.ival) = ShareRowExclusiveLock; }
    break;

  case 1355:
/* Line 1787 of yacc.c  */
#line 9180 "gram.y"
    { (yyval.ival) = ExclusiveLock; }
    break;

  case 1356:
/* Line 1787 of yacc.c  */
#line 9181 "gram.y"
    { (yyval.ival) = AccessExclusiveLock; }
    break;

  case 1357:
/* Line 1787 of yacc.c  */
#line 9184 "gram.y"
    { (yyval.boolean) = TRUE; }
    break;

  case 1358:
/* Line 1787 of yacc.c  */
#line 9185 "gram.y"
    { (yyval.boolean) = FALSE; }
    break;

  case 1359:
/* Line 1787 of yacc.c  */
#line 9201 "gram.y"
    {
					UpdateStmt *n = makeNode(UpdateStmt);
					n->relation = (yyvsp[(3) - (8)].range);
					n->targetList = (yyvsp[(5) - (8)].list);
					n->fromClause = (yyvsp[(6) - (8)].list);
					n->whereClause = (yyvsp[(7) - (8)].node);
					n->returningList = (yyvsp[(8) - (8)].list);
					n->withClause = (yyvsp[(1) - (8)].with);
					(yyval.node) = (Node *)n;
				}
    break;

  case 1360:
/* Line 1787 of yacc.c  */
#line 9214 "gram.y"
    { (yyval.list) = (yyvsp[(1) - (1)].list); }
    break;

  case 1361:
/* Line 1787 of yacc.c  */
#line 9215 "gram.y"
    { (yyval.list) = list_concat((yyvsp[(1) - (3)].list),(yyvsp[(3) - (3)].list)); }
    break;

  case 1362:
/* Line 1787 of yacc.c  */
#line 9219 "gram.y"
    { (yyval.list) = list_make1((yyvsp[(1) - (1)].target)); }
    break;

  case 1363:
/* Line 1787 of yacc.c  */
#line 9220 "gram.y"
    { (yyval.list) = (yyvsp[(1) - (1)].list); }
    break;

  case 1364:
/* Line 1787 of yacc.c  */
#line 9225 "gram.y"
    {
					(yyval.target) = (yyvsp[(1) - (3)].target);
					(yyval.target)->val = (Node *) (yyvsp[(3) - (3)].node);
				}
    break;

  case 1365:
/* Line 1787 of yacc.c  */
#line 9233 "gram.y"
    {
					ListCell *col_cell;
					ListCell *val_cell;

					/*
					 * Break the ctext_row apart, merge individual expressions
					 * into the destination ResTargets.  XXX this approach
					 * cannot work for general row expressions as sources.
					 */
					if (list_length((yyvsp[(2) - (5)].list)) != list_length((yyvsp[(5) - (5)].list)))
						ereport(ERROR,
								(errcode(ERRCODE_SYNTAX_ERROR),
								 errmsg("number of columns does not match number of values"),
								 parser_errposition((yylsp[(1) - (5)]))));
					forboth(col_cell, (yyvsp[(2) - (5)].list), val_cell, (yyvsp[(5) - (5)].list))
					{
						ResTarget *res_col = (ResTarget *) lfirst(col_cell);
						Node *res_val = (Node *) lfirst(val_cell);

						res_col->val = res_val;
					}

					(yyval.list) = (yyvsp[(2) - (5)].list);
				}
    break;

  case 1366:
/* Line 1787 of yacc.c  */
#line 9261 "gram.y"
    {
					(yyval.target) = makeNode(ResTarget);
					(yyval.target)->name = (yyvsp[(1) - (2)].str);
					(yyval.target)->indirection = check_indirection((yyvsp[(2) - (2)].list), yyscanner);
					(yyval.target)->val = NULL;	/* upper production sets this */
					(yyval.target)->location = (yylsp[(1) - (2)]);
				}
    break;

  case 1367:
/* Line 1787 of yacc.c  */
#line 9271 "gram.y"
    { (yyval.list) = list_make1((yyvsp[(1) - (1)].target)); }
    break;

  case 1368:
/* Line 1787 of yacc.c  */
#line 9272 "gram.y"
    { (yyval.list) = lappend((yyvsp[(1) - (3)].list),(yyvsp[(3) - (3)].target)); }
    break;

  case 1369:
/* Line 1787 of yacc.c  */
#line 9283 "gram.y"
    {
					DeclareCursorStmt *n = makeNode(DeclareCursorStmt);
					n->portalname = (yyvsp[(2) - (7)].str);
					/* currently we always set FAST_PLAN option */
					n->options = (yyvsp[(3) - (7)].ival) | (yyvsp[(5) - (7)].ival) | CURSOR_OPT_FAST_PLAN;
					n->query = (yyvsp[(7) - (7)].node);
					(yyval.node) = (Node *)n;
				}
    break;

  case 1370:
/* Line 1787 of yacc.c  */
#line 9293 "gram.y"
    { (yyval.str) = (yyvsp[(1) - (1)].str); }
    break;

  case 1371:
/* Line 1787 of yacc.c  */
#line 9296 "gram.y"
    { (yyval.ival) = 0; }
    break;

  case 1372:
/* Line 1787 of yacc.c  */
#line 9297 "gram.y"
    { (yyval.ival) = (yyvsp[(1) - (3)].ival) | CURSOR_OPT_NO_SCROLL; }
    break;

  case 1373:
/* Line 1787 of yacc.c  */
#line 9298 "gram.y"
    { (yyval.ival) = (yyvsp[(1) - (2)].ival) | CURSOR_OPT_SCROLL; }
    break;

  case 1374:
/* Line 1787 of yacc.c  */
#line 9299 "gram.y"
    { (yyval.ival) = (yyvsp[(1) - (2)].ival) | CURSOR_OPT_BINARY; }
    break;

  case 1375:
/* Line 1787 of yacc.c  */
#line 9300 "gram.y"
    { (yyval.ival) = (yyvsp[(1) - (2)].ival) | CURSOR_OPT_INSENSITIVE; }
    break;

  case 1376:
/* Line 1787 of yacc.c  */
#line 9303 "gram.y"
    { (yyval.ival) = 0; }
    break;

  case 1377:
/* Line 1787 of yacc.c  */
#line 9304 "gram.y"
    { (yyval.ival) = CURSOR_OPT_HOLD; }
    break;

  case 1378:
/* Line 1787 of yacc.c  */
#line 9305 "gram.y"
    { (yyval.ival) = 0; }
    break;

  case 1381:
/* Line 1787 of yacc.c  */
#line 9358 "gram.y"
    { (yyval.node) = (yyvsp[(2) - (3)].node); }
    break;

  case 1382:
/* Line 1787 of yacc.c  */
#line 9359 "gram.y"
    { (yyval.node) = (yyvsp[(2) - (3)].node); }
    break;

  case 1383:
/* Line 1787 of yacc.c  */
#line 9374 "gram.y"
    { (yyval.node) = (yyvsp[(1) - (1)].node); }
    break;

  case 1384:
/* Line 1787 of yacc.c  */
#line 9376 "gram.y"
    {
					insertSelectOptions((SelectStmt *) (yyvsp[(1) - (2)].node), (yyvsp[(2) - (2)].list), NIL,
										NULL, NULL, NULL,
										yyscanner);
					(yyval.node) = (yyvsp[(1) - (2)].node);
				}
    break;

  case 1385:
/* Line 1787 of yacc.c  */
#line 9383 "gram.y"
    {
					insertSelectOptions((SelectStmt *) (yyvsp[(1) - (4)].node), (yyvsp[(2) - (4)].list), (yyvsp[(3) - (4)].list),
										list_nth((yyvsp[(4) - (4)].list), 0), list_nth((yyvsp[(4) - (4)].list), 1),
										NULL,
										yyscanner);
					(yyval.node) = (yyvsp[(1) - (4)].node);
				}
    break;

  case 1386:
/* Line 1787 of yacc.c  */
#line 9391 "gram.y"
    {
					insertSelectOptions((SelectStmt *) (yyvsp[(1) - (4)].node), (yyvsp[(2) - (4)].list), (yyvsp[(4) - (4)].list),
										list_nth((yyvsp[(3) - (4)].list), 0), list_nth((yyvsp[(3) - (4)].list), 1),
										NULL,
										yyscanner);
					(yyval.node) = (yyvsp[(1) - (4)].node);
				}
    break;

  case 1387:
/* Line 1787 of yacc.c  */
#line 9399 "gram.y"
    {
					insertSelectOptions((SelectStmt *) (yyvsp[(2) - (2)].node), NULL, NIL,
										NULL, NULL,
										(yyvsp[(1) - (2)].with),
										yyscanner);
					(yyval.node) = (yyvsp[(2) - (2)].node);
				}
    break;

  case 1388:
/* Line 1787 of yacc.c  */
#line 9407 "gram.y"
    {
					insertSelectOptions((SelectStmt *) (yyvsp[(2) - (3)].node), (yyvsp[(3) - (3)].list), NIL,
										NULL, NULL,
										(yyvsp[(1) - (3)].with),
										yyscanner);
					(yyval.node) = (yyvsp[(2) - (3)].node);
				}
    break;

  case 1389:
/* Line 1787 of yacc.c  */
#line 9415 "gram.y"
    {
					insertSelectOptions((SelectStmt *) (yyvsp[(2) - (5)].node), (yyvsp[(3) - (5)].list), (yyvsp[(4) - (5)].list),
										list_nth((yyvsp[(5) - (5)].list), 0), list_nth((yyvsp[(5) - (5)].list), 1),
										(yyvsp[(1) - (5)].with),
										yyscanner);
					(yyval.node) = (yyvsp[(2) - (5)].node);
				}
    break;

  case 1390:
/* Line 1787 of yacc.c  */
#line 9423 "gram.y"
    {
					insertSelectOptions((SelectStmt *) (yyvsp[(2) - (5)].node), (yyvsp[(3) - (5)].list), (yyvsp[(5) - (5)].list),
										list_nth((yyvsp[(4) - (5)].list), 0), list_nth((yyvsp[(4) - (5)].list), 1),
										(yyvsp[(1) - (5)].with),
										yyscanner);
					(yyval.node) = (yyvsp[(2) - (5)].node);
				}
    break;

  case 1391:
/* Line 1787 of yacc.c  */
#line 9433 "gram.y"
    { (yyval.node) = (yyvsp[(1) - (1)].node); }
    break;

  case 1392:
/* Line 1787 of yacc.c  */
#line 9434 "gram.y"
    { (yyval.node) = (yyvsp[(1) - (1)].node); }
    break;

  case 1393:
/* Line 1787 of yacc.c  */
#line 9464 "gram.y"
    {
					SelectStmt *n = makeNode(SelectStmt);
					n->distinctClause = (yyvsp[(2) - (9)].list);
					n->targetList = (yyvsp[(3) - (9)].list);
					n->intoClause = (yyvsp[(4) - (9)].into);
					n->fromClause = (yyvsp[(5) - (9)].list);
					n->whereClause = (yyvsp[(6) - (9)].node);
					n->groupClause = (yyvsp[(7) - (9)].list);
					n->havingClause = (yyvsp[(8) - (9)].node);
					n->windowClause = (yyvsp[(9) - (9)].list);
					(yyval.node) = (Node *)n;
				}
    break;

  case 1394:
/* Line 1787 of yacc.c  */
#line 9476 "gram.y"
    { (yyval.node) = (yyvsp[(1) - (1)].node); }
    break;

  case 1395:
/* Line 1787 of yacc.c  */
#line 9478 "gram.y"
    {
					/* same as SELECT * FROM relation_expr */
					ColumnRef *cr = makeNode(ColumnRef);
					ResTarget *rt = makeNode(ResTarget);
					SelectStmt *n = makeNode(SelectStmt);

					cr->fields = list_make1(makeNode(A_Star));
					cr->location = -1;

					rt->name = NULL;
					rt->indirection = NIL;
					rt->val = (Node *)cr;
					rt->location = -1;

					n->targetList = list_make1(rt);
					n->fromClause = list_make1((yyvsp[(2) - (2)].range));
					(yyval.node) = (Node *)n;
				}
    break;

  case 1396:
/* Line 1787 of yacc.c  */
#line 9497 "gram.y"
    {
					(yyval.node) = makeSetOp(SETOP_UNION, (yyvsp[(3) - (4)].boolean), (yyvsp[(1) - (4)].node), (yyvsp[(4) - (4)].node));
				}
    break;

  case 1397:
/* Line 1787 of yacc.c  */
#line 9501 "gram.y"
    {
					(yyval.node) = makeSetOp(SETOP_INTERSECT, (yyvsp[(3) - (4)].boolean), (yyvsp[(1) - (4)].node), (yyvsp[(4) - (4)].node));
				}
    break;

  case 1398:
/* Line 1787 of yacc.c  */
#line 9505 "gram.y"
    {
					(yyval.node) = makeSetOp(SETOP_EXCEPT, (yyvsp[(3) - (4)].boolean), (yyvsp[(1) - (4)].node), (yyvsp[(4) - (4)].node));
				}
    break;

  case 1399:
/* Line 1787 of yacc.c  */
#line 9520 "gram.y"
    {
				(yyval.with) = makeNode(WithClause);
				(yyval.with)->ctes = (yyvsp[(2) - (2)].list);
				(yyval.with)->recursive = false;
				(yyval.with)->location = (yylsp[(1) - (2)]);
			}
    break;

  case 1400:
/* Line 1787 of yacc.c  */
#line 9527 "gram.y"
    {
				(yyval.with) = makeNode(WithClause);
				(yyval.with)->ctes = (yyvsp[(3) - (3)].list);
				(yyval.with)->recursive = true;
				(yyval.with)->location = (yylsp[(1) - (3)]);
			}
    break;

  case 1401:
/* Line 1787 of yacc.c  */
#line 9536 "gram.y"
    { (yyval.list) = list_make1((yyvsp[(1) - (1)].node)); }
    break;

  case 1402:
/* Line 1787 of yacc.c  */
#line 9537 "gram.y"
    { (yyval.list) = lappend((yyvsp[(1) - (3)].list), (yyvsp[(3) - (3)].node)); }
    break;

  case 1403:
/* Line 1787 of yacc.c  */
#line 9541 "gram.y"
    {
				CommonTableExpr *n = makeNode(CommonTableExpr);
				n->ctename = (yyvsp[(1) - (6)].str);
				n->aliascolnames = (yyvsp[(2) - (6)].list);
				n->ctequery = (yyvsp[(5) - (6)].node);
				n->location = (yylsp[(1) - (6)]);
				(yyval.node) = (Node *) n;
			}
    break;

  case 1404:
/* Line 1787 of yacc.c  */
#line 9552 "gram.y"
    { (yyval.with) = (yyvsp[(1) - (1)].with); }
    break;

  case 1405:
/* Line 1787 of yacc.c  */
#line 9553 "gram.y"
    { (yyval.with) = NULL; }
    break;

  case 1406:
/* Line 1787 of yacc.c  */
#line 9558 "gram.y"
    {
					(yyval.into) = makeNode(IntoClause);
					(yyval.into)->rel = (yyvsp[(2) - (2)].range);
					(yyval.into)->colNames = NIL;
					(yyval.into)->options = NIL;
					(yyval.into)->onCommit = ONCOMMIT_NOOP;
					(yyval.into)->tableSpaceName = NULL;
					(yyval.into)->viewQuery = NULL;
					(yyval.into)->skipData = false;
				}
    break;

  case 1407:
/* Line 1787 of yacc.c  */
#line 9569 "gram.y"
    { (yyval.into) = NULL; }
    break;

  case 1408:
/* Line 1787 of yacc.c  */
#line 9578 "gram.y"
    {
					(yyval.range) = (yyvsp[(3) - (3)].range);
					(yyval.range)->relpersistence = RELPERSISTENCE_TEMP;
				}
    break;

  case 1409:
/* Line 1787 of yacc.c  */
#line 9583 "gram.y"
    {
					(yyval.range) = (yyvsp[(3) - (3)].range);
					(yyval.range)->relpersistence = RELPERSISTENCE_TEMP;
				}
    break;

  case 1410:
/* Line 1787 of yacc.c  */
#line 9588 "gram.y"
    {
					(yyval.range) = (yyvsp[(4) - (4)].range);
					(yyval.range)->relpersistence = RELPERSISTENCE_TEMP;
				}
    break;

  case 1411:
/* Line 1787 of yacc.c  */
#line 9593 "gram.y"
    {
					(yyval.range) = (yyvsp[(4) - (4)].range);
					(yyval.range)->relpersistence = RELPERSISTENCE_TEMP;
				}
    break;

  case 1412:
/* Line 1787 of yacc.c  */
#line 9598 "gram.y"
    {
					ereport(WARNING,
							(errmsg("GLOBAL is deprecated in temporary table creation"),
							 parser_errposition((yylsp[(1) - (4)]))));
					(yyval.range) = (yyvsp[(4) - (4)].range);
					(yyval.range)->relpersistence = RELPERSISTENCE_TEMP;
				}
    break;

  case 1413:
/* Line 1787 of yacc.c  */
#line 9606 "gram.y"
    {
					ereport(WARNING,
							(errmsg("GLOBAL is deprecated in temporary table creation"),
							 parser_errposition((yylsp[(1) - (4)]))));
					(yyval.range) = (yyvsp[(4) - (4)].range);
					(yyval.range)->relpersistence = RELPERSISTENCE_TEMP;
				}
    break;

  case 1414:
/* Line 1787 of yacc.c  */
#line 9614 "gram.y"
    {
					(yyval.range) = (yyvsp[(3) - (3)].range);
					(yyval.range)->relpersistence = RELPERSISTENCE_UNLOGGED;
				}
    break;

  case 1415:
/* Line 1787 of yacc.c  */
#line 9619 "gram.y"
    {
					(yyval.range) = (yyvsp[(2) - (2)].range);
					(yyval.range)->relpersistence = RELPERSISTENCE_PERMANENT;
				}
    break;

  case 1416:
/* Line 1787 of yacc.c  */
#line 9624 "gram.y"
    {
					(yyval.range) = (yyvsp[(1) - (1)].range);
					(yyval.range)->relpersistence = RELPERSISTENCE_PERMANENT;
				}
    break;

  case 1417:
/* Line 1787 of yacc.c  */
#line 9630 "gram.y"
    {}
    break;

  case 1418:
/* Line 1787 of yacc.c  */
#line 9631 "gram.y"
    {}
    break;

  case 1419:
/* Line 1787 of yacc.c  */
#line 9634 "gram.y"
    { (yyval.boolean) = TRUE; }
    break;

  case 1420:
/* Line 1787 of yacc.c  */
#line 9635 "gram.y"
    { (yyval.boolean) = FALSE; }
    break;

  case 1421:
/* Line 1787 of yacc.c  */
#line 9636 "gram.y"
    { (yyval.boolean) = FALSE; }
    break;

  case 1422:
/* Line 1787 of yacc.c  */
#line 9643 "gram.y"
    { (yyval.list) = list_make1(NIL); }
    break;

  case 1423:
/* Line 1787 of yacc.c  */
#line 9644 "gram.y"
    { (yyval.list) = (yyvsp[(4) - (5)].list); }
    break;

  case 1424:
/* Line 1787 of yacc.c  */
#line 9645 "gram.y"
    { (yyval.list) = NIL; }
    break;

  case 1425:
/* Line 1787 of yacc.c  */
#line 9646 "gram.y"
    { (yyval.list) = NIL; }
    break;

  case 1426:
/* Line 1787 of yacc.c  */
#line 9650 "gram.y"
    { (yyval.list) = (yyvsp[(1) - (1)].list);}
    break;

  case 1427:
/* Line 1787 of yacc.c  */
#line 9651 "gram.y"
    { (yyval.list) = NIL; }
    break;

  case 1428:
/* Line 1787 of yacc.c  */
#line 9655 "gram.y"
    { (yyval.list) = (yyvsp[(3) - (3)].list); }
    break;

  case 1429:
/* Line 1787 of yacc.c  */
#line 9659 "gram.y"
    { (yyval.list) = list_make1((yyvsp[(1) - (1)].sortby)); }
    break;

  case 1430:
/* Line 1787 of yacc.c  */
#line 9660 "gram.y"
    { (yyval.list) = lappend((yyvsp[(1) - (3)].list), (yyvsp[(3) - (3)].sortby)); }
    break;

  case 1431:
/* Line 1787 of yacc.c  */
#line 9664 "gram.y"
    {
					(yyval.sortby) = makeNode(SortBy);
					(yyval.sortby)->node = (yyvsp[(1) - (4)].node);
					(yyval.sortby)->sortby_dir = SORTBY_USING;
					(yyval.sortby)->sortby_nulls = (yyvsp[(4) - (4)].ival);
					(yyval.sortby)->useOp = (yyvsp[(3) - (4)].list);
					(yyval.sortby)->location = (yylsp[(3) - (4)]);
				}
    break;

  case 1432:
/* Line 1787 of yacc.c  */
#line 9673 "gram.y"
    {
					(yyval.sortby) = makeNode(SortBy);
					(yyval.sortby)->node = (yyvsp[(1) - (3)].node);
					(yyval.sortby)->sortby_dir = (yyvsp[(2) - (3)].ival);
					(yyval.sortby)->sortby_nulls = (yyvsp[(3) - (3)].ival);
					(yyval.sortby)->useOp = NIL;
					(yyval.sortby)->location = -1;		/* no operator */
				}
    break;

  case 1433:
/* Line 1787 of yacc.c  */
#line 9685 "gram.y"
    { (yyval.list) = list_make2((yyvsp[(2) - (2)].node), (yyvsp[(1) - (2)].node)); }
    break;

  case 1434:
/* Line 1787 of yacc.c  */
#line 9686 "gram.y"
    { (yyval.list) = list_make2((yyvsp[(1) - (2)].node), (yyvsp[(2) - (2)].node)); }
    break;

  case 1435:
/* Line 1787 of yacc.c  */
#line 9687 "gram.y"
    { (yyval.list) = list_make2(NULL, (yyvsp[(1) - (1)].node)); }
    break;

  case 1436:
/* Line 1787 of yacc.c  */
#line 9688 "gram.y"
    { (yyval.list) = list_make2((yyvsp[(1) - (1)].node), NULL); }
    break;

  case 1437:
/* Line 1787 of yacc.c  */
#line 9692 "gram.y"
    { (yyval.list) = (yyvsp[(1) - (1)].list); }
    break;

  case 1438:
/* Line 1787 of yacc.c  */
#line 9693 "gram.y"
    { (yyval.list) = list_make2(NULL,NULL); }
    break;

  case 1439:
/* Line 1787 of yacc.c  */
#line 9698 "gram.y"
    { (yyval.node) = (yyvsp[(2) - (2)].node); }
    break;

  case 1440:
/* Line 1787 of yacc.c  */
#line 9700 "gram.y"
    {
					/* Disabled because it was too confusing, bjm 2002-02-18 */
					ereport(ERROR,
							(errcode(ERRCODE_SYNTAX_ERROR),
							 errmsg("LIMIT #,# syntax is not supported"),
							 errhint("Use separate LIMIT and OFFSET clauses."),
							 parser_errposition((yylsp[(1) - (4)]))));
				}
    break;

  case 1441:
/* Line 1787 of yacc.c  */
#line 9710 "gram.y"
    { (yyval.node) = (yyvsp[(3) - (5)].node); }
    break;

  case 1442:
/* Line 1787 of yacc.c  */
#line 9715 "gram.y"
    { (yyval.node) = (yyvsp[(2) - (2)].node); }
    break;

  case 1443:
/* Line 1787 of yacc.c  */
#line 9718 "gram.y"
    { (yyval.node) = (yyvsp[(2) - (3)].node); }
    break;

  case 1444:
/* Line 1787 of yacc.c  */
#line 9722 "gram.y"
    { (yyval.node) = (yyvsp[(1) - (1)].node); }
    break;

  case 1445:
/* Line 1787 of yacc.c  */
#line 9724 "gram.y"
    {
					/* LIMIT ALL is represented as a NULL constant */
					(yyval.node) = makeNullAConst((yylsp[(1) - (1)]));
				}
    break;

  case 1446:
/* Line 1787 of yacc.c  */
#line 9731 "gram.y"
    { (yyval.node) = (yyvsp[(1) - (1)].node); }
    break;

  case 1447:
/* Line 1787 of yacc.c  */
#line 9741 "gram.y"
    { (yyval.node) = makeIntConst((yyvsp[(1) - (1)].ival), (yylsp[(1) - (1)])); }
    break;

  case 1448:
/* Line 1787 of yacc.c  */
#line 9742 "gram.y"
    { (yyval.node) = (yyvsp[(2) - (3)].node); }
    break;

  case 1449:
/* Line 1787 of yacc.c  */
#line 9743 "gram.y"
    { (yyval.node) = makeIntConst(1, -1); }
    break;

  case 1450:
/* Line 1787 of yacc.c  */
#line 9751 "gram.y"
    { (yyval.node) = (yyvsp[(1) - (1)].node); }
    break;

  case 1451:
/* Line 1787 of yacc.c  */
#line 9755 "gram.y"
    { (yyval.ival) = 0; }
    break;

  case 1452:
/* Line 1787 of yacc.c  */
#line 9756 "gram.y"
    { (yyval.ival) = 0; }
    break;

  case 1453:
/* Line 1787 of yacc.c  */
#line 9759 "gram.y"
    { (yyval.ival) = 0; }
    break;

  case 1454:
/* Line 1787 of yacc.c  */
#line 9760 "gram.y"
    { (yyval.ival) = 0; }
    break;

  case 1455:
/* Line 1787 of yacc.c  */
#line 9765 "gram.y"
    { (yyval.list) = (yyvsp[(3) - (3)].list); }
    break;

  case 1456:
/* Line 1787 of yacc.c  */
#line 9766 "gram.y"
    { (yyval.list) = NIL; }
    break;

  case 1457:
/* Line 1787 of yacc.c  */
#line 9770 "gram.y"
    { (yyval.node) = (yyvsp[(2) - (2)].node); }
    break;

  case 1458:
/* Line 1787 of yacc.c  */
#line 9771 "gram.y"
    { (yyval.node) = NULL; }
    break;

  case 1459:
/* Line 1787 of yacc.c  */
#line 9775 "gram.y"
    { (yyval.list) = (yyvsp[(1) - (1)].list); }
    break;

  case 1460:
/* Line 1787 of yacc.c  */
#line 9776 "gram.y"
    { (yyval.list) = NIL; }
    break;

  case 1461:
/* Line 1787 of yacc.c  */
#line 9780 "gram.y"
    { (yyval.list) = (yyvsp[(1) - (1)].list); }
    break;

  case 1462:
/* Line 1787 of yacc.c  */
#line 9781 "gram.y"
    { (yyval.list) = NIL; }
    break;

  case 1463:
/* Line 1787 of yacc.c  */
#line 9785 "gram.y"
    { (yyval.list) = list_make1((yyvsp[(1) - (1)].node)); }
    break;

  case 1464:
/* Line 1787 of yacc.c  */
#line 9786 "gram.y"
    { (yyval.list) = lappend((yyvsp[(1) - (2)].list), (yyvsp[(2) - (2)].node)); }
    break;

  case 1465:
/* Line 1787 of yacc.c  */
#line 9791 "gram.y"
    {
					LockingClause *n = makeNode(LockingClause);
					n->lockedRels = (yyvsp[(2) - (3)].list);
					n->strength = (yyvsp[(1) - (3)].ival);
					n->noWait = (yyvsp[(3) - (3)].boolean);
					(yyval.node) = (Node *) n;
				}
    break;

  case 1466:
/* Line 1787 of yacc.c  */
#line 9801 "gram.y"
    { (yyval.ival) = LCS_FORUPDATE; }
    break;

  case 1467:
/* Line 1787 of yacc.c  */
#line 9802 "gram.y"
    { (yyval.ival) = LCS_FORNOKEYUPDATE; }
    break;

  case 1468:
/* Line 1787 of yacc.c  */
#line 9803 "gram.y"
    { (yyval.ival) = LCS_FORSHARE; }
    break;

  case 1469:
/* Line 1787 of yacc.c  */
#line 9804 "gram.y"
    { (yyval.ival) = LCS_FORKEYSHARE; }
    break;

  case 1470:
/* Line 1787 of yacc.c  */
#line 9808 "gram.y"
    { (yyval.list) = (yyvsp[(2) - (2)].list); }
    break;

  case 1471:
/* Line 1787 of yacc.c  */
#line 9809 "gram.y"
    { (yyval.list) = NIL; }
    break;

  case 1472:
/* Line 1787 of yacc.c  */
#line 9815 "gram.y"
    {
					SelectStmt *n = makeNode(SelectStmt);
					n->valuesLists = list_make1((yyvsp[(2) - (2)].list));
					(yyval.node) = (Node *) n;
				}
    break;

  case 1473:
/* Line 1787 of yacc.c  */
#line 9821 "gram.y"
    {
					SelectStmt *n = (SelectStmt *) (yyvsp[(1) - (3)].node);
					n->valuesLists = lappend(n->valuesLists, (yyvsp[(3) - (3)].list));
					(yyval.node) = (Node *) n;
				}
    break;

  case 1474:
/* Line 1787 of yacc.c  */
#line 9838 "gram.y"
    { (yyval.list) = (yyvsp[(2) - (2)].list); }
    break;

  case 1475:
/* Line 1787 of yacc.c  */
#line 9839 "gram.y"
    { (yyval.list) = NIL; }
    break;

  case 1476:
/* Line 1787 of yacc.c  */
#line 9843 "gram.y"
    { (yyval.list) = list_make1((yyvsp[(1) - (1)].node)); }
    break;

  case 1477:
/* Line 1787 of yacc.c  */
#line 9844 "gram.y"
    { (yyval.list) = lappend((yyvsp[(1) - (3)].list), (yyvsp[(3) - (3)].node)); }
    break;

  case 1478:
/* Line 1787 of yacc.c  */
#line 9851 "gram.y"
    {
					(yyvsp[(1) - (2)].range)->alias = (yyvsp[(2) - (2)].alias);
					(yyval.node) = (Node *) (yyvsp[(1) - (2)].range);
				}
    break;

  case 1479:
/* Line 1787 of yacc.c  */
#line 9856 "gram.y"
    {
					RangeFunction *n = (RangeFunction *) (yyvsp[(1) - (2)].node);
					n->alias = linitial((yyvsp[(2) - (2)].list));
					n->coldeflist = lsecond((yyvsp[(2) - (2)].list));
					(yyval.node) = (Node *) n;
				}
    break;

  case 1480:
/* Line 1787 of yacc.c  */
#line 9863 "gram.y"
    {
					RangeFunction *n = (RangeFunction *) (yyvsp[(2) - (3)].node);
					n->lateral = true;
					n->alias = linitial((yyvsp[(3) - (3)].list));
					n->coldeflist = lsecond((yyvsp[(3) - (3)].list));
					(yyval.node) = (Node *) n;
				}
    break;

  case 1481:
/* Line 1787 of yacc.c  */
#line 9871 "gram.y"
    {
					RangeSubselect *n = makeNode(RangeSubselect);
					n->lateral = false;
					n->subquery = (yyvsp[(1) - (2)].node);
					n->alias = (yyvsp[(2) - (2)].alias);
					/*
					 * The SQL spec does not permit a subselect
					 * (<derived_table>) without an alias clause,
					 * so we don't either.  This avoids the problem
					 * of needing to invent a unique refname for it.
					 * That could be surmounted if there's sufficient
					 * popular demand, but for now let's just implement
					 * the spec and see if anyone complains.
					 * However, it does seem like a good idea to emit
					 * an error message that's better than "syntax error".
					 */
					if ((yyvsp[(2) - (2)].alias) == NULL)
					{
						if (IsA((yyvsp[(1) - (2)].node), SelectStmt) &&
							((SelectStmt *) (yyvsp[(1) - (2)].node))->valuesLists)
							ereport(ERROR,
									(errcode(ERRCODE_SYNTAX_ERROR),
									 errmsg("VALUES in FROM must have an alias"),
									 errhint("For example, FROM (VALUES ...) [AS] foo."),
									 parser_errposition((yylsp[(1) - (2)]))));
						else
							ereport(ERROR,
									(errcode(ERRCODE_SYNTAX_ERROR),
									 errmsg("subquery in FROM must have an alias"),
									 errhint("For example, FROM (SELECT ...) [AS] foo."),
									 parser_errposition((yylsp[(1) - (2)]))));
					}
					(yyval.node) = (Node *) n;
				}
    break;

  case 1482:
/* Line 1787 of yacc.c  */
#line 9906 "gram.y"
    {
					RangeSubselect *n = makeNode(RangeSubselect);
					n->lateral = true;
					n->subquery = (yyvsp[(2) - (3)].node);
					n->alias = (yyvsp[(3) - (3)].alias);
					/* same comment as above */
					if ((yyvsp[(3) - (3)].alias) == NULL)
					{
						if (IsA((yyvsp[(2) - (3)].node), SelectStmt) &&
							((SelectStmt *) (yyvsp[(2) - (3)].node))->valuesLists)
							ereport(ERROR,
									(errcode(ERRCODE_SYNTAX_ERROR),
									 errmsg("VALUES in FROM must have an alias"),
									 errhint("For example, FROM (VALUES ...) [AS] foo."),
									 parser_errposition((yylsp[(2) - (3)]))));
						else
							ereport(ERROR,
									(errcode(ERRCODE_SYNTAX_ERROR),
									 errmsg("subquery in FROM must have an alias"),
									 errhint("For example, FROM (SELECT ...) [AS] foo."),
									 parser_errposition((yylsp[(2) - (3)]))));
					}
					(yyval.node) = (Node *) n;
				}
    break;

  case 1483:
/* Line 1787 of yacc.c  */
#line 9931 "gram.y"
    {
					(yyval.node) = (Node *) (yyvsp[(1) - (1)].jexpr);
				}
    break;

  case 1484:
/* Line 1787 of yacc.c  */
#line 9935 "gram.y"
    {
					(yyvsp[(2) - (4)].jexpr)->alias = (yyvsp[(4) - (4)].alias);
					(yyval.node) = (Node *) (yyvsp[(2) - (4)].jexpr);
				}
    break;

  case 1485:
/* Line 1787 of yacc.c  */
#line 9961 "gram.y"
    {
					(yyval.jexpr) = (yyvsp[(2) - (3)].jexpr);
				}
    break;

  case 1486:
/* Line 1787 of yacc.c  */
#line 9965 "gram.y"
    {
					/* CROSS JOIN is same as unqualified inner join */
					JoinExpr *n = makeNode(JoinExpr);
					n->jointype = JOIN_INNER;
					n->isNatural = FALSE;
					n->larg = (yyvsp[(1) - (4)].node);
					n->rarg = (yyvsp[(4) - (4)].node);
					n->usingClause = NIL;
					n->quals = NULL;
					(yyval.jexpr) = n;
				}
    break;

  case 1487:
/* Line 1787 of yacc.c  */
#line 9977 "gram.y"
    {
					JoinExpr *n = makeNode(JoinExpr);
					n->jointype = (yyvsp[(2) - (5)].jtype);
					n->isNatural = FALSE;
					n->larg = (yyvsp[(1) - (5)].node);
					n->rarg = (yyvsp[(4) - (5)].node);
					if ((yyvsp[(5) - (5)].node) != NULL && IsA((yyvsp[(5) - (5)].node), List))
						n->usingClause = (List *) (yyvsp[(5) - (5)].node); /* USING clause */
					else
						n->quals = (yyvsp[(5) - (5)].node); /* ON clause */
					(yyval.jexpr) = n;
				}
    break;

  case 1488:
/* Line 1787 of yacc.c  */
#line 9990 "gram.y"
    {
					/* letting join_type reduce to empty doesn't work */
					JoinExpr *n = makeNode(JoinExpr);
					n->jointype = JOIN_INNER;
					n->isNatural = FALSE;
					n->larg = (yyvsp[(1) - (4)].node);
					n->rarg = (yyvsp[(3) - (4)].node);
					if ((yyvsp[(4) - (4)].node) != NULL && IsA((yyvsp[(4) - (4)].node), List))
						n->usingClause = (List *) (yyvsp[(4) - (4)].node); /* USING clause */
					else
						n->quals = (yyvsp[(4) - (4)].node); /* ON clause */
					(yyval.jexpr) = n;
				}
    break;

  case 1489:
/* Line 1787 of yacc.c  */
#line 10004 "gram.y"
    {
					JoinExpr *n = makeNode(JoinExpr);
					n->jointype = (yyvsp[(3) - (5)].jtype);
					n->isNatural = TRUE;
					n->larg = (yyvsp[(1) - (5)].node);
					n->rarg = (yyvsp[(5) - (5)].node);
					n->usingClause = NIL; /* figure out which columns later... */
					n->quals = NULL; /* fill later */
					(yyval.jexpr) = n;
				}
    break;

  case 1490:
/* Line 1787 of yacc.c  */
#line 10015 "gram.y"
    {
					/* letting join_type reduce to empty doesn't work */
					JoinExpr *n = makeNode(JoinExpr);
					n->jointype = JOIN_INNER;
					n->isNatural = TRUE;
					n->larg = (yyvsp[(1) - (4)].node);
					n->rarg = (yyvsp[(4) - (4)].node);
					n->usingClause = NIL; /* figure out which columns later... */
					n->quals = NULL; /* fill later */
					(yyval.jexpr) = n;
				}
    break;

  case 1491:
/* Line 1787 of yacc.c  */
#line 10030 "gram.y"
    {
					(yyval.alias) = makeNode(Alias);
					(yyval.alias)->aliasname = (yyvsp[(2) - (5)].str);
					(yyval.alias)->colnames = (yyvsp[(4) - (5)].list);
				}
    break;

  case 1492:
/* Line 1787 of yacc.c  */
#line 10036 "gram.y"
    {
					(yyval.alias) = makeNode(Alias);
					(yyval.alias)->aliasname = (yyvsp[(2) - (2)].str);
				}
    break;

  case 1493:
/* Line 1787 of yacc.c  */
#line 10041 "gram.y"
    {
					(yyval.alias) = makeNode(Alias);
					(yyval.alias)->aliasname = (yyvsp[(1) - (4)].str);
					(yyval.alias)->colnames = (yyvsp[(3) - (4)].list);
				}
    break;

  case 1494:
/* Line 1787 of yacc.c  */
#line 10047 "gram.y"
    {
					(yyval.alias) = makeNode(Alias);
					(yyval.alias)->aliasname = (yyvsp[(1) - (1)].str);
				}
    break;

  case 1495:
/* Line 1787 of yacc.c  */
#line 10053 "gram.y"
    { (yyval.alias) = (yyvsp[(1) - (1)].alias); }
    break;

  case 1496:
/* Line 1787 of yacc.c  */
#line 10054 "gram.y"
    { (yyval.alias) = NULL; }
    break;

  case 1497:
/* Line 1787 of yacc.c  */
#line 10063 "gram.y"
    {
					(yyval.list) = list_make2((yyvsp[(1) - (1)].alias), NIL);
				}
    break;

  case 1498:
/* Line 1787 of yacc.c  */
#line 10067 "gram.y"
    {
					(yyval.list) = list_make2(NULL, (yyvsp[(3) - (4)].list));
				}
    break;

  case 1499:
/* Line 1787 of yacc.c  */
#line 10071 "gram.y"
    {
					Alias *a = makeNode(Alias);
					a->aliasname = (yyvsp[(2) - (5)].str);
					(yyval.list) = list_make2(a, (yyvsp[(4) - (5)].list));
				}
    break;

  case 1500:
/* Line 1787 of yacc.c  */
#line 10077 "gram.y"
    {
					Alias *a = makeNode(Alias);
					a->aliasname = (yyvsp[(1) - (4)].str);
					(yyval.list) = list_make2(a, (yyvsp[(3) - (4)].list));
				}
    break;

  case 1501:
/* Line 1787 of yacc.c  */
#line 10083 "gram.y"
    {
					(yyval.list) = list_make2(NULL, NIL);
				}
    break;

  case 1502:
/* Line 1787 of yacc.c  */
#line 10088 "gram.y"
    { (yyval.jtype) = JOIN_FULL; }
    break;

  case 1503:
/* Line 1787 of yacc.c  */
#line 10089 "gram.y"
    { (yyval.jtype) = JOIN_LEFT; }
    break;

  case 1504:
/* Line 1787 of yacc.c  */
#line 10090 "gram.y"
    { (yyval.jtype) = JOIN_RIGHT; }
    break;

  case 1505:
/* Line 1787 of yacc.c  */
#line 10091 "gram.y"
    { (yyval.jtype) = JOIN_INNER; }
    break;

  case 1506:
/* Line 1787 of yacc.c  */
#line 10095 "gram.y"
    { (yyval.node) = NULL; }
    break;

  case 1507:
/* Line 1787 of yacc.c  */
#line 10096 "gram.y"
    { (yyval.node) = NULL; }
    break;

  case 1508:
/* Line 1787 of yacc.c  */
#line 10108 "gram.y"
    { (yyval.node) = (Node *) (yyvsp[(3) - (4)].list); }
    break;

  case 1509:
/* Line 1787 of yacc.c  */
#line 10109 "gram.y"
    { (yyval.node) = (yyvsp[(2) - (2)].node); }
    break;

  case 1510:
/* Line 1787 of yacc.c  */
#line 10115 "gram.y"
    {
					/* default inheritance */
					(yyval.range) = (yyvsp[(1) - (1)].range);
					(yyval.range)->inhOpt = INH_DEFAULT;
					(yyval.range)->alias = NULL;
				}
    break;

  case 1511:
/* Line 1787 of yacc.c  */
#line 10122 "gram.y"
    {
					/* inheritance query */
					(yyval.range) = (yyvsp[(1) - (2)].range);
					(yyval.range)->inhOpt = INH_YES;
					(yyval.range)->alias = NULL;
				}
    break;

  case 1512:
/* Line 1787 of yacc.c  */
#line 10129 "gram.y"
    {
					/* no inheritance */
					(yyval.range) = (yyvsp[(2) - (2)].range);
					(yyval.range)->inhOpt = INH_NO;
					(yyval.range)->alias = NULL;
				}
    break;

  case 1513:
/* Line 1787 of yacc.c  */
#line 10136 "gram.y"
    {
					/* no inheritance, SQL99-style syntax */
					(yyval.range) = (yyvsp[(3) - (4)].range);
					(yyval.range)->inhOpt = INH_NO;
					(yyval.range)->alias = NULL;
				}
    break;

  case 1514:
/* Line 1787 of yacc.c  */
#line 10146 "gram.y"
    { (yyval.list) = list_make1((yyvsp[(1) - (1)].range)); }
    break;

  case 1515:
/* Line 1787 of yacc.c  */
#line 10147 "gram.y"
    { (yyval.list) = lappend((yyvsp[(1) - (3)].list), (yyvsp[(3) - (3)].range)); }
    break;

  case 1516:
/* Line 1787 of yacc.c  */
#line 10161 "gram.y"
    {
					(yyval.range) = (yyvsp[(1) - (1)].range);
				}
    break;

  case 1517:
/* Line 1787 of yacc.c  */
#line 10165 "gram.y"
    {
					Alias *alias = makeNode(Alias);
					alias->aliasname = (yyvsp[(2) - (2)].str);
					(yyvsp[(1) - (2)].range)->alias = alias;
					(yyval.range) = (yyvsp[(1) - (2)].range);
				}
    break;

  case 1518:
/* Line 1787 of yacc.c  */
#line 10172 "gram.y"
    {
					Alias *alias = makeNode(Alias);
					alias->aliasname = (yyvsp[(3) - (3)].str);
					(yyvsp[(1) - (3)].range)->alias = alias;
					(yyval.range) = (yyvsp[(1) - (3)].range);
				}
    break;

  case 1519:
/* Line 1787 of yacc.c  */
#line 10193 "gram.y"
    {
					RangeFunction *n = makeNode(RangeFunction);
					n->lateral = false;
					n->ordinality = (yyvsp[(2) - (2)].boolean);
					n->is_rowsfrom = false;
					n->functions = list_make1(list_make2((yyvsp[(1) - (2)].node), NIL));
					/* alias and coldeflist are set by table_ref production */
					(yyval.node) = (Node *) n;
				}
    break;

  case 1520:
/* Line 1787 of yacc.c  */
#line 10203 "gram.y"
    {
					RangeFunction *n = makeNode(RangeFunction);
					n->lateral = false;
					n->ordinality = (yyvsp[(6) - (6)].boolean);
					n->is_rowsfrom = true;
					n->functions = (yyvsp[(4) - (6)].list);
					/* alias and coldeflist are set by table_ref production */
					(yyval.node) = (Node *) n;
				}
    break;

  case 1521:
/* Line 1787 of yacc.c  */
#line 10215 "gram.y"
    { (yyval.list) = list_make2((yyvsp[(1) - (2)].node), (yyvsp[(2) - (2)].list)); }
    break;

  case 1522:
/* Line 1787 of yacc.c  */
#line 10219 "gram.y"
    { (yyval.list) = list_make1((yyvsp[(1) - (1)].list)); }
    break;

  case 1523:
/* Line 1787 of yacc.c  */
#line 10220 "gram.y"
    { (yyval.list) = lappend((yyvsp[(1) - (3)].list), (yyvsp[(3) - (3)].list)); }
    break;

  case 1524:
/* Line 1787 of yacc.c  */
#line 10223 "gram.y"
    { (yyval.list) = (yyvsp[(3) - (4)].list); }
    break;

  case 1525:
/* Line 1787 of yacc.c  */
#line 10224 "gram.y"
    { (yyval.list) = NIL; }
    break;

  case 1526:
/* Line 1787 of yacc.c  */
#line 10227 "gram.y"
    { (yyval.boolean) = true; }
    break;

  case 1527:
/* Line 1787 of yacc.c  */
#line 10228 "gram.y"
    { (yyval.boolean) = false; }
    break;

  case 1528:
/* Line 1787 of yacc.c  */
#line 10233 "gram.y"
    { (yyval.node) = (yyvsp[(2) - (2)].node); }
    break;

  case 1529:
/* Line 1787 of yacc.c  */
#line 10234 "gram.y"
    { (yyval.node) = NULL; }
    break;

  case 1530:
/* Line 1787 of yacc.c  */
#line 10239 "gram.y"
    { (yyval.node) = (yyvsp[(2) - (2)].node); }
    break;

  case 1531:
/* Line 1787 of yacc.c  */
#line 10241 "gram.y"
    {
					CurrentOfExpr *n = makeNode(CurrentOfExpr);
					/* cvarno is filled in by parse analysis */
					n->cursor_name = (yyvsp[(4) - (4)].str);
					n->cursor_param = 0;
					(yyval.node) = (Node *) n;
				}
    break;

  case 1532:
/* Line 1787 of yacc.c  */
#line 10248 "gram.y"
    { (yyval.node) = NULL; }
    break;

  case 1533:
/* Line 1787 of yacc.c  */
#line 10253 "gram.y"
    { (yyval.list) = (yyvsp[(1) - (1)].list); }
    break;

  case 1534:
/* Line 1787 of yacc.c  */
#line 10254 "gram.y"
    { (yyval.list) = NIL; }
    break;

  case 1535:
/* Line 1787 of yacc.c  */
#line 10259 "gram.y"
    {
					(yyval.list) = list_make1((yyvsp[(1) - (1)].node));
				}
    break;

  case 1536:
/* Line 1787 of yacc.c  */
#line 10263 "gram.y"
    {
					(yyval.list) = lappend((yyvsp[(1) - (3)].list), (yyvsp[(3) - (3)].node));
				}
    break;

  case 1537:
/* Line 1787 of yacc.c  */
#line 10269 "gram.y"
    {
					ColumnDef *n = makeNode(ColumnDef);
					n->colname = (yyvsp[(1) - (3)].str);
					n->typeName = (yyvsp[(2) - (3)].typnam);
					n->inhcount = 0;
					n->is_local = true;
					n->is_not_null = false;
					n->is_from_type = false;
					n->storage = 0;
					n->raw_default = NULL;
					n->cooked_default = NULL;
					n->collClause = (CollateClause *) (yyvsp[(3) - (3)].node);
					n->collOid = InvalidOid;
					n->constraints = NIL;
					n->location = (yylsp[(1) - (3)]);
					(yyval.node) = (Node *)n;
				}
    break;

  case 1538:
/* Line 1787 of yacc.c  */
#line 10299 "gram.y"
    {
					(yyval.typnam) = (yyvsp[(1) - (2)].typnam);
					(yyval.typnam)->arrayBounds = (yyvsp[(2) - (2)].list);
				}
    break;

  case 1539:
/* Line 1787 of yacc.c  */
#line 10304 "gram.y"
    {
					(yyval.typnam) = (yyvsp[(2) - (3)].typnam);
					(yyval.typnam)->arrayBounds = (yyvsp[(3) - (3)].list);
					(yyval.typnam)->setof = TRUE;
				}
    break;

  case 1540:
/* Line 1787 of yacc.c  */
#line 10311 "gram.y"
    {
					(yyval.typnam) = (yyvsp[(1) - (5)].typnam);
					(yyval.typnam)->arrayBounds = list_make1(makeInteger((yyvsp[(4) - (5)].ival)));
				}
    break;

  case 1541:
/* Line 1787 of yacc.c  */
#line 10316 "gram.y"
    {
					(yyval.typnam) = (yyvsp[(2) - (6)].typnam);
					(yyval.typnam)->arrayBounds = list_make1(makeInteger((yyvsp[(5) - (6)].ival)));
					(yyval.typnam)->setof = TRUE;
				}
    break;

  case 1542:
/* Line 1787 of yacc.c  */
#line 10322 "gram.y"
    {
					(yyval.typnam) = (yyvsp[(1) - (2)].typnam);
					(yyval.typnam)->arrayBounds = list_make1(makeInteger(-1));
				}
    break;

  case 1543:
/* Line 1787 of yacc.c  */
#line 10327 "gram.y"
    {
					(yyval.typnam) = (yyvsp[(2) - (3)].typnam);
					(yyval.typnam)->arrayBounds = list_make1(makeInteger(-1));
					(yyval.typnam)->setof = TRUE;
				}
    break;

  case 1544:
/* Line 1787 of yacc.c  */
#line 10336 "gram.y"
    {  (yyval.list) = lappend((yyvsp[(1) - (3)].list), makeInteger(-1)); }
    break;

  case 1545:
/* Line 1787 of yacc.c  */
#line 10338 "gram.y"
    {  (yyval.list) = lappend((yyvsp[(1) - (4)].list), makeInteger((yyvsp[(3) - (4)].ival))); }
    break;

  case 1546:
/* Line 1787 of yacc.c  */
#line 10340 "gram.y"
    {  (yyval.list) = NIL; }
    break;

  case 1547:
/* Line 1787 of yacc.c  */
#line 10344 "gram.y"
    { (yyval.typnam) = (yyvsp[(1) - (1)].typnam); }
    break;

  case 1548:
/* Line 1787 of yacc.c  */
#line 10345 "gram.y"
    { (yyval.typnam) = (yyvsp[(1) - (1)].typnam); }
    break;

  case 1549:
/* Line 1787 of yacc.c  */
#line 10346 "gram.y"
    { (yyval.typnam) = (yyvsp[(1) - (1)].typnam); }
    break;

  case 1550:
/* Line 1787 of yacc.c  */
#line 10347 "gram.y"
    { (yyval.typnam) = (yyvsp[(1) - (1)].typnam); }
    break;

  case 1551:
/* Line 1787 of yacc.c  */
#line 10348 "gram.y"
    { (yyval.typnam) = (yyvsp[(1) - (1)].typnam); }
    break;

  case 1552:
/* Line 1787 of yacc.c  */
#line 10350 "gram.y"
    {
					(yyval.typnam) = (yyvsp[(1) - (2)].typnam);
					(yyval.typnam)->typmods = (yyvsp[(2) - (2)].list);
				}
    break;

  case 1553:
/* Line 1787 of yacc.c  */
#line 10355 "gram.y"
    {
					(yyval.typnam) = (yyvsp[(1) - (5)].typnam);
					if ((yyvsp[(5) - (5)].list) != NIL)
					{
						if (list_length((yyvsp[(5) - (5)].list)) != 1)
							ereport(ERROR,
									(errcode(ERRCODE_SYNTAX_ERROR),
									 errmsg("interval precision specified twice"),
									 parser_errposition((yylsp[(1) - (5)]))));
						(yyval.typnam)->typmods = lappend((yyvsp[(5) - (5)].list), makeIntConst((yyvsp[(3) - (5)].ival), (yylsp[(3) - (5)])));
					}
					else
						(yyval.typnam)->typmods = list_make2(makeIntConst(INTERVAL_FULL_RANGE, -1),
												 makeIntConst((yyvsp[(3) - (5)].ival), (yylsp[(3) - (5)])));
				}
    break;

  case 1554:
/* Line 1787 of yacc.c  */
#line 10384 "gram.y"
    { (yyval.typnam) = (yyvsp[(1) - (1)].typnam); }
    break;

  case 1555:
/* Line 1787 of yacc.c  */
#line 10385 "gram.y"
    { (yyval.typnam) = (yyvsp[(1) - (1)].typnam); }
    break;

  case 1556:
/* Line 1787 of yacc.c  */
#line 10386 "gram.y"
    { (yyval.typnam) = (yyvsp[(1) - (1)].typnam); }
    break;

  case 1557:
/* Line 1787 of yacc.c  */
#line 10387 "gram.y"
    { (yyval.typnam) = (yyvsp[(1) - (1)].typnam); }
    break;

  case 1558:
/* Line 1787 of yacc.c  */
#line 10399 "gram.y"
    {
					(yyval.typnam) = makeTypeName((yyvsp[(1) - (2)].str));
					(yyval.typnam)->typmods = (yyvsp[(2) - (2)].list);
					(yyval.typnam)->location = (yylsp[(1) - (2)]);
				}
    break;

  case 1559:
/* Line 1787 of yacc.c  */
#line 10405 "gram.y"
    {
					(yyval.typnam) = makeTypeNameFromNameList(lcons(makeString((yyvsp[(1) - (3)].str)), (yyvsp[(2) - (3)].list)));
					(yyval.typnam)->typmods = (yyvsp[(3) - (3)].list);
					(yyval.typnam)->location = (yylsp[(1) - (3)]);
				}
    break;

  case 1560:
/* Line 1787 of yacc.c  */
#line 10412 "gram.y"
    { (yyval.list) = (yyvsp[(2) - (3)].list); }
    break;

  case 1561:
/* Line 1787 of yacc.c  */
#line 10413 "gram.y"
    { (yyval.list) = NIL; }
    break;

  case 1562:
/* Line 1787 of yacc.c  */
#line 10420 "gram.y"
    {
					(yyval.typnam) = SystemTypeName("int4");
					(yyval.typnam)->location = (yylsp[(1) - (1)]);
				}
    break;

  case 1563:
/* Line 1787 of yacc.c  */
#line 10425 "gram.y"
    {
					(yyval.typnam) = SystemTypeName("int4");
					(yyval.typnam)->location = (yylsp[(1) - (1)]);
				}
    break;

  case 1564:
/* Line 1787 of yacc.c  */
#line 10430 "gram.y"
    {
					(yyval.typnam) = SystemTypeName("int2");
					(yyval.typnam)->location = (yylsp[(1) - (1)]);
				}
    break;

  case 1565:
/* Line 1787 of yacc.c  */
#line 10435 "gram.y"
    {
					(yyval.typnam) = SystemTypeName("int8");
					(yyval.typnam)->location = (yylsp[(1) - (1)]);
				}
    break;

  case 1566:
/* Line 1787 of yacc.c  */
#line 10440 "gram.y"
    {
					(yyval.typnam) = SystemTypeName("float4");
					(yyval.typnam)->location = (yylsp[(1) - (1)]);
				}
    break;

  case 1567:
/* Line 1787 of yacc.c  */
#line 10445 "gram.y"
    {
					(yyval.typnam) = (yyvsp[(2) - (2)].typnam);
					(yyval.typnam)->location = (yylsp[(1) - (2)]);
				}
    break;

  case 1568:
/* Line 1787 of yacc.c  */
#line 10450 "gram.y"
    {
					(yyval.typnam) = SystemTypeName("float8");
					(yyval.typnam)->location = (yylsp[(1) - (2)]);
				}
    break;

  case 1569:
/* Line 1787 of yacc.c  */
#line 10455 "gram.y"
    {
					(yyval.typnam) = SystemTypeName("numeric");
					(yyval.typnam)->typmods = (yyvsp[(2) - (2)].list);
					(yyval.typnam)->location = (yylsp[(1) - (2)]);
				}
    break;

  case 1570:
/* Line 1787 of yacc.c  */
#line 10461 "gram.y"
    {
					(yyval.typnam) = SystemTypeName("numeric");
					(yyval.typnam)->typmods = (yyvsp[(2) - (2)].list);
					(yyval.typnam)->location = (yylsp[(1) - (2)]);
				}
    break;

  case 1571:
/* Line 1787 of yacc.c  */
#line 10467 "gram.y"
    {
					(yyval.typnam) = SystemTypeName("numeric");
					(yyval.typnam)->typmods = (yyvsp[(2) - (2)].list);
					(yyval.typnam)->location = (yylsp[(1) - (2)]);
				}
    break;

  case 1572:
/* Line 1787 of yacc.c  */
#line 10473 "gram.y"
    {
					(yyval.typnam) = SystemTypeName("bool");
					(yyval.typnam)->location = (yylsp[(1) - (1)]);
				}
    break;

  case 1573:
/* Line 1787 of yacc.c  */
#line 10480 "gram.y"
    {
					/*
					 * Check FLOAT() precision limits assuming IEEE floating
					 * types - thomas 1997-09-18
					 */
					if ((yyvsp[(2) - (3)].ival) < 1)
						ereport(ERROR,
								(errcode(ERRCODE_INVALID_PARAMETER_VALUE),
								 errmsg("precision for type float must be at least 1 bit"),
								 parser_errposition((yylsp[(2) - (3)]))));
					else if ((yyvsp[(2) - (3)].ival) <= 24)
						(yyval.typnam) = SystemTypeName("float4");
					else if ((yyvsp[(2) - (3)].ival) <= 53)
						(yyval.typnam) = SystemTypeName("float8");
					else
						ereport(ERROR,
								(errcode(ERRCODE_INVALID_PARAMETER_VALUE),
								 errmsg("precision for type float must be less than 54 bits"),
								 parser_errposition((yylsp[(2) - (3)]))));
				}
    break;

  case 1574:
/* Line 1787 of yacc.c  */
#line 10501 "gram.y"
    {
					(yyval.typnam) = SystemTypeName("float8");
				}
    break;

  case 1575:
/* Line 1787 of yacc.c  */
#line 10511 "gram.y"
    {
					(yyval.typnam) = (yyvsp[(1) - (1)].typnam);
				}
    break;

  case 1576:
/* Line 1787 of yacc.c  */
#line 10515 "gram.y"
    {
					(yyval.typnam) = (yyvsp[(1) - (1)].typnam);
				}
    break;

  case 1577:
/* Line 1787 of yacc.c  */
#line 10523 "gram.y"
    {
					(yyval.typnam) = (yyvsp[(1) - (1)].typnam);
				}
    break;

  case 1578:
/* Line 1787 of yacc.c  */
#line 10527 "gram.y"
    {
					(yyval.typnam) = (yyvsp[(1) - (1)].typnam);
					(yyval.typnam)->typmods = NIL;
				}
    break;

  case 1579:
/* Line 1787 of yacc.c  */
#line 10535 "gram.y"
    {
					char *typname;

					typname = (yyvsp[(2) - (5)].boolean) ? "varbit" : "bit";
					(yyval.typnam) = SystemTypeName(typname);
					(yyval.typnam)->typmods = (yyvsp[(4) - (5)].list);
					(yyval.typnam)->location = (yylsp[(1) - (5)]);
				}
    break;

  case 1580:
/* Line 1787 of yacc.c  */
#line 10547 "gram.y"
    {
					/* bit defaults to bit(1), varbit to no limit */
					if ((yyvsp[(2) - (2)].boolean))
					{
						(yyval.typnam) = SystemTypeName("varbit");
					}
					else
					{
						(yyval.typnam) = SystemTypeName("bit");
						(yyval.typnam)->typmods = list_make1(makeIntConst(1, -1));
					}
					(yyval.typnam)->location = (yylsp[(1) - (2)]);
				}
    break;

  case 1581:
/* Line 1787 of yacc.c  */
#line 10568 "gram.y"
    {
					(yyval.typnam) = (yyvsp[(1) - (1)].typnam);
				}
    break;

  case 1582:
/* Line 1787 of yacc.c  */
#line 10572 "gram.y"
    {
					(yyval.typnam) = (yyvsp[(1) - (1)].typnam);
				}
    break;

  case 1583:
/* Line 1787 of yacc.c  */
#line 10578 "gram.y"
    {
					(yyval.typnam) = (yyvsp[(1) - (1)].typnam);
				}
    break;

  case 1584:
/* Line 1787 of yacc.c  */
#line 10582 "gram.y"
    {
					/* Length was not specified so allow to be unrestricted.
					 * This handles problems with fixed-length (bpchar) strings
					 * which in column definitions must default to a length
					 * of one, but should not be constrained if the length
					 * was not specified.
					 */
					(yyval.typnam) = (yyvsp[(1) - (1)].typnam);
					(yyval.typnam)->typmods = NIL;
				}
    break;

  case 1585:
/* Line 1787 of yacc.c  */
#line 10595 "gram.y"
    {
					if (((yyvsp[(5) - (5)].str) != NULL) && (strcmp((yyvsp[(5) - (5)].str), "sql_text") != 0))
						(yyvsp[(1) - (5)].str) = psprintf("%s_%s", (yyvsp[(1) - (5)].str), (yyvsp[(5) - (5)].str));

					(yyval.typnam) = SystemTypeName((yyvsp[(1) - (5)].str));
					(yyval.typnam)->typmods = list_make1(makeIntConst((yyvsp[(3) - (5)].ival), (yylsp[(3) - (5)])));
					(yyval.typnam)->location = (yylsp[(1) - (5)]);
				}
    break;

  case 1586:
/* Line 1787 of yacc.c  */
#line 10606 "gram.y"
    {
					if (((yyvsp[(2) - (2)].str) != NULL) && (strcmp((yyvsp[(2) - (2)].str), "sql_text") != 0))
						(yyvsp[(1) - (2)].str) = psprintf("%s_%s", (yyvsp[(1) - (2)].str), (yyvsp[(2) - (2)].str));

					(yyval.typnam) = SystemTypeName((yyvsp[(1) - (2)].str));

					/* char defaults to char(1), varchar to no limit */
					if (strcmp((yyvsp[(1) - (2)].str), "bpchar") == 0)
						(yyval.typnam)->typmods = list_make1(makeIntConst(1, -1));

					(yyval.typnam)->location = (yylsp[(1) - (2)]);
				}
    break;

  case 1587:
/* Line 1787 of yacc.c  */
#line 10621 "gram.y"
    { (yyval.str) = (yyvsp[(2) - (2)].boolean) ? "varchar": "bpchar"; }
    break;

  case 1588:
/* Line 1787 of yacc.c  */
#line 10623 "gram.y"
    { (yyval.str) = (yyvsp[(2) - (2)].boolean) ? "varchar": "bpchar"; }
    break;

  case 1589:
/* Line 1787 of yacc.c  */
#line 10625 "gram.y"
    { (yyval.str) = "varchar"; }
    break;

  case 1590:
/* Line 1787 of yacc.c  */
#line 10627 "gram.y"
    { (yyval.str) = (yyvsp[(3) - (3)].boolean) ? "varchar": "bpchar"; }
    break;

  case 1591:
/* Line 1787 of yacc.c  */
#line 10629 "gram.y"
    { (yyval.str) = (yyvsp[(3) - (3)].boolean) ? "varchar": "bpchar"; }
    break;

  case 1592:
/* Line 1787 of yacc.c  */
#line 10631 "gram.y"
    { (yyval.str) = (yyvsp[(2) - (2)].boolean) ? "varchar": "bpchar"; }
    break;

  case 1593:
/* Line 1787 of yacc.c  */
#line 10635 "gram.y"
    { (yyval.boolean) = TRUE; }
    break;

  case 1594:
/* Line 1787 of yacc.c  */
#line 10636 "gram.y"
    { (yyval.boolean) = FALSE; }
    break;

  case 1595:
/* Line 1787 of yacc.c  */
#line 10640 "gram.y"
    { (yyval.str) = (yyvsp[(3) - (3)].str); }
    break;

  case 1596:
/* Line 1787 of yacc.c  */
#line 10641 "gram.y"
    { (yyval.str) = NULL; }
    break;

  case 1597:
/* Line 1787 of yacc.c  */
#line 10649 "gram.y"
    {
					if ((yyvsp[(5) - (5)].boolean))
						(yyval.typnam) = SystemTypeName("timestamptz");
					else
						(yyval.typnam) = SystemTypeName("timestamp");
					(yyval.typnam)->typmods = list_make1(makeIntConst((yyvsp[(3) - (5)].ival), (yylsp[(3) - (5)])));
					(yyval.typnam)->location = (yylsp[(1) - (5)]);
				}
    break;

  case 1598:
/* Line 1787 of yacc.c  */
#line 10658 "gram.y"
    {
					if ((yyvsp[(2) - (2)].boolean))
						(yyval.typnam) = SystemTypeName("timestamptz");
					else
						(yyval.typnam) = SystemTypeName("timestamp");
					(yyval.typnam)->location = (yylsp[(1) - (2)]);
				}
    break;

  case 1599:
/* Line 1787 of yacc.c  */
#line 10666 "gram.y"
    {
					if ((yyvsp[(5) - (5)].boolean))
						(yyval.typnam) = SystemTypeName("timetz");
					else
						(yyval.typnam) = SystemTypeName("time");
					(yyval.typnam)->typmods = list_make1(makeIntConst((yyvsp[(3) - (5)].ival), (yylsp[(3) - (5)])));
					(yyval.typnam)->location = (yylsp[(1) - (5)]);
				}
    break;

  case 1600:
/* Line 1787 of yacc.c  */
#line 10675 "gram.y"
    {
					if ((yyvsp[(2) - (2)].boolean))
						(yyval.typnam) = SystemTypeName("timetz");
					else
						(yyval.typnam) = SystemTypeName("time");
					(yyval.typnam)->location = (yylsp[(1) - (2)]);
				}
    break;

  case 1601:
/* Line 1787 of yacc.c  */
#line 10686 "gram.y"
    {
					(yyval.typnam) = SystemTypeName("interval");
					(yyval.typnam)->location = (yylsp[(1) - (1)]);
				}
    break;

  case 1602:
/* Line 1787 of yacc.c  */
#line 10693 "gram.y"
    { (yyval.boolean) = TRUE; }
    break;

  case 1603:
/* Line 1787 of yacc.c  */
#line 10694 "gram.y"
    { (yyval.boolean) = FALSE; }
    break;

  case 1604:
/* Line 1787 of yacc.c  */
#line 10695 "gram.y"
    { (yyval.boolean) = FALSE; }
    break;

  case 1605:
/* Line 1787 of yacc.c  */
#line 10700 "gram.y"
    { (yyval.list) = list_make1(makeIntConst(INTERVAL_MASK(YEAR), (yylsp[(1) - (1)]))); }
    break;

  case 1606:
/* Line 1787 of yacc.c  */
#line 10702 "gram.y"
    { (yyval.list) = list_make1(makeIntConst(INTERVAL_MASK(MONTH), (yylsp[(1) - (1)]))); }
    break;

  case 1607:
/* Line 1787 of yacc.c  */
#line 10704 "gram.y"
    { (yyval.list) = list_make1(makeIntConst(INTERVAL_MASK(DAY), (yylsp[(1) - (1)]))); }
    break;

  case 1608:
/* Line 1787 of yacc.c  */
#line 10706 "gram.y"
    { (yyval.list) = list_make1(makeIntConst(INTERVAL_MASK(HOUR), (yylsp[(1) - (1)]))); }
    break;

  case 1609:
/* Line 1787 of yacc.c  */
#line 10708 "gram.y"
    { (yyval.list) = list_make1(makeIntConst(INTERVAL_MASK(MINUTE), (yylsp[(1) - (1)]))); }
    break;

  case 1610:
/* Line 1787 of yacc.c  */
#line 10710 "gram.y"
    { (yyval.list) = (yyvsp[(1) - (1)].list); }
    break;

  case 1611:
/* Line 1787 of yacc.c  */
#line 10712 "gram.y"
    {
					(yyval.list) = list_make1(makeIntConst(INTERVAL_MASK(YEAR) |
												 INTERVAL_MASK(MONTH), (yylsp[(1) - (3)])));
				}
    break;

  case 1612:
/* Line 1787 of yacc.c  */
#line 10717 "gram.y"
    {
					(yyval.list) = list_make1(makeIntConst(INTERVAL_MASK(DAY) |
												 INTERVAL_MASK(HOUR), (yylsp[(1) - (3)])));
				}
    break;

  case 1613:
/* Line 1787 of yacc.c  */
#line 10722 "gram.y"
    {
					(yyval.list) = list_make1(makeIntConst(INTERVAL_MASK(DAY) |
												 INTERVAL_MASK(HOUR) |
												 INTERVAL_MASK(MINUTE), (yylsp[(1) - (3)])));
				}
    break;

  case 1614:
/* Line 1787 of yacc.c  */
#line 10728 "gram.y"
    {
					(yyval.list) = (yyvsp[(3) - (3)].list);
					linitial((yyval.list)) = makeIntConst(INTERVAL_MASK(DAY) |
												INTERVAL_MASK(HOUR) |
												INTERVAL_MASK(MINUTE) |
												INTERVAL_MASK(SECOND), (yylsp[(1) - (3)]));
				}
    break;

  case 1615:
/* Line 1787 of yacc.c  */
#line 10736 "gram.y"
    {
					(yyval.list) = list_make1(makeIntConst(INTERVAL_MASK(HOUR) |
												 INTERVAL_MASK(MINUTE), (yylsp[(1) - (3)])));
				}
    break;

  case 1616:
/* Line 1787 of yacc.c  */
#line 10741 "gram.y"
    {
					(yyval.list) = (yyvsp[(3) - (3)].list);
					linitial((yyval.list)) = makeIntConst(INTERVAL_MASK(HOUR) |
												INTERVAL_MASK(MINUTE) |
												INTERVAL_MASK(SECOND), (yylsp[(1) - (3)]));
				}
    break;

  case 1617:
/* Line 1787 of yacc.c  */
#line 10748 "gram.y"
    {
					(yyval.list) = (yyvsp[(3) - (3)].list);
					linitial((yyval.list)) = makeIntConst(INTERVAL_MASK(MINUTE) |
												INTERVAL_MASK(SECOND), (yylsp[(1) - (3)]));
				}
    break;

  case 1618:
/* Line 1787 of yacc.c  */
#line 10754 "gram.y"
    { (yyval.list) = NIL; }
    break;

  case 1619:
/* Line 1787 of yacc.c  */
#line 10759 "gram.y"
    {
					(yyval.list) = list_make1(makeIntConst(INTERVAL_MASK(SECOND), (yylsp[(1) - (1)])));
				}
    break;

  case 1620:
/* Line 1787 of yacc.c  */
#line 10763 "gram.y"
    {
					(yyval.list) = list_make2(makeIntConst(INTERVAL_MASK(SECOND), (yylsp[(1) - (4)])),
									makeIntConst((yyvsp[(3) - (4)].ival), (yylsp[(3) - (4)])));
				}
    break;

  case 1621:
/* Line 1787 of yacc.c  */
#line 10792 "gram.y"
    { (yyval.node) = (yyvsp[(1) - (1)].node); }
    break;

  case 1622:
/* Line 1787 of yacc.c  */
#line 10794 "gram.y"
    { (yyval.node) = makeTypeCast((yyvsp[(1) - (3)].node), (yyvsp[(3) - (3)].typnam), (yylsp[(2) - (3)])); }
    break;

  case 1623:
/* Line 1787 of yacc.c  */
#line 10796 "gram.y"
    {
					CollateClause *n = makeNode(CollateClause);
					n->arg = (yyvsp[(1) - (3)].node);
					n->collname = (yyvsp[(3) - (3)].list);
					n->location = (yylsp[(2) - (3)]);
					(yyval.node) = (Node *) n;
				}
    break;

  case 1624:
/* Line 1787 of yacc.c  */
#line 10804 "gram.y"
    {
					(yyval.node) = (Node *) makeFuncCall(SystemFuncName("timezone"),
											   list_make2((yyvsp[(5) - (5)].node), (yyvsp[(1) - (5)].node)),
											   (yylsp[(2) - (5)]));
				}
    break;

  case 1625:
/* Line 1787 of yacc.c  */
#line 10819 "gram.y"
    { (yyval.node) = (Node *) makeSimpleA_Expr(AEXPR_OP, "+", NULL, (yyvsp[(2) - (2)].node), (yylsp[(1) - (2)])); }
    break;

  case 1626:
/* Line 1787 of yacc.c  */
#line 10821 "gram.y"
    { (yyval.node) = doNegate((yyvsp[(2) - (2)].node), (yylsp[(1) - (2)])); }
    break;

  case 1627:
/* Line 1787 of yacc.c  */
#line 10823 "gram.y"
    { (yyval.node) = (Node *) makeSimpleA_Expr(AEXPR_OP, "+", (yyvsp[(1) - (3)].node), (yyvsp[(3) - (3)].node), (yylsp[(2) - (3)])); }
    break;

  case 1628:
/* Line 1787 of yacc.c  */
#line 10825 "gram.y"
    { (yyval.node) = (Node *) makeSimpleA_Expr(AEXPR_OP, "-", (yyvsp[(1) - (3)].node), (yyvsp[(3) - (3)].node), (yylsp[(2) - (3)])); }
    break;

  case 1629:
/* Line 1787 of yacc.c  */
#line 10827 "gram.y"
    { (yyval.node) = (Node *) makeSimpleA_Expr(AEXPR_OP, "*", (yyvsp[(1) - (3)].node), (yyvsp[(3) - (3)].node), (yylsp[(2) - (3)])); }
    break;

  case 1630:
/* Line 1787 of yacc.c  */
#line 10829 "gram.y"
    { (yyval.node) = (Node *) makeSimpleA_Expr(AEXPR_OP, "/", (yyvsp[(1) - (3)].node), (yyvsp[(3) - (3)].node), (yylsp[(2) - (3)])); }
    break;

  case 1631:
/* Line 1787 of yacc.c  */
#line 10831 "gram.y"
    { (yyval.node) = (Node *) makeSimpleA_Expr(AEXPR_OP, "%", (yyvsp[(1) - (3)].node), (yyvsp[(3) - (3)].node), (yylsp[(2) - (3)])); }
    break;

  case 1632:
/* Line 1787 of yacc.c  */
#line 10833 "gram.y"
    { (yyval.node) = (Node *) makeSimpleA_Expr(AEXPR_OP, "^", (yyvsp[(1) - (3)].node), (yyvsp[(3) - (3)].node), (yylsp[(2) - (3)])); }
    break;

  case 1633:
/* Line 1787 of yacc.c  */
#line 10835 "gram.y"
    { (yyval.node) = (Node *) makeSimpleA_Expr(AEXPR_OP, "<", (yyvsp[(1) - (3)].node), (yyvsp[(3) - (3)].node), (yylsp[(2) - (3)])); }
    break;

  case 1634:
/* Line 1787 of yacc.c  */
#line 10837 "gram.y"
    { (yyval.node) = (Node *) makeSimpleA_Expr(AEXPR_OP, ">", (yyvsp[(1) - (3)].node), (yyvsp[(3) - (3)].node), (yylsp[(2) - (3)])); }
    break;

  case 1635:
/* Line 1787 of yacc.c  */
#line 10839 "gram.y"
    { (yyval.node) = (Node *) makeSimpleA_Expr(AEXPR_OP, "=", (yyvsp[(1) - (3)].node), (yyvsp[(3) - (3)].node), (yylsp[(2) - (3)])); }
    break;

  case 1636:
/* Line 1787 of yacc.c  */
#line 10842 "gram.y"
    { (yyval.node) = (Node *) makeA_Expr(AEXPR_OP, (yyvsp[(2) - (3)].list), (yyvsp[(1) - (3)].node), (yyvsp[(3) - (3)].node), (yylsp[(2) - (3)])); }
    break;

  case 1637:
/* Line 1787 of yacc.c  */
#line 10844 "gram.y"
    { (yyval.node) = (Node *) makeA_Expr(AEXPR_OP, (yyvsp[(1) - (2)].list), NULL, (yyvsp[(2) - (2)].node), (yylsp[(1) - (2)])); }
    break;

  case 1638:
/* Line 1787 of yacc.c  */
#line 10846 "gram.y"
    { (yyval.node) = (Node *) makeA_Expr(AEXPR_OP, (yyvsp[(2) - (2)].list), (yyvsp[(1) - (2)].node), NULL, (yylsp[(2) - (2)])); }
    break;

  case 1639:
/* Line 1787 of yacc.c  */
#line 10849 "gram.y"
    { (yyval.node) = (Node *) makeA_Expr(AEXPR_AND, NIL, (yyvsp[(1) - (3)].node), (yyvsp[(3) - (3)].node), (yylsp[(2) - (3)])); }
    break;

  case 1640:
/* Line 1787 of yacc.c  */
#line 10851 "gram.y"
    { (yyval.node) = (Node *) makeA_Expr(AEXPR_OR, NIL, (yyvsp[(1) - (3)].node), (yyvsp[(3) - (3)].node), (yylsp[(2) - (3)])); }
    break;

  case 1641:
/* Line 1787 of yacc.c  */
#line 10853 "gram.y"
    { (yyval.node) = (Node *) makeA_Expr(AEXPR_NOT, NIL, NULL, (yyvsp[(2) - (2)].node), (yylsp[(1) - (2)])); }
    break;

  case 1642:
/* Line 1787 of yacc.c  */
#line 10856 "gram.y"
    { (yyval.node) = (Node *) makeSimpleA_Expr(AEXPR_OP, "~~", (yyvsp[(1) - (3)].node), (yyvsp[(3) - (3)].node), (yylsp[(2) - (3)])); }
    break;

  case 1643:
/* Line 1787 of yacc.c  */
#line 10858 "gram.y"
    {
					FuncCall *n = makeFuncCall(list_make1(makeString("like_escape")),
											   list_make2((yyvsp[(3) - (5)].node), (yyvsp[(5) - (5)].node)),
											   (yylsp[(2) - (5)]));
					(yyval.node) = (Node *) makeSimpleA_Expr(AEXPR_OP, "~~", (yyvsp[(1) - (5)].node), (Node *) n, (yylsp[(2) - (5)]));
				}
    break;

  case 1644:
/* Line 1787 of yacc.c  */
#line 10865 "gram.y"
    { (yyval.node) = (Node *) makeSimpleA_Expr(AEXPR_OP, "!~~", (yyvsp[(1) - (4)].node), (yyvsp[(4) - (4)].node), (yylsp[(2) - (4)])); }
    break;

  case 1645:
/* Line 1787 of yacc.c  */
#line 10867 "gram.y"
    {
					FuncCall *n = makeFuncCall(list_make1(makeString("like_escape")),
											   list_make2((yyvsp[(4) - (6)].node), (yyvsp[(6) - (6)].node)),
											   (yylsp[(2) - (6)]));
					(yyval.node) = (Node *) makeSimpleA_Expr(AEXPR_OP, "!~~", (yyvsp[(1) - (6)].node), (Node *) n, (yylsp[(2) - (6)]));
				}
    break;

  case 1646:
/* Line 1787 of yacc.c  */
#line 10874 "gram.y"
    { (yyval.node) = (Node *) makeSimpleA_Expr(AEXPR_OP, "~~*", (yyvsp[(1) - (3)].node), (yyvsp[(3) - (3)].node), (yylsp[(2) - (3)])); }
    break;

  case 1647:
/* Line 1787 of yacc.c  */
#line 10876 "gram.y"
    {
					FuncCall *n = makeFuncCall(list_make1(makeString("like_escape")),
											   list_make2((yyvsp[(3) - (5)].node), (yyvsp[(5) - (5)].node)),
											   (yylsp[(2) - (5)]));
					(yyval.node) = (Node *) makeSimpleA_Expr(AEXPR_OP, "~~*", (yyvsp[(1) - (5)].node), (Node *) n, (yylsp[(2) - (5)]));
				}
    break;

  case 1648:
/* Line 1787 of yacc.c  */
#line 10883 "gram.y"
    { (yyval.node) = (Node *) makeSimpleA_Expr(AEXPR_OP, "!~~*", (yyvsp[(1) - (4)].node), (yyvsp[(4) - (4)].node), (yylsp[(2) - (4)])); }
    break;

  case 1649:
/* Line 1787 of yacc.c  */
#line 10885 "gram.y"
    {
					FuncCall *n = makeFuncCall(list_make1(makeString("like_escape")),
											   list_make2((yyvsp[(4) - (6)].node), (yyvsp[(6) - (6)].node)),
											   (yylsp[(2) - (6)]));
					(yyval.node) = (Node *) makeSimpleA_Expr(AEXPR_OP, "!~~*", (yyvsp[(1) - (6)].node), (Node *) n, (yylsp[(2) - (6)]));
				}
    break;

  case 1650:
/* Line 1787 of yacc.c  */
#line 10893 "gram.y"
    {
					FuncCall *n = makeFuncCall(list_make1(makeString("similar_escape")),
											   list_make2((yyvsp[(4) - (4)].node), makeNullAConst(-1)),
											   (yylsp[(2) - (4)]));
					(yyval.node) = (Node *) makeSimpleA_Expr(AEXPR_OP, "~", (yyvsp[(1) - (4)].node), (Node *) n, (yylsp[(2) - (4)]));
				}
    break;

  case 1651:
/* Line 1787 of yacc.c  */
#line 10900 "gram.y"
    {
					FuncCall *n = makeFuncCall(list_make1(makeString("similar_escape")),
											   list_make2((yyvsp[(4) - (6)].node), (yyvsp[(6) - (6)].node)),
											   (yylsp[(2) - (6)]));
					(yyval.node) = (Node *) makeSimpleA_Expr(AEXPR_OP, "~", (yyvsp[(1) - (6)].node), (Node *) n, (yylsp[(2) - (6)]));
				}
    break;

  case 1652:
/* Line 1787 of yacc.c  */
#line 10907 "gram.y"
    {
					FuncCall *n = makeFuncCall(list_make1(makeString("similar_escape")),
											   list_make2((yyvsp[(5) - (5)].node), makeNullAConst(-1)),
											   (yylsp[(2) - (5)]));
					(yyval.node) = (Node *) makeSimpleA_Expr(AEXPR_OP, "!~", (yyvsp[(1) - (5)].node), (Node *) n, (yylsp[(2) - (5)]));
				}
    break;

  case 1653:
/* Line 1787 of yacc.c  */
#line 10914 "gram.y"
    {
					FuncCall *n = makeFuncCall(list_make1(makeString("similar_escape")),
											   list_make2((yyvsp[(5) - (7)].node), (yyvsp[(7) - (7)].node)),
											   (yylsp[(2) - (7)]));
					(yyval.node) = (Node *) makeSimpleA_Expr(AEXPR_OP, "!~", (yyvsp[(1) - (7)].node), (Node *) n, (yylsp[(2) - (7)]));
				}
    break;

  case 1654:
/* Line 1787 of yacc.c  */
#line 10931 "gram.y"
    {
					NullTest *n = makeNode(NullTest);
					n->arg = (Expr *) (yyvsp[(1) - (3)].node);
					n->nulltesttype = IS_NULL;
					(yyval.node) = (Node *)n;
				}
    break;

  case 1655:
/* Line 1787 of yacc.c  */
#line 10938 "gram.y"
    {
					NullTest *n = makeNode(NullTest);
					n->arg = (Expr *) (yyvsp[(1) - (2)].node);
					n->nulltesttype = IS_NULL;
					(yyval.node) = (Node *)n;
				}
    break;

  case 1656:
/* Line 1787 of yacc.c  */
#line 10945 "gram.y"
    {
					NullTest *n = makeNode(NullTest);
					n->arg = (Expr *) (yyvsp[(1) - (4)].node);
					n->nulltesttype = IS_NOT_NULL;
					(yyval.node) = (Node *)n;
				}
    break;

  case 1657:
/* Line 1787 of yacc.c  */
#line 10952 "gram.y"
    {
					NullTest *n = makeNode(NullTest);
					n->arg = (Expr *) (yyvsp[(1) - (2)].node);
					n->nulltesttype = IS_NOT_NULL;
					(yyval.node) = (Node *)n;
				}
    break;

  case 1658:
/* Line 1787 of yacc.c  */
#line 10959 "gram.y"
    {
					if (list_length((yyvsp[(1) - (3)].list)) != 2)
						ereport(ERROR,
								(errcode(ERRCODE_SYNTAX_ERROR),
								 errmsg("wrong number of parameters on left side of OVERLAPS expression"),
								 parser_errposition((yylsp[(1) - (3)]))));
					if (list_length((yyvsp[(3) - (3)].list)) != 2)
						ereport(ERROR,
								(errcode(ERRCODE_SYNTAX_ERROR),
								 errmsg("wrong number of parameters on right side of OVERLAPS expression"),
								 parser_errposition((yylsp[(3) - (3)]))));
					(yyval.node) = (Node *) makeFuncCall(SystemFuncName("overlaps"),
											   list_concat((yyvsp[(1) - (3)].list), (yyvsp[(3) - (3)].list)),
											   (yylsp[(2) - (3)]));
				}
    break;

  case 1659:
/* Line 1787 of yacc.c  */
#line 10975 "gram.y"
    {
					BooleanTest *b = makeNode(BooleanTest);
					b->arg = (Expr *) (yyvsp[(1) - (3)].node);
					b->booltesttype = IS_TRUE;
					(yyval.node) = (Node *)b;
				}
    break;

  case 1660:
/* Line 1787 of yacc.c  */
#line 10982 "gram.y"
    {
					BooleanTest *b = makeNode(BooleanTest);
					b->arg = (Expr *) (yyvsp[(1) - (4)].node);
					b->booltesttype = IS_NOT_TRUE;
					(yyval.node) = (Node *)b;
				}
    break;

  case 1661:
/* Line 1787 of yacc.c  */
#line 10989 "gram.y"
    {
					BooleanTest *b = makeNode(BooleanTest);
					b->arg = (Expr *) (yyvsp[(1) - (3)].node);
					b->booltesttype = IS_FALSE;
					(yyval.node) = (Node *)b;
				}
    break;

  case 1662:
/* Line 1787 of yacc.c  */
#line 10996 "gram.y"
    {
					BooleanTest *b = makeNode(BooleanTest);
					b->arg = (Expr *) (yyvsp[(1) - (4)].node);
					b->booltesttype = IS_NOT_FALSE;
					(yyval.node) = (Node *)b;
				}
    break;

  case 1663:
/* Line 1787 of yacc.c  */
#line 11003 "gram.y"
    {
					BooleanTest *b = makeNode(BooleanTest);
					b->arg = (Expr *) (yyvsp[(1) - (3)].node);
					b->booltesttype = IS_UNKNOWN;
					(yyval.node) = (Node *)b;
				}
    break;

  case 1664:
/* Line 1787 of yacc.c  */
#line 11010 "gram.y"
    {
					BooleanTest *b = makeNode(BooleanTest);
					b->arg = (Expr *) (yyvsp[(1) - (4)].node);
					b->booltesttype = IS_NOT_UNKNOWN;
					(yyval.node) = (Node *)b;
				}
    break;

  case 1665:
/* Line 1787 of yacc.c  */
#line 11017 "gram.y"
    {
					(yyval.node) = (Node *) makeSimpleA_Expr(AEXPR_DISTINCT, "=", (yyvsp[(1) - (5)].node), (yyvsp[(5) - (5)].node), (yylsp[(2) - (5)]));
				}
    break;

  case 1666:
/* Line 1787 of yacc.c  */
#line 11021 "gram.y"
    {
					(yyval.node) = (Node *) makeA_Expr(AEXPR_NOT, NIL, NULL,
									(Node *) makeSimpleA_Expr(AEXPR_DISTINCT,
															  "=", (yyvsp[(1) - (6)].node), (yyvsp[(6) - (6)].node), (yylsp[(2) - (6)])),
											 (yylsp[(2) - (6)]));

				}
    break;

  case 1667:
/* Line 1787 of yacc.c  */
#line 11029 "gram.y"
    {
					(yyval.node) = (Node *) makeSimpleA_Expr(AEXPR_OF, "=", (yyvsp[(1) - (6)].node), (Node *) (yyvsp[(5) - (6)].list), (yylsp[(2) - (6)]));
				}
    break;

  case 1668:
/* Line 1787 of yacc.c  */
#line 11033 "gram.y"
    {
					(yyval.node) = (Node *) makeSimpleA_Expr(AEXPR_OF, "<>", (yyvsp[(1) - (7)].node), (Node *) (yyvsp[(6) - (7)].list), (yylsp[(2) - (7)]));
				}
    break;

  case 1669:
/* Line 1787 of yacc.c  */
#line 11043 "gram.y"
    {
					(yyval.node) = (Node *) makeA_Expr(AEXPR_AND, NIL,
						(Node *) makeSimpleA_Expr(AEXPR_OP, ">=", (yyvsp[(1) - (6)].node), (yyvsp[(4) - (6)].node), (yylsp[(2) - (6)])),
						(Node *) makeSimpleA_Expr(AEXPR_OP, "<=", (yyvsp[(1) - (6)].node), (yyvsp[(6) - (6)].node), (yylsp[(2) - (6)])),
											 (yylsp[(2) - (6)]));
				}
    break;

  case 1670:
/* Line 1787 of yacc.c  */
#line 11050 "gram.y"
    {
					(yyval.node) = (Node *) makeA_Expr(AEXPR_OR, NIL,
						(Node *) makeSimpleA_Expr(AEXPR_OP, "<", (yyvsp[(1) - (7)].node), (yyvsp[(5) - (7)].node), (yylsp[(2) - (7)])),
						(Node *) makeSimpleA_Expr(AEXPR_OP, ">", (yyvsp[(1) - (7)].node), (yyvsp[(7) - (7)].node), (yylsp[(2) - (7)])),
											 (yylsp[(2) - (7)]));
				}
    break;

  case 1671:
/* Line 1787 of yacc.c  */
#line 11057 "gram.y"
    {
					(yyval.node) = (Node *) makeA_Expr(AEXPR_OR, NIL,
						(Node *) makeA_Expr(AEXPR_AND, NIL,
							(Node *) makeSimpleA_Expr(AEXPR_OP, ">=", (yyvsp[(1) - (6)].node), (yyvsp[(4) - (6)].node), (yylsp[(2) - (6)])),
							(Node *) makeSimpleA_Expr(AEXPR_OP, "<=", (yyvsp[(1) - (6)].node), (yyvsp[(6) - (6)].node), (yylsp[(2) - (6)])),
											(yylsp[(2) - (6)])),
						(Node *) makeA_Expr(AEXPR_AND, NIL,
							(Node *) makeSimpleA_Expr(AEXPR_OP, ">=", (yyvsp[(1) - (6)].node), (yyvsp[(6) - (6)].node), (yylsp[(2) - (6)])),
							(Node *) makeSimpleA_Expr(AEXPR_OP, "<=", (yyvsp[(1) - (6)].node), (yyvsp[(4) - (6)].node), (yylsp[(2) - (6)])),
											(yylsp[(2) - (6)])),
											 (yylsp[(2) - (6)]));
				}
    break;

  case 1672:
/* Line 1787 of yacc.c  */
#line 11070 "gram.y"
    {
					(yyval.node) = (Node *) makeA_Expr(AEXPR_AND, NIL,
						(Node *) makeA_Expr(AEXPR_OR, NIL,
							(Node *) makeSimpleA_Expr(AEXPR_OP, "<", (yyvsp[(1) - (7)].node), (yyvsp[(5) - (7)].node), (yylsp[(2) - (7)])),
							(Node *) makeSimpleA_Expr(AEXPR_OP, ">", (yyvsp[(1) - (7)].node), (yyvsp[(7) - (7)].node), (yylsp[(2) - (7)])),
											(yylsp[(2) - (7)])),
						(Node *) makeA_Expr(AEXPR_OR, NIL,
							(Node *) makeSimpleA_Expr(AEXPR_OP, "<", (yyvsp[(1) - (7)].node), (yyvsp[(7) - (7)].node), (yylsp[(2) - (7)])),
							(Node *) makeSimpleA_Expr(AEXPR_OP, ">", (yyvsp[(1) - (7)].node), (yyvsp[(5) - (7)].node), (yylsp[(2) - (7)])),
											(yylsp[(2) - (7)])),
											 (yylsp[(2) - (7)]));
				}
    break;

  case 1673:
/* Line 1787 of yacc.c  */
#line 11083 "gram.y"
    {
					/* in_expr returns a SubLink or a list of a_exprs */
					if (IsA((yyvsp[(3) - (3)].node), SubLink))
					{
						/* generate foo = ANY (subquery) */
						SubLink *n = (SubLink *) (yyvsp[(3) - (3)].node);
						n->subLinkType = ANY_SUBLINK;
						n->testexpr = (yyvsp[(1) - (3)].node);
						n->operName = list_make1(makeString("="));
						n->location = (yylsp[(2) - (3)]);
						(yyval.node) = (Node *)n;
					}
					else
					{
						/* generate scalar IN expression */
						(yyval.node) = (Node *) makeSimpleA_Expr(AEXPR_IN, "=", (yyvsp[(1) - (3)].node), (yyvsp[(3) - (3)].node), (yylsp[(2) - (3)]));
					}
				}
    break;

  case 1674:
/* Line 1787 of yacc.c  */
#line 11102 "gram.y"
    {
					/* in_expr returns a SubLink or a list of a_exprs */
					if (IsA((yyvsp[(4) - (4)].node), SubLink))
					{
						/* generate NOT (foo = ANY (subquery)) */
						/* Make an = ANY node */
						SubLink *n = (SubLink *) (yyvsp[(4) - (4)].node);
						n->subLinkType = ANY_SUBLINK;
						n->testexpr = (yyvsp[(1) - (4)].node);
						n->operName = list_make1(makeString("="));
						n->location = (yylsp[(3) - (4)]);
						/* Stick a NOT on top */
						(yyval.node) = (Node *) makeA_Expr(AEXPR_NOT, NIL, NULL, (Node *) n, (yylsp[(2) - (4)]));
					}
					else
					{
						/* generate scalar NOT IN expression */
						(yyval.node) = (Node *) makeSimpleA_Expr(AEXPR_IN, "<>", (yyvsp[(1) - (4)].node), (yyvsp[(4) - (4)].node), (yylsp[(2) - (4)]));
					}
				}
    break;

  case 1675:
/* Line 1787 of yacc.c  */
#line 11123 "gram.y"
    {
					SubLink *n = makeNode(SubLink);
					n->subLinkType = (yyvsp[(3) - (4)].ival);
					n->testexpr = (yyvsp[(1) - (4)].node);
					n->operName = (yyvsp[(2) - (4)].list);
					n->subselect = (yyvsp[(4) - (4)].node);
					n->location = (yylsp[(2) - (4)]);
					(yyval.node) = (Node *)n;
				}
    break;

  case 1676:
/* Line 1787 of yacc.c  */
#line 11133 "gram.y"
    {
					if ((yyvsp[(3) - (6)].ival) == ANY_SUBLINK)
						(yyval.node) = (Node *) makeA_Expr(AEXPR_OP_ANY, (yyvsp[(2) - (6)].list), (yyvsp[(1) - (6)].node), (yyvsp[(5) - (6)].node), (yylsp[(2) - (6)]));
					else
						(yyval.node) = (Node *) makeA_Expr(AEXPR_OP_ALL, (yyvsp[(2) - (6)].list), (yyvsp[(1) - (6)].node), (yyvsp[(5) - (6)].node), (yylsp[(2) - (6)]));
				}
    break;

  case 1677:
/* Line 1787 of yacc.c  */
#line 11140 "gram.y"
    {
					/* Not sure how to get rid of the parentheses
					 * but there are lots of shift/reduce errors without them.
					 *
					 * Should be able to implement this by plopping the entire
					 * select into a node, then transforming the target expressions
					 * from whatever they are into count(*), and testing the
					 * entire result equal to one.
					 * But, will probably implement a separate node in the executor.
					 */
					ereport(ERROR,
							(errcode(ERRCODE_FEATURE_NOT_SUPPORTED),
							 errmsg("UNIQUE predicate is not yet implemented"),
							 parser_errposition((yylsp[(1) - (2)]))));
				}
    break;

  case 1678:
/* Line 1787 of yacc.c  */
#line 11156 "gram.y"
    {
					(yyval.node) = makeXmlExpr(IS_DOCUMENT, NULL, NIL,
									 list_make1((yyvsp[(1) - (3)].node)), (yylsp[(2) - (3)]));
				}
    break;

  case 1679:
/* Line 1787 of yacc.c  */
#line 11161 "gram.y"
    {
					(yyval.node) = (Node *) makeA_Expr(AEXPR_NOT, NIL, NULL,
											 makeXmlExpr(IS_DOCUMENT, NULL, NIL,
														 list_make1((yyvsp[(1) - (4)].node)), (yylsp[(2) - (4)])),
											 (yylsp[(2) - (4)]));
				}
    break;

  case 1680:
/* Line 1787 of yacc.c  */
#line 11179 "gram.y"
    { (yyval.node) = (yyvsp[(1) - (1)].node); }
    break;

  case 1681:
/* Line 1787 of yacc.c  */
#line 11181 "gram.y"
    { (yyval.node) = makeTypeCast((yyvsp[(1) - (3)].node), (yyvsp[(3) - (3)].typnam), (yylsp[(2) - (3)])); }
    break;

  case 1682:
/* Line 1787 of yacc.c  */
#line 11183 "gram.y"
    { (yyval.node) = (Node *) makeSimpleA_Expr(AEXPR_OP, "+", NULL, (yyvsp[(2) - (2)].node), (yylsp[(1) - (2)])); }
    break;

  case 1683:
/* Line 1787 of yacc.c  */
#line 11185 "gram.y"
    { (yyval.node) = doNegate((yyvsp[(2) - (2)].node), (yylsp[(1) - (2)])); }
    break;

  case 1684:
/* Line 1787 of yacc.c  */
#line 11187 "gram.y"
    { (yyval.node) = (Node *) makeSimpleA_Expr(AEXPR_OP, "+", (yyvsp[(1) - (3)].node), (yyvsp[(3) - (3)].node), (yylsp[(2) - (3)])); }
    break;

  case 1685:
/* Line 1787 of yacc.c  */
#line 11189 "gram.y"
    { (yyval.node) = (Node *) makeSimpleA_Expr(AEXPR_OP, "-", (yyvsp[(1) - (3)].node), (yyvsp[(3) - (3)].node), (yylsp[(2) - (3)])); }
    break;

  case 1686:
/* Line 1787 of yacc.c  */
#line 11191 "gram.y"
    { (yyval.node) = (Node *) makeSimpleA_Expr(AEXPR_OP, "*", (yyvsp[(1) - (3)].node), (yyvsp[(3) - (3)].node), (yylsp[(2) - (3)])); }
    break;

  case 1687:
/* Line 1787 of yacc.c  */
#line 11193 "gram.y"
    { (yyval.node) = (Node *) makeSimpleA_Expr(AEXPR_OP, "/", (yyvsp[(1) - (3)].node), (yyvsp[(3) - (3)].node), (yylsp[(2) - (3)])); }
    break;

  case 1688:
/* Line 1787 of yacc.c  */
#line 11195 "gram.y"
    { (yyval.node) = (Node *) makeSimpleA_Expr(AEXPR_OP, "%", (yyvsp[(1) - (3)].node), (yyvsp[(3) - (3)].node), (yylsp[(2) - (3)])); }
    break;

  case 1689:
/* Line 1787 of yacc.c  */
#line 11197 "gram.y"
    { (yyval.node) = (Node *) makeSimpleA_Expr(AEXPR_OP, "^", (yyvsp[(1) - (3)].node), (yyvsp[(3) - (3)].node), (yylsp[(2) - (3)])); }
    break;

  case 1690:
/* Line 1787 of yacc.c  */
#line 11199 "gram.y"
    { (yyval.node) = (Node *) makeSimpleA_Expr(AEXPR_OP, "<", (yyvsp[(1) - (3)].node), (yyvsp[(3) - (3)].node), (yylsp[(2) - (3)])); }
    break;

  case 1691:
/* Line 1787 of yacc.c  */
#line 11201 "gram.y"
    { (yyval.node) = (Node *) makeSimpleA_Expr(AEXPR_OP, ">", (yyvsp[(1) - (3)].node), (yyvsp[(3) - (3)].node), (yylsp[(2) - (3)])); }
    break;

  case 1692:
/* Line 1787 of yacc.c  */
#line 11203 "gram.y"
    { (yyval.node) = (Node *) makeSimpleA_Expr(AEXPR_OP, "=", (yyvsp[(1) - (3)].node), (yyvsp[(3) - (3)].node), (yylsp[(2) - (3)])); }
    break;

  case 1693:
/* Line 1787 of yacc.c  */
#line 11205 "gram.y"
    { (yyval.node) = (Node *) makeA_Expr(AEXPR_OP, (yyvsp[(2) - (3)].list), (yyvsp[(1) - (3)].node), (yyvsp[(3) - (3)].node), (yylsp[(2) - (3)])); }
    break;

  case 1694:
/* Line 1787 of yacc.c  */
#line 11207 "gram.y"
    { (yyval.node) = (Node *) makeA_Expr(AEXPR_OP, (yyvsp[(1) - (2)].list), NULL, (yyvsp[(2) - (2)].node), (yylsp[(1) - (2)])); }
    break;

  case 1695:
/* Line 1787 of yacc.c  */
#line 11209 "gram.y"
    { (yyval.node) = (Node *) makeA_Expr(AEXPR_OP, (yyvsp[(2) - (2)].list), (yyvsp[(1) - (2)].node), NULL, (yylsp[(2) - (2)])); }
    break;

  case 1696:
/* Line 1787 of yacc.c  */
#line 11211 "gram.y"
    {
					(yyval.node) = (Node *) makeSimpleA_Expr(AEXPR_DISTINCT, "=", (yyvsp[(1) - (5)].node), (yyvsp[(5) - (5)].node), (yylsp[(2) - (5)]));
				}
    break;

  case 1697:
/* Line 1787 of yacc.c  */
#line 11215 "gram.y"
    {
					(yyval.node) = (Node *) makeA_Expr(AEXPR_NOT, NIL,
						NULL, (Node *) makeSimpleA_Expr(AEXPR_DISTINCT, "=", (yyvsp[(1) - (6)].node), (yyvsp[(6) - (6)].node), (yylsp[(2) - (6)])), (yylsp[(2) - (6)]));
				}
    break;

  case 1698:
/* Line 1787 of yacc.c  */
#line 11220 "gram.y"
    {
					(yyval.node) = (Node *) makeSimpleA_Expr(AEXPR_OF, "=", (yyvsp[(1) - (6)].node), (Node *) (yyvsp[(5) - (6)].list), (yylsp[(2) - (6)]));
				}
    break;

  case 1699:
/* Line 1787 of yacc.c  */
#line 11224 "gram.y"
    {
					(yyval.node) = (Node *) makeSimpleA_Expr(AEXPR_OF, "<>", (yyvsp[(1) - (7)].node), (Node *) (yyvsp[(6) - (7)].list), (yylsp[(2) - (7)]));
				}
    break;

  case 1700:
/* Line 1787 of yacc.c  */
#line 11228 "gram.y"
    {
					(yyval.node) = makeXmlExpr(IS_DOCUMENT, NULL, NIL,
									 list_make1((yyvsp[(1) - (3)].node)), (yylsp[(2) - (3)]));
				}
    break;

  case 1701:
/* Line 1787 of yacc.c  */
#line 11233 "gram.y"
    {
					(yyval.node) = (Node *) makeA_Expr(AEXPR_NOT, NIL, NULL,
											 makeXmlExpr(IS_DOCUMENT, NULL, NIL,
														 list_make1((yyvsp[(1) - (4)].node)), (yylsp[(2) - (4)])),
											 (yylsp[(2) - (4)]));
				}
    break;

  case 1702:
/* Line 1787 of yacc.c  */
#line 11249 "gram.y"
    { (yyval.node) = (yyvsp[(1) - (1)].node); }
    break;

  case 1703:
/* Line 1787 of yacc.c  */
#line 11250 "gram.y"
    { (yyval.node) = (yyvsp[(1) - (1)].node); }
    break;

  case 1704:
/* Line 1787 of yacc.c  */
#line 11252 "gram.y"
    {
					ParamRef *p = makeNode(ParamRef);
					p->number = (yyvsp[(1) - (2)].ival);
					p->location = (yylsp[(1) - (2)]);
					if ((yyvsp[(2) - (2)].list))
					{
						A_Indirection *n = makeNode(A_Indirection);
						n->arg = (Node *) p;
						n->indirection = check_indirection((yyvsp[(2) - (2)].list), yyscanner);
						(yyval.node) = (Node *) n;
					}
					else
						(yyval.node) = (Node *) p;
				}
    break;

  case 1705:
/* Line 1787 of yacc.c  */
#line 11267 "gram.y"
    {
					if ((yyvsp[(4) - (4)].list))
					{
						A_Indirection *n = makeNode(A_Indirection);
						n->arg = (yyvsp[(2) - (4)].node);
						n->indirection = check_indirection((yyvsp[(4) - (4)].list), yyscanner);
						(yyval.node) = (Node *)n;
					}
					else
						(yyval.node) = (yyvsp[(2) - (4)].node);
				}
    break;

  case 1706:
/* Line 1787 of yacc.c  */
#line 11279 "gram.y"
    { (yyval.node) = (yyvsp[(1) - (1)].node); }
    break;

  case 1707:
/* Line 1787 of yacc.c  */
#line 11281 "gram.y"
    { (yyval.node) = (yyvsp[(1) - (1)].node); }
    break;

  case 1708:
/* Line 1787 of yacc.c  */
#line 11283 "gram.y"
    {
					SubLink *n = makeNode(SubLink);
					n->subLinkType = EXPR_SUBLINK;
					n->testexpr = NULL;
					n->operName = NIL;
					n->subselect = (yyvsp[(1) - (1)].node);
					n->location = (yylsp[(1) - (1)]);
					(yyval.node) = (Node *)n;
				}
    break;

  case 1709:
/* Line 1787 of yacc.c  */
#line 11293 "gram.y"
    {
					/*
					 * Because the select_with_parens nonterminal is designed
					 * to "eat" as many levels of parens as possible, the
					 * '(' a_expr ')' opt_indirection production above will
					 * fail to match a sub-SELECT with indirection decoration;
					 * the sub-SELECT won't be regarded as an a_expr as long
					 * as there are parens around it.  To support applying
					 * subscripting or field selection to a sub-SELECT result,
					 * we need this redundant-looking production.
					 */
					SubLink *n = makeNode(SubLink);
					A_Indirection *a = makeNode(A_Indirection);
					n->subLinkType = EXPR_SUBLINK;
					n->testexpr = NULL;
					n->operName = NIL;
					n->subselect = (yyvsp[(1) - (2)].node);
					n->location = (yylsp[(1) - (2)]);
					a->arg = (Node *)n;
					a->indirection = check_indirection((yyvsp[(2) - (2)].list), yyscanner);
					(yyval.node) = (Node *)a;
				}
    break;

  case 1710:
/* Line 1787 of yacc.c  */
#line 11316 "gram.y"
    {
					SubLink *n = makeNode(SubLink);
					n->subLinkType = EXISTS_SUBLINK;
					n->testexpr = NULL;
					n->operName = NIL;
					n->subselect = (yyvsp[(2) - (2)].node);
					n->location = (yylsp[(1) - (2)]);
					(yyval.node) = (Node *)n;
				}
    break;

  case 1711:
/* Line 1787 of yacc.c  */
#line 11326 "gram.y"
    {
					SubLink *n = makeNode(SubLink);
					n->subLinkType = ARRAY_SUBLINK;
					n->testexpr = NULL;
					n->operName = NIL;
					n->subselect = (yyvsp[(2) - (2)].node);
					n->location = (yylsp[(1) - (2)]);
					(yyval.node) = (Node *)n;
				}
    break;

  case 1712:
/* Line 1787 of yacc.c  */
#line 11336 "gram.y"
    {
					A_ArrayExpr *n = (A_ArrayExpr *) (yyvsp[(2) - (2)].node);
					Assert(IsA(n, A_ArrayExpr));
					/* point outermost A_ArrayExpr to the ARRAY keyword */
					n->location = (yylsp[(1) - (2)]);
					(yyval.node) = (Node *)n;
				}
    break;

  case 1713:
/* Line 1787 of yacc.c  */
#line 11344 "gram.y"
    {
					RowExpr *r = makeNode(RowExpr);
					r->args = (yyvsp[(1) - (1)].list);
					r->row_typeid = InvalidOid;	/* not analyzed yet */
					r->colnames = NIL;	/* to be filled in during analysis */
					r->location = (yylsp[(1) - (1)]);
					(yyval.node) = (Node *)r;
				}
    break;

  case 1714:
/* Line 1787 of yacc.c  */
#line 11355 "gram.y"
    {
					(yyval.node) = (Node *) makeFuncCall((yyvsp[(1) - (3)].list), NIL, (yylsp[(1) - (3)]));
				}
    break;

  case 1715:
/* Line 1787 of yacc.c  */
#line 11359 "gram.y"
    {
					FuncCall *n = makeFuncCall((yyvsp[(1) - (5)].list), (yyvsp[(3) - (5)].list), (yylsp[(1) - (5)]));
					n->agg_order = (yyvsp[(4) - (5)].list);
					(yyval.node) = (Node *)n;
				}
    break;

  case 1716:
/* Line 1787 of yacc.c  */
#line 11365 "gram.y"
    {
					FuncCall *n = makeFuncCall((yyvsp[(1) - (6)].list), list_make1((yyvsp[(4) - (6)].node)), (yylsp[(1) - (6)]));
					n->func_variadic = TRUE;
					n->agg_order = (yyvsp[(5) - (6)].list);
					(yyval.node) = (Node *)n;
				}
    break;

  case 1717:
/* Line 1787 of yacc.c  */
#line 11372 "gram.y"
    {
					FuncCall *n = makeFuncCall((yyvsp[(1) - (8)].list), lappend((yyvsp[(3) - (8)].list), (yyvsp[(6) - (8)].node)), (yylsp[(1) - (8)]));
					n->func_variadic = TRUE;
					n->agg_order = (yyvsp[(7) - (8)].list);
					(yyval.node) = (Node *)n;
				}
    break;

  case 1718:
/* Line 1787 of yacc.c  */
#line 11379 "gram.y"
    {
					FuncCall *n = makeFuncCall((yyvsp[(1) - (6)].list), (yyvsp[(4) - (6)].list), (yylsp[(1) - (6)]));
					n->agg_order = (yyvsp[(5) - (6)].list);
					/* Ideally we'd mark the FuncCall node to indicate
					 * "must be an aggregate", but there's no provision
					 * for that in FuncCall at the moment.
					 */
					(yyval.node) = (Node *)n;
				}
    break;

  case 1719:
/* Line 1787 of yacc.c  */
#line 11389 "gram.y"
    {
					FuncCall *n = makeFuncCall((yyvsp[(1) - (6)].list), (yyvsp[(4) - (6)].list), (yylsp[(1) - (6)]));
					n->agg_order = (yyvsp[(5) - (6)].list);
					n->agg_distinct = TRUE;
					(yyval.node) = (Node *)n;
				}
    break;

  case 1720:
/* Line 1787 of yacc.c  */
#line 11396 "gram.y"
    {
					/*
					 * We consider AGGREGATE(*) to invoke a parameterless
					 * aggregate.  This does the right thing for COUNT(*),
					 * and there are no other aggregates in SQL that accept
					 * '*' as parameter.
					 *
					 * The FuncCall node is also marked agg_star = true,
					 * so that later processing can detect what the argument
					 * really was.
					 */
					FuncCall *n = makeFuncCall((yyvsp[(1) - (4)].list), NIL, (yylsp[(1) - (4)]));
					n->agg_star = TRUE;
					(yyval.node) = (Node *)n;
				}
    break;

  case 1721:
/* Line 1787 of yacc.c  */
#line 11424 "gram.y"
    {
					FuncCall *n = (FuncCall *) (yyvsp[(1) - (4)].node);
					/*
					 * The order clause for WITHIN GROUP and the one for
					 * plain-aggregate ORDER BY share a field, so we have to
					 * check here that at most one is present.  We also check
					 * for DISTINCT and VARIADIC here to give a better error
					 * location.  Other consistency checks are deferred to
					 * parse analysis.
					 */
					if ((yyvsp[(2) - (4)].list) != NIL)
					{
						if (n->agg_order != NIL)
							ereport(ERROR,
									(errcode(ERRCODE_SYNTAX_ERROR),
									 errmsg("cannot use multiple ORDER BY clauses with WITHIN GROUP"),
									 parser_errposition((yylsp[(2) - (4)]))));
						if (n->agg_distinct)
							ereport(ERROR,
									(errcode(ERRCODE_SYNTAX_ERROR),
									 errmsg("cannot use DISTINCT with WITHIN GROUP"),
									 parser_errposition((yylsp[(2) - (4)]))));
						if (n->func_variadic)
							ereport(ERROR,
									(errcode(ERRCODE_SYNTAX_ERROR),
									 errmsg("cannot use VARIADIC with WITHIN GROUP"),
									 parser_errposition((yylsp[(2) - (4)]))));
						n->agg_order = (yyvsp[(2) - (4)].list);
						n->agg_within_group = TRUE;
					}
					n->agg_filter = (yyvsp[(3) - (4)].node);
					n->over = (yyvsp[(4) - (4)].windef);
					(yyval.node) = (Node *) n;
				}
    break;

  case 1722:
/* Line 1787 of yacc.c  */
#line 11459 "gram.y"
    { (yyval.node) = (yyvsp[(1) - (1)].node); }
    break;

  case 1723:
/* Line 1787 of yacc.c  */
#line 11469 "gram.y"
    { (yyval.node) = (yyvsp[(1) - (1)].node); }
    break;

  case 1724:
/* Line 1787 of yacc.c  */
#line 11470 "gram.y"
    { (yyval.node) = (yyvsp[(1) - (1)].node); }
    break;

  case 1725:
/* Line 1787 of yacc.c  */
#line 11478 "gram.y"
    {
					(yyval.node) = (Node *) makeFuncCall(SystemFuncName("pg_collation_for"),
											   list_make1((yyvsp[(4) - (5)].node)),
											   (yylsp[(1) - (5)]));
				}
    break;

  case 1726:
/* Line 1787 of yacc.c  */
#line 11484 "gram.y"
    {
					/*
					 * Translate as "'now'::text::date".
					 *
					 * We cannot use "'now'::date" because coerce_type() will
					 * immediately reduce that to a constant representing
					 * today's date.  We need to delay the conversion until
					 * runtime, else the wrong things will happen when
					 * CURRENT_DATE is used in a column default value or rule.
					 *
					 * This could be simplified if we had a way to generate
					 * an expression tree representing runtime application
					 * of type-input conversion functions.  (As of PG 7.3
					 * that is actually possible, but not clear that we want
					 * to rely on it.)
					 *
					 * The token location is attached to the run-time
					 * typecast, not to the Const, for the convenience of
					 * pg_stat_statements (which doesn't want these constructs
					 * to appear to be replaceable constants).
					 */
					Node *n;
					n = makeStringConstCast("now", -1, SystemTypeName("text"));
					(yyval.node) = makeTypeCast(n, SystemTypeName("date"), (yylsp[(1) - (1)]));
				}
    break;

  case 1727:
/* Line 1787 of yacc.c  */
#line 11510 "gram.y"
    {
					/*
					 * Translate as "'now'::text::timetz".
					 * See comments for CURRENT_DATE.
					 */
					Node *n;
					n = makeStringConstCast("now", -1, SystemTypeName("text"));
					(yyval.node) = makeTypeCast(n, SystemTypeName("timetz"), (yylsp[(1) - (1)]));
				}
    break;

  case 1728:
/* Line 1787 of yacc.c  */
#line 11520 "gram.y"
    {
					/*
					 * Translate as "'now'::text::timetz(n)".
					 * See comments for CURRENT_DATE.
					 */
					Node *n;
					TypeName *d;
					n = makeStringConstCast("now", -1, SystemTypeName("text"));
					d = SystemTypeName("timetz");
					d->typmods = list_make1(makeIntConst((yyvsp[(3) - (4)].ival), (yylsp[(3) - (4)])));
					(yyval.node) = makeTypeCast(n, d, (yylsp[(1) - (4)]));
				}
    break;

  case 1729:
/* Line 1787 of yacc.c  */
#line 11533 "gram.y"
    {
					/*
					 * Translate as "now()", since we have a function that
					 * does exactly what is needed.
					 */
					(yyval.node) = (Node *) makeFuncCall(SystemFuncName("now"), NIL, (yylsp[(1) - (1)]));
				}
    break;

  case 1730:
/* Line 1787 of yacc.c  */
#line 11541 "gram.y"
    {
					/*
					 * Translate as "'now'::text::timestamptz(n)".
					 * See comments for CURRENT_DATE.
					 */
					Node *n;
					TypeName *d;
					n = makeStringConstCast("now", -1, SystemTypeName("text"));
					d = SystemTypeName("timestamptz");
					d->typmods = list_make1(makeIntConst((yyvsp[(3) - (4)].ival), (yylsp[(3) - (4)])));
					(yyval.node) = makeTypeCast(n, d, (yylsp[(1) - (4)]));
				}
    break;

  case 1731:
/* Line 1787 of yacc.c  */
#line 11554 "gram.y"
    {
					/*
					 * Translate as "'now'::text::time".
					 * See comments for CURRENT_DATE.
					 */
					Node *n;
					n = makeStringConstCast("now", -1, SystemTypeName("text"));
					(yyval.node) = makeTypeCast((Node *)n, SystemTypeName("time"), (yylsp[(1) - (1)]));
				}
    break;

  case 1732:
/* Line 1787 of yacc.c  */
#line 11564 "gram.y"
    {
					/*
					 * Translate as "'now'::text::time(n)".
					 * See comments for CURRENT_DATE.
					 */
					Node *n;
					TypeName *d;
					n = makeStringConstCast("now", -1, SystemTypeName("text"));
					d = SystemTypeName("time");
					d->typmods = list_make1(makeIntConst((yyvsp[(3) - (4)].ival), (yylsp[(3) - (4)])));
					(yyval.node) = makeTypeCast((Node *)n, d, (yylsp[(1) - (4)]));
				}
    break;

  case 1733:
/* Line 1787 of yacc.c  */
#line 11577 "gram.y"
    {
					/*
					 * Translate as "'now'::text::timestamp".
					 * See comments for CURRENT_DATE.
					 */
					Node *n;
					n = makeStringConstCast("now", -1, SystemTypeName("text"));
					(yyval.node) = makeTypeCast(n, SystemTypeName("timestamp"), (yylsp[(1) - (1)]));
				}
    break;

  case 1734:
/* Line 1787 of yacc.c  */
#line 11587 "gram.y"
    {
					/*
					 * Translate as "'now'::text::timestamp(n)".
					 * See comments for CURRENT_DATE.
					 */
					Node *n;
					TypeName *d;
					n = makeStringConstCast("now", -1, SystemTypeName("text"));
					d = SystemTypeName("timestamp");
					d->typmods = list_make1(makeIntConst((yyvsp[(3) - (4)].ival), (yylsp[(3) - (4)])));
					(yyval.node) = makeTypeCast(n, d, (yylsp[(1) - (4)]));
				}
    break;

  case 1735:
/* Line 1787 of yacc.c  */
#line 11600 "gram.y"
    {
					(yyval.node) = (Node *) makeFuncCall(SystemFuncName("current_user"), NIL, (yylsp[(1) - (1)]));
				}
    break;

  case 1736:
/* Line 1787 of yacc.c  */
#line 11604 "gram.y"
    {
					(yyval.node) = (Node *) makeFuncCall(SystemFuncName("current_user"), NIL, (yylsp[(1) - (1)]));
				}
    break;

  case 1737:
/* Line 1787 of yacc.c  */
#line 11608 "gram.y"
    {
					(yyval.node) = (Node *) makeFuncCall(SystemFuncName("session_user"), NIL, (yylsp[(1) - (1)]));
				}
    break;

  case 1738:
/* Line 1787 of yacc.c  */
#line 11612 "gram.y"
    {
					(yyval.node) = (Node *) makeFuncCall(SystemFuncName("current_user"), NIL, (yylsp[(1) - (1)]));
				}
    break;

  case 1739:
/* Line 1787 of yacc.c  */
#line 11616 "gram.y"
    {
					(yyval.node) = (Node *) makeFuncCall(SystemFuncName("current_database"), NIL, (yylsp[(1) - (1)]));
				}
    break;

  case 1740:
/* Line 1787 of yacc.c  */
#line 11620 "gram.y"
    {
					(yyval.node) = (Node *) makeFuncCall(SystemFuncName("current_schema"), NIL, (yylsp[(1) - (1)]));
				}
    break;

  case 1741:
/* Line 1787 of yacc.c  */
#line 11624 "gram.y"
    { (yyval.node) = makeTypeCast((yyvsp[(3) - (6)].node), (yyvsp[(5) - (6)].typnam), (yylsp[(1) - (6)])); }
    break;

  case 1742:
/* Line 1787 of yacc.c  */
#line 11626 "gram.y"
    {
					(yyval.node) = (Node *) makeFuncCall(SystemFuncName("date_part"), (yyvsp[(3) - (4)].list), (yylsp[(1) - (4)]));
				}
    break;

  case 1743:
/* Line 1787 of yacc.c  */
#line 11630 "gram.y"
    {
					/* overlay(A PLACING B FROM C FOR D) is converted to
					 * overlay(A, B, C, D)
					 * overlay(A PLACING B FROM C) is converted to
					 * overlay(A, B, C)
					 */
					(yyval.node) = (Node *) makeFuncCall(SystemFuncName("overlay"), (yyvsp[(3) - (4)].list), (yylsp[(1) - (4)]));
				}
    break;

  case 1744:
/* Line 1787 of yacc.c  */
#line 11639 "gram.y"
    {
					/* position(A in B) is converted to position(B, A) */
					(yyval.node) = (Node *) makeFuncCall(SystemFuncName("position"), (yyvsp[(3) - (4)].list), (yylsp[(1) - (4)]));
				}
    break;

  case 1745:
/* Line 1787 of yacc.c  */
#line 11644 "gram.y"
    {
					/* substring(A from B for C) is converted to
					 * substring(A, B, C) - thomas 2000-11-28
					 */
					(yyval.node) = (Node *) makeFuncCall(SystemFuncName("substring"), (yyvsp[(3) - (4)].list), (yylsp[(1) - (4)]));
				}
    break;

  case 1746:
/* Line 1787 of yacc.c  */
#line 11651 "gram.y"
    {
					/* TREAT(expr AS target) converts expr of a particular type to target,
					 * which is defined to be a subtype of the original expression.
					 * In SQL99, this is intended for use with structured UDTs,
					 * but let's make this a generally useful form allowing stronger
					 * coercions than are handled by implicit casting.
					 *
					 * Convert SystemTypeName() to SystemFuncName() even though
					 * at the moment they result in the same thing.
					 */
					(yyval.node) = (Node *) makeFuncCall(SystemFuncName(((Value *)llast((yyvsp[(5) - (6)].typnam)->names))->val.str),
												list_make1((yyvsp[(3) - (6)].node)),
												(yylsp[(1) - (6)]));
				}
    break;

  case 1747:
/* Line 1787 of yacc.c  */
#line 11666 "gram.y"
    {
					/* various trim expressions are defined in SQL
					 * - thomas 1997-07-19
					 */
					(yyval.node) = (Node *) makeFuncCall(SystemFuncName("btrim"), (yyvsp[(4) - (5)].list), (yylsp[(1) - (5)]));
				}
    break;

  case 1748:
/* Line 1787 of yacc.c  */
#line 11673 "gram.y"
    {
					(yyval.node) = (Node *) makeFuncCall(SystemFuncName("ltrim"), (yyvsp[(4) - (5)].list), (yylsp[(1) - (5)]));
				}
    break;

  case 1749:
/* Line 1787 of yacc.c  */
#line 11677 "gram.y"
    {
					(yyval.node) = (Node *) makeFuncCall(SystemFuncName("rtrim"), (yyvsp[(4) - (5)].list), (yylsp[(1) - (5)]));
				}
    break;

  case 1750:
/* Line 1787 of yacc.c  */
#line 11681 "gram.y"
    {
					(yyval.node) = (Node *) makeFuncCall(SystemFuncName("btrim"), (yyvsp[(3) - (4)].list), (yylsp[(1) - (4)]));
				}
    break;

  case 1751:
/* Line 1787 of yacc.c  */
#line 11685 "gram.y"
    {
					(yyval.node) = (Node *) makeSimpleA_Expr(AEXPR_NULLIF, "=", (yyvsp[(3) - (6)].node), (yyvsp[(5) - (6)].node), (yylsp[(1) - (6)]));
				}
    break;

  case 1752:
/* Line 1787 of yacc.c  */
#line 11689 "gram.y"
    {
					CoalesceExpr *c = makeNode(CoalesceExpr);
					c->args = (yyvsp[(3) - (4)].list);
					c->location = (yylsp[(1) - (4)]);
					(yyval.node) = (Node *)c;
				}
    break;

  case 1753:
/* Line 1787 of yacc.c  */
#line 11696 "gram.y"
    {
					MinMaxExpr *v = makeNode(MinMaxExpr);
					v->args = (yyvsp[(3) - (4)].list);
					v->op = IS_GREATEST;
					v->location = (yylsp[(1) - (4)]);
					(yyval.node) = (Node *)v;
				}
    break;

  case 1754:
/* Line 1787 of yacc.c  */
#line 11704 "gram.y"
    {
					MinMaxExpr *v = makeNode(MinMaxExpr);
					v->args = (yyvsp[(3) - (4)].list);
					v->op = IS_LEAST;
					v->location = (yylsp[(1) - (4)]);
					(yyval.node) = (Node *)v;
				}
    break;

  case 1755:
/* Line 1787 of yacc.c  */
#line 11712 "gram.y"
    {
					(yyval.node) = makeXmlExpr(IS_XMLCONCAT, NULL, NIL, (yyvsp[(3) - (4)].list), (yylsp[(1) - (4)]));
				}
    break;

  case 1756:
/* Line 1787 of yacc.c  */
#line 11716 "gram.y"
    {
					(yyval.node) = makeXmlExpr(IS_XMLELEMENT, (yyvsp[(4) - (5)].str), NIL, NIL, (yylsp[(1) - (5)]));
				}
    break;

  case 1757:
/* Line 1787 of yacc.c  */
#line 11720 "gram.y"
    {
					(yyval.node) = makeXmlExpr(IS_XMLELEMENT, (yyvsp[(4) - (7)].str), (yyvsp[(6) - (7)].list), NIL, (yylsp[(1) - (7)]));
				}
    break;

  case 1758:
/* Line 1787 of yacc.c  */
#line 11724 "gram.y"
    {
					(yyval.node) = makeXmlExpr(IS_XMLELEMENT, (yyvsp[(4) - (7)].str), NIL, (yyvsp[(6) - (7)].list), (yylsp[(1) - (7)]));
				}
    break;

  case 1759:
/* Line 1787 of yacc.c  */
#line 11728 "gram.y"
    {
					(yyval.node) = makeXmlExpr(IS_XMLELEMENT, (yyvsp[(4) - (9)].str), (yyvsp[(6) - (9)].list), (yyvsp[(8) - (9)].list), (yylsp[(1) - (9)]));
				}
    break;

  case 1760:
/* Line 1787 of yacc.c  */
#line 11732 "gram.y"
    {
					/* xmlexists(A PASSING [BY REF] B [BY REF]) is
					 * converted to xmlexists(A, B)*/
					(yyval.node) = (Node *) makeFuncCall(SystemFuncName("xmlexists"), list_make2((yyvsp[(3) - (5)].node), (yyvsp[(4) - (5)].node)), (yylsp[(1) - (5)]));
				}
    break;

  case 1761:
/* Line 1787 of yacc.c  */
#line 11738 "gram.y"
    {
					(yyval.node) = makeXmlExpr(IS_XMLFOREST, NULL, (yyvsp[(3) - (4)].list), NIL, (yylsp[(1) - (4)]));
				}
    break;

  case 1762:
/* Line 1787 of yacc.c  */
#line 11742 "gram.y"
    {
					XmlExpr *x = (XmlExpr *)
						makeXmlExpr(IS_XMLPARSE, NULL, NIL,
									list_make2((yyvsp[(4) - (6)].node), makeBoolAConst((yyvsp[(5) - (6)].boolean), -1)),
									(yylsp[(1) - (6)]));
					x->xmloption = (yyvsp[(3) - (6)].ival);
					(yyval.node) = (Node *)x;
				}
    break;

  case 1763:
/* Line 1787 of yacc.c  */
#line 11751 "gram.y"
    {
					(yyval.node) = makeXmlExpr(IS_XMLPI, (yyvsp[(4) - (5)].str), NULL, NIL, (yylsp[(1) - (5)]));
				}
    break;

  case 1764:
/* Line 1787 of yacc.c  */
#line 11755 "gram.y"
    {
					(yyval.node) = makeXmlExpr(IS_XMLPI, (yyvsp[(4) - (7)].str), NULL, list_make1((yyvsp[(6) - (7)].node)), (yylsp[(1) - (7)]));
				}
    break;

  case 1765:
/* Line 1787 of yacc.c  */
#line 11759 "gram.y"
    {
					(yyval.node) = makeXmlExpr(IS_XMLROOT, NULL, NIL,
									 list_make3((yyvsp[(3) - (7)].node), (yyvsp[(5) - (7)].node), (yyvsp[(6) - (7)].node)), (yylsp[(1) - (7)]));
				}
    break;

  case 1766:
/* Line 1787 of yacc.c  */
#line 11764 "gram.y"
    {
					XmlSerialize *n = makeNode(XmlSerialize);
					n->xmloption = (yyvsp[(3) - (7)].ival);
					n->expr = (yyvsp[(4) - (7)].node);
					n->typeName = (yyvsp[(6) - (7)].typnam);
					n->location = (yylsp[(1) - (7)]);
					(yyval.node) = (Node *)n;
				}
    break;

  case 1767:
/* Line 1787 of yacc.c  */
#line 11778 "gram.y"
    { (yyval.node) = (yyvsp[(2) - (2)].node); }
    break;

  case 1768:
/* Line 1787 of yacc.c  */
#line 11780 "gram.y"
    { (yyval.node) = makeNullAConst(-1); }
    break;

  case 1769:
/* Line 1787 of yacc.c  */
#line 11784 "gram.y"
    { (yyval.node) = makeIntConst(XML_STANDALONE_YES, -1); }
    break;

  case 1770:
/* Line 1787 of yacc.c  */
#line 11786 "gram.y"
    { (yyval.node) = makeIntConst(XML_STANDALONE_NO, -1); }
    break;

  case 1771:
/* Line 1787 of yacc.c  */
#line 11788 "gram.y"
    { (yyval.node) = makeIntConst(XML_STANDALONE_NO_VALUE, -1); }
    break;

  case 1772:
/* Line 1787 of yacc.c  */
#line 11790 "gram.y"
    { (yyval.node) = makeIntConst(XML_STANDALONE_OMITTED, -1); }
    break;

  case 1773:
/* Line 1787 of yacc.c  */
#line 11793 "gram.y"
    { (yyval.list) = (yyvsp[(3) - (4)].list); }
    break;

  case 1774:
/* Line 1787 of yacc.c  */
#line 11796 "gram.y"
    { (yyval.list) = list_make1((yyvsp[(1) - (1)].target)); }
    break;

  case 1775:
/* Line 1787 of yacc.c  */
#line 11797 "gram.y"
    { (yyval.list) = lappend((yyvsp[(1) - (3)].list), (yyvsp[(3) - (3)].target)); }
    break;

  case 1776:
/* Line 1787 of yacc.c  */
#line 11801 "gram.y"
    {
					(yyval.target) = makeNode(ResTarget);
					(yyval.target)->name = (yyvsp[(3) - (3)].str);
					(yyval.target)->indirection = NIL;
					(yyval.target)->val = (Node *) (yyvsp[(1) - (3)].node);
					(yyval.target)->location = (yylsp[(1) - (3)]);
				}
    break;

  case 1777:
/* Line 1787 of yacc.c  */
#line 11809 "gram.y"
    {
					(yyval.target) = makeNode(ResTarget);
					(yyval.target)->name = NULL;
					(yyval.target)->indirection = NIL;
					(yyval.target)->val = (Node *) (yyvsp[(1) - (1)].node);
					(yyval.target)->location = (yylsp[(1) - (1)]);
				}
    break;

  case 1778:
/* Line 1787 of yacc.c  */
#line 11818 "gram.y"
    { (yyval.ival) = XMLOPTION_DOCUMENT; }
    break;

  case 1779:
/* Line 1787 of yacc.c  */
#line 11819 "gram.y"
    { (yyval.ival) = XMLOPTION_CONTENT; }
    break;

  case 1780:
/* Line 1787 of yacc.c  */
#line 11822 "gram.y"
    { (yyval.boolean) = TRUE; }
    break;

  case 1781:
/* Line 1787 of yacc.c  */
#line 11823 "gram.y"
    { (yyval.boolean) = FALSE; }
    break;

  case 1782:
/* Line 1787 of yacc.c  */
#line 11824 "gram.y"
    { (yyval.boolean) = FALSE; }
    break;

  case 1783:
/* Line 1787 of yacc.c  */
#line 11830 "gram.y"
    {
					(yyval.node) = (yyvsp[(2) - (2)].node);
				}
    break;

  case 1784:
/* Line 1787 of yacc.c  */
#line 11834 "gram.y"
    {
					(yyval.node) = (yyvsp[(2) - (4)].node);
				}
    break;

  case 1785:
/* Line 1787 of yacc.c  */
#line 11838 "gram.y"
    {
					(yyval.node) = (yyvsp[(4) - (4)].node);
				}
    break;

  case 1786:
/* Line 1787 of yacc.c  */
#line 11842 "gram.y"
    {
					(yyval.node) = (yyvsp[(4) - (6)].node);
				}
    break;

  case 1787:
/* Line 1787 of yacc.c  */
#line 11852 "gram.y"
    { (yyval.list) = (yyvsp[(4) - (5)].list); }
    break;

  case 1788:
/* Line 1787 of yacc.c  */
#line 11853 "gram.y"
    { (yyval.list) = NIL; }
    break;

  case 1789:
/* Line 1787 of yacc.c  */
#line 11857 "gram.y"
    { (yyval.node) = (yyvsp[(4) - (5)].node); }
    break;

  case 1790:
/* Line 1787 of yacc.c  */
#line 11858 "gram.y"
    { (yyval.node) = NULL; }
    break;

  case 1791:
/* Line 1787 of yacc.c  */
#line 11866 "gram.y"
    { (yyval.list) = (yyvsp[(2) - (2)].list); }
    break;

  case 1792:
/* Line 1787 of yacc.c  */
#line 11867 "gram.y"
    { (yyval.list) = NIL; }
    break;

  case 1793:
/* Line 1787 of yacc.c  */
#line 11871 "gram.y"
    { (yyval.list) = list_make1((yyvsp[(1) - (1)].windef)); }
    break;

  case 1794:
/* Line 1787 of yacc.c  */
#line 11873 "gram.y"
    { (yyval.list) = lappend((yyvsp[(1) - (3)].list), (yyvsp[(3) - (3)].windef)); }
    break;

  case 1795:
/* Line 1787 of yacc.c  */
#line 11878 "gram.y"
    {
					WindowDef *n = (yyvsp[(3) - (3)].windef);
					n->name = (yyvsp[(1) - (3)].str);
					(yyval.windef) = n;
				}
    break;

  case 1796:
/* Line 1787 of yacc.c  */
#line 11886 "gram.y"
    { (yyval.windef) = (yyvsp[(2) - (2)].windef); }
    break;

  case 1797:
/* Line 1787 of yacc.c  */
#line 11888 "gram.y"
    {
					WindowDef *n = makeNode(WindowDef);
					n->name = (yyvsp[(2) - (2)].str);
					n->refname = NULL;
					n->partitionClause = NIL;
					n->orderClause = NIL;
					n->frameOptions = FRAMEOPTION_DEFAULTS;
					n->startOffset = NULL;
					n->endOffset = NULL;
					n->location = (yylsp[(2) - (2)]);
					(yyval.windef) = n;
				}
    break;

  case 1798:
/* Line 1787 of yacc.c  */
#line 11901 "gram.y"
    { (yyval.windef) = NULL; }
    break;

  case 1799:
/* Line 1787 of yacc.c  */
#line 11906 "gram.y"
    {
					WindowDef *n = makeNode(WindowDef);
					n->name = NULL;
					n->refname = (yyvsp[(2) - (6)].str);
					n->partitionClause = (yyvsp[(3) - (6)].list);
					n->orderClause = (yyvsp[(4) - (6)].list);
					/* copy relevant fields of opt_frame_clause */
					n->frameOptions = (yyvsp[(5) - (6)].windef)->frameOptions;
					n->startOffset = (yyvsp[(5) - (6)].windef)->startOffset;
					n->endOffset = (yyvsp[(5) - (6)].windef)->endOffset;
					n->location = (yylsp[(1) - (6)]);
					(yyval.windef) = n;
				}
    break;

  case 1800:
/* Line 1787 of yacc.c  */
#line 11931 "gram.y"
    { (yyval.str) = (yyvsp[(1) - (1)].str); }
    break;

  case 1801:
/* Line 1787 of yacc.c  */
#line 11932 "gram.y"
    { (yyval.str) = NULL; }
    break;

  case 1802:
/* Line 1787 of yacc.c  */
#line 11935 "gram.y"
    { (yyval.list) = (yyvsp[(3) - (3)].list); }
    break;

  case 1803:
/* Line 1787 of yacc.c  */
#line 11936 "gram.y"
    { (yyval.list) = NIL; }
    break;

  case 1804:
/* Line 1787 of yacc.c  */
#line 11948 "gram.y"
    {
					WindowDef *n = (yyvsp[(2) - (2)].windef);
					n->frameOptions |= FRAMEOPTION_NONDEFAULT | FRAMEOPTION_RANGE;
					if (n->frameOptions & (FRAMEOPTION_START_VALUE_PRECEDING |
										   FRAMEOPTION_END_VALUE_PRECEDING))
						ereport(ERROR,
								(errcode(ERRCODE_FEATURE_NOT_SUPPORTED),
								 errmsg("RANGE PRECEDING is only supported with UNBOUNDED"),
								 parser_errposition((yylsp[(1) - (2)]))));
					if (n->frameOptions & (FRAMEOPTION_START_VALUE_FOLLOWING |
										   FRAMEOPTION_END_VALUE_FOLLOWING))
						ereport(ERROR,
								(errcode(ERRCODE_FEATURE_NOT_SUPPORTED),
								 errmsg("RANGE FOLLOWING is only supported with UNBOUNDED"),
								 parser_errposition((yylsp[(1) - (2)]))));
					(yyval.windef) = n;
				}
    break;

  case 1805:
/* Line 1787 of yacc.c  */
#line 11966 "gram.y"
    {
					WindowDef *n = (yyvsp[(2) - (2)].windef);
					n->frameOptions |= FRAMEOPTION_NONDEFAULT | FRAMEOPTION_ROWS;
					(yyval.windef) = n;
				}
    break;

  case 1806:
/* Line 1787 of yacc.c  */
#line 11972 "gram.y"
    {
					WindowDef *n = makeNode(WindowDef);
					n->frameOptions = FRAMEOPTION_DEFAULTS;
					n->startOffset = NULL;
					n->endOffset = NULL;
					(yyval.windef) = n;
				}
    break;

  case 1807:
/* Line 1787 of yacc.c  */
#line 11982 "gram.y"
    {
					WindowDef *n = (yyvsp[(1) - (1)].windef);
					/* reject invalid cases */
					if (n->frameOptions & FRAMEOPTION_START_UNBOUNDED_FOLLOWING)
						ereport(ERROR,
								(errcode(ERRCODE_WINDOWING_ERROR),
								 errmsg("frame start cannot be UNBOUNDED FOLLOWING"),
								 parser_errposition((yylsp[(1) - (1)]))));
					if (n->frameOptions & FRAMEOPTION_START_VALUE_FOLLOWING)
						ereport(ERROR,
								(errcode(ERRCODE_WINDOWING_ERROR),
								 errmsg("frame starting from following row cannot end with current row"),
								 parser_errposition((yylsp[(1) - (1)]))));
					n->frameOptions |= FRAMEOPTION_END_CURRENT_ROW;
					(yyval.windef) = n;
				}
    break;

  case 1808:
/* Line 1787 of yacc.c  */
#line 11999 "gram.y"
    {
					WindowDef *n1 = (yyvsp[(2) - (4)].windef);
					WindowDef *n2 = (yyvsp[(4) - (4)].windef);
					/* form merged options */
					int		frameOptions = n1->frameOptions;
					/* shift converts START_ options to END_ options */
					frameOptions |= n2->frameOptions << 1;
					frameOptions |= FRAMEOPTION_BETWEEN;
					/* reject invalid cases */
					if (frameOptions & FRAMEOPTION_START_UNBOUNDED_FOLLOWING)
						ereport(ERROR,
								(errcode(ERRCODE_WINDOWING_ERROR),
								 errmsg("frame start cannot be UNBOUNDED FOLLOWING"),
								 parser_errposition((yylsp[(2) - (4)]))));
					if (frameOptions & FRAMEOPTION_END_UNBOUNDED_PRECEDING)
						ereport(ERROR,
								(errcode(ERRCODE_WINDOWING_ERROR),
								 errmsg("frame end cannot be UNBOUNDED PRECEDING"),
								 parser_errposition((yylsp[(4) - (4)]))));
					if ((frameOptions & FRAMEOPTION_START_CURRENT_ROW) &&
						(frameOptions & FRAMEOPTION_END_VALUE_PRECEDING))
						ereport(ERROR,
								(errcode(ERRCODE_WINDOWING_ERROR),
								 errmsg("frame starting from current row cannot have preceding rows"),
								 parser_errposition((yylsp[(4) - (4)]))));
					if ((frameOptions & FRAMEOPTION_START_VALUE_FOLLOWING) &&
						(frameOptions & (FRAMEOPTION_END_VALUE_PRECEDING |
										 FRAMEOPTION_END_CURRENT_ROW)))
						ereport(ERROR,
								(errcode(ERRCODE_WINDOWING_ERROR),
								 errmsg("frame starting from following row cannot have preceding rows"),
								 parser_errposition((yylsp[(4) - (4)]))));
					n1->frameOptions = frameOptions;
					n1->endOffset = n2->startOffset;
					(yyval.windef) = n1;
				}
    break;

  case 1809:
/* Line 1787 of yacc.c  */
#line 12044 "gram.y"
    {
					WindowDef *n = makeNode(WindowDef);
					n->frameOptions = FRAMEOPTION_START_UNBOUNDED_PRECEDING;
					n->startOffset = NULL;
					n->endOffset = NULL;
					(yyval.windef) = n;
				}
    break;

  case 1810:
/* Line 1787 of yacc.c  */
#line 12052 "gram.y"
    {
					WindowDef *n = makeNode(WindowDef);
					n->frameOptions = FRAMEOPTION_START_UNBOUNDED_FOLLOWING;
					n->startOffset = NULL;
					n->endOffset = NULL;
					(yyval.windef) = n;
				}
    break;

  case 1811:
/* Line 1787 of yacc.c  */
#line 12060 "gram.y"
    {
					WindowDef *n = makeNode(WindowDef);
					n->frameOptions = FRAMEOPTION_START_CURRENT_ROW;
					n->startOffset = NULL;
					n->endOffset = NULL;
					(yyval.windef) = n;
				}
    break;

  case 1812:
/* Line 1787 of yacc.c  */
#line 12068 "gram.y"
    {
					WindowDef *n = makeNode(WindowDef);
					n->frameOptions = FRAMEOPTION_START_VALUE_PRECEDING;
					n->startOffset = (yyvsp[(1) - (2)].node);
					n->endOffset = NULL;
					(yyval.windef) = n;
				}
    break;

  case 1813:
/* Line 1787 of yacc.c  */
#line 12076 "gram.y"
    {
					WindowDef *n = makeNode(WindowDef);
					n->frameOptions = FRAMEOPTION_START_VALUE_FOLLOWING;
					n->startOffset = (yyvsp[(1) - (2)].node);
					n->endOffset = NULL;
					(yyval.windef) = n;
				}
    break;

  case 1814:
/* Line 1787 of yacc.c  */
#line 12096 "gram.y"
    { (yyval.list) = (yyvsp[(3) - (4)].list); }
    break;

  case 1815:
/* Line 1787 of yacc.c  */
#line 12097 "gram.y"
    { (yyval.list) = NIL; }
    break;

  case 1816:
/* Line 1787 of yacc.c  */
#line 12098 "gram.y"
    { (yyval.list) = lappend((yyvsp[(2) - (5)].list), (yyvsp[(4) - (5)].node)); }
    break;

  case 1817:
/* Line 1787 of yacc.c  */
#line 12101 "gram.y"
    { (yyval.ival) = ANY_SUBLINK; }
    break;

  case 1818:
/* Line 1787 of yacc.c  */
#line 12102 "gram.y"
    { (yyval.ival) = ANY_SUBLINK; }
    break;

  case 1819:
/* Line 1787 of yacc.c  */
#line 12103 "gram.y"
    { (yyval.ival) = ALL_SUBLINK; }
    break;

  case 1820:
/* Line 1787 of yacc.c  */
#line 12106 "gram.y"
    { (yyval.str) = (yyvsp[(1) - (1)].str); }
    break;

  case 1821:
/* Line 1787 of yacc.c  */
#line 12107 "gram.y"
    { (yyval.str) = (yyvsp[(1) - (1)].str); }
    break;

  case 1822:
/* Line 1787 of yacc.c  */
#line 12110 "gram.y"
    { (yyval.str) = "+"; }
    break;

  case 1823:
/* Line 1787 of yacc.c  */
#line 12111 "gram.y"
    { (yyval.str) = "-"; }
    break;

  case 1824:
/* Line 1787 of yacc.c  */
#line 12112 "gram.y"
    { (yyval.str) = "*"; }
    break;

  case 1825:
/* Line 1787 of yacc.c  */
#line 12113 "gram.y"
    { (yyval.str) = "/"; }
    break;

  case 1826:
/* Line 1787 of yacc.c  */
#line 12114 "gram.y"
    { (yyval.str) = "%"; }
    break;

  case 1827:
/* Line 1787 of yacc.c  */
#line 12115 "gram.y"
    { (yyval.str) = "^"; }
    break;

  case 1828:
/* Line 1787 of yacc.c  */
#line 12116 "gram.y"
    { (yyval.str) = "<"; }
    break;

  case 1829:
/* Line 1787 of yacc.c  */
#line 12117 "gram.y"
    { (yyval.str) = ">"; }
    break;

  case 1830:
/* Line 1787 of yacc.c  */
#line 12118 "gram.y"
    { (yyval.str) = "="; }
    break;

  case 1831:
/* Line 1787 of yacc.c  */
#line 12122 "gram.y"
    { (yyval.list) = list_make1(makeString((yyvsp[(1) - (1)].str))); }
    break;

  case 1832:
/* Line 1787 of yacc.c  */
#line 12124 "gram.y"
    { (yyval.list) = (yyvsp[(3) - (4)].list); }
    break;

  case 1833:
/* Line 1787 of yacc.c  */
#line 12129 "gram.y"
    { (yyval.list) = list_make1(makeString((yyvsp[(1) - (1)].str))); }
    break;

  case 1834:
/* Line 1787 of yacc.c  */
#line 12131 "gram.y"
    { (yyval.list) = (yyvsp[(3) - (4)].list); }
    break;

  case 1835:
/* Line 1787 of yacc.c  */
#line 12136 "gram.y"
    { (yyval.list) = list_make1(makeString((yyvsp[(1) - (1)].str))); }
    break;

  case 1836:
/* Line 1787 of yacc.c  */
#line 12138 "gram.y"
    { (yyval.list) = (yyvsp[(3) - (4)].list); }
    break;

  case 1837:
/* Line 1787 of yacc.c  */
#line 12140 "gram.y"
    { (yyval.list) = list_make1(makeString("~~")); }
    break;

  case 1838:
/* Line 1787 of yacc.c  */
#line 12142 "gram.y"
    { (yyval.list) = list_make1(makeString("!~~")); }
    break;

  case 1839:
/* Line 1787 of yacc.c  */
#line 12144 "gram.y"
    { (yyval.list) = list_make1(makeString("~~*")); }
    break;

  case 1840:
/* Line 1787 of yacc.c  */
#line 12146 "gram.y"
    { (yyval.list) = list_make1(makeString("!~~*")); }
    break;

  case 1841:
/* Line 1787 of yacc.c  */
#line 12158 "gram.y"
    {
					(yyval.list) = list_make1((yyvsp[(1) - (1)].node));
				}
    break;

  case 1842:
/* Line 1787 of yacc.c  */
#line 12162 "gram.y"
    {
					(yyval.list) = lappend((yyvsp[(1) - (3)].list), (yyvsp[(3) - (3)].node));
				}
    break;

  case 1843:
/* Line 1787 of yacc.c  */
#line 12169 "gram.y"
    {
					(yyval.list) = list_make1((yyvsp[(1) - (1)].node));
				}
    break;

  case 1844:
/* Line 1787 of yacc.c  */
#line 12173 "gram.y"
    {
					(yyval.list) = lappend((yyvsp[(1) - (3)].list), (yyvsp[(3) - (3)].node));
				}
    break;

  case 1845:
/* Line 1787 of yacc.c  */
#line 12179 "gram.y"
    {
					(yyval.node) = (yyvsp[(1) - (1)].node);
				}
    break;

  case 1846:
/* Line 1787 of yacc.c  */
#line 12183 "gram.y"
    {
					NamedArgExpr *na = makeNode(NamedArgExpr);
					na->name = (yyvsp[(1) - (3)].str);
					na->arg = (Expr *) (yyvsp[(3) - (3)].node);
					na->argnumber = -1;		/* until determined */
					na->location = (yylsp[(1) - (3)]);
					(yyval.node) = (Node *) na;
				}
    break;

  case 1847:
/* Line 1787 of yacc.c  */
#line 12193 "gram.y"
    { (yyval.list) = list_make1((yyvsp[(1) - (1)].typnam)); }
    break;

  case 1848:
/* Line 1787 of yacc.c  */
#line 12194 "gram.y"
    { (yyval.list) = lappend((yyvsp[(1) - (3)].list), (yyvsp[(3) - (3)].typnam)); }
    break;

  case 1849:
/* Line 1787 of yacc.c  */
#line 12198 "gram.y"
    {
					(yyval.node) = makeAArrayExpr((yyvsp[(2) - (3)].list), (yylsp[(1) - (3)]));
				}
    break;

  case 1850:
/* Line 1787 of yacc.c  */
#line 12202 "gram.y"
    {
					(yyval.node) = makeAArrayExpr((yyvsp[(2) - (3)].list), (yylsp[(1) - (3)]));
				}
    break;

  case 1851:
/* Line 1787 of yacc.c  */
#line 12206 "gram.y"
    {
					(yyval.node) = makeAArrayExpr(NIL, (yylsp[(1) - (2)]));
				}
    break;

  case 1852:
/* Line 1787 of yacc.c  */
#line 12211 "gram.y"
    { (yyval.list) = list_make1((yyvsp[(1) - (1)].node)); }
    break;

  case 1853:
/* Line 1787 of yacc.c  */
#line 12212 "gram.y"
    { (yyval.list) = lappend((yyvsp[(1) - (3)].list), (yyvsp[(3) - (3)].node)); }
    break;

  case 1854:
/* Line 1787 of yacc.c  */
#line 12218 "gram.y"
    {
					(yyval.list) = list_make2(makeStringConst((yyvsp[(1) - (3)].str), (yylsp[(1) - (3)])), (yyvsp[(3) - (3)].node));
				}
    break;

  case 1855:
/* Line 1787 of yacc.c  */
#line 12221 "gram.y"
    { (yyval.list) = NIL; }
    break;

  case 1856:
/* Line 1787 of yacc.c  */
#line 12228 "gram.y"
    { (yyval.str) = (yyvsp[(1) - (1)].str); }
    break;

  case 1857:
/* Line 1787 of yacc.c  */
#line 12229 "gram.y"
    { (yyval.str) = "year"; }
    break;

  case 1858:
/* Line 1787 of yacc.c  */
#line 12230 "gram.y"
    { (yyval.str) = "month"; }
    break;

  case 1859:
/* Line 1787 of yacc.c  */
#line 12231 "gram.y"
    { (yyval.str) = "day"; }
    break;

  case 1860:
/* Line 1787 of yacc.c  */
#line 12232 "gram.y"
    { (yyval.str) = "hour"; }
    break;

  case 1861:
/* Line 1787 of yacc.c  */
#line 12233 "gram.y"
    { (yyval.str) = "minute"; }
    break;

  case 1862:
/* Line 1787 of yacc.c  */
#line 12234 "gram.y"
    { (yyval.str) = "second"; }
    break;

  case 1863:
/* Line 1787 of yacc.c  */
#line 12235 "gram.y"
    { (yyval.str) = (yyvsp[(1) - (1)].str); }
    break;

  case 1864:
/* Line 1787 of yacc.c  */
#line 12246 "gram.y"
    {
					(yyval.list) = list_make4((yyvsp[(1) - (4)].node), (yyvsp[(2) - (4)].node), (yyvsp[(3) - (4)].node), (yyvsp[(4) - (4)].node));
				}
    break;

  case 1865:
/* Line 1787 of yacc.c  */
#line 12250 "gram.y"
    {
					(yyval.list) = list_make3((yyvsp[(1) - (3)].node), (yyvsp[(2) - (3)].node), (yyvsp[(3) - (3)].node));
				}
    break;

  case 1866:
/* Line 1787 of yacc.c  */
#line 12257 "gram.y"
    { (yyval.node) = (yyvsp[(2) - (2)].node); }
    break;

  case 1867:
/* Line 1787 of yacc.c  */
#line 12263 "gram.y"
    { (yyval.list) = list_make2((yyvsp[(3) - (3)].node), (yyvsp[(1) - (3)].node)); }
    break;

  case 1868:
/* Line 1787 of yacc.c  */
#line 12264 "gram.y"
    { (yyval.list) = NIL; }
    break;

  case 1869:
/* Line 1787 of yacc.c  */
#line 12281 "gram.y"
    {
					(yyval.list) = list_make3((yyvsp[(1) - (3)].node), (yyvsp[(2) - (3)].node), (yyvsp[(3) - (3)].node));
				}
    break;

  case 1870:
/* Line 1787 of yacc.c  */
#line 12285 "gram.y"
    {
					/* not legal per SQL99, but might as well allow it */
					(yyval.list) = list_make3((yyvsp[(1) - (3)].node), (yyvsp[(3) - (3)].node), (yyvsp[(2) - (3)].node));
				}
    break;

  case 1871:
/* Line 1787 of yacc.c  */
#line 12290 "gram.y"
    {
					(yyval.list) = list_make2((yyvsp[(1) - (2)].node), (yyvsp[(2) - (2)].node));
				}
    break;

  case 1872:
/* Line 1787 of yacc.c  */
#line 12294 "gram.y"
    {
					/*
					 * Since there are no cases where this syntax allows
					 * a textual FOR value, we forcibly cast the argument
					 * to int4.  The possible matches in pg_proc are
					 * substring(text,int4) and substring(text,text),
					 * and we don't want the parser to choose the latter,
					 * which it is likely to do if the second argument
					 * is unknown or doesn't have an implicit cast to int4.
					 */
					(yyval.list) = list_make3((yyvsp[(1) - (2)].node), makeIntConst(1, -1),
									makeTypeCast((yyvsp[(2) - (2)].node),
												 SystemTypeName("int4"), -1));
				}
    break;

  case 1873:
/* Line 1787 of yacc.c  */
#line 12309 "gram.y"
    {
					(yyval.list) = (yyvsp[(1) - (1)].list);
				}
    break;

  case 1874:
/* Line 1787 of yacc.c  */
#line 12313 "gram.y"
    { (yyval.list) = NIL; }
    break;

  case 1875:
/* Line 1787 of yacc.c  */
#line 12317 "gram.y"
    { (yyval.node) = (yyvsp[(2) - (2)].node); }
    break;

  case 1876:
/* Line 1787 of yacc.c  */
#line 12320 "gram.y"
    { (yyval.node) = (yyvsp[(2) - (2)].node); }
    break;

  case 1877:
/* Line 1787 of yacc.c  */
#line 12323 "gram.y"
    { (yyval.list) = lappend((yyvsp[(3) - (3)].list), (yyvsp[(1) - (3)].node)); }
    break;

  case 1878:
/* Line 1787 of yacc.c  */
#line 12324 "gram.y"
    { (yyval.list) = (yyvsp[(2) - (2)].list); }
    break;

  case 1879:
/* Line 1787 of yacc.c  */
#line 12325 "gram.y"
    { (yyval.list) = (yyvsp[(1) - (1)].list); }
    break;

  case 1880:
/* Line 1787 of yacc.c  */
#line 12329 "gram.y"
    {
					SubLink *n = makeNode(SubLink);
					n->subselect = (yyvsp[(1) - (1)].node);
					/* other fields will be filled later */
					(yyval.node) = (Node *)n;
				}
    break;

  case 1881:
/* Line 1787 of yacc.c  */
#line 12335 "gram.y"
    { (yyval.node) = (Node *)(yyvsp[(2) - (3)].list); }
    break;

  case 1882:
/* Line 1787 of yacc.c  */
#line 12346 "gram.y"
    {
					CaseExpr *c = makeNode(CaseExpr);
					c->casetype = InvalidOid; /* not analyzed yet */
					c->arg = (Expr *) (yyvsp[(2) - (5)].node);
					c->args = (yyvsp[(3) - (5)].list);
					c->defresult = (Expr *) (yyvsp[(4) - (5)].node);
					c->location = (yylsp[(1) - (5)]);
					(yyval.node) = (Node *)c;
				}
    break;

  case 1883:
/* Line 1787 of yacc.c  */
#line 12359 "gram.y"
    { (yyval.list) = list_make1((yyvsp[(1) - (1)].node)); }
    break;

  case 1884:
/* Line 1787 of yacc.c  */
#line 12360 "gram.y"
    { (yyval.list) = lappend((yyvsp[(1) - (2)].list), (yyvsp[(2) - (2)].node)); }
    break;

  case 1885:
/* Line 1787 of yacc.c  */
#line 12365 "gram.y"
    {
					CaseWhen *w = makeNode(CaseWhen);
					w->expr = (Expr *) (yyvsp[(2) - (4)].node);
					w->result = (Expr *) (yyvsp[(4) - (4)].node);
					w->location = (yylsp[(1) - (4)]);
					(yyval.node) = (Node *)w;
				}
    break;

  case 1886:
/* Line 1787 of yacc.c  */
#line 12375 "gram.y"
    { (yyval.node) = (yyvsp[(2) - (2)].node); }
    break;

  case 1887:
/* Line 1787 of yacc.c  */
#line 12376 "gram.y"
    { (yyval.node) = NULL; }
    break;

  case 1888:
/* Line 1787 of yacc.c  */
#line 12379 "gram.y"
    { (yyval.node) = (yyvsp[(1) - (1)].node); }
    break;

  case 1889:
/* Line 1787 of yacc.c  */
#line 12380 "gram.y"
    { (yyval.node) = NULL; }
    break;

  case 1890:
/* Line 1787 of yacc.c  */
#line 12384 "gram.y"
    {
					(yyval.node) = makeColumnRef((yyvsp[(1) - (1)].str), NIL, (yylsp[(1) - (1)]), yyscanner);
				}
    break;

  case 1891:
/* Line 1787 of yacc.c  */
#line 12388 "gram.y"
    {
					(yyval.node) = makeColumnRef((yyvsp[(1) - (2)].str), (yyvsp[(2) - (2)].list), (yylsp[(1) - (2)]), yyscanner);
				}
    break;

  case 1892:
/* Line 1787 of yacc.c  */
#line 12395 "gram.y"
    {
					(yyval.node) = (Node *) makeString((yyvsp[(2) - (2)].str));
				}
    break;

  case 1893:
/* Line 1787 of yacc.c  */
#line 12399 "gram.y"
    {
					(yyval.node) = (Node *) makeNode(A_Star);
				}
    break;

  case 1894:
/* Line 1787 of yacc.c  */
#line 12403 "gram.y"
    {
					A_Indices *ai = makeNode(A_Indices);
					ai->lidx = NULL;
					ai->uidx = (yyvsp[(2) - (3)].node);
					(yyval.node) = (Node *) ai;
				}
    break;

  case 1895:
/* Line 1787 of yacc.c  */
#line 12410 "gram.y"
    {
					A_Indices *ai = makeNode(A_Indices);
					ai->lidx = (yyvsp[(2) - (5)].node);
					ai->uidx = (yyvsp[(4) - (5)].node);
					(yyval.node) = (Node *) ai;
				}
    break;

  case 1896:
/* Line 1787 of yacc.c  */
#line 12419 "gram.y"
    { (yyval.list) = list_make1((yyvsp[(1) - (1)].node)); }
    break;

  case 1897:
/* Line 1787 of yacc.c  */
#line 12420 "gram.y"
    { (yyval.list) = lappend((yyvsp[(1) - (2)].list), (yyvsp[(2) - (2)].node)); }
    break;

  case 1898:
/* Line 1787 of yacc.c  */
#line 12424 "gram.y"
    { (yyval.list) = NIL; }
    break;

  case 1899:
/* Line 1787 of yacc.c  */
#line 12425 "gram.y"
    { (yyval.list) = lappend((yyvsp[(1) - (2)].list), (yyvsp[(2) - (2)].node)); }
    break;

  case 1902:
/* Line 1787 of yacc.c  */
#line 12440 "gram.y"
    { (yyval.node) = (Node *) (yyvsp[(1) - (1)].node); }
    break;

  case 1903:
/* Line 1787 of yacc.c  */
#line 12442 "gram.y"
    {
					SetToDefault *n = makeNode(SetToDefault);
					n->location = (yylsp[(1) - (1)]);
					(yyval.node) = (Node *) n;
				}
    break;

  case 1904:
/* Line 1787 of yacc.c  */
#line 12450 "gram.y"
    { (yyval.list) = list_make1((yyvsp[(1) - (1)].node)); }
    break;

  case 1905:
/* Line 1787 of yacc.c  */
#line 12451 "gram.y"
    { (yyval.list) = lappend((yyvsp[(1) - (3)].list), (yyvsp[(3) - (3)].node)); }
    break;

  case 1906:
/* Line 1787 of yacc.c  */
#line 12459 "gram.y"
    { (yyval.list) = (yyvsp[(2) - (3)].list); }
    break;

  case 1907:
/* Line 1787 of yacc.c  */
#line 12469 "gram.y"
    { (yyval.list) = (yyvsp[(1) - (1)].list); }
    break;

  case 1908:
/* Line 1787 of yacc.c  */
#line 12470 "gram.y"
    { (yyval.list) = NIL; }
    break;

  case 1909:
/* Line 1787 of yacc.c  */
#line 12474 "gram.y"
    { (yyval.list) = list_make1((yyvsp[(1) - (1)].target)); }
    break;

  case 1910:
/* Line 1787 of yacc.c  */
#line 12475 "gram.y"
    { (yyval.list) = lappend((yyvsp[(1) - (3)].list), (yyvsp[(3) - (3)].target)); }
    break;

  case 1911:
/* Line 1787 of yacc.c  */
#line 12479 "gram.y"
    {
					(yyval.target) = makeNode(ResTarget);
					(yyval.target)->name = (yyvsp[(3) - (3)].str);
					(yyval.target)->indirection = NIL;
					(yyval.target)->val = (Node *)(yyvsp[(1) - (3)].node);
					(yyval.target)->location = (yylsp[(1) - (3)]);
				}
    break;

  case 1912:
/* Line 1787 of yacc.c  */
#line 12495 "gram.y"
    {
					(yyval.target) = makeNode(ResTarget);
					(yyval.target)->name = (yyvsp[(2) - (2)].str);
					(yyval.target)->indirection = NIL;
					(yyval.target)->val = (Node *)(yyvsp[(1) - (2)].node);
					(yyval.target)->location = (yylsp[(1) - (2)]);
				}
    break;

  case 1913:
/* Line 1787 of yacc.c  */
#line 12503 "gram.y"
    {
					(yyval.target) = makeNode(ResTarget);
					(yyval.target)->name = NULL;
					(yyval.target)->indirection = NIL;
					(yyval.target)->val = (Node *)(yyvsp[(1) - (1)].node);
					(yyval.target)->location = (yylsp[(1) - (1)]);
				}
    break;

  case 1914:
/* Line 1787 of yacc.c  */
#line 12511 "gram.y"
    {
					ColumnRef *n = makeNode(ColumnRef);
					n->fields = list_make1(makeNode(A_Star));
					n->location = (yylsp[(1) - (1)]);

					(yyval.target) = makeNode(ResTarget);
					(yyval.target)->name = NULL;
					(yyval.target)->indirection = NIL;
					(yyval.target)->val = (Node *)n;
					(yyval.target)->location = (yylsp[(1) - (1)]);
				}
    break;

  case 1915:
/* Line 1787 of yacc.c  */
#line 12532 "gram.y"
    { (yyval.list) = list_make1((yyvsp[(1) - (1)].range)); }
    break;

  case 1916:
/* Line 1787 of yacc.c  */
#line 12533 "gram.y"
    { (yyval.list) = lappend((yyvsp[(1) - (3)].list), (yyvsp[(3) - (3)].range)); }
    break;

  case 1917:
/* Line 1787 of yacc.c  */
#line 12545 "gram.y"
    {
					(yyval.range) = makeRangeVar(NULL, (yyvsp[(1) - (1)].str), (yylsp[(1) - (1)]));
				}
    break;

  case 1918:
/* Line 1787 of yacc.c  */
#line 12549 "gram.y"
    {
					check_qualified_name((yyvsp[(2) - (2)].list), yyscanner);
					(yyval.range) = makeRangeVar(NULL, NULL, (yylsp[(1) - (2)]));
					switch (list_length((yyvsp[(2) - (2)].list)))
					{
						case 1:
							(yyval.range)->catalogname = NULL;
							(yyval.range)->schemaname = (yyvsp[(1) - (2)].str);
							(yyval.range)->relname = strVal(linitial((yyvsp[(2) - (2)].list)));
							break;
						case 2:
							(yyval.range)->catalogname = (yyvsp[(1) - (2)].str);
							(yyval.range)->schemaname = strVal(linitial((yyvsp[(2) - (2)].list)));
							(yyval.range)->relname = strVal(lsecond((yyvsp[(2) - (2)].list)));
							break;
						default:
							ereport(ERROR,
									(errcode(ERRCODE_SYNTAX_ERROR),
									 errmsg("improper qualified name (too many dotted names): %s",
											NameListToString(lcons(makeString((yyvsp[(1) - (2)].str)), (yyvsp[(2) - (2)].list)))),
									 parser_errposition((yylsp[(1) - (2)]))));
							break;
					}
				}
    break;

  case 1919:
/* Line 1787 of yacc.c  */
#line 12576 "gram.y"
    { (yyval.list) = list_make1(makeString((yyvsp[(1) - (1)].str))); }
    break;

  case 1920:
/* Line 1787 of yacc.c  */
#line 12578 "gram.y"
    { (yyval.list) = lappend((yyvsp[(1) - (3)].list), makeString((yyvsp[(3) - (3)].str))); }
    break;

  case 1921:
/* Line 1787 of yacc.c  */
#line 12582 "gram.y"
    { (yyval.str) = (yyvsp[(1) - (1)].str); }
    break;

  case 1922:
/* Line 1787 of yacc.c  */
#line 12585 "gram.y"
    { (yyval.str) = (yyvsp[(1) - (1)].str); }
    break;

  case 1923:
/* Line 1787 of yacc.c  */
#line 12588 "gram.y"
    { (yyval.str) = (yyvsp[(1) - (1)].str); }
    break;

  case 1924:
/* Line 1787 of yacc.c  */
#line 12590 "gram.y"
    { (yyval.str) = (yyvsp[(1) - (1)].str); }
    break;

  case 1925:
/* Line 1787 of yacc.c  */
#line 12592 "gram.y"
    { (yyval.str) = (yyvsp[(1) - (1)].str); }
    break;

  case 1926:
/* Line 1787 of yacc.c  */
#line 12594 "gram.y"
    { (yyval.str) = (yyvsp[(1) - (1)].str); }
    break;

  case 1927:
/* Line 1787 of yacc.c  */
#line 12605 "gram.y"
    { (yyval.list) = list_make1(makeString((yyvsp[(1) - (1)].str))); }
    break;

  case 1928:
/* Line 1787 of yacc.c  */
#line 12607 "gram.y"
    {
						(yyval.list) = check_func_name(lcons(makeString((yyvsp[(1) - (2)].str)), (yyvsp[(2) - (2)].list)),
											 yyscanner);
					}
    break;

  case 1929:
/* Line 1787 of yacc.c  */
#line 12618 "gram.y"
    {
					(yyval.node) = makeIntConst((yyvsp[(1) - (1)].ival), (yylsp[(1) - (1)]));
				}
    break;

  case 1930:
/* Line 1787 of yacc.c  */
#line 12622 "gram.y"
    {
					(yyval.node) = makeFloatConst((yyvsp[(1) - (1)].str), (yylsp[(1) - (1)]));
				}
    break;

  case 1931:
/* Line 1787 of yacc.c  */
#line 12626 "gram.y"
    {
					(yyval.node) = makeStringConst((yyvsp[(1) - (1)].str), (yylsp[(1) - (1)]));
				}
    break;

  case 1932:
/* Line 1787 of yacc.c  */
#line 12630 "gram.y"
    {
					(yyval.node) = makeBitStringConst((yyvsp[(1) - (1)].str), (yylsp[(1) - (1)]));
				}
    break;

  case 1933:
/* Line 1787 of yacc.c  */
#line 12634 "gram.y"
    {
					/* This is a bit constant per SQL99:
					 * Without Feature F511, "BIT data type",
					 * a <general literal> shall not be a
					 * <bit string literal> or a <hex string literal>.
					 */
					(yyval.node) = makeBitStringConst((yyvsp[(1) - (1)].str), (yylsp[(1) - (1)]));
				}
    break;

  case 1934:
/* Line 1787 of yacc.c  */
#line 12643 "gram.y"
    {
					/* generic type 'literal' syntax */
					TypeName *t = makeTypeNameFromNameList((yyvsp[(1) - (2)].list));
					t->location = (yylsp[(1) - (2)]);
					(yyval.node) = makeStringConstCast((yyvsp[(2) - (2)].str), (yylsp[(2) - (2)]), t);
				}
    break;

  case 1935:
/* Line 1787 of yacc.c  */
#line 12650 "gram.y"
    {
					/* generic syntax with a type modifier */
					TypeName *t = makeTypeNameFromNameList((yyvsp[(1) - (6)].list));
					ListCell *lc;

					/*
					 * We must use func_arg_list and opt_sort_clause in the
					 * production to avoid reduce/reduce conflicts, but we
					 * don't actually wish to allow NamedArgExpr in this
					 * context, nor ORDER BY.
					 */
					foreach(lc, (yyvsp[(3) - (6)].list))
					{
						NamedArgExpr *arg = (NamedArgExpr *) lfirst(lc);

						if (IsA(arg, NamedArgExpr))
							ereport(ERROR,
									(errcode(ERRCODE_SYNTAX_ERROR),
									 errmsg("type modifier cannot have parameter name"),
									 parser_errposition(arg->location)));
					}
					if ((yyvsp[(4) - (6)].list) != NIL)
							ereport(ERROR,
									(errcode(ERRCODE_SYNTAX_ERROR),
									 errmsg("type modifier cannot have ORDER BY"),
									 parser_errposition((yylsp[(4) - (6)]))));

					t->typmods = (yyvsp[(3) - (6)].list);
					t->location = (yylsp[(1) - (6)]);
					(yyval.node) = makeStringConstCast((yyvsp[(6) - (6)].str), (yylsp[(6) - (6)]), t);
				}
    break;

  case 1936:
/* Line 1787 of yacc.c  */
#line 12682 "gram.y"
    {
					(yyval.node) = makeStringConstCast((yyvsp[(2) - (2)].str), (yylsp[(2) - (2)]), (yyvsp[(1) - (2)].typnam));
				}
    break;

  case 1937:
/* Line 1787 of yacc.c  */
#line 12686 "gram.y"
    {
					TypeName *t = (yyvsp[(1) - (3)].typnam);
					t->typmods = (yyvsp[(3) - (3)].list);
					(yyval.node) = makeStringConstCast((yyvsp[(2) - (3)].str), (yylsp[(2) - (3)]), t);
				}
    break;

  case 1938:
/* Line 1787 of yacc.c  */
#line 12692 "gram.y"
    {
					TypeName *t = (yyvsp[(1) - (6)].typnam);
					if ((yyvsp[(6) - (6)].list) != NIL)
					{
						if (list_length((yyvsp[(6) - (6)].list)) != 1)
							ereport(ERROR,
									(errcode(ERRCODE_SYNTAX_ERROR),
									 errmsg("interval precision specified twice"),
									 parser_errposition((yylsp[(1) - (6)]))));
						t->typmods = lappend((yyvsp[(6) - (6)].list), makeIntConst((yyvsp[(3) - (6)].ival), (yylsp[(3) - (6)])));
					}
					else
						t->typmods = list_make2(makeIntConst(INTERVAL_FULL_RANGE, -1),
												makeIntConst((yyvsp[(3) - (6)].ival), (yylsp[(3) - (6)])));
					(yyval.node) = makeStringConstCast((yyvsp[(5) - (6)].str), (yylsp[(5) - (6)]), t);
				}
    break;

  case 1939:
/* Line 1787 of yacc.c  */
#line 12709 "gram.y"
    {
					(yyval.node) = makeBoolAConst(TRUE, (yylsp[(1) - (1)]));
				}
    break;

  case 1940:
/* Line 1787 of yacc.c  */
#line 12713 "gram.y"
    {
					(yyval.node) = makeBoolAConst(FALSE, (yylsp[(1) - (1)]));
				}
    break;

  case 1941:
/* Line 1787 of yacc.c  */
#line 12717 "gram.y"
    {
					(yyval.node) = makeNullAConst((yylsp[(1) - (1)]));
				}
    break;

  case 1942:
/* Line 1787 of yacc.c  */
#line 12722 "gram.y"
    { (yyval.ival) = (yyvsp[(1) - (1)].ival); }
    break;

  case 1943:
/* Line 1787 of yacc.c  */
#line 12723 "gram.y"
    { (yyval.str) = (yyvsp[(1) - (1)].str); }
    break;

  case 1944:
/* Line 1787 of yacc.c  */
#line 12724 "gram.y"
    { (yyval.str) = (yyvsp[(1) - (1)].str); }
    break;

  case 1945:
/* Line 1787 of yacc.c  */
#line 12727 "gram.y"
    { (yyval.list) = list_make1(makeString((yyvsp[(1) - (1)].str))); }
    break;

  case 1946:
/* Line 1787 of yacc.c  */
#line 12729 "gram.y"
    { (yyval.list) = lappend((yyvsp[(1) - (3)].list), makeString((yyvsp[(3) - (3)].str))); }
    break;

  case 1947:
/* Line 1787 of yacc.c  */
#line 12732 "gram.y"
    { (yyval.ival) = (yyvsp[(1) - (1)].ival); }
    break;

  case 1948:
/* Line 1787 of yacc.c  */
#line 12733 "gram.y"
    { (yyval.ival) = + (yyvsp[(2) - (2)].ival); }
    break;

  case 1949:
/* Line 1787 of yacc.c  */
#line 12734 "gram.y"
    { (yyval.ival) = - (yyvsp[(2) - (2)].ival); }
    break;

  case 1950:
/* Line 1787 of yacc.c  */
#line 12750 "gram.y"
    { (yyval.str) = (yyvsp[(1) - (1)].str); }
    break;

  case 1951:
/* Line 1787 of yacc.c  */
#line 12751 "gram.y"
    { (yyval.str) = pstrdup((yyvsp[(1) - (1)].keyword)); }
    break;

  case 1952:
/* Line 1787 of yacc.c  */
#line 12752 "gram.y"
    { (yyval.str) = pstrdup((yyvsp[(1) - (1)].keyword)); }
    break;

  case 1953:
/* Line 1787 of yacc.c  */
#line 12757 "gram.y"
    { (yyval.str) = (yyvsp[(1) - (1)].str); }
    break;

  case 1954:
/* Line 1787 of yacc.c  */
#line 12758 "gram.y"
    { (yyval.str) = pstrdup((yyvsp[(1) - (1)].keyword)); }
    break;

  case 1955:
/* Line 1787 of yacc.c  */
#line 12759 "gram.y"
    { (yyval.str) = pstrdup((yyvsp[(1) - (1)].keyword)); }
    break;

  case 1956:
/* Line 1787 of yacc.c  */
#line 12764 "gram.y"
    { (yyval.str) = (yyvsp[(1) - (1)].str); }
    break;

  case 1957:
/* Line 1787 of yacc.c  */
#line 12765 "gram.y"
    { (yyval.str) = pstrdup((yyvsp[(1) - (1)].keyword)); }
    break;

  case 1958:
/* Line 1787 of yacc.c  */
#line 12766 "gram.y"
    { (yyval.str) = pstrdup((yyvsp[(1) - (1)].keyword)); }
    break;

  case 1959:
/* Line 1787 of yacc.c  */
#line 12767 "gram.y"
    { (yyval.str) = pstrdup((yyvsp[(1) - (1)].keyword)); }
    break;

  case 1960:
/* Line 1787 of yacc.c  */
#line 12773 "gram.y"
    { (yyval.str) = (yyvsp[(1) - (1)].str); }
    break;

  case 1961:
/* Line 1787 of yacc.c  */
#line 12774 "gram.y"
    { (yyval.str) = pstrdup((yyvsp[(1) - (1)].keyword)); }
    break;

  case 1962:
/* Line 1787 of yacc.c  */
#line 12775 "gram.y"
    { (yyval.str) = pstrdup((yyvsp[(1) - (1)].keyword)); }
    break;

  case 1963:
/* Line 1787 of yacc.c  */
#line 12776 "gram.y"
    { (yyval.str) = pstrdup((yyvsp[(1) - (1)].keyword)); }
    break;

  case 1964:
/* Line 1787 of yacc.c  */
#line 12777 "gram.y"
    { (yyval.str) = pstrdup((yyvsp[(1) - (1)].keyword)); }
    break;


/* Line 1787 of yacc.c  */
#line 38480 "gram.c"
      default: break;
    }
  /* User semantic actions sometimes alter yychar, and that requires
     that yytoken be updated with the new translation.  We take the
     approach of translating immediately before every use of yytoken.
     One alternative is translating here after every semantic action,
     but that translation would be missed if the semantic action invokes
     YYABORT, YYACCEPT, or YYERROR immediately after altering yychar or
     if it invokes YYBACKUP.  In the case of YYABORT or YYACCEPT, an
     incorrect destructor might then be invoked immediately.  In the
     case of YYERROR or YYBACKUP, subsequent parser actions might lead
     to an incorrect destructor call or verbose syntax error message
     before the lookahead is translated.  */
  YY_SYMBOL_PRINT ("-> $$ =", yyr1[yyn], &yyval, &yyloc);

  YYPOPSTACK (yylen);
  yylen = 0;
  YY_STACK_PRINT (yyss, yyssp);

  *++yyvsp = yyval;
  *++yylsp = yyloc;

  /* Now `shift' the result of the reduction.  Determine what state
     that goes to, based on the state we popped back to and the rule
     number reduced by.  */

  yyn = yyr1[yyn];

  yystate = yypgoto[yyn - YYNTOKENS] + *yyssp;
  if (0 <= yystate && yystate <= YYLAST && yycheck[yystate] == *yyssp)
    yystate = yytable[yystate];
  else
    yystate = yydefgoto[yyn - YYNTOKENS];

  goto yynewstate;


/*------------------------------------.
| yyerrlab -- here on detecting error |
`------------------------------------*/
yyerrlab:
  /* Make sure we have latest lookahead translation.  See comments at
     user semantic actions for why this is necessary.  */
  yytoken = yychar == YYEMPTY ? YYEMPTY : YYTRANSLATE (yychar);

  /* If not already recovering from an error, report this error.  */
  if (!yyerrstatus)
    {
      ++yynerrs;
#if ! YYERROR_VERBOSE
      yyerror (&yylloc, yyscanner, YY_("syntax error"));
#else
# define YYSYNTAX_ERROR yysyntax_error (&yymsg_alloc, &yymsg, \
                                        yyssp, yytoken)
      {
        char const *yymsgp = YY_("syntax error");
        int yysyntax_error_status;
        yysyntax_error_status = YYSYNTAX_ERROR;
        if (yysyntax_error_status == 0)
          yymsgp = yymsg;
        else if (yysyntax_error_status == 1)
          {
            if (yymsg != yymsgbuf)
              YYSTACK_FREE (yymsg);
            yymsg = (char *) YYSTACK_ALLOC (yymsg_alloc);
            if (!yymsg)
              {
                yymsg = yymsgbuf;
                yymsg_alloc = sizeof yymsgbuf;
                yysyntax_error_status = 2;
              }
            else
              {
                yysyntax_error_status = YYSYNTAX_ERROR;
                yymsgp = yymsg;
              }
          }
        yyerror (&yylloc, yyscanner, yymsgp);
        if (yysyntax_error_status == 2)
          goto yyexhaustedlab;
      }
# undef YYSYNTAX_ERROR
#endif
    }

  yyerror_range[1] = yylloc;

  if (yyerrstatus == 3)
    {
      /* If just tried and failed to reuse lookahead token after an
	 error, discard it.  */

      if (yychar <= YYEOF)
	{
	  /* Return failure if at end of input.  */
	  if (yychar == YYEOF)
	    YYABORT;
	}
      else
	{
	  yydestruct ("Error: discarding",
		      yytoken, &yylval, &yylloc, yyscanner);
	  yychar = YYEMPTY;
	}
    }

  /* Else will try to reuse lookahead token after shifting the error
     token.  */
  goto yyerrlab1;


/*---------------------------------------------------.
| yyerrorlab -- error raised explicitly by YYERROR.  |
`---------------------------------------------------*/
yyerrorlab:

  /* Pacify compilers like GCC when the user code never invokes
     YYERROR and the label yyerrorlab therefore never appears in user
     code.  */
  if (/*CONSTCOND*/ 0)
     goto yyerrorlab;

  yyerror_range[1] = yylsp[1-yylen];
  /* Do not reclaim the symbols of the rule which action triggered
     this YYERROR.  */
  YYPOPSTACK (yylen);
  yylen = 0;
  YY_STACK_PRINT (yyss, yyssp);
  yystate = *yyssp;
  goto yyerrlab1;


/*-------------------------------------------------------------.
| yyerrlab1 -- common code for both syntax error and YYERROR.  |
`-------------------------------------------------------------*/
yyerrlab1:
  yyerrstatus = 3;	/* Each real token shifted decrements this.  */

  for (;;)
    {
      yyn = yypact[yystate];
      if (!yypact_value_is_default (yyn))
	{
	  yyn += YYTERROR;
	  if (0 <= yyn && yyn <= YYLAST && yycheck[yyn] == YYTERROR)
	    {
	      yyn = yytable[yyn];
	      if (0 < yyn)
		break;
	    }
	}

      /* Pop the current state because it cannot handle the error token.  */
      if (yyssp == yyss)
	YYABORT;

      yyerror_range[1] = *yylsp;
      yydestruct ("Error: popping",
		  yystos[yystate], yyvsp, yylsp, yyscanner);
      YYPOPSTACK (1);
      yystate = *yyssp;
      YY_STACK_PRINT (yyss, yyssp);
    }

  YY_IGNORE_MAYBE_UNINITIALIZED_BEGIN
  *++yyvsp = yylval;
  YY_IGNORE_MAYBE_UNINITIALIZED_END

  yyerror_range[2] = yylloc;
  /* Using YYLLOC is tempting, but would change the location of
     the lookahead.  YYLOC is available though.  */
  YYLLOC_DEFAULT (yyloc, yyerror_range, 2);
  *++yylsp = yyloc;

  /* Shift the error token.  */
  YY_SYMBOL_PRINT ("Shifting", yystos[yyn], yyvsp, yylsp);

  yystate = yyn;
  goto yynewstate;


/*-------------------------------------.
| yyacceptlab -- YYACCEPT comes here.  |
`-------------------------------------*/
yyacceptlab:
  yyresult = 0;
  goto yyreturn;

/*-----------------------------------.
| yyabortlab -- YYABORT comes here.  |
`-----------------------------------*/
yyabortlab:
  yyresult = 1;
  goto yyreturn;

#if !defined yyoverflow || YYERROR_VERBOSE
/*-------------------------------------------------.
| yyexhaustedlab -- memory exhaustion comes here.  |
`-------------------------------------------------*/
yyexhaustedlab:
  yyerror (&yylloc, yyscanner, YY_("memory exhausted"));
  yyresult = 2;
  /* Fall through.  */
#endif

yyreturn:
  if (yychar != YYEMPTY)
    {
      /* Make sure we have latest lookahead translation.  See comments at
         user semantic actions for why this is necessary.  */
      yytoken = YYTRANSLATE (yychar);
      yydestruct ("Cleanup: discarding lookahead",
                  yytoken, &yylval, &yylloc, yyscanner);
    }
  /* Do not reclaim the symbols of the rule which action triggered
     this YYABORT or YYACCEPT.  */
  YYPOPSTACK (yylen);
  YY_STACK_PRINT (yyss, yyssp);
  while (yyssp != yyss)
    {
      yydestruct ("Cleanup: popping",
		  yystos[*yyssp], yyvsp, yylsp, yyscanner);
      YYPOPSTACK (1);
    }
#ifndef yyoverflow
  if (yyss != yyssa)
    YYSTACK_FREE (yyss);
#endif
#if YYERROR_VERBOSE
  if (yymsg != yymsgbuf)
    YYSTACK_FREE (yymsg);
#endif
  /* Make sure YYID is used.  */
  return YYID (yyresult);
}


/* Line 2050 of yacc.c  */
#line 13240 "gram.y"


/*
 * The signature of this function is required by bison.  However, we
 * ignore the passed yylloc and instead use the last token position
 * available from the scanner.
 */
static void
base_yyerror(YYLTYPE *yylloc, core_yyscan_t yyscanner, const char *msg)
{
	parser_yyerror(msg);
}

static Node *
makeColumnRef(char *colname, List *indirection,
			  int location, core_yyscan_t yyscanner)
{
	/*
	 * Generate a ColumnRef node, with an A_Indirection node added if there
	 * is any subscripting in the specified indirection list.  However,
	 * any field selection at the start of the indirection list must be
	 * transposed into the "fields" part of the ColumnRef node.
	 */
	ColumnRef  *c = makeNode(ColumnRef);
	int		nfields = 0;
	ListCell *l;

	c->location = location;
	foreach(l, indirection)
	{
		if (IsA(lfirst(l), A_Indices))
		{
			A_Indirection *i = makeNode(A_Indirection);

			if (nfields == 0)
			{
				/* easy case - all indirection goes to A_Indirection */
				c->fields = list_make1(makeString(colname));
				i->indirection = check_indirection(indirection, yyscanner);
			}
			else
			{
				/* got to split the list in two */
				i->indirection = check_indirection(list_copy_tail(indirection,
																  nfields),
												   yyscanner);
				indirection = list_truncate(indirection, nfields);
				c->fields = lcons(makeString(colname), indirection);
			}
			i->arg = (Node *) c;
			return (Node *) i;
		}
		else if (IsA(lfirst(l), A_Star))
		{
			/* We only allow '*' at the end of a ColumnRef */
			if (lnext(l) != NULL)
				parser_yyerror("improper use of \"*\"");
		}
		nfields++;
	}
	/* No subscripting, so all indirection gets added to field list */
	c->fields = lcons(makeString(colname), indirection);
	return (Node *) c;
}

static Node *
makeTypeCast(Node *arg, TypeName *typename, int location)
{
	TypeCast *n = makeNode(TypeCast);
	n->arg = arg;
	n->typeName = typename;
	n->location = location;
	return (Node *) n;
}

static Node *
makeStringConst(char *str, int location)
{
	A_Const *n = makeNode(A_Const);

	n->val.type = T_String;
	n->val.val.str = str;
	n->location = location;

	return (Node *)n;
}

static Node *
makeStringConstCast(char *str, int location, TypeName *typename)
{
	Node *s = makeStringConst(str, location);

	return makeTypeCast(s, typename, -1);
}

static Node *
makeIntConst(int val, int location)
{
	A_Const *n = makeNode(A_Const);

	n->val.type = T_Integer;
	n->val.val.ival = val;
	n->location = location;

	return (Node *)n;
}

static Node *
makeFloatConst(char *str, int location)
{
	A_Const *n = makeNode(A_Const);

	n->val.type = T_Float;
	n->val.val.str = str;
	n->location = location;

	return (Node *)n;
}

static Node *
makeBitStringConst(char *str, int location)
{
	A_Const *n = makeNode(A_Const);

	n->val.type = T_BitString;
	n->val.val.str = str;
	n->location = location;

	return (Node *)n;
}

static Node *
makeNullAConst(int location)
{
	A_Const *n = makeNode(A_Const);

	n->val.type = T_Null;
	n->location = location;

	return (Node *)n;
}

static Node *
makeAConst(Value *v, int location)
{
	Node *n;

	switch (v->type)
	{
		case T_Float:
			n = makeFloatConst(v->val.str, location);
			break;

		case T_Integer:
			n = makeIntConst(v->val.ival, location);
			break;

		case T_String:
		default:
			n = makeStringConst(v->val.str, location);
			break;
	}

	return n;
}

/* makeBoolAConst()
 * Create an A_Const string node and put it inside a boolean cast.
 */
static Node *
makeBoolAConst(bool state, int location)
{
	A_Const *n = makeNode(A_Const);

	n->val.type = T_String;
	n->val.val.str = (state ? "t" : "f");
	n->location = location;

	return makeTypeCast((Node *)n, SystemTypeName("bool"), -1);
}

/* check_qualified_name --- check the result of qualified_name production
 *
 * It's easiest to let the grammar production for qualified_name allow
 * subscripts and '*', which we then must reject here.
 */
static void
check_qualified_name(List *names, core_yyscan_t yyscanner)
{
	ListCell   *i;

	foreach(i, names)
	{
		if (!IsA(lfirst(i), String))
			parser_yyerror("syntax error");
	}
}

/* check_func_name --- check the result of func_name production
 *
 * It's easiest to let the grammar production for func_name allow subscripts
 * and '*', which we then must reject here.
 */
static List *
check_func_name(List *names, core_yyscan_t yyscanner)
{
	ListCell   *i;

	foreach(i, names)
	{
		if (!IsA(lfirst(i), String))
			parser_yyerror("syntax error");
	}
	return names;
}

/* check_indirection --- check the result of indirection production
 *
 * We only allow '*' at the end of the list, but it's hard to enforce that
 * in the grammar, so do it here.
 */
static List *
check_indirection(List *indirection, core_yyscan_t yyscanner)
{
	ListCell *l;

	foreach(l, indirection)
	{
		if (IsA(lfirst(l), A_Star))
		{
			if (lnext(l) != NULL)
				parser_yyerror("improper use of \"*\"");
		}
	}
	return indirection;
}

/* extractArgTypes()
 * Given a list of FunctionParameter nodes, extract a list of just the
 * argument types (TypeNames) for input parameters only.  This is what
 * is needed to look up an existing function, which is what is wanted by
 * the productions that use this call.
 */
static List *
extractArgTypes(List *parameters)
{
	List	   *result = NIL;
	ListCell   *i;

	foreach(i, parameters)
	{
		FunctionParameter *p = (FunctionParameter *) lfirst(i);

		if (p->mode != FUNC_PARAM_OUT && p->mode != FUNC_PARAM_TABLE)
			result = lappend(result, p->argType);
	}
	return result;
}

/* extractAggrArgTypes()
 * As above, but work from the output of the aggr_args production.
 */
static List *
extractAggrArgTypes(List *aggrargs)
{
	Assert(list_length(aggrargs) == 2);
	return extractArgTypes((List *) linitial(aggrargs));
}

/* makeOrderedSetArgs()
 * Build the result of the aggr_args production (which see the comments for).
 * This handles only the case where both given lists are nonempty, so that
 * we have to deal with multiple VARIADIC arguments.
 */
static List *
makeOrderedSetArgs(List *directargs, List *orderedargs,
				   core_yyscan_t yyscanner)
{
	FunctionParameter *lastd = (FunctionParameter *) llast(directargs);
	int			ndirectargs;

	/* No restriction unless last direct arg is VARIADIC */
	if (lastd->mode == FUNC_PARAM_VARIADIC)
	{
		FunctionParameter *firsto = (FunctionParameter *) linitial(orderedargs);

		/*
		 * We ignore the names, though the aggr_arg production allows them;
		 * it doesn't allow default values, so those need not be checked.
		 */
		if (list_length(orderedargs) != 1 ||
			firsto->mode != FUNC_PARAM_VARIADIC ||
			!equal(lastd->argType, firsto->argType))
			ereport(ERROR,
					(errcode(ERRCODE_FEATURE_NOT_SUPPORTED),
					 errmsg("an ordered-set aggregate with a VARIADIC direct argument must have one VARIADIC aggregated argument of the same data type"),
					 parser_errposition(exprLocation((Node *) firsto))));

		/* OK, drop the duplicate VARIADIC argument from the internal form */
		orderedargs = NIL;
	}

	/* don't merge into the next line, as list_concat changes directargs */
	ndirectargs = list_length(directargs);

	return list_make2(list_concat(directargs, orderedargs),
					  makeInteger(ndirectargs));
}

/* insertSelectOptions()
 * Insert ORDER BY, etc into an already-constructed SelectStmt.
 *
 * This routine is just to avoid duplicating code in SelectStmt productions.
 */
static void
insertSelectOptions(SelectStmt *stmt,
					List *sortClause, List *lockingClause,
					Node *limitOffset, Node *limitCount,
					WithClause *withClause,
					core_yyscan_t yyscanner)
{
	Assert(IsA(stmt, SelectStmt));

	/*
	 * Tests here are to reject constructs like
	 *	(SELECT foo ORDER BY bar) ORDER BY baz
	 */
	if (sortClause)
	{
		if (stmt->sortClause)
			ereport(ERROR,
					(errcode(ERRCODE_SYNTAX_ERROR),
					 errmsg("multiple ORDER BY clauses not allowed"),
					 parser_errposition(exprLocation((Node *) sortClause))));
		stmt->sortClause = sortClause;
	}
	/* We can handle multiple locking clauses, though */
	stmt->lockingClause = list_concat(stmt->lockingClause, lockingClause);
	if (limitOffset)
	{
		if (stmt->limitOffset)
			ereport(ERROR,
					(errcode(ERRCODE_SYNTAX_ERROR),
					 errmsg("multiple OFFSET clauses not allowed"),
					 parser_errposition(exprLocation(limitOffset))));
		stmt->limitOffset = limitOffset;
	}
	if (limitCount)
	{
		if (stmt->limitCount)
			ereport(ERROR,
					(errcode(ERRCODE_SYNTAX_ERROR),
					 errmsg("multiple LIMIT clauses not allowed"),
					 parser_errposition(exprLocation(limitCount))));
		stmt->limitCount = limitCount;
	}
	if (withClause)
	{
		if (stmt->withClause)
			ereport(ERROR,
					(errcode(ERRCODE_SYNTAX_ERROR),
					 errmsg("multiple WITH clauses not allowed"),
					 parser_errposition(exprLocation((Node *) withClause))));
		stmt->withClause = withClause;
	}
}

static Node *
makeSetOp(SetOperation op, bool all, Node *larg, Node *rarg)
{
	SelectStmt *n = makeNode(SelectStmt);

	n->op = op;
	n->all = all;
	n->larg = (SelectStmt *) larg;
	n->rarg = (SelectStmt *) rarg;
	return (Node *) n;
}

/* SystemFuncName()
 * Build a properly-qualified reference to a built-in function.
 */
List *
SystemFuncName(char *name)
{
	return list_make2(makeString("pg_catalog"), makeString(name));
}

/* SystemTypeName()
 * Build a properly-qualified reference to a built-in type.
 *
 * typmod is defaulted, but may be changed afterwards by caller.
 * Likewise for the location.
 */
TypeName *
SystemTypeName(char *name)
{
	return makeTypeNameFromNameList(list_make2(makeString("pg_catalog"),
											   makeString(name)));
}

/* doNegate()
 * Handle negation of a numeric constant.
 *
 * Formerly, we did this here because the optimizer couldn't cope with
 * indexquals that looked like "var = -4" --- it wants "var = const"
 * and a unary minus operator applied to a constant didn't qualify.
 * As of Postgres 7.0, that problem doesn't exist anymore because there
 * is a constant-subexpression simplifier in the optimizer.  However,
 * there's still a good reason for doing this here, which is that we can
 * postpone committing to a particular internal representation for simple
 * negative constants.	It's better to leave "-123.456" in string form
 * until we know what the desired type is.
 */
static Node *
doNegate(Node *n, int location)
{
	if (IsA(n, A_Const))
	{
		A_Const *con = (A_Const *)n;

		/* report the constant's location as that of the '-' sign */
		con->location = location;

		if (con->val.type == T_Integer)
		{
			con->val.val.ival = -con->val.val.ival;
			return n;
		}
		if (con->val.type == T_Float)
		{
			doNegateFloat(&con->val);
			return n;
		}
	}

	return (Node *) makeSimpleA_Expr(AEXPR_OP, "-", NULL, n, location);
}

static void
doNegateFloat(Value *v)
{
	char   *oldval = v->val.str;

	Assert(IsA(v, Float));
	if (*oldval == '+')
		oldval++;
	if (*oldval == '-')
		v->val.str = oldval+1;	/* just strip the '-' */
	else
		v->val.str = psprintf("-%s", oldval);
}

static Node *
makeAArrayExpr(List *elements, int location)
{
	A_ArrayExpr *n = makeNode(A_ArrayExpr);

	n->elements = elements;
	n->location = location;
	return (Node *) n;
}

static Node *
makeXmlExpr(XmlExprOp op, char *name, List *named_args, List *args,
			int location)
{
	XmlExpr		*x = makeNode(XmlExpr);

	x->op = op;
	x->name = name;
	/*
	 * named_args is a list of ResTarget; it'll be split apart into separate
	 * expression and name lists in transformXmlExpr().
	 */
	x->named_args = named_args;
	x->arg_names = NIL;
	x->args = args;
	/* xmloption, if relevant, must be filled in by caller */
	/* type and typmod will be filled in during parse analysis */
	x->type = InvalidOid;			/* marks the node as not analyzed */
	x->location = location;
	return (Node *) x;
}

/*
 * Merge the input and output parameters of a table function.
 */
static List *
mergeTableFuncParameters(List *func_args, List *columns)
{
	ListCell   *lc;

	/* Explicit OUT and INOUT parameters shouldn't be used in this syntax */
	foreach(lc, func_args)
	{
		FunctionParameter *p = (FunctionParameter *) lfirst(lc);

		if (p->mode != FUNC_PARAM_IN && p->mode != FUNC_PARAM_VARIADIC)
			ereport(ERROR,
					(errcode(ERRCODE_SYNTAX_ERROR),
					 errmsg("OUT and INOUT arguments aren't allowed in TABLE functions")));
	}

	return list_concat(func_args, columns);
}

/*
 * Determine return type of a TABLE function.  A single result column
 * returns setof that column's type; otherwise return setof record.
 */
static TypeName *
TableFuncTypeName(List *columns)
{
	TypeName *result;

	if (list_length(columns) == 1)
	{
		FunctionParameter *p = (FunctionParameter *) linitial(columns);

		result = (TypeName *) copyObject(p->argType);
	}
	else
		result = SystemTypeName("record");

	result->setof = true;

	return result;
}

/*
 * Convert a list of (dotted) names to a RangeVar (like
 * makeRangeVarFromNameList, but with position support).  The
 * "AnyName" refers to the any_name production in the grammar.
 */
static RangeVar *
makeRangeVarFromAnyName(List *names, int position, core_yyscan_t yyscanner)
{
	RangeVar *r = makeNode(RangeVar);

	switch (list_length(names))
	{
		case 1:
			r->catalogname = NULL;
			r->schemaname = NULL;
			r->relname = strVal(linitial(names));
			break;
		case 2:
			r->catalogname = NULL;
			r->schemaname = strVal(linitial(names));
			r->relname = strVal(lsecond(names));
			break;
		case 3:
			r->catalogname = strVal(linitial(names));
			r->schemaname = strVal(lsecond(names));
			r->relname = strVal(lthird(names));
			break;
		default:
			ereport(ERROR,
					(errcode(ERRCODE_SYNTAX_ERROR),
					 errmsg("improper qualified name (too many dotted names): %s",
							NameListToString(names)),
					 parser_errposition(position)));
			break;
	}

	r->relpersistence = RELPERSISTENCE_PERMANENT;
	r->location = position;

	return r;
}

/* Separate Constraint nodes from COLLATE clauses in a ColQualList */
static void
SplitColQualList(List *qualList,
				 List **constraintList, CollateClause **collClause,
				 core_yyscan_t yyscanner)
{
	ListCell   *cell;
	ListCell   *prev;
	ListCell   *next;

	*collClause = NULL;
	prev = NULL;
	for (cell = list_head(qualList); cell; cell = next)
	{
		Node   *n = (Node *) lfirst(cell);

		next = lnext(cell);
		if (IsA(n, Constraint))
		{
			/* keep it in list */
			prev = cell;
			continue;
		}
		if (IsA(n, CollateClause))
		{
			CollateClause *c = (CollateClause *) n;

			if (*collClause)
				ereport(ERROR,
						(errcode(ERRCODE_SYNTAX_ERROR),
						 errmsg("multiple COLLATE clauses not allowed"),
						 parser_errposition(c->location)));
			*collClause = c;
		}
		else
			elog(ERROR, "unexpected node type %d", (int) n->type);
		/* remove non-Constraint nodes from qualList */
		qualList = list_delete_cell(qualList, cell, prev);
	}
	*constraintList = qualList;
}

/*
 * Process result of ConstraintAttributeSpec, and set appropriate bool flags
 * in the output command node.  Pass NULL for any flags the particular
 * command doesn't support.
 */
static void
processCASbits(int cas_bits, int location, const char *constrType,
			   bool *deferrable, bool *initdeferred, bool *not_valid,
			   bool *no_inherit, core_yyscan_t yyscanner)
{
	/* defaults */
	if (deferrable)
		*deferrable = false;
	if (initdeferred)
		*initdeferred = false;
	if (not_valid)
		*not_valid = false;

	if (cas_bits & (CAS_DEFERRABLE | CAS_INITIALLY_DEFERRED))
	{
		if (deferrable)
			*deferrable = true;
		else
			ereport(ERROR,
					(errcode(ERRCODE_FEATURE_NOT_SUPPORTED),
					 /* translator: %s is CHECK, UNIQUE, or similar */
					 errmsg("%s constraints cannot be marked DEFERRABLE",
							constrType),
					 parser_errposition(location)));
	}

	if (cas_bits & CAS_INITIALLY_DEFERRED)
	{
		if (initdeferred)
			*initdeferred = true;
		else
			ereport(ERROR,
					(errcode(ERRCODE_FEATURE_NOT_SUPPORTED),
					 /* translator: %s is CHECK, UNIQUE, or similar */
					 errmsg("%s constraints cannot be marked DEFERRABLE",
							constrType),
					 parser_errposition(location)));
	}

	if (cas_bits & CAS_NOT_VALID)
	{
		if (not_valid)
			*not_valid = true;
		else
			ereport(ERROR,
					(errcode(ERRCODE_FEATURE_NOT_SUPPORTED),
					 /* translator: %s is CHECK, UNIQUE, or similar */
					 errmsg("%s constraints cannot be marked NOT VALID",
							constrType),
					 parser_errposition(location)));
	}

	if (cas_bits & CAS_NO_INHERIT)
	{
		if (no_inherit)
			*no_inherit = true;
		else
			ereport(ERROR,
					(errcode(ERRCODE_FEATURE_NOT_SUPPORTED),
					 /* translator: %s is CHECK, UNIQUE, or similar */
					 errmsg("%s constraints cannot be marked NO INHERIT",
							constrType),
					 parser_errposition(location)));
	}
}

/*----------
 * Recursive view transformation
 *
 * Convert
 *
 *     CREATE RECURSIVE VIEW relname (aliases) AS query
 *
 * to
 *
 *     CREATE VIEW relname (aliases) AS
 *         WITH RECURSIVE relname (aliases) AS (query)
 *         SELECT aliases FROM relname
 *
 * Actually, just the WITH ... part, which is then inserted into the original
 * view definition as the query.
 * ----------
 */
static Node *
makeRecursiveViewSelect(char *relname, List *aliases, Node *query)
{
	SelectStmt *s = makeNode(SelectStmt);
	WithClause *w = makeNode(WithClause);
	CommonTableExpr *cte = makeNode(CommonTableExpr);
	List	   *tl = NIL;
	ListCell   *lc;

	/* create common table expression */
	cte->ctename = relname;
	cte->aliascolnames = aliases;
	cte->ctequery = query;
	cte->location = -1;

	/* create WITH clause and attach CTE */
	w->recursive = true;
	w->ctes = list_make1(cte);
	w->location = -1;

	/* create target list for the new SELECT from the alias list of the
	 * recursive view specification */
	foreach (lc, aliases)
	{
		ResTarget *rt = makeNode(ResTarget);

		rt->name = NULL;
		rt->indirection = NIL;
		rt->val = makeColumnRef(strVal(lfirst(lc)), NIL, -1, 0);
		rt->location = -1;

		tl = lappend(tl, rt);
	}

	/* create new SELECT combining WITH clause, target list, and fake FROM
	 * clause */
	s->withClause = w;
	s->targetList = tl;
	s->fromClause = list_make1(makeRangeVar(NULL, relname, -1));

	return (Node *) s;
}

/* parser_init()
 * Initialize to parse one query string
 */
void
parser_init(base_yy_extra_type *yyext)
{
	yyext->parsetree = NIL;		/* in case grammar forgets to set it */
}
